unit Orbis01Impl1;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls,
  ComServ, StdVCL, AXCtrls, Orbis01XControl1_TLB, Orbis01, ExtCtrls;

type
  TOrbis01X = class(TActiveXControl, IOrbis01X)
  private
    { Private declarations }
    FDelphiControl: TOrbis01;
    FEvents: IOrbis01XEvents;
    procedure CanResizeEvent(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure ClickEvent(Sender: TObject);
    procedure ConstrainedResizeEvent(Sender: TObject; var MinWidth, MinHeight,
      MaxWidth, MaxHeight: Integer);
    procedure DblClickEvent(Sender: TObject);
    procedure ProjectionCHangedEvent(aX, aY, aScale: Double);
    procedure ResizeEvent(Sender: TObject);
    procedure SelectEvent;
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function Get_Active: WordBool; safecall;
    function Get_ActiveToolName: WideString; safecall;
    function Get_ActualMap: WideString; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_Alignment: TxAlignment; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_BevelInner: TxBevelCut; safecall;
    function Get_BevelOuter: TxBevelCut; safecall;
    function Get_BorderStyle: TxBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_CenterX: Double; safecall;
    function Get_CenterY: Double; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_Ctl3D: WordBool; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DILEC: WideString; safecall;
    function Get_Directory_Project: WideString; safecall;
    function Get_Directory_Root: WideString; safecall;
    function Get_Directory_Script: WideString; safecall;
    function Get_Directory_Service: WideString; safecall;
    function Get_Directory_Store: WideString; safecall;
    function Get_DockSite: WordBool; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DragCursor: Smallint; safecall;
    function Get_DragMode: TxDragMode; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_FullRepaint: WordBool; safecall;
    function Get_HelpKeyword: WideString; safecall;
    function Get_HelpType: TxHelpType; safecall;
    function Get_LHC: Integer; safecall;
    function Get_Locked: WordBool; safecall;
    function Get_ODDELENI: Integer; safecall;
    function Get_ParentColor: WordBool; safecall;
    function Get_ParentCtl3D: WordBool; safecall;
    function Get_POROST: WideString; safecall;
    function Get_Scale: Double; safecall;
    function Get_SKUPINA: WideString; safecall;
    function Get_UseDockManager: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    function IsRightToLeft: WordBool; safecall;
    function UseRightToLeftReading: WordBool; safecall;
    function UseRightToLeftScrollBar: WordBool; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure ExploreWorld; safecall;
    procedure FillMapsList(const aList: IStrings); safecall;
    function  FillMapsString: WideString; safecall;
    procedure Import; safecall;
    procedure InitiateAction; safecall;
    procedure LoadProject(const aProjectName: WideString); safecall;
    procedure NewProject(const aPath: WideString); safecall;
    procedure NewProjectDialog; safecall;
    procedure Print; safecall;
    procedure PrintMap; safecall;
    procedure ReView; safecall;
    procedure Set_Active(Value: WordBool); safecall;
    procedure Set_ActiveToolName(const Value: WideString); safecall;
    procedure Set_ActualMap(const Value: WideString); safecall;
    procedure Set_Alignment(Value: TxAlignment); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_BevelInner(Value: TxBevelCut); safecall;
    procedure Set_BevelOuter(Value: TxBevelCut); safecall;
    procedure Set_BorderStyle(Value: TxBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_CenterX(Value: Double); safecall;
    procedure Set_CenterY(Value: Double); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_Ctl3D(Value: WordBool); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DILEC(const Value: WideString); safecall;
    procedure Set_Directory_Project(const Value: WideString); safecall;
    procedure Set_Directory_Root(const Value: WideString); safecall;
    procedure Set_Directory_Script(const Value: WideString); safecall;
    procedure Set_Directory_Service(const Value: WideString); safecall;
    procedure Set_Directory_Store(const Value: WideString); safecall;
    procedure Set_DockSite(Value: WordBool); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DragCursor(Value: Smallint); safecall;
    procedure Set_DragMode(Value: TxDragMode); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_FullRepaint(Value: WordBool); safecall;
    procedure Set_HelpKeyword(const Value: WideString); safecall;
    procedure Set_HelpType(Value: TxHelpType); safecall;
    procedure Set_LHC(Value: Integer); safecall;
    procedure Set_Locked(Value: WordBool); safecall;
    procedure Set_ODDELENI(Value: Integer); safecall;
    procedure Set_ParentColor(Value: WordBool); safecall;
    procedure Set_ParentCtl3D(Value: WordBool); safecall;
    procedure Set_POROST(const Value: WideString); safecall;
    procedure Set_Scale(Value: Double); safecall;
    procedure Set_SKUPINA(const Value: WideString); safecall;
    procedure Set_UseDockManager(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure SetSubComponent(IsSubComponent: WordBool); safecall;
    procedure SetupMaps; safecall;
    procedure ShowMap(const aMap: WideString); safecall;
    procedure ShowTheForest(Pattern: WordBool); safecall;
    procedure ViewAll; safecall;
    procedure ZoomIn; safecall;
    procedure ZoomOut; safecall;
  end;

implementation

uses ComObj;

{ TOrbis01X }

procedure TOrbis01X.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  {TODO: Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_Orbis01XPage); }
end;

procedure TOrbis01X.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IOrbis01XEvents;
end;

procedure TOrbis01X.InitializeControl;
begin
  FDelphiControl := Control as TOrbis01;
  FDelphiControl.OnCanResize := CanResizeEvent;
  FDelphiControl.OnClick := ClickEvent;
  FDelphiControl.OnConstrainedResize := ConstrainedResizeEvent;
  FDelphiControl.OnDblClick := DblClickEvent;
  FDelphiControl.OnProjectionCHanged := ProjectionCHangedEvent;
  FDelphiControl.OnResize := ResizeEvent;
  FDelphiControl.OnSelect := SelectEvent;
end;

function TOrbis01X.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := FDelphiControl.DrawTextBiDiModeFlagsReadingOnly;
end;

function TOrbis01X.Get_Active: WordBool;
begin
  Result := FDelphiControl.Active;
end;

function TOrbis01X.Get_ActualMap: WideString;
begin
  Result := WideString(FDelphiControl.ActualMap);
end;

function TOrbis01X.Get_AlignDisabled: WordBool;
begin
  Result := FDelphiControl.AlignDisabled;
end;

function TOrbis01X.Get_Alignment: TxAlignment;
begin
  Result := Ord(FDelphiControl.Alignment);
end;

function TOrbis01X.Get_AutoSize: WordBool;
begin
  Result := FDelphiControl.AutoSize;
end;

function TOrbis01X.Get_BevelInner: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelInner);
end;

function TOrbis01X.Get_BevelOuter: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelOuter);
end;

function TOrbis01X.Get_BorderStyle: TxBorderStyle;
begin
  Result := Ord(FDelphiControl.BorderStyle);
end;

function TOrbis01X.Get_Caption: WideString;
begin
  Result := WideString(FDelphiControl.Caption);
end;

function TOrbis01X.Get_CenterX: Double;
begin
  Result := FDelphiControl.CenterX;
end;

function TOrbis01X.Get_CenterY: Double;
begin
  Result := FDelphiControl.CenterY;
end;

function TOrbis01X.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(FDelphiControl.Color);
end;

function TOrbis01X.Get_Ctl3D: WordBool;
begin
  Result := FDelphiControl.Ctl3D;
end;

function TOrbis01X.Get_Cursor: Smallint;
begin
  Result := Smallint(FDelphiControl.Cursor);
end;

function TOrbis01X.Get_DILEC: WideString;
begin
  Result := WideString(FDelphiControl.DILEC);
end;

function TOrbis01X.Get_Directory_Project: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Project);
end;

function TOrbis01X.Get_Directory_Root: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Root);
end;

function TOrbis01X.Get_Directory_Script: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Script);
end;

function TOrbis01X.Get_Directory_Service: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Service);
end;

function TOrbis01X.Get_Directory_Store: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Store);
end;

function TOrbis01X.Get_DockSite: WordBool;
begin
  Result := FDelphiControl.DockSite;
end;

function TOrbis01X.Get_DoubleBuffered: WordBool;
begin
  Result := FDelphiControl.DoubleBuffered;
end;

function TOrbis01X.Get_DragCursor: Smallint;
begin
  Result := Smallint(FDelphiControl.DragCursor);
end;

function TOrbis01X.Get_DragMode: TxDragMode;
begin
  Result := Ord(FDelphiControl.DragMode);
end;

function TOrbis01X.Get_Enabled: WordBool;
begin
  Result := FDelphiControl.Enabled;
end;

function TOrbis01X.Get_Font: IFontDisp;
begin
  GetOleFont(FDelphiControl.Font, Result);
end;

function TOrbis01X.Get_FullRepaint: WordBool;
begin
  Result := FDelphiControl.FullRepaint;
end;

function TOrbis01X.Get_HelpKeyword: WideString;
begin
  Result := WideString(FDelphiControl.HelpKeyword);
end;

function TOrbis01X.Get_HelpType: TxHelpType;
begin
  Result := Ord(FDelphiControl.HelpType);
end;

function TOrbis01X.Get_LHC: Integer;
begin
  Result := FDelphiControl.LHC;
end;

function TOrbis01X.Get_Locked: WordBool;
begin
  Result := FDelphiControl.Locked;
end;

function TOrbis01X.Get_ODDELENI: Integer;
begin
  Result := FDelphiControl.ODDELENI;
end;

function TOrbis01X.Get_ParentColor: WordBool;
begin
  Result := FDelphiControl.ParentColor;
end;

function TOrbis01X.Get_ParentCtl3D: WordBool;
begin
  Result := FDelphiControl.ParentCtl3D;
end;

function TOrbis01X.Get_POROST: WideString;
begin
  Result := WideString(FDelphiControl.POROST);
end;

function TOrbis01X.Get_Scale: Double;
begin
  Result := FDelphiControl.Scale;
end;

function TOrbis01X.Get_SKUPINA: WideString;
begin
  Result := WideString(FDelphiControl.SKUPINA);
end;

function TOrbis01X.Get_UseDockManager: WordBool;
begin
  Result := FDelphiControl.UseDockManager;
end;

function TOrbis01X.Get_Visible: WordBool;
begin
  Result := FDelphiControl.Visible;
end;

function TOrbis01X.Get_VisibleDockClientCount: Integer;
begin
  Result := FDelphiControl.VisibleDockClientCount;
end;

function TOrbis01X.IsRightToLeft: WordBool;
begin
  Result := FDelphiControl.IsRightToLeft;
end;

function TOrbis01X.UseRightToLeftReading: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftReading;
end;

function TOrbis01X.UseRightToLeftScrollBar: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftScrollBar;
end;

procedure TOrbis01X._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TOrbis01X.CanResizeEvent(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
var
  TempNewWidth: Integer;
  TempNewHeight: Integer;
  TempResize: WordBool;
begin
  TempNewWidth := Integer(NewWidth);
  TempNewHeight := Integer(NewHeight);
  TempResize := WordBool(Resize);
  if FEvents <> nil then FEvents.OnCanResize(TempNewWidth, TempNewHeight, TempResize);
  NewWidth := Integer(TempNewWidth);
  NewHeight := Integer(TempNewHeight);
  Resize := Boolean(TempResize);
end;

procedure TOrbis01X.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TOrbis01X.ConstrainedResizeEvent(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
var
  TempMinWidth: Integer;
  TempMinHeight: Integer;
  TempMaxWidth: Integer;
  TempMaxHeight: Integer;
begin
  TempMinWidth := Integer(MinWidth);
  TempMinHeight := Integer(MinHeight);
  TempMaxWidth := Integer(MaxWidth);
  TempMaxHeight := Integer(MaxHeight);
  if FEvents <> nil then FEvents.OnConstrainedResize(TempMinWidth, TempMinHeight, TempMaxWidth, TempMaxHeight);
  MinWidth := Integer(TempMinWidth);
  MinHeight := Integer(TempMinHeight);
  MaxWidth := Integer(TempMaxWidth);
  MaxHeight := Integer(TempMaxHeight);
end;

procedure TOrbis01X.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TOrbis01X.ExploreWorld;
begin
  FDelphiControl.ExploreWorld;
end;

procedure TOrbis01X.FillMapsList(const aList: IStrings);
begin

end;

procedure TOrbis01X.Import;
begin
  FDelphiControl.Import;
end;

procedure TOrbis01X.InitiateAction;
begin
  FDelphiControl.InitiateAction;
end;

procedure TOrbis01X.LoadProject(const aProjectName: WideString);
begin
  FDelphiControl.LoadProject(aProjectName);
end;

procedure TOrbis01X.NewProject(const aPath: WideString);
begin
  FDelphiControl.NewProject(aPath);
end;

procedure TOrbis01X.NewProjectDialog;
begin
  FDelphiControl.NewProjectDialog;
end;

procedure TOrbis01X.Print;
begin
  FDelphiControl.Print;
end;

procedure TOrbis01X.PrintMap;
begin
  FDelphiControl.PrintMap;
end;

procedure TOrbis01X.ProjectionCHangedEvent(aX, aY, aScale: Double);
begin
  if FEvents <> nil then FEvents.OnProjectionCHanged(aX, aY, aScale);
end;

procedure TOrbis01X.ResizeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnResize;
end;

procedure TOrbis01X.ReView;
begin
  FDelphiControl.ReView;
end;

procedure TOrbis01X.SelectEvent;
begin
  if FEvents <> nil then FEvents.OnSelect;
end;

procedure TOrbis01X.Set_Active(Value: WordBool);
begin
  FDelphiControl.Active := Value;
end;

procedure TOrbis01X.Set_ActualMap(const Value: WideString);
begin
  FDelphiControl.ActualMap := String(Value);
end;

procedure TOrbis01X.Set_Alignment(Value: TxAlignment);
begin
  FDelphiControl.Alignment := TAlignment(Value);
end;

procedure TOrbis01X.Set_AutoSize(Value: WordBool);
begin
  FDelphiControl.AutoSize := Value;
end;

procedure TOrbis01X.Set_BevelInner(Value: TxBevelCut);
begin
  FDelphiControl.BevelInner := TBevelCut(Value);
end;

procedure TOrbis01X.Set_BevelOuter(Value: TxBevelCut);
begin
  FDelphiControl.BevelOuter := TBevelCut(Value);
end;

procedure TOrbis01X.Set_BorderStyle(Value: TxBorderStyle);
begin
  FDelphiControl.BorderStyle := TBorderStyle(Value);
end;

procedure TOrbis01X.Set_Caption(const Value: WideString);
begin
  FDelphiControl.Caption := TCaption(Value);
end;

procedure TOrbis01X.Set_CenterX(Value: Double);
begin
  FDelphiControl.CenterX := Value;
end;

procedure TOrbis01X.Set_CenterY(Value: Double);
begin
  FDelphiControl.CenterY := Value;
end;

procedure TOrbis01X.Set_Color(Value: OLE_COLOR);
begin
  FDelphiControl.Color := TColor(Value);
end;

procedure TOrbis01X.Set_Ctl3D(Value: WordBool);
begin
  FDelphiControl.Ctl3D := Value;
end;

procedure TOrbis01X.Set_Cursor(Value: Smallint);
begin
  FDelphiControl.Cursor := TCursor(Value);
end;

procedure TOrbis01X.Set_DILEC(const Value: WideString);
begin
  FDelphiControl.DILEC := String(Value);
end;

procedure TOrbis01X.Set_Directory_Project(const Value: WideString);
begin
  FDelphiControl.Directory_Project := String(Value);
end;

procedure TOrbis01X.Set_Directory_Root(const Value: WideString);
begin
  FDelphiControl.Directory_Root := String(Value);
end;

procedure TOrbis01X.Set_Directory_Script(const Value: WideString);
begin
  FDelphiControl.Directory_Script := String(Value);
end;

procedure TOrbis01X.Set_Directory_Service(const Value: WideString);
begin
  FDelphiControl.Directory_Service := String(Value);
end;

procedure TOrbis01X.Set_Directory_Store(const Value: WideString);
begin
  FDelphiControl.Directory_Store := String(Value);
end;

procedure TOrbis01X.Set_DockSite(Value: WordBool);
begin
  FDelphiControl.DockSite := Value;
end;

procedure TOrbis01X.Set_DoubleBuffered(Value: WordBool);
begin
  FDelphiControl.DoubleBuffered := Value;
end;

procedure TOrbis01X.Set_DragCursor(Value: Smallint);
begin
  FDelphiControl.DragCursor := TCursor(Value);
end;

procedure TOrbis01X.Set_DragMode(Value: TxDragMode);
begin
  FDelphiControl.DragMode := TDragMode(Value);
end;

procedure TOrbis01X.Set_Enabled(Value: WordBool);
begin
  FDelphiControl.Enabled := Value;
end;

procedure TOrbis01X.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TOrbis01X.Set_FullRepaint(Value: WordBool);
begin
  FDelphiControl.FullRepaint := Value;
end;

procedure TOrbis01X.Set_HelpKeyword(const Value: WideString);
begin
  FDelphiControl.HelpKeyword := String(Value);
end;

procedure TOrbis01X.Set_HelpType(Value: TxHelpType);
begin
  FDelphiControl.HelpType := THelpType(Value);
end;

procedure TOrbis01X.Set_LHC(Value: Integer);
begin
  FDelphiControl.LHC := Value;
end;

procedure TOrbis01X.Set_Locked(Value: WordBool);
begin
  FDelphiControl.Locked := Value;
end;

procedure TOrbis01X.Set_ODDELENI(Value: Integer);
begin
  FDelphiControl.ODDELENI := Value;
end;

procedure TOrbis01X.Set_ParentColor(Value: WordBool);
begin
  FDelphiControl.ParentColor := Value;
end;

procedure TOrbis01X.Set_ParentCtl3D(Value: WordBool);
begin
  FDelphiControl.ParentCtl3D := Value;
end;

procedure TOrbis01X.Set_POROST(const Value: WideString);
begin
  FDelphiControl.POROST := String(Value);
end;

procedure TOrbis01X.Set_Scale(Value: Double);
begin
  FDelphiControl.Scale := Value;
end;

procedure TOrbis01X.Set_SKUPINA(const Value: WideString);
begin
  FDelphiControl.SKUPINA := String(Value);
end;

procedure TOrbis01X.Set_UseDockManager(Value: WordBool);
begin
  FDelphiControl.UseDockManager := Value;
end;

procedure TOrbis01X.Set_Visible(Value: WordBool);
begin
  FDelphiControl.Visible := Value;
end;

procedure TOrbis01X.SetSubComponent(IsSubComponent: WordBool);
begin
  FDelphiControl.SetSubComponent(IsSubComponent);
end;

procedure TOrbis01X.SetupMaps;
begin
  FDelphiControl.SetupMaps;
end;

procedure TOrbis01X.ShowMap(const aMap: WideString);
begin
  FDelphiControl.ShowMap(aMap);
end;

procedure TOrbis01X.ShowTheForest(Pattern: WordBool);
begin
  FDelphiControl.ShowTheForest(Pattern);
end;

procedure TOrbis01X.ViewAll;
begin
  FDelphiControl.ViewAll;
end;

procedure TOrbis01X.ZoomIn;
begin
  FDelphiControl.ZoomIn;
end;

procedure TOrbis01X.ZoomOut;
begin
  FDelphiControl.ZoomOut;
end;

function TOrbis01X.Get_ActiveToolName: WideString;
begin
  Result := WideString(FDelphiControl.ActiveToolName);
end;

procedure TOrbis01X.Set_ActiveToolName(const Value: WideString);
begin
  FDelphiControl.ActiveToolName := String(Value);
end;

function TOrbis01X.FillMapsString: WideString;
begin
  result := WideString(FDelphiControl.FillMapsString);
end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TOrbis01X,
    TOrbis01,
    Class_Orbis01X,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.

