unit F_prop;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids,
  Tools, ExtCtrls, ComCtrls, StdCtrls;

type
  TFProp = class(TForm)
    PageControl: TPageControl;
    tsAscProperties: TTabSheet;
    tsMethods: TTabSheet;
    sgAscProperties: TStringGrid;
    sgMethods: TStringGrid;
    tsElementProperties: TTabSheet;
    sgElementProperties: TStringGrid;
    Panel1: TPanel;
    btExplore: TButton;
    btZobraz: TButton;
    btOwners: TButton;
    lbClassName: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sgAscPropertiesDblClick(Sender: TObject);
    procedure sgAscPropertiesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgAscPropertiesMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgAscPropertiesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sgAscPropertiesSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure HeaderSizing(Sender: TObject; ASection, AWidth: Integer);
    procedure FormResize(Sender: TObject);
    procedure btExploreClick(Sender: TObject);
    procedure btZobrazClick(Sender: TObject);
    procedure btOwnersClick(Sender: TObject);
  private
    { Private declarations }
    FX, FY: integer;
    FSelRow: longInt;
    function GetPropName: string;
    function GetPropString: string;
    function GetStringGrid: TStringGrid;
  public
    { Public declarations }
    Tool: TTool;
  published
    property SelRow: longInt read FSelRow;
    property PropName: string read GetPropName;
    property PropString: string read GetPropString;
  end;

implementation

{$R *.DFM}
uses
  M_Intera,
  // KERNEL
  Elements,
  M_Orbis,
  Worlds;

procedure TFProp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= caFree;
  Tool.Free
end;


function TFProp.GetStringGrid: TStringGrid;
begin
  result := nil;
  if PageControl.ActivePage = tsAscProperties then
  begin
    result:= sgAscProperties;
  end
  else
  if PageControl.ActivePage = tsMethods then
  begin
    result:= sgMethods;
  end
  else
  if PageControl.ActivePage = tsElementProperties then
  begin
    result:= sgElementProperties;
  end;
end;



procedure TFProp.sgAscPropertiesDblClick(Sender: TObject);
var
  aSG: TStringGrid;
  Column, Row: longInt;
  MouseMess: TOrbisMouseEvent;
  aCont: string;
begin
  if not (Sender is TStringGrid) then exit;
  aSG:= TStringGrid(Sender);
  aSG.MouseToCell(FX, FY, Column, Row);
  aCont:= aSG.Cells[1,0];
  if (aSG.Cells[1,0] = 'TDatabaseClass') and (row >= 10) then
    begin
      if aSG.Cells[1,0] = 'DSData' then
        begin

        end;
    end;

  MouseMess:= TOrbisMouseEvent.CreateAll(tm_EditProperty, Tool, Tool, [], mbLeft, Column, Row, true);
  MouseMess.Post;
end;

procedure TFProp.sgAscPropertiesMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FX:= X; FY:= Y
end;

procedure TFProp.sgAscPropertiesMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FX:= X; FY:= Y;
  FormResize(Sender)
end;

procedure TFProp.sgAscPropertiesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 13 then
    sgAscPropertiesDblClick(Sender)
end;


procedure TFProp.sgAscPropertiesSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  FSelRow:= Row;
  if col = 0 then CanSelect := False;
end;



function TFProp.GetPropName: string;
begin
  result:= '';
  if FSelRow > 0 then
     result:= GetStringGrid.Cells[0, FSelRow];
end;



function TFProp.GetPropString: string;
begin
  result:= '';
  if FSelRow > 0 then
     result:= GetStringGrid.Cells[1, FSelRow];
end;
{
[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,
 goColMoving,goEditing,goThumbTracking]
}
procedure TFProp.HeaderSizing(Sender: TObject; ASection, AWidth: Integer);
begin
   GetStringGrid.ColWidths[ASection] := aWidth;
end;

procedure TFProp.FormResize(Sender: TObject);
begin
   GetStringGrid.ColWidths[1] := GetStringGrid.ClientWidth - GetStringGrid.ColWidths[0]-1;
end;

procedure TFProp.btExploreClick(Sender: TObject);
begin
  Tool.PostMsg(tm_Explore, World.MainTool, Tool.Input, DontKill);
end;

procedure TFProp.btZobrazClick(Sender: TObject);
begin
  Tool.PostMsg(tm_AddView, World.MainTool, Tool.Input,DontKill);
end;

procedure TFProp.btOwnersClick(Sender: TObject);
begin
  Tool.PostMsg(tm_ExploreOwners, World.MainTool, Tool.Input, DontKill);
end;

end.
