unit T_SaveToRegistry;

interface
uses
   Classes,
   Registry,
   Elements,
   e_Class,
   T_Saver;

type

TSaveToRegistry = class(TOrbisSaver)
private
   FKeys: TStringList;
   FReg: TRegistry;
   FKey: string;
   procedure SetKeys(const Value: TStringList);
   procedure SetReg(const Value: TRegistry);
   function GetActualKey: string;
   procedure SetKey(const Value: string);
protected
   function  QGoInside(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
   procedure AddKey(const Value: string);
   procedure DeleteLastKey(const Value: string);
public
   procedure   DoIt; override;
   procedure   SaveInfo; override;
   procedure   SaveClass(aClass: TOrbisClass); override;
   procedure   NewElement; override;
   procedure   SaveElements(realy: boolean); override;
   procedure   SaveInteger(aValue: integer); override;
   procedure   SaveChar(aValue: char); override;
   procedure   SaveFloat(const aValue: extended); override;
   procedure   SaveString(const aValue: string); override;
   procedure   SaveElement(aValue: TElement); override;
   function    NumberToPropertyName(aNumber: longInt): string; override;
   property    Keys: TStringList read FKeys write SetKeys;
   property    Reg: TRegistry read FReg write SetReg;
   property    ActualKey: string read GetActualKey;
published
   property    Key: string read FKey write SetKey;
end;


implementation

{ TSaveToRegistry }

procedure TSaveToRegistry.NewElement;
begin
  // nic
end;

procedure TSaveToRegistry.Process(Element: TElement);
var
   i: integer;
begin
   Reg.OpenKey(ActualKey,true);
   if Element.ID > BaseID then exit;
   Element.ID := Index;
   Index := Index + 1;
   if (Index mod 100) = 0 then
   begin
      F_GaugeForm.Progress := FIndex;
      Application.ProcessMessages;
   end;
   FActualElement := Element;
   FInstance.Instance := Element;
   Reg.WriteString('Class',Instance.ElementClassName);
   if Element is TStringListElement then
   begin

   end
   else SaveProperties;
   Reg.CloseKey;
   DeleteLastKey;
end;

function TSaveToRegistry.QGoInside(Element: TElement): boolean;
begin
   result := (Element is TEntity) and not (Element is TStringListElement);
   AddKey(Element.Name);
end;


procedure TSaveToRegistry.SaveClass(aClass: TOrbisClass);
begin
  // nic
end;

procedure TSaveToRegistry.SaveElement(aValue: TElement);
begin
  // nic
end;

procedure TSaveToRegistry.SaveElements(realy: boolean);
begin
  // nic
end;

procedure TSaveToRegistry.SaveFloat(const aValue: extended);
begin
   Reg.WriteFloat(Instance.PropertyName[ActualPropertyIndex],aValue);
end;

procedure TSaveToRegistry.SaveChar(aValue: char);
begin
   Reg.WriteString(Instance.PropertyName[ActualPropertyIndex],aValue);
end;

procedure TSaveToRegistry.SaveInfo;
begin
  // nic
end;

procedure TSaveToRegistry.SaveInteger(aValue: integer);
begin
   Reg.WriteInteger(Instance.PropertyName[ActualPropertyIndex],aValue);
end;

procedure TSaveToRegistry.SaveString(const aValue: string);
begin
   Reg.WriteString(Instance.PropertyName[ActualPropertyIndex],aValue);
end;

procedure TSaveToRegistry.SetKeys(const Value: TStringList);
begin
  FKeys := Value;
end;

procedure TSaveToRegistry.DoIt;
begin
   Keys := TStringList.Create;
   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_LOCAL_MACHINE;
   inherited DoIt;
   Reg.Free;
   Keys.Free;
end;

procedure TSaveToRegistry.SetReg(const Value: TRegistry);
begin
   FReg := Value;
end;


procedure TSaveToRegistry.AddKey(const Value: string);
begin
   Keys.Add('\'+Value);
end;

procedure TSaveToRegistry.DeleteLastKey(const Value: string);
begin
   Keys.Delete(Keys.Count - 1);
end;

function TSaveToRegistry.GetActualKey: string;
var
   i: integer;
begin
   result := Key;
   for i := 0 to Keys.Count - 1 do result := result + Keys[i];
end;

procedure TSaveToRegistry.SetKey(const Value: string);
begin
  FKey := Value;
end;


function TSaveToRegistry.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'Key';
end;


end.
