unit e_People;

interface
uses
   Elements;

type
TPersonElement = class(TOwnerEntity)
  private
    FSwapName: boolean;
    FFirstName: string;
    FComment: string;
    FSecondName: string;
    FPIN: integer;
    procedure SetComment(const Value: string);
    procedure SetFirstName(const Value: string);
    procedure SetFullName(const Value: string);
    procedure SetSecondName(const Value: string);
    procedure SetSwapName(const Value: boolean);
    procedure SetPIN(const Value: integer);
    function GetFullName: string;
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
published
   property FirstName: string read FFirstName write SetFirstName;
   property SecondName: string read FSecondName write SetSecondName;
   property FullName: string read GetFullName write SetFullName stored false;
   property SwapName: boolean read FSwapName write SetSwapName;
   property Comment: string read FComment write SetComment;
   property PIN: integer read FPIN write SetPIN;
end;

TPerson_Collection = class(TOwnerEntity)
end;

implementation
uses
   SysUtils,
   e_Class,
   u_String;


{ TPersonElement }

function TPersonElement.GetFullName: string;
begin
   if SwapName then
   begin
      result := SecondName;
      if FirstName <> '' then
         result := result + ' ' + FirstName;
   end
   else
   begin
      result := FirstName;
      if SecondName <> '' then
         result := result + ' ' + SecondName;
   end;
end;

function TPersonElement.GetName: string;
begin
   result := FullName;
end;

procedure TPersonElement.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure TPersonElement.SetFirstName(const Value: string);
begin
  FFirstName := BezVnejsichMezer(Value);
end;

procedure TPersonElement.SetFullName(const Value: string);
var
   S,S1,S2: string;
begin
   S := TrimLeft(Value);
   StringAsTwoParams(S,' ',S1,S2);
   if SwapName then
   begin
      SecondName := S1;
      FirstName := S2;
   end
   else
   begin
      FirstName := S1;
      SecondName := S2;
   end;
end;

procedure TPersonElement.SetName(aName: string);
begin
   SetFullName(aName);
end;

procedure TPersonElement.SetPIN(const Value: integer);
begin
  FPIN := Value;
end;

procedure TPersonElement.SetSecondName(const Value: string);
begin
  FSecondName := BezVnejsichMezer(Value);
end;

procedure TPersonElement.SetSwapName(const Value: boolean);
begin
  FSwapName := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TPersonElement);
END.
