unit t_RasterTransformation;

interface
uses
   Graphics,
   t_InterfaceTool,
   f_RasterTransformer;
type

TRasterTransformerStatus=(rtsNIL,rtsWaitForFile,rtsDraftPosition,rtsTransformation);

TRasterTransformer = class(TInterfaceTool)
private
    FForm: TRasterTransformer_Form;
    FFileName: string;
    FBM: TBitmap;
    function GetForm: TRasterTransformer_Form;
    procedure SetFileName(const Value: string);
    procedure SetDoOpen(const Value: boolean);
protected
   property Form: TRasterTransformer_Form read GetForm;
public
   procedure On_Activate  ; override;
   procedure On_DeActivate; override;
   procedure RegisterCursors; override;
   function LoadFile: boolean;
published
   property FileName: string read FFileName write SetFileName;
   property DoOpen: boolean write SetDoOpen;
end;

implementation
uses
   Forms,
   e_Class;

{ TRasterTransformer }

function TRasterTransformer.GetForm: TRasterTransformer_Form;
begin
   result := FForm;
   if result = nil then
   begin
      FForm := TRasterTransformer_Form.Create(Application);
      FForm.Tool := Self;
      result := FForm;
   end;
end;

function TRasterTransformer.LoadFile: boolean;
begin

end;

procedure TRasterTransformer.On_Activate;
begin
  inherited;
  Form.Show;
end;

procedure TRasterTransformer.On_DeActivate;
begin
  inherited;
  FForm.Free;
  FForm := nil;
end;

procedure TRasterTransformer.RegisterCursors;
begin
   NewCursorName('EDITMS');     //0
end;

procedure TRasterTransformer.SetDoOpen(const Value: boolean);
begin
   if Value then
   begin
      if Form.OpenDialog1.Execute then
      begin
         FileName := Form.OpenDialog1.FileName;
         Form.Pages.Pages[1].Enabled := true;
         Form.Pages.ActivePageIndex := 1;
      end;
   end;
end;

procedure TRasterTransformer.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

initialization
   RegisterOrbisClass(TRasterTransformer);
end.
