unit t_TEZDET;

interface
uses
   Elements,
   Tools;
type

TFindDETforTEZ = class(TTool)
  private
    FTEZ: TEntity;
    FDET: TEntity;
    procedure SetDET(const Value: TEntity);
    procedure SetTEZ(const Value: TEntity);
public
   procedure DoIt; override;
published
   property DET: TEntity read FDET write SetDET;
   property TEZ: TEntity read FTEZ write SetTEZ;
end;

implementation
uses
   Dialogs,
   Forms,
   SysUtils,
   e_QTree,
   t_QTreeTools,
   e_LHCModel,
   e_LHCElements,
   e_Class;

{ TFindDETforTEZ }

procedure TFindDETforTEZ.DoIt;
var
   QT: TRectEntityQTree;
   AQ: TAddEntityToQTree;
   F: TFindRectEntityInQTreeByXY;
   i: integer;
   E: TElement;
   PSK: Tgis_PorostniSkupina;
   TP: Tgis_UserAreaElement;
   Nal: integer;
begin
   if (DET = nil) or (TEZ= nil) then
   begin
      ShowMessage('Chyb jedna z vrstev DET nebo TEZ');
      exit;
   end;
   AQ := TAddEntityToQTree.Create;
   AQ.Input := DET;
   AQ.DoIt;
   QT := TRectEntityQTree(AQ.Output);
   AQ.Free;
   F := TFindRectEntityInQTreeByXY.Create;
   F.Input := QT;
   StartProgress('Zaazovn tebnch ploch ke skupinm',0,TEZ.LastIndex);
   ProgressText := '0/0';
   Nal := 0;
   for i := 0 to TEZ.LastIndex do
   begin
      Progress := i;
      E := TEZ.Elements[i];
      if not (E is Tgis_UserAreaElement) then continue;
      TP := Tgis_UserAreaElement(E);
      F.X := TP.X;
      F.Y := TP.Y;
      F.DoIt;
      E := F.Output;
      if E = nil then continue;
      if not (E is Tgis_PorostniSkupina) then continue;
      PSK := Tgis_PorostniSkupina(E);
      TP._Skupina := PSK;
      Inc(Nal);
      ProgressText := IntToStr(Nal)+'/'+IntToStr(i+1);
      Application.ProcessMessages;
   end;
   F.Free;
   QT.Free;
end;

procedure TFindDETforTEZ.SetDET(const Value: TEntity);
begin
  FDET := Value;
end;

procedure TFindDETforTEZ.SetTEZ(const Value: TEntity);
begin
  FTEZ := Value;
end;

INITIALIZATION
   registerOrbisClass(TFindDETforTEZ);
END.
