unit f_OrbisForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Tools;

type
TSimpleEvent = procedure of object;

TORBISForm = class(TForm)
private
   FTool: TTool;
   FIsPossibleToClose: boolean;
   FAcceptDropFiles: boolean;
    FSizeMove: boolean;
    FOnEndSizeMove: TSimpleEvent;
    FOnStartSizeMove: TSimpleEvent;
    procedure SetSizeMove(const Value: boolean);
    procedure SetOnEndSizeMove(const Value: TSimpleEvent);
    procedure SetOnStartSizeMove(const Value: TSimpleEvent);
protected
   procedure SetTool(const Value: TTool); virtual;
   procedure SetIsPossibleToClose(const Value: boolean);  virtual;
   procedure SetAcceptDropFiles(const Value: boolean);  virtual;
   procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
   procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
   procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;
public
   procedure StartSizeMove; virtual;
   procedure EndSizeMove; virtual;
   property  SizeMove: boolean read FSizeMove write SetSizeMove;
   property  OnStartSizeMove: TSimpleEvent read FOnStartSizeMove write SetOnStartSizeMove;
   property  OnEndSizeMove: TSimpleEvent read FOnEndSizeMove write SetOnEndSizeMove;
   property Tool: TTool read FTool write SetTool;
   property AcceptDropFiles: boolean read FAcceptDropFiles write SetAcceptDropFiles;
   property IsPossibleToClose: boolean read FIsPossibleToClose write SetIsPossibleToClose;
end;


implementation
uses
   ShellApi,
   M_Orbis;

{$R *.DFM}

{ TORBISForm }

procedure TORBISForm.EndSizeMove;
begin
   SizeMove := false;
   if Assigned(OnEndSizeMove) then
      OnEndSizemove;
end;

procedure TORBISForm.SetAcceptDropFiles(const Value: boolean);
begin
   FAcceptDropFiles := Value;
   DragAcceptFiles(Handle, Value);
end;

procedure TORBISForm.SetIsPossibleToClose(const Value: boolean);
begin
  FIsPossibleToClose := Value;
end;

procedure TORBISForm.SetOnEndSizeMove(const Value: TSimpleEvent);
begin
  FOnEndSizeMove := Value;
end;

procedure TORBISForm.SetOnStartSizeMove(const Value: TSimpleEvent);
begin
  FOnStartSizeMove := Value;
end;

procedure TORBISForm.SetSizeMove(const Value: boolean);
begin
  FSizeMove := Value;
end;

procedure TORBISForm.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

procedure TORBISForm.StartSizeMove;
begin
   SizeMove := true;
   if Assigned(OnStartSizeMove) then
      OnStartSizeMove;
end;

procedure TORBISForm.WMDropFiles(var Message: TMessage);
var
   i: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S: string;
   //CL: TCommandLine;
   Size: word;
begin
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      StrDispose(P);
      Tool.PostTextMsg(tm_DropFile, S, Tool);
      //ShowMessage(S);
   end;
   Tool.PostTextMsg(tm_DropFile, '', Tool); // jako posledn se posl przdn string
end;

procedure TORBISForm.WMEnterSizeMove(var Message: TMessage);
begin
   StartSizeMove;
end;

procedure TORBISForm.WMExitSizeMove(var Message: TMessage);
begin
   EndSizemove;
end;

end.
