unit t_GeometryListForm;

interface
uses
   f_GeometryListForm,
   t_GraphicForm,
   t_FormTool,
   Tools,
   Elements;

type

TGeometryListForm = class(TFormTool)
private
    FGraphicForm: TGraphicForm;
    FText: string;
    FB1Tool: TTool;
    FB2Tool: TTool;
    function GetListForm: TGeometryList_Form;
    procedure SetGraphicForm(const Value: TGraphicForm);
    procedure SetText(const Value: string);
    procedure SetB1Tool(const Value: TTool);
    procedure SetB2Tool(const Value: TTool);
protected
   procedure   SetInput(aInput: TElement); override;
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  ListForm: TGeometryList_Form read GetListForm;
published
   property GraphicForm: TGraphicForm read FGraphicForm write SetGraphicForm;
   property Text: string read FText write SetText;
   property B1Tool: TTool read FB1Tool write SetB1Tool;
   property B2Tool: TTool read FB2Tool write SetB2Tool;
end;

implementation
uses
   Forms,
   e_Class;

{ TGeometryListForm }

procedure TGeometryListForm.CreateForm;
begin
  aForm := TGeometryList_Form.Create(Application);
  aForm.Tool := Self;
  ListForm.Layer := TEntity(Input);
  ListForm.GraphicForm := GraphicForm;
  ListForm.ItemText := Text;
end;

procedure TGeometryListForm.DoIt;
begin
   Visible := true;
   ListForm.B1Tool := B1Tool;
   ListForm.B2Tool := B2Tool;
   ListForm.CheckTools;
end;

function TGeometryListForm.GetListForm: TGeometryList_Form;
begin
   result := TGeometryList_Form(aForm);
end;

procedure TGeometryListForm.SetB1Tool(const Value: TTool);
begin
   FB1Tool := Value;
   AddTool(Value);
end;

procedure TGeometryListForm.SetB2Tool(const Value: TTool);
begin
   FB2Tool := Value;
   AddTool(Value);
end;

procedure TGeometryListForm.SetGraphicForm(const Value: TGraphicForm);
begin
   FGraphicForm := Value;
   ListForm.GraphicForm := GraphicForm;
end;

procedure TGeometryListForm.SetInput(aInput: TElement);
begin
   inherited;
   AddElement(aInput);
   ListForm.Layer := TEntity(Input);
end;

procedure TGeometryListForm.SetText(const Value: string);
begin
  FText := Value;
  ListForm.ItemText := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TGeometryListForm);
END.
