unit T_maintl;
{
[Unit_Description]
Description=Pedek hlavnho nstroje
Admin=Petr
TechTopic=Tools
Topic=Aplikace
Version=1.0
}

interface
uses
  { test }


  WinTypes,
  Elements,
// DEVICE
  d_txt,
  //T_Recurs,
  t_ProgressMonitor,
  Tools;




type

TBaseOptions = class(TOwnerEntity);

TOnProgressEvent = procedure(_ID, _Event: integer; _Name, _Text: string; _MinValue, _MaxValue, _Progress: integer) of object;
TOnSelectDirectoryEvent = function(const Caption: string; const Root: WideString; var Directory: string): boolean of object;
TOnSelectFileEvent = function(const Caption: string; const Directory: String; const Filter: string; var FileName: string): boolean of object;

TOldMainTool = class(TTechnology)
private
  FCancel: boolean;
  FProtocol: TMemoFormDevice;
  FProgressMonitor: TProgressMonitor;
    FNoProtocol: boolean;
    FOn_Progress_Event: TOnProgressEvent;
    FOn_SelectDirectory_Event: TOnSelectDirectoryEvent;
    FOn_SelectFile_Event: TOnSelectFileEvent;
  function GetProgressMonitor: TProgressMonitor;
    procedure SetNoProtocol(const Value: boolean);
    procedure SetOn_Progress_Event(const Value: TOnProgressEvent);
    procedure SetOn_SelectDirectory_Event(const Value: TOnSelectDirectoryEvent);
    procedure SetOn_SelectFile_Event(const Value: TOnSelectFileEvent);
    function Get_ComputerName: string;
    function Get_UserName: string;
protected
  function  GetParamWithExt(aExt: string): string;
{ nalezne v pkazovm dku parametr se zadanou pponou }

  procedure ReadParamsFromIni; virtual;
  procedure WriteParamsToIni; virtual;

  procedure ReadParams; virtual;
  function  GetIniFileName: string; virtual;
  function  GetWorkingDirectory: string; virtual;

  function  GetOptions: TBaseOptions; virtual; abstract;
  procedure SetOptions(aValue: TBaseOptions); virtual; abstract;

  procedure SetIniString(aGroup, aParam: string; aValue: string);
  procedure SetIniBoolean(aGroup, aParam: string; aValue: Boolean);
  procedure SetIniInteger(aGroup, aParam: string; aValue: integer);
  function  GetIniString(aGroup, aParam: string; aDef: string): string;
  function  GetIniBoolean(aGroup, aParam: string; aDef: boolean): boolean;
  function  GetIniInteger(aGroup, aParam: string; aDef: integer): integer;

public
  constructor CreateWorld;
  procedure  DoIt; override;
  procedure  LoadCursors; virtual;
  procedure  LoadplugIns; virtual;
  procedure  RunStartScripts; virtual;
  procedure  on_tm_QuitTask; override;
  procedure  On_tm_About(var Handled: boolean); virtual;
  procedure  on_tm_AddToProtocol(aMessage: TOrbisMessage); virtual;
  procedure  on_tm_Done(aMessage: TOrbisMessage); virtual;
  procedure  on_tm_Help; virtual;
  procedure  On_ProgressEvents(var aMessage: TOrbisMessage; var Handled: boolean);
  procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
  procedure  AddWorkTools; virtual;
  function   OptionPropString(aPropName: string): string;
  function   OptionBooleanProp(aPropName: string): boolean;
  property   CancelProcess: boolean read FCancel write FCancel;
  property   WorkingDirectory: string read GetWorkingDirectory;
  property   IniFileName: string read GetIniFileName;
  property   UserName: string read Get_UserName;
  property   ComputerName: string read Get_ComputerName;
  property   Options: TBaseOptions read GetOptions write SetOptions;
  property   ProgressMonitor : TProgressMonitor read GetProgressMonitor;
  procedure  onThreadTerminate(Sender:TObject);
published
  property   Protocol: TMemoFormDevice read FProtocol write FProtocol;
  property   NoProtocol: boolean read FNoProtocol write SetNoProtocol;
  property   On_Progress_Event: TOnProgressEvent read FOn_Progress_Event write SetOn_Progress_Event;
  property   On_SelectDirectory_Event: TOnSelectDirectoryEvent read FOn_SelectDirectory_Event write SetOn_SelectDirectory_Event;
  property   On_SelectFile_Event     : TOnSelectFileEvent read FOn_SelectFile_Event write SetOn_SelectFile_Event;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs,  SysUtils, Graphics,
  WinProcs,

  _IniFile,
//  Props,
  M_Orbis,
  M_Proj,
  e_Type,
  e_Wcs,
  {$IFNDEF NOMAINFORM}
  F_Main,
  {$ENDIF}
  FileVersion,
  //g_Elems,
  //u_Cursor,
  t_Loader,
  //u_CKTM,
  U_Props,
  u_Shell,
  u_String,
  Worlds;

constructor TOldMainTool.CreateWorld;
var
   S: string;
begin
   inherited Create;
   World := TWCSWorld.Create;
   World.MainTool:= Self;
   Application.OnMessage:= World.HandleWinMessage;
   Application.OnException := World.HandleException;
end;

procedure  TOldMainTool.on_tm_AddToProtocol(aMessage: TOrbisMessage);
var
   S: string;
begin
   if NoProtocol then exit;
   if Protocol = nil then FProtocol := TMemoFormDevice.Create;
   S := TOrbisTextMessage(aMessage).Text;
   if S = '' then exit;
   (*
   if S[Length(S)]=#13 then Protocol.WriteLnText(TOrbisTextMessage(aMessage).Text)
                       else Protocol.WriteText(TOrbisTextMessage(aMessage).Text);
   *)
   Protocol.WriteLnText(TOrbisTextMessage(aMessage).Text);
end;

procedure  TOldMainTool.on_tm_Done(aMessage: TOrbisMessage);
begin
   if aMessage.Sender = Protocol then Protocol := nil
   else
   if aMessage.Sender = FProgressMonitor then FProgressMonitor := nil;
   {
   if aMessage.Sender is TMemoFormDevice then Protocol := nil
   else
   if aMessage.Sender is TProgressMonitor then FProgressMonitor := nil;
   }
end;


function  TOldMainTool.GetParamWithExt(aExt: string): string;
{ nalezne v pkazovm dku parametr se zadanou pponou }
var
  I: integer;
begin
  aExt:= upperCase(aExt);
  result:= '';
  if ParamCount < 1 then exit;
  for I:= 1 to ParamCount do
  begin
    if upperCase(ExtractFileExt(ParamStr(I))) = aExt then
    begin
      result:= ParamStr(I);
      break
    end
  end
end;



function  TOldMainTool.GetIniFileName: string;
begin
  result:= GetParamWithExt('.INI');
  if (result <> '') and FileExists(result) then exit;
  result := WorkingDirectory + ChangeFileExt(ExtractFileName(ParamStr(0)), '.INI');
end;


function  TOldMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   if RootDirectory <> '' then
      S := RootDirectory
   else
      S := ExtractFilePath(ParamStr(0));
   result := CheckBackSlash(S);
end;


procedure TOldMainTool.SetIniString(aGroup, aParam: string; aValue: string);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteString(aGroup, aParam, aValue);
   IniFile.Free;
end;

procedure TOldMainTool.SetIniBoolean(aGroup, aParam: string; aValue: Boolean);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteBool(aGroup, aParam, aValue);
   IniFile.Free;
end;

procedure TOldMainTool.SetIniInteger(aGroup, aParam: string; aValue: integer);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteInteger(aGroup, aParam, aValue);
   IniFile.Free;
end;


function  TOldMainTool.GetIniString(aGroup, aParam: string; aDef: string): string;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadString(aGroup, aParam, aDef);
  IniFile.Free
end;

function  TOldMainTool.GetIniBoolean(aGroup, aParam: string; aDef: boolean): boolean;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadBool(aGroup, aParam, aDef);
  IniFile.Free
end;

function  TOldMainTool.GetIniInteger(aGroup, aParam: string; aDef: integer): integer;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadInteger(aGroup, aParam, aDef);
  IniFile.Free
end;



procedure TOldMainTool.LoadCursors;
var
   C: TStringListElement;
   i: integer;
   S,SS: string;
begin
   //LoadUserCursors;    windows
   C := World.SystemRegister.Cursors;
   if C = nil then
      exit;
   //S := ExtractFilePath(ParamStr(0));
   //CheckBackSlash(S);
   for i := 0 to C.LastIndex do
   begin
      SS := C.Strings[i];
      SS := GetAbsolutePath(SS);
      if not FileExists(SS) then
      begin
         PostTextMsg(tm_AddToProtocol, 'Cursor file: '+SS+' not found',nil);
         Continue;
      end;
      Screen.Cursors[i+1] := LoadCursorFromFile(PChar(SS));
   end;
end;



procedure TOldMainTool.AddWorkTools;
begin
end;


procedure TOldMainTool.ReadParamsFromIni;
var
  IniFile: TRealIniFile;
  I: longInt;
begin
  if Options <> nil then
  begin
    IniFile:= TRealIniFile.Create(IniFileName);
    for I:= GetPropIndex(Options,'LastIndex')+1 to GetPropCount(Options)-1 do
    begin
      SetPropString(Options, I,
                    IniFile.ReadString
                    ('Options', GetPropName(Options, I), GetPropString(Options, I)));
    end;
    IniFile.Free;
  end
end;


procedure TOldMainTool.WriteParamsToIni;
var
  IniFile: TRealIniFile;
  I: longInt;
  PropName,PropValue: string;
begin
  if Options <> nil then
  begin
    IniFile:= TRealIniFile.Create(IniFileName);
    for I:= GetPropIndex(Options,'LastIndex')+1 to GetPropCount(Options)-1 do
    begin
       PropName := GetPropName(Options, I);
       PropValue := GetPropString(Options, I);
       IniFile.WriteString('Options', PropName, PropValue);
    end;
    IniFile.Free;
  end
end;




procedure TOldMainTool.ReadParams;
begin
  {
  Parameters:
   1.ProjectFile
   2.ApplicationHandle
   3.Other
  }
  (*
  if ParamCount > 0 then
  begin
     Project := TRuntimeProject.Create(ParamStr(1));
  end;
  if ParamCount > 1 then
  begin
     Project.MainHandle := StrToInt(ParamStr(2));
  end;
  if ParamCount > 2 then
  begin
     { Other..... }
  end;
  *)
end;


procedure TOldMainTool.DoIt;
begin
   ReadParams;
   {$IFNDEF NOMAINFORM}
   Application.CreateForm(TMainForm, MainForm);
   MainForm.Tool:= Self;
   MainForm.IsPossibleToClose:= false;
   {$ENDIF}
   AddWorkTools;
   RunStartScripts;
   LoadPlugIns;
   LoadCursors;
end;


procedure  TOldMainTool.on_tm_QuitTask;
begin
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
        try
           {
           PostAppMessage(Project.MainHandle, TProjectWorld(World).WM_MODUL_END, 0, 0)
           }
        except
        end;
        Application.Terminate;
      end;
   end;
end;



procedure  TOldMainTool.On_tm_About(var Handled: boolean);
begin
   ChDir(ExtractFilePath(ParamStr(0)));
   _CreateProcess('ORBISPanel.exe',ParamStr(0)+'" "1');
end;


function   TOldMainTool.OptionPropString(aPropName: string): string;
begin
  result:= '';
  if Options = nil then exit;
  result:= GetPropStringByName(Options, aPropName)
end;

function   TOldMainTool.OptionBooleanProp(aPropName: string): boolean;
var
   S: string;
begin
   result:= false;
   S := OptionPropString(aPropName);
   if S = '' then exit;
   try
      result := UpperCase(S[1])='T';
   except
      result := false;
   end;
end;


procedure   TOldMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_About: On_tm_About(Handled);
      tm_AddToProtocol    : on_tm_AddToProtocol(aMessage);
      tm_Done             : on_tm_Done(aMessage);
      tm_StartProgress,
      tm_EndProgress,
      tm_Progress,
      tm_MaxProgress,
      tm_ProgressText: On_ProgressEvents(aMessage, Handled);
      tm_Help   :  on_tm_Help;
   end;
end;



procedure TOldMainTool.On_ProgressEvents(var aMessage: TOrbisMessage; var Handled: boolean);
var
   PM: TProgressMessage;
   TM: TOrbisTextMessage;
begin
   if Assigned(On_Progress_Event) then
   begin
      case aMessage.Message of
         tm_EndProgress:
            On_Progress_Event(Integer(aMessage.Sender),aMessage.Message,'','',0,0,0);
         tm_ProgressText:
         begin
            TM := TOrbisTextMessage(aMessage);
            On_Progress_Event(Integer(TM.Sender),TM.Message,'',TM.Text,0,0,0);
         end;
      else
         begin
            PM := TProgressMessage(aMessage);
            On_Progress_Event(Integer(PM.Sender),PM.Message,PM.ProcessName,'',PM.MinProgress,PM.MaxProgress,PM.Progress);
         end;
      end;
      Handled := true;
   end
   else
      ProgressMonitor.HandleMessage(aMessage, Handled);
end;

function TOldMainTool.GetProgressMonitor: TProgressMonitor;
begin
   if FProgressMonitor = nil then
   begin
      FProgressMonitor := TProgressMonitor.Create;
      AddTool(FProgressMonitor);
   end;
   result := FProgressMonitor;
end;

procedure TOldMainTool.LoadplugIns;
var
   S,SS: string;
   Load: TLoad;
   FV: TFileVersion;
   E: TElement;
   SLE: TStringListElement;
   i: integer;
begin
   //S := ExtractFilePath(ParamStr(0));
   //CheckBackSlash(S);
   PostTextMsg(tm_ShowText, 'Inicializace Plug - Ins',nil);
   //Text := 'Inicializace Plug - Ins';
   SS := GetAbsolutePath('Plugin.ORB');
   if FileExists(SS) then
   begin
      Load := TLoad.CreateAll(SS);
      try
         Load.DoIt;
         if Load.Output <> nil then
         begin
            Load.Output.Name := 'PLUGIN';
            World.AddElement(Load.Output);
         end;
      except
         ShowMessage('Chyba inicializace Plug Ins: '+SS);
      end;
      Load.Free;
   end;
   E := World.FindElementName('PLUGIN');
   if E = nil then
      exit;
   if not (E is TStringListElement) then
      exit;
   SLE := TStringListElement(E);
   FV := TFileVersion.Create;
   for i := 0 to SLE.LastIndex do
   begin
      S := SLE.Strings[i];
      if not FileExists(S) then
      begin
         PostTextMsg(tm_AddToprotocol,'Plug-In file: '+ S + ' not found!', nil);
         Continue;
      end;
      FV.FileName := S;
      if FV.InfoString('InternalName') = 'RBO' then
      begin
         //if not CheckModulRegistration(S) then Continue;
      end;
     LoadPackage(S);
     {!!!!!!!!!!!!!!!!!!!!!!}
   end;
   FV.Free;
end;

procedure TOldMainTool.RunStartScripts;
begin

end;

procedure TOldMainTool.SetNoProtocol(const Value: boolean);
begin
  FNoProtocol := Value;
end;

procedure TOldMainTool.SetOn_Progress_Event(const Value: TOnProgressEvent);
begin
  FOn_Progress_Event := Value;
end;

procedure TOldMainTool.SetOn_SelectDirectory_Event(const Value: TOnSelectDirectoryEvent);
begin
  FOn_SelectDirectory_Event := Value;
end;

procedure TOldMainTool.SetOn_SelectFile_Event(const Value: TOnSelectFileEvent);
begin
  FOn_SelectFile_Event := Value;
end;

procedure TOldMainTool.onThreadTerminate(Sender: TObject);
begin
   ShowMessage(' Thread end!');
end;

procedure TOldMainTool.on_tm_Help;
begin

end;

function TOldMainTool.Get_ComputerName: string;
var
   S: string;
   b: boolean;
   i: DWORD;
begin
   i := 254;
   SetLength(S,i);
   b := GetComputerName(PChar(S),i);
   if b then
   begin
      SetLength(S,i);
      result := S;
   end
   else
      S := '?';
end;

function TOldMainTool.Get_UserName: string;
var
   S: string;
   b: boolean;
   i: DWORD;
begin
   i := 254;
   SetLength(S,i);
   b := GetUserName(PChar(S),i);
   if b then
   begin
      SetLength(S,i-1);
      result := S;
   end
   else
      S := '?';
end;

END.
