unit t_OrbisFrame;

interface
uses
   Classes,
   Controls,
   Forms,
   //t_InterfaceTool,
   t_InterfaceTool;
type

TOrbisFrame = class(TInterfaceTool)
  private
    FFrame: TFrame;
    function GetHeight: integer;
    function GetLeft: integer;
    function GetTop: integer;
    function GetWidth: integer;
    procedure SetaFrame(const Value: TFrame);
    procedure SetHeight(const Value: integer);
    procedure SetLeft(const Value: integer);
    procedure SetTop(const Value: integer);
    procedure SetWidth(const Value: integer);
    function GetOwner: TComponent;
    function GetParent: TControl;
    procedure SetOwner(const Value: TComponent);
    procedure SetParent(const Value: TControl);
    function GetAlign: TAlign;
    procedure SetAlign(const Value: TAlign);
    function GetVisible: boolean;
    procedure SetVisible(const Value: boolean);
public
   constructor Create; override;
   destructor  destroy; override;
   procedure   CreateFrame; virtual;
   property  Owner: TComponent read GetOwner write SetOwner;
   property  Parent: TControl  read GetParent write SetParent;
   property  aFrame: TFrame read FFrame write SetaFrame;
published
   property Align: TAlign read GetAlign write SetAlign;
   property Left: integer read GetLeft write SetLeft;
   property Top: integer read GetTop write SetTop;
   property Width: integer read GetWidth write SetWidth;
   property Height: integer read GetHeight write SetHeight;
   property Visible: boolean read GetVisible write SetVisible;
end;

implementation
uses
   e_Class;

{ TFrameTool }

constructor TOrbisFrame.Create;
begin
   inherited;
   CreateFrame;
end;

procedure TOrbisFrame.CreateFrame;
begin
   aFrame := TFrame.Create(nil);
end;

destructor TOrbisFrame.destroy;
begin
   {
   try
   if aFrame <> nil then
      aFrame.Free;
   except
   end;
   }
   inherited;
end;

function TOrbisFrame.GetAlign: TAlign;
begin
   result := alNone;
   if aFrame <> nil then
      result := aFrame.Align;
end;

function TOrbisFrame.GetHeight: integer;
begin
   result := 0;
   if aFrame <> nil then
      result := aFrame.Height;
end;

function TOrbisFrame.GetLeft: integer;
begin
   result := 0;
   if aFrame <> nil then
      result := aFrame.Left;
end;

function TOrbisFrame.GetOwner: TComponent;
begin
   result := nil;
   if aFrame = nil then exit;
   result := aFrame.Owner;
end;

function TOrbisFrame.GetParent: TControl;
begin
   result := nil;
   if aFrame = nil then exit;
   result := aFrame.Parent;
end;

function TOrbisFrame.GetTop: integer;
begin
   result := 0;
   if aFrame <> nil then
      result := aFrame.Top;
end;

function TOrbisFrame.GetVisible: boolean;
begin
   result := false;
   if aFrame <> nil then
      result := aFrame.Visible;
end;

function TOrbisFrame.GetWidth: integer;
begin
   result := 0;
   if aFrame <> nil then
      result := aFrame.Width;
end;

procedure TOrbisFrame.SetaFrame(const Value: TFrame);
begin
   FFrame := Value;
end;

procedure TOrbisFrame.SetAlign(const Value: TAlign);
begin
   if aFrame <> nil then
      aFrame.Align := Value;
end;

procedure TOrbisFrame.SetHeight(const Value: integer);
begin
   if aFrame <> nil then
      aFrame.Height := Value;
end;

procedure TOrbisFrame.SetLeft(const Value: integer);
begin
   if aFrame <> nil then
      aFrame.Left := Value;
end;

procedure TOrbisFrame.SetOwner(const Value: TComponent);
begin
   if aFrame = nil then exit;
   if Owner <> nil then
   begin
      Owner.RemoveComponent(aFrame);
   end;
   Value.InsertComponent(aFrame);
end;

procedure TOrbisFrame.SetParent(const Value: TControl);
begin
   if aFrame = nil then exit;
   if not (Value is TWinControl) then exit;
   aFrame.Parent := TWinControl(Value);
end;

procedure TOrbisFrame.SetTop(const Value: integer);
begin
   if aFrame <> nil then
      aFrame.Top := Value;
end;

procedure TOrbisFrame.SetVisible(const Value: boolean);
begin
   if aFrame <> nil then
      aFrame.Visible := Value;
end;

procedure TOrbisFrame.SetWidth(const Value: integer);
begin
   if aFrame <> nil then
      aFrame.Width := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbisFrame);
END.
