unit ActualSQL;

interface
uses
  Classes,
  Elements,
  SysUtils,
  Windows,
  u_BdeObj,
  u_SqlList;

type
   TorbActualSql = class(TOwnerEntity)
   private
      FAlias: TorbAlias;
      FSQLGroupe: TOrbSQLGroupe;
      FSQLQuery: TOrbSQLQuery;
      FChanged: Boolean;

      function  GetSQLQuery: TOrbSQLQuery;
      function  IsEqualActualSQL(aVal: TorbActualSql): Boolean;

      procedure SetSQLQuery(const Value: TOrbSQLQuery);
      procedure SetChanged(const Value: Boolean);
    procedure SetAlias(const Value: TorbAlias);
   public

 {
      constructor Create; override;
      destructor  Destroy; override;
 }
      procedure Reset;

   protected

   published
      property Alias: TorbAlias read FAlias write SetAlias;
      property SQLGroupe: TOrbSQLGroupe read FSQLGroupe;
      property SQLQuery: TOrbSQLQuery read GetSQLQuery write SetSQLQuery;
      property Changed: Boolean read FChanged write SetChanged;
   end;

implementation
uses
  dialogs,
  e_Class;


{ TorbActualSql }
{
constructor TorbActualSql.Create;
begin
   inherited;
end;

destructor TorbActualSql.Destroy;
begin
  inherited Destroy;
end;
}


function TorbActualSql.GetSQLQuery: TOrbSQLQuery;
begin
  if FSQLQuery = nil then FSQLQuery := TOrbSQLQuery.Create;

   result := FSQLQuery;
end;



function TorbActualSql.IsEqualActualSQL(aVal: TorbActualSql): Boolean;
begin
   result := false;

   if aVal = nil then exit;

   if Alias <> aVal.Alias then exit;
   if SQLGroupe <> aVal.SQLGroupe then exit;
   if SQLQuery <> aVal.SQLQuery then exit;

   result := true;
end;



procedure TorbActualSql.Reset;
begin
   if FAlias <> nil then
   begin
      FAlias := nil;
   end;

   if FSQLGroupe <> nil then
   begin
      FSQLGroupe := nil;
   end;

   if FSQLQuery <> nil then
   begin
      FSQLQuery := nil;
   end;

   FChanged := False;
end;


procedure TorbActualSql.SetAlias(const Value: TorbAlias);
begin
   FAlias := Value;
end;

procedure TorbActualSql.SetChanged(const Value: Boolean);
begin
  FChanged := Value;
end;



procedure TorbActualSql.SetSQLQuery(const Value: TOrbSQLQuery);
begin
   if ((FSQLQuery <> Value) and FChanged) then
      ShowMessage('Ulo dotaz');

   FSQLQuery := Value;

   if FSQLQuery = nil then
   begin
      FSQLGroupe := nil;
      FAlias := nil;
   end
   else
   begin
      FSQLGroupe := TorbSQLGroupe(FSQLQuery.FindClassInOwners(TorbSQLGroupe));

      if FSQLGroupe <> nil then
         FAlias := TorbAlias(FSQLGroupe.FindClassInOwners(TorbAlias));
   end;

   FChanged := False;
end;



INITIALIZATION
   RegisterOrbisClass(TorbActualSQL);
END.
