unit U_Ini;

interface

uses classes;


function  ReadBooleanFromIni(IniFile, sekce, polozka: String; DefaultVal: Boolean): Boolean;
function  ReadIntegerFromIni(IniFile, sekce, polozka: String; DefaultVal: Integer): Integer;
function  ReadStringFromIni(IniFile, sekce, polozka, DefaultVal: String): string;

procedure EraseSection(IniFile, sekce: String);
procedure WriteBooleanToIni(IniFile, sekce, polozka: String; aBool: Boolean);
procedure WriteIntegerToIni(IniFile, sekce, polozka: String; hodnota: Integer);
procedure WriteStringToIni(IniFile, sekce, polozka, hodnota: String);



implementation

uses iniFiles, SysUtils;


procedure WriteBooleanToIni(IniFile, sekce, polozka: String; aBool: Boolean);
var
   aINI: TiniFile;
begin

   aINI := TiniFile.Create(IniFile);
   aINI.WriteBool(sekce, polozka, aBool);
   aINI.Free;
end;



procedure WriteIntegerToIni(IniFile, sekce, polozka: String; hodnota: Integer);
var
   aINI: TiniFile;
begin

   aINI := TiniFile.Create(IniFile);
   aINI.WriteInteger(sekce, polozka, hodnota);
   aINI.Free;
end;



procedure WriteStringToIni(IniFile, sekce, polozka, hodnota: String);
var
   aINI: TiniFile;
begin
{
[SEKCE]
polozka = hodnota
}

   aINI := TiniFile.Create(IniFile);
   aINI.WriteString(sekce, polozka, hodnota);
   aINI.Free;
end;



function ReadBooleanFromIni(IniFile, sekce, polozka: String; DefaultVal: Boolean): Boolean;
var
   aIni: TiniFile;
begin
   aIni := TiniFile.Create(IniFile);
   Result := aIni.ReadBool(sekce, polozka, DefaultVal);
   aIni.Free;

end;


function ReadIntegerFromIni(IniFile, sekce, polozka: String; DefaultVal: Integer): Integer;
var
   aIni: TiniFile;
begin
   aIni := TiniFile.Create(IniFile);
   Result := aIni.ReadInteger(sekce, polozka, DefaultVal);
   aIni.Free;

end;



function ReadStringFromIni(IniFile, sekce, polozka, DefaultVal: String): string;
var
   aIni: TiniFile;
begin
   aIni := TiniFile.Create(IniFile);
   Result := aIni.ReadString(sekce, polozka, DefaultVal);
   aIni.Free;
end;


procedure EraseSection(IniFile, sekce: String);
var
   aINI: TiniFile;
begin

   aINI := TiniFile.Create(IniFile);
   aINI.EraseSection(sekce);
   aINI.Free;
end;


end.
