unit PrevTab;
INTERFACE

uses

  CtiPar,
  Dos;


type
  PPrevodBunky = ^TPrevodBunky;
  TPrevodBunky = record
     Nazev: string[6];
     Kod  : integer;
     Dalsi: PPrevodBunky;
  end;

  PPrevodniTabulka = ^TPrevodniTabulka;
  TPrevodniTabulka = object
     Body: PPrevodBunky;
     BodyOK: boolean;
     constructor Init;
     destructor  Done;
     procedure   PridejBunku(Bunka: PPrevodBunky);
     function    VratKodDleBunky(B: string): integer;
     procedure   ZrusBunky;
  end;

  { Objekt pro nacitani Prevodni tabulky z textoveho souboru }
  { ************************************************************ }

  PCteniPrevodniTabulky = ^TCteniPrevodniTabulky;
  TCteniPrevodniTabulky = object(TCteniParametru)
    constructor Init;
    procedure   CtiTabulku;
    procedure   CtiBunky;
    function    DejBoolParametr: boolean;
    function    DejIntParametr: Integer;
  end;

var

  PrevodniTabulka: TPrevodniTabulka;

procedure  InicializacePrevodniTabulky;

IMPLEMENTATION

uses

  CtiRadek,
  Global,
  StrProc;

const

  Ano = True;
  Ne  = False;

  lzBunky          = 'BUNKY';
  lzEnd            = 'END';
  lzKod            = 'KOD';

{
  **********************************************************
  *                                                        *
  *             Tela metod TPrevodniTabulka                *
  *                                                        *
  **********************************************************
}

constructor TPrevodniTabulka.Init;
begin
  Body   := nil;
  BodyOK := Ne;
end;


destructor  TPrevodniTabulka.Done;
begin
  ZrusBunky;
end;


procedure   TPrevodniTabulka.PridejBunku(Bunka: PPrevodBunky);
begin
  Bunka^.Dalsi := Body;
  Body         := Bunka;
end;



function    TPrevodniTabulka.VratKodDleBunky(B: string): integer;
var
  NameB: String;
  P: PPrevodBunky;
begin
  P := Body;
  while P <> nil do
  begin
     NameB := BezVnejsichMezer(B);
     NameB := UpStr(NameB);
     if NameB = P^.Nazev then
     begin
        VratKodDleBunky := P^.Kod;
        exit;
     end;
     P := P^.Dalsi;
  end;
  VratKodDleBunky := 0;
end;



procedure   TPrevodniTabulka.ZrusBunky;
var
  P,PP: PPrevodBunky;
begin
  P := Body;
  while P <> nil do
  begin
    PP := P^.Dalsi;
    dispose(P);
    P := PP;
  end;
end;



{
  **********************************************************
  *                                                        *
  *             Tela metod TCteniPrevodniTabulky           *
  *                                                        *
  **********************************************************
}

constructor TCteniPrevodniTabulky.Init;
var
   OuKlej: boolean;
begin
   inherited Init(AdresarDGN + 'TABULKA.TTT', OuKlej);
end;



procedure   TCteniPrevodniTabulky.CtiTabulku;
var
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;

begin
  PrevodniTabulka.Init;

  { Zatim pouze prevod bunek (CELLS) na body s definovanym druhem }
  { ------------------------------------------------------------- }
  if SouborOK then
  begin
     { Hledam bunky }
     { ------------ }
     repeat
        DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                   NazevParametru, HodnotaParametru);
     until (JeToInfo and (HodnotaParametru = lzBunky)) or PosledniRadek;
     if PosledniRadek then exit;
     Ctibunky;
  end;
end;


procedure   TCteniPrevodniTabulky.CtiBunky;
var
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;
  PBunka: PPrevodBunky;
begin
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     if not JeToInfo then
     begin
        new(PBunka);
        with PBunka^ do
        begin;
           Nazev := NazevParametru;
           Kod   := DejIntParametr;
           Dalsi := nil;
        end;
        PrevodniTabulka.PridejBunku(PBunka);
     end;
  until JeToInfo and (HodnotaParametru = lzEnd);
end;


function    TCteniPrevodniTabulky.DejBoolParametr: boolean;
var
  CtiR: TCtiRadek;

begin
  CtiR.Init(Hodnota);
  DejBoolParametr:= CtiR.DejBoolean;
  CtiR.Done
end;

{-----------------------------------------------------------}
function    TCteniPrevodniTabulky.DejIntParametr: Integer;
var
  CtiR: TCtiRadek;

begin
  CtiR.Init(Hodnota);
  DejIntParametr:= CtiR.DejInteger;
  CtiR.Done
end;



{-----------------------------------------------------------}

procedure InicializacePrevodniTabulky;
var
  Ctenar: TCteniPrevodniTabulky;
begin
   Ctenar.Init;

   Ctenar.CtiTabulku;

   Ctenar.Done;

end;



End.