unit U_dgn;

interface

procedure RadixToAscii(var Rad: TCellName; var Asc: string; Delka: byte);
procedure VaxToIeee(var D: double);
function  SwapLong( L: longInt ): LongInt;
function  LL(L: LongInt): Real;
procedure KontrolaSour(var S: Tsour);
procedure Bod2DnaSour(B: Point2D; var S: TSour);
procedure Bod3DnaSour(B: Point3D; var S: TSour);
procedure DBod2DnaSour(var B: DPoint2D; var S: TSour);
procedure DBod3DnaSour(var B: DPoint3D; var S: TSour);
procedure PosunSour(var ss: TSour);{ Posunuti vzhledem ke globalnimu pocatku }


implementation


procedure RadixToAscii(var Rad: TCellName; var Asc: string; Delka: byte);
  var
    Status: Integer;
    c, i, IRad: byte;
    n: word;
  begin;
     c      := 0;
     n      := 0;
     IRad   := 0;
     status := 0;
     Asc    := '';
     for  i := 0 to Delka - 1 do
     begin

       case (i mod 3) of
         0:
         begin
           n := Rad[IRad];
           Inc(IRad);
           c := n div 1600;
           n := n mod 1600;
         end;
         1:
         begin
           c := n div 40;
           n := n mod 40;
         end;
         2:
           c := n;
       end;
       if (c = 0) then
          c := 32
       else
       if (c >= 1) and (c <= 26) then
          c := c + 64
       else
       if (c = 27 ) then
          c := Ord('$')
       else
       if (c = 28 ) then
          c := Ord('.')
       else
       if (c >= 30) and (c <= 39 ) then
          c := c + 18
       else
       begin
         c := 32;
         status := -1;
       end;
       Asc := Asc + Chr(c);
     end;
     {
     return status;
     }
   end;


procedure VTI(var D: double); near;
begin
  asm
      push  di
      push  si
      push  ds
      lds   si,[bp+04]
      mov   ax,word ptr [si]
      mov   bx,word ptr [si+02]
      mov   cx,word ptr [si+04]
      mov   dx,word ptr [si+06]
      mov   di,ax
      and   di,8000H
      and   ax,7fffH
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      or    ax,ax
      je    @@Nula
      add   ax,37e0H
  @@Nula:
      or    ax,di
      mov   word ptr [si],dx
      mov   word ptr [si+02],cx
      mov   word ptr [si+04],bx
      mov   word ptr [si+06],ax
      pop   ds
      pop   si
      pop   di
  end;
end;

procedure VaxToIeee(var D: double);
begin
   VTI(D);
end;


function SwapLong( L: longInt ): LongInt; assembler;
  asm
    mov   ax, word ptr L + 2
    mov   dx, word ptr L
  end;


function LL(L: LongInt): Real;
  var
     PomR: Real;
  begin
     PomR   := SwapLong(L);
     LL     := PomR/Prep;
  end;

procedure KontrolaSour(var S: Tsour);
  begin
     if (Abs(S.x) > 1E8) or
        (Abs(S.y) > 1E8) then
     begin
        Lup;
        Hlaska('Nalezena souradnice s hodnotou nepouzitelnou v TopoLu - Bude prevedena jako 0!',False);
        S.y := 0;
        S.x := 0;
     end;
  end;

procedure Bod2DnaSour(B: Point2D; var S: TSour);
  begin
     S.y := LL(B.x);
     S.x := LL(B.y);
     KontrolaSour(S);
  end;


procedure Bod3DnaSour(B: Point3D; var S: TSour);
  begin
     S.y := LL(B.x);
     S.x := LL(B.y);
     KontrolaSour(S);
  end;



procedure DBod2DnaSour(var B: DPoint2D; var S: TSour);
  begin
     VaxToIeee(B.x);
     S.y := B.x/Prep;
     VaxToIeee(B.y);
     S.x := B.y/Prep;
     KontrolaSour(S);
  end;


procedure DBod3DnaSour(var B: DPoint3D; var S: TSour);
  begin
     VaxToIeee(B.x);
     S.y := B.x/Prep;
     VaxToIeee(B.y);
     S.x := B.y/Prep;
     KontrolaSour(S);
  end;



procedure PosunSour(var ss: TSour);{ Posunuti vzhledem ke globalnimu pocatku }
  begin
     ss.y := ss.y - Pocatek.y;
     ss.x := ss.x - Pocatek.x;
     KontrolaSour(ss);
  end;




end.
