unit i_TMPText;

interface
uses
   i_Basic,
   Elements;

type

TTMPTextInterpret = class(TInterpret)
protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
end;


implementation
uses
   Forms,
   Graphics,
   Windows,
   MathLib,
   g_Elems,
   e_Class,
   e_Device,
   e_TMPText;

{ TTMPTextInterpret }

function DejPocetCR(aText: string): integer;
var
  Konec: boolean;
  PosCR: integer;
begin
  Konec:= false;
  result:= 0;
  repeat
    PosCR:= pos(#13+#10, aText);
    if PosCR = 0 then
    begin
      Konec:= true;
    end
    else
    begin
      aText:= copy(aText, PosCR+2, 255);
      inc(result)
    end;
  until Konec
end;

function TTMPTextInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := aObject.ClassType = TTMPText;
end;

procedure TTMPTextInterpret.Process(Element: TElement);
var
   T: TTMPText;
   FS: integer;
   Angle: double;
   aCrd: TDoubleCoord;
   Konec: boolean;
   aText, WText,S: string;
   PosCR: integer;
   aPocetCR: integer;
   aTM: TTextMetric;
   aPom: double;
   anOK: boolean;
   RealHeight,WHeight,
   RealDescent,WDescent,
   dHeight: double;
   Resolution,Mult: double;
   aDevice: TCanvasDevice;
begin
   T := TTMPText(Element);
   aDevice := TCanvasDevice(Device);
   // TEST cross
   aDevice.Pen.Color:= 255;
   aDevice.Pen.Style:= psSolid;
   aDevice.Pen.Width:= 1;
   aDevice.MoveTo(T.X-0.5, T.Y);
   aDevice.LineTo(T.X+0.5, T.Y);
   aDevice.MoveTo(T.X, T.Y-0.5);
   aDevice.LineTo(T.X, T.Y+0.5);

   // rect
   aDevice.Pen.Color:= $00FF00;
   aDevice.MoveTo(T.MinX, T.MinY);
   aDevice.LineTo(T.MaxX, T.MinY);
   aDevice.LineTo(T.MaxX, T.MaxY);
   aDevice.LineTo(T.MinX, T.MaxY);
   aDevice.LineTo(T.MinX, T.MinY);
   //END TEST cross

   if T.TextSize = 0 then
   begin
      Resolution := 1000 * Screen.PixelsPerInch / 25.4;
      Mult := 10000 / Resolution;
      //T.TextSize := -Round(T.TextHeight/Mult);
      T.TextSize := {Round}(T.TextHeight/Mult);
   end;
   FS:= round(10000.0 * T.TextSize/ aDevice.Projection.Scale);
   if abs(FS) < 2 then
   with aDevice.Canvas do
   begin
     Pen.Color:= T.TextColor;
     Pen.Style:= psSolid;
     Pen.Width:= 1;
     aDevice.MoveTo(T.X, T.Y);
     aDevice.LineTo(T.X+aDevice.Projection.GetModelLength(5), T.Y)
   end
   else
   begin
     with aDevice.Canvas do
     begin
       Font.Name:= T.FontName;
       Font.Size:= FS;
       Font.Color:= T.TextColor;
       Font.Style:= TFontStyles(T.FontStyle);
 // Vaek 7.9.2001
       Font.Charset := EASTEUROPE_CHARSET;
     end;
     Angle := T.TextAngle;
     Angle:= Angle * 180/Pi;
     //Angle:= ZMAngle * 180/Pi
     //Angle:= 180*ATan2M(QPX-QLX, QPY-QLY)/Pi;
     aCrd.X:= T.X;
     aCrd.Y:= T.Y;
     Konec:= false;

     aText:= T.Text;
     S := aText;
     aPocetCR:= DejPocetCR(S);

     aDevice.SetTextOrientation(0);
     anOK:= GetTextMetrics(TCanvasDevice(aDevice).Canvas.Handle, aTM);
     RealHeight := aDevice.TextModelHeight(S);
     RealDescent := (RealHeight / aTM.tmHeight) * aTM.tmDescent;
     //aPom:= aDevice.TextModelHeight(QText);
     //aPom:= (aPom / aTM.tmHeight) * aTM.tmDescent;

     aDevice.SetTextOrientation(Angle);
     anOK:= GetTextMetrics(TCanvasDevice(aDevice).Canvas.Handle, aTM);
     WHeight := aDevice.TextModelHeight(S);
     WDescent := (WHeight / aTM.tmHeight) * aTM.tmDescent;
     dHeight := (WHeight-WDescent) - (RealHeight-RealDescent);

     VratPosunutyBod(aCrd, -(DejRadZeStupnu(Angle)+PiPul),
                     RealDescent, aCrd);

     VratPosunutyBod(aCrd, DejRadZeStupnu(Angle)+PiPul,
                     RealHeight*(aPocetCR + 1)+dHeight, aCrd);

     repeat
       PosCR:= pos(#13+#10, aText);

       if PosCR = 0 then
       begin
         Konec:= true;
         WText:= aText;
       end
       else
       begin
         WText:= copy(aText, 1, PosCR-1);
         aText:= copy(aText, PosCR+2, 255);
       end;
       aDevice.SetTextOrientation(Angle);
       aDevice.TextOut(aCrd.X, aCrd.Y, WText);

       if PosCR > 0 then
       begin
         with aDevice.Canvas do
         begin
           Font.Name:= T.FontName;
           Font.Size:= FS;
           Font.Color:= T.TextColor;
           Font.Style:= TFontStyles(T.FontStyle);
           Font.Charset := EASTEUROPE_CHARSET;
        end;
         VratPosunutyBod(aCrd, DejRadZeStupnu(Angle)-PiPul,
                         RealHeight, aCrd);
       end;

     until Konec
   end
end;

function TTMPTextInterpret.QProcessBefore(Element: TElement): boolean;
begin
   Result:= (Element.ClassType = TTMPText);
end;

INITIALIZATION
   RegisterOrbisClass(TTMPTextInterpret);
END.

