unit E_page;
{
[Unit_Description]
Description=Tdy strnek zazen
Admin=Olda
TechTopic=Elements
Topic=Zobrazen dat
Version=1.0

[Edit]
 8.8.1997 19:57=Registrace
}


interface

uses
   Classes,
   Graphics,
   WinTypes,
   // KERNEL
   Elements,
   // GLIB
   g_Elems;

type


T_Page = class(TOwnerElement)
 protected
   FHandler: word;
   FColor: TColor;
   FResolution: TDoubleCoord;              { rozlien v bodech na m }
   FRect: TRect;
   FClipRegion: TRect;
   FClipping: boolean;
   FCenterToClipRegion: boolean;
   procedure SetColor(aColor: TColor);
   function  GetWidth: integer;
   function  GetHeight: integer;
   function  GetHRes: double;
   function  GetVRes: double;
 public
   procedure Load(aReader: TReader; aIndex: TEntity); override;
   procedure Save(aWriter: TWriter); override;
   procedure Assign(Source: TPersistent); override;
   procedure SetClipRegion(aCR: TRect);
   procedure SetRect(x1, y1, x2, y2: integer);
   procedure SetRectPoints(A, B: WinTypes.TPoint);
   procedure SetResolution(x, y: double);

   property  Handler: word read FHandler;
   property  Color: TColor read FColor write SetColor;
   property  ClipRegion: TRect read FClipRegion write SetClipRegion;
   property  Clipping: boolean read FClipping write FClipping;
   property  CenterToClipRegion: boolean read FCenterToClipRegion write FCenterToClipRegion;
   property  Rect: TRect read FRect write FRect;
   property  Resolution: TDoubleCoord read FResolution;
 published
   property  Width: integer read GetWidth;
   property  Height: integer read GetHeight;
   property  HRes: double read GetHRes;  { v bodech na m}
   property  VRes: double read GetVRes;  { v bodech na m}
end;




implementation

uses
 {!T_Main, }
   // KERNEL
   e_Class;


{ T_Page }


function  T_Page.GetHRes: double;
begin
   result := Resolution.x;
end;

function  T_Page.GetVRes: double;
begin
   result := Resolution.y;
end;




procedure T_Page.SetColor(aColor: TColor);
begin
   FColor := aColor;
end;

function  T_Page.GetWidth: integer;
begin
   result := FRect.Right - FRect.Left;
end;

function  T_Page.GetHeight: integer;
begin
   result := FRect.Bottom - FRect.Top;
end;


procedure  T_Page.Load(aReader: TReader; aIndex: TEntity);
begin
   inherited Load(aReader, aIndex);
   aReader.Read(FHandler, SizeOf(FHandler)   +
                          SizeOf(FColor)     +
                          SizeOf(FResolution)+
                          SizeOf(FRect)      +
                          SizeOf(FClipRegion)+
                          SizeOf(FClipping)  +
                          SizeOf(FCenterToClipRegion));
end;


procedure  T_Page.Save(aWriter: TWriter);
begin
   inherited Save(aWriter);
   aWriter.Write(FHandler,SizeOf(FHandler)   +
                          SizeOf(FColor)     +
                          SizeOf(FResolution)+
                          SizeOf(FRect)      +
                          SizeOf(FClipRegion)+
                          SizeOf(FClipping)  +
                          SizeOf(FCenterToClipRegion));
end;




procedure T_Page.Assign(Source: TPersistent);
var
   aPage: T_Page;
begin
   if not (Source is T_Page) then exit;
   aPage := T_Page(Source);
   {
   FHandler           := aPage.Handler;
   }
   Color              := aPage.Color;
   ClipRegion         := aPage.ClipRegion;
   Clipping           := aPage.Clipping;
   CenterToClipRegion := aPage.CenterToClipRegion;
   Rect               := aPage.Rect;
   FResolution         := aPage.Resolution;
end;



procedure T_Page.SetClipRegion(aCR: TRect);
begin
   FClipRegion := aCR;
end;


procedure T_Page.SetRect(x1, y1, x2, y2: integer);
begin
   FRect.Left   := x1;
   FRect.Top    := y1;
   FRect.Right  := x2;
   FRect.Bottom := y2;
end;


procedure T_Page.SetRectPoints(A, B: WinTypes.TPoint);
begin
   FRect.TopLeft     := A;
   FRect.BottomRight := B;
end;


procedure T_Page.SetResolution(x, y: double);
begin
   FResolution.x := x;
   FResolution.y := y;
end;



INITIALIZATION
   RegisterOrbisClass(T_Page);
END.
