unit t_Device;
{
[Unit_Description]
Description=Nstroj se zazenm
Admin=Petr
TechTopic=Tools
Topic=Interpretace
Version=1.0
}

interface

uses
   Classes,
   Controls,
   // KERNEL
   Elements,
   Tools,
   // DEVICE
   e_Device;

type

{ Nstroj pro prci s Device - zazen }
TDeviceTool = class(TTechnology)
  private
    FDevice: TDevice;
    function  GetDevice: TDevice;
    procedure SetDevice(aDevice: TDevice);
    function  GetDeviceScale: double;
    procedure SetDeviceScale(aValue: double);
  public
    procedure   PostMouseEvent(Msg: longInt; Receiver: TElement; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer; Active: boolean); virtual; abstract;
    procedure   PostKeyEvent(Msg: longInt; Receiver: TElement; Key: Word;
                             Shift: TShiftState); virtual; abstract;
    property    Device: TDevice read GetDevice write SetDevice;
  published
    property    Scale: double read GetDeviceScale write SetDeviceScale stored false;
end;

{
TDeviceTool = class(TTechnology)
  private
    FDevices: TDevices;
    function  GetDevices: TDevices;
    function  GetDevice(aIndex: longInt): TDevice;
    procedure PutDevice(aIndex: longInt; aDevice: TDevice);
    procedure SetDevices(aDevices: TDevices);
  public
    function  AddDevice(aDevice: TDevice): TDevice;
    property  Devices: TDevices read GetDevices write SetDevices;
    property  Device[Index: longint]: TDevice read GetDevice write PutDevice;
  end;
}



implementation

uses
   // KERNEL
   e_Class;

{  TDeviceTool }

function  TDeviceTool.GetDevice: TDevice;
begin
   result := FDevice;
end;



procedure TDeviceTool.SetDevice(aDevice: TDevice);
begin
   if assigned(FDevice) then
   begin
     RemoveElement(FDevice);
     FDevice:= nil
   end;

   FDevice := aDevice;
   AddElement(FDevice);
end;


function TDeviceTool.GetDeviceScale: double;
begin
  result:= 0;
  try
    result:= Device.Projection.Scale
  except
  end;
end;


procedure TDeviceTool.SetDeviceScale(aValue: double);
begin
  try
    Device.Projection.Scale:= aValue
  except
  end;
end;



{
function  TDeviceTool.GetDevices: TDevices;
begin
   if not assigned(FDevices) then
   begin
      FDevices := TDevices.Create;
      AddElement(FDevices);
   end;
   result := FDevices;
end;


function  TDeviceTool.GetDevice(aIndex: longInt): TDevice;
begin
   result := Devices.Device[aIndex];
end;


procedure TDeviceTool.PutDevice(aIndex: longInt; aDevice: TDevice);
begin
   Devices.Device[aIndex] := aDevice;
end;


procedure TDeviceTool.SetDevices(aDevices: TDevices);
begin
   if assigned(FDevices) then
   begin
     FreeElement(FDevices);
     FDevices := nil
   end;
   FDevices := aDevices;
   AddElement(FDevices);
end;

function  TDeviceTool.AddDevice(aDevice: TDevice): TDevice;
begin
   Devices.AddElement(aDevice);
   result := aDevice;
end;



}

INITIALIZATION
   RegisterOrbisClass(TDeviceTool);
END.
