unit G_elem2;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy grafickch objekt .2                           *
*                                                                   *
*                       Topol Pro 1996                             *
*                                                                   *
*********************************************************************
}
INTERFACE
uses
   Classes,
   Graphics,
// KERNEL
   Elements,
// GLIB
   G_Elems;

type




{ Rotovan obdlnk }
TDrawRectRot = class(TDrawRectangle)
private
  FAngle: double;
  FRotWidth: double;  { rotovan ka a vka }
  FRotHeight: double;
  FRefX, FRefY: double;
  FRef_LBX, FRef_LBY: double; { vzdalenost Ref vi LB relativn vzhledem k
                                RotWidth a RotHeight}
  FBitMap: TBitMap;

  function GetRefCrd: TDoubleCoord;

  function GetLBX: double;
  function GetLBY: double;
  function GetRBX: double;
  function GetRBY: double;
  function GetLUX: double;
  function GetLUY: double;
  function GetRUX: double;
  function GetRUY: double;


public
  function XYInside(aX, aY: double): boolean;
  procedure SetRectangle;

published
  property Angle: double read FAngle write FAngle; { rad }
  property RotWidth:  double read FRotWidth  write FRotWidth;
  property RotHeight: double read FRotHeight write FRotHeight;
  property RefX: double read FRefX write FRefX;
  property RefY: double read FRefY write FRefY;
  property Ref_LBX: double read FRef_LBX write FRef_LBX; { 0 .. 1 }
  property Ref_LBY: double read FRef_LBY write FRef_LBY; { 0 .. 1 }
  property LBX: double read GetLBX;
  property LBY: double read GetLBY;
  property RBX: double read GetRBX;
  property RBY: double read GetRBY;
  property LUX: double read GetLUX;
  property LUY: double read GetLUY;
  property RUX: double read GetRUX;
  property RUY: double read GetRUY;
end;




IMPLEMENTATION

uses
  SysUtils,
// KERNEL
  E_Class,
  u_String,
// GLIB
  AnalInt,
  MathLib;




{
procedure Rotatate4Crds(CrdLD: TDoubleCoord;
                        Width, Height, Angle: double;
                        var Crd1, Crd2, Crd3, Crd4: TDoubleCoord);
begin
  Crd1:= CrdLD;
  Crd2.X:= CrdLD.X + Width;
  Crd2.Y:= CrdLD.Y;
  Crd3.X:= CrdLD.X + Width;
  Crd3.Y:= CrdLD.Y + Height;
  Crd4.X:= CrdLD.X;
  Crd4.Y:= CrdLD.Y + Height;

  RotateCrd(Crd1, Crd2, Angle);
  RotateCrd(Crd1, Crd3, Angle);
  RotateCrd(Crd1, Crd4, Angle);
end;
}


function TDrawRectRot.GetRefCrd: TDoubleCoord;
begin
  result.X:= RefX;
  result.Y:= RefY
end;


function TDrawRectRot.GetLBX: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX - RotWidth * Ref_LBX;
  aCrd.Y:= RefY - RotHeight * Ref_LBY;
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.X
end;


function TDrawRectRot.GetLBY: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX - RotWidth * Ref_LBX;
  aCrd.Y:= RefY - RotHeight * Ref_LBY;
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.Y
end;

function TDrawRectRot.GetRBX: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX + RotWidth * (1-Ref_LBX);
  aCrd.Y:= RefY - RotHeight * Ref_LBY;
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.X
end;


function TDrawRectRot.GetRBY: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef  := GetRefCrd;
  aCrd.X:= RefX + RotWidth * (1-Ref_LBX);
  aCrd.Y:= RefY - RotHeight * Ref_LBY;
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.Y
end;

function TDrawRectRot.GetLUX: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX - RotWidth * Ref_LBX;
  aCrd.Y:= RefY + RotHeight * (1-Ref_LBY);
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.X
end;


function TDrawRectRot.GetLUY: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX - RotWidth * Ref_LBX;
  aCrd.Y:= RefY + RotHeight * (1-Ref_LBY);
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.Y
end;


function TDrawRectRot.GetRUX: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX + RotWidth * (1-Ref_LBX);
  aCrd.Y:= RefY + RotHeight * (1-Ref_LBY);
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.X
end;


function TDrawRectRot.GetRUY: double;
var
  aRef,
  aCrd: TDoubleCoord;
begin
  aRef:= GetRefCrd;
  aCrd.X:= RefX + RotWidth * (1-Ref_LBX);
  aCrd.Y:= RefY + RotHeight * (1-Ref_LBY);
  aCrd:= GetRotatedCrd(aRef, aCrd, Angle);
  result:= aCrd.Y
end;



procedure TDrawRectRot.SetRectangle;
var
  aMinX, aMaxX, aMinY, aMaxY: double;
begin
  aMinX:= 1E30; aMaxX:= -1E30;
  aMinY:= 1E30; aMaxY:= -1E30;

  if LBX < aMinX then aMinX:= LBX;
  if LUX < aMinX then aMinX:= LUX;
  if RBX < aMinX then aMinX:= RBX;
  if RUX < aMinX then aMinX:= RUX;

  if LBX > aMaxX then aMaxX:= LBX;
  if LUX > aMaxX then aMaxX:= LUX;
  if RBX > aMaxX then aMaxX:= RBX;
  if RUX > aMaxX then aMaxX:= RUX;

  if LBY < aMinY then aMinY:= LBY;
  if LUY < aMinY then aMinY:= LUY;
  if RBY < aMinY then aMinY:= RBY;
  if RUY < aMinY then aMinY:= RUY;

  if LBY > aMaxY then aMaxY:= LBY;
  if LUY > aMaxY then aMaxY:= LUY;
  if RBY > aMaxY then aMaxY:= RBY;
  if RUY > aMaxY then aMaxY:= RUY;

  MinX:= aMinX;
  MaxX:= aMaxX;
  MinY:= aMinY;
  MaxY:= aMaxY
end;

function TDrawRectRot.XYInside(aX, aY: double): boolean;
begin
  result:= Inside4XY(aX, aY, LUX, LUY, RUX, RUY, LBX, LBY, RBX, RBY)
end;



begin
   RegisterOrbisClass(TDrawRectRot);
end.

