unit I_uni;

{
[Unit_Description]
Description=Obecn interpret pouvajc interpretan pedpis
Admin=Petr
TechTopic=Interprets
Topic=Zobrazen dat
Version=1.0
}


interface
uses
   // KERNEL
   Elements,
   e_Time,
   Tools,
   // DEVICE
   e_Device,
   // INTERPRET
   e_IScrpt,
   e_InterpretContainer,
   i_Basic;

const
   MaxElementCount = 200;

type

TUniversalInterpret = class(TInterpret)
private
   FInterpretByLayer: Boolean;
   FLayerClass: TElementClass;
   FTile: boolean;
   FTileDevice: TTileDevice;
    FTilePart: boolean;
   procedure SetTile(const Value: boolean);
   procedure SetTileDevice(const Value: TTileDevice);
   function GetTileDevice: TTileDevice;
{ TODO -oO. -cNovinka :  }
   function ShowLayer(aIL: TInterpretLayer): boolean;
    procedure SetTilePart(const Value: boolean);
    procedure SetFrameElement(const Value: TElement);

protected
   FTimer: TTickElement;
   FScript: TInterpretScript;
   FLastScript: TISInstance;
   FCanGoInside: boolean;
   FInterpret: TInterpret;
   FCounter: Word;

   function  GetTimer: TTickElement;
   function  QGoInside(anElement: TElement): boolean; override;
   function  QProcessBefore(anElement: TElement): boolean; override;
   function  QProcessAfter(anElement: TElement): boolean; override;
   procedure Process(anElement: TElement); override;
   function  GetScript: TInterpretScript;
   procedure SetScript(aScript: TInterpretScript);
   procedure SetBreak(aBreak: boolean); override;
public
   procedure BeforeDoIt; override;
   procedure DoIt; override;
   procedure AfterDoIt; override;
   procedure On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure On_tm_ReViewByElement(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure TransparencyBegin(Value: integer);
   procedure TransparencyEnd;
published
   property  Timer: TTickElement read GetTimer stored false;
   property  Script: TInterpretScript read GetScript write SetScript;
   property  CanGoInside: boolean read FCanGoInside write FCanGoInside default false;
   property  Counter: word read FCounter write FCounter default 0;
   property  Interpret: TInterpret read FInterpret write FInterpret;
   property  Tile: boolean read FTile write SetTile;
   property  TilePart: boolean read FTilePart write SetTilePart;
   property  TileDevice: TTileDevice read GetTileDevice write SetTileDevice;

   property InterpretByLayer: Boolean  read FInterpretByLayer write FInterpretByLayer;
   property LayerClass: TElementClass read FLayerClass write FLayerClass;
   property FrameElement: TElement write SetFrameElement stored false;
end;

implementation
uses
   {Test}
   Dialogs,
   Forms,
   Graphics,
   SysUtils,
   {!T_Main,}
   // GLib
   G_Elems,
   // KERNEL
   m_Orbis,
   e_Class;

function  TUniversalInterpret.GetTimer: TTickElement;
begin
   if FTimer = nil then
   begin
      FTimer := TTickElement.Create;
      AddElement(FTimer);
//o.s.      FTimer.Interval := '0.1';
      FTimer.Interval := 200;
   end;
   result := FTimer;
end;


function  TUniversalInterpret.QGoInside(anElement: TElement): boolean;
var
  aIL: TInterpretLayer;
begin
  if anElement is TInterpretLayer then
  begin
    aIL:= TInterpretLayer(anElement);
    result:= ShowLayer(aIL);
  end
  else
    result := CanGoInside and (anElement is TEntity);
end;



function  TUniversalInterpret.QProcessBefore(anElement: TElement): boolean;
var
  aIL: TInterpretLayer;
begin
  if anElement is TInterpretLayer then
  begin
    aIL:= TInterpretLayer(anElement);
    result:= ShowLayer(aIL);
    if not Result then
       Exit;
    TransparencyBegin(aIL.Transparency);
    if  aIL.VirtualScale > 0 then
    begin
       aIL.BackVirtualScale := Device.Projection.VirtualScale;
       Device.Projection.VirtualScale := aIL.VirtualScale;
    end;
    if (aIL.Interpret <> nil) and (aIL.LayerClass <> nil) then
    begin
      Interpret:= aIL.Interpret;
      Interpret.Reset(Device);
      LayerClass:= aIL.LayerClass;
      InterpretByLayer:= true;
      Exit;
    end
  end;

  Result:= inherited QProcessBefore(anElement)
end;


function  TUniversalInterpret.QProcessAfter(anElement: TElement): boolean;
var
   aIL: TInterpretLayer;
begin
  if anElement is TInterpretLayer then
  begin
    if InterpretByLayer then
       Interpret.Close;
    aIL := TInterpretLayer(anElement);
    if aIL.VirtualScale > 0 then
       Device.Projection.VirtualScale := aIL.BackVirtualScale;
    InterpretByLayer:= False;
    LayerClass:= nil;
    TransparencyEnd;
    Result:= False;
  end
  else
    Result:= inherited QProcessAfter(anElement)
end;


procedure TUniversalInterpret.Process(anElement: TElement);

begin
   if Printing then
   begin
{
    if Element is TTopolRectEntity then
    begin
      TRE:= TTopolRectEntity(Element);
      ShowMessage('Interpretace vektoru pro tisk ' + #13 + #13 +
                  TRE.ClassName + ' / ' + TRE.Name + #13 +
                  '(' + TRE.BlockDIR + ')')
    end
    else
    if Element is TTopRas then
       ShowMessage('Interpretace rastru pro tisk' + #13 + #13 +
                  Element.ClassName + ' / ' + Element.Name)
}
   end;

   CanGoInside := true;

   if InterpretByLayer then
   begin
     if anElement is LayerClass then
     begin
        Interpret.Input := anElement;
        Interpret.Printing:= Printing;
        Interpret.DoIt;
        CanGoInside := Interpret.CanUniGoInside(anElement);
     end;
   end
   else
   if FScript <> nil then
   {
   try
   }
   if FScript.ItsMyElement(anElement)then
   begin
       Interpret := FScript.InterpretForElement(anElement);
       if Interpret <> nil then
       begin
          Interpret.Input := anElement;
          Interpret.Printing:= Printing;
          Interpret.DoIt;
          CanGoInside := Interpret.CanUniGoInside(anElement);
       end;
       Interpret:= nil
   end;
   {
   except
      CanGoInside := true;
   end;
   }
   {
   MessageDlg('interp: '+ Element.ClassName + '  '+ Element.Name, mtInformation,[mbOK],0);
   }

   if Timer.Alarm then
   begin
     Timer.Pause:= true;
     if (Tile and TilePart) then
        TileDevice.RefreshDevice;
     //PostTextMsg(tm_AddToProtocol,'Ted'+IntToStr(FCounter),nil);
     PostMsgToOwners(tm_Repaint,nil,DontKill);
     Application.ProcessMessages;
     //if BreakWork then raise EBreakInterpret.Create('Konec intepretace');
     //Inc(FCounter);
     Timer.Reset;
   end;
   if BreakWork then raise EBreakInterpret.Create('Konec intepretace');

   {
   inc(FCounter);
   if FCounter > MaxElementCount then
   begin
      FCounter := 0;
      Application.ProcessMessages;
      if BreakWork then raise EBreakInterpret.Create('Konec intepretace');
   end;
   }
end;

function  TUniversalInterpret.GetScript: TInterpretScript;
begin
   result := FScript;
end;

procedure TUniversalInterpret.SetScript(aScript: TInterpretScript);
begin
   if assigned(FScript) then
   begin
      FreeElement(FScript);
      FScript := nil;
   end;
   FScript := aScript;
   AddElement(FScript);
end;


procedure TUniversalInterpret.SetBreak(aBreak: boolean);
begin
   inherited SetBreak(aBreak);
   try
      if Interpret <> nil then
         Interpret.BreakWork := true;
   except
   end;
end;





procedure TUniversalInterpret.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Application.ProcessMessages;
   if aMessage.Data = nil then Device.Reset;
   inherited On_tm_ReView(aMessage, Handled);
   Device.Close;
end;

procedure TUniversalInterpret.On_tm_ReViewByElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   R: TRectEntity;
   D,MW: TDoubleRect;
begin
   Application.ProcessMessages;
   if not (aMessage.Data is TRectEntity) then exit;
   R := TRectEntity(aMessage.Data);
   D := R.Rect.AsDoubleRect;
   MW := Device.Projection.ClipModelView;
   //Oez
   if MW.MinX > D.MinX then
      D.MinX := MW.MinX;
   if MW.MinY > D.MinY then
      D.MinY := MW.MinY;
   if MW.MaxX < D.MaxX then
      D.MaxX := MW.MaxX;
   if MW.MaxY < D.MaxY then
      D.MaxY := MW.MaxY;
   Device.Projection.ClipModelView := D;//R.Rect.AsDoubleRect;
   Device.Page.Clipping := true;
   if not NoResetReviewByELement then
      Device.Reset;
   aMessage.Data := nil;
   inherited On_tm_ReView(aMessage, Handled);
   Device.Page.Clipping := false;
   Device.Page.ClipRegion := Device.Page.Rect;
   Device.Close;
end;



procedure   TUniversalInterpret.BeforeDoIt;
begin
   if FScript <> nil then
      FScript.Reset(Device);
   Timer.Reset;
   Counter := 0;
end;

procedure   TUniversalInterpret.AfterDoIt;
begin
   FScript.Close;
   PostMsgToOwners(tm_Done, nil, DontKill);
end;


procedure TUniversalInterpret.DoIt;
var
   T: integer;
   procedure DoByScript;
   var
      i: integer;
      Pass: integer;
   begin
      if Script = nil then exit;
      i := Script.PassesCount;
      if i = 0 then exit;
      for Pass := 0 to i-1 do
      begin
         Script.Pass := Pass;
         if Script.Error > 0 then exit;
         inherited DoIt;
      end;
end;
begin
   if Tile then
   begin
      T := 1;
      TileDevice.Device := Device;
      Device := TileDevice;
      if TileDevice.TilesCount > 1 then
      begin
         StartProgress('Interpretace Bitmapovch Dladic',0,0);
         ProgressText := 'Inicializace....';
      end;
      repeat
         if TileDevice.TilesCount > 1 then
            ProgressText := 'Interpretace '+IntToStr(T)+'. dladice z '+IntToStr(TileDevice.TilesCount);
         TileDevice.Reset;
         DoByScript;
         TileDevice.Close;
         TileDevice.NextTile;
         inc(T);
      until TileDevice.LastTile;
      Device := TileDevice.Device;
      EndProgress;
   end
   else
   begin
      DoByScript;
   end;
end;

procedure TUniversalInterpret.SetTile(const Value: boolean);
begin
  FTile := Value;
end;

procedure TUniversalInterpret.SetTileDevice(const Value: TTileDevice);
begin
   if not (TElement(Value) is TTileDevice) then exit;
   ExchangeFieldElement(TElement(FTileDevice), Value);
end;

function TUniversalInterpret.GetTileDevice: TTileDevice;
begin
   if FTileDevice = nil then
   begin
      //ExchangeFieldElement(TElement(FTileDevice),TTileDevice.Create);
      ExchangeFieldElement(TElement(FTileDevice),TTransparentTileDevice.Create);
   end;
   result := FTileDevice;
end;

function TUniversalInterpret.ShowLayer(aIL: TInterpretLayer): boolean;
begin
  Result:= not aIL.SwitchedOff;
  if not result then
     exit;
  if aIL.Transparency = 100 then
  begin
     result := false;
     exit;
  end;
  if aIL.MinScaleNumber <> 0 then
  begin
    Result:= aIL.MinScaleNumber < Device.Projection.Scale;
    if not Result then
       Exit;
  end;

  if aIL.MaxScaleNumber <> 0 then
  begin
    Result:= aIL.MaxScaleNumber > Device.Projection.Scale;
    if not Result then
       Exit;
  end;
end;


procedure TUniversalInterpret.SetTilePart(const Value: boolean);
begin
  FTilePart := Value;
end;

procedure TUniversalInterpret.TransparencyBegin(Value: integer);
begin
   if Device <> nil then
      Device.TransparencyBegin(Value);
end;

procedure TUniversalInterpret.TransparencyEnd;
begin
   if Device <> nil then
      Device.TransparencyEnd;
end;

procedure TUniversalInterpret.SetFrameElement(const Value: TElement);
begin
   TTransparentTileDevice(TileDevice).FrameElement := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TUniversalInterpret);
END.
