unit Worlds;
{
[Unit_Description]
Description=Tda svt
Admin=Petr
TechTopic=Elements
Topic=System
Version=1.0
}
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy svt                                            *
*                                                                   *
*********************************************************************
}

interface
uses
   SysUtils, Forms, Graphics,
   WinTypes,
   e_SysReg,
   Elements,
   Tools;

type


TObjectModel = class(TOwnerEntity);

TWorld = class(TEntity)
private
   FMainTool: TTechnology;
   FSystemRegister: TSystemRegister;
   FObjectClasses: TOwnerEntity;
   FObjectModel: TObjectModel;
   //FDevices: TEntity;
   function  GetMainTool: TTechnology;
   function  GetSysReg: TSystemRegister;
   function  GetObjectClasses: TOwnerEntity;
   function  GetObjectModel: TObjectModel;

   procedure SetMainTool(aTool: TTechnology);
   procedure SetSysReg(aValue: TSystemRegister);
   procedure SetObjectClasses(aClasses: TOwnerEntity);
   procedure SetObjectModel(aModel: TObjectModel);

   function  GetApplication: TApplication;
   function  GetExeName: string;
   function  GetHelpFile: string;
   procedure  SetHelpFile(aVal: string);
   function  GetHint: string;
   procedure  SetHint(aVal: string);
   function   GetShowHint: boolean;
   procedure  SetShowHint(aVal: boolean);
   function   GetHintPause: integer;
   procedure  SetHintPause(aVal: integer);
   function   GetHintColor: TColor;
   procedure  SetHintColor(aVal: TColor);
   function   GetMainForm: TForm;
   function   GetTitle: string;
   procedure  SetTitle(aVal: string);
{!!!}procedure  SetTestElement(E: TOwnerElement);
    function GetApplicDir: string;
public
   constructor Create; override;
   procedure   Error; virtual;
   procedure   HandleWinMessage(var aMessage: TMsg; var Handled: boolean); virtual;
   procedure   HandleException(Sender: TObject; E: Exception); virtual;
published
   property Application: TApplication read GetApplication;
{   property ApplicActive: Boolean read FActive;}
{   property DialogHandle: HWnd read FDialogHandle write FDialogHandle; }
   property ApplicExeName: string read GetExeName;
   property ApplicDir: string read GetApplicDir;
{   property Handle: HWnd read FHandle write SetHandle; }
   property ApplicHelpFile: string read GetHelpFile write SetHelpFile;
   property ApplicHint: string read GetHint write SetHint;
   property ApplicShowHint: Boolean read GetShowHint write SetShowHint;
   property ApplicHintColor: TColor read GetHintColor write SetHintColor;
   property ApplicHintPause: Integer read GetHintPause write SetHintPause;
{   property ApplicIcon: TIcon read FIcon write SetIcon; }
   property ApplicMainForm: TForm read GetMainForm;
{   property ApplicTerminated: Boolean read FTerminate; }
   property ApplicTitle: string read GetTitle write SetTitle;
{!!!}  property    TestElement: TOwnerElement write SetTestElement;
   property    MainTool:  TTechnology  read GetMainTool      write SetMainTool;
   property    SystemRegister: TSystemRegister read GetSysReg write SetSysReg;
   property    ObjectClasses: TOwnerEntity  read GetObjectClasses write SetObjectClasses;
   property    ObjectModel: TObjectModel read GetObjectModel   write SetObjectModel;
end;

var
   World: TWorld;

function MainToolPropString(aPropName: string): string;

implementation


uses
   Dialogs,
   e_Class, U_Props,
   {!T_Main,}
   M_Orbis;

{ TWorld }

{!!!}
procedure  TWorld.SetTestElement(E: TOwnerElement);
begin
   TestedElement := E;
end;


constructor TWorld.Create;
begin
   inherited Create;
   if ObjectClasses <> nil then;
{$IFDEF OrbisRegister}
   OrbisRegister:= TQuickEntity.Create;
   AddElement(OrbisRegister)
{$ENDIF}
end;



procedure   TWorld.Error;
begin
   { !!!!!!!!!!!!!!!!!!!!!!!!! }
end;





procedure   TWorld.HandleWinMessage(var aMessage: TMsg; var Handled: boolean);
var
   OM: TOrbisMessage;
   R: TElement;
begin
   if aMessage.Message = 0 then exit;
   if aMessage.Message <> WM_ORBISMESSAGE then
      exit;
   if aMessage.wParam <> TM_ORBISMESSAGE then
      exit;
try
   OM := TOrbisMessage(aMessage.LParam);
   R  := OM.Receiver;

   if assigned(R) then
      R.HandleMessage(OM, Handled)
   //               else inherited HandleMessage(OM, Handled);
   else
   begin
      if MainTool <> nil then
      begin
         OM.Receiver := MainTool;
         MainTool.HandleMessage(OM, Handled);
      end;
   end;
   OM.Free;
except
end;
end;


procedure   TWorld.HandleException(Sender: TObject; E: Exception);
begin
   ShowMessage('World Level Error :' + E.Message);
end;



function  TWorld.GetApplication: TApplication;
begin
  result:= Forms.Application
end;


function TWorld.GetMainTool:  TTechnology;
begin
   if not Assigned(FMainTool) then Error;
   result := FMainTool;
end;

function TWorld.GetSysReg: TSystemRegister;
begin
   if not Assigned(FSystemRegister) then
   begin
      FSystemRegister := TSystemRegister.Create;
      FSystemRegister.Name := 'System register';
      AddElement(FSystemRegister);
   end;
   result := FSystemRegister;
end;


function TWorld.GetObjectClasses: TOwnerEntity;
begin
   if not Assigned(FObjectClasses) then
   begin
      FObjectClasses := OrbisClasses;
      FObjectClasses.Name := 'ObjectClasses';
      AddElement(FObjectClasses);
   end;
   result := FObjectClasses;
end;



function TWorld.GetObjectModel: TObjectModel;
begin
   if not Assigned(FObjectModel) then
   begin
      FObjectModel := TObjectModel.Create;
      FObjectModel.Name := 'Object model';
      AddElement(FObjectModel);
   end;
   result := FObjectModel;
end;



procedure TWorld.SetMainTool(aTool: TTechnology);
begin
   if Assigned(FMainTool) then
   begin
      FreeElement(FMainTool);
      FMainTool := nil;
   end;
   AddElement(aTool);
   FMainTool := aTool;
end;

procedure TWorld.SetSysReg(aValue: TSystemRegister);
begin
   if Assigned(FSystemRegister) then
   begin
      FreeElement(FSystemRegister);
      FSystemRegister := nil;
   end;
   AddElement(aValue);
   FSystemRegister := aValue;
end;



procedure TWorld.SetObjectClasses(aClasses: TOwnerEntity);
begin
   {
   if Assigned(FObjectClasses) then
   begin
      FreeElement(ObjectClasses);
      FObjectClasses := nil;
   end;
   AddElement(aClasses);
   FObjectClasses := aClasses;
   }
end;



procedure TWorld.SetObjectModel(aModel: TObjectModel);
begin
   if Assigned(FObjectModel) then
   begin
      FreeElement(FObjectModel);
      FObjectModel := nil;
   end;
   AddElement(aModel);
   FObjectModel := aModel;
end;



function  TWorld.GetExeName: string;
begin
  result:= Application.ExeName;
end;


function TWorld.GetApplicDir: string;
begin
  result:= extractFilePath(ApplicExeName);
end;


function  TWorld.GetHelpFile: string;
begin
  result:= Application.HelpFile;
end;

procedure  TWorld.SetHelpFile(aVal: string);
begin
  Application.HelpFile:= aVal
end;

function  TWorld.GetHint: string;
begin
  result:= Application.Hint;
end;

procedure  TWorld.SetHint(aVal: string);
begin
  Application.Hint:= aVal
end;

function   TWorld.GetShowHint: boolean;
begin
  result:= Application.ShowHint;
end;

procedure  TWorld.SetShowHint(aVal: boolean);
begin
  Application.ShowHint:= aVal
end;

function   TWorld.GetHintPause: integer;
begin
  result:= Application.HintPause;
end;

procedure  TWorld.SetHintPause(aVal: integer);
begin
  Application.HintPause:= aVal
end;

function   TWorld.GetHintColor: TColor;
begin
  result:= Application.HintColor;
end;

procedure  TWorld.SetHintColor(aVal: TColor);
begin
  Application.HintColor:= aVal
end;

function   TWorld.GetMainForm: TForm;
begin
  result:= Application.MainForm;
end;

function   TWorld.GetTitle: string;
begin
  result:= Application.Title;
end;

procedure  TWorld.SetTitle(aVal: string);
begin
  Application.Title:= aVal
end;


function MainToolPropString(aPropName: string): string;
begin
  result:= '';
  if World = nil then exit;
  if World.MainTool = nil then exit;
  result:= GetPropStringByName(World.MainTool, aPropName)
end;



BEGIN
   RegisterOrbisClass(TObjectModel);
   RegisterOrbisClass(TWorld);
END.
