unit U_props;
{
[Unit_Description]
Description=funkce pro prci s propertami
Admin=Olda
TechTopic=Utilities
Topic=System
Version=1.0
}
interface
uses
  Classes,
  TypInfo;

function  GetPropCount       (Instance: TPersistent): integer;
function  GetPropName        (Instance: TPersistent; Index: integer): string;
function  GetPropType        (Instance: TPersistent; Index: integer): TTypeKind;
function  GetPropIndex       (Instance: TPersistent; aName: string): integer;
function  GetPropString      (Instance: TPersistent; Index: integer): string;
procedure SetPropByString    (Instance: TPersistent; PropInfo: PPropInfo; NewVal: string);
procedure SetPropString      (Instance: TPersistent; Index: integer; NewVal: string);
function  SetPropStringByName(Instance: TPersistent; aName, NewVal: string): boolean;
function  SetObjectPropByName(Instance: TPersistent; aName: string; NewVal: TObject): boolean;
function  GetPropStringByName(Instance: TPersistent; aName: string): string;

function  GetObjectPropByName(Instance: TPersistent; aName: string): TObject;

procedure FillWithData(Instance: TPersistent; PropInfo: PPropInfo; var Vystup: string);


implementation

uses
  SysUtils, Dialogs,
 {!t_Main,}
  U_String;



function MethodToString(aMethod: TMethod): string;
begin
  result:= intToStr(integer(aMethod.Code)) + ';' + intToStr(integer(aMethod.Data))
end;


procedure StringToMethod(aString: string; var aMethod: TMethod);
var
  aPos, aRes: integer;
  aCode, aData: string;

begin
  aPos:= pos(';', aString);
  aCode:= copy(aString, 1, aPos-1);
  aData:= copy(aString, aPos+1, 255);
  Val(aCode, integer(aMethod.Code), aRes);
  Val(aData, integer(aMethod.Data), aRes);
end;


procedure FillWithData(Instance: TPersistent; PropInfo: PPropInfo; var Vystup: string);
var
  PropType: PTypeInfo;

  procedure WritePropPath;
  begin
{    WritePropName(PPropInfo(PropInfo)^.Name); }
  end;

  procedure WriteSet(Value: Cardinal);
  type
    TCardinalSet = set of 0..SizeOf(Cardinal) * 8 - 1;
  //var
    //I: Integer;
    //BaseType: PTypeInfo;
  begin
  { takto hezky vypisuje nzvy prvk mnoiny
    BaseType := GetTypeData(PropType)^.CompType;
    for I := 0 to 15 do
      if I in TCardinalSet(Value) then
         Vystup:= Vystup + ',' + GetEnumName(BaseType, I)^;
  }
    Vystup:= IntToStr(Value); { takto slo }
  end;

  procedure WriteIntProp(IntType: PTypeInfo; Value: Longint);
//  var
    //I: Integer;
    //Ident: string[64];
  begin
    Vystup:= IntToStr(Value);
  end;


  procedure WriteOrdProp;
  var
    Value: Longint;
  begin
    try
      Value := GetOrdProp(Instance, PropInfo);
  {    if Value <> PPropInfo(PropInfo)^.Default then }
      begin
        WritePropPath;
        case PropType^.Kind of
          tkInteger:
            WriteIntProp(PPropInfo(PropInfo)^.PropType^, Value);
          tkChar:
            Vystup:= Chr(Value);
          tkSet:
            WriteSet(Value);
          tkEnumeration:
            {$IFDEF WIN32}
               Vystup:= GetEnumName(PropType, Value);
            {$ELSE}
               Vystup:= GetEnumName(PropType, Value)^;
            {$ENDIF}
        end; { case }
      end;
    except
      Vystup:= 'Err Ord Value'
    end;
  end;




  procedure WriteFloatProp;
  var
    Value: Extended;
  begin
    Value := GetFloatProp(Instance, PropInfo);
    Vystup:= FloatToStr(Value);
  end;


  procedure WriteStrProp;
  var
    Value: string;
  begin
    Value := GetStrProp(Instance, PropInfo);
    Vystup:= Value;
  end;

  procedure WriteObjectProp;
//  var
//    Len: Integer;
//    Value: TObject;
  begin
    try
       Vystup := IntToStr(longInt(GetOrdProp(Instance, PropInfo)));
    except
       Vystup:= '';
    end;
    {
    Value := TObject(GetOrdProp(Instance, PropInfo));
    if Value is TElement then
       Vystup:= TElement(Value).Name
    else
    if Value is TFont then
       Vystup:= TFont(Value).Name
    }
  end;


  procedure WriteMethodProp;
  var
    Value: TMethod;
  begin
    Vystup:= '';
    try
      Value := GetMethodProp(Instance, PropInfo);
      Vystup:= MethodToString(Value)
    except
    end;
{
    Value := GetMethodProp(Instance, PropInfo);
    if (Value.Code <> nil) and (Value.Data = Root) then
    begin
      WritePropPath;
      WriteIdent(Root.MethodName(Value.Code));
    end;
 }
  end;



begin
  Vystup:= '';
  try
    if PropInfo^.GetProc = nil then exit;

    PropType := PropInfo^.PropType^;
    case PropType^.Kind of
      tkInteger, tkChar, tkEnumeration, tkSet: WriteOrdProp;
      tkFloat: WriteFloatProp;
      tkString
      {$IFDEF Win32}
      ,tkLString
      {$ENDIF}
                : WriteStrProp;
      tkClass: WriteObjectProp;
      tkMethod: WriteMethodProp;
    end;
  except
    Vystup:= 'Err Value'
  end;
end;





procedure FillObject(Instance: TPersistent; PropInfo: PPropInfo; var aObject: TObject);
var
  PropType: PTypeInfo;
begin
  if PropInfo^.GetProc <> nil then
  begin
    PropType := PropInfo^.PropType^;
    if PropType^.Kind = tkClass then aObject := TObject(GetOrdProp(Instance, PropInfo))
                                else aObject := nil;
  end;
end;


function GetObjectPropByName(Instance: TPersistent; aName: string): TObject;
var
  I, Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
//  Vystup: string;
  Nasel: boolean;

begin
  PropInfo := nil;
  aName:= UpperCase(aName);
  result:= nil;
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);
      I:= 0;
      Nasel:= false;

      while (I < Count) and not Nasel do
      begin
        PropInfo := PropList^[I];
        if aName = UpperCase(PropInfo^.Name) then Nasel:= true;
        if not Nasel then inc(I)
      end;
      if Nasel then FillObject(Instance, PropInfo, result);

    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;



function GetPropString(Instance: TPersistent; Index: integer): string;
var
  Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;

begin
  result:= '';
  if instance = nil then exit;
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);

      PropInfo := PropList^[Index];
      FillWithData(Instance, PropInfo, result);
    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;


function GetPropType(Instance: TPersistent; Index: integer): TTypeKind;
{TTypeKind = (tkUnknown, tkInteger, tkChar, tkEnumeration, tkFloat, tkString, tkSet,
             tkClass, tkMethod);
}
var
  Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
  PropType: PTypeInfo;

begin
  result:= tkUnknown;
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);
      PropInfo := PropList^[Index];

      PropType := PropInfo^.PropType^;

      result:= PropType^.Kind;
    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;



procedure SetPropByString(Instance: TPersistent; PropInfo: PPropInfo; NewVal: string);
var
  PomINt: longInt;
  PomDouble: double;
  Code: integer;
  aMethod: TMethod;
begin
  if Instance = nil then exit;
  if PropInfo = nil then exit;
  if PropInfo^.SetProc = nil then exit;

  try
  case PropInfo^.PropType^.Kind of
     tkString
     {$IFDEF Win32}
     , tkLString
     {$ENDIF}
              : SetStrProp(Instance, PropInfo, NewVal);
     tkChar:
     begin
        if NewVal <> '' then
           PomInt:= Byte(NewVal[1])
        else
           PomInt := 0;
        SetOrdProp(Instance, PropInfo, PomInt);
     end;
     tkInteger:
     begin
        PomInt:= StrToIntDef(NewVal, 0);
        SetOrdProp(Instance, PropInfo, PomInt);
     end;
     tkFloat:
     begin
       PomDouble:= 0;
       if NewVal <> '' then
       begin
          PomDouble:= strToExtended(NewVal);
       end;
       SetFloatProp(Instance, PropInfo, PomDouble);
     end;
     tkEnumeration,tkSet:
     begin
        val(NewVal, PomInt, Code);
        if Code <> 0 then
        begin
           PomInt:= GetEnumValue(PropInfo^.PropType^, NewVal);
        end;
        SetOrdProp(Instance, PropInfo, PomInt);
{
        PomInt:= GetEnumValue(PropInfo^.PropType, NewVal);
        SetOrdProp(Instance, PropInfo, PomInt);
}
     end;
     tkClass:
     begin
         PomInt:= StrToIntDef(NewVal, 0);
         SetOrdProp(Instance, PropInfo, PomInt);
     end;
     tkMethod:
     begin
       StringToMethod(NewVal, aMethod);
       SetMethodProp(Instance, PropInfo, aMethod)
     end;
  end; { case }
  except
     ShowMessage('Error filling property ' + PropInfo^.Name + ' by string ' + NewVal)
  end;
end;




procedure SetPropString(Instance: TPersistent; Index: integer; NewVal: string);
var
  Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
begin
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);

      PropInfo := PropList^[Index];

      SetPropByString(Instance, PropInfo, NewVal);
    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;



function SetPropStringByName(Instance: TPersistent; aName, NewVal: string): boolean;
var
  Index: integer;
begin
  result:= false;
  Index:= GetPropIndex(Instance, aName);
  if Index < 0 then exit;
  SetPropString(Instance, Index, NewVal);
  result:= true
end;


function  SetObjectPropByName(Instance: TPersistent; aName: string; NewVal: TObject): boolean;
var
  Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
  Index: integer;
begin
  result:= false;
  Index:= GetPropIndex(Instance, aName);
  if Index < 0 then exit;

  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count = 0 then exit;
  GetMem(PropList, Count * SizeOf(Pointer));
  try
    GetPropInfos(Instance.ClassInfo, PropList);

    PropInfo := PropList^[Index];

    if PropInfo^.SetProc <> nil then
    case PropInfo^.PropType^.Kind of
       tkClass:
       begin
           SetOrdProp(Instance, PropInfo, longInt(NewVal));
           result := true;
       end;
    end;
  finally
    FreeMem(PropList, Count * SizeOf(Pointer));
  end;
end;



function GetPropStringByName(Instance: TPersistent; aName: string): string;
var
  I, Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
//  Vystup: string;
  Nasel: boolean;

begin
  PropInfo := nil;
  aName:= UpperCase(aName);
  result:= '';
  if aName = '' then exit;
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);
      I:= 0;
      Nasel:= false;

      while (I < Count) and not Nasel do
      begin
        PropInfo := PropList^[I];
        if aName = UpperCase(PropInfo^.Name) then Nasel:= true;
        if not Nasel then inc(I)
      end;
      if Nasel then FillWithData(Instance, PropInfo, result);

    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
{  Instance.DefineProperties(Self); }
end;



function GetPropIndex(Instance: TPersistent; aName: string): integer;
var
  I, Count: Integer;
  PropInfo: PPropInfo;
  PropList: PPropList;
  Nasel: boolean;

begin
  aName:= UpperCase(aName);
  result:= -1;

  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);
      I:= 0;
      Nasel:= false;

      while (I < Count) and not Nasel do
      begin
        PropInfo := PropList^[I];
        if aName = UpperCase(PropInfo^.Name) then Nasel:= true;
        if not Nasel then inc(I)
      end;
      if Nasel then
         result:= I

    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;





function GetPropCount(Instance: TPersistent): integer;
begin
  result:= GetTypeData(Instance.ClassInfo)^.PropCount;
end;



function GetPropName(Instance: TPersistent; Index: integer): string;
var
  Count: Integer;
  PropList: PPropList;
begin
  result:= '';
  Count := GetTypeData(Instance.ClassInfo)^.PropCount;
  if  Index < Count then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      GetPropInfos(Instance.ClassInfo, PropList);
      result:= PPropInfo(PropList^[Index])^.Name
    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;





end.
