unit T_CreateParcelModel;

interface
uses
   Elements,
   e_KatastrModel,
   e_Type,
   T_CreateModelFromLayer;

type

(*
  Input - Vrstva ploch nebo eho, asi topolsk plochy
  Output - Model Parcel nebo nic - pak ho vytvo
*)
TCreateParcelModel = class(TCreateModelFromLayer)
  private
    FSkupinaParcelGroup: integer;
    FParcelaGroup: integer;
    FParpodPropertyName: string;
    FSkupinaParcelPropertyName: string;
    FKatastrPropertyName: string;
    FParcisPropertyName: string;
    FParcisPodInOne: boolean;
    FStavebniParcelaValue: integer;
    FPARSKUKNPropertyName: string;
    FChangeLinesToTopol: boolean;
    FKatastrID: integer;
    FSKPByComment: boolean;
    FVlastnikPropertyName: string;
    FMajitele: Tgis_Majitele;
    FFindLinesInAreas: boolean;
    FLineSymbol: integer;
    FLineGroup: integer;
    FLineColor: integer;
    FKatastrPropertyName1: string;
    FKatastrNazevPropertyName: string;
    FKatastrGroup: integer;
    FPARSKUKNasText: boolean;
    FPKText: string;
    FGPText: string;
    FKATUZE_KOD_PUVPropertyName: string;
    FDontSumVym: boolean;
    procedure SetKatastrPropertyName(const Value: string);
    procedure SetParcelaGroup(const Value: integer);
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetParcisPropertyName(const Value: string);
    procedure SetParpodPropertyName(const Value: string);
    procedure SetSkupinaParcelGroup(const Value: integer);
    procedure SetSkupinaParcelPropertyName(const Value: string);
    function GetParcelModel: Tgis_ParcelModel;
    procedure SetParcisPodInOne(const Value: boolean);
    procedure SetStavebniParcelaValue(const Value: integer);
    procedure SetPARSKUKNPropertyName(const Value: string);
    procedure SetChangeLinesToTopol(const Value: boolean);
    procedure SetKatastrID(const Value: integer);
    procedure SetSKPByComment(const Value: boolean);
    procedure SetVlastnikPropertyName(const Value: string);
    procedure SetMajitele(const Value: Tgis_Majitele);
    procedure SetFindLinesInAreas(const Value: boolean);
    procedure SetLineColor(const Value: integer);
    procedure SetLineGroup(const Value: integer);
    procedure SetLineSymbol(const Value: integer);
    procedure SetKatastrPropertyName1(const Value: string);
    procedure SetKatastrNazevPropertyName(const Value: string);
    procedure SetKatastrGroup(const Value: integer);
    procedure SetGPText(const Value: string);
    procedure SetPARSKUKNasText(const Value: boolean);
    procedure SetPKText(const Value: string);
    procedure SetKATUZE_KOD_PUVPropertyName(const Value: string);
    procedure SetDontSumVym(const Value: boolean);
public
   procedure CreateModel; override;
published
   property ParcelModel: Tgis_ParcelModel read GetParcelModel write SetParcelModel;
   property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
   property KatastrGroup: integer read FKatastrGroup write SetKatastrGroup;
   property SkupinaParcelGroup: integer read FSkupinaParcelGroup write SetSkupinaParcelGroup;
   property ParcelaGroup: integer read FParcelaGroup write SetParcelaGroup;
   property KatastrPropertyName: string read FKatastrPropertyName write SetKatastrPropertyName;
   property KatastrPropertyName1: string read FKatastrPropertyName1 write SetKatastrPropertyName1;
   property KatastrNazevPropertyName: string read FKatastrNazevPropertyName write SetKatastrNazevPropertyName;
   property SkupinaParcelPropertyName: string read FSkupinaParcelPropertyName write SetSkupinaParcelPropertyName;
   property ParcisPropertyName: string read FParcisPropertyName write SetParcisPropertyName;
   property ParpodPropertyName: string read FParpodPropertyName write SetParpodPropertyName;
   property KATUZE_KOD_PUVPropertyName: string read FKATUZE_KOD_PUVPropertyName write SetKATUZE_KOD_PUVPropertyName;
   property PARSKUKNPropertyName: string read FPARSKUKNPropertyName write SetPARSKUKNPropertyName;
   property PARSKUKNasText: boolean read FPARSKUKNasText write SetPARSKUKNasText;
   property PKText: string read FPKText write SetPKText;
   property GPText: string read FGPText write SetGPText;
   property VlastnikPropertyName: string read FVlastnikPropertyName write SetVlastnikPropertyName;
   property ParcisPodInOne: boolean read FParcisPodInOne write SetParcisPodInOne;
   property StavebniParcelaValue: integer read FStavebniParcelaValue write SetStavebniParcelaValue;
   property ChangeLinesToTopol: boolean read FChangeLinesToTopol write SetChangeLinesToTopol;
   property KatastrID: integer read FKatastrID write SetKatastrID;
   property SKPByComment: boolean read FSKPByComment write SetSKPByComment;
   property FindLinesInAreas: boolean read FFindLinesInAreas write SetFindLinesInAreas;
   property LineGroup: integer read FLineGroup write SetLineGroup;
   property LineColor: integer read FLineColor write SetLineColor;
   property LineSymbol: integer read FLineSymbol write SetLineSymbol;
   property DontSumVym: boolean read FDontSumVym write SetDontSumVym;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Class,
   e_GeometryElement,
   e_TopolElements,
   e_Props,
   g_Elems,
   m_Orbis,
   t_LayScr,
   t_LineExtractor,
   t_LMCre,
   u_String;

{ TCreateParcelModel }

procedure TCreateParcelModel.CreateModel;
var
   AC: TAreaCollection;
   PC: TPolyLineCollection;
   G: TGeometryElement;
   FinalG: TGeometryElement;
   PGE: TPropertyGeometryElement;
   E,NE: TElement;
   i,ii,j: integer;
   IsKatastr, IsParcela: boolean;
   Ku_kod: integer;
   Ku_Nazev: string;
   Skupar_cis: integer;
   Skupar_Comment: string;
   Parcis: integer;
   Parpod: integer;
   aKATUZE_KOD_PUV: integer;
   Vlastnik: string;
   ParSkuKn: integer;
   ParSkuKnText: string;
   S: TStringElement;
   S1,S2,SS,SP: string;
   PA: Tgis_Parcela;
   PAC: Tgis_ParcelaCast;
   TL: TTopolLineElement;
   aPK: boolean;
   aGP: boolean;
   M: Tgis_Majitel;
   LEX: TLineExtractor;
   Setting: boolean;
   aN: string;
begin
   Error := 1;
   Setting := true;
   if StavebniParcelaValue = 0 then
      StavebniParcelaValue := 1;
   if not (TElement(Majitele)is Tgis_Majitele) then
      Majitele := nil;
   // Linie
   if not FindLinesInAreas then
   begin
      E := Data.FindElementName('LIN');
      if not (E is TEntity) then exit; // dn linie
      if TEntity(E).NoElements  then exit;
      E := TEntity(E).Elements[0];
      if not (E is TPolyLineCollection) then exit;
      PC := TPolyLineCollection(E);
      if LinesLayer <> nil then
      begin
         if not ChangeLinesToTopol and NoLineTransferModel then
         begin
            LinesLayer.AddAllFrom := E;
            if LinesLayer is TRectEntity then
               TRectEntity(LinesLayer).ResetAndUpdate;
         end
         else
         begin
            if PC.Count > 50 then
            begin
               MaxProgress := PC.LastIndex;
               Application.ProcessMessages;
            end;
            for i := 0 to PC.LastIndex do
            begin
               if i mod 50 = 0 then
               begin
                  Progress := i;
                  Application.ProcessMessages;
               end;
               E := PC.Elements[i];
               NE := E;
               if CHangeLinesToTopol then
               begin
                  TL := TTopolLineElement.Create;
                  TL.Geometry := TGeometryElement(E).Geometry;
                  NE := TL;
               end;
               for j := 0 to LineTransferModel.LastIndex do
               begin
                  S := LineTransferModel.StringElements[j];

                  if (S.Name='DYNAMIC') or (S.Name[1]='@') then
                  begin
                     if S.Name[1]='@' then
                        aN := copy(S.Name,2,Length(S.Name))
                     else
                        aN := S.Value;
                     if NE is TPropertyGeometryElement then
                     begin
                        PGE := TPropertyGeometryElement(NE);
                        if PGE.NoProperties then
                           PGE.Properties := TDynamicProperties.Create;
                        PGE.Properties.SetPropertyStringByName(S.Value,E.GetPropertyStringByName(aN));
                     end;
                  end
                  else
                     NE.SetPropertyStringByName(S.Value,E.GetPropertyStringByName(S.Name));
                  Application.ProcessMessages;
                  if LinesLayer is TRectEntity then
                     TRectEntity(LinesLayer).AddAndUpdateRect(NE)
                  else
                     LinesLayer.AddElement(NE);



               end;
            end;
         end;
      end;
   end; // if FindLinesInAreas
   Progress := 0;
   Application.ProcessMessages;
   // Plochy
   if Data.NoElements then exit;
   E := Data.FindElementName('ARE');
   if not (E is TEntity) then exit;
   if TEntity(E).NoElements  then exit;
   E := TEntity(E).Elements[0];
   if not (E is TAreaCollection) then exit;
   AC := TAreaCollection(E);
   if AC.Count > 50 then
   begin
      MaxProgress := AC.LastIndex;
      Application.ProcessMessages;
   end;
   for i := 0 to AC.LastIndex do
   begin
      PA := nil;
      PAC := nil;
      E := AC.Elements[i];
      if not (E is TGeometryElement) then continue;
      G := TGeometryElement(E);
      if i mod 50 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      IsKatastr := G.Group = KatastrGroup;
      if not IsKatastr then
      begin
         IsParcela := G.Group = ParcelaGroup;
         // jet kontrola, jestli je to skupina parcel ... na neplochy kalu
         if not IsParcela and (G.Group <> SkupinaParcelGroup) then continue;
      end;
      if KatastrID > 0 then
         ku_kod := KatastrID
      else
      begin
         Ku_kod := G.GetPropertyLongIntByName(KatastrPropertyName);
         if Setting then
         begin
            Setting := false;
            if Ku_Kod <= 0 then
            begin
               SP := KatastrPropertyName;
               KatastrPropertyName := KatastrPropertyName1;
               KatastrPropertyName1 := SP;
               Ku_kod := G.GetPropertyLongIntByName(KatastrPropertyName);
            end;
         end;
      end;
      if Ku_kod < 0 then ku_kod := 0;
      if IsKatastr then
      begin
         ParcelModel.CreateKatastrCislo(Ku_Kod);
         FinalG := ParcelModel.ActualKatastr;
      end
      else
      begin
         if SKPByComment then
            Skupar_Comment := G.GetPropertyStringByName(SkupinaParcelPropertyName)
         else
            Skupar_cis := G.GetPropertyLongIntByName(SkupinaParcelPropertyName);
         ParcelModel.CreateKatastrCislo(Ku_Kod);
         if SKPByComment then
            ParcelModel.CreateSkupinaParcelComment(Skupar_Comment)
         else
            ParcelModel.CreateSkupinaParcelCislo(Skupar_cis);
         FinalG := ParcelModel.ActualSkupinaParcel;
         //Parcis := 0;
         //Parpod := 0;
         if IsParcela then
         begin
            if ParCisPodInOne then
            begin
               SS := G.GetPropertyStringByName(ParcisPropertyName);
               if StringAsTwoParams(SS,'/',S1,S2) then
               begin
                  SS := '';
                  ii := 1;
                  while not (ii > Length(S2)) and (S2[ii] in ['0'..'9']) do
                  begin
                     SS := SS + S2[ii];
                     Inc(ii);
                  end;
                  PARPOD := StrToIntDef(SS,0);
               end
               else
                  PARPOD := 0;
               S1 := BezVnejsichMezer(S1);
               if S1 > '' then    // prvni znak parcis jinej nez cislo ... asi stavebni
                  if not (S1[1] in ['0'..'9']) then
                     S1[1] := '-';
               PARCIS := StrToIntDef(S1,0);
            end
            else
            begin
               Parcis := G.GetPropertyLongIntByName(ParcisPropertyName);
               Parpod := G.GetPropertyLongIntByName(ParpodPropertyName);
            end;
            aPK := false;
            aGP := false;
            aKATUZE_KOD_PUV := -1;
            if KATUZE_KOD_PUVPropertyName <> '' then
               aKATUZE_KOD_PUV := G.GetPropertyLongIntByName(KATUZE_KOD_PUVPropertyName);
            if PARSKUKNPropertyName <> '' then
            begin
               if PARSKUKNasText then
               begin
                  ParSkuKnText := G.GetPropertyStringByName(PARSKUKNPropertyName);
                  ParSkuKnText := UpperCase(ParSkuKnText);
                  aPK := ParSkuKNText = PKText;
                  aGP := ParSkuKNText = GPText;
                  if aGP then
                     aPK := true;
               end
               else
               begin
                  ParSkuKn := G.GetPropertyLongIntByName(PARSKUKNPropertyName);
                  if (ParSkuKn = 1) or (ParSkuKN = 4) or (ParSkuKN = 6) then
                     Parcis := -Abs(Parcis);
                  aPK :=  ParSkuKN > 2;
                  aGP := ParSkuKN > 5;
               end;
            end;
            ParcelModel.CreateParcelaCislo(Parcis,Parpod,aKATUZE_KOD_PUV);
            ParcelModel.ActualParcela.PK := aPK;
            FinalG := ParcelModel.CreateParCast;
            ParcelModel.ActualParCast.SkupinaParcel := ParcelModel.ActualSkupinaParcel;
            PA := ParcelModel.ActualParcela;
            PAC := ParcelModel.ActualParCast;
            if aPK then
            begin
               PAC.PKCIS := Parcis;
               PAC.PKPOD := Parpod;
            end;
            PAC.GP := aGP;
            PAC.ParZar := true;
            if VlastnikPropertyName <> '' then
            begin
               Vlastnik := G.GetPropertyStringByName(VlastnikPropertyName);
               if (Vlastnik <> '') and (Vlastnik <> '0') then
               if Majitele <> nil then
               begin
                  M := Majitele.CreateMajitelCislo(Vlastnik);
                  PAC.Majitel := M;
               end;
            end;
         end;
      end; // if IsKatastr
      FinalG.AddGeometry(G.Geometry);
      (*
      if FinalG.Geometry <> nil then
      begin
         //!!!!!!!!!!!!!
         PostTextMsg (tm_AddToProtocol,'Multi plocha parcel '+IntToStr(Ku_Kod)+'*'+
                     IntToStr(Skupar_cis)+'*'+IntToStr(Parcis)+'/'+IntToStr(ParPod),nil);
         Application.ProcessMessages;
      end;
      FinalG.Geometry := G.Geometry;
      *)
      if NoTransferModel then continue;
      for j := 0 to TransferModel.LastIndex do
      begin
         S := TransferModel.StringElements[j];
         if S.Name='DYNAMIC' then
         begin
            if FinalG is TPropertyGeometryElement then
            begin
               PGE := TPropertyGeometryElement(FinalG);
               if PGE.NoProperties then
                  PGE.Properties := TDynamicProperties.Create;
               PGE.SetPropertyStringByName(S.Value,G.GetPropertyStringByName(S.Value));
            end;
         end
         else
            FinalG.SetPropertyStringByName(S.Value,G.GetPropertyStringByName(S.Name));
      end;
      // prenos vymer
      if not DontSumVym and (PA <> nil) and (PAC <> nil) then
      begin
         // predpoklad, ze dve stejne hodnoty vymer jsou nepravdepodobne
 { TODO 3 -oPPK -cOpravit :
Vmry st se do par setou (pokud nemaj stejnou hodnotu jako par)
to by mlo pedejt problmm s stmi s vym parcely }
         if PAC.Vymera <> PA.Vymera then
            PA.Vymera := PA.Vymera + PAC.Vymera;
      end;
      if (AreasLayer <> nil) and not FinalG.IsMyOwner(AreasLayer) then
      begin
         if (AreasLayer is TRectEntity) then
            TRectEntity(AreasLayer).AddAndUpdateRect(FinalG)
         else
            AreasLayer.AddElement(FinalG);
      end;
   end;
   ParcelModel.UpdateAll := true;
   if FindLinesInAreas then
   begin
      {
      PC := TPolyLineCollection.Create;
      AddElement(PC);
      LEX := TLineExtractor.Create;
      //LEX.CopyLines := DoCopy;
      LEX.NoDuplicates := true;
      LEX.Input := AreasLayer;
      LEX.Output := Lines;
      LEX.DoIt;
      LEX.Free;
      PC.Free;
      }
   end;
   Error := 0;
end;

function TCreateParcelModel.GetParcelModel: Tgis_ParcelModel;
begin
   result := Tgis_ParcelModel(Output);
end;


procedure TCreateParcelModel.SetChangeLinesToTopol(const Value: boolean);
begin
  FChangeLinesToTopol := Value;
end;

procedure TCreateParcelModel.SetDontSumVym(const Value: boolean);
begin
  FDontSumVym := Value;
end;

procedure TCreateParcelModel.SetFindLinesInAreas(const Value: boolean);
begin
  FFindLinesInAreas := Value;
end;

procedure TCreateParcelModel.SetGPText(const Value: string);
begin
  FGPText := Value;
end;

procedure TCreateParcelModel.SetKatastrGroup(const Value: integer);
begin
  FKatastrGroup := Value;
end;

procedure TCreateParcelModel.SetKatastrID(const Value: integer);
begin
  FKatastrID := Value;
end;

procedure TCreateParcelModel.SetKatastrNazevPropertyName(const Value: string);
begin
  FKatastrNazevPropertyName := Value;
end;

procedure TCreateParcelModel.SetKatastrPropertyName(const Value: string);
begin
  FKatastrPropertyName := Value;
end;

procedure TCreateParcelModel.SetKatastrPropertyName1(const Value: string);
begin
  FKatastrPropertyName1 := Value;
end;

procedure TCreateParcelModel.SetKATUZE_KOD_PUVPropertyName(
  const Value: string);
begin
  FKATUZE_KOD_PUVPropertyName := Value;
end;

procedure TCreateParcelModel.SetLineColor(const Value: integer);
begin
  FLineColor := Value;
end;

procedure TCreateParcelModel.SetLineGroup(const Value: integer);
begin
  FLineGroup := Value;
end;

procedure TCreateParcelModel.SetLineSymbol(const Value: integer);
begin
  FLineSymbol := Value;
end;

procedure TCreateParcelModel.SetMajitele(const Value: Tgis_Majitele);
begin
  FMajitele := Value;
end;

procedure TCreateParcelModel.SetParcelaGroup(const Value: integer);
begin
   FParcelaGroup := Value;
end;

procedure TCreateParcelModel.SetParcelModel(const Value: Tgis_ParcelModel);
begin
   Output := Value;
end;

procedure TCreateParcelModel.SetParcisPodInOne(const Value: boolean);
begin
  FParcisPodInOne := Value;
end;

procedure TCreateParcelModel.SetParcisPropertyName(const Value: string);
begin
   FParcisPropertyName := Value;
end;

procedure TCreateParcelModel.SetParpodPropertyName(const Value: string);
begin
  FParpodPropertyName := Value;
end;

procedure TCreateParcelModel.SetPARSKUKNasText(const Value: boolean);
begin
   FPARSKUKNasText := Value;
   if Value then
   begin
      if PKText = '' then
         PKText := 'PK';
      if GPText = '' then
         GPText := 'GP';
   end;
end;

procedure TCreateParcelModel.SetPARSKUKNPropertyName(const Value: string);
begin
  FPARSKUKNPropertyName := Value;
end;


procedure TCreateParcelModel.SetPKText(const Value: string);
begin
  FPKText := Value;
end;

procedure TCreateParcelModel.SetSKPByComment(const Value: boolean);
begin
  FSKPByComment := Value;
end;

procedure TCreateParcelModel.SetSkupinaParcelGroup(const Value: integer);
begin
  FSkupinaParcelGroup := Value;
end;

procedure TCreateParcelModel.SetSkupinaParcelPropertyName(
  const Value: string);
begin
  FSkupinaParcelPropertyName := Value;
end;

procedure TCreateParcelModel.SetStavebniParcelaValue(const Value: integer);
begin
  FStavebniParcelaValue := Value;
end;

procedure TCreateParcelModel.SetVlastnikPropertyName(const Value: string);
begin
  FVlastnikPropertyName := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TCreateParcelModel);
END.
