unit T_TypPDialog;
interface
uses
   Elements,
   e_GeometryElement,
   f_TypPDialog,
   t_OrbisDialog;

type
TTypPDialog = class(TOrbisDialog)
private
    FFrame: TElement;
    FBigFrame: TElement;
    FComment: string;
    FOldObjectText: string;
    FNewObjectText: string;
    function GetForm: TTypPDialog_Form;
    procedure SetFrame(const Value: TElement);
    procedure SetBigFrame(const Value: TElement);
    procedure SetComment(const Value: string);
    procedure SetNewObjectText(const Value: string);
    procedure SetOldObjectText(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TTypPDialog_Form read GetForm;
published
   property  BigFrame: TElement read FBigFrame write SetBigFrame stored false;
   property  Frame: TElement read FFrame write SetFrame stored false;
   property  Comment: string read FComment write SetComment;
   property  NewObjectText: string read FNewObjectText write SetNewObjectText;
   property  OldObjectText: string read FOldObjectText write SetOldObjectText;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Geometry,
   e_LHCElements,
   e_Class;
   //e_LHCProps,
   //e_Space,
   //t_SpPick;

{ TTypPDialog }

procedure TTypPDialog.CreateForm;
begin
   aForm := TTypPDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TTypPDialog.DoIt;
var
   Are: TAreaElement;
   GAre: TGeometryElement;
   S: string;
begin
   Are := nil;
   GAre := nil;
   if input = nil then exit;
   if Input is TAreaElement then Are := TAreaElement(Input);
   if Input = nil then exit;
   if Output <> nil then
      if Output is TGeometryElement then GAre := TGeometryElement(Output);

   Form.l_Area.Caption := FormatFloat('0.####', Are.Area);
   if GAre <> nil then
   begin
      Caption := OldObjectText+Comment;
      Form.ed_Vymera.Text := GAre.GetPropertyStringByName('Vymera');
      Form.ed_SLT.Text := GAre.GetPropertyStringByName('SLT');
      Form.ed_LT.Text := GAre.GetPropertyStringByName('LT');
      Form.ed_TVL.Text := GAre.GetPropertyStringByName('TVL');
      Form.ed_LO.Text := GAre.GetPropertyStringByName('LES_OBL');
      Form.ed_LOcast.Text := GAre.GetPropertyStringByName('LO_CAST');
      Form.ed_Udrzba.Text := GAre.GetPropertyStringByName('Udrzba');
      Form.ed_Zmena.Text := GAre.GetPropertyStringByName('Zmena');
      Form.ed_PLT.Text := GAre.GetPropertyStringByName('PLT');
      Form.ed_PLT_Nazev.Text := GAre.GetPropertyStringByName('PLT_Nazev');
      Form.b_Delete.Enabled := true;
   end
   else
   begin
      Caption := NewObjectText+Comment;
      Form.ed_TVL.Text := '  -';
   end;
   inherited;
   if Result = 1 then
   begin
      if GAre = nil then
      begin
         GAre := Tgis_LT.Create;
         GAre.Geometry := Are;
      end;
      Output := GAre;
      GAre.SetPropertyStringByName('Vymera',Form.ed_Vymera.Text);
      GAre.SetPropertyStringByName('LT',Form.ed_LT.Text);
      GAre.SetPropertyStringByName('SLT',Form.ed_SLT.Text);
      GAre.SetPropertyStringByName('LES_OBL',Form.ed_LO.Text);
      GAre.SetPropertyStringByName('LO_CAST',Form.ed_LOCast.Text);
      GAre.SetPropertyStringByName('Udrzba',Form.ed_Udrzba.Text);
      GAre.SetPropertyStringByName('Zmena',Form.ed_Zmena.Text);
      GAre.SetPropertyStringByName('TVL',Form.ed_TVL.Text);
      GAre.SetPropertyStringByName('PLT',Form.ed_PLT.Text);
      GAre.SetPropertyStringByName('PLT_Nazev',Form.ed_PLT_Nazev.Text);
      GAre.SetPropertyStringByName('Barva','9');
      GAre.SetPropertyStringByName('ZNACKA','1');
   end;
end;

function TTypPDialog.GetForm: TTypPDialog_Form;
begin
   result := TTypPDialog_Form(aForm);
end;

procedure TTypPDialog.SetBigFrame(const Value: TElement);
begin
   FBigFrame := Value;
end;

procedure TTypPDialog.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure TTypPDialog.SetFrame(const Value: TElement);
begin
   FFrame := Value;
end;

procedure TTypPDialog.SetNewObjectText(const Value: string);
begin
  FNewObjectText := Value;
end;

procedure TTypPDialog.SetOldObjectText(const Value: string);
begin
  FOldObjectText := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTypPDialog);
END.
