unit e_LinkText;

interface
uses
   Elements;

type

TLinkTextElement = class(TOwnerEntity)
  private
    FPropertyName: string;
    FStyle: integer;
    function GetText: string;
    procedure SetPropertyName(const Value: string);
    function GetNoLink: boolean;
    procedure SetStyle(const Value: integer);
published
   property PropertyName: string read FPropertyName write SetPropertyName;
   property Style: integer read FStyle write SetStyle;
   property Text: string read GetText stored false;
   property NoLink: boolean read GetNoLink stored false;
end;

implementation
uses
   e_Class;

{ TLinkTextElement }

function TLinkTextElement.GetNoLink: boolean;
begin
   result := NoElements;
end;

function TLinkTextElement.GetText: string;
var
   e: TElement;
   S :string;
begin
   result := '';
   if NoElements then exit;
   e := Elements[0];
   S := PropertyName;
   if S = '' then S := 'Name';
   result := e.GetPropertyStringByName(S);
end;

procedure TLinkTextElement.SetPropertyName(const Value: string);
begin
  FPropertyName := Value;
end;

procedure TLinkTextElement.SetStyle(const Value: integer);
begin
  FStyle := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TLinkTextElement);
END.
