unit f_KUPDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, f_OrbisDialog, StdCtrls, Buttons, ExtCtrls,
  e_KatastrModel;

type
  TKUPDialog_Form = class(TOrbisDialog_Form)
    BitBtn1: TBitBtn;
    Panel4: TPanel;
    Label6: TLabel;
    l_Area: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    l_AreaCount: TLabel;
    Panel_skupina: TPanel;
    Label3: TLabel;
    Label10: TLabel;
    Label15: TLabel;
    ed_Vlastnik: TComboBox;
    c_Nazev: TComboBox;
    c_KU: TComboBox;
    cb_IsKUMajitel: TCheckBox;
    l_MajName: TStaticText;
    Label1: TLabel;
    ed_Cislo_: TEdit;
    Label2: TLabel;
    ed_ORP: TEdit;
    ed_ORP_Nazev: TEdit;
    ed_Kraj: TEdit;
    ed_Kraj_Nazev: TEdit;
    Label4: TLabel;
    l_SumArea: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    PanelAreaOnly: TPanel;
    cb_AreaOnly: TCheckBox;
    ed_KU: TEdit;
    ed_Nazev: TEdit;
    procedure c_KUClick(Sender: TObject);
    procedure c_NazevClick(Sender: TObject);
  private
    FNewObject: boolean;
    FMajitele: Tgis_Majitele;
    FPModel: Tgis_ParcelModel;
    FKUSetting: boolean;
    procedure SetMajitele(const Value: Tgis_Majitele);
    procedure SetNewObject(const Value: boolean);
    procedure SetPModel(const Value: Tgis_ParcelModel);
    procedure SetKUSetting(const Value: boolean);
    { Private declarations }
  public
     procedure SetForKU(aKU: Tgis_Katastr);
     property PModel: Tgis_ParcelModel read FPModel write SetPModel;
     property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
     property NewObject: boolean read FNewObject write SetNewObject;
     property KUSetting: boolean read FKUSetting write SetKUSetting;
  end;


implementation

{$R *.dfm}

{ TKUPDialog_Form }

procedure TKUPDialog_Form.SetMajitele(const Value: Tgis_Majitele);
var
   M: Tgis_Majitel;
   i: integer;
   S: string;
begin
  FMajitele := Value;
  S := ed_Vlastnik.Text;
  ed_Vlastnik.Clear;
  if Value <> nil then
  begin
     for i := 0 to Value.LastIndex do
     begin
        M := Tgis_Majitel(Value.Elements[i]);
        ed_Vlastnik.Items.Add(M.Cislo);
     end;
  end;
  ed_Vlastnik.Text := S;
end;

procedure TKUPDialog_Form.SetNewObject(const Value: boolean);
begin
  FNewObject := Value;
end;

procedure TKUPDialog_Form.SetPModel(const Value: Tgis_ParcelModel);
var
   S,Sn,SS: string;
   K: Tgis_Katastr;
   i: integer;
begin
  FPModel := Value;
  S := ed_KU.Text;
  Sn := ed_Nazev.Text;
  c_KU.Clear;
  c_Nazev.Clear;
  c_KU.Sorted := true;
  c_Nazev.Sorted := true;
  for i := 0 to Value.LastIndex do
  begin
     K := Tgis_Katastr(Value.Elements[i]);
     c_KU.Items.AddObject(K.Name,K);
     if K.Nazev <> '' then
        SS := K.Nazev
     else
        SS := '?';
     c_Nazev.Items.AddObject(SS,K);
  end;
  ed_KU.Text := S;
  ed_Nazev.Text := Sn;
end;

procedure TKUPDialog_Form.c_KUClick(Sender: TObject);
var
   K: TGis_Katastr;
begin
   if KUSetting then exit;
   KUSetting := true;
   K := TGis_Katastr(c_KU.Items.Objects[c_KU.ItemIndex]);
   if K <> PModel.ActualKatastr then
      SetForKU(K);
   KUSetting := false;
end;

procedure TKUPDialog_Form.SetKUSetting(const Value: boolean);
begin
  FKUSetting := Value;
end;

procedure TKUPDialog_Form.c_NazevClick(Sender: TObject);
var
   K: TGis_Katastr;
begin
   if KUSetting then exit;
   KUSetting := true;
   K := TGis_Katastr(c_Nazev.Items.Objects[c_Nazev.ItemIndex]);
   if K <> PModel.ActualKatastr then
      SetForKU(K);
   KUSetting := false;
end;

procedure TKUPDialog_Form.SetForKU(aKU: Tgis_Katastr);
begin
   PModel.ActualKatastr := aKU;
   ed_KU.Text := aKU.GetpropertyStringByName('CISLO');
   ed_Cislo_.Text := aKU.GetpropertyStringByName('CISLO_');
   ed_Nazev.Text := aKU.Nazev;
   ed_ORP.Text := aKU.GetpropertyStringByName('ORP');
   ed_ORP_Nazev.Text := aKU.ORP_Nazev;
   ed_Kraj.Text := aKU.Kraj;
   ed_Kraj_Nazev.Text := aKU.Kraj_Nazev;
   ed_Vlastnik.Text := aKU.GetPropertyStringByName('Vlastnik');
end;

end.
