unit f_SimpleTextDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, f_OrbisDialog, StdCtrls, Buttons, ExtCtrls,
  e_BGIF;

type
  TSimpleTextDialog_Form = class(TOrbisDialog_Form)
    b_Anchor: TBitBtn;
    b_JoinNext: TBitBtn;
    b_Remove: TBitBtn;
    b_Copy: TBitBtn;
    Edit: TEdit;
    ed_Styl: TComboBox;
    procedure ed_StylChange(Sender: TObject);
  private
    FStyly: TTextStyles;
    FStyl: integer;
    procedure SetStyly(const Value: TTextStyles);
    procedure SetStyl(const Value: integer);
    procedure SetNew(const Value: boolean);
    { Private declarations }
  public
     property Styly: TTextStyles read FStyly write SetStyly;
     property Styl: integer read FStyl write SetStyl;
     property New: boolean write SetNew;
    { Public declarations }
  end;


implementation

{$R *.dfm}

{ TSimpleTextDialog_Form }

procedure TSimpleTextDialog_Form.SetStyl(const Value: integer);
var
   TS: TTextStyle;
begin
   FStyl := Value;
   if Styly = nil then exit;
   TS := Styly.StyleOfCode[Value];
   if TS = nil then
      ed_Styl.Text  := IntToStr(Value)
   else
   begin
      ed_Styl.ItemIndex := Styly.IndexOf(TS);
   end;
end;

procedure TSimpleTextDialog_Form.SetStyly(const Value: TTextStyles);
var
  TS: TTextStyle;
  i: integer;
begin
  FStyly := Value;
  ed_Styl.Items.Clear;
  if Value = nil then exit;
  for i := 0 to Value.LastIndex do
  begin
     TS := TTextStyle(Value.Elements[i]);
     ed_Styl.Items.AddObject(IntToStr(TS.Druh)+' '+TS.Name,TS);
  end;
  if FStyl > 0 then
     Styl := FStyl;
end;

procedure TSimpleTextDialog_Form.ed_StylChange(Sender: TObject);
begin
   if ed_Styl.ItemIndex > -1 then
      FStyl := TTextStyle(ed_Styl.Items.Objects[ed_Styl.ItemIndex]).Druh;
end;

procedure TSimpleTextDialog_Form.SetNew(const Value: boolean);
begin
   b_Remove.Enabled := not Value;
   b_Copy.Enabled := not Value;
   b_Anchor.Enabled := not Value;
end;

end.

