unit t_LHCImportDialog;

interface
uses
   f_LHCImportDialog,
   t_OrbisDialog;
type

TLHCImportDialog = class(TOrbisDialog)
private
    function GetForm: TLHCImportDialog_Form;
    function GetDET: boolean;
    function GetDETLines: boolean;
    function GetParcely: boolean;
    function GetSkupinyParcel: boolean;
    function GetSLU: boolean;
    function GetSRF: boolean;
    function GetZAK: boolean;
    procedure SetDET(const Value: boolean);
    procedure SetDETLines(const Value: boolean);
    procedure SetParcely(const Value: boolean);
    procedure SetSkupinyParcel(const Value: boolean);
    procedure SetSLU(const Value: boolean);
    procedure SetSRF(const Value: boolean);
    procedure SetZAK(const Value: boolean);
    function GetTEZ: boolean;
    procedure SetTEZ(const Value: boolean);
    function GetREV: boolean;
    procedure SetRev(const Value: boolean);
    function GetHRK: boolean;
    function GetTSK: boolean;
    function GetTXT: boolean;
    procedure SetHRK(const Value: boolean);
    procedure SetTSK(const Value: boolean);
    procedure SetTXT(const Value: boolean);
    function GetCES: boolean;
    procedure SetCES(const Value: boolean);
public
   procedure CreateForm; override;
   property  Form: TLHCImportDialog_Form read GetForm;
published
   property  SkupinyParcel: boolean read GetSkupinyParcel write SetSkupinyParcel;
   property  Parcely: boolean read GetParcely write SetParcely;
   property  REV: boolean read GetREV write SetRev;
   property  ZAK: boolean read GetZAK write SetZAK;
   property  DET: boolean read GetDET write SetDET;
   property  DETLines: boolean read GetDETLines write SetDETLines;
   property  SLU: boolean read GetSLU write SetSLU;
   property  SRF: boolean read GetSRF write SetSRF;
   property  TEZ: boolean read GetTEZ write SetTEZ;
   property  CES: boolean read GetCES write SetCES;
   property  HRK: boolean read GetHRK write SetHRK;
   property  TXT: boolean read GetTXT write SetTXT;
   property  TSK: boolean read GetTSK write SetTSK;
end;


implementation
uses
   Forms;
{ TLHCImportDialog }

procedure TLHCImportDialog.CreateForm;
begin
   aForm := TLHCImportDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;


function TLHCImportDialog.GetCES: boolean;
begin
   result := FOrm.cb_CES.Checked;
end;

function TLHCImportDialog.GetDET: boolean;
begin
   result := FOrm.cb_DET.Checked;
end;

function TLHCImportDialog.GetDETLines: boolean;
begin
   result := FOrm.cb_DETLines.Checked;
end;

function TLHCImportDialog.GetForm: TLHCImportDialog_Form;
begin
   result := TLHCImportDialog_Form(aForm);
end;

function TLHCImportDialog.GetHRK: boolean;
begin
   result := Form.cb_HRK.Checked;
end;

function TLHCImportDialog.GetParcely: boolean;
begin
   result := FOrm.cb_Parcely.Checked;
end;

function TLHCImportDialog.GetREV: boolean;
begin
   result := FOrm.cb_Rev.Checked;
end;

function TLHCImportDialog.GetSkupinyParcel: boolean;
begin
   result := FOrm.cb_SkupinyParcel.Checked;
end;

function TLHCImportDialog.GetSLU: boolean;
begin
   result := FOrm.cb_SLU.Checked;
end;

function TLHCImportDialog.GetSRF: boolean;
begin
   result := FOrm.cb_SRF.Checked;
end;

function TLHCImportDialog.GetTEZ: boolean;
begin
   result := FOrm.cb_TEZ.Checked;
end;

function TLHCImportDialog.GetTSK: boolean;
begin
   result := FOrm.cb_TSK.Checked;
end;

function TLHCImportDialog.GetTXT: boolean;
begin
   result := FOrm.cb_TXT.Checked;
end;

function TLHCImportDialog.GetZAK: boolean;
begin
   result := FOrm.cb_ZAK.Checked;
end;

procedure TLHCImportDialog.SetCES(const Value: boolean);
begin
   Form.cb_CES.Checked := Value;
end;

procedure TLHCImportDialog.SetDET(const Value: boolean);
begin
   Form.cb_DET.Checked := Value;
end;

procedure TLHCImportDialog.SetDETLines(const Value: boolean);
begin
   Form.cb_DETLines.Checked := Value;
end;


procedure TLHCImportDialog.SetHRK(const Value: boolean);
begin
   Form.cb_HRK.Checked := Value;
end;

procedure TLHCImportDialog.SetParcely(const Value: boolean);
begin
   Form.cb_Parcely.Checked := Value;
end;

procedure TLHCImportDialog.SetRev(const Value: boolean);
begin
   Form.cb_Rev.Checked := Value;
end;

procedure TLHCImportDialog.SetSkupinyParcel(const Value: boolean);
begin
   Form.cb_SkupinyParcel.Checked := Value;
end;

procedure TLHCImportDialog.SetSLU(const Value: boolean);
begin
   Form.cb_SLU.Checked := Value;
end;

procedure TLHCImportDialog.SetSRF(const Value: boolean);
begin
   Form.cb_SRF.Checked := Value;
end;

procedure TLHCImportDialog.SetTEZ(const Value: boolean);
begin
   Form.cb_TEZ.Checked := Value;
end;

procedure TLHCImportDialog.SetTSK(const Value: boolean);
begin
   Form.cb_TSK.Checked := Value;
end;

procedure TLHCImportDialog.SetTXT(const Value: boolean);
begin
   Form.cb_TXT.Checked := Value;
end;

procedure TLHCImportDialog.SetZAK(const Value: boolean);
begin
   Form.cb_ZAK.Checked := Value;
end;

end.
