unit T_guideu;

interface

uses
   Elements,
   t_Recurs;

type

TRecGuideSelect = class(TRecursor)
private
  FSelect50: boolean;
  FSelect25: boolean;
  FSelect10: boolean;
  FSelect5: boolean;
  FSelect2: boolean;
  FSelectU: boolean;
  FSelectVectors: boolean;
protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
public
  procedure DoIt; override;
  property  Select50: boolean read FSelect50 write FSelect50;
  property  Select25: boolean read FSelect25 write FSelect25;
  property  Select10: boolean read FSelect10 write FSelect10;
  property  Select5:  boolean read FSelect5  write FSelect5;
  property  Select2:  boolean read FSelect2  write FSelect2;
  property  SelectU:  boolean read FSelectU  write FSelectU;
  property  SelectVectors:  boolean read FSelectVectors  write FSelectVectors;
end;




implementation
uses
   g_Elems,
   e_Guide,
   e_MSpace;


{ TRecGuideSelect }


function  TRecGuideSelect.QGoInside(Element: TElement): boolean;
begin
  result := false;
  if SelectVectors then
  begin
     if Element is TGuide then result := true
  end
  else
  if not (Element is TVectors) then result := true;
end;

function  TRecGuideSelect.QProcessBefore(Element: TElement): boolean;
begin
   result := false;
   if SelectVectors then
   begin
      if Element is TVectors then result := true
   end
   else Result:= Element is TMapSpace;
end;



procedure TRecGuideSelect.Process(Element: TElement);
var
  aClass: TClass;
  V: TVectors;
  i: longInt;
begin
   aClass := Element.ClassType;
   if SelectVectors then
   begin
      if aClass = TVectors then
      begin
         V := TVectors(Element);
         for i := 0 to V.Count -1 do
         begin
            if V.Elements[i] is TRectEntity then
               TRectangle(Output).UpdateByRectangle(TRectEntity(V.Elements[i]).Rect);
         end;
      end;
   end
   else
   if SelectU then
   begin
      if (aClass = TUserMapSpace) and TUserMapSpace(Element).Selected then
         TRectangle(Output).UpdateByRectangle(TUserMapSpace(Element).Rect);
   end
   else
   if
   ((aClass = TGuidePage_2) and Select2) or
   ((aClass = TGuidePage_5) and Select5 and not Select2) or
   ((aClass = TGuidePage_10) and Select10 and not (Select5 or Select2)) or
   ((aClass = TGuidePage_25) and Select25 and not(Select2 or Select5 or Select10)) or
   ((aClass = TGuidePage_50) and Select50 and not(Select2 or Select5 or Select10 or Select25))
   then
   begin
      if TSMO_2(Element).Selected then
         TRectangle(Output).UpdateByRectangle(TRectEntity(Element).Rect);
   end
   else exit;
end;



procedure TRecGuideSelect.DoIt;
begin
   Output := TRectangle.Create;
   inherited DoIt;
end;






end.
