// Tahle unita je trochu mimo, protoe je to tak zoufale nekoncepn een a se mi chce zvracet..
// take naprosto nebude vadit, kdy v n bude zakomponovanej i interpret ...

unit e_GeometryELementTable;

interface
uses
   Elements,
   G_Elems;

type

TGeometryElementTable = class(TText)
  private
    FTextHeight: double;
    FImageVirtualScale: double;
    FImageWidth: double;
    FImageScale: double;
    FImageHeight: double;
    FMargins: double;
    FDelimiter2: string;
    FSortBy1: string;
    FDelimiter3: string;
    FProperty2: string;
    FDelimiter1: string;
    FProperty1: string;
    FSortBy2: string;
    FProperty3: string;
    FSortBy3: string;
    FGES: TEntity;
    procedure SetDelimiter1(const Value: string);
    procedure SetDelimiter2(const Value: string);
    procedure SetDelimiter3(const Value: string);
    procedure SetImageHeight(const Value: double);
    procedure SetImageScale(const Value: double);
    procedure SetImageVirtualScale(const Value: double);
    procedure SetImageWidth(const Value: double);
    procedure SetMargins(const Value: double);
    procedure SetProperty1(const Value: string);
    procedure SetProperty2(const Value: string);
    procedure SetProperty3(const Value: string);
    procedure SetSortBy1(const Value: string);
    procedure SetSortBy2(const Value: string);
    procedure SetSortBy3(const Value: string);
    procedure SetTextHeight(const Value: double);
    procedure SetEntity(const Value: TEntity);
    function  GetGES: TEntity;
public
    property  GES: TEntity read GetGES;
published
   property Entity: TEntity write SetEntity stored false;
   property ImageHeight: double read FImageHeight write SetImageHeight;
   property ImageWidth: double read FImageWidth write SetImageWidth;
   property TextHeight: double read FTextHeight write SetTextHeight;
   property Margins: double read FMargins write SetMargins;
   property ImageScale: double read FImageScale write SetImageScale;
   property ImageVirtualScale: double read FImageVirtualScale write SetImageVirtualScale;
   property Property1: string read FProperty1 write SetProperty1;
   property Property2: string read FProperty2 write SetProperty2;
   property Property3: string read FProperty3 write SetProperty3;
   property Delimiter1: string read FDelimiter1 write SetDelimiter1;
   property Delimiter2: string read FDelimiter2 write SetDelimiter2;
   property Delimiter3: string read FDelimiter3 write SetDelimiter3;
   property SortBy1: string read FSortBy1 write SetSortBy1;
   property SortBy2: string read FSortBy2 write SetSortBy2;
   property SortBy3: string read FSortBy3 write SetSortBy3;
end;


implementation
uses
   Graphics,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   e_Sort,
   e_TopolElements,
   e_View;

{ TGeometryElementTable }

function TGeometryElementTable.GetGES: TEntity;
begin
   if FGES = nil then
   begin
      FGES := TSortedEntity.Create;
      FGES.Name := 'GES';
      AddElement(FGES);
   end;
   result := FGES;
end;

procedure TGeometryElementTable.SetDelimiter1(const Value: string);
begin
  FDelimiter1 := Value;
end;

procedure TGeometryElementTable.SetDelimiter2(const Value: string);
begin
  FDelimiter2 := Value;
end;

procedure TGeometryElementTable.SetDelimiter3(const Value: string);
begin
  FDelimiter3 := Value;
end;

procedure TGeometryElementTable.SetEntity(const Value: TEntity);
var
   i: integer;
   e: TElement;
   Ge: TGeometryElement;
   GEN: TEntity;
   S,SS: string;
   oe: TStringEntity;
   aView: TView;
   aText: TText;
   aX,aY: double;
   TA,TAO: TTopolAreaELement;
   TL: TTopolLineElement;
   L: TPolyLineElement;
   A: TPolyLineAreaElement;
   DR: TDrawRectangle;
begin
   if Value = nil then exit;
   GEN := GES;
   GEN.FreeAll;
   for i := 0 to Value.LastIndex do
   begin
      e := Value.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      // name
      S := '';
      if Property1 <> '' then
         S :=     Delimiter1 + GE.GetPropertyStringByName(Property1);
      if Property2 <> '' then
         S := S + Delimiter2 + GE.GetPropertyStringByName(Property2);
      if Property3 <> '' then
         S := S + Delimiter3 + GE.GetPropertyStringByName(Property3);
      // sort name
      SS := '';
      if SortBy1 <> '' then
         SS := GE.GetPropertyStringByName(SortBy1);
      if SortBy2 <> '' then
         SS := SS + GE.GetPropertyStringByName(SortBy2);
      if SortBy3 <> '' then
         SS := SS + GE.GetPropertyStringByName(SortBy3);
      e := GEN.FindElementName(SS);
      if e = nil then
      begin
         oe := TStringEntity.Create;
         oe.Name := SS;
         oe.Value := S;
         GEN.AddElement(oe);
         oe.AddElement(GE);
      end;
   end;
   aX := MinX + Margins;
   aY := MaxY - Margins - ImageHeight;
   for i := 0 to GEN.LastIndex do
   begin
      oe := TStringEntity(GEN.Elements[i]);
      // View
      aView := TView.Create;
      aView.MinX := aX;
      aView.MinY := aY;
      aView.Width := ImageWidth;
      aVIew.Height := ImageHeight;
      aView.Scale := ImageScale;
      aView.VirtualScale := ImageVirtualScale;
      aView.PenStyle := psSolid;
      aView.PenColor := 0;
      oe.AddElement(aView);
      DR := TDrawRectangle.Create;
      Dr.UpdateRect(aView);
      Dr.BrushStyle := bsClear;
      Dr.PenStyle := PsSolid;
      Dr.PenColor := 0;
      oe.AddElement(DR);
      // vnitrek view
      e := oe.FindElementClass(TGeometryElement);
      if e <> nil then
      begin
         if e is TTopolAreaElement then
         begin
            TAO := TTopolAreaElement(e);
            TA := TTopolAreaElement.Create;
            TA.Barva := TAO.Barva;
            TA.Znacka := TAO.Znacka;
            TA.Druh := TAO.Druh;
            TA.Presnost := TAO.Presnost;
            L := TPolyLineELement.Create;
            A := TPolyLineAreaElement.Create;
            L.AddXY(aView.ModelMinX - 100,aView.ModelMinY - 100);
            L.AddXY(aView.ModelMaxX + 100,aView.ModelMinY - 100);
            L.AddXY(aView.ModelMaxX + 100,aView.ModelMaxY + 100);
            L.AddXY(aView.ModelMinX - 100,aView.ModelMaxY + 100);
            L.AddXY(aView.ModelMinX - 100,aView.ModelMinY - 100);
            L.Update;
            A.AddAndUpdateRect(L);
            TA.Geometry := A;
            aView.Model := TA;
         end
         else
         if e is TTopolLineElement then
         begin
         end;
         oe.ElementToRemove := e;
      end;
      // text
      aText := TText.Create;
      aText.X := aView.MaxX + Margins;
      aText.Y := aY + (ImageHeight - TextHeight)/2;
      aText.Text := oe.Value;
      aText.Height := TextHeight;
      aText.Orientation := Orientation;
      aText.FontName := FontName;
      aText.FontStyle := FontStyle;
      aText.Color := Color;
      aText.Charset := CHarset;
      oe.AddElement(aText);

      aY := aY - Margins - ImageHeight;
   end;
end;

procedure TGeometryElementTable.SetImageHeight(const Value: double);
begin
  FImageHeight := Value;
end;

procedure TGeometryElementTable.SetImageScale(const Value: double);
begin
  FImageScale := Value;
end;

procedure TGeometryElementTable.SetImageVirtualScale(const Value: double);
begin
  FImageVirtualScale := Value;
end;

procedure TGeometryElementTable.SetImageWidth(const Value: double);
begin
  FImageWidth := Value;
end;

procedure TGeometryElementTable.SetMargins(const Value: double);
begin
  FMargins := Value;
end;

procedure TGeometryElementTable.SetProperty1(const Value: string);
begin
  FProperty1 := Value;
end;

procedure TGeometryElementTable.SetProperty2(const Value: string);
begin
  FProperty2 := Value;
end;

procedure TGeometryElementTable.SetProperty3(const Value: string);
begin
  FProperty3 := Value;
end;

procedure TGeometryElementTable.SetSortBy1(const Value: string);
begin
  FSortBy1 := Value;
end;

procedure TGeometryElementTable.SetSortBy2(const Value: string);
begin
  FSortBy2 := Value;
end;

procedure TGeometryElementTable.SetSortBy3(const Value: string);
begin
  FSortBy3 := Value;
end;

procedure TGeometryElementTable.SetTextHeight(const Value: double);
begin
  FTextHeight := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TGeometryElementTable);
END.
