unit F_edview;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls,
// KERNEL
  Elements,
  Tools,
// MAPPER  
  E_View;

type
  TSetupViewDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    edName: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    bbScript: TBitBtn;
    Label1: TLabel;
    edControlView: TComboBox;
    edVirtualScale: TComboBox;
    edScale: TComboBox;
    cbReadAfter: TCheckBox;
    Panel1: TPanel;
    Image1: TImage;
    procedure bbScriptClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FView: TView;
  end;



TViewDialog = class(TTool)
private
  FView: TView;
  Form:  TSetupViewDialog;
public
  procedure DoIt; override;
end;


implementation

{$R *.DFM}
uses
  SysUtils,
// KERNEL
  Worlds,
// GISLAYER
  E_LayScr,
  f_LayImp,
  t_LayScr,
// MAPPER
  e_Desktp,
// MAIN
  t_Main;
  //T_VSEdit,



procedure TViewDialog.DoIt;
var
   i: longInt;
   D: TDesktop;
   E: TElement;
begin
   if not (input is TView) then exit;
   FView:= TView(input);

   Form:= TSetupViewDialog.Create(Application);
   Form.FView:= FView;
   Form.EdName.Text:= FView.Name;
   Form.EdScale.Text:= IntToStr(trunc(FView.Scale));
   Form.EdVirtualScale.Text:= IntToStr(trunc(FView.VirtualScale));
   Form.cbReadAfter.Checked := FView.ReadAfter;
   D := TDesktop(FView.FIndOwnerClass(TDesktop));
   if D <> nil then
   begin
      for i := 0 to D.Count-1 do
      begin
         E := D.Elements[i];
         if E is TView then Form.EdControlView.Items.Add(E.Name);
      end;
   end;
   Form.EdControlView.Text:= FView.ControlViewName;
   if Form.ShowModal = mrOK then
   begin
     FView.Name:= Form.EdName.Text;
     FView.Scale:= StrToFloat(Form.EdScale.Text);
     FView.VirtualScale:= StrToFloat(Form.EdVirtualScale.Text);
     FView.ControlViewName:= Form.EdControlView.Text;
     FView.ReadAfter := Form.cbReadAfter.Checked;
   end;
   Form.Free;
end;



procedure TSetupViewDialog.bbScriptClick(Sender: TObject);
var
  LI: TLayerImportDialog;
  MS: TModelScript;
  SLFM: TStringListFromModelScript;
  MSC: TModelScriptCreator;
begin
  LI:= TLayerImportDialog.Create;
  LI.Initialdir := TMainTool(World.MainTool).Options.DataDirectory;
  SLFM := TStringListFromModelScript.Create;
  SLFM.Input := FView.ModelScript;
  SLFM.DoIt;
  LI.Input := SLFM.Output;
  SLFM.Free;
  LI.DoIt;
  MSC := TModelScriptCreator.Create;
  MSC.Input := LI.Output;
  LI.Free;
  MSC.DataDirectory :=  TMainTool(World.MainTool).Options.DataDirectory;
  MSC.DoIt;
  FView.FreeElement(FView.ModelScript);
  FView.AddElement(MSC.Output);
  MSC.Free;
  {
  MS:= FView.ModelScript;
  VSE.Input:= FView.FindElementClass(TModelScript);
  VSE.DoIt;
  }
{  VSE.Free }
end;

end.
