unit F_templ;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Buttons, ExtCtrls;

type
  TF_Template = class(TForm)
    ListBox: TListBox;
    Panel1: TPanel;
    bbzrus: TBitBtn;
    bbViewTemplate: TBitBtn;
    bbNova: TBitBtn;
    odNovaSablona: TOpenDialog;
    b_EditMS: TBitBtn;
    b_NewMS: TBitBtn;
    b_MSD: TSpeedButton;
    b_MSC: TSpeedButton;
    b_OIL: TSpeedButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bbNovaClick(Sender: TObject);
    procedure bbViewTemplateClick(Sender: TObject);
    procedure bbzrusClick(Sender: TObject);
    procedure b_MSDClick(Sender: TObject);
    procedure b_EditMSClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure b_MSCClick(Sender: TObject);
    procedure b_OILClick(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure b_NewMSClick(Sender: TObject);
  private
    { Private declarations }
  public
     isPossibleToClose: boolean;
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
   IniFiles,
   Elements,
   m_Proj,
   t_MainTl,
   Worlds;


procedure TF_Template.FormDestroy(Sender: TObject);
var
   Ini: TIniFile;
begin
   try
      Ini := TIniFile.Create(TOldMainTool(World.MainTool).IniFileName);

      Ini.WriteInteger('TemplateForm','Left', Left);
      Ini.WriteInteger('TemplateForm','Top', Top);
      Ini.WriteInteger('TemplateForm','Height', Height);
      Ini.WriteInteger('TemplateForm','Width', Width);
      Ini.Free;
   except
   end;
end;




procedure TF_Template.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
begin
   try
      IsPossibleToClose := false;
      {$IFDEF NoEditorMS}
      b_EditMS.Visible := false;
      b_NewMS.Visible:= false;
      {$ENDIF}
      Ini := TIniFile.Create(TOldMainTool(World.MainTool).IniFileName);
      Left        := Ini.ReadInteger('TemplateForm','Left', 0);
      Top         := Ini.ReadInteger('TemplateForm','Top', 0);
      Height      := Ini.ReadInteger('TemplateForm','Height', 200);
      Width       := Ini.ReadInteger('TemplateForm','Width', 200);

      Ini.Free;
   except
   end;
end;



procedure TF_Template.ListBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{
   if ListBox.Selected[ListBox.ItemIndex] then
      World.PostMsg(tm_TemplateSelected, World.MainTool, nil, DontKill);
}
end;

procedure TF_Template.bbNovaClick(Sender: TObject);
begin
  World.PostMsg(tm_AddTemplate, World.MainTool, nil, DontKill);
end;


procedure TF_Template.bbViewTemplateClick(Sender: TObject);
begin
{ zobrazen vybran ablony }
   if (ListBox.ItemIndex >=0) and ListBox.Selected[ListBox.ItemIndex] then
      World.PostMsg(tm_TemplateSelected, World.MainTool, nil, DontKill);
end;

procedure TF_Template.bbZrusClick(Sender: TObject);
begin
  World.PostMsg(tm_DeleteTemplate, World.MainTool, nil, DontKill);
end;

procedure TF_Template.b_MSDClick(Sender: TObject);
begin
   {$IFNDEF NoEditorMS}
   World.PostMsg(tm_NotePadTemplate, World.MainTool, nil, DontKill);
   {$ENDIF}
   World.PostMsg(tm_TemplateTouched, World.MainTool, nil, DontKill);
end;

procedure TF_Template.b_EditMSClick(Sender: TObject);
begin
  World.PostMsg(tm_EditTemplate, World.MainTool, nil, DontKill);
end;

procedure TF_Template.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= caFree
end;

procedure TF_Template.b_MSCClick(Sender: TObject);
begin
   {$IFNDEF NoEditorMS}
   World.PostMsg(tm_NotePadMSC, World.MainTool, nil, DontKill);
   {$ENDIF}
   World.PostMsg(tm_TemplateTouched, World.MainTool, nil, DontKill);
end;

procedure TF_Template.b_OILClick(Sender: TObject);
begin
   {$IFNDEF NoEditorMS}
   World.PostMsg(tm_NotePadOIL, World.MainTool, nil, DontKill);
   {$ENDIF}
   World.PostMsg(tm_TemplateTouched, World.MainTool, nil, DontKill);
end;

procedure TF_Template.ListBoxClick(Sender: TObject);
begin
   World.PostMsg(tm_TemplateTouched, World.MainTool, nil, DontKill);
end;

procedure TF_Template.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if IsPossibleToClose then
  begin
     CanClose:= true;
  end
  else
  begin
    CanClose:= false;
    IsPossibleToClose := true;
    World.PostMsg(tm_Template, World.MainTool, nil, DontKill);
  end
end;

procedure TF_Template.b_NewMSClick(Sender: TObject);
begin
   World.PostMsg(tm_NewMapSheet, World.MainTool, nil, DontKill);
end;

end.
