unit language;

interface
uses Elements,
     E_Type,
     T_Oper,
     Tools;

const MaxVariables=50;
      MaxVarLength=30;

      WorldIndex=0{poradi Worldu ve stacku};
      MToolIndex=1{poradi MainToolu ve stacku};
      ActiveElIndex=2{poradi Activeelemetu ve stacku};

type
 NameString=string[MaxVarLength];
 TToolClass=class of TTool;

 TPrgLine=class(TOwnerEntity) {predelat na entitu a pridelat Program caller}
 public
  procedure DoIt;virtual;abstract;
 end;

TPrgBlock=class(TPrgLine)
private
 FPrgLineList:TNameEntity;
 FVarInfoList:TNameEntity; {soupis promennych deklarovanych pro tento blok}
 FStackIndex:integer;{prvni misto v staku patrici tomuto bloku}
 FStack:TOwnerEntity;
 procedure SetVariable(index:integer;aVar:TTypeElement);virtual;{asi neni nutne}
 function GetVariable(index:integer):TTypeElement;virtual;
 property Variable[index:integer]:TTypeElement read GetVariable write SetVariable;
 procedure SetStack(aStack:TOwnerEntity);virtual;{asi neni nutne}
 function GetStack:TOwnerEntity;virtual;
 procedure SetPrgLineList(aList:TNameEntity);virtual;
 function GetPrgLineList:TNameEntity;virtual;
 function GetPrgLine(index:longint):TPrgLine;virtual;
 procedure SetPrgline(index:longint;aLine:TPrgLine);virtual;
 procedure CreateVarsInStack;virtual;
 procedure DestroyVarsInStack;virtual;
 procedure SetVarInfoList(aList:TNameEntity);
 function GetVarInfoList:TNameEntity;
 function GetVarType(index:byte):TType;
 procedure SetVarType(index:byte;aType:TType);
 function GetVarName(index:byte):string;
 procedure SetVarName(index:byte;aname:string);
public
 property Stack:TOwnerEntity read GetStack write SetStack;
 property VarInfoList:TNameEntity read GetVarInfoList write SetVarInfoList;
 property VarType[index:byte]:TType read GetVarType write SetVarType;
 property VarTypeName[index:byte]:string read GetVarName write SetVarName;
 property PrgLinelist:TNameEntity read GetPrgLineList write SetPrgLineList;
 property PrgLine[index:longint]:TPrgLine read GetPrgLine write SetPrgline;
 property StackIndex:integer read FStackIndex write FStackIndex;
 procedure AddPrgLine(aLine:TPrgLine);
 procedure DoIt;override;
end;

TParametr=class(TEntity)
private
 FExp:TOperator;
 function GetExp:TOperator;
 procedure SetExp(aExp:TOperator);
public
 VarIndex:longint;
 property Expression:TOperator read GetExp write SetExp;
end;

{na vstupu bude ocekavat entitu s TParametry}
TOilProc=class(TPrgBlock)
private
 FCalls:integer;
 FParams:TEntity;
 procedure ReadParameters;
 function GetFuncResult:TTypeElement;virtual;
public
 property FuncResult:TTypeElement read GetFuncResult;
 property Parameters:TEntity read FParams write FParams;
 procedure DoIt;override;
published
 property Calls:integer read FCalls write FCalls;
end;


TProgram=class(TOilProc)
private
 FProcedureList:TEntity;
 function GetProcList:TEntity;
 procedure SetProcList(aList:TEntity);
public
 property ProcList:TEntity read GetProcList write SetProcList;
 procedure DoIt;override;
end;
{enf of neni uplne}

TVariable=class(TNoPtrOperator)
  private
   function GetConst:TTypeElement;virtual;abstract;
   procedure SetConst(aConst:TTypeElement);virtual;abstract;
   function GetConstTyp:TType;virtual;abstract;
   function GetConstName:string;virtual;abstract;
  public
   procedure DoIt;override;
   procedure GetTypeInfo;override;
   property Constant:TTypeElement read GetConst write SetConst;
   property Typ:TType read GetConstTyp; {mozna zbytecne}
   property TypeName:string read GetConstName;
  end;

TVarInfo=class(TElement)
private
   FType:TType;
   FTypeName:NameString;
published
   property VarType:TType read FType write FType;
   property TypeName:NameString read FTypeName write FTypeName;
end;

TNormalVariable=class(TVariable)
  private
   FVarIndex:integer;
   FBlock:TPrgBlock;
   function GetConst:TTypeElement;override;
   procedure SetConst(aConst:TTypeElement);override;
   function GetConstTyp:TType;override;
   function GetConstName:string;override;
  public
   property Block:TPrgBlock read FBlock write FBlock;
  published
   property VarIndex:integer read FVarIndex write FVarIndex;
  end;

TCalledVariable=class(TNormalVariable)
private
   function GetConst:TTypeElement;override;
   procedure SetConst(aConst:TTypeElement);override;
   {function GetConstTyp:TType;override;}
 end;


TPropVariable=class(TVariable)
 private
  FInitialExp:TOperator; {kdyby bylo vicenasobne dedeni
  					pridal by se TOnePtrOperator}
  FPropName:string;
  function GetConst:TTypeElement;override;
  procedure SetConst(aConst:TTypeElement);override;
  function GetConstTyp:TType;override;
  function GetInitialExp:TOperator;
  procedure SetInitialExp(aOp:TOperator);
 public
  property InitialExp:TOperator read GetInitialExp write SetInitialExp;
 published
  property PropertyName:string read FPropName write FPropName;
 end;

TElementOperator=class(TOnePtrOperator)
private
 FElName:String;
public
  procedure DoIt;override;
  procedure GetTypeInfo;override;
published
  property ElementName:string read FElName write FElName;
  end;

TOwnerOperator=class(TElementOperator)
 public
	procedure DoIt;override;
 end;

TToolInputInfo=class(TEntity)
 private
  FPropIndex:longint;
  FInputExpr:TOperator;
  function GetInputExpr:TOperator;
  procedure SetInputExpr(aExp:TOperator);
 public
  property InputExpr:TOperator read GetInputExpr write SetInputExpr;
 published
  property PropIndex:longint read FPropIndex write FPropIndex;
end;

TToolOperator=class(TOnePtrOperator)
 private
  FToolClass:TToolClass;
  FPropInputList:TEntity;
  function GetPropInputList:TEntity;
  procedure SetPropInputList(aList:TEntity);
  function GetInputItem(index:longint):TToolInputinfo;virtual;
 public
  property PropInputList:TEntity read GetPropInputList write SetPropInputList;
  property PropInputItem[index:longint]:TToolInputInfo read GetInputItem;
  property ToolClass:TToolClass read FToolClass write FToolClass;
  procedure DoIt;override;
  procedure GetTypeInfo;override;
 end;

TProtectBlock=class(TPrgBlock)
public
 procedure DoIt;override;
end;

TAssignLine=class(TPrgLine)
private
 FLeftVar:TVariable;
 FExpression:TOperator;
 function GetExpr:TOperator;
 procedure SetExpr(aExpr:TOperator);
 function GetLeftVar:TVariable;
 procedure SetLeftVar(aExpr:TVariable);
public
 procedure DoIt;override;
 property LeftVar:TVariable read GetLeftVar write SetLeftVar;
 property Expression:TOperator read GetExpr write Setexpr;
end;

TExprLine=class(TPrgLine)
private
 FOperator:TOperator;
 function GetOperator:TOperator;
 procedure SetOperator(aOp:TOperator);
public
 property Operator:TOperator read GetOperator write SetOperator;
 procedure DoIt;override;
end;

TIfLine=class(TPrgLine)
private
 FExpression:{TBooleanOperator}TOperator;
 FThenBlock,FElseBlock:TPrgLine;
 function GetExpr:TOperator;
 procedure SetExpr(aExpr:TOperator);
 function GetThenBlock:TPrgLine;
 procedure SetThenBlock(ablock:TPrgLine);
 function GetElseBlock:TPrgLine;
 procedure SetElseBlock(aBlock:TPrgLine);
 public
 procedure DoIt;override;
 property Expression:TOperator read GetExpr write SetExpr;
 property ThenBlock:TPrgLine read GetThenBlock write SetThenBlock;
 property ElseBlock:TPrgLine read GetElseBlock write SetElseBlock;
end;

TForLine=class(TPrgLine)
private
 FVariable:TNormalVariable;
 FBlock:TPrgLine;
 FStart,FEnd:TOperator;
 FIncrease:Boolean;
 function GetVar:TNormalVariable;
 procedure SetVar(aVar:TNormalVariable);
 function GetStart:TOperator;
 procedure SetStart(aVar:TOperator);
 function GetEnd:TOperator;
 procedure SetEnd(aVar:TOperator);
 function GetBlock:TPrgLine;
 procedure SetBlock(ablock:TPrgLine);
 public
 procedure DoIt;override;
 property Variable:TNormalVariable read GetVar write SetVar;
 property Block:TPrgLine read GetBlock write SetBlock;
 property Increase:boolean read FIncrease write FIncrease;
 {predelat na operatory}
 property StartValue:TOperator read GetStart write SetStart;
 property EndValue:TOperator read GetEnd write SetEnd;
end;

TWhileLine=class(TprgLine)
  FBlock:TPrgLine;
  FExpression:{TBooleanOperator}TOperator;
 private
  function GetBlock:TPrgLine;
  procedure SetBlock(ablock:TPrgLine);
  function GetExpr:TOperator;
  procedure SetExpr(aExpr:TOperator);
 public
  procedure DoIt;override;
  property Block:TPrgLine read GetBlock write SetBlock;
  property Expression:TOperator read GetExpr write SetExpr;
 end;

TRepeatline=class(TprgBlock)
private
  FExpression:{TBooleanOperator}TOperator;
 private
  function GetExpr:TOperator;
  procedure SetExpr(aExpr:TOperator);
 public
  procedure DoIt;override;
  property Expression:TOperator read GetExpr write SetExpr;
end;

TCaseLine=class(TPrgline)
  FExpression:TOperator;
  FCaseList,FBlockList:TEntity;
  {FBlock:TPrgLine;}
  FElseBlock:TPrgLine;
private
  function GetExp:TOperator;
  procedure SetExp(aExp:TOperator);
  {function GetBlock:TPrgLine;
  procedure SetBlock(ablock:TPrgLine);}
  function GetCaseList:TEntity;
  procedure SetCaseList(aList:TEntity);
  function GetCaseItem(index:integer):TTypeElement;
  procedure SetCaseItem(index:integer;Item:TTypeElement);
  function GetBlockList:TEntity;
  procedure SetBlockList(aList:TEntity);
  function GetBlockItem(index:integer):TPrgLine;
  procedure SetBlockItem(index:integer;Item:TPrgLine);
  function GetElseBlock:TPrgLine;
  procedure SetElseBlock(aBlock:TPrgLine);
public
  procedure DoIt;override;
  property Expression:TOperator read GetExp write SetExp;
  {property Block:TPrgLine read GetBlock write SetBlock;}
  property CaseList:TEntity read GetCaseList write SetCaseList;
  property CaseItem[index:integer]:TTypeElement read GetCaseItem write SetCaseItem;
  property BlockList:TEntity read GetBlockList write SetBlockList;
  property BlockItem[index:integer]:TPrgLine read GetBlockItem write SetBlockItem;
  property ElseBlock:TPrgLine read GetElseBlock write SetElseBlock;
end;

TOilFunc=class(TOilProc)
private
 FFuncResult:TTypeElement;
 function GetFuncResult:TTypeElement;override;
 procedure DestroyVarsInStack;override;
public
 procedure DoIt;override;
end;

TCaller=class(TNoPtrOperator)
private
  FParams:TNameEntity;
  function GetParams:TNameEntity;
  procedure SetParams(aPar:TNameEntity);
public
 property Parameters:TNameEntity read GetParams write SetParams;
end;


TProcCaller=class(TCaller)
private
 FProc:TOilProc;
 function GetProc:TOilProc;virtual;
 procedure SetProc(aProc:TOilProc);virtual;
public
 property OilProc:TOilProc read GetProc write SetProc;
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;


implementation
uses
     Dialogs,
     Classes,
     U_Props,
     T_Errors,
     SysUtils,
     E_Class,
     TypInfo,
     worlds;

function AssignableTypes(t1,t2:TType):boolean;
 begin
 result:=t1=t2;
 if not result then
   case T1 of
    _Other:result:=true;
    _Float:result:=t2 in [_Integer,_Byte];
    _Integer:result:=t2=_Byte;
    _String:result:=t2=_Char;
    {_Byte:result:=t2=_Integer;}
    end;
 end;

{TPrgBlock}
procedure TPrgBlock.SetVariable(index:integer;aVar:TTypeElement);
{tady uz musi byt zkontrolovana kompatidebilita}
var El:TTypeElement;
 begin
  if Stack.Count>index then
  begin
  El:=TTypeElement(Stack.Elements[index]);
   case El.Typ of
    _Boolean:El.AsBoolean:=aVar.AsBoolean;
    _Char:El.AsChar:=aVar.AsChar;
    _Float:El.AsFloat:=aVar.AsFloat;
    _String:El.AsString:=aVar.AsString;
    _Integer:El.AsInteger:=aVar.AsInteger;
    _Pointer:El.AsPointer:=aVar.AsPointer
    else El.AsString:=aVar.AsString;
    end;{case}
  if aVar.OwnersCount=0 then
     aVar.Free;
  end
  else Stack.AddElement(aVar);
 end;

function TPrgBlock.GetVariable(index:integer):TTypeElement;
 begin
  result:=TTypeElement(Stack.Elements[index]);
 end;

procedure TPrgBlock.SetStack(aStack:TOwnerEntity);
 begin
  if assigned(FStack) then FreeElement(FStack);
  AddElement(aStack);
  FStack:=aStack;
 end;

function TPrgBlock.GetStack:TOwnerEntity;
 begin
 if not assigned(FStack) then
   begin
   FStack:=TOwnerEntity.create;
   FStack.name:='STACK'+name;
   AddElement(FStack);
   end;
  result:=FStack;
 end;


procedure TPrgBlock.SetPrgLineList(aList:TNameEntity);
   begin
   if assigned(FPrgLineList) then FreeElement(FPrgLineList);
   AddElement(aList);
   FPrgLineList:=aList;
   end;

function TPrgBlock.GetPrgLineList:TNameEntity;
   begin
   if not assigned(FPrgLineList) then
      begin
      FPrgLineList:=TNameEntity.create;
      AddELement(FPrgLineList);
      FPrgLineList.Name:='Program Lines';
      end;
   result:=FPrgLineList;
   end;

function TPrgBlock.GetPrgLine(index:longint):TPrgLine;
   begin
   result:=TPrgLine(PrgLineList.Elements[index]);
   end;

procedure TPrgBlock.SetPrgline(index:longint;aLine:TPrgLine);
   begin
   if PrgLineList.Count>index then
   begin
   PrgLineList.InsertElement(index,aLine);
   PrgLineList.FreeElement(PrgLineList.Elements[index+1]);
   end
   else PrgLineList.AddElement(aLine);
   end;

procedure TPrgBlock.AddPrgLine(aLine:TPrgLine);
   begin
   if aLine<>nil then
   	begin
   	PrgLineList.AddElement(aLine);
       end;
   end;


function TPrgBlock.GetVarInfoList:TNameEntity;
    begin
    if not assigned(FVarInfoList) then
       begin
       FVarInfoList:=TNameEntity.Create;
       FVarInfoList.Name:='VarInfo';
       AddElement(FVarInfoList);
       end;
    result:=FVarInfoList;
    end;

procedure TPrgBlock.SetVarInfoList(aList:TNameEntity);
    begin
    if assigned(FVarInfoList) then FreeElement(FVarInfoList);
    FVarInfoList:=aList;
    AddElement(FVarInfoList);
    end;


function TPrgBlock.GetVarType(index:byte):TType;
   begin
   result:=TVarinfo(VarInfoList.Elements[index]).VarType;
   end;

procedure TPrgBlock.SetVarType(index:byte;aType:TType);
   begin
   TVarinfo(VarInfoList.Elements[index]).VarType:=aType;
   end;

function TPrgBlock.GetVarName(index:byte):string;
   begin
   result:=TVarinfo(VarInfoList.Elements[index]).TypeName;
   end;

procedure TPrgBlock.SetVarName(index:byte;aName:string);
   begin
   TVarinfo(VarInfoList.Elements[index]).TypeName:=aName;
   end;


procedure TPrgBlock.CreateVarsInStack;
var i:integer;
    aVar:TPointerElement;
   begin
   StackIndex:=Stack.Count;
   if assigned(FVarInfoList) then if VarInfolist.Count>0 then
      for i:=0 to VarInfolist.Count-1 do
      begin
      case VarType[i] of
            _Boolean:Stack.AddElement(TBooleanElement.CreateValue(false));
            _Char:Stack.AddElement(TCharElement.CreateValue(#0));
            _Byte:Stack.AddElement(TByteElement.CreateValue(0));
            _Float:Stack.AddElement(TFloatElement.CreateValue(0));
            _String:Stack.AddElement(TStringElement.CreateValue(''));
            _Integer:Stack.AddElement(TIntegerElement.CreateValue(0));
            _Pointer:begin
                     aVar:=TPointerElement.Create;
                     aVar.aClassName:=varTypeName[i];
                     Stack.AddElement(aVar);
                     end;
      end;{case}
      end;
   end;

procedure TPrgBlock.DestroyVarsInStack;
var i:integer;
   begin
   if assigned(FVarInfoList) then if VarInfolist.Count>0 then
    for i:=1 to VarInfolist.Count do Stack.FreeElement(Variable[Stack.Count-1]);
   end;                                       {skoda, ze nejde dat primo index}


procedure TPrgBlock.DoIt;
var i:longint;
   begin
   CreateVarsInStack;
   if PrgLineList.Count>0 then
     for i:=0 to PrgLinelist.Count-1 do
      if PrgLine[i]<>nil then PrgLine[i].Doit;
   DestroyVarsInStack;
   end;



{TOilProc}
function TOilProc.GetFuncResult:TTypeElement;
	begin
  result:=nil;
  end;

procedure TOilProc.ReadParameters;
var i:integer;
    P:TParametr;
    E:TTypeElement;
	begin
  if Parameters<>nil then
  begin
  if Parameters.Count>0 then for i:=0 to Parameters.Count-1 do
     begin
     P:=TParametr(Parameters.Elements[i]);
     P.Expression.Doit;
     E:=TTypeElement(P.Expression.Output);
     if P.VarIndex>=Calls then
     	begin
     	if not AssignableTypes(VarType[P.varIndex],E.typ) then
        begin
        if E.OwnersCount=0 then E.free;
        raise TRunTimeError.CreateError(3);
        end;
       end;
     Variable[StackIndex+P.VarIndex]:=E;
     end;
  end;
  end;

procedure TOilProc.DoIt;
var i:longint;
	begin
  CreateVarsInStack;
  ReadParameters;
  if PrgLineList.Count>0 then
  for i:=0 to PrgLinelist.Count-1 do if PrgLine[i]<>nil then
  PrgLine[i].DoIt;
  DestroyVarsInStack;
  end;

{TProgram}
procedure TProgram.DoIt;
var i:longint;
    PE:TPointerElement;
begin
try
StackIndex:=0;
CreateVarsInStack;
PE:=TPointerElement.CreateValue(World);
PE.Name:='TELEMENT';
Variable[WorldIndex]:=PE;
PE:=TPointerElement.CreateValue(World.MainTool);
PE.Name:='TTOOL';
Variable[MToolIndex]:=PE;
PE:=TPointerElement.CreateValue(World);
PE.Name:='TELEMENT';
Variable[ActiveElIndex]:=PE;
{ulozit world,acctivelemment a maintool}
if PrgLineList.Count>0 then
   for i:=0 to PrgLinelist.Count-1 do
   if PrgLine[i]<>nil then
    PrgLine[i].DoIt;
DestroyVarsInStack;
 except
    on E:TRunTimeError do
     begin
     showmessage(E.Message);
     end;
 end;
end;

procedure TProgram.SetProcList(aList:TEntity);
 begin
  if assigned(FProcedureList) then FreeElement(FProcedureList);
  AddElement(aList);
  FProcedureList:=aList;
 end;

function TProgram.GetProcList:TEntity;
 begin
 if not assigned(FProcedureList) then
   begin
   FProcedureList:=TEntity.create;
   AddElement(FProcedureList);
   end;
  result:=FProcedureList;
 end;


{TVariable}
procedure TVariable.GetTypeInfo;
var i:TType;
    tmp:TType;
   begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   tmp:=Typ;
   if tmp=_other then For i:=_boolean to pred(_other) do TypeItem[i]:=true else
      TypeItem[tmp]:=true;
   end;


procedure TVariable.DoIt;
 begin
  Output:=Constant;
 end;

{Constantni VAR}
function TNormalVariable.GetConst:TTypeElement;
 begin
  result:=TTypeElement(Block.Variable[Block.StackIndex+VarIndex]);
 end;

function TNormalVariable.GetConstTyp:TType;
 begin
 result:=Block.VarType[Varindex]
 end;

function TNormalVariable.GetConstName:string;
 begin
 result:=Block.VarTypeName[Varindex];
 end;


procedure TNormalVariable.SetConst(aConst:TTypeElement);
{mozna by byla lepsi kontrola na vyssi urovni}
function Agrees:boolean;
         var p:TElement;
             CL:TClass;
         begin
         p:=TPointerElement(aConst).Value;
         if p=nil then result:=true
         else
         begin
         CL:=GetOrbisClass(TypeName);
         result:=p is CL;
         end
         end;

  begin
  if (aConst.Typ=_pointer) and (Block.Variable[Block.StackIndex+VarIndex].typ=_Pointer) then
    begin
    if Agrees then Block.Variable[Block.StackIndex+VarIndex]:=aConst
       else
        begin
        if aconst.OwnersCount=0 then aConst.free;
        raise TRunTimeError.CreateError(3);
        end;
    end
   else
    Block.Variable[Block.StackIndex+VarIndex]:=aConst;
  end;

{called VAR}
function TCalledVariable.GetConst:TTypeElement;
var El:TTypeElement;
 begin
  El:=Block.Variable[Block.StackIndex+VarIndex];
  result:=TVariable(TPointerElement(El).Value).Constant;
 end;

procedure TCalledVariable.SetConst(aConst:TTypeElement);
 begin
  TVariable(TPointerElement(Block.Variable[Block.StackIndex+VarIndex]).Value).Constant:=aConst;
 end;
{ tohle blbost
function TCalledVariable.GetConstTyp:TType;
var El:TTypeElement;
 begin
  El:=Block.Variable[Block.StackIndex+VarIndex];
  result:=TVariable(TPointerElement(El).Value).Typ;
 end;         }

{PropVAR}
function TPropVariable.GetInitialExp:TOperator;
 begin
  result:=FInitialExp;
 end;

procedure TPropVariable.SetInitialExp(aOp:TOperator);
 begin
  if assigned(FInitialExp) then FreeElement(FInitialExp);
  AddElement(aOp);
  FInitialExp:=aOp;
 end;

{odtud je potreba to predelat}
function TPropVariable.GetConstTyp:TType;
 begin
   result:=_Other;
 end;

function TPropVariable.GetConst:TTypeElement;
  var InitialValue:TTypeElement;
      OrbInst:TOrbisInstance;
      St:string;
      i:longint;
      f:Extended;
      P:pointer;
      PIndex:integer;
   begin
    result:=nil;
    InitialValue:=nil;
    OrbInst:=TOrbisInstance.Create;
    try
    InitialExp.Doit;
    InitialValue:=TTypeElement(InitialExp.Output);
    if not (InitialValue.Typ=_pointer) then raise TRunTimeError.CreateError(2);
    if InitialValue.AsPointer=nil then raise TRunTimeError.CreateError(2);
    if not (TObject(InitialValue.AsPointer) is TElement) then raise TRunTimeError.CreateError(4);
    OrbInst.Instance:=TElement(InitialValue.AsPointer);
    PIndex:=OrbInst.PropertyIndex(PropertyName);
    if PIndex<0 then raise TRunTimeError.CreateError(5);
    case OrbInst.PropertyTypeKind[PIndex] of
        {_Boolean,_Char,_Byte,_Float,_String,_Integer,_Pointer}
        tkString
       {$IFDEF Win32}
       ,tkLString,tkWString
       {$ENDIF}
                         :begin
                          OrbInst.GetPropertyValue(Pindex,St);
                          result:=TStringElement.CreateValue(St);
                          end;
       tkInteger:
                          begin
                          OrbInst.GetPropertyValue(Pindex,i);
                          result:=TIntegerElement.CreateValue(i);
                          end;
       tkChar
       {$IFDEF Win32}
       ,tkWChar
       {$ENDIF}:
                          begin
                          OrbInst.GetPropertyValue(Pindex,i);
                          result:=TCharElement.Create;
                          TCharElement(result).AsInteger:=i;
                          end;
       tkFloat:
                          begin
                          OrbInst.GetPropertyValue(Pindex,f);
                          result:=TFloatElement.CreateValue(f);
                          end;
       tkClass:
                          begin
                          OrbInst.GetPropertyValue(Pindex,p);
                          result:=TPointerElement.CreateValue(p);
                          end;
       tkEnumeration:
                         begin
                         St:=GetPropString(Initialvalue.AsPointer,PIndex);
                         AnsiUpperCase(St);
                         if St='TRUE' then result:=TBooleanElement.createvalue(true)
                         else
                         if St='FALSE' then result:=TBooleanElement.createvalue(false)
                         else raise TRunTimeError.CreateError(15);
                         end;
       else raise TRunTimeError.CreateError(15);
       end;{case}
    finally
    OrbInst.Free;
    if InitialValue<>nil then if InitialValue.OwnersCount=0 then  InitialValue.free;
    end;
  end;



procedure TPropVariable.SetConst(aConst:TTypeElement);
var Initialvalue:TTypeElement;
    OrbInst:TOrbisInstance;
    St:string;
     i:longint;
     f:Extended;
     P:pointer;
     c:char;
     b:boolean;
     PIndex:integer;
begin
  InitialValue:=nil;
  OrbInst:=TOrbisInstance.Create;
  try
    InitialExp.DoIt;
    InitialValue:=TTypeElement(InitialExp.Output);
    if not (InitialValue.Typ=_pointer) then raise TRunTimeError.CreateError(2);
    if InitialValue.AsPointer=nil then raise TRunTimeError.CreateError(2);
    if not (TObject(InitialValue.AsPointer) is TElement) then raise TRunTimeError.CreateError(4);
    OrbInst.Instance:=TElement(InitialValue.AsPointer);
    PIndex:=OrbInst.PropertyIndex(PropertyName);
    if PIndex<0 then raise TRunTimeError.CreateError(5);
    case OrbInst.PropertyTypeKind[PIndex] of
     {_Boolean,_Char,_Byte,_Float,_String,_Integer,_Pointer}
        tkString
       {$IFDEF Win32}
       ,tkLString,tkWString
       {$ENDIF}
                         :begin
                          if not (aConst.Typ in [_Char,_String]) then raise TRunTimeError.CreateError(3);
                          St:=aConst.AsString; {neni toprilis pomale}
                          OrbInst.SetPropertyValue(Pindex,St);
                          end;
       tkInteger:
                          begin
                          if not (aConst.Typ in [_Byte,_Integer]) then raise TRunTimeError.CreateError(3);
                          i:=aConst.AsInteger;
                          OrbInst.SetPropertyValue(Pindex,i);
                          end;
       tkChar
       {$IFDEF Win32}
       ,tkWChar
       {$ENDIF}:
                          begin
                          if not (aConst.Typ =_Char) then raise TRunTimeError.CreateError(3);
                          c:=aConst.AsChar;
                          OrbInst.SetPropertyValue(Pindex,c);
                          end;
       tkFloat:
                          begin
                          if not (aConst.Typ in [_Byte,_Integer,_Float]) then raise TRunTimeError.CreateError(3);
                          f:=aConst.AsFloat;
                          OrbInst.SetPropertyValue(Pindex,f);
                          end;
       tkClass:
                          begin
                          if not (aConst.Typ =_Pointer) then raise TRunTimeError.CreateError(3);
                          p:=aConst.AsPointer;
                          OrbInst.SetPropertyValue(Pindex,p);
                          end;
       tkEnumeration:
                         begin
                         if not (aConst.Typ =_Boolean) then raise TRunTimeError.CreateError(3);
                         b:=aConst.AsBoolean;
                         OrbInst.SetPropertyValue(Pindex,b);
                         end;
       else raise TRunTimeError.CreateError(15);
       end;{case}
 finally
 OrbInst.Free;
 if aConst.OwnersCount=0 then aConst.free;
 if InitialValue<>nil then if InitialValue.OwnersCount=0 then InitialValue.free;
 end;
end;

{TElementOperator}
procedure TElementOperator.GetTypeInfo;
var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_pointer]:=true;
  end;

procedure TElementOperator.DoIt;
var tmp:TElement;
	begin
  Output:=nil;
  try
  ReadFirstResult;
  if not (FirstResult.Typ=_pointer) then raise TRunTimeError.CreateError(2);;
  if FirstResult.AsPointer=nil then raise TRunTimeError.CreateError(2);;
  if not (TObject(FirstResult.AsPointer) is TEntity) then raise TRunTimeError.CreateError(14);
  tmp:=TEntity(FirstResult.AsPointer).FindElementName(Elementname);
  Output:=TPointerElement.CreateValue(tmp);
  finally
  ClearResults;
  end;
  end;

{TOwnerOperator}
procedure TOwnerOperator.DoIt;
var tmp:TElement;
	begin
  Output:=nil;
  try
  ReadFirstResult;
  if not (FirstResult.Typ=_pointer) then raise TRunTimeError.CreateError(2);;
  if FirstResult.AsPointer=nil then raise TRunTimeError.CreateError(2);;
  if TObject(FirstResult.AsPointer) is TOwnerElement then
     tmp:=TOwnerElement(FirstResult.AsPointer).FindOwnerName(Elementname)
     else  if TObject(FirstResult.AsPointer) is TOwnerEntity then
     tmp:=TOwnerEntity(FirstResult.AsPointer).FindOwnerName(Elementname)
     else raise TRunTimeError.CreateError(14);
  Output:=TPointerElement.CreateValue(tmp);
  finally
  ClearResults;
  end;
  end;

(*
TToolInputInfo=class(TEntity)
 private
  FPropIndex:longint;
  FInputExpr:TOperator;
  function GetInputExpr:TOperator;
  procedure SetInputExpr(aExp:TOperator);
 public
  property InputExpr:TOperator read GetInputExpr write SetInputExpr;
 published
  property PropIndex:longint read FPropIndex write FPropIndex;
end;

TToolOperator=class(TOnePtrOperator)
 private
  FToolClass:TToolClass;
  FMainInput:TOperator;
  FPropInputList:TEntity;
  function GetPropInputList:TEntity;
  procedure SetPropInputList(aList:TEntity);
  function GetInputItem(index:longint):TToolInputinfo;virtual;
  function GetMainInput:TOperator;virtual;
  procedure SetMainInput(aInput:TOperator);virtual;
 public
  property PropInputList:TEntity read GetPropInputList write SetPropInputList;
  property PropInputItem[index:longint]:TToolInputInfo read GetInputItem;
  property MainInput:TOperator read getMainInput write SetMainInput;
  property ToolClass:TToolClass read FToolClass write FToolClass;
  procedure DoIt;override;
  procedure GetTypeInfo;override;
 end;


*)

{TToolInputInfo}
function TToolInputInfo.GetInputExpr:TOperator;
   begin
   result:=FInputExpr;
   end;

procedure TToolInputInfo.SetInputExpr(aExp:TOperator);
   begin
   if assigned(FInputExpr) then FreeElement(FInputExpr);
   AddElement(aExp);
   FInputExpr:=aExp;
   end;

{TToolOperator}
function TToolOperator.GetPropInputList:TEntity;
    begin
    if not assigned(FPropInputList) then
       begin
       FPropInputList:=TEntity.Create;
       AddElement(FPropInputList);
       end;
    result:=FPropInputList;
    end;

procedure TToolOperator.SetPropInputList(aList:TEntity);
    begin
    if assigned(FPropInputList) then FreeElement(FPropInputList);
    FPropInputList:=aList;
    AddElement(FPropInputList);
    end;

function TToolOperator.GetInputItem(index:longint):TToolInputInfo;
   begin
   result:=TToolInputInfo(PropInputList.Elements[index]);
   end;


procedure TToolOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_pointer]:=true;
  end;

procedure TToolOperator.DoIt;
var
aRes:TTypeElement;
aInp:TElement;
theTool:TTool;
aInstance:TOrbisInstance;
PIndex,i,int:longint;
bool:boolean;
st:string;
ptr:pointer;
chr:char;
fl:extended;

  function CompatibleTypes(a:TTypeKind;b:TType):boolean;
      {cunarna, ale jinak to asi nejde}
      begin
      case a of
      tkInteger,tkInt64:result:=b in [_integer,_byte];
      tkChar,tkWChar:result:=b in [_char];
      tkEnumeration:result:=b in [_boolean];
      tkFloat:result:=b in [_integer,_byte,_float];
      tkString,tkLString,tkWString:result:=b in [_char,_string];
      tkClass, tkMethod:result:=b in [_pointer,_other];
      else result:=false;
      end;
      end;


  begin
  aInstance:=nil;
  theTool:=nil;
  try
  aInp:=nil;
  ReadFirstResult;
  aRes:=FirstResult;
  if assigned(ares) then
  	begin {pokud je vstup, tak musi byt spravny}
 	     if aRes.typ=_pointer then aInp:=aRes.AsPointer
    	   else raise TRunTimeError.CreateError(8);
   	end;
  if Toolclass=nil then raise TRunTimeError.CreateError(9);
  theTool:=ToolClass.Create;
  theTool.Input:=aInp;
  aInstance:=TOrbisInstance.Create;
  aInstance.Instance:=theTool;
  if PropInputList.Count>0 then
      begin
      for i:=0 to PropInputList.Count-1 do
      begin {naplneni propert}
      pindex:=PropInputItem[i].PropIndex-1;
      PropInputItem[i].InputExpr.DoIt;
      aRes:=TTypeElement(PropInputItem[i].InputExpr.Output);
      if CompatibleTypes(aInstance.PropertyTypeKind[PIndex],aRes.Typ)then
         begin
          case  aRes.Typ of
             _Integer:
                 begin
                 int:=aRes.AsInteger;
                 aInstance.SetPropertyValue(PIndex,int);
                 end;
             _Char:
                 begin
                 chr:=aRes.AsChar;
                 aInstance.SetPropertyValue(PIndex,chr);
                 end;
             _Boolean:
                 begin
                 bool:=aRes.AsBoolean;
                 aInstance.SetPropertyValue(PIndex,bool);
                 end;
             _Float:
                 begin
                 fl:=aRes.AsFloat;
                 aInstance.SetPropertyValue(PIndex,fl);
                 end;
             _String:
                 begin
                 st:=aRes.AsString;
                 aInstance.SetPropertyValue(PIndex,st);
                 end;
             _Pointer:
                 begin
                 ptr:=aRes.AsPointer;
                 aInstance.SetPropertyValue(PIndex,ptr);
                 end;
             end{case}
         end
        else
         raise TRunTimeError.CreateError(3);
         {typova nekompatibilita s propertou aInstance.PropertyTypename[PIndex];}
      end;
      end;
  theTool.DoIt;
  Output:=TPointerElement.CreateValue(theTool.Output);
  finally
  ClearResults;
  if aInstance<>nil then aInstance.Free;
  if theTool<>nil then theTool.Free;
  end;
  end;

{TExpressionline}
function TExprLine.GetOperator:TOperator;
 begin
  result:=FOperator;
 end;

procedure TExprLine.SetOperator(aOp:TOperator);
 begin
 if assigned(FOperator) then FreeElement(FOperator);
  AddElement(aOp);
  FOperator:=aOp;
 end;

procedure TExprLine.DoIt;
begin
  Operator.DoIt;
  {Ulozit vysledek do...StringListu}
  Operator.CleanData;
end;

{IF}
function TIfLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TIfLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

function TIfLine.GetThenBlock:TPrgLine;
 begin
  result:=FThenBlock;
 end;

procedure TIfLine.SetThenBlock(aBlock:TPrgLine);
 begin
  if assigned(FThenBlock) then FreeElement(FThenBlock);
  AddElement(aBlock);
  FThenBlock:=aBlock;
 end;

function TIfLine.GetElseBlock:TPrgLine;
 begin
  result:=FElseBlock;
 end;

procedure TIfLine.SetElseBlock(aBlock:TPrgLine);
 begin
  if assigned(FElseBlock) then FreeElement(FElseBlock);
  AddElement(aBlock);
  FElseBlock:=aBlock;
 end;

procedure TIfLine.DoIt;
var TmpRes:TTypeElement;
 begin
  try
  Expression.DoIt;
  TmpRes:=TTypeElement(Expression.Output);
  if (TmpRes=nil) then raise TRunTimeError.CreateError(2);
  if(TmpRes.Typ<>_boolean) then raise TRunTimeError.CreateError(10);
  if TBooleanElement(TmpRes).Value then ThenBlock.DoIt
     else if ElseBlock<>nil then ElseBlock.DoIt;
  finally
  Expression.CleanData;
  end;
 end;

{FOR}
function TForLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TForLine.SetBlock(aBlock:TPrgLine);
 begin
  if assigned(FBlock) then FreeElement(FBlock);
  AddElement(aBlock);
  FBlock:=aBlock;
 end;

function TForLine.GetVar:TNormalVariable;
 begin
  result:=FVariable;
 end;

procedure TForLine.SetVar(aVar:TNormalVariable);
 begin
 if assigned(FVariable) then FreeElement(FVariable);
  AddElement(aVar);
  FVariable:=aVar;
 end;

function TForLine.GetStart:TOperator;
 begin
  result:=FStart;
 end;

procedure TForLine.SetStart(aVar:TOperator);
 begin
 if assigned(FStart) then FreeElement(FStart);
  AddElement(aVar);
  FStart:=aVar;
 end;

function TForLine.GetEnd:TOperator;
 begin
  result:=FEnd;
 end;

procedure TForLine.SetEnd(aVar:TOperator);
 begin
 if assigned(FEnd) then FreeElement(FEnd);
  AddElement(aVar);
  FEnd:=aVar;
 end;

(* V teto versi se pokazde znovu inicializuje konecna hodnota
procedure TForLine.DoIt;
var TmpRes:TTypeElement;
    First:boolean;

 function GetOut:boolean;
    var tmp:TTypeElement;
    begin
    EndValue.DoIt;
    Tmp:=TTypeElement(EndValue.Output);
    if (Variable.Typ=_char) then
      begin
      if not (Tmp.Typ=_char) then
         begin
         EndValue.CleanData;
         raise TRunTimeError.CreateError(3);
         end;
      end
      else if not((Tmp.Typ=_byte) or (Tmp.Typ=_integer)) then raise TRunTimeError.CreateError(3);
    result:=Variable.Constant.AsInteger=Tmp.AsInteger;
    EndValue.CleanData;
    end;

 begin
  try
  if not(Variable.Typ in [_integer,_char,_byte]) then raise TRunTimeError.CreateError(2);
  StartValue.Doit;
  TmpRes:=TTypeElement(StartValue.Output);
  if (Variable.Typ=_char) then
      begin
      if not (Tmpres.Typ=_char) then
         raise TRunTimeError.CreateError(3);
      end
  else if not((TmpRes.Typ=_byte) or (Tmpres.Typ=_integer)) then raise TRunTimeError.CreateError(3);

  Variable.Constant:=TmpRes;
  First:=true;
  repeat
  if not First then
      if Increase then Variable.Constant.AsInteger:=Variable.Constant.AsInteger+1
      else Variable.Constant.AsInteger:=Variable.Constant.AsInteger-1;
  Block.DoIt;
  First:=false;
  until GetOut;
  finally
  StartValue.CleanData;
  end;
 end;
*)

procedure TForLine.DoIt;
var TmpVal:TTypeElement;
    tp:TType;
    cVal,EVal,i:longint;
 begin
  try
  if not(Variable.Typ in [_integer,_char,_byte]) then raise TRunTimeError.CreateError(2);
  StartValue.Doit;
  TmpVal:=TTypeElement(StartValue.Output);
  tp:=TmpVal.Typ;
  if (Variable.Typ=_char) then
      begin
      if not (Tp=_char) then
         raise TRunTimeError.CreateError(3);
      end
  else if not(Tp in[_byte,_integer]) then raise TRunTimeError.CreateError(3);
  Variable.Constant:=TmpVal;
  CVal:=TmpVal.AsInteger;
  EndValue.DoIt;
  TmpVal:=TTypeElement(EndValue.Output);
  tp:=TmpVal.Typ;
  if (Variable.Typ=_char) then
      begin
      if not (Tp=_char) then
         raise TRunTimeError.CreateError(3);
      end
  else if not(Tp in[_byte,_integer]) then raise TRunTimeError.CreateError(3);
  Eval:=TmpVal.AsInteger;
  if Increase then
      begin
      for i:=CVal to EVal do
      begin
      Variable.Constant.AsInteger:=i;{tohle prirazeni by mohlo jit zrychlit}
      Block.DoIt;
      end;
      end
      else
      for i:=CVal downto EVal do
      begin
      Variable.Constant.AsInteger:=i;
      Block.DoIt;
      end;
  finally
  EndValue.CleanData;
  StartValue.CleanData;
  end;
 end;


{WHILE}
function TWhileLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TWhileLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

 function TWhileLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TWhileLine.SetBlock(aBlock:TPrgLine);
 begin
  if assigned(FBlock) then FreeElement(FBlock);
  AddElement(aBlock);
  FBlock:=aBlock;
 end;

procedure TWhileLine.DoIt;
var TmpRes:TTypeElement;
 begin
  try
  Expression.DoIt;
  TmpRes:=TTypeElement(Expression.Output);
  if (TmpRes=nil) then raise TRunTimeError.CreateError(2);
  if (TmpRes.Typ<>_boolean) then raise TRunTimeError.CreateError(10);
  while (TmpRes as TBooleanElement).value do
    begin
    Expression.CleanData;
    Block.Doit;
    Expression.DoIt;
    TmpRes:=TTypeElement(Expression.Output);
    if (TmpRes=nil) then raise TRunTimeError.CreateError(2);
    if (TmpRes.Typ<>_boolean) then raise TRunTimeError.CreateError(10);
    end;
  finally
  Expression.CleanData;
  end;
 end;

{REPEAT}
function TRepeatLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TRepeatLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;


procedure TRepeatLine.DoIt;
var TmpRes:TTypeElement;
    NotFirst:boolean;
    i:longint;
 begin
  try
   NotFirst:=false;
   repeat
    if NotFirst then Expression.CleanData;
    NotFirst:=true;
    if PrgLineList.Count>0 then
       for i:=0 to PrgLinelist.Count-1 do if PrgLine[i]<>nil then PrgLine[i].Doit;
    Expression.DoIt;
    TmpRes:=TTypeElement(Expression.Output);
    if (TmpRes=nil) then raise TRunTimeError.CreateError(2);
    if (TmpRes.Typ<>_boolean) then raise TRunTimeError.CreateError(10);
   until TBooleanElement(Tmpres).value;
  finally
  Expression.CleanData;
  end;
 end;

{CASE}
 {function TCaseLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TCaseLine.SetBlock(aBlock:TPrgLine);
 begin
 if assigned(FBlock) then FreeElement(FBlock);
 AddElement(aBlock);
 FBlock:=aBlock;
 end;
  }
function TCaseLine.GetExp:TOperator;
 begin
 result:=FExpression;
 end;

procedure TCaseLine.SetExp(aExp:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
 AddElement(aExp);
 FExpression:=aExp;
 end;

procedure TCaseLine.SetCaseList(aList:TEntity);
 begin
 if assigned(FCaseList) then FreeElement(FCaseList);
 AddElement(aList);
 FCaseList:=aList;
 end;

function TCaseLine.GetCaseList:TEntity;
 begin
 if not assigned(FCaseList) then
   begin
   FCaseList:=TEntity.create;
   AddElement(FCaseList);
   end;
 result:=FCaseList;
 end;

procedure TCaseLine.SetCaseItem(index:integer;Item:TTypeElement);
 begin
 if CaseList.Count>index then
  begin
  CaseList.InsertElement(index,Item);
  CaseList.FreeElement(CaseList.Elements[index+1]);
  end
  else
  CaseList.AddElement(Item);
 end;

function TCaseLine.GetcaseItem(index:integer):TTypeElement;
 begin
 result:=TTypeElement(CaseList.Elements[index]);
 end;

procedure TCaseLine.SetBlockList(aList:TEntity);
 begin
 if assigned(FBlockList) then FreeElement(FBlockList);
 AddElement(aList);
 FBlockList:=aList;
 end;

function TCaseLine.GetBlockList:TEntity;
 begin
  if not assigned(FBlockList) then
   begin
   FBlockList:=TEntity.create;
   AddElement(FBlockList);
   end;
 result:=FBlockList;
 end;

procedure TCaseLine.SetBlockItem(index:integer;Item:TPrgLine);
 begin
 if BlockList.Count>index then
  begin
  BlockList.InsertElement(index,Item);
  BlockList.FreeElement(BlockList.Elements[index+1]);
  end
  else BlockList.AddElement(Item);
 end;

function TCaseLine.GetBlockItem(index:integer):TPrgLine;
 begin
 result:=TPrgLine(BlockList.Elements[index]);
 end;

function TCaseLine.GetElseBlock:TPrgLine;
 begin
  result:=FElseBlock;
 end;

procedure TCaseLine.SetElseBlock(aBlock:TPrgLine);
 begin
  if assigned(FElseBlock) then FreeElement(FElseBlock);
  AddElement(aBlock);
  FElseBlock:=aBlock;
 end;

procedure TCaseline.DoIt;
var i:longint;
    GoOn:boolean;
    TmpObj:TTypeElement;
    Res:TTypeElement;
    CanCompare,Equal:boolean;
 begin
 i:=0;
 GoOn:=true;
 try
 Expression.Doit;
 Res:=TTypeElement(Expression.Output);
 if Res.Typ in [_byte,_char,_integer,_float,_string,_boolean] then
 begin
 while (i < CaseList.Count)and GoOn do
  begin
  TmpObj:=CaseItem[i];
  case TmpObj.typ of
       _boolean:CanCompare:=Res.Typ=_boolean;
       _char,_string:CanCompare:=Res.Typ in [_char,_string];
       _integer,_float:CanCompare:=Res.Typ in [_integer,_float];
       else CanCompare:=false;
       end;
  if CanCompare then
     begin
     Equal:=false;
     case TmpObj.typ of
       _boolean:Equal:=Res.Asboolean=TmpObj.AsBoolean;
       _char,_string:Equal:=Res.AsString=TmpObj.AsString;
       _integer,_float:Equal:=Res.AsFloat=TmpObj.AsFloat;
       end;
     if Equal then if BlockItem[i]<>nil then
          begin
          BlockItem[i].DoIt;
          GoOn:=false;
         end
         else raise TRunTimeError.CreateError(12);
     end;
  inc(i);
  end;
  if GoOn then if ElseBlock<>nil then ElseBlock.DoIt;
  end else raise TRunTimeError.CreateError(13);
  finally
  Expression.Cleandata;
  end;
 end;

{TCaller}
function TCaller.GetParams:TNameEntity;
   begin
   if not assigned(FParams) then
      begin
      FParams:=TNameEntity.create;
      AddElement(FParams);
      FParams.name:='Parametry';
      end;
   result:=FParams;
   end;

procedure TCaller.SetParams(aPar:TNameEntity);
   begin
   if assigned(FParams) then FreeElement(FParams);
   AddElement(aPar);
   FParams:=aPar;
   end;

{TProcCaller}
function TProcCaller.GetProc:TOilProc;
   begin
   result:=FProc;
   end;

procedure TProcCaller.SetProc(aProc:TOilProc);
   begin
   if assigned(FProc) then FreeElement(FProc);
   AddElement(aProc);
   FProc:=aProc;
   end;


procedure TProcCaller.DoIt;
   begin
   Output:=nil;
   OilProc.parameters:=Parameters;
   OilProc.Doit;
   Output:=OilProc.FuncResult;
   end;

procedure  TProcCaller.GetTypeInfo;
var i:TType;
	begin
  new(FTypeList);
  For i:=_boolean to _other do TypeItem[i]:=false;
  if OilProc is TOilFunc then
		TypeItem[OilProc.VarType[OilProc.Calls]]:=true;
  end;

{TParametr}
function TParametr.GetExp:TOperator;
 begin
 result:=FExp;
 end;

procedure TParametr.SetExp(aExp:TOperator);
 begin
 if FExp<>nil then FreeElement(FExp);
 AddElement(aExp);
 FExp:=aExp;
 end;


{TOilFunc}
function TOilFunc.GetFuncResult:TTypeElement;
 begin
 result:=FFuncResult;
 end;

procedure TOilFunc.DestroyVarsInStack;
var i:integer;
   begin
   if assigned(FVarInfoList) then if VarInfolist.Count>0 then
   	begin
       if VarInfoList.Count>(Calls+1) then
       	for i:=1 to VarInfoList.Count-Calls-1 do Stack.FreeElement(Variable[Stack.Count-1]);
       Stack.RemoveElement(Variable[Stack.Count-1]);
   	if Calls>0 then for i:=1 to Calls do Stack.FreeElement(Variable[Stack.Count-1]);
   	end;
   end;


procedure TOilFunc.DoIt;
var i:longint;
	begin
  CreateVarsInStack;
  ReadParameters;
  if PrgLineList.Count>0 then
  for i:=0 to PrgLinelist.Count-1 do
    if PrgLine[i]<>nil then PrgLine[i].DoIt;
  FFuncResult:=Variable[StackIndex+Calls];
  DestroyVarsInStack;
  end;

{TProtectBlock}
procedure TProtectBlock.DoIt;
var i:longint;
   begin
   try
   if PrgLineList.Count>0 then
     for i:=0 to PrgLinelist.Count-1 do if PrgLine[i]<>nil then PrgLine[i].Doit;
   except
     on E:TRunTimeError do;
   end;
   end;


{SetLine}
function TAssignLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TAssignLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

function TAssignLine.GetLeftVar:TVariable;
 begin
  result:=FLeftVar;
 end;

procedure TAssignLine.SetLeftVar(aExpr:TVariable);
 begin
  if assigned(FLeftVar) then FreeElement(FLeftVar);
  FLeftVar:=aExpr;
  AddElement(FLeftVar);
 end;

procedure TAssignLine.DoIt;
var TmpRes:TTypeElement;
begin
 Tmpres:=nil;
 try
 Expression.DoIt;
 TmpRes:=TTypeElement(Expression.Output);
 if (TmpRes=nil) then raise TRunTimeError.CreateError(1);
 if (Leftvar=nil) then raise TRunTimeError.CreateError(2);
 if AssignableTypes(LeftVar.typ,TmpRes.typ) then LeftVar.Constant:=TmpRes
    else
    begin
    raise TRunTimeError.CreateError(3);
    end;
 except
 if tmpRes<>nil then TmpRes.Free;
 end;
end;


end.

