unit T_Debug;
interface
uses Elements,
     tools,
     E_Type,
     language;

type
TBreakpointManager=class(TTechnology)
 {Na Input prijde TDBProgram}
private
 FNumbers:TIntegerListElement;
 procedure SetNumbers(aNums:TIntegerListElement);virtual;
 function  GetNumbers:TIntegerListElement;virtual;
 procedure SetNextNum(aNum:integer);virtual;
 function  GetNumberCount:integer;virtual;
 function  GetLineNum(index:integer):integer;virtual;
 procedure SetLineNumber(index:integer;anum:integer);virtual;
 procedure SetInput(aInput:TElement);override;
protected
 function  FindLine(LIneNum:integer):TOilLine;
public
 function  IsInList(num:integer):boolean;virtual;
 procedure DeleteLineNUmber(aNum:integer);virtual;
 property  NextLineNumber:integer write SetNextNum;{prida cislo}
 property  Numberlist:TIntegerListElement read GetNumbers write SetNumbers;
 property  LineNumber[index:integer]:integer read GetLineNum write SetLineNumber;
 {^^^^^vrati cislo radky pro braekpoint}
 procedure DoIt;override;{dodosadi Breakpointy}
 function IsValidBreakPoint(index:integer):boolean;virtual;{index - cislo v seznamu}
 {^^^^az po zavolani doit}
 procedure AddBreakPoint(aLineNum:integer);virtual;
 procedure DeleteBreakPoint(aLineNum:integer);virtual;
 {^^^^az po zavolani doit}
published
 property Numbers:integer read GetNumberCount;
end;

TWatchManager=class(TTechnology)
{na outputu da OwnerEntitu s TypeElementy}
private
 FWatches:TStringListElement;
 procedure SetWatches(aWatch:TStringListElement);virtual;
 function GetWatches:TStringListElement;virtual;
 procedure SetInput(aInput:TElement);override;
public
 function GetVarValue(VarName:string):TTypeElement;virtual;
 property Watches:TStringListElement read GetWatches write SetWatches;
 procedure DoIt;override;
end;

implementation
uses
    SysUtils,
    U_string;

procedure TBreakpointManager.SetNumbers(aNums:TIntegerListElement);
    begin
    if assigned(FNumbers)then FreeElement(FNumbers);
    AddElement(FNumbers);
    FNumbers:=aNums;
    if FNumbers<>nil then
      begin
      FNumbers.Duplicates:=false;
      FNumbers.Sorted:=true;
      end;
    end;


function TBreakpointManager.GetNumbers:TIntegerListElement;
    begin
    if not assigned(FNumbers)then
       begin
       FNumbers:=TIntegerListElement.Create;
       FNumbers.Duplicates:=false;
       FNumbers.Sorted:=true;
       Addelement(FNumbers);
       end;
    result:=FNumbers;
    end;

procedure TBreakpointManager.SetNextNum(aNum:integer);
    begin
    if not NumberList.ValueExists(anum) then NumberList.Addinteger(aNum);
    end;

function TBreakpointManager.IsInList(num:integer):boolean;
    begin
    result:=NumberList.ValueExists(num);
    end;

function TBreakpointManager.GetNumberCount:integer;
    begin
    result:=NumberList.Count;
    end;

procedure TBreakpointManager.SetLineNumber(index:integer;anum:integer);
    begin
    Numberlist.Integers[index]:=aNum;
    end;

function  TBreakpointManager.GetLineNum(index:integer):integer;
    begin
    result:=Numberlist.Integers[index];
    end;

procedure TBreakpointManager.DeleteLineNUmber(aNum:integer);
   var
    i: longInt;
   begin
   for i := 0 to Numbers do
      begin
      if aNum =  NumberList.Integers[i] then
         begin
          NumberList.FreeElement( NumberList.Elements[i]);
         exit;
         end;
      end;
   end;


procedure TBreakpointManager.AddBreakPoint(aLineNum:integer);
var aLine:TOilline;
    Bp:TOilBreakPoint;
   begin
   aLine:=FindLine(aLIneNum);
   if (aLine<>nil) and(not(aLine is TOilProgram)) then
      begin
      if aLine.BreakPoint<>nil then
         begin
         Bp:=aLine.BreakPoint;
         TDBOilProgram(Input).BreakPointList.FreeElement(Bp);
         aLine.BreakPoint:=nil;
         end;
      Bp:=TOilBreakPoint.Create;
      Bp.Linenum:=aLineNum;
      Bp.Line:=aLine;
      Bp.OilProgram:=TOilProgram(Input);
      aLine.BreakPoint:=Bp;
      TDBOilProgram(Input).BreakPointList.AddElement(Bp);
      end;
   end;

procedure TBreakpointManager.DeleteBreakPoint(aLineNum:integer);
var aLine:TOilline;
    Bp:TOilBreakPoint;
   begin
   aLine:=FindLine(aLIneNum);
   if aLine<>nil then
      if aLine.BreakPoint<>nil then
         begin
         Bp:=aLine.BreakPoint;
         TDBOilProgram(Input).BreakPointList.FreeElement(Bp);
         aLine.BreakPoint:=nil;
         end;
   end;

procedure TBreakpointManager.SetInput(aInput:TElement);
   begin
   FInput:=aInput;
   if FInput<>nil then if not(FInput is TDBOilProgram) then
      FInput:=nil;
   end;

function TBreakpointManager.FindLine(LIneNum:integer):TOilLine;
function GetTheLine(Line:ToilLine):TOilLine;
   var i:integer;
   begin
   if line=nil then result:=nil
   else
   if line.SourceLineNum=linenum then result:=Line
     else
     begin {hledam hloubeji}
     result:=nil;
     if Line is TOilProc then
        begin
        i:=0;
        while (result=nil) and (i<TOilProc(Line).SubProcs.Count) do
              begin
              result:=GetTheLine(TOilProc(TOilProc(line).SubProcs.elements[i]));
              inc(i);
              end;
        i:=0;
        if result=nil then
        while (result=nil) and (i<TOilProc(Line).PrgLineList.Count) do
              begin
              result:=GetTheLine(TOilProc(Line).PrgLine[i]);
              inc(i);
              end;
        end
     else if Line is TOilblock then  {RepeatLine a ostani bloky}
         begin
         i:=0;
         while (result=nil) and (i<TOilProc(Line).PrgLineList.Count) do
              begin
              result:=GetTheLine(TOilProc(Line).PrgLine[i]);
              inc(i);
              end;
         end
     else if Line is TForLine then result:=GetTheLine(TForLine(Line).Block)
     else if Line is TWhileLine then result:=GetTheLine(TWhileLine(Line).Block)
     else if Line is TIfLine then
          begin
          result:=GetTheLine(TIfLine(Line).ThenBlock);
          if result<>nil then result:=GetTheLine(TIfLine(Line).ElseBlock)
          end
     else if Line is TCaseLine then
         begin
         i:=0;
         while (result=nil) and (i<TCaseLine(Line).BlockList.Count) do
              begin
              result:=GetTheLine(TCaseLine(Line).BlockItem[i]);
              inc(i);
              end;
         if result<>nil then result:=GetTheLine(TCaseLine(Line).ElseBlock)
         end;
     end;{hledam hloubeji}
   end;
   {FindLine}
   begin
   result:=nil;
   if Input<>nil then
     begin
     result:=GetTheLine(TDBOilProgram(Input));
     end;
   end;

procedure TBreakpointManager.DoIt;
var i:integer;
    l:ToilLine;
    b:TOilBreakpoint;
   begin
   if Input<>nil then
     begin
     while TDBoilProgram(input).BreakPoints>0 do
        begin
         b:=TDBoilProgram(input).BreakPoint[TDBoilProgram(input).BreakPoints-1];
         l:=b.Line;
         TDBOilProgram(Input).BreakPointList.FreeElement(B);
         L.BreakPoint:=nil;
        end;
     if Numbers>0 then
        for i:=0 to Numbers-1 do AddBreakpoint(LineNumber[i]);
     end;
   end;

function TBreakpointManager.IsValidBreakPoint(index:integer):boolean;
var i,Lnum:integer;
   begin
   result:=false;
   if (Input<>nil)and (index<=Numbers) then
    begin
    i:=0;
    Lnum:=LineNumber[index];
    while (not result) and (i<TDBoilProgram(input).BreakPoints) do
       begin
       result:=TDBoilProgram(input).BreakPoint[i].LineNum=Lnum;
       inc(i);
       end;
    end;
   end;

{TWatchManager}
procedure TWatchManager.SetInput(aInput:TElement);
   begin
   FInput:=aInput;
   if FInput<>nil then if not(FInput is TDBOilProgram) then
      FInput:=nil;
   end;

procedure TWatchManager.SetWatches(aWatch:TStringListElement);
   begin
   if assigned(FWatches) then FreeElement(FWatches);
   FWatches:=aWatch;
   AddElement(FWatches);
   end;

function TWatchManager.GetWatches:TStringListElement;
   begin
   if not assigned(FWatches) then
      begin
      FWatches:=TStringListElement.Create;
      AddElement(FWatches);
      end;
   result:=FWatches;
   end;

procedure TWatchManager.DoIt;
var i:integer;
   begin
   Output:=nil;
   if Watches.Count>0 then
      begin
      Output:=TOwnerEntity.Create;
      for i:=0 to Watches.Count-1 do
          begin
          TOwnerEntity(Output).AddElement(GetVarValue(Watches.Strings[i]));
          end;
      end;
   end;

function TWatchManager.GetVarValue(VarName:string):TTypeElement;
var i,dumm:integer;
    P:TDBOilProgram;
    St:string;
    Del:char;
   begin
   result:=nil;
   if Input<>nil then
    begin
    varname:=AnsiUpperCase(varName);
    result:=nil;
    P:=TDBOilProgram(Input);
    i:=P.NameStack.Count-1;
    while (i>=0)and(result=nil) do
      begin
      Del:=#0;
      St:=P.NameStack.Strings[i];
      St:=AnsiUpperCase(ReadToDelimiter(St,['+'],1,Del,dumm));
      if St=VarName then
          begin
          {if Del='+' then called}
          result:=TTypeElement(P.stack.elements[i]).SelfCopy;
          end;
      dec(i);
      end;
    end;
   end;

end.



