unit t_oilpro;

interface
uses
    Elements,
    {!T_Main,}
    Language,{kvuli TToolClass}
    Tools;

{
   cl_Element            = 'ELEMENT';
   cl_ActiveElement      = 'ACTIVEELEMENT';
   cl_World              = 'WORLD';
   cl_Self               = 'SELF';
   cl_ObjectModel        = 'OBJECTMODEL';
   cl_MainTool           = 'MAINTOOL';
   cl_Close              = 'CLOSE';
   cl_Call               = 'CALL';
}
type
TCreateElement=class(TTool)
private
  FElementName:string;
  FNameOfClass:string;
public
 function NumberToPropertyName(aNumber: longInt): string;override;
published
  property NameOfClass:string read FNameOfClass write FNameOfClass;
  property ElementName:string read FElementName write FElementName;
  procedure DoIt;override;
end;

TCreate=class(TCreateElement)
public
  procedure DoIt;override;
end;

TCreateTool=class(TTool)
private
  FElementName:string;
  FNameOfTool:string;
public
  function NumberToPropertyName(aNumber: longInt): string;override;
  procedure DoIt;override;
published
  property NameOfTool:string read FNameOfTool write FNameOfTool;
  property ElementName:string read FElementName write FElementName;
end;

TDoIt=class(TTool)
public
  procedure DoIt;override;
end;

TFree=class(TTool)
public
  procedure DoIt;override;
end;

TFreeAll=class(TTool)
public
  procedure DoIt;override;
end;

TAddElement=class(TTool)
  FElementToAdd:TElement;
public
  procedure DoIt;override;
  function NumberToPropertyName(aNumber: longInt): string;override;
published
  property ElementToAdd:TElement read FElementToAdd write FElementToAdd;
end;

TFindOwnerByClass=class(TTool)
private
  FOwnerClass:string;
public
 function NumberToPropertyName(aNumber: longInt): string;override;
published
  property OwnerClass:string read FOwnerClass write FOwnerClass;
  procedure DoIt;override;
end;

TFindOwnerByName=class(TTool)
private
  FOwnerName:string;
public
  function NumberToPropertyName(aNumber: longInt): string;override;
  procedure DoIt;override;
published
  property OwnerName:string read FOwnerName write FOwnerName;
end;

TFindElementByName=class(TTool)
private
  FElementName:string;
public
  function NumberToPropertyName(aNumber: longInt): string;override;
  procedure DoIt;override;
published
  property ElementName:string read FElementName write FElementName;
end;

TFindElementByClass=class(TTool)
private
  FClassOfElement:string;
public
 function NumberToPropertyName(aNumber: longInt): string;override;
published
  property ClassOfElement:string read FClassOfElement write FClassOfElement;
  procedure DoIt;override;
end;


implementation
uses
    e_Class;

{TCreateElement}
procedure TCreateElement.DoIt;
var Cl:TElementClass;
    aEl:TElement;
    aEnt:TEntity;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TEntity) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      CL:=GetOrbisClass(NameOfClass);
      if CL=nil then {raise neexistuje class}
         else
         begin
         aEl:=Cl.Create;
         aEl.Name:=ElementName;
         aEnt.AddElement(aEl);
         Output:=aEl;
         end;
      end;
      end;
end;

function TCreateElement.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='NameOfClass';
   1:result:='ElementName';
   else result:='';
   end;{case}
end;

{Create}
procedure TCreate.DoIt;
var Cl:TElementClass;
    aEl:TElement;
begin
  CL:=GetOrbisClass(NameOfClass);
  if CL=nil then {raise neexistuje class}
         else
         begin
         aEl:=Cl.Create;
         aEl.Name:=ElementName;
         Output:=aEl;
         end;
end;

{TCreateTool}
procedure TCreateTool.DoIt;
var aTool:TTool;
    CL:TElementClass;
    aEnt:TTechnology;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TTechnology{TEntity}) then{raise neni technologie}
      else
      begin
      aEnt:=TTechnology(Input);
      CL:=GetOrbisClass(NameOfTool);
      if CL=nil then {raise neexistuje class}
         else
         if not CL.InheritsFrom(TTool) then {raise neni tool}
         else
         begin
         aTool:=TToolClass(CL).Create;
         aTool.Name:=ElementName;
         aEnt.AddTool(aTool);
         Output:=aTool;
         end;
      end;
      end;
end;

function TCreateTool.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='NameOfTool';
   1:result:='ElementName';
   else result:='';
   end;{case}
end;

{TDoIt}
procedure TDoIt.DoIt;
var aTool:TTool;
   begin
   if Input=nil then{raise error}
      else
      begin
      if not(Input is TTool) then{raise error}
      else
      begin
      aTool:=TTool(Input);
      aTool.DoIt;
      Output:=aTool.Output;
      end;
      end;
   end;

procedure TFree.DoIt;
begin
if Input=nil then {raise error}
   else
      begin
      Input.Free;
      Output:=nil
      end;
end;

procedure TFreeAll.DoIt;
var aEnt:TEntity;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TEntity) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      aEnt.FreeAll;
      Output:=nil;
      end;
      end;
end;

{TAddElement}
function TAddElement.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='ElementToAdd';
   else result:='';
   end;{case}
end;

procedure TAddElement.DoIt;
var aent:TEntity;
   begin
   {mozna by chtelo malou ochranu pridavaneho prvku}
   if Input=nil then {raise error}
      else
      begin
      if not(Input is TEntity) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      aEnt.AddElement(ElementToAdd);
      Output:=ElementToAdd;
      end;
      end;

   end;

{FindOwnerByClass}
function TFindOwnerByClass.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='OwnerClass';
   else result:='';
   end;{case}
end;

procedure TFindOwnerByClass.DoIt;
var aEnt:TEntity;
    Cl:TClass;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TElement) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      CL:=GetOrbisClass(OwnerClass);
      if CL=nil then {raise neexistuje class}
         else
         begin
         Output:=aEnt.FindOwnerClass(CL);
         end;
      end;
      end;
end;


{FindOwnerByName}
function TFindOwnerByName.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='OwnerName';
   else result:='';
   end;{case}
end;

procedure TFindOwnerByName.DoIt;
var aEnt:TEntity;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TElement) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      Output:=aEnt.FindOwnerName(OwnerName);
      end;
      end;
end;

{FindElementByName}
function TFindElementByName.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='ElementName';
   else result:='';
   end;{case}
end;

procedure TFindElementByName.DoIt;
var aEnt:TEntity;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TEntity) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      Output:=aEnt.FindElementName(ElementName);
      end;
      end;
end;

{FindElementByClass}
function TFindElementByClass.NumberToPropertyName(aNumber: longInt): string;
begin
case aNumber of
   0:result:='ClassOfElement';
   else result:='';
   end;{case}
end;

procedure TFindElementByClass.DoIt;
var aEnt:TEntity;
    Cl:TClass;
begin
if Input=nil then {raise error}
      else
      begin
      if not(Input is TEntity) then{raise error}
      else
      begin
      aEnt:=TEntity(Input);
      CL:=GetOrbisClass(ClassOfElement);
      if CL=nil then {raise neexistuje class}
         else
         begin
         Output:=aEnt.FindElementClass(CL);
         end;
      end;
      end;
end;



INITIALIZATION
   RegisterOrbisClass(TCreateElement);
   RegisterOrbisClass(TCreate);
   RegisterOrbisClass(TCreateTool);
   RegisterOrbisClass(TDoIt);
   RegisterOrbisClass(TFree);
   RegisterOrbisClass(TFreeAll);
   RegisterOrbisClass(TAddElement);
   RegisterOrbisClass(TFindOwnerByClass);
   RegisterOrbisClass(TFindOwnerByName);
   RegisterOrbisClass(TFindElementByClass);
   RegisterOrbisClass(TFindElementByName);
END.
