unit t_SriptTool;

interface
uses
   Tools;

type

TScriptTool = class(TTool)
private
   FScript: string;
   procedure SetScript(const Value: string);
public
   procedure DoIt; override;
   function  NumberToPropertyName(aNumber: longInt): string; override;
published
   property Script: string read FScript write SetScript;
end;


implementation
uses
   SysUtils,
   e_Class,
   t_CmdLn,
   u_String;
{ TScriptTool }

procedure TScriptTool.DoIt;
var
   CL: TCommandLine;
   S: string;
begin
   inherited;
   if Script = '' then exit;
   CL := TCommandLine.Create;
   CL.FileName := GetAbsolutePath(Script);
   Cl.DoIt;
   CL.Free;
end;

function TScriptTool.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'Script';
end;

procedure TScriptTool.SetScript(const Value: string);
begin
   FScript := Value;
   //Name := Value;
end;

initialization
   RegisterOrbisClass(TScriptTool);
end.
