unit ViewTrf_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ ViewTrf Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_ViewTrf: TGUID = '{AB7FFF86-D8F3-11D1-91FD-0040332CDCD8}';

const

{ Component class GUIDs }
  Class_ViewTrfObj: TGUID = '{AB7FFF88-D8F3-11D1-91FD-0040332CDCD8}';

type

{ Forward declarations: Interfaces }
  IViewTrfObj = interface;
  IViewTrfObjDisp = dispinterface;

{ Forward declarations: CoClasses }
  ViewTrfObj = IViewTrfObj;

{ Dispatch interface for ViewTrfObj Object }

  IViewTrfObj = interface(IDispatch)
    ['{AB7FFF87-D8F3-11D1-91FD-0040332CDCD8}']
    procedure SetViewRect(NewVertMin, NewHorMin, NewDVert, NewDHor: Double; HWindow, VelikostBMPX, VelikostBMPY, HorScroll, VertScroll, aDC: Integer; BMP: WordBool); safecall;
    procedure SetViewRectFromScale(Scale, StredVert, StredHor: Double; HWindow, VelikostBMPX, VelikostBMPY, HorScroll, VertScroll, aDC: Integer; BMP: WordBool); safecall;
    procedure ChangeBasicToGeoRect(var aVertMin, aHorMin, aDVert, aDHor: Double; aSourSystem: Integer); safecall;
    procedure ChangeGeoToBasicRect(var aVertMin, aHorMin, aDVert, aDHor: Double; aSourSystem: Integer); safecall;
    procedure ChangeBasicToGeo(var XV, YH: Double; aSourSystem: Integer); safecall;
    procedure ChangeGeoToBasic(var XV, YH: Double; aSourSystem: Integer); safecall;
    function Get_VertMin: Double; safecall;
    procedure Set_VertMin(Value: Double); safecall;
    function Get_HorMin: Double; safecall;
    procedure Set_HorMin(Value: Double); safecall;
    function Get_DVert: Double; safecall;
    procedure Set_DVert(Value: Double); safecall;
    function Get_DHor: Double; safecall;
    procedure Set_DHor(Value: Double); safecall;
    function Get_KVert: Double; safecall;
    procedure Set_KVert(Value: Double); safecall;
    function Get_KHoriz: Double; safecall;
    procedure Set_KHoriz(Value: Double); safecall;
    function Get_HorScrollPos: Integer; safecall;
    procedure Set_HorScrollPos(Value: Integer); safecall;
    function Get_VertScrollPos: Integer; safecall;
    procedure Set_VertScrollPos(Value: Integer); safecall;
    procedure TrfGeoScr(aVert, aHor: Double; aSourSys: Integer; var XH, YV: Integer); safecall;
    procedure TrfScrGeo(XH, YV, aSourSys: Integer; var aVert, aHor: Double); safecall;
    procedure TrfGeoScrRect(aVertMin, aHorMin, aDVert, aDHor: Double; aSourSys: Integer; var XHmin, YVmin, DXH, DYV: Integer); safecall;
    procedure TrfScrGeoRect(XHmin, YVmin, DXH, DYV, aSourSys: Integer; var aVertMin, aHorMin, aDVert, aDHor: Double); safecall;
    function Get_SourSys: Integer; safecall;
    procedure Set_SourSys(Value: Integer); safecall;
    function Get_VertSize: Integer; safecall;
    procedure Set_VertSize(Value: Integer); safecall;
    function Get_HorSize: Integer; safecall;
    procedure Set_HorSize(Value: Integer); safecall;
    procedure TrfGeoBitMap(aVert, aHor: Double; aSourSys: Integer; var XH, YV: Integer); safecall;
    procedure TrfGeoBitMapRect(aVertMin, aHorMin, aDVert, aDHor: Double; aSourSys: Integer; var XHmin, YVmin, DXH, DYV: Integer); safecall;
    function Get_TileVertSize: Integer; safecall;
    procedure Set_TileVertSize(Value: Integer); safecall;
    function Get_TileHorSize: Integer; safecall;
    procedure Set_TileHorSize(Value: Integer); safecall;
    property VertMin: Double read Get_VertMin write Set_VertMin;
    property HorMin: Double read Get_HorMin write Set_HorMin;
    property DVert: Double read Get_DVert write Set_DVert;
    property DHor: Double read Get_DHor write Set_DHor;
    property KVert: Double read Get_KVert write Set_KVert;
    property KHoriz: Double read Get_KHoriz write Set_KHoriz;
    property HorScrollPos: Integer read Get_HorScrollPos write Set_HorScrollPos;
    property VertScrollPos: Integer read Get_VertScrollPos write Set_VertScrollPos;
    property SourSys: Integer read Get_SourSys write Set_SourSys;
    property VertSize: Integer read Get_VertSize write Set_VertSize;
    property HorSize: Integer read Get_HorSize write Set_HorSize;
    property TileVertSize: Integer read Get_TileVertSize write Set_TileVertSize;
    property TileHorSize: Integer read Get_TileHorSize write Set_TileHorSize;
  end;

{ DispInterface declaration for Dual Interface IViewTrfObj }

  IViewTrfObjDisp = dispinterface
    ['{AB7FFF87-D8F3-11D1-91FD-0040332CDCD8}']
    procedure SetViewRect(NewVertMin, NewHorMin, NewDVert, NewDHor: Double; HWindow, VelikostBMPX, VelikostBMPY, HorScroll, VertScroll, aDC: Integer; BMP: WordBool); dispid 1;
    procedure SetViewRectFromScale(Scale, StredVert, StredHor: Double; HWindow, VelikostBMPX, VelikostBMPY, HorScroll, VertScroll, aDC: Integer; BMP: WordBool); dispid 2;
    procedure ChangeBasicToGeoRect(var aVertMin, aHorMin, aDVert, aDHor: Double; aSourSystem: Integer); dispid 3;
    procedure ChangeGeoToBasicRect(var aVertMin, aHorMin, aDVert, aDHor: Double; aSourSystem: Integer); dispid 4;
    procedure ChangeBasicToGeo(var XV, YH: Double; aSourSystem: Integer); dispid 5;
    procedure ChangeGeoToBasic(var XV, YH: Double; aSourSystem: Integer); dispid 6;
    property VertMin: Double dispid 7;
    property HorMin: Double dispid 8;
    property DVert: Double dispid 9;
    property DHor: Double dispid 10;
    property KVert: Double dispid 11;
    property KHoriz: Double dispid 12;
    property HorScrollPos: Integer dispid 13;
    property VertScrollPos: Integer dispid 14;
    procedure TrfGeoScr(aVert, aHor: Double; aSourSys: Integer; var XH, YV: Integer); dispid 15;
    procedure TrfScrGeo(XH, YV, aSourSys: Integer; var aVert, aHor: Double); dispid 16;
    procedure TrfGeoScrRect(aVertMin, aHorMin, aDVert, aDHor: Double; aSourSys: Integer; var XHmin, YVmin, DXH, DYV: Integer); dispid 17;
    procedure TrfScrGeoRect(XHmin, YVmin, DXH, DYV, aSourSys: Integer; var aVertMin, aHorMin, aDVert, aDHor: Double); dispid 18;
    property SourSys: Integer dispid 19;
    property VertSize: Integer dispid 20;
    property HorSize: Integer dispid 21;
    procedure TrfGeoBitMap(aVert, aHor: Double; aSourSys: Integer; var XH, YV: Integer); dispid 22;
    procedure TrfGeoBitMapRect(aVertMin, aHorMin, aDVert, aDHor: Double; aSourSys: Integer; var XHmin, YVmin, DXH, DYV: Integer); dispid 23;
    property TileVertSize: Integer dispid 24;
    property TileHorSize: Integer dispid 25;
  end;

{ ViewTrfObjObject }

  CoViewTrfObj = class
    class function Create: IViewTrfObj;
    class function CreateRemote(const MachineName: string): IViewTrfObj;
  end;



implementation

uses ComObj;

class function CoViewTrfObj.Create: IViewTrfObj;
begin
  Result := CreateComObject(Class_ViewTrfObj) as IViewTrfObj;
end;

class function CoViewTrfObj.CreateRemote(const MachineName: string): IViewTrfObj;
begin
  Result := CreateRemoteComObject(MachineName, Class_ViewTrfObj) as IViewTrfObj;
end;


end.
