unit I_chktpl;

interface
uses
  Elements, Tools, T_Recurs,
  //E_Space,
  e_Device,
  I_Chk;


type

TTestTplInterpret = class(TTestInterpret)
private
   FBlockName: string;
   FMsgProp: string;
protected
   procedure WriteInfo(Element: TElement); override;
   procedure Process(Element: TElement); override;
public
   procedure   Reset(aDevice: TDevice); override;
   procedure   Close;  override;
   property BlockName: string read FBlockName write FBlockName;
published
   property MsgProp: string read FMsgProp write FMsgProp;
end;

TTestAreaInterpret = class(TTestTplInterpret)
protected
{
  procedure WriteInfo(Element: TElement); override;
  }
  procedure Process(Element: TElement); override;
end;


TTestLineInterpret = class(TTestTplInterpret)
protected
{
  procedure WriteInfo(Element: TElement); override;
}
  procedure Process(Element: TElement); override;
end;

TTestPointInterpret = class(TTestTplInterpret)
protected
{
  procedure WriteInfo(Element: TElement); override;
  }
  procedure Process(Element: TElement); override;
end;

TTestTextInterpret = class(TTestTplInterpret)
protected
{
  procedure WriteInfo(Element: TElement); override;
  }
  procedure Process(Element: TElement); override;
end;


implementation
uses
  Forms,
  SysUtils,
  E_Class,
  //e_TopMdl,
  //E_TplPrp,
  e_TopolElements,
  u_String;


procedure  TTestTplInterpret.WriteInfo(Element: TElement);
var
  TE: TTopolElement;
  S,SS,S1: string;
begin
  if not (Element is TTopolElement) then exit;
  TE := TTopolElement(Element);
  SS := ' .'+ IntToStr(TE.Cislo) + ' ';
  {
  if TopolProps.BlockDir <> BlockName then
  }
  S := MsgProp;
  if S <> '' then
  begin
     while StringAsTwoParams(S,',',S,S1)do
     begin
        SS := SS + ' * ' + Input.GetPropertyStringByName(S);
        S := S1;
     end;
     SS := SS + ' * ' + Input.GetPropertyStringByName(S);
  end;
  begin
     BlockName := TE.BlockName;
     SS := SS + ' ' + BlockName;
  end;
  Device.WriteLnText(SS);
end;

procedure  TTestTplInterpret.Process(Element: TElement);
begin
  TestCount := TestCount + 1;
  ProgressText := 'Objekt . '+ IntToStr(TestCount);
  inherited Process(Element);
  Application.ProcessMessages;
end;



{
procedure  TTestAreaInterpret.WriteInfo(Element: TElement);
var
  AreaProps: TTopolAreaProps;
begin
  AreaProps:= TTopolAreaProps(TAreaElement(Element).Properties);
  if not (AreaProps is TTopolAreaProps) then exit;

  Device.WriteLnText
         (IntToStr(AreaProps.Cislo) + ' ' +
           AreaProps.BlockDir);
end;

}


procedure  TTestAreaInterpret.Process(Element: TElement);
begin
  if not (Element is TTopolAreaElement) then exit;
  inherited Process(Element)
end;



                { TTestLineInterpret }

{
procedure  TTestLineInterpret.WriteInfo(Element: TElement);
var
  LineProps: TTopolLineProps;
begin
  LineProps:= TTopolLineProps(TPolyLineElement(Element).Properties);
  if not (LineProps is TTopolLineProps) then exit;

  Device.WriteLnText
         (IntToStr(LineProps.Cislo) + ' ' +
           LineProps.BlockDir);
end;

}


procedure  TTestLineInterpret.Process(Element: TElement);
begin
  if not (Element is TTopolLineElement) then exit;
  inherited Process(Element)
end;


                { TTestPointInterpret }

{
procedure  TTestPointInterpret.WriteInfo(Element: TElement);
var
  PointProps: TTopolPointProps;
begin
  PointProps:= TTopolPointProps(TPointElement(Element).Properties);
  if not (PointProps is TTopolPointProps) then exit;

  Device.WriteLnText
         (IntToStr(PointProps.Cislo) + ' ' +
           PointProps.BlockDir);
end;

}


procedure  TTestPointInterpret.Process(Element: TElement);
begin
  if not (Element is TTopoLPointElement) then exit;
  inherited Process(Element)
end;



procedure  TTestTextInterpret.Process(Element: TElement);
begin
  if not (Element is TTopoLTextElement) then exit;
  inherited Process(Element)
end;





procedure TTestTplInterpret.Close;
begin
   EndProgress;
   Application.ProcessMessages;
   inherited;
end;

procedure TTestTplInterpret.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
   StartProgress(Name,0,0);
   Application.ProcessMessages;
end;

initialization
   RegisterOrbisClass(TTestAreaInterpret);
   RegisterOrbisClass(TTestLineInterpret);
   RegisterOrbisClass(TTestPointInterpret);
   RegisterOrbisClass(TTestTextInterpret);
end.
