
unit e_PlZn;
{
********************************************************************
**                                                                **
**               ORBIS - Plosne uzivatelske znacky ...            **
**                     tedy srafy, nebo tak neco                  **
**                                                                **
**                            -PPK-1994-                          **
**                                                                **
********************************************************************
}



                         INTERFACE

{*****************************************************************}

uses
   Classes,
   Graphics,
   WinTypes,
// KERNEL
   CtiPar,
   Elements,
// DEVICE
   e_Device;
{*****************************************************************}

const

  UniverzalniDelitel = 1000;
  BaseLineValue = 15000;
  MaxPocetVrcholu = 100000;

  { Vystupni zarizeni }
  { ***************** }
  dvcVideo = 0;
  dvcHPGL  = 1;
  dvcHPGL2 = 3;


type

  PVrcholy = ^TVrcholy;
  TVrcholy = array [1..MaxPocetVrcholu] of TPoint;


  { Hrana .... }
  { ********** }

  Hrana = record
    y_horni    : integer;        { vetsi souradnice x hrany }
    PrusecikX : longint;        { y, ktere patri k y_horni }
    DeltaY    : integer;        { rozdil mezi souradnicemi x }
    ZmenaXNaRadek : longint;  { zmena y pri zmene y o 1 pixel }
  end;



  { TSrafa - Nejjednodussi prvek plosne znacky ... jejich pole tvori Vrstvu }
  { *********************************************************************** }

  TSrafa = class(TElement)
   private
    FTrueColor: TColor;
    FByTrueColor: boolean;
    FUseExternalColor: boolean;
   public
    Sirka       : integer;    { Sirka (tloustka) srafy }
    Barva       : integer;       { Jeji barva }
    Vzdalenost  : integer;    { Vzdalenost k dalsi }
    Vzor        : boolean;    { Informace o tom, zda je srafa vzorovana }
    vzVzd1      : integer;    { Mezera pred plnou casti vzoru }
    VzDelka     : integer;    { Delka plne casti vzoru }
    vzVzd2      : integer;    { Mezera za plnou casti vzoru }
    DelkaVzoru  : integer;    { Celkova delka Vzoru }
    x           : integer;    { kolikata srafa se vznechava}
    dx          : integer;    { odsazeni na nasledujicim r.}
    Dalsi       : TSrafa;     { Ukazatel na dalsi srafu }
  published
    property     Color: integer read Barva write Barva;
    property     TrueColor: TColor read FTrueColor write FTrueColor;
    property     ByTrueColor: boolean read FByTrueColor write FByTrueColor;
    property     UseExternalColor: boolean read FUseExternalColor write FUseExternalColor;
  end;



  { VrstvaSraf - Zaznam obsahujici pole Sraf, jejich uhel a odkaz na dalsi }
  { ********************************************************************** }

  TVrstvaSraf = class
    PocetSraf: integer;    { Vek nejstarsiho snehulaka v obci }
    Uhel : byte;           { Uhel sraf }
    Srafy: TSrafa;         { Cyklicky spojovy seznam sraf }
    Dalsi: TVrstvaSraf;    { Ukazatel na dalsi vrstvu }
  end;



  PHranice = ^THranice;
  THranice = array [1..MaxPocetVrcholu] of hrana;



  { Plosna znacka }
  { ************* }

  TPlosnaZnacka = class(TOwnerElement)
   private
    FTrueColor: TColor;
    FByTrueColor: boolean;
    FFillBackground: boolean;
    FExternalColor: integer;
    FRefY: integer;
    FRefX: integer;
    procedure SetRefX(const Value: integer);
    procedure SetRefY(const Value: integer);
  protected
    Hranice   : PHranice;
    procedure VyplnRadkovymRozkladem (Device: TDevice;
                                      var Coords,Lengths; PolygonsCount: integer);
    procedure VyplnRadkovymRozklademSikmo( Device: TDevice;
                                           var Coords,Lengths; PolygonsCount: integer);
    procedure UvodniZpracovaniHranice (Device: TDevice; var Coords,Lengths; PolygonsCount: integer;
                                   var PocetHran, NejnizsiY : integer);
    procedure UvodniZpracovaniHraniceSvisle (Device: TDevice; var Coords,Lengths; PolygonsCount: integer;
                                         var PocetHran, NejnizsiX : integer);
    procedure AktualizujSeznamHran (PocetHran, radek : integer;
                                var PrvniHrana, PosledniHrana : integer);
    procedure UpravSeznamHran (PrvniHrana, PosledniHrana: integer);
    procedure NalezniPrusecikyY (Radek : integer;
                             var PocetPruseciku : integer;
                                 PrvniHrana, PosledniHrana : integer);
    procedure KresliUseky      ( Device: TDevice;
                                 Radek, PocetPruseciku, index_hrany : integer);
    procedure KresliUsekySvisle( Device: TDevice;
                                 Radek, PocetPruseciku, index_hrany : integer);
    procedure KresliUsekySikmo ( Device: TDevice;
                                 Radek, PocetPruseciku, index_hrany : integer);
  public
    Kod           : longInt;          { Kodove oznaceni zn. }
    Nazev         : string[30];       { Jeji nazev }
    Podklad       : integer;             { Barva podkladu }
    ZakladniZnacka: integer;          { Moznost def.jedn.zn. misto slozite }
    NahradniZnacka: integer;          { Nahradni srafa pro rychly rezim }
    Znacky        : TVrstvaSraf;      { Vrstvy sraf }
    AktualniVrstva: TVrstvaSraf;      { Ukazatel na aktivni vrstvu sraf }
    AktualniSrafa : TSrafa;           { Ukazatel na aktivni srafu }
    Status        : word;             { informace o znacce .. dynamicka a tak }
    constructor Create; override;
    destructor  Destroy; override;
    function    JeStatus(Stat: word): boolean;
    procedure   NastavKod(AKod: longInt);
    procedure   NastavNahradniZnacku(AZnacka: integer);
    procedure   NastavNazev(ANazev: String);
    procedure   NastavStatus(Stat: word; Rozh: boolean);
    procedure   PridejZnacku(AZnacka: TVrstvaSraf);
    procedure   VyplnPlochu(Device: TDevice; var Coords,Lengths; PolygonsCount: integer; aRefX,aRefY: double);
    property    RefX: integer read FRefX write SetRefX;
    property    RefY: integer read FRefY write SetRefY;
  published
    property     Color: integer read Podklad write Podklad;
    property     TrueColor: TColor read FTrueColor write FTrueColor;
    property     ExternalColor: integer read FExternalColor write FExternalColor;
    property     ByTrueColor: boolean read FByTrueColor write FByTrueColor;
    property     FillBackground: boolean read FFillBackground write FFillBackground;
end;




  { Kolekce plosnych znacek }
  { *********************** }

  TPlosneZnacky = class(TNameEntity)
  public
    Nabidka: boolean;  { Informace o tom, ze se jede v nabidkovem rezimu}
    Device: TDevice;
    constructor CreateAll( ASoubor: string);
    procedure   NastavNabidku; { Nastavi nabidkovy rezim }
    procedure   ZrusNabidku;   { Zrusi   ----- || -----  }
    procedure   VratListKodu(const aList: TStrings);
    procedure   PridejVsechnyZnacky;
    function    PridejZnackuDleKodu(  AKod: longInt): TPlosnaZnacka;
    function    VratZnackuDleKodu(AKod: longInt): TPlosnaZnacka;
  end;




  { Objekt pro nacitani strukturovane znacky z textoveho souboru }
  { ************************************************************ }
  TCteniPlosnychZnacek = class(TCteniParametru)
  public
    Background: integer;
    BackgroundOnly: boolean;
    Device: TDevice;
    procedure VratListKodu(const aList: TStrings);
    procedure CtiVsechnyZnacky(E: Tentity);
    function  CtiPlosnouZnacku (  Kod: longInt): TPlosnaZnacka;
    function  CtiVrstvu: TVrstvaSraf;
    function  CtiSrafu(aUhel: byte): TSrafa;
    function  MilimetryNaObrHoriz(mm: double): longInt;
    function  MilimetryNaObrVert(mm: double): longInt;
    function  DejBoolParametr: boolean;
    function  DejIntParametr: Integer;
  end;



{
const

  PlosneZnacky: TPlosneZnacky = nil;

}





                          IMPLEMENTATION

{********************************************************************}
uses
   SysUtils,
// KERNEL
   CtiRadek,
// GLIB
   ClipArea,
   e_Color,
   G_Elems;
(*
{$IFDEF Windows}
  CtiRadek,
  NadGraph,
  ZobrGlob,
  MatProc,
  WinProcs;

{$ELSE}
  CtiRadek,
  {$IFNDEF TopoSkop}
  NadGraph,
  ZobraObj,
  ZobrGlob,
  {$ELSE}
  ProgOkno,
  VektOkno,
  {$ENDIF}
  MatProc;
{$ENDIF}

*)
{********************************************************************}

const

  Ano = True;
  Ne  = False;
  //Sour00: TDoubleCoord = (x: 0; y: 0);
  NabKoef = 3;            { Koeficient pro prepocet mm na  body nabidky }

{ Klicova Slova pro ctenare }
{ ************************* }

  pzBarva          = 'BARVA';
  pzD1             = 'D1';
  pzD2             = 'D2';
  pzx              = 'X';
  pzdx             = 'DX';
  pzDelkaVzoru     = 'DELKAVZORU';
  pzElse           = 'ELSE';
  pzEnd            = 'END';
  pzKod            = 'KOD';
  pzNahradniZnacka = 'NAHRADNIZNACKA';
  pzNazev          = 'NAZEV';
  pzPetrklic       = 'PETRKLIC';
  pzPlosnaZnacka   = 'PLOSNAZNACKA';
  pzPodklad        = 'PODKLAD';
  pzSirka          = 'SIRKA';
  pzSoubor         = 'SOUBOR';
  pzSrafa          = 'SRAFA';
  pzUhel           = 'UHEL';
  pzVrstvaSraf     = 'VRSTVASRAF';
  pzVzdalenost     = 'VZDALENOST';
  pzVzor           = 'VZOR';
  pzZakladniZnacka = 'ZAKLADNIZNACKA';


type


  { Jednoduchy zaznam srafy pro ulozeni do pole pri sikmem vykresleni }
  { ***************************************************************** }
  TSimpleSrafa = record
     Sirka       : integer;    { Sirka (tloustka) srafy }
     Barva       : longInt;
     Vzdalenost  : integer;    { Vzdalenost k dalsi }
     Vzor        : boolean;     // je vzor
     V1          : integer;     // prvni mezera
     D           : integer;     // delka plne casti
     V2          : integer;     // druha mezera
     DV          : integer;     // celkova delka vzoru
  end;


  { Komplikovane pole jednoduchych sraf }
  { *********************************** }
  PPoleSimpleSraf = ^TPoleSimpleSraf;
  TPoleSimpleSraf = Array[1..1000] of TSimpleSrafa;



var

  //Otacet: boolean;
  Dira      : boolean;
  SirkaSraf : integer;
  BaseLine  : integer;
  PoleSraf  : PPoleSimpleSraf;



{
  ****************************************
  *       Tela metod TPlosnaZnacka       *
  ****************************************
}

constructor TPlosnaZnacka.Create;
begin
  inherited Create;
  Kod           := -1;
  Nazev         := '';
  Podklad       := 0;
  NahradniZnacka:= 0;
  ZakladniZnacka:= 0;
  Znacky        := nil;
  Dira          := Ne;
  Hranice       := nil;
  Status        := 0;   { Staticky definovana znacka }
end;


{-----------------------------------------------------------}
destructor  TPlosnaZnacka.Destroy;
var
  P, DalsiP, PosledniP: TSrafa;
  Pv, DalsiPv: TVrstvaSraf;
begin
  Pv := Znacky;
  while Pv <> nil do
  begin
     DalsiPv := Pv.Dalsi;
     P := Pv.Srafy;
     PosledniP := P;
     if P <> nil then
     repeat
        DalsiP := P.Dalsi;
        P.Free;
        P := DalsiP;
     until  P = PosledniP;
     Pv.Free;
     Pv := DalsiPv;
  end;
  inherited Destroy
end;

{-----------------------------------------------------------}
function    TPlosnaZnacka.JeStatus(Stat: word): boolean;
begin
  JeStatus := (Status and Stat) = Stat;
end;
{-----------------------------------------------------------}
procedure   TPlosnaZnacka.NastavKod(AKod: longInt);
begin
  Kod := AKod;
end;

{-----------------------------------------------------------}
procedure   TPlosnaZnacka.NastavNahradniZnacku(AZnacka: integer);
begin
  NahradniZnacka := AZnacka;
end;

{-----------------------------------------------------------}
procedure   TPlosnaZnacka.NastavNazev(ANazev: String);
begin
  Nazev := ANazev;
end;

{-----------------------------------------------------------}
procedure   TPlosnaZnacka.NastavStatus(Stat: word; Rozh: boolean);
begin
   Status := Status OR stat;
   If Not Rozh then Status := Status XOR Stat;
end;

{-----------------------------------------------------------}
procedure   TPlosnaZnacka.PridejZnacku(AZnacka: TVrstvaSraf);
begin
  if Assigned(AZnacka) then
  begin
     AZnacka.Dalsi := Znacky;
     Znacky := AZnacka;
  end;
end;

{-----------------------------------------------------------}

procedure TPlosnaZnacka.UvodniZpracovaniHranice (Device: TDevice; var Coords,Lengths; PolygonsCount: integer;
               var PocetHran, NejnizsiY : integer);
var
  k, x1, y1, ix, nx, n, ActualPolygon : integer;

  {LF}
  function Najdi_dalsi_y (k : integer) : integer;
  var
    i:integer;
    hotovo : boolean;
  begin
     { nalezne v seznamu vrcholu dalsi vrchol,
       jehoz souradnice x neni rovna x[k]}
     { --------------------------------------- }
     i:=k;
     hotovo := false;
     while not (hotovo) do
        if TVrcholy(Coords)[i].y<>TVrcholy(Coords)[k].y then hotovo := true
        else
        begin
           inc(i);
           if i>nx then i:=ix;
        end;
     Najdi_dalsi_y := TVrcholy(Coords)[i].y
  end; {Najdi_dalsi_y}

  {LF}
  procedure Vloz_do_seznamu_hran (polozka, x1, y1, x2, y2, dalsi_y : integer);
  var
    max_y : integer;
    x2_prac, zmena_x_prac : real48;
    Zarazeno : boolean;
  begin
     { uprava souradnic vrcholu pri kraceni hrany }
     { ------------------------------------------ }
     zmena_x_prac := (x2 - x1) / (y2 - y1) ;
     x2_prac := x2;
     if (y2 > y1) and (y2 < dalsi_y) then
     begin
        y2 := y2 - 1;
        x2_prac := x2_prac - zmena_x_prac;
     end
     else
     if (y2 < y1) and (y2 > dalsi_y) then
     begin
        y2 := y2 + 1;
        x2_prac := x2_prac + zmena_x_prac;
     end;

     { zatrideni do seznamu hran podle max_y dane hrany }
     { ------------------------------------------------ }
     if y1 > y2 then max_y := y1 else max_y := y2;
     Zarazeno := false;
     while not(Zarazeno) and (polozka > 1) do
     begin
        if (max_y <= hranice^[polozka - 1].y_horni) then
           Zarazeno := true
        else
        begin
           hranice^[polozka] := hranice^[polozka-1];
           polozka := polozka - 1
        end;
     end; {while}
     with hranice^[polozka] do
     begin
          y_horni := max_y;
          DeltaY := abs(y2 - y1) + 1;
          if y1 > y2 then PrusecikX := longint(x1)*UniverzalniDelitel
                     else PrusecikX := round(x2_prac*UniverzalniDelitel);
          ZmenaXNaRadek := round(zmena_x_prac*UniverzalniDelitel){ * VeleKrok};
     end; {with}
  end; {Vloz_do_seznamu_hran}


{MAIN}
begin {UvodniZpracovaniHranice}
   ix := 1;
   nx := 0;
   PocetHran := 0;
   for ActualPolygon := 0 to PolygonsCount - 1 do
   begin
      n := TLengthArray(Lengths)[ActualPolygon];
      nx := nx + n;
      x1 := TVrcholy(Coords)[nx].x;
      y1 := TVrcholy(Coords)[nx].y; {inicializace}
      if ActualPolygon = 0 then NejnizsiY := y1;
      for k := ix to nx do
      begin
         if y1 = TVrcholy(Coords)[k].y then
         begin                      { vodorovna hrana je hned vykreslena }
            //***Tile2010***//
            //Device.MoveToDevice(x1,y1);
            //Device.LineToDevice(TVrcholy(Coords)[k].x,y1)
         end
         else                             { umisteni nesvisle hrany do seznamu }
         begin
           PocetHran := PocetHran + 1;
           Vloz_do_seznamu_hran ( PocetHran, x1, y1,
                                  TVrcholy(Coords)[k].x,
                                  TVrcholy(Coords)[k].y,
                                  Najdi_dalsi_y(k))
         end;
         x1 := TVrcholy(Coords)[k].x;
         y1 := TVrcholy(Coords)[k].y;     {priprava pro dalsi hranu}
         if y1 < NejnizsiY then NejnizsiY := y1;
      end; {for k}
      ix := ix + n;
   end;
end; { vodni_zpracovani_hranice }


procedure TPlosnaZnacka.UvodniZpracovaniHraniceSvisle (Device: TDevice; var Coords,Lengths; PolygonsCount: integer;
               var PocetHran, NejnizsiX : integer);
var
  k, x1, y1, ix, nx, n, ActualPolygon : integer;

  {LF}
  function Najdi_dalsi_x (k : integer) : integer;
  var
    i:integer;
    hotovo : boolean;
  begin
     { nalezne v seznamu vrcholu dalsi vrchol,
       jehoz souradnice x neni rovna x[k]}
     { --------------------------------------- }
     i:=k;
     hotovo := false;
     while not (hotovo) do
        if TVrcholy(Coords)[i].x<>TVrcholy(Coords)[k].x then hotovo := true
        else
        begin
           inc(i);
           if i>nx then i := ix;
        end;
     Najdi_dalsi_x := TVrcholy(Coords)[i].x
  end; {Najdi_dalsi_x}

  {LF}
  procedure Vloz_do_seznamu_hran (polozka, x1, y1, x2, y2, dalsi_x : integer);
  var
    max_x : integer;
    y2_prac, zmena_y_prac : real48;
    Zarazeno : boolean;
  begin
     { uprava souradnic vrcholu pri kraceni hrany }
     { ------------------------------------------ }
     zmena_y_prac := (y2 - y1) / (x2 - x1) ;
     y2_prac := y2;
     if (x2 > x1) and (x2 < dalsi_x) then
     begin
        x2 := x2 - 1;
        y2_prac := y2_prac - zmena_y_prac;
     end
     else
     if (x2 < x1) and (x2 > dalsi_x) then
     begin
        x2 := x2 + 1;
        y2_prac := y2_prac + zmena_y_prac;
     end;

     { zatrideni do seznamu hran podle max_x dane hrany }
     { ------------------------------------------------ }
     if x1 > x2 then max_x := x1 else max_x := x2;
     Zarazeno := false;
     while not(Zarazeno) and (polozka > 1) do
     begin
        if (max_x <= hranice^[polozka - 1].y_horni) then
           Zarazeno := true
        else
        begin
           hranice^[polozka] := hranice^[polozka-1];
           polozka := polozka - 1
        end;
     end; {while}
     with hranice^[polozka] do
     begin
          y_horni := max_x;
          DeltaY := abs(x2 - x1) + 1;
          if x1 > x2 then PrusecikX := longint(y1)*UniverzalniDelitel
                     else PrusecikX := round(y2_prac*UniverzalniDelitel);
          ZmenaXNaRadek := round(zmena_y_prac*UniverzalniDelitel){ * VeleKrok};
     end; {with}
  end; {Vloz_do_seznamu_hran}


{MAIN}
begin {UvodniZpracovaniHranice}
   ix := 1;
   nx := 0;
   PocetHran := 0;
   for ActualPolygon := 0 to PolygonsCount - 1 do
   begin
      n := TLengthArray(Lengths)[ActualPolygon];
      nx := nx + n;
      x1 := TVrcholy(Coords)[nx].x;
      y1 := TVrcholy(Coords)[nx].y; {inicializace}
      if ActualPolygon = 0 then NejnizsiX := x1;
      for k := ix to nx do
      begin
         if x1 = TVrcholy(Coords)[k].x then        { vodorovna hrana je hned vykreslena }
         begin
            //***Tile2010***//
            //Device.MoveToDevice(x1,y1);
            //Device.LineToDevice(TVrcholy(Coords)[k].x,y1);
         end
         else                             { umisteni nesvisle hrany do seznamu }
         begin
           PocetHran := PocetHran + 1;
           Vloz_do_seznamu_hran ( PocetHran, x1, y1,
                                  TVrcholy(Coords)[k].x,
                                  TVrcholy(Coords)[k].y,
                                  Najdi_dalsi_x(k))
         end;
         x1 := TVrcholy(Coords)[k].x;
         y1 := TVrcholy(Coords)[k].y;     {priprava pro dalsi hranu}
         if x1 < NejnizsiX then NejnizsiX := x1;
      end; {for k}
      ix := ix + n;
   end;
end; { vodni_zpracovani_hranice }



procedure TPlosnaZnacka.AktualizujSeznamHran (PocetHran, radek : integer;
                      var PrvniHrana, PosledniHrana : integer);
     var konec_cyklu : boolean;
begin
   konec_cyklu := (PosledniHrana = PocetHran);
   while not konec_cyklu do
   begin
      if (hranice^[PosledniHrana + 1].y_horni >= radek)
      then begin
              inc(PosledniHrana);
              konec_cyklu := (PosledniHrana = PocetHran);
           end
      else konec_cyklu := true;
   end;
   while (PrvniHrana < PosledniHrana) and (hranice^[PrvniHrana].DeltaY = 0) do inc(PrvniHrana);
end; { AktualizujSeznamHran }


{-----------------------------------------------------------}

procedure TPlosnaZnacka.NalezniPrusecikyY (radek : integer;
                                      var PocetPruseciku : integer;
                                          PrvniHrana, PosledniHrana : integer);
var
  k:integer;

  {............................................}

  procedure ZaradPodleX (DanaHrana, PrvniHrana: integer);
  var
    Zarazeno : boolean;
    NaZamenu : hrana;
  begin
    Zarazeno := false;
    while not (Zarazeno) and (DanaHrana > PrvniHrana)  do
      if (hranice^[DanaHrana].PrusecikX >=
          hranice^[DanaHrana - 1].PrusecikX)
            then Zarazeno := true
            else          {zamena dvou zaznamu v tabulce hran }
              begin
                NaZamenu := hranice^[DanaHrana];
                hranice^[DanaHrana] := hranice^[DanaHrana - 1];
                hranice^[DanaHrana - 1] := NaZamenu;
                DanaHrana := DanaHrana - 1
              end
  end; {Zara_podle_y}
  {............................................}

begin {Nalezni_pruseiky_x}
     PocetPruseciku := 0;
     for k := PrvniHrana to PosledniHrana do
          begin
               if hranice^[k].DeltaY > 0 then
                    PocetPruseciku := PocetPruseciku + 1;
               ZaradPodleX (k, PrvniHrana)
          end
end; {Nalezni_pruseiky_x}

{-----------------------------------------------------------}




procedure TPlosnaZnacka.KresliUseky ( Device: TDevice;
                                      Radek, PocetPruseciku, index_hrany : integer);
var
  k, x1, x2 : integer;
  //xx1,yy1,xx2,yy2: integer;
  pX,aX: integer;
begin
  for k := 1 to PocetPruseciku div 2 do
  begin
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     x1 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;
     inc(index_hrany);
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     x2 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;

     if AktualniSrafa.Vzor then
     begin
        //#2 ***Tile2010***// pX := x1 mod AktualniSrafa.DelkaVzoru;
        pX := abs(x1 - RefX) mod AktualniSrafa.DelkaVzoru;
        pX := AktualniSrafa.DelkaVzoru - pX;
        if pX >= AktualniSrafa.vzVzd2 then
        begin
           dec(pX,AktualniSrafa.vzVzd2);
           if pX > AktualniSrafa.vzDelka then
           begin
              inc(x1,pX - AktualniSrafa.vzDelka);
              dec(pX,pX - AktualniSrafa.vzDelka);
           end;
           pX := x1 + pX;
        end
        else
        begin
           Inc(x1,pX);
           Inc(x1,AktualniSrafa.vzVzd1);
           pX := x1 + AktualniSrafa.vzDelka;
        end;

        while pX < x2 do
        begin
           if AktualniSrafa.x > 0 then
           begin
              aX := abs(x1 - RefX) div AktualniSrafa.DelkaVzoru;
              if aX mod AktualniSrafa.x <> 0 then
              begin
                 Device.MoveToDevice(x1, Radek);
                 Device.LineToDevice(pX+1, Radek);
              end;
           end
           else
           begin
              Device.MoveToDevice(x1, Radek);
              Device.LineToDevice(pX+1, Radek);
           end;
           inc(pX,AktualniSrafa.vzVzd2);
           inc(pX,AktualniSrafa.vzVzd1);
           x1 := pX;
           inc(pX,AktualniSrafa.vzDelka);
        end;
        if x1 < x2 then
        begin
           if AktualniSrafa.x > 0 then
           begin
              aX := abs(x1 - RefX) div AktualniSrafa.DelkaVzoru;
              if aX mod AktualniSrafa.x <> 0 then
              begin
                 Device.MoveToDevice(x1, Radek);
                 Device.LineToDevice(x2+1, Radek);
              end;
           end
           else
           begin
              Device.MoveToDevice(x1, Radek);
              Device.LineToDevice(x2+1, Radek);
           end;
        end;
     end
     else
     begin
        Device.MoveToDevice(x1, Radek);
        Device.LineToDevice(x2+1, Radek);
     end;
     inc(index_hrany);
  end {for k}
end; {KresliUseky}





procedure TPlosnaZnacka.KresliUsekySvisle (Device: TDevice;
                                            Radek, PocetPruseciku, index_hrany : integer);
var
  k, y1, y2 : integer;
  //xx1,yy1,xx2,yy2: integer;
  pY: integer;
begin
  for k := 1 to PocetPruseciku div 2 do
  begin
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     y1 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;
     inc(index_hrany);
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     y2 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;
     if AktualniSrafa.Vzor then
     begin
        //***Tile2010***// pY := y1 mod AktualniSrafa.DelkaVzoru;
        pY := abs(y1 - RefY ) mod AktualniSrafa.DelkaVzoru;
        pY := AktualniSrafa.DelkaVzoru - pY;
        if pY >= AktualniSrafa.vzVzd2 then
        begin
           dec(pY,AktualniSrafa.vzVzd2);
           if pY > AktualniSrafa.vzDelka then
           begin
              inc(y1,pY - AktualniSrafa.vzDelka);
              dec(pY,pY - AktualniSrafa.vzDelka);
           end;
           pY := y1 + pY;
        end
        else
        begin
           Inc(y1,pY);
           Inc(y1,AktualniSrafa.vzVzd1);
           pY := y1 + AktualniSrafa.vzDelka;
        end;

        while pY < y2 do
        begin
           Device.MoveToDevice(Radek, y1);
           Device.LineToDevice(Radek, pY+1);
           inc(pY,AktualniSrafa.vzVzd2);
           inc(pY,AktualniSrafa.vzVzd1);
           y1 := pY;
           inc(pY,AktualniSrafa.vzDelka);
        end;
        if y1 < y2 then
        begin
           Device.MoveToDevice(Radek, y1);
           Device.LineToDevice(Radek, y2+1);
        end;
     end
     else
     begin
        Device.MoveToDevice(Radek, y1);
        Device.LineToDevice(Radek, y2+1);
     end;
     inc(index_hrany);
  end {for k}
end; {KresliUsekySvisle}



procedure TPlosnaZnacka.KresliUsekySikmo (Device: TDevice;
                                           Radek, PocetPruseciku, index_hrany : integer);
var
  k , x1, x2 : integer;
  //xx1,yy1,xx2,yy2: integer;
  pX,pY: integer;
  ISraf: integer;
  //Pom: integer;
  ZacMezerou: boolean;
  MaxIS: integer;
begin
  MaxIS := AktualniVrstva.PocetSraf;
  for k := 1 to PocetPruseciku div 2 do
  begin
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     x1 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;
     inc(index_hrany);
     while hranice^[index_hrany].DeltaY = 0 do inc(index_hrany);
     x2 := hranice^[index_hrany].PrusecikX div UniverzalniDelitel;

     //***Tile 2010***// pX := (x1+BaseLine) mod SirkaSraf;
     pX := abs(x1-RefX+BaseLine) mod SirkaSraf;

     //Pom:= 0;
     ZacMezerou := Ne;

     begin
        { Sherlockuji Holmesuji tu spravnou srafu, kterou zacnu }
        { ----------------------------------------------------- }
        for ISraf := 1 to MaxIS do
        begin
           if pX <= PoleSraf^[ISraf].Sirka then
           begin
             pX := PoleSraf^[ISraf].Sirka - pX;
             break;
           end
           else dec(pX,PoleSraf^[ISraf].Sirka);

           if pX <= PoleSraf^[ISraf].Vzdalenost then
           begin
             pX := PoleSraf^[ISraf].Vzdalenost - px;
             ZacMezerou := Ano;
             break;
           end
           else dec(pX,PoleSraf^[ISraf].Vzdalenost);

        end;
     end;
     { Nastavime pocatecni x1 & pX }
     { --------------------------- }
     if ZacMezerou then
     begin
        inc(x1,pX);
        inc(ISraf);
        if ISraf > MaxIS then ISraf := 1;
        pX := x1 + PoleSraf^[ISraf].Sirka;
     end
     else
     begin
        pX := x1 + pX;
     end;

     while pX < x2 do
     begin
        Device.Pen.Color := PoleSraf^[ISraf].Barva;
        // #1 reseni vzoru ... tedy jestli se ta kravina bude vykreslovat nebo ne
        if PoleSraf^[ISraf].Vzor then
        begin
           //#2 ***Tile2010***// pX := x1 mod AktualniSrafa.DelkaVzoru;
           py := abs(radek{ - Baseline} - RefY) mod PoleSraf^[ISraf].DV;
           py := PoleSraf^[ISraf].DV - py;
           if (py >= PoleSraf^[ISraf].V1) and (py < PoleSraf^[ISraf].V1 + PoleSraf^[ISraf].D) then
           begin
              Device.MoveToDevice(x1, Radek);
              Device.LineToDevice(pX+1, Radek);
           end;
        end
        else
        begin
           Device.MoveToDevice(x1, Radek);
           Device.LineToDevice(pX+1, Radek);
        end;
        inc(pX,PoleSraf^[ISraf].Vzdalenost);
        x1 := pX;
        inc(ISraf);
        if ISraf > MaxIS then ISraf := 1;
        inc(pX,PoleSraf^[ISraf].Sirka);
     end;
     if x1 < x2 then
     begin
        Device.Pen.Color := PoleSraf^[ISraf].Barva;
        if PoleSraf^[ISraf].Vzor then
        begin
           //#2 ***Tile2010***// pX := x1 mod AktualniSrafa.DelkaVzoru;
           py := abs(radek{ - Baseline} - RefY) mod PoleSraf^[ISraf].DV;
           py := PoleSraf^[ISraf].DV - py;
           if (py >= PoleSraf^[ISraf].V1) and (py < PoleSraf^[ISraf].V1 + PoleSraf^[ISraf].D) then
           begin
              Device.MoveToDevice(x1, Radek);
              Device.LineToDevice(x2+1, Radek);
           end;
        end
        else
        begin
           Device.MoveToDevice(x1, Radek);
           Device.LineToDevice(x2+1, Radek);
        end;
     end;
     inc(index_hrany);
  end {for k}
end; {KresliUseky}





procedure TPlosnaZnacka.UpravSeznamHran (PrvniHrana, PosledniHrana: integer);
  var k : integer;
  begin
    for k := PrvniHrana to PosledniHrana do
      with hranice^[k] do
        if DeltaY > 0 then   {ureni dalsiho PrusecikY, snizeni DeltaY}
          begin
            dec(DeltaY);
            if DeltaY < 0 then DeltaY := 0;
            PrusecikX := PrusecikX - ZmenaXNaRadek
          end
  end; {UpravSeznamHran}




{-----------------------------------------------------------}
procedure TPlosnaZnacka.VyplnPlochu ( Device: TDevice; var Coords,Lengths; PolygonsCount: integer; aRefX,aRefY: double);
var
   PocetHran: integer;
   i: integer;
begin
   { Vybarveni podkladem }
   { ------------------- }
   if Podklad = -1 then
   begin
      // nevyplnuje se ....
   end
   else
   if Podklad = -2 then // externalcolor
   begin
      Device.Brush.Style := bsSolid;
      Device.Brush.Color := ExternalColor;
      Device.Pen.Style:= psClear;
      //{$IFNDEF WIN32}WinProcs.{$ENDIF}Polygon(Device.Handle, Vrcholy, PocetVrcholu);
      PolyPolygon(Device.Handle, Coords, Lengths, PolygonsCount);
   end
   else
   if wordbool(Podklad) then
   begin
      Device.Brush.Style := bsSolid;
      if ByTrueColor then Device.Brush.Color := trueColor
                     else Device.Brush.Color := DejBarvicku(Podklad);
      Device.Pen.Style:= psClear;
      //{$IFNDEF WIN32}WinProcs.{$ENDIF}Polygon(Device.Handle, Vrcholy, PocetVrcholu);
      PolyPolygon(Device.Handle, Coords, Lengths, PolygonsCount);
   end
   else
   if FillBackGround then
   begin
      Device.Brush.Style := bsSolid;
      Device.Brush.Color := DejBarvicku(Podklad);
      Device.Pen.Style:= psClear;
      //{$IFNDEF WIN32}WinProcs.{$ENDIF}Polygon(Device.Handle, Vrcholy, PocetVrcholu);
      PolyPolygon(Device.Handle, Coords, Lengths, PolygonsCount);
   end;
   if Status = 33 then exit; // podklad staci, zbytek je stejny

   // referencni souradnice ... kvuli tile device a navazovani sraf ppk 2010
   RefX := Device.Projection.GetPageX(aRefX);
   RefY := Device.Projection.GetPageY(aRefY);
   // -----------------------------------------------------------------------

   PocetHran := 0;
   for i := 0 to PolygonsCount - 1 do
   begin
      PocetHran := PocetHran + TLengthArray(Lengths)[i];
   end;
   GetMem(Hranice, {PocetVrcholu}PocetHran * SizeOf(Hrana));

   Device.Pen.Style := psSolid;
   Device.Pen.Width := 1;
   AktualniVrstva := Znacky;
   while AktualniVrstva <> nil do
   begin
      AktualniSrafa := AktualniVrstva.Srafy;
      if (AktualniVrstva.Uhel = 0) or (AktualniVrstva.Uhel = 2) then
         VyplnRadkovymRozkladem  (Device, Coords, Lengths, PolygonsCount)
      else
         VyplnRadkovymRozklademSikmo(Device, Coords, Lengths, PolygonsCount);
      AktualniVrstva := AktualniVrstva.Dalsi;
   end;
   if Assigned(Hranice) then FreeMem(Hranice, {PocetVrcholu}PocetHran * SizeOf(Hrana));
end;




{-----------------------------------------------------------}
procedure TPlosnaZnacka.VyplnRadkovymRozkladem ( Device: TDevice;
                                                 var Coords,Lengths; PolygonsCount: integer);
var
  PocetHran, PrvniHrana, PosledniHrana,
  Radek, NejnizsiY, PocetPruseciku : integer;
  CD: Integer;
  //Bv: Word;

  i: word;
  MaxIS: word;      { Maximalni index pole sraf }
  ISraf: word;      { index pole sraf }
  //ASRF: TSrafa;

begin {VyplnRadkovymRozkladem}
   if not Assigned(Hranice) then exit;
   { Tady by mozna bodla chybova hlaska ... neco o pameti a tak.}


   { Naplneni pole sraf ... pouzivat budu jen pero }
   { --------------------------------------------- }
   GetMem(PoleSraf, AktualniVrstva.PocetSraf * SizeOf(TSimpleSrafa));
   if not Assigned(Hranice) then exit;
   SirkaSraf := 0;
   //ASRF := AktualniSrafa;
   for i := 1 to AktualniVrstva.PocetSraf do
   begin
      PoleSraf^[i].Sirka      := AktualniSrafa.Sirka;
      if AktualniSrafa.UseExternalColor then
         PoleSraf^[i].Barva := ExternalColor
      else
      if AktualniSrafa.ByTrueColor then
         PoleSraf^[i].Barva := AktualniSrafa.TrueColor
      else
         PoleSraf^[i].Barva := DejBarvicku(AktualniSrafa.Barva);
      PoleSraf^[i].Vzdalenost := AktualniSrafa.Vzdalenost;
      inc(SirkaSraf,PoleSraf^[i].Sirka);
      inc(SirkaSraf,PoleSraf^[i].Vzdalenost);
      AktualniSrafa := AktualniSrafa.Dalsi;
   end;

   case AktualniVrstva.Uhel of
      2:  UvodniZpracovaniHraniceSvisle ( Device, Coords, Lengths, PolygonsCount,
                                          PocetHran, NejnizsiY);
     else UvodniZpracovaniHranice ( Device, Coords, Lengths, PolygonsCount,
                                    PocetHran, NejnizsiY);
   end;{case}
   if PocetHran < 1 then
   begin
      if Assigned(PoleSraf) then
         FreeMem(PoleSraf, AktualniVrstva.PocetSraf * SizeOf(TSimpleSrafa));
      exit;
   end;

   PrvniHrana := 1;              { inicializace ukazatelu }
   PosledniHrana := 1;           { do setrideneho seznamu }
   Radek := Hranice^[1].y_horni;

   MaxIS := AktualniVrstva.PocetSraf;
   ISraf := 1;
   Device.Pen.Style := psSolid;
   Device.Pen.Color := PoleSraf^[ISraf].Barva;
   //CD := AktualniSrafa.Sirka;
   Dira := Ne;
   //***tile2010***
   if  AktualniVrstva.Uhel = 2 then
      CD := abs(Radek-RefX) mod SirkaSraf
   else
      CD := abs(Radek-RefY) mod SirkaSraf;
   CD := SirkaSraf - CD;

     //AktualniSrafa := aSRF;
     begin
        { Sherlockuji Holmesuji tu spravnou srafu, kterou zacnu }
        { ----------------------------------------------------- }
        for ISraf := 1 to MaxIS do
        begin
           if CD < PoleSraf^[ISraf].Sirka then
           begin
             CD := PoleSraf^[ISraf].Sirka - CD;
             break;
           end
           else dec(CD,PoleSraf^[ISraf].Sirka);

           if CD < PoleSraf^[ISraf].Vzdalenost then
           begin
             CD := PoleSraf^[ISraf].Vzdalenost - CD;
             Dira := Ano;
             break;
           end
           else dec(CD,PoleSraf^[ISraf].Vzdalenost);
           AktualniSrafa := AktualniSrafa.Dalsi;
           if AktualniSrafa.dx > 0 then
           begin
              case AktualniVrstva.Uhel of
                 2 : RefY := RefY - AktualniSrafa.dx;
              else
                 RefX := RefX - AktualniSrafa.dx;
              end;
           end;
        end;
     end;
  if CD = 0 then
     CD := AktualniSrafa.Sirka;

  //---------------------------------------
  while Radek >= NejnizsiY do
  begin
     AktualizujSeznamHran ( PocetHran, Radek,
                              PrvniHrana, PosledniHrana);
     if not Dira then
     begin
        NalezniPrusecikyY ( Radek, PocetPruseciku,
                            PrvniHrana, PosledniHrana);
        case AktualniVrstva.Uhel of
          2 : KresliUsekySvisle(Device, Radek, PocetPruseciku, PrvniHrana);
          else
              KresliUseky      (Device, Radek, PocetPruseciku, PrvniHrana);
        end;
     end;
     UpravSeznamHran (PrvniHrana, PosledniHrana);
     Dec(CD);
     if not wordbool(CD) then
     begin
        if not Dira and (AktualniSrafa.Vzdalenost > 0) then
        begin
           CD   := AktualniSrafa.Vzdalenost;
           Dira := Ano;
        end
        else
        begin
           AktualniSrafa := AktualniSrafa.Dalsi;
           if AktualniSrafa.dx > 0 then
           begin
              case AktualniVrstva.Uhel of
                 2 : RefY := RefY - AktualniSrafa.dx;
              else
                 RefX := RefX - AktualniSrafa.dx;
              end;
           end;
           inc(ISraf);
           if ISraf > MaxIS then ISraf := 1;
           Device.Pen.Color := PoleSraf^[ISraf].Barva;
           CD   := AktualniSrafa.Sirka;
           Dira := Ne;
        end;
     end;
     Dec(Radek);
  end; {while soupec}

  if Assigned(PoleSraf) then
     FreeMem(PoleSraf, MaxIS * SizeOf(TSimpleSrafa));
end; {VyplnRadkovymRozkladem}



{------------------------------------------------------------------------}

procedure TPlosnaZnacka.VyplnRadkovymRozklademSikmo (Device: TDevice;
                                                    var Coords,Lengths; PolygonsCount: integer);
var
  PocetHran, PrvniHrana, PosledniHrana,
  Radek, NejnizsiY, PocetPruseciku : integer;
  //CD: Integer;
  //Bv: Word;
  i: integer;
begin {VyplnRadkovymRozklademSikmo}
  if not Assigned(Hranice) then exit;
  { Tady by mozna bodla chybova hlaska ... neco o pameti a tak.}

  { Naplneni pole sraf }
  { ------------------ }
  GetMem(PoleSraf, AktualniVrstva.PocetSraf * SizeOf(TSimpleSrafa));
  if not Assigned(Hranice) then exit;
  SirkaSraf := 0;
  for i := 1 to AktualniVrstva.PocetSraf do
  begin
     PoleSraf^[i].Sirka      := AktualniSrafa.Sirka;

     if AktualniSrafa.UseExternalColor then
        PoleSraf^[i].Barva := ExternalColor
     else
     if AktualniSrafa.ByTrueColor then
        PoleSraf^[i].Barva      := AktualniSrafa.TrueColor
     else
        PoleSraf^[i].Barva      := DejBarvicku(AktualniSrafa.Barva);

     PoleSraf^[i].Vzdalenost := AktualniSrafa.Vzdalenost;
     PoleSraf^[i].Vzor := AktualniSrafa.Vzor;
     PoleSraf^[i].V1 := AktualniSrafa.vzVzd1;
     PoleSraf^[i].D := AktualniSrafa.VzDelka;
     PoleSraf^[i].V2 := AktualniSrafa.vzVzd2;
     PoleSraf^[i].DV := AktualniSrafa.DelkaVzoru;

     inc(SirkaSraf,PoleSraf^[i].Sirka);
     inc(SirkaSraf,PoleSraf^[i].Vzdalenost);
     AktualniSrafa := AktualniSrafa.Dalsi;
  end;


  UvodniZpracovaniHranice ( Device,  Coords, Lengths, PolygonsCount,
                            PocetHran, NejnizsiY);
  if PocetHran > 1 then
  begin
     PrvniHrana := 1;              { inicializace ukazatelu }
     PosledniHrana := 1;           { do setrideneho seznamu }
     Radek := Hranice^[1].y_horni;
     {
     ISraf := 0;
     }
     //***Tile2010***//BaseLine := BaseLineValue ;
     if AktualniVrstva.Uhel = 1 then
        BaseLine := BaseLineValue - (Radek - RefY)
     else
        BaseLine := BaseLineValue + (Radek - RefY);
     // ------------------------------------------
     Dira := Ne;
     (*
     {!}ShowMessage(IntToStr(Radek)+ ' >=  ' + IntToStr(NejnizsiY));
     *)


     while Radek >= NejnizsiY do
     begin
        AktualizujSeznamHran ( PocetHran, Radek,
                                 PrvniHrana, PosledniHrana);
        NalezniPrusecikyY ( Radek, PocetPruseciku,
                            PrvniHrana, PosledniHrana);
        KresliUsekySikmo  ( Device, Radek, PocetPruseciku, PrvniHrana);
        UpravSeznamHran   ( PrvniHrana, PosledniHrana);
        Dec(Radek);
        if AktualniVrstva.Uhel = 1 then inc(BaseLine)
                                   else dec(BaseLine);
     end;{while radek}
   end;
   if Assigned(PoleSraf) then
      FreeMem(PoleSraf, AktualniVrstva.PocetSraf * SizeOf(TSimpleSrafa));
end; {VyplnRadkovymRozklademSikmo}

{-----------------------------------------------------------}

{
  ***********************************************
  *          Tela metod TPlosneZnacky           *
  ***********************************************
}

constructor TPlosneZnacky.CreateAll(ASoubor: string);
begin
  inherited Create;
  Nabidka := false;
  Name := aSoubor;
end;


{-----------------------------------------------------------}

procedure   TPlosneZnacky.NastavNabidku;
begin
  if (not Nabidka)  then
  begin
     FreeAll;
     Nabidka := Ano;
  end;
end;

{-----------------------------------------------------------}
procedure   TPlosneZnacky.ZrusNabidku;
begin
  if Nabidka then
  begin
     FreeAll;
     Nabidka    := Ne;
  end;
end;

{-----------------------------------------------------------}
function    TPlosneZnacky.PridejZnackuDleKodu( AKod: longInt): TPlosnaZnacka;
var
  Ctenar       : TCteniPlosnychZnacek;
  OK           : boolean;
  PlosnaZnacka: TPlosnaZnacka;
begin
  //PlosnaZnacka := nil;
  Ctenar := TCteniPlosnychZnacek.Create(Name, OK);
  Ctenar.Device := Device;
  if OK then with Ctenar do
  begin
     PlosnaZnacka := Ctenar.CtiPlosnouZnacku( AKod);
     if Assigned(PlosnaZnacka) then AddElement(PlosnaZnacka);
     result := PlosnaZnacka;
  end
  else result := nil;
  Ctenar.Free;
end;

{-----------------------------------------------------------}
function    TPlosneZnacky.VratZnackuDleKodu(AKod: longInt): TPlosnaZnacka;
var
  Znacka: TPlosnaZnacka;
  i: longInt;
begin
   Znacka := nil;
   for i := 0 to Count -1 do
   begin
      Znacka := TPlosnaZnacka(Elements[i]);
      if Znacka.Kod = AKod then break;
      Znacka := nil;
   end;
   if not assigned(Znacka) then Znacka := PridejZnackuDleKodu(AKod);
   result := Znacka;
end;

{-----------------------------------------------------------}



{
  ***********************************************
  *       Tela metod TCteniPlosnychZnacek       *
  ***********************************************
}



function  TCteniPlosnychZnacek.CtiPlosnouZnacku(Kod: longInt): TPlosnaZnacka;
var
  PlosnaZnacka: TPlosnaZnacka;
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;

begin
  PlosnaZnacka := TPlosnaZnacka.Create;
  BackgroundOnly := true;
  Background := -1;

  { Nacitame Znacku s konkretnim kodem - ta se musi ovsem nejdriv najit }
  { ------------------------------------------------------------------- }
  if longBool(Kod) and (Kod > 999) then
  begin
     PlosnaZnacka.Kod := -1;
     repeat
        { Hledam Liniovou Znacku }
        { ---------------------- }
        repeat
           DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                      NazevParametru, HodnotaParametru);
        until (JeToInfo and (HodnotaParametru = pzPlosnaZnacka)) or PosledniRadek;
        { Kontrola kodu }
        if not PosledniRadek then
        begin
           DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                      NazevParametru, HodnotaParametru);
           if JeToParametr and (NazevParametru = pzKod) then
              PlosnaZnacka.Kod :=  DejLongIntParametr {else
           if JeToParametr and (NazevParametru = pzNazev) then
              PlosnaZnacka^.Nazev :=  HodnotaParametru} ;
        end;
     until (PlosnaZnacka.Kod = Kod) or PosledniRadek ;
     if PosledniRadek then
     begin
        { Zadna takova znacka tady nikdy nebyla }
        { ------------------------------------- }
        PlosnaZnacka.Free;
        result := nil;
        exit;
     end;
  end;
  { Vlastni nacitani znacky }
  { ----------------------- }
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     { Kod }
     { --- }
     if JeToParametr and (NazevParametru = pzKod) then
        PlosnaZnacka.Kod :=  DejLongIntParametr
     else
     { Nazev }
     { ----- }
     if JeToParametr and (NazevParametru = pzNazev) then
        PlosnaZnacka.Nazev :=  HodnotaParametru
     else
     { NahradniZnacka }
     { -------------- }
     if JeToParametr and (NazevParametru = pzNahradniZnacka) then
        PlosnaZnacka.NahradniZnacka :=  DejIntParametr
     else
     { Podklad }
     { ------- }
     if JeToParametr and (NazevParametru = pzPodklad) then
     begin
        PlosnaZnacka.Podklad :=  DejIntParametr;
        Background := PlosnaZnacka.Podklad
     end
     else
     { Zakladni znacka }
     { --------------- }
     if JeToParametr and (NazevParametru = pzZakladniZnacka) then
        PlosnaZnacka.ZakladniZnacka :=  DejIntParametr
     else
     { VrstvaSraf }
     { ---------- }
     if JeToInfo and (HodnotaParametru = pzVrstvaSraf) then
        PlosnaZnacka.PridejZnacku(CtiVrstvu);
  until JeToInfo and (HodnotaParametru = pzEnd);

  if (PlosnaZnacka.Kod > -1) and
     ((PlosnaZnacka.ZakladniZnacka > 0) or
      Assigned(PlosnaZnacka.Znacky)) then
  begin
     CtiPlosnouZnacku := PlosnaZnacka;
     if BackGroundOnly then PlosnaZnacka.Status := 33;
  end
  else
  begin
     result := nil;
     PlosnaZnacka.Free;
  end;
end;

{-----------------------------------------------------------}
function  TCteniPlosnychZnacek.CtiVrstvu: TVrstvaSraf;
var
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;
  Vrstva: TVrstvaSraf;
  Srafa: TSrafa;
  PosledniSrafa: TSrafa;
  PomUhel: double;
begin
  PosledniSrafa := nil;
  Vrstva := TVrstvaSraf.Create;
  Vrstva.PocetSraf := 0;
  Vrstva.Uhel  := 0;
  Vrstva.Srafy := nil;
  Vrstva.Dalsi := nil;
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     { Uhel }
     { ---------- }
     if JeToParametr and (NazevParametru = pzUhel) then
     begin
        PomUhel:= DejRealParametr / 45;
        Vrstva.Uhel := abs(round(PomUhel));
        if Vrstva.Uhel >= 4 then
           Vrstva.Uhel := Vrstva.Uhel-
                          (4*(Vrstva.Uhel div 4));
     end
     else
     { Srafa }
     { ----- }
     if JeToInfo and (HodnotaParametru = pzSrafa) then
     begin
        Srafa := CtiSrafu(Vrstva.Uhel);
        if Assigned(Srafa) then
        begin
           if not Assigned(Vrstva.Srafy) then PosledniSrafa := Srafa;
           Srafa.Dalsi := Vrstva.Srafy;
           Vrstva.Srafy := Srafa;
           { Posledni srafa ukazuje na prvni ... to je veda }
           { ---------------------------------------------- }
           PosledniSrafa.Dalsi := Srafa;
           if Vrstva.Uhel in [1,3] then
           begin
              if Srafa.Sirka = 0 then Srafa.Sirka := 1
              else
              begin
                 PomUhel := Srafa.Sirka;
                 PomUhel := SQRT(2*SQR(PomUhel));
                 if PomUhel > MaxInt then PomUhel := MaxInt;
                 Srafa.Sirka      := round(PomUhel);
              end;
              if Srafa.Vzdalenost = 0 then Srafa.Vzdalenost := 1
              else
              begin
                 PomUhel := Srafa.Vzdalenost;
                 PomUhel := SQRT(2*SQR(PomUhel));
                 if PomUhel > MaxInt then PomUhel := MaxInt;
                 Srafa.Vzdalenost := round(PomUhel);;
              end;
              inc(Srafa.Vzdalenost);
              dec(Srafa.Sirka);
           end;

           { ...a zvysim pocet sraf }
           { ---------------------- }
           Inc(Vrstva.PocetSraf);
        end;
     end;
  until JeToInfo and (HodnotaParametru = pzEnd);
  if Assigned(Vrstva.Srafy) then
     result := Vrstva
  else
  begin
     result := nil;
     Vrstva.Free;
  end;
end;

{-----------------------------------------------------------}
{ Hodnota je automaticky zkrouhnuta na MaxInt/4 }
function TCteniPlosnychZnacek.MilimetryNaObrHoriz(mm: double): longInt;
const
  MaxIQ = MaxInt div 4;
var
  Pom: longInt;
  PomR: double;
begin
   PomR := Device.Projection.GetPageLengthHoriz1(mm/1000 * Device.Projection.VirtualScale);
   if PomR > MaxIQ then PomR := MaxIQ;
   Pom := round(PomR);
   if not longBool(Pom) and (mm > 0 ) then Pom := 1;
   result := Pom;
end;

function TCteniPlosnychZnacek.MilimetryNaObrVert(mm: double): longInt;
const
  MaxIQ = MaxInt div 4;
var
  Pom: longInt;
  PomR: double;
begin
   PomR := Device.Projection.GetPageLengthVert1(mm/1000 * Device.Projection.VirtualScale);
   if PomR > MaxIQ then PomR := MaxIQ;
   Pom := round(PomR);
   if not longBool(Pom) and (mm > 0 ) then Pom := 1;
   result := Pom;
end;

{-----------------------------------------------------------}

function  TCteniPlosnychZnacek.CtiSrafu(aUhel: byte): TSrafa;
var
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;
  Srafa: TSrafa;
  PomLong: integer;
begin
  Srafa := TSrafa.Create;
  Srafa.Sirka      := 0;
  Srafa.Barva      := 0;
  Srafa.Vzdalenost := 0;
  Srafa.Vzor       := Ne;
  Srafa.vzVzd1     := 0;
  Srafa.vzDelka    := 0;
  Srafa.vzVzd2     := 0;
  Srafa.DelkaVzoru := 0;
  Srafa.x          := 0;
  Srafa.dx         := 0;
  Srafa.Dalsi      := nil;
  Srafa.UseExternalColor := false;
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     { Sirka }
     { ----- }
     if JeToParametr and (NazevParametru = pzSirka) then
     begin
        case aUhel of
           0,4: Srafa.Sirka := MilimetryNaObrVert(DejRealParametr);
        else
           Srafa.Sirka := MilimetryNaObrHoriz(DejRealParametr);
        end;
     end
     else
     { Barva }
     { ----- }
     if JeToParametr and (NazevParametru = pzBarva) then
     begin
        Srafa.Barva := DejIntParametr;
        if BackgroundOnly and (Srafa.Barva <> Background) then BackgroundOnly := false;
        if Srafa.Barva = -1 then
        begin
           Srafa.UseExternalColor := true;
           BackgroundOnly := false;
        end;
     end
     else
     { Vzdalenost }
     { ---------- }
     if JeToParametr and (NazevParametru = pzVzdalenost) then
     begin
        case aUhel of
           0,4: Srafa.Vzdalenost := MilimetryNaObrVert(DejRealParametr);
        else
           Srafa.Vzdalenost := MilimetryNaObrHoriz(DejRealParametr);
        end;
     end
     else
     { D1 }
     { -- }
     if JeToParametr and (NazevParametru = pzD1) then
     begin
        case aUhel of
           0,4: Srafa.VzVzd1 := MilimetryNaObrHoriz(DejRealParametr);
        else
           Srafa.VzVzd1 := MilimetryNaObrVert(DejRealParametr);
        end;
     end
     else
     { dx }
     { -- }
     if JeToParametr and (NazevParametru = pzDX) then
     begin
         Srafa.dX := MilimetryNaObrHoriz(DejRealParametr);
     end
     else
     { x }
     { -- }
     if JeToParametr and (NazevParametru = pzX) then
     begin
         Srafa.X := DejLongIntParametr;
     end
     else
     { DelkaVzoru }
     { ---------- }
     if JeToParametr and (NazevParametru = pzDelkaVzoru) then
     begin
        case aUhel of
           0,4: Srafa.VzDelka := MilimetryNaObrHoriz(DejRealParametr);
        else
           Srafa.VzDelka := MilimetryNaObrVert(DejRealParametr);
        end;
     end
     else
     { D2 }
     { -- }
     if JeToParametr and (NazevParametru = pzD2) then
     begin
        case aUhel of
           0,4: Srafa.VzVzd2 := MilimetryNaObrHoriz(DejRealParametr);
        else
           Srafa.VzVzd2 := MilimetryNaObrVert(DejRealParametr);
        end;
     end;
  until JeToInfo and (HodnotaParametru = pzEnd);

  if (Srafa.Sirka > 0) then
  begin
     if Srafa.vzDelka > 0 then Srafa.Vzor := Ano;
     if Srafa.Vzor then
     begin
        if (Srafa.vzDelka <= 0) or
           ((Srafa.vzVzd1 = 0) and (Srafa.vzVzd2 = 0)) then Srafa.Vzor := Ne;
        PomLong := {longInt}(Srafa.vzVzd1) + Srafa.vzDelka + Srafa.vzVzd2;
        //if PomLong > MaxInt then PomLong := MaxInt;
        Srafa.DelkaVzoru := PomLong;
     end;
     result := Srafa;
  end
  else
  begin
     result := nil;
     Srafa.Free;
  end;
end;

{-----------------------------------------------------------}
function  TCteniPlosnychZnacek.DejBoolParametr: boolean;
var
  CtiR: TCtiRadekClass;

begin
  CtiR:= TCtiRadekClass.Create(Hodnota);
  DejBoolParametr:= CtiR.DejBoolean;
  CtiR.Free
end;

{-----------------------------------------------------------}
function  TCteniPlosnychZnacek.DejIntParametr: Integer;
var
  CtiR: TCtiRadekClass;

begin
  CtiR:= TCtiRadekClass.Create(Hodnota);
  DejIntParametr:= CtiR.DejInteger;
  CtiR.Free
end;

{-----------------------------------------------------------}

procedure TPlosneZnacky.VratListKodu(const aList: TStrings);
var
  Ctenar       : TCteniPlosnychZnacek;
  OK           : boolean;
begin
  //PlosnaZnacka := nil;
  Ctenar := TCteniPlosnychZnacek.Create(Name, OK);
  Ctenar.Device := Device;
  if OK then
  begin
     Ctenar.VratListKodu(aList);
  end;
  Ctenar.Free;
end;

procedure TCteniPlosnychZnacek.VratListKodu(const aList: TStrings);
var
  PlosnaZnacka: TPlosnaZnacka;
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;
  kod: integer;
begin
   if aList = nil then exit;
   aList.Clear;
   repeat
      DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                 NazevParametru, HodnotaParametru);
      if JeToParametr and (NazevParametru = pzKod) then
      begin
         Kod :=  DejLongIntParametr;
         aList.Add(IntToStr(Kod));
      end;
   until PosledniRadek ;
end;

procedure TCteniPlosnychZnacek.CtiVsechnyZnacky(E: Tentity);
var
  PlosnaZnacka: TPlosnaZnacka;
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;

begin
   if E = nil then exit;
   repeat
      { Hledam Liniovou Znacku }
      { ---------------------- }
      repeat
         DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                    NazevParametru, HodnotaParametru);
      until (JeToInfo and (HodnotaParametru = pzPlosnaZnacka)) or PosledniRadek;
      // Nasli jsme znacku, jdeme ji nacist
      if not PosledniRadek then
      begin
         PlosnaZnacka := TPlosnaZnacka.Create;
         PlosnaZnacka.Kod := -1;
         BackgroundOnly := true;
         Background := -1;
         { Vlastni nacitani znacky }
         { ----------------------- }
         repeat
            DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                       NazevParametru, HodnotaParametru);
            { Kod }
            { --- }
            if JeToParametr and (NazevParametru = pzKod) then
               PlosnaZnacka.Kod :=  DejLongIntParametr
            else
            { Nazev }
            { ----- }
            if JeToParametr and (NazevParametru = pzNazev) then
               PlosnaZnacka.Nazev :=  HodnotaParametru
            else
            { NahradniZnacka }
            { -------------- }
            if JeToParametr and (NazevParametru = pzNahradniZnacka) then
               PlosnaZnacka.NahradniZnacka :=  DejIntParametr
            else
            { Podklad }
            { ------- }
            if JeToParametr and (NazevParametru = pzPodklad) then
            begin
               PlosnaZnacka.Podklad :=  DejIntParametr;
               Background := PlosnaZnacka.Podklad
            end
            else
            { Zakladni znacka }
            { --------------- }
            if JeToParametr and (NazevParametru = pzZakladniZnacka) then
               PlosnaZnacka.ZakladniZnacka :=  DejIntParametr
            else
            { VrstvaSraf }
            { ---------- }
            if JeToInfo and (HodnotaParametru = pzVrstvaSraf) then
               PlosnaZnacka.PridejZnacku(CtiVrstvu);
         until JeToInfo and (HodnotaParametru = pzEnd);

         if (PlosnaZnacka.Kod > -1) and
            ((PlosnaZnacka.ZakladniZnacka > 0) or
             Assigned(PlosnaZnacka.Znacky)) then
         begin
            E.AddElement(PlosnaZnacka);
            if BackGroundOnly then PlosnaZnacka.Status := 33;
         end
         else
         begin
            PlosnaZnacka.Free;
         end;
      end;
   until PosledniRadek ;
end;

procedure TPlosneZnacky.PridejVsechnyZnacky;
var
  Ctenar       : TCteniPlosnychZnacek;
  OK           : boolean;
begin
   Ctenar := TCteniPlosnychZnacek.Create(Name, OK);
   Ctenar.Device := Device;
   if OK then with Ctenar do
   begin
      Ctenar.CtiVsechnyZnacky(Self);
   end;
end;

procedure TPlosnaZnacka.SetRefX(const Value: integer);
begin
  FRefX := Value;
end;

procedure TPlosnaZnacka.SetRefY(const Value: integer);
begin
  FRefY := Value;
end;

END.
