unit StrProc;

interface

uses
     MathLib;

const
  PocZnPrezDatumStr = 10;
  PocZnPrezMemoStr  = 6;
  PocZnNormDatumStr = 8;
  PocZnCasStr       = 8;
  PocZnDenVTydnuStr = 7;
  PocZnRealStr      = 21;
  PocZnIntegerStr   = 7;
  PocZnLongIntStr   = 14;
  PocZnBooleanStr   = 7;
  PocZnRadStr       = 8;
  PocZnGradStr      = 10;
  PocZnStuMinSekStr = 15;
  PocZnJmFilStr     = 12;


  PocZnDatumu       =  8;



type
  TPoleZn          = array[1..65528] of byte;
  TPoleZnPtr       = ^TPoleZn;
  TMnozinaZnaku    = set of char;
  TMnozinaZnakuPtr = ^TMnozinaZnaku;

const
  INTCISLOZN  :TMnozinaZnaku = ['0'..'9', '+', '-', ' '];
  REALCISLOZN :TMnozinaZnaku = ['0'..'9', '+', '-','.', ' '];
  DATUMZN     :TMnozinaZnaku = ['0'..'9','.'];
  BOOLEANZN   :TMnozinaZnaku = ['T', 't', 'F', 'f'];

  JMSOUBZN    :TMnozinaZnaku = [chr (33)..chr (255)]
      -['|','','%','.','\',':','"','/','[',']','|','<','>','+','=',';',','];

type
  TStr12        = string[12];
  str15         = string[15];
  TJmeno        = string[10];
  TStr10        = string[10];
  TNormDatumStr = string[PocZnNormDatumStr];
  TPrezDatumStr = string[PocZnPrezDatumStr];
  TCasStr       = string[PocZnCasStr];
  TDenVTydnuStr = string[PocZnDenVTydnuStr];

  TString21     = string[21];
  TRealStr      = string[PocZnRealStr];
  TByteStr      = string[3];
  TWordStr      = string[6];
  TIntegerStr   = string[PocZnIntegerStr];
  TLongIntStr   = string[PocZnLongIntStr];
  TBooleanStr   = string[PocZnBooleanStr];

  TRadStr       = string[PocZnRadStr];
  TGradStr      = string[PocZnGradStr];
  TStuMinSekStr = string[PocZnStuMinSekStr];

  TJmFilStr     = string[PocZnJmFilStr];

  TPopisStr     = string[42];

{
  TPathPtr         = ^pathStr;
  TDirPtr          = ^dirStr;

  TNamePtr         = ^nameStr;
 }

  TNormDatumStrPtr = ^TNormDatumStr;
  TPrezDatumStrPtr = ^TPrezDatumStr;
  TStringPtr       = ^string;
  TString21Ptr     = ^TString21;
  TRealStrPtr      = ^TRealStr;
  TIntegerStrPtr   = ^TIntegerStr;
  TLongIntStrPtr   = ^TLongIntStr;
  TByteStrPtr      = ^TByteStr;
  TWordStrPtr      = ^TWordStr;

  TIntegerPtr      = ^integer;
  TLongIntPtr      = ^longInt;
  TRealPtr         = ^real48;
  TBytePtr         = ^byte;
  TBooleanPtr      = ^boolean;

type
  TSeznamStrPtr = ^TSeznamStr;
  TSeznamStr    = record
    DalsiPtr   : TSeznamStrPtr;
    PredesliPtr: TSeznamStrPtr;
    PolStr     : string;
  end;


  TPopisPtr = ^TPopis;
  TPopis    = record
    DalsiPtr: TPopisPtr;
    Popis   : TString21;
  end;

  TDatumStr     = string[PocZnDatumu];
  TZobrDatumStr = string[PocZnDatumu +2];


const
  ZNFALSE: TBooleanStr = #1;
  ZNTRUE : TBooleanStr = #2;


(*
procedure PrevedStrNaDouble(Retez: string; var Hodnota: double; var OKej: boolean);
function DejBoolCislem(L: boolean): byte;


function Rim12(W: word): string;

*)
function UpStr (S: string): string;

(*
function DejStrZArr(var StrArray): string;

function DejBezExt (S: string): string;


function BStrA(B: boolean): TLongIntStr;
function BStrC(B: boolean): TLongIntStr;

function LStr       (L: longInt): TLongIntStr;
function LPrezStr   (L: longInt): TLongIntStr;

function LStr0      (L: longInt; CelkemZn: byte): TLongIntStr;
function LPrezStr0  (L: longInt; CelkemZn: byte): TLongIntStr;

function LStrSP     (L: longInt; CelkemZn: byte): TLongIntStr;
function LPrezStrSP (L: longInt; CelkemZn: byte): TLongIntStr;



function RStr       (R: real48; DesMist: byte): TRealStr;
function SourStr    (const Sour: TSour): string;
function ObdelStr   (const Obdelnik: TObdelnik): string;
function RPrezStr   (R: real48; DesMist: byte): TRealStr;

function RStr0      (R: real48; CelkemZn, DesMist: byte): TRealStr;
function RPrezStr0  (R: real48; CelkemZn, DesMist: byte): TRealStr;

function RStrSP     (R: real48; CelkemZn, DesMist: byte): TRealStr;
function RPrezStrSP (R: real48; CelkemZn, DesMist: byte): TRealStr;




function NormStrNaLPrezStr   (L: string): TLongIntStr;
function NormStrNaLPrezStr0  (L: string): TLongIntStr;
function NormStrNaLPrezStrSP (L: string; CelkemZn: byte): TLongIntStr;

function NormStrNaRPrezStr   (R: string): TRealStr;
function NormStrNaRPrezStr0  (R: string): TRealStr;
function NormStrNaRPrezStrSP (R: string; CelkemZn: byte): TRealStr;

function DejCistyNumStr  (NStr: string): string;
function NumStrNaNormStr (NStr: string; CelkMist: integer; DesMist: integer): string;
procedure LNumStrNaNormStr (CelkMist: byte; var S: string);

function RFormatDBStr (NStr: string;CelkMist: integer;DesMist: integer): string;
function LFormatDBStr (NStr: string; CelkMist: integer): string;
function SFormatDBStr (NStr: string; CelkMist: integer): string;
function BFormatDBStr (NStr: string): string;

procedure JmBezPravSP (var Jm: TStr10);


function DejNormDStr (D: TPrezDatumStr): TNormDatumStr;
function DejNormDObecnejiStr(D: string): string;
function DejPrezDStr (D: TNormDatumStr): TPrezDatumStr;

function DejDBNormDatumStr(Cas: longInt): string;


function DejPocetReal (OdCisla, DoCisla: real48; PocDesMist: byte): byte;
function DejPocetLInt (OdCisla, DoCisla: longInt): byte;

function DejMaxReal (PocMist, DesMist: byte): real48;
function DejMaxLInt (PocMist: byte): longInt;

function DejMinReal (PocMist, DesMist: byte): real48;
function DejMinLInt (PocMist: byte): longInt;


function StrStrSp(Retezec: string; Delka: byte): string;

function DejSPNaNul (S: string): string;
function DejBezSP   (const S: string): string;
function DejBez0    (NormStr: string): string;


function DejRadStr       (UhelVRad: real48): TStuMinSekStr;
function DejGradStr      (UhelVRad: real48): TStuMinSekStr;
function DejStuMinSekStr (UhelVrad: real48): TStuMinSekStr;
function DejStuMinRSekStr(UhelVRad: real48; DesMistSek: byte): TStuMinSekStr;


function DejDatCasStr(Time: longInt): string;

function DejSysCasStr      : TCasStr;
function DejSysNormDatumStr: TNormDatumStr;
function DejSysPrezDatumStr: TPrezDatumStr;
function DejSysDenVTydnuStr: TDenVTydnuStr;
*)
function BezVsechMezer(Retezec: string): string;
function BezVnejsichMezer(Retezec: string): string;
function JeMezera(const Retezec : string;
                  var   Retezec1: string;
                  var   Retezec2: string): boolean;
(*
function DejDoplSPZLeva  (Retezec: string; CelkZn: byte): string;
function DejDoplSPZPrava (Retezec: string; CelkZn: byte): string;


function DejMaxZnVyberuStr (S: string): byte;


function DejZobrDatumStr (const D: TDatumStr): TZobrDatumStr;
function DejDatumStr (D: TZobrDatumStr): TDatumStr;

function DejUriznutyStr(const Retez: string; Pocet: byte): string;



procedure NormLNumSP (CelkZn: byte; var AC);
procedure NormRNumSP (CelkZn, DesMist: byte; var AC);

procedure NormLNum0 (CelkZn: byte; var AC);
procedure NormRNum0 (CelkZn, DesMist: byte; var AC);

procedure NormChar (CelkZn: byte; var AC);

function DejPrezentacniHodnotuStr
         (Typ: char; Delka, DesMist: integer; Hodnota: string): string;

function StrZStr(Ret: string;
                 TypPolozky: char; DelkaRet, DesMist: integer): string;

procedure VratFormat(Retez: string;
                     var Parametr: string; var FDelka, FDesMist: integer);


function DejNormStr (Typ: char; ZdrCM,CilCM,CilDM: byte; var AC): string;



function DejOcistenyPathStr (Path: string): string;

function DejJmenoSouboruProVypis(FileName: string; Pocet: byte) : string;

function JmSoubNa30(JmSoub: string): string;

function KonJmSoubNa30 (JmSoub: string): string;
function DejKonJmSoub  (JmSoub: string; PocetZn: integer): string;

function JmBezSP (Jm: TStr10): TStr10;

function DejJmenoSExt(FileName: string): string;
function JmNa8 (Jm: string): string;

function OKVstupJm  (Jm : string): boolean;
function OKVstupExt (Ext: string): boolean;

function OKJmSoub  (Jm : string): boolean;
function OKExtSoub (Ext: string): boolean;

*)

implementation



(*

procedure PrevedStrNaDouble(Retez: string; var Hodnota: double; var OKej: boolean);
var
  Code: integer;

begin
  OKej:= false;

  if Retez <> '' then
  begin
    val(BezVnejsichMezer(Retez), Hodnota, Code);
    OKej:= Code = 0;
    if not OKej then Hodnota:= 0
  end
end;



function DejBoolCislem(L: boolean): byte;
begin
  if L then DejBoolCislem:= 1
  else DejBoolCislem:= 0
end;




function Rim12(W: word): string;
begin
  case W of
    1 : Rim12 := 'I';
    2 : Rim12 := 'II';
    3 : Rim12 := 'III';
    4 : Rim12 := 'IV';
    5 : Rim12 := 'V';
    6 : Rim12 := 'VI';
    7 : Rim12 := 'VII';
    8 : Rim12 := 'VIII';
    9 : Rim12 := 'IX';
    10: Rim12 := 'X';
    11: Rim12 := 'XI';
    12: Rim12 := 'XII';
    else Rim12 := '';
  end;
end;

{$IFNDEF Windows}
function JmNa8 (Jm: string): string;
var
  A: dirStr;
  J: nameStr;
  E: extStr;
begin
  fSplit (Jm, A, J, E);
  if Jm[1] = '.'
  then begin
    J := '..      ';
    E := '    ';
  end;
  while length (J) <> 8 do J := J + ' ';
  while length (E) <> 4 do E := E + ' ';
  JmNa8 := J + E;
end;

{$ENDIF}


*)
function UpStr (S: string): string;
var
  i: byte;
begin
  for i := 1 to length (S) do
  S[i]  := upCase (S[i]);
  UpStr := S;
end;

(*
{$IFNDEF Windows}
function DejStrZArr(var StrArray): string;
type
  TStrArray = array[0..255] of char;
var
  S: string;

begin
  byte(S[0]) := 0;

  while (byte(S[0]) < 255) and
        (TStrArray(StrArray)[byte(S[0])] <> #0)
  do inc(byte(S[0]));

  if (TStrArray(StrArray)[byte(S[0])] <> #0)
  then byte(S[0]) := 0
  else move (TStrArray(StrArray)[0], S[1], byte(S[0]));

  DejStrZArr := S;
end;
{$ENDIF}






function DejBezExt (S: string): string;
var
  Tecka: longInt;
  PosledniTecka: longInt;
  Pocet: longInt;
  PomS : string;

begin

  if S <> ''
  then begin
    PomS := S;

    Tecka := 100;

    while Tecka <> 0
    do begin
      PosledniTecka := Tecka;

      Tecka := pos ('.', PomS);

      if Tecka <> 0
      then PomS[Tecka] := '+';

    end;


    if PosledniTecka <> 100
    then begin
      Pocet := length (S) -PosledniTecka +1;
      dec (byte (S[0]), Pocet);
    end;
  end;

  DejBezExt := S;
end;





function BStrA(B: boolean): TLongIntStr;
begin
  if B then BStrA:= 'TRUE'
  else      BStrA:= 'FALSE'
end;



function BStrC(B: boolean): TLongIntStr;
begin
{$IFNDEF English}
{$IFNDEF Deutsch}

  if B then BStrC:= 'ANO'
  else      BStrC:= 'NE'

{$ENDIF}
{$ENDIF}

{$IFDEF English}

  if B then BStrC:= 'YES'
  else      BStrC:= 'NO'

{$ENDIF}

{$IFDEF Deutsch}

  if B then BStrC:= 'JA'
  else      BStrC:= 'NEIN'

{$ENDIF}


end;




function LStr (L: longInt): TLongIntStr;
var
  Pom: TLongIntStr;
begin
  Str (L, Pom);
  LStr := Pom;
end;







function LPrezStr (L: longInt): TLongIntStr;
var
  Pom   : string;
  i,Uk,j: integer;

begin
  Str (L, Pom);

  i  := 1;
  Uk := 0;
  j := length (Pom);

  if L < 0
  then j := j -1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', Pom, length(Pom) - Uk);
      inc (Uk);
    end;
    inc (i);
    inc (Uk);
  end;

  LPrezStr := Pom;
end;









function LStrSP (L: longInt; CelkemZn: byte): TLongIntStr;
var
  Pom: string;
begin
  Str (L:CelkemZn, Pom);
  LStrSP := Pom;

end;









function  LPrezStrSP (L: longInt; CelkemZn: byte): TLongIntStr;
var
  Pom, SP: string;
  j: integer;
begin
  Pom := LPrezStr (L);

  j := CelkemZn -length (Pom);

  if j > 0
  then begin
    FillChar (SP[1], j, ' ');
    byte (SP[0]) := j;
  end
  else SP := '';

  LPrezStrSP := SP +Pom;
end;






function LStr0 (L: longInt; CelkemZn: byte): TLongIntStr;
begin
  LStr0[0] := Chr(CelkemZn);

  if L < 0
  then begin
    L := abs(L);

    while CelkemZn > 0 do
    begin
      LStr0[CelkemZn] := chr(L mod 10 +ord('0'));
      L := L div 10;
      dec (CelkemZn);
    end;

    LStr0[1] := '-';
  end
  else begin
    while CelkemZn > 0 do
    begin
      LStr0[CelkemZn] := chr(L mod 10 +ord('0'));
      L := L div 10;
      dec (CelkemZn);
    end;
  end;
end;





function LStr0 (L: longInt; CelkemZn: byte): TLongIntStr;
var
  Pom, Null: string;
  j: integer;
begin
  Pom := LStr (abs(L));

  j := CelkemZn -length (Pom);

  if j > 0
  then begin
    FillChar (Null[1], j, '0');
    byte (Null[0]) := j;
  end
  else Null := '';

  if L < 0 then Null[1] := '-';

  LStr0 := Null +Pom;
end;









function LPrezStr0 (L: longInt; CelkemZn: byte): TLongIntStr;
var
  Pom   : TLongIntStr;
  i,Uk,j: integer;

begin
  Pom := LStr0 (abs (L), CelkemZn);

  i  := 1;
  Uk := 0;
  j := length (Pom);

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', Pom, length(Pom) - Uk);
      inc (Uk);
    end;
    inc (i);
    inc (Uk);
  end;

  while (length (Pom) > CelkemZn)
        and
        (
         (Pom[1] = '0')
         or
         (Pom[1] = ' ')
        )
  do delete (Pom, 1, 1);

  if L < 0
  then begin
    if (Pom[1] = '0')
       and
       (Pom[2] = ' ')
    then delete (Pom, 1, 1);

    if (Pom[1] = '0')
       or
       (Pom[1] = ' ')
    then Pom[1] := '-'
    else Pom := '-' +Pom;
  end;


  LPrezStr0 := Pom;
end;










function RStr (R: real48; DesMist: byte): TRealStr;
var
  Pom: string;

begin
  Str (R:22:DesMist, Pom);

  while Pom[1] = ' '
  do delete (Pom, 1, 1);

  RStr := Pom;
end;




function SourStr(const Sour: TSour): string;

begin
  SourStr:= RStr(Sour.Y,2) + ', ' + RStr(Sour.X,2);
end;




function ObdelStr   (const Obdelnik: TObdelnik): string;

begin
  ObdelStr:= SourStr(Obdelnik.PH) + '; ' + SourStr(Obdelnik.LD)
end;





function RPrezStr (R: real48; DesMist: byte): TRealStr;
var
  Pom: string ;
  i, j, Uk, Des: integer;

begin
  Pom := RStr (R, DesMist);

  i   := pos ('.', Pom);
  j   := i -1;

  if Pom[1] = '-'
  then j := j -1;

  Uk  := length (Pom) -i +1;
  i   := 1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', Pom, length (Pom) - Uk);
      inc (Uk);
    end;

    inc (i);
    inc (Uk);
  end;

  RPrezStr := Pom;
end;









function  RStrSP (R: real48; CelkemZn, DesMist: byte): TRealStr;
var
  Pom: string ;
begin
  Str (R:CelkemZn:DesMist, Pom);
  RStrSP := Pom;
end;








function RPrezStrSP (R: real48; CelkemZn, DesMist: byte): TRealStr;
var
  Pom: string;
  i  : integer;
begin
  Pom := RPrezStr (R, DesMist);

  for i := length (Pom) to CelkemZn -1
  do Pom := ' ' +Pom;

  RPrezStrSP := Pom;
end;












function RStr0 (R: real48; CelkemZn, DesMist: byte): TRealStr;
var
  Pom, Null: string;
  j: integer; 
begin
  Null := '';
  Pom  := RStr (abs (R), DesMist);
  j    := CelkemZn -length (Pom);

  if j > 0
  then begin
    FillChar (Null[1], j, '0');
    byte (Null[0]) := j;
    if R < 0 then Null[1] := '-';
  end
  else 
  if (j < 0) or (R < 0)
  then Pom := '';

  RStr0 := Null +Pom;
end;








function RPrezStr0  (R: real48; CelkemZn, DesMist: byte): TRealStr;
var
  Pom, Null: string;
  i,j, Uk: integer;

begin
  Pom := RStr0 (abs (R), CelkemZn, DesMist);

  i   := pos ('.', Pom);
  J   := i -1;
  Uk  := length (Pom) -i +1;
  i   := 1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', Pom, length (Pom) - Uk);
      inc (Uk);
    end;

    inc (i);
    inc (Uk);
  end;

  while (length (Pom) > CelkemZn)
        and
        (
         (Pom[1] = '0')
         or
         (Pom[1] = ' ')
        )
  do delete (Pom, 1, 1);

  if R < 0
  then begin
    if (Pom[1] = '0')
       and
       (Pom[2] = ' ')
    then delete (Pom, 1, 1);

    if (Pom[1] = '0')
       or
       (Pom[1] = ' ')
    then Pom[1] := '-'
    else Pom := '-' +Pom;
  end;

  RPrezStr0 := Pom;
end;








function DejBez0 (NormStr: string): string;
begin
  if NormStr[1] = '-'
  then begin
    while (NormStr[2] = '0')
          and
          (length (NormStr) > 2)
    do delete (NormStr, 2, 1);

    if NormStr[2] = '.'
    then insert ('0', NormStr, 2);
  end
  else begin
    while (NormStr[1] = '0')
          and
          (length (NormStr) > 1)
    do delete (NormStr, 1, 1);

    if NormStr[1] = '.'
    then insert ('0', NormStr, 1);
  end;

  DejBez0 := NormStr;
end;









function NormStrNaLPrezStr (L: string): TLongIntStr;
var
  i,j,Uk: integer;

begin
  L := DejBez0 (L);

  i  := 1;
  Uk := 0;
  j  := length (L);

  if L[1] = '-'
  then j := j -1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', L, length (L) - Uk);
      inc (Uk);
    end;
    inc (i);
    inc (Uk);
  end;

  NormStrNaLPrezStr := L;
end;









function NormStrNaLPrezStrSP (L: string; CelkemZn: byte): TLongIntStr;
var
  SP: string;
  j : integer;
begin
  L := NormStrNaLPrezStr (L);

  j := CelkemZn -length (L);

  if j > 0
  then begin
    FillChar (SP[1], j, ' ');
    byte (SP[0]) := j;
  end
  else SP := '';

  NormStrNaLPrezStrSP := SP +L;
end;









function NormStrNaLPrezStr0 (L: string): TLongIntStr;
var
  i,j,Uk: integer;

begin
  i  := 1;
  Uk := 0;
  j  := length (L);

  if L[1] = '-'
  then j := j -1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', L, length (L) - Uk);
      inc (Uk);
    end;
    inc (i);
    inc (Uk);
  end;

  NormStrNaLPrezStr0:= L;
end;






function NormStrNaRPrezStr (R: string): TRealStr;
var
  i, j, Uk, Des: integer;

begin
  R := DejBez0 (R);

  i   := pos ('.', R);
  j   := i -1;

  if R[1] = '-'
  then j := j -1;

  Uk  := length (R) -i +1;
  i   := 1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', R, length (R) -Uk);
      inc (Uk);
    end;

    inc (i);
    inc (Uk);
  end;

  NormStrNaRPrezStr:= R;
end;











function NormStrNaRPrezStrSP (R: string; CelkemZn: byte): TRealStr;
var
  SP: string;
  j : integer;
begin
  R := NormStrNaRPrezStr (R);

  j := CelkemZn -length (R);

  if j > 0
  then begin
    FillChar (SP[1], j, ' ');
    byte (SP[0]) := j;
  end
  else SP := '';

  NormStrNaRPrezStrSP:= SP +R;
end;












function NormStrNaRPrezStr0 (R: string): TRealStr;
var
  i, j, Uk, Des: integer;

begin
  i   := pos ('.', R);
  j   := i -1;

  if R[1] = '-'
  then j := j -1;

  Uk  := length (R) -i +1;
  i   := 1;

  while i < j do begin
    if (i mod 3) = 0
    then begin
      insert (' ', R, length (R) -Uk);
      inc (Uk);
    end;

    inc (i);
    inc (Uk);
  end;

  NormStrNaRPrezStr0:= R;
end;












function DejNormDStr (D: TPrezDatumStr): TNormDatumStr;
var
  Poz1Tecky: byte;
  Poz2Tecky: byte;

  Den  : string[2];
  Mesic: string[2];
  Rok  : string[4];

begin
  if D <> ''
  then begin
    Poz1Tecky  := pos ('.', D);

    if (Poz1Tecky = 2)
       or
       (Poz1Tecky = 3)
    then begin
      D[Poz1Tecky] := ':';
      Poz2Tecky    := pos ('.', D);;

      if (Poz2Tecky > 3)
         and
         (Poz2Tecky < 7)
      then begin
        Den   := copy (D, 1, Poz1Tecky -1);
        Mesic := copy (D, Poz1Tecky +1, Poz2Tecky -Poz1Tecky -1);
        Rok   := copy (D, Poz2Tecky +1, length (D) -Poz2Tecky);

        if length (Den)   < 2 then Den   := '0'  +Den;
        if length (Mesic) < 2 then Mesic := '0'  +Mesic;
        if length (Rok)   < 3 then Rok   := '19' +Rok;

        if not (Den > '31')
           and
           not (Mesic > '12')
        then DejNormDStr := Rok +Mesic +Den
        else DejNormDStr := '';
      end
      else DejNormDStr := '';
    end
    else DejNormDStr := '';
  end
  else DejNormDStr := '';
end;





function DejNormDObecnejiStr(D: string): string;
begin
  DejNormDObecnejiStr:= '';
  if D <> '' then
  begin
    if (pos('.',D) = 0) and (length(D) = 8) then
       DejNormDObecnejiStr:= D
    else
       DejNormDObecnejiStr:= DejNormDStr(D)
  end
end;



function DejDBNormDatumStr(Cas: longInt): string;
var
{$IFNDEF Windows}
  DT: DateTime;
{$ELSE}
  DT: TDateTime;
{$ENDIF}
  Den  : string[2];
  Mesic: string[2];
  Rok  : string[4];


begin
  unPackTime(Cas, DT);
  with DT do
    DejDBNormDatumStr:= LStr(Year) + LStr0(Month,2) + LStr0(Day,2)
end;




function DejPrezDStr (D: TNormDatumStr): TPrezDatumStr;
begin
  if D <> ''
  then DejPrezDStr := copy (D, 7, 2) +'.' +copy (D, 5, 2) +'.' +copy (D, 1, 4)
  else DejPrezDStr := '';
end;








function DejCistyNumStr (NStr: string): string;
begin
  NStr := DejBezSP (NStr);

  while (NStr[1] = '0')
        and
        (length (NStr) > 1)
  do delete (NStr, 1, 1);

  if NStr[1] = '+'
  then  begin
    delete (NStr, 1, 1);

    while (NStr[1] = '0')
          and
          (length (NStr) > 1)
    do delete (NStr, 1, 1);
  end;

  if NStr[1] = '-'
  then begin
    delete (NStr, 1, 1);

    while (NStr[1] = '0')
          and
          (length (NStr) > 1)
    do delete (NStr, 1, 1);

    if NStr[1] = '.'
    then NStr := '0' +NStr;

    if NStr[length (NStr)] = '.'
    then NStr := NStr +'0';

    NStr := '-' +NStr;
  end
  else begin
    if NStr[1] = '.'
    then NStr := '0' +NStr;

    if NStr[length (NStr)] = '.'
    then NStr := NStr +'0';
  end;

  DejCistyNumStr := NStr;
end;






function NumStrNaNormStr (
                          NStr    : string;
                          CelkMist: integer;
                          DesMist : integer
                         ): string;
var
  CelCast: string;
  DesCast: string;
  PozTec : integer;
  i      : integer;
  CelychZ: integer;
  Zaporne: boolean;

begin
  if CelkMist > 22
  then CelkMist := 22;

  if (CelkMist <= 0)
     or
     (CelkMist <= DesMist)
     or
     (NStr = '')
  then NumStrNaNormStr := ''
  else begin

    NStr := DejCistyNumStr (NStr);

    if NStr[1] = '-'
    then begin
      Zaporne := true;
      delete (NStr, 1, 1);
    end
    else Zaporne := false;

    PozTec := pos ('.', NStr);

    CelCast := NStr;
    DesCast := '';

    if PozTec <> 0
    then begin
      dec (byte (CelCast[0]), length (CelCast) -PozTec +1);
      DesCast := copy (NStr, PozTec +1, length (NStr) -PozTec);
    end;

    if (DesMist > 0)
    then CelychZ := CelkMist -DesMist -1
    else CelychZ := CelkMist;

    for i := length (CelCast) to CelychZ -1
    do CelCast := '0' +CelCast;

    if length (DesCast) > DesMist
    then byte (Descast[0]) := DesMist
    else begin
      for i := length (DesCast) to DesMist -1
      do DesCast := DesCast +'0';
    end;

    if DesMist > 0
    then NStr := CelCast +'.' +DesCast
    else NStr := CelCast;


    if Zaporne
    then begin
      if NStr[1] = '0'
      then NStr[1] := '-'
      else NStr := '-' +NStr;
    end;

    NumStrNaNormStr := NStr;
  end;
end;






function RFormatDBStr (NStr: string;CelkMist: integer;DesMist: integer): string;
var
  CelCast: string;
  DesCast: string;
  PozTec : integer;
  i      : integer;
  CelychZ: integer;
  Zaporne: boolean;

begin
  if (CelkMist <= 0) or
     (CelkMist <= DesMist)or
     (NStr = '')
  then begin
    RFormatDBStr := '';
    exit;
  end;


  NStr := DejCistyNumStr (NStr);

  if length (NStr) > CelkMist
  then begin
    fillChar (NStr[1], CelkMist, '*');
    byte(NStr[0]) := CelkMist;
  end
  else begin
    if NStr[1] = '-'
    then begin
      Zaporne := true;
      delete (NStr, 1, 1);
    end
    else Zaporne := false;

    PozTec := pos ('.', NStr);

    CelCast := NStr;
    DesCast := '';

    if PozTec <> 0
    then begin
      dec (byte (CelCast[0]), length (CelCast) -PozTec +1);
      DesCast := copy (NStr, PozTec +1, length (NStr) -PozTec);
    end;

    if DesMist > 0
    then CelychZ := CelkMist -DesMist -1
    else CelychZ := CelkMist;

    for i := length (CelCast) to CelychZ -1
    do CelCast := '0' +CelCast;

    if length (DesCast) > DesMist
    then byte (Descast[0]) := DesMist
    else begin
      for i := length (DesCast) to DesMist -1
      do DesCast := DesCast +'0';
    end;

    if DesMist > 0
    then NStr := CelCast +'.' +DesCast
    else NStr := CelCast;


    if Zaporne
    then begin
      if NStr[1] = '0'
      then NStr[1] := '-'
      else begin
        fillChar (NStr[1], CelkMist, '*');
        byte(NStr[0]) := CelkMist;
      end;
    end;
  end;

  RFormatDBStr := NStr;
end;






function LFormatDBStr (NStr: string; CelkMist: integer): string;
var
  Null   : string;
  PozTec : integer;
  i      : integer;
  CelychZ: integer;
  Zaporne: boolean;

begin
  PozTec := pos ('.', NStr);

  if PozTec > 0 then dec (byte(NStr[0]), length(NStr)-PozTec+1);

  NStr := DejCistyNumStr (NStr);

  if (CelkMist > 0) and (NStr <> '')
  then begin
    if length (NStr) > CelkMist
    then begin
      fillChar (NStr[1], CelkMist, '*');
      byte(NStr[0]) := CelkMist;
    end
    else begin
      Zaporne := NStr[1] = '-';
      if Zaporne then delete (NStr, 1, 1);
      fillChar (Null[1], 255, '0');
      byte(Null[0]) := CelkMist-length (NStr);
      NStr := Null+NStr;

      if Zaporne
      then begin
        if NStr[1] = '0'
        then NStr[1] := '-'
        else begin
          fillChar (NStr[1], CelkMist, '*');
          byte(NStr[0]) := CelkMist;
        end;
      end;
    end;
  end;

  LFormatDBStr := NStr;
end;


function SFormatDBStr (NStr: string; CelkMist: integer): string;
var
  SP: string;

begin
  if length (NStr) > CelkMist
  then byte(NStr[0]) := CelkMist
  else begin
    fillChar (SP[1], 255, ' ');
    byte(SP[0]) := CelkMist-length (NStr);
    NStr := NStr+SP;
  end;

  SFormatDBStr := NStr;
end;


function BFormatDBStr (NStr: string): string;
var
  i: byte;
begin
  BFormatDBStr := 'F';

  for i := 1 to length(NStr) do
  if (NStr[i] <> '0') or (NStr[i] <> ' ')
  then begin
    BFormatDBStr := 'T';
    exit;
  end;
end;






procedure LNumStrNaNormStr (CelkMist: byte; var S: string);
var
  i      : byte;
  CelychZ: byte;
  Zaporne: boolean;

begin
  if byte(S[0]) = 0
  then begin
    byte(S[0]) := CelkMist;
    fillChar(S[1], CelkMist, '0');
  end
  else begin
    if byte(S[0]) = 1
    then begin
      byte(S[0]) := CelkMist;

      if (S[1] = ' ') or (S[1] = '-')
      then fillChar(S[1], CelkMist, '0')
      else begin
        S[CelkMist] := S[1];
        fillChar(S[1], CelkMist -1, '0');
      end;
    end
    else begin
      i := 1;

      while (S[i] = ' ') and (i < byte(S[0])) do inc(i);

      if i > 1
      then begin
        if i = byte(S[0])
        then begin
          byte(S[0]) := CelkMist;
          fillChar(S[1], CelkMist, '0');
        end
        else begin
          dec(i);
          move (S[i+1], S[1], byte(S[0]) -i);
          dec(byte(S[0]), i);
        end;
      end;

      while S[byte(S[0])] = ' ' do dec(byte(S[0]));

      if byte(S[0]) < CelkMist
      then begin
        i := CelkMist -byte(S[0]);

        if S[1] <> '-'
        then begin
          move (S[1], S[i+1], byte(S[0]));
          byte(S[0]) := CelkMist;
          fillChar (S[1], i, '0');
        end
        else begin
          move (S[2], S[i+2], byte(S[0])-1);
          byte(S[0]) := CelkMist;
          fillChar (S[2], i, '0');
        end;
      end;
    end;
  end;
end;












function DejMaxReal (PocMist, DesMist: byte): real48;
var
  i: integer;
  S: string;
  R: real48;
begin
  S := '';
  for i := 1 to PocMist -DesMist -1
  do S := S +'9';

  S := S +'.0';

  val (S, R, i);

  if i <> 0
  then DejMaxReal := 0
  else DejMaxReal := R;
end; {}











function DejMaxLInt (PocMist: byte): longInt;
var
  i: integer;
  S: string;
  L: longInt;
begin
  if PocMist >= 10
  then DejMaxLInt := 2147483646
  else begin
    S := '';
    for i := 1 to PocMist
    do S := S +'9';

    val (S, L, i);

    if i <> 0
    then DejMaxLInt := 0
    else DejMaxLInt := L;
  end;
end; {}













function DejMinReal (PocMist, DesMist: byte): real48;
var
  i: integer;
  S: string;
  R: real48;
begin
  S := '-';
  for i := 1 to PocMist -DesMist -2
  do S := S +'9';

  S := S +'.0';

  val (S, R, i);

  if i <> 0
  then DejMinReal := 0
  else DejMinReal := R;
end; {}












function DejMinLInt (PocMist: byte): longInt;
var
  i: integer;
  S: string;
  L: longInt;
begin
  if PocMist >= 11
  then DejMinLInt := -2147483646
  else begin
    S := '-';
    for i := 2 to PocMist
    do S := S +'9';

    val (S, L, i);

    if i <> 0
    then DejMinLInt := 0
    else DejMinLInt := L;
  end;
end; {}






























function DejPocetLInt (OdCisla, DoCisla: longInt): byte;
var
  P1Str: string;
  P2Str: string;
begin
  P1Str := LPrezStr (OdCisla);
  P2Str := LPrezStr (DoCisla);

  if length (P1Str) > length (P2Str)
  then DejPocetLInt := length (P1Str)
  else DejPocetLInt := length (P2Str);
end;












function DejPocetReal (OdCisla, DoCisla: real48; PocDesMist: byte): byte;
var
  P1Str: string;
  P2Str: string;
begin
  P1Str := RPrezStr (OdCisla, PocDesMist);
  P2Str := RPrezStr (DoCisla, PocDesMist);

  if length (P1Str) > length (P2Str)
  then DejPocetReal := length (P1Str)
  else DejPocetReal := length (P2Str);
end;








function StrStrSp(Retezec: string; Delka: byte): string;
{ Retezec upravi na Delku: bud zkrati, nebo prida mezery }
var
  Pom: string;
  PuvDelka: byte;

begin
  PuvDelka:= length(Retezec);
  if PuvDelka > Delka then Retezec[0]:= chr(Delka)
  else if PuvDelka < Delka then
       begin
         Retezec[0]:= chr(Delka);
         fillChar(Retezec[PuvDelka+1], Delka-PuvDelka, byte(' '))
       end;
  StrStrSp:= Retezec
end;













function DejSPNaNul (S: string): string;
var
  i: byte;
begin
  for i := 1 to length (S)
  do if S[i] = ' '
     then S[i] := '0';
  DejSPNaNul := S;
end;










function DejBezSP (const S: string): string;
var
  i     : byte;
  PomStr: string;

begin
  PomStr := '';

  for i := 1 to length (S)
  do if S[i] <> ' ' then PomStr := PomStr +S[i];

  DejBezSP := PomStr;
end;










function DejRadStr (UhelVRad: real48): TStuMinSekStr;
begin
  DejRadStr := RStr0 (UhelVRad, 6, 4) +' r';
end;







function DejGradStr (UhelVRad: real48): TStuMinSekStr;
begin
  DejGradStr := RStr0 (DejGrady (UhelVRad), 8, 4) +' g';
end;






function DejStuMinSekStr  (UhelVRad: real48): TStuMinSekStr;
var
  Stupne : longInt;
  Minuty : longInt;
  Sekundy: longInt;
begin
  VratStuMinSek (UhelVRad, Stupne, Minuty, Sekundy);

  DejStuMinSekStr := LStrSP (Stupne, 3) +
{$IFNDEF Windows}
                     chr (248) + ' '
{$ELSE}
                     chr (176) + ' '
{$ENDIF}
                     +LStr0 (Minuty, 2) +chr (39)  +' '
                     +LStr0 (Sekundy,2) +'"';
end;










function DejStuMinRSekStr  (UhelVRad: real48; DesMistSek: byte): TStuMinSekStr;
var
  Stupne : longInt;
  Minuty : longInt;
  Sekundy: real48;
begin
  VratStuMinRSek (UhelVRad, Stupne, Minuty, Sekundy);

  DejStuMinRSekStr :=  LStrSP (Stupne, 3) +
                       chr (176) + ' '
                       +LStrSP (Minuty, 2) +'''' +' '
                       +RStrSP (Sekundy, 3+DesMistSek , DesMistSek)+'"';
end;



function DejDatCasStr(Time: longInt): string;
var
{$IFNDEF Windows}
  DT: DateTime;
{$ELSE}
  DT: TDateTime;
{$ENDIF}
begin
  unPackTime(Time, DT);
  with DT do
    DejDatCasStr:= LStr(Year) + '-' + LStr0(Month,2) + '-' + LStr0(Day,2) + ' ' +
                   LStr0(Hour,2) +':' +LStr0(Min,2) +':' +LStr0(Sec,2)
end;





function DejSysCasStr: TCasStr;
var
  H,M,S,SS: word;
begin
  getTime (H,M,S,SS);
  DejSysCasStr := LStr0(H,2) +':' +LStr0(M,2) +':' +LStr0(S,2);
end;








function DejSysNormDatumStr: TNormDatumStr;
var
  R,M,D,DT: word;
begin
  getDate (R,M,D,DT);
  DejSysNormDatumStr := LStr(R) +LStr0(M,2) +LStr0(D,2);
end;







function DejSysPrezDatumStr: TPrezDatumStr;
begin
  DejSysPrezDatumStr := DejPrezDStr (DejSysNormDatumStr);
end;





function DejSysDenVTydnuStr: TDenVTydnuStr;
var
  R,M,D,DT: word;
begin
  getDate (R,M,D,DT);

  case DT of
    0: DejSysDenVTydnuStr := 'NEDELE';
    1: DejSysDenVTydnuStr := 'PONDELI';
    2: DejSysDenVTydnuStr := 'UTERY';
    3: DejSysDenVTydnuStr := 'STREDA';
    4: DejSysDenVTydnuStr := 'CTVRTEK';
    5: DejSysDenVTydnuStr := 'PATEK';
    6: DejSysDenVTydnuStr := 'SOBOTA';
  end;
end;


*)



function BezVsechMezer(Retezec: string): string;
var
  I: byte;

begin
  I:= pos (' ', Retezec);

  while I <> 0 do
  begin
    delete (Retezec, I, 1);
    I:= pos (' ', Retezec)
  end;

  BezVsechMezer:= Retezec
end;








function BezVnejsichMezer(Retezec: string): string;
var
  I: integer;

begin
  BezVnejsichMezer:= '';
  if Retezec = '' then exit;
  I:= 1;
  while (Retezec[I] in [' ',#0]) and (I <= length(Retezec)) do inc(I);
  if I > length(Retezec) then BezVnejsichMezer:= ''
  else
  begin
    delete(Retezec, 1, I-1);
    while (Retezec[length(Retezec)] in [' ',#0]) and
          (length(Retezec) > 0) do
          {$IFDEF WIN32}
             SetLength(Retezec, Length(Retezec) - 1);
          {$ELSE}
             dec(Retezec[0]);
          {$ENDIF}
    BezVnejsichMezer:= Retezec
  end
end;







function JeMezera(const Retezec : string;
                  var   Retezec1: string;
                  var   Retezec2: string): boolean;
var
  I: byte;

begin
  JeMezera := false;
  I:= pos (' ', Retezec);

  if I <> 0 then
  begin
    JeMezera := true;
    Retezec1 := copy(Retezec, 1, pred(I));
    Retezec2 := copy(Retezec, succ(I), length(Retezec) - I);
  end;

end;


(*

function DejDoplSPZLeva (Retezec: string; CelkZn: byte): string;
begin
  if length (Retezec) < CelkZn
  then while length (Retezec) < CelkZn
       do insert (' ', Retezec, 1);

  DejDoplSPZLeva := Retezec;
end;






function DejDoplSPZPrava (Retezec: string; CelkZn: byte): string;
begin
  if length (Retezec) < CelkZn
  then while length (Retezec) < CelkZn
       do insert (' ', Retezec, length (Retezec) +1);

  DejDoplSPZPrava:= Retezec;
end;







function DejMaxZnVyberuStr (S: string): byte;
var
  PosAmp: integer;
  MaxZn : byte;
  PStr  : TString21;
begin
  MaxZn := 0;

  PosAmp := pos ('&', S);

  if PosAmp = 0
  then begin
    DejMaxZnVyberuStr := length (S);
    exit;
  end;

  while PosAmp <> 0
  do begin
    PStr := copy (S, 1, PosAmp -1);

    if length(PStr) > MaxZn
    then MaxZn := length(PStr);

    delete (S, 1, PosAmp);
    PosAmp := pos ('&', S);
  end;

  DejMaxZnVyberuStr := MaxZn;
end;





function DejZobrDatumStr (const D: TDatumStr): TZobrDatumStr;
begin
  DejZobrDatumStr := copy (D, 7, 2)
                     +'.'+
                     copy (D, 5, 2)
                     +'.'+
                     copy (D, 1, 4);
end;











function DejDatumStr (D: TZobrDatumStr): TDatumStr;
var
  Poz1Tecky: byte;
  Poz2Tecky: byte;

  Den  : string[2];
  Mesic: string[2];
  Rok  : string[4];

begin
  Poz1Tecky := pos ('.', D);
  D[Poz1Tecky] := ':';
  Poz2Tecky := pos ('.', D);;

  Den   := copy (D, 1, Poz1Tecky -1);
  Mesic := copy (D, Poz1Tecky +1, Poz2Tecky -Poz1Tecky -1);
  Rok   := copy (D, Poz2Tecky +1, length (D) -Poz2Tecky);

  if length (Den) < 2 then Den := '0' +Den;

  if length (Mesic) < 2 then Mesic := '0' +Mesic;

  if length (Rok) < 3 then Rok := '19' +Rok;

  DejDatumStr := Rok +Mesic +Den;
end;





function DejUriznutyStr(const Retez: string; Pocet: byte): string;
var
  Pom: string;

begin
  if Pocet > 5 then
  begin
    Pom:= copy(Retez, 1, Pocet - 4);
    Pom:= BezVnejsichMezer(Pom) + ' ...';
  end
  else
    Pom:= '';

  DejUriznutyStr:= Pom
end;


function DejJmenoSExt(FileName: string): string;
var
  D: dirStr;
  N: nameStr;
  E: extStr;

begin
  fSplit(FileName, D, N, E);
  DejJmenoSExt:= N + E
end;





function DejJmenoSouboruProVypis(FileName: pathStr; Pocet: byte) : pathStr;
var
   Pom, PomCesta, Cesta, PomJE: dirStr;
   Jmeno: nameStr;
   Ext: extStr;

  DelkaJE, DelkaC, DelkaP, PomD, i, j: byte;

begin
  if  length(FileName) <= Pocet then
  begin
    DejJmenoSouboruProVypis := FileName;
  end else
  begin
{$IFNDEF Windows}
    FSplit(FileName, Cesta, Jmeno, Ext);
{$ELSE}
    FileSplit(aFileName, CestaP, JmenoP, ExtP);
    Cesta := StrPas(CestaP);
    Jmeno := StrPas(JmenoP);
    Ext   := StrPas(ExtP);
{$ENDIF}
    PomJE := Jmeno + Ext;
    DelkaJE := length(PomJE);
    DelkaC  := length(Cesta);

    if DelkaJE > Pocet then  { test jmena s extenzi }
       DejJmenoSouboruProVypis := ''
    else
    begin
      if Pos(':', Cesta) <> 0 then
         PomCesta := copy(Cesta, 1, 2)
      else
         PomCesta := '';

      DelkaP := length(PomCesta);

      if DelkaP + DelkaJE > Pocet then
         DejJmenoSouboruProVypis := PomJE
      else
      begin
        if DelkaP + 5 + DelkaJE > Pocet then
           DejJmenoSouboruProVypis := PomCesta + PomJE
        else
        begin
          PomCesta := PomCesta + '\...\';
          DelkaP:= length(PomCesta);
          i := DelkaC;

          repeat
            PomD := i;
            j := 0;
            repeat
              dec(i);
              inc(j);
            until (copy(Cesta, i, 1) = '\');

            Pom := copy(Cesta, succ(i), j);
            DelkaJE := length(Pom + PomJE);

            if DelkaP + DelkaJE <= Pocet then
              PomJE := Pom + PomJE;

          until DelkaP + DelkaJE > Pocet;

          DejJmenoSouboruProVypis := PomCesta + PomJE;
        end;
      end;
    end;
  end;
end;





{$IFNDEF Windows}
function JmSoubNa30(JmSoub: pathStr): pathStr;
begin
  JmSoubNa30:= DejJmenoSouboruProVypis(JmSoub, 30)
end;





function DejKonJmSoub (JmSoub: pathStr; PocetZn: integer): pathStr;
var
  D: dirStr;
  N: nameStr;
  E: extStr;
begin
  if  length (JmSoub) <= PocetZn
  then DejKonJmSoub := JmSoub
  else begin
    JmSoub := fExpand (JmSoub);

    FSplit (JmSoub, D, N, E);

    if length(N) +length(E) > PocetZn
    then DejKonJmSoub := ''
    else begin
      delete (D, 1, length(JmSoub) -PocetZn +2);
      delete (D, 1, pos('\', D) -1);

      if D = ''
      then DejKonJmSoub := N +E
      else DejKonJmSoub := '..' +D +N +E;
    end;
  end;
end;






function KonJmSoubNa30 (JmSoub: pathStr): pathStr;
begin
   KonJmSoubNa30 := DejKonJmSoub (JmSoub, 30);
end;





function DejOcistenyPathStr (Path: pathStr): pathStr;
{$ELSE}
function DejOcistenyPathStr
                           (const aPath: TPathStr): PChar;
{$ENDIF}
var
  i: integer;
{$IFDEF Windows}
  Pom: String;
  Path: string;
  Pch: TpathStr;
{$ENDIF}
begin
  i := 1;
{$IFDEF Windows}
  Path := StrPas(aPath);
{$ENDIF}
  while i < length (Path)
  do begin
    if Path[i] = ' '
    then delete (Path,i,1)
    else inc (i);
  end;



  i := 1;
  while i < length (Path)
  do begin
    if (Path[i] = '\')
       and
       (Path[i] = Path[i+1])
    then delete (Path,i,1)
    else inc (i);
  end;

{$IFDEF Windows}
  strPCopy(Pch, Path);
  DejOcistenyPathStr := Pch;
{$ELSE}
  DejOcistenyPathStr := Path;
{$ENDIF}
end;




function JmBezSP (Jm: TStr10): TStr10;
begin
  while (Jm[byte(Jm[0])] = ' ') and
        (byte(Jm[0]) > 0)
  do dec(byte(Jm[0]));

  JmBezSP := Jm;
end;


procedure JmBezPravSP (var Jm: TStr10);
begin
  while (Jm[byte(Jm[0])] = ' ') and
        (byte(Jm[0]) > 0)
  do dec(byte(Jm[0]));
end;




function OKVstupJm  (Jm : nameStr): boolean;
var
  i: byte;
begin
  if length(Jm) = 0
  then begin
    OKVstupJm := false;
    exit;
  end;

  for i := 1 to length(Jm) do
  if not (Jm[i] in INPUTJMZN)
  then begin
    OKVstupJm := false;
    exit;
  end;

  OKVstupJm := true;
end;





function OKVstupExt (Ext: extStr): boolean;
var
  i: byte;
begin
  if (length(Ext) > 0) and
     (Ext[1] = '.')
  then delete(Ext,1,1);

  if pos('.', Ext) <> 0
  then begin
    OKVstupExt := false;
    exit;
  end;

  for i := 1 to length(Ext) do
  if not (Ext[i] in INPUTExtZN)
  then begin
    OKVstupExt := false;
    exit;
  end;

  OKVstupExt := true;
end;




function OKJmSoub  (Jm : nameStr): boolean;
var
  i: byte;
begin
  if length(Jm) = 0
  then begin
    OKJmSoub:= false;
    exit;
  end;

  for i := 1 to length(Jm) do
  if not (Jm[i] in JMSOUBZN)
  then begin
    OKJmSoub:= false;
    exit;
  end;

  OKJmSoub:= true;
end;





function OKExtSoub (Ext: extStr): boolean;
var
  i: byte;
begin
  if length(Ext) = 0
  then begin
    OKExtSoub:= true;
    exit;
  end;

  if Ext[1] = '.'
  then delete(Ext,1,1);

  if pos('.', Ext) <> 0
  then begin
    OKExtSoub:= false;
    exit;
  end;

  for i := 1 to length(Ext) do
  if not (Ext[i] in JMSOUBZN)
  then begin
    OKExtSoub:= false;
    exit;
  end;

  OKExtSoub:= true;
end;

function StrComp(Str1, Str2: PChar): integer; assembler;
asm
	PUSH	DS
	CLD
	LES	DI,Str2
	MOV	SI,DI
	MOV	CX,0FFFFH
	XOR	AX,AX
	CWD
	REPNE	SCASB
	NOT	CX
	MOV	DI,SI
	LDS	SI,Str1
	REPE	CMPSB
	MOV	AL,DS:[SI-1]
	MOV	DL,ES:[DI-1]
	SUB	AX,DX
	POP	DS
end;


type
  TAC = array[0..255] of char;


procedure OsetriSameMezery(CelkZn, DesMist: byte; var AC);
var
  I: integer;
  Nasel: boolean;

begin
  if CelkZn > 0 then
  begin
    Nasel:= false;
    I:= 0;
    while (I < CelkZn) and not Nasel do
    begin
      Nasel:= TAC(AC)[I] <> ' ';
      if not Nasel then
         inc(I)
    end;

    if not Nasel then
    begin
      if DesMist = 0 then
         TAC(AC)[CelkZn-1]:= '0'
      else
      if (CelkZn<3) or (CelkZn<DesMist+2) then
         TAC(AC)[CelkZn-1]:= '0'
      else
      begin
        fillChar(TAC(AC)[CelkZn-DesMist-2], DesMist+2, '0');
        TAC(AC)[CelkZn-DesMist-1]:= '.'
      end
    end
  end
end;




procedure NormLNumSP (CelkZn: byte; var AC);
var
  PocLSP: byte;
  PocPSP: byte;

begin
  PocLSP := 0;

  while (TAC(AC)[PocLSP] in [' ', '0', #0])
        and
        (PocLSP < CelkZn) do inc(PocLSP);

  if (PocLSP = CelkZn) then
  begin
  {
    TAC(AC)[0]:= '0';
    PocLSP:= 0
  }
    fillChar(TAC(AC)[0], CelkZn, ' ')
  end
  else
  begin
    if (PocLSP = CelkZn) or
       (TAC(AC)[PocLSP] = #0)
    then
    begin
      fillChar(TAC(AC)[0], CelkZn, ' ');
    end
    else begin
      PocPSP := CelkZn -1;

      while (PocPSP > 0) and (TAC(AC)[PocPSP] in [' ', #0])
      do dec(PocPSP);

      inc(PocPSP);

      if PocPSP < CelkZn
      then begin
        move(TAC(AC)[0], TAC(AC)[CelkZn -PocPSP], PocPSP);
        inc(PocLSP, CelkZn -PocPSP);
      end;

      if TAC(AC)[PocLSP] <> '-'
      then fillChar(TAC(AC)[0], PocLSP, ' ')
      else begin
        fillChar(TAC(AC)[0], PocLSP+1, ' ');
        TAC(AC)[0] := '-';
      end;
    end
  end;

  OsetriSameMezery(CelkZn, 0, AC)
end;





procedure NormRNumSP (CelkZn, DesMist: byte; var AC);
var
  PocLSP  : byte;
  PocPSP  : byte;
  Posun   : integer;
  PozTecky: integer;

begin
  if DesMist = 0 then
  begin
     NormLNumSP(CelkZn, AC)
  end
  else
  begin
    PocLSP := 0;

    while (PocLSP < CelkZn) and
          (
           (TAC(AC)[PocLSP] in [' ', '0', #0])
          )
    do inc(PocLSP);

    if (PocLSP = CelkZn) then
    begin
    {
      TAC(AC)[0]:= '0';
      PocLSP:= 0
    }
      fillChar(TAC(AC)[0], CelkZn, ' ');
    end
    else
    begin
      if (PocLSP = CelkZn) or
         (TAC(AC)[PocLSP] = #0)
      then begin
        fillChar(TAC(AC)[0], CelkZn, ' ');
       { TAC(AC)[CelkZn -DesMist -1] := '.' }
      end
      else begin
        PocPSP := CelkZn -1;

        while (PocPSP > 0) and (TAC(AC)[PocPSP] in [' ', #0]) do
        dec(PocPSP);

        PozTecky := PocPSP;
        PocPSP   := CelkZn -PocPSP -1;

        while (PozTecky > -1) and (TAC(AC)[PozTecky] <> '.') do dec(PozTecky);

        if PozTecky < 0
        then begin
          if PocPSP > 0
          then begin
            PozTecky := CelkZn -PocPSP;
            TAC(AC)[PozTecky] := '.';
            dec (PocPSP);
          end
          else begin
            if PocLSP > 0
            then begin
              move (TAC(AC)[PocLSP], TAC(AC)[PocLSP -1], CelkZn -PocLSP -PocPSP);
              dec (PocLSP);
              PozTecky := CelkZn -1;
              TAC(AC)[PozTecky] := '.';
            end
            else begin
              move (TAC(AC)[0], TAC(AC)[1], CelkZn -PocLSP -PocPSP -1);
              PozTecky := CelkZn -1;
              TAC(AC)[PozTecky] := '.';
            end;
          end;
        end;

        Posun := CelkZn -DesMist -1 -PozTecky;

        if Posun <> 0
        then begin
          move (TAC(AC)[PocLSP], TAC(AC)[PocLSP +Posun], CelkZn -PocLSP -PocPSP);
          inc(PocLSP, Posun);
          dec(PocPSP, Posun);
        end;

        if TAC(AC)[PocLSP] <> '-'
        then
        begin
          fillChar(TAC(AC)[0], PocLSP, ' ');
          if TAC(AC)[PocLSP] = '.' then
             TAC(AC)[PocLSP-1]:= '0'
        end
        else begin
          fillChar(TAC(AC)[0], PocLSP+1, ' ');
          TAC(AC)[0] := '-';
        end;

        fillChar(TAC(AC)[CelkZn -PocPSP], PocPSP, '0')
      end
    end;

    OsetriSameMezery(CelkZn, DesMist, AC)
  end
end;



{$IFNDEF Windows}
function DejPrezentacniHodnotuStr
         (Typ: char; Delka, DesMist: integer; Hodnota: string): string;
var
  Retez: string;
  DMZdr: integer;

begin
  fillChar(Retez[1], Delka, ' ');

  if Delka < length(Hodnota) then
  begin  { Delka je kratsi- oriznout }
    if Typ = 'N' then { u numerickych oriznuti zprava }
    begin
       NormRNumSP(Delka, DesMist, Hodnota[1]);
       Hodnota[0]:= chr(Delka);
       Retez:= Hodnota
{         Retez:= copy(Hodnota, length(Hodnota)-Delka + 1, Delka)}
    end
    else
       Retez:= copy(Hodnota, 1, Delka)
  end
  else
     Retez:= Hodnota;

  if Typ = 'N' then
  begin
    if DesMist = 0 then
    begin
      if pos('.', Retez) > 0 then
         Retez:= copy(Retez, 1, pos('.', Retez)-1);

      NormLNumSP (Delka, Retez[1])
    end
    else
    begin
      NormRNumSP (Delka, DesMist, Retez[1])
    end
  end
  else NormChar (Delka, Retez[1]);

  byte(Retez[0]):= Delka;

  DejPrezentacniHodnotuStr:= Retez;
end;

{$ENDIF}



function StrZStr(Ret: string;
                 TypPolozky: char; DelkaRet, DesMist: integer): string;
begin
  if DelkaRet = 0 then
     StrZStr:= Ret
  else
  begin
    if TypPolozky = 'N' then
    begin
      StrZStr:= DejPrezentacniHodnotuStr
                (TypPolozky, DelkaRet, DesMist,
                 Ret);
    end
    else
      StrZStr:= StrStrSP(Ret, DelkaRet)
  end
end;




procedure VratFormat(Retez: string;
                     var Parametr: string; var FDelka, FDesMist: integer);
var
  PosDvojT, Pos2DvojT, DelkaRet, DesMist, Code: integer;
  FormatStr, DelkaRetStr, DesMistStr: string;

begin
  FDelka:= 0;
  FDesMist:= 0;
  Parametr:= Retez;
  DesMistStr:= '';

  PosDvojT:= pos(':', Retez);

  if PosDvojT > 0 then
  begin
    Parametr:= copy(Retez, 1, PosDvojT-1);
    FormatStr:= copy(Retez, PosDvojT+1, 10);
    Pos2DvojT:= pos(':', FormatStr);

    if (Pos2DvojT > 0) then
    begin
      DelkaRetStr:= copy(FormatStr, 1, Pos2DvojT-1);
      DesMistStr:= copy(FormatStr, Pos2DvojT+1, 1);
    end
    else DelkaRetStr:= FormatStr;

    if DelkaRetStr <> '' then
    begin
      val(DelkaRetStr, FDelka, Code);
      if Code <> 0 then FDelka:= 0
    end;

    if DesMistStr <> '' then
    begin
      val(DesMistStr, FDesMist, Code);
      if Code <> 0 then FDesMist:= 0
    end
  end

end;




procedure NormLNum0 (CelkZn: byte; var AC);
type
  TAC = array[0..255] of char;
var
  PocLSP: byte;
  PocPSP: byte;

begin
  PocLSP := 0;

  while (PocLSP < CelkZn) and
        ((TAC(AC)[PocLSP] = ' ') or
         (TAC(AC)[PocLSP] = '0') or
         (TAC(AC)[PocLSP] = #0))
  do inc(PocLSP);

  if PocLSP = CelkZn
  then fillChar(TAC(AC)[0], CelkZn, '0')
  else begin
    PocPSP := CelkZn -1;

    while (PocPSP > 0) and ((TAC(AC)[PocPSP] = ' ') or (TAC(AC)[PocPSP] = #0))
    do dec(PocPSP);

    inc(PocPSP);

    if PocPSP < CelkZn
    then begin
      move(TAC(AC)[0], TAC(AC)[CelkZn -PocPSP], PocPSP);
      inc(PocLSP, CelkZn -PocPSP);
    end;

    if TAC(AC)[PocLSP] <> '-'
    then fillChar(TAC(AC)[0], PocLSP, '0')
    else begin
      fillChar(TAC(AC)[0], PocLSP+1, '0');
      TAC(AC)[0] := '-';
    end;
  end;
end;





procedure NormRNum0 (CelkZn, DesMist: byte; var AC);
type
  TAC = array[0..255] of char;
var
  PocLSP  : byte;
  PocPSP  : byte;
  Posun   : integer;
  PozTecky: integer;

begin
  if DesMist >= CelkZn
  then begin
    fillChar(TAC(AC)[0], CelkZn, '0');
  end;

  PocLSP := 0;

  while (PocLSP < CelkZn) and
        ((TAC(AC)[PocLSP] = ' ') or
         (TAC(AC)[PocLSP] = '0') or
         (TAC(AC)[PocLSP] = #0))
  do inc(PocLSP);

  if PocLSP = CelkZn
  then begin
    fillChar(TAC(AC)[0], CelkZn, '0');
    TAC(AC)[CelkZn -DesMist -1] := '.'
  end
  else begin
    PocPSP := CelkZn -1;

    while (PocPSP > 0) and ((TAC(AC)[PocPSP] = ' ') or (TAC(AC)[PocPSP] = #0))
    do dec(PocPSP);
    while TAC(AC)[PocPSP] = ' ' do dec(PocPSP);

    PozTecky := PocPSP;
    PocPSP   := CelkZn -PocPSP -1;

    while (PozTecky > -1) and (TAC(AC)[PozTecky] <> '.') do dec(PozTecky);

    if PozTecky < 0
    then begin
      if PocPSP > 0
      then begin
        PozTecky := CelkZn -PocPSP;
        TAC(AC)[PozTecky] := '.';
        dec (PocPSP);
      end
      else begin
        if PocLSP > 0
	then begin
          move (TAC(AC)[PocLSP], TAC(AC)[PocLSP -1], CelkZn -PocLSP -PocPSP);
          dec (PocLSP);
          PozTecky := CelkZn -1;
          TAC(AC)[PozTecky] := '.';
        end
        else begin
          move (TAC(AC)[0], TAC(AC)[1], CelkZn -PocLSP -PocPSP -1);
          PozTecky := CelkZn -1;
          TAC(AC)[PozTecky] := '.';
        end;
      end;
    end;

    Posun := CelkZn -DesMist -1 -PozTecky;

    if Posun <> 0
    then begin
      move (TAC(AC)[PocLSP], TAC(AC)[PocLSP +Posun], CelkZn -PocLSP -PocPSP);
      inc(PocLSP, Posun);
      if Posun > PocPSP then
        PocPSP:= 0
      else
        dec(PocPSP, Posun);
    end;

    if TAC(AC)[PocLSP] <> '-'
    then fillChar(TAC(AC)[0], PocLSP, '0')
    else begin
      fillChar(TAC(AC)[0], PocLSP+1, '0');
      TAC(AC)[0] := '-';
    end;

    fillChar(TAC(AC)[CelkZn -PocPSP], PocPSP, '0')
  end;
end;









procedure NormChar (CelkZn: byte; var AC);
type
  TAC = array[0..255] of char;
var
  PocSP: byte;

begin
  PocSP := 0;

  while ((TAC(AC)[PocSP] = ' ') or (TAC(AC)[PocSP] = #0))
        and
        (PocSP < CelkZn)
  do inc(PocSP);

  if PocSP > 0
  then begin
    if PocSP = CelkZn
    then fillChar (AC,CelkZn, ' ')
    else begin
      dec (CelkZn);
      while TAC(AC)[CelkZn] = ' ' do dec(CelkZn);
      dec (CelkZn, PocSP -1);

      move(TAC(AC)[PocSP], TAC(AC)[0], CelkZn);
      fillChar(TAC(AC)[CelkZn], PocSP, ' ');
    end;
  end;
end;




procedure NumVlevoAOrez (ZdrCM,CilCM: byte; var AC);
type
  TAC = array[0..255] of char;
var
  PocLSP: byte;
  NulInd: byte;

begin
  if ZdrCM > CilCM
  then begin
    if TAC(AC)[0] = '-'
    then NulInd := 1
    else NulInd := 0;

    PocLSP := NulInd;

    while (PocLSP < ZdrCM) and
          ((TAC(AC)[PocLSP] = ' ') or
           (TAC(AC)[PocLSP] = '0') or
           (TAC(AC)[PocLSP] = #0))
    do inc(PocLSP);

    if PocLSP = ZdrCM
    then fillChar(TAC(AC)[0], ZdrCM, '0')
    else move(TAC(AC)[PocLSP], TAC(AC)[NulInd], ZdrCM-PocLSP);

    fillChar (TAC(AC)[CilCM],ZdrCM-CilCM,' ');
  end;
end;





procedure CharVlevoAOrez (ZdrCM,CilCM: byte; var AC);
type
  TAC = array[0..255] of char;
var
  PocLSP: byte;

begin
  if ZdrCM > CilCM
  then begin
    PocLSP := 0;

    while (PocLSP < ZdrCM) and
          ((TAC(AC)[PocLSP] = ' ') or
           (TAC(AC)[PocLSP] = #0))
    do inc(PocLSP);

    if PocLSP = ZdrCM
    then fillChar(TAC(AC)[0], ZdrCM, ' ')
    else move(TAC(AC)[PocLSP], TAC(AC)[0], ZdrCM-PocLSP);

    fillChar (TAC(AC)[CilCM],ZdrCM-CilCM,' ');
  end;
end;



{ Pozor! Pouzivaji se na obycejne stringy.}

function DejNormStr (Typ: char; ZdrCM,CilCM,CilDM: byte; var AC): string;
var
  S: string;
  i: byte;

begin
  fillChar(S, sizeOf(string), ' ');
  move (AC, S[1], ZdrCM);
  byte(S[0]):= CilCM;

  if Typ <> 'N'
  then begin
    CharVlevoAOrez(ZdrCM,CilCM, S[1]);

    NormChar (CilCM, S[1]);
  end
  else begin
    NumVlevoAOrez (ZdrCM,CilCM, S[1]);

    if CilDM = 0
    then NormLNum0 (CilCM, S[1])
    else NormRNum0 (CilCM, CilDM, S[1]);
  end;

  DejNormStr := S;
end;




{$IFDEF Windows}
function JmenoSouboruNa30(
                          const FileName: PChar): string;

begin
  JmenoSouboruNa30 := DejJmenoSouboruProVypis(FileName, 30);
end;





function DejStrPoZnak(const S: string; Zn: char): string;
var
  PomStr: string;
  i: integer;
begin

  PomStr:= '';

  i:= 1;
  while (S[i] <> Zn) and (i <= Length(S)) do
  begin
    PomStr:= PomStr + S[i];
    inc(i);
  end;
  DejStrPoZnak:= PomStr;

{  Pomstr:=copy(PomStr, 1, pred(Pos(Zn, PomStr)));}
end;









function LeapYear(Year: integer): boolean;
begin
  LeapYear:= (Year mod 4 = 0) and (not (Year mod 100 = 0) or (Year mod 400 = 0));
end;


function DateStringValid(var D: TPrezDatumStr): boolean;
var
  ADate: TPrezDatumStr;
  Day,
  Month,
  Year,
  Code : integer;
begin
  DateStringValid:= false;
  ADate:= DejPrezDStr(DejNormDStr(D));
  if ADate <> '' then
  begin
    val(copy(ADate, 1, 2), Day  , Code);
    if Code = 0 then
    begin
      val(copy(ADate, 4, 2), Month, Code);
      if code = 0 then
      begin
        val(copy(ADate, 7, 4), Year, Code);
        if Code = 0 then
          case Month of
            1, 3, 5, 7, 8, 10, 12:
                if (Day < 1) or (Day > 31) then ADate:= '';
            4, 6, 9, 11:
                if (Day < 1) or (Day > 30) then ADate:= '';
            2:
              if not LeapYear(Year) then
                if (Day < 1) or (Day > 28) then ADate:= ''
              else
                if (Day < 1) or (Day > 29) then ADate:= '';
          end
        else ADate:= '';
      end
      else ADate:= '';
    end
    else ADate:= '';
  end;
  if ADate <> '' then
  begin
    D:= ADate;
    DateStringValid:= true;
  end;
end;






function GetFileName(FilePath: PChar): PChar;
var
  P: PChar;
begin
  P := StrRScan(FilePath, '\');
  if P = nil then P := StrRScan(FilePath, ':');
  if P = nil then GetFileName := FilePath else GetFileName := P + 1;
end;



function GetExtension(FilePath: PChar): PChar;
var
  P: PChar;
begin
  P := StrScan(GetFileName(FilePath), '.');
  if P = nil then GetExtension := StrEnd(FilePath) else GetExtension := P;
end;



function WithoutExtension(FilePath: PChar): PChar;
var
  P: PChar;
begin
  P := StrRScan(GetFileName(FilePath), '.');
  if P <> nil then P[0]:= #0;
  WithoutExtension:= FilePath;
end;



function HasWildCards(FilePath: PChar): Boolean;
begin
  HasWildCards := (StrScan(FilePath, '*') <> nil) or
    (StrScan(FilePath, '?') <> nil);
end;









function OKVstupJmBl  (Jm : PChar): boolean;
const
  INPUTJMZN    :TMnozinaZnaku = [chr (33)..chr (255)]
-['*','?','|','','%',{'.','\',':',}'"','/','[',']','|','<','>','+','=',';',','];

var
  i: byte;
begin
  if Strlen(Jm) = 0
  then begin
    OKVstupJmBl := false;
    exit;
  end;

  for i := 0 to pred(Strlen(Jm)) do
  if not (Jm[i] in INPUTJMZN)
  then begin
    OKVstupJmBl := false;
    exit;
  end;

  OKVstupJmBl := true;
end;




procedure ZrusSeznamSouboru(var SeznamSouboru: PPathS);
var
  PomPtr: PPathS;

begin
  while SeznamSouboru <> nil do
  begin
    PomPtr := SeznamSouboru^.Dalsi;
    Dispose(SeznamSouboru);
    SeznamSouboru := PomPtr;
  end;
end;


{ Pozor! Pouzivaji se na obycejne stringy.}

function DejUpravenouHodnotuStr
         (Typ: char; Delka, DesMist: integer; UCiselZlevaNuly: boolean;
          Hodnota: string): string;
var
  Retez: string;

begin
  begin
    fillChar(Retez[1], Delka, ' ');

    if Delka < length(Hodnota) then
    begin  { Delka je kratsi- oriznout }
      if Typ = 'N' then { u numerickych oriznuti zprava }
         Retez:= copy(Hodnota, length(Hodnota)-Delka + 1, Delka)
      else
         Retez:= copy(Hodnota, 1, Delka)
    end
    else
       Retez:= Hodnota;

    if Typ = 'N' then
    begin
      if DesMist = 0 then
      begin
        if UCiselZlevaNuly then
          NormLNum0 (Delka, Retez[1])
        else
          NormLNumSP (Delka, Retez[1])
      end
      else
      begin
        if UCiselZlevaNuly then
          NormRNum0 (Delka, DesMist, Retez[1])
        else
          NormRNumSP (Delka, DesMist, Retez[1])
      end
    end
    else NormChar (Delka, Retez[1]);

    byte(Retez[0]):= Delka;
  end;
  DejUpravenouHodnotuStr:= Retez;
end;


{$ENDIF}

*)
end.
