unit CreaDBF;
interface
uses
// KERNEL
  Elements;
type


TFieldDefElement = class(TOwnerElement)
private
  FSel: boolean;
  FType: char;
  FSize: word;
  FDecimal: word;
  function GetSQLType: string;
    procedure SetSel(const Value: boolean);
public
  procedure SetField(aName: string; aType: char; aSize, aDecimal: word);
published
  property SQLType: string read GetSQLType stored false;
  property dbType: char read FType write FType;
  property dbSize: word read FSize write FSize;
  property dbDecimal: word read FDecimal write FDecimal;
  property Sel: boolean read FSel write SetSel;
end;


procedure CreateTable(TableName: String; aFieldDefs: TEntity);
 { TODO 2 -oPPK -cDodlat : Pri tvoreni db podle pouzit fukce pro nacteni definice nize }
procedure VytvorDBDleCRT(JmCRT, JmDB: string; var OKej: boolean);
procedure VytvorDBDleDBF(ZdrojDBF, JmDB: string; var OKej: boolean);
procedure VytvorDBFDle(Zdroj, JmDB: string; var OKEj: boolean);
function  NactiDefiniciZeSouboru(Zdroj: string; OKej: boolean): TEntity;
function  NactiDefiniciZCRT(JmCRT: string; var OKej: boolean): TEntity;
function  NactiDefiniciZDBF(ZdrojDBF: string; var OKej: boolean): TEntity;


implementation
uses
  SysUtils, DB, DBTables, Dialogs, Forms,
// KERNEL
  CtiRadek,
// TOPOL
  //F_Main, ???
  e_Class,
  DBType;



procedure TFielddefElement.SetField(aName: string; aType: char; aSize, aDecimal: word);
begin
  Name:= aName;
  FType:= aType;
  FSize:= aSize;
  FDecimal:= aDecimal
end;


function TFieldDefElement.GetSQLType: string;
begin
  result:= '';
  case FType of
  'C': result:= 'char(' + IntToStr(FSize) + ')';
  'N': result:= 'decimal(' + IntToStr(FSize) + ',' + IntToStr(FDecimal) + ')';
  'L': result:= 'boolean';
  'D': result:= 'date'
  end
end;





procedure CreateTable(TableName: String; aFieldDefs: TEntity);
var
  Query1: TQuery;
  i: longInt;
  aField: TFieldDefElement;
begin
   if FileExists(TableName) then DeleteFile(TableName);
   Query1:= TQuery.Create(Application);
   try
      query1.sql.clear;
      query1.sql.add ('create table "' + TableName + '" (');
      for i:= 0 to aFieldDefs.Count-1 do
      begin
        aField:= TFieldDefElement(aFieldDefs.Elements[I]);
        if not (TObject(aField) is TFieldDefElement) then continue;

        if i = aFieldDefs.Count - 1 then
           query1.sql.add (aField.Name + ' ' + aField.GetSQLType + ')')
        else
           query1.sql.add (aField.Name + ' ' + aField.GetSQLType + ',');
      end;


      try
         query1.execSQL;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu vytvoit tabulku '+
                        TableName + #13#10 + 'Chybov hlen: ' +  #13#10 +
            E.Message , mtError, [mbOK], 0);
         end;
      end;

   finally
     Query1.Free;
   end
end;

{
 sql m vypadat:

 create table "C:\DBF\POKUS.DBF"
     ( Pole1 char(20),
       Pole2 decimal(12,3),
       Pole3 Boolean)
}

procedure Hlaska(Hl: string);
begin
  MessageDlg(Hl, mtError, [mbOK], 0)
end;


function  NactiDefiniciZeSouboru(Zdroj: string; OKej: boolean): TEntity;
var
  aExt: string;
begin
  OKEj:= false;
  result := nil;
  aExt:= UpperCase(ExtractFileExt(Zdroj));
  if aExt = '.DBF' then
     result := NactiDefiniciZDBF(Zdroj, OKej)
  else
  if aExt = '.CRT' then
     result := NactiDefiniciZCRT(Zdroj, OKej);
end;

function  NactiDefiniciZCRT(JmCRT: string; var OKej: boolean): TEntity;
var
  F: text;
  Radek: string;
  CR: longInt;
  RO: TCtiRadekClass;
  Jmeno: string;
  Typ: char;
  Delka: integer;
  PocDesMist: integer;
  Entita: TEntity;
  Polozka: TFieldDefElement;
  Chyba: boolean;
  ByloCislo: boolean;
begin
   OKej:= false;
   ByloCislo:= false;
   result := nil;
 try
   if (JmCRT <> '') then
   begin
      assign(F, JmCRT);
      {$I-} reset(F) {$I+};
      if IOResult = 0 then
      begin
         Chyba:= false;
         CR:= 0;
         Entita:= TOwnerEntity.Create;
         result := Entita;
         while not eof(F) and not Chyba do
         begin
            readln(F, Radek);
            inc(CR);
            if (Radek <> '') and (not (Radek[1] in [';','{','('])) then
            begin
               RO:= TCtiRadekClass.Create(Radek);
               if not RO.DosloKChybe then
               with RO do
               begin
                  PreskocMezery;
                  Jmeno:= DejStringPoZnak(' ');
                  if not ByloCislo then
                     ByloCislo:= UpperCase(Jmeno) = 'CISLO';
                  if not DosloKChybe and (Jmeno <> '') then
                  begin
                     PreskocMezery;
                     Typ:= upCase(DejChar);
                     if not DosloKChybe and (Typ in ['C', 'N', 'L', 'D']) then
                     begin
                        Delka:= DejInteger;
                        PocDesMist:= DejInteger;
                        Polozka:= TFieldDefElement.Create;
                        Polozka.SetField(Jmeno, Typ, Delka, PocDesMist);
                        Entita.AddElement(Polozka);
                        OKej:= true
                     end
                     else
	                Hlaska(ExtractFileName(JmCRT) + ': Spatny typ polozky, radek c.' + IntToStr(CR))
                  end
                  else
	             Hlaska(ExtractFileName(JmCRT) + ': Spatne jmeno polozky, radek c.' + IntToStr(CR))
               end
               else
                  Hlaska(ExtractFileName(JmCRT) + ': Spatny radek c.' + IntToStr(CR));
               RO.Free
            end
         end;
         if OKej then
         begin
            if not ByloCislo then
            begin
               Polozka:= TFieldDefElement.Create;
               Polozka.SetField('CISLO', 'N', 8, 0);
               Entita.AddElement(Polozka);
            end;
         end;
         {I-}close(F);{$I+}
         if IOresult <> 0 then;
      end;
   end;
 except
    ShowMessage('Error reading fields def. by: ' + JmCRT)
 end;
end;

function  NactiDefiniciZDBF(ZdrojDBF: string; var OKej: boolean): TEntity;
var
  F: file of TPopisPol;
  Jmeno: string;
  Entita: TEntity;
  Polozka: TFieldDefElement;
  DBPolozka: TPopisPol;
  Hlavicka: TPopisSouboruDBF;
  I: integer;
begin
   OKej:= false;
   result := nil;
   if (ZdrojDBF <> '') and FileExists(ZdrojDBF) then
   begin
      Entita:= TOwnerEntity.Create;
      result := Entita;
      assign(F, ZdrojDBF);
      fileMode:= $40;
      {$I-} reset(F); {$I+}
      if ioResult = 0 then
      begin
         read(F, TPopisPol(Hlavicka));
         for I:= 2 to Hlavicka.DelkaZahlavi div 32 do
         begin
            read(F, DBPolozka);
            Jmeno:= strPas(DBPolozka.JmenoPolozky);
            Polozka:= TFieldDefElement.Create;
            with DBPolozka do
               Polozka.SetField(Jmeno, TypPolozky, DelkaPolozky, PocetDesMist);
            Entita.AddElement(Polozka);
            OKej:= true
         end;
         {I-}close(F);{$I+}
         if IOresult <> 0 then;
      end;
   end;
end;







procedure VytvorDBDleCRT(JmCRT, JmDB: string; var OKej: boolean);
var
  F: text;
  Radek: string;
  CR: longInt;
  RO: TCtiRadekClass;
  Jmeno: string;
  Typ: char;
  Delka: integer;
  PocDesMist: integer;
  Entita: TEntity;
  Polozka: TFieldDefElement;
  Chyba: boolean;
  ByloCislo: boolean;
begin
  OKej:= false;
  ByloCislo:= false;

  try
  if (JmCRT <> '') and (JmDB <> '') then
  begin
    assign(F, JmCRT);

    {$I-} reset(F) {$I+};
    if IOResult = 0 then
    begin
      Chyba:= false;
      CR:= 0;
      Entita:= TEntity.Create;

      while not eof(F) and not Chyba do
      begin
        readln(F, Radek);
        inc(CR);

        if (Radek <> '') and (not (Radek[1] in [';','{','('])) then
        begin
          RO:= TCtiRadekClass.Create(Radek);
          if not RO.DosloKChybe then
          with RO do
          begin
            PreskocMezery;
            Jmeno:= DejStringPoZnak(' ');

            if not ByloCislo then
               ByloCislo:= UpperCase(Jmeno) = 'CISLO';

            if not DosloKChybe and (Jmeno <> '') then
            begin
              PreskocMezery;
              Typ:= upCase(DejChar);

              if not DosloKChybe and (Typ in ['C', 'N', 'L', 'D']) then
              begin
                Delka:= DejInteger;
                PocDesMist:= DejInteger;
                Polozka:= TFieldDefElement.Create;
                Polozka.SetField(Jmeno, Typ, Delka, PocDesMist);
                Entita.AddElement(Polozka);
                OKej:= true
              end
              else
	      Hlaska(ExtractFileName(JmCRT) + ': Spatny typ polozky, radek c.' + IntToStr(CR))



            end
            else
	    Hlaska(ExtractFileName(JmCRT) + ': Spatne jmeno polozky, radek c.' + IntToStr(CR))



          end
          else Hlaska(ExtractFileName(JmCRT) + ': Spatny radek c.' + IntToStr(CR));


          RO.Free
        end
      end;

      if OKej then
      begin
        if not ByloCislo then
        begin
          Polozka:= TFieldDefElement.Create;
          Polozka.SetField('CISLO', 'N', 6, 0);
          Entita.AddElement(Polozka);
        end;

        if (Entita <> nil) and (Entita.Count > 1) then
        begin
          CreateTable(JmDB, Entita)
        end
      end;
  {I-}close(F);{$I+}
      if IOresult <> 0 then;

      Entita.Free
    end
    else
  end
  except
    ShowMessage('Problm s vytvoenm DBF dle ' + JmCRT)
  end;
end;

(*
function DejDBFTyp(DelphiTyp: TFieldType): char;
begin
  result:= 'C';
  case DelphiTyp of
  ftUnknown:  result:= 'C';
  ftString:   result:= 'C';
  ftSmallint: result:= 'N';
  ftInteger:  result:= 'N';
  ftWord:     result:= 'N';
  ftBoolean:  result:= 'L';
  ftFloat:    result:= 'N';
  ftCurrency: result:= 'N';
  ftBCD:      result:= 'N';
  ftDate:     result:= 'D';
  ftTime:     result:= 'N';
  ftDateTime: result:= 'N';
  ftBytes:    result:= 'N';
  ftVarBytes: result:= 'N';
  ftBlob:     result:= 'B';
  ftMemo:     result:= 'M';
  ftGraphic:  result:= 'G';
  end;
end;

*)

procedure VytvorDBDleDBF(ZdrojDBF, JmDB: string; var OKej: boolean);
var
  F: file of TPopisPol;
  Jmeno: string;
  Entita: TEntity;
  Polozka: TFieldDefElement;
  DBPolozka: TPopisPol;
  Hlavicka: TPopisSouboruDBF;
  I: integer;
begin
  OKej:= false;

  if FileExists(JmDB) then DeleteFile(JmDB);

  if (ZdrojDBF <> '') and (JmDB <> '') and FileExists(ZdrojDBF) then
  begin
    Entita:= TEntity.Create;
    assign(F, ZdrojDBF);
    fileMode:= $40;
    {$I-} reset(F); {$I+}
    if ioResult = 0 then
    begin
      read(F, TPopisPol(Hlavicka));
      for I:= 2 to Hlavicka.DelkaZahlavi div 32 do
      begin
        read(F, DBPolozka);
        Jmeno:= strPas(DBPolozka.JmenoPolozky);
        Polozka:= TFieldDefElement.Create;
        with DBPolozka do
             Polozka.SetField(Jmeno, TypPolozky, DelkaPolozky, PocetDesMist);
        Entita.AddElement(Polozka);
        OKej:= true
      end;

  {I-}close(F);{$I+}
      if IOresult <> 0 then;
    end;

    if (Entita <> nil) and (Entita.Count > 1) then
    begin
      CreateTable(JmDB, Entita)
    end;

    Entita.Free;
  end

end;


procedure VytvorDBFDle(Zdroj, JmDB: string; var OKEj: boolean);
var
  aExt: string;
begin
  OKEj:= false;
  aExt:= ExtractFileExt(Zdroj);
  if aExt = '.DBF' then
     VytvorDBDleDBF(Zdroj, JmDB, OKej)
  else
  if aExt = '.CRT' then
     VytvorDBDleCRT(Zdroj, JmDB, OKej)
end;


procedure TFieldDefElement.SetSel(const Value: boolean);
begin
   FSel := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TFieldDefElement);
END.
