unit E_impsrc;

interface

uses
// KERNEL
  Elements;


type

TImportSourceNode = class(TOwnerElement)
 protected
   FSourcePath: PString;
   function  GetSourcePath: string;
   procedure SetSourcePath(aSource: string);
 public
   destructor Destroy; override;
   property   SourcePath: string read GetSourcePath write SetSourcePath;
end;



TImportSource = class(TOwnerEntity)
 protected
    function  GetItem(Index: longint): TImportSourceNode;
 public
   procedure AddItem(aSourcePath: string); virtual;

   property Items[Index: longint]: TImportSourceNode read GetItem ;
end;

implementation

uses
// KERNEL
   e_Class,
   u_String;

{ TImportSourceNode }

destructor TImportSourceNode.Destroy;
begin
   SetPString(FSourcePath, '');
   inherited Destroy;
end;


function  TImportSourceNode.GetSourcePath: string;
begin
   result := GetPString(FSourcePath);
end;

procedure TImportSourceNode.SetSourcePath(aSource: string);
begin
   SetPString(FSourcePath, aSource);
end;

{ TImportSource }


function  TImportSource.GetItem(Index: longint): TImportSourceNode;
begin
   result := TImportSourceNode(Elements[Index]);
end;


procedure TImportSource.AddItem(aSourcePath: string);
var
   Node: TImportSourceNode;
begin
   if aSourcePath = '' then exit;
   Node := TImportSourceNode.Create;
   Node.SourcePath := aSourcePath;
   AddElement(Node);
end;

BEGIN
   RegisterOrbisClass(TImportSourceNode);
   RegisterOrbisClass(TImportSource);
END.
