unit T_copblk;

interface

uses
// KERNEL
  Elements,
  Tools,
// SPACE
   e_Geometry,
  //E_Space,
  E_QTree,
// SPACETOOL
  E_QTLin;
// DIALOG
  //F_Gauge;

type

(*

TCopyBlok = class(TTool)
private
  FDruhyLinii: string;
  FSourceBlockDir: string;
  FQTree: TQTreeTopLin;
  FLinesContainer: TPolyLineString;
  FMinLength   : double;
  FSnapDistance: double;
  FOnlyEnds    : boolean;
  FSelfTest    : boolean;
  FCompareOnlyDifferentSource: boolean;
  FPrepocitavatPopBodyLinii: boolean;
  FSmazatSymboly: boolean;

  procedure Process(Element: TElement);
  function QProcessLine(Lin: TPolyLineElement): boolean; virtual;
public
  procedure DoIt; override;
published
  property DruhyLinii: string read FDruhyLinii write FDruhyLinii;
  property SourceBlockDir: string read FSourceBlockDir write FSourceBlockDir;
  property MinLength   : double  read FMinLength    write FMinLength   ;
  property SnapDistance: double  read FSnapDistance write FSnapDistance;
  property OnlyEnds    : boolean read FOnlyEnds     write FOnlyEnds    ;
  property SelfTest    : boolean read FSelfTest     write FSelfTest    ;
  property CompareOnlyDifferentSource: boolean
           read FCompareOnlyDifferentSource write FCompareOnlyDifferentSource;
  property PrepocitavatPopBodyLinii: boolean read FPrepocitavatPopBodyLinii
           write FPrepocitavatPopBodyLinii;
  property SmazatSymboly: boolean read FSmazatSymboly write FSmazatSymboly;
end;



TMakeNodedQTree = class(TTool)
private
  FDeletePseudoNodes: boolean;
public
  procedure DoIt; override;
published
  property DeletePseudoNodes: boolean read FDeletePseudoNodes write FDeletePseudoNodes;
end;

*)

TMakeNodes = class(TTool)
private
  FJoinDifferentLines: boolean;
  FDeletePseudoNodes: boolean;
    function GetNodesQtree: TSpaceLineBegEndCell;
public
  procedure DoIt; override;
published
  property JoinDifferentLines: boolean read FJoinDifferentLines write FJoinDifferentLines;
  property DeletePseudoNodes: boolean read FDeletePseudoNodes write FDeletePseudoNodes;
  property NodesQTree: TSpaceLineBegEndCell read GetNodesQtree;
end;


(*
TMakeNodesAndAreas = class(TMakeNodes)
public
  procedure DoIt; override;
end;



TSaveAreasToBlok = class(TTool)
{ vstup - entity obsahujc nkde linie }
{ vstup - zpis do bloku }
private
  FDruhLinii: integer;
  FDruhPloch: integer;
  FBlockDir: string;
  FCreateDBFFileName: string;
  FTransferDBFScript: string;
  procedure Prepare; virtual;
public
  procedure DoIt; override;
published
  property DruhLinii: integer read FDruhLinii write FDruhLinii;
  property DruhPloch: integer read FDruhPloch write FDruhPloch;
  property TransferDBFScript: string read FTransferDBFScript write FTransferDBFScript;
  property CreateDBFFileName: string read FCreateDBFFileName write FCreateDBFFileName;
  property BlockDir: string read FBlockDir write FBlockDir;
end;

*)

implementation

uses
  SysUtils, Dialogs, Forms, Controls,
// KERNEL
   e_Class,
   E_Type,
   Worlds,
   U_String,
// GLIB
   E_WCS,
   MathLib,
// SPACETOOL
   T_ApPlac,
   T_LinJoi,
   T_Topol,
   T_ToTool,
// TOPOL
   T_TopImp, T_TopExp, {T_NodExp,}
  {!t_Main,}
  U_TopolT, {T_ExpAre,} T_ExArTl,
  T_SAMake,
  C_TlDBF//,
  //F_Main
  {, T_SAMake};

//var
  //FGF: TF_GaugeForm;


(*

procedure TCopyBlok.Process(Element: TElement);
{ Penos z jedn struktury do druh:
  Natat linie z QTree a ukldat je do druh struktury
  Input   : QTree lini
  Praktick loha: do jedn struktury vkldat nco z jin struktury
  Vody - Cesty - chpat je jako QTree }
var
  Lin: TPolyLineElement;
  LC : TLinComparator;
  LAE: TLinesAbscEntity;
  SCL: TSaveChangedLines;
  NewLin: TPolyLineElement;
  Pom: boolean;
begin
  if (Element is TPolyLineElement) and not (TPolyLineElement(Element).IsDone) then
  begin
    Lin:= TPolyLineElement(Element);

    if Lin.Length<= MinLength then
       exit;

    Lin.IsDone:= true;

    NewLin:= TPolyLineElement.Create;
    NewLin.Assign(Lin);
    NewLin.GetElements(Lin, 0, Lin.Count-1);

{$IFDEF TestProtocol}
    ProtocolName:= IntToStrZ(FPocetLinii, 4, true) +
                   IntToStrZ(TPolyLineElement(Element).Cislo,4,true) + '.PTC';
    Uroven:= 0;
{$ENDIF}

    LC:= TLinComparator.Create;
    LC.Input:= NewLin;
    LC.QTree:= FQTree;
    LC.SnapDistance:= SnapDistance;
    LC.OnlyEnds:= OnlyEnds;
    LC.SelfTest:= SelfTest;
    LC.CompareOnlyDifferentSource:= CompareOnlyDifferentSource;
    LC.RefContainer:= FLinesContainer;
    LC.DoIt;
    LAE:= TLinesAbscEntity(LC.Output);
    LC.Free;

    if LAE.GetLine(0) = NewLin then
    { Jestli vbec nco z nov linie zbylo }
    begin
      SCL:= TSaveChangedLines.Create;
      SCL.Input:= LAE;
      SCL.QTree:= FQTree;
      SCL.NewLines:= FLinesContainer;
      SCL.SetLinesLabelPoint:= PrepocitavatPopBodyLinii;
      SCL.MinLength:= 0;
      SCL.DoIt;
      SCL.Free;
    end;
    Pom:= false;

    if  Pom then
       VypisQTree('G:\GIS\TMP\VYPIS.TXT', FQTree);


{    TEntity(Input).AddElement(LAE); }
{
    FQTree.Add(Lin);
    FLinesContainer.AddAndUpdateRect(Lin);
}
  end
end;



function TCopyBlok.QProcessLine(Lin: TPolyLineElement): boolean;
begin
  result:= true;
end;



procedure TCopyBlok.DoIt;
var
  DrzakQTree: TEntity;
  RBL: TReadBlokLines;
  I: longInt;
  Lin: TPolyLineElement;

  Xmin, Ymin, Xmax, Ymax: double;

  OL: TOznacLinie;

{  NLDQ: TReadLinesIntoQTree; }
  QTree: TSpaceLineBegEndCell;
  Bloky: TSpaceEntity;
  Nacitat: boolean;
  SE: TStringElement;
  IL: TIntegerListElement;
  FD: TFiltrDruhuObjektu;


begin
try
{  FSourceBlockDir:= 'g:\gis\l1\_2ces.blk'; }
{  FSourceBlockDir:= 'c:\0\mezna\det.blk'; }
{  FSourceBlockDir:= 'c:\0\mezna\6l.blk'; }
{  FSourceBlockDir:= 'c:\orbis\spoj.blk'; }
  if FSourceBlockDir = '' then
     FSourceBlockDir:= 'c:\TMP\Vstup.blk';
  DrzakQTree:= TEntity(Input);

  if DrzakQTree is TEntity then
  begin
    Bloky:= TSpaceEntity(DrzakQTree.FindElementName('PredmetZajmu'));
    if Bloky = nil then
    begin
      Bloky:= TSpaceEntity.Create;
      Bloky.Name:= 'PredmetZajmu';
      DrzakQTree.AddElement(Bloky);
    end;


   { vytvoen novho kontejneru pro linie z jednoho bloku }
    FLinesContainer:= TPolyLineString.Create;
    Bloky.AddElement(FLinesContainer);
    FLinesContainer.Name:= 'Lines from ' + FSourceBlockDir;

    RBL:= TReadBlokLines.CreateBlock(FSourceBlockDir);
    RBL.GiveRectangle(Xmin, Ymin, Xmax, Ymax);

    if DruhyLinii <> '' then
    begin
      SE:= TStringElement.Create;
      SE.Text:= DruhyLinii;
      IL:= SE.CreateIntegerList;
      FD:= TFiltrDruhuObjektu.Create;
      FD.SetFiltr('L', IL);
      SE.Free;
      RBL.FiltrDruhu:= FD;
    end;

    FQTree:= TQTreeTopLin(DrzakQTree.FindElementClass(TQTreeTopLin));
    if FQTree = nil then
    begin
       FQTree:= TQTreeTopLin.Create;
       DrzakQTree.AddElement(FQTree);
       FQTree.SetForRectangle(Xmin, Ymin, Xmax, Ymax)
    end
    else
      FQTree.ExtendQuad(Xmin, Ymin, Xmax, Ymax);

    Application.CreateForm(TF_GaugeForm, FGF);
    FGF.Caption:= '';
    FGF.MaxValue:= RBL.Size-1;
    FGF.Show;
    Screen.Cursor:= crHourGlass;

    for I:= 1 to RBL.Size-1 do
    begin
      if FGF.DoCloseQuery and FGF.RealyClose('Peruit natn lini ?') then
         break;
      FGF.Progress:= I;
      FGF.Caption:= FSourceBlockDir + ': tu linii . ' + IntToStrZ(I, 5, false);
      Application.ProcessMessages;

      Lin:= RBL.GetLine(I);

      if Lin = nil then continue;

      Nacitat:= QProcessLine(Lin);

      if Nacitat then
      begin
        Process(Lin);
        Lin.Clear;
      end;

      Lin.Free
    end;

    FGF.Free;
    Screen.Cursor:= crDefault;

    RBL.Free;

    Bloky.UpdateRect(FLinesContainer)
  end;
except
   on E:Exception do
   begin
      ShowMessage(E.Message);
      Screen.Cursor:= crDefault;
   end
end;
end;
*)

(*

function TCopyBlokDoLHC.QProcessLine(Lin: TPolyLineElement): boolean;
var
  PravyRevir, LevyRevir: integer;
  DBTable: TTopolDBFTable;
  Plo: TPlocha;
begin
  result:= false;
  DBTable:= TTopolDBFTable.Create(MainForm);

  PravyRevir:= -1; LevyRevir:= -1;
  if (Lin.LevaPlocha <> Lin.PravaPlocha) then
  begin
    if (Lin.LevaPlocha > 0) then
    begin
      try
        Plo:= DejTopPlochu(FSourceBlockDir, Lin.LevaPlocha);
        if (Plo.Druh = 1100) and
           DBTable.SetForTopolObject(FSourceBlockDir, 'P', 1100, Lin.LevaPlocha) then
           LevyRevir:= DBTable.FieldByName('REVIR').AsInteger;
      except
      end
    end;

    if (Lin.PravaPlocha> 0 ) then
    begin
      try
        Plo:= DejTopPlochu(FSourceBlockDir, Lin.PravaPlocha);
        if (Plo.Druh = 1100) and
           DBTable.SetForTopolObject(FSourceBlockDir, 'P', 1100, Lin.PravaPlocha) then
           PRavyRevir:= DBTable.FieldByName('REVIR').AsInteger;
      except
      end
    end;

    if (PravyRevir =-1) or (LevyRevir = -1) or (PravyRevir <> LevyRevir) then
       result:= true;
  end;

  DBTable.Free
end;
{$ENDIF}

*)
             { TMakeNodedQTree }
(*

procedure TMakeNodedQTree.DoIt;
var
  NLDQ: TReadLinesIntoQTree;
  PNIQ: TPutNodesIntoQTree;
  ZPVNL: TDeleteDirectRelationsToLinesInQTree;
  NC: TNodesConector;

  QTree: TSpaceLineBegEndCell;

begin
  if not (Input is TEntity) then exit;
  NLDQ:= TReadLinesIntoQTree.Create;
  NLDQ.Input:= Input;
  NLDQ.DoIt;
  QTree:= TSpaceLineBegEndCell(NLDQ.Output);
  NLDQ.Free;

  PNIQ:= TPutNodesIntoQTree.Create;
  PNIQ.Input:= QTree;
  PNIQ.DoIt;
  PNIQ.Free;

  ZPVNL:= TDeleteDirectRelationsToLinesInQTree.Create;
  ZPVNL.Input:= QTree;
  ZPVNL.DoIt;
  ZPVNL.Free;

  NC:= TNodesConector.Create;
  NC.Input:= QTree;
  NC.DeletePseudoNodes:= DeletePseudoNodes;
  NC.DoIt;
  NC.Free;
  Output:= QTree
end;
*)

                   { TMakeNodes }

function TMakeNodes.GetNodesQtree: TSpaceLineBegEndCell;
begin
  Result:= TSpaceLineBegEndCell(Self.FindElementClass(TSpaceLineBegEndCell));
end;


procedure TMakeNodes.DoIt;
var
  NLDQ: TReadLinesIntoQTree;
  PNIQ: TPutNodesIntoQTree;
  ZPVNL: TDeleteDirectRelationsToLinesInQTree;
  NC: TNodesConector;

  QTree: TSpaceLineBegEndCell;
  Hledac: THledacLinii;
  Linie: TPolyLineString;

begin
  if not (Input is TEntity) then exit;

  NLDQ:= TReadLinesIntoQTree.Create;
  NLDQ.Input:= Input;
  NLDQ.DoIt;
  QTree:= TSpaceLineBegEndCell(NLDQ.Output);
  AddElement(QTree);
  NLDQ.Free;

  PNIQ:= TPutNodesIntoQTree.Create;
  PNIQ.Input:= QTree;
  PNIQ.DoIt;
  PNIQ.Free;

  ZPVNL:= TDeleteDirectRelationsToLinesInQTree.Create;
  ZPVNL.Input:= QTree;
  ZPVNL.DoIt;
  ZPVNL.Free;

  NC:= TNodesConector.Create;
  NC.Input:= QTree;
  NC.JoinDifferentLines:= JoinDifferentLines;
  NC.DeletePseudoNodes:= DeletePseudoNodes;
  NC.DoIt;
  NC.Free;

  Hledac:= THledacLinii.Create;
  Hledac.input:= QTree;
  Hledac.DoIt;
  Linie:= TPolyLineString(Hledac.output);
  AddElement(Linie);
  Hledac.Free;

  Output:= Linie
end;

(*
procedure TMakeNodesAndAreas.DoIt;
var
  NLDQ: TReadLinesIntoQTree;
  PNIQ: TPutNodesIntoQTree;
  ZPVNL: TDeleteDirectRelationsToLinesInQTree;
  NC: TNodesConector;
  CAFQ: TCreateAreasForQTree;
  SubArM: TSubAreaMakerInQTree;
  Hledac: THledacPloch;
  APP: TMultiAreaPointPlacer;

  QTree: TSpaceLineBegEndCell;
  QTreePloch: TSpaceEntityQTree;
  Plochy: TAreaString;

begin
  if not (Input is TEntity) then exit;

  NLDQ:= TReadLinesIntoQTree.Create;
  NLDQ.Input:= Input;
  NLDQ.DoIt;
  QTree:= TSpaceLineBegEndCell(NLDQ.Output);
  NLDQ.Free;

  PNIQ:= TPutNodesIntoQTree.Create;
  PNIQ.Input:= QTree;
  PNIQ.DoIt;
  PNIQ.Free;

  ZPVNL:= TDeleteDirectRelationsToLinesInQTree.Create;
  ZPVNL.Input:= QTree;
  ZPVNL.DoIt;
  ZPVNL.Free;

  NC:= TNodesConector.Create;
  NC.Input:= QTree;
  NC.JoinDifferentLines:= JoinDifferentLines;
  NC.DeletePseudoNodes:= DeletePseudoNodes;
  NC.DoIt;
  NC.Free;


  CAFQ:= TCreateAreasForQTree.Create;
  CAFQ.Input:= QTree;
  CAFQ.DoIt;
  QTreePloch:= TSpaceEntityQTree(CAFQ.Output);
  CAFQ.Free;

  SubArM:= TSubAreaMakerInQTree.Create;
  SubArM.Input:= QTreePloch;
  SubArM.DoIt;
  SubArM.Free;

  Hledac:= THledacPloch.Create;
  Hledac.input:= QTreePloch;
  Hledac.DoIt;
  Plochy:= TAreaString(Hledac.output);
  World.ObjectModel.AddElement(Plochy);
  Hledac.Free;


  APP:= TMultiAreaPointPlacer.Create;
  APP.Input:= Plochy;
  APP.DoIt;
  APP.Free;

  Output:= Plochy
end;



procedure TSaveAreasToBlok.Prepare;
var
  OL: TOznacLinie;
begin
  OL:= TOznacLinie.Create;
  OL.Input:= Input;
  OL.DoIt;
  OL.Free;
end;



procedure TSaveAreasToBlok.DoIt;
var
{  EDPT: TExportDBPlochProTriduObec; }
  EATT: TExportAreasToTopol;

{  ETLI: TExportTopolLiniiDBRecursorI; }
begin
  if Input is TEntity then
  begin
    EATT:= TExportAreasToTopol.Create;
    EATT.Input:= Input;
    EATT.BlockName:= BlockDir;
    EATT.ExportDBF:= true;
    EATT.DoIt;
    EATT.Free;
{
    EDPT:= TExportDBPlochProTriduObec.Create;
    EDPT.Input:= Input;
    EDPT.BlockDirectory:= BlockDir;
    EDPT.WCS:= TWCSWorld(World).GetIDWCS(cs_JTSK);
    EDPT.DruhPloch:= DruhPloch;
    EDPT.SetContainerClass(TUkladacPloch);
    EDPT.TransferDBFScript:= TransferDBFScript;
    EDPT.CreateDBFFileName:= CreateDBFFileName;
    EDPT.DoIt;
    EDPT.Free;

    ETLI:= TExportTopolLiniiDBRecursorI.Create
           (BlockDir, TWCSWorld(World).GetIDWCS(cs_JTSK), true);
    ETLI.Input:= Input;
    ETLI.DoIt;
    ETLI.Free;
}
  end
end;

*)
(*
procedure TSaveAreasLHCToBlok.DoIt;
var
  EDPT: TExportDBPlochLHC;

begin
  if Input is TEntity then
  begin
    Prepare;

    EDPT:= TExportDBPlochLHC.Create;
    EDPT.Input:= Input;
    EDPT.BlockDirectory:= BlockDir;
    EDPT.WCS:= TWCSWorld(World).GetIDWCS(cs_JTSK);
    EDPT.DruhLinii:= 1100;
    EDPT.DruhPloch:= 1100;
    EDPT.SetContainerClass(TUkladacPloch);
    EDPT.TransferDBFScript:= TransferDBFScript;
    EDPT.CreateDBFFileName:= CreateDBFFileName;
    EDPT.DoIt;
    EDPT.Free;
  end
end;
*)



begin
  RegisterOrbisClass(TMakeNodes);
  //RegisterOrbisClass(TMakeNodesAndAreas);
  //RegisterOrbisClass(TSaveAreasToBlok);
end.
