unit T_topimp;

{
[Unit_Description]
Description=Import dat TopoLu do modelu ORBISu
Comment=siln provizorn zleitost .... chce to revizi
Admin=Olda
TechTopic=Tools
Topic=Import
Version=1.0

[Edit]
 8.8.1997 19:12=Registrace
 21.8.1997 O.S.
}

interface

uses
   Classes,
// KERNEL
   Elements, {e_lstBin,}
   e_Type,
   Tools,
// DIALOG
   //F_Gauge,
   //F_Protcl,
// GLIB
   e_WCS,
   g_Elems,
// SPACE
   //e_Space,
   e_Geometry,
   e_GeometryElement,
   e_Reg,
// RASTER
{$IFDEF RAS}
   e_Raster,
{$ENDIF}
// SYMBOL
   u_Symbol,
// TOPOL
   {e_TopMDL, }
   e_TplReg,
   e_TopoLElements,
   //e_TplPrp,
   u_TopoLT;

const
   WCSID = cs_JTSK;
type

   TObjectEvent = procedure (var Element: TElement) of object;


   TArrayOfInt = array[0..100]of longInt;

   TFiltrDruhu = record
                   Count: integer;
                   ArrayOfInt: TArrayOfInt;
                 end;


   TFiltrDruhuObjektu = class(TOwnerElement)
   private
     FExclude: boolean;   { uvedene nevybirat }
     FPropName: string;
     procedure SetObjektFiltr
               (var ObjektFiltr: TIntegerListElement; NewFilter: TIntegerListElement);

   public
     ProBod, ProLin, ProPlo, ProTxt: TIntegerListElement;

     destructor Destroy; override;
     procedure AddFilter(Objekt: char; Druh: integer);
     procedure SetFiltrByArray(Objekt: char; Druhy: array of integer);
     procedure SetFiltr(Objekt: char; Druhy: TIntegerListElement);
     function GetFiltr(Objekt: char):  TIntegerListElement;
     function OKDruh(Objekt: char; TopObjekt: TElement): boolean;
   published
     property Exclude: boolean read FExclude write FExclude;
     property PropName: string read FPropName write FPropName;
   end;



   TTopolManipulator = class(TTool)
   private
       FFiltrDruhu : TFiltrDruhuObjektu;
       FRectLimits: TRectEntity;
       FMinSize: double;
       FCondition: string;
       procedure SetFiltrDruhu(aFiltr: TFiltrDruhuObjektu);
       procedure SetRectLimits(aRect: TRectEntity);
    protected
       FWCS: TWCS;
       FBlockDirectory: string;
       function  GetWCS: TWCS; virtual;
       procedure SetWCS(aWCS: TWCS); virtual;
       procedure   SendProtocolMessage(aMessage: string);
    public
       property    WCS: TWCS read GetWCS write SetWCS;
       property    RectLimits: TRectEntity read FRectLimits write SetRectLimits;
       property    Protocol: string write SendProtocolMessage;
       property    FiltrDruhu: TFiltrDruhuObjektu read FFiltrDruhu write SetFiltrDruhu;
    published
       property MinSize: double read FMinSize write FMinSize;
       property Condition: string read FCondition write FCondition;
       property BlockName: string read FBlockDirectory write FBlockDirectory;
   end;




   TTopoLReader = class(TTopolManipulator)
    private
       FGaugeModulo: integer;
       FRegister: TTopolBlockRegister;
       FUseMemory: boolean;
       FBarva, FZnacka: smallInt;
       FUseBarva, FUseZnacka: boolean;
       FOnNewObject: TObjectEvent;

       procedure SetBarva(aVal: smallInt);
       procedure SetZnacka(aVal: smallInt);
    protected
       FStream: TStream;
       FRecordSize: longInt;
       sss: string;
       //F_gaugeForm: TF_gaugeForm;
       function  GetSize: longInt; virtual;
       procedure GiveCoordFromSour(Sour: TSour; var X, Y: double);
       procedure GiveSourFromCoord(X, Y: double; var Sour: TSour);
       procedure OpenStream; virtual;
       function  OKDruh(Objekt: char; TopObjekt: TElement): boolean;
       function  CreateICSRect(Ymin, Xmin, Ymax, Xmax: double): TRectangle;
       function  GetObjectType: char; virtual;
       function  ConditionIsTrue(TopObject: TElement): boolean;
       function  GetRegister: TTopolBlockRegister; virtual;
    public
       procedure   StartGauge;
       procedure   EndGauge;
       destructor  Destroy; override;
       procedure   ReadIt(var Buf);
       procedure   WriteIt(var Buf);
       procedure   SeekTo(aIndex: longInt); virtual;
       function    GetRect(aObdelnik: TObdelnik): TRectangle;
       function    OKRectLimits(Ymin, Xmin, Ymax, Xmax: double): boolean;
       procedure   SetProps(aProps:TPropertyList);
{       function    GetDBFEntity: TEntity; }

       property    Size: longInt read GetSize;
   published
     property Register: TTopolBlockRegister read GetRegister;
     property UseMemory: boolean read FuseMemory write FUseMemory;
     property Barva: smallInt read FBarva write SetBarva;
     property Znacka: smallInt read FZnacka write SetZnacka;
     property OnNewObject: TObjectEvent read FOnNewObject write FOnNewObject;
   end;


   TTopoLObjectReader = class(TTopolReader)
    protected
       procedure   NewObject(aObject: TTopoLElement); virtual;
    public
       constructor CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS);  virtual;
       procedure   SetRecordSize; virtual; abstract;
       function    GetFileName: string; virtual; abstract;
   end;




   TTopolCoordReader = class(TTopoLObjectReader)
    protected
       {
       procedure OpenStream; override;
       }
    public
       procedure   SetRecordSize; override;
       function    GetFileName: string; override;
       function    ReadCoord: TCoordinate;
   end;

   TTopolLinReader = class(TTopoLObjectReader)
    protected
       FCoordReader: TTopolCoordReader;
       procedure     OpenCoords(aBlockDirectory: string; aWCS: TWCS); virtual;
       function  GetObjectType: char; override;
    public

       constructor CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS); override;
       destructor  Destroy; override;
       procedure   SetRecordSize; override;
       function    GetFileName: string; override;
       function    ReadTopolLin(Position: longInt): TLin;
       function    ReadLin: TTopoLLineElement;
       function    ReadLineSymbol: TTopoLPointElement;
       function OKVratDalsiLiniiVpravo
                     (const Linie    : TLin;
                      LevaStrana     : boolean;
                  var DalsiLinie     : TLin;
                  var DalsiLevaStrana: boolean): boolean;
       function OKVratDalsiLiniiVlevo
                     (const Linie    : TLin;
                      LevaStrana     : boolean;
                  var DalsiLinie     : TLin;
                  var DalsiLevaStrana: boolean): boolean;
   end;


   TReadBlokLines = class(TTopolLinReader)
     constructor CreateBlock(aBlockDirectory: string); virtual;
     procedure GiveRectangle(var X1, Y1, X2, Y2: double);
     function GetLine(Position: longInt): TTopoLLineElement;
   end;


   TTopolAreaBoundaryReader = class(TTopoLObjectReader)
    private
       procedure VratLiniiPlochy
                 (Plocha: TPlocha; var Linie: TLin;
                  var LevaStrana: boolean; var Nalezl: boolean);
    protected
       FCoordReader: TTopolCoordReader;
       FLinReader  : TTopolLinReader;
       function  GetObjectType: char; override;
    public
       constructor CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS); override;
       destructor  Destroy; override;
       procedure   SetRecordSize; override;
       function    GetFileName: string; override;
       function    ReadBoundary(Plo: TPlocha): TTopoLAreaElement;
       function    ReadArea: TTopoLAreaElement; virtual;
   end;

   TTopolAreaInfoReader = class(TTopolAreaBoundaryReader)
     constructor CreateBlock(aBlockDirectory: string); virtual;
     procedure ReadTPlocha(Position: longInt; var Plocha: TPlocha);
   end;


   TTopolAreaReader = class(TTopoLAreaBoundaryReader)
   private
{     AreasBoolList:  TBooleanList; }
{     function   LineFromRegister(aCislo: longInt): TPolyLineElement; }
     function   ReadAreaWithLines(Plo: TPlocha): TTopoLAreaElement;
     function   OuterArea(aCislo: longInt): boolean;
     function   ReadAreaAsHole(Plo: TPlocha): TPolyLineAreaElement;
   public
     function   ReadArea: TTopoLAreaElement; override;
     function   ReadAreaBoundary: TTopoLAreaElement; virtual;
   end;


   TTopolPointReader = class(TTopoLObjectReader)
    protected
       function  GetObjectType: char; override;
    public
       procedure   SetRecordSize; override;
       function    GetFileName: string; override;
       function    ReadPoint: TTopoLPointElement;
   end;


   TTopolTextReader = class(TTopoLObjectReader)
    protected
       FText: System.Text;
       function  GetObjectType: char; override;
    public
       constructor CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS); override;
       destructor  Destroy; override;
       procedure   SetRecordSize; override;
       procedure   OpenTTX(aBlockDirectory: string); virtual;
       function    GetFileName: string; override;
       function    ReadText(var aIndex: integer): TTopoLTextElement;
   end;


   TTopoLBlokInfoReader = class(TTopoLManipulator)
    protected
      function  GetWCS: TWCS; override;
    public
      constructor CreateBlock(aBlockDirectory: string); virtual;
      procedure   ReadRectangle(var Xmin, Ymin, Xmax, Ymax: double);
      function   GetCodePage: TCodePage;
   end;


   TTopoLBlokReader = class(TTopoLReader)
    private
       FCodePage: TCodePage;
{       FObjektList: TObjektList; }
       FReadAreaAsBoundary: boolean;

       function DejPlochuSPodPlochou
                (SeznamPloch: TAreaCollection; Cislo: longInt): TTopoLAreaElement;
       function OKRectLimits(TopolObject: TElement): boolean;
       procedure SetReader(ObjectReader: TTopolReader);
       procedure SetObjectString(aObjString: TGeometryElementCollection; aType: string);

    protected
       FInfoReader : TTopoLBlokInfoReader;
       FLinReader  : TTopoLLinReader;
       FAreaReader : TTopoLAreaReader;
       FPointReader: TTopoLPointReader;
       FTextReader : TTopoLTextReader;
    public
       QReadAreas: boolean;
       constructor CreateBlock(aBlockDirectory: string); virtual;
       Destructor  Destroy; override;
       function    ReadPoints: TPointCollection;
       function    ReadLines:  TPolyLineCollection;
       function    ReadAreas:  TAreaCollection;
       function    ReadTexts:  TTextCollection;
       function    ReadBlock:  TRectEntity;
       function    ReadLineSymbols:  TPointCollection;
   published
     property CodePage: TCodePage read FCodePage;
     property ReadAreaAsBoundary: boolean read FReadAreaAsBoundary write FReadAreaAsBoundary;
   end;


(*

   TPZReaderNoRastr = class(TTool)
   private
      FFiltrDruhu: TFiltrDruhuObjektu;
      procedure SetFiltrDruhu(aFiltr: TFiltrDruhuObjektu);
   public
      QReadAreas: boolean;
      procedure DoIt; override;
      property FiltrDruhu: TFiltrDruhuObjektu read FFiltrDruhu write SetFiltrDruhu;
   end;

*)

procedure GetBlokRect(aPath: string; var Xmin,Ymin,Xmax,Ymax: double);

function  BlokInRect(aPath: string; Rect: TRectEntity): boolean;

function CreateFiltrDruhu(aType: string; Props: TPropertyList): TFiltrDruhuObjektu;

{$IFDEF RAS}
   function ReadTopolRaster(RasterName: string): TRaster;
{$ENDIF}

implementation

uses
   WinProcs,
   Controls,
   Dialogs,
   Forms,
   SysUtils,
// KERNEL
   CtiRadek,
   M_Orbis,
   U_String,
   U_Props,
   U_File,
   Worlds,
// OIL
   Creacond,
   t_oper,
// TOPOL
   e_TopIS;




// APP
   //t_MainTl;




                        { TTopoLManipulator }



function  TTopoLManipulator.GetWCS: TWCS;
begin
  result:= nil;
   if not assigned(FWCS) then
   begin
     {!!!!!!!!!!!!!!!!!!! Chyba !!!!!!!!!!!!!!!!!!}
   end
   else
   begin
      result := FWCS;
   end;
end;

procedure TTopoLManipulator.SetWCS(aWCS: TWCS);
begin
   FWCS := aWCS;
end;


procedure TTopolManipulator.SetFiltrDruhu(aFiltr: TFiltrDruhuObjektu);
begin
  if FFiltrDruhu <> nil then
     FreeElement(FFiltrDruhu);
  FFiltrDruhu:= aFiltr;

  AddElement(FFiltrDruhu)
end;

procedure TTopolManipulator.SetRectLimits(aRect: TRectEntity);
begin
  if FRectLimits <> nil then
     FreeElement(FRectLimits);
  FRectLimits:= aRect;

  AddElement(FRectLimits)
end;



procedure   TTopolManipulator.SendProtocolMessage(aMessage: string);
begin
  World.MainTool.PostTextMsg(tm_AddToProtocol, aMessage, World.MainTool);
  Application.ProcessMessages
end;



{ TTopoLReader }




function TTopolReader.GetRegister: TTopolBlockRegister;
var
  TR: TRegister;
begin
  result:= FRegister;
  if result <> nil then exit;

  TR:= TRegister(World.ObjectModel.FindElementClass(TRegister));
  if TR = nil then
  begin
    TR:= TRegister.Create;
    World.ObjectModel.AddElement(TR);
  end;

  if TR = nil then exit;
  FRegister:= TTopolBlockRegister
              (TR.GetAndCreateBlockRegister(FBlockDirectory, 'TTopolBlockRegister'));
  result:= FRegister;
end;





procedure TTopolReader.SetBarva(aVal: smallInt);
begin
  FUseBarva:= true;
  FBarva:= aVal
end;


procedure TTopolReader.SetZnacka(aVal: smallInt);
begin
  FUseZnacka:= true;
  FZnacka:= aVal
end;


function  TTopolReader.OKDruh(Objekt: char; TopObjekt: TElement): boolean;
begin
  result:= true;
  if FFiltrDruhu <> nil then
  begin
    result:= FFiltrDruhu.OKDruh(Objekt, TopObjekt)
  end;
end;



function TTopolReader.ConditionIsTrue(TopObject: TElement): boolean;
var
  CC: TCondCreator;
  aCondition: TCondition;

begin
  result:= true;
  if Condition = '' then exit;
  if TopObject = nil then exit;

  try
    CC := TCondCreator.Create;
    CC.Command:=Condition;
    CC.DoIt;
    aCondition := TCondition(CC.Output);
    CC.Free;

    if aCondition = nil then
       exit;

    aCondition.ParamItem[0]:=TopObject;

    result:= aCondition.IsTrue;

    aCondition.Free;
  except
    ShowMessage('Condition processing Error' + #13+#10+ Condition)
  end
end;



function TTopolReader.CreateICSRect(Ymin, Xmin, Ymax, Xmax: double): TRectangle;
begin
  result:= TRectangle.Create;
  if result = nil then exit;

  result.MaxX:= Ymin;
  result.MaxY:= Xmin;
  result.MinX:= Ymax;
  result.MinY:= Xmax;

  FWCS.RecalculateToICS(result.Min);
  FWCS.RecalculateToICS(result.Max);
end;


function TTopolReader.OKRectLimits(Ymin, Xmin, Ymax, Xmax: double): boolean;
var
  Rect: TRectangle;
begin
  result:= true;
  if RectLimits <> nil then
  begin
    Rect:= CreateICSRect(Ymin, Xmin, Ymax, Xmax);
    result:= Rect.IsOverlap(RectLimits.Rect);
    Rect.Free
  end
end;


procedure  TTopolReader.SetProps(aProps:TPropertyList);
var
  I: longInt;
  PropName: string;
begin
  if aProps = nil then exit;

  for I:= 0 to aProps.Count-1 do
  begin
    PropName:= aProps.Names[I];
    if PropName[1] = '@' then
       PropName:= copy(PropName, 2, 255)
    else
      continue;

    SetPropStringByName(self, PropName, aProps.Strings[I]);
  end
end;



(*
function    TTopolReader.GetDBFEntity: TEntity;
var
  SearchRec: TSearchRec;
  Vysl: integer;
  DBResult: TEnvelopeEntity;

  procedure AddDBF(aName: string);
  var
    DBF: TTopolDBFTable;
  begin
    if DBResult = nil then
    begin
      DBResult:= TEnvelopeEntity.Create;
    end;

    DBF:= TTopolDBFTable.Create;
    DBF.TTopolDBFTable;
    DBResult;
  end;

begin
  DBResult:= nil;
{ hledn vech soubor DBF, zanajcch na typ objektu }
  Vysl:= findFirst(BlockDirectory + '\' + GetBlockType + '*.DBF', faAnyFile, SearchRec);

  while Vysl = 0 then
  begin
    AddDBF(SearchRec.Name);
    findNext(SearchRec)
  end;

  findClose(SearchRec)
end;

*)


procedure TTopolReader.StartGauge;
begin
   Screen.Cursor:= crHourGlass;
   StartProgress(Self.ClassName + ' (' + SSS +') ',0,GetSize);
   FGaugeModulo := GetSize div 40;
   if FGaugeModulo < 50 then FGaugeModulo := 50;
   Application.ProcessMessages;
   (*
   F_GaugeForm:= TF_GaugeForm.Create(Application);
   F_GaugeForm.Caption:= Self.ClassName + '(' + SSS +')';
   F_GaugeForm.MaxValue:= GetSize;
   F_GaugeForm.Show
   *)
end;




procedure TTopolReader.EndGauge;
begin
   Screen.Cursor:= crDefault;
   EndProgress;
   Application.ProcessMessages;
   (*
   if F_GaugeForm <> nil then
   begin
      F_GaugeForm.Free;
      F_GaugeForm:= nil
   end;
   *)
end;


procedure TTopolReader.OpenStream;
begin
  if not FileExists(SSS) then
  begin
    exit;
  end;

  if not useMemory then
  begin
     if FStream <> nil then exit; {!!!!!!!!!!!!!!!}
     FStream := TFileStream.Create(SSS, fmOpenRead{Write !!!!!!!} );
  end
  else
  begin
     try
        FStream := TMemoryStream.Create;
        TMemoryStream(FStream).LoadFromFile(SSS);
     except
        ShowMessage('Nedostatek pamti ! vypnte poloku Agresivn vyuvat pam v nastaven Mapperu');
     end;
  end;
end;


function    TTopoLReader.GetSize: longInt;
begin
   Result := 0;
   if (FStream <> nil) and (FRecordSize > 0) then
      Result := FStream.Size div FRecordSize;
end;



destructor  TTopoLReader.Destroy;
begin
   if FStream <> nil then FStream.Free;
   {
   if F_GaugeForm <> nil then
      F_GaugeForm.Free;

   }
   inherited Destroy;
end;

procedure   TTopoLReader.ReadIt(var Buf);
begin
   FStream.Read(Buf, FRecordSize);
   if {(F_GaugeForm <> nil) and}
      //((FStream.Position div FRecordSize) mod 50 = 0) then
      (FGaugeModulo > 0) and
      ((FStream.Position div FRecordSize) mod FGaugeModulo = 0) then
   begin
      //F_GaugeForm.Progress:= FStream.Position div FRecordSize;
      Progress:= FStream.Position div FRecordSize;
      Application.ProcessMessages
   end;
end;

procedure   TTopolReader.WriteIt(var Buf);
begin
   FStream.Write(Buf, FRecordSize);
   if {(F_GaugeForm <> nil) and}
      //((FStream.Position div FRecordSize) mod 50 = 0) then
      (FGaugeModulo > 0) and
      ((FStream.Position div FRecordSize) mod FGaugeModulo = 0) then
   begin
      //F_GaugeForm.Progress:= FStream.Position div FRecordSize;
      Progress:= FStream.Position div FRecordSize;
      Application.ProcessMessages
   end;
end;


procedure   TTopoLReader.SeekTo(aIndex: longInt);
begin
   if FStream <> nil then FStream.Seek(aIndex * FRecordSize, 0);
end;


function    TTopoLReader.GetRect(aObdelnik: TObdelnik): TRectangle;
begin
   result := TRectangle.Create;
   result.Min.x := aObdelnik.PH.Y;
   result.Min.y := aObdelnik.PH.x;
   result.Max.x := aObdelnik.LD.Y;
   result.Max.y := aObdelnik.LD.x;
   WCS.RecalculateToICS(result.Min);
   WCS.RecalculateToICS(result.Max);
   result.Sort;
end;



function  TTopolReader.GetObjectType: char;
begin
  result:= ' '
end;



procedure TTopolReader.GiveCoordFromSour(Sour: TSour; var X, Y: double);
var
  Xe, Ye, Ze: extended;
begin
  WCS.GiveICS(Sour.Y, Sour.X, 0, Xe, Ye, Ze);
  X:= Xe; Y:= Ye
end;




procedure TTopolReader.GiveSourFromCoord(X, Y: double; var Sour: TSour);
var
  Xe, Ye, Ze: extended;
begin
  WCS.GiveWCSFromICS(X, Y, 0, Xe, Ye, Ze);
  Sour.Y:= Xe;
  Sour.X:= Ye
end;




                           { TTopoLObjectReader }

constructor TTopoLObjectReader.CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS);
begin
   inherited Create;
   FWCS := aWCS;
   SetRecordSize;
   SSS := aBlockDirectory+'\'+ GetFileName;
   FBlockDirectory:= aBlockDirectory;
   UseMemory := false;//TOldMainTool(World.MainTool).OptionBooleanProp('FullUseMemory');
   try
      OpenStream;
   except
   end;
end;


procedure   TTopolObjectReader.NewObject(aObject: TTopoLElement);
begin
  if assigned(OnNewObject) then
     OnNewObject(TElement(aObject));
end;



{ TTopolCoordReader }

(*

procedure TTopolCoordReader.OpenStream;
begin
  FStream := TFileStream.Create(SSS, fmOpenRead{Write!!!!!!!} );
end;

*)

procedure   TTopolCoordReader.SetRecordSize;
begin
   FRecordSize := SizeOf(TSour);
end;


function    TTopolCoordReader.GetFileName: string;
begin
   Result := 'TN.CRD';
end;


function    TTopolCoordReader.ReadCoord: TCoordinate;
var
   Sour: TSour;
begin
   result := T2dCoordinate.Create;
   ReadIt(Sour);
   result.X := Sour.Y;
   result.Y := Sour.X;
   WCS.RecalculateToICS(result);
   result.CS := WCS.ID;
end;


{ TTopoLLinReader }

constructor TTopolLinReader.CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS);
begin
   inherited CreateBlockWCS(aBlockDirectory, aWCS);
   OpenCoords(aBlockDirectory, aWCS);
end;


procedure TTopolLinReader.OpenCoords(aBlockDirectory: string; aWCS: TWCS);
begin
  FCoordReader := TTopoLCoordReader.CreateBlockWCS(aBlockDirectory, aWCS);
end;



Destructor TTopolLinReader.Destroy;
begin
   if assigned(FCoordReader) then FCoordReader.Free;
   inherited Destroy;
end;

procedure   TTopolLinReader.SetRecordSize;
begin
   FRecordSize := SizeOf(TLin);
end;

function    TTopolLinReader.GetFileName: string;
begin
   Result := 'TN.LIN';
end;


function  TTopolLinReader.GetObjectType: char;
begin
  result:= 'L'
end;




function    TTopolLinReader.ReadTopolLin(Position: longInt): TLin;
begin
  SeekTo(Position);
  ReadIt(Result)
end;


function    TTopolLinReader.ReadLin: TTopoLLineElement;
var
   Lin: TLin;
   i: longInt;
   aX, aY: double;
   PLE: TPolyLineElement;
begin
   result := nil;
   ReadIt(Lin);
   if (ZrusenaL in Lin.Atributy) or (FStream.Position = FRecordSize) or
      not OKRectLimits(Lin.OpsanyObdelnik.PH.Y, Lin.OpsanyObdelnik.PH.X,
                       Lin.OpsanyObdelnik.LD.Y, Lin.OpsanyObdelnik.LD.X) then exit;

   if (lnKrivka in Lin.Atributy) or
      (lnKruznice in Lin.Atributy)  then
       exit;

  { testovn zda ji nen v registru }
   if Register <> nil then
   begin
     result:= TTopoLLineElement(Register.GetObject('L', Lin.Cislo));

     if result <> nil then
     { linie nalezena v registru }
     begin;
       if (OKDruh('L', result)  and ConditionIsTrue(result)) then
       begin
         if FUseBarva then
            result.SetPropertyLongIntByName('Barva', FBarva);

         if FUseZnacka then
            result.SetPropertyLongIntByName('Znacka', FZnacka);
         exit
       end
       else
       begin
       { avak nespluje podmnku }
         result:= nil;
         exit;
       end
     end
     { pokud nen nalezena, pokrauje se ve ten }
   end;

  { zjitn max rozmru }
   aX:= abs(Lin.OpsanyObdelnik.PH.Y-Lin.OpsanyObdelnik.LD.Y);
   aY:= abs(Lin.OpsanyObdelnik.PH.X-Lin.OpsanyObdelnik.LD.X);
   if aY > aX then aX:= aY;

   result := TTopoLLineElement.Create;
   PLE := TPolyLineElement.Create;
   result.Geometry := PLE;
   if (aX < MinSize) then
   begin
   { natu pouze prvn a posledn souadnici }
     FCoordReader.SeekTo(Lin.PrvniSour);
     PLE.AddAndUpdateRect(FCoordReader.ReadCoord);
     FCoordReader.SeekTo(Lin.PosledniSour);
     PLE.AddAndUpdateRect(FCoordReader.ReadCoord);
   end
   else
   begin
   { regulrn ten }
     i := Lin.PrvniSour;
 { TODO -oPPK -cfilosofovat : pomcka pi debiln uloenm souboru lini - chyba souadnic }
     if (i < 0) or (i > FCoordReader.Size) then  // blbost, linie se nenate
     begin
        World.MainTool.PostTextMsg(tm_AddToProtocol, ' Lin reader error CISLO: '+IntToStr(Lin.Cislo)+' invalid Coordinate', nil);
        result.Free;
        result := nil;
        exit;
     end;
     FCoordReader.SeekTo(i);
     while i <= Lin.PosledniSour do
     begin
        PLE.AddAndUpdateRect(FCoordReader.ReadCoord);
        inc(i);
     end
   end;

   if (PLE.Count < 2) then
   begin
      {!!!!!!!!!!!!!!!!
      Lin.Atributy := Lin.Atributy + [ZrusenaL];
      FStream.Seek(OldPos, 0);
      FStream.Write(Lin, FRecordSize);
      !!!!!!!!!!!!!!!!}
      result.Free;
      result := nil;
      exit;
   end;

   //LP:= TTopolLineProps.Create;
   //result.Properties:= LP;

   result.Cislo       := Lin.Cislo;
   result.Druh        := Lin.Druh;

   if FUseBarva then
      result.Barva:= FBarva
   else
     result.Barva       := Lin.Barva;

   if FUseZnacka then
      result.Znacka:= FZnacka
   else
      result.Znacka      := Lin.Znacka;

   result.Presnost    := Lin.Presnost;
   result.Symbol      := Lin.Symbol;
   result.LeftArea    := Lin.LevaPlocha;
   result.RightArea   := Lin.PravaPlocha;

   result.DrziSe      := Lin.DrziSe;

   GiveCoordFromSour(Lin.PolohaSymbolu.Sour, aX, aY);
   PLE.AbsRefX:= aX;
   PLE.AbsRefY:= aY;
   PLE.Angle:= Lin.PolohaSymbolu.UhelKolmice;

   //result.Update;

   Register.RegisterObject(result);

   if not (OKDruh('L', result)  and ConditionIsTrue(result)) then
   begin
     result.Free;
     result:= nil;
     exit
   end
   else
     NewObject(result)
end;





function  TTopolLinReader.ReadLineSymbol: TTopoLPointElement;
var
  Lin: TLin;
  PE: TPointElement;
begin
   result := nil;
   ReadIt(Lin);
   if (ZrusenaL in Lin.Atributy) or (FStream.Position = FRecordSize) or
      not OKRectLimits(Lin.OpsanyObdelnik.PH.Y, Lin.OpsanyObdelnik.PH.X,
                       Lin.OpsanyObdelnik.LD.Y, Lin.OpsanyObdelnik.LD.X) or
      (Lin.Symbol < 1000)  then exit;

  result := TTopoLPointElement.Create;
  PE := TpointElement.Create;
  result.Geometry := PE;
  {!!!!!!!!!!!!!!!}
  PE.x := -Lin.PolohaSymbolu.Sour.Y;
  PE.y := -Lin.PolohaSymbolu.Sour.X;
  {!!!!!!!!!!!!!!!}


  //PP:= TTopolPointProps.Create;
  //result.Properties:= PP;

  result.Cislo       := Lin.Cislo;
  result.Druh        := Lin.Druh;
  result.Barva       := Lin.Barva;
  result.Znacka      := Lin.Symbol;//Lin.Znacka;
  result.Presnost    := Lin.Presnost;

  PE.Angle     := Lin.PolohaSymbolu.UhelKolmice + Pi/2;

  if not OKDruh('L', result) then
  begin
    result.Free;
    result:= nil;
    exit
  end
  else
    NewObject(result);
end;





function TTopolLinReader.OKVratDalsiLiniiVpravo
              (const Linie    : TLin;
               LevaStrana     : boolean;
           var DalsiLinie     : TLin;
           var DalsiLevaStrana: boolean): boolean;
var
  CLinie: longInt;

begin
  OKVratDalsiLiniiVpravo:= true;

  if LevaStrana then
  begin
    CLinie         :=     Linie.DrziSe.Levou.Nohou.Koho;
    DalsiLevaStrana:=     Linie.DrziSe.Levou.Nohou.ZaRuku
  end
  else
  begin
    CLinie         :=     Linie.DrziSe.Pravou.Rukou.Koho;
    DalsiLevaStrana:=     Linie.DrziSe.Pravou.Rukou.ZaRuku
  end;

  if (CLinie > 0) and (CLinie < Size) then
     DalsiLinie:= ReadTopolLin(CLinie)
  else OKVratDalsiLiniiVpravo:= false;

  if ZrusenaL in DalsiLinie.Atributy then OKVratDalsiLiniiVpravo:= false
end;



function TTopolLinReader.OKVratDalsiLiniiVlevo
              (const Linie    : TLin;
               LevaStrana     : boolean;
           var DalsiLinie     : TLin;
           var DalsiLevaStrana: boolean): boolean;
var
  CLinie: longInt;

begin
  result:= true;

  if not LevaStrana then
  begin
    CLinie         :=     Linie.DrziSe.Levou.Nohou.Koho;
    DalsiLevaStrana:=     Linie.DrziSe.Levou.Nohou.ZaRuku
  end
  else
  begin
    CLinie         :=     Linie.DrziSe.Pravou.Rukou.Koho;
    DalsiLevaStrana:=     Linie.DrziSe.Pravou.Rukou.ZaRuku
  end;

  if (CLinie > 0) and (CLinie < Size) then
     DalsiLinie:= ReadTopolLin(CLinie)
  else
     result:= false;

  if ZrusenaL in DalsiLinie.Atributy then
     result:= false
end;




              {  TReadBlokLines }

constructor  TReadBlokLines.CreateBlock(aBlockDirectory: string);
var
  WCS: TWCS;

begin
  WCS:=  TWCSWorld(World).GetIDWCS(cs_JTSK);
  inherited CreateBlockWCS(aBlockDirectory, WCS);
end;


procedure TReadBlokLines.GiveRectangle(var X1, Y1, X2, Y2: double);
var
  Rect, MaxRect: TRectangle;
  Lin: TLin;
  I: longInt;
begin
  MaxRect:= TRectangle.Create;

  for I:= 1 to Size-1 do
  begin
    SeekTo(I);
    ReadIt(Lin);

    if not (ZrusenaL in Lin.Atributy) and not (lnKrivka in Lin.Atributy) then
    begin
      Rect:= GetRect(Lin.OpsanyObdelnik);
      MaxRect.UpdateByRectangle(Rect);
      Rect.Free;
    end
  end;
  X1:= MaxRect.MinX;
  Y1:= MaxRect.MinY;
  X2:= MaxRect.MaxX;
  Y2:= MaxRect.MaxY;
  MaxRect.Free;
end;


function TReadBlokLines.GetLine(Position: longInt): TTopoLLineElement;
begin
  SeekTo(Position);
  result:= readLin
end;



constructor  TTopolAreaInfoReader.CreateBlock(aBlockDirectory: string);
var
  WCS: TWCS;

begin
  WCS:=  TWCSWorld(World).GetIDWCS(cs_JTSK);
  inherited CreateBlockWCS(aBlockDirectory, WCS);
end;




procedure TTopolAreaInfoReader.ReadTPlocha(Position: longInt; var Plocha: TPlocha);
begin
  SeekTo(Position);
  ReadIt(Plocha);
end;




{ TTopolAreaBoundaryReader }

constructor TTopolAreaBoundaryReader.CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS);
begin
   inherited CreateBlockWCS(aBlockDirectory, aWCS);
{   FCoordReader := TTopoLCoordReader.CreateBlockWCS(aBlockDirectory, aWCS); }
   FLinReader   := TTopoLLinReader.  CreateBlockWCS(aBlockDirectory, aWCS);
end;

Destructor TTopolAreaBoundaryReader.Destroy;
begin
   if assigned(FLinReader)   then FLinReader.Free;
{   if assigned(FCoordReader) then FCoordReader.Free; }
   inherited Destroy;
end;


function  TTopolAreaBoundaryReader.GetObjectType: char;
begin
  result:= 'P'
end;






procedure   TTopolAreaBoundaryReader.SetRecordSize;
begin
   FRecordSize := SizeOf(TPlocha);
end;

function    TTopolAreaBoundaryReader.GetFileName: string;
begin
   Result := 'TN.ARE';
end;







procedure TTopolAreaBoundaryReader.VratLiniiPlochy
          (Plocha: TPlocha; var Linie: TLin;
           var LevaStrana: boolean; var Nalezl: boolean);
var
  I: longInt;
begin
  I:= 1;
  Nalezl:= false;
  LevaStrana:= true;

  if (Plocha.PrvniLinie > 0) and
     (Plocha.PrvniLinie < FLinReader.Size) then
  begin
    Linie:= FLinReader.ReadTopolLin(Plocha.PrvniLinie);

    if not (ZrusenaL in Linie.Atributy) then
    begin
      Nalezl:= (Linie.PravaPlocha = Plocha.Cislo) or
               (Linie.LevaPlocha = Plocha.Cislo);
      if Nalezl then
         LevaStrana:= Linie.LevaPlocha = Plocha.Cislo
    end
  end;
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! }
  if Nalezl then exit;
  MessageBeep(0);

  while (I < FLinReader.Size) and not Nalezl do
  begin
    Linie:= FLinReader.ReadTopolLin(I);
    if not (ZrusenaL in Linie.Atributy) then
    begin
      Nalezl:= (Linie.PravaPlocha = Plocha.Cislo) or
               (Linie.LevaPlocha = Plocha.Cislo);
      if Nalezl then
      begin
        LevaStrana:= Linie.LevaPlocha = Plocha.Cislo;
{
        Plocha.PrvniLinie:= I;
        PisPlochu(Plocha.Cislo, Plocha)
}
      end
    end;

    inc(I)
  end

end;





function    TTopolAreaBoundaryReader.ReadBoundary(Plo: TPlocha): TTopoLAreaElement;
var
   CPrvniLin, CDalsiLin: longInt;
   Lin, DalsiLin: TLin;
   i, PocetCyklu: longInt;
   LevaStrana, OKej: boolean;
   AP: TAreaElement;

begin
   result := nil;
   {Zjisteni prvni linie}
   VratLiniiPlochy(Plo, Lin, LevaStrana, OKej);
   if not OKej then exit;

   CPrvniLin:= Lin.Cislo;
   CDalsiLin:= CPrvniLin;
   DalsiLin:= Lin;

   AP := TAreaElement.Create;

   {cyklus nacitani linii dokud se nenajde ta prvni}
   OKej:= true;
   PocetCyklu:= 0;

   repeat
     inc(PocetCyklu);

   {nacteni souradnic linie, krome prvniho bodu}
     if LevaStrana then
     begin
       i := DalsiLin.PrvniSour+1;
       {!}FLinReader.FCoordReader.SeekTo(i);
       while i <= DalsiLin.PosledniSour do
       begin
          AP.AddElement({!}FLinReader.FCoordReader.ReadCoord);
          inc(i);
       end
     end
     else
     begin
       i := DalsiLin.PosledniSour-1;
       while i >= DalsiLin.PrvniSour do
       begin
          {!}FLinReader.FCoordReader.SeekTo(i);
          AP.AddElement({!}FLinReader.FCoordReader.ReadCoord);
          dec(i);
       end
     end;

   {zjisteni dalsi linie}
     OKej:= FLinReader.OKVratDalsiLiniiVpravo
            (DalsiLin, LevaStrana,
             DalsiLin, LevaStrana) and (PocetCyklu < 10000);
     if OKej then CDalsiLin:= DalsiLin.Cislo;
   until (CDalsiLin = CPrvniLin) or not OKej;

   if (AP.Count < 2) or not OKej then
   begin
      {!!!!!!!!!!!!!!!!
      Plo.Atributy := Plo.Atributy + [ZrusenaP];
      FStream.Seek(OldPos, 0);
      FStream.Write(Plo, FRecordSize);
      !!!!!!!!!!!!!!!!}
      AP.Free;
      //AP := nil;
      exit;
   end;

   result:= TTopolAreaElement.Create;
   result.Geometry:= AP;

   result.Cislo := Plo.Cislo;
   result.Druh  := Plo.Druh;

   if FUseBarva then
      result.Barva:= FBarva
   else
     result.Barva       := Plo.Barva;

   if FUseZnacka then
      result.Znacka:= FZnacka
   else
      result.Znacka      := Plo.Znacka;

   result.LineNo         := Plo.PrvniLinie;
   result.PaterNo        := Plo.CisloOtce;
   result.HasChildren    := Plo.MaEnklavu;

   if not OKDruh('P', result) then
   begin
     result.Free;
     result:= nil;
     exit
   end
   else
     NewObject(result);
end;






function    TTopolAreaBoundaryReader.ReadArea: TTopoLAreaElement;
var
  Plo: TPlocha;

begin
   result := nil;
   ReadIt(Plo);
   if not RegulerniPlocha(Plo) or (FStream.Position = FRecordSize) or
      not OKRectLimits(Plo.OpsanyObdelnik.PH.Y, Plo.OpsanyObdelnik.PH.X,
                       Plo.OpsanyObdelnik.LD.Y, Plo.OpsanyObdelnik.LD.X) then exit;

   result:= ReadBoundary(Plo);
end;



{
function TTopolAreaReader.LineFromRegister(aCislo: longInt): TPolyLineElement;
begin
  Result:= nil;
  if Register=nil then exit;
  result:= TPolyLineElement(Register.GetObject('L', aCislo));
  if result is TPolyLineElement then exit;
  result:= nil
end;
}


function TTopolAreaReader.ReadAreaBoundary: TTopoLAreaElement;
begin
  result:= inherited ReadArea;
end;




function TTopolAreaReader.ReadAreaWithLines(Plo: TPlocha): TTopoLAreaElement;
var
   CPrvniLin, CDalsiLin: longInt;
   Lin, DalsiLin: TLin;
   Linie: TTopoLLineElement;
   PocetCyklu: longInt;
   PrvniLevaStrana, LevaStrana, OKej: boolean;
   X, Y, Z: extended;
   AP: TPolyLineAreaElement;
begin
   result:= nil;
   VratLiniiPlochy(Plo, Lin, PrvniLevaStrana, OKej);
   if not OKej then
   begin
     Protocol:= BlockName +': Nelze nast pro plochu .' + IntToStr(Plo.Cislo) +
                ' linii .' + IntToStr(Plo.PrvniLinie);
     exit;
   end;

   AP := TPolyLineAreaElement.Create;

   CPrvniLin:= Lin.Cislo;
   CDalsiLin:= CPrvniLin;
   DalsiLin:= Lin;
   LevaStrana:= PrvniLevaStrana;
   OKej:= true;
   PocetCyklu:= 0;

   repeat
     AP.LinesOrigines[PocetCyklu]:= LevaStrana;
   { zkusm nast linii ze souboru ci registru }
     FLinReader.SeekTo(CDalsiLin);
     Linie:= FLinReader.ReadLin;
     // Tady se pedpokld, e linie se najde v registru, nebo nate a ulo do registru
     // prost e nevis ve vzduchu ... proto se nekontroluje a ppadn neru
     if Linie <> nil then
     begin
        AP.AddAndUpdateRect(Linie.Geometry);
     end
     else
     begin
       Protocol:= 'Pro plochu .' + IntToStr(Plo.Cislo) +
                  ' se nepodailo nalzt linii .' + IntToStr(CDalsiLin);
       OKej:= false
     end;

   {zjisteni dalsi linie}
     if OKej then
        OKej:= FLinReader.OKVratDalsiLiniiVpravo
               (DalsiLin, LevaStrana,
                DalsiLin, LevaStrana) and (PocetCyklu < 10000);

     if OKej then CDalsiLin:= DalsiLin.Cislo
     else
       Protocol:= BlockName +':Pro plochu .' + IntToStr(Plo.Cislo) + ' a linii .' +
                  IntToStr(DalsiLin.Cislo) + ' nelze nast dal linii vlevo';

     inc(PocetCyklu);
   until ((CDalsiLin = CPrvniLin) and (LevaStrana = PrvniLevaStrana)) or not OKej;

   if (AP.Count < 1) or not OKej then
   begin
      {!!!!!!!!!!!!!!!!
      Plo.Atributy := Plo.Atributy + [ZrusenaP];
      FStream.Seek(OldPos, 0);
      FStream.Write(Plo, FRecordSize);
      !!!!!!!!!!!!!!!!}
      AP.Free;
      //AP := nil;
      Protocol:= BlockName +':Nelze nast linie pro plochu .' + IntToStr(Plo.Cislo) + ' linii';
      exit;
   end;
   if AP <> nil then
   begin
     result:= TTopolAreaElement.Create;
     result.Geometry:= AP;


     result.Cislo       := Plo.Cislo;
{     result.Rect        := GetRect(Plo.OpsanyObdelnik); }
     result.Druh        := Plo.Druh;
     if FUseBarva then
        result.Barva:= FBarva
     else
       result.Barva       := Plo.Barva;

     if FUseZnacka then
        result.Znacka:= FZnacka
     else
        result.Znacka      := Plo.Znacka;

     result.PaterNo        := Plo.CisloOtce;
     WCS.GiveICS(Plo.Sour.Y, Plo.Sour.X, 0, X, Y, Z);
     AP.AbsRefX:= X;
     AP.AbsRefY:= Y;
     //result.Update;
   end
end;



function TTopolAreaReader.OuterArea(aCislo: longInt): boolean;
var
  aPlocha: TPlocha;
begin
  result:= true;
  if aCislo < 1 then exit;
  SeekTo(aCislo);
  ReadIt(aPlocha);
  result:= not RegulerniPlocha(aPlocha)
end;



function TTopolAreaReader.ReadAreaAsHole(Plo: TPlocha): TPolyLineAreaElement;
var
   CPrvniLin, CDalsiLin, CFirstLin: longInt;
   Lin, DalsiLin: TLin;
   Linie: TTopoLLineElement;
   PocetCyklu: longInt;
   PrvniLevaStrana, LevaStrana, OKej: boolean;
   X, Y, Z: extended;
   FirstX, FirstY, NextX, NextY: double;
   //AP: TTopolAreaProps;
   G: TPolyLineElement;
begin
   result:= nil;
   G := nil;
   PocetCyklu:= 0;
   VratLiniiPlochy(Plo, Lin, PrvniLevaStrana, OKej);
   // PK  1.10.2002
   CFirstLin := Lin.Cislo; // poznamenm si cislo prvn linie
   { hledm linii, kter soused s nadplochou }
   while OKej and
         not
    (
     (Lin.LevaPlocha = Plo.CisloOtce) or OuterArea(Lin.LevaPlocha) or
     (Lin.PravaPlocha = Plo.CisloOtce) or OuterArea(Lin.PravaPlocha)
    ) do
   begin
     OKej:= FLinReader.OKVratDalsiLiniiVPravo
            (Lin, PrvniLevaStrana,
             DalsiLin, LevaStrana) and (PocetCyklu < 10000);
     inc(PocetCyklu);
     Lin:= DalsiLin;
     PrvniLevaStrana:= LevaStrana;
     // PK  1.10.2002
     // V pripade, ze jsem dosel k stejne linii - enklava nejspis primo nesousedi s otcem
     if Lin.Cislo = CFirstLin then
     begin
         exit;
     end;
     //END PK  1.10.2002
   end;

   if not OKej then
   begin
     Protocol:= BlockName +':Nelze nast pro plochu .' + IntToStr(Plo.Cislo) +
                ' linii .' + IntToStr(Plo.PrvniLinie)+' -Hole error nebo co';
     exit;
   end;

   result := TPolyLineAreaElement.Create;

   CPrvniLin:= Lin.Cislo;
   CDalsiLin:= CPrvniLin;
   DalsiLin:= Lin;
   LevaStrana:= not PrvniLevaStrana;
   PrvniLevaStrana:= not PrvniLevaStrana; { jdeme v opanm smru }
   OKej:= true;
   PocetCyklu:= 0;

   {cyklus nacitani linii dokud se nenajde ta prvni dle totoznych souradnic }
   repeat
     result.LinesOrigines[PocetCyklu]:= LevaStrana;

   { zkusm nast linii ze souboru }
     FLinReader.SeekTo(CDalsiLin);
     Linie:= FLinReader.ReadLin;
     if Linie <> nil then
     begin
        G := TPolyLineElement(Linie.Geometry);
        result.AddAndUpdateRect(G);
     end
     else
     begin
       Protocol:= 'Pro plochu .' + IntToStr(Plo.Cislo) +
                  ' se nepodailo nalzt linii .' + IntToStr(CDalsiLin)+' -Hole error';
       OKej:= false
     end;

     if OKej and (PocetCyklu = 0) then
        G.GetOrientedCoord(0, LevaStrana, FirstX, FirstY);

     G.GetOrientedCoord(0, not LevaStrana, NextX, NextY);

   {zjisteni dalsi linie}
     if OKej then
        OKej:= FLinReader.OKVratDalsiLiniiVpravo
               (DalsiLin, LevaStrana,
                DalsiLin, LevaStrana) and (PocetCyklu < 10000);

     if OKej then CDalsiLin:= DalsiLin.Cislo
     else
       Protocol:= BlockName +':Pro plochu .' + IntToStr(Plo.Cislo) + ' a linii .' +
                  IntToStr(DalsiLin.Cislo) + ' nelze nast dal linii vlevo';

     inc(PocetCyklu);
   until ((FirstX = NextX) and (FirstY = NextY) and (CDalsiLin = CPrvniLin))
          or not OKej;
{#OSzmena 19990415   until ((FirstX = NextX) and (FirstY = NextY)) or not OKej;  }
{   until ((CDalsiLin = CPrvniLin) and (LevaStrana = PrvniLevaStrana)) or not OKej; }

   if (result.Count < 1) or not OKej then
   begin
      {!!!!!!!!!!!!!!!!
      Plo.Atributy := Plo.Atributy + [ZrusenaP];
      FStream.Seek(OldPos, 0);
      FStream.Write(Plo, FRecordSize);
      !!!!!!!!!!!!!!!!}
      result.Free;
      result := nil;
      Protocol:= BlockName +':Nelze nast linie pro plochu .' + IntToStr(Plo.Cislo) + ' -Hole Error ';
      exit;
   end;
   if result <> nil then
   begin
     (*
     AP:= TTopolAreaProps.Create;
     result.Properties:= AP;
     AP.Cislo       := Plo.Cislo;
{     result.Rect        := GetRect(Plo.OpsanyObdelnik); }
     AP.Druh        := Plo.Druh;

     if FUseBarva then
        AP.Barva:= FBarva
     else
       AP.Barva       := Plo.Barva;

     if FUseZnacka then
        AP.Znacka:= FZnacka
     else
        AP.Znacka      := Plo.Znacka;
     *)
     WCS.GiveICS(Plo.Sour.Y, Plo.Sour.X, 0, X, Y, Z);
     result.AbsRefX:= X;
     result.AbsRefY:= Y
   end
end;




function    TTopolAreaReader.ReadArea: TTopoLAreaElement;
var
   Plo: TPlocha;
begin
   result := nil;
try
   ReadIt(Plo);

   if not RegulerniPlocha(Plo) or (FStream.Position = FRecordSize) or
      not OKRectLimits(Plo.OpsanyObdelnik.PH.Y, Plo.OpsanyObdelnik.PH.X,
                       Plo.OpsanyObdelnik.LD.Y, Plo.OpsanyObdelnik.LD.X) then exit;

   result:= TTopoLAreaElement(ReadAreaWithLines(Plo));
   if not OKDruh('P', result) then
   begin
     result.Free;
     result:= nil;
     exit
   end
   else
     NewObject(result);
except
   PostTextMsg(tm_AddToProtocol,'Chyba ten plochy',nil);
end;
end;


{ TTopolPointReader }



procedure   TTopolPointReader.SetRecordSize;
begin
   FRecordSize := SizeOf(TBod);
end;

function    TTopolPointReader.GetFileName: string;
begin
   Result := 'TN.PNT';
end;


function  TTopolPointReader.GetObjectType: char;
begin
  result:= 'B'
end;




function    TTopolPointReader.ReadPoint: TTopoLPointElement;
var
   Bod: TBod;
   PP: TPointElement;
begin
   result := nil;
   ReadIt(Bod);

   if (ZrusenB in Bod.Atributy) or (FStream.Position = FRecordSize) then
       exit;

   if (Bod.Sour.X < 0) or (Bod.Sour.X > 2000000) or
      (Bod.Sour.Y < 0) or (Bod.Sour.Y > 2000000) then
   begin
     SendProtocolMessage('Bod.c.' + IntToStr(Bod.Cislo) + ' je mimo rozsah');
     exit;
   end;

   if Register <> nil then
   begin
     result:= TTopoLPointElement(Register.GetObject('B', Bod.Cislo));

     if result <> nil then
     { bod nalezen v registru }
     begin;
       if (OKDruh('B', result)  and ConditionIsTrue(result)) then
          exit
       else
       begin
       { avak nespluje podmnku }
         result:= nil;
         exit;
       end
     end
     { pokud nen bod nalezen, pokrauje se ve ten }
   end;
  {!!!!!!!!!!!!!!!}
   PP := TPointElement.Create;
   PP.x := -Bod.Sour.Y;
   PP.y := -Bod.Sour.X;
  {!!!!!!!!!!!!!!!}


   result:= TTopolPointElement.Create;
   result.Geometry := PP;
   //result.Properties:= PP;

   result.Cislo       := Bod.Cislo;
   result.Druh        := Bod.Druh;

   if FUseBarva then
      result.Barva:= FBarva
   else
     result.Barva       := Bod.Barva;

   if FUseZnacka then
      result.Znacka:= FZnacka
   else
      result.Znacka      := Bod.Znacka;

   result.Presnost    := Bod.Presnost;

   PP.Angle:= Bod.Uhel;

   //result.Update;

   Register.RegisterObject(result);

   if (OKDruh('B', result)  and ConditionIsTrue(result)) then
     NewObject(result)
   else
   begin
     result.Free;
     result:= nil;
     exit
   end

end;



{ TTopoLTextReader }


constructor TTopolTextReader.CreateBlockWCS(aBlockDirectory: string; aWCS: TWCS);
begin
   inherited CreateBlockWCS(aBlockDirectory, aWCS);
   if FStream = nil then exit;
   OpenTTX(aBlockDirectory);
   { Bez Kontroly }
end;

Destructor TTopolTextReader.Destroy;
begin
{$I-}
   System.Close(FText);
{$I+}
   if ioResult <> 0 then
   begin
   end;

   inherited Destroy;
end;





procedure   TTopolTextReader.SetRecordSize;
begin
   FRecordSize := SizeOf(TTopText);
end;

function    TTopolTextReader.GetFileName: string;
begin
   Result := 'TN.TBX';
end;


function  TTopolTextReader.GetObjectType: char;
begin
  result:= 'T'
end;




function    TTopolTextReader.ReadText(var aIndex: integer): TTopoLTextElement;
var
   Tx: U_TopoLT.TTopText;
   Veta: string;
   Coord: TCoordinate;
   TP: TTextElement;
begin
   result := nil;
   ReadIt(Tx);
   System.ReadLn(FText, Veta);
   if (ZrusenT in Tx.Atributy) or (FStream.Position = 0{FRecordSize}) then
      exit;

   if Tx.Cislo <> aIndex then
   begin
      Tx.Cislo := aIndex;
      aIndex := -1;
   end;

   if Register <> nil then
   begin
     result:= TTopoLTextElement(Register.GetObject('T', Tx.Cislo));

     if result <> nil then
     { text nalezen v registru }
     begin;
       if (OKDruh('T', result)  and ConditionIsTrue(result)) then
          exit
       else
       begin
       { avak nespluje podmnku }
         result:= nil;
         exit;
       end
     end
     { pokud nen text nalezen, pokrauje se ve ten }
   end;
  {!!!!!!!!!!!!!!!}
   result := TTopoLTextElement.Create;
  {!!!!!!!!!!!!!!!}

   TP:= TTextElement.Create;
   result.Geometry := TP;
   //result.Properties:= TP;

   result.Cislo       := TX.Cislo;
   result.Druh        := TX.Druh;
   result.TextAtrib   := TX.Atributy;

   if FUseBarva then
      result.Barva:= FBarva
   else
     result.Barva       := TX.Barva;

   if FUseZnacka then
      result.Znacka:= FZnacka
   else
      result.Znacka      := TX.DruhCary;


   result.TextMode := Tx.RezimTextu;
   result.Druh       := Tx.Druh;
   result.Direction  := Tx.Smer;
   result.TopolFont  := Tx.Font;

   Coord := T2DCoordinate.Create;
   Coord.x := Tx.VychoziBod.Y;
   Coord.y := Tx.VychoziBod.X;
   WCS.RecalculateToICS(Coord);
   result.StartPoint := Coord;
   TP.x          := Coord.x;
   TP.y          := Coord.y;

   result.Height     := Tx.KoefVysky;
   result.WidthCoef  := Tx.KoefSirky;

   { oprava chyby data - Sklon ve stupnich }
   if abs(Tx.Sklon) > 1 then
      result.Slope:= Pi*Tx.Sklon/180;

   result.Distance  := Tx.Rozestupy;
   TP.Text := Veta;

   //result.Update;

   Register.RegisterObject(result);

   if not OKDruh('T', result) then
   begin
     result.Free;
     result:= nil;
     exit
   end
//   else
//      NewObject(result);
end;





{ TTopoLBlockInfoReader }

constructor TTopoLBlokInfoReader.CreateBlock(aBlockDirectory: string);
begin
   inherited Create;
   FBlockDirectory:= aBlockDirectory
end;


function  TTopoLBlokInfoReader.GetWCS: TWCS;
var
  FN: string;
  List: TStringList;
  CPStr: string;
  CP: longInt;
begin
   result :=  TWCSWorld(World).GetIDWCS(cs_JTSK);
   try
    FN:= AddBackSlash(FBlockDirectory) + 'INFO.TXT';
    if not fileExists(FN) then exit;

    List:= TStringList.Create;

    try
      List.LoadFromFile(FN);
      CPStr:= List.Values['SOURADNYSYSTEM'];
      CPStr:= BezVnejsichMezer(CPStr);
      if UpperCase(CPStr) = 'GAUSS-KRUGER' then
         result :=  TWCSWorld(World).GetIDWCS(cs_Gauss);
    finally
      List.Free
    end

    except
    end
end;


procedure TTopolBlokInfoReader.ReadRectangle(var Xmin, Ymin, Xmax, Ymax: double);
var
  CR: TCtiRadekClass;
  List: TStringList;
  FN, Souradnice: string;
begin
  Xmin:= 0;
  Ymin:= 0;
  Xmax:= 0;
  Ymax:= 0;
  try
  FN:= AddBackSlash(FBlockDirectory) + 'INFO.TXT';
  if not fileExists(FN) then exit;

  List:= TStringList.Create;

  try
    List.LoadFromFile(FN);
    Souradnice:= List.Values['OPSANYOBDELNIKBLOKU'];
    if Souradnice <> '' then
    begin
      CR:= TCtiRadekClass.Create(Souradnice);
      Xmax:= -CR.DejExtended;

      if not CR.DosloKChybe then
      begin
         Ymax:= -CR.DejExtended;
         if not CR.DosloKChybe then
         begin
            Xmin:= -CR.DejExtended;
            if not CR.DosloKChybe then
               Ymin:= -CR.DejExtended
            else
             Xmin:= 0
         end
         else
          Ymax:= 0
      end
      else
        Xmin:= 0;

      CR.Free;
    end;
  finally
    List.Free
  end

  except
  end
end;


function   TTopolBlokInfoReader.GetCodePage: TCodePage;
var
  FN: string;
  List: TStringList;
  CPStr: string;
  CP: longInt;
begin
  result:= cpIBM;
  try
  FN:= AddBackSlash(FBlockDirectory) + 'INFO.TXT';
  if not fileExists(FN) then exit;

  List:= TStringList.Create;

  try
    List.LoadFromFile(FN);
    CPStr:= List.Values['CODEPAGE'];
    CPStr:= BezVnejsichMezer(CPStr);
    if CPStr <> '' then
    begin
      CP:= StrToIntDef(CPStr, 0);
      case CP of
      0: result:= cpIBM;
      1: result:= cpKamenickych;
      2: result:= cpLatin2;
      867: result:= cpKamenickych;
      852: result:= cpLatin2;
      1250: result := cpWindows;
      else
         result:= cpIBM
      end;
    end;
  finally
    List.Free
  end

  except
  end
end;


procedure GetBlokRect(aPath: string; var Xmin,Ymin,Xmax,Ymax: double);
var
  BI: TTopolBlokInfoReader;
begin
  BI:= TTopolBlokInfoReader.CreateBlock(aPath);
  BI.ReadRectangle(Xmin,Ymin,Xmax,Ymax);
  BI.Free;
end;



function BlokInRect(aPath: string; Rect: TRectEntity): boolean;
var
  Xmin,Ymin,Xmax,Ymax: double;
begin
  result:= true;
  GetBlokRect(aPath, Xmin,Ymin,Xmax,Ymax);

  if (Xmin = 0) and (Xmax=0) then exit;
  result:= Rect.IsOverRegion(Xmin,Ymin,Xmax,Ymax);
end;


procedure TTopolTextReader.OpenTTX(aBlockDirectory: string);
begin
   System.Assign(FText, aBlockDirectory+'\TN.TTX');
   System.Reset(FText);
end;

{ TTopoLBlokReader }


constructor TTopoLBlokReader.CreateBlock(aBlockDirectory: string);
begin
   QReadAreas :=  true;
   inherited Create;
   FInfoReader := TTopoLBlokInfoReader.CreateBlock(aBlockDirectory);
   FBlockDirectory:= aBlockDirectory;
   WCS := FInfoReader.WCS;
   FCodePage:= FInfoReader.GetCodePage;
end;


Destructor  TTopoLBlokReader.Destroy;
begin
{   if FObjektList <> nil then FObjektList.Free; }
   if assigned(FInfoReader)   then FInfoReader.Free;
   if assigned(FLinReader)   then FLinReader.Free;
   if assigned(FAreaReader)  then FAreaReader.Free;
   if assigned(FPointReader) then FPointReader.Free;
   if assigned(FTextReader)  then FTextReader.Free;
   inherited Destroy;
end;



function TTopolBlokReader.OKRectLimits(TopolObject: TElement): boolean;
var
   G: TGeometry;
begin
  result:= true;
  G := nil;
  if RectLimits = nil then exit;
  if (TopoLObject is TGeometryElement) then
     G := TGeometryElement(TopoLObject).Geometry;
  if G = nil then exit;
  with RectLimits do
  begin
    if G is TPolyElement then { linie, plocha }
       result:= TPolyElement(G).IsOverRegion(MinX, MinY, MaxX, MaxY)
    else
    if G is  TPointElement then
       result:= TPointElement(G).IsInsideRegion(MinX, MinY, MaxX, MaxY)
    else
    if TopolObject is TTextElement then
       result:= TTextElement(G).IsOverRegion(MinX, MinY, MaxX, MaxY)
  end
end;



procedure TTopoLBlokReader.SetReader(ObjectReader: TTopolReader);
begin
  ObjectReader.FiltrDruhu:= FiltrDruhu;
  ObjectReader.MinSize:= MinSize;
  ObjectReader.RectLimits:= RectLimits;
  ObjectReader.Condition:= Condition;
  ObjectReader.OnNewObject:= OnNewObject;

  if FUseBarva then
     ObjectReader.Barva:= Barva;
  if FUseZnacka then
     ObjectReader.Znacka:= Znacka;
end;


procedure TTopolBlokReader.SetObjectString(aObjString: TGeometryElementCollection; aType: string);
begin
  aObjString.Name:= BlockName + ' ' + aType;
  // nsledujc vlastnosti mi k nepasujou ... kalu na n
  aObjString.SetPropertyStringByName('BlockName', BlockName);
  aObjString.SetPropertyStringByName('TYPE', aType);
end;



function    TTopoLBlokReader.ReadPoints: TPointCollection;
var
   i: longInt;
   Point: TTopoLPointElement;
begin
  result:= nil;
  try
  try
    try
       FPointReader:= TTopoLPointReader.CreateBlockWCS(FBlockDirectory, WCS);

    except
      Protocol:= 'Chybn nebo neexistujc soubor Bod -' + FBlockDirectory;
      if FPointReader <> nil then FPointReader.Free;
      FPointReader:= nil;
      exit;
    end;
    if FPointReader = nil then exit;

    result := TPointCollection.Create;
    SetReader(FPointReader);
    SetObjectString(result, 'PNT');

    FPointReader.StartGauge;
    FPointReader.FStream.Seek(0, 0);
    for i := 1 to FPointReader.Size do
    begin
       {
       if FPointReader.F_gaugeForm.DoCloseQuery and
          FPointReader.F_gaugeForm.RealyClose('Peruit natn bod ?') then
          break;
       }
       Point:= FPointReader.ReadPoint;
       if (Point <> nil)
           and
          (OKRectLimits(Point)) then
       begin
         result.AddAndUpdateRect(Point);
         if not ConditionIsTrue(Point) then
           result.FreeElement(Point)
       end
       else
          if Point <> nil then
          if Point.OwnersCount < 2 then Point.Free;
    end;
  finally
    FPointReader.EndGauge;
    FPointReader.Free;
    FPointReader:= nil;
  end;
  except
     World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chyba ten Bod -' + FBlockDirectory, World.MainTool);
{      MessageDlg('Chyba ten Bod', mtInformation, [mbOK], 0); }
  end;
end;



function    TTopoLBlokReader.ReadLines:  TPolyLineCollection;
var
   i: longInt;
   Lin: TTopoLLineElement;
begin
  result:= nil;
  try
  try
    try
       FLinReader  := TTopoLLinReader.CreateBlockWCS(FBlockDirectory, WCS);
    except
      begin
        Protocol:= 'Chybn nebo neexistujc soubor Lini -' + FBlockDirectory;
        if FLinReader <> nil then FLinReader.Free;
        exit;
      end;
    end;

    if FLinReader = nil then exit;

    result := TPolyLineCollection.Create;


    SetReader(FLinReader);
    SetObjectString(result, 'LIN');

    FLinReader.StartGauge;
    FLinReader.FStream.Seek(0, 0);

    for i := 1 to FLinReader.Size do
    begin
       {
       if FLinReader.F_gaugeForm.DoCloseQuery and
          FLinReader.F_gaugeForm.RealyClose('Peruit natn lini ?') then
          break;
        }
       Lin:= FLinReader.ReadLin;
       if (Lin <> nil) then
       begin
          result.AddAndUpdateRect(Lin);
       end;
    end;
  finally
    FLinReader.EndGauge;
    FLinReader.Free;
    FLinReader:= nil;
  end;
  except
     World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chyba ten Lini -' + FBlockDirectory, World.MainTool);
{      MessageDlg('Chyba ten Lini', mtInformation, [mbOK], 0); }
  end;
end;




function    TTopoLBlokReader.ReadLineSymbols:  TPointCollection;
{ natn symbol na linich do bodovch objekt }
var
   i: longInt;
   Point: TTopoLPointElement;
begin
  result:= nil;
  try
  try
    try
       FLinReader  := TTopoLLinReader.CreateBlockWCS(FBlockDirectory, WCS);
    except
      begin
        Protocol:= 'Chybn soubor Lini -' + FBlockDirectory;
        if FLinReader <> nil then FLinReader.Free;
        exit;
      end;
    end;

    if FLinReader = nil then exit;

    result := TPointCollection.Create;
    SetObjectString(result, 'LINSYM');

    FLinReader.FiltrDruhu:= FiltrDruhu;
    FLinReader.RectLimits:= RectLimits;
    FLinReader.StartGauge;
    FLinReader.FStream.Seek(0, 0);
    for i := 1 to FLinReader.Size do
    begin
       {
       if FLinReader.F_gaugeForm.DoCloseQuery and
          FLinReader.F_gaugeForm.RealyClose('Peruit natn liniovch symbol ?') then
          break;
        }
       Point:= FLinReader.ReadLineSymbol;
       if (Point <> nil)
           and
          (OKRectLimits(Point)) then
          begin
             result.AddAndUpdateRect(Point);
             if not ConditionIsTrue(Point) then
                result.freeElement(Point)
          end
       else
          if Point <> nil then Point.Free;
    end;
  finally
    FLinReader.EndGauge;
    FLinReader.Free;
    FLinReader:= nil;
  end;
  except
     World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chyba ten liniovch symbol -' + FBlockDirectory, World.MainTool);
  end;
end;





function TTopolBlokReader.DejPlochuSPodPlochou
         (SeznamPloch: TAreaCollection; Cislo: longInt): TTopoLAreaElement;
{ Pokud plocha vlastn podplochy, je poteba je nast jako dry.
  Jeliko nadplocha nem potebn informace, je poteba aby podplochy zjiovaly
  i kdy se nenataj zda jejich otcov nejsou natni.
  Podplochy tedy zad naten svch nadploch.
  Do nadploch by se mly dostat pouze linie hranic s nadplochou a podplochou.
     To se udl tak, e podplocha do nadplochy nate linie v opanm smru.
     Vdy se pitom mus testovat zda pidvan linie tam ji nejsou.
  Ped vloenm plochy do SeznamuPloch testovat zda ji tam nen (pouze v ppad
  e nen v registru ploch).
}
var
  Plo: TPlocha;
  //!!!!!!!
  Otec: TTopoLAreaElement;
  aHole: TPolyLineAreaElement;
begin
  result:= nil;
  if FAreaReader = nil then exit;

  FAreaReader.FStream.Seek(Cislo*sizeOf(TPlocha), 0);
  FAreaReader.ReadIt(Plo);

  if not
     (
     RegulerniPlocha(Plo) and
     not(FAreaReader.FStream.Position = FAreaReader.FRecordSize) and
     FAreaReader.OKRectLimits(Plo.OpsanyObdelnik.PH.Y, Plo.OpsanyObdelnik.PH.X,
                              Plo.OpsanyObdelnik.LD.Y, Plo.OpsanyObdelnik.LD.X)
     ) then
       exit;

  { testovn zda ji nen v registru }
  if Register <> nil then
  begin
    result:= TTopoLAreaElement(Register.GetObject('P', Plo.Cislo));

    if result <> nil then
    { Plocha nalezena v registru }
    begin;

// O.. pidno 27.1.1999
      { Jet nezvisle na vsledku testovn zjistme, zda nem nadplochu }
      if Plo.Cislo=Plo.CisloOtce then
      begin
        Protocol:= 'Jako otce m plocha .' + IntToStr(Plo.Cislo) + ' sama sebe !';
      end
      else
      if Plo.CisloOtce > 0 then
      begin
      { najdeme otce, pokud neexistuje, tak se nate - dti natou sv tatnky }
        try
        Otec:= DejPlochuSPodPlochou(SeznamPloch, Plo.CisloOtce);
        except
          Protocol:= 'Import: plocha .' + IntToStr(Plo.Cislo) + ' m chybn slo otce !';
          Otec := nil;
        end;
        if Otec <> nil then
        begin
        { nejdve otestovat zda ji tato plocha nen soust dry v tatnkovi }
          if TAreaElement(Otec.Geometry).GetHoleByXY(result.Geometry.X, result.Geometry.Y) = nil then
          begin
          { vlo linie do nadplochy }
            aHole:= FAreaReader.ReadAreaAsHole(Plo);
            if aHole <> nil then
               TAreaElement(Otec.Geometry).AddHole(aHole)
          end
        end;
      end;
// Konec pdavku

      if (OKDruh('P', result)  and ConditionIsTrue(result)) then
      begin
       { ......... Nalezena plocha result ...........}
        if SeznamPloch.IndexOf(result) > -1 then
           exit;
        SeznamPloch.AddAndUpdateRect(result);
        exit
      end
      else
      begin
      { avak nespluje podmnku }
        result:= nil;
        exit;
      end
    end
    { pokud nen nalezena, pokrauje se ve ten }
  end;

  if ReadAreaAsBoundary then
     result:= FAreaReader.ReadBoundary(Plo)
  else
     result:= FAreaReader.ReadAreaWithLines(Plo);

  if result = nil then
     exit;

  { Jet nezvisle na vsledku testovn zjistme, zda nem nadplochu }
  if Plo.Cislo=Plo.CisloOtce then
  begin
    Protocol:= 'Jako otce m plocha .' + IntToStr(Plo.Cislo) + ' sama sebe !';
  end
  else
  if Plo.CisloOtce > 0 then
  begin
  { najdeme otce, pokud neexistuje, tak se nate - dti natou sv tatnky }
    //Otec:= DejPlochuSPodPlochou(SeznamPloch, Plo.CisloOtce);
    try
    Otec:= DejPlochuSPodPlochou(SeznamPloch, Plo.CisloOtce);
    except
      Protocol:= 'Import: plocha .' + IntToStr(Plo.Cislo) + ' m chybn slo otce !';
      Otec := nil;
    end;
    if Otec <> nil then
    begin
    { nejdve otestovat zda ji tato plocha nen soust dry v tatnkovi }
      if TAreaElement(Otec.Geometry).GetHoleByXY(result.Geometry.X, result.Geometry.Y) = nil then
      begin
      { vlo linie do nadplochy }
        aHole:= FAreaReader.ReadAreaAsHole(Plo);
        if aHole <> nil then
           TAreaElement(Otec.Geometry).AddHole(aHole)
      end
    end;
  end;

  Register.RegisterObject(result);

  if not (OKDruh('P', result)  and ConditionIsTrue(result)) then
  begin
    result.Free;
    result:= nil;
    exit
  end
  else
      FAreaReader.NewObject(result);
  { ......... Nalezena plocha result ...........
    nemusm kontrolovat zda ji v seznamu nen, neb nebyla v registru }
  SeznamPloch.AddAndUpdateRect(result);

end;




function    TTopoLBlokReader.ReadAreas:  TAreaCollection;
var
   i: longInt;
   //Area: TTopoLAreaElement;
begin
{ if FAreaReader.TopolLines <> nil then }
  result:= nil;
  try
  try
    try
       FAreaReader := TTopoLAreaReader.CreateBlockWCS(FBlockDirectory, WCS);
    except
    begin
      Protocol:= 'Chybn nebo neexistujc soubor Ploch -' + FBlockDirectory;
      if FAreaReader <> nil then FAreaReader.Free;
      FAreaReader:= nil;
      exit;
    end
    end;

    if FAreaReader = nil then exit;

    result := TAreaCollection.Create;
    SetReader(FAreaReader);
    SetObjectString(result, 'ARE');

    FAreaReader.StartGauge;
    FAreaReader.FStream.Seek(0, 0);

    for i := 1 to FAreaReader.Size-1 do
    begin
      {
      if FAreaReader.F_gaugeForm.DoCloseQuery and
         FAreaReader.F_gaugeForm.RealyClose('Peruit natn ploch ?') then
         break;
       }
      {Area:= }DejPlochuSPodPlochou(result, i);  { do resultu to strk DejPlochuSpodPlochou }
    end;

  finally
    FAreaReader.EndGauge;
    FAreaReader.Free;
    FAreaReader:= nil
  end;
  except
    World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chyba ten Ploch - ' + FBlockDirectory , World.MainTool);
{      MessageDlg('Chyba ten Ploch', mtInformation, [mbOK], 0); }
  end;
end;







function    TTopoLBlokReader.ReadTexts:  TTextCollection;
var
  i, RetI: longInt;
  aText: TTopoLTextElement;
  {
  Err: boolean;
  ErrSum: integer;
  }
begin
  result:= nil;
  {
  Err := false;
  ErrSum := 0;
  }
 try
 try
   try
      FTextReader := TTopoLTextReader.CreateBlockWCS(FBlockDirectory, WCS);
   except
     World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chybn nebo neexistujc soubor Text -' + FBlockDirectory, World.MainTool);
     if FTextReader <> nil then FTextReader.Free;
     FTextReader:= nil;
     exit;
   end;
   if FTextReader = nil then exit;

   result := TTextCollection.Create;
   SetReader(FTextReader);
   SetObjectString(result, 'TXT');

   FTextReader.StartGauge;
   FTextReader.FStream.Seek(0, 0);
   for i := 0 to FTextReader.Size - 1 do
   begin
     {
     if FTextReader.F_gaugeForm.DoCloseQuery and
        FTextReader.F_gaugeForm.RealyClose('Peruit natn text ?') then
        break;
     }
     RetI:= i;
     aText:= FTextReader.ReadText(RetI);
     {
     if RetI < 0 then
     begin
        Err := true;
        inc(ErrSum);
     end;
     }
     if (aText <> nil) then
     begin
       aText.CodePage:= CodePage;
       result.AddAndUpdateRect(aText);
       if not ConditionIsTrue(aText) then
       begin
         result.FreeElement(aText);
       end
     end
   end;
   //if Err then PostTextMsg(tm_AddToProtocol,BlockName + ' Nesoulad sel text a jejich poad v bloku: '+IntToStr(ErrSum),nil);
  finally
    FTextReader.EndGauge;
    FTextReader.Free;
    FTextReader:= nil;
  end;
  except
    World.MainTool.PostTextMsg(tm_AddToProtocol, 'Chyba ten Text - ' + FBlockDirectory , World.MainTool);
{      MessageDlg('Chyba ten Text', mtInformation, [mbOK], 0); }
  end;
end;




function    TTopoLBlokReader.ReadBlock:  TRectEntity;
var
  Lines: TPolyLineCollection;
  Areas: TAreaCollection;
begin
   result := TRectEntity.Create;
   result.Name := 'BLOK: '+ FBlockDirectory;
{
   result.BlockDir:= FBlockDirectory;
   result.CodePage:= CodePage;
}
   Lines:= ReadLines;
   result.AddAndUpdateRect(Lines); {musi se cist nejdrive linie, o ne se
                                    opiraji pri cteni plochy}
   Areas:= nil;
   if QReadAreas then
   begin
     Areas:= ReadAreas;
     result.AddAndUpdateRect(Areas);
   end;

   if (Lines <> nil) and (Areas <> nil) then
      result.ExchangeElements(Lines, Areas);

   result.AddAndUpdateRect(ReadPoints);
   result.AddAndUpdateRect(ReadTexts);
end;





{
   TFiltrDruhuObjektu = class(TElement)
     ProBod, ProLin, ProPlo, ProTxt: TFiltrDruhu;
}



destructor TFiltrDruhuObjektu.Destroy;
begin
  if ProBod <> nil then
     ProBod.Free;
  if ProLin <> nil then
     ProLin.Free;
  if ProPlo <> nil then
     ProPlo.Free;
  if ProTxt <> nil then
     ProTxt.Free;
  inherited Destroy;
end;




procedure TFiltrDruhuObjektu.AddFilter(Objekt: char; Druh: integer);
begin
end;



procedure TFiltrDruhuObjektu.SetFiltrByArray(Objekt: char; Druhy: array of integer);
var
  ILE: TIntegerListElement;
  I: longInt;
begin
  ILE:= TIntegerListElement.Create;
  for I:= 0 to High(Druhy) do
  begin
    ILE.AddInteger(Druhy[I]);
  end;
  SetFiltr(Objekt, ILE)
end;


procedure TFiltrDruhuObjektu.SetObjektFiltr
          (var ObjektFiltr: TIntegerListElement; NewFilter: TIntegerListElement);
begin
  if ObjektFiltr <> nil then ObjektFiltr.Free;
  ObjektFiltr:= NewFilter
end;

procedure TFiltrDruhuObjektu.SetFiltr(Objekt: char; Druhy: TIntegerListElement);
begin
  if Druhy = nil then exit;

  case Objekt of
  'B': SetObjektFiltr(ProBod, Druhy);
  'L': SetObjektFiltr(ProLin, Druhy);
  'P': SetObjektFiltr(ProPlo,  Druhy);
  'T': SetObjektFiltr(ProTxt, Druhy);
  end;
end;




function TFiltrDruhuObjektu.GetFiltr(Objekt: char): TIntegerListElement;
begin
  result:= nil;
  case Objekt of
  'B': result:=  ProBod;
  'L': result:=  ProLin;
  'P': result:=  ProPlo;
  'T': result:=  ProTxt;
  end
end;





function TFiltrDruhuObjektu.OKDruh(Objekt: char; TopObjekt: TElement): boolean;
var
    DruhList: TIntegerListElement;
    Hodnota: longInt;
    Test: integer;
    HodnotaStr: string;
    I: longInt;

begin
  result:= false;
  if Exclude then result:= true;

  DruhList:= nil;
  case Objekt of
  'B': DruhList:=  ProBod;
  'L': DruhList:=  ProLin;
  'P': DruhList:=  ProPlo;
  'T': DruhList:=  ProTxt;
  end;

  HodnotaStr:= TopObjekt.GetPropertyStringByName(PropName);
  if HodnotaStr = '' then exit;
  val(HodnotaStr, Hodnota, Test);
  if Test <> 0 then exit;

  if DruhList = nil then
  begin
    result:= true;
    exit
  end;

  for I:= 0 to DruhList.Count-1 do
  begin
    if DruhList.Integers[I] = Hodnota then
    begin
       result:= true;
       if Exclude then result:= false;
       break
    end
  end
end;


(*
{ TPZReaderNoRastr }

procedure TPZReaderNoRastr.DoIt;
var
   BR: TTopoLBlokReader;
   Source: TTopoLImportSource;
   PZ : TSpaceEntity;
   i: longInt;
begin
  try
     if Input = nil then
     begin
        MessageDlg('Nen vybrn dn blok', mtInformation, [mbOK], 0);
        OutPut := nil;
        exit;
     end;
     TEntity(World.ObjectModel).AddElement(Input);
     Screen.Cursor := crHourglass;
     Source := TTopoLImportSource(Input);
     PZ := TSpaceEntity.Create;
     PZ.Name := 'TOPOL ... Pedmt zjmu:';

     { Bloky }
     for i := 0 to Source.Blocks.Count -1 do
     begin
       BR:= nil;
       try
        BR := TTopoLBlokReader.CreateBlock(Source.Blocks.Items[i].SourcePath);
        BR.FiltrDruhu:= FiltrDruhu;
        BR.QReadAreas :=  QReadAreas;
        PZ.AddAndUpdateRect(Br.ReadBlock);
       finally
        if BR <> nil then
           BR.Free;
       end
     end;
     PathOfLibraries := Source.Libraries.Name;
     PathOfLibraries := RemoveBackSlash(PathOfLibraries);
     OutPut := PZ;
     Screen.Cursor := crDefault;
  except
    messageDlg('Chyba ten pedmtu zjmu', mtError, [mbOK], 0)
  end;
end;



procedure TPZReaderNoRastr.SetFiltrDruhu(aFiltr: TFiltrDruhuObjektu);
begin
  if FFiltrDruhu <> nil then
     FreeElement(FFiltrDruhu);
  FFiltrDruhu:= aFiltr;

  AddElement(FFiltrDruhu)
end;


*)

function CreateFiltrDruhu(aType: string; Props: TPropertyList): TFiltrDruhuObjektu;
var
  I: longInt;
  SE: TStringElement;
  ILE: TIntegerListElement;
  aPropName: string;
  Znak: char;
begin
  result:= nil;
  if Props = nil then exit;
  for I:= 0 to Props.Count-1 do
  begin
    SE:= Props.StringElements[I];
    if (SE.Name[1] = '!') or (SE.Name[1] = '-') then
    begin
       ILE:= SE.CreateIntegerList;
       if ILE <> nil then
       begin
         result:= TFiltrDruhuObjektu.Create;
         if aType = 'ARE' then Znak:= 'P'
         else
         if aType = 'PNT' then Znak:= 'B'
         else
         if aType = 'LIN' then Znak:= 'L'
         else
         if aType = 'TXT' then Znak:= 'T'
         else Znak:= 'X';

         result.SetFiltr(Znak, ILE);
         aPropName:= upperCase(copy(SE.Name, 2, 255));
         result.PropName:= aPropName;
         if SE.Name[1] = '-' then
            result.Exclude:= true
       end;
       break
    end

  end;
end;


{$IFDEF RAS}
function ReadTopolRaster(RasterName: string): TRaster;
begin
   result:= nil;
   if not fileExists(RasterName) then exit;
   result := TRaster.Create;
   result.FileName := RasterName;
   result.Active := true;
end;
{$ENDIF}





end.
