unit e_Transformation;

interface
uses
   Elements;

type

TTrBod = record
   x,y,z: extended;
end;

TKlic = array[0..20] of extended;
TExtVector = array of extended;

TIDBod = class(TOwnerElement)
private
   FCislo: integer;
   FcX, FcY, FcZ,
   FzX, FzY, FzZ,
   FOdchX, FOdchY, FOdchZ: extended;
   FVaha: extended;
   FComment: string;
   FActive: boolean;
    procedure SetCislo(const Value: integer);
    procedure SetComment(const Value: string);
    procedure SetcX(const Value: extended);
    procedure SetcY(const Value: extended);
    procedure SetcZ(const Value: extended);
    procedure SetOdchX(const Value: extended);
    procedure SetOdchY(const Value: extended);
    procedure SetOdchZ(const Value: extended);
    procedure SetVaha(const Value: extended);
    procedure SetzX(const Value: extended);
    procedure SetzY(const Value: extended);
    procedure SetzZ(const Value: extended);
    procedure SetActive(const Value: boolean);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
public
   constructor Create; override;
published
   property cX: extended read FcX write SetcX;
   property cY: extended read FcY write SetcY;
   property cZ: extended read FcZ write SetcZ;
   property zX: extended read FzX write SetzX;
   property zY: extended read FzY write SetzY;
   property zZ: extended read FzZ write SetzZ;
   property OdchX: extended read FOdchX write SetOdchX;
   property OdchY: extended read FOdchY write SetOdchY;
   property OdchZ: extended read FOdchZ write SetOdchZ;
   property Cislo: integer read FCislo write SetCislo;
   property Vaha: extended read FVaha write SetVaha;
   property Comment: string read FComment write SetComment;
   property Active: boolean read FActive write SetActive;
end;

TTransformationTable = class(TOwnerEntity)
private
    FmX, FmY, FmZ, FmP: extended;
    FTransformationName: string;
    procedure SetTransformationName(const Value: string);
    function GetIDBod(aIndex: integer): TIDBod;
    procedure SetmP(const Value: extended);
    procedure SetmX(const Value: extended);
    procedure SetmY(const Value: extended);
    procedure SetmZ(const Value: extended);
    function GetActivePointsCount: integer;
public
   property IDBod[aIndex: integer]: TIDBod read GetIDBod;
published
   property TransformationName: string read FTransformationName write SetTransformationName;
   property ActivePointsCount: integer read GetActivePointsCount stored false;
   property mX: extended read FmX write SetmX;
   property mY: extended read FmY write SetmY;
   property mZ: extended read FmZ write SetmZ;
   property mP: extended read FmP write SetmP;
end;

implementation
uses
   SysUtils,
   e_Class;

{ TIDBod }

constructor TIDBod.Create;
begin
   inherited;
   Vaha := 1;
   Active := true;
end;

function TIDBod.GetName: string;
begin
   result := IntToStr(FCislo);
end;

procedure TIDBod.SetActive(const Value: boolean);
begin
  FActive := Value;
end;

procedure TIDBod.SetCislo(const Value: integer);
begin
  FCislo := Value;
end;

procedure TIDBod.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure TIDBod.SetcX(const Value: extended);
begin
  FcX := Value;
end;

procedure TIDBod.SetcY(const Value: extended);
begin
  FcY := Value;
end;

procedure TIDBod.SetcZ(const Value: extended);
begin
  FcZ := Value;
end;

procedure TIDBod.SetName(aName: string);
begin
   FCislo := StrToIntDef(aName,0);
end;

procedure TIDBod.SetOdchX(const Value: extended);
begin
  FOdchX := Value;
end;

procedure TIDBod.SetOdchY(const Value: extended);
begin
  FOdchY := Value;
end;

procedure TIDBod.SetOdchZ(const Value: extended);
begin
  FOdchZ := Value;
end;

procedure TIDBod.SetVaha(const Value: extended);
begin
  FVaha := Value;
end;

procedure TIDBod.SetzX(const Value: extended);
begin
  FzX := Value;
end;

procedure TIDBod.SetzY(const Value: extended);
begin
  FzY := Value;
end;

procedure TIDBod.SetzZ(const Value: extended);
begin
  FzZ := Value;
end;


{ TTransformationTable }

function TTransformationTable.GetActivePointsCount: integer;
var
   i: integer;
begin
   result := Count;
   for i := 0 to LastIndex do
   begin
      if not IDBod[i].Active then
         dec(result);
   end;
end;

function TTransformationTable.GetIDBod(aIndex: integer): TIDBod;
begin
   result := TIDBod(Elements[aIndex]);
end;


procedure TTransformationTable.SetmP(const Value: extended);
begin
  FmP := Value;
end;

procedure TTransformationTable.SetmX(const Value: extended);
begin
  FmX := Value;
end;

procedure TTransformationTable.SetmY(const Value: extended);
begin
  FmY := Value;
end;

procedure TTransformationTable.SetmZ(const Value: extended);
begin
  FmZ := Value;
end;

procedure TTransformationTable.SetTransformationName(const Value: string);
begin
   FTransformationName := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TIDBod);
   RegisterOrbisClass(TTransformationTable);
END.
