unit IdBody;

interface

uses {$IFDEF Delphi} Messages, {$ENDIF}
     {$IFNDEF BezBWCC}BWCC, {$ENDIF BezBWCC}OWindows, WinTypes, Objects,
     StrProc, MatProc, TranType,
     Pokus, ZaklOinc, TopolInc,
     TrTab;


type
  PTransformaceProtokol = ^TTransformaceProtokol;
  TTransformaceProtokol = record
    Transformace: pointer;
    TrInterpolovat: boolean;
  end;

  PCilIdBod = ^TCilIdBod;
  TCilIdBod = record

    cCislo: integer;
    ccX, ccY, ccZ,
    czX, czY, czZ: extended;
    cTypIdBodu: TTypIdBodu;
    cVaha: extended;
    cPoznamka: TPoznamka;
  end;

  PCilIdBodCollection = ^TCilIdBodCollection;
  TCilIdBodCollection = object(TCollection)

    procedure FreeItem(Item: Pointer); virtual;
  end;

{ **************************************************************************************** }

  PSnimacIdBodu = ^TSnimacIdBodu;
  TSnimacIdBodu = object(TTool)

    Transformace: pointer;
{$IFNDEF Reduced}
    MenuPoziceRastry,
    MenuKonstrukce: HMenu;

    StrMenuPoziceRastry,
    StrMenuKonstrukce: array[0..20] of char;
{$ENDIF Reduced}

    { Vytvoreni a aktivace }
    constructor Init(aState: PState; aUpdateChildren: boolean; aProcedura: TProcedura;
                     aPorCisloIdB: longInt; aRastr: boolean; const aJmTrTab: TPathStr;
                     aCilBodColl: PCilIdBodCollection; aObdelnik: boolean;
                     const aNazevTransformaceIdB: TNazevTran; aShortHelp: word);
    procedure   Select; virtual;
    procedure   Deselect; virtual;

    { Akce zpusobene mysi }
    procedure   LMouseDown(aWindow: HWnd; aX, aY   : Integer;
      aState : PState); virtual;
    procedure   RMouseDown(aWindow: HWnd; aX, aY: Integer;
      aState: PState); virtual;
    procedure   MouseMove(aX, aY: Integer); virtual;

    { Akce zpusobene Tabletem }
    procedure   TabletButtonDown(aX, aY: double; t: word); virtual;
    procedure   TabletMove(aX, aY: double); virtual;

    procedure   DrawObject; virtual;

    { Akce zpusobene stiskem klavesy }
    procedure   Klavesa(Key, Count, lParamHi: Word); virtual;

    { Akce zpusobene volbou Menu}
    procedure   KonejPrikaz(Prikaz: longInt); virtual;

    procedure   Potvrzeni; virtual;
    procedure   Opusteni; virtual;

    procedure   NoveAktivniOkno(Okno: PWindowsObject; var Msg: TMessage);
                virtual;

    procedure   PaintChildren(Okno: PWindowsObject; AktivniOkno: Boolean;
                              PPaintInfo : PPaintStruct); virtual;

    procedure   ZobrInfoPlochy(Okno: HWnd; Plocha: TRect); virtual;
    procedure   ZakresliNovyStav; virtual;
    procedure   ZakresliStavBMP; virtual;
    procedure   ZakresliNovyBodCSoustavy; virtual;

    procedure   NastavKurzor(Zobrazit: boolean); virtual;
    procedure   KresliKurzor(DC: HDC; aX, aY: integer; Polomer: integer);
    procedure   KresliPaprsky(aX, aY: integer);

    procedure   Chyt(var Bod: TSour);
  private

    OldCursor,
    NovyCursor,
    StaryKurzor   : HCursor;
    AndBitmap,
    XORBitmap     : HBitmap;
    ANDBits,
    XORBits       : pointer;
    VelikostBmp   : word;

    aCX, aCY: extended;
    bX, bY, KurzX, KurzY: integer;
    KurzSour: TSour;

    BodColl: PIdBodCollection;
    CilBodColl: PCilIdBodCollection;

    Vaha: extended;
    Poznamka, OldPoznamka: TPoznamka;

    PuvPorCisloIdB, PorCisloIdB, CisIdBProVypis: longInt;
    PuvCilove, Cilove, Rastr, Opravovat, Obdelnik: boolean;

    NazevTransformaceIdB: TNazevTran;
    JmenoTrTab, OldName: TPathStr;

    ZadanyCilSouradnice: boolean;

    procedure   NastavMenu;
    procedure   ZrusMenu;

    procedure   SipkaNahoru;
    procedure   SipkaDolu;
    procedure   SipkaVlevo;
    procedure   SipkaVpravo;

    procedure   ZobrazTransfTabulku;
    procedure   ZadejPoznamku;
    procedure   ZadejVahu;
    procedure   ZadejSourCiselne;
    procedure   Ukonci;
  end;

function VratParametryObdelniku(var CilBodColl: PCilIdBodCollection): boolean;

function VratParametryML(Metoda: word; var CilBodColl: PCilIdBodCollection): boolean;

function NactiTransfTabulku(var CilBodColl: PCilIdBodCollection; var JmTrTab: TPathStr;
                            var NazevTransformaceIdB: TNazevTran): boolean;

function NactiIdBZDB(var CilBodColl: PCilIdBodCollection; var JmTrTab: TPathStr): boolean;


implementation

uses WinProcs, Strings, WinDos, ODialogs,
     KeyProc, NadGraph, CtiRadek, FilProc, Hlasky,
     ProsGlob, ToolBar,
     DialInc, Help_Dlg, PomDlg,
     RasOpDLL,
     MaplDLL, SMOProc, MapLKat, GausKrug, MapLZM,
     Tablet, BlokPred,
     EditGlob, RASMNDll,
     Chytani,
     RastProc,
     {DBF_DLL,} Stream, DBStream, DBFProc,
     TxRuzne,
     ZaklOkno, ZobraOkn, Lupa;

{ **************************************************************************************** }

procedure TCilIdBodCollection.FreeItem(Item: Pointer);
begin
  freeMem(Item, sizeOf(TCilIdBod));
end;

{ **************************************************************************************** }

function VratParametryObdelniku(
                                var CilBodColl: PCilIdBodCollection): boolean;
var
  X, Y, Sirka, Vyska: extended;
  CilBod: PCilIdBod;

begin
  X     := 0;
  Y     := 0;
  Sirka := 1;
  Vyska := 1;

  if VratObdelnik(X, Y, Sirka, Vyska) then
  begin
    VratParametryObdelniku := true;
    CilBodColl := New(PCilIdBodCollection, Init(1, 1));

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 1;
      case SourSystem of
        JTSK       : begin
                       ccX := X;
                       ccY := Y + Sirka;
                     end;
        Gauss      : begin
                       ccX := X;
                       ccY := Y - Sirka;
                     end;
        Matematicky: begin
                       ccX := Y;
                       ccY := X - Sirka;
                     end;
      end;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 195, cPoznamka, 12);
      {'levy horni'}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 2;
      case SourSystem of
        JTSK,
        Gauss      : begin
                       ccX := X;
                       ccY := Y;
                     end;
        Matematicky: begin
                       ccX := Y;
                       ccY := X;
                     end;
      end;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 196, cPoznamka, 12);
      {'pravy horni'}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 3;
      case SourSystem of
        JTSK       : begin
                       ccX := X + Vyska;
                       ccY := Y + Sirka;
                     end;
        Gauss      : begin
                       ccX := X - Vyska;
                       ccY := Y - Sirka;
                     end;
        Matematicky: begin
                       ccX := Y - Vyska;
                       ccY := X - Sirka;
                     end;
      end;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 197, cPoznamka, 12);
      {levy dolni}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 4;
      case SourSystem of
        JTSK       : begin
                       ccX := X + Vyska;
                       ccY := Y;
                     end;
        Gauss      : begin
                       ccX := X - Vyska;
                       ccY := Y;
                     end;
        Matematicky: begin
                       ccX := Y - Vyska;
                       ccY := X;
                     end;
      end;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 198, cPoznamka, 12);
      {pravy dolni}
    end;
    CilBodColl^.Insert(CilBod);
  end else
  begin
    CilBodColl             := nil;
    VratParametryObdelniku := false;
  end;
end;

{ **************************************************************************************** }

function VratParametryML(
                             Metoda: word;
                         var CilBodColl: PCilIdBodCollection): boolean;
var
  CilBod: PCilIdBod;
  EscDone: boolean;
  Stav: string;
  YRohu, XRohu: RDim9;
  LHY, LHX, PHY, PHX, LDY, LDX, PDY, PDX: double;

begin
  Stav:= 'OK';
  case Metoda of
    1: begin
         DejRozmerListuSMO(State^.ZobrOkno, PHY, PHX, LDY, LDX, EscDone);
         LHY := LDY;
         LHX := PHX;
         PDY := PHY;
         PDX := LDX;
       end;
    2: begin
         DejRozmerListu2880(State^.ZobrOkno, 'G', YRohu, XRohu, Stav);
         if Stav = 'OK' then
         begin
           EscDone := false;
           LHY := YRohu[4];
           LHX := XRohu[4];
           PHY := YRohu[3];
           PHX := XRohu[3];
           LDY := YRohu[1];
           LDX := XRohu[1];
           PDY := YRohu[2];
           PDX := XRohu[2];
         end
         else
           EscDone := true;
       end;
    3: begin
         DejRozmerListu2880(State^.ZobrOkno, 'S', YRohu, XRohu, Stav);
         if Stav = 'OK' then
         begin
           EscDone := false;
           LHY := YRohu[4];
           LHX := XRohu[4];
           PHY := YRohu[3];
           PHX := XRohu[3];
           LDY := YRohu[1];
           LDX := XRohu[1];
           PDY := YRohu[2];
           PDX := XRohu[2];
         end
         else
           EscDone := true;
       end;
    4: begin
         DejRozmerListuZM(State^.ZobrOkno, YRohu, XRohu, Stav);
         if Stav = 'OK' then
         begin
           EscDone := false;
           LHY := YRohu[4];
           LHX := XRohu[4];
           PHY := YRohu[3];
           PHX := XRohu[3];
           LDY := YRohu[1];
           LDX := XRohu[1];
           PDY := YRohu[2];
           PDX := XRohu[2];
         end
         else
           EscDone := true;
       end;
    5: DejRozmerListuGausKrie(State^.ZobrOkno, LHY, LHX, PHY, PHX, LDY, LDX, PDY, PDX, EscDone);
  end;

  if not EscDone then
  begin
    VratParametryML := true;
    CilBodColl := New(PCilIdBodCollection, Init(1, 1));

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 1;
      ccX    := LHX;
      ccY    := LHY;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 195, cPoznamka, 12);
      {'levy horni'}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 2;
      ccX    := PHX;
      ccY    := PHY;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 196, cPoznamka, 12);
      {'pravy horni'}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 3;
      ccX    := LDX;
      ccY    := LDY;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 197, cPoznamka, 12);
      {levy dolni}
    end;
    CilBodColl^.Insert(CilBod);

    CilBod     := New(PCilIdBod);
    with CilBod^ do
    begin
      cCislo := 4;
      ccX    := PDX;
      ccY    := PDY;
      ccZ    := 0;
      czX    := 0;
      czY    := 0;
      czZ    := 0;
      cVaha  := 1;
      LoadString(HInstance, 198, cPoznamka, 12);
      {pravy dolni}
    end;
    CilBodColl^.Insert(CilBod);
  end else
  begin
    CilBodColl      := nil;
    VratParametryML := false;
  end;
end;

{ **************************************************************************************** }


function NactiTransfTabulku(
                            var CilBodColl          : PCilIdBodCollection;
                            var JmTrTab             : TPathStr;
                            var NazevTransformaceIdB: TNazevTran): boolean;
var
  CilBod: PCilIdBod;
  Ext: TExtStr;
  F: text;
  Radek: string;
  TypTr, ZnakDimense: char;
  OKej: boolean;
  RadekObj: TCtiRadek;
  MeziApostrofy: boolean;
  IniPoznamka: string[12];
  Retezec1: array[0..50] of char;
  aP, aA, aK, a2, a3: char;

  procedure NactiRadekTrTabulky(
                                    Radek: string;
                                var OKej: boolean);
  var
    TypRadku: char;

  begin
    OKej:= false;
    RadekObj.Init(Radek);

    with RadekObj, CilBod^ do
    begin
      cCislo := DejInteger;

      if ZnakDimense = '2' then
      begin
        czY := DejReal;
        czX := DejReal;
        czZ := 0;
      end else
      begin
        czY := DejReal;
        czX := DejReal;
        czZ := DejReal;
      end;

      if ZnakDimense = '2' then
      begin
        ccY := DejReal;
        ccX := DejReal;
        ccZ := 0;
      end else
      begin
        ccY := DejReal;
        ccX := DejReal;
        ccZ := DejReal;
      end;

      repeat
        TypRadku:= upCase(DejChar)
      until (TypRadku in ['T', 'K', 'P']) or DosloKChybe;

      if not DosloKChybe then
      begin
        if TypRadku in ['T', 'K', 'P'] then
        begin
          case TypRadku of
            'T': cTypIdBodu := Transformacni;
            'K': cTypIdBodu := Kontrolni;
            'P': cTypIdBodu := Pasivni;
          end;
          OKej:= true
        end;

        IniPoznamka := '';
        while (Obsah[Ukazovatko] <> '"') and (Ukazovatko <= length (Obsah)) do
          inc(Ukazovatko);
        if Ukazovatko <= length (Obsah) then
        begin
          inc(Ukazovatko);
          while (Ukazovatko <= length (Obsah)) and not (Obsah[Ukazovatko] = '"') do
          begin
            IniPoznamka := IniPoznamka + Obsah[Ukazovatko];
            inc (Ukazovatko);
          end;
        end;

        StrPCopy(cPoznamka, IniPoznamka);

        if Ukazovatko < length (Obsah) then
          cVaha := DejReal
        else
          cVaha := 1;
      end else
      begin
        cTypIdBodu := Transformacni;
        StrPCopy(cPoznamka, '');
        cVaha := 1;
      end;
    end;

    RadekObj.Done
  end;


begin
  StrPCopy(Ext, '*.trt');
  if VolbaSouboru(Ext, JmTrTab) then
  begin
    LoadString(HInstance, 621, Retezec1, 20); {Podobnost}
    aP := Retezec1[0];
    LoadString(HInstance, 622, Retezec1, 20); {Afinita}
    aA := Retezec1[0];
    LoadString(HInstance, 623, Retezec1, 20); {Kolineace}
    aK := Retezec1[0];
    LoadString(HInstance, 627, Retezec1, 20); {2.st.Pol.}
    a2 := Retezec1[0];
    LoadString(HInstance, 628, Retezec1, 20); {3.st.Pol.}
    a3 := Retezec1[0];

    CilBodColl := New(PCilIdBodCollection, Init(1, 1));

    OKej:= false;
    assign(F, JmTrTab);
{$I-}
    fileMode := moOpenRONN;
    reset(F);
    fileMode := moStandard;
{$I+}
    if IOResult = 0 then
    begin
      readLn(F, Radek);
      RadekObj.Init(Radek);

      with RadekObj do
      begin
        repeat
          TypTr:= upCase(DejChar)
        until TypTr in [aP, aA, aK, a2, a3];

        if not (TypTr in ['2','3']) then
          repeat
            ZnakDimense:= DejChar
          until ZnakDimense in ['2','3']
        else
          ZnakDimense:= '2'
      end;

      if not RadekObj.DosloKChybe then
      begin
        Dimenze := ord(ZnakDimense) - 48;

        if TypTr = aP then
        begin
          if ZnakDimense = '2' then
            LoadString(HInstance, 621, NazevTransformaceIdB, 20)
          else
            LoadString(HInstance, 621, NazevTransformaceIdB, 20);
        end
        else
          if TypTr = aA then
          begin
            if ZnakDimense = '2' then
              LoadString(HInstance, 622, NazevTransformaceIdB, 20)
            else
              LoadString(HInstance, 622, NazevTransformaceIdB, 20);
          end
          else
            if TypTr = aK then
            begin
              if ZnakDimense = '2' then
                LoadString(HInstance, 623, NazevTransformaceIdB, 20)
              else
                LoadString(HInstance, 623, NazevTransformaceIdB, 20);
            end
            else
              if TypTr = a2 then
                LoadString(HInstance, 627, NazevTransformaceIdB, 20)
              else
                LoadString(HInstance, 628, NazevTransformaceIdB, 20);
      end else
      begin
        LoadString(HInstance, 193, Retezec1, sizeOf(Retezec1));
        {'Spatna transformacni tabulka!'}
        Hlaska(StrPas(Retezec1));
      end;

      RadekObj.Done;

      if not eof(F) then
      begin
        readln(F, Radek);

        CilBod     := New(PCilIdBod);
        NactiRadekTrTabulky(Radek,  OKej);
        CilBodColl^.Insert(CilBod);

        while not eof(F) do
        begin
          readln(F, Radek);
          CilBod     := New(PCilIdBod);
          NactiRadekTrTabulky(Radek, OKej);
          CilBodColl^.Insert(CilBod);
        end;
      end;
      close(F);
      NactiTransfTabulku := true;
    end else
    begin
      CilBodColl         := nil;
      NactiTransfTabulku := false;
      LoadString(HInstance, 192, Retezec1, sizeOf(Retezec1));
      {'Transformacni tabulka neexistuje!'}
      Hlaska(StrPas(Retezec1));
    end;
  end else
  begin
    CilBodColl         := nil;
    NactiTransfTabulku := false;
  end;
end;

{ **************************************************************************************** }

function NactiIdBZDB(
                     var CilBodColl          : PCilIdBodCollection;
                     var JmTrTab             : TPathStr): boolean;

type
  TAr = array[1..12] of char;

var
  CilBod: PCilIdBod;
  JmenoDB: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  DB: pointer;
  YPole, XPole, CisloPole: TAr;
  Cislo, i: integer;
  YC, XC: real;

  Retezec1: array[0..50] of char;

begin
  StrPCopy(Ext, '*.dbf');
  if VolbaSouboru(Ext, JmenoDB) then
  begin
    NactiIdBZDB := true;
    FileSplit(JmenoDB, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.Trt');

    CilBodColl := New(PCilIdBodCollection, Init(1, 1));

    DB:= DBStreamInit(JmenoDB, nil, false);

    if ZdrojOkInit(DB) and ExtStreamOkSetBuf(DB, 10000) then
      for i := 1 to ExtStreamDejPocPrvku(DB) do
          if ZdrojOkInit(DB) then
          begin
            if ExtDBStreamOkNastavZazn(DB, i) then
              Cislo{Pole}:= DBStreamDejLongIntPol(DB, Pol_Cislo)

{            if ZdrojOkInit(DB) then
              DBPtrPredejPolozku(DB, CisloPole, DBPtrPolozkaCislem(DB, 'CISLO'))}

            else
            begin
              LoadString(HInstance, 194, Retezec1, sizeOf(Retezec1));
              {'Chyba databazoveho souboru!'}
              Hlaska(StrPas(Retezec1));
              DBStreamDone(DB);
              exit;
            end;

            if ZdrojOkInit(DB) then
{              DBPtrPredejPolozku(DB, YPole, DBPtrPolozkaCislem(DB, 'Y'))}
               YC{Pole}:= DBStreamDejRealPol(DB, 'Y')
            else
            begin
              LoadString(HInstance, 194, Retezec1, sizeOf(Retezec1));
              {'Chyba databazoveho souboru!'}
              Hlaska(StrPas(Retezec1));
              DBStreamDone(DB);
              exit;
            end;

            if ZdrojOkInit(DB) then
{              DBPtrPredejPolozku(DB, XPole, DBPtrPolozkaCislem(DB, 'X'))}
              XC{Pole}:= DBStreamDejRealPol(DB, 'X')
            else
            begin
              LoadString(HInstance, 194, Retezec1, sizeOf(Retezec1));
              {'Chyba databazoveho souboru!'}
              Hlaska(StrPas(Retezec1));
              DBStreamDone(DB);
              exit;
            end;

            if ZdrojOkInit(DB) then
            begin
              New(CilBod);

              with CilBod^ do
              begin
                cCislo := DejIntegerDB(DB, ExtDBStreamDejCPol(DB, Pol_Cislo));
                StrPCopy(cPoznamka, LStr(cCislo));
                ccX   := DejRealDB(DB, ExtDBStreamDejCPol(DB, 'X'));
                ccY   := DejRealDB(DB, ExtDBStreamDejCPol(DB, 'Y'));
                ccZ   := 0;
                czX   := 0;
                czY   := 0;
                czZ   := 0;
                cVaha := 1;
              end;

              CilBodColl^.Insert(CilBod);
            end;
          end;
    DBStreamDone(DB);
  end else
  begin
    CilBodColl  := nil;
    NactiIdBZDB := false;
  end;
end;

{ **************************************************************************************** }


constructor TSnimacIdBodu.Init(
                                     aState               : PState;
                                     aUpdateChildren      : boolean;
                                     aProcedura           : TProcedura;
                                     aPorCisloIdB         : longInt;
                                     aRastr               : boolean;
                               const aJmTrTab             : TPathStr;
                                     aCilBodColl          : PCilIdBodCollection;
                                     aObdelnik            : boolean;
                               const aNazevTransformaceIdB: TNazevTran;
                                     aShortHelp           : word);

begin
  inherited Init(aState, aUpdateChildren, aProcedura);
  ShortHelp := aShortHelp;
  StrCopy(JmenoTrTab, aJmTrTab);
  StrCopy(NazevTransformaceIdB, aNazevTransformaceIdB);
  Rastr        := aRastr;
  CilBodColl   := aCilBodColl;
  PorCisloIdB  := aPorCisloIdB;
  Obdelnik     := aObdelnik;
  MenuNastaveno:= false;
  NovyCursor   := 0;
  AndBitmap    := 0;
  XORBitmap    := 0;
  ANDBits      := nil;
  XORBits      := nil;
  VelikostBmp  := 0;
  StaryKurzor  := 0;
end;

procedure TSnimacIdBodu.NastavMenu;
var
  PopupMenu: HMenu;
  Konst: byte;
  PomPlocha: TRect;
  Retezec1: array[0..100] of char;
  Pos: byte;

begin
  with PWindow(Application^.MainWindow)^ do
  begin
    UpDateFocusChild;
    if (FocusChildHandle <> 0) and (IsZoomed(FocusChildHandle)) then
      Konst := 1
    else
      Konst := 0;

    Pos:= 0;

    EnableMenuItem(GetMenu(HWindow), PozicePredmetZajmu+Konst, mf_ByPosition or mf_Grayed);
    EnableMenuItem(GetMenu(HWindow), PoziceEditace+Konst, mf_ByPosition or mf_Grayed);
    PopupMenu := CreatePopupMenu;
    LoadString(HInstance, 640, Retezec1, sizeOf(Retezec1));
    {&Transformacni tabulka};
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_TrTab, Retezec1);
    inc(Pos);

    LoadString(HInstance, 642, Retezec1, sizeOf(Retezec1));
    {&Vaha};
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_Vaha, Retezec1);
    inc(Pos);

    LoadString(HInstance, 641, Retezec1, sizeOf(Retezec1));
    {&Poznamka}
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_Poznamka, Retezec1);
    inc(Pos);

    LoadString(HInstance, 643, Retezec1, sizeOf(Retezec1));
    {Cilove &souradnice ciselne};
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_VstupSourCiselne, Retezec1);
    inc(Pos);

{$IFNDEF NoVektor}
    LoadString(HInstance, 666, Retezec1, sizeOf(Retezec1));
    {&Parametry chytani};
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_MezChytani, Retezec1);
    inc(Pos);
{$ENDIF}

    LoadString(HInstance, 744, Retezec1, sizeOf(Retezec1));
    {Lupa};
    if PouzitLupu then
      InsertMenu(PopupMenu, Pos, mf_ByPosition or mf_Checked, cm_PouzitLupu, Retezec1)
    else
      InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_PouzitLupu, Retezec1);

    inc(Pos);

    InsertMenu(PopupMenu, Pos, mf_ByPosition or mf_Separator, 0, Retezec1);
    inc(Pos);

    LoadString(HInstance, 644, Retezec1, sizeOf(Retezec1));
    InsertMenu(PopupMenu, Pos, mf_ByPosition, cm_OpusteniIdB, Retezec1);
    inc(Pos);

{$IFNDEF Reduced}
  {$IFNDEF PhoTopoL}
      GetMenuString(GetMenu(HWindow), PoziceRastry+Konst, StrMenuPoziceRastry, 20, mf_ByPosition);
      GetMenuString(GetMenu(HWindow), PoziceKonstrukce+Konst, StrMenuKonstrukce, 20, mf_ByPosition);
      MenuPoziceRastry       := GetSubMenu(GetMenu(HWindow), PoziceRastry+Konst);
      MenuKonstrukce         := GetSubMenu(GetMenu(HWindow), PoziceKonstrukce+Konst);

      RemoveMenu(GetMenu(HWindow), PoziceRastry+Konst, mf_ByPosition);
      RemoveMenu(GetMenu(HWindow), PoziceRastry+Konst, mf_ByPosition);

      LoadString(HInstance, 645, Retezec1, sizeOf(Retezec1)); {Prikazy}
      InsertMenu(GetMenu(HWindow), PoziceRastry+Konst, mf_ByPosition + mf_Popup, PopupMenu, Retezec1);
{      MenuPrikazy            := PoziceRastry;}
  {$ELSE}
      LoadString(HInstance, 645, Retezec1, sizeOf(Retezec1));
      {Prik&azy}
      InsertMenu(GetMenu(HWindow), succ(PoziceOkna)+Konst, mf_ByPosition + mf_Popup, PopupMenu, Retezec1);
{      MenuPrikazy            := succ(PoziceOkna);}
  {$ENDIF}
{$ELSE}
    LoadString(HInstance, 645, Retezec1, sizeOf(Retezec1)); {Prikazy}
    InsertMenu(GetMenu(HWindow), succ(PoziceOkna)+Konst, mf_ByPosition + mf_Popup, PopupMenu, Retezec1);
{$ENDIF}

    DrawMenuBar(HWindow);

    strPCopy(Retezec1, 'IdB');
    Application^.HAccTable := LoadAccelerators(HInstance, Retezec1);

    StrCopy(OldObrMenu, ObrMenu^.ResName);

    strPCopy(Retezec1, 'EdBod');
    ObrMenu^.SwitchTo(Retezec1);
    GetClientRect (ObrMenu^.HWindow,  PomPlocha);
    InvalidateRect(ObrMenu^.HWindow, @PomPlocha, True);
  end;
end;

procedure TSnimacIdBodu.ZrusMenu;
var
  Konst: byte;
  PomPlocha: TRect;
  Retezec1: array[0..12] of char;

begin
  with PWindow(Application^.MainWindow)^ do
  begin
    UpDateFocusChild;
    if (FocusChildHandle <> 0) and (IsZoomed(FocusChildHandle)) then
      Konst := 1
    else
      Konst := 0;

    EnableMenuItem(GetMenu(HWindow), PozicePredmetZajmu+Konst, mf_ByPosition or mf_Enabled);
    EnableMenuItem(GetMenu(HWindow), PoziceEditace+Konst, mf_ByPosition or mf_Enabled);
    EnableMenuItem(GetMenu(HWindow), cm_SourSystem, mf_ByCommand or mf_Enabled);
    if not PouzitLupu then
      CheckMenuItem(GetMenu(HWindow), cm_PouzitLupu, mf_ByCommand or mf_UnChecked)
    else
      CheckMenuItem(GetMenu(HWindow), cm_PouzitLupu, mf_ByCommand or mf_Checked);

{$IFNDEF Reduced}
  {$IFNDEF PhoTopoL}
      DeleteMenu(GetMenu(HWindow), PoziceRastry+Konst, mf_ByPosition);

      InsertMenu(GetMenu(HWindow), PoziceRastry+Konst,
        mf_ByPosition + mf_Popup, MenuPoziceRastry, StrMenuPoziceRastry);
      InsertMenu(GetMenu(HWindow), PoziceKonstrukce+Konst,
        mf_ByPosition + mf_Popup, MenuKonstrukce, StrMenuKonstrukce);
   {$ELSE}
      DeleteMenu(GetMenu(HWindow), succ(PoziceOkna)+Konst, mf_ByPosition);
   {$ENDIF}
{$ELSE}
    DeleteMenu(GetMenu(HWindow), succ(PoziceOkna)+Konst, mf_ByPosition);
{$ENDIF}

    DrawMenuBar(HWindow);

    strPCopy(Retezec1, 'Top_hlavni');
    Application^.HAccTable := LoadAccelerators(HInstance, Retezec1);

    ObrMenu^.SwitchTo(OldObrMenu);
    GetClientRect(ObrMenu^.HWindow, PomPlocha);
    InvalidateRect(ObrMenu^.HWindow,@PomPlocha,True);
  end;
end;

procedure TSnimacIdBodu.Select;
type
  PtrRec = record
    Lo, Hi: Word
  end;

var
  i: integer;
  Bod: PIdBod;
  Retezec1: array[0..10] of char;

begin
  inherited Select;
  ZobrOkno := State^.ZobrOkno;

  BodColl  := New(PIdBodCollection, Init(1, 1));

  Opravovat := false;

  if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
  begin
    CisIdBProVypis      := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cCislo;
    StrCopy(Poznamka, PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cPoznamka);
    Cilove              := false;
    ZadanyCilSouradnice := true;
    if Rastr and (SourSystem = Matematicky) then
    begin
      aCY                 := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccX;
      aCX                 := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccY;
    end else
    begin
      aCX                 := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccX;
      aCY                 := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccY;
    end;
  end else
  begin
    if (CilBodColl <> nil) and (PorCisloIdB > CilBodColl^.Count) then
      for i := 0 to pred(CilBodColl^.Count) do
        with PCilIdBod(CilBodColl^.At(i))^ do
        begin
          Bod := New(PIdBod, Init(cCislo, Rastr));

          Bod^.VlozCilSour(ccX, ccY, ccZ);
          Bod^.VlozPoznamku(cPoznamka);
          Bod^.VlozVahu(cVaha);
          Bod^.VlozZdrSour(czX, czY, czZ);
          Bod^.VlozTypIdBodu(cTypIdBodu);

          BodColl^.Insert(Bod);
        end;
    CisIdBProVypis      := PorCisloIdB;
    StrPCopy(Poznamka, LStr(PorCisloIdB));
    Cilove              := true;
    ZadanyCilSouradnice := false;
  end;
  Vaha     := 1;

  NoveOkno := false;

  StrPCopy(OldName, '');

  Transformace := nil;

  NastavMenu;

  strPCopy(Retezec1, 'Snimac');
  OldCursor := SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, LoadCursor(HInstance, Retezec1));

  if Cilove or not Rastr then
    NastavKurzor(true);
  SendMessage(ZobrOkno^.Parent^.HWindow, wm_ZapisInformPlochy, 0, 0);
  InvalidateRect(ZobrOkno^.HWindow, nil, false);
end;

procedure TSnimacIdBodu.Deselect;
begin
  if Cilove or not Rastr then
    NastavKurzor(false);
  ZrusMenu;
  SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, OldCursor);
  inherited Deselect;
end;

procedure TSnimacIdBodu.LMouseDown(
                                   aWindow: HWnd;
                                   aX, aY : Integer;
                                   aState : PState);
var
  BodL: TPoint;

begin
  if not NoveOkno then
  begin
    MouseMove(aX, aY);

    BodL.X := bX;
    BodL.Y := bY;

    with PZobrazOkno(ZobrOkno)^ do
      ObrBodNaSour(BodL, KurzSour);

    Potvrzeni;
  end
  else
    NoveOkno := false;
end;

procedure TSnimacIdBodu.RMouseDown(
                                   aWindow: HWnd;
                                   aX, aY : Integer;
                                   aState : PState);
begin
  Opusteni
end;

procedure TSnimacIdBodu.MouseMove(
                                  aX, aY: Integer);
begin
  bX := aX;
  bY := aY;
end;

procedure TSnimacIdBodu.TabletButtonDown(
                                         aX, aY: double;
                                         t     : word);
begin
  TabletMove(aX, aY);
  Klavesa(t, 0, 0);
end;

procedure TSnimacIdBodu.TabletMove(
                                   aX, aY: double);
var
  BodL: TPoint;

begin
  DrawObject;

  KurzSour.X := aX;
  KurzSour.Y := aY;

  with PZobrazOkno(ZobrOkno)^ do
  begin
    SourNaObrBod(KurzSour, BodL);

    with BodL do
    begin
      KurzX := X;
      KurzY := Y;
    end;
  end;

  DrawObject;
end;

procedure TSnimacIdBodu.KLavesa(
                                Key, Count, lParamHi: Word);
begin
  case Key of
    SNahoru : SipkaNahoru;
    SDolu   : SipkaDolu;
    SVlevo  : SipkaVlevo;
    SVpravo : SipkaVpravo;
    Enter   : Potvrzeni;
    Esc     : Opusteni;
  end;
end;

procedure TSnimacIdBodu.KonejPrikaz(Prikaz: longInt);
begin
  case Prikaz of
    cm_TrTab            : ZobrazTransfTabulku;
    cm_Poznamka         : ZadejPoznamku;
    cm_Vaha             : ZadejVahu;
    cm_VstupSourCiselne : ZadejSourCiselne;
    cm_OpusteniIdB      : Ukonci;
  end;
end;

procedure TSnimacIdBodu.ZobrInfoPlochy(Okno: HWnd; Plocha: TRect);
var
  SirkaTextu, VyskaTextu: integer;
  PomDC: HDC;
  Text, Pom: array[0..50] of Char;
  PomFont: HFont;

begin
  PomDC:= GetDC(Okno);
  SetBkMode(PomDC, Transparent);
  PomFont  := SelectObject(PomDC, HelpLineFont);

  if Obdelnik and (PorCisloIdB <= CilBodColl^.Count) then
    StrCopy(Text, Poznamka)
  else
  begin
    StrPCopy(Text, LStr(CisIdBProVypis));
    if Cilove then
      LoadString(HInstance, 199, Pom, 50)
      {'.bod cil. soustavy'}
    else
      LoadString(HInstance, 200, Pom, 50);
      {'.bod zdr. soustavy')}
    StrCat(Text, Pom);
  end;

  VyskaTextu:= HiWord (GetTextExtent (PomDC, Text, 1));
  SirkaTextu:= LoWord (GetTextExtent (PomDC, Text, StrLen(Text)));
  TextOut(PomDC, Plocha.Left + 2,
          Plocha.Bottom + 1 - VyskaNapovedy + (VyskaNapovedy - VyskaTextu) div 2, Text, StrLen (Text));

  SelectObject(PomDC, PomFont);
  ReleaseDC(Okno, PomDC);
end;


procedure TSnimacIdBodu.Potvrzeni;
var
  Bod: PIdBod;
  BodL: TPoint;
  XPR, YPR: real;
  BodCollection: PBodCollection;
  RastrPtr: pointer;
  IX, IY: longint;

begin
  RastrPtr:= SRGetAktRastr;
  IX:= RastObjGetRows(RastrPtr);
  IY:= RastObjGetCols(RastrPtr);

  with PZobrazOkno(ZobrOkno)^ do
  begin
    if Cilove then
    begin
      if Opravovat then
        with PIdBod(BodColl^.At(CisAktIdBodu))^ do
        begin
          BodL.X := bX;
          BodL.Y := bY;

          if PouzitLupu then
          begin
            if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
               or (BodCollection = nil)
               or (BodCollection^.Count < 1) then
            begin
              if BodCollection <> nil then
                Dispose(BodCollection, Done);
              exit;
            end;

            KurzSour := PSour(BodCollection^.At(0))^;
            Dispose(BodCollection, Done);
          end;

          Chyt(KurzSour);
          if Rastr then
          begin
            case SourSystem of
              JTSK,
              Gauss      : VlozCilSour(KurzSour.X, KurzSour.Y, cZ);
              Matematicky: VlozCilSour(KurzSour.Y, KurzSour.X, cZ);
            end;
          end
          else
            VlozCilSour(KurzSour.X, KurzSour.Y, cZ);

          VlozTypIdBodu(Transformacni);
        end
      else
      begin
        BodL.X := bX;
        BodL.Y := bY;

        if PouzitLupu then
        begin
          if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
             or (BodCollection = nil)
             or (BodCollection^.Count < 1) then
          begin
            if BodCollection <> nil then
              Dispose(BodCollection, Done);
            exit;
          end;

          KurzSour := PSour(BodCollection^.At(0))^;
          Dispose(BodCollection, Done);
        end;

        Chyt(KurzSour);
        acX := KurzSour.X;
        acY := KurzSour.Y;
      end;

      if Rastr then
        NastavKurzor(false);
      NoveOkno := false;
      Cilove   := false;
      ZakresliNovyBodCSoustavy;
      SendMessage(ZobrOkno^.Parent^.HWindow, wm_ZapisInformPlochy, 0, 0);
    end else
    begin
      if Opravovat then
      begin
        with PIdBod(BodColl^.At(CisAktIdBodu))^ do
        begin
          if Rastr then
          begin
            if RastrPtr = nil then
              Ukonci;

            BodL.X := bX;
            BodL.Y := bY;

            if PouzitLupu then
            begin
              if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
                 or (BodCollection = nil)
                 or (BodCollection^.Count < 1) then
              begin
                if BodCollection <> nil then
                  Dispose(BodCollection, Done);
                exit;
              end;

              KurzSour := PSour(BodCollection^.At(0))^;
              Dispose(BodCollection, Done);
            end;

            SourNaPixlove(RastrPtr, KurzSour, XPR, YPR, SourSystem);
{            with SpravceRastru^.AktRastr^ do}
              case SourSystem of
                JTSK        : VlozZdrSour(XPR, YPR, zZ);
                Gauss,
                Matematicky : VlozZdrSour(IX-XPR+1, IY-YPR+1, zZ);
              end;
          end else
          begin
            BodL.X := bX;
            BodL.Y := bY;

            if PouzitLupu then
            begin
              if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
                 or (BodCollection = nil)
                 or (BodCollection^.Count < 1) then
              begin
                if BodCollection <> nil then
                  Dispose(BodCollection, Done);
                exit;
              end;

              KurzSour := PSour(BodCollection^.At(0))^;
              Dispose(BodCollection, Done);
            end;

            Chyt(KurzSour);
            VlozZdrSour(KurzSour.X, KurzSour.Y, zZ);
          end;
          VlozTypIdBodu(Transformacni);
        end;

        NoveOkno := false;
        ZakresliNovyStav;
        Opusteni;
        exit;
      end else
      begin
        if Rastr then
        begin
          if RastrPtr = nil then
            Ukonci;

          BodL.X := bX;
          BodL.Y := bY;

          if PouzitLupu then
          begin
            if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
               or (BodCollection = nil)
               or (BodCollection^.Count < 1) then
            begin
              if BodCollection <> nil then
                Dispose(BodCollection, Done);
              exit;
            end;

            KurzSour := PSour(BodCollection^.At(0))^;
            Dispose(BodCollection, Done);
          end;

          SourNaPixlove(RastrPtr, KurzSour, XPR, YPR, SourSystem);
        end else
        begin
          BodL.X := bX;
          BodL.Y := bY;

          if PouzitLupu then
          begin
            if    not VratSouradniceLupou(BodL, KurzSour, false, nil, 0, false, BodCollection)
               or (BodCollection = nil)
               or (BodCollection^.Count < 1) then
            begin
              if BodCollection <> nil then
                Dispose(BodCollection, Done);
              exit;
            end;

            KurzSour := PSour(BodCollection^.At(0))^;
            Dispose(BodCollection, Done);
          end;

          Chyt(KurzSour);
        end;

        Bod := New(PIdBod, Init(CisIdBProVypis, Rastr));
        if Rastr then
        begin
          if RastrPtr = nil then
            Ukonci;

{          with SpravceRastru^.AktRastr^ do}
            case SourSystem of
              JTSK       : Bod^.VlozZdrSour(XPR, YPR, 0);
              Gauss,
              Matematicky: Bod^.VlozZdrSour(IX-XPR+1, IY-YPR+1, 0);
            end;
        end else
        begin
          Bod^.VlozZdrSour(KurzSour.X, KurzSour.Y, 0);
        end;

        if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
        begin
          with PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^ do
            if Rastr then
            begin
              case SourSystem of
                JTSK,
                Gauss      : Bod^.VlozCilSour(ccX, ccY, ccZ);
                Matematicky: Bod^.VlozCilSour(ccY, ccX, ccZ);
              end;
            end
            else
              Bod^.VlozCilSour(ccX, ccY, ccZ);
        end else
        begin
          if Rastr then
          begin
            case SourSystem of
              JTSK,
              Gauss      : Bod^.VlozCilSour(aCX, aCY, 0);
              Matematicky: Bod^.VlozCilSour(aCY, aCX, 0);
            end;
          end else
          begin
            Bod^.VlozCilSour(aCX, aCY, 0);
          end;
        end;

        inc(PorCisloIdB);

        Bod^.VlozPoznamku(Poznamka);
        Bod^.VlozVahu(Vaha);

        if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
        begin
          CisIdBProVypis := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cCislo;
          StrCopy(Poznamka, PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cPoznamka);
          Cilove         := false;
          if Rastr and (SourSystem = Matematicky) then
          begin
            aCY            := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccX;
            aCX            := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccY;
          end else
          begin
            aCX            := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccX;
            aCY            := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.ccY;
          end;
        end else
        begin
          CisIdBProVypis := PorCisloIdB;
          StrPCopy(Poznamka, LStr(PorCisloIdB));
          Cilove         := true;
        end;

        Vaha := 1;
        Bod^.VlozTypIdBodu(Transformacni);

        BodColl^.Insert(Bod);

        NoveOkno := false;
        ZakresliNovyStav;
        SendMessage(ZobrOkno^.Parent^.HWindow, wm_ZapisInformPlochy, 0, 0);

        if ZadanyCilSouradnice and (CilBodColl <> nil) and
           (PorCisloIdB > CilBodColl^.Count) then
        begin
          ZadanyCilSouradnice := false;
          Opusteni;
          exit;
        end;
      end;
      if Rastr and Cilove then
        NastavKurzor(true);
    end;
  end;
end;

procedure TSnimacIdBodu.Opusteni;
var
  i: longInt;
  PomProcedura: TProcedura;
  TransformaceProtokol: PTransformaceProtokol;
  PomRohy: TObdelnik;
  RastrPtr: pointer;
  IX, IY: longint;

begin
  if not (Opravovat and Cilove) then
  begin
    RastrPtr:= SRGetAktRastr;
    IX:= RastObjGetRows(RastrPtr);
    IY:= RastObjGetCols(RastrPtr);

    if Opravovat then
    begin
      Cilove       := PuvCilove;
      if Cilove and Rastr then
        NastavKurzor(true);

      PorCisloIdB  := PuvPorCisloIdB;
      StrCopy(Poznamka, OldPoznamka);

      if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
        CisIdBProVypis := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cCislo
      else
        CisIdBProVypis := PorCisloIdB;

      Opravovat    := false;
    end;

    case TransformacniTabulka(Rastr, BodColl, Transformace, NazevTransformaceIdB,
                              JmenoTrTab, OldName) of
      id_Cancel  : begin
                     Dispose(BodColl, Done);
                     if CilBodColl <> nil then
                       Dispose(CilBodColl, Done);
                     if Transformace <> nil then
                       TransformaceDone(Transformace);
                     Transformace := nil;
                     Deselect;
                   end;

      id_OK      : begin
                     ZakresliStavBMP;
                     if Transformace <> nil then
                     begin
                       TransformaceNastavNazevTransformace(Transformace, NazevTransformaceIdB);
                       TransformaceNastavNazevTransfTabulky(Transformace, JmenoTrTab);

                       with PomRohy do
                       begin
                         LD.Y:= -1E20; PH.Y:= 1E20; PH.X:= 1E20; LD.X:= -1E20;
                       end;

                       if Rastr then
                       begin
                         if RastrPtr = nil then
                           Ukonci;

                         for i := 0 to pred(BodColl^.Count) do
                           with PIdBod(BodColl^.At(i))^{, SpravceRastru^.AktRastr^} do
                             if TypIdBodu = Transformacni then
                               case SourSystem of
                                 JTSK       : AktualizaceOpObdelnika(zY, zX, PomRohy);
                                 Gauss,
                                 Matematicky: with PomRohy do
                                              begin
                                                if (abs(IY-zY) < 1E19) then
                                                begin
                                                  if IY-zY > LD.Y then LD.Y := IY-zY;
                                                  if IY-zY < PH.Y then PH.Y := IY-zY;
                                                end;

                                                if (abs(IX-zX) < 1E19) then
                                                begin
                                                  if IX-zX > LD.X then LD.X := IX-zX;
                                                  if IX-zX < PH.X then PH.X := IX-zX;
                                                end
                                              end;
                               end;

                         TransformaceNastavSourRohu(Transformace, PomRohy);
                       end;

                       Dispose(BodColl, Done);
                       if CilBodColl <> nil then
                         Dispose(CilBodColl, Done);
                       New(TransformaceProtokol);
                       TransformaceProtokol^.Transformace   := Transformace;
                       PomProcedura    := Procedura;
                       Deselect;
                       PomProcedura(TransformaceProtokol);
                     end else
                     begin
                       Dispose(BodColl, Done);
                       if CilBodColl <> nil then
                         Dispose(CilBodColl, Done);
                       Deselect;
                     end;
                   end;

      id_DalsiIdB: begin
                   end;

      id_OpravIdB: begin
                     if not Cilove and Rastr then
                       NastavKurzor(true);
                     PuvCilove      := Cilove;
                     PuvPorCisloIdB := PorCisloIdB;
                     StrCopy(OldPoznamka, Poznamka);
                     Cilove         := true;
                     PorCisloIdB    := succ(CisAktIdBodu);
                     StrCopy(Poznamka, PIdBod(BodColl^.At(CisAktIdBodu))^.Poznamka);
                     CisIdBProVypis := PIdBod(BodColl^.At(CisAktIdBodu))^.Cislo;
                     Opravovat      := true;
                   end;
    end;
  end else
  begin
    Cilove := false;
    if Rastr then
      NastavKurzor(false);
    SendMessage(ZobrOkno^.Parent^.HWindow, wm_ZapisInformPlochy, 0, 0);
  end;
end;

procedure TSnimacIdBodu.NastavKurzor(Zobrazit: boolean);
var
  PomDC       : HDC;
  MezPixelu   : longint;
  StrX, StrY  : integer;
  Sirka, Vyska: integer;
  PomBitmap   : HBitmap;
  Retezec1: array[0..10] of char;

begin
  if Zobrazit and (Cilove or not Rastr) then
  begin
    if ANDBits <> nil then
      FreeMem(AndBits, VelikostBMP);
    ANDBits:= nil;

    if XORBits <> nil then
      FreeMem(XORBits, VelikostBMP);
    XORBits:= nil;

    if ANDBitmap <> 0 then
      DeleteObject(ANDBitmap);
    ANDBitmap := 0;

    if XORBitmap <> 0 then
      DeleteObject(XORBitmap);
    XORBitmap := 0;

    if StaryKurzor <> 0 then
      SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, StaryKurzor);

    if NovyCursor <> 0 then
      DestroyCursor(NovyCursor);
    NovyCursor := 0;

    MezPixelu:= 0;
    with PZobrazOkno(ZobrOkno)^ do
      if Kvert > Khoriz then MezPixelu:= Round(MezChytani * Kvert)
                        else MezPixelu:= Round(MezChytani * Khoriz);
    Vyska:= GetSystemMetrics(sm_CXCursor);
    Sirka:= GetSystemMetrics(sm_CYCursor);
    StrX:= Round(Sirka/2) - 1;
    StrY:= Round(Vyska/2) - 1;
    if MezPixelu >= StrX then MezPixelu:= -1;

    if MezPixelu >= 0 then
    begin
      VelikostBmp:= (Sirka * Vyska) div 8;
      PomDC:= ZobrOkno^.CreateMemoryDC;

      ANDBitmap:= CreateCompatibleBitmap(PomDC, Sirka, Vyska);
      PomBitmap:= SelectObject(PomDC, ANDBitmap);
      PatBlt(PomDC, 0, 0, Sirka, Vyska, whiteness);
      GetMem(ANDBits, VelikostBmp);
      GetBitmapBits(ANDBitmap, VelikostBMP, ANDBits);

      XORBitmap:= CreateCompatibleBitmap(PomDC, Sirka, Vyska);
      SelectObject(PomDC, XORBitmap);
      PatBlt(PomDC, 0, 0, Sirka, Vyska, blackness);
      KresliKurzor(PomDC, StrX, StrY, MezPixelu);
      GetMem(XORBits, VelikostBmp);
      GetBitmapBits(XORBitmap, VelikostBMP, XORBits);

      NovyCursor := CreateCursor(HInstance, StrX, StrY, Sirka, Vyska, ANDBits, XORBits);
      StaryKurzor:= SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, NovyCursor);

      SelectObject(PomDC, PomBitmap);
      DeleteDC(PomDC);
    end
    else
    begin
      if Chytat then
        strPCopy(Retezec1, 'SNAPEX')
      else
        strPCopy(Retezec1, 'EDITKRIZ');

      StaryKurzor:= SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, LoadCursor(HInstance, Retezec1));
    end
  end
  else
    if StaryKurzor > 0 then
    begin
      SetClassWord(ZobrOkno^.HWindow, GCW_HCursor, StaryKurzor);
      if NovyCursor <> 0 then
      begin
        DestroyCursor(NovyCursor);
        NovyCursor := 0;;
      end;
      if ANDBits <> nil then
      begin
        FreeMem(AndBits, VelikostBMP);
        ANDBits := nil;
      end;
      if XORBits <> nil then
      begin
        FreeMem(XORBits, VelikostBMP);
        XORBits := nil;
      end;
      if ANDBitmap <> 0 then
      begin
        DeleteObject(ANDBitmap);
        AndBitmap := 0;
      end;
      if XORBitmap <> 0 then
      begin
        DeleteObject(XORBitmap);
        XORBitmap := 0;
      end;
      VelikostBmp  := 0;
      StaryKurzor  := 0;
    end;
end;

procedure TSnimacIdBodu.KresliKurzor(DC: HDC; aX, aY: integer; Polomer: integer);
begin
  if Chytat and (Polomer > 0) then
    KresliOsmiuhelnik(DC, aX, aY, Polomer, BarvaPevnehoNastroje, R2_not);
  KresliKrizek(DC, aX, aY, 15, BarvaPevnehoNastroje, R2_not)
end;

procedure TSnimacIdBodu.KresliPaprsky(aX, aY: integer);
var
  PomPen, OldPen: HPen;
  PomROP2: word;
  DiagR: integer;
  MezPixelu: integer;
  DC: HDC;
begin
  with PZobrazOkno(ZobrOkno)^ do
    if Kvert > Khoriz then MezPixelu:= Round(MezChytani * Kvert)
                      else MezPixelu:= Round(MezChytani * Khoriz);
  DC:= GetDC(ZobrOkno^.HWindow);
  PomPen:= CreatePen(ps_Dot, 1, DejSkutBarvu(BarvaPevnehoNastroje));
  OldPen:= SelectObject(DC, PomPen);
  PomRop2:= SetRop2(DC, r2_NotXorPen(*R2_XORPen*));

  DiagR:= MezPixelu - MezPixelu div 4;
  MoveTo(DC, aX, aY);
  LineTo(DC, aX-MezPixelu, aY);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX-DiagR, aY-DiagR);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX, aY-MezPixelu);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX+DiagR, aY-DiagR);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX+MezPixelu, aY);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX+DiagR, aY+DiagR);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX, aY+MezPixelu);
  MoveTo(DC, aX, aY);
  LineTo(DC, aX-DiagR, aY+DiagR);

  SetRop2(DC, PomRop2);
  SelectObject(DC, OldPen);
  DeleteObject(PomPen);
  ReleaseDC(ZobrOkno^.HWindow, DC);
end;


procedure TSnimacIdBodu.Chyt(var Bod: TSour);
var
  PomPoint: TPoint;
  CChytLinie: longInt;
  ChytBlok  : TBlokPredekPtr;
  PomSour: {$IFDEF ZSour} TSour3 {$ELSE}TSour {$ENDIF};

begin
  if Chytat and not ((GetKeyState(VK_SHIFT) = -128) or (GetKeyState(VK_SHIFT) = -127)) then
  begin
    DrawObject;
    PSour(@PomSour)^ := Bod;
    if ChytSouradnici(PomSour) then
    begin
      Bod := PSour(@PomSour)^;
      with PZobrazOkno(ZobrOkno)^ do
      begin
        SourNaObrBod(Bod, PomPoint);
      end;
      ClientToScreen(ZobrOkno^.HWindow, PomPoint);
      SetCursorPos(PomPoint.X, PomPoint.Y);
      KresliPaprsky(PomPoint.X, PomPoint.Y);
      MessageBeep(mb_IconExclamation);
      MessageBeep(mb_IconInformation);
      MessageBeep(mb_IconExclamation);
      KresliPaprsky(PomPoint.X, PomPoint.Y);
    end;
    DrawObject;
  end;
end;


procedure TSnimacIdBodu.ZobrazTransfTabulku;
begin
  if Opravovat then
  begin
    Cilove       := PuvCilove;
    PorCisloIdB  := PuvPorCisloIdB;
    StrCopy(Poznamka, OldPoznamka);

    if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
      CisIdBProVypis := PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^.cCislo
    else
      CisIdBProVypis := PorCisloIdB;

    Opravovat    := false;
  end;
  Opusteni;
end;

procedure TSnimacIdBodu.ZadejPoznamku;
type
  TData = record
    Cis: TPoznamka;
    Pozn: TPoznamka;
  end;

const
  id_E  = 1002;
  id_S  = 1001;

var
  Data: TData;
  Dlg: PHelpDialog;
  Ed: PEdit;
  St: PStatic;
  Retezec1: array[0..10] of char;

begin
  with Data do
  begin
    StrPCopy(Cis, LStr(CisIdBProVypis));
    StrCopy(Pozn, Poznamka);
  end;

  strPCopy(Retezec1, 'Poznamka');
  Dlg := New(PHelpDialog, Init(Application^.MainWindow, Retezec1, cm_Poznamka));

  New(St, InitResource(Dlg, id_S, 13));
  New(Ed, InitResource(Dlg, id_E, 13));

  Dlg^.TransferBuffer := @Data;
  if Application^.ExecDialog(Dlg) <> idCancel then
    if Opravovat then
      with PIdBod(BodColl^.At(CisAktIdBodu))^ do
        VlozPoznamku(Data.Pozn)
    else
      StrCopy(Poznamka, Data.Pozn);
end;

procedure TSnimacIdBodu.ZadejVahu;
type
  TData = record
    Cis: TPoznamka;
    Pozn: TPoznamka;
  end;

const
  id_E  = 1002;
  id_S  = 1001;

var
  Data: TData;
  Temp: real;
  ErrorPos: integer;
  Dlg: PHelpDialog;
  Ed: PEdit;
  St: PStatic;
  EscDone, OK: boolean;
  Retezec1: array[0..80] of char;

begin
  with Data do
  begin
    StrPCopy(Cis, LStr(CisIdBProVypis));
    StrPCopy(Pozn, RStrSp(Vaha, 6, 4));
  end;
  repeat
    EscDone := true;
    OK      := false;

    strPCopy(Retezec1, 'Vaha');
    Dlg := New(PHelpDialog, Init(Application^.MainWindow, Retezec1, cm_Vaha));
    New(St, InitResource(Dlg, id_S, 13));
    New(Ed, InitResource(Dlg, id_E, 13));
    Dlg^.TransferBuffer := @Data;
    if Application^.ExecDialog(Dlg) <> idCancel then
    begin
      EscDone := false;
      Val(StrPas(Data.Pozn), Temp, ErrorPos);
      if ErrorPos <> 0 then
      begin
        LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
        Hlaska(StrPas(Retezec1));
        {Nekorektni vstup !}
      end else
      begin
        OK := true;
        if Opravovat then
          with PIdBod(BodColl^.At(CisAktIdBodu))^ do
            VlozVahu(Temp)
        else
          Vaha := Temp;
      end;
    end;
  until EscDone or OK;
end;

procedure TSnimacIdBodu.ZadejSourCiselne;
var
  PomStrC, aTitle: array[0..40] of char;
  TempX, TempY, TempZ: extended;
  Pozice, BodL: TPoint;
  BodS: TSour;

begin
  if Cilove then
  begin
    with PZobrazOkno(ZobrOkno)^ do
    begin
      GetCursorPos(Pozice);
      ScreenToClient(HWindow, Pozice);

      ObrBodNaSour(Pozice, BodS);
      TempY := BodS.Y;
      TempX := BodS.X;

      LoadString(HInstance, 201, PomStrC, 40);
      {Cil. sour. pro}
      StrPCopy(aTitle, DejDoplSPZPrava(StrPas(PomStrC), 16));
      if Obdelnik and (PorCisloIdB <= CilBodColl^.Count) then
        StrCat(aTitle, Poznamka)
      else
      begin
        StrPCopy(PomStrC, LStr(CisIdBProVypis));
        StrCat(aTitle, PomStrC);
        LoadString(HInstance, 202, PomStrC, 40);
        {'. id.bod'}
        StrCat(aTitle, PomStrC)
      end;

      if Opravovat then
        with PIdBod(BodColl^.At(CisAktIdBodu))^ do
          TempZ := zZ
        else
          if (CilBodColl <> nil) and (PorCisloIdB <= CilBodColl^.Count) then
            with PCilIdBod(CilBodColl^.At(pred(PorCisloIdB)))^ do
              TempZ := ccZ
          else
            TempZ := 0;

      if VratSouradniceCiselne(TempX, TempY, TempZ, Dimenze, aTitle) then
      begin
        if Opravovat then
          with PIdBod(BodColl^.At(CisAktIdBodu))^ do
          begin
            BodS.X := TempX;
            BodS.Y := TempY;
            SourNaObrBod(BodS, BodL);
            by := BodL.Y;
            bx := BodL.X;
            if Rastr then
            begin
              case SourSystem of
                JTSK,
                Gauss      : VlozCilSour(BodS.X, BodS.Y, TempZ);
                Matematicky: VlozCilSour(BodS.Y, BodS.X, TempZ);
              end;
            end
            else
              VlozCilSour(BodS.X, BodS.Y, TempZ);
            VlozTypIdBodu(Transformacni);
          end
        else
        begin
          BodS.X := TempX;
          BodS.Y := TempY;
          acx    := TempX;
          acy    := TempY;
          SourNaObrBod(BodS, BodL);
          by := BodL.Y;
          bx := BodL.X;
        end;
        if Rastr then
          NastavKurzor(false);
        NoveOkno := false;
        Cilove   := false;
        ZakresliNovyBodCSoustavy;
        SendMessage(ZobrOkno^.Parent^.HWindow, wm_ZapisInformPlochy, 0, 0);
      end;
    end;
  end;
end;

procedure TSnimacIdBodu.Ukonci;
begin
  Dispose(BodColl, Done);
  if CilBodColl <> nil then
    Dispose(CilBodColl, Done);
  if Transformace <> nil then
    TransformaceDone(Transformace);
  Transformace := nil;
  Deselect;
end;


procedure TSnimacIdBodu.SipkaNahoru;
var
  Pom: longint;
  Plocha: TRect;
  PolohaCursoru: TPoint;

begin
  GetCursorPos(PolohaCursoru);
  GetClientRect(ZobrOkno^.HWindow, Plocha);
  ScreenToClient(ZobrOkno^.HWindow, PolohaCursoru);
  if PtInRect(Plocha, PolohaCursoru) then
    if PolohaCursoru.Y > Plocha.top then
      with PolohaCursoru do
      begin
        Dec(Y);
        MouseMove(X, Y);
        ClientToScreen(ZobrOkno^.HWindow, PolohaCursoru);
        SetCursorPos(X, Y);
      end
    else
      with PWindow(ZobrOkno)^.Scroller^ do
        if YPos > 0 then
        begin
          ScrollTo(XPos, YPos - 1);
          with PZobrazOkno(ZobrOkno)^ do
            MouseMove(bX, Plocha.top);
        end;
end;


procedure TSnimacIdBodu.SipkaDolu;
var
  Plocha: TRect;
  PolohaCursoru: TPoint;

begin
  GetCursorPos(PolohaCursoru);
  GetClientRect(ZobrOkno^.HWindow, Plocha);
  ScreenToClient(ZobrOkno^.HWindow, PolohaCursoru);
  if PtInRect(Plocha, PolohaCursoru) then
    if PolohaCursoru.Y < (Plocha.bottom - 1) then
      with PolohaCursoru do
      begin
        Inc(Y);
        MouseMove(X, Y);
        ClientToScreen(ZobrOkno^.HWindow, PolohaCursoru);
        SetCursorPos(X, Y);
      end
    else
      with PWindow(ZobrOkno)^.Scroller^ do
        if YPos < YRange then
        begin
          ScrollTo(XPos, YPos + 1);
          with PZobrazOkno(ZobrOkno)^ do
            MouseMove(bX, Plocha.bottom);
        end;
end;

procedure TSnimacIdBodu.SipkaVlevo;
var
  Plocha: TRect;
  PolohaCursoru: TPoint;

begin
  GetCursorPos(PolohaCursoru);
  GetClientRect(ZobrOkno^.HWindow, Plocha);
  ScreenToClient(ZobrOkno^.HWindow, PolohaCursoru);
  if PtInRect(Plocha, PolohaCursoru) then
    if PolohaCursoru.X > Plocha.left then
      with PolohaCursoru do
      begin
        Dec(X);
        MouseMove(X, Y);
        ClientToScreen(ZobrOkno^.HWindow, PolohaCursoru);
        SetCursorPos(X, Y);
      end
    else
      with PWindow(ZobrOkno)^.Scroller^ do
        if XPos > 0 then
        begin
          ScrollTo(XPos - 1, YPos);
          with PZobrazOkno(ZobrOkno)^ do
            MouseMove(Plocha.left, bY);
        end;
end;

procedure TSnimacIdBodu.SipkaVpravo;
var
  Plocha: TRect;
  PolohaCursoru: TPoint;

begin
  GetCursorPos(PolohaCursoru);
  GetClientRect(ZobrOkno^.HWindow, Plocha);
  ScreenToClient(ZobrOkno^.HWindow, PolohaCursoru);
  if PtInRect(Plocha, PolohaCursoru) then
    if PolohaCursoru.X < (Plocha.right - 1) then
      with PolohaCursoru do
      begin
        Inc(X);
        MouseMove(X, Y);
        ClientToScreen(ZobrOkno^.HWindow, PolohaCursoru);
        SetCursorPos(X, Y);
      end
    else
      with PWindow(ZobrOkno)^.Scroller^ do
      if XPos < XRange then
        begin
          ScrollTo(XPos + 1, YPos);
          with PZobrazOkno(ZobrOkno)^ do
          MouseMove(Plocha.right, bY);
        end;
end;

procedure TSnimacIdBodu.NoveAktivniOkno(
                                            Okno: PWindowsObject;
                                        var Msg : TMessage);

var
  DC: HDC;

begin
  if State^.Tool = @Self then
  begin
    ZobrOkno := Okno;
    if not IsIconic(Okno^.HWindow) then
    begin
      DC := GetDC(Okno^.HWindow);

      BodColl^.KresliCilSourCol(DC, ZobrOkno);
      BodColl^.KresliZdrSourCol(DC, ZobrOkno);
      if Msg.wParam = 2 then
      begin
        if Cilove or not Rastr then
          NastavKurzor(false);
        NoveOkno := True;
        if Cilove or not Rastr then
          NastavKurzor(true);
      end;

      ReleaseDC(Okno^.HWindow, DC);
    end;

    if State^.OldTool <> nil then
    begin
      State^.OldTool^.NoveAktivniOkno(Okno, Msg);
      if State^.OldOldTool <> nil then
      begin
        State^.OldOldTool^.NoveAktivniOkno(Okno, Msg);
        if State^.OldOldOldTool <> nil then
          State^.OldOldOldTool^.NoveAktivniOkno(Okno, Msg);
      end;
    end;
  end
  else
    ZobrOkno := Okno;
end;


procedure TSnimacIdBodu.PaintChildren(
                                      Okno       : PWindowsObject;
                                      AktivniOkno: Boolean;
                                      PPaintInfo : PPaintStruct);
var
  Sour: TSour;
  Bod: TPoint;
  PaintInfo: TPaintStruct;
  PomOrg: longint;

begin
  if not IsIconic(Okno^.HWindow) then
  begin
    KeepPaintWindow(ZobrOkno);

    PaintInfo := PPaintInfo^;
    PomOrg    := SetViewPortOrg(PaintInfo.hDC, 0, 0);

    BodColl^.KresliCilSourCol(PaintInfo.hDC, Okno);
    BodColl^.KresliZdrSourCol(PaintInfo.hDC, Okno);

    if not Cilove then
    begin
      Sour.Y := aCY;
      Sour.X := aCX;

      with PZobrazOkno(Okno)^ do
        SourNaObrBodPaint(Sour, Bod);

      KresliBodZnackou(PaintInfo.hDC, Bod.X, Bod.Y, 6, 1, RGB($00, $00, $00));
    end;

{$R-}
    SetViewPortOrg(PaintInfo.hDC, LoWord(PomOrg), HiWord(PomOrg));
{$R+}
  end;
end;


procedure TSnimacIdBodu.ZakresliNovyStav;

  procedure Zobraz(Okno: PWindowsObject); far;
  var
    DC: HDC;

  begin
    if TypeOf(Okno^) = TypeOf(TZobrazOkno) then
      if not IsIconic(Okno^.HWindow) then
      begin
        DC := GetDC(Okno^.HWindow);

        BodColl^.KresliCilSourCol(DC, Okno);
        BodColl^.KresliZdrSourCol(DC, Okno);

        ReleaseDC(Okno^.HWindow, DC);
      end;
  end;

begin
  PZaklOkno(ZobrOkno^.Parent)^.ForEach(@Zobraz);
end;


procedure TSnimacIdBodu.ZakresliStavBMP;

  procedure Zobraz(Okno: PWindowsObject); far;

  begin
    if TypeOf(Okno^) = TypeOf(TZobrazOkno) then
      if not IsIconic(Okno^.HWindow) then
        with PZobrazOkno(Okno)^ do
        begin
          MemoryDC := CreateMemoryDC;
          PomBmp   := SelectObject(MemoryDC, BitMap);

          BodColl^.KresliCilSourBMPCol(MemoryDC, Okno);
          BodColl^.KresliZdrSourBMPCol(MemoryDC, Okno);

          SelectObject(MemoryDC, PomBmp);
          DeleteDC(MemoryDC);
          MemoryDC := 0;
        end;
  end;

begin
  PZaklOkno(ZobrOkno^.Parent)^.ForEach(@Zobraz);
end;


procedure TSnimacIdBodu.ZakresliNovyBodCSoustavy;

  procedure Zobraz(Okno: PWindowsObject); far;
  var
    Sour: TSour;
    Bod: TPoint;
    DC: HDC;

  begin
    if TypeOf(Okno^) = TypeOf(TZobrazOkno) then
      if not IsIconic(Okno^.HWindow) then
      begin
        if Opravovat then
          with PIdBod(BodColl^.At(CisAktIdBodu))^, Sour do
          begin
            if Rastr then
            begin
              case SourSystem of
                JTSK,
                Gauss      : begin
                               X := cX;
                               Y := cY;
                             end;
                Matematicky: begin
                               X := cY;
                               Y := cX;
                             end;
              end;
            end else
            begin
              X := cX;
              Y := cY;
            end;
          end
        else
        begin
          Sour.Y := aCY;
          Sour.X := aCX;
        end;

        with PZobrazOkno(Okno)^ do
          SourNaObrBod(Sour, Bod);

        DC := GetDC(Okno^.HWindow);
        KresliBodZnackou(DC, Bod.X, Bod.Y, 6, 1, RGB($00, $00, $00));
        ReleaseDC(Okno^.HWindow, DC);
      end;
  end;

begin
  PZaklOkno(ZobrOkno^.Parent)^.ForEach(@Zobraz);
end;



procedure TSnimacIdBodu.DrawObject;
var
  OldPen, Pen: HPen;
  OldBrush: HBrush;
  OldROP2: integer;
  DC: HDC;

begin
  KeepPaintAll;

  if Vykreslit and JeVOkne and not IsIconic(ZobrOkno^.HWindow) and (TabletPtr <> nil) then
  begin
    DC       := GetDC(ZobrOkno^.HWindow);
    Pen      := CreatePen(ps_Solid, 1, DejSkutBarvu(BarvaPevnehoNastroje));
    OldPen   := SelectObject(DC, Pen);
    OldBrush := SelectObject(DC, GetStockObject(Null_Brush));
    OldROP2  := SetROP2(DC, r2_NotXorPen);

    moveTo(DC, KurzX-10, KurzY   );
    lineTo(DC, KurzX+11, KurzY   );
    moveTo(DC, KurzX   , KurzY-10);
    lineTo(DC, KurzX   , KurzY+11);

    SelectObject(DC, OldPen);
    DeleteObject(Pen);
    SelectObject(DC, OldBrush);
    SetROP2(DC, OldROP2);
    ReleaseDC(ZobrOkno^.HWindow, DC);
  end
  else
    if not Vykreslit and JeVOkne then
      Vykreslit := true;
end;


end.
