unit TrojSit;
{$R-}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses Objects,
     MatProc, TranType,
     TrTab;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

type
  PStrana = ^TStrana;
  TStrana = record
              ZB, KB, RZ: integer;
            end;

  PStranaCollection = ^TStranaCollection;
  TStranaCollection = object(TCollection)

    procedure FreeItem(Item: Pointer); virtual;

  end;

  PTrojuhelnik = ^TTrojuhelnik;
  TTrojuhelnik = record
                   V1, V2, V3: integer;
                 end;

  PTrojuhelnikCollection = ^TTrojuhelnikCollection;
  TTrojuhelnikCollection = object(TCollection)

    procedure FreeItem(Item: Pointer); virtual;

  end;

  PVektTrojuhelnik = ^TVektTrojuhelnik;
  TVektTrojuhelnik = record
                   V1, V2, V3: TSour;
                   OpsObdelnik: TObdelnik;
                   Klic: array[1..9] of extended;
                   ZdrojStred, CilStred: TranType.Bod;
                 end;

  PTrojuhelnikVektCollection = ^TTrojuhelnikVektCollection;
  TTrojuhelnikVektCollection = object(TCollection)

    procedure FreeItem(Item: Pointer); virtual;

  end;


  PGeneratorTrSite = ^TGeneratorTrSite;
  TGeneratorTrSite = object

    SeznamBodu: PIdBodCollection;

    SeznamStran: PStranaCollection;

    SeznamTrojuhelniku: PTrojuhelnikCollection;

    PocetBodu,
    PocObvStran, PocetVsechStran,
    PocTrojuhelniku: integer;

    Vektor: boolean;

    constructor Init(TransfPtr: pointer; AVektor: boolean);

    function    ZadejPredurceneStrany: boolean;
    procedure   NajdiOptimalniVrchol(var Vrchol  : PIdBod; Strana12: PStrana);
    procedure   Generuj;

    destructor  Done;
  end;


function Smernik(B1x, B1y, B2x, B2y: double; var Identicke: boolean): double;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses WinTypes, WinProcs, Messages,
     Hlasky,
     BlokType,
     RasOpDLL,
     RAsMNDll,
     Pokus, OrezLin;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


function Smernik(B1x, B1y, B2x, B2y: double; var Identicke: boolean): double;
var
  Pom: double;

begin
  Identicke := false;
  if abs(B2y - B1y) > 1E-10 then
  begin
    if B2y < B1y then
      Smernik := 180 + 180/Pi * (arcTan((B2x - B1x)/(B2y - B1y)))
    else
      if B2x < B1x then
        Smernik := 360 + 180/Pi * (arcTan((B2x - B1x)/(B2y - B1y)))
      else
        Smernik :=       180/Pi * (arcTan((B2x - B1x)/(B2y - B1y)));
  end else
  begin
    pom := B2x - B1x;
    if pom < -1E-10 then
      Smernik := 270
    else
      if pom > 1E-10 then
        Smernik := 90
      else
      begin
        Identicke := true;
        Smernik   := 0;
      end;
  end;
end;


function Vzdalenost(B1x, B1y, B2x, B2y: double): double;
begin
  Vzdalenost := sqrt(sqr(B2y - B1y) + sqr(B2x - B1x));
end;



procedure TStranaCollection.FreeItem(Item: Pointer);
begin
  freeMem(Item, sizeOf(TStrana));
end;


procedure TTrojuhelnikCollection.FreeItem(Item: Pointer);
begin
  freeMem(Item, sizeOf(TTrojuhelnik));
end;


procedure TTrojuhelnikVektCollection.FreeItem(Item: Pointer);
begin
  freeMem(Item, sizeOf(TVektTrojuhelnik));
end;





{**************************************************************************
  Generovani site se provede v oblasti, urcene obvodovym polygonem,
  ktery sestava z vybranych bodu definicniho souboru.
  Sit muze obsahovat tzv. predurcene strany, ktere umoznuji konfigurovat
  sit s ohledem na zname udaje.
**************************************************************************}





constructor TGeneratorTrSite.Init(
                                  TransfPtr: pointer;
                                  AVektor  : boolean);
var
  i, j, k, PocetIdBodu: integer;
  Bod: PIdBod;
  Stejny: boolean;
  PomKurzor: HCursor;
  ZdrojStred, CilStred, Sta, Nov: TranType.Bod;

begin
  PomKurzor := SetCursor(LoadCursor(0, idc_Wait));

  Vektor := AVektor;
  New(SeznamBodu, Init(1, 1));

  TransformaceDejZdrojStred(TransfPtr, ZdrojStred);
  TransformaceDejCilStred(TransfPtr, CilStred);

  PocetIdBodu := TransformaceDejPocetIdB(TransfPtr);

  i := 1;
  while i <= PocetIdBodu do
  begin
    Stejny := false;
    TransformaceDejNov(TransfPtr, i, Nov);
    TransformaceDejSta(TransfPtr, i, Sta);

    for j := 1 to pred(i) do
    begin
      TransformaceDejNov(TransfPtr, i, Nov);
      TransformaceDejSta(TransfPtr, i, Sta);

      with SeznamBodu^ do
        if ((abs(PIdBod(At(pred(j)))^.zY - (ZdrojStred.X + Sta.X)) < 2.5) and
            (abs(PIdBod(At(pred(j)))^.zX - (ZdrojStred.Y + Sta.Y)) < 2.5)) or
           ((abs(PIdBod(At(pred(j)))^.cX - (CilStred.X   + Nov.X)) < 1.0) and
            (abs(PIdBod(At(pred(j)))^.cY - (CilStred.Y   + Nov.Y)) < 1.0)) then
        begin
          dec(PocetIdBodu);
          for k := i to PocetIdBodu do
          begin
            TransformaceZmenNov(TransfPtr, k, succ(k));
            TransformaceZmenSta(TransfPtr, k, succ(k));
          end;
          Stejny:= true;
        end;
    end;

    if not Stejny then
    begin
      New(Bod, Init(i, true));
      with Bod^ do
      begin
        TypIdBodu := Transformacni;
        zY        := ZdrojStred.X + Sta.X;
        zX        := ZdrojStred.Y + Sta.Y;
        cX        := CilStred.X   + Nov.X;
        cY        := CilStred.Y   + Nov.Y;
      end;
      SeznamBodu^.Insert(Bod);
      inc(i);
    end;
  end;

  TransformaceNastavPocetIdBodu(TransfPtr, SeznamBodu^.Count);
  PocetBodu := SeznamBodu^.Count;
  SeznamTrojuhelniku := nil;

  SetCursor(PomKurzor);
end;


const
  Polygon: TLomBodPtr = nil;
  Konec  : boolean    = false;


procedure VyberOhraniceni(var Parametr);
begin
  Polygon := TLomBodPtr(Parametr);
  Konec   := true;
end;

function TGeneratorTrSite.ZadejPredurceneStrany: boolean;
const
  eps = 5;
  delta = 0.005;

var
  PrvniBod, DalsiBod: PIdBod;
  PomStrana, Strana: PStrana;
  min1, min2: double;
  PomNasel, Nasel: boolean;
  BC1, i, j, k: integer;
  A, B: TSour;
  PLomPtr: TLomBodPtr;
  Konkavni, Identicke: boolean;
  VybPolygon: POrezLinie;
  aProcedura: TProcedura;
  M: TMsg;
  PomKurzor: HCursor;

  procedure NajdiNejmensi(Bod: PIdBod); far;
  begin
    if Bod^.zX < min1 then
    begin
      PrvniBod := Bod;
      min1     := Bod^.zX;
    end;
  end;

  procedure NajdiVlevoDolu(Bod: PIdBod); far;
  var
    pom1, pom2: double;

  begin
    if Bod^.Cislo <> PrvniBod^.Cislo then
    begin
      pom1 := Smernik(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX, Identicke);
      if not Identicke then
      begin
        pom2 := Vzdalenost(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX);
        if ((pom1 > min1) and (pom1 <= 90)) or ((pom1 = min1) and (pom2 < min2)) then
        begin
          Nasel    := true;
          DalsiBod := Bod;
          min1     := pom1;
          min2     := pom2;
        end;
      end;
    end;
  end;


  procedure NajdiVpravoDolu(Bod: PIdBod); far;
  var
    pom1, pom2: double;

  begin
    if Bod^.Cislo <> PrvniBod^.Cislo then
    begin
      pom1 := Smernik(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX, Identicke);
      if not Identicke then
      begin
        pom2 := Vzdalenost(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX);
        if ((pom1 > min1) and (pom1 >= 270)) or ((pom1 = min1) and (pom2 < min2)) then
        begin
          Nasel    := true;
          DalsiBod := Bod;
          min1     := pom1;
          min2     := pom2;
        end;
      end;
    end;
  end;


  procedure NajdiNahoruVpravo(Bod: PIdBod); far;
  var
    pom1, pom2: double;

  begin
    if Bod^.Cislo <> PrvniBod^.Cislo then
    begin
      pom1 := Smernik(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX, Identicke);
      if not Identicke then
      begin
        pom2 := Vzdalenost(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX);
        if ((pom1 > min1) and (pom1 >= 180)) or ((pom1 = min1) and (pom2 < min2)) then
        begin
          Nasel    := true;
          DalsiBod := Bod;
          min1     := pom1;
          min2     := pom2;
        end;
      end;
    end;
  end;

  procedure NajdiNahoruVlevo(Bod: PIdBod); far;
  var
    pom1, pom2: double;

  begin
    if Bod^.Cislo <> PrvniBod^.Cislo then
    begin
      pom1 := Smernik(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX, Identicke);
      if not Identicke then
      begin
        pom2 := Vzdalenost(PrvniBod^.zY, PrvniBod^.zX, Bod^.zY, Bod^.zX);
        if ((pom1 > min1) and (pom1 >= 90) and (pom1 < 180)) or ((pom1 = min1) and (pom2 < min2)) then
        begin
          Nasel    := true;
          DalsiBod := Bod;
          min1     := pom1;
          min2     := pom2;
        end;
      end;
    end;
  end;

  procedure Zarovnani;
  var
    Bod, PataKolmice: TSour;
    PataKolmiceJeUvnitrUsecky: boolean;
    VzdalenostBoduOdPrimky: real;
    PomCB: integer;

  begin
    Bod.Y := PrvniBod^.zY;
    Bod.X := PrvniBod^.zX;
    DejVztahyBod_Usecka(Bod, A, B, PataKolmiceJeUvnitrUsecky,
                        PataKolmice, VzdalenostBoduOdPrimky);

    if PataKolmiceJeUvnitrUsecky and (VzdalenostBoduOdPrimky < eps) then
    begin
      Nasel      := true;
      PomCB      := Strana^.KB;
      Strana^.KB := PrvniBod^.Cislo;
      getMem(Strana, sizeOf(TStrana));
      Strana^.ZB := PrvniBod^.Cislo;
      Strana^.KB := PomCB;
      Strana^.RZ := 1;
      if succ(i) = SeznamStran^.Count then
        SeznamStran^.Insert(Strana)
      else
        SeznamStran^.AtInsert(succ(i), Strana);
    end;
  end;

begin
{**************************************************************************
     Naplneni seznamu predurcenych stran
     Nejdrive jsou v seznamu ulozeny strany obvodoveho polygonu.
     Orientace techto stran musi byt "levostrana", tj. takova, aby oblast
     polygonem vymezena lezela vzdy na po leve strane kazde teto strany.
     (Znamena to tedy proti smeru hodinovych rucicek).

     Generovane strany se zapisuji do seznamu jako jeho volne pokracovani.
***************************************************************************}
  ZadejPredurceneStrany := false;

  New(SeznamStran, Init(1, 1));

  if Vektor then
    Konkavni := true
  else
    Konkavni := Souhlas('Vytvoit konkvn s');

  if Konkavni then
  begin
    PomKurzor := SetCursor(LoadCursor(0, idc_Wait));

    min1 := 1E10;
    SeznamBodu^.ForEach(@NajdiNejmensi);
    getMem(Strana, sizeOf(TStrana));
    Strana^.ZB := PrvniBod^.Cislo;
    BC1        := PrvniBod^.Cislo;

    repeat
      Nasel := false;
      min1  := -1;
      SeznamBodu^.ForEach(@NajdiVlevoDolu);
      if Nasel then
      begin
        Strana^.KB := DalsiBod^.Cislo;
        Strana^.RZ := 1;
        SeznamStran^.Insert(Strana);
        getMem(Strana, sizeOf(TStrana));
        Strana^.ZB := DalsiBod^.Cislo;
        PrvniBod   := DalsiBod;
      end;
    until not Nasel;

    repeat
      Nasel := false;
      min1  := -1;
      SeznamBodu^.ForEach(@NajdiVpravoDolu);
      if Nasel then
      begin
        Strana^.KB := DalsiBod^.Cislo;
        Strana^.RZ := 1;
        SeznamStran^.Insert(Strana);
        getMem(Strana, sizeOf(TStrana));
        Strana^.ZB := DalsiBod^.Cislo;
        PrvniBod   := DalsiBod;
      end;
    until not Nasel;

    repeat
      Nasel := false;
      min1  := -1;
      SeznamBodu^.ForEach(@NajdiNahoruVpravo);
      if Nasel then
      begin
        Strana^.KB := DalsiBod^.Cislo;
        Strana^.RZ := 1;
        SeznamStran^.Insert(Strana);
        if DalsiBod^.Cislo <> BC1 then
        begin
          getMem(Strana, sizeOf(TStrana));
          Strana^.ZB := DalsiBod^.Cislo;
          PrvniBod   := DalsiBod;
        end
        else
          Nasel := false;
      end;
    until not Nasel;

    if DalsiBod^.Cislo <> BC1 then
      repeat
        Nasel := false;
        min1  := -1;
        SeznamBodu^.ForEach(@NajdiNahoruVlevo);
        if Nasel then
        begin
          Strana^.KB := DalsiBod^.Cislo;
          Strana^.RZ := 1;
          SeznamStran^.Insert(Strana);
          if DalsiBod^.Cislo <> BC1 then
          begin
            getMem(Strana, sizeOf(TStrana));
            Strana^.ZB := DalsiBod^.Cislo;
            PrvniBod   := DalsiBod;
          end
          else
            Nasel := false;
        end;
      until not Nasel;

    repeat
      Nasel := false;
      i := 0;
      repeat
        Strana := SeznamStran^.At(i);
        A.Y := TIdBod((SeznamBodu^.At(pred(Strana^.ZB)))^).zY;
        A.X := TIdBod((SeznamBodu^.At(pred(Strana^.ZB)))^).zX;
        B.Y := TIdBod((SeznamBodu^.At(pred(Strana^.KB)))^).zY;
        B.X := TIdBod((SeznamBodu^.At(pred(Strana^.KB)))^).zX;
        j := 0;
        repeat
          if (succ(j) <> Strana^.ZB) and (succ(j) <> Strana^.KB) then
          begin
            PrvniBod := SeznamBodu^.At(j);
            k := 0;
            PomNasel := false;
            repeat
              PomStrana := SeznamStran^.At(k);
              if ((PomStrana^.ZB = PrvniBod^.Cislo) and ((PomStrana^.KB <> Strana^.ZB) or (PomStrana^.KB <> Strana^.KB)))
                 or
                 ((PomStrana^.KB = PrvniBod^.Cislo) and ((PomStrana^.ZB <> Strana^.ZB) or (PomStrana^.ZB <> Strana^.KB))) then
                PomNasel := true;
              inc(k);
            until PomNasel or (k = SeznamStran^.Count);
            if not PomNasel then
              Zarovnani;
          end;
          inc(j);
        until Nasel or (j = SeznamBodu^.Count);
        inc(i);
      until Nasel or (i = SeznamStran^.Count);
    until not Nasel;

    ZadejPredurceneStrany := true;

    SetCursor(PomKurzor);
  end else
  begin
    aProcedura := VyberOhraniceni;
    VybPolygon := New(POrezLinie, Init(State, true, aProcedura, SeznamBodu));
    VybPolygon^.Select;

    repeat
      while PeekMessage(M,0,wm_Paint,wm_Paint,pm_Remove) do
      begin
        TranslateMessage(M);
        DispatchMessage(M);
      end;
    until Konec;

    if Konec and (Polygon <> nil) then
    begin
      PomKurzor := SetCursor(LoadCursor(0, idc_Wait));

      ZadejPredurceneStrany := true;
      PLomPtr := Polygon;
{      with SpravceRastru^.AktRastr^ do}
        while PLomPtr <> nil do
        begin
          case SourSystem of
            JTSK       : PlomPtr^.Sour.Y := RAstObjGetCols(SRGetAktRastr) - PlomPtr^.Sour.Y + 1;
            Gauss,
            Matematicky: PlomPtr^.Sour.X := RAstObjGetRows(SRGetAktRastr) - PlomPtr^.Sour.X + 1;
          end;

          PLomPtr         := PLomPtr^.Dalsi
        end;

      PLomPtr:= Polygon;
      while PLomPtr^.Dalsi <> nil do
      begin
        i     := 0;
        Nasel := false;
        repeat
          PrvniBod := SeznamBodu^.At(i);
          if (abs(PlomPtr^.Dalsi^.Sour.Y - PrvniBod^.zY) < delta)
              and
             (abs(PlomPtr^.Dalsi^.Sour.X - PrvniBod^.zX) < delta) then
            Nasel := true;
          inc(i);
        until Nasel;
        if Nasel then
        begin
          i     := 0;
          Nasel := false;
          repeat
            DalsiBod := SeznamBodu^.At(i);
            if (abs(PlomPtr^.Sour.Y - DalsiBod^.zY) < delta)
                and
               (abs(PlomPtr^.Sour.X - DalsiBod^.zX) < delta) then
              Nasel := true;
            inc(i);
          until Nasel;
          if Nasel then
          begin
            getMem(Strana, sizeOf(TStrana));
            if Strana <> nil then
            begin
              Strana^.ZB := PrvniBod^.Cislo;
              Strana^.KB := DalsiBod^.Cislo;
              Strana^.RZ := 1;
              SeznamStran^.Insert(Strana)
            end;
          end;
        end;
        PLomPtr:= PLomPtr^.Dalsi
      end;


      while Polygon <> nil do
      begin
        PLomPtr := Polygon^.Dalsi;
        Dispose(Polygon);
        Polygon := PLomPtr;
      end;

      SetCursor(PomKurzor);
    end;

    Polygon := nil;
    Konec   :=  false;
  end;
end;


procedure TGeneratorTrSite.NajdiOptimalniVrchol(
                                                var Vrchol  : PIdBod;
                                                    Strana12: PStrana);
var
  Vrchol1, Vrchol2: PIdBod;
  Smernik12, MaxVrchUhel: double;
  Identicke: boolean;

  procedure NajdiVrcholVlevoSMaxVrchUhlemNeprotinajiciStranu(Bod: PIdBod);  far;
  var
    Smernik13, Smernik31, Smernik32, VrchUhel: double;
    Prunik: boolean;
    i: integer;

    function PrunikStrany13(
                            Strana: PStrana): boolean;
    var
      BodA1, BodA2, BodB1, BodB2: PIdBod;

    begin
      if (Strana12^.ZB <> Strana^.ZB) and (Strana12^.ZB <> Strana^.KB) and
         (Bod^.Cislo   <> Strana^.ZB) and (Bod^.Cislo   <> Strana^.KB) then
      begin
        BodA1 := SeznamBodu^.At(pred(Strana12^.ZB));
        BodB1 := SeznamBodu^.At(pred(Bod^.Cislo));
        BodA2 := SeznamBodu^.At(pred(Strana^.ZB));
        BodB2 := SeznamBodu^.At(pred(Strana^.KB));
        if ProtnutyUsecky(BodA1^.zY, BodA1^.zX,   BodB1^.zY, BodB1^.zX,
                          BodA2^.zY, BodA2^.zX,   BodB2^.zY, BodB2^.zX) then
          PrunikStrany13 := true
        else
          PrunikStrany13 := false;
      end
      else
        PrunikStrany13 := false;
    end;

    function PrunikStrany32(
                             Strana: PStrana): boolean;
    var
      BodA1, BodA2, BodB1, BodB2: PIdBod;

    begin
      if (Strana12^.KB <> Strana^.ZB) and (Strana12^.KB <> Strana^.KB) and
         (Bod^.Cislo   <> Strana^.ZB) and (Bod^.Cislo   <> Strana^.KB) then
      begin
        BodA1 := SeznamBodu^.At(pred(Bod^.Cislo));
        BodB1 := SeznamBodu^.At(pred(Strana12^.KB));
        BodA2 := SeznamBodu^.At(pred(Strana^.ZB));
        BodB2 := SeznamBodu^.At(pred(Strana^.KB));
        if ProtnutyUsecky(BodA1^.zY, BodA1^.zX,   BodB1^.zY, BodB1^.zX,
                          BodA2^.zY, BodA2^.zX,   BodB2^.zY, BodB2^.zX) then
          PrunikStrany32 := true
        else
          PrunikStrany32 := false;
      end
      else
        PrunikStrany32 := false;
    end;

  begin
    if (Bod^.Cislo <> Vrchol1^.Cislo) and (Bod^.Cislo <> Vrchol2^.Cislo) then
    begin
      Smernik13 := Smernik(Vrchol1^.zY, Vrchol1^.zX, Bod^.zY, Bod^.zX, Identicke);
      if ((Smernik12 < 180 ) and ((Smernik13 < Smernik12) or ((Smernik13 > Smernik12) and (Smernik13 - Smernik12 > 180))))
          or
         ((Smernik12 >= 180) and ((Smernik12 > Smernik13) and (Smernik12 - Smernik13 < 180))) then
      begin
        Smernik32 := Smernik(Bod^.zY, Bod^.zX, Vrchol2^.zY, Vrchol2^.zX, Identicke);

        Smernik31 := Smernik13 - 180;
        if Smernik31 < 0 then
          Smernik31 := Smernik31 + 360;

        VrchUhel := Smernik31 - Smernik32;
        if VrchUhel < 0 then
          VrchUhel := VrchUhel + 360;

        if VrchUhel > MaxVrchUhel then
        begin
          i := 0;
          repeat
            Prunik := PrunikStrany13(SeznamStran^.At(i));
            inc(i);
          until Prunik or (i = SeznamStran^.Count);
          if not Prunik then
          begin
            i := 0;
            repeat
              Prunik := PrunikStrany32(SeznamStran^.At(i));
              inc(i);
            until Prunik or (i = SeznamStran^.Count);
            if not Prunik then
            begin
              MaxVrchUhel := VrchUhel;
              Vrchol      := Bod;
            end;
          end;
        end;
      end;
    end;
  end;


begin
  Vrchol1 := SeznamBodu^.At(pred(Strana12^.ZB));
  Vrchol2 := SeznamBodu^.At(pred(Strana12^.KB));

  Smernik12 := Smernik(Vrchol1^.zY, Vrchol1^.zX, Vrchol2^.zY, Vrchol2^.zX, Identicke);

  MaxVrchUhel := 0;
  Vrchol      := nil;
  SeznamBodu^.ForEach(@NajdiVrcholVlevoSMaxVrchUhlemNeprotinajiciStranu);
end;



procedure TGeneratorTrSite.Generuj;

var
  Strana12, Strana13, Strana32: PStrana;
  Vrchol: PIdBod;
  Trojuhelnik: PTrojuhelnik;
  i, j: integer;
  Nalezena, Nalezena0: boolean;
  PomKurzor: HCursor;

  function NajdiPrvniStranu(Strana: PStrana): boolean;
  begin
    if Strana^.RZ = 1 then
      NajdiPrvniStranu := true
    else
      NajdiPrvniStranu := false;
  end;

  function TestStrany13(Strana: PStrana): boolean;
  begin
    if ((Strana^.ZB = Strana12^.ZB) and (Strana^.KB = Vrchol^.Cislo))
        or
       ((Strana^.KB = Strana12^.ZB) and (Strana^.ZB = Vrchol^.Cislo)) then
      TestStrany13 := true
    else
      TestStrany13 := false;
  end;

  function TestStrany32(Strana: PStrana): boolean;
  begin
    if ((Strana^.KB = Strana12^.KB) and (Strana^.ZB = Vrchol^.Cislo))
        or
       ((Strana^.ZB = Strana12^.KB) and (Strana^.KB = Vrchol^.Cislo)) then
      TestStrany32 := true
    else
      TestStrany32 := false;
  end;


begin
  if ZadejPredurceneStrany then
  begin
    PomKurzor := SetCursor(LoadCursor(0, idc_Wait));

    New(SeznamTrojuhelniku, Init(1, 1));
    i := 0;
    repeat
      repeat
        Nalezena0 := NajdiPrvniStranu(SeznamStran^.At(i));
        inc(i);
      until Nalezena0 or (i = SeznamStran^.Count);
      if Nalezena0 then
      begin
        Strana12 := SeznamStran^.At(pred(i));
        {*********************************************************************
          Generovani trojuhelnika, tj. urceni orintovanych stran s13, s32
          (Urceni jisteho trojuhelnika site se provede k jedne jeho jiz zname
          strane. Touto stranou je bud strana obvodova, nebo strana predurcena,
          nebo strana, ziskana jiz z nektereho vygenerovaneho trojuhelnika.
          Orientovana primka jdouci touto stranou rozdeli horizontalni bazi
          definicniho souboru do dvou polorovin. V polorovine poleve strane
          teto primky se najde treti vrchol trojuhelnika s ohledem na jistou
          limitujici podminku, zarucujici, ze uvnitr trojuhelnika nebude lezet
          zadny bod definicniho souboru. Touto podminkou muze byt minimalni
          obvod trojuhelnika nebo maximalni uhel pri hledanem vrcholu. Pri
          teto podmince jsou vysledky optimalnejsi.
          Test, zda se strana s13 nebo s32 protina s nekterou stranou SeznamStran
         *********************************************************************};
        NajdiOptimalniVrchol(Vrchol, Strana12);


        {*********************************************************************
         Test zda strana s13 nebo s31 neni obsazena v SeznamStran
          ne   k := k + 1;
               SeznamStran^[k]  := s13;
               SeznamRZnaku^[k] := 1;
          ano  obsazuje v SeznamStran polohu m
               SeznamRZnaku^[m] := 0;
        **********************************************************************}
        j := 0;
        repeat
          Nalezena := TestStrany13(SeznamStran^.At(j));
          inc(j);
        until Nalezena or (j = SeznamStran^.Count);
        if Nalezena then
        begin
          Strana13 := SeznamStran^.At(pred(j));
          Strana13^.RZ := 0;
        end else
        begin
          getMem(Strana13, sizeOf(TStrana));
          Strana13^.ZB := Strana12^.ZB;
          Strana13^.KB := Vrchol^.Cislo;
          Strana13^.RZ := 1;
          SeznamStran^.Insert(Strana13);
        end;

        {*********************************************************************
         Test zda strana s23 nebo s32 neni obsazena v SeznamStran
          ne   k := k + 1;
               SeznamStran^[k]  := s32;
               SeznamRZnaku^[k] := 1;
          ano  obsazuje v SeznamStran polohu m
               SeznamRZnaku^[m] := 0;
        **********************************************************************}
        j := 0;
        repeat
          Nalezena := TestStrany32(SeznamStran^.At(j));
          inc(j);
        until Nalezena or (j = SeznamStran^.Count);
        if Nalezena then
        begin
          Strana32 := SeznamStran^.At(pred(j));
          Strana32^.RZ := 0;
        end else
        begin
          getMem(Strana32, sizeOf(TStrana));
          Strana32^.ZB := Vrchol^.Cislo;
          Strana32^.KB := Strana12^.KB;
          Strana32^.RZ := 1;
          SeznamStran^.Insert(Strana32);
        end;

        {*********************************************************************
         Zapis trojuhelnika do seznamu trojuhlniku
         *********************************************************************}
        getMem(Trojuhelnik, sizeOf(TTrojuhelnik));

        Trojuhelnik^.V1 := Strana12^.ZB;
        Trojuhelnik^.V2 := Strana12^.KB;
        Trojuhelnik^.V3 := Vrchol^.Cislo;

        SeznamTrojuhelniku^.Insert(Trojuhelnik);
      end;
    until not Nalezena0 or (i = SeznamStran^.Count);

    SetCursor(PomKurzor);
  end;
end;




destructor TGeneratorTrSite.Done;
begin
  Dispose(SeznamBodu, Done);
  Dispose(SeznamStran, Done);
end;


end.
