{ D-}

unit TabletOb;


{ zakladni objekt pro praci s tabletem }



{&&&&&&&&&&&&&&&&&&&&&&&&&&}  interface  {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses dos, SIOObj;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



type
  TByteBit = record
               Byte, Bit: byte
             end;

  TFiltrByte = record
                 Filtr, CBytu: byte
               end;

  TBinarniSouradnice = record
                         PrvniX, PrvniY, PocetBytuSour, PocetBituSour: byte;
                         NizsiPakVyssi: boolean;
                         Filtr1BytuSouradnice, FiltrPBytuSouradnice: byte;
                         ZnamenkoX, ZnamenkoY: TFiltrByte;
                         Zaporne1: boolean     { zaporne znamenko znaceno 1 }
                       end;

  TTabletPtr = ^TTablet;

  TTablet = object

    Digit: TSIO;
    Xprvni, Xza, Yprvni, Yza: integer;  { umisteni znaku sour.X a Y }
    Bprvni, Bza             : integer;  { umisteni znaku tlacitka }
    JednoZnakoveTlacitko    : boolean;
    DelkaVystupnihoRetezce  : integer;


    ZnakTl1,   ZnakTl2,  ZnakTl3,  ZnakTl4, ZnakTl5, ZnakTl6: char;

    OznaceniTl1, OznaceniTl2, OznaceniTl3, OznaceniTl4,
    OznaceniTl5, OznaceniTl6: nameStr;

    LDX, LDY, PDX, PDY, PHX, PHY: longInt;

    KanalStr, InitStr, FormatStr, PromptStr: pathStr;

    BinarniFormat: boolean;
    OdlisovaciBit: byte;
    ProximityBit : byte;
    FiltrTlacitek: TFiltrByte;

    BinarniSouradnice: TBinarniSouradnice;

    PrenosovaRychlost: longInt;
    DelkaSlova, PocetStopBitu: byte;
    Parita: char;
    OKejTabletu: boolean;
    XPLAN, DICOMAT: boolean;
    PrubezneZobrazovaniDICOMATU: boolean;

    constructor Init( KonfigSoubor : pathStr; var Pripraven: boolean);

    procedure   NactiParametryDigitizeru(Soubor: pathStr);
    procedure   VyslaniInicializace;

    procedure DejAkci(  var XL, YL : real;
                      var Tlacitko : char;
                      var Znak     : char;
                      var VPoradku : boolean);

    procedure DejAkciXPlanu(var XL, YL: real;
                            var Tlacitko : char;
                            var Znak     : char;
                            var VPoradku: boolean);

{$IFDEF DICOMAT}
    procedure DejAkciDICOMATU(var XL, YL: real;
                              var Tlacitko : char;
                              var Znak     : char;
                              var VPoradku: boolean);
{$ENDIF}
    destructor Done;

  end;




{&&&&&&&&&&&&&&&&&&&&&&&&&&}  implementation  {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses crt,
     KeyProc, StrProc, CtiRadek, FilProc,
     ProsGlob;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}




procedure DejZnakyPoStrednik
          (Retezec: pathStr; var Posice: integer; var Znaky: pathStr);

begin

  Znaky:= '';
  while (Posice <= length(Retezec)) and
        (Retezec[Posice] <> ';')             do
  begin
    Znaky:= Znaky + Retezec[Posice];
    inc(Posice)
  end;

  inc(Posice)
end;


function DejZnakyPoCR(Retezec: string): string;
var
  Posice: integer;
  Znaky: string;

begin
  Posice:= 1;
  Znaky:= '';

  while (Posice <= length(Retezec)) and
        (Retezec[Posice] <> #13)             do
  begin
    Znaky:= Znaky + Retezec[Posice];
    inc(Posice)
  end;
  DejZnakyPoCR:= Znaky
end;







function PosunutyZnak(Znak: char; FiltrTlacitek: byte): char;
var
  CTlacitka: integer;

begin
  if FiltrTlacitek > 0 then
  begin
    CTlacitka:= ord(Znak) and FiltrTlacitek;

    while (FiltrTlacitek and 1) = 0 do
    begin
      FiltrTlacitek:= FiltrTlacitek shr 1;
      CTlacitka:= CTlacitka shr 1
    end;

    PosunutyZnak:= char(CTlacitka + 48)
  end
  else PosunutyZnak:= #0
end;






function FiltrovanyByte(Slovo: TBinarniRetez; FiltrByte: TFiltrByte): byte;
begin
  FiltrovanyByte:= byte(Slovo[FiltrByte.CBytu]) and FiltrByte.Filtr
end;


procedure FiltrujSlovo(var Slovo: TBinarniRetez; CBytu, Filtr: byte);
begin
  byte(Slovo[CBytu]):= byte(Slovo[CBytu]) and Filtr
end;






procedure VratBinarniXYTlacProx
          (    Slovo: TBinarniRetez; ProximityBit: byte;
               FiltrTlacitek: TFiltrByte;
               BinarniSouradnice: TBinarniSouradnice;
           var X, Y: real; var CTlacitka: integer; var Proximity: boolean);
var
  Pom: byte;
  I: integer;
  MinusX, MinusY: boolean;
  XL, YL: longInt;

begin
  MinusX:= false;
  MinusY:= false;

  Pom:= byte(Slovo[1]);
  Proximity:= Pom and ProximityBit = 0;
  if FiltrTlacitek.CBytu > 0 then
  begin
    CTlacitka:= byte(Slovo[FiltrTlacitek.CBytu]) and FiltrTlacitek.Filtr;

    while (FiltrTlacitek.Filtr and 1) = 0 do
    begin
      FiltrTlacitek.Filtr:= FiltrTlacitek.Filtr shr 1;
      CTlacitka:= CTlacitka shr 1
    end
  end
  else CTlacitka:= 0;

  XL:= 0;
  YL:= 0;

  with BinarniSouradnice do
  if PrvniX > 0 then
  begin
  { Zjistovani znaminek }
    if (ZnamenkoX.CBytu > 0) then
      MinusX:= FiltrovanyByte(Slovo, ZnamenkoX) <> 0;

    if (ZnamenkoY.CBytu > 0) then
      MinusY:= FiltrovanyByte(Slovo, ZnamenkoY) <> 0;

    if not Zaporne1 then
    begin
      MinusX:= not MinusX;
      MinusY:= not MinusY
    end;

  { Filtrovani souradnic }
    if Filtr1BytuSouradnice > 0 then
    begin
      FiltrujSlovo(Slovo, PrvniX, Filtr1BytuSouradnice);
      FiltrujSlovo(Slovo, PrvniY, Filtr1BytuSouradnice)
    end;

    if FiltrPBytuSouradnice > 0 then
    begin
      FiltrujSlovo(Slovo, PrvniX + PocetBytuSour-1, FiltrPBytuSouradnice);
      FiltrujSlovo(Slovo, PrvniY + PocetBytuSour-1, FiltrPBytuSouradnice)
    end;

  { Zjistovani vlastnich souradnic }
    if NizsiPakVyssi then
    begin
      for I:= PrvniX + PocetBytuSour -1 downTo PrvniX do
        XL:= (XL shl PocetBituSour) + ord(Slovo[I]);

      for I:= PrvniY + PocetBytuSour -1 downTo PrvniY do
        YL:= (YL shl PocetBituSour) + ord(Slovo[I]);
    end

    else
    begin
      for I:= PrvniX to PrvniX + PocetBytuSour -1 do
        XL:= (XL shl PocetBituSour) + ord(Slovo[I]);

      for I:= PrvniY to PrvniY + PocetBytuSour -1 do
        YL:= (YL shl PocetBituSour) + ord(Slovo[I])
    end;

  end;

  if MinusX then X:= -XL
  else X:= XL;

  if MinusY then Y:= -YL
  else Y:= YL

end;








constructor TTablet.Init(KonfigSoubor: pathStr; var Pripraven: boolean);
var
  Posice: integer;
  Znaky: pathStr;

begin
  NactiParametryDigitizeru(KonfigSoubor);
  if OKejTabletu then
  begin
    if BinarniFormat then
       DelkaVystupnihoRetezce:= 10
    else
    if XPLAN then
       DelkaVystupnihoRetezce:= 20
    else
    if DICOMAT then
       DelkaVystupnihoRetezce:= 30
    else
       DelkaVystupnihoRetezce:= length(FormatStr);

    Digit.Init
    (KanalStr, PrenosovaRychlost, Parita, DelkaSlova, PocetStopBitu,
     PrimaKomunikaceSeSio, DelkaVystupnihoRetezce);

{    OKejTabletu:= Digit.VPoradku; }

    if OKejTabletu then
    begin
      VyslaniInicializace;


      if not BinarniFormat and not XPLAN and not DICOMAT then
      with Digit do
      begin

      { zjisteni posic pro X a Y ve formatu vystupu }
        Xprvni:= 1;
        while upCase(FormatStr[Xprvni]) <> 'X' do inc(Xprvni);

        Xza:= Xprvni + 1;
        while upCase(FormatStr[Xza]) = 'X' do inc(Xza);

        Yprvni:= 1;
        while upCase(FormatStr[Yprvni]) <> 'Y' do inc(Yprvni);

        Yza:= Yprvni + 1;
        while upCase(FormatStr[Yza]) = 'Y' do inc(Yza);
{
        Bi:= 1;
        while upCase(FormatStr[Bi]) <> 'B' do inc(Bi);
}
        Bprvni:= 1;
        while upCase(FormatStr[Bprvni]) <> 'B' do inc(Bprvni);

        Bza:= Bprvni + 1;
        while upCase(FormatStr[Bza]) = 'B' do inc(Bza);

        JednoznakoveTlacitko:= Bza-Bprvni = 1;
      end;

      Posice:= 1;
      DejZnakyPoStrednik(PromptStr, Posice, Znaky);
      PromptStr:= Znaky;
    end { if OKejTabletu }
  end; { if OKejTabletu }

  PrubezneZobrazovaniDICOMATU:= false;

  Pripraven:= OKejTabletu
end;






procedure  TTablet.NactiParametryDigitizeru(Soubor: pathStr);
var
  Radek: TCtiRadek;
  F: text;
  Pom: pathStr;
  Znak: char;

  function DejStringZRadku: pathStr;
  begin
    readln(F,Pom);
    Radek.Init(Pom);
    Znak:= Radek.DejChar;
    DejStringZRadku:= Radek.DejStringPoZnak(#39); {'}
    Radek.Done
  end;



  function DejByteZe3Cisel(C1, C2, C3: char): byte;
  var
    Pom, Code: integer;

  begin
    val(C1+C2+C3, Pom, Code);
    if Code = 0 then DejByteZe3Cisel:= Pom
    else
       DejByteZe3Cisel:= 0
  end;



  function DejFormatZRadku(var Binarne: boolean): pathStr;
  begin
    Binarne:= false;
    readln(F,Pom);
    Radek.Init(Pom);
    Znak:= Radek.DejChar;

    if upCase(Znak) = 'B' then
    with Radek do
    begin
      Binarne:= true;

      OdlisovaciBit:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

      if DosloKChybe or (OdlisovaciBit = 0) then
         OdlisovaciBit:= 64;

      Znak:= DejChar;
      if (upCase(Znak) = 'P') and not DosloKChybe then
         ProximityBit:= DejByteZe3Cisel(DejChar, DejChar, DejChar)
      else ProximityBit:= 0;

      Znak:= DejChar;
      if (upCase(Znak) = 'T') and not DosloKChybe then
      begin
        FiltrTlacitek.CBytu:= ord(DejChar)-ord('0');
        FiltrTlacitek.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);
      end
      else FiltrTlacitek.CBytu:= 0;

      Znak:= DejChar;
      if (upCase(Znak) = 'S') and not DosloKChybe then
      with BinarniSouradnice do
      begin
        PrvniX:= ord(DejChar)-ord('0');
        PrvniY:= ord(DejChar)-ord('0');
        PocetBytuSour:= ord(DejChar)-ord('0');
        PocetBituSour:= ord(DejChar)-ord('0');
        NizsiPakVyssi:= upCase(DejChar) = 'A';
      end
      else
      begin
        BinarniSouradnice.PrvniX:= 0;
      end;

      Znak:= DejChar;


      if (upCase(Znak) = 'F') and not DosloKChybe  then
      with BinarniSouradnice do
      begin
        Filtr1BytuSouradnice:= DejByteZe3Cisel(DejChar, DejChar, DejChar);
        FiltrPBytuSouradnice:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        Znak:= DejChar;
      end
      else
      begin
        BinarniSouradnice.Filtr1BytuSouradnice:= 0;
        BinarniSouradnice.FiltrPBytuSouradnice:= 0;
      end;

      if (upCase(Znak) = 'Z') and not DosloKChybe then
      with BinarniSouradnice do
      begin
        ZnamenkoX.CBytu:= ord(DejChar)-ord('0');
        ZnamenkoX.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        ZnamenkoY.CBytu:= ord(DejChar)-ord('0');
        ZnamenkoY.Filtr:= DejByteZe3Cisel(DejChar, DejChar, DejChar);

        Zaporne1:= upCase(DejChar) = 'A'
      end
      else
      begin
        BinarniSouradnice.ZnamenkoX.CBytu:= 0;
        BinarniSouradnice.ZnamenkoY.CBytu:= 0;
        BinarniSouradnice.Zaporne1:= true
      end


    end;

    DejFormatZRadku:= Radek.DejStringPoZnak(#39); {'}

    Radek.Done
  end;





  function DejIntegerZRadku: integer;
  begin
    readln(F,Pom);
    Radek.Init(Pom);
    DejIntegerZRadku:= Radek.DejInteger;
    Radek.Done
  end;


  procedure DejZnakAOznaceni(var ZnakTlacitka: char; var Oznaceni: nameStr);
  begin
    {$I-} readln(F, Pom); {I+}

    if IOResult = 0 then
    begin
      Radek.Init(Pom);
      Znak:= Radek.DejChar;
      Pom:= Radek.DejStringPoZnak(#39);
      ZnakTlacitka:= Pom[1];
      Znak:= Radek.DejChar;
      Pom:= Radek.DejStringPoZnak(#39);
      Znak:= Radek.DejChar;
      Oznaceni:= StrStrSP(Radek.DejStringPoZnak(#39), 8);
      Radek.Done
    end
    else ZnakTlacitka:= Esc
  end;



  procedure Dej2longInt(var L1, L2: longInt);
  begin
    readln(F,Pom);
    Radek.Init(Pom);
    L1:= Radek.DejLongInt;
    L2:= Radek.DejLongInt;
    Radek.Done
  end;


  procedure PrelozSekvenci(var Sekv: pathStr; var OKej: boolean);
  var
    PomStr: string;
    I: byte;
    ZnakH, code: integer;

  begin
    I:= 1;
    PomStr:= '';
    OKej:= true;

    while (I <= length(Sekv)) and OKej do
    begin
      case Sekv[I] of
      '#': begin   { vstup lib. ciselne hodnoty decimalne na 3 cifry }
             val(copy(Sekv, I+1, 3), ZnakH, code);
             OKej:= code=0;
             if OKej then
             begin
               PomStr:= PomStr + chr(ZnakH);
               inc(I, 4)
             end
           end;

      '!': begin   { vstup ESC }
             PomStr:= PomStr + #27;
             inc(I)
           end;

      '\': begin   { vstup ENTER }
             PomStr:= PomStr + #13;
             inc(I)
           end

      else begin   { vsechny ostatni znaky }
             PomStr:= PomStr + Sekv[I];
             inc(I)
           end
      end
    end;

    if OKej then Sekv:= PomStr
    else Sekv:= ''
  end;




begin
  BinarniFormat:= false;

  assign(F, Soubor);
  fileMode:= moOpenRONN;
  {$I-} reset(F); {$I+}
  fileMode:= moStandard;

  OKejTabletu:= IOResult = 0;

  if OKejTabletu then
  begin
    KanalStr:= DejStringZRadku;
    PrenosovaRychlost:= DejIntegerZRadku;

    Pom:= DejStringZRadku;
    Parita:= Pom[1];

    DelkaSlova:= DejIntegerZRadku;
    PocetStopBitu:= DejIntegerZRadku;

    InitStr:=   DejStringZRadku;
    PrelozSekvenci(InitStr, OKejTabletu);

    FormatStr:= DejFormatZRadku(BinarniFormat);
    XPLAN:= FormatStr = 'XPLAN';
    DICOMAT:= FormatStr = 'DICOMAT';

    PromptStr:= DejStringZRadku;
    PrelozSekvenci(PromptStr, OkejTabletu);

    DejZnakAOznaceni(ZnakTl1, OznaceniTl1);
    if ZnakTl1 <> Esc then
    begin
       DejZnakAOznaceni(ZnakTl2, OznaceniTl2);
       if ZnakTl2 <> Esc then
       begin
         DejZnakAOznaceni(ZnakTl3, OznaceniTl3);
         if ZnakTl3 <> Esc then
         begin
           DejZnakAOznaceni(ZnakTl4, OznaceniTl4);
           if ZnakTl4 <> Esc then
           begin
             DejZnakAOznaceni(ZnakTl5, OznaceniTl5);
             if ZnakTl5 <> Esc then
             begin
               DejZnakAOznaceni(ZnakTl6, OznaceniTl6)
             end
           end
         end
       end
    end;

{
    Dej2LongInt(LDX, LDY);
    Dej2LongInt(PDX, PDY);
    Dej2LongInt(PHX, PHY)
}

    Pom:= DejStringZRadku;
    if (Pom <> '') and (upCase(Pom[1]) in ['A','N']) then
       PrimaKomunikaceSeSIO:= Pom = 'A';
    close(F)
  end;
end;






procedure TTablet.VyslaniInicializace;
var
  Znaky: pathStr;
  Posice: integer;

begin
  if OKejTabletu then
  with Digit do
  begin

  { vyslani inicializacnich prikazu }
    Posice:= 1;
    DejZnakyPoStrednik(InitStr, Posice, Znaky);
    while Znaky <> '' do
    begin
      delay(100);
      Prikaz(Znaky);
      DejZnakyPoStrednik(InitStr, Posice, Znaky)
    end
  end
end;




procedure VyjmiCisloZRetezu
          (Retez: string; var Hodnota: real; var OKej: boolean);
var
  CR: TCtiRadek;

begin
  CR.Init(Retez);
  Hodnota:= CR.DejReal;
  OKej:= not CR.DosloKChybe;
  CR.Done
end;



var
  XPX, XPY: real;

procedure TTablet.DejAkciXPlanu(var XL, YL: real;
                                var Tlacitko : char;
                                var Znak     : char;
                                var VPoradku: boolean);
var
  Hodnota: real;
  OKej: boolean;
  Retez: string;
  PrerusZnak: char;

begin
  Vporadku:= false;
  if not Digit.VstupPripraven then
  begin
    XL:= XPX;
    YL:= XPY;
    TLacitko:= #0;
    Znak:= #0;
    VPoradku:= true
  end
  else
  begin

    Retez:= Digit.PrijatySamostatnyRetezec(PrerusZnak);
  {$IFDEF Test}
    gotoXY(1,22);
    writeln('1.radek XPLAN: ',Retez);
  {$ENDIF}
    if PrerusZnak = #0 then
    begin
      if Retez = 'CA' then
      begin
        Tlacitko:= #3;
        Znak:= #0;
        Vporadku:= true
      end
      else
      if Retez[1] = 'X' then
      begin
        VyjmiCisloZRetezu(Retez, Hodnota, OKej);
        if OKej then
        begin
          XL:= round(Hodnota * 1000);
          Retez:= Digit.PrijatySamostatnyRetezec(PrerusZnak);
  {$IFDEF Test}
          gotoXY(1, 23);
          writeln('2.radek XPLAN: ',Retez);
  {$ENDIF}
          if Retez[1] = 'Y' then
          begin
            VyjmiCisloZRetezu(Retez, Hodnota,OKej);
            if OKej then
            begin
              YL:= round(Hodnota * 1000);
              VPoradku:= true;
              Tlacitko:= #1;
              Znak:= #0;
              XPX:= XL;
              XPY:= YL
            end;
          end
        end;
      end;
    end
    else
      Znak:= PrerusZnak
  end
end;



{$IFDEF DICOMAT}
procedure TTablet.DejAkciDICOMATU(var XL, YL: real;
                                var Tlacitko : char;
                                var Znak     : char;
                                var VPoradku: boolean);
var
  Hodnota: real;
  OKej: boolean;
  Retez: string;
  PrerusZnak, PZnak: char;
  Code, I: integer;


  procedure VypisNaDisplay(Retez: string);
  begin
    if length(Retez) > 20 then
       Retez:= copy(Retez, 1, 20);

    if Retez = '' then Retez:= ' . . . nic . . . ';

    Digit.Prikaz('TX '''+Retez+''''+#13)
  end;



  procedure ZpracujRetez(Retez: string; var XL, YL: real; var VPoradku: boolean);
  var
    CR: TCTiRadek;

  begin
    VPoradku:= false;

    CR.Init(Retez);
    if not CR.DosloKChybe then
    begin
      XL:= CR.DejReal;
      if not CR.DosloKChybe then
      begin
        YL:= CR.DejReal;
        VPoradku:= true
      end
    end;
    CR.Done;

    if VPoradku then
    begin
      XPX:= XL;
      XPY:= YL;
    end;

    VypisNaDisplay(RStrSP(XL,10,2)+RStrSP(YL,10,2))
  end;



  procedure VyvolejSour(var XL, YL: real; var Znak: char);
  begin
    Znak:= #0;

    Digit.Prikaz('RC'+#13);
    Retez:= Digit.PrijatySamostatnyRetezec(PrerusZnak);
    if (PrerusZnak = #0) and (Retez[1] = 'C') then
    begin
      ZpracujRetez(Retez, XL, YL, VPoradku);
      if not VPoradku then
      begin
      {$IFDEF test}
        gotoxy(1,20);
        writeln(Retez);
      {$ENDIF}
        Znak:= PrerusZnak;
        XL:= XPX;
        YL:= XPY
      end
    end
    else
    begin
    {$IFDEF test}
      gotoxy(1,20);
      clrEol;
      writeln('ne Sour: ', Retez);
    {$ENDIF}
      Znak:= PrerusZnak;
      XL:= XPX;
      YL:= XPY
    end
  end;


begin
  Vporadku:= false;
  TLacitko:= #0;
  Znak:= #0;

  with Digit do
  begin
    XL:= XPX;
    YL:= XPY;

    repeat
    until VstupPripraven or KeyPressed;

    if not KeyPressed then
    begin
      if DejZnak = 'K' then
      begin
        if DejZnak = 'C' then
        begin
          if DejZnak = ' ' then
          begin
            if DejZnak = '0' then
            begin
              Znak:= DejZnak;
              if Znak = '9' then
              begin
                if DejZnak = '3' then
                begin
                  if DejZnak = #13 then
                  begin
                    if DejZnak = 'C' then
                    begin
                      Znak:= DejZnak;
                      Znak:= DejZnak;
                      I:= 1;
                      while not (I>25) and not (Znak = #13) do
                      begin
                        Znak:= DejZnak;
                        Retez[I]:= Znak;
                        inc(I)
                      end;

                      if Znak = #13 then dec(I);
                      Retez[0]:= chr(I);
                      ZpracujRetez(Retez, XL, YL, VPoradku);
                      Tlacitko:= #1;
                      Znak:= #0;
                      VPoradku:= true
                    end
                  end
                end
                else
                begin
                  XL:= XPX;
                  YL:= XPY;
                  Tlacitko:= #2;
                  VPoradku:= true
                end
              end
              else
              if Znak = '0' then
              begin
                Znak:= DejZnak;
                XL:= XPX;
                YL:= XPY;
                Tlacitko:= chr(ord(Znak)-46);
                VPoradku:= true
              end
              else
              if Znak = '2' then
              begin
                Znak:= DejZnak;
                if Znak = '9' then
                begin
                  VyvolejSour(XL, YL, Znak)
                end
              end
            end
          end
        end
      end
    end
    else
    begin
      Znak:= CtiKlavesu;
      VyvolejSour(XL, YL, PZnak);
      if Znak = ' ' then Znak:= #0
    end

  end;

(*
  Vporadku:= false;
  TLacitko:= #0;
  Znak:= #0;

  if not Digit.VstupPripraven then
  begin
    if PrubezneZobrazovaniDICOMATU then
    begin
      VyvolejSour(XL, YL, Znak);
      VPoradku:= true
    end
    else
    begin
      XL:= XPX;
      YL:= XPY;
      VPoradku:= true;
    end
  end
  else
  begin
    Retez:= Digit.PrijatyRetezecBezpecne(PrerusZnak);
{    VypisNaDisplay(Retez); }

    if PrerusZnak = #0 then
    begin
      if copy(Retez,1,2) = 'KC' then
      begin
        Retez:= copy(Retez, 4, 3);

        if (Retez = '091') then
        begin
          Tlacitko:= #2;
          Retez:= Digit.PrijatyRetezecBezpecne(PrerusZnak);
          if (PrerusZnak = #0) and (Retez[1] = 'C') then
          begin
            ZpracujRetez(Retez, XL, YL, VPoradku);
          end
          else
            Znak:= PrerusZnak
        end
        else
        if Retez = '093' then
        begin
          Tlacitko:= #1;
          Retez:= Digit.PrijatyRetezecBezpecne(PrerusZnak);
          if (PrerusZnak = #0) and (Retez[1] = 'C')then
          begin
            ZpracujRetez(Retez, XL, YL, VPoradku);
          end
          else
            Znak:= PrerusZnak
        end
        else
        begin
          val(Retez, Hodnota, Code);
          if Code = 0 then
             Tlacitko:= chr(trunc(Hodnota));
          XL:= XPX;
          YL:= XPY;

          if Hodnota = 29 then PrubezneZobrazovaniDICOMATU:= true;
          if Hodnota = 30 then PrubezneZobrazovaniDICOMATU:= false;
        end;

        Vporadku:= true
      end
      else
      if Retez[1]  = 'C' then
      begin
        ZpracujRetez(Retez, XL, YL, VPoradku);
      end
      else
      begin
      {$IFDEF Test}
        gotoxy(1,20);
        clrEol;
        writeln('Ne KC: ', Retez);
      {$ENDIF}
      end
    end
    else
      Znak:= PrerusZnak
  end

*)
end;

{$ENDIF}



procedure TTablet.DejAkci(var XL, YL : real;
                          var Tlacitko : char;
                          var Znak     : char;
                          var VPoradku: boolean);
const
  PointMode: boolean = false;

var
  PrijatyRetezec: string;
  BinarniRetez  : string[10];
  Code: integer;
  TNum: integer;
  PrerusZnak: char;
  CTlacitka, I: integer;
  Proximity: boolean;

begin
  if XPLAN then DejAkciXPLanu(XL, YL, Tlacitko, Znak, VPoradku)
{$IFDEF DICOMAT}
  else
  if DICOMAT then DejAkciDICOMATU(XL, YL, Tlacitko, Znak, VPoradku)
{$ENDIF}
  else
  begin
    Tlacitko:= #0;
    Znak:= #0;
    VPoradku:= false;

    if keyPressed then
    begin
      Znak:= readKey;
      if Znak = #0 then
         Znak:= chr (ord (readKey) + 123)
    end;

    if OKejTabletu and (Znak <> Esc) then
    begin

      if PromptStr <> '' then
         Digit.Prikaz(PromptStr);

      Code:= -1;

      if BinarniFormat then
         BinarniRetez:= Digit.BinarniSlovo(OdlisovaciBit, PrerusZnak)
      else
      if PointMode then
         PrijatyRetezec:= Digit.PrijatySamostatnyRetezec(PrerusZnak)
      else
         PrijatyRetezec:= Digit.PrijatyRetezec(PrerusZnak);



      if PrerusZnak = #0 then
      begin

        if BinarniFormat then
        begin
  {$IFDEF Test}
          gotoXY(1, 23); clrEol;
          write('Binarni retezec: ');
          for I:= 1 to length(BinarniRetez) do
              write(ord(BinarniRetez[I]):3, ':');

          write('   Znak:', PosunutyZnak(BinarniRetez[1], FiltrTlacitek.Filtr));
  {$ENDIF}

          VratBinarniXYTlacProx
             (BinarniRetez, ProximityBit, FiltrTlacitek, BinarniSouradnice,
              XL, YL, CTlacitka, Proximity);

          Tlacitko:= chr(CTlacitka + 48);
          Code:= 0;
          VPoradku:= Proximity;

  {$IFDEF Test}
          gotoXY(1, 16); clrEol;

          if not Proximity then
             write('Kurzor je mimo desku');
  {$ENDIF}

        end

        else
        begin
          if DelkaVystupnihoRetezce < length(PrijatyRetezec) then
            PrijatyRetezec:= DejZnakyPoCR(PrijatyRetezec);

  {$IFDEF Test}
          gotoXY(1, 23);
          write('Prijaty retezec: ', PrijatyRetezec);
  {$ENDIF}

          if DelkaVystupnihoRetezce = length(PrijatyRetezec) then
          begin
            val(copy(PrijatyRetezec, Xprvni, Xza-Xprvni), XL, Code);

            if Code = 0 then
               val(copy(PrijatyRetezec, Yprvni, Yza-Yprvni), YL, Code);

            if Code = 0 then
            begin
              if JednoznakoveTlacitko then
                 Tlacitko:= PrijatyRetezec[Bprvni]
              else
              begin
                val(copy(PrijatyRetezec, Bprvni, Bza-Bprvni), TNum, Code);
                if (Code = 0) and (TNum < 250) then
                   Tlacitko:= chr((TNum) + 48)
                else Code:= -1
              end
            end
          end;

          VPoradku:= true;
        end;

        if (Code = 0) and VPoradku then
        begin
          if Tlacitko = ZnakTl1 then Tlacitko:= #1
          else
          if Tlacitko = ZnakTl2 then Tlacitko:= #2
          else
          if Tlacitko = ZnakTl3 then Tlacitko:= #3
          else
          if Tlacitko = ZnakTl4 then Tlacitko:= #4
          else
          if Tlacitko = ZnakTl5 then Tlacitko:= #5
          else
          if Tlacitko = ZnakTl6 then Tlacitko:= #6
          else Tlacitko:= #0;
        end
        else
        begin
          VPoradku:= false;
          VyslaniInicializace;
          delay(5)
        end;
      end
      else Znak:= PrerusZnak

    end { if OKejTabletu }
  end
end;





destructor TTablet.Done;

begin
  Digit.Done
end;




end.
