{ D-}

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXX                                                             XXX}
{XXX    Copyright (c) - Help Service - Mapping, s.r.o.  1994     XXX}
{XXX                                                             XXX}
{XXX    Pouziti : - DosTopoL                                     XXX}
{XXX              - WinTopoL                                     XXX}
{XXX                                                             XXX}
{XXX                                                             XXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

unit Krivky;

{**********************************************************************************}

                                INTERFACE

{**********************************************************************************}
uses
{$IFDEF WINDOWS}
  WinTypes, OWindows, Objects,
  GlobProm,
  Hlasky,
  BlokObj,
  BlokType,
  MatProc,
  NadGraph;
{$ELSE}
  BlokObj,
  BlokType,
  Graph,
  MatProc,
  NadGraph,
  BPObject,
  PTranPov;
{$ENDIF}
{**********************************************************************************}

const

  { Orezavani }
  { ********* }
  Orezavat   = True;
  Neorezavat = False;

  { Krokova politika }
  { **************** }
  PixKrok     = 20;            { Standardni pixlovy krok }
  PixKrokMin  = 1;             { Minimalni pixlovy krok }
  MinPocKroku = 10;            { Minimalni pocet kroku pri zobrazeni }
  MaxPocKroku = 200;           { ... a maximalni }
  deltaU      = 0.0849;        { Standardni uhlovy krok }
  PresnostHPGL= 0.00005;       { Krok v m pro HPGL }

  { Povolena chyba pro prevod krivky na Linii (v metrech) }
  { ***************************************************** }
  PresnostKrivek: real = 10;
  PevnaDelkaVertexu: boolean = False;
  PrevodKrivekLomovymiBody: boolean = True;

(*
  { Modelova krivka ... pro nastaveni atributu v menu }
  { ************************************************* }

  Je potreba jen v ArcImp - v pripade potreby je mozno udelat proceduru
  inicializujici prislusnou linii  17.5.95 V.C.

  ModelovaKrivka : TLin = (
           Cislo         : 0;
           Druh          : 1;
           Presnost      : 9;
           Atributy      : [lnKrivka];
           Vybrana       : False;
           Barva         : Cerna;
           Znacka        : 0;
           Symbol        : 0;
           Cas           : 0;

           PrvniSour     : 0;
           PosledniSour  : 0;

           DrziSe        : (

                           Levou : (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   );
                           Pravou: (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   )
                          );
           LevaPlocha    : -1;
           PravaPlocha   : -1;

           Delka         : 0
           {
           OpsanyObdelnik:(PH:(y: 0; x: 0);LD: (y: 0; x: 0));

           PolohaSymbolu : TPolohaSymbolu
           }
           );
*)
type


  PUzly = ^TUzly;
  TUzly = Array [0..5460] of TSour;

{$IFDEF WINDOWS}
  PIntUzly = ^TIntUzly;
  TIntUzly = Array [0..16380] of TPoint;
{$ELSE}
  PIntUzly = ^TIntUzly;
  TIntUzly = Array [0..16380] of PointType;
{$ENDIF}


  { KRIVKA --------------------------------}
  {        zakladni predek vsech krivek    }
  { ************************************** }
  PKrivka = ^TKrivka;
  TKrivka = object(TObject)
     Uzly: PUzly;
     PocetUzlu: word;
     MinimalniPocetUzlu: Byte;
     Krok: Real;
     Kroku: LongInt;
{$IFDEF WINDOWS}
     DC: HDC;
     Okno: PWindowsObject;
     BMP: boolean;
{$ENDIF}
     constructor Init;
     destructor  Done; virtual;
{$IFDEF WINDOWS}
     procedure   NastavDC(aDC: HDC; const aOkno: PWindowsObject; aBMP: boolean);
{$ENDIF}
     function    DelkaKrivky: Real; virtual;
     function    KrivkaVObdelniku(Obdelnik: TObdelnik): boolean; virtual;
     function    NaplnPoleZDisku( Linie: TLin;
                                  PBlok: TBlokPtr): Boolean;
     function    NaplnPoleZeSeznamu( PSeznam: TLomBodPtr): Boolean;
     procedure   NastavKrok;
{$IFDEF WINDOWS}
     procedure   NastavKrokProVyber;
{$ENDIF}
     procedure   PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                   OtevreneSoub: boolean); virtual;
     function    PrevedLiniiNaKrivku(var Lin: TLin; Blok: TBlokPtr): boolean;
     procedure   PridejSeznamBodu (    Blok: TBlokPtr;
                                   var Prvni, Posledni: longInt);
     procedure   UlozSeznamBodu ( Blok: TBlokPtr;var Prvni, Posledni: longInt);
     procedure   UvolniPole;
     procedure   UlozKrivkuNaDisk(Lin: TLin; Kontrola: Boolean);
     function    VratKrok: Real;
     procedure   VratOpsanyObdelnik (var OpsObd: TObdelnik); virtual;
{$IFNDEF WINDOWS}
     procedure   VystupDoHPGL ( Vyrez: TObdelnik;
                                Meritko: real); virtual;
     procedure   VystupDoHPGLZeSeznamu ( PSeznam: TLomBodPtr;
                                         Vyrez: TObdelnik;
                                         Meritko: real); virtual;
{$ENDIF}
     function    VytvorNovePole: Boolean; virtual;

{$IFDEF WINDOWS}
     procedure   ZobrazRealne ( Orez: Boolean); virtual;

     procedure   ZobrazRealneZDisku( Linie: TLin;
                                     PBlok: TBlokPtr;
                                     Orezavat: Boolean);    virtual;
     procedure   ZobrazRealneZeSeznamu( PSeznam: TLomBodPtr;
                                        Orezavat: Boolean); virtual;
{$ELSE}
     procedure   ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                Nastavit: boolean;
                                Orez: Boolean); virtual;

     procedure   ZobrazRealneZDisku( Linie: TLin;
                                     Barva, Typ, ZobrMod: integer;
                                     Nastavit: boolean;
                                     PBlok: TBlokPtr;
                                     Orezavat: Boolean);    virtual;
     procedure   ZobrazRealneZeSeznamu( PSeznam: TLomBodPtr;
                                        Barva, Typ, ZobrMod: integer;
                                        Nastavit: boolean;
                                        Orezavat: Boolean); virtual;
{$ENDIF}
  end;


  { Elipsa --------------------------------}
  { ************************************** }

  PParametryElipsy = ^TParametryElipsy;
  TParametryElipsy = record
     y   : real;
     x   : real;
     a   : real;
     b   : real;
     Uhel: real;
  end;

  PElipsa = ^TElipsa;
  TElipsa = object(TKrivka)
     Par: PParametryElipsy;
     Kruznice: Boolean;
     constructor Init;
     function    DelkaKrivky: Real; virtual;
     function    KrivkaVObdelniku(Obdelnik: TObdelnik): boolean; virtual;
     function    OrezNaOblouk (   Obdelnik: TObdelnik;
                              var Uhel1, Uhel2: real;
                              var Orez: boolean): boolean;
     procedure   PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                   OtevreneSoub: boolean); virtual;
{$IFNDEF WINDOWS}
     procedure   VystupDoHPGL ( Vyrez: TObdelnik;
                                Meritko: real); virtual;
{$ENDIF}
     procedure   VratBodPodUhlem(Alfa: real; var Bod: TSour);
     procedure   VratOpsanyObdelnik (var OpsObd: TObdelnik); virtual;
     procedure   VratUhelAVzdalBoduOdStredu(    Bod: TSour;
                                            var SklUhel, Vzdal: real;
                                            Tocit: boolean);
{$IFDEF WINDOWS}
     procedure   ZobrazRealne ( Orez: Boolean); virtual;
{$ELSE}
     procedure   ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                Nastavit: boolean;
                                Orez: Boolean); virtual;
{$ENDIF}
  end;

  { Oblouk --------------------------------}
  { ************************************** }

  PParametryOblouku = ^TParametryOblouku;
  TParametryOblouku = record
     y      : real;
     x      : real;
     a      : real;
     b      : real;
     Uhel   : real;
     Zacatek: real;
     Konec  : real;
  end;

  POblouk = ^TOblouk;
  TOblouk = object(TElipsa)
     ParO: PParametryOblouku;
     constructor Init;
     function    DelkaKrivky: Real; virtual;
     function    KrivkaVObdelniku(Obdelnik: TObdelnik): boolean; virtual;
     procedure   PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                   OtevreneSoub: boolean); virtual;
{$IFNDEF WINDOWS}
     procedure   VystupDoHPGL ( Vyrez: TObdelnik;
                                Meritko: real); virtual;
{$ENDIF}
     procedure   VratOpsanyObdelnik (var OpsObd: TObdelnik); virtual;
{$IFDEF WINDOWS}
     procedure   ZobrazRealne ( Orez: Boolean); virtual;
{$ELSE}
     procedure   ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                Nastavit: boolean;
                                Orez: Boolean); virtual;
{$ENDIF}
  end;


var
   Siny: Array[0..74] of Integer;
   Cosy: Array[0..74] of Integer;


{ Procedury pro celociselne zobrazeni a nejen pro nej }
{ *************************************************** }

procedure NapustGoniometry;
procedure NacpiUhelDoDvaPi (var Uhel: real);
function CaraVObdelniku(S1,S2: TSour; Obdelnik: TObdelnik): boolean;

{$IFNDEF WINDOWS}
procedure ElipsaInt(x,y,a,b: longint; Uhel: real; Barva: Word);
procedure ObloukInt(x,y,a,b: longint; Uhel,Zac,Kon: real; Barva: Word);
procedure ElipsaIntDoBuffferu(x,y,a,b: longint; Uhel: real;
                              var PocetLB: integer; var Buffer: Pointer);
procedure ObloukIntDoBuffferu(x,y,a,b: longint; Uhel,Zac,Kon: real;
                              var PocetLB: integer; var Buffer: Pointer;
                              Pridat: integer);
{$ENDIF}
{**********************************************************************************}

                       IMPLEMENTATION

{**********************************************************************************}

uses
{$IFDEF WINDOWS}
   BPrevody,
   Chytani,
   MyStream,
   Pokus,
   Strings,
   StrProc,
   VektoOkn,
   WinProcs;
{$ELSE}
   BPrevody,
   Crt,
   Chytani,
   Hlasky,
   HPGLBod,
   KeyProc,
   KurzObj,
   MyStream,
   PredmObj,
   StRadek,
   StrProc,
   UkazObj,
   VybUkaz,
   ZakNapov,
   ZobraObj,
   ZobrVyre,
   TxHlasky, TxBezNap;
{$ENDIF}

{**********************************************************************************}




const
   Ano = True;
   Ne  = False;
   Sour00: TSour = (y: 0; x: 0);

   UnivDelitel  = 1000;             { Delitele pro zrychleny vyp. elipsy }
   UnivDelitel2 = 1000000;

type
  TPoloha = set of (Vlevo, VPravo, Nahore, Dole);

  TLongSour = record
    X: longInt;
    Y: longInt;
  end;


  PLongVrcholy = ^TLongVrcholy;
  TLongVrcholy = Array[1..8000] of TLongSour;

{========================= pomocne procedury ================================}


procedure NapustGoniometry;
  var
    uu: real;
    i : byte;
  begin
    uu := 0;
    for i := 0 to 74 do
    begin
       Siny[i] := Round(sin(uu)*1000);
       Cosy[i] := Round(cos(uu)*1000);
       uu := uu + deltaU;
    end;
  end;

procedure NacpiUhelDoDvaPi (var Uhel: real);
  begin
     if Uhel < 0 then Uhel := DvaPi + Uhel else
     if Uhel > DvaPi then Uhel := Uhel-(Int(Uhel/DvaPi)*DvaPi);
  end;


function CaraVObdelniku(S1,S2: TSour; Obdelnik: TObdelnik): boolean;
begin
  with Obdelnik do
  begin
     if PrekryvObdelnikuSouradnicemi(LD, PH, S1, S2, 0) then
       CaraVObdelniku :=
       ProtnutyUsecky
     (LD.Y,PH.X, PH.Y,PH.X, S1.Y,S1.X, S2.Y, S2.X) or
       ProtnutyUsecky
     (LD.Y,LD.X, LD.Y,PH.X, S1.Y,S1.X, S2.Y, S2.X) or
       ProtnutyUsecky
     (LD.Y,LD.X, PH.Y,LD.X, S1.Y,S1.X, S2.Y, S2.X) or
       ProtnutyUsecky
     (PH.Y,LD.X, PH.Y,PH.X, S1.Y,S1.X, S2.Y, S2.X)
     else CaraVObdelniku := Ne;
  end;
end;



{sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss}
{ Bacha ! nasledujici procedura fungi only for Krovak ... Howgh }
procedure VratPolohuBodu(Bod: TSour; Obd: TObdelnik; var Poloha: TPoloha);
  begin
     Poloha := [];
     if Bod.y > Obd.LD.y then Poloha := Poloha + [Vlevo] else
     if Bod.y < Obd.PH.y then Poloha := Poloha + [Vpravo];
     if Bod.x > Obd.LD.x then Poloha := Poloha + [Dole] else
     if Bod.x < Obd.PH.x then Poloha := Poloha + [Nahore];
  end;

{================================================}


           { Tela metod TKrivka }


{================================================}

constructor TKrivka.Init;
  begin
     Uzly      := nil;
     PocetUzlu := 0;
     Krok      := 0;
     Kroku     := 10;
     MinimalniPocetUzlu := 0;
{$IFDEF WINDOWS}
     DC        := 0;
     Okno      := nil;
     BMP       := False;
{$ENDIF}
  end;

{------------------------------------------------}
destructor  TKrivka.Done;
  begin
     UvolniPole;
  end;

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TKrivka.NastavDC(aDC: HDC; const aOkno: PWindowsObject; aBMP: boolean);
  begin
     DC   := aDC;
     Okno := aOkno;
     BMP  := aBMP;
  end;
{$ENDIF}

{------------------------------------------------}
function    TKrivka.DelkaKrivky: Real;
  begin
  end;

{------------------------------------------------}
function    TKrivka.KrivkaVObdelniku(Obdelnik: TObdelnik): boolean;
  begin
     Abstract;
  end;

{------------------------------------------------}
function    TKrivka.NaplnPoleZDisku(Linie: TLin; PBlok: TBlokPtr): Boolean;
  var
     I,J: LongInt;

  begin
     NaplnPoleZDisku := Ne;
     UvolniPole;
     with Linie do
     begin
        PocetUzlu := PosledniSour - PrvniSour + 1;
        GetMem(Uzly,PocetUzlu*SizeOf(TSour));
        if not Assigned(Uzly) then exit;
        with PBlok^ do
        begin
          J := 0;
          for I:= PrvniSour  to PosledniSour do
          begin
            CtiSour(I, Uzly^[J]);
            Inc(J);
          end;
          NaplnPoleZDisku := Ano;
        end;
     end;
  end;

{------------------------------------------------}
function    TKrivka.NaplnPoleZeSeznamu(PSeznam: TLomBodPtr): Boolean;
  var
     B: TLomBodPtr;
     i: Word;
  begin
     NaplnPoleZeSeznamu := Ne;
     UvolniPole;
     B := PSeznam;
     while B <> nil do
     begin
       B := B^.Dalsi;
       Inc(PocetUzlu);
     end;
     GetMem(Uzly,PocetUzlu*SizeOf(TSour));
     if not Assigned(Uzly) then exit;
     B := PSeznam;
     i := 0;
     while B <> nil do
     begin
       Uzly^[i] := B^.Sour;
       B := B^.Dalsi;
       Inc(i);
     end;
     NaplnPoleZeSeznamu := Ano;
  end;

{------------------------------------------------}
procedure   TKrivka.NastavKrok;
begin
   Krok := VratKrok;
end;

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TKrivka.NastavKrokProVyber;
begin
   Krok := PixKrok/PVektorOkno(State^.ZobrOkno)^.KVert;
end;
{$ENDIF}


{------------------------------------------------}
procedure   TKrivka.PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                      OtevreneSoub: boolean);
begin
   Abstract;
end;

{------------------------------------------------}
function    TKrivka.PrevedLiniiNaKrivku(var Lin: TLin; Blok: TBlokPtr): boolean;
var
  NoveUzly: PUzly;
  NovyPocet,i : word;
begin
  if not NaplnPoleZDisku(Lin, Blok) then
  begin
     PrevedLiniiNaKrivku := Ne;
     exit;
  end;
  NovyPocet := PocetUzlu+4;
  GetMem(NoveUzly,(NovyPocet)*SizeOf(TSour));
  if not Assigned(NoveUzly) then
  begin
     PrevedLiniiNaKrivku := Ne;
     exit;
  end;
  Move(Uzly^[0],NoveUzly^[2],PocetUzlu*sizeOf(TSour));
  for i := 0 to 1 do NoveUzly^[i] := NoveUzly^[2];
  for i := (NovyPocet-2) to (NovyPocet-1) do
      NoveUzly^[i] := NoveUzly^[(NovyPocet-3)];
  FreeMem(Uzly,(PocetUzlu)*SizeOf(TSour));
  PocetUzlu := NovyPocet;
  Uzly      := NoveUzly;
  Lin.Atributy := [lnKrivka,lnFerguson];
  PridejSeznamBodu(Blok,Lin.PrvniSour,Lin.PosledniSour);
  Blok^.PisLinii(Lin.Cislo,Lin);
  PrevedLiniiNaKrivku := Ano;
end;


{------------------------------------------------}
procedure   TKrivka.PridejSeznamBodu (    Blok: TBlokPtr;
                                      var Prvni, Posledni: longInt);
{ prida pole bodu k souboru souradnic ... predpoklada, ze je otevreny }
var
  i : longint;
begin
  if Uzly <> nil then
  begin
    Prvni   := Blok^.DejPocetSour;
    for i := 0 to PocetUzlu - 1 do
    begin
      Blok^.PridejSour(Uzly^[i]);
    end;
    Posledni:= Prvni + PocetUzlu - 1
  end
  else
  begin
    Prvni   := -1;
    Posledni:= -1
  end
end;

{------------------------------------------------}
procedure   TKrivka.UlozSeznamBodu (    Blok: TBlokPtr;
                                    var Prvni, Posledni: longInt);
  { Ulozi pole bodu do souboru souradnic ... predpoklada, ze je otevreny }
  var
    i : longint;
    CSour: LongInt;
  begin
    if Uzly <> nil then
    begin
      CSour := Prvni;
      for i := 0 to PocetUzlu - 1 do
      begin
        Blok^.PisSour(CSour, Uzly^[i]);
        Inc(CSour);
      end;
      Posledni:= Prvni + PocetUzlu - 1
    end;
  end;


{------------------------------------------------}
procedure   TKrivka.UvolniPole;
  begin
     if Uzly <> nil then FreeMem(Uzly,PocetUzlu*SizeOf(TSour));
     Uzly := nil;
     Pocetuzlu := 0;
  end;

{------------------------------------------------}
procedure   TKrivka.UlozKrivkuNaDisk(Lin: TLin; Kontrola: Boolean);
  { Ulozi krivku jako linii ... predpoklada, ze je nastaven ops.obd., delka,
    poloha symbolu, atributy a jine blbiny}
  var
     Blok: TBlokPtr;
  begin
     Blok := PredmetZajmu^.DejAktBlokPtr;
     if Blok^.JeEditovatelny(true) then
     begin
        Blok^.OtevriSoubory(true);
        { Fungl nova linie }
        if Lin.Cislo = -1 then
        begin
           PridejSeznamBodu(Blok,Lin.PrvniSour,Lin.PosledniSour);
           Blok^.PridejLinii(Lin);
        end
        { Existujici linie }
        else begin
           { Pokud je pozadovana kontrola poctu souradnic }
           if Kontrola then
           begin
              if PocetUzlu > Lin.PosledniSour - Lin.PrvniSour + 1 then
                 PridejSeznamBodu(Blok,Lin.PrvniSour,Lin.PosledniSour) else
                 UlozSeznamBodu  (Blok,Lin.PrvniSour,Lin.PosledniSour);
           end
           { Pokud ne tak ... }
           else  UlozSeznamBodu  (Blok,Lin.PrvniSour,Lin.PosledniSour);
           Blok^.PisLinii(Lin.Cislo, Lin);
        end;
        Blok^.ZavriSoubory;
     end;
  end;


{------------------------------------------------}
function    TKrivka.VratKrok: Real;
  begin
{$IFDEF WINDOWS}
       VratKrok := PixKrok/PVektorOkno(Okno)^.KVert;
{$ELSE}
       VratKrok := PixKrok/Zobrazovac.KVert;
{$ENDIF}
  end;

{------------------------------------------------}
procedure   TKrivka.VratOpsanyObdelnik (var OpsObd: TObdelnik);
  begin
     Abstract;
  end;

{------------------------------------------------}
function    TKrivka.VytvorNovePole: Boolean;
  begin
     VytvorNovepole := Ne;
     if MinimalniPocetUzlu > 0 then
     begin
        if Uzly <> nil then UvolniPole;
        PocetUzlu := 0;
        GetMem(Uzly,MinimalnipocetUzlu * SizeOf(TSour));
        if Uzly <> nil then
        begin
           VytvorNovePole := Ano;
           PocetUzlu := MinimalniPocetUzlu;
        end;
     end;
  end;

{$IFNDEF WINDOWS}
{------------------------------------------------}
procedure   TKrivka.VystupDoHPGL ( Vyrez: TObdelnik;
                                   Meritko: real);
  begin
     Abstract;
  end;

{------------------------------------------------}
procedure   TKrivka.VystupDoHPGLZeSeznamu ( PSeznam: TLomBodPtr;
                                            Vyrez: TObdelnik;
                                            Meritko: real);
  begin
     if not NaplnPoleZeSeznamu(PSeznam) then
     Begin
        Hlaska(hlKrivky1+hlKrivky2);
        exit;
     end;
     Krok := VratKrok;
     VystupDoHPGL ( Vyrez, Meritko);
  end;

{$ENDIF}

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TKrivka.ZobrazRealne ( Orez: Boolean);
{$ELSE}
procedure   TKrivka.ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                   Nastavit: boolean;
                                   Orez: Boolean);
{$ENDIF}
  begin
     Abstract;
  end;

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TKrivka.ZobrazRealneZDisku( Linie: TLin;
                                        PBlok: TBlokPtr;
                                        Orezavat: Boolean);
  var
     Retezec1: array[0..255]of char;

  begin
     if not NaplnPoleZDisku(Linie,PBlok) then
     Begin
         LoadString(HInstance, 8000, Retezec1, 256);
         Hlaska(StrPas(Retezec1));
         {' ... Nedostatecna velikost pameti '}
        exit;
     end;
     ZobrazRealne(Orezavat);
  end;

{$ELSE}   {......................................}

procedure   TKrivka.ZobrazRealneZDisku(Linie: TLin;
  {|}                                  Barva, Typ, ZobrMod: integer;
  {|}                                  Nastavit: boolean;
  {|}                                  PBlok: TBlokPtr;
  {|}                                  Orezavat: Boolean);
  begin
     if not NaplnPoleZDisku(Linie,PBlok) then
     Begin
        Hlaska(hlKrivky1+hlKrivky2);
        exit;
     end;
     ZobrazRealne(Barva, Typ, ZobrMod, Nastavit, Orezavat);
  end;
{$ENDIF}

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TKrivka.ZobrazRealneZeSeznamu( PSeznam: TLomBodPtr;
                                           Orezavat: Boolean);
  var
     Retezec1: array[0..255]of char;
  begin
     if not NaplnPoleZeSeznamu(PSeznam) then
     Begin
         LoadString(HInstance, 8000, Retezec1, 256);
         Hlaska(StrPas(Retezec1));
         {' ... Nedostatecna velikost pameti '}
        exit;
     end;
     ZobrazRealne(Orezavat);
  end;
{$ELSE}
procedure   TKrivka.ZobrazRealneZeSeznamu(PSeznam: TLomBodPtr;
  {|}                                     Barva, Typ, ZobrMod: integer;
  {|}                                     Nastavit: boolean;
  {|}                                     Orezavat: Boolean);
  begin
     if not NaplnPoleZeSeznamu(PSeznam) then
     Begin
        Hlaska(hlKrivky1+hlKrivky2);
        exit;
     end;
     ZobrazRealne(Barva, Typ, ZobrMod, Nastavit, Orezavat);
  end;
{$ENDIF}


{================================================}


   { Tela metod TElipsa }


{================================================}

{ rychla elipsa v celociselnem zobrazeni }

{$IFNDEF WINDOWS}
procedure ElipsaInt(x,y,a,b: longint; Uhel: real; Barva: Word);
  var
     U: real;
     x0,y0: LongInt;
     Pomx,Pomy: LongInt;
     x1,y1: LongInt;
     x2,y2: LongInt;
     sinUhel,cosUhel: Longint;
     i: word;

  begin
     SetColor(Barva);
     Uhel    := 0 - Uhel;
     sinUhel := Round(Sin(Uhel)*UnivDelitel);
     cosUhel := Round(Cos(Uhel)*UnivDelitel);
     x2 := a*cosUhel div UnivDelitel;
     y2 := a*sinUhel div UnivDelitel;

     MoveTo(x+x2,y+y2);
     x0 := 0;
     y0 := 0;
     for i := 0 to 74 do
     begin
        x1 := LongInt(cosy[i])*a;
        y1 := LongInt(siny[i])*b;
        if (x1 = x0) and (y1 = y0) then continue
        else begin
           x0 := x1;
           y0 := y1;
        end;
        x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel2;
        y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel2;
        PomX := x+x2;
        PomY := y+y2;
        LineTo(PomX,PomY);
        LineTo(PomX,PomY);

     end;
     x2 := a*cosUhel div UnivDelitel;
     y2 := a*sinUhel div UnivDelitel;

     LineTo(x+x2,y+y2);

  end;

{ Elipsa do bufferu .. treba pro plochu a tak }
{ ------------------------------------------- }

procedure ElipsaIntDoBuffferu(x,y,a,b: longint; Uhel: real;
                              var PocetLB: integer; var Buffer: Pointer);
  var
     U: real;
     x0,y0: LongInt;
     Pomx,Pomy: LongInt;
     x1,y1: LongInt;
     x2,y2: LongInt;
     sinUhel,cosUhel: Longint;
     i: word;
     Vrcholy: PLongVrcholy;
     IB: integer;
  begin
     PocetLB := 77;
     GetMem(Vrcholy,PocetLB * SizeOf(TLongSour));
     Buffer := Vrcholy;
     if not Assigned(Buffer)then exit;
     IB := 1;

     Uhel    := 0 - Uhel;
     sinUhel := Round(Sin(Uhel)*UnivDelitel);
     cosUhel := Round(Cos(Uhel)*UnivDelitel);
     x2 := a*cosUhel div UnivDelitel;
     y2 := a*sinUhel div UnivDelitel;

     Vrcholy^[IB].x := x+x2;
     Vrcholy^[IB].y := y+y2;
     inc(IB);
     x0 := 0;
     y0 := 0;
     for i := 0 to 74 do
     begin
        x1 := LongInt(cosy[i])*a;
        y1 := LongInt(siny[i])*b;
        if (x1 = x0) and (y1 = y0) then continue
        else begin
           x0 := x1;
           y0 := y1;
        end;
        x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel2;
        y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel2;
        PomX := x+x2;
        PomY := y+y2;

        Vrcholy^[IB].x := PomX;
        Vrcholy^[IB].y := PomY;
        inc(IB);

     end;
     x2 := a*cosUhel div UnivDelitel;
     y2 := a*sinUhel div UnivDelitel;

     Vrcholy^[IB].x := x+x2;
     Vrcholy^[IB].y := y+y2;

  end;
{$ENDIF}
{================================================}

constructor TElipsa.Init;
  begin
     Inherited Init;
     MinimalniPocetUzlu := 3;
  end;
{------------------------------------------------}

function    TElipsa.DelkaKrivky: Real;
  begin
     if Uzly <> nil then
     begin
        if Kruznice then DelkaKrivky := PParametryElipsy(Uzly)^.a * DvaPI
                    else DelkaKrivky :=(PParametryElipsy(Uzly)^.a +
                                        PParametryElipsy(Uzly)^.b)* PI;
     end
     else DelkaKrivky := 0;
  end;

{------------------------------------------------}
function    TElipsa.KrivkaVObdelniku(Obdelnik: TObdelnik): boolean;
  var
     x1,y1  : real;
     x2,y2  : real;
     Alfa   : real;
     dU     : real;
     Krucek : real;
     Stred  : TSour;
     sinUhel,
     cosUhel: real;
     i,j    : word;
     Oblouk : TOblouk;         { Orezavaci oblouk }
     Uhel1,
     Uhel2  : real;            { Uhly pro oriznuti elipsy na oblouk }
     Orez   : boolean;
     OS,NS  : TSour;

  begin
     KrivkaVObdelniku := Ne;
     Par   := PParametryElipsy(Uzly);

     { Kontrola, zda je Elipsa v Obdelniku }
     { ----------------------------------- }
     if not OrezNaOblouk(Obdelnik, Uhel1, Uhel2 ,Orez) then exit { asi ne };
     if Orez then
     begin
        Oblouk.Init;
        if not Oblouk.VytvorNovePole then
        begin
           Oblouk.Done;
           Exit;
        end;
        Oblouk.ParO := PParametryOblouku(Oblouk.Uzly);
        Move (Par^, Oblouk.ParO^,SizeOf(TParametryElipsy));
        Oblouk.ParO^.Zacatek := Uhel1;
        Oblouk.ParO^.Konec   := Uhel2;
        KrivkaVObdelniku := Oblouk.KrivkaVObdelniku(Obdelnik);
        Oblouk.Done;
        exit;
     end;

     sinUhel := (Sin(Par^.Uhel));
     cosUhel := (Cos(Par^.Uhel));
     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

     { Nastaveni pera na pocatek vykresl. elipsy }
     { ----------------------------------------- }
     OS.y := Par^.y-y2;
     OS.x := Par^.x-x2;

     { Vypocet delky elipt. usece v pixelech }
     { ------------------------------------- }
{$IFDEF WINDOWS}
     Krucek := (tan(deltaU) * Par^.a) * PVektorOkno(State^.ZobrOkno)^.KVert;
{$ELSE}
     Krucek := (tan(deltaU) * Par^.a) * Zobrazovac.KVert;
{$ENDIF}

     if (Krucek > PixKrok) then { Tutove orezavani }
     begin
{$IFDEF WINDOWS}
        dU   := ArcTan((PixKrok/PVektorOkno(State^.ZobrOkno)^.KVert)/Par^.a);
{$ELSE}
        dU   := ArcTan((PixKrok/Zobrazovac.KVert)/Par^.a);
{$ENDIF}
        Alfa := dU;
        while Alfa < 6.28 do
        begin
           x1 := (Par^.a*(cos(Alfa)));
           y1 := (Par^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

           NS.y := Par^.y-y2;
           NS.x := Par^.x-x2;
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end;
           OS := NS;
           Alfa := Alfa+dU;
        end;
     end
     else begin
        for i := 0 to 74 do
        begin
           x1 := (Par^.a*(cosy[i]));
           y1 := (Par^.b*(siny[i]));
           y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
           x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

           NS.y := Par^.y-y2;
           NS.x := Par^.x-x2;
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end;
           OS := NS;
        end;
     end;
     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

     NS.y := Par^.y-y2;
     NS.x := Par^.x-x2;
     KrivkaVObdelniku := CaraVObdelniku(OS,NS,Obdelnik) ;
  end;

{------------------------------------------------}

function    TElipsa.OrezNaOblouk (    Obdelnik: TObdelnik;
                                  var Uhel1, Uhel2: real;
                                  var Orez: boolean): boolean;
  type
     TAnal = record
        Sour: TSour;
        Uh  : real;     { Uhel }
        Vzd : real;     { vzdalenost od stredu }
        RVzd: real;     { skutecna vzdal. k elipse }
     end;
  var
     Stred: TSour;
     PomBod: TSour;
     PomUhel: real;
     PolohaStredu: TPoloha;
     Vyrez: TObdelnik;
     LH,PH,LD,PD: TAnal;

  { Otoci sledovany bod o Uhel do zakl. polohy }
  procedure OtocBod(var B: TSour);
  begin
     PomUhel  := 0 - Par^.Uhel;
     PomBod.y := B.y - Stred.y;
     PomBod.x := B.x - Stred.x;
     B.y  := (PomBod.y*cos(PomUhel)-PomBod.x*sin(PomUhel));
     B.x  := (PomBod.y*sin(PomUhel)+PomBod.x*cos(PomUhel));
  end;

  begin
     { nastaveni pole Par je zvlast kvuliva obloukum }
     Par := PParametryElipsy(Uzly);
     OrezNaOblouk := Ne;
     Orez         := Ano;

     Vyrez   := Obdelnik;

     { Souradnice }
     PH.Sour := Vyrez.PH;
     LD.Sour := Vyrez.LD;
     LH.Sour.y := LD.Sour.y;
     LH.Sour.x := PH.Sour.x;
     PD.Sour.y := PH.Sour.y;
     PD.Sour.x := LD.Sour.x;
     { Uhly a Vzdalenosti od stredu }
     Stred.y := Par^.y;
     Stred.x := Par^.x;
     { Sklopeni Souradnic o uhel elipsy }
     OtocBod(PH.Sour);
     OtocBod(PD.Sour);
     OtocBod(LH.Sour);
     OtocBod(LD.Sour);

     with PH do VratUhelAVzdalBoduOdStredu(Sour, Uh, Vzd, Ne);
     with PD do VratUhelAVzdalBoduOdStredu(Sour, Uh, Vzd, Ne);
     with LH do VratUhelAVzdalBoduOdStredu(Sour, Uh, Vzd, Ne);
     with LD do VratUhelAVzdalBoduOdStredu(Sour, Uh, Vzd, Ne);

     VratBodPodUhlem(PH.Uh, PomBod);
     PH.RVzd := VzdalenostBodu(Stred, PomBod);
     VratBodPodUhlem(PD.Uh, PomBod);
     PD.RVzd := VzdalenostBodu(Stred, PomBod);
     VratBodPodUhlem(LH.Uh, PomBod);
     LH.RVzd := VzdalenostBodu(Stred, PomBod);
     VratBodPodUhlem(LD.Uh, PomBod);
     LD.RVzd := VzdalenostBodu(Stred, PomBod);

     { Zjistuji, v jake poloze je stred }
     VratPolohuBodu(Stred, Vyrez, PolohaStredu);
     { Vlevo }
     if Vlevo  in PolohaStredu then
     begin
        { Vlevo Nahore }
        if Nahore in PolohaStredu then
        begin
           { Vyrez je uvnitr elipsy }
           if (PH.Vzd < PH.RVzd) and
              (PD.Vzd < PD.RVzd) and
              (LD.Vzd < LD.RVzd) then exit;
           Uhel1 := LD.Uh;
           Uhel2 := PH.Uh;
        end else
        { Vlevo Dole }
        if Dole in PolohaStredu then
        begin
           { Vyrez je uvnitr elipsy }
           if (LH.Vzd < LH.RVzd) and
              (PH.Vzd < PH.RVzd) and
              (PD.Vzd < PD.RVzd) then exit;
           Uhel1 := PD.Uh;
           Uhel2 := LH.Uh;
        end else
        { Vlevo uprostred }
        begin
           { Vyrez je uvnitr elipsy }
           if (PH.Vzd < PH.RVzd) and
              (PD.Vzd < PD.RVzd) then exit;
           Uhel1 := LD.Uh;
           Uhel2 := LH.Uh;
        end;
     end else
     { Vpravo }
     if Vpravo in PolohaStredu then
     begin
        { Vpravo Nahore }
        if Nahore in PolohaStredu then
        begin
           { Vyrez je uvnitr elipsy }
           if (LH.Vzd < LH.RVzd) and
              (LD.Vzd < LD.RVzd) and
              (PD.Vzd < PD.RVzd) then exit;
           Uhel1 := LH.Uh;
           Uhel2 := PD.Uh;
        end else
        { Vpravo Dole }
        if Dole in PolohaStredu then
        begin
           { Vyrez je uvnitr elipsy }
           if (PH.Vzd < PH.RVzd) and
              (LH.Vzd < LH.RVzd) and
              (LD.Vzd < LD.RVzd) then exit;
           Uhel1 := PH.Uh;
           Uhel2 := LD.Uh;
        end else
        { Vpravo uprostred }
        begin
           { Vyrez je uvnitr elipsy }
           if (LH.Vzd < LH.RVzd) and
              (LD.Vzd < LD.RVzd) then exit;
           Uhel1 := PH.Uh;
           Uhel2 := PD.Uh;
        end;
     end else
     { Nahore uprostred }
     if Nahore in PolohaStredu then
     begin
        { Vyrez je uvnitr elipsy }
        if (PD.Vzd < PD.RVzd) and
           (LD.Vzd < LD.RVzd) then exit;
        Uhel1 := LH.Uh;
        Uhel2 := PH.Uh;
     end else
     { Dole uprostred }
     if Dole in PolohaStredu then
     begin
        { Vyrez je uvnitr elipsy }
        if (PH.Vzd < PH.RVzd) and
           (LH.Vzd < LH.RVzd) then exit;
        Uhel1 := PD.Uh;
        Uhel2 := LD.Uh;
     end
     { Stred lezi ve vyrezu }
     else begin
        { Vyrez je uvnitr elipsy }
        if (PH.Vzd < PH.RVzd) and
           (PD.Vzd < PD.RVzd) and
           (LH.Vzd < LH.RVzd) and
           (LD.Vzd < LD.RVzd) then exit;
        Orez := Ne;
     end;

     OrezNaOblouk := Ano;

  end;

{------------------------------------------------}
procedure   TElipsa.PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                      OtevreneSoub: boolean);
  var
     x1,y1  : real;
     x2,y2  : real;
     Alfa   : real;
     dU     : real;
     Krucek : real;
     Stred  : TSour;
     sinUhel,
     cosUhel: real;
     i,j    : word;
     Ro     : real;
     Sour   : TSour;
{$IFNDEF WINDOWS}
     Htx,Dtx: TTextNapovedy;
{$ENDIF}
     CLinStr: String;

  begin
     if not OtevreneSoub then PBlok^.OtevriSoubory(false);
     if not Assigned(Uzly) then if not NaplnPoleZDisku(Linie,PBlok) then
     begin
        if not OtevreneSoub then PBlok^.ZavriSoubory;
        exit;
     end;
     Par   := PParametryElipsy(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if Par^.b > Par^.a then
     begin
        Krucek := Par^.a;
        Par^.a := Par^.b;
        Par^.b := Krucek;
        Par^.Uhel := Par^.Uhel + PiPul;
        NacpiUhelDoDvaPi(Par^.Uhel);
     end;

     { Vypocet KrokovehoUhlu }
     { --------------------- }
     if PresnostKrivek > 0 then
     begin
        if PevnaDelkaVertexu then
           Ro := SQRT(SQR(Par^.a)-SQR(PresnostKrivek/2))
        else
           Ro := Par^.a - PresnostKrivek;
        dU := 2*ACos(Ro/Par^.a);
     end
{$IFNDEF WINDOWS}
     else dU := ArcTan((PixKrok/Zobrazovac.KVert)/Par^.a);
{$ELSE}
     else dU := ArcTan((PixKrok/PVektorOkno(State^.ZobrOkno)^.KVert)/Par^.a);
{$ENDIF}
     with Linie do
     begin

        PrvniSour    := PBlok^.DejPocetSour;
        PosledniSour := PrvniSour;
{$IFNDEF WINDOWS}
        UlozNapovedu(Htx,Dtx);
        Str(Cislo,CLinStr);
        CLinStr := hlKrivky101 + CLinStr;
        BeznaNapoveda(CLinStr,'');
{$ENDIF}
        sinUhel := (Sin(Par^.Uhel));
        cosUhel := (Cos(Par^.Uhel));
        y2 := (Par^.a*cosUhel) ;
        x2 := (Par^.a*sinUhel) ;

        Sour.y := Par^.y-y2;
        Sour.x := Par^.x-x2;
        PBlok^.PridejSour(Sour);

        Alfa := dU;
        while Alfa < 6.28 do
        begin
           x1 := (Par^.a*(cos(Alfa)));
           y1 := (Par^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

           Sour.y := Par^.y-y2;
           Sour.x := Par^.x-x2;
           Inc(PosledniSour);
           PBlok^.PridejSour(Sour);

           Alfa := Alfa+dU;
        end;

        y2 := (Par^.a*cosUhel) ;
        x2 := (Par^.a*sinUhel) ;

        Sour.y := Par^.y-y2;
        Sour.x := Par^.x-x2;
        Inc(PosledniSour);
        PBlok^.PridejSour(Sour);

        Atributy := Atributy - [lnKrivka];
     end;
{$IFNDEF WINDOWS}
     BeznaNapoveda(Htx,Dtx);
{$ENDIF}

     PBlok^.PisLinii(Linie.Cislo,Linie);
     if not OtevreneSoub then PBlok^.ZavriSoubory;
  end;

{------------------------------------------------}

{ Vraci bod elipsy pod zadanym uhlem .. predpoklada, ze Par ukazuje na
  parametry elipsy. }

procedure   TElipsa.VratBodPodUhlem(Alfa: real; var Bod: TSour);
  var
     x1,y1: Real;
     sinUhel,cosUhel: Real;
  begin
     sinUhel := (Sin(Par^.Uhel));
     cosUhel := (Cos(Par^.Uhel));
     x1      := (Par^.a*(cos(Alfa)));
     y1      := (Par^.b*(sin(Alfa)));
     Bod.y   := (x1*cosUhel-y1*sinUhel);
     Bod.x   := (x1*sinUhel+y1*cosUhel);
     Bod.y   := Par^.y - Bod.y;
     Bod.x   := Par^.x - Bod.x;
  end;


{------------------------------------------------}
procedure   TElipsa.VratOpsanyObdelnik (var OpsObd: TObdelnik);
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     sinUhel,cosUhel: Real;
     Cedit: Boolean;
     i,j  : word;
     Pridat: real;
  begin
     if Kruznice then with PParametryElipsy(Uzly)^ do
     begin;
        with OpsObd do
          case SourSystem of
            JTSK        : begin
                            PH.y := y - a;
                            PH.x := x - a;
                            LD.y := y + a;
                            LD.x := x + a;
                          end;
            Matematicky,
            Gauss       : begin
                            PH.y := y + a;
                            PH.x := x + a;
                            LD.y := y - a;
                            LD.x := x - a;
                          end;
          end;
     end
     else
        with OpsObd do
        begin
           Par   := PParametryElipsy(Uzly);
           sinUhel := (Sin(Par^.Uhel));
           cosUhel := (Cos(Par^.Uhel));
           y2 := (Par^.a*cosUhel) ;
           x2 := (Par^.a*sinUhel) ;

           PH.y := y2;
           PH.x := x2;
           LD.y := y2;
           LD.x := x2;

           for i := 0 to 74 do
           begin
              x1 := (Par^.a*(cosy[i]));
              y1 := (Par^.b*(siny[i]));
              y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
              x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

              if y2 > PH.y then PH.y := y2;
              if x2 > PH.x then PH.x := x2;
              if y2 < LD.y then LD.y := y2;
              if x2 < LD.x then LD.x := x2;
           end;
           PH.y := Par^.y - PH.y;
           PH.x := Par^.x - PH.x;
           LD.y := Par^.y - LD.y;
           LD.x := Par^.x - LD.x;
        end;

{$IFDEF WINDOWS}
        Pridat := 2/PVektorOkno(Okno)^.KVert;
{$ELSE}
        Pridat := 2/Zobrazovac.KVert;
{$ENDIF}
        with OpsObd do
          case SourSystem of
            JTSK        : begin
                             PH.y := PH.y - Pridat;
                             PH.x := PH.x - Pridat;
                             LD.y := LD.y + Pridat;
                             LD.x := LD.x + Pridat;
                          end;
            Matematicky,
            Gauss       : begin
                             PH.y := PH.y + Pridat;
                             PH.x := PH.x + Pridat;
                             LD.y := LD.y - Pridat;
                             LD.x := LD.x - Pridat;
                          end;
          end;
     end;

{------------------------------------------------}
{ Parametr Tocit informuje o tom, zda Bod je v relativnich sour ke stredu
  a zda je otocen o uh. Elipsy }
procedure   TElipsa.VratUhelAVzdalBoduOdStredu(    Bod: TSour;
                                               var SklUhel, Vzdal: real;
                                                   Tocit: boolean);
  var
    dX,dY: real;
    PomdX: real;
    PomdY: real;
    PomR : real;
    SinU : real;
    CosU : real;
    BdivA: real;

  begin

    if Tocit then
    begin
       { Souradnicove rozdily bodu od Stredu }
       PomdX := Bod.x - Par^.x;
       PomdY := Bod.y - Par^.y;
       { Otoceni Bodu kolem Stredu }
       SinU := Sin(Par^.Uhel);
       CosU := Cos(Par^.Uhel);
       dY   := (PomdX*cosU-PomdY*sinU);
       dX   := (PomdX*sinU+PomdY*cosU);
    end
    else begin
       dX := Bod.x;
       dY := Bod.y;
    end;

    { Uprava dX ...sklopeni na principu pod. trojuh.}
    if Par^.a <> 0 then BdivA := (Par^.b / Par^.a)
                   else BdivA := 1;
    dX := dX / BdivA;

    { Vlastni vypocet uhlu a vzdal. bodu }
    if dY = 0 then begin
       if dX < 0 then SklUhel := PI/2
                 else SklUhel := 1.5*PI;
       Vzdal := Abs(dX * BdivA);
    end
    else begin
       if dY<0 then PomR :=  0
               else PomR := PI;
       SklUhel  := PomR + ArcTAN(dX/dY);
       Vzdal := SQRT(SQR(dY)+SQR(dX * BdivA));
    end;
    { Uhel rveme do tradicniho intervalu }
    NacpiUhelDoDvaPi(SklUhel);
  end;

{$IFNDEF WINDOWS}
{------------------------------------------------}
procedure   TElipsa.VystupDoHPGL ( Vyrez: TObdelnik;
                                     Meritko: real);
  var
     x1,y1  : real;
     x2,y2  : real;
     Alfa   : real;
     dU     : real;
     Krucek : real;
     Stred  : TSour;
     sinUhel,
     cosUhel: real;
     i,j    : word;
     Ro     : real;
     Sour   : TSour;
     Orez   : boolean;
     Oblouk : TOblouk;
     Uhel1,
     Uhel2  : real;
     Presnost: real;
     PomStr : String;
     PlotSour: TPlotSour;


  begin
     Par   := PParametryElipsy(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if Par^.b > Par^.a then
     begin
        Krucek := Par^.a;
        Par^.a := Par^.b;
        Par^.b := Krucek;
        Par^.Uhel := Par^.Uhel + PiPul;
        NacpiUhelDoDvaPi(Par^.Uhel);
     end;

     { Kontrola, zda se Elipsa se bude ukladat }
     if not OrezNaOblouk(Zobrazovac.RozmerVyrezu,Uhel1, Uhel2 ,Orez) then
        exit { asi ne };
     if Orez then
     begin
        Oblouk.Init;
        if not Oblouk.VytvorNovePole then
        begin
           Oblouk.Done;
           Exit;
        end;
        Oblouk.ParO := PParametryOblouku(Oblouk.Uzly);
        Move (Par^, Oblouk.ParO^,SizeOf(TParametryElipsy));
        Oblouk.ParO^.Zacatek := Uhel1;
        Oblouk.ParO^.Konec   := Uhel2;
        Oblouk.VystupDoHPGL(Vyrez, Meritko);
        Oblouk.Done;
        exit;
     end;
     { Vypocet KrokovehoUhlu }
     { --------------------- }
     Presnost := PresnostHPGL * Meritko;
     if (Presnost > 0) and (Par^.a > Presnost) then
     begin
        Ro := Par^.a - Presnost;
        dU := 2*ACos(Ro/Par^.a);
     end
     else dU := deltaU;



     sinUhel := (Sin(Par^.Uhel));
     cosUhel := (Cos(Par^.Uhel));
     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

     Sour.y := Par^.y-y2;
     Sour.x := Par^.x-x2;
     DejPlotSour (Sour, PlotSour);
     PomStr := 'PU;PA'
                    +LStr (PlotSour.X)+
               ','  +LStr (PlotSour.Y)+ ';'
               +'PD;PA';
     HPGL( PomStr);


     Alfa := dU;
     while Alfa < 6.28 do
     begin
        x1 := (Par^.a*(cos(Alfa)));
        y1 := (Par^.b*(sin(Alfa)));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        Sour.y := Par^.y-y2;
        Sour.x := Par^.x-x2;

        DejPlotSour (Sour, PlotSour);
        PomStr :=   LStr (PlotSour.X)+ ','
                   +LStr (PlotSour.Y)+ ',';
        HPGL( PomStr);

        Alfa := Alfa+dU;
     end;

     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

     Sour.y := Par^.y-y2;
     Sour.x := Par^.x-x2;

     DejPlotSour (Sour, PlotSour);
     PomStr :=   LStr (PlotSour.X)+ ','
                +LStr (PlotSour.Y)+ ';PU;';
     HPGL( PomStr);
  end;

{$ENDIF}
{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TElipsa.ZobrazRealne ( Orez: Boolean);
{$ELSE}
procedure   TElipsa.ZobrazRealne (Barva, Typ, ZobrMod: integer;
                                   Nastavit: boolean;
                                   Orez: Boolean);
{$ENDIF}
  var
     x1,y1  : real;
     x2,y2  : real;
     Alfa   : real;
     dU     : real;
     Krucek : real;
     Stred  : TSour;
     sinUhel,
     cosUhel: real;
     i,j    : word;
     Oblouk : TOblouk;         { Orezavaci oblouk }
     Uhel1,
     Uhel2  : real;            { Uhly pro oriznuti elipsy na oblouk }
  begin
     Par   := PParametryElipsy(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if Par^.b > Par^.a then
     begin
        Krucek := Par^.a;
        Par^.a := Par^.b;
        Par^.b := Krucek;
        Par^.Uhel := Par^.Uhel + PiPul;
        NacpiUhelDoDvaPi(Par^.Uhel);
     end;
     if Orez then
     begin
        { Kontrola, zda se Elipsa se bude zobrazovat }
{$IFDEF WINDOWS}
        if not OrezNaOblouk(PVektorOkno(Okno)^.RozmerJTSK,Uhel1, Uhel2 ,Orez) then
           exit { asi ne };
{$ELSE}
        if not OrezNaOblouk(Zobrazovac.RozmerVyrezu,Uhel1, Uhel2 ,Orez) then
           exit { asi ne };
{$ENDIF}
        if Orez then
        begin
           Oblouk.Init;
{$IFDEF WINDOWS}
           Oblouk.NastavDC(DC, Okno, BMP);
{$ENDIF}
           if not Oblouk.VytvorNovePole then
           begin
              Oblouk.Done;
              Exit;
           end;
           Oblouk.ParO := PParametryOblouku(Oblouk.Uzly);
           Move (Par^, Oblouk.ParO^,SizeOf(TParametryElipsy));
           Oblouk.ParO^.Zacatek := Uhel1;
           Oblouk.ParO^.Konec   := Uhel2;
{$IFDEF WINDOWS}
           Oblouk.ZobrazRealne(Ne);
{$ELSE}
           Oblouk.ZobrazRealne(Barva, Typ, ZobrMod, Nastavit, Ne);
{$ENDIF}
           Oblouk.Done;
           exit;
        end;
     end;

     { Nastaveni barev a tak ... ve Windows samozrejme ne }
     { -------------------------------------------------- }
{$IFNDEF WINDOWS}
     if Nastavit then
     begin
        SetWriteMode(ZobrMod);
        SetColor(Barva);
        NastaveniTypuCary(Typ);
     end;
{$ENDIF}

     sinUhel := (Sin(Par^.Uhel));
     cosUhel := (Cos(Par^.Uhel));
     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

     { Nastaveni pera na pocatek vykresl. elipsy }
     { ----------------------------------------- }
{$IFDEF WINDOWS}
     if BMP then
       PVektorOkno(Okno)^.MoveYXPaint(DC, Par^.y-y2, Par^.x-x2)
     else
       PVektorOkno(Okno)^.MoveYX(DC,  Par^.y-y2, Par^.x-x2);
{$ELSE}
     Zobrazovac.MoveYX(Par^.y-y2,Par^.x-x2);
{$ENDIF}

     { Vypocet delky elipt. usece v pixelech }
     { ------------------------------------- }
{$IFDEF WINDOWS}
     Krucek := (tan(deltaU) * Par^.a) * PVektorOkno(Okno)^.KVert;
{$ELSE}
     Krucek := (tan(deltaU) * Par^.a) * Zobrazovac.KVert;
{$ENDIF}

     if (Krucek > PixKrok) then { Tutove orezavani }
     begin
{$IFDEF WINDOWS}
        dU   := ArcTan((PixKrok/PVektorOkno(Okno)^.KVert)/Par^.a);
{$ELSE}
        dU   := ArcTan((PixKrok/Zobrazovac.KVert)/Par^.a);
{$ENDIF}
        Alfa := dU;
        while Alfa < 6.28 do
        begin
           x1 := (Par^.a*(cos(Alfa)));
           y1 := (Par^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

{$IFDEF WINDOWS}
           if BMP then
              PVektorOkno(Okno)^.LineYXPaint(DC, Par^.y-y2, Par^.x-x2)
           else
              PVektorOkno(Okno)^.LineYX(DC,  Par^.y-y2, Par^.x-x2);
{$ELSE}
           Zobrazovac.LineYX(Par^.y-y2,Par^.x-x2);
{$ENDIF}
           Alfa := Alfa+dU;
        end;
     end
     else begin
        for i := 0 to 74 do
        begin
           x1 := (Par^.a*(cosy[i]));
           y1 := (Par^.b*(siny[i]));
           y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
           x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

{$IFDEF WINDOWS}
           if BMP then
              PVektorOkno(Okno)^.LineYXPaint(DC, Par^.y-y2, Par^.x-x2)
           else
              PVektorOkno(Okno)^.LineYX(DC,  Par^.y-y2, Par^.x-x2);
{$ELSE}
           Zobrazovac.LineYX(Par^.y-y2,Par^.x-x2);
{$ENDIF}
        end;
     end;
     y2 := (Par^.a*cosUhel) ;
     x2 := (Par^.a*sinUhel) ;

{$IFDEF WINDOWS}
     if BMP then
        PVektorOkno(Okno)^.LineYXPaint(DC, Par^.y-y2, Par^.x-x2)
     else
        PVektorOkno(Okno)^.LineYX(DC,  Par^.y-y2, Par^.x-x2);
{$ELSE}
     Zobrazovac.LineYX(Par^.y-y2,Par^.x-x2);
{$ENDIF}

{$IFNDEF WINDOWS}
     { Reset vykreslovacich parametru }
     { ------------------------------ }
     SetWriteMode(NormalPut);
     NastaveniTypuCary(0);
{$ENDIF}
  end;
{================================================}


   { Tela metod TOblouk }


{================================================}

{ rychly oblouk v celociselnem zobrazeni }
{ ovsem achtung ! na rozdil od realneho zobrazovani tato metodka vykresluje
  oblouk od Zac do Kon pouze proti smeru hodinovych nozicek }

{$IFNDEF WINDOWS}
procedure ObloukInt(x,y,a,b: longint; Uhel,Zac,Kon: real; Barva: Word);
  var
     U: real;
     x0,y0: LongInt;
     Pomx,Pomy: LongInt;
     x1,y1: LongInt;
     x2,y2: LongInt;
     sinUhel,cosUhel: Longint;
     StartI,EndI: Integer;
     PomR: real;

  procedure KresliSegmentiky(Odkud,Kam: Word);
  var
     i: Word;
  begin
     x0 := 0;
     y0 := 0;
     for i := Odkud to Kam do
     begin
        x1 := LongInt(cosy[i])*a;
        y1 := LongInt(siny[i])*b;
        if (x1 = x0) and (y1 = y0) then continue
        else begin
           x0 := x1;
           y0 := y1;
        end;
        x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel2;
        y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel2;
        PomX := x+x2;
        PomY := y-y2;
        LineTo(PomX,PomY);
        LineTo(PomX,PomY);
     end;
  end;

  begin
     SetColor(Barva);
     {
     Uhel := 0 - Uhel;
     }
     { Uhly zacatku a konce je treba nacpat do intervalu <0,2> }
     if Zac > DvaPi then Zac := Zac-(Int(Zac/DvaPi)*DvaPi) else
        if Zac < 0 then Zac := DvaPi + Zac;
     if Kon > DvaPi then Kon := Kon-(Int(Kon/DvaPi)*DvaPi) else
        if Kon < 0 then Kon := DvaPi + Kon;

     { Indexy zacatku a konce }
     StartI := Round(Zac/deltaU)+1;
     EndI   := Round(Kon/deltaU)-1;
     if StartI > 74 then StartI := 1;
     if EndI   <  0 then EndI   := 74;


     sinUhel := Round(Sin(Uhel)*UnivDelitel);
     cosUhel := Round(Cos(Uhel)*UnivDelitel);

     x1   := Round(Cos(Zac)*a);
     y1   := Round(Sin(Zac)*b);
     x2   := (x1*cosUhel-y1*sinUhel) div UnivDelitel;
     y2   := (x1*sinUhel+y1*cosUhel) div UnivDelitel;

     MoveTo(x+x2,y-y2);

     x0 := 0;
     y0 := 0;
     if not ((EndI < StartI) and (Kon > Zac)) and
        not (StartI = EndI) then
     begin
        if EndI > StartI then
        begin
           KresliSegmentiky(StartI, EndI);
        end
        else begin
           KresliSegmentiky(StartI, 74);
           KresliSegmentiky(0, EndI);
        end;
     end;

     x1 := Round(Cos(Kon)*a);
     y1 := Round(Sin(Kon)*b);
     x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel;
     y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel;

     LineTo(x+x2,y-y2);
  end;

{ Celociselny oblouk nasypany do bufferu }
{ -------------------------------------- }
procedure ObloukIntDoBuffferu(x,y,a,b: longint; Uhel,Zac,Kon: real;
                              var PocetLB: integer; var Buffer: Pointer;
                              Pridat: integer);

  var
     U: real;
     x0,y0: LongInt;
     Pomx,Pomy: LongInt;
     x1,y1: LongInt;
     x2,y2: LongInt;
     sinUhel,cosUhel: Longint;
     StartI,EndI: Integer;
     PomR: real;
     Vrcholy: PLongVrcholy;
     IB: integer;                { index bufferu }
     PomLB : integer;

  procedure KresliSegmentiky(Odkud,Kam: Word);
  var
     i: Word;
  begin
     x0 := 0;
     y0 := 0;
     for i := Odkud to Kam do
     begin
        x1 := LongInt(cosy[i])*a;
        y1 := LongInt(siny[i])*b;
        if (x1 = x0) and (y1 = y0) then continue
        else begin
           x0 := x1;
           y0 := y1;
        end;
        x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel2;
        y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel2;
        PomX := x+x2;
        PomY := y-y2;

        Vrcholy^[IB].x := x+x2;
        Vrcholy^[IB].y := y+y2;
        inc(IB);
     end;
  end;

  begin
     {
     Uhel := 0 - Uhel;
     }
     { Uhly zacatku a konce je treba nacpat do intervalu <0,2> }
     if Zac > DvaPi then Zac := Zac-(Int(Zac/DvaPi)*DvaPi) else
        if Zac < 0 then Zac := DvaPi + Zac;
     if Kon > DvaPi then Kon := Kon-(Int(Kon/DvaPi)*DvaPi) else
        if Kon < 0 then Kon := DvaPi + Kon;

     { Indexy zacatku a konce }
     StartI := Round(Zac/deltaU)+1;
     EndI   := Round(Kon/deltaU)-1;
     if StartI > 74 then StartI := 1;
     if EndI   <  0 then EndI   := 74;


     sinUhel := Round(Sin(Uhel)*UnivDelitel);
     cosUhel := Round(Cos(Uhel)*UnivDelitel);

     x1   := Round(Cos(Zac)*a);
     y1   := Round(Sin(Zac)*b);
     x2   := (x1*cosUhel-y1*sinUhel) div UnivDelitel;
     y2   := (x1*sinUhel+y1*cosUhel) div UnivDelitel;


     x0 := 0;
     y0 := 0;
     IB := 1;
     if Pridat < 0 then PomLB := PocetLB * abs(Pridat)
                   else PomLB := PocetLB + Pridat;
     if not ((EndI < StartI) and (Kon > Zac)) and
        not (StartI = EndI) then
     begin
        if EndI > StartI then
        begin
           PocetLB := EndI - StartI + 3;
           if Pridat < 0 then PomLB := PocetLB * abs(Pridat)
                         else PomLB := PocetLB + Pridat;
           GetMem(Vrcholy, PomLB * SizeOf(TLongSour));
           Buffer := Vrcholy;
           if not Assigned(Buffer)then exit;
           Vrcholy^[IB].x := x+x2;
           Vrcholy^[IB].y := y+y2;
           inc(IB);
           KresliSegmentiky(StartI, EndI);
        end
        else begin
           PocetLB := (75 - StartI) + EndI + 3;
           if Pridat < 0 then PomLB := PocetLB * abs(Pridat)
                         else PomLB := PocetLB + Pridat;
           GetMem(Vrcholy, PomLB * SizeOf(TLongSour));
           Buffer := Vrcholy;
           if not Assigned(Buffer)then exit;
           Vrcholy^[IB].x := x+x2;
           Vrcholy^[IB].y := y+y2;
           inc(IB);
           KresliSegmentiky(StartI, 74);
           KresliSegmentiky(0, EndI);
        end;
     end;

     x1 := Round(Cos(Kon)*a);
     y1 := Round(Sin(Kon)*b);
     x2 := (x1*cosUhel-y1*sinUhel) div UnivDelitel;
     y2 := (x1*sinUhel+y1*cosUhel) div UnivDelitel;

     Vrcholy^[IB].x := x+x2;
     Vrcholy^[IB].y := y+y2;
  end;

{$ENDIF}

{------------------------------------------------}
constructor TOblouk.Init;
  begin
     Inherited Init;
     MinimalniPocetUzlu := 4;
  end;

{------------------------------------------------}

function    TOblouk.DelkaKrivky: Real;
  var
     Sweep: real;
  begin
     with PParametryOblouku(Uzly)^ do
     begin
        if Kruznice then
        begin
           if Zacatek > DvaPi then
              Zacatek := Zacatek-(Int(Zacatek/DvaPi)*DvaPi)  else
              if Zacatek < 0 then Zacatek := DvaPi + Zacatek;
           if Konec > DvaPi then
              Konec := Konec-(Int(Konec/DvaPi)*DvaPi)  else
              if Konec < 0 then Konec := DvaPi + Konec;
           if Konec >= Zacatek then Sweep := Konec - Zacatek
                               else Sweep := DvaPi + Konec - Zacatek;
           DelkaKrivky := Sweep*a;
        end
        else begin
           DelkaKrivky := 0;
        end;
     end;
  end;

{------------------------------------------------}
function    TOblouk.KrivkaVObdelniku(Obdelnik: TObdelnik): boolean;
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     Uhel1,
     Uhel2: real;
     U1,U2: real;
     sinUhel,cosUhel: Real;
     i,j  : word;
     StartI,EndI: Integer;
     Segment: LongInt;
     ZvetsOPi: boolean;
     OS,NS: TSour;
     Orez: boolean;
     PomVert: real;

  begin
{$IFDEF WINDOWS}
     PomVert := PVektorOkno(State^.ZobrOkno)^.KVert;
{$ELSE}
     PomVert := Zobrazovac.KVert;
{$ENDIF}
     KrivkaVObdelniku := Ne;
     ParO             := PParametryOblouku(Uzly);

     { Uhly ParO^.Zacatek a ParO^.Konec je treba nacpat do intervalu <0,2> }
     NacpiUhelDoDvaPi(ParO^.Zacatek);
     NacpiUhelDoDvaPi(ParO^.Konec);

     U1 := ParO^.Zacatek;
     U2 := ParO^.Konec;
     { Lezi vubec v obdelniku ? }
     { ------------------------ }
     if not OrezNaOblouk(Obdelnik,Uhel1, Uhel2 ,Orez) then
        exit { asi ne };
     { Nemilosrdne ofiknuti na vypoctene uhly }
     { -------------------------------------- }
     if Orez then
     begin
        { Vyrovnani intervalu ... pro zjisteni prekryvu }
        if (U1 > U2) or (Uhel1 > Uhel2) then
        begin
           U2    := U2 + DvaPi;
           Uhel2 := Uhel2 + DvaPi;
           ZvetsOpi := Ano
        end
        else ZvetsOpi := Ne;
        if Uhel1 > U1 then U1 := Uhel1;
        if Uhel2 < U2 then U2 := Uhel2;
        { pokud vyrez lezi mimo obouk tak opusteni }
        if U1 > U2 then exit;
        if ZvetsOPi then U2 := U2 - DvaPi;
        Orez := Ne;
     end;

     sinUhel := (Sin(ParO^.Uhel));
     cosUhel := (Cos(ParO^.Uhel));

     x1 := ParO^.a*(cos(U1));
     y1 := ParO^.b*(sin(U1));
     y2 := (x1*cosUhel-y1*sinUhel);
     x2 := (x1*sinUhel+y1*cosUhel);

     OS.y := ParO^.y-y2;
     OS.x := ParO^.x-x2;
     Segment := Round((tan(deltaU) * ParO^.a) * PomVert);

     Orez :=  (Segment > PixKrok) or (U2-U1 < deltaU);

     if not Orez then
     begin

     { Indexy zacatku a konce }
     StartI := Round(U1/deltaU)+1;
     EndI   := Round(U2/deltaU)-1;
     if StartI > 74 then StartI := 1;
     if EndI   <  0 then EndI   := 74;


        if StartI > EndI then
        begin
           for i := StartI to 74 do
           begin
              if i >= 75 then i := 0;
              x1 := (ParO^.a*(cosy[i]));
              y1 := (ParO^.b*(siny[i]));
              y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
              x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

              NS.y := ParO^.y-y2;
              NS.x := ParO^.x-x2;
              if CaraVObdelniku(OS,NS,Obdelnik) then
              begin
                 KrivkaVObdelniku := Ano;
                 exit;
              end;
              OS := NS;
           end;
           for i := 0 to EndI do
           begin
              if i >= 75 then i := 0;
              x1 := (ParO^.a*(cosy[i]));
              y1 := (ParO^.b*(siny[i]));
              y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
              x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

              NS.y := ParO^.y-y2;
              NS.x := ParO^.x-x2;
              if CaraVObdelniku(OS,NS,Obdelnik) then
              begin
                 KrivkaVObdelniku := Ano;
                 exit;
              end;
              OS := NS;

           end;
        end
        else
        for i := StartI to EndI do
        begin
           if i >= 75 then i := 0;
           x1 := (ParO^.a*(cosy[i]));
           y1 := (ParO^.b*(siny[i]));
           y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
           x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

           NS.y := ParO^.y-y2;
           NS.x := ParO^.x-x2;
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end;
           OS := NS;

        end;
     end
     else begin
        if Segment < PixKrokMin then
           dU   := ArcTan((PixKrokMin/PomVert)/ParO^.a) else
              if Segment > PixKrok then
                 dU   := ArcTan((PixKrok/PomVert)/ParO^.a)   else
                 dU   := DeltaU;
        Alfa := U1+dU;
        if U2 < U1 then
           U2 := U2 + DvaPI;
        while Alfa < U2 do
        begin
           x1 := (ParO^.a*(cos(Alfa)));
           y1 := (ParO^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

           NS.y := ParO^.y-y2;
           NS.x := ParO^.x-x2;
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end;
           OS := NS;
           Alfa := Alfa+dU;
        end;
     end;
     x1 := ParO^.a*(cos(U2));
     y1 := ParO^.b*(sin(U2));
     y2 := (x1*cosUhel-y1*sinUhel);
     x2 := (x1*sinUhel+y1*cosUhel);

     NS.y := ParO^.y-y2;
     NS.x := ParO^.x-x2;

     KrivkaVObdelniku := CaraVObdelniku(OS,NS,Obdelnik);
  end;

{------------------------------------------------}
procedure   TOblouk.PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                      OtevreneSoub: boolean);
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     Uhel1,
     Uhel2: real;
     U1,U2: real;
     sinUhel,cosUhel: Real;
     i,j  : word;
     PomR: real;
     Ro     : real;
     Sour   : TSour;
{$IFNDEF WINDOWS}
     Htx,Dtx: TTextNapovedy;
{$ENDIF}
     CLinStr: String;


  begin
     if not OtevreneSoub then PBlok^.OtevriSoubory(false);
     if not Assigned(Uzly) then if not NaplnPoleZDisku(Linie,PBlok) then
     begin
        if not OtevreneSoub then PBlok^.ZavriSoubory;
        exit;
     end;
     ParO     := PParametryOblouku(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if ParO^.b > ParO^.a then
     begin
        U1     := ParO^.a;
        ParO^.a := ParO^.b;
        ParO^.b := U1;
        ParO^.Uhel := ParO^.Uhel + PiPul;
        NacpiUhelDoDvaPi(ParO^.Uhel);
        ParO^.Zacatek := ParO^.Zacatek - PiPul;
        ParO^.Konec   := ParO^.Konec - PiPul;
     end;

     { Uhly ParO^.Zacatek a ParO^.Konec je treba nacpat do intervalu <0,2> }
     NacpiUhelDoDvaPi(ParO^.Zacatek);
     NacpiUhelDoDvaPi(ParO^.Konec);

     U1 := ParO^.Zacatek;
     U2 := ParO^.Konec;
     if U2 = 0 then U2 := DvaPi;

     { Vypocet KrokovehoUhlu }
     { --------------------- }
     if PresnostKrivek > 0 then
     begin
        if PevnaDelkaVertexu then
           Ro := SQRT(SQR(ParO^.a)-SQR(PresnostKrivek/2))
        else
           Ro := ParO^.a - PresnostKrivek;
        dU := 2*ACos(Ro/ParO^.a);
     end
{$IFDEF WINDOWS}
     else dU := ArcTan((PixKrok/PVektorOkno(State^.ZobrOkno)^.KVert)/ParO^.a);
{$ELSE}
     else dU := ArcTan((PixKrok/Zobrazovac.KVert)/ParO^.a);
{$ENDIF}


     with Linie do
     begin
        PrvniSour    := PBlok^.DejPocetSour;
        PosledniSour := PrvniSour;
{$IFNDEF WINDOWS}
        UlozNapovedu(Htx,Dtx);
        Str(Cislo,CLinStr);
        CLinStr := hlKrivky101 + CLinStr;
        BeznaNapoveda(CLinStr,'');
{$ENDIF}
        sinUhel := (Sin(ParO^.Uhel));
        cosUhel := (Cos(ParO^.Uhel));

        x1 := ParO^.a*(cos(U1));
        y1 := ParO^.b*(sin(U1));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        Sour.y := ParO^.y-y2;
        Sour.x := ParO^.x-x2;
        PBlok^.PridejSour(Sour);

        Alfa := U1+dU;
        if U2 < U1 then
           U2 := U2 + DvaPI;
        while Alfa < U2 do
        begin
           x1 := (ParO^.a*(cos(Alfa)));
           y1 := (ParO^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

           Sour.y := ParO^.y-y2;
           Sour.x := ParO^.x-x2;
           Inc(PosledniSour);
           PBlok^.PridejSour(Sour);

           Alfa := Alfa+dU;
        end;
        x1 := ParO^.a*(cos(U2));
        y1 := ParO^.b*(sin(U2));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        Sour.y := ParO^.y-y2;
        Sour.x := ParO^.x-x2;
        Inc(PosledniSour);
        PBlok^.PridejSour(Sour);

        Atributy := Atributy - [lnKrivka];
     end;
{$IFNDEF WINDOWS}
     BeznaNapoveda(Htx,Dtx);
{$ENDIF}
     PBlok^.PisLinii(Linie.Cislo,Linie);
     if not OtevreneSoub then PBlok^.ZavriSoubory;
  end;


{------------------------------------------------}
procedure   TOblouk.VratOpsanyObdelnik (var OpsObd: TObdelnik);
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     sinUhel,cosUhel: Real;
     Cedit: Boolean;
     StartI,EndI: Integer;
     Segment: LongInt;
     Pridat: real;


  procedure KontrolujSegmentiky(Odkud, Kam: word);
  var
     i: word;
  begin
     with OpsObd do
     for i := Odkud to Kam do
     begin
        if i >= 75 then i := 0;
        x1 := (ParO^.a*(cosy[i]));
        y1 := (ParO^.b*(siny[i]));
        y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
        x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

        if y2 > PH.y then PH.y := y2;
        if x2 > PH.x then PH.x := x2;
        if y2 < LD.y then LD.y := y2;
        if x2 < LD.x then LD.x := x2;

     end;
  end;


  begin
     ParO := PParametryOblouku(Uzly);
     with OpsObd, ParO^ do
     begin

        sinUhel := (Sin(Uhel));
        cosUhel := (Cos(Uhel));

        x1 := ParO^.a*(cos(Zacatek));
        y1 := ParO^.b*(sin(Zacatek));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        PH.y := y2;
        PH.x := x2;
        LD.y := y2;
        LD.x := x2;


        if ParO^.Zacatek < 0 then
           StartI:= Round((DvaPi + ParO^.Zacatek)/deltaU)+1 else
           if ParO^.Zacatek = 0 then StartI := 1 else
              if ParO^.Zacatek > DvaPi then
                 StartI:= Round((ParO^.Zacatek-DvaPi)/deltaU)+1 else
                    StartI:= Round(ParO^.Zacatek/deltaU)+1;
        if ParO^.Konec > DvaPi then
           EndI  := Round((ParO^.Konec-DvaPi)/deltaU)-1 else
           if ParO^.Konec = 0 then EndI := 74 else
              EndI  := Round(ParO^.Konec/deltaU)-1;
        if StartI > 74 then StartI := 1;
        if EndI < 0 then EndI := 74;
        if StartI > EndI then
        begin
           KontrolujSegmentiky(StartI, 74);
           KontrolujSegmentiky(0, EndI);
        end
        else
           KontrolujSegmentiky(StartI, EndI);

        x1 := ParO^.a*(cos(ParO^.Konec));
        y1 := ParO^.b*(sin(ParO^.Konec));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        if y2 > PH.y then PH.y := y2;
        if x2 > PH.x then PH.x := x2;
        if y2 < LD.y then LD.y := y2;
        if x2 < LD.x then LD.x := x2;

        PH.y := ParO^.y - PH.y;
        PH.x := ParO^.x - PH.x;
        LD.y := ParO^.y - LD.y;
        LD.x := ParO^.x - LD.x;
     end;
{$IFDEF WINDOWS}
     Pridat := 2/PVektorOkno(Okno)^.KVert;
{$ELSE}
     Pridat := 2/Zobrazovac.KVert;
{$ENDIF}
     with OpsObd do
       case SourSystem of
         JTSK        :  begin
                          PH.y := PH.y - Pridat;
                          PH.x := PH.x - Pridat;
                          LD.y := LD.y + Pridat;
                          LD.x := LD.x + Pridat;
                       end;
         Matematicky,
         Gauss       : begin
                          PH.y := PH.y + Pridat;
                          PH.x := PH.x + Pridat;
                          LD.y := LD.y - Pridat;
                          LD.x := LD.x - Pridat;
                       end;
       end;
  end;

{$IFNDEF WINDOWS}
{------------------------------------------------}
procedure   TOblouk.VystupDoHPGL ( Vyrez: TObdelnik;
                                   Meritko: real);
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     Uhel1,
     Uhel2: real;
     U1,U2: real;
     U3,U4: real;
     DvaUhly: boolean;
     sinUhel,cosUhel: Real;
     i,j  : word;
     PomR: real;
     Poprve: boolean;
     Orez: boolean;
     PomStr: String;
     PomSour: TSour;
     PlotSour: TPlotSour;
     Presnost: real;
     Ro: real;

  begin
     ParO     := PParametryOblouku(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if ParO^.b > ParO^.a then
     begin
        U1     := ParO^.a;
        ParO^.a := ParO^.b;
        ParO^.b := U1;
        ParO^.Uhel := ParO^.Uhel + PiPul;
        NacpiUhelDoDvaPi(ParO^.Uhel);
        ParO^.Zacatek := ParO^.Zacatek - PiPul;
        ParO^.Konec   := ParO^.Konec - PiPul;
     end;

     { Uhly ParO^.Zacatek a ParO^.Konec je treba nacpat do intervalu <0,2> }
     NacpiUhelDoDvaPi(ParO^.Zacatek);
     NacpiUhelDoDvaPi(ParO^.Konec);

     U1 := ParO^.Zacatek;
     U2 := ParO^.Konec;
     if U2 = 0 then U2 := DvaPi;

     DvaUhly := Ne;

     begin
        { Bude se Oblouk zobrazovat ? }
        if not OrezNaOblouk(Zobrazovac.RozmerVyrezu,Uhel1, Uhel2 ,Orez) then
           exit { asi ne };
        { Nemilosrdne ofiknuti na vypoctene uhly }
        if Orez then
        begin
           if U1 > U2 then
           begin
              if Uhel1 > Uhel2 then
              begin
                 if Uhel1 > U1 then U1 := Uhel1;
                 if Uhel2 < U2 then U2 := Uhel2;
              end
              { Uhel1 < Uhel2 }
              else
              begin
                 { Vychazeji 2 uhly ve vyrezu }
                 if (Uhel1 < U2) and (Uhel2 > U1) then
                 begin
                    DvaUhly := Ano;
                    U3 := U1;
                    U4 := Uhel2;
                    U1 := Uhel1; { U2 zustava }
                 end
                 else if Uhel1 < U2 then
                 begin
                    U1 := Uhel1;
                    if Uhel2 < U2 then U2 := Uhel2;
                 end
                 else if Uhel2 > U1 then
                 begin
                    U2 := Uhel2;
                    if Uhel1 > U1 then U1 := Uhel1;
                 end
                 else exit; { Ani zdibec uhlu neni ve vyrezu }
              end;
           end
           { U1 < U2 }
           else begin
              if Uhel1 < Uhel2 then
              begin
                 if Uhel1 > U1 then U1 := Uhel1;
                 if Uhel2 < U2 then U2 := Uhel2;
                 if (Uhel2 < U1) or (Uhel1 > U2) then exit;
              end
              { Uhel1 > Uhel2 }
              else
              begin
                 { Vychazeji 2 uhly ve vyrezu }
                 if (Uhel1 < U2) and (Uhel2 > U1) then
                 begin
                    DvaUhly := Ano;
                    U3 := Uhel1;
                    U4 := U2;
                    U2 := Uhel2; { U1 zustava }
                 end
                 else if Uhel1 < U2 then U1 := Uhel1
                 else if Uhel2 > U1 then U2 := Uhel2
                 else exit; { Ani zdibec uhlu neni ve vyrezu }
              end;
           end;
           Orez := Ne;
        end;
     end;


     { Vypocet KrokovehoUhlu }
     { --------------------- }
     Presnost := PresnostHPGL * Meritko;
     if (Presnost > 0) and (Par^.a > Presnost) then
     begin
        Ro := Par^.a - Presnost;
        dU := 2*ACos(Ro/Par^.a);
     end
     else dU := deltaU;

     sinUhel := (Sin(ParO^.Uhel));
     cosUhel := (Cos(ParO^.Uhel));

     Poprve  := Ano;

     { Vykresleni se pripadne zopakuje pro druhy uhel }
     while Poprve or  DvaUhly do
     begin
        if not Poprve then
        begin
           U1 := U3;
           U2 := U4;
           DvaUhly := Ne;
        end
        else Poprve := Ne;

        x1 := ParO^.a*(cos(U1));
        y1 := ParO^.b*(sin(U1));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        PomSour.y := ParO^.y-y2;
        PomSour.x := ParO^.x-x2;
        DejPlotSour (PomSour, PlotSour);
        PomStr := 'PU;PA'
                       +LStr (PlotSour.X)+
                  ','  +LStr (PlotSour.Y)+ ';'
                  +'PD;PA';
        HPGL( PomStr);

        Alfa := U1+dU;
        if U2 < U1 then
           U2 := U2 + DvaPI;
        while Alfa < U2 do
        begin
           x1 := (ParO^.a*(cos(Alfa)));
           y1 := (ParO^.b*(sin(Alfa)));
           y2 := (x1*cosUhel-y1*sinUhel);
           x2 := (x1*sinUhel+y1*cosUhel);

           PomSour.y := ParO^.y-y2;
           PomSour.x := ParO^.x-x2;

           DejPlotSour (PomSour, PlotSour);
           PomStr :=   LStr (PlotSour.X)+ ','
                      +LStr (PlotSour.Y)+ ',';
           HPGL( PomStr);

           Alfa := Alfa+dU;
        end;
        x1 := ParO^.a*(cos(U2));
        y1 := ParO^.b*(sin(U2));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        PomSour.y := ParO^.y-y2;
        PomSour.x := ParO^.x-x2;

        DejPlotSour (PomSour, PlotSour);
        PomStr :=   LStr (PlotSour.X)+ ','
                   +LStr (PlotSour.Y)+ ';';
        HPGL( PomStr);
     end;
     PomStr := 'PU;';
     HPGL( PomStr);
  end;

{$ENDIF}

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TOblouk.ZobrazRealne ( Orez: Boolean);
{$ELSE}
procedure   TOblouk.ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                   Nastavit: boolean;
                                   Orez: Boolean);
{$ENDIF}
  var
     x1,y1: Real;
     x2,y2: Real;
     Alfa : Real;
     dU   : Real;
     ku   : Integer;
     Uhel1,
     Uhel2: real;
     U1,U2: real;
     U3,U4: real;
     DvaUhly: boolean;
     sinUhel,cosUhel: Real;
     i,j  : word;
     StartI,EndI: Integer;
     Segment: LongInt;
     PrumOsa: real;
     Doladit: boolean;
     Kontrol1: TSour;
     Kontrol2: TSour;
     PomR: real;
     Poprve: boolean;
     PomVert: real;

  begin
{$IFDEF WINDOWS}
     PomVert := PVektorOkno(Okno)^.KVert;
{$ELSE}
     PomVert := Zobrazovac.KVert;
{$ENDIF}
     ParO     := PParametryOblouku(Uzly);

     { Osa a bude delsi a basta ! }
     { -------------------------- }
     if ParO^.b > ParO^.a then
     begin
        U1     := ParO^.a;
        ParO^.a := ParO^.b;
        ParO^.b := U1;
        ParO^.Uhel := ParO^.Uhel + PiPul;
        NacpiUhelDoDvaPi(ParO^.Uhel);
        ParO^.Zacatek := ParO^.Zacatek - PiPul;
        ParO^.Konec   := ParO^.Konec - PiPul;
     end;

     { Uhly ParO^.Zacatek a ParO^.Konec je treba nacpat do intervalu <0,2> }
     NacpiUhelDoDvaPi(ParO^.Zacatek);
     NacpiUhelDoDvaPi(ParO^.Konec);

     U1 := ParO^.Zacatek;
     U2 := ParO^.Konec;
     if U2 = 0 then U2 := DvaPi;

     DvaUhly := Ne;
     if Orez then
     begin
        { Bude se Oblouk zobrazovat ? }
{$IFDEF WINDOWS}
        if not OrezNaOblouk(PVektorOkno(Okno)^.RozmerJTSK,Uhel1, Uhel2 ,Orez) then
           exit { asi ne };
{$ELSE}
        if not OrezNaOblouk(Zobrazovac.RozmerVyrezu,Uhel1, Uhel2 ,Orez) then
           exit { asi ne };
{$ENDIF}
        { Nemilosrdne ofiknuti na vypoctene uhly }
        if Orez then
        begin
           if U1 > U2 then
           begin
              if Uhel1 > Uhel2 then
              begin
                 if Uhel1 > U1 then U1 := Uhel1;
                 if Uhel2 < U2 then U2 := Uhel2;
              end
              { Uhel1 < Uhel2 }
              else
              begin
                 { Vychazeji 2 uhly ve vyrezu }
                 if (Uhel1 < U2) and (Uhel2 > U1) then
                 begin
                    DvaUhly := Ano;
                    U3 := U1;
                    U4 := Uhel2;
                    U1 := Uhel1; { U2 zustava }
                 end
                 else if Uhel1 < U2 then
                 begin
                    U1 := Uhel1;
                    if Uhel2 < U2 then U2 := Uhel2;
                 end
                 else if Uhel2 > U1 then
                 begin
                    U2 := Uhel2;
                    if Uhel1 > U1 then U1 := Uhel1;
                 end
                 else exit; { Ani zdibec uhlu neni ve vyrezu }
              end;
           end
           { U1 < U2 }
           else begin
              if Uhel1 < Uhel2 then
              begin
                 if Uhel1 > U1 then U1 := Uhel1;
                 if Uhel2 < U2 then U2 := Uhel2;
                 if (Uhel2 < U1) or (Uhel1 > U2) then exit;
              end
              { Uhel1 > Uhel2 }
              else
              begin
                 { Vychazeji 2 uhly ve vyrezu }
                 if (Uhel1 < U2) and (Uhel2 > U1) then
                 begin
                    DvaUhly := Ano;
                    U3 := Uhel1;
                    U4 := U2;
                    U2 := Uhel2; { U1 zustava }
                 end
                 else if Uhel1 < U2 then U1 := Uhel1
                 else if Uhel2 > U1 then U2 := Uhel2
                 else exit; { Ani zdibec uhlu neni ve vyrezu }
              end;
           end;
           Orez := Ne;
        end;
     end;

     { Nastaveni barev a tak }
{$IFNDEF WINDOWS}
     if Nastavit then
     begin
        SetWriteMode(ZobrMod);
        SetColor(Barva);
        NastaveniTypuCary(Typ);
     end;
{$ENDIF}
     {...}

     sinUhel := (Sin(ParO^.Uhel));
     cosUhel := (Cos(ParO^.Uhel));

     Poprve  := Ano;

     { Vykresleni se pripadne zopakuje pro druhy uhel }
     while Poprve or  DvaUhly do
     begin
        if not Poprve then
        begin
           U1 := U3;
           U2 := U4;
           DvaUhly := Ne;
        end
        else Poprve := Ne;

        x1 := ParO^.a*(cos(U1));
        y1 := ParO^.b*(sin(U1));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

        Prumosa := (ParO^.a + ParO^.b)/2;
        Kontrol1.y := y2;
        Kontrol1.x := x2;

{$IFDEF WINDOWS}
        if BMP then  PVektorOkno(Okno)^.MoveYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
               else  PVektorOkno(Okno)^.MoveYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
        Zobrazovac.MoveYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}
        Segment := Round((tan(deltaU) * PrumOsa) * PomVert);

        if U1 > U2 then Orez := (U2 + DvaPi - U1) < deltaU
                   else Orez := (U2 - U1) < deltaU;
        Orez := Orez or (Segment > PixKrok);

        if not Orez then
        begin

        { Indexy zacatku a konce }
        StartI := Round(U1/deltaU)+1;
        EndI   := Round(U2/deltaU)-1;
        if StartI > 74 then StartI := 1;
        if EndI   <  0 then EndI   := 74;

           if StartI > EndI then
           begin
              for i := StartI to 74 do
              begin
                 if i >= 75 then i := 0;
                 x1 := (ParO^.a*(cosy[i]));
                 y1 := (ParO^.b*(siny[i]));
                 y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
                 x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

{$IFDEF WINDOWS}
                 if BMP then  PVektorOkno(Okno)^.LineYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
                        else  PVektorOkno(Okno)^.LineYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
                 Zobrazovac.LineYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}

              end;
              for i := 0 to EndI do
              begin
                 if i >= 75 then i := 0;
                 x1 := (ParO^.a*(cosy[i]));
                 y1 := (ParO^.b*(siny[i]));
                 y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
                 x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

{$IFDEF WINDOWS}
                 if BMP then  PVektorOkno(Okno)^.LineYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
                        else  PVektorOkno(Okno)^.LineYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
                 Zobrazovac.LineYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}

              end;
           end
           else
           for i := StartI to EndI do
           begin
              if i >= 75 then i := 0;
              x1 := (ParO^.a*(cosy[i]));
              y1 := (ParO^.b*(siny[i]));
              y2 := ((x1*cosUhel-y1*sinUhel) / UnivDelitel);
              x2 := ((x1*sinUhel+y1*cosUhel) / UnivDelitel);

{$IFDEF WINDOWS}
              if BMP then  PVektorOkno(Okno)^.LineYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
                     else  PVektorOkno(Okno)^.LineYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
              Zobrazovac.LineYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}

           end;
        end
        else begin
           if Segment < PixKrokMin then
              dU   := ArcTan((PixKrokMin/PomVert)/PrumOsa) else
                 if Segment > PixKrok then
                    dU   := ArcTan((PixKrok/PomVert)/PrumOsa)   else
                    dU   := DeltaU;
           Alfa := U1+dU;
           if U2 < U1 then
              U2 := U2 + DvaPI;
           Doladit := Ano;
           while Alfa < U2 do
           begin
              x1 := (ParO^.a*(cos(Alfa)));
              y1 := (ParO^.b*(sin(Alfa)));
              y2 := (x1*cosUhel-y1*sinUhel);
              x2 := (x1*sinUhel+y1*cosUhel);

              { Doladeni uhloveho kroku }
              { ----------------------- }
              if Doladit then
              begin
                 Kontrol2.y := y2;
                 Kontrol2.x := x2;
                 if VzdalenostBodu(Kontrol1,Kontrol2)*PomVert < PixKrok
                    then dU      := dU * 2
                    else Doladit := Ne;
              end;
{$IFDEF WINDOWS}
              if BMP then  PVektorOkno(Okno)^.LineYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
                     else  PVektorOkno(Okno)^.LineYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
              Zobrazovac.LineYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}
              Alfa := Alfa+dU;
           end;
        end;
        x1 := ParO^.a*(cos(U2));
        y1 := ParO^.b*(sin(U2));
        y2 := (x1*cosUhel-y1*sinUhel);
        x2 := (x1*sinUhel+y1*cosUhel);

{$IFDEF WINDOWS}
        if BMP then  PVektorOkno(Okno)^.LineYXPaint(DC, ParO^.y-y2,ParO^.x-x2)
               else  PVektorOkno(Okno)^.LineYX(DC, ParO^.y-y2,ParO^.x-x2);
{$ELSE}
        Zobrazovac.LineYX(ParO^.y-y2,ParO^.x-x2);
{$ENDIF}
     end;
{$IFNDEF WINDOWS}
     { Reset vykreslovacich parametru }
     SetWriteMode(NormalPut);
     NastaveniTypuCary(0);
{$ENDIF}
  end;

{------------------------------------------------}

{$IFDEF KrivkyBezOvr}
begin
  NapustGoniometry;
{$ENDIF}
end.







