{$N+,R-,Q-}

unit PAKTRANS;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
     StrProc, MatProc, TranType;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

type
  PTransformace = ^TTransformace;
  TTransformace = object

    Sta, Nov: array[1..300] of Bod;
    Vaha: array[1..300] of extended;

    ZdrojStred, CilStred: Bod;
    PocetIdentBodu: integer;
    DimenseTransformace: byte;
    DostatecnyPocetDvojic: byte;
    Klic: TKlic;
    NelzeVypocistKlic: boolean;
    CisloChyby: byte;

    NazevTransformace: TNazevTran;
    NazevTransformacniTabulky: TPathStr;
    SourRohy: TObdelnik;
    InvKlic: TKlic;

    constructor Lojza;

    constructor Init(
                     var PoleIdBodu        : PExtVector;
                         PocetDvojicIdBodu : integer);

    function    KlicVypocten : boolean;

    function    VratCisloChyby : byte;

    function    VratPopisChyby : string;

    function    Dimense : byte;

    function    MinimalniPocetDvojic : byte;

    function    DejPocetIdB: integer;

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

    destructor  Done; virtual;

  end;


  PTransformace2D = ^TTransformace2D;
  TTransformace2D = object(TTransformace)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

  end;


  PTransformace3D = ^TTransformace3D;
  TTransformace3D = object(TTransformace)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

  end;



function ResSoustRovnic(
                        var V                              : PExtVector;
                        var PM                             : PExtVector;
                        var VPS                            : PExtVector;
                        var NEZ                            : TKlic;
                            PocetRovnic, PocetNezn, Dimenze: integer) : boolean;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses WinProcs, Strings, Objects;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



{ pomocne procedury a funkce }

type
  TMA= array[1..400] of extended;


function InvMat(
                var a: TMA;
                    n: integer) : boolean;
const
  MaxRadMatice=21;

var
  biga, hold: extended;
  i, j, k, nk, kk, iz, ij, ki, ji, jp, jk, ik, kj, jq, jr: integer;
  l, m: array [1..MaxRadMatice] of integer;
  ok: boolean;
  poms: string[6];

begin
  if n <= MaxRadMatice then
  begin
    ok := true;
    nk := -n ;

    { hledani nejvetsiho prvku }

    k := 0;
    repeat
      inc(k);

      nk   := nk + n;
      l[k] := k;
      m[k] := k;
      kk   := nk + k;
      biga := a[kk];

      for j := k to n do
      begin
        iz := n * pred(j);

        for i := k to n do
        begin
          ij := iz + i;

          if abs(biga) < abs(a[ij])  then
          begin
            biga := a[ij];
            l[k] := i;
            m[k] := j
          end;
        end;
      end;

      { zamena radku }

      j := l[k];

      if j > k  then
      begin
        ki := k - n;

        for i := 1 to n do
        begin
          ki    := ki + n;
          hold  := -a[ki];
          ji    := ki - k + j;
          a[ki] := a[ji];
          a[ji] := hold
        end;
      end;

      { zamena sloupcu }

      i := m[k];

      if i > k then
      begin
        jp := n * pred(i);

        for j := 1 to n do
        begin
          jk    := nk + j;
          ji    := jp + j;
          hold  := -a[jk];
          a[jk] := a[ji];
          a[ji] := hold
        end;
      end;

      { deleni sloupce zapornym pivotem (hodnota pivotu je v biga) }

      if biga <> 0.0 then
      begin
        for i := 1 to n do
          if i <> k then
          begin
            ik    := nk + i;
            a[ik] := -a[ik] / biga
          end;
        { redukce matice }

        for i := 1 to n do
        begin
          ik   := nk + i;
          hold := a[ik];
          ij   := i-n ;

          for j := 1 to n do
          begin
            ij := ij + n;

            if (i <> k) and (j <> k) then
            begin
              kj    := ij - i + k;
              a[ij] := hold * a[kj] + a[ij]
            end;
          end;
        end;

        { deleni radku pivotem }

        kj := k - n;

        for j := 1 to n do
        begin
          kj := kj + n;

          if j <> k then
            a[kj] := a[kj] / biga
        end;

        { nahrada pivotu prevracenou hodnotou }

        a[kk] := 1.0 / biga
      end
      else
        ok := false;
    until ((k = n) or (not ok));

    if ok then begin
      { konecna vymena radku a sloupcu }

      k := pred(n);

      while k > 0 do
      begin
        i := l[k];

        if i > k then
        begin
          jq := n * pred(k);
          jr := n * pred(i);

          for j := 1 to n do
          begin
            jk    := jq + j;
            hold  := a[jk];
            ji    := jr + j;
            a[jk] := -a[ji];
            a[ji] := hold
          end;
        end;

        j := m[k];

        if j > k then
        begin
          ki := k - n;

          for i := 1 to n do
          begin
            ki    := ki + n;
            hold  := a[ki];
            ji    := ki - k + j;
            a[ki] := -a[ji];
            a[ji] := hold

          end;
        end;
        dec(k);
      end;
    end;
  end
  else
    ok := false;

  InvMat := ok;
end;



function ResSoustRovnic(
                        var V                              : PExtVector;
                        var PM                             : PExtVector;
                        var VPS                            : PExtVector;
                        var NEZ                            : TKlic;
                            PocetRovnic, PocetNezn, Dimenze: integer) : boolean;
const
  MaxDimense=21;

var
  MA: TMA;
  PS: array[1..MaxDimense] of extended;
  i, j, k, l: integer;
  NelzeResit:boolean;

begin
  NelzeResit:=false;

  if PocetNezn > MaxDimense then
    NelzeResit:=true
  else
  begin
    for i := 1 to PocetNezn do
    begin
      for j := 1 to PocetNezn do
      begin
        MA[PocetNezn * pred(i) + j] := 0;
        for k := 1 to PocetRovnic do
           MA[PocetNezn * pred(i) + j] := MA[PocetNezn * pred(i) + j] +
                                        V^[succ(pred(k) div Dimenze)]  *
                                        PM^[PocetNezn * pred(k) + i]   *
                                        PM^[PocetNezn * pred(k) + j];
      end;
    end;

    for i := 1 to PocetNezn do
    begin
      PS[i] := 0;
      for k := 1 to PocetRovnic do
        PS[i] := PS[i] + V^[succ(pred(k) div Dimenze)] * PM^[PocetNezn * pred(k) + i] * VPS^[k];
    end;

    if InvMat(MA, PocetNezn) then
    begin
      for i := 1 to PocetNezn do
      begin
        NEZ[i] := 0;

        for k := 1 to PocetNezn do
          NEZ[i] := NEZ[i] + MA[PocetNezn * pred(i) + k] * PS[k]
      end;
    end
    else
      NelzeResit:=true;

    ResSoustRovnic := not NelzeResit;
  end;
end;


constructor TTransformace.Lojza;
begin
end;

{ procedury a funkce k objektum }

constructor TTransformace.Init(
                               var PoleIdBodu       : PExtVector;
                                   PocetDvojicIdBodu: integer);
var
  i, j:integer;

begin
  CisloChyby        := 0;

  NelzeVypocistKlic := false;
  ZdrojStred.X      := 0;
  CilStred.X        := 0;
  ZdrojStred.Y      := 0;
  CilStred.Y        := 0;
  PocetIdentBodu    := PocetDvojicIdBodu;


  if DimenseTransformace = 3 then
  begin
    ZdrojStred.Z := 0;
    CilStred.Z   := 0;
  end;

  j := 0;
  for i := 1 to PocetDvojicIdBodu do
  begin
    inc(j);
    Vaha[i]  := PoleIdBodu^[j];

    inc(j);
    Sta[i].X := PoleIdBodu^[j];

    inc(j);
    Sta[i].Y := PoleIdBodu^[j];

    if DimenseTransformace=3 then
    begin
      inc(j);
      Sta[i].Z := PoleIdBodu^[j];
    end;

    inc(j);
    Nov[i].X := PoleIdBodu^[j];

    inc(j);
    Nov[i].Y := PoleIdBodu^[j];

    if DimenseTransformace=3 then
    begin
      inc(j);
      Nov[i].Z := PoleIdBodu^[j];
    end;

  end;

  for i:=1 to PocetDvojicIdBodu do
  begin
    ZdrojStred.X := ZdrojStred.X + Sta[i].X;
    CilStred.X   := CilStred.X   + Nov[i].X;

    ZdrojStred.Y := ZdrojStred.Y + Sta[i].Y;
    CilStred.Y   := CilStred.Y   + Nov[i].Y;

    if DimenseTransformace=3 then
    begin
      ZdrojStred.Z := ZdrojStred.Z + Sta[i].Z;
      CilStred.Z   := CilStred.Z   + Nov[i].Z;
    end;
  end;

  ZdrojStred.X := ZdrojStred.X / PocetDvojicIdBodu;
  CilStred.X   := CilStred.X   / PocetDvojicIdBodu;

  ZdrojStred.Y := ZdrojStred.Y / PocetDvojicIdBodu;
  CilStred.Y   := CilStred.Y   / PocetDvojicIdBodu;

  if DimenseTransformace=3 then
  begin
    ZdrojStred.Z := ZdrojStred.Z / PocetDvojicIdBodu;
    CilStred.Z   := CilStred.Z   / PocetDvojicIdBodu;
  end;


  for i:=1 to PocetDvojicIdBodu do
  begin
    Sta[i].X := Sta[i].X - ZdrojStred.X;
    Nov[i].X := Nov[i].X - CilStred.X;
    Sta[i].Y := Sta[i].Y - ZdrojStred.Y;
    Nov[i].Y := Nov[i].Y - CilStred.Y;

    if DimenseTransformace=3 then
    begin
      Sta[i].Z := Sta[i].Z - ZdrojStred.Z;
      Nov[i].Z := Nov[i].Z - CilStred.Z;
    end;
  end;
end;



procedure TTransformace.Transformuj(
                                    const ZdrojBod: Bod;
                                    var   CilBod  : Bod);
begin
end;

procedure TTransformace.InvTransformuj(
                                       const ZdrojBod: Bod;
                                       var   CilBod  : Bod);
begin
end;


destructor TTransformace.Done;
begin
end;



function TTransformace.KlicVypocten : boolean;
begin
  KlicVypocten := not NelzeVypocistKlic;
end;


function TTransformace.VratCisloChyby : byte;
begin
  VratCisloChyby := CisloChyby;
end;


function TTransformace.VratPopisChyby : string;
var
  Retezec1: array[0..255] of char;

begin
  if CisloChyby = 1 then
    LoadString(HInstance, 630, Retezec1, 256)
    {Neni misto v dyn. pameti}
  else
    if CisloChyby=2 then
      LoadString(HInstance, 631, Retezec1, 256)
      {Chyba v id. bodech}
    else
      if CisloChyby=3 then
        LoadString(HInstance, 632, Retezec1, 256);
        {Nedostatek id. bodu}

  VratPopisChyby := StrPas(Retezec1);
end;



function TTransformace.Dimense : byte;
begin
  Dimense := DimenseTransformace;
end;



function TTransformace.MinimalniPocetDvojic : byte;
begin
  MinimalniPocetDvojic := DostatecnyPocetDvojic;
end;


function TTransformace.DejPocetIdB : integer;
begin
  DejPocetIdB := PocetIdentBodu;
end;


constructor TTransformace2D.Init(
                                var PoleIdBodu       : PExtVector;
                                    PocetDvojicIdBodu: integer);
begin
  DimenseTransformace := 2;
  inherited Init(PoleIdBodu, PocetDvojicIdBodu);
end;



constructor TTransformace3D.Init(
                                var PoleIdBodu        : PExtVector;
                                     PocetDvojicIdBodu: integer);
begin
  DimenseTransformace := 3;
  inherited Init(PoleIdBodu, PocetDvojicIdBodu);
end;



end.
