unit f_auto;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Basic_TLB, StdCtrls,
  DBClient,
  n_Basic;

type
  TForm1 = class(TForm)
    btSpojeni: TButton;
    edWhere: TEdit;
    edTam: TEdit;
    edZpet: TEdit;
    btTam: TButton;
    btZpet: TButton;
    procedure btSpojeniClick(Sender: TObject);
    procedure btTamClick(Sender: TObject);
    procedure btZpetClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    FAuto: IAutoViewer;
    FChecker: TBasicChecker;
    procedure Spoj;
  public
    { Public declarations }
    FStartTick: double;
  end;

var
  Form1: TForm1;




implementation

{$R *.DFM}

procedure TForm1.Spoj;
begin
  try
    if edWhere.Text = '' then
       FAuto := CoAutoViewer.Create
    else
       FAuto := CoAutoViewer.CreateRemote(edWhere.Text);

    if FAuto = nil then
    begin
      showMessage('Basic automation server se nepodarilo najit');
      exit;
    end;

  except
   on E:Exception do
   begin { Dialogs, Controls }
      ShowMessage('Problem s AutoViewerem ' + #13 + #10 +
                   E.Message);
   end
  end;
end;


procedure TForm1.btSpojeniClick(Sender: TObject);
begin
  Spoj
end;


procedure TForm1.btTamClick(Sender: TObject);
begin
  if FAuto = nil then exit;
  FStartTick:= GetTickCount;
  FAuto.BlockName:= edTam.Text;
end;


procedure TForm1.btZpetClick(Sender: TObject);
begin
  if FAuto = nil then exit;
  EdZpet.Text:= FAuto.BlockName;
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
  if ParamCount > 0 then
     EdTam.Text:= ParamStr(1);

  if EdTam.Text = '' then exit;

  Spoj;
  if FAuto = nil then exit;
  FStartTick:= GetTickCount;
  FAuto.BlockName:= edTam.Text;
end;

end.
