unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// DEVICE
  d_txt;



type

TOptions = class(TBaseOptions)
private
  FDelRAS: TStringListElement;
  FDeleteRAS: boolean;
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  FPaletFile: string;
  {Directories}
  FWorkingDirectory: String;
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FFullUseMemory: boolean;
  function  GetDelRAS: TStringListElement;
  procedure SetServiceDirectory(const aValue: string);
public
  property   DelRAS: TStringListElement read GetDelRAS;
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   WorkingDirectory: string read FWorkingDirectory write FWorkingDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
//  property   PaletFile: string read FPaletFile write FPaletFile;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FProtocol: TMemoFormDevice;
  function  GetOptions: TBaseOptions; override;
  function  GetNOptions: TOptions; virtual;
  procedure SetOptions(aValue: TBaseOptions); override;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
protected
  function  GetWorkingDirectory: string; override;
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  on_tm_DataSet(var Handled: boolean); virtual;
   procedure  on_tm_ControlSet(var Handled: boolean); virtual;
   procedure  on_tm_Run(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_EndOfPrint(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_AddToProtocol(aMessage: TOrbisMessage); virtual;
   procedure  on_tm_Done(aMessage: TOrbisMessage); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   ExePath: string read GetExePath;
   property   Protocol: TMemoFormDevice read FProtocol write FProtocol;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  t_Loader,
  t_Saver,
  u_String,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// INTERPRET
  e_IScrpt,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
// TOPOL
  e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  f_Option,
  F_Start,
  M_Proj;

{TOptions}

function  TOptions.GetDelRAS: TStringListElement;
begin
   if FDelRas = nil then
   begin
      FdelRas := TStringListElement.Create;
      AddElement(FDelRas);
   end;
   result := FDelRas;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
end;


{TMainTool}


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
  CommandLine.FileName:= aFileName;
  CommandLine.DoIt
end;


function  TMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   S := Options.WorkingDirectory;
   result := CheckBackSlash(S);
end;



procedure TMainTool.DoIt;
var
  OIL: string;
  S,SS: string;
begin
  inherited DoIt;
  //Application.HelpFile := ChangeFileExt(ParamStr(0),'.HLP');
  {
  if not Application.HelpJump('Obsah') then
     ShowMessage('Soubor npovdy neexistuje');
  }
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ExtractFilePath(ParamStr(0));
  CheckBackSlash(S);
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
end;





procedure TMainTool.ReadParamsFromIni;
var
   Load: TLoad;
   S: string;
begin
   inherited ReadParamsFromIni;
   //PostMsg(tm_OpenProject,Self,nil,DontKill);
   {
   NactiBarvickuZeSouboru(Options.PaletFile);
   }
   {
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      SourceModel := TOwnerEntity(Load.Output);
      Load.Free;
   end;
   }
end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
var
   Save: TSave;
begin
   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
begin
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Work.Text := Options.WorkingDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Data.Text := Options.DataDirectory;
   D.ed_Template.Text := Options.TemplateDirectory;
   if D.ShowModal = mrOk then
   begin
      Options.WorkingDirectory := D.ed_Work.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      Options.DataDirectory := D.ed_Data.Text;
      Options.TemplateDirectory := D.ed_Template.Text;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   MainForm.l_Data.Caption := Options.DataDirectory;
   Application.ProcessMessages;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
        try
           (*
           if Options.DeleteRAS then
           for i := 0 to Options.DelRas.Count - 1 do
           begin
              SysUtils.DeleteFile(Options.DelRas.Strings[i]);
           end;
           *)
           {
           PostAppMessage(Project.MainHandle, TProjectWorld(World).WM_MODUL_END, 0, 0)
           }
        except
        end;
        Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
begin
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
{
var
   Load: TLoad;
   S: string;
   i: integer;
   ?: TOwnerEntity;
}
begin
   (*
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      ? := TOwnerEntity(Load.Output);
      ??? := SM;
      Load.Free;
      for i := 0 to ?.LastIndex do
      begin
         MainForm.ed_LHC.Items.Add(?.Elements[i].Name);
      end;
   end;
   *)
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;

procedure  TMainTool.on_tm_DataSet(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.DataSetScript;
*)
end;

procedure  TMainTool.on_tm_ControlSet(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.ControlSetScript;
*)
end;

procedure  TMainTool.on_tm_Run(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
end;



procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.Panels.Items[0].Text := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
//  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfPrint(var Handled: boolean);
begin
   {
   if CancelProcess then
   begin
      MainForm.Dioda.Color := clBtnFace;
      MainForm.Dioda.Enabled := false;
   end;
   if Automat.Busy then Automat.ProcessMap := false;
   }
end;


procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      tm_DataSet:     on_tm_DataSet(Handled);
      tm_ControlSet:  on_tm_ControlSet(Handled);
      tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);


     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);

      tm_EndOfPrint       : on_tm_EndOfPrint(Handled);
      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_AddToProtocol    : on_tm_AddToProtocol(aMessage);
      tm_Done             : on_tm_Done(aMessage);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)   
end;


function  TMainTool.GetText: string;
begin
   result := MainForm.StatusBar.Panels.Items[0].Text;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.Panels.Items[0].Text := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;




procedure  TMainTool.on_tm_AddToProtocol(aMessage: TOrbisMessage);
var
   S: string;
begin
   if Protocol = nil then FProtocol := TMemoFormDevice.Create;
   S := TOrbisTextMessage(aMessage).Text;
   if S = '' then exit;
   if S[Length(S)]=#13 then Protocol.WriteLnText(TOrbisTextMessage(aMessage).Text)
                       else Protocol.WriteText(TOrbisTextMessage(aMessage).Text);
end;

procedure  TMainTool.on_tm_Done(aMessage: TOrbisMessage);
begin
   if aMessage.Sender is TMemoFormDevice then Protocol := nil;
end;








END.
