unit F_Info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    l_www: TLabel;
    l_Close: TLabel;
    l_Install: TLabel;
    l_Browse: TLabel;
    l_TXT: TLabel;
    l_BDE: TLabel;
    l_RAS: TLabel;
    l_text: TLabel;
    Timer1: TTimer;
    Animate1: TAnimate;
    procedure l_wwwClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure l_InstallMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure l_InstallClick(Sender: TObject);
    procedure l_BrowseClick(Sender: TObject);
    procedure l_TXTClick(Sender: TObject);
  private
    FBDEExists: boolean;
    FRasLibsExists: boolean;
    FBDEVersion: integer;
    FRasLibsVersion: integer;
    FApp: string;
    FRAS: string;
    FBDE: string;
    FTXT: string;
    FUSER: string;
    FNoUser: boolean;
    FNoRAS: boolean;
    FNoCover: boolean;
    FCover: string;
      procedure CreateParams(var Params: TCreateParams); override;
    procedure SetBDEExists(const Value: boolean);
    procedure SetBDEVersion(const Value: integer);
    procedure SetRasLibsExists(const Value: boolean);
    procedure SetRasLibsVersion(const Value: integer);
    procedure SetApp(const Value: string);
    procedure SetBDE(const Value: string);
    procedure SetRAS(const Value: string);
    procedure SetTXT(const Value: string);
    procedure SetUSER(const Value: string);
    procedure SetNoUser(const Value: boolean);
    procedure SetNoRAS(const Value: boolean);
    procedure SetCover(const Value: string);
    procedure SetNoCover(const Value: boolean);
  protected
      LastLabel: TLabel;
      Path: string;
      ProcessHandle: THandle;
    procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
  public
    { Public declarations }
   procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
   procedure CHeckBDE;
   procedure CHeckRASLibs;
   procedure RunInst_App;
   procedure RunInst_RAS;
   procedure RunInst_BDE;
   procedure RunInst_User;
   procedure Run(Ap: string);
   property  App: string read FApp write SetApp;
   property  RAS: string read FRAS write SetRAS;
   property  BDE: string read FBDE write SetBDE;
   property  TXT: string read FTXT write SetTXT;
   property  USER: string read FUSER write SetUSER;
   property  NoRAS: boolean read FNoRAS write SetNoRAS;
   property  NoUser: boolean read FNoUser write SetNoUser;
   property  BDEExists: boolean read FBDEExists write SetBDEExists;
   property  BDEVersion: integer read FBDEVersion write SetBDEVersion;
   property  RasLibsExists: boolean read FRasLibsExists write SetRasLibsExists;
   property  RasLibsVersion: integer read FRasLibsVersion write SetRasLibsVersion;
   property  Cover: string read FCover write SetCover;
   property  NoCover: boolean read FNoCover write SetNoCover;

  end;

var
  Form1: TForm1;

implementation
uses
   BDE,
   IniFiles,
   Registry,
   ShellApi,
   FileVersion,
   u_String;


procedure TForm1.CreateParams(var Params: TCreateParams);
begin
   inherited createparams(params);
   {This makes a borderless and captionless form}
   params.style:=params.style or ws_popup xor ws_dlgframe;
end;

{$R *.DFM}

procedure TForm1.WMDropFiles(var Message: TMessage);
var
   i: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S: string;
   Size: word;
begin
   {
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      StrDispose(P);
      VersionFor(S);
   end;
   }
end;


procedure TForm1.l_wwwClick(Sender: TObject);
begin
   ShellExecute(0, Nil, PChar(l_www.Caption), Nil, Nil, SW_NORMAL);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   l_Text.Font.Color := not(l_Text.Font.Color);
end;

procedure TForm1.CloseClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   i,j,k: integer;
   FV: TFileVersion;
   formrgn,Rgn1,Rgn2:hrgn;
   ini: TIniFile;
   S: string;
begin
   {makes the form clear}
   form1.brush.style:=bsclear;
   {makes the form round}
   GetWindowRgn(form1.Handle, formRgn);
   DeleteObject(formRgn);
   {
   FormRgn:= CreateroundRectRgn
             (ClientRect.Left+3,ClientRect.Top+3,
              ClientRect.Right,ClientRect.Bottom,50,50);

   }
   FormRgn:= CreateEllipticRgn
             (ClientRect.Left+10,ClientRect.Top+10,
              ClientRect.Right,ClientRect.Bottom);

   i := 237;
   j := 4;
   k := 3;
   Rgn1:= CreateEllipticRgn
             (ClientRect.Left+j,ClientRect.Top+j,
              ClientRect.Right+k,ClientRect.Bottom+k);
   Rgn2:= CreateEllipticRgn
             (ClientRect.Left+10+i,ClientRect.Top+10+i,
              ClientRect.Right-i,ClientRect.Bottom-i);
   CombineRgn(FormRgn,Rgn1,Rgn2,RGN_DIFF);
   SetWindowRgn(form1.Handle, formrgn, TRUE);
   DragAcceptFiles(Handle, true);
   i := ParamCount;
   Path := ExtractFilePath(ParamStr(0));
   CheckBackSlash(Path);
   Ini := TIniFile.Create(CHangeFileExt(ParamStr(0),'.INI'));
   App := ini.ReadString('PATH','APP','');
   App := Path+App;
   RAS := ini.ReadString('PATH','RAS','');
   NoRAS := RAS = '';
   RAS := Path+RAS;
   BDE := ini.ReadString('PATH','BDE','');
   BDE := Path+BDE;
   TXT := ini.ReadString('PATH','TXT','');
   TXT := Path+TXT;
   USER := ini.ReadString('PATH','USER','');
   NoUser := USER = '';
   USER := Path+USER;
   COVER := ini.ReadString('PATH','COVER','');
   NoCover := COVER = '';
   COVER := Path + COVER;
   if not NoCOVER then
   begin
      if not FileExists(COVER) then
         ShowMessage('Soubor '+COVER+' neexistuje!')
      else
         Image1.Picture.LoadFromFile(COVER);
   end;
   Ini.Free;
end;

procedure TForm1.l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   //Bevel.Style := bsLowered;
end;

procedure TForm1.l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   //Bevel.Style := bsRaised;
end;


procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
var
   P: TPoint;
begin
  inherited;                    { call the inherited message handler }
  if  M.Result = htClient then  { is the click in the client area?   }
  begin
    P.x := M.XPos;
    P.y := M.YPos;
    P := ScreenToClient(P);
    if ((P.x > l_Close.Left) and (P.y > l_Close.Top) and
       (P.x < l_Close.Left+l_Close.Width) and (P.y < l_Close.Top+l_Close.Height))
        or
       ((P.x > l_www.Left) and (P.y > l_www.Top) and
       (P.x < l_www.Left+l_www.Width) and (P.y < l_www.Top+l_www.Height))
        or
       ((P.x > l_Install.Left) and (P.y > l_Install.Top) and
       (P.x < l_Install.Left+l_Install.Width) and (P.y < l_Install.Top+l_Install.Height))
        or
       ((P.x > l_Browse.Left) and (P.y > l_Browse.Top) and
       (P.x < l_Browse.Left+l_Browse.Width) and (P.y < l_Browse.Top+l_Browse.Height))
        or
       ((P.x > l_TXT.Left) and (P.y > l_TXT.Top) and
       (P.x < l_TXT.Left+l_TXT.Width) and (P.y < l_TXT.Top+l_TXT.Height))
        then exit;
    M.Result := htCaption;      { if so, make Windows think it's     }
                                { on the caption bar.                }
  end;
end;

procedure TForm1.l_InstallMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   LL: TLabel;
begin
   if not (Sender is TLabel) then exit;
   LL := TLabel(Sender);
   if LL = LastLabel then exit;
   if LastLabel <> nil then
      LastLabel.Font.Color := clBlack;
   LL.Font.Color := clWhite;
   LastLabel := LL;
end;

procedure TForm1.CHeckBDE;
var
   SV: SysVersion;
begin
   BDEExists  := false;
   if DBIInit(nil)= DBIERR_NONE then
   begin
      BDEExists := true;
      DbiGetSysVersion (SV);
      l_BDE.Caption := 'Nalezena BDE verze: ' + intToStr(SV.iVersion);
      Application.ProcessMessages;
      DBIExit;
   end
   else
      l_BDE.Caption := 'BDE ... nen nainstalovno';
   l_BDE.Visible := true;
end;

procedure TForm1.SetBDEExists(const Value: boolean);
begin
   FBDEExists := Value;
end;

procedure TForm1.l_InstallClick(Sender: TObject);
begin
   l_Text.Caption := 'Probh vyhledn nainstalovanch soust. ekejte...';
   l_Text.Visible := true;
   Application.ProcessMessages;
   CheckBDE;
   Application.ProcessMessages;
   if not NoRAS then
      CheckRaslibs;
   Application.ProcessMessages;
   l_Text.Caption := 'Probh vlastn instalace ....';
   //WindowState := wsMinimized;
   Application.ProcessMessages;
   RunInst_App;
   //WindowState := wsNormal;
   Application.ProcessMessages;
   //WindowState := wsMinimized;
   //Application.ProcessMessages;
   RunInst_USER;
   Application.ProcessMessages;
   RunInst_RAS;
   //WindowState := wsNormal;
   Application.ProcessMessages;
   //WindowState := wsMinimized;
   //Application.ProcessMessages;
   RunInst_BDE;
   //WindowState := wsNormal;
   Application.ProcessMessages;
   l_Text.Caption := 'Instalace skonena';
   //l_Text.Caption := l_Text.Caption + App;
   //l_Ras.Caption := RAS;
   //l_BDE.Caption := BDE;

end;

procedure TForm1.l_BrowseClick(Sender: TObject);
var
   S: string;
   W: integer;
begin
   begin
      //Left := Screen.DesktopWidth - Width div 2;
      //Top := Screen.DesktopHeight - Height div 2;
      S := 'Explorer.exe '+Path;
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.CHeckRASLibs;
var
   Reg: TRegistry;
begin
   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_CLASSES_ROOT;
   //RasLibsExists := Reg.KeyExists('Interface\{C1F953C4-FE91-11D0-BC6B-0000E80ADAFB}');
   RasLibsExists := Reg.KeyExists('Topol.Raster');
   if RasLibsExists then
   begin
      l_RAS.Caption := 'Nalezena Instalace rastrovch komponent.';
   end
   else
   begin
      l_RAS.Caption := 'Rastrov knihovny ... nejsou nainstalovny!';
   end;
   l_RAS.Visible := true;
   Reg.Free;
end;

procedure TForm1.SetBDEVersion(const Value: integer);
begin
  FBDEVersion := Value;
end;

procedure TForm1.SetRasLibsExists(const Value: boolean);
begin
  FRasLibsExists := Value;
end;

procedure TForm1.SetRasLibsVersion(const Value: integer);
begin
  FRasLibsVersion := Value;
end;

procedure TForm1.RunInst_App;
begin
   Run(App);
end;

procedure TForm1.RunInst_BDE;
begin
   if BDEExists then exit;
   Run(BDE);
   l_BDE.Caption  := 'Instalace BDE .... OK';
end;

procedure TForm1.RunInst_RAS;
begin
   if NoRAS then exit;
   if RasLibsExists then exit;
   Run(RAS);
   l_RAS.Caption  := 'Instalace rastrovch komponent .... OK';
end;

procedure TForm1.SetApp(const Value: string);
begin
  FApp := Value;
end;

procedure TForm1.SetBDE(const Value: string);
begin
  FBDE := Value;
end;

procedure TForm1.SetRAS(const Value: string);
begin
  FRAS := Value;
end;

procedure TForm1.Run(Ap: string);
var
   S: string;
   SI: TStartupInfo;
   PI: TProcessInformation;
   EC: DWord;
begin
   S := Ap;
   if not FileExists(S) then
   begin
      ShowMessage('Soubor '+ S+ ' nelze nalzt !');
      exit;
   end;
   with SI do
   begin
      cb:= SizeOf(TStartupInfo);
      lpReserved:= nil;
      lpDesktop:= nil;
      lpTitle:= nil;
      dwX:= 0;
      dwY:= 0;
      dwXSize:= 0;
      dwYSize:= 0;
      dwXCountChars:= 0;
      dwYCountChars:= 0;
      dwFillAttribute:= 0;
      dwFlags:= 0;
      wShowWindow:= 0;
      cbReserved2:= 0;
      lpReserved2:= nil;
      hStdInput:= 0;
      hStdOutput:= 0;
      hStdError:= 0;
   end;
   //Semafor.Color := clRed;
   if not CreateProcess(PChar(S),nil,nil,nil,false,CREATE_DEFAULT_ERROR_MODE,nil,
     nil, SI,PI) then
   begin
      ShowMessage('Chyba sputn '+S);
      ProcessHandle := 0;
   end
   else
   begin
      ProcessHandle := PI.hProcess;
      repeat
         ProcessHandle := PI.hProcess;
         Application.ProcessMessages;
         GetExitCodeProcess(PI.hProcess,EC);
      until EC <> STILL_ACTIVE;
      //Semafor.Color := clLime;
   end;
end;

procedure TForm1.l_TXTClick(Sender: TObject);
begin
   if not FileExists(TXT) then
   begin
      ShowMessage('Soubor '+ TXT+ ' nelze nalzt !');
      exit;
   end;
   //Left := Screen.DesktopWidth - Width div 2;
   //Top := Screen.DesktopHeight - Height div 2;
   ShellExecute(0, Nil, PChar(TXT), Nil, Nil, SW_NORMAL);
end;

procedure TForm1.SetTXT(const Value: string);
begin
  FTXT := Value;
end;

procedure TForm1.RunInst_User;
begin
   if NoUser then exit;
   Run(USER);
end;

procedure TForm1.SetUSER(const Value: string);
begin
  FUSER := Value;
end;

procedure TForm1.SetNoUser(const Value: boolean);
begin
   FNoUser := Value;
end;

procedure TForm1.SetNoRAS(const Value: boolean);
begin
   FNoRAS := Value;
end;

procedure TForm1.SetCover(const Value: string);
begin
  FCover := Value;
end;

procedure TForm1.SetNoCover(const Value: boolean);
begin
  FNoCover := Value;
end;

end.
