#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#pragma pack(1)

typedef unsigned char BYTE;
typedef struct          /* element symbology word */
{
  unsigned style:3;     /* element line style */
  unsigned weight:5;    /* current line weight */
  unsigned color:8;     /* current color */
} SYMBOLOGY;

typedef struct
{
  unsigned short class:4;     /* element class */
  unsigned short :4;          /* reserved by Intergraph */
  unsigned short l:1;         /* locked */
  unsigned short n:1;         /* new */
  unsigned short m:1;         /* modified */
  unsigned short a:1;         /* attributes present */
  unsigned short r:1;         /* relative to: 0=database 1=screen */
  unsigned short p:1;         /* planar */
  unsigned short s:1;         /* 0=snappable, 1=nonsnappable */
  unsigned short h:1;         /* hole or solid (usually) */
} PROPERTIES;

typedef struct
{
  unsigned short level:6;    /* level element is on */
  unsigned short igresvd:1;  /* reserved by Intergraph */
  unsigned short complex:1;  /* part of complex element (cell) if set */
  unsigned short type:7;      /* type of element */
  unsigned short deleted:1;  /* set if element is deleted */

  unsigned short words; /* number of words to follow in element */
  unsigned long xlow;   /* range of element - low (reversed longs) */
  unsigned long ylow;
  unsigned long zlow;
  unsigned long xhigh;  /* range of element - high (reversed longs) */
  unsigned long yhigh;
  unsigned long zhigh;        
} ELM_HDR;

typedef struct
{
  unsigned long x;
  unsigned long y;
} POINT;
typedef struct
{
  double x;
  double y;
} DPOINT;

typedef struct
{
  unsigned short grphgrp;  /* graphics group number */
  short attindx;           /* words between this and attribute linkage */
  PROPERTIES props;
  SYMBOLOGY symb;
} DISP_HDR;

typedef struct
{
  unsigned        grid_lock:1;    /* grid lock in effect */
  unsigned        unit_lock:1;    /* unit lock in effect */
  unsigned        rsrv3:1;        /* reserved */
  unsigned        stream_mode:1;  /* point/stream mode */
  unsigned        delay_pattrn:1; /* delayed patterning */
  unsigned        dis_asp:1;      /* display aspect ratio */
  unsigned        rsrv2:2;        /* reserved */
  unsigned        inh_msg:1;      /* inhibit CF, ST and PR messages */
  unsigned        inh_err:1;      /* inhibit err msgs (except fatal) */
  unsigned        rsrv1:4;        /* reserved */
  unsigned        wind_alt:1;     /* display window altered */
  unsigned        overview:1;     /* overview on */
} CNTRLWD;
typedef struct
{
  unsigned      fast_curve:1;   /* fast curve display */
  unsigned      fast_text:1;    /* fast text */
  unsigned      fast_font:1;    /* fast font text */
  unsigned      line_wghts:1;   /* line weights */
  unsigned      patterns:1;     /* pattern display */
  unsigned      text_nodes:1;   /* text node display */
  unsigned      ed_fields:1;    /* enter data field underlines */
  unsigned      on_off:1;     /* view on or off */
  unsigned      delay:1;      /* delay on */
  unsigned      grid:1;     /* grid on */
  unsigned      lev_symb:1;     /* level symbology */
  unsigned      points:1;     /* points */
  unsigned      constructs:1;   /* line constructs */
  unsigned      dimens:1;     /* dimensioning */
  unsigned      fast_cell:1;    /* fast cells */
  unsigned      def:1;      /* def/undef ?? */
} VIEWFLAGS;
typedef struct
{
  VIEWFLAGS     flags;      /* view flags */
  short         levels[4];      /* active levels (64 bit array) */
  POINT         origin;     /* origin (3d point made of longs) */
  unsigned long originZ;
  POINT         delta;      /* delta to other corner of view */
  unsigned long deltaZ;
  double        transmatrx[9];  /* view transformation matrix */
  double        conversion;     /* conversion digitizer units to uors */
  unsigned long activeZ;      /* view active z */
} VIEWINFO;

typedef struct
{
  CNTRLWD        control;       // control word
  short          filler_1[7];
  BYTE           vwfull1;       // view # on scrn 1 (full scrn mode)
  BYTE           vwfull2;       //    -- "" --    2
  VIEWINFO       view[9];       // view information for each view
  unsigned long  mastunits;     // master units per design (unsigned)
  unsigned long  subpermast;    // sub-units per master unit (unsigned)
  unsigned long  uorpersub;     // uors per sub unit (unsigned)
  char           mastname[2];   // master units name
  char           subname[2];    // sub units name
  double         actangle;      // active angle
  double         anglernd;      // angle round-off
  double         xactscle;      // active scale in x-axis
  double         yactscle;      // active scale in y-axis
  double         zactscle;      // active scale in z-axis
  double         rndscle;       // scale lock roundoff value
  unsigned long  chheight;      // character height (uors)
  unsigned long  chwidth;       // character width (uors)
  unsigned long  nodespace;     // vert uors between chars in text node
  BYTE           nodelen;       // maximum line length in node
  BYTE           nodejust;      // text node justification value (0-14)
  BYTE           actfont;       // active font number
  BYTE           anglefmt;      // angle readout format
  unsigned short graphic;       // next graphics group number
  BYTE           txtjust;       // text justification value (0-14)
  BYTE           rfcntrl;       // reference file control flag
  BYTE           tentmode;      // tentative point mode flag
  BYTE           tentsubmode;   // tentative point sub mode
  short          filler_2[171];
} TCB;
typedef struct
{
  BYTE      font;         /* text font used */
  BYTE      just;         /* justification type */
  long      lngthmult;    /* length multiplier */
  long      hghtmult;     /* height multiplier */
  long      rotation;     /* rotation angle */
  POINT     origin;       /* origin */
  BYTE      numchars;     /* # of characters */
  BYTE      edflds;       /* # of enter data fields */
} TEXT_HDR;
typedef struct
{
  long      startang;     /* start angle */
  long      sweepang;     /* sweep angle */
  double    primary;      /* primary axis */
  double    secondary;      /* secondary axis */
  long      rotation;     /* rotation angle */
  DPOINT    origin;     /* origin */
} ARC;
typedef struct
{
  short     celltype;     /* cell type */
  short     attindx;      /* attribute linkage */
  short     name[2];     /* radix-50 cell name */
  unsigned short  numwords;     /* number of words in descriptions */
  short     properties;     /* properties */
  short     dispsymb;     /* display symbology */
  short     class;        /* cell class (always 0) */
  short     levels[4];      /* levels used in cell */
  short     descrip[9];     /* cell description */
} CELL_LIB_HDR;
typedef struct
{
  unsigned short  totlength;	    /* total length of cell */
  short           name[2];     /* radix-50 cell name */
  short           class;      /* class bit map */
  short           levels[4];      /* levels used in cell */
  POINT           rnglow;     /* range block lo */
  POINT           rnghigh;      /* range block hi */
  POINT           trans1;      /* transformation matrix */
  POINT           trans2;      /* transformation matrix */
  POINT           origin;     /* cell origin */
} CELL;

char *types[] = { "???",
                  "LIBRARY_CELL",
                  "CELL",
                  "LINE",
                  "LINE_STRING",
                  "GROUP_DATA",
                  "SHAPE",
                  "NODE",
                  "DIGITIZER",
                  "DESIGN_FILE (HEADER)",
                  "LEVEL_SYMB",
                  "CURVE",
                  "CONNECTED_STRING",
                  "???",
                  "COMPLEX_SHAPE",
                  "ELLIPSE",
                  "ARC",
                  "TEXT",
                  "SURFACE",
                  "CAPPED_SURFACE",
                  "SUBFIGURE",
                  "B_spline POLE",
                  "POINT_STRING",
                  "TRUNCATED_CONE",
                  "B_spline surface HEADER",
                  "B_spline surface BOUNDARY",
                  "B_spline KNOT",
                  "B_spline CURVE_HEADER",
                  "B_spline WEIGHT FACTOR" };

FILE *infile;
int buff[1024];
TCB tcb;

long SwapLong( long l );
void DispViewInfo( BYTE n );
void VaxToIeee( double *d );
int asciiToRadix( char *input, short *output, short length );
int radixToAscii( unsigned short *input, char *output, short length );

void main( int argc, char *argv[] )
{
  ELM_HDR ehdr;
  DISP_HDR dhdr;
  TEXT_HDR thdr;
  ARC arc;
  POINT point;
  CELL_LIB_HDR clhdr;
  CELL cell;
  char ch, name[7], descr[28];
  int i = 0, j, k, n, p, typ, nv;
  double start, sweep, rot, lmult, hmult;

  if( (infile = fopen( argv[1], "rb" )) == NULL )
    exit( 1 );
 
  while( 1 )
  {
    fread( &n, sizeof( int ), 1, infile );
    if( n == -1 )
      break;
    fseek( infile, -2L, SEEK_CUR );
    fread( &ehdr, sizeof( ELM_HDR ), 1, infile );
    typ = ehdr.type;
    i++;
    j = typ > 28 ? 0 : typ;
    printf( "\n%d.zaznam - typ: %d (%s), uroven: %d, delka: %d", i,
                                                          typ,
                                                          types[j],
                                                          ehdr.level,
                                                          ehdr.words + 2 );
    if( ehdr.complex )
      printf( " (C)" );
    if( ehdr.deleted )
      printf( " (D)" );
    printf( "\n" );

    ehdr.xlow = ( SwapLong( ehdr.xlow ) - LONG_MAX ) - 1;
    ehdr.ylow = ( SwapLong( ehdr.ylow ) - LONG_MAX ) - 1;
    ehdr.zlow = ( SwapLong( ehdr.zlow ) - LONG_MAX ) - 1;
    ehdr.xhigh = ( SwapLong( ehdr.xhigh ) - LONG_MAX ) - 1;
    ehdr.yhigh = ( SwapLong( ehdr.yhigh ) - LONG_MAX ) - 1;
    ehdr.zhigh = ( SwapLong( ehdr.zhigh ) - LONG_MAX ) - 1;
    printf( " limity [%ld,%ld,%ld:%ld,%ld,%ld]\n", ehdr.xlow,
                                                   ehdr.ylow,
                                                   ehdr.zlow,
                                                   ehdr.xhigh,
                                                   ehdr.yhigh,
                                                   ehdr.zhigh );
    n = 12;
    k = 0;
    if( typ == 2 || typ == 3 || typ == 4 || typ == 5 || typ == 7 ||
        typ == 12 || typ == 14 || typ == 15 || typ == 16 || typ == 17 ||
        typ == 18 || typ == 21 || typ == 23 || typ == 24 || typ == 25 ||
        typ == 26 || typ == 27 || typ == 28 )
    {
      fread( &dhdr, sizeof( DISP_HDR ), 1, infile );
      n = 16;
      printf( "graf grp: %d, attr.index: %d", dhdr.grphgrp,
                                              dhdr.attindx );
      if( k = ehdr.words - dhdr.attindx - 14 )
        printf( ", slov pro atributy: %d", k );
      printf( "\ntyp: %d, barva: %d, sirka: %d\n", dhdr.symb.style,
                                                   dhdr.symb.color,
                                                   dhdr.symb.weight );
      printf( "class: %d, locked: %d, new: %d, modified: %d, attributes: %d\n", dhdr.props.class,
                                                                                dhdr.props.l,
                                                                                dhdr.props.n,
                                                                                dhdr.props.m,
                                                                                dhdr.props.a );
      printf( "relative: %d, planar: %d, snappable: %d, hole: %d\n", dhdr.props.r,
                                                                     dhdr.props.p,
                                                                     dhdr.props.s,
                                                                     dhdr.props.h );
    }
    if( typ == 9 )
    {
      fread( &tcb, sizeof( TCB ), 1, infile );
      DispViewInfo( tcb.vwfull1 );
      DispViewInfo( tcb.vwfull2 );
      tcb.mastunits = SwapLong( tcb.mastunits );
      tcb.subpermast = SwapLong( tcb.subpermast );
      tcb.uorpersub = SwapLong( tcb.uorpersub );
      printf( "WorkingUnits = %ld %c%c : %ld %c%c : 1\n", tcb.mastunits,
                                                          tcb.mastname[0], tcb.mastname[1],
                                                          tcb.subpermast,
                                                          tcb.subname[0], tcb.subname[1],
                                                          tcb.uorpersub );
      n = 766;
    }
    else if( typ == 1 )
    {
      fread( &clhdr, sizeof( CELL_LIB_HDR ), 1, infile );
      radixToAscii( clhdr.name, name, 6 );
      name[6] = 0;
      radixToAscii( clhdr.descrip, descr, 27 );
      descr[27] = 0;
      printf( " \"%s\", \"%s\"\n", name, descr );
      printf( " celltype: %d, attindx: %d, numwords: %d, properties: %.4X\n", clhdr.celltype,
                                                                              clhdr.attindx,
                                                                              clhdr.numwords,
                                                                              clhdr.properties );
      printf( " dispsymb: %.4X, class: %d, levels[: %.4X %.4X %.4X %.4X\n", clhdr.dispsymb,
                                                                            clhdr.class,
                                                                            clhdr.levels[0],
                                                                            clhdr.levels[1],
                                                                            clhdr.levels[2],
                                                                            clhdr.levels[3] );
      n += sizeof( CELL_LIB_HDR ) / 2;
//    _getch();
    }
    else if( typ == 2 )
    {
      fread( &cell, sizeof( CELL ), 1, infile );
      radixToAscii( cell.name, name, 6 );
      name[6] = 0;
      cell.origin.x = SwapLong( cell.origin.x );
      cell.origin.y = SwapLong( cell.origin.y );
      printf( " name: \"%s\", origin: [ %ld, %ld]\n", name, cell.origin.x, cell.origin.y );
      printf( " length: %d, class: %.4X, levels[: %.4X %.4X %.4X %.4X\n", cell.totlength,
                                                                          cell.class,
                                                                          cell.levels[0],
                                                                          cell.levels[1],
                                                                          cell.levels[2],
                                                                          cell.levels[3] );
      cell.rnglow.x = SwapLong( cell.rnglow.x );
      cell.rnglow.y = SwapLong( cell.rnglow.y );
      cell.rnghigh.x = SwapLong( cell.rnghigh.x );
      cell.rnghigh.y = SwapLong( cell.rnghigh.y );
      printf( "rnglow: [ %ld, %ld], rnghigh: [ %ld, %ld]\n", cell.rnglow.x, cell.rnglow.y,
                                                             cell.rnghigh.x, cell.rnghigh.y );
      printf( "trans: [ %lX, %lX] [ %lX, %lX]\n", cell.trans1.x, cell.trans1.y,
                                                  cell.trans2.x, cell.trans2.y );
      cell.trans1.x = SwapLong( cell.trans1.x );
      cell.trans1.y = SwapLong( cell.trans1.y );
      cell.trans2.x = SwapLong( cell.trans2.x );
      cell.trans2.y = SwapLong( cell.trans2.y );
      printf( "trans: [ %ld, %ld] [ %ld, %ld]\n", cell.trans1.x, cell.trans1.y,
                                                  cell.trans2.x, cell.trans2.y );
      printf( "trans: [ %lX, %lX] [ %lX, %lX]\n", cell.trans1.x, cell.trans1.y,
                                                  cell.trans2.x, cell.trans2.y );
      n += sizeof( CELL ) / 2;
//    _getch();
    }
    else if( typ == 4 )
    {
      fread( &nv, sizeof( int ), 1, infile );
      printf( "pocet bodu: %d\n", nv );
      n++;
      for( j = 0; j < nv; j++ )
      {
        fread( &point, sizeof( POINT ), 1, infile );
        point.x = SwapLong( point.x );
        point.y = SwapLong( point.y );
        printf( "        [ %ld, %ld]\n", point.x, point.y );
        n += 4;
      }
      printf( "\n" );
    }
    else if( typ == 14 )
    {
      fread( &j, sizeof( int ), 1, infile );
      fread( &nv, sizeof( int ), 1, infile );
      printf( "total len: %d, pocet prvku: %d\n", j, nv );
      n += 2;
    }
    else if( typ == 16 )
    {
      fread( &arc, sizeof( ARC ), 1, infile );
      arc.startang = SwapLong( arc.startang );
      start = (double)arc.startang / 360000.0;
      arc.sweepang = SwapLong( arc.sweepang );
      sweep = (double)( arc.sweepang & 0x7FFFFFFF )/ 360000.0;
      arc.rotation = SwapLong( arc.rotation );
      rot = (double)arc.rotation / 360000.0;
      VaxToIeee( &(arc.origin.x) );
      VaxToIeee( &(arc.origin.y) );
      VaxToIeee( &(arc.primary) );
      VaxToIeee( &(arc.secondary) );
      printf( "  Origin: [ %.3lf, %.3lf]\n", arc.origin.x, arc.origin.y );
      printf( "  Axes:  %.3lf, %.3lf\n", arc.primary, arc.secondary );
      printf( "  Start: %.3lf, sweep: %.3lf (%c), rot: %.3lf\n", start, sweep,
                            arc.sweepang & 0x80000000 ? '-' : '+', rot );
      n += sizeof( ARC ) / 2;
    }
    else if( typ == 17 )
    {
      fread( &thdr, sizeof( TEXT_HDR ), 1, infile );
      thdr.lngthmult = SwapLong( thdr.lngthmult );
      thdr.hghtmult = SwapLong( thdr.hghtmult );
      thdr.rotation = SwapLong( thdr.rotation );
      lmult = (double)thdr.lngthmult / 1000.0;
      hmult = (double)thdr.hghtmult / 1000.0;
      rot = (double)thdr.rotation / 360000.0;
      thdr.origin.x = SwapLong( thdr.origin.x );
      thdr.origin.y = SwapLong( thdr.origin.y );
      printf( "  Origin: [ %ld, %ld]\n", thdr.origin.x, thdr.origin.y );

      printf( "  font: %d, just: %d, numchars: %d, edflds: %d\n", thdr.font,
                                                                  thdr.just,
                                                                  thdr.numchars,
                                                                  thdr.edflds );
      printf( "  lngthmult: %.3lf, hghtmult: %.3lf, rotation: %.3lf\n", lmult,
                                                                        hmult,
                                                                        rot );
      printf( "  \"" );
      for( j = 0; j < thdr.numchars; j++ )
      {
        fread( &ch, 1, 1, infile );
        printf( "%c", ch );
      }
      printf( "\"\n" );
      if( thdr.numchars & 1 )
      {
        thdr.numchars++;
        fread( &ch, 1, 1, infile );
      }
      n += ( thdr.numchars + sizeof( TEXT_HDR ) ) / 2;
    }

    if( ( n = ehdr.words - n ) > 0 )
      fread( buff, 2, n, infile );
    if( typ == 5 )
      for( i = 0; i < n; i++ )
        printf( "%d: %d\n", i + 1, buff[i] );
    if( k && !( k & 3 ) )
    {
      for( j = n - k, p = 0; j < n; j++, p++ )
        printf( "%.4X ", buff[j] );
      printf( "\n" );
    }

  }
  fclose( infile );
}
void DispViewInfo( BYTE n )
{
  int i = n - 1;
  unsigned long xo, yo, xd, yd;

  printf( "Pohled %d", n );
  xo = SwapLong( tcb.view[i].origin.x );
  yo = SwapLong( tcb.view[i].origin.y );
  printf( "  pocatek: %ld, %ld\n" , xo, yo );

  xd = SwapLong( tcb.view[i].delta.x );
  yd = SwapLong( tcb.view[i].delta.y );
  printf( "            delta: %ld, %ld\n" , xd, yd );
}
long SwapLong( long l )
{
  _asm
  {
    mov   ax, word ptr l + 2
    mov   dx, word ptr l
  }
}
void VaxToIeee( double *d )
{
  _asm
  {
      push  di
      push  si
      push  ds
      lds   si,[bp+06]
      mov   ax,word ptr [si]
      mov   bx,word ptr [si+02]
      mov   cx,word ptr [si+04]
      mov   dx,word ptr [si+06]
      mov   di,ax
      and   di,0x8000
      and   ax,0x7fff
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      or    ax,ax
      je    Nula
      add   ax,0x37e0
Nula:
      or    ax,di
      mov   word ptr [si],dx
      mov   word ptr [si+02],cx
      mov   word ptr [si+04],bx
      mov   word ptr [si+06],ax
      pop   ds
      pop   si
      pop   di
  }
}
int asciiToRadix( char *input, short *output, short length )
{
  int status, c, i, n;

  *output = status = i = n = 0;
  while( 1 )
  {
    c = *input++;
    if( c == ' ' )
      c = 0;
    else if( c >= 'A' && c <= 'Z' )
      c = c - 64;
    else if( c == '$' )
      c = 27;
    else if( c == '.' )
      c = 28;
    else if( c >= '0' && c <= '9' )
      c = c - 18;
    else
    {
      c = 0;
      status = -1;
    }
    *output = 40 * *output + c;
    if( ++i == length )
      break;
    if( ++n == 3 )
      *(++output) = n = 0;
  }

  while( ++n != 3 )
    *output *= 40;

  return status;
}
int radixToAscii( unsigned short *input, char *output, short length )
{
  int status, c, i;
  unsigned short n;

  status = 0;
  for( i = 0; i < length; i++ )
  {
    switch( i % 3 )
    {
      case 0:
        n = *input++;
        c = n / 1600;
        n %= 1600;
        break;
      case 1:
        c = n / 40;
        n %= 40;
        break;
      case 2:
        c = n;
    }
    if( c == 0 )
      c = ' ';
    else if( c >= 1 && c <= 26 )
      c = c + 64;
    else if( c == 27 )
      c = '$';
    else if( c == 28 )
      c = '.';
    else if( c >= 30 && c <= 39 )
      c = c + 18;
    else
    {
      c = ' ';
      status = -1;
    }
    *output++ = (char)c;
  }

  return status;
}
/*
void printTcb( TCB *tcb )
{
  unsigned fofs = _FP_OFF( tcb );
  void *adr;

  printf( "control:      %Fp   28\n", &(tcb->control)     );
  printf( "rndunit:      %Fp", &(tcb->rndunit)     );  adr = &(tcb->rndunit);
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "uorgrid:      %Fp", &(tcb->uorgrid)     );  adr = &(tcb->uorgrid);
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "refgrid:      %Fp", &(tcb->refgrid)     );   adr = &(tcb->refgrid)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "vwfull1:      %Fp", &(tcb->vwfull1)     );   adr = &(tcb->vwfull1)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "vwfull2:      %Fp", &(tcb->vwfull2)     );   adr = &(tcb->vwfull2)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "view:         %Fp", &(tcb->view)        );   adr = &(tcb->view)        ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "mastunits:    %Fp", &(tcb->mastunits)   );   adr = &(tcb->mastunits)   ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "subpermast:   %Fp", &(tcb->subpermast)  );   adr = &(tcb->subpermast)  ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "uorpersub:    %Fp", &(tcb->uorpersub)   );   adr = &(tcb->uorpersub)   ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "mastname:     %Fp", &(tcb->mastname)    );   adr = &(tcb->mastname)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "subname:      %Fp", &(tcb->subname)     );   adr = &(tcb->subname)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "actangle:     %Fp", &(tcb->actangle)    );   adr = &(tcb->actangle)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "anglernd:     %Fp", &(tcb->anglernd)    );   adr = &(tcb->anglernd)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "xactscle:     %Fp", &(tcb->xactscle)    );   adr = &(tcb->xactscle)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "yactscle:     %Fp", &(tcb->yactscle)    );   adr = &(tcb->yactscle)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "zactscle:     %Fp", &(tcb->zactscle)    );   adr = &(tcb->zactscle)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "rndscle:      %Fp", &(tcb->rndscle)     );   adr = &(tcb->rndscle)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "chheight:     %Fp", &(tcb->chheight)    );   adr = &(tcb->chheight)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "chwidth:      %Fp", &(tcb->chwidth)     );   adr = &(tcb->chwidth)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "nodespace:    %Fp", &(tcb->nodespace)   );   adr = &(tcb->nodespace)   ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "nodelen:      %Fp", &(tcb->nodelen)     );   adr = &(tcb->nodelen)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "nodejust:     %Fp", &(tcb->nodejust)    );   adr = &(tcb->nodejust)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "actfont:      %Fp", &(tcb->actfont)     );   adr = &(tcb->actfont)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "anglefmt:     %Fp", &(tcb->anglefmt)    );   adr = &(tcb->anglefmt)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "graphic:      %Fp", &(tcb->graphic)     );   adr = &(tcb->graphic)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "txtjust:      %Fp", &(tcb->txtjust)     );   adr = &(tcb->txtjust)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "rfcntrl:      %Fp", &(tcb->rfcntrl)     );   adr = &(tcb->rfcntrl)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "tentmode:     %Fp", &(tcb->tentmode)    );   adr = &(tcb->tentmode)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "tentsubmode:  %Fp", &(tcb->tentsubmode) );   adr = &(tcb->tentsubmode) ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "azimuth:      %Fp", &(tcb->azimuth)     );   adr = &(tcb->azimuth)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "ad1:          %Fp", &(tcb->ad1)         );   adr = &(tcb->ad1)         ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "props:        %Fp", &(tcb->props)       );   adr = &(tcb->props)       ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "symbology:    %Fp", &(tcb->symbology)   );   adr = &(tcb->symbology)   ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "fbfdcn:       %Fp", &(tcb->fbfdcn)      );   adr = &(tcb->fbfdcn)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "low:          %Fp", &(tcb->low)         );   adr = &(tcb->low)         ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "high:         %Fp", &(tcb->high)        );   adr = &(tcb->high)        ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "globorg:      %Fp", &(tcb->globorg)     );   adr = &(tcb->globorg)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "celllib:      %Fp", &(tcb->celllib)     );   adr = &(tcb->celllib)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "cellendsec:   %Fp", &(tcb->cellendsec)  );   adr = &(tcb->cellendsec)  ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "cellendbyte:  %Fp", &(tcb->cellendbyte) );   adr = &(tcb->cellendbyte) ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "grgrpbas:     %Fp", &(tcb->grgrpbas)    );   adr = &(tcb->grgrpbas)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "nodebase:     %Fp", &(tcb->nodebase)    );   adr = &(tcb->nodebase)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "canode:       %Fp", &(tcb->canode)      );   adr = &(tcb->canode)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "parent:       %Fp", &(tcb->parent)      );   adr = &(tcb->parent)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "sysclass:     %Fp", &(tcb->sysclass)    );   adr = &(tcb->sysclass)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "usercmd:      %Fp", &(tcb->usercmd)     );   adr = &(tcb->usercmd)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "ucdata:       %Fp", &(tcb->ucdata)      );   adr = &(tcb->ucdata)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dmrsfile:     %Fp", &(tcb->dmrsfile)    );   adr = &(tcb->dmrsfile)    ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "oldref:       %Fp", &(tcb->oldref)      );   adr = &(tcb->oldref)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "linkgen:      %Fp", &(tcb->linkgen)     );   adr = &(tcb->linkgen)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dmrsflg:      %Fp", &(tcb->dmrsflg)     );   adr = &(tcb->dmrsflg)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "tutview:      %Fp", &(tcb->tutview)     );   adr = &(tcb->tutview)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "iactfl:       %Fp", &(tcb->iactfl)      );   adr = &(tcb->iactfl)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "ad2:          %Fp", &(tcb->ad2)         );   adr = &(tcb->ad2)         ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dynamicorg:   %Fp", &(tcb->dynamicorg)  );   adr = &(tcb->dynamicorg)  ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dynamicext:   %Fp", &(tcb->dynamicext)  );   adr = &(tcb->dynamicext)  ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dytab:        %Fp", &(tcb->dytab)       );   adr = &(tcb->dytab)       ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "cntrl1:       %Fp", &(tcb->cntrl1)      );   adr = &(tcb->cntrl1)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "ad3:          %Fp", &(tcb->ad3)         );   adr = &(tcb->ad3)         ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "auxtype:      %Fp", &(tcb->auxtype)     );   adr = &(tcb->auxtype)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "dyndwnext:    %Fp", &(tcb->dyndwnext)   );   adr = &(tcb->dyndwnext)   ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "fbfdcn2:      %Fp", &(tcb->fbfdcn2)     );   adr = &(tcb->fbfdcn2)     ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "reserv:       %Fp", &(tcb->reserv)      );   adr = &(tcb->reserv)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
  printf( "tcbend:       %Fp", &(tcb->tcbend)      );   adr = &(tcb->tcbend)      ;
  printf( " %4d\n", _FP_OFF( adr ) - fofs + 28 );
}
*/
