unit f_EditorOIL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Edit: TRichEdit;
    MainMenu1: TMainMenu;
    StatusBar: TStatusBar;
    File1: TMenuItem;
    Open1: TMenuItem;
    Syntax1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure EditSelectionChange(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Syntax1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ProcessLineSyntax(const S: string; RealPos,LinePos: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.EditSelectionChange(Sender: TObject);
var
   ln,li: integer;
begin
   Ln :=   Edit.Perform(EM_LINEFROMCHAR, -1, 0);
   Li :=   Edit.Perform(EM_LINEINDEX, -1, 0);
   Li :=   Edit.SelStart - Li;
   StatusBar.SimpleText := IntToStr(Ln)+'/'+IntToStr(Li);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
   if OpenDialog.InitialDir = '' then
      OpenDialog.InitialDir := 'c:\orbis32\exe\led';
   if OpenDialog.Execute then
   begin
      OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
      Edit.Lines.LoadFromFile(OpenDialog.FileName);
   end;
end;

procedure TForm1.ProcessLineSyntax(const S: string; RealPos, LinePos: integer);
var
   i,l: integer;
   CommentStart,cs: integer;
begin
   l := Length(S);
   if S[LinePos]=';' then
   begin
      CommentStart := RealPos + LinePos - 1;
      Edit.SelStart := CommentStart;
      Edit.SelLength := l - LinePos + 1;
      Edit.SelAttributes.Color := clSilver;
      Application.ProcessMessages;
   end
end;

procedure TForm1.Syntax1Click(Sender: TObject);
var
   i: integer;
   l: integer;
   _Start,_End: integer;
   BlockComment: boolean;
   BlockCommentStart,BlockCommentLength: integer;
   _Comment: boolean;
   _CommentStart,_CommentLength: integer;
   Realpos: integer;
   LinePos: integer;
   LineLength: integer;
   S: string;
   CH: char;
   OldSelStart: integer;
   OldSelLength: integer;
   C1: integer;
   function  SkipWhiteSpace: boolean;
   begin
      while (LinePos <= LineLength) and (S[LinePos] in [' ',#9]) do Inc(LinePos);
      result := LinePos <= LineLength;
   end;
begin
   Edit.Enabled := false;
   OldSelStart := Edit.SelStart;
   OldSelLength := Edit.SelLength;
   l := Length(Edit.Text);
   Edit.SelStart :=0;
   Edit.SelLength := l;
   Edit.SelAttributes.Color := clBlack;
   Application.ProcessMessages;
   RealPos := 0;
   BlockComment := false;
   BlockCommentStart := 0;
   //BlockCommentLength := 0;
   C1 := Edit.Lines.Count;
   for i := 0 to Edit.Lines.Count - 1 do
   begin
      LinePos := 1;
      S := Edit.Lines.Strings[i];
      LineLength := Length(S);
      if SkipWhiteSpace then // krom mezer tam jeste neco je
      begin
         //CH := S[LinePos];
         // komentar bloku
         {
         if S[LinePos] = '*' then
         begin
            if BlockComment then
            begin
               BlockCommentLength := RealPos + LinePos - BlockCommentStart;
               Edit.SelStart := BlockCommentStart;
               Edit.SelLength := BlockCommentLength;
               Edit.SelAttributes.Color := clSilver;
               //Edit.SelAttributes.Style := [fsBold];
               BlockComment := false;
               Application.ProcessMessages;
            end
            else
            begin
               BlockCommentStart := RealPos + LinePos -1;
               BlockComment := true;
            end;
         end
         else
         if not BlockComment then
         }
            ProcessLineSyntax(S,RealPos,LinePos);

      end;
      RealPos := Realpos + LineLength + 2;
   end;
   if BlockComment then
   begin
      BlockCommentLength := l-BlockCommentStart;
      Edit.SelStart := BlockCommentStart;
      Edit.SelLength := BlockCommentLength;
      Edit.SelAttributes.Color := clSilver;
      Application.ProcessMessages;
   end;
   Edit.Enabled := true;
   Edit.SelStart := OldSelStart;
   Edit.SelLength := OldSelLength;
   Edit.SetFocus;
   ShowMessage(IntToStr(C1)+'/'+IntToStr(i));
end;

end.
