unit F_ExpDgn50;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, Wwquery, Wwdatsrc, StdCtrls, Buttons, Mask, Wwdbedit,
  Wwdotdot, Wwdbcomb, ComCtrls, ExtCtrls, wwdblook, DBCtrls;

type
  TFExpDGN = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    BBtn_Export: TBitBtn;
    BBtn_Close: TBitBtn;
    wwQry1_Mapy10: TwwQuery;
    SaveDialog1: TSaveDialog;
    wwQry1_Mapy10MAPA_001: TStringField;
    wwQry1_Texty10: TwwQuery;
    wwQry1_Texty10POCET: TFloatField;
    wwQry1_ExpTxt10: TwwQuery;
    wwQry1_ExpTxt10NAZEV_TISK_001: TStringField;
    wwQry1_ExpTxt10SOUR_LDX_001: TFloatField;
    wwQry1_ExpTxt10SOUR_LDY_001: TFloatField;
    wwQry1_ExpTxt10SOUR_PDX_001: TFloatField;
    wwQry1_ExpTxt10SOUR_PDY_001: TFloatField;
    wwQry1_ExpTxt10FONT_NAME_001: TStringField;
    wwQry1_ExpTxt10FONT_HEIGHT_001: TFloatField;
    wwQry1_ExpTxt10FONT_COLOR_001: TFloatField;
    wwQry1_ExpTxt10FONT_STYLE_001: TFloatField;
    wwQry1_ExpTxt10FONT_ALIGN_001: TFloatField;
    wwQry1_ExpTxt10LINE_HEIGHT_001: TFloatField;
    wwQry1_CisFontu: TwwQuery;
    wwQry1_ExpTxt10POR_CIS_OBJ_001: TFloatField;
    wwQry1_CisFontuFONT_ID_DGN_104: TFloatField;
    wwQry1_CisFontuFONT_NAME_104: TStringField;
    RdGr_TypMapy: TRadioGroup;
    wwQry1_Mapy50: TwwQuery;
    CmbBox_Mapy10: TComboBox;
    CmbBox_Mapy50: TComboBox;
    ListBox1: TListBox;
    wwQry1_Mapy50SUBSTRMAPA_00115: TStringField;
    Panel3: TImage;
    wwQry1_Mapy10_50: TwwQuery;
    wwQry1_Mapy10_50MAPA_001: TStringField;
    wwQry1_CountMapy10_50: TwwQuery;
    wwQry1_CountMapy10_50COUNTDISTINCTMAPA_001: TFloatField;
    Exp_Path: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    BitBtn_UPSize: TBitBtn;
    BitBtn_DownSize: TBitBtn;

    procedure FormCreate(Sender: TObject);
    procedure CmbBox_Mapy10Change(Sender: TObject);
    procedure BBtn_ExportClick(Sender: TObject);
    procedure RdGr_TypMapyClick(Sender: TObject);
    procedure BitBtn_UPSizeClick(Sender: TObject);
    procedure BitBtn_DownSizeClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
     fntName: String;

     function  GetNameDGN(Mapa10: String): String;
     function  StartSaveDialog1: Boolean;
     function  VratCisloFontu: Integer;
     function  VyhodPomlcky(aStr: String): String;

     procedure AddToListBox(aStr: String);
     procedure Export_Mapa10(Mapa10, aPathDGN: String; pouzeDesitka: Boolean);
     procedure Export_Mapa50(Mapa50, aPathDGN: String);
     procedure NastavBBtnExport;
     procedure NastavPanel(pnlCaption: String);
     procedure UlozTextDoDGN(PocetZazn: LongInt; Krok: Double; Mapa, aPathDGN: String;
               desitka: Boolean);
     procedure UpSetText(aUp: Boolean);
  public
    { Public declarations }
//     property PathExpDGN: String read FPathExpDGN write SetPathExpDGN;
  end;

var
  FExpDGN: TFExpDGN;

implementation

uses u_DBLib, IniFiles, FileCtrl, t_DGNExp,
     T_GNIntr,
     MathLib,
     Elements,
     e_ZM,
     g_Elems,
     u_string;

{$R *.DFM}



procedure TFExpDGN.FormCreate(Sender: TObject);
var
   aIni: TIniFile;
   ExportDir, IniFile: String;
begin
   IniFile := ExtractFilePath(ParamStr(0)) + 'GN.INI';
   aIni := TiniFile.Create(IniFile);
   ExportDir := UpperCase(aIni.ReadString('Options', 'ExportDirectory', ''));
   aIni.Free;

   if DirectoryExists(ExportDir) then
       Exp_Path.Text := ExportDir
   else
       Exp_Path.Text := '';


   orbOpenQuery(wwQry1_Mapy10);
   with wwQry1_Mapy10 do
   begin
      DisableControls;
      First;

      while not EOF do
      begin
         CmbBox_Mapy10.Items.Add(wwQry1_Mapy10MAPA_001.AsString);
         next;
      end;
      EnableControls;
      Close;
   end;

   CmbBox_Mapy10.Text := CmbBox_Mapy10.Items[1];
//   CmbBox_Mapy10.ItemIndex := 0;

   orbOpenQuery(wwQry1_Mapy50);

   with wwQry1_Mapy50 do
   begin
      DisableControls;
      First;

      while not EOF do
      begin
         CmbBox_Mapy50.Items.Add(wwQry1_Mapy50SUBSTRMAPA_00115.AsString);
         Next;
      end;

      EnableControls;
      Close;
   end;

   CmbBox_Mapy50.Text := CmbBox_Mapy50.Items[1];
//   CmbBox_Mapy50.ItemIndex := 0;
   NastavBBtnExport;
   Application.ProcessMessages;
end;



procedure TFExpDGN.NastavBBtnExport;
begin
   if (((RdGr_TypMapy.ItemIndex = 0) and (CmbBox_Mapy10.Text = ''))
      or ((RdGr_TypMapy.ItemIndex = 1) and (CmbBox_Mapy50.Text = ''))) then
      BBtn_Export.Enabled := False
   else
      BBtn_Export.Enabled := True;
end;



procedure TFExpDGN.CmbBox_Mapy10Change(Sender: TObject);
begin
   NastavBBtnExport;
end;



procedure TFExpDGN.BBtn_ExportClick(Sender: TObject);
begin
   if not DirectoryExists(Exp_Path.Text) then
   begin
      MessageDlg('Chybn sloka pro export "' + Exp_Path.Text
        + '".' + #13#10 + 'Export byl peruen!', mtError, [mbOK], 0);
      Exit;
   end;

   NastavPanel('Pipravuji data pro export ...');
   ListBox1.Items.Clear;


   if RdGr_TypMapy.ItemIndex = 0 then
      Export_Mapa10(CmbBox_Mapy10.Text, Exp_Path.Text, True)
   else
      Export_Mapa50(CmbBox_Mapy50.Text, Exp_Path.Text);
end;



procedure TFExpDGN. Export_Mapa50(Mapa50, aPathDGN: String);
var
  PocetZazn: LongInt;
  Krok: Double;
begin
   AddToListBox('Export Mapy 1:50 000:');
   AddToListBox('Sloka:' + aPathDGN);
   AddToListBox('Mapa slo: ' + Mapa50);
   AddToListBox('--------------------------------------------');

   with wwQry1_CountMapy10_50 do
   begin
      Params[0].AsString := Mapa50 + '%';
      Prepare;

      if orbOpenQuery(wwQry1_CountMapy10_50) then
      begin
         if wwQry1_CountMapy10_50COUNTDISTINCTMAPA_001.AsInteger <= 0 then
         begin
            close;
            MessageDlg('Mapov list ' + Mapa50
              + ' neobsahuje dn vyplnn mapy 1:10 000.' + #13#10
              + 'Export byl peruen!', mtInformation, [mbOK], 0);
            NastavPanel('');

            AddToListBox('Mapov list');
            AddToListBox('neobsahuje dn');
            AddToListBox('vyplnn mapy 1:10 000');
            AddToListBox('Export byl peruen');

            exit;
         end;

         PocetZazn := wwQry1_CountMapy10_50COUNTDISTINCTMAPA_001.AsInteger;
         Krok := 100.00 / PocetZazn;
         Close;
      end
      else
      begin
         NastavPanel('');
         exit;
      end;
   end;

   NastavPanel('');

   with wwQry1_Mapy10_50 do
   begin
      Params[0].AsString := Mapa50 + '%';
      Prepare;

      if not orbOpenQuery(wwQry1_Mapy10_50) then
      begin
         exit
      end;

      DisableControls;
      First;

      while not EOF do
      begin
          Export_Mapa10(wwQry1_Mapy10_50MAPA_001.AsString, aPathDGN, False);
          next;
      end;

      Close;
   end;

end;



procedure TFExpDGN.Export_Mapa10(Mapa10, aPathDGN: String; pouzeDesitka: Boolean);
var
  PocetZazn: LongInt;
  Krok: Double;
begin
   NastavPanel('Pipravuji data pro export mapy ' + Mapa10 + '...');

   with wwQry1_Texty10 do
   begin
      Params[0].AsString := Mapa10;
      Prepare;

      if orbOpenQuery(wwQry1_Texty10) then
      begin
         if wwQry1_Texty10POCET.AsInteger<=0 then
         begin
            close;
            AddToListBox('Mapov list: ' + Mapa10);
            AddToListBox('  dn text.');
            NastavPanel('');

            exit;
         end;

         PocetZazn := wwQry1_Texty10POCET.AsInteger;
         Krok := 100.00 / PocetZazn;
         Close;
      end
      else
      begin
         NastavPanel('');
         exit;
      end;
   end;

   NastavPanel('');

   with wwQry1_ExpTxt10 do
   begin
      Params[0].AsString := Mapa10;
      Prepare;

      if orbOpenQuery(wwQry1_ExpTxt10) then UlozTextDoDGN(PocetZazn, Krok, Mapa10, aPathDgn, pouzedesitka);

      Close;
   end;

end;



function TFExpDGN.StartSaveDialog1: Boolean;
var
   aIni: TIniFile;
   ExportDir, IniFile: String;
begin

   IniFile := ExtractFilePath(ParamStr(0)) + 'GN.INI';
   aIni := TiniFile.Create(IniFile);
   ExportDir := UpperCase(aIni.ReadString('Options', 'ExportDirectory', ''));

   if DirectoryExists(ExportDir) then
      SaveDialog1.InitialDir := ExportDir
   else
      SaveDialog1.InitialDir := '';

   SaveDialog1.FileName := 'ML' + VyhodPomlcky(CmbBox_Mapy10.Text) + '.DGN';

   if SaveDialog1.Execute then
   begin
      Result := True;

      if ExtractFilePath(SaveDialog1.FileName) <> ExportDir then
         aINI.WriteString('Options', 'ExportDirectory',
            UpperCase(ExtractFilePath(SaveDialog1.FileName)));
   end
   else
      Result := False;

   aIni.Free;
end;


function TFExpDGN.VyhodPomlcky(aStr: String): String;
begin
  while Pos('-', aStr) > 0 do
    Delete(aSTr, Pos('-', aStr), 1);

  Result := aStr;
end;



{VCH 29.6.1999}
function TFExpDGN.GetNameDGN(Mapa10: String): String;
begin
   Result := 'ML' + VyhodPomlcky(Mapa10) + '.DGN';
end;



procedure TFExpDGN.UlozTextDoDGN(PocetZazn: LongInt; Krok: Double; Mapa, aPathDGN: String; desitka: Boolean);
var
   DGNE: TDGNExport;
   En: TEntity;
   E: TMSTextElement;
   i: integer;
   A,B: TDoubleCoord;
   Rotation: Double;
   TextL, TextH: double;
   LineH: double;
   TextSiz: integer;
   PomCislo: Double;
   CisloFontu: Integer;
   TextS: string;
   Resolution, Mult: double;
   aZM: TMapsZM;
   FileNameDGN: String;
begin
  aZM:= TMapsZM.Create;
  aZM.MapName:= CmbBox_Mapy10.Text;

  if aZM.Scale = 0 then
  begin
    ShowMessage('patn mapov list: ' + Mapa);
    exit;
  end;

  screen.cursor := crHourglass;
  {VCH 29.6.1999}
   FileNameDGN := CheckBackSlash(aPathDGN) + GetNameDGN(Mapa);

  {PK 22.4.1998}
  Resolution := 1000 * Screen.PixelsPerInch / 25.4;
  Mult := 10000 / Resolution;

  {VCH 29.6.1999}
   NastavPanel('Exportuji data do souboru ' + FileNameDGN + ' ...');

   DGNE := TDGNExport.Create;
  {VCH 29.6.1999}
   DGNE.FileName := FileNameDGN;
   DGNE.Open;
   DGNE.SetBackgroundColor($FFFFFF);
   PomCislo := 0;
   CisloFontu := 0;

   with wwQry1_ExpTxt10 do
   begin
      DisableControls;
      First;

      while not EOF do
      begin
         CisloFontu := VratCisloFontu;
         A.x :=-wwQry1_ExpTxt10SOUR_LDY_001.AsFloat;
         A.y :=-wwQry1_ExpTxt10SOUR_LDX_001.AsFloat;
         B.x :=-wwQry1_ExpTxt10SOUR_PDY_001.AsFloat;
         B.y :=-wwQry1_ExpTxt10SOUR_PDX_001.AsFloat;

         TextH := wwQry1_ExpTxt10FONT_HEIGHT_001.AsFloat;
         TextSiz := round(TextH);
         {PK 22.4.1998}
         TextH := Abs(TextH);
         TextH := TextH * Mult;
         TextS := wwQry1_ExpTxt10NAZEV_TISK_001.AsString;

         if (B.x <> 0) and (B.y <> 0) then
            XYToPolar(A,B, TextL, Rotation)
         else
         begin
            TextL := TextH * Length(TextS);
            Rotation := aZM.Angle;;
         end;

         En := TEntity(DGNE.GetMultiText(TextS));
         //En := nil;
         if En = nil then
         begin
            DGNE.WriteText(CisloFontu, wwQry1_ExpTxt10FONT_COLOR_001.AsInteger,
              -wwQry1_ExpTxt10SOUR_LDY_001.AsFloat,
              -wwQry1_ExpTxt10SOUR_LDX_001.AsFloat,
               TextH, TextL, Rotation, TextS);
         end
         else
         begin
            Panel3.Canvas.Font.Name := FntName;
            Panel3.Canvas.Font.Size := TextSiz;
            LineH := Mult * Panel3.Canvas.TextHeight(TextS);
            LineH := LineH - TextH;
            for i := 0 to En.Count-1 do
            begin
               E := TMSTextElement(En.Elements[i]);
               E.LengthT := Mult * Panel3.Canvas.TextWidth(E.Text);
            end;
            DGNE.WriteTextNode(CisloFontu, wwQry1_ExpTxt10FONT_COLOR_001.AsInteger,
              -wwQry1_ExpTxt10SOUR_LDY_001.AsFloat,
              -wwQry1_ExpTxt10SOUR_LDX_001.AsFloat,
               TextH, TextL,LineH, Rotation, En);
         end;

{         DG
   wwQry1_ExpTxtNAZEV_TISK_001.AsString;
   wwQry1_ExpTxtSOUR_LDX_001.AsFloat;
   wwQry1_ExpTxtSOUR_LDY_001.AsFloat;
   wwQry1_ExpTxtSOUR_PDX_001.AsFloat;
   wwQry1_ExpTxtSOUR_PDY_001.AsFloat;
   wwQry1_ExpTxtFONT_NAME_001.AsString;
   wwQry1_ExpTxtFONT_HEIGHT_001.AsFloat;
   wwQry1_ExpTxtFONT_COLOR_001.AsInteger;
   wwQry1_ExpTxtFONT_STYLE_001.AsFloat;
   wwQry1_ExpTxtFONT_ALIGN_001.AsFloat;
   wwQry1_ExpTxtLINE_HEIGHT_001.AsFloat;
 }


         next;
         PomCislo := PomCislo + Krok;
         ProgressBar1.Position :=  Round(PomCislo);
         Application.ProcessMessages;
      end;
      EnableControls;
      DGNE.Close;
      DGNE.Free;
      NastavPanel('');

      screen.cursor := crDefault;
      ProgressBar1.Position := 0;

      if desitka then
      begin
         MessageDlg('Export do souboru ' + FileNameDGN
          + ' spn ukonen.' + #13#10
          + 'Poet zapsanch text: ' + IntToStr(RecordCount),
          mtInformation, [mbOK], 0);
      end
      else
      begin
         AddToListBox('   Mapov list: ' + Mapa + ';   exportovanch text: ' + IntToStr(RecordCount));
         AddToListBox('----------------');
      end;
   end;
   aZM.Free
end;



function TFExpDGN.VratCisloFontu: Integer;
begin

   Result := 0;
   with wwQry1_CisFontu do
   begin
      Params[0].AsInteger := wwQry1_ExpTxt10POR_CIS_OBJ_001.AsInteger;
      Prepare;
      fntName := '';
      if orbOpenQuery(wwQry1_CisFontu) then
      begin
         if (RecordCount > 0) then
         begin
            fntName := wwQry1_ExpTxt10FONT_NAME_001.AsString;
            Result := wwQry1_CisFontuFONT_ID_DGN_104.AsInteger
         end
         else
            MessageDlg('V tabulce "selnk pouitch typ psma na map" '
              + #13#10 + 'nebyl nalezen pouit font "'
              + wwQry1_ExpTxt10FONT_NAME_001.AsString +'"'
              + #13#10 + 'pro text "' + wwQry1_ExpTxt10NAZEV_TISK_001.AsString
              + '"', mtInformation, [mbOK], 0);

         Close;
     end;
   end;
end;



procedure TFExpDGN.NastavPanel(pnlCaption: String);
begin
   StatusBar1.Panels.Items[1].Text := '  ' + pnlCaption;
   Application.ProcessMessages;
end;



procedure TFExpDGN.AddToListBox(aStr: String);
begin
   ListBox1.Items.Add(aStr);
   Application.ProcessMessages;
end;



procedure TFExpDGN.RdGr_TypMapyClick(Sender: TObject);
begin
   if  RdGr_TypMapy.ItemIndex = 0 then
   begin
      CmbBox_Mapy10.Enabled := True;
      CmbBox_Mapy50.Enabled := False;
   end
   else
   begin
      CmbBox_Mapy10.Enabled := False;
      CmbBox_Mapy50.Enabled := True;
   end;
end;



procedure TFExpDGN.UpSetText(aUp: Boolean);
var
  I, N: integer;
  aLX, aLY, aPX, aPY, anAngle: Double;
  anOK: Boolean;
  aTM: TTextMetric;
  aShift: Double;
  QFStyle: Byte;

  Resolution, Mult, TextH: Double;
  aVal: string;
begin
  try
    Resolution := 1000 * Screen.PixelsPerInch / 25.4;
    Mult := 10000 / Resolution;
    with wwQry1_ExpTxt10 do
    begin

      Params[0].AsString := CmbBox_Mapy10.Text;
      Prepare;

      if not orbOpenQuery(wwQry1_ExpTxt10) then exit;

        DisableControls;
        First;

        while not EOF do
        begin
           aLY:= -wwQry1_ExpTxt10SOUR_LDX_001.AsFloat;
           aLX:= -wwQry1_ExpTxt10SOUR_LDY_001.AsFloat;
           aPY:= -wwQry1_ExpTxt10SOUR_PDX_001.AsFloat;
           aPX:= -wwQry1_ExpTxt10SOUR_PDY_001.AsFloat;
           aVal:= wwQry1_ExpTxt10NAZEV_TISK_001.AsString;
           TextH := wwQry1_ExpTxt10FONT_HEIGHT_001.AsFloat;
//           TextSiz := round(TextH);
           {PK 22.4.1998}
           TextH := Abs(TextH);
           TextH := TextH * Mult;

           if (aPX=0) or (aPY=0) then
              anAngle:= GetZMAngleForXY(aLX, aLY)
           else
              anAngle:= ATan2M(aPX-aLX, aPY-aLY);

           with Panel3.Canvas do
           begin
             Font.Name:= wwQry1_ExpTxt10FONT_NAME_001.AsString;
             Font.Size:= 100;
             Font.Color:= wwQry1_ExpTxt10FONT_COLOR_001.AsInteger;
             QFStyle := wwQry1_ExpTxt10FONT_STYLE_001.AsInteger;
             Font.Style:= TFontStyles(QFStyle);
           end;

           anOK:= GetTextMetrics(Panel3.Canvas.Handle, aTM);
           aShift:= TextH;
           aShift:= (aShift / aTM.tmHeight) * aTM.tmDescent;

           if aUp then
           begin
             {Posun nahoru }
             PosunSour(aLX, aLY, aShift, (anAngle+Pi/2));

             if (aPX<>0) or (aPY<>0) then
                PosunSour(aPX, aPY, aShift, (anAngle+Pi/2));

           end
           else
           begin
             {Posun dolu }
             PosunSour(aLX, aLY, aShift, -(anAngle+Pi/2));

             if (aPX<>0) or (aPY<>0) then
                PosunSour(aPX, aPY, aShift, - (anAngle+Pi/2));
           end;

           Edit;
           wwQry1_ExpTxt10SOUR_LDX_001.AsFloat := round(-aLY);
           wwQry1_ExpTxt10SOUR_LDY_001.AsFloat := round(-aLX);

           if (aPX<>0) or (aPY<>0) then
           begin
              wwQry1_ExpTxt10SOUR_PDX_001.AsFloat := round(-aPY);
              wwQry1_ExpTxt10SOUR_PDY_001.AsFloat := round(-aPX);
           end;
           Post;

           Next;
        end;

        EnableControls;
        Close;
      end;
   except
   end;
end;


procedure TFExpDGN.BitBtn_UPSizeClick(Sender: TObject);
begin
    UpSetText(True);
end;

procedure TFExpDGN.BitBtn_DownSizeClick(Sender: TObject);
begin
    UpSetText(False);
end;


procedure TFExpDGN.SpeedButton1Click(Sender: TObject);
var
   aIni: TIniFile;
   ExportDir, IniFile: String;
begin

   IniFile := ExtractFilePath(ParamStr(0)) + 'GN.INI';
   aIni := TiniFile.Create(IniFile);

   if DirectoryExists(Exp_Path.Text) then
      SaveDialog1.InitialDir := Exp_Path.Text
   else
      SaveDialog1.InitialDir := '';


   if SaveDialog1.Execute then
   begin
      if ExtractFilePath(SaveDialog1.FileName) <> Exp_Path.Text then
      begin
         aINI.WriteString('Options', 'ExportDirectory',
            UpperCase(ExtractFilePath(SaveDialog1.FileName)));
         Exp_Path.Text := UpperCase(ExtractFilePath(SaveDialog1.FileName));
      end;
   end;

   aIni.Free;

end;




BEGIN
   Classes.RegisterClass(TFExpDGN);
END.

