unit F_main;

interface

uses
  { test }
  t_Saver,
  e_MSpace,

  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus,
  Elements,
  Tools, ExtCtrls, StdCtrls, Mask, Buttons, ComCtrls,
  {$IFNDEF NOSESTAVY}
  UPrint,
  {$ENDIF}
  DB, DBTables,
  Fabout1;

type

  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    Konec: TMenuItem;
    Help: TMenuItem;
    Ciselniky: TMenuItem;
    Timer1: TTimer;
    OpenDialog: TOpenDialog;
    Sestavy: TMenuItem;
    OAplikaci1: TMenuItem;
    Obsah1: TMenuItem;
    Status: TStatusBar;
    Nastaveni: TMenuItem;
    Panel1: TPanel;
    BitBtn4: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn5: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    B_DruhGo: TMenuItem;
    B_DruhOz: TMenuItem;
    B_Du: TMenuItem;
    B_Ku: TMenuItem;
    Query1: TQuery;
    Query1ROLE_100: TStringField;
    B_TypPis: TMenuItem;
    Adresrastr1: TMenuItem;
    Prava: TMenuItem;
    Adreasexportovanchsoubor1: TMenuItem;
    N1: TMenuItem;
    Exporty1: TMenuItem;
    BExpDGN: TMenuItem;
    procedure KonecClick(Sender: TObject);
    procedure HelpClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure UlozitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Obsah1Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure SestavyClick(Sender: TObject);
    procedure PravaClick(Sender: TObject);
    procedure Adresrastr1Click(Sender: TObject);
    procedure B_DruhGoClick(Sender: TObject);
    procedure BExpDGNClick(Sender: TObject);

  private
    BM: integer;
    procedure ChangeBM;
    procedure SetMessageText(aText: string);
    procedure UkazForm(Sender: TObject);
  public
    Tool: TTool;
    IsPossibleToClose: boolean;
    OrigMem: longInt;
    property  MessageText: string write SetMessageText;

    procedure CiziKey(Sender: TObject; var Key: Word; Shift: TShiftState);
  end;



var
  MainForm: TMainForm;
  AboutBox: TAboutBox;



implementation


{$R *.DFM}
uses
   { Test}
   g_Elems,
//   e_TopMDL,

   IniFiles,
   M_Orbis,
   F_Start, M_Proj,
   t_Main,
   u_String,
   Worlds,

   UDBForm,

   F_DruhGo, F_DruhOz, F_Du, F_Ku, F_Users, F_TypPis;

{$IFDEF WIN32}
{$R TEST32}
{$ELSE}
{$R TEST}
{$ENDIF}


procedure TMainForm.SetMessageText(aText: string);
begin
   Status.SimpleText := aText;
end;




procedure TMainForm.UkazForm(Sender: TObject);
var
   aForm: TForm;
   aClass: TFormClass;
   Nasel: boolean;
   I: integer;
   S: string;
begin
   Nasel:= false;
   aForm := nil;

   if not (TButton(Sender) is TButton) then exit;

   S := TButton(Sender).Name;
   S[1] := 'F';
   S := 'T' + S;
   aClass := TFormClass(GetClass(S));
   if aClass = nil then exit;

   for I := 0 to Screen.FormCount - 1 do
   begin
      aForm := (Screen.Forms[I]);
      if (aForm is aClass) then
      begin
         Nasel:= true;
         Break;
      end;
   end;

   if not Nasel then
      aForm := aClass.Create(Self);

   if aForm = nil then exit;

   Screen.Cursor := crDefault;
   aForm.Show;
end;



procedure TMainForm.ChangeBM;
var
   ch: array[0..30] of char;
   s : string;
begin
   inc(BM);
   if BM > 30 then BM := 1;
   s := 'BITMAP_'+ IntToStr(BM);
   StrPCopy(ch, s);
   Image1.Picture.Bitmap.Handle := LoadBitmap(HInstance, ch);
end;

procedure TMainForm.KonecClick(Sender: TObject);
begin
   Tool.PostMsg(tm_QuitTask, Tool, nil, DontKill);
end;



procedure TMainForm.HelpClick(Sender: TObject);
begin
//   Tool.PostMsg(tm_About,  Tool, nil, DontKill)
   try
      AboutBox.ShowModal;
   except
      AboutBox := TAboutBox.Create(self);
      AboutBox.ShowModal;
   end;

end;



procedure TMainForm.FormCloseQuery(Sender: TObject;
                                   var CanClose: Boolean);
begin
  if IsPossibleToClose then
  begin
     CanClose:= true
  end
  else
  begin
    CanClose:= false;
    Tool.PostMsg(tm_QuitTask,  Tool, nil, DontKill)
  end
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= caFree
end;



procedure TMainForm.Timer1Timer(Sender: TObject);
begin
   ChangeBM;
end;



procedure TMainForm.Image1Click(Sender: TObject);
begin
   Timer1.Enabled  := not(Timer1.Enabled);
end;



procedure TMainForm.UlozitClick(Sender: TObject);
var
   Saver: TSaver;
begin
   Saver := TSaver.Create;
   Saver.Input := World.ObjectModel;
   Saver.DoIt;
end;



procedure TMainForm.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
begin
   try
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);
      Left        := Ini.ReadInteger('MainForm','Left', 0);
      Top         := Ini.ReadInteger('MainForm','Top', 0);

      Ini.Free;
   except
   end;
end;



procedure TMainForm.FormDestroy(Sender: TObject);
var
   Ini: TIniFile;
begin
   try
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);

      Ini.WriteInteger('MainForm','Left', Left);
      Ini.WriteInteger('MainForm','Top', Top);
      Ini.Free;
   except
   end;
end;



procedure TMainForm.Obsah1Click(Sender: TObject);
begin
  if not Application.HelpContext(0) then
     ShowMessage('Soubor npovdy neexistuje')
end;



procedure TMainForm.BitBtn6Click(Sender: TObject);
begin
    Tool.PostMsg(tm_SetOptions, Tool, nil, DontKill);
end;



procedure TMainForm.SestavyClick(Sender: TObject);
var
{   S: PChar;}

   vysl: integer;
   S: array[0..500] of Char;
begin
   StrPCopy(S, ExtractFilePath(ParamStr(0))+ 'Reporter.exe');

   vysl := winexec(S, SW_SHOW);

  {$IFNDEF NOSESTAVY}
  Screen.Cursor := crHourGlass;
  if FPrint = nil then FPrint := TFPrint.Create(Application);
  FPrint.Show;
  {$ENDIF}
end;



procedure TMainForm.PravaClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  Users := TUsers.Create(Application);
  Users.BorderIcons := Users.BorderIcons + [biMaximize,biMinimize];
  Users.BitBtnCancel.Caption := 'Zavt';
  Users.Show;

end;



procedure TMainForm.CiziKey(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_F2:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).DBNavigator1.BtnClick(nbPost);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).DBNavigator1.BtnClick(nbPost);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).DBNavigator1.BtnClick(nbPost);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).DBNavigator1.BtnClick(nbPost);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).DBNavigator1.BtnClick(nbPost);
          end;
    VK_F4:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).DBNavigator1.BtnClick(nbEdit);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).DBNavigator1.BtnClick(nbEdit);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).DBNavigator1.BtnClick(nbEdit);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).DBNavigator1.BtnClick(nbEdit);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).DBNavigator1.BtnClick(nbEdit);
          end;
    VK_F6:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).DBNavigator1.BtnClick(nbInsert);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).DBNavigator1.BtnClick(nbInsert);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).DBNavigator1.BtnClick(nbInsert);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).DBNavigator1.BtnClick(nbInsert);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).DBNavigator1.BtnClick(nbInsert);
          end;
    VK_F8:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).DBNavigator1.BtnClick(nbDelete);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).DBNavigator1.BtnClick(nbDelete);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).DBNavigator1.BtnClick(nbDelete);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).DBNavigator1.BtnClick(nbDelete);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).DBNavigator1.BtnClick(nbDelete);
          end;
    VK_F11:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).DBNavigator1.BtnClick(nbCancel);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).DBNavigator1.BtnClick(nbCancel);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).DBNavigator1.BtnClick(nbCancel);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).DBNavigator1.BtnClick(nbCancel);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).DBNavigator1.BtnClick(nbCancel);
          end;
  end;

{
  case Key of
    VK_F2:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).SBSaveRecClick(Sender);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).SBSaveRecClick(Sender);
          end;
    VK_F4:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).OpravRec;
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).OpravRec;
          end;
    VK_F6:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).PridejRec;
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).PridejRec;
          end;
    VK_F8:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).SmazRec;
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).SmazRec;
          end;
    VK_F11:begin
            if Screen.ActiveForm is TFDBForm then TFDBForm(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_DruhGo then TF_DruhGo(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_DruhOz then TF_DruhOz(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_Du then TF_Du(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_Ku then TF_Ku(Screen.ActiveForm).SBUndoRecClick(Sender);
            if Screen.ActiveForm is TF_TypPis then TF_TypPis(Screen.ActiveForm).SBUndoRecClick(Sender);
          end;
  end;
}
end;



procedure TMainForm.Adresrastr1Click(Sender: TObject);
begin
    Tool.PostMsg(tm_SetRasDirectory, Tool, nil, DontKill);
end;



procedure TMainForm.B_DruhGoClick(Sender: TObject);
begin
   Screen.Cursor := crHourGlass;
   UkazForm(Sender);
end;



procedure TMainForm.BExpDGNClick(Sender: TObject);
begin
   Screen.Cursor := crHourGlass;
   UkazForm(Sender);
end;

end.

