unit f_SRDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls;

type
  TRasShowDialog = class(TForm)
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel3: TPanel;
    Panel4: TPanel;
    TreeView1: TTreeView;
    c_L: TCheckBox;
    c_P: TCheckBox;
    c_R: TCheckBox;
    c_T: TCheckBox;
    c_V: TCheckBox;
    p_L: TPanel;
    p_P: TPanel;
    p_R: TPanel;
    p_T: TPanel;
    p_V: TPanel;
    HeaderControl1: THeaderControl;
    ColorDialog: TColorDialog;
    procedure p_LClick(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetFormVar(LColor, PColor, RColor, TColor, VColor: TColor; aLayers: string);
    procedure GetFormVar(var LColor, PColor, RColor, TColor, VColor: TColor; var aLayers: string);
  end;


implementation

{$R *.DFM}

procedure TRasShowDialog.p_LClick(Sender: TObject);
begin
   ColorDialog.Color := TPanel(Sender).Color;
   if ColorDialog.Execute then TPanel(Sender).Color := ColorDialog.Color;
end;

procedure TRasShowDialog.TreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   if Sender = Source then Accept := true;
end;


function LayerInLayers(aLayer: char; aLayers: string): boolean;
var
  I: integer;
begin
  result:= false;
  aLayers:= UpperCase(aLayers);
  for I:= 1 to length(aLayers) do
  begin
    if upCase(aLayer) = aLayers[I] then
    begin
      result:= true;
      exit
    end
  end
end;


procedure TRasShowDialog.SetFormVar(LColor, PColor, RColor, TColor, VColor: TColor; aLayers: string);
begin
  p_L.Color:= LColor;
  p_P.Color:= PColor;
  p_R.Color:= RColor;
  p_T.Color:= TColor;
  p_V.Color:= VColor;

  c_L.Checked:= false;
  c_P.Checked:= false;
  c_R.Checked:= false;
  c_T.Checked:= false;
  c_V.Checked:= false;

  aLayers:= UpperCase(aLayers);

  if LayerInLayers('L', aLayers) then
     c_L.Checked:= true
  else
     c_L.Checked:= false;
  if LayerInLayers('P', aLayers) then
     c_P.Checked:= true
  else
     c_P.Checked:= false;
  if LayerInLayers('R', aLayers) then
     c_R.Checked:= true
  else
     c_R.Checked:= false;
  if LayerInLayers('T', aLayers) then
     c_T.Checked:= true
  else
     c_T.Checked:= false;
  if LayerInLayers('V', aLayers) then
     c_V.Checked:= true
  else
     c_V.Checked:= false

end;



procedure TRasShowDialog.GetFormVar(var LColor, PColor, RColor, TColor, VColor: TColor;
                                    var aLayers: string);
begin
  LColor:= p_L.Color;
  PColor:= p_P.Color;
  RColor:= p_R.Color;
  TColor:= p_T.Color;
  VColor:= p_V.Color;

  aLayers:= '     ';
  if c_L.Checked then aLayers[1]:= 'l';
  if c_P.Checked then aLayers[2]:= 'p';
  if c_R.Checked then aLayers[3]:= 'r';
  if c_T.Checked then aLayers[4]:= 't';
  if c_V.Checked then aLayers[5]:= 'v'
end;

end.
