unit F_Test1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables,
  Tools, Buttons;

type
  TF_Test1Form = class(TForm)
    edX: TEdit;
    edY: TEdit;
    edAngle: TEdit;
    edZM: TEdit;
    edPDX: TEdit;
    edPDY: TEdit;
    Memo1: TMemo;
    TableText: TTable;
    Label_Font: TLabel;
    DS: TDataSource;
    FontDialog1: TFontDialog;
    BitBtn1: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    procedure SetPDXY(LDY, LDX, Angle: double; Text: string; FontName: string;
                      FontSize: integer; Style: TFontStyles;
                      var PDY, PDX: double);
  public
    LDColor, PDColor: TColor;
    Tool: TTool;
    { Public declarations }
    procedure SetCoords(LDY, LDX, PDY, PDX, Angle: double; ZM :string);
    procedure FindText(ZM: string; X, Y: double);
  end;


implementation

{$R *.DFM}



procedure TF_Test1Form.SetPDXY(LDY, LDX, Angle: double; Text: string; FontName: string;
                           FontSize: integer; Style: TFontStyles;
                           var PDY, PDX: double);
var
  TW: double; { ka v m }
  AT: double; { hel v radinech }

  function PixelsToSize(Pixels: integer): double;
  begin
    result:= Pixels * Canvas.Font.PixelsPerInch / 72
  end;

begin
  Canvas.Font.Size:= FontSize;
  Canvas.Font.Name:= FontName;
  Canvas.Font.Style:= Style;

  TW:= PixelsToSize(Canvas.TextWidth(Text)) * 0.000353; { m }
  TW:= TW * 10000;
  AT:= Pi * Angle/180;
  PDY:= LDY - TW * cos(AT);
  PDX:= LDX - TW * sin(AT);

  edPDY.Text:= IntToStr(round(PDX));
  edPDX.Text:= IntToStr(round(PDY))
end;


procedure TF_Test1Form.SetCoords(LDY, LDX, PDY, PDX, Angle: double; ZM :string);
begin
  edX.Text:= IntToStr(round(LDY));
  edY.Text:= IntToStr(round(LDX));
  edAngle.Text:= FloatToStr(Angle);
  edZM.Text:= ZM;
{
  SetPDXY(-X, -Y, Angle, 'ABCDEFG', 'Times New Roman CE', 12, [], PDY, PDX);
}
end;

procedure TF_Test1Form.FindText(ZM: string; X, Y: double);
begin
  edX.Text:= IntToStr(round(-X));
  edY.Text:= IntToStr(round(-Y));
  edZM.Text:= ZM
end;

procedure TF_Test1Form.BitBtn1Click(Sender: TObject);
begin
  FontDialog1.Font:= Label_Font.Font;
  FontDialog1.Font.Size := 10;
  if FontDialog1.Execute then
    Label_Font.Font := FontDialog1.Font;
end;

end.
