unit F_users;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB, ExtCtrls, DBCtrls, Grids, DBGrids, Buttons, Wwlocate, 
  StdCtrls, Menus;

type
  TUsers = class(TForm)
    Table: TTable;
    DS: TDataSource;
    Panel4: TPanel;
    BitBtnCancel: TBitBtn;
    Panel1: TPanel;
    SBFirst: TSpeedButton;
    SBPrior: TSpeedButton;
    SBNext: TSpeedButton;
    SBLast: TSpeedButton;
    SBNewRec: TSpeedButton;
    SBDeleteRec: TSpeedButton;
    SBEditRec: TSpeedButton;
    SBSaveRec: TSpeedButton;
    SBUndoRec: TSpeedButton;
    SBRefresh: TSpeedButton;
    Panel2: TPanel;
    DBGrid: TDBGrid;
    CB_Find: TComboBox;
    PopupMenu1: TPopupMenu;
    Vyhledn1: TMenuItem;
    TablePRIHL_JM_100: TStringField;
    TablePLNE_JM_100: TStringField;
    TableROLE_100: TStringField;
    Query1: TQuery;
    Database1: TDatabase;
    wwSearch: TwwLocateDialog;
    procedure FormCreate(Sender: TObject);
    procedure CB_FindChange(Sender: TObject);
    procedure SBFirstClick(Sender: TObject);
    procedure SBPriorClick(Sender: TObject);
    procedure SBNextClick(Sender: TObject);
    procedure SBLastClick(Sender: TObject);
    procedure SBNewRecClick(Sender: TObject);
    procedure SBDeleteRecClick(Sender: TObject);
    procedure SBEditRecClick(Sender: TObject);
    procedure SBSaveRecClick(Sender: TObject);
    procedure SBUndoRecClick(Sender: TObject);
    procedure SBRefreshClick(Sender: TObject);
    procedure CB_FindExit(Sender: TObject);
    procedure Vyhledn1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TableBeforeEdit(DataSet: TDataSet);
    procedure TableBeforeInsert(DataSet: TDataSet);
    procedure TableAfterPost(DataSet: TDataSet);
    procedure TableAfterCancel(DataSet: TDataSet);
    procedure DBGridDblClick(Sender: TObject);
    procedure CB_FindEnter(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TableBeforePost(DataSet: TDataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    OldUser: String;
    OldRole: String;
    procedure AddNewUser;
    procedure DropUser;
    procedure ChangeUser;
  public
    { Public declarations }
  end;

var
  Users: TUsers;

implementation

uses F_Main;

{$R *.DFM}

procedure TUsers.FormCreate(Sender: TObject);
begin
  Database1.Params := MainForm.Database.Params;
  Database1.Params.Values['SQLPASSTHRU MODE'] := 'SHARED NOAUTOCOMMIT';
  Table.Open;
end;

procedure TUsers.CB_FindChange(Sender: TObject);
begin
  Table.FindNearest([CB_Find.Text]);
end;

procedure TUsers.SBFirstClick(Sender: TObject);
begin
  Table.First;
end;

procedure TUsers.SBPriorClick(Sender: TObject);
begin
  Table.Prior;
end;

procedure TUsers.SBNextClick(Sender: TObject);
begin
  Table.Next;
end;

procedure TUsers.SBLastClick(Sender: TObject);
begin
  Table.Last;
end;

procedure TUsers.SBNewRecClick(Sender: TObject);
begin
  if not Database1.InTransaction then Database1.StartTransaction;
  if not (DS.State in [dsEdit,dsInsert]) then Table.append;
end;

procedure TUsers.SBDeleteRecClick(Sender: TObject);
begin
   if MessageDlg('Skuten chcete smazat aktuln zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
   begin
      if not Database1.InTransaction then Database1.StartTransaction;

      try
         Table.Delete;
         DropUser;
         Database1.Commit;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu vymazat uivatele ' + #13#10#13#10 +
            'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
            Table.cancel;
            Database1.RollBack;
         end;
      end;
   end;
end;


procedure TUsers.SBEditRecClick(Sender: TObject);
begin
  if not Database1.InTransaction then Database1.StartTransaction;

  OldUser :=  TablePRIHL_JM_100.AsString;
  OldRole :=  TableROLE_100.AsString;
  Table.edit;
end;


procedure TUsers.SBSaveRecClick(Sender: TObject);
begin
   if DS.State in [dsInsert,dsEdit] then
   begin
      if MessageDlg('Skuten chcete uloit zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
      begin
         try
            Table.post;
            Database1.Commit;
         except
            on E:EDatabaseError do
            begin
               MessageDlg('Nemohu uloit zznam ' + #13#10#13#10 +
               'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
               Table.cancel;
               Database1.RollBack;
            end;
         end;
      end
      else
      begin
         Database1.RollBack;
      end;
   end;
end;

procedure TUsers.SBUndoRecClick(Sender: TObject);
begin
   if dgRowSelect in DBGrid.Options then exit;

   if MessageDlg('Skuten chcete zruit proveden zmny?',mtInformation,[mbYES,mbNO],0) = mrYES then
   begin
      Table.Cancel;
      Database1.RollBack;
   end;
end;

procedure TUsers.SBRefreshClick(Sender: TObject);
begin
  Table.refresh;
end;

procedure TUsers.CB_FindExit(Sender: TObject);
begin
  CB_Find.Items.Add(CB_Find.Text);
  CB_Find.Text := 'Vyhledn';
end;

procedure TUsers.Vyhledn1Click(Sender: TObject);
begin
  wwSearch.execute;
end;

procedure TUsers.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    VK_F7 : wwSearch.execute;
  end;
end;

procedure TUsers.TableBeforeEdit(DataSet: TDataSet);
begin
  DBGrid.Options := [dgEditing,dgTitles,dgIndicator,dgColumnResize,dgColLines,
                     dgRowLines,dgTabs,dgConfirmDelete,dgCancelOnExit];
end;

procedure TUsers.TableBeforeInsert(DataSet: TDataSet);
begin
  DBGrid.Options := [dgEditing,dgTitles,dgIndicator,dgColumnResize,dgColLines,
                     dgRowLines,dgTabs,dgConfirmDelete,dgCancelOnExit];
end;

procedure TUsers.TableAfterPost(DataSet: TDataSet);
begin
  DBGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgTabs,
                     dgRowSelect,dgConfirmDelete,dgCancelOnExit]
end;

procedure TUsers.TableAfterCancel(DataSet: TDataSet);
begin
  DBGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgTabs,
                     dgRowSelect,dgConfirmDelete,dgCancelOnExit]
end;

procedure TUsers.DBGridDblClick(Sender: TObject);
begin
   if dgRowSelect in DBGrid.Options then
   begin
      ModalResult := mrOK;
   end;
end;

procedure TUsers.CB_FindEnter(Sender: TObject);
begin
  CB_Find.Text := '';
end;

procedure TUsers.BitBtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TUsers.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;


procedure TUsers.TableBeforePost(DataSet: TDataSet);
begin
  case DS.state of
    dsInsert   : AddNewUser;
    dsEdit     : ChangeUser;
  end;
end;


procedure TUsers.AddNewUser;
begin

   with query1 do
   begin
      SQL.Clear;
      SQL.Add('create user ');
      SQL.Add(TablePRIHL_JM_100.AsString);
      SQL.Add(' identified by ');
      SQL.Add(TablePRIHL_JM_100.AsString);
      SQL.Add(' default tablespace USER_DATA ');
      SQL.Add(' temporary tablespace TEMPORARY_DATA ');

      try
         ExecSQL;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu vytvoit novho uivatele ' +
            TablePRIHL_JM_100.AsString + #13#10#13#10 +
            'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
            Table.cancel;
            Database1.RollBack;
            Exit;
         end;
      end;

      SQL.Clear;
      SQL.Add('grant ');
      SQL.Add(TableROLE_100.AsString);
      SQL.Add(' to ');
      SQL.Add(TablePRIHL_JM_100.AsString);

      if TableROLE_100.AsString = 'SPRAVA' then
         SQL.Add(' with admin option ');

      try
         ExecSQL;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu pidlit prva ' + TableROLE_100.AsString
            + ' pro novho uivatele ' +
            TablePRIHL_JM_100.AsString + #13#10#13#10 +
            'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
            Table.cancel;
            Database1.RollBack;
         end;
      end;
   end;

end;


procedure TUsers.ChangeUser;
begin
   DropUser;
   AddNewUser;

end;


procedure TUsers.DropUser;
begin
   with query1 do
   begin
      SQL.Clear;
      SQL.Add('drop user ');
      SQL.Add(OldUser);

      try
         ExecSQL;
      except
         on E:EDatabaseError do
         begin
            MessageDlg('Nemohu odebrat prva '
            + OldRole + ' pro uivatele ' +
            OldUser + #13#10#13#10 +
            'Chybov hlen: ' +  #13#10 + E.Message , mtError, [mbOK], 0);
            Table.cancel;
            Database1.RollBack;
         end;
      end;
   end;
end;



procedure TUsers.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Database1.Close;
  Action:= caFree;
end;

end.
