unit T_GNIntr;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy interaktivnch nstroj                          *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}


interface
uses
  Menus, StdCtrls,
  WinTypes,
  Classes,
  Controls,
  Graphics,
  F_STD,
  Elements, G_Elems,
  M_InterA,
  t_Intera,
  t_Recurs,
  t_Editor,
  Tools;

type



TZoomIn = class(TInteractiveTool)
 protected
   ShiftRect: TRect;
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
 public
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;

TZoomOut = class(TInteractiveTool)
 protected
   ShiftRect: TRect;
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
 public
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;


TEditorIATool = class(TDrawLineTool)
private
   FColor: TColor;
   FFont: TFont;
   FMemo: TMemo;
   FAngle: double;
{   FEditor:  TRectEntityEditor; }
   function  GetElementClass: TElementClass; virtual; abstract;
   procedure SetFont(aFont: TFont);
   procedure DrawTextRect(aCoord: TDoubleCoord);
   procedure ChangeBitMap(aCoord: TDoubleCoord);
public
   FBitMap: TBitMap;
   Crd1, Crd2, Crd3, Crd4: TDoubleCoord;
   BMdX, BMdY: double;

   constructor Create; override;
   destructor  Destroy; override;
   procedure GetPixelRect
              (var Pnt1, Pnt2, Pnt3, Pnt4: WinTypes.TPoint;
               var aRect: TRect);
   procedure PutTextToBM;
   procedure On_Erase(aCoord: TDoubleCoord); override;
   procedure On_Draw (aCoord: TDoubleCoord); override;

   function ItsMyClass(aClass: TElementClass): boolean;
   property ElementClass: TElementClass read GetElementClass;
{   property Editor: TRectEntityEditor read FEditor write FEditor; }
published
   property Color: TColor read FColor write FColor;
   property EdFont: TFont read FFont write SetFont;
   property Memo: TMemo read FMemo write FMemo;
   property Angle: double read FAngle write FAngle;
end;




TNewTextTool = class(TEditorIATool)
protected
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
public
   procedure On_Activate; override;
   procedure On_Point(aCoord: TDoubleCoord); override;
   procedure On_Line(aCrd1, aCrd2: TDoubleCoord); override;
end;


TEditTextTool = class(TEditorIATool)
protected
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
public
   procedure On_Point(aCoord: TDoubleCoord); override;
   procedure On_Line(aCrd1, aCrd2: TDoubleCoord); override;
end;



implementation
uses
   SysUtils, Dialogs,
   Forms,
   MathLib,
   D_STD,
   e_Device,
   e_IScrpt,
   M_Orbis,
   {
   i_TopoL,
   }
   i_Uni,
{$IFNDEF NOTIS}
   t_SelAre,
   t_SelMS,
   t_TisCre,
{$ENDIF}
   u_Cursor,
   E_ZM,
   Worlds,
   T_Main;



procedure SetTextOrientation(aCanvas: TCanvas; aOrientation: double);
var
  LogFont: TLogFont;

begin
  if aCanvas = nil then exit;

  with LogFont do
  begin
    lfHeight := abs(aCanvas.Font.Height);

    lfWidth := 0; { have font mapper choose }
    lfEscapement := round(aOrientation*10);
    lfOrientation := 0{round(aOrientation*10)};
    if fsBold in aCanvas.Font.Style then
      lfWeight := FW_BOLD
    else
      lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in aCanvas.Font.Style);
    lfUnderline := Byte(fsUnderline in aCanvas.Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in aCanvas.Font.Style);
    lfCharSet := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, aCanvas.Font.Name);
    lfQuality := DEFAULT_QUALITY;
    { Everything else as default }
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := DEFAULT_PITCH;
  end;
{  DeleteObject(Canvas.Font.Handle); }
  aCanvas.Font.Handle := CreateFontIndirect(LogFont);
end;



procedure RotateCrd(Crd1: TDoubleCoord; var Crd2: TDoubleCoord; Angle: double);
var
  Radius: double;
begin
  Radius:= sqrt(sqr(Crd1.X-Crd2.X) +  sqr(Crd1.Y-Crd2.Y));
  Angle:= Angle + Atan2M(Crd2.X-Crd1.X, Crd2.Y-Crd1.Y);
  Crd2.X:= Crd1.X + Radius * cos(Angle);
  Crd2.Y:= Crd1.Y + Radius * sin(Angle);
end;



procedure Rotatate4Crds(CrdLD: TDoubleCoord;
                        Width, Height, Angle: double;
                        var Crd1, Crd2, Crd3, Crd4: TDoubleCoord);
begin
  Crd1:= CrdLD;
  Crd2.X:= CrdLD.X + Width;
  Crd2.Y:= CrdLD.Y;
  Crd3.X:= CrdLD.X + Width;
  Crd3.Y:= CrdLD.Y + Height;
  Crd4.X:= CrdLD.X;
  Crd4.Y:= CrdLD.Y + Height;

  RotateCrd(Crd1, Crd2, Angle);
  RotateCrd(Crd1, Crd3, Angle);
  RotateCrd(Crd1, Crd4, Angle);
end;






{ TZoomIn }

function  TZoomIn.GetName: string;
begin
   result := '+ Lupa';
end;


function  TZoomIn.GetCursor: TCursor;
begin
   result := cr_Lupa;
end;


procedure TZoomIn.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   if aMessage.Key = VK_ESCAPE then PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
end;

procedure TZoomIn.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      ShiftRect := Rect(aMessage.x,aMessage.y,aMessage.x,aMessage.y);
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
   Handled := true;
end;

procedure TZoomIn.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
   RE: TRectangle;
begin
    Handled := true;
    if not aMessage.ActiveDevice then exit;
    if aMessage.Button = mbLeft then
    begin
       with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
       TCanvasDevice(Device).Canvas.Pen.Mode  := pmCopy;
       TCanvasDevice(Device).Canvas.Pen.Color := clBlack;
       TCanvasDevice(Device).Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 4) and (Bottom - Top <= 4) then
          begin
            Device.Projection.CenterPoint :=
                 Device.Projection.GetModelPoint(aMessage.x,aMessage.y);
            RE:= TRectangle.Create;
            RE.UpdateByDoubleRect(TCanvasDevice(Device).Projection.ModelView);
            RE.GrowByKoef(1/TOptions(TMainTool(World.MainTool).Options).ZoomKoef);
            TCanvasDevice(Device).Projection.ModelView := RE.AsDoubleRect;
            PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
            RE.Free
          end
          else
          begin
             R := Device.Projection.GetModelRect(Left, Top, Right, Bottom);
             TCanvasDevice(Device).Projection.ModelView := R;
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
          end;
       end;
    end;
end;

procedure TZoomIn.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
   if not aMessage.ActiveDevice then exit;
   if  ssLeft in aMessage.Shift then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      Device.Brush.Style:= bsClear;
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      ShiftRect.Right  := aMessage.x;
      ShiftRect.Bottom := aMessage.y;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
end;


{ TZoomOut }

function  TZoomOut.GetName: string;
begin
   result := '- Lupa';
end;


function  TZoomOut.GetCursor: TCursor;
begin
   result := cr_ZoomOut;
end;


procedure TZoomOut.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   if aMessage.Key = VK_ESCAPE then PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
end;

procedure TZoomOut.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      ShiftRect := Rect(aMessage.x,aMessage.y,aMessage.x,aMessage.y);
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
   Handled := true;
end;

procedure TZoomOut.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
   RE: TRectangle;
begin
    Handled := true;
    if not aMessage.ActiveDevice then exit;
    if aMessage.Button = mbLeft then
    begin
       with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
       TCanvasDevice(Device).Canvas.Pen.Mode  := pmCopy;
       TCanvasDevice(Device).Canvas.Pen.Color := clBlack;
       TCanvasDevice(Device).Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 4) and (Bottom - Top <= 4) then
          begin
            Device.Projection.CenterPoint :=
                 Device.Projection.GetModelPoint(aMessage.x,aMessage.y);
            RE:= TRectangle.Create;
            RE.UpdateByDoubleRect(TCanvasDevice(Device).Projection.ModelView);
            RE.GrowByKoef(TOptions(TMainTool(World.MainTool).Options).ZoomKoef);
            TCanvasDevice(Device).Projection.ModelView := RE.AsDoubleRect;
            PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
            RE.Free
          end
          else
          begin
             R := Device.Projection.GetModelRect(Left, Top, Right, Bottom);
             TCanvasDevice(Device).Projection.ModelView := R;
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
          end;
       end;
    end;
end;

procedure TZoomOut.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
   if not aMessage.ActiveDevice then exit;
{
   if  ssLeft in aMessage.Shift then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      ShiftRect.Right  := aMessage.x;
      ShiftRect.Bottom := aMessage.y;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
}
end;


{ TEditorIATool }



constructor TEditorIATool.Create;
begin
  inherited Create;
  FFont:= TFont.Create;
  FFont.Color:= clBlack;
  FFont.Name:= 'Times New Roman CE';
  FFont.Size:= 12;
  FBitmap:= TBitMap.Create;
  FBitMap.Monochrome:= false;
  FBitmap.Canvas.Font.Assign(FFont);
  FMemo:= TMainTool(World.MainTool).TextDBForm.Memo1;
end;


destructor  TEditorIATool.Destroy;
begin
  FFont.Free;
  FBitMap.Free;
  inherited Destroy
end;


function TEditorIATool.ItsMyClass(aClass: TElementClass): boolean;
begin
   result := aClass = ElementClass;
end;

procedure TEditorIATool.SetFont(aFont: TFont);
begin
  FFont.Assign(aFont);
{  FBitMap.Canvas.Font.Assign(aFont); }
end;


procedure TEditorIATool.GetPixelRect
           (var Pnt1, Pnt2, Pnt3, Pnt4: WinTypes.TPoint;
            var aRect: TRect);
var
  aMinX, aMaxX, aMinY, aMaxY: double;
  ShiftY, ShiftX: integer;
  aH: integer;
  CrdL1, CrdL2, CrdL3, CrdL4: TDoubleCoord;

  procedure SetMinMax(aCrd: TDoubleCoord);
  begin
    if aCrd.X < aMinX then aMinX:= aCrd.X;
    if aCrd.X > aMaxX then aMaxX:= aCrd.X;
    if aCrd.Y < aMinY then aMinY:= aCrd.Y;
    if aCrd.Y > aMaxY then aMaxY:= aCrd.Y;
  end;

begin
  aMinX:= 1E30; aMaxX:= -1E30;
  aMinY:= 1E30; aMaxY:= -1E30;
  CrdL1.X:= Crd1.X-Crd3.X;
  CrdL1.Y:= Crd1.Y-Crd3.Y;
  SetMinMax(CrdL1);
  CrdL2.X:= Crd2.X-Crd3.X;
  CrdL2.Y:= Crd2.Y-Crd3.Y;
  SetMinMax(CrdL2);
  CrdL4.X:= Crd4.X-Crd3.X;
  CrdL4.Y:= Crd4.Y-Crd3.Y;
  SetMinMax(CrdL4);
  CrdL3.X:= 0;
  CrdL3.Y:= 0;
  SetMinMax(CrdL3);



  with Device.Projection do
  begin
    ShiftY:= GetPageLength(aMinY);
    ShiftX:= GetPageLength(aMinX);
    aH := GetPageLength(aMaxY-aMinY);

    Pnt1.X:= GetPageLength(CrdL1.X) - ShiftX;
    Pnt1.Y:= aH-GetPageLength(CrdL1.Y) + ShiftY;
    Pnt2.X:= GetPageLength(CrdL2.X) - ShiftX;
    Pnt2.Y:= aH-GetPageLength(CrdL2.Y) + ShiftY;
    Pnt3.X:= GetPageLength(CrdL3.X) - ShiftX;
    Pnt3.Y:= aH-GetPageLength(CrdL3.Y) + ShiftY;
    Pnt4.X:= GetPageLength(CrdL4.X) - ShiftX;
    Pnt4.Y:= aH-GetPageLength(CrdL4.Y) + ShiftY;

    aRect.Left:= 0;
    aRect.Top := 0;
    aRect.Right := GetPageLength(aMaxX-aMinX);
    aRect.Bottom:= GetPageLength(aMaxY-aMinY);
    BMdX:= GetModelLength(Pnt1.X);
    BMdY:= GetModelLength(Pnt1.Y);
  end;
end;


procedure TEditorIATool.PutTextToBM;
var
  WT, HT: integer;
  Pnt1, Pnt2, Pnt3, Pnt4: WinTypes.TPoint;
  aRect: TRect;
begin
  GetPixelRect(Pnt1, Pnt2, Pnt3, Pnt4, aRect);

  FBitmap.Width:= aRect.Right;
  FBitMap.Height:= aRect.Bottom;


  with FBitMap.Canvas do
  begin
    Brush.Color:= clGray;
    Brush.Style:= bsSolid;
    FillRect(FBitMap.Canvas.ClipRect);

    Pen.Color:= clGreen;
    Pen.Style:= psSolid;
    Pen.Width:= 1;
    MoveTo(Pnt1.X, Pnt1.Y);
    LineTo(Pnt2.X, Pnt2.Y);
    LineTo(Pnt3.X, Pnt3.Y);
    LineTo(Pnt4.X, Pnt4.Y);
    LineTo(Pnt1.X, Pnt1.Y);
  end;


  WT:= round((FBitmap.Canvas.TextWidth(Memo.Text)*10000.0)/Device.Projection.Scale);
  HT:= round((FBitmap.Canvas.TextHeight(Memo.Text)*10000.0)/Device.Projection.Scale);

  FBitMap.Canvas.Brush.Color:= clBlack;
  FBitMap.Canvas.Brush.Style:= bsSolid;
  FBitMap.Canvas.Font.Assign(EdFont);
  FBitMap.Canvas.Font.Color:= clLime;
  FBitMap.Canvas.Font.Size:= round((EdFont.Size * 10000.0)/Device.Projection.Scale);
  SetTextOrientation(FBitMap.Canvas, Angle);
  FBitMap.Canvas.TextOut(Pnt4.X, Pnt4.Y, Memo.Text);
{$IFDEF Debug}
  FBitMap.SaveToFile('\Text.BMP')
{$ENDIF}
end;


procedure TEditorIATool.DrawTextRect(aCoord: TDoubleCoord);
begin
  with Device.Pen do
  begin
    Color:= clGreen;
    Mode:= pmXor
  end;
  TCanvasDevice(Device).Canvas.CopyMode:= cmSrcInvert	 {cmPatCopy cmSrcCopy};

  Device.MoveTo(Crd1.X, Crd1.Y);
  Device.LineTo(Crd2.X, Crd2.Y);
  Device.LineTo(Crd3.X, Crd3.Y);
  Device.LineTo(Crd4.X, Crd4.Y);
  Device.LineTo(Crd1.X, Crd1.Y);
  TCanvasDevice(Device).Draw(aCoord.X-BMdX, aCoord.Y+BMdY, FBitMap);
end;


procedure TEditorIATool.ChangeBitMap(aCoord: TDoubleCoord);
var
  W, H: double;
begin
  Device.Font.Assign(EdFont);
  Device.Font.Size:= round((EdFont.Size*10000.0)/ Device.Projection.Scale);

  W:= Device.TextModelWidth(Memo.Text);
  H:= Device.TextModelHeight(Memo.Text);
  Rotatate4Crds(aCoord, W, H, Pi*Angle/180, Crd1, Crd2, Crd3, Crd4);
  PutTextToBM
end;


procedure TEditorIATool.On_Erase(aCoord: TDoubleCoord);
begin
  DrawTextRect(aCoord);
end;

procedure TEditorIATool.On_Draw (aCoord: TDoubleCoord);
begin
  DrawTextRect(aCoord);
end;



{ TNewTextTool }

function  TNewTextTool.GetName: string;
begin
   result := 'Nov Text';
end;


function  TNewTextTool.GetCursor: TCursor;
begin
   result := cr_NewText;
end;

procedure TNewTextTool.On_Activate;
var
  aCoord: TDoubleCoord;
begin
  with Device.Pen do
  begin
    Color:= clGreen;
    Mode:= pmXor
  end;

  Angle:= 350;

  aCoord.X:= 0;
  aCoord.Y:= 0;
  ChangeBitMap(aCoord);
end;





procedure TNewTextTool.On_Point(aCoord: TDoubleCoord);
var
  Odsazeni: double;
  FOut: system.Text;
{
  I, X, Y: longInt;
  Mapa: string;
  Barva: longInt;
}
begin
  with TMainTool(World.MainTool).TextDBForm do
  begin
    EdFont.Assign(Label_Font.Font);
  end;

  ChangeBitMap(aCoord);

  if (Device.Projection.Scale > 20000) or (Device.Projection.Scale < 5000) then
  begin
     ShowMessage('Pro vkldn novch text' + #13+ 'mus bt mtko v rozmez 1:5000 a 1:20 000');
     exit
  end;


  Device.Font.Assign(EdFont);
  Device.Font.Size:= round((EdFont.Size*10000.0)/ Device.Projection.Scale);

{  Odsazeni:= Device.TextModelHeight(Memo.Text); }
  Odsazeni:= 0;
  SetTextOrientation(TCanvasDevice(Device).Canvas, Angle);
  Device.TextOut(Crd4.X, Crd4.Y+Odsazeni, Memo.Text);


  TMainTool(World.MainTool).TextDBForm.SetCoords
            (-aCoord.X, -aCoord.Y, -Crd2.X, -Crd2.Y, Angle, GetZMName(10000, aCoord.X, aCoord.Y));
            { pevod do Kovka }
end;


procedure TNewTextTool.On_Line(aCrd1, aCrd2: TDoubleCoord);
begin
  if (Device.Projection.Scale > 20000) or (Device.Projection.Scale < 5000) then
  begin
     ShowMessage('Pro vkldn novch text' + #13+ 'mus bt mtko v rozmez 1:5000 a 1:20 000');
     exit
  end;

  Angle:= 180*ATan2M(aCrd2.X-aCrd1.X, aCrd2.Y-aCrd1.Y)/Pi;
  ChangeBitMap(aCrd1);
end;



{ TTextEditor }

function  TEditTextTool.GetName: string;
begin
   result := 'Editor Textu';
end;


function  TEditTextTool.GetCursor: TCursor;
begin
   result := cr_NewText;
end;

procedure TEditTextTool.On_Point(aCoord: TDoubleCoord);
var
  PDX, PDY: double;
  aPoint: WinTypes.TPoint;
begin
  TMainTool(World.MainTool).TextDBForm.FindText
            (GetZMName(10000, aCoord.X, aCoord.Y), -aCoord.X, -aCoord.Y);

  with TMainTool(World.MainTool).TextDBForm do
  begin
    aCoord.X:= -TableSOUR_LDX_001.value;
    aCoord.Y:= -TableSOUR_LDY_001.value;
    PDX     := -TableSOUR_PDX_001.value;
    PDY     := -TableSOUR_PDY_001.value;
    EdFont.Assign(Label_Font.Font);
    if (PDX=0) or (PDY=0) then
      Angle:= GetZMAngleForXY(aCoord.X, aCoord.Y)*180/Pi;
    else
      Angle:= 180*ATan2M(PDX-aCoord.X, PDY-aCoord.Y)/Pi;
  end;

{
  aPoint:= Device.Projection.GetPagePoint(aCoord.X, aCoord.Y);
  aPoint:= TMainTool(World.MainTool).GForm.PaintBox.ClientToScreen(aPoint);
  SetCursorPos(aPoint.X, aPoint.Y);
}
  ChangeBitMap(aCoord)
end;


procedure TEditTextTool.On_Line(aCrd1, aCrd2: TDoubleCoord);
begin

end;


{
  system.assign(Fout, 'h:\vystup.txt');
  system.rewrite(Fout);

  for I:= 1 to 100000 do
  begin
    case I mod 3 of
    0: Barva:= 255;
    1: Barva:= 0;
    2: Barva:= $FF0000;
    end;

    X:= random(600000) + 400000;
    Y:= random(400000) + 900000;
    Mapa:= ZM.GetNameByCoords(-X, -Y);
    if Mapa <> '' then
       writeln(Fout, I:6, X:7, Y:8, ' ''', Mapa,''' ''', X:6,';',Y:7,''' ', Barva:9)
  end;
  system.close(Fout);
}



end.
