unit Uprint;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Grids, DBGrids, DB, DBTables, 
  ExtCtrls, IniFiles, Sestavy;

type
  TFPrint = class(TForm)
    P_But: TPanel;
    BitBtn5: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn7: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    BitBtn9: TBitBtn;
    P_Par: TPanel;
    SB_Par: TScrollBox;
    DS: TDataSource;
    Table: TTable;
    TableNazev: TStringField;
    TableSkupina: TStringField;
    OpenDialog: TOpenDialog;
    TableSoubor: TStringField;
    Query: TQuery;
    DS_SQL: TDataSource;
    P_Size: TPanel;
    DBG: TDBGrid;
    Table1: TTable;
    Report: TSestava;
    Database: TDatabase;
    procedure FormResize(Sender: TObject);
    procedure DSDataChange(Sender: TObject; Field: TField);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure P_SizeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure P_SizeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure P_SizeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1Resize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure VytvorEd;
    function CtiIntZIni(Sekce,Pole: string; DefHodnota : LongInt) :LongInt;
    function CtiStrZIni(Sekce,Pole,DefHodnota: string) :string;
    procedure OtevriDotaz;
  public
    { Public declarations }
  end;

var
  FPrint: TFPrint;
  Moving : Boolean;
  MouseOrigin : TPoint;

implementation

Uses UResult,UTisk32, F_start;

{$R *.DFM}

procedure TFPrint.FormResize(Sender: TObject);
begin
{  DBG.ColWidths[0] :=  DBG.Width - 22;}
end;

procedure TFPrint.DSDataChange(Sender: TObject; Field: TField);
begin
  VytvorEd;
end;

procedure TFPrint.VytvorEd;
var i,PocetParametru : Integer;
    MyEdit : TEdit;
    MyLabel : TLabel;
begin
  PocetParametru := CtiIntZIni('SQLDotaz','PocetParametru',0);

  for i:= ComponentCount - 1  Downto 0 do
    begin
      if (Components[i] is TEdit) and ((Components[i] as TEdit).Parent = SB_Par) then (Components[i] as TEdit).free
      else
       if (Components[i] is TLabel) and ((Components[i] as TLabel).Parent = SB_Par) then (Components[i] as TLabel).free;
    end;
  for i:=1 to PocetParametru do
    begin
      MyLabel := TLabel.Create(Self);
      MyLabel.Visible := false;
      MyLabel.Name := 'MyLabel'+IntToStr(i);
      MyLabel.Parent := SB_Par;
      MyLabel.Left := 7;
      MyLabel.Top := (i-1)*40 + (i)*5;
{      MyLabel.Caption := 'Parametr ('+IntToStr(i+1)+')';}
      MyLabel.Caption := CtiStrZIni('Parametry','Parametr ('+IntToStr(i)+')','Parametr ('+IntToStr(i)+')');
      MyLabel.Show;

      MyEdit := TEdit.Create(Self);
      MyEdit.Visible := false;
      MyEdit.Name := 'MyEdit'+IntToStr(i);
      MyEdit.Parent := SB_Par;
      MyEdit.Left := 7;
      MyEdit.Height := 24;
      MyEdit.Width := 121;
      MyEdit.Top := MyLabel.Top + 2 + MyLabel.Height;
      MyEdit.Text := '';
      MyEdit.Show;
    end;
end;

function TFPrint.CtiIntZIni(Sekce,Pole: string; DefHodnota : LongInt) :LongInt;
var IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(TableSoubor.value);

  Result := IniFile.ReadInteger(Sekce,Pole,DefHodnota);

  IniFile.Free;
end;

function TFPrint.CtiStrZIni(Sekce,Pole,DefHodnota: string) :string;
var IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(TableSoubor.value);

  Result := IniFile.ReadString(Sekce,Pole,DefHodnota);

  IniFile.Free;
end;


procedure TFPrint.BitBtn5Click(Sender: TObject);
begin
  if MessageDlg('Skuten chcete sestavu vyadit?',mtConfirmation,[mbYES,mbNO],0)=mrYES then Table.Delete;
end;

procedure TFPrint.BitBtn1Click(Sender: TObject);
begin
  OtevriDotaz;
  Report.Print;
end;

procedure TFPrint.BitBtn2Click(Sender: TObject);
begin
  OtevriDotaz;
  Report.Preview;
end;

procedure TFPrint.BitBtn3Click(Sender: TObject);
begin
  OtevriDotaz;
  Report.Edit;
end;

procedure TFPrint.BitBtn7Click(Sender: TObject);
begin
  Close;
end;

procedure TFPrint.BitBtn9Click(Sender: TObject);
var Tabulka : TFResult;
begin
  OtevriDotaz;
  Tabulka := TFResult.Create(Application);
  Tabulka.Nazev := TableSoubor.value;
  Tabulka.DBG.Show;
  Tabulka.Memo1.Hide;
  Tabulka.DBG.DataSource := DS_SQL;
  Tabulka.Show;
end;

procedure TFPrint.BitBtn4Click(Sender: TObject);
var  NazevSestavy,Soubor : string;
begin
  if OpenDialog.Execute then
    begin
      NazevSestavy := InputBox('Vstupn box','Zadejte nzev sestavy','');
      Soubor := OpenDialog.FileName;

      if (NazevSestavy <> '') and Fileexists(Soubor) then
        begin
          Table.Append;
            TableNazev.Value := NazevSestavy;
            TableSoubor.value := Soubor;
          Table.Post;

          Table.Last;
          DBG.SetFocus;
        end;
    end;
end;

procedure TFPrint.FormShow(Sender: TObject);
begin
  Table.Open;
end;

procedure TFPrint.OtevriDotaz;
var  Parametry,Dir,NazevDotazu,PrehledD,NazevD : string;
     i,PocetD : Integer;
begin
  Screen.Cursor := crHourGlass;

  Query.Close;
  Parametry := '';
  NazevDotazu := TableSoubor.value;
  Dir := ExtractFilePath(NazevDotazu);

  try
    for i:= 0 to ComponentCount - 1 do
      begin
        if (Components[i] is TEdit) and ((Components[i] as TEdit).Parent = SB_Par) then
          begin
            Parametry := Parametry + (Components[i] as TEdit).Text + ';';
          end
      end;
  except
    exit;
  end;


  Database.Open;

  try
    Query.SQL.LoadFromFile(NactiDotaz(Parametry,NazevDotazu));

    Screen.Cursor := crSQLWait;
    Query.Open;
  except on E:EDatabaseError do
    begin
      Screen.Cursor := crDefault;
      messagedlg('Tento dotaz nelze provst!'+#13#10+E.message,mtInformation,[mbOK],0);
      abort;
    end;
   end;
   Report.ReportDir := Dir;
   Report.ReportName := NactiSestavu(NazevDotazu);

   Screen.Cursor := crDefault;
end;

procedure TFPrint.P_SizeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button = mbLeft then
  begin
   MouseOrigin := Point(X,Y);
   Moving := True;

   Panel1.Align := alNone;
   P_Size.Align := alNone;
   P_Par.Align:=alNone;
   P_But.Align:=alNone;
  end  else Moving :=False;
end;

procedure TFPrint.P_SizeMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if Moving then P_Size.Left := P_Size.Left + (X - MouseOrigin.X);
end;

procedure TFPrint.P_SizeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Moving then Moving := False;


 if Panel1.Width > P_Size.Left then
   begin
     Panel1.Width := P_Size.Left;
     P_Par.Left := P_Size.Left + P_Size.Width;
   end;
 P_Par.Width := ClientWidth - (P_Size.Left + P_Size.Width) - P_But.Width;


 P_But.Align := alRight;
 P_Par.Align := alRight; 
 P_Size.Align:=alRight;
 Panel1.Align := alClient;

 FormResize(Sender);
end;

procedure TFPrint.Panel1Resize(Sender: TObject);
begin
  DBG.Columns[0].Width := Panel1.Width-38;
end;

procedure TFPrint.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Database.Close;
  Action := caFree;
  FPrint := nil;
end;

procedure TFPrint.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;

procedure TFPrint.FormCreate(Sender: TObject);
begin
  Database.Params := f_StartForm.Database.Params;
end;

end.
