unit F_DruhGO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB, ExtCtrls, DBCtrls, Grids, DBGrids, Buttons,
  Wwlocate,F_TypPis,
  StdCtrls, Menus, Wwintl;

type
  TDruhGO = class(TForm)
    Table: TTable;
    DS: TDataSource;
    TableObjekt_Naz_102: TStringField;
    TablePismo_Typ_104: TStringField;
    Panel4: TPanel;
    BitBtnCancel: TBitBtn;
    BitBtnOK: TBitBtn;
    Panel1: TPanel;
    SBFirst: TSpeedButton;
    SBPrior: TSpeedButton;
    SBNext: TSpeedButton;
    SBLast: TSpeedButton;
    SBNewRec: TSpeedButton;
    SBDeleteRec: TSpeedButton;
    SBEditRec: TSpeedButton;
    SBSaveRec: TSpeedButton;
    SBUndoRec: TSpeedButton;
    SBRefresh: TSpeedButton;
    Panel2: TPanel;
    DBGrid: TDBGrid;
    wwSearch: TwwLocateDialog;
    CB_Find: TComboBox;
    PopupMenu1: TPopupMenu;
    Vyhledn1: TMenuItem;
    TableOBJEKT_KOD_102: TFloatField;
    wwIntl1: TwwIntl;
    procedure FormCreate(Sender: TObject);
    procedure CB_FindChange(Sender: TObject);
    procedure SBFirstClick(Sender: TObject);
    procedure SBPriorClick(Sender: TObject);
    procedure SBNextClick(Sender: TObject);
    procedure SBLastClick(Sender: TObject);
    procedure SBNewRecClick(Sender: TObject);
    procedure SBDeleteRecClick(Sender: TObject);
    procedure SBEditRecClick(Sender: TObject);
    procedure SBSaveRecClick(Sender: TObject);
    procedure SBUndoRecClick(Sender: TObject);
    procedure SBRefreshClick(Sender: TObject);
    procedure CB_FindExit(Sender: TObject);
    procedure Vyhledn1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TableBeforeEdit(DataSet: TDataSet);
    procedure TableBeforeInsert(DataSet: TDataSet);
    procedure TableAfterPost(DataSet: TDataSet);
    procedure TableAfterCancel(DataSet: TDataSet);
    procedure DBGridDblClick(Sender: TObject);
    procedure CB_FindEnter(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DBGridEditButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure DOEdit;
    procedure DoView;
  public
    { Public declarations }
    procedure PridejRec;
    procedure OpravRec;
    procedure SmazRec;
  end;

var
  DruhGO: TDruhGO;

implementation

Uses F_Main;

{$R *.DFM}

procedure TDruhGO.FormCreate(Sender: TObject);
begin
  Table.Open;
end;

procedure TDruhGO.CB_FindChange(Sender: TObject);
begin
  Table.FindNearest([CB_Find.Text]);
end;

procedure TDruhGO.SBFirstClick(Sender: TObject);
begin
  Table.First;
end;

procedure TDruhGO.SBPriorClick(Sender: TObject);
begin
  Table.Prior;
end;

procedure TDruhGO.SBNextClick(Sender: TObject);
begin
  Table.Next;
end;

procedure TDruhGO.SBLastClick(Sender: TObject);
begin
  Table.Last;
end;

procedure TDruhGO.SBNewRecClick(Sender: TObject);
begin
  PridejRec;
end;

procedure TDruhGO.PridejRec;
begin
  if not (DS.State in [dsEdit,dsInsert]) then Table.append;
end;

procedure TDruhGO.SBDeleteRecClick(Sender: TObject);
begin
  SmazRec;
end;

procedure TDruhGO.SmazRec;
begin
  if MessageDlg('Skuten chcete smazat aktuln zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
     Table.Delete;
    end;
end;

procedure TDruhGO.SBEditRecClick(Sender: TObject);
begin
  OpravRec;
end;

procedure TDruhGO.OpravRec;
begin
  Table.edit;
end;

procedure TDruhGO.SBSaveRecClick(Sender: TObject);
begin
  if DS.State in [dsInsert,dsEdit] then
    if MessageDlg('Skuten chcete uloit zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
      begin
        Table.post;
      end;
end;

procedure TDruhGO.SBUndoRecClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then exit;
  
  if MessageDlg('Skuten chcete zruit proveden zmny?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
      Table.Cancel;
    end;
end;

procedure TDruhGO.SBRefreshClick(Sender: TObject);
begin
  Table.refresh;
end;

procedure TDruhGO.CB_FindExit(Sender: TObject);
begin
  CB_Find.Items.Add(CB_Find.Text);
  CB_Find.Text := 'Vyhledn';
end;

procedure TDruhGO.Vyhledn1Click(Sender: TObject);
begin
  wwSearch.SearchField := DBGrid.SelectedField.FieldName;
  wwSearch.execute;
end;

procedure TDruhGO.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    VK_F7 : wwSearch.execute;
  else MainForm.CiziKey(Sender, Key, Shift);
  end;
end;

procedure TDruhGO.DOEdit;
begin
  DBGrid.Options := [dgEditing,dgTitles,dgIndicator,dgColumnResize,dgColLines,
                     dgRowLines,dgTabs,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clWindow;
end;

procedure TDruhGO.DoView;
begin
  DBGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgTabs,
                     dgRowSelect,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clBtnFace;
end;

procedure TDruhGO.TableBeforeEdit(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TDruhGO.TableBeforeInsert(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TDruhGO.TableAfterPost(DataSet: TDataSet);
begin
  DoView;
end;

procedure TDruhGO.TableAfterCancel(DataSet: TDataSet);
begin
  DoView;                   
end;

procedure TDruhGO.DBGridDblClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then
    begin
      ModalResult := mrOK;
    end;
end;

procedure TDruhGO.CB_FindEnter(Sender: TObject);
begin
  CB_Find.Text := '';
end;

procedure TDruhGO.BitBtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TDruhGO.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;

procedure TDruhGO.DBGridEditButtonClick(Sender: TObject);
var  ModalDlg: TTypPisma;
begin
  ModalDlg := TTypPisma.Create(Application);
  ModalDlg.Table.FindKey([TablePismo_Typ_104.value]);
  if ModalDlg.ShowModal = mrOK then
    begin
      TablePismo_Typ_104.value := ModalDlg.TablePismo_Typ_104.value;
    end;

end;

procedure TDruhGO.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= caFree
end;

end.
