unit F_TypPis;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB, ExtCtrls, DBCtrls, Grids, DBGrids, Buttons,
  Wwlocate,
  StdCtrls, Menus, Wwintl;

type
  TTypPisma = class(TForm)
    Table: TTable;
    DS: TDataSource;
    Panel4: TPanel;
    BitBtnCancel: TBitBtn;
    BitBtnOK: TBitBtn;
    Panel1: TPanel;
    SBFirst: TSpeedButton;
    SBPrior: TSpeedButton;
    SBNext: TSpeedButton;
    SBLast: TSpeedButton;
    SBNewRec: TSpeedButton;
    SBDeleteRec: TSpeedButton;
    SBEditRec: TSpeedButton;
    SBSaveRec: TSpeedButton;
    SBUndoRec: TSpeedButton;
    SBRefresh: TSpeedButton;
    Panel2: TPanel;
    DBGrid: TDBGrid;
    wwSearch: TwwLocateDialog;
    CB_Find: TComboBox;
    PopupMenu1: TPopupMenu;
    Vyhledn1: TMenuItem;
    wwIntl1: TwwIntl;
    TablePISMO_TYP_104: TStringField;
    TablePISMO_PREDM_104: TStringField;
    TableFONT_NAME_104: TStringField;
    TableFONT_COLOR_104: TFloatField;
    TableFONT_HEIGHT_104: TFloatField;
    TableFONT_STYLE_104: TFloatField;
    TableFONT_ALIGN_104: TFloatField;
    TableLINE_HEIGHT_104: TFloatField;
    FontDialog: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure CB_FindChange(Sender: TObject);
    procedure SBFirstClick(Sender: TObject);
    procedure SBPriorClick(Sender: TObject);
    procedure SBNextClick(Sender: TObject);
    procedure SBLastClick(Sender: TObject);
    procedure SBNewRecClick(Sender: TObject);
    procedure SBDeleteRecClick(Sender: TObject);
    procedure SBEditRecClick(Sender: TObject);
    procedure SBSaveRecClick(Sender: TObject);
    procedure SBUndoRecClick(Sender: TObject);
    procedure SBRefreshClick(Sender: TObject);
    procedure CB_FindExit(Sender: TObject);
    procedure Vyhledn1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TableBeforeEdit(DataSet: TDataSet);
    procedure TableBeforeInsert(DataSet: TDataSet);
    procedure TableAfterPost(DataSet: TDataSet);
    procedure TableAfterCancel(DataSet: TDataSet);
    procedure DBGridDblClick(Sender: TObject);
    procedure CB_FindEnter(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DBGridEditButtonClick(Sender: TObject);
  private
    { Private declarations }
    procedure DOEdit;
    procedure DoView;
  public
    { Public declarations }
    procedure PridejRec;
    procedure OpravRec;
    procedure SmazRec;
  end;

var
  TypPisma: TTypPisma;

implementation

Uses F_Main;

{$R *.DFM}

procedure TTypPisma.FormCreate(Sender: TObject);
begin
  Table.Open;
end;

procedure TTypPisma.CB_FindChange(Sender: TObject);
begin
  Table.FindNearest([CB_Find.Text]);
end;

procedure TTypPisma.SBFirstClick(Sender: TObject);
begin
  Table.First;
end;

procedure TTypPisma.SBPriorClick(Sender: TObject);
begin
  Table.Prior;
end;

procedure TTypPisma.SBNextClick(Sender: TObject);
begin
  Table.Next;
end;

procedure TTypPisma.SBLastClick(Sender: TObject);
begin
  Table.Last;
end;

procedure TTypPisma.SBNewRecClick(Sender: TObject);
begin
  PridejRec;
end;

procedure TTypPisma.PridejRec;
begin
  if not (DS.State in [dsEdit,dsInsert]) then Table.append;
end;

procedure TTypPisma.SBDeleteRecClick(Sender: TObject);
begin
  SmazRec;
end;

procedure TTypPisma.SmazRec;
begin
  if MessageDlg('Skuten chcete smazat aktuln zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
     Table.Delete;
    end;
end;

procedure TTypPisma.SBEditRecClick(Sender: TObject);
begin
  OpravRec;
end;

procedure TTypPisma.OpravRec;
begin
  Table.edit;
end;

procedure TTypPisma.SBSaveRecClick(Sender: TObject);
begin
  if DS.State in [dsInsert,dsEdit] then
    if MessageDlg('Skuten chcete uloit zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
      begin
        Table.post;
      end;
end;

procedure TTypPisma.SBUndoRecClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then exit;
  
  if MessageDlg('Skuten chcete zruit proveden zmny?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
      Table.Cancel;
    end;
end;

procedure TTypPisma.SBRefreshClick(Sender: TObject);
begin
  Table.refresh;
end;

procedure TTypPisma.CB_FindExit(Sender: TObject);
begin
  CB_Find.Items.Add(CB_Find.Text);
  CB_Find.Text := 'Vyhledn';
end;

procedure TTypPisma.Vyhledn1Click(Sender: TObject);
begin
  wwSearch.SearchField := DBGrid.SelectedField.FieldName;
  wwSearch.execute;
end;

procedure TTypPisma.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    VK_F7 : wwSearch.execute;
  else MainForm.CiziKey(Sender, Key, Shift);
  end;
end;

procedure TTypPisma.DOEdit;
begin
  DBGrid.Options := [dgEditing,dgTitles,dgIndicator,dgColumnResize,dgColLines,
                     dgRowLines,dgTabs,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clWindow;
end;

procedure TTypPisma.DoView;
begin
  DBGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgTabs,
                     dgRowSelect,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clBtnFace;
end;

procedure TTypPisma.TableBeforeEdit(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TTypPisma.TableBeforeInsert(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TTypPisma.TableAfterPost(DataSet: TDataSet);
begin
  DoView;
end;

procedure TTypPisma.TableAfterCancel(DataSet: TDataSet);
begin
  DoView;                   
end;

procedure TTypPisma.DBGridDblClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then
    begin
      ModalResult := mrOK;
    end;
end;

procedure TTypPisma.CB_FindEnter(Sender: TObject);
begin
  CB_Find.Text := '';
end;

procedure TTypPisma.BitBtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TTypPisma.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;

procedure TTypPisma.DBGridEditButtonClick(Sender: TObject);
begin
   FontDialog.Font.Name   := TableFONT_NAME_104.value;
   FontDialog.Font.Height := TableFONT_HEIGHT_104.AsInteger;
   FontDialog.Font.Style  := TFontStyles(byte(TableFONT_STYLE_104.AsInteger));
   FontDialog.Font.Color  := TableFONT_COLOR_104.AsInteger;

   if FontDialog.Execute then
   begin
      TableFONT_NAME_104.value := FontDialog.Font.Name;
      TableFONT_HEIGHT_104.AsInteger := FontDialog.Font.Height;
      TableFONT_STYLE_104.AsInteger := byte(FontDialog.Font.Style);
      TableFONT_COLOR_104.AsInteger := FontDialog.Font.Color;
   end;
end;

end.
