unit F_DruhOz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB, ExtCtrls, DBCtrls, Grids, DBGrids, Buttons, Wwlocate,
  StdCtrls, Menus, Wwintl;

type
  TDruhOz = class(TForm)
    Table: TTable;
    DS: TDataSource;
    Panel4: TPanel;
    BitBtnCancel: TBitBtn;
    BitBtnOK: TBitBtn;
    Panel1: TPanel;
    SBFirst: TSpeedButton;
    SBPrior: TSpeedButton;
    SBNext: TSpeedButton;
    SBLast: TSpeedButton;
    SBNewRec: TSpeedButton;
    SBDeleteRec: TSpeedButton;
    SBEditRec: TSpeedButton;
    SBSaveRec: TSpeedButton;
    SBUndoRec: TSpeedButton;
    SBRefresh: TSpeedButton;
    Panel2: TPanel;
    DBGrid: TDBGrid;
    wwSearch: TwwLocateDialog; 
    CB_Find: TComboBox;
    PopupMenu1: TPopupMenu;
    Vyhledn1: TMenuItem;
    TableDruh_Ozn_Kod_101: TStringField;
    TableDruh_Ozn_Naz_101: TStringField;
    wwIntl1: TwwIntl;
    procedure FormCreate(Sender: TObject);
    procedure CB_FindChange(Sender: TObject);
    procedure SBFirstClick(Sender: TObject);
    procedure SBPriorClick(Sender: TObject);
    procedure SBNextClick(Sender: TObject);
    procedure SBLastClick(Sender: TObject);
    procedure SBNewRecClick(Sender: TObject);
    procedure SBDeleteRecClick(Sender: TObject);
    procedure SBEditRecClick(Sender: TObject);
    procedure SBSaveRecClick(Sender: TObject);
    procedure SBUndoRecClick(Sender: TObject);
    procedure SBRefreshClick(Sender: TObject);
    procedure CB_FindExit(Sender: TObject);
    procedure Vyhledn1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TableBeforeEdit(DataSet: TDataSet);
    procedure TableBeforeInsert(DataSet: TDataSet);
    procedure TableAfterPost(DataSet: TDataSet);
    procedure TableAfterCancel(DataSet: TDataSet);
    procedure DBGridDblClick(Sender: TObject);
    procedure CB_FindEnter(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure DOEdit;
    procedure DoView;    
  public
    { Public declarations }
    procedure PridejRec;
    procedure OpravRec;
    procedure SmazRec;    
  end;

var
  DruhOz: TDruhOz;

implementation

Uses F_Main;

{$R *.DFM}

procedure TDruhOz.FormCreate(Sender: TObject);
begin
  Table.Open;
end;

procedure TDruhOz.CB_FindChange(Sender: TObject);
begin
  Table.FindNearest([CB_Find.Text]);
end;

procedure TDruhOz.SBFirstClick(Sender: TObject);
begin
  Table.First;
end;

procedure TDruhOz.SBPriorClick(Sender: TObject);
begin
  Table.Prior;
end;

procedure TDruhOz.SBNextClick(Sender: TObject);
begin
  Table.Next;
end;

procedure TDruhOz.SBLastClick(Sender: TObject);
begin
  Table.Last;
end;

procedure TDruhOz.SBNewRecClick(Sender: TObject);
begin
  PridejRec;
end;

procedure TDruhOz.PridejRec;
begin
  if not (DS.State in [dsEdit,dsInsert]) then Table.append;
end;

procedure TDruhOz.SBDeleteRecClick(Sender: TObject);
begin
  SmazRec;
end;

procedure TDruhOz.SmazRec;
begin
  if MessageDlg('Skuten chcete smazat aktuln zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
     Table.Delete;
    end;
end;

procedure TDruhOz.SBEditRecClick(Sender: TObject);
begin
  OpravRec;
end;

procedure TDruhOz.OpravRec;
begin
  Table.edit;
end;

procedure TDruhOz.SBSaveRecClick(Sender: TObject);
begin
  if DS.State in [dsInsert,dsEdit] then
    if MessageDlg('Skuten chcete uloit zznam?',mtInformation,[mbYES,mbNO],0) = mrYES then
      begin
        Table.post;
      end;
end;

procedure TDruhOz.SBUndoRecClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then exit;
  
  if MessageDlg('Skuten chcete zruit proveden zmny?',mtInformation,[mbYES,mbNO],0) = mrYES then
    begin
      Table.Cancel;
    end;
end;

procedure TDruhOz.SBRefreshClick(Sender: TObject);
begin
  Table.refresh;
end;

procedure TDruhOz.CB_FindExit(Sender: TObject);
begin
  CB_Find.Items.Add(CB_Find.Text);
  CB_Find.Text := 'Vyhledn';
end;

procedure TDruhOz.Vyhledn1Click(Sender: TObject);
begin
  wwSearch.SearchField := DBGrid.SelectedField.FieldName;
  wwSearch.execute; 
end;

procedure TDruhOz.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    VK_F7 : wwSearch.execute;
  else MainForm.CiziKey(Sender, Key, Shift);    
  end;
end;

procedure TDruhOz.DOEdit;
begin
  DBGrid.Options := [dgEditing,dgTitles,dgIndicator,dgColumnResize,dgColLines,
                     dgRowLines,dgTabs,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clWindow;
end;

procedure TDruhOz.DoView;
begin
  DBGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgTabs,
                     dgRowSelect,dgConfirmDelete,dgCancelOnExit];
  DBGrid.Color := clBtnFace;
end;

procedure TDruhOz.TableBeforeEdit(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TDruhOz.TableBeforeInsert(DataSet: TDataSet);
begin
  DoEdit;
end;

procedure TDruhOz.TableAfterPost(DataSet: TDataSet);
begin
  DoView;
end;

procedure TDruhOz.TableAfterCancel(DataSet: TDataSet);
begin
  DoView;                   
end;
procedure TDruhOz.DBGridDblClick(Sender: TObject);
begin
  if dgRowSelect in DBGrid.Options then
    begin
      ModalResult := mrOK;
    end;
end;

procedure TDruhOz.CB_FindEnter(Sender: TObject);
begin
  CB_Find.Text := '';
end;

procedure TDruhOz.BitBtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TDruhOz.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;

end.
