unit UEditor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, ExtCtrls, DBTables, DB;

type
  TFEditor = class(TForm)
    LBAll: TListBox;
    DoKey: TSpeedButton;
    DoAllKey: TSpeedButton;
    LBFields: TListBox;
    DeleteAllKey: TSpeedButton;
    DeleteKey: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Chbs: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure ChbsClick(Sender: TObject);
    procedure DoKeyClick(Sender: TObject);
    procedure DoAllKeyClick(Sender: TObject);
    procedure DeleteAllKeyClick(Sender: TObject);
    procedure DeleteKeyClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure LBAllDblClick(Sender: TObject);
    procedure LBFieldsDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure DoFields;
    procedure DoAllFields;
    procedure DeleteAllFields;
    procedure DeleteFields;
    procedure UpField;
    procedure DownField;
  public
    { Public declarations }
  end;


implementation

{$R *.DFM}

procedure TFEditor.ChbsClick(Sender: TObject);
begin
  LBAll.Sorted := ChBs.Checked;
end;

procedure TFEditor.DoKeyClick(Sender: TObject);
begin
  DoFields;
end;

procedure TFEditor.DoAllKeyClick(Sender: TObject);
begin
  DoAllFields;
end;

procedure TFEditor.DeleteAllKeyClick(Sender: TObject);
begin
  DeleteAllFields; 
end;

procedure TFEditor.DeleteKeyClick(Sender: TObject);
begin
  DeleteFields;
end;

procedure TFEditor.SpeedButton1Click(Sender: TObject);
begin
  UpField;
end;

procedure TFEditor.SpeedButton2Click(Sender: TObject);
begin
  DownField;
end;

procedure TFEditor.DoFields;
begin
  LBFields.Items.Add(LBAll.Items[LBAll.ItemIndex]);
end;

procedure TFEditor.DoAllFields;
begin
  LBFields.Items := LBAll.Items;
end;

procedure TFEditor.DeleteAllFields;
begin
  LBFields.Items.Clear;
end;

procedure TFEditor.DeleteFields;
begin
  LBFields.Items.Delete(LBFields.ItemIndex);
end;

procedure TFEditor.UpField;
begin
  LBFields.Items.Move(LBFields.ItemIndex,LBFields.ItemIndex-1);
end;

procedure TFEditor.DownField;
begin
  LBFields.Items.Move(LBFields.ItemIndex,LBFields.ItemIndex+1);
end;

procedure TFEditor.LBAllDblClick(Sender: TObject);
begin
  DoFields;
end;

procedure TFEditor.LBFieldsDblClick(Sender: TObject);
begin
  DeleteFields;
end;

end.
