unit T_GNIntr;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy interaktivnch nstroj                          *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}


interface
uses
  Menus, StdCtrls,
  WinTypes,
  Classes,
  Controls,
  Graphics,
  F_STD,
  Elements, G_Elems, G_Elem2,
  M_InterA,
  t_Intera,
  t_Recurs,
  t_Editor,
  Tools;



const
  DolniMezZobrazeni =  1000;
  DolniMezEditace   =  1000;
  HorniMezEditace   = 20000;

type

TZoomIn = class(TInteractiveTool)
 protected
   ShiftRect: TRect;
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
 public
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;

TZoomOut = class(TInteractiveTool)
 protected
   ShiftRect: TRect;
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
 public
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;


TEditTextState = (etsStart, etsSelected, etsMove, etsRotate);

TEditTextTool = class(TDrawRectTool)
private
   FColor: TColor;

   FFRectRot: TDrawRectRot;
   FState: TEditTextState;
   FX, FY: double;

   function  GetElementClass: TElementClass; virtual; abstract;

   function  ScaleKoef(aValue: double): double;
   procedure DrawText(Erase: boolean);
   function  InsideSelectedText(aX, aY: integer): boolean;
   procedure RotateText(aX, aY: integer);
   procedure MoveGhostTo(aX, aY: integer);
   procedure MoveRotGhost(aX, aY: integer);
   procedure On_tm_ConfirmPosition(var Handled: boolean);
   function  InsideRotation(aX, aY: integer): boolean;
   function  GetDBFont: TFont;
   function  GetDBMemo: TMemo;
   procedure GetPixelRect(var aRect: TRect);
   procedure SetDBCoords;
   function  GetRectRot: TDrawRectRot;
   procedure SetRectRot(aRR: TDrawRectRot);
   function GetTextShift: double;

protected
   function  GetCursor: TCursor; override;
   function  GetName: string; override;

public
   FBitMap: TBitMap;
//   Crd1, Crd2, Crd3, Crd4: TDoubleCoord;
   Pnt1, Pnt2, Pnt3, Pnt4: WinTypes.TPoint;
   BMdX, BMdY: double;
   PrevX, PrevY, DeltaX, DeltaY: integer;
   ReactDBChange: boolean;

   constructor Create; override;
   destructor  Destroy; override;
{   procedure ViewActualText(AColor: longInt);}
   procedure PutTextToBM(XORM: boolean);
   procedure On_Erase(aCoord: TDoubleCoord); override;
   procedure On_Draw (aCoord: TDoubleCoord);
   procedure DrawTextGhost(aX, aY: integer; XORM: boolean);
   procedure FillRectRot;
   procedure DeleteRectRot;

   procedure On_Activate; override;
   procedure On_DeActivate; override;
   procedure On_tm_SavedDBRec(var Handled: boolean);
   procedure On_tm_DBChange(var Handled: boolean);
   procedure On_tm_DBCrdChange(var Handled: boolean);
   procedure On_tm_ResetTool(var Handled: boolean);
   procedure on_tm_AfterReview(var Handled: boolean);
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;

   function ItsMyClass(aClass: TElementClass): boolean;

   procedure DeSelect; virtual;
   procedure SelectText(aX, aY: integer); { vbr dle DBFormu }
   procedure OnSelectText(aX, aY: integer);

   property ElementClass: TElementClass read GetElementClass;
{   property Editor: TRectEntityEditor read FEditor write FEditor; }
published
   property Color: TColor read FColor write FColor;
   property DBFont: TFont read GetDBFont;
   property DBMemo: TMemo read GetDBMemo;
   property RectRot: TDrawRectRot read GetRectRot write SetRectRot;
end;


TNewTextTool = class(TEditTextTool)
private
protected
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
   procedure FirstPoint(aX, aY: integer);
public
   procedure DeSelect; override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;

   procedure On_Activate; override;
end;

procedure PosunSour(var aX, aY: Double; aShift, anAngle: double);


implementation
uses
   SysUtils, Dialogs, DB,
//   Windows,
   Forms,
   MathLib,
   //D_STD,
   e_Device,
   e_IScrpt,
   M_Orbis, M_Proj,
   {
   i_TopoL,
   }
   i_Uni,
{$IFNDEF NOTIS}
   //t_SelAre,
   //t_SelMS,
//   t_TisCre,
{$ENDIF}
   u_Cursor,
   E_ZM,
   Worlds,
   uDBForm,
   T_Main;



procedure PosunSour(var aX, aY: Double; aShift, anAngle: double);
var
  aCrd: TDoubleCoord;

begin
  aCrd.X:= aX;
  aCrd.Y:= aY;
  VratPosunutyBod(aCrd, anAngle, aShift, aCrd);
  aX:= aCrd.X;
  aY:= aCrd.Y;
end;



procedure SetTextOrientation(aCanvas: TCanvas; aOrientation: double);
var
  LogFont: TLogFont;

begin
  if aCanvas = nil then exit;

  with LogFont do
  begin
    lfHeight := aCanvas.Font.Height;

    lfWidth := 0; { have font mapper choose }
    lfEscapement := round(aOrientation*10);
    lfOrientation := 0{round(aOrientation*10)};
    if fsBold in aCanvas.Font.Style then
      lfWeight := FW_BOLD
    else
      lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in aCanvas.Font.Style);
    lfUnderline := Byte(fsUnderline in aCanvas.Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in aCanvas.Font.Style);
    lfCharSet := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, aCanvas.Font.Name);
    lfQuality := DEFAULT_QUALITY;
    { Everything else as default }
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := DEFAULT_PITCH;
  end;
{  DeleteObject(Canvas.Font.Handle); }
  aCanvas.Font.Handle := CreateFontIndirect(LogFont);
end;



procedure RotateCrd(Crd1: TDoubleCoord; var Crd2: TDoubleCoord; Angle: double);
var
  Radius: double;
begin
  Radius:= sqrt(sqr(Crd1.X-Crd2.X) +  sqr(Crd1.Y-Crd2.Y));
  Angle:= Angle + Atan2M(Crd2.X-Crd1.X, Crd2.Y-Crd1.Y);
  Crd2.X:= Crd1.X + Radius * cos(Angle);
  Crd2.Y:= Crd1.Y + Radius * sin(Angle);
end;



procedure Rotatate4Crds(CrdLD: TDoubleCoord;
                        Width, Height, Angle: double;
                        var Crd1, Crd2, Crd3, Crd4: TDoubleCoord);
begin
  Crd1:= CrdLD;
  Crd2.X:= CrdLD.X + Width;
  Crd2.Y:= CrdLD.Y;
  Crd3.X:= CrdLD.X + Width;
  Crd3.Y:= CrdLD.Y + Height;
  Crd4.X:= CrdLD.X;
  Crd4.Y:= CrdLD.Y + Height;

  RotateCrd(Crd1, Crd2, Angle);
  RotateCrd(Crd1, Crd3, Angle);
  RotateCrd(Crd1, Crd4, Angle);
end;






{ TZoomIn }

function  TZoomIn.GetName: string;
begin
   result := '+ Lupa';
end;


function  TZoomIn.GetCursor: TCursor;
begin
   result := cr_Lupa;
end;


procedure TZoomIn.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   if aMessage.Key = VK_ESCAPE then PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
end;

procedure TZoomIn.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      ShiftRect := Rect(aMessage.x,aMessage.y,aMessage.x,aMessage.y);
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
   Handled := true;
end;

procedure TZoomIn.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R, RP: TDoubleRect;
   RE: TRectangle;
begin
    Handled := true;
    if not aMessage.ActiveDevice then exit;
    if aMessage.Button = mbLeft then
    begin
       with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
       TCanvasDevice(Device).Canvas.Pen.Mode  := pmCopy;
       TCanvasDevice(Device).Canvas.Pen.Color := clBlack;
       TCanvasDevice(Device).Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 4) and (Bottom - Top <= 4) then
          begin
            Device.Projection.CenterPoint :=
                 Device.Projection.GetModelPoint(aMessage.x,aMessage.y);
            RE:= TRectangle.Create;
            RE.UpdateByDoubleRect(TCanvasDevice(Device).Projection.ModelView);
            RE.GrowByKoef(1/TOptions(TMainTool(World.MainTool).Options).ZoomKoef);
            if Device.Projection.Scale/TOptions(TMainTool(World.MainTool).Options).ZoomKoef < DolniMezZobrazeni then
            begin
              MessageBeep(0);
              exit;
            end;

            TCanvasDevice(Device).Projection.ModelView := RE.AsDoubleRect;
            PostMsgToOwners(tm_AddProjection, nil, DontKill);
            PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
            RE.Free
          end
          else
          begin
             R := Device.Projection.GetModelRect(Left, Top, Right, Bottom);
             RP:= TCanvasDevice(Device).Projection.ModelView;
             TCanvasDevice(Device).Projection.ModelView := R;
             if Device.Projection.Scale < DolniMezZobrazeni then
             begin
               TCanvasDevice(Device).Projection.ModelView:= RP;
               MessageBeep(0);
               exit
             end;
             PostMsgToOwners(tm_AddProjection, nil, DontKill);
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
          end;
       end;
    end;
end;

procedure TZoomIn.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
   if not aMessage.ActiveDevice then exit;
   if  ssLeft in aMessage.Shift then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      Device.Brush.Style:= bsClear;
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      ShiftRect.Right  := aMessage.x;
      ShiftRect.Bottom := aMessage.y;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
end;


{ TZoomOut }

function  TZoomOut.GetName: string;
begin
   result := '- Lupa';
end;


function  TZoomOut.GetCursor: TCursor;
begin
   result := cr_ZoomOut;
end;


procedure TZoomOut.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   if aMessage.Key = VK_ESCAPE then PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
end;

procedure TZoomOut.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      ShiftRect := Rect(aMessage.x,aMessage.y,aMessage.x,aMessage.y);
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
   Handled := true;
end;

procedure TZoomOut.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
   RE: TRectangle;
begin
    Handled := true;
    if not aMessage.ActiveDevice then exit;
    if aMessage.Button = mbLeft then
    begin
       with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
       TCanvasDevice(Device).Canvas.Pen.Mode  := pmCopy;
       TCanvasDevice(Device).Canvas.Pen.Color := clBlack;
       TCanvasDevice(Device).Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 4) and (Bottom - Top <= 4) then
          begin
            Device.Projection.CenterPoint :=
                 Device.Projection.GetModelPoint(aMessage.x,aMessage.y);
            RE:= TRectangle.Create;
            RE.UpdateByDoubleRect(TCanvasDevice(Device).Projection.ModelView);
            RE.GrowByKoef(TOptions(TMainTool(World.MainTool).Options).ZoomKoef);
            TCanvasDevice(Device).Projection.ModelView := RE.AsDoubleRect;
            PostMsgToOwners(tm_AddProjection, nil, DontKill);
            PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
            RE.Free
          end
          else
          begin
             R := Device.Projection.GetModelRect(Left, Top, Right, Bottom);
             TCanvasDevice(Device).Projection.ModelView := R;
             PostMsgToOwners(tm_AddProjection, nil, DontKill);
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
          end;
       end;
    end;
end;

procedure TZoomOut.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
   if not aMessage.ActiveDevice then exit;
{
   if  ssLeft in aMessage.Shift then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      ShiftRect.Right  := aMessage.x;
      ShiftRect.Bottom := aMessage.y;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
}
end;


{ TEditorIATool }



constructor TEditTextTool.Create;
begin
  inherited Create;
  FBitmap:= TBitMap.Create;
  FBitMap.Monochrome:= false;
  FState:= etsStart;
  ReactDBChange:= true;
end;


destructor  TEditTextTool.Destroy;
begin
  RectRot:= nil;
  FBitMap.Free;
  inherited Destroy
end;

{
function  TEditTextTool.GetDBForm: TTextDBForm;
begin
  result:= TMainTool(World.MainTool).TextDBForm
end;
}

function  TEditTextTool.GetDBFont: TFont;
begin
  result:= TMainTool(World.MainTool).TextDBForm.Label_Font.Font
end;


function  TEditTextTool.GetDBMemo: TMemo;
begin
  result:= TMainTool(World.MainTool).TextDBForm.Memo1;
end;





function TEditTextTool.InsideSelectedText(aX, aY: integer): boolean;
begin
  FX:= Device.Projection.GetModelX(aX);
  FY:= Device.Projection.GetModelY(aY);
  result:= false;
  if RectRot = nil then exit;
  result:= RectRot.XYInside(FX, FY)
end;



function TEditTextTool.ItsMyClass(aClass: TElementClass): boolean;
begin
   result := aClass = ElementClass;
end;


function  TEditTextTool.GetName: string;
begin
   result := 'Editor Textu';
end;


function  TEditTextTool.GetCursor: TCursor;
begin
   result := cr_EditText;
end;




function TEditTextTool.ScaleKoef(aValue: double): double;
begin
  result:= (10000*aValue)/Scale
end;



procedure TEditTextTool.GetPixelRect(var aRect: TRect);
var
  aH: integer;

begin
  if RectRot = nil then exit;
  with RectRot do
  begin
    SetRectangle;

    aRect.Left:= 0;
    aRect.Top := 0;
    aRect.Right := Device.Projection.GetPageLength(MaxX-MinX);
    aRect.Bottom:= Device.Projection.GetPageLength(MaxY-MinY);

    aH := Device.Projection.GetPageLength(MaxY-MinY);
    { globln promnn objektu }
    Pnt1.X:= Device.Projection.GetPageLength(LBX - MinX);
    Pnt1.Y:= aH-Device.Projection.GetPageLength(LBY - MinY);
    Pnt2.X:= Device.Projection.GetPageLength(RBX - MinX);
    Pnt2.Y:= aH-Device.Projection.GetPageLength(RBY - MinY);
    Pnt3.X:= Device.Projection.GetPageLength(RUX - MinX);
    Pnt3.Y:= aH-Device.Projection.GetPageLength(RUY - MinY);
    Pnt4.X:= Device.Projection.GetPageLength(LUX - MinX);
    Pnt4.Y:= aH-Device.Projection.GetPageLength(LUY - MinY);

    BMdX:= (LBX - MinX);
    BMdY:= (LBX - MinX);
  end
end;



(*
procedure TEditTextTool.ViewActualText(AColor: longInt);
var
  FS: integer;
  Angle: double;
  aCrd: TDoubleCoord;

  QText: string;
  QLX,QLY: double;
  QPX,QPY: double;
  QFName: string;
  QFHeight: integer;
  QFColor: longInt;
  QFStyle: byte;
  QFAlign: integer;

begin
  with TMainTool(World.MainTool).TextDBForm do
  begin
      QText:= NazevTisk.AsString;
      QLY:= -LY.AsFloat;
      QLX:= -LX.AsFloat; { pevod z Kovka }

      QPY:= -PY.AsFloat;
      QPX:= -PX.AsFloat;

      QFName:= FontName.AsString;
      QFHeight:= FontHeight.AsInteger;

      if AColor < 0 then
         QFColor := FontColor.AsInteger
      else
         QFColor:= AColor;

      QFStyle:=  FontStyle.AsInteger;
      QFAlign:=  FontAlign.AsInteger;

  end;


  FS:= round(10000.0 * QFHeight/ Device.Projection.Scale);
  if FS < 2 then
  with TCanvasDevice(Device).Canvas do
  begin
    Pen.Color:= QFColor;
    Pen.Style:= psSolid;
    Pen.Width:= 1;
    Device.MoveTo(QLX, QLY);
    Device.LineTo(QLX+Device.Projection.GetModelLength(5), QLY)
  end
  else
  begin
    with TCanvasDevice(Device).Canvas do
    begin
      Font.Name:= QFName;
      Font.Size:= FS;
      Font.Color:= QFColor;
      Font.Style:= TFontStyles(QFStyle);
    end;
    if (QPX=0) or (QPY=0) then Angle:= 350
    else
       Angle:= 180*ATan2M(QPX-QLX, QPY-QLY)/Pi;

    aCrd.X:= QLX;
    aCrd.Y:= QLY;

    VratPosunutyBod(aCrd, DejRadZeStupnu(Angle)+PiPul,
                    Device.TextModelHeight(QText), aCrd);

    TCanvasDevice(Device).SetTextOrientation(Angle);
    Device.TextOut(aCrd.X, aCrd.Y, QText)
  end
end;

*)



procedure TEditTextTool.PutTextToBM(XORM: boolean);
var
  WT, HT: integer;
  aRect: TRect;
  I, XP, YP: integer;
begin
  if RectRot = nil then exit;

  GetPixelRect(aRect);

  FBitmap.Width:= aRect.Right;
  FBitMap.Height:= aRect.Bottom;


  with FBitMap.Canvas do
  begin
    if XORM then
       Brush.Color:= clBlack
    else
       Brush.Color:= clWhite;

    Brush.Style:= bsSolid;
    FillRect(FBitMap.Canvas.ClipRect);

    if XORM then
       Pen.Color:= clWhite
    else
       Pen.Color:= clBlack;

    Pen.Style:= psSolid;
    Pen.Width:= 1;
    MoveTo(Pnt1.X, Pnt1.Y);
    LineTo(Pnt2.X, Pnt2.Y);
{
    LineTo(Pnt3.X, Pnt3.Y);
    LineTo(Pnt4.X, Pnt4.Y);
    LineTo(Pnt1.X, Pnt1.Y);
}
  end;

  if XORM then
     FBitMap.Canvas.Brush.Color:= clBlack
  else
     FBitMap.Canvas.Brush.Color:= clWhite;
  FBitMap.Canvas.Brush.Style:= bsSolid;

  for I:= 0 to DBMemo.Lines.Count-1 do
  with RectRot do
  begin
    XP:= Pnt4.X + (I*(Pnt1.X-Pnt4.X)) div DBMemo.Lines.Count;
    YP:= Pnt4.Y + (I*(Pnt1.Y-Pnt4.Y)) div DBMemo.Lines.Count;
    FBitMap.Canvas.Font.Assign(DBFont);
    if XORM then
       FBitMap.Canvas.Font.Color:= clWhite
    else
      FBitMap.Canvas.Font.Color:= clBlack;
    FBitMap.Canvas.Font.Size:= round(ScaleKoef(DBFont.Size));
    SetTextOrientation(FBitMap.Canvas, DejStupne(Angle));
    FBitMap.Canvas.TextOut(Xp, Yp, DBMemo.Lines.Strings[I]);
  end;

{
  SetTextOrientation(FBitMap.Canvas, DejStupne(Angle));
  FBitMap.Canvas.TextOut(Pnt4.X, Pnt4.Y, Memo.Text);
}
{$IFDEF Debug}
  FBitMap.SaveToFile('\Text.BMP')
{$ENDIF}
end;









procedure TEditTextTool.DrawTextGhost(aX, aY: integer; XORM: boolean);
var
  aPDX, aPDY: integer;
begin
  aPDX:= aX+Pnt2.X;
  aPDY:= aY+Pnt2.Y;

  with Device.Pen do
  begin
    Color:= clWhite;
    if XORM then
       Mode:= pmXor
    else
    begin
      Color:= clBlack;
      Mode:= pmCopy
    end
  end;

  with TCanvasDevice(Device).Canvas do
  begin
    if XORM then
       CopyMode:= cmSrcInvert	 {cmPatCopy cmSrcCopy}
    else
       CopyMode:= cmSrcAnd;

    Draw(aX, aY, FBitMap);

    MoveTo(aPDX-5, aPDY-5);
    LineTo(aPDX-5, aPDY+5);
    LineTo(aPDX+5, aPDY+5);
    LineTo(aPDX+5, aPDY-5);
    LineTo(aPDX-5, aPDY-5);
  end;

end;



function TEditTextTool.InsideRotation(aX, aY: integer): boolean;
var
  aPDX, aPDY: integer;
begin
  aPDX:= PrevX+Pnt2.X;
  aPDY:= PrevY+Pnt2.Y;

{ !!! result:=  (aX in [aPDX-5..aPDX+5]) and (aY in [aPDY-5..aPDY+5]) }
  result:= (abs(aPDX-aX) <= 5) and (abs(aPDY-aY) <= 5)
end;



procedure TEditTextTool.On_Erase(aCoord: TDoubleCoord);
begin
{  DrawTextRect(aCoord); }
end;

procedure TEditTextTool.On_Draw (aCoord: TDoubleCoord);
begin
{  DrawTextRect(aCoord); }
end;

function TEditTextTool.GetTextShift: double;
var
  anOK: Boolean;
  aTM: TTextMetric;

begin
  anOK:= GetTextMetrics(TCanvasDevice(Device).Canvas.Handle, aTM);
  Result:= Device.TextModelHeight('X');
  result:= (Result / aTM.tmHeight) * aTM.tmDescent;
end;


procedure TEditTextTool.FillRectRot;
{ Informace z DB:
     Memo
     LDX, LDY, PDX, PDY (-> Angle)
     Font -> Device.Font
  Nastaven Device
     Device.Font.Size dle aktulnho mtka
  Informace z Device
     ka a vka konkrtnho memo textu

  Strings, LDX, LDY, Angle, FontSize, VirtualScale,
}
var
  LDX, LDY, PDX, PDY: double;
  W, H: double;
  I: integer;
  anAngle: double;
  ZMAngle: double;
  ZMName: string;
  anOK: boolean;
  aTM: TTextMetric;
begin
{$IFNDEF Debug}

  ZMAngle:= 0;
//  ZMName:= TMainTool(World.MainTool).TextDBForm.TableMapa_001.AsString;
  ZMName:= TMainTool(World.MainTool).TextDBForm.QueryMapa_001.AsString;

  ZMAngle:= GetZMAngle(ZMName);

  if (DBMemo.Lines.Count > 0) or
     (TMainTool(World.MainTool).TextDBForm.Table.RecordCount > 0) then
  begin
    W:= -1;

    with TMainTool(World.MainTool).TextDBForm do
    begin
{      if not (DS.State in [dsEdit, dsInsert]) then exit; }

(*
      LDX := -TableSOUR_LDY_001.value;
      LDY := -TableSOUR_LDX_001.value;
      PDX := -TableSOUR_PDY_001.value;
      PDY := -TableSOUR_PDX_001.value;
*)
      LDX := -QuerySOUR_LDY_001.value;
      LDY := -QuerySOUR_LDX_001.value;
      PDX := -QuerySOUR_PDY_001.value;
      PDY := -QuerySOUR_PDX_001.value;

      if (PDX=0) or (PDY=0) then
      begin
        if ZMAngle = 0 then
        begin
          if ZMName = '' then
          begin
            if LDX = 0 then
            begin
              LDX:= FX;
              LDY:= FY;
            end;
            anAngle:= GetZMAngleForXY(LDX, LDY);
            if anAngle = 0 then
               anAngle:= DejRadZeStupnu(350)
          end
          else
            anAngle:= DejRadZeStupnu(350)
        end
        else
           anAngle:= ZMAngle
      end
      else
        anAngle:= ATan2M(PDX-LDX, PDY-LDY);
    end;

    Device.Font.Assign(DBFont);
    Device.Font.Size:= round(ScaleKoef(DBFont.Size));

    {Posun dolu }
    PosunSour(LDX, LDY, GetTextShift, -(anAngle+Pi/2));

    for I:= 0 to DBMemo.Lines.Count-1 do
    begin
      if Device.TextModelWidth(DBMemo.Lines.Strings[I]) > W then
         W:= Device.TextModelWidth(DBMemo.Lines.Strings[I]);
    end;
    H:= abs(DBMemo.Lines.Count * Device.TextModelHeight(DBMemo.Lines.Strings[0]));
  end
  else
  begin
    Device.Font.Name:= 'Arial';
    Device.Font.Size:= 10;
    W:= Device.TextModelWidth('.');
    H:= abs(Device.TextModelHeight('M'));
    if ZMAngle = 0 then
       anAngle:= DejRadZeStupnu(350)
    else
       anAngle:= ZMAngle;
    LDX:= 0;
    LDY:= 0;
  end;

  anOK:= GetTextMetrics(TCanvasDevice(Device).Canvas.Handle, aTM);


  RectRot:= TDrawRectRot.Create;
  RectRot.RotWidth := W;
  RectRot.RotHeight:= H;
  RectRot.Angle    := anAngle;
  RectRot.RefX     := LDX;
  RectRot.RefY     := LDY;
  RectRot.SetRectangle;
{$ENDIF}
end;


procedure TEditTextTool.DeleteRectRot;
begin
  RectRot:= nil
end;




procedure TEditTextTool.DrawText(Erase: boolean);
var
  TC, I: integer;
  Xp, Yp: double;
begin
  if RectRot = nil then
     FillRectRot;
  if RectRot = nil then exit;

  TC:= DBMemo.Lines.Count;
  if TC = 0 then exit;


  for I:= 0 to TC-1 do
  with RectRot do
  begin
    XP:= LUX - I*(LUX-LBX)/TC;
    YP:= LUY - I*(LUY-LBY)/TC;
    Device.Font.Assign(DBFont);
    Device.Font.Size:= round(ScaleKoef(DBFont.Size));
    if Erase then
       Device.Font.Color:= Device.Page.Color;
    Device.SetTextOrientation(DejStupne(Angle));
    Device.TextOut(Xp, Yp, DBMemo.Lines.Strings[I]);
  end;

{
  Device.Pen.Color:= clGreen;

  with FRectRot do
  begin
    Device.MoveTo(LBX, LBY);
    Device.LineTo(RBX, RBY);
    Device.LineTo(RUX, RUY);
    Device.LineTo(LUX, LUY);
    Device.LineTo(LBX, LBY)
  end
}
end;



procedure TEditTextTool.DeSelect;
begin
  if FState = etsStart then
  begin
    DeleteRectRot;
    exit;
  end;

  DrawTextGhost(PrevX, PrevY, true);

  if (TMainTool(World.MainTool).TextDBForm.DS.State = dsEdit) then
  begin
    TMainTool(World.MainTool).TextDBForm.LDColor:= clWhite;
    TMainTool(World.MainTool).TextDBForm.PDColor:= clWhite;
  end
  else
  begin
    TMainTool(World.MainTool).TextDBForm.LDColor:= clSilver;
    TMainTool(World.MainTool).TextDBForm.PDColor:= clSilver
  end;

  DeleteRectRot;
  DrawText(false);
  FState:= etsStart;
  Manager.FormCursor:= cr_EditText
end;



procedure TEditTextTool.SetDBCoords;
var
  AReactDBChange: boolean;
  aLBX, aLBY, aRBX, aRBY, aSize: double;
begin
  if RectRot = nil then exit;

  AReactDBChange:= ReactDBChange;
  ReactDBChange:= false;
  with RectRot do
  begin
    {Posun nahoru }
    aLBX := LBX;
    aLBY := LBY;
    aRBX := RBX;
    aRBY := RBY;

    Device.Font.Assign(DBFont);
    Device.Font.Size:= round(ScaleKoef(DBFont.Size));

    aSize:= GetTextShift;
    PosunSour(aLBX, aLBY, aSize, Pi-(Angle+Pi/2));
    PosunSour(aRBX, aRBY, aSize, Pi-(Angle+Pi/2));
    TMainTool(World.MainTool).TextDBForm.SetCoords
              (-aLBX, -aLBY, -aRBX, -aRBY, DejStupne(Angle), GetZMName(10000, aLBX, aLBY)); { pevod do Kovka }
  end;
  Application.ProcessMessages;

  ReactDBChange:= AReactDBChange;
end;

function  TEditTextTool.GetRectRot: TDrawRectRot;
begin
  result:= FFRectRot
end;


procedure TEditTextTool.SetRectRot(aRR: TDrawRectRot);
begin
  if FFRectRot <> nil then
  begin
    FFRectRot.Free
  end;

  FFRectRot:= aRR
end;


procedure TEditTextTool.SelectText(aX, aY: integer);
begin
  FillRectRot;
  if RectRot = nil then exit;

  DrawText(true);

  PutTextToBM(true);
  TMainTool(World.MainTool).TextDBForm.LDColor:= clWhite;

  PrevX:= Device.Projection.GetPageX(RectRot.MinX);
  PrevY:= Device.Projection.GetPageY(RectRot.MaxY);
  DeltaX:= aX - PrevX;
  DeltaY:= aY - PrevY;
  DrawTextGhost(PrevX, PrevY, true);

  FState:= etsSelected;
end;


procedure TEditTextTool.OnSelectText(aX, aY: integer);
var
  PDX, PDY: double;
  aPoint: WinTypes.TPoint;
  aCoord: TDoubleCoord;
begin
  aCoord:= Device.Projection.GetModelPoint(aX, aY);
  ReactDBChange:=false;

  TMainTool(World.MainTool).TextDBForm.FindText
            (GetZMName(10000, aCoord.X, aCoord.Y), -aCoord.X, -aCoord.Y);

  SelectText(aX, aY);
end;


procedure TEditTextTool.RotateText(aX, aY: integer);
begin
  DrawTextGhost(PrevX, PrevY, true);

  if RectRot = nil then exit;
  ReactDBChange:= false;

  FX:= Device.Projection.GetModelX(aX);
  FY:= Device.Projection.GetModelY(aY);

  with RectRot do
  begin
    Angle:= Atan2M(FX-LBX, FY-LBY);
    SetRectangle;
  end;
  PutTextToBM(true);

  PrevX:= Device.Projection.GetPageX(RectRot.MinX);
  PrevY:= Device.Projection.GetPageY(RectRot.MaxY);

  DrawTextGhost(PrevX, PrevY, true);

  SetDBCoords;

  TMainTool(World.MainTool).TextDBForm.PDColor:= clYellow;
  ReactDBChange:= true;
end;


procedure TEditTextTool.MoveGhostTo(aX, aY: integer);
begin
  FX:= Device.Projection.GetModelX(PrevX);
  FY:= Device.Projection.GetModelY(PrevY);

  DrawTextGhost(PrevX, PrevY, true);

  if RectRot = nil then exit;
  ReactDBChange:= false;
  PrevX:= aX-DeltaX;
  PrevY:= aY-DeltaY;
  DrawTextGhost(PrevX, PrevY, true);
  with RectRot do
  begin
    RefX:= (LBX-MinX) + FX;
    RefY:= (LBY-MaxY) + FY;
    SetRectangle
  end;
  SetDBCoords;
  TMainTool(World.MainTool).TextDBForm.LDColor:= clYellow;
  ReactDBChange:= true;
end;


procedure TEditTextTool.MoveRotGhost(aX, aY: integer);
begin
  if FState = etsRotate then
     RotateText(aX, aY)
  else
  if FState = etsMove then
     MoveGhostTo(aX, aY)
end;


procedure TEditTextTool.On_tm_ConfirmPosition(var Handled: boolean);
begin
  if FState = etsStart then exit;

  Handled:= true;

  DrawText(true);

  SetDBCoords;
  Application.ProcessMessages;

  DeSelect;

  TMainTool(World.MainTool).TextDBForm.LDColor:= clFuchsia;
  TMainTool(World.MainTool).TextDBForm.PDColor:= clFuchsia;
end;



procedure TEditTextTool.on_tm_AfterReview(var Handled: boolean);
begin
  if FState = etsStart then exit;

  PutTextToBM(false);
  DrawTextGhost(PrevX, PrevY, false);
  PutTextToBM(true);
end;


procedure TEditTextTool.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
     if FState = etsStart then
     begin
       OnSelectText(aMessage.X, aMessage.Y);
     end
     else
     if FState = etsSelected then
     begin
       if InsideRotation(aMessage.X, aMessage.Y) then
       begin
         FState:= etsRotate;
         DeltaX:= aMessage.X - PrevX;
         DeltaY:= aMessage.Y - PrevY;
       end
       else
       if InsideSelectedText(aMessage.X, aMessage.Y) then
       begin
         Manager.FormCursor:= cr_MoveText;
         DeltaX:= aMessage.X - PrevX;
         DeltaY:= aMessage.Y - PrevY;
         FState:= etsMove
       end
       else
       begin
         DeSelect;

         OnSelectText(aMessage.X, aMessage.Y);
       end
     end
   end;
   Handled := true;
end;



procedure TEditTextTool.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
{   if not aMessage.ActiveDevice then exit; }
   if  ssLeft in aMessage.Shift then
   begin
     case FState of
     etsMove: MoveGhostTo(aMessage.X, aMessage.Y);
     etsRotate: RotateText(aMessage.X, aMessage.Y)
     end
   end
   else
   if FState = etsSelected then
   begin
     if not (TMainTool(World.MainTool).TextDBForm.DS.State in [dsEdit, dsInsert]) then
     begin
       FState:= etsStart;
       Manager.FormCursor:= cr_EditText
     end
     else
     if InsideRotation(aMessage.X, aMessage.Y) then
        Manager.FormCursor:= cr_RotText
     else
     if InsideSelectedText(aMessage.X, aMessage.Y) then
        Manager.FormCursor:= cr_MoveText
     else
        Manager.FormCursor:= cr_EditText
   end
end;



procedure TEditTextTool.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
   C: TDoubleCoord;
begin
    Handled := true;

    if FState in [etsMove, etsRotate] then
    begin
      FState:= etsSelected;
      Manager.FormCursor:= cr_EditText;
    end;

    if aMessage.Button = mbLeft then
    begin
    end;
end;



procedure TEditTextTool.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
var
  aX, aY: integer;
  ZMAngle: double;
  ZM: TMapsZM;
begin
  aX:= PrevX + DeltaX;
  aY:= PrevY + DeltaY;
  case aMessage.Key of
  VK_ESCAPE: begin
               PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
               DeSelect
             end;
  VK_Return: begin
               On_tm_ConfirmPosition(Handled)
             end;
  VK_Down: begin
             aY:= aY+1;
             MoveGhostTo(aX, aY);
           end;
  VK_Left: begin
             aX:= aX-1;
             MoveGhostTo(aX, aY);
           end;
  VK_Right: begin
              aX:= aX+1;
              MoveGhostTo(aX, aY);
            end;
  VK_Up: begin
             aY:= aY-1;
             MoveGhostTo(aX, aY);
         end;
  ord('U'):if RectRot <> nil then
           begin
             //ZMAngle:= GetZMAngleForXY(RectRot.RefX, RectRot.RefY);
             ZM := TMapsZM.Create;
             ZM.Scale := 10000;
             ZM.GetNameByCoords(RectRot.RefX, RectRot.RefY);
             ZMAngle:= ZM.Angle;
             ZM.Free;
             if (DejStupne(Abs(RectRot.Angle-ZMAngle)) > 1) and
                (FState = etsSelected) then
             begin
               DrawTextGhost(PrevX, PrevY, true);
               with RectRot do
               begin
                 Angle:= ZMAngle;
                 SetRectangle;
               end;
               PutTextToBM(true);

               PrevX:= Device.Projection.GetPageX(RectRot.MinX);
               PrevY:= Device.Projection.GetPageY(RectRot.MaxY);

               DrawTextGhost(PrevX, PrevY, true);
               SetDBCoords;
               TMainTool(World.MainTool).TextDBForm.PDColor:= clYellow
             end
           end
  end;
end;


procedure TEditTextTool.On_Activate;
var
  aCoord: TDoubleCoord;
begin
  FState:= etsStart;
  aCoord.X:= 0;
  aCoord.Y:= 0;

  if RectRot <> nil then
     PutTextToBM(true)
  else
    with TMainTool(World.MainTool).TextDBForm do
    begin
      {$IFNDEF Debug}
      if (DS.State in [dsEdit]) then
//         SelectText(round(-TableSOUR_LDY_001.value), round(-TableSOUR_LDX_001.value))
         SelectText(round(-QuerySOUR_LDY_001.value), round(-QuerySOUR_LDX_001.value))
      {$ENDIF}   
    end;
end;


procedure TEditTextTool.On_DeActivate;
var
  aCoord: TDoubleCoord;
begin
  DeSelect;
  with TMainTool(World.MainTool).TextDBForm do
  begin
{$IFNDEF Debug}
    if DS.State in [dsInsert,dsEdit] then
    begin
//      Table.Cancel;
      Query.Cancel;
    end;
    NastavEdit(1,True,clBtnFace);
{$ENDIF}
  end
end;


procedure TEditTextTool.On_tm_SavedDBRec(var Handled: boolean);
begin
  DeSelect
end;


procedure TEditTextTool.On_tm_DBChange(var Handled: boolean);
var
  aRDB: boolean;
begin
  Application.ProcessMessages;
  if not (TMainTool(World.MainTool).TextDBForm.DS.State in [dsEdit, dsInsert]) then
     exit;
  if not ReactDBChange then
     exit;
  if FState <> etsSelected then exit;

  aRDB:= ReactDBChange;
  ReactDBChange:= false;

  DrawTextGhost(PrevX, PrevY, true);

  FillRectRot;

  if RectRot = nil then exit;

  PrevX:= Device.Projection.GetPageX(RectRot.MinX);
  PrevY:= Device.Projection.GetPageY(RectRot.MaxY);
  PutTextToBM(true);
  DrawTextGhost(PrevX, PrevY, true);

  SetDBCoords;

  TMainTool(World.MainTool).TextDBForm.PDColor:= clYellow;

  ReactDBChange:= aRDB;
end;


procedure TEditTextTool.On_tm_DBCrdChange(var Handled: boolean);
var
  aRDB: boolean;
begin
  Application.ProcessMessages;
  if not (TMainTool(World.MainTool).TextDBForm.DS.State in [dsEdit, dsInsert]) then
     exit;
  if not ReactDBChange then
     exit;
  if FState <> etsSelected then exit;

  DrawTextGhost(PrevX, PrevY, true);

  aRDB:= ReactDBChange;
  ReactDBChange:= false;
  FillRectRot;
  if RectRot = nil then exit;

  PrevX:= Device.Projection.GetPageX(RectRot.MinX);
  PrevY:= Device.Projection.GetPageY(RectRot.MaxY);
  PutTextToBM(true);
  DrawTextGhost(PrevX, PrevY, true);
  SetDBCoords;
  TMainTool(World.MainTool).TextDBForm.PDColor:= clYellow;
  ReactDBChange:= aRDB;
end;



procedure TEditTextTool.On_tm_ResetTool(var Handled: boolean);
begin
  DeSelect
end;


procedure TEditTextTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled := false;

   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;

   case aMessage.Message of
      tm_AfterReview    :      on_tm_AfterReview(Handled);
      tm_ConfirmPosition:      on_tm_ConfirmPosition(Handled);
      tm_SavedDBRec     :      on_tm_SavedDBRec(Handled);
      tm_DBChange       :      on_tm_DBChange(Handled);
      tm_DBCrdChange    :      on_tm_DBCrdChange(Handled);
      tm_ResetTool      :      on_tm_ResetTool(Handled);
   end;
end;





function  TNewTextTool.GetName: string;
begin
   result := 'Nov Text';
end;


function  TNewTextTool.GetCursor: TCursor;
begin
   result := cr_NewText;
end;


procedure TNewTextTool.On_Activate;
var
  aCoord: TDoubleCoord;
begin
  FState:= etsStart;
  with Device.Pen do
  begin
    Color:= clGreen;
    Mode:= pmXor
  end;

  aCoord.X:= 0;
  aCoord.Y:= 0;
  PutTextToBM(true);
end;


procedure TNewTextTool.DeSelect;
begin
  if FState = etsStart then exit;
  DrawTextGhost(PrevX, PrevY, true);

  if (TMainTool(World.MainTool).TextDBForm.DS.State = dsEdit) then
  begin
    TMainTool(World.MainTool).TextDBForm.LDColor:= clWhite;
    TMainTool(World.MainTool).TextDBForm.PDColor:= clWhite;
  end
  else
  begin
    TMainTool(World.MainTool).TextDBForm.LDColor:= clSilver;
    TMainTool(World.MainTool).TextDBForm.PDColor:= clSilver
  end;

  DeleteRectRot;
  DrawText(false);  {pro nov text nen co kreslit }
  FState:= etsStart;
  Manager.FormCursor:= cr_NewText
end;




procedure TNewTextTool.FirstPoint(aX, aY: integer);
begin
  FX:= Device.Projection.GetModelX(aX);
  FY:= Device.Projection.GetModelY(aY);

  if (Scale > HorniMezEditace) or (Scale < DolniMezEditace) then
  begin
     ShowMessage('Pro vkldn novch text' + #13+
                 'mus bt mtko v rozmez 1:' + IntToStr(DolniMezEditace) +
                 ' a 1:' + IntToStr(HorniMezEditace));
     exit
  end;
  ReactDBChange:= false;
{$IFNDEF Debug}

  TMainTool(World.MainTool).TextDBForm.PridejRec;
{$ENDIF}
  DeltaX:= 0;
  DeltaY:= 0;
  PrevX:= aX;
  PrevY:= aY;

  FillRectRot;
  if RectRot = nil then exit;

  with RectRot do
  begin
    RefX:= FX;
    RefY:= FY;
    SetRectangle
  end;

  PutTextToBM(true);

  PrevX:= Device.Projection.GetPageX(RectRot.MinX);
  PrevY:= Device.Projection.GetPageY(RectRot.MaxY);
  DeltaX:= aX - PrevX;
  DeltaY:= aY - PrevY;

  DrawTextGhost(PrevX, PrevY, true);

  FState:= etsSelected;

  SetDBCoords;
  ReactDBChange:= true;
end;




procedure TNewTextTool.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   if aMessage.Button = mbLeft then
   begin
     if FState = etsStart then
     begin
       FirstPoint(aMessage.X, aMessage.Y);
     end
     else
     if FState = etsSelected then
     begin
       if InsideRotation(aMessage.X, aMessage.Y) then
       begin
         FState:= etsRotate
       end
       else
       if InsideSelectedText(aMessage.X, aMessage.Y) then
       begin
         Manager.FormCursor:= cr_MoveText;
         DeltaX:= aMessage.X - PrevX;
         DeltaY:= aMessage.Y - PrevY;
         FState:= etsMove
       end
       else
       begin
         DeSelect;

         FirstPoint(aMessage.X, aMessage.Y);
       end
     end
   end;
   Handled := true;
end;



procedure TNewTextTool.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
{   if not aMessage.ActiveDevice then exit; }
   if  ssLeft in aMessage.Shift then
   begin
     case FState of
     etsMove: MoveGhostTo(aMessage.X, aMessage.Y);
     etsRotate: RotateText(aMessage.X, aMessage.Y)
     end
   end
   else
   if FState = etsSelected then
   begin
     if not (TMainTool(World.MainTool).TextDBForm.DS.State in [dsEdit, dsInsert]) then
     begin
       FState:= etsStart;
       Manager.FormCursor:= cr_NewText
     end
     else
     if InsideRotation(aMessage.X, aMessage.Y) then
        Manager.FormCursor:= cr_RotText
     else
     if InsideSelectedText(aMessage.X, aMessage.Y) then
        Manager.FormCursor:= cr_MoveText
     else
        Manager.FormCursor:= cr_NewText
   end
end;



procedure TNewTextTool.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
   C: TDoubleCoord;
begin
    Handled := true;

    if FState in [etsMove, etsRotate] then
    begin
      FState:= etsSelected;
      Manager.FormCursor:= cr_NewText;
    end;

    if aMessage.Button = mbLeft then
    begin
    end;
end;







{
  system.assign(Fout, 'h:\vystup.txt');
  system.rewrite(Fout);

  for I:= 1 to 100000 do
  begin
    case I mod 3 of
    0: Barva:= 255;
    1: Barva:= 0;
    2: Barva:= $FF0000;
    end;

    X:= random(600000) + 400000;
    Y:= random(400000) + 900000;
    Mapa:= ZM.GetNameByCoords(-X, -Y);
    if Mapa <> '' then
       writeln(Fout, I:6, X:7, Y:8, ' ''', Mapa,''' ''', X:6,';',Y:7,''' ', Barva:9)
  end;
  system.close(Fout);
}



end.
