unit T_Helhie;

interface
uses
  Controls,
  comctrls,
// KERNEL
   Elements,
   Tools,
   T_Recurs,
// GUI
   M_Intera,
// GLIB
   G_Elems,
// SPACE
   E_Space,
// 0TEMP
   T_selare,
   f_STD1;


type

// input - Hierarchy
// hodnoty se mus zadvat postupn od LHC po PSk

  THeleHier = class(TTool)
  private
    FLHC, FOdd, FDil, FPor, FPSk: TRectEntity;
    FResultRect: TRectEntity;

    function GetLHC: string;
    procedure SetLHC(aVal: string);
    function GetOdd: string;
    procedure SetOdd(aVal: string);
    function GetDil: string;
    procedure SetDil(aVal: string);
    function GetPor: string;
    procedure SetPor(aVal: string);
    function GetPSk: string;
    procedure SetPSk(aVal: string);

  public
    procedure DoIt; override;
  published
    property LHC: string read GetLHC write SetLHC;
    property Odd: string read GetODD write SetODD;
    property Dil: string  read GetDIL write SetDIL;
    property Por: string  read GetPOR write SetPOR;
    property PSK: string  read GetPSK write SetPSK;
  end;


  THeleSkupina = class(TRecursor)
  private
    FX, FY: double;
    FFound: boolean;
    FProcessArea, FKeptArea: TAreaElement;
    function GetOutString: string;
    function GetLHC: string;
    function GetODD: string;
    function GetDIL: string;
    function GetPOR: string;
    function GetPSK: string;
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    function  QProcessAfter(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    procedure PrepareOutPut; override;
  public
    procedure DoIt; override;
    destructor Destroy; override;
  published
    property X: double read FX write FX;
    property Y: double read FY write FY;
    property OutString: string read GetOutString;
    property LHC: string read GetLHC;
    property ODD: string read GetODD;
    property DIL: string read GetDIL;
    property POR: string read GetPOR;
    property PSk: string read GetPSk;
    property Found: boolean read FFound write FFound;
    property KeptArea: TAreaElement read FKeptArea;
  end;



  TPSKSelector = class(TObjectSelector)
  private
    FX, FY: double;
  protected
     function   GetCursor: TCursor; override;
   public
     FHele: THeleSkupina;
     StatusBar: TStatusBar;
     constructor Create; override;
     procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
     procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
     procedure ViewPSK;
  end;

implementation
uses
   SysUtils,
   Graphics,
   Dialogs,
// KERNEL
   E_Class,
   Worlds,
// MAIN
   u_Cursor,
   T_Main;



function THeleHier.GetLHC: string;
begin
  result:= '';
  if FLHC = nil then exit;
  result:= FLHC.Name
end;

procedure THeleHier.SetLHC(aVal: string);
begin
  FLHC:= nil;
  if not (input is TEntity) then exit;
  FLHC:= TRectEntity(TEntity(input).FindElementName(aVal));
end;

function THeleHier.GetOdd: string;
begin
  result:= '';
  if FOdd = nil then exit;
  result:= FOdd.Name
end;

procedure THeleHier.SetOdd(aVal: string);
begin
  FOdd:= nil;
  if FLHC = nil then exit;
  FOdd:= TRectEntity(FLHC.FindElementName(aVal));
end;

function THeleHier.GetDil: string;
begin
  result:= '';
  if FDil = nil then exit;
  result:= FDil.Name
end;

procedure THeleHier.SetDil(aVal: string);
begin
  FDil:= nil;
  if FOdd = nil then exit;
  FDil:= TRectEntity(FOdd.FindElementName(aVal));
end;

function THeleHier.GetPor: string;
begin
  result:= '';
  if FPor = nil then exit;
  result:= FPor.Name
end;

procedure THeleHier.SetPor(aVal: string);
begin
  FPor:= nil;
  if FDil = nil then exit;
  FPor:= TRectEntity(FDil.FindElementName(aVal));
end;

function THeleHier.GetPSk: string;
begin
  result:= '';
  if FPSk = nil then exit;
  result:= FPSk.Name
end;

procedure THeleHier.SetPSk(aVal: string);
begin
  FPSk:= nil;
  if FPor = nil then exit;
  FPSk:= TRectEntity(FPor.FindElementName(aVal));
end;


procedure THeleHier.DoIt;
begin
  output:= nil;
  if FLHC <> nil then
     Output:= FLHC;
  if FOdd <> nil then
     Output:= FOdd;
  if FDil <> nil then
     Output:= FDil;
  if FPor <> nil then
     Output:= FPor;
  if FPSk <> nil then
     Output:= FPSk;
end;


                  { THeleSkupina }

function  THeleSkupina.QGoInside(Element: TElement): boolean;
begin
  result:= false;
  if FFound then exit;
  if not (Element is TEntity) then exit;
  if (Element is TEntity) and not (Element is TRectEntity) then
  begin
    result:= true;
    exit;
  end;

  if not TRectEntity(Element).Rect.IsValid then
  begin
    result:= true;
    exit;
  end;

  result:= (Element is TRectEntity) and not(Element is TAreaElement);
  if result then
  begin
    result:= TRectEntity(Element).PointIsInside(FX, FY);
  end;
end;


function  THeleSkupina.QProcessBefore(Element: TElement): boolean;
begin
  result:= not FFound and (Element is TAreaElement)
end;

function  THeleSkupina.QProcessAfter(Element: TElement): boolean;
begin
  result:= false;
end;

procedure THeleSkupina.PrepareOutPut;
begin
  Output:= nil
end;


destructor THeleSkupina.Destroy;
begin
  if FKeptArea <> nil then
     FKeptArea.Free;
  inherited Destroy
end;




procedure THeleSkupina.Process(Element: TElement);
var
  aAE, aArea: TAreaElement;
begin
  if not (Element is TAreaElement) then exit;
  aAE:= TAreaElement(Element);
  if not aAE.PointIsInside(FX, FY) then exit;

// Za elem eten asu se ppadn pevod z PolylineArea na Area
// provd ji zde a peveden FKeptArea se pamatuje. Originln plocha
// se pamatuje v FProcessArea

  if aAE = FProcessArea then
     aArea:= FKeptArea
  else
  begin
// Nejdve zjistm jestli peci jen nejsem pod v t pvodn
    if (FProcessArea <> nil) and (FKeptArea <> nil) then
    begin
      fFound:=  FKeptArea.XYIsInside(FX, FY);
      if FFound then
// Aha, i kdy jsem i v obdlnku jin plochy, zstvm pod uvnit t
// pvodn
      begin
        Output:= FProcessArea;
        exit
      end;

      FKeptArea.Free;
      FKeptArea:= nil;
      FProcessArea:= nil;
    end;


    if aAE is TPolylineAreaElement then
       aArea:= TPolylineAreaElement(aAE).CreateAreaElement
    else
       aArea:= aAE;
  end;

  FFound:=  aArea.XYIsInside(FX, FY);

  if FFound then
  begin
    FProcessArea:= aAE;
    FKeptArea:= aArea;
    Output:= aAE;
  end;
end;



procedure THeleSkupina.DoIt;
begin
  if Busy then
     exit;

  Busy:= true;

  inherited DoIt;

  if not FFound then
  begin
  FProcessArea:= nil;
  FKeptArea:= nil;
  Output:= nil;
  end;

  Busy:= false;
end;



function THeleSkupina.GetOutString: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('LHC') + ' ' +
           Output.GetPropertyStringByName('ODDELENI') +
           Output.GetPropertyStringByName('DILEC') +
           Output.GetPropertyStringByName('POROST') + ' ' +
           Output.GetPropertyStringByName('SKUPINA')
end;



function THeleSkupina.GetLHC: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('LHC');
end;

function THeleSkupina.GetODD: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('ODDELENI');
end;

function THeleSkupina.GetDIL: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('DILEC');
end;

function THeleSkupina.GetPOR: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('POROST');
end;

function THeleSkupina.GetPSK: string;
begin
  result:= '';
  if Output = nil then exit;
  result:= Output.GetPropertyStringByName('SKUPINA');
end;



                    { TPSKSelector }

constructor TPSKSelector.Create;
var
  aData, aHier: TEntity;
begin
  aData:= TEntity(World.ObjectModel.FindElementName('DATA'));
  if aData = nil then exit;
  aHier:= TEntity(aData.FindElementName('HIERARCHY'));
  if aHier = nil then exit;

  FHele:= THeleSkupina.Create;
  FHele.Input:= aHier;
  AddElement(FHele);
end;



function  TPSKSelector.GetCursor: TCursor;
begin
   result := cr_SelectArea;
end;



procedure   TPSkSelector.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Coord: TDoubleCoord;
begin
  Coord:= Device.Projection.GetModelPoint(aMessage.x, aMessage.y);

  if (FHele <> nil) and not FHele.Busy then
  begin
    FHele.X:= Coord.X;
    FHele.Y:= Coord.Y;
    FHele.Found:= false;
    FHele.DoIt;
    if FHele.Found then
    begin
      StatusBar.Panels[0].Text:= FHele.LHC;
      StatusBar.Panels[1].Text:= FHele.ODD;
      StatusBar.Panels[2].Text:= FHele.DIL;
      StatusBar.Panels[3].Text:= FHele.POR;
      StatusBar.Panels[4].Text:= FHele.PSK;
    end
    else
    begin
      StatusBar.Panels[0].Text:= '';
      StatusBar.Panels[1].Text:= '';
      StatusBar.Panels[2].Text:= '';
      StatusBar.Panels[3].Text:= '';
      StatusBar.Panels[4].Text:= '';
    end;
  end;

  inherited
end;



procedure TPSKSelector.ViewPSK;
   procedure KolmyKrizek(aX, aY: double; Pixlu: integer);
   var
     Vel: double;
   begin
     Vel:= Device.Projection.GetModelLength(Pixlu);
     Device.MoveTo(aX-Vel, aY);
     Device.LineTo(aX+Vel, aY);
     Device.MoveTo(aX, aY-Vel);
     Device.LineTo(aX, aY+Vel);
   end;


   procedure PricnyKrizek(aX, aY: double; Pixlu: integer);
   var
     Vel: double;
   begin
     Vel:= Device.Projection.GetModelLength(Pixlu);
     Device.MoveTo(aX-Vel, aY-Vel);
     Device.LineTo(aX+Vel, aY+Vel);
     Device.MoveTo(aX+Vel, aY-Vel);
     Device.LineTo(aX-Vel, aY+Vel);
   end;


   procedure VyznacBod;
   var
     I: longInt;
     aArea: TAreaElement;
   begin
     try
       aArea:= TAreaElement(FHele.Output);
       Device.Pen.Color:= clRed;
       PricnyKrizek(aArea.X, aArea.Y, 5);
       Device.Pen.Color:= clWhite;
       KolmyKrizek(aArea.X, aArea.Y, 5);
     except
     end
   end;

begin
  if FHele = nil then exit;
  if FHele.KeptArea = nil then exit;

  Device.Brush.Color:= clWhite;
  Device.Brush.Style:= bsBDiagonal;
  Device.Pen.Color:= clRed;
  Device.Pen.Style:= psClear;
  Device.PolyPolygon(FHele.KeptArea);
  Device.Brush.Color:= clBlack;
  Device.Brush.Style:= bsFDiagonal;
  Device.Pen.Color:= clRed;
  Device.Pen.Style:= psSolid;
  Device.PolyPolygon(FHele.KeptArea);
  VyznacBod;
end;




procedure TPSKSelector.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   X, Y: longInt;


begin
    Handled := true;

    if aMessage.Button = mbLeft then
    begin
      try
       if FHele = nil then exit;
       if not FHele.Found then exit;

       ViewPSK;

       if ShowProperties then InterpretIt(FHele.Output, aMessage.x, aMessage.y);
       Output := FHele.Output;
       if OnSelect <> nil then
       begin
          Onselect.Input := FHele.Output;
          OnSelect.NameParameter['FTM']:= TTools(Owners[0]).Owner;
          OnSelect.DoIt;
       end;

      except
        on E: Exception do
         ShowMessage('Hleda porostn skupiny: ' + E.Message);
      end;
    end
    else
      Handled:= false
end;







begin
  RegisterOrbisClass(THeleHier);
  RegisterOrbisClass(THeleSkupina);
  RegisterOrbisClass(TPSKSelector);
end.
