unit T_HelSel;

interface
uses
// KERNEL
   Elements,
   Tools,
// GLIB
   G_Elems,
// PROJEKTY
   TaxView_TLB
   ;

type
  THelePlocha = class(TTool)
  public
    constructor Create; override;
    procedure DoIt; override;
  end;



  THeleNacti = class(TTool)
  private
    FChyba: boolean;
    FDirectory: string;
    FModelScript: TEntity;
    FTemp: TRectEntity;
    FDetTemp: TEntity;

    function  GetDataModel: TEntity;
    function  DejDATAEntitu(aJm: string): TEntity;
    procedure PosliText(aText: string);

    procedure VytvorModelScript;
    procedure NactiData;
    procedure PrehodDoDataLayers;
    procedure NajdiAREDET;
    procedure VytvorHierarchii;

  public
    procedure DoIt; override;

  published
    property Directory: string read FDirectory write FDirectory;
    property DataModel: TEntity read GetDataModel;
  end;



implementation
uses
   SysUtils,
// KERNEL
   e_class,
   worlds,
// OIL
   T_AdvRcz,
// GLIB
   T_Grp,
// SPACE
   E_Space,
// GISLAYER
   T_LMCre,
   T_LayScr,
   T_BLKLay,
// MAIN
   T_Main,
// .
   U_HelStr;

constructor THelePlocha.Create;
begin
//  FAutoTax:= CoAutoTaxView.Create;
end;


procedure THelePlocha.DoIt;
var
  LHC, Odd, Dil, Por, PSk: string;
  aMT: TMainTool;
begin
  if not (input is TAreaElement) then exit;

  LHC:= input.GetPropertyStringByName('LHC');
  Odd:= input.GetPropertyStringByName('ODDELENI');
  DIL:= input.GetPropertyStringByName('DILEC');
  POR:= input.GetPropertyStringByName('POROST');
  PSK:= input.GetPropertyStringByName('SKUPINA');

  aMT:= TMainTool(World.MainTool);
  if aMT = nil then exit;

  if aMT.AutoTaxView = nil then exit;
  aMT.AutoTaxView.Odd:= strToInt(Odd);
  aMT.AutoTaxView.Dil:= Dil;
  aMT.AutoTaxView.Por:= Por;
  aMT.AutoTaxView.PSk:= DoplnMezeryDoPSk(PSk);
  aMT.AutoTaxView.Show
end;



        { THeleNacti }


function  THeleNacti.DejDATAEntitu(aJm: string): TEntity;
var
  aDATA: TElement;
begin
  result:= nil;
  aDATA:= World.ObjectModel.findElementName('DATA');
  if not (aDATA is TEntity) then exit;
  aData:= TEntity(aDATA).FindElementName(aJm);
  if not (aDATA is TEntity) then exit;
  result:= TEntity(aData)
end;



function  THeleNacti.GetDataModel: TEntity;
begin
  result:= TEntity(World.ObjectModel.findElementName('DATAMODEL'))
end;

procedure THeleNacti.VytvorModelScript;
var
  aDataModel: TEntity;
  aMSC: TModelScriptCreator;
begin
  FChyba:= true;
  aDataModel:= TEntity(World.ObjectModel.FindElementName('DATAMODEL'));
  if aDataModel = nil then exit;

  aMSC:= TModelScriptCreator.Create;
  aMSC.input:= aDataModel;
  aMSC.DataDirectory:= Directory;
  aMSC.DoIt;
  FModelScript:= TEntity(aMSC.Output);
  AddElement(FModelScript);
  aMSC.Free;
  FChyba:= false;
end;


procedure THeleNacti.NactiData;
var
  aMBSC: TModelByScriptCreator;
begin
  FChyba:= true;

  if FModelScript = nil then exit;
  if FTemp <> nil then
     FTemp.FreeAll
  else
  begin
     FTemp:= TRectEntity.Create;
     AddElement(FTemp);
  end;
  if FTemp = nil then exit;

  aMBSC:= TModelByScriptCreator.Create;
  aMBSC.Input:= FModelScript;
  aMBSC.Output:= FTemp;
  aMBSC.DoIt;
  aMBSC.Free;

  FChyba:= false;
end;

procedure THeleNacti.PrehodDoDataLayers;
var
  aLayers: TEntity;
  aBLT: TBlockLayersTool;
begin
  FChyba:= true;
  if FTemp = nil then exit;
  if FTemp.Count = 0 then exit;
  aLayers:= DejDataEntitu('LAYERS');
  if aLayers = nil then exit;
  aBLT:= TBlockLayersTool.Create;
  aBLT.Input:= FTemp;
  aBLT.Output:= aLayers;
  aBLT.DoIt;
  aBLT.Free;
  FChyba:= false;
end;


procedure THeleNacti.NajdiAREDET;
var
  aFBL: TFindBlockLayer;
begin
  FChyba:= true;
  if FTemp = nil then exit;
  if FTemp.Count = 0 then exit;
  if FDETTEMP = nil then
  begin
    FDETTEMP:= TEntity.Create;
    AddElement(FDETTEMP);
  end
  else
    FDETTEMP.FreeAll;
  aFBL:= TFindBlockLayer.Create;
  aFBL.Input:= FTemp;
  aFBL.Output:= FDETTEMP;
  aFBL.LayerName:= 'DET';
  aFBL.LayerType:= 'ARE';
  aFBL.DoIt;
  aFBL.Free;

  if FDetTemp.Count = 0 then exit;

  FChyba:= false;

  FDetTemp:= TEntity(FDetTemp.FindElementClass(TAreaString));
  if FDetTemp <> nil then exit;
  FDetTemp:= TEntity(FDetTemp.FindElementClass(TAreaString));
  if FDetTemp <> nil then exit;
  FDetTemp:= TEntity(FDetTemp.FindElementClass(TAreaString));
  if FDetTemp <> nil then exit;

  FChyba:= true;
end;



procedure THeleNacti.VytvorHierarchii;
var
   EE: TEntity;
   GR: TGroupper;
   Krit: TPropsAndClass;
   I: longInt;
   aHier: TEntity;
   aMax, Delta, aCount: longInt;
begin
  FChyba:= true;
  if not(FDETTEMP is TAreaString) then exit;
  if FDetTemp.Count = 0 then exit;

  aHier:= DejDataEntitu('HIERARCHY');
  if not (aHier is TRectEntity) then exit;
  EE := TEntity.Create;
  //vytvoen kritria pro tvorbu skupin dle katastru
  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'LHC';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'ODDELENI';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'DILEC';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'POROST';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'SKUPINA';
  KRIT.OwnerClassName:= 'TAREASTRING';
  EE.NextElement := Krit;

  //Vytvoen grupovacho nstroje
  GR := TGroupper.Create;
  GR.Criterion := EE;
  GR.OwnerClass := 'TRectEntity';
  //GR.NextAssigment='BlockDir=BlockDir'
  GR.DoItEmpty := false;
  GR.Output:= aHier;

  aMax:= FDetTemp.Count-1;
  TMainTool(World.MainTool).MinProgress:= 0;
  TMainTool(World.MainTool).MaxProgress:= aMax;
  TMainTool(World.MainTool).Progress:= 0;
  Delta:= aMax div 20;
  aCount:= 0;

  for I:= 0 to aMax do
  begin
    GR.Input:= FDetTemp.Elements[I];
    GR.DoIt;
    if I > aCount then
    begin
      TMainTool(World.MainTool).Progress:= I;
      inc(aCount, Delta)
    end;
  end;

  GR.Free;
  FChyba:= false;
end;


procedure THeleNacti.PosliText(aText: string);
begin
  TMainTool(World.MainTool).Text:= aText;
end;



procedure THeleNacti.DoIt;
var
  aTMP: TElement;
begin
  Busy:= true;
  PosliText('Vytven popisu modelu ...');
  TMainTool(World.MainTool).ProgressVisible:= true;
  TMainTool(World.MainTool).MinProgress:= 0;
  TMainTool(World.MainTool).MaxProgress:= 10;
  VytvorModelScript;
  if FChyba then
  begin
    PosliText('Chyba vytven popisu modelu ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;
  TMainTool(World.MainTool).Progress:= 1;

  PosliText('Natn dat ...');
  NactiData;
  if FChyba then
  begin
    PosliText('Chyba natn dat ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;
  TMainTool(World.MainTool).Progress:= 2;

  PosliText('Pemisovn vrstev ...');
  PrehodDoDataLayers;
  if FChyba then
  begin
    PosliText('Chyba pemisovn vrstev ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;
  TMainTool(World.MainTool).Progress:= 3;

  PosliText('Vyjmut vrstvy ploch z DET ...');
  NajdiAREDET;
  if FChyba then
  begin
    PosliText('Chyba vyjmn vrstvy ploch z DET ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;
  TMainTool(World.MainTool).Progress:= 4;

  PosliText('Vytven hierarchie z natench dat ...');
  VytvorHierarchii;
  if FChyba then
  begin
    PosliText('Chyba vytven hierarchie ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;

  PosliText('Naten dat do hierarchie v podku');
  TMainTool(World.MainTool).ProgressVisible:= false;
  Busy:= false;
end;



BEGIN
   RegisterOrbisClass(THeleNacti);
end.
