unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  t_HelW,
  t_MainTl,
  t_CmdLn,
// DEVICE
  d_txt,
// .
  TaxView_TLB;


const
  DefIniFileName = 'Revizor.INI';
  c_NewWindow = 'NEWWINDOW';
  c_CloseApplication = 'CLOSEAPPLICATION';
  c_Script = 'SCRIPT';
  c_BEGIN = 'BEGIN';
  c_END = 'END';


type

TOptions = class(TBaseOptions)
private
  FDelRAS: TStringListElement;
  FDeleteRAS: boolean;
  {Scripts}
  FStartScript: string;
  FDataSetScript: string;
  FControlSetScript: string;
  FRunScript: string;
  FEndScript: string;
  {Files}
  FINE: string;
  FPaletFile: string;
  {Directories}
  FWorkingDirectory: String;
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FFullUseMemory: boolean;
  function  GetDelRAS: TStringListElement;
  procedure SetServiceDirectory(const aValue: string);
public
  property   DelRAS: TStringListElement read GetDelRAS;
published
//  property   DeleteRAS: boolean read FDeleteRas write FDeleteRAS;
  property   StartScript: string read FStartScript write FStartScript;
//  property   DataSetScript: string read FDataSetScript write FDataSetScript;
//  property   ControlSetScript: string read FControlSetScript write FControlSetScript;
//  property   RunScript: string read FRunScript write FRunScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   WorkingDirectory: string read FWorkingDirectory write FWorkingDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
//  property   INE: string read FINE write FINE;
//  property   PaletFile: string read FPaletFile write FPaletFile;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FLHC: string;
  FODDELENI: string;
  FDILEC: string;
  FPOROST: string;
  FSKUPINA: string;
  FWindowName: string;
  FActualMap: TRectEntity;
  FAutoTaxView: IAutoTaxView;
  FProtocol: TMemoFormDevice;
  function  GetOptions: TBaseOptions; override;
  function  GetNOptions: TOptions; virtual;
  procedure SetOptions(aValue: TBaseOptions); override;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetSourceModel: TOwnerEntity;
  procedure SetSourceModel(aValue: TOwnerEntity);
  function  GetMaps: TOwnerEntity;
  function  GetData: TOwnerEntity;
  function  GetExePath: string;
protected
  function  GetWorkingDirectory: string; override;
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
  procedure SetLHC(aValue: string);
  procedure SetODDELENI(aValue: string);
  procedure SetDILEC(aValue: string);
  procedure SetPOROST(aValue: string);
  procedure SetSKUPINA(aValue: string);
  function  GetMapName: string;
  procedure SetMapName(aValue: string);
  function  GetBaseWindow: TLesWindow;
  function  GetActualMap: TRectEntity;
  procedure SetActualMap(aValue: TRectEntity);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  on_tm_DataSet(var Handled: boolean); virtual;
   procedure  on_tm_ControlSet(var Handled: boolean); virtual;
   procedure  on_tm_Run(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_EndOfPrint(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_NewLHC; virtual;
   procedure  on_tm_ShowLHC; virtual;
   procedure  on_tm_Map; virtual;
   procedure  on_tm_AddToProtocol(aMessage: TOrbisMessage); virtual;
   procedure  on_tm_Done(aMessage: TOrbisMessage); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;
   procedure  ShowTheForest;
   procedure  NewLHC;
   procedure  ConnectTaxView;
   procedure  DisConnectTaxView;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   SourceModel: TOwnerEntity read GetSourceModel write SetSourceModel;
   property   Maps: TOwnerEntity read GetMaps;
   property   Data: TOwnerEntity read GetData;
   property   ExePath: string read GetExePath;
   property   Protocol: TMemoFormDevice read FProtocol write FProtocol;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   BaseWindow: TLesWindow read GetBaseWindow;
   property   ActualMap: TRectEntity read GetActualMap write SetActualMap;

   property   LHC: string read FLHC write SetLHC;
   property   ODDELENI: string read FODDELENI write SetODDELENI;
   property   DILEC: string read FDILEC write SetDILEC;
   property   POROST: string read FPOROST write SetPOROST;
   property   SKUPINA: string read FSKUPINA write SetSKUPINA;
   property   WindowName: string read FWindowName write FWindowName;
   property   MapName: string read GetMapName write SetMapName;
   property   AutoTaxView: IAutoTaxView read FAutoTaxView write FAutoTaxView;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  _IniFile,
  M_Orbis,
  M_Proj,
  f_SelDir,
  e_DClass,
  e_IScrpt,
  e_TplPrp,
  e_Reg,
  f_YesNo,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  t_Grp,
  T_Explor,
  T_EdiPro,
  t_HelSel,
  t_HelHie,
  t_Select,
  t_Loader,
  t_Saver,
  t_Intera,
  u_String,
  E_Files,
  Worlds,
// MAIN
  F_Main,
  f_Option,
  F_Start,
// .
  U_HelStr;

{TOptions}

function  TOptions.GetDelRAS: TStringListElement;
begin
   if FDelRas = nil then
   begin
      FdelRas := TStringListElement.Create;
      AddElement(FDelRas);
   end;
   result := FDelRas;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
end;


{TMainTool}


procedure TMainTool.SetLHC(aValue: string);
var
   FM: TFileModel;
   i: integer;
begin
   if aValue = FLHC then exit;
   FM := TFileModel(SourceModel.FindElementName(aValue));
   if FM= nil then
   begin
      // pidn novho LHC
      exit;
   end;
   FLHC := aValue;
   if MainForm.ed_LHC.Items.IndexOf(FLHC) < 0 then
      MainForm.ed_LHC.Items.Add(FLHC);
   MainForm.ed_LHC.Text := FLHC;
   MainForm.ed_Oddeleni.Items.Clear;
   for i := 0 to FM.LastIndex do
   begin
      MainForm.ed_Oddeleni.Items.Add(FM.Elements[i].Name);
   end;
   FODDELENI := '';
   ODDELENI := FM.Elements[0].Name;
end;

procedure TMainTool.SetODDELENI(aValue: string);
var
   E: TEntity;
   i: integer;
begin
   if aValue = FODDELENI then exit;
   MainForm.ed_Dilec.Items.Clear;
   MainForm.ed_Porost.Items.Clear;
   MainForm.ed_Skupina.Items.Clear;
   if (aValue <> '') and (MainForm.ed_ODDELENI.Items.IndexOf(aValue) < 0)then
   begin
      // Oddlen neexistuje
      FODDELENI := '';
      MainForm.ed_ODDELENI.Text := '';
      DILEC := '';
      POROST := '';
      SKUPINA := '';
      exit;
   end;
   FODDELENI := aValue;
   MainForm.ed_ODDELENI.Text := aValue;
   if aValue <> '' then
   begin
      E := TEntity(SourceModel.FindElementName(LHC));
      if E = nil then exit;
      E := TEntity(E.FindElementName(FODDELENI));
      if E = nil then exit;
      for i := 0 to E.LastIndex do
      begin
         MainForm.ed_Dilec.Items.Add(E.Elements[i].Name);
      end;
   end;
   DILEC := '';
   POROST := '';
   SKUPINA := '';
end;

procedure TMainTool.SetDILEC(aValue: string);
var
   E: TEntity;
   i: integer;
begin
   if aValue = FDILEC then exit;
   MainForm.ed_Porost.Items.Clear;
   MainForm.ed_Skupina.Items.Clear;
   if MainForm.ed_Dilec.Items.IndexOf(aValue) < 0 then
   begin
      FDILEC := '';
      MainForm.ed_Dilec.Text := '';
      // Oddlen neexistuje
      POROST := '';
      SKUPINA := '';
      exit;
   end;
   FDILEC := aValue;
   MainForm.ed_DILEC.Text := aValue;
   E := TEntity(SourceModel.FindElementName(LHC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(ODDELENI));
   if E = nil then exit;
   E := TEntity(E.FindElementName(FDILEC));
   if E = nil then exit;
   for i := 0 to E.LastIndex do
   begin
      MainForm.ed_Porost.Items.Add(E.Elements[i].Name);
   end;
   POROST := '';
   SKUPINA := '';
end;

procedure TMainTool.SetPOROST(aValue: string);
var
   E: TEntity;
   i: integer;
begin
   if aValue = FPOROST then exit;
   MainForm.ed_Skupina.Items.Clear;
   if MainForm.ed_Porost.Items.IndexOf(aValue) < 0 then
   begin
      FPOROST := '';
      MainForm.ed_Porost.Text := '';
      // Oddlen neexistuje
      SKUPINA := '';
      exit;
   end;
   FPOROST := aValue;
   MainForm.ed_Porost.Text := aValue;
   E := TEntity(SourceModel.FindElementName(LHC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(ODDELENI));
   if E = nil then exit;
   E := TEntity(E.FindElementName(DILEC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(FPOROST));
   if E = nil then exit;
   for i := 0 to E.LastIndex do
   begin
      MainForm.ed_Skupina.Items.Add(BezMezer(E.Elements[i].Name));
   end;
   SKUPINA := '';
end;

procedure TMainTool.SetSKUPINA(aValue: string);
var
   i: integer;
begin
   if aValue = FSKUPINA then exit;
   if MainForm.ed_Skupina.Items.IndexOf(aValue) < 0 then
   begin
      FSKUPINA := '';
      MainForm.ed_Skupina.Text := '';
      // Oddlen neexistuje
      exit;
   end;
   FSKUPINA := aValue;
   MainForm.ed_Skupina.Text := aValue;
end;

function  TMainTool.GetMapName: string;
begin
   result := ActualMap.Name;
end;

procedure TMainTool.SetMapName(aValue: string);
var
   E: TRectEntity;
begin
   if MainForm.MapList.Visible = true then
   begin
      MainForm.MapList.Visible := false;
      MainForm.Height := MainForm.Height - MainForm.MapList.Height;
   end;
   E := TRectEntity(Maps.Element[aValue]);
   if E = nil then
   begin
      Text := 'Zvolen mapa neexistuje !';
      exit;
   end;
   ActualMap := E;
end;


function  TMainTool.GetBaseWindow: TLesWindow;
var
   RE: TRectEntity;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
   S: string;
begin
   S := 'BASEWINDOW';
   result := TLesWindow(Tools.FindElementName(S));
   if result = nil then
   begin
      result := TLesWindow.Create;
      result.Name := S;
      TIS := TUniversalTopolScriptCreator.Create;
      TIS.DoIt;
      ISC := TInterpretScript(TIS.Output);
      result.InterpretScript := ISC;
      TIS.Free;
      AddTool(result);
   end;
end;


function  TMainTool.GetActualMap: TRectEntity;
var
  aName: string;
begin
  result:= nil;
  if FActualMap = nil then exit;
  aName:= FActualMap.ClassName;
  FActualMap.ResetAndUpdate;
  result := FActualMap;
end;

procedure TMainTool.SetActualMap(aValue: TRectEntity);
var
   i: integer;
begin
   if aValue = nil then
   begin
      aValue := TRectEntity(Maps.Element['Obrysov mapa']);
   end;
   FActualMap := aValue;
   i := Maps.IndexOf(FActualMap);
   MainForm.MapPictures.GetBitmap(i,MainForm.MapPicture.Picture.Bitmap);
   MainForm.MapPicture.Refresh;
   MainForm.l_Mapa.Caption := FActualMap.Name;
end;

function  TMainTool.GetSourceModel: TOwnerEntity;
var
   S: string;
begin
   S := 'SOURCE';
   result := TOwnerEntity(World.ObjectModel.FindElementName(S));
   if result = nil then
   begin
      result := TOwnerEntity.Create;
      result.Name := S;
      World.ObjectModel.AddElement(result);
   end;
end;

procedure TMainTool.SetSourceModel(aValue: TOwnerEntity);
var
   S: string;
   E: TElement;
begin
   S := 'SOURCE';
   if aValue = nil then exit;
   if not(TElement(aValue) is TOwnerEntity) then exit;
   aValue.Name := S;
   E := World.ObjectModel.FindElementName(S);
   if E <> nil then World.FreeElement(E);
   World.ObjectModel.AddElement(aValue);
end;

function  TMainTool.GetMaps: TOwnerEntity;
var
   S: string;
begin
   S := 'THEMATIC';
   result := TOwnerEntity(Data.FindElementName(S));
   if result = nil then
   begin
      result := TOwnerEntity.Create;
      result.Name := S;
      World.ObjectModel.AddElement(result);
   end;
end;

function  TMainTool.GetData: TOwnerEntity;
var
   S: string;
begin
   S := 'DATA';
   result := TOwnerEntity(World.ObjectModel.FindElementName(S));
   if result = nil then
   begin
      result := TOwnerEntity.Create;
      result.Name := S;
      World.ObjectModel.AddElement(result);
   end;
end;

function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   MainForm.ProgressBar.Visible := aValue;
end;



procedure TMainTool.ShowTheForest;
var
   FM: TFileModel;
   E,EE: TEntity;
   RE: TRectEntity;
   TH: THeleNacti;
   THH: THeleHier;
   aWindow: TLesWindow;
   R: TDoubleRect;
begin
   FM := TFileModel(SourceModel.FindElementName(LHC));
   if FM = nil then exit; {!!!!!!!!!!!!!!}
   FM := TFileModel(FM.FindElementName(ODDELENI));
   if FM = nil then exit; {!!!!!!!!!!!!!!}
   E := TEntity(World.ObjectModel.FindElementClass(TRegister));
   if E <> nil then E := TEntity(E.FindElementName(FM.FileName));
   if E = nil then
   begin
      TH := THeleNacti.Create;
      TH.Directory := FM.Path;
      TH.DoIt;
      TH.Free;
   end;

   E := TEntity(World.ObjectModel.FindElementName('DATA'));
   if E = nil then exit; {!!!!!!!!!!!!}
   EE := TEntity(E.FindElementName('HIERARCHY'));
   if EE = nil then exit; {!!!!!!!!!!!!}

   THH := THeleHier.Create;
   THH.Input := EE;
   THH.LHC := LHC;
   THH.ODD := ODDELENI;
   THH.DIL := DILEC;
   THH.POR := POROST;
   THH.PSK := SKUPINA;
   THH.DoIt;
   RE := TrectEntity(THH.Output);
   if RE = nil then exit;

   R.Minx := RE.Minx;
   R.Maxx := RE.Maxx;
   R.Miny := RE.Miny;
   R.Maxy := RE.Maxy;


   aWindow := BaseWindow;
   aWindow.Input := ActualMap;
   aWindow.Caption := MapName + ' '+ LHC+' '+ODDELENI+' '+DILEC+' '+POROST+' '+SKUPINA;
   aWindow.PageColor := clSilver;
   aWindow.Projection.ModelView := R;
   aWindow.DoIt;
end;

constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
  CommandLine.FileName:= aFileName;
  CommandLine.DoIt
end;


function  TMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   S := Options.WorkingDirectory;
   result := CheckBackSlash(S);
end;



procedure TMainTool.DoIt;
var
  OIL: string;
  S,SS: string;
begin
  inherited DoIt;
  //Application.HelpFile := ChangeFileExt(ParamStr(0),'.HLP');
  {
  if not Application.HelpJump('Obsah') then
     ShowMessage('Soubor npovdy neexistuje');
  }
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ExtractFilePath(ParamStr(0));
  CheckBackSlash(S);
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  MapName := 'Obrysov mapa'
end;





procedure TMainTool.ReadParamsFromIni;
var
   Load: TLoad;
   S: string;
begin
   inherited ReadParamsFromIni;
   PostMsg(tm_OpenProject,Self,nil,DontKill);
   {
   NactiBarvickuZeSouboru(Options.PaletFile);
   }
   {
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      SourceModel := TOwnerEntity(Load.Output);
      Load.Free;
   end;
   }
end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
var
   Save: TSave;
begin
   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := SourceModel;
   Save.DoIt;
   Save.Free;
end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
begin
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Work.Text := Options.WorkingDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Data.Text := Options.DataDirectory;
   if D.ShowModal = mrOk then
   begin
      Options.WorkingDirectory := D.ed_Work.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      Options.DataDirectory := D.ed_Data.Text;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
        try
           (*
           if Options.DeleteRAS then
           for i := 0 to Options.DelRas.Count - 1 do
           begin
              SysUtils.DeleteFile(Options.DelRas.Strings[i]);
           end;
           *)
           {
           PostAppMessage(Project.MainHandle, TProjectWorld(World).WM_MODUL_END, 0, 0)
           }
        except
        end;
        Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
begin
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
var
   Load: TLoad;
   S: string;
   i: integer;
   Sm: TOwnerEntity;
begin
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      SM := TOwnerEntity(Load.Output);
      SourceModel := SM;
      Load.Free;
      for i := 0 to SM.LastIndex do
      begin
         MainForm.ed_LHC.Items.Add(SM.Elements[i].Name);
      end;
   end;
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;   
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;   
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;

procedure  TMainTool.on_tm_DataSet(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.DataSetScript;
*)
end;

procedure  TMainTool.on_tm_ControlSet(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.ControlSetScript;
*)
end;

procedure  TMainTool.on_tm_Run(var Handled: boolean);
begin
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
end;



procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.Panels.Items[0].Text := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
//  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfPrint(var Handled: boolean);
begin
   {
   if CancelProcess then
   begin
      MainForm.Dioda.Color := clBtnFace;
      MainForm.Dioda.Enabled := false;
   end;
   if Automat.Busy then Automat.ProcessMap := false;
   }
end;


procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      tm_DataSet:     on_tm_DataSet(Handled);
      tm_ControlSet:  on_tm_ControlSet(Handled);
      tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);


     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);

      tm_EndOfPrint       : on_tm_EndOfPrint(Handled);
      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : on_tm_ShowText(aMessage, Handled);
      tm_NewLHC           : on_tm_NewLHC;
      tm_ShowLHC          : on_tm_ShowLHC;
      tm_Map              : on_tm_Map;
      tm_AddToProtocol    : on_tm_AddToProtocol(aMessage);
      tm_Done             : on_tm_Done(aMessage);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
end;


function  TMainTool.GetText: string;
begin
   result := MainForm.StatusBar.Panels.Items[0].Text;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.Panels.Items[0].Text := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;

procedure  TMainTool.on_tm_NewLHC;
begin
   NewLHC;
end;

procedure  TMainTool.on_tm_ShowLHC;
begin
   ShowTheForest;
end;

procedure  TMainTool.on_tm_Map;
begin
   if MainForm.MapList.Visible = true then exit;
   MainForm.Height := MainForm.Height + MainForm.MapList.Height;
   MainForm.MapList.Visible := true;
end;

procedure  TMainTool.on_tm_AddToProtocol(aMessage: TOrbisMessage);
var
   S: string;
begin
   if Protocol = nil then FProtocol := TMemoFormDevice.Create;
   S := TOrbisTextMessage(aMessage).Text;
   if S = '' then exit;
   if S[Length(S)]=#13 then Protocol.WriteLnText(TOrbisTextMessage(aMessage).Text)
                       else Protocol.WriteText(TOrbisTextMessage(aMessage).Text);
end;

procedure  TMainTool.on_tm_Done(aMessage: TOrbisMessage);
begin
   if aMessage.Sender is TMemoFormDevice then Protocol := nil;
end;


procedure  TMainTool.NewLHC;
var
   SD: TSelectDirDialog;
   DE,DDE: TDirectoryElement;
   S: TAllSelector;
   LHCS,SS,SSS: string;
   i,j,k, deltaK: integer;
   TMP: TOwnerEntity;
   EE: TEntity;
   Dety,DBH: TOwnerEntity;
   DC: TDatabaseClass;
   FM,FM1,FM2,FMLHC: TFileModel;
   GR: TGroupper;
   Krit: TPropsAndClass;
   Source: TOwnerEntity;
   SL: TStringList;
begin
   FMLHC := nil;
   LHC := '';
   ProgressVisible := true;
   MinProgress := 0;
   MaxProgress := 10;
   Text := 'Vbr sloky LHC';
   SD :=TSelectDirDialog.Create;
   SD.DoIt;
   if SD.Directory = '' then
   begin
      SD.Free;
      ProgressVisible := false;
      Text := 'Nebyl vybrn dn adres, akce ukonena';
      exit;
   end;
   Progress := 2;
   Text := 'Probh natn vybran sloky ... ';
   TMP := TOwnerEntity(World.ObjectModel.FindElementName('TMP'));
   if TMP = nil then
   begin
      TMP := TOwnerEntity.Create;
      TMP.Name := 'TMP';
      World.ObjectModel.AddElement(TMP);
   end;

   Progress := 4;
   DE := TDirectoryElement.Create;
   TMP.AddElement(DE);
   LHCS := SD.Directory;
   DE.FileName := SD.Directory;
   SD.Free;
   Text := 'Probh vbr blok DET';
   Progress := 5;
   S := TAllSelector.Create;
   AddTool(S);
   S.Condition :='Name=''DET.BLK''';
   S.Input := DE;
   S.DoIt;
   S.Output.Name := 'Dety';
   TMP.NextElement := S.Output;
   Dety := TOwnerEntity(S.Output);
   S.Free;
   Text := 'Probh vbr DBF tabulek ...';
   DBH := TOwnerEntity.Create;
   DBH.Name := 'DBH';
   TMP.AddElement(DBH);
   Progress := 0;

   MinProgress := 0;
   MaxProgress := Dety.LastIndex;

   for i := 0 to Dety.LastIndex do
   begin
      Progress := i;
      if not (Dety.Elements[i] is TDirectoryElement) then Continue;
      DDE := TDirectoryElement(Dety.Elements[i]);
      DC := TDatabaseClass.Create;
      DC.Name := 'P0110_DBF';
      DC.DataSourceType := dstTable;
      DC.DataSourcePath := DDE.FileName;
      DC.DataSource := 'p0110.dbf';
      DC.AdressField := 'CISLO';
      DC.NameField := 'CISLO';
      EE := TOwnerEntity.Create;
      EE.Name := DDE.FilePath;
      DBH.NextElement := EE;
      FM := TFileModel.Create;
      FM.Name := DDE.FilePath;
      FM.FileName := DDE.FileName;
      EE.NextElement := FM;
      EE.NextElement := DC;
      Text := 'Vybrm tabulku ' + DDE.FileName;
   end;
   TMP.FreeElement(DE);
   TMP.FreeElement(Dety);
   Text := 'Vbr tabulek ukonen';
   // sestavovn vbru do ENT


   EE := TEntity.Create;
   //vytvoen kritria pro tvorbu skupin dle katastru
   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'LHC';
   KRIT.OwnerClassName := 'TFileModel';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'ODDELENI';
   KRIT.OwnerClassName := 'TFileModel';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'DILEC';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'POROST';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'SKUPINA';
   EE.NextElement := Krit;

   //Vytvoen grupovacho nstroje
   GR := TGroupper.Create;
   GR.Criterion := EE;
   GR.OwnerClass := 'TOwnerEntity';
   //GR.NextAssigment='BlockDir=BlockDir'
   GR.DoItEmpty := true;
   SS := '/' + IntToStr(DBH.Count)+')';
   Source := SourceModel;
   SL := TStringList.Create;
   Progress := 0;
   SSS := '';
   for i := 0 to DBH.LastIndex do
   begin
      EE := TEntity(DBH.Elements[i]);
      DC := TDatabaseClass(EE.FindElementClass(TDatabaseClass));
      if DC = nil then continue;
      if DC.Count = 0 then Continue;
      FM := TFileModel(EE.FindElementClass(TFileModel));
      Text := 'Analza ' +  FM.Path + ' (' + IntToStr(i+1) + SS;
      GR.Output := FM;
      k := DC.Count - 1;
      MinProgress := 0;
      MaxProgress := k;
      Progress := 0;
      DeltaK := 0;
      for j := 0 to k do
      begin
         GR.Input := DC.Elements[j];
         GR.DoIt;
         Inc(DeltaK);
         if DeltaK >= (k div 20) then
         begin
            MainForm.ProgressBar.Position := j;
            DeltaK := 0;
         end;
      end;
      // zaazen do SOURCE
      FM1 := TFileModel(FM.FindElementClass(TFileModel));
      FMLHC := TFileModel(Source.FindElementName(FM1.Name));
      if FMLHC = nil then
      begin
         FMLHC := FM1;
         Source.AddElement(FMLHC);
         FMLHC.FileName := LHCS;
         j := SL.Add(FMLHC.Name);
         SL.Objects[j] := FMLHC;
         SSS := SSS + FMLHC.Name + ';';
         MainForm.ed_LHC.Items.Add(FMLHC.Name);
      end
      else
      begin
         j := SL.IndexOf(FMLHC.Name);
         if j < 0 then
         begin
            if YesNoDialog('LHC slo '+ FMLHC.Name + ' je ji zmapovno. Pejete si jej skuten nast znovu ?') then
            begin
               Source.FreeElement(FMLHC);
               FMLHC := FM1;
               Source.AddElement(FMLHC);
               FMLHC.FileName := LHCS;
               J := SL.Add(FMLHC.Name);
               SL.Objects[j] := FMLHC;
               SSS := SSS + FMLHC.Name + ';';
            end
            else SL.Add(FMLHC.Name); // Objects je nil ... bude peskakovno
         end
         else
         begin
            if SL.Objects[j]= nil then continue;
         end;
      end;
      for j := 0 to FM1.LastIndex do
      begin
         TFileModel(FM1.Elements[j]).FileName := FM.FileName;
         if i > 0 then FMLHC.AddElement(FM1.Elements[j]);
      end;
   end;
   SL.Free;
   MinProgress := 0;
   MaxProgress := 0;
   Progress := 0;
   ProgressVisible := false;
   if SSS = '' then Text := 'Analza LHC skonena, nepidno dn nov LHC'
               else Text := 'Analza LHC skonena, pidno LHC '+ SSS;
   if FMLHC <> nil then
      LHC := FMLHC.Name;
   TMP.FreeElement(DBH);
end;


procedure  TMainTool.ConnectTaxView;
begin
try
  if FAutoTaxView = nil then
     FAutoTaxView:= CoAutoTaxView.Create;
finally
  MainForm.cbConnect.Checked:= FAutoTaxView <> nil
end;
end;


procedure  TMainTool.DisConnectTaxView;
begin
  if FAutoTaxView <> nil then
     FAutoTaxView:= nil
end;


END.
