unit t_HelW;

interface
uses
// KERNEL
   Elements,
   m_InterA,
   t_InterA,
// ..
   T_HelHie,
   f_STD1;

type

TLesWindow = class(TFormToolManager)
 protected
   procedure   CreateForm; override;
   procedure   CreateTools; override;
   function    GetLesForm: TLesForm;
 public
   procedure   On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   on_tm_Viewer(var Handled: boolean);
   procedure   on_tm_AreaSelector(var Handled: boolean);
   procedure   HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
published
   property    LesForm: TLesForm read GetLesForm;
end;



implementation

uses
   Forms,
// KERNEL
   Worlds,
// GLIB
   g_Elems,

   m_Proj,
// .
   T_HelSel;



{ TLesWindow }

procedure   TLesWindow.CreateForm;
var
  aData, aHier: TEntity;
begin
   Application.CreateForm(TLesForm, FForm);
   Form.Tool := Self;
   Form.IsPossibleToClose := false;

   aData:= TEntity(World.ObjectModel.FindElementName('DATA'));
   if aData = nil then exit;
   aHier:= TEntity(aData.FindElementName('HIERARCHY'));
   if aHier = nil then exit;
end;



procedure   TLesWindow.CreateTools;
var
   T: TInteractiveTool;
   aHele: THelePlocha;
begin
{$IFNDEF NOTIS}
   {
   NextTool := TSMO_10_Selector.Create;
   NextTool := TSMO_5_Selector.Create;
   }
   (*
   T := TPointSelector.Create;
   T.Name := 'Vybrn bod';
   NextTool := T;
   T := TLineSelector.Create;
   T.Name := 'Vybrn lini';
   NextTool := T;
*)


   T := TPSkSelector.Create;
   T.Name := 'Vybrn porostn skupiny';
   TPSkSelector(T).StatusBar:= LesForm.StatusBar;
   NextTool := T;
   aHele:= THelePlocha.Create;
   TPSkSelector(T).OnSelect:= aHele;
   AddElement(aHele);

(*
   T := TPointCollector.Create;
   T.Name := 'Snmn bod';
   NextTool := T;
   *)
{$ENDIF}
   NextTool := TViewer.Create;
end;

function    TLesWindow.GetLesForm: TLesForm;
begin
   result := TLesForm(Form);
end;

procedure   TLesWindow.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
  inherited
end;



procedure   TLesWindow.on_tm_Viewer(var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TViewer').OnClick(nil);
   except
   end;
end;

procedure   TLesWindow.on_tm_AreaSelector(var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TPSkSelector').OnClick(nil);
   except
   end;
end;


procedure   TLesWindow.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   inherited;
   case aMessage.Message of
      tm_Viewer:        on_tm_Viewer(Handled);
      tm_AreaSelector:  on_tm_AreaSelector(Handled);
   end;
end;

end.
