unit F_Info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, Buttons;

type
  TForm1 = class(TForm)
    Image1: TImage;
    l_www: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    FileVersion: TLabel;
    FileDescription: TLabel;
    Company: TLabel;
    Copyright: TLabel;
    Label2: TLabel;
    Bevel: TBevel;
    l_Close: TLabel;
    FileName: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    procedure l_wwwClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
      procedure CreateParams(var Params: TCreateParams); override;
  protected
    procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
    procedure VersionFor(aFile: string);
  public
    { Public declarations }
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;  end;
var
  Form1: TForm1;

implementation
uses
   ShellApi,
   FileVersion;


procedure TForm1.CreateParams(var Params: TCreateParams);
begin
   inherited createparams(params);
   {This makes a borderless and captionless form}
   params.style:=params.style or ws_popup xor ws_dlgframe;
end;

{$R *.DFM}

procedure TForm1.WMDropFiles(var Message: TMessage);
var
   i: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S: string;
   Size: word;
begin
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      StrDispose(P);
      VersionFor(S);
   end;
end;

procedure TForm1.VersionFor(aFile: string);
var
   FV: TFileVersion;
begin
   FV := TFileVersion.Create;
   FV.FileName := aFile;
   FileName.Caption := FV.ProductName;
   Company.Caption := FV.CompanyName;
   FileVersion.Caption := FV.FileVersion;
   FileDescription.Caption := FV.FileDescription;
   CopyRight.Caption := FV.LegalCopyRight;
end;


procedure TForm1.l_wwwClick(Sender: TObject);
begin
   ShellExecute(0, Nil, PChar(l_www.Caption), Nil, Nil, SW_NORMAL);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.CloseClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   i: integer;
   FV: TFileVersion;
   formrgn:hrgn;
begin
   {makes the form clear}
   form1.brush.style:=bsclear;
   {makes the form round}
   GetWindowRgn(form1.Handle, formRgn);
   DeleteObject(formRgn);
   FormRgn:= CreateroundRectRgn
             (ClientRect.Left+3,ClientRect.Top+3,
              ClientRect.Right,ClientRect.Bottom,50,50);
   SetWindowRgn(form1.Handle, formrgn, TRUE);
   DragAcceptFiles(Handle, true);
   i := ParamCount;
   if i > 0 then VersionFor(ParamStr(1));
   if i > 1 then Timer1.Enabled := false;
end;

procedure TForm1.l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Bevel.Style := bsLowered;
end;

procedure TForm1.l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Bevel.Style := bsRaised;
end;


procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
var
   P: TPoint;
begin
  inherited;                    { call the inherited message handler }
  if  M.Result = htClient then  { is the click in the client area?   }
  begin
    P.x := M.XPos;
    P.y := M.YPos;
    P := ScreenToClient(P);
    if ((P.x > l_Close.Left) and (P.y > l_Close.Top) and
       (P.x < l_Close.Left+l_Close.Width) and (P.y < l_Close.Top+l_Close.Height))
        or
       ((P.x > l_www.Left) and (P.y > l_www.Top) and
       (P.x < l_www.Left+l_www.Width) and (P.y < l_www.Top+l_www.Height))
        then exit;
    M.Result := htCaption;      { if so, make Windows think it's     }
                                { on the caption bar.                }
  end;
end;

end.
