unit F_OrbisInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, Buttons;

type
  TForm1 = class(TForm)
    Image1: TImage;
    l_www: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    FileVersion: TLabel;
    FileDescription: TLabel;
    Company: TLabel;
    Copyright: TLabel;
    Label2: TLabel;
    Bevel: TBevel;
    l_Close: TLabel;
    FileName: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    l_Subject: TLabel;
    l_User: TLabel;
    l_TimeWall: TLabel;
    l_Regtyp: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    l_modul: TLabel;
    l_regprog: TLabel;
    Timer2: TTimer;
    l_newversion: TLabel;
    procedure l_wwwClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
      procedure CreateParams(var Params: TCreateParams); override;
  protected
    procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
    procedure VersionFor(aFile: string);
  public
    { Public declarations }
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure CloseProcs;
end;

var
  Form1: TForm1;

implementation
uses
   u_cktm,
   ShellApi,
   FileVersion;


procedure TForm1.CreateParams(var Params: TCreateParams);
begin
   inherited createparams(params);
   {This makes a borderless and captionless form}
   params.style:=params.style or ws_popup xor ws_dlgframe;
end;

{$R *.DFM}

procedure TForm1.WMDropFiles(var Message: TMessage);
var
   i: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S: string;
   Size: word;
begin
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      StrDispose(P);
      VersionFor(S);
   end;
end;

procedure TForm1.VersionFor(aFile: string);
var
   FV: TFileVersion;
begin
   FV := TFileVersion.Create;
   FV.FileName := aFile;
   FileName.Caption := FV.ProductName;
   Company.Caption := FV.CompanyName;
   FileVersion.Caption := FV.FileVersion;
   FileDescription.Caption := FV.FileDescription;
   CopyRight.Caption := FV.LegalCopyRight;
end;


procedure TForm1.l_wwwClick(Sender: TObject);
begin
   ShellExecute(0, Nil, PChar(l_www.Caption), Nil, Nil, SW_NORMAL);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.CloseClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   formrgn:hrgn;
begin
   {makes the form clear}
   form1.brush.style:=bsclear;
   {makes the form round}
   GetWindowRgn(form1.Handle, formRgn);
   DeleteObject(formRgn);
   FormRgn:= CreateroundRectRgn
             (ClientRect.Left+3,ClientRect.Top+3,
              ClientRect.Right,ClientRect.Bottom,50,50);
   SetWindowRgn(form1.Handle, formrgn, TRUE);
   DragAcceptFiles(Handle, true);
end;

procedure TForm1.l_CloseMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Bevel.Style := bsLowered;
end;

procedure TForm1.l_CloseMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Bevel.Style := bsRaised;
end;


procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
var
   P: TPoint;
begin
  inherited;                    { call the inherited message handler }
  if  M.Result = htClient then  { is the click in the client area?   }
  begin
    P.x := M.XPos;
    P.y := M.YPos;
    P := ScreenToClient(P);
    if ((P.x > l_Close.Left) and (P.y > l_Close.Top) and
       (P.x < l_Close.Left+l_Close.Width) and (P.y < l_Close.Top+l_Close.Height))
        or
       ((P.x > l_www.Left) and (P.y > l_www.Top) and
       (P.x < l_www.Left+l_www.Width) and (P.y < l_www.Top+l_www.Height))
        then exit;
    M.Result := htCaption;      { if so, make Windows think it's     }
                                { on the caption bar.                }
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
   RInfo: TRegistrationInfo;
   RegOK: boolean;
   i: integer;
begin
   i := ParamCount;
   if i > 0 then VersionFor(ParamStr(1));
//     ShowMessage('Panel');
   if ParamCount = 0 then exit;
   if CheckModulReg_ByFly(ParamStr(1),false,RInfo,RegOK) then
   begin
      if RegOK then
      begin
         l_Modul.Caption := RInfo.Reg.ModuleName+' '+RBOVersionString(RInfo);
         l_Subject.Caption := RInfo.Reg.Company;
         l_User.Caption := RInfo.Reg.User;
         if RInfo.Reg.IsTimeWall then
            l_TimeWall.Caption := DateToStr(RInfo.Reg.TimeWall);
         if RInfo.Reg.ByPhone then
            l_Regtyp.Caption := 'Telefon'
         else
            l_Regtyp.Caption := 'WEB';
         Timer2.Enabled := true;
      end
      else
         CloseProcs;
   end
   else
   begin
      l_Regtyp.Caption := 'Chyba registrace';
      CloseProcs;
   end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
   RInfo: TRegistrationInfo;
   RegOK: boolean;
   i: integer;
   NewVersion,url: string;
begin
    Timer2.Enabled := false;
   // pokus o aktualizaci ze serveru
   l_regprog.Caption := '?';
   if CheckModulReg_ByFly(ParamStr(1),true,RInfo,RegOK) then
   begin
      if RegOK then
         l_regprog.Caption := '+'
      else
         l_regprog.Caption := '!';
      if RInfo.Reg.IsTimeWall then
         l_TimeWall.Caption := DateToStr(RInfo.Reg.TimeWall);
      if RInfo.Reg.ByPhone then
         l_Regtyp.Caption := 'Telefon'
      else
         l_Regtyp.Caption := 'WEB';
      l_newversion.Caption := 'Kontrola existence nov verze .......';
      Application.ProcessMessages;
      if CheckApplicationForUpgrade(RInfo, ParamStr(1),NewVersion,url) then
      begin
         l_newversion.Font.Color := clRed;
         l_newversion.Caption := 'Je k dispozici aktualizace : '+NewVersion;
         case MessageDlg('Je k dispozici aktualizace '+NewVersion+', chcete otevt strnku s detaily?', mtConfirmation, mbYesNoCancel, 0) of
            mrYes:
            begin
              try
              ShellExecute(0, Nil, PChar(url), Nil, Nil, SW_NORMAL);
              except
              end;
            end;
         end;
      end
      else
         l_newversion.Caption := 'Aplikace je aktuln.......';
   end
   else
     l_regprog.Caption := '-';
   i := ParamCount;
   CloseProcs;
end;

procedure TForm1.CloseProcs;
begin
   Timer1.Enabled := (ParamCount <= 1);
   Bevel.Visible := true;
   l_Close.Visible := true;
end;

end.
