library TestRBO;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  Dialogs,
  SysUtils,
  Classes,
  u_cktm;

{$R *.res}

function CheckRBO(AppName,Version,RBOPath: PChar): boolean; stdcall;
var
  RBOName: string;
  IsRBO: boolean;
  RBO: TRegistrationInfo;
  App: TAppRec;
  Vers: string;
  AppInstallInfo: TAppInstallInfo;
begin
   //ShowMessage('App: '+string(AppName)+' ver: ' +string(Version)+' RBO: '+string(RBOPath) );
   //result := false;
   //exit;
   AppInstallInfo := TAppInstallInfo.Create;
   App.AppName := string(Appname);
   Vers := string(Version);
   SetAppVersionString(Vers, App);
   result := true;
   IsRBO := false;
   RBOName := string(RBOPath);
   if RBOName <> '' then
   if FileExists(RBOName) then
   begin
      RBO := LoadRBOFromFile(RBOName);
      // pokud je RBO tak se informace o aplikaci prebiraji z nej (modul)
      App.AppName := RBO.Reg.ModuleName;
      App.MajorVersion := RBO.Reg.MajorVersion;
      App.MinorVersion := RBO.Reg.MinorVersion;
      IsRBO := true;
      //ShowMessage('RBO:'+RBOName+' exists!');
   end;
   result := CheckFoldersForSetup(App,RBO,IsRBO,AppInstallInfo,true);
   AppInstallInfo.Modul := IntToStr(RBO.Reg.Key);
   if Result then
   begin
      //SetupFolders(App,RBO,IsRBO,AppInstallInfo);
      //ShowMessage('RBO OK:'+IntToStr(RBO.Reg.Key));
   end;
   AppInstallInfo.Free;
end;

function SetupRBO(AppName,Version,RBOPath: PChar): boolean; stdcall;
var
  RBOName: string;
  IsRBO: boolean;
  RBO: TRegistrationInfo;
  App: TAppRec;
  Vers: string;
  AppInstallInfo: TAppInstallInfo;
begin
   //ShowMessage('App: '+string(AppName)+' ver: ' +string(Version)+' RBO: '+string(RBOPath) );
   //result := false;
   //exit;
   AppInstallInfo := TAppInstallInfo.Create;
   App.AppName := string(Appname);
   Vers := string(Version);
   SetAppVersionString(Vers, App);
   result := true;
   IsRBO := false;
   RBOName := string(RBOPath);
   if RBOName <> '' then
   if FileExists(RBOName) then
   begin
      RBO := LoadRBOFromFile(RBOName);
      // pokud je RBO tak se informace o aplikaci prebiraji z nej (modul)
      App.AppName := RBO.Reg.ModuleName;
      App.MajorVersion := RBO.Reg.MajorVersion;
      App.MinorVersion := RBO.Reg.MinorVersion;
      IsRBO := true;
      //ShowMessage('RBO:'+RBOName+' exists!');
   end;
   result := CheckFoldersForSetup(App,RBO,IsRBO,AppInstallInfo,false);
   AppInstallInfo.Modul := IntToStr(RBO.Reg.Key);
   if Result then
   begin
      SetupFolders(App,RBO,IsRBO,AppInstallInfo);
      //ShowMessage('RBO OK:'+IntToStr(RBO.Reg.Key));
   end;
   AppInstallInfo.Free;
end;

exports
   CheckRBO,
   SetupRBO;

begin
end.
