unit f_KeyboardFull;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    ed_Delay: TEdit;
    ed_Repeat: TEdit;
    b_Delay: TBitBtn;
    b_Repeat: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Memo1: TMemo;
    Error: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure b_DelayClick(Sender: TObject);
    procedure b_RepeatClick(Sender: TObject);
  private
    procedure SetErrText(const Value: boolean);
    { Private declarations }
  public
     procedure QueryDelay;
     procedure QueryRepeat;
     procedure SetDelay;
     procedure SetRepeat;
     property  ErrText: boolean write SetErrText;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   QueryDelay;
   QueryRepeat;
   if ParamCount > 0 then
   begin
      SetDelay;
      SetRepeat;
      Application.Terminate;
   end;
end;

procedure TForm1.QueryDelay;
var
   Int: integer;
begin
   ErrText := SystemParametersInfo(SPI_GETKEYBOARDDELAY,0,@Int,0);
   ed_Delay.Text := IntToStr(Int);
end;

procedure TForm1.QueryRepeat;
var
   Int: DWORD;
begin
   ErrText := SystemParametersInfo(SPI_GETKEYBOARDSPEED,0,@Int,0);
   ed_Repeat.Text := IntToStr(Int);
end;

procedure TForm1.SetDelay;
begin
   ErrText := SystemParametersInfo(SPI_SETKEYBOARDDELAY,StrToInt(ed_Delay.Text),nil,0);
end;

procedure TForm1.SetRepeat;
begin
   ErrText := SystemParametersInfo(SPI_SETKEYBOARDSPEED,StrToInt(ed_Repeat.Text),nil,0);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
   QueryDelay;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
   QueryRepeat;
end;

procedure TForm1.SetErrText(const Value: boolean);
begin
   if Value then
      Error.Caption := 'O.K.'
   else
      Error.Caption := 'Error';
end;

procedure TForm1.b_DelayClick(Sender: TObject);
begin
   SetDelay;
end;

procedure TForm1.b_RepeatClick(Sender: TObject);
begin
   SetRepeat;
end;

end.
