program SilvaLED;



uses
  Forms,
  SysUtils,
  Dialogs,
  PubUnits in 'pubunits.pas',
  F_MAIN1 in '..\..\Lib\App\F_MAIN1.pas' {MainForm1},
  F_Main2 in '..\..\LIB\APP\F_MAIN2.pas' {MainForm2},
  e_GFile in '..\..\Lib\GLIB\e_GFile.pas',
  t_SelFil in '..\..\Lib\App\t_SelFil.pas',
  U_cktm in '..\..\Lib\REG\U_Cktm.pas',
  u_BMPs in '..\..\Lib\BMPS\u_BMPs.pas',
  t_Tiletm in '..\TileTemplate\t_Tiletm.pas',
  T_Main in 'T_Main.pas',
  Worlds in '..\..\Lib\Kernel\Worlds.pas',
  u_Shell in '..\..\Lib\0TEMP\u_Shell.pas',
  u_Type in '..\..\Lib\Kernel\u_Type.pas',
  t_ConditionFilter in '..\..\Lib\ConditionFilter\t_ConditionFilter.pas',
  f_ConditionFilter in '..\..\Lib\ConditionFilter\f_ConditionFilter.pas' {ConditionFilterForm},
  e_CompareModel in '..\..\Lib\0TEMP\e_CompareModel.pas',
  e_LHCModel in '..\..\Lib\LHC\e_LHCModel.pas',
  e_GeometryElement in '..\..\Lib\Space\e_GeometryElement.pas',
  e_TaskModel in '..\..\Lib\LHC\e_TaskModel.pas',
  e_Group in '..\..\Lib\LHC\e_Group.pas',
  f_OrbisForm in '..\..\Lib\App\f_OrbisForm.pas' {ORBISForm},
  c_Actions in '..\..\Lib\App\c_Actions.pas',
  F_TaskForm in '..\..\Lib\App\F_TaskForm.pas' {Task_Form},
  t_TaskForm in '..\..\Lib\App\t_TaskForm.pas',
  t_FormTool in '..\..\Lib\App\t_FormTool.pas',
  t_InterfaceTool in '..\..\Lib\App\t_InterfaceTool.pas',
  t_GraphicForm in '..\..\Lib\App\t_GraphicForm.pas',
  f_ExtendedOrbisForm in '..\..\Lib\App\f_ExtendedOrbisForm.pas' {ExtendedORBIS_Form},
  t_ExtendedFormTool in '..\..\Lib\App\t_ExtendedFormTool.pas',
  f_GraphicForm in '..\..\Lib\App\f_GraphicForm.pas' {Graphic_Form},
  e_ElementModel in '..\..\Lib\Kernel\e_ElementModel.pas',
  e_ToolModel in '..\..\Lib\Kernel\e_ToolModel.pas',
  t_SriptTool in '..\..\Lib\OIL\t_SriptTool.pas',
  t_ControlGroup in '..\..\Lib\App\t_ControlGroup.pas',
  f_ControlGroupForm in '..\..\Lib\App\f_ControlGroupForm.pas' {ControlGroupForm},
  t_ViewTools in '..\..\Lib\App\t_ViewTools.pas',
  t_ShImg in '..\..\Lib\GUI\t_ShImg.pas',
  T_OrbisDialog in '..\..\Lib\App\T_OrbisDialog.pas',
  f_OrbisDialog in '..\..\Lib\App\f_OrbisDialog.pas' {OrbisDialog_Form},
  f_ConfirmDialog in '..\..\Lib\App\f_ConfirmDialog.pas' {OrbisConfirmDialog_Form},
  t_ConfirmDialog in '..\..\Lib\App\t_ConfirmDialog.pas',
  e_Project in '..\..\Lib\App\e_Project.pas',
  e_LHCProject in '..\..\Lib\LHC\e_LHCProject.pas',
  t_LHCProjectDialog in '..\..\Lib\LHC\t_LHCProjectDialog.pas',
  f_Main in 'f_Main.pas' {MainForm},
  f_ProjectIntroDialog in '..\..\Lib\App\f_ProjectIntroDialog.pas' {ProjectIntroDialog_Form},
  t_ProjectIntroDialog in '..\..\Lib\App\t_ProjectIntroDialog.pas',
  f_LHCProjectDialog in '..\..\Lib\LHC\f_LHCProjectDialog.pas' {LHCProjectDialog_Form},
  t_ExportLHCDialog in '..\..\Lib\LHC\t_ExportLHCDialog.pas',
  f_ExportLHCDialog in '..\..\Lib\LHC\f_ExportLHCDialog.pas' {ExportLHCDialog_Form},
  t_ControlTool in '..\..\Lib\App\t_ControlTool.pas',
  t_GraphicFormControls in '..\..\Lib\App\t_GraphicFormControls.pas',
  E_Class in '..\..\Lib\Kernel\E_class.pas',
  i_Node in '..\..\Lib\Editor\i_Node.pas',
  t_OrbisFrame in '..\..\Lib\App\t_OrbisFrame.pas',
  r_OrbisFrame in '..\..\Lib\App\r_OrbisFrame.pas' {Orbis_Frame: TFrame},
  r_CoordMonitor in '..\..\Lib\App\r_CoordMonitor.pas' {CoordMonitor_Frame: TFrame},
  t_CoordMonitor in '..\..\Lib\App\t_CoordMonitor.pas',
  r_ScaleMonitor in '..\..\Lib\App\r_ScaleMonitor.pas' {ScaleMonitor_Frame: TFrame},
  t_ScaleMonitor in '..\..\Lib\App\t_ScaleMonitor.pas',
  e_Geometry in '..\..\Lib\Space\e_Geometry.pas',
  T_AreMak in '..\..\lib\Editor\t_Aremak.pas',
  i_AreaElement in '..\..\Lib\0TEMP\i_AreaElement.pas',
  i_PolyLineElement in '..\..\Lib\0TEMP\i_PolyLineElement.pas',
  e_KatastrModel in '..\..\Lib\LHC\e_KatastrModel.pas',
  T_CreateParcelModel in '..\..\Lib\LHC\T_CreateParcelModel.pas',
  T_CreateForestModel in '..\..\Lib\LHC\T_CreateForestModel.pas',
  T_CreateModelFromLayer in '..\..\Lib\LHC\T_CreateModelFromLayer.pas',
  t_LHCImportDialog in '..\..\Lib\LHC\t_LHCImportDialog.pas',
  f_LHCImportDialog in '..\..\Lib\LHC\f_LHCImportDialog.pas' {LHCImportDialog_Form},
  t_GraphicEditors in '..\..\lib\Editor\t_GraphicEditors.pas',
  t_LHCPDialog in '..\..\Lib\LHC\t_LHCPDialog.pas',
  f_LHCPDialog in '..\..\Lib\LHC\f_LHCPDialog.pas' {LHCPDIalog_Form},
  i_AreaGeometryElement in '..\..\Lib\0TEMP\i_AreaGeometryElement.pas',
  i_LHCElements in '..\..\Lib\LHC\i_LHCElements.pas',
  T_ExpLHC in '..\..\Lib\LHC\T_ExpLHC.pas',
  t_ElementKiller in '..\..\Lib\Editor\t_ElementKiller.pas',
  t_GraphicSelectors in '..\..\Lib\Editor\t_GraphicSelectors.pas',
  t_LineDialog in '..\..\Lib\Editor\t_LineDialog.pas',
  t_ForestModelSelector in '..\..\Lib\LHC\t_ForestModelSelector.pas',
  t_ParcelModelSelector in '..\..\Lib\LHC\t_ParcelModelSelector.pas',
  e_LHCModelSupport in '..\..\Lib\LHC\e_LHCModelSupport.pas',
  t_Sluckovani in '..\..\Lib\LHC\t_Sluckovani.pas',
  f_SluckovaniDialog in '..\..\Lib\LHC\f_SluckovaniDialog.pas' {SluckovaniDialog_Form},
  t_SluckovaniDialog in '..\..\Lib\LHC\t_SluckovaniDialog.pas',
  t_LHCProjectManager in '..\..\Lib\LHC\t_LHCProjectManager.pas',
  f_LHCProjectManager in '..\..\Lib\LHC\f_LHCProjectManager.pas' {LHCProjectManager_Form},
  t_SRFEditor in '..\..\Lib\LHC\t_SRFEditor.pas',
  t_TezpDialog in '..\..\Lib\LHC\t_TezpDialog.pas',
  t_GeometryTools in '..\..\Lib\0TEMP\t_GeometryTools.pas',
  t_SimplePointDialog in '..\..\Lib\LHC\t_SimplePointDialog.pas',
  e_ThematicMap in '..\..\Lib\Mapper\e_ThematicMap.pas',
  t_TransferLineAttributes in '..\..\Lib\0TEMP\t_TransferLineAttributes.pas',
  t_OrbisPageForm in '..\..\Lib\App\t_OrbisPageForm.pas',
  f_OrbisPageForm in '..\..\Lib\App\f_OrbisPageForm.pas' {ORBISPage_Form},
  t_OrbisControlElements in '..\..\Lib\App\t_OrbisControlElements.pas',
  r_OrbisPageFrame in '..\..\Lib\App\r_OrbisPageFrame.pas' {OrbisPage_Frame: TFrame},
  t_OrbisPageFrame in '..\..\Lib\App\t_OrbisPageFrame.pas',
  T_MapManagerFrame in '..\..\Lib\App\T_MapManagerFrame.pas',
  r_MapManagerFrame in '..\..\Lib\App\r_MapManagerFrame.pas' {MapManager_Frame: TFrame},
  r_ProjectionsFrame in '..\..\Lib\App\r_ProjectionsFrame.pas' {Projections_Frame: TFrame},
  t_ProjectionsFrame in '..\..\Lib\App\t_ProjectionsFrame.pas',
  t_RasterManipulator in '..\..\Lib\Editor\t_RasterManipulator.pas',
  t_RasterDialog in '..\..\Lib\LHC\t_RasterDialog.pas',
  f_RasterDialog in '..\..\Lib\LHC\f_RasterDialog.pas' {RasterDialog_Form},
  t_Snap in '..\..\Lib\Editor\t_Snap.pas',
  e_TopolDruhy in '..\..\Lib\LHC\e_TopolDruhy.pas',
  t_TopolLineDialog in '..\..\Lib\LHC\t_TopolLineDialog.pas',
  f_LineDialog in '..\..\lib\Editor\f_LineDialog.pas' {LineDialog_Form},
  f_TopolLineDialog in '..\..\Lib\LHC\f_TopolLineDialog.pas' {TopolLineDialog_Form},
  f_SimpleColorDialog in '..\..\Lib\Editor\f_SimpleColorDialog.pas' {SimpleColordialog},
  e_SerialPort in '..\..\Lib\Serial\e_SerialPort.pas',
  d_Tablet in '..\..\Lib\Serial\d_Tablet.pas',
  t_30LEDLoader in '..\..\Lib\0TEMP\t_30LEDLoader.pas',
  t_TEZDET in '..\..\Lib\0TEMP\t_TEZDET.pas',
  i_KatastrElements in '..\..\Lib\LHC\i_KatastrElements.pas',
  t_KatastrPDialog in '..\..\Lib\LHC\t_KatastrPDialog.pas',
  f_KatastrPDialog in '..\..\Lib\LHC\f_KatastrPDialog.pas' {KatastrPDialog_Form},
  t_CreateSKPfromPAR in '..\..\Lib\LHC\t_CreateSKPfromPAR.pas',
  e_Transformation in '..\..\Lib\Trafo\e_Transformation.pas',
  t_Transformation in '..\..\Lib\Trafo\t_Transformation.pas',
  t_XML_ISLHC in '..\..\Lib\0TEMP\t_XML_ISLHC.pas',
  t_TabletManager in '..\..\Lib\Serial\t_TabletManager.pas',
  r_TabletManager in '..\..\Lib\Serial\r_TabletManager.pas' {TabletManager_Frame: TFrame},
  f_TabletDialog in '..\..\Lib\Serial\f_TabletDialog.pas' {TabletDialog_Form},
  f_TransformationTableDialog in '..\..\Lib\Serial\f_TransformationTableDialog.pas' {TransformationTableDialog_Form},
  t_CopyLinesFromTo in '..\..\Lib\LHC\t_CopyLinesFromTo.pas',
  t_FreeNoGeometryElements in '..\..\Lib\Editor\t_FreeNoGeometryElements.pas',
  t_FindBreakLineConnections in '..\..\Lib\Editor\t_FindBreakLineConnections.pas',
  t_ParcelyTestTools in '..\..\Lib\LHC\t_ParcelyTestTools.pas',
  t_ThematicMapsEditor in '..\..\Lib\0TEMP\t_ThematicMapsEditor.pas',
  f_ThematicMapsEditor in '..\..\Lib\0TEMP\f_ThematicMapsEditor.pas' {ThematicMapsEditor_Form},
  r_ThematicLayerEditor in '..\..\Lib\0TEMP\r_ThematicLayerEditor.pas' {ThematicLayerEditor_Frame: TFrame},
  r_ThematicLinesLayerEditor in '..\..\Lib\0TEMP\r_ThematicLinesLayerEditor.pas' {ThematicLinesLayerEditor_Frame: TFrame},
  t_TestTool in '..\..\Lib\0TEMP\t_TestTool.pas',
  t_MapSpacesFrame in '..\..\Lib\0TEMP\t_MapSpacesFrame.pas',
  r_MapSpacesFrame in '..\..\Lib\0TEMP\r_MapSpacesFrame.pas' {MapSpaces_Frame: TFrame},
  f_MapSpaceForm in '..\..\Lib\0TEMP\f_MapSpaceForm.pas' {MapSpaces_Form},
  t_RasTest in '..\..\Lib\0TEMP\t_RasTest.pas',
  r_ThematicTextLayerEditor in '..\..\Lib\0TEMP\r_ThematicTextLayerEditor.pas' {ThematicLayerTextEditor_Frame: TFrame},
  t_GeometryCHecks in '..\..\Lib\Editor\t_GeometryCHecks.pas',
  t_GeometryListForm in '..\..\Lib\App\t_GeometryListForm.pas',
  f_GeometryListForm in '..\..\Lib\App\f_GeometryListForm.pas' {GeometryList_Form},
  t_RepairTools in '..\..\Lib\Editor\t_RepairTools.pas',
  t_FreeDuplicateGeometryElements in '..\..\Lib\Editor\t_FreeDuplicateGeometryElements.pas',
  t_CheckForestParcelConnection in '..\..\Lib\LHC\t_CheckForestParcelConnection.pas',
  t_CreateIslandAreas in '..\..\Lib\Editor\t_CreateIslandAreas.pas',
  T_showm in '..\..\Lib\0TEMP\t_ShowM.pas',
  t_ParcelyUtils in '..\..\Lib\LHC\t_ParcelyUtils.pas',
  t_CreateSKPGeometry in '..\..\Lib\LHC\t_CreateSKPGeometry.pas',
  T_dgnimp in '..\..\Lib\DGN\t_DGNImp.pas',
  i_TMPText in '..\..\Lib\DGN\i_TMPText.pas',
  e_LinkText in '..\..\Lib\LHC\e_LinkText.pas',
  i_Annotation in '..\..\Lib\LHC\i_Annotation.pas',
  T_CreateParcelModel_Other in '..\..\Lib\LHC\T_CreateParcelModel_Other.pas',
  t_LHCTestTools in '..\..\Lib\LHC\t_LHCTestTools.pas',
  t_LHCUtils in '..\..\Lib\LHC\t_LHCUtils.pas',
  f_ExportLCRDialog in '..\..\Lib\LHC\f_ExportLCRDialog.pas' {ExportLCRDialog_Form},
  t_ExportLCRDialog in '..\..\Lib\LHC\t_ExportLCRDialog.pas',
  t_MultiParalelLineEditor in '..\..\Lib\LHC\t_MultiParalelLineEditor.pas',
  e_VersionInfo in '..\..\Lib\App\e_VersionInfo.pas',
  t_OilPro1 in '..\..\Lib\0TEMP\t_OilPro1.pas',
  f_MultiParalelLineDialog in '..\..\Lib\LHC\f_MultiParalelLineDialog.pas' {MultiParalelLineDialog_Form},
  t_MultiParalelLineDialog in '..\..\Lib\LHC\t_MultiParalelLineDialog.pas',
  t_PolyLineDivider in '..\..\Lib\Editor\t_PolyLineDivider.pas',
  t_SpatialAnalysis in '..\..\Lib\Editor\t_SpatialAnalysis.pas',
  t_DivideLHC in '..\..\Lib\LHC\t_DivideLHC.pas',
  t_JoinLHCLines in '..\..\Lib\LHC\t_JoinLHCLines.pas',
  t_TopolPointDialog in '..\..\Lib\LHC\t_TopolPointDialog.pas',
  f_SimplePointDialog in '..\..\lib\LHC\f_SimplePointDialog.pas' {SimplePointDialog_Form},
  f_TopolPointDialog in '..\..\Lib\LHC\f_TopolPointDialog.pas' {TopolPointDialog_Form},
  e_Annotation in '..\..\Lib\LHC\e_Annotation.pas',
  t_Annotation in '..\..\Lib\LHC\t_Annotation.pas',
  t_AnnotationEditor in '..\..\Lib\LHC\t_AnnotationEditor.pas',
  t_AnnotationDialog in '..\..\Lib\LHC\t_AnnotationDialog.pas',
  f_TextAnnotationDialog in '..\..\Lib\LHC\f_TextAnnotationDialog.pas' {TextAnnotationDialog_Form},
  t_LHCFinderFrame in '..\..\Lib\0TEMP\t_LHCFinderFrame.pas',
  f_LHCFinderForm in '..\..\Lib\0TEMP\f_LHCFinderForm.pas' {LHCFinder_Form},
  r_LHCFinderFrame in '..\..\Lib\0TEMP\r_LHCFinderFrame.pas' {LHCFinder_Frame: TFrame},
  t_CreateHRK in '..\..\Lib\LHC\t_CreateHRK.pas',
  e_Chk in '..\..\Lib\REVIZOR\e_Chk.pas',
  T_Chk in '..\..\Lib\REVIZOR\T_Chk.pas',
  T_ChkSp in '..\..\Lib\REVIZOR\T_CHKSP.PAS',
  t_OrbisGraphicFrame in '..\..\Lib\App\t_OrbisGraphicFrame.pas',
  t_OrbisControlElementsEx in '..\..\Lib\App\t_OrbisControlElementsEx.pas',
  r_OrbisGraphicFrame in '..\..\Lib\App\r_OrbisGraphicFrame.pas' {OrbisGraphic_Frame: TFrame},
  i_ErrorElement in '..\..\Lib\REVIZOR\i_ErrorElement.pas',
  t_SolveErrors in '..\..\Lib\Editor\t_SolveErrors.pas',
  e_Stat in '..\..\Lib\LHC\e_Stat.pas',
  t_SoupisParcel in '..\..\Lib\LHC\t_SoupisParcel.pas',
  t_CHeck_LIN_ARE in '..\..\Lib\REVIZOR\t_CHeck_LIN_ARE.pas',
  t_Check_AreaExists in '..\..\Lib\REVIZOR\t_Check_AreaExists.pas',
  t_Synchronize_TABLE_Model in '..\..\Lib\LHC\t_Synchronize_TABLE_Model.pas',
  f_Synchronize_TABLE_ParcelModel in '..\..\Lib\LHC\f_Synchronize_TABLE_ParcelModel.pas' {Synchronize_Table_ParcelModel_Form},
  t_CHeck_Parcely in '..\..\Lib\REVIZOR\t_CHeck_Parcely.pas',
  t_Chk_TAX_LED in '..\..\Lib\REVIZOR\t_Chk_TAX_LED.pas',
  f_Test in '..\..\Lib\0TEMP\f_Test.pas' {Form1},
  t_RepairSRF in '..\..\Lib\LHC\t_RepairSRF.pas',
  f_Synchronize_TABLE_ForestModel in '..\..\Lib\LHC\f_Synchronize_TABLE_ForestModel.pas' {Synchronize_TABLE_ForestModel_Form},
  t_TextEditor in '..\..\Lib\LHC\t_TextEditor.pas',
  t_SimpleTextDialog in '..\..\Lib\LHC\t_SimpleTextDialog.pas',
  f_SimpleTextDialog in '..\..\Lib\LHC\f_SimpleTextDialog.pas' {SimpleTextDialog_Form},
  t_JoinLines in '..\..\Lib\Editor\t_JoinLines.pas',
  t_GeometryElementUtils in '..\..\Lib\Editor\t_GeometryElementUtils.pas',
  t_CHeck_ARE_LIN in '..\..\Lib\REVIZOR\t_CHeck_ARE_LIN.pas',
  t_CHeck_NEXT in '..\..\Lib\REVIZOR\t_CHeck_NEXT.pas',
  e_XML in '..\..\Lib\XML\e_XML.pas',
  t_ExpLHC_XML in '..\..\Lib\LHC\t_ExpLHC_XML.pas',
  t_TAXUtils in '..\..\Lib\LHC\t_TAXUtils.pas',
  t_ExtractSymbolsFromLines in '..\..\Lib\0TEMP\t_ExtractSymbolsFromLines.pas',
  t_ChkDruhy in '..\..\Lib\REVIZOR\t_ChkDruhy.pas',
  t_Create1VSLayer in '..\..\Lib\LHC\t_Create1VSLayer.pas',
  T_mapcre in '..\..\Lib\Mapper\T_MAPCRE.PAS',
  f_NamedProjectionsForm in '..\..\Lib\App\f_NamedProjectionsForm.pas' {NamedProjections_Form},
  t_SpaceFilters in '..\..\Lib\Editor\t_SpaceFilters.pas',
  f_TypPDialog in '..\..\Lib\LHC\f_TypPDialog.pas' {TypPDialog_Form},
  T_TypPDialog in '..\..\Lib\LHC\T_TypPDialog.pas',
  t_SoupisTYP in '..\..\Lib\LHC\t_SoupisTYP.pas',
  T_Orbis_Excel in '..\..\Lib\0TEMP\T_Orbis_Excel.pas',
  f_Synchronize_TABLE_Majitele in '..\..\Lib\LHC\f_Synchronize_TABLE_Majitele.pas' {Synchronize_TABLE_Majitele_Form},
  e_OverlayGeometryElement in '..\..\Lib\0TEMP\e_OverlayGeometryElement.pas',
  t_CreateOverlay in '..\..\Lib\0TEMP\t_CreateOverlay.pas',
  t_NodeEditor in '..\..\Lib\Editor\t_NodeEditor.pas',
  t_ShpExport in '..\..\Lib\SHPFILE\t_ShpExport.pas',
  T_IniF in '..\..\Lib\0TEMP\T_IniF.PAS',
  t_DxfImp in '..\..\Lib\DXF\t_DxfImp.pas',
  t_PrepareSymbols in '..\..\Lib\0TEMP\t_PrepareSymbols.pas',
  t_Orbis_ColorDialog in '..\..\Lib\App\t_Orbis_ColorDialog.pas',
  d_Geometry in '..\..\Lib\0TEMP\d_Geometry.pas',
  e_SKmap in '..\..\Lib\Mapper\e_SKmap.pas',
  r_MeasureMonitor in '..\..\Lib\App\r_MeasureMonitor.pas' {MeasureMonitor_FRAME: TFrame},
  t_MeasureMonitor in '..\..\Lib\App\t_MeasureMonitor.pas',
  t_MeasureTools in '..\..\Lib\Editor\t_MeasureTools.pas',
  e_3D in '..\..\Lib\0TEMP\e_3D.pas',
  t_RevPDialog in '..\..\Lib\LHC\t_RevPDialog.pas',
  f_RevPDialog in '..\..\Lib\LHC\f_RevPDialog.pas' {OrbisDialog_Form1},
  e_Terrain in '..\..\Lib\0TEMP\e_Terrain.pas',
  t_DynamicPrint in '..\..\Lib\0TEMP\t_DynamicPrint.pas',
  f_VodPDialog in '..\..\Lib\LHC\f_VodPDialog.pas' {VODPDialog_Form},
  t_VodPDialog in '..\..\Lib\LHC\t_VodPDialog.pas',
  f_KUPDialog in '..\..\Lib\LHC\f_KUPDialog.pas' {KUPDialog_Form},
  t_Free_ in '..\..\Lib\0TEMP\t_Free_.pas',
  t_ConvertLesniCelek in '..\..\Lib\0TEMP\t_ConvertLesniCelek.pas',
  e_People in '..\..\Lib\0TEMP\e_People.pas',
  GpsToolsXP_TLB in '..\..\Lib\franson\GpsToolsXP_TLB.pas',
  e_GPS in '..\..\Lib\franson\e_GPS.pas',
  r_GPSManager in '..\..\Lib\franson\r_GPSManager.pas' {GPSManager_Frame: TFrame},
  t_GPSManager in '..\..\Lib\franson\t_GPSManager.pas',
  e_WMS in '..\..\Lib\0TEMP\e_WMS.pas',
  i_WMS in '..\..\Lib\0TEMP\i_WMS.pas',
  f_TM_Editor in '..\..\Lib\0TEMP\f_TM_Editor.pas' {TematicMap_Editor_Form},
  t_ExchangeElementClass in '..\..\Lib\0TEMP\t_ExchangeElementClass.pas',
  t_RasterTransformation in '..\..\Lib\0TEMP\t_RasterTransformation.pas',
  f_RasterTransformer in '..\..\Lib\0TEMP\f_RasterTransformer.pas' {RasterTransformer_Form};

{$R *.RES}

function checktime(aY,aM: word): boolean;
var
   Y,M,D: word;
begin
   result := true;
   DecodeDate(Now, Y, M, D);
   if (Y <> aY) or (M > aM) then
      result := false;
end;

BEGIN
   if not CheckModulRegistration(ParamStr(0)) then exit;
//   if not checktime(2014,9) then
//   begin
//      ShowMessage('Zvltn chyba 9, prosm kontaktujte vrobce!');
//      exit;
//   end;
   Application.ProcessMessages;
   ChDir(ExtractFilePath(ParamStr(0)));
   _CreateProcess('ORBISPanel.exe',ParamStr(0));
   Application.ProcessMessages;
   Application.Initialize;
   Application.HintHidePause := 60000;
   Application.Title := 'LED';
   TMainTool.CreateWorld;
   if World.MainTool = nil then exit;
   World.MainTool.DoIt;
   //CHeckOrbisClasses;
   if Application.MainForm = nil then
      ShowMessage('neni form');
   Application.Run;
END.
