unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// MAPPER
  e_Map,
  e_MSpace;
  //f_MSEdit,
  //f_Templ,
  //t_Guide,
  //t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  FDelRAS: TStringListElement;
  FDeleteRAS: boolean;
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FWorkingDirectory: String;
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
    FProjectDirectory: string;
    FProjectFile: string;
  function  GetDelRAS: TStringListElement;
  procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
    procedure SetProjectDirectory(const Value: string);
    procedure SetProjectFile(const Value: string);
public
  property   DelRAS: TStringListElement read GetDelRAS;
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   WorkingDirectory: string read FWorkingDirectory write FWorkingDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
  property   ProjectFile: string read FProjectFile write SetProjectFile;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FActualAction: integer;
    FActualActionVisible: boolean;
    FButtonCount: integer;
    FActualActionImageIndex: integer;
    FActualActionCaption: string;
    FActualActionScript: string;
  function  GetOptions: TBaseOptions; override;
  function  GetNOptions: TOptions; virtual;
  procedure SetOptions(aValue: TBaseOptions); override;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
    procedure SetActualAction(const Value: integer);
    procedure SetActualActionCaption(const Value: string);
    procedure SetActualActionImageIndex(const Value: integer);
    procedure SetActualActionScript(const Value: string);
    procedure SetActualActionVisible(const Value: boolean);
    procedure SetButtonCount(const Value: integer);
    procedure SetNewImage(const Value: string);
    function GetActualActionCaption: string;
    function GetActualActionImageIndex: integer;
    function GetActualActionScript: string;
    function GetActualActionVisible: boolean;
    function GetActualActionHint: string;
    procedure setActualActionHint(const Value: string);
    procedure SetShowActionsCaptions(const Value: boolean);
    function GetImageHeight: integer;
    function GetImageWidth: integer;
    procedure SetImageHeight(const Value: integer);
    procedure SetImageWidth(const Value: integer);
protected
  function  GetWorkingDirectory: string; override;
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   RunStartScripts; override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProjectAs(var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   ExePath: string read GetExePath;
   property   ButtonCount: integer read FButtonCount write SetButtonCount;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   NewImage: string write SetNewImage;
   property   ActualAction: integer read FActualAction write SetActualAction;
   property   ActualActionVisible: boolean read GetActualActionVisible write SetActualActionVisible;
   property   ActualActionScript: string read GetActualActionScript write SetActualActionScript;
   property   ActualActionImageIndex: integer read GetActualActionImageIndex write SetActualActionImageIndex;
   property   ActualActionCaption: string read GetActualActionCaption write SetActualActionCaption;
   property   ActualActionHint: string read GetActualActionHint write setActualActionHint;
   property   ImageHeight: integer read GetImageHeight write SetImageHeight;
   property   ImageWidth: integer read GetImageWidth write SetImageWidth;
   property   ShowActionCaptions: boolean write SetShowActionsCaptions;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  ActnList,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  f_CmdLn,
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// SYMBOL
  u_Symbol,
// INTERPRET
  e_IScrpt,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
// TOPOL
  e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  f_Option,
  F_Start,
  M_Proj,
// FILES
  u_File,
// REG
  FileVersion,
  u_cktm;
// MAPPER
  //t_MSEdit,
  //t_VieMap;

{TOptions}

function  TOptions.GetDelRAS: TStringListElement;
begin
   if FDelRas = nil then
   begin
      FdelRas := TStringListElement.Create;
      AddElement(FDelRas);
   end;
   result := FDelRas;
end;

function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   PaletFile := Value;
   NactiBarvickuZeSouboru(Value);
end;

procedure TOptions.SetProjectDirectory(const Value: string);
begin
   FProjectDirectory := Value;
end;

procedure TOptions.SetProjectFile(const Value: string);
begin
  FProjectFile := Value;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
   RemoveBackSlash(PathOfLibraries);
end;


{TMainTool}


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   //if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
  CommandLine.FileName:= aFileName;
  CommandLine.DoIt
end;


function  TMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   S := Options.WorkingDirectory;
   result := CheckBackSlash(S);
end;



procedure TMainTool.DoIt;
var
   S: string;
begin
   getDir(0, S);
   Options.WorkingDirectory := S;
   Options.DataDirectory := S;
   inherited;
end;





procedure TMainTool.ReadParamsFromIni;
var
   IniFile: TIniFile;
begin
   inherited ReadParamsFromIni;
   IniFile:= TIniFile.Create(IniFileName);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
(*
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;
*)
begin
   //IniFile:= TRealIniFile.Create(IniFileName);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   //IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   //SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
begin
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Work.Text := Options.WorkingDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Data.Text := Options.DataDirectory;
   D.ed_Template.Text := Options.TemplateDirectory;
   if D.ShowModal = mrOk then
   begin
      Options.WorkingDirectory := D.ed_Work.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.DataDirectory := D.ed_Data.Text;
      Options.TemplateDirectory := D.ed_Template.Text;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   //MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
begin
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
begin

end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.Panels.Items[0].Text := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_SaveProject: on_tm_SaveProject(Handled);
      tm_SaveProjectAs: on_tm_SaveProjectAs(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_MapSheetList: PostMsg(tm_Explore, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);



     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);
      tm_OIL              : on_tm_OIL(aMessage,Handled);

      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
      tm_Run              : on_tm_Run(aMessage,Handled);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)   
end;


function  TMainTool.GetText: string;
begin
   result := MainForm.StatusBar.Panels.Items[0].Text;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.Panels.Items[0].Text := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;








procedure TMainTool.SetActualAction(const Value: integer);
begin
   FActualAction := Value;
   if FActualAction > 4 then FActualAction := 4;
end;

procedure TMainTool.SetActualActionCaption(const Value: string);
begin
   TAction(MainForm.ActionList.Actions[ActualAction]).Caption := Value;
end;

procedure TMainTool.SetActualActionImageIndex(const Value: integer);
begin
   TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex := Value;
end;

procedure TMainTool.SetActualActionScript(const Value: string);
begin
   TAction(MainForm.ActionList.Actions[ActualAction]).Category := Value;
end;

procedure TMainTool.SetActualActionVisible(const Value: boolean);
begin
   TAction(MainForm.ActionList.Actions[ActualAction]).Visible := Value;
end;

procedure TMainTool.SetButtonCount(const Value: integer);
begin
end;

procedure TMainTool.SetNewImage(const Value: string);
var
   BM: Graphics.TBitmap;
   S: string;
begin
   BM := Graphics.TBitmap.Create;
   S := '';
   if pos(':',Value) = 0 then
   begin
      S := ExePath;
      CheckBackSlash(S);
   end;
   S := S + Value;
   try
      BM.LoadFromFile(S);
   except
   end;
   MainForm.ImageList.AddMasked(BM,clGray);
end;

procedure TMainTool.on_tm_Run(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   S,SS: string;
begin
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   if pos(':',S) = 0 then
   begin
      SS := ExePath;
      CheckBackSlash(SS);
      S := SS + S;
   end;
   ExecuteScript := S;
end;

function TMainTool.GetActualActionCaption: string;
begin
   result := TAction(MainForm.ActionList.Actions[ActualAction]).Caption;
end;

function TMainTool.GetActualActionImageIndex: integer;
begin
   result := TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex;
end;

function TMainTool.GetActualActionScript: string;
begin
   result := TAction(MainForm.ActionList.Actions[ActualAction]).Category;
end;

function TMainTool.GetActualActionVisible: boolean;
begin
   result := TAction(MainForm.ActionList.Actions[ActualAction]).Visible;
end;

function TMainTool.GetActualActionHint: string;
begin
   result := TAction(MainForm.ActionList.Actions[ActualAction]).Hint;
end;

procedure TMainTool.setActualActionHint(const Value: string);
begin
   TAction(MainForm.ActionList.Actions[ActualAction]).Hint := Value;
end;

procedure TMainTool.SetShowActionsCaptions(const Value: boolean);
begin
   MainForm.ToolBar.ShowCaptions := Value;
   MainForm.ToolBar.ButtonHeight := 50;
   MainForm.ToolBar.ButtonWidth := 50;
end;

function TMainTool.GetImageHeight: integer;
begin
   result := MainForm.ImageList.Height;
end;

function TMainTool.GetImageWidth: integer;
begin
   result := MainForm.ImageList.Width;
end;

procedure TMainTool.SetImageHeight(const Value: integer);
begin
   MainForm.ImageList.Height := Value;
end;

procedure TMainTool.SetImageWidth(const Value: integer);
begin
   MainForm.ImageList.Width := Value;
end;

procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   CMD: TCommandLineDlg;
   El: TElement;
begin
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
end;

procedure TMainTool.RunStartScripts;
var
  OIL: string;
  S,SS: string;
begin
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ExtractFilePath(ParamStr(0));
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
//     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
end;

procedure TMainTool.On_tm_SaveProject(var Handled: boolean);
begin

end;

procedure TMainTool.On_tm_SaveProjectAs(var Handled: boolean);
begin

end;

END.
