unit f_Main;

interface

uses
{$IFDEF HintShadow}
  HintShadow,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, Menus, ToolWin, ComCtrls, MenuBar, ExtCtrls, StdCtrls,
  ActnList, r_OrbisFrame, Gauges;

type
  TMainForm = class(TORBISForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    huhu1: TMenuItem;
    Nastaven2: TMenuItem;
    ActionList: TActionList;
    a_OpenProject: TAction;
    StatusBar: TStatusBar;
    a_Exit: TAction;
    a_StatusBar: TAction;
    a_WorldModel: TAction;
    a_ToolModel: TAction;
    a_ObjectModel: TAction;
    a_OIL: TAction;
    a_Options: TAction;
    OtevtProjekt1: TMenuItem;
    N1: TMenuItem;
    Konecaplikace1: TMenuItem;
    EditorjazykaOIL1: TMenuItem;
    Strukturasvta1: TMenuItem;
    Strukturanstroj1: TMenuItem;
    Strukturaobjektovhomodelu1: TMenuItem;
    N3: TMenuItem;
    Stavovdek1: TMenuItem;
    Vlastnostiaplikace1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    a_SilentOil: TAction;
    OILvtichmmdu1: TMenuItem;
    N5: TMenuItem;
    OpenOIL: TOpenDialog;
    Button1: TButton;
    Memo1: TMemo;
    Gauge1: TGauge;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure a_ExitExecute(Sender: TObject);
    procedure a_OpenProjectExecute(Sender: TObject);
    procedure a_OptionsExecute(Sender: TObject);
    procedure a_OILExecute(Sender: TObject);
    procedure a_WorldModelExecute(Sender: TObject);
    procedure a_ToolModelExecute(Sender: TObject);
    procedure a_ObjectModelExecute(Sender: TObject);
    procedure a_StatusBarExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure a_ProjectOptionsExecute(Sender: TObject);
    procedure a_SilentOilExecute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
  public
    procedure DisplayHint(Sender: TObject);
    procedure ScriptExec(aScript: string);
  end;

var
  MainForm: TMainForm;

implementation
uses
   {!!!!}
   e_OverlayGeometryElement,
   e_LHCModel,
   e_LHCElements,
   f_Test,
   t_Orbis_XML,
   //f_ProgEdit,
   {!!!!}
   IniFiles,
   FileVersion,
   f_PlugIn,
   m_Orbis,
   m_Proj,
   t_Main,
   u_String,
   Worlds, Elements;
{$R *.DFM}

procedure TMainForm.DisplayHint(Sender: TObject);
begin
   StatusBar.SimpleText := Application.Hint;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
   S: string;
   FV: TFileVersion;
begin
   inherited;
   try
      FV := TFileVersion.Create;
      FV.FileName := ParamStr(0);
      Caption := FV.ProductName + ' verze ' + FV.FileVersion;
      //if TimeWall <> 0 then Caption := Caption + ' neregistrovan demo';
      //TimeWall := T + EncodeTime(0, twTimeWall, 0, 0);
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);
      Left        := Ini.ReadInteger('MainForm','Left', Left);
      Top         := Ini.ReadInteger('MainForm','Top', Top);
      Width       := Ini.ReadInteger('MainForm','Width', Width);
      Height      := Ini.ReadInteger('MainForm','Height', Height);
      Ini.Free;
      //b_Directory.Hint := 'Data: ' + TMainTool(World.MainTool).Options.DataDirectory;
      S := ParamStr(0);
      S := ExtractFilePath(S);
      //DragAcceptFiles(Handle, true);
   except
   end;
  inherited;
  Application.HintColor := clLime;
  Application.OnHint := DisplayHint;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
   Ini: TIniFile;
begin
   inherited;
   try
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);

      Ini.WriteInteger('MainForm','Left', Left);
      Ini.WriteInteger('MainForm','Top', Top);
      Ini.WriteInteger('MainForm','Width', Width);
      Ini.WriteInteger('MainForm','Height', Height);
      Ini.Free;
   except
   end;
end;

procedure TMainForm.a_ExitExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_QuitTask,Tool,nil,false);
end;

procedure TMainForm.a_OpenProjectExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_OpenProject,Tool,nil,false);
end;


procedure TMainForm.a_OptionsExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_SetOptions,Tool,nil,false);
end;


procedure TMainForm.a_OILExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_OIL,Tool,nil,false);
end;

procedure TMainForm.a_WorldModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World,false);
end;

procedure TMainForm.a_ToolModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World.MainTool,false);
end;

procedure TMainForm.a_ObjectModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World.ObjectModel,false);
end;

procedure TMainForm.a_StatusBarExecute(Sender: TObject);
begin
   inherited;
   Statusbar.Visible := not StatusBar.Visible;
   a_StatusBar.Checked := StatusBar.Visible;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   inherited;
   if IsPossibleToClose then
   begin
      CanClose:= true
   end
   else
   begin
      CanClose:= false;
      Tool.PostMsg(tm_QuitTask,  Tool, nil, false)
   end
end;

procedure TMainForm.a_ProjectOptionsExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_SetUpProject,Tool,nil,false);
end;



procedure TMainForm.a_SilentOilExecute(Sender: TObject);
begin
   inherited;
   if not OpenOil.Execute then exit;
   Tool.PostTextMsg(tm_Run,OpenOil.FileName,Tool);
end;



procedure TMainForm.ScriptExec(aScript: string);
begin
   TMainTool(Tool).ExecuteScript := aScript;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
   En: TEntity;
   e: TElement;
   i: integer;
   OE: TOverlayGeometryElement;
   PS: TGis_PorostniSkupina;
   LT: TGis_LT;
begin
   Memo1.Clear;
   Memo1.Lines.Add(' - Tvorba pekryvu ');
   // uvodni oil zkontroluje vrstvy a provede prekryv
   ScriptExec('LED\LETAX\Prekryv_DET_TYP_Start.oil');
   // hledani prekryvu
   e := World.ObjectModel.FindElementName('OVERLAY');
   if e <> nil then
   begin              // pokud prekryv s nazvem OVERLAY existuje ....
      En := TEntity(e);
      Gauge1.Progress := 0;
      Gauge1.MaxValue := En.LastIndex;
      for i := 0 to En.LastIndex do
      begin
         Gauge1.Progress := i;
         OE := TOverlayGeometryElement(En.Elements[i]);
         {
         OE.IsEmpty; // nic v prekryvu ... pravdepodobne nezaplochovana lin. kresba
         OE.IsFull;  // oboustranny prekryv ... je nenilove A1 i A2
         OE.IsA1;    // integer hodnota 0 nebo 1 ... existence A1
         OE.IsA2;    // totez ale s A2
         OE.A1;      // element ... v tomto pripade nil nebo typ Tgis_PorostniSkupina
         OE.A2;      // element ... v tomto pripade nil nebo typ Tgis_LT
         OE.Area;    // plocha prekryvu v m2
         }
         // ukazka vypisu plneho prekryvu
         if OE.IsFull then
         begin;
            PS := TGis_PorostniSkupina(OE.A1);
            LT := Tgis_LT(OE.A2);
            Memo1.Lines.Add(IntToStr(PS.Oddeleni)+' '+PS.Dilec+' '+PS.Name+' LT: '+LT.LT);
         end;

      end;
   end
   else
   begin              // ... a pokud neexistuje
      Memo1.Lines.Add(' ! Pekryv nebyl vytvoen !');
   end;
   Memo1.Lines.Add(' - Ukonovn ... ');
   // zaverecny oil uklidi pracovni nalezitosti prekryvu
   ScriptExec('LED\LETAX\Prekryv_DET_TYP_Finish.oil');
   Memo1.Lines.Add(' - KONEC ');
end;

INITIALIZATION
END.
