unit F_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    BitBtn1: TBitBtn;
    ProgressBar: TProgressBar;
    StatusBar: TStatusBar;
    Anim: TAnimate;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MSD,MSC,OIL: string;
    M16,M32,List: TStringList;
    procedure Go;
    procedure translate(aFile: string);
  public
    { Public declarations }
  end;

const
   M16S ='VIEWMODEL.TTOPOLBODY,TTOPOLLINIE,TINTERPRETTOPRASTRU,TTOPOLBODY,TTOPOLPLOCHY,TTOPOLTEXTY,TTOPOLBOD,TTOPOLLIN,TTOPOLTEXT,TTOPOLPLOCHA,TTOPOLNADPLOCHA,TTOPRAS';
   M32S ='VIEWMODEL.FindElementByClass(TPointString),TPolyLineString,TRasterInterpret,TPointString,TAreaString,TTextString,TPointElement,TPolyLineElement,TTextElement,TPolyLineAreaElement,TPolyLineAreaElement,TRaster';


var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   if OpenDialog.execute then
   begin
      MSD := OpenDialog.FileName;
      Caption := 'Pevod '+ MSD;
      MSC := CHangeFileExt(MSD,'.MSC');
      OIL := CHangeFileExt(MSD,'.OIL');
      Go;
      StatusBar.SimpleText := 'GAME OVER ... '+ MSD;
   end;
end;

procedure TForm1.Go;
begin
   Anim.Visible := true;
   Anim.Active := true;
   Translate(MSD);
   Translate(MSC);
   Translate(OIL);
   Anim.Active := false;
   Anim.Visible := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   List := TStringList.Create;
   M16 := TStringList.Create;
   M16.CommaText := M16S;
   M32 := TStringList.Create;
   M32.CommaText := M32S;
end;

procedure TForm1.translate(aFile: string);
var
   i,j: integer;
   p: integer;
   S1,S2,S3: string;
begin
   List.Clear;
   StatusBar.SimpleText := 'Zpracovn souboru '+ aFile;
   if not FileExists(aFile) then exit;
   List.LoadFromFile(aFile);
   ProgressBar.Min := 0;
   ProgressBar.Max := List.Count - 1;
   ProgressBar.Position := 0;
   for i := 0 to List.Count - 1 do
   begin
      ProgressBar.Position := i;
      S1 := List.Strings[i];
      S2 := UpperCase(S1);
      for j := 0 to M16.Count - 1 do
      begin
         p := Pos(M16.Strings[j],S2);
         if p > 0 then
         begin
            S3 := copy(S1, 1, p-1);
            S3 := S3 + M32.Strings[j];
            S3 := S3 + copy(S1,p + length(M16.Strings[j]),200);
            S1 := S3;
            S2 := UpperCase(S1);
         end;
      end;
      List.Strings[i] := S1;
   end;
   S1 := ExtractFilePath(aFile);
   S2 := ExtractFileName(aFile);
   ProgressBar.Position := 0;
   List.SaveToFile(S1+'32'+S2);
end;

end.
