unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_ToolModel,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
// SYMBOL
  u_Symbol,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// APP
  t_ControlGroup,
// LHC
  e_MapperProject,
// MAPPER
  e_Map,
  e_MSpace,
  f_MSEdit,
  f_Templ,
  t_Guide,
  t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
    FProjectDirectory: string;
    FProjectFile: string;
    FDontViewProjectIntroDialog: boolean;
    FAutoOpenLastProject: boolean;
    FExportScript: string;
    FImportScript: string;
    FEditorScript: string;
    FEditorDataScript: string;
    FExportControlDirectory: string;
    FEditorOn: boolean;
    FNewEditor: boolean;
    FAutoSave: boolean;
    FAutoSaveInterval: integer;
    FLOG: boolean;
    FCodePage: TCodePage;
    FNewVersion: boolean;
    FCompatibility30: boolean;
    FDirectory30: string;
    FPrintToFileEnabled: boolean;
    FRun30Script: string;
    FPrintDirectory: string;
    FPrintToFile30Script: string;
  procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
    procedure SetProjectDirectory(const Value: string);
    procedure SetProjectFile(const Value: string);
    procedure SetDontViewProjectIntroDialog(const Value: boolean);
    procedure SetAutoOpenLastProject(const Value: boolean);
    procedure SetExportScript(const Value: string);
    procedure SetImportScript(const Value: string);
    procedure SetEditorScript(const Value: string);
    procedure SetEditorDataScript(const Value: string);
    procedure SetExportControlDirectory(const Value: string);
    procedure SetEditorOn(const Value: boolean);
    function GetRaster: boolean;
    procedure SetRaster(const Value: boolean);
    procedure SetAutoSave(const Value: boolean);
    procedure SetAutoSaveInterval(const Value: integer);
    procedure SetLOG(const Value: boolean);
    procedure SetCodePage(const Value: TCodePage);
    procedure SetNewVersion(const Value: boolean);
    procedure SetCompatibility30(const Value: boolean);
    procedure SetDirectory30(const Value: string);
    procedure SetPrintToFileEnabled(const Value: boolean);
    procedure SetRun30Script(const Value: string);
    procedure SetPrintDirectory(const Value: string);
    procedure SetPrintToFile30Script(const Value: string);
    function GetBDETransLiterate: boolean;
    procedure SetBDETransLiterate(const Value: boolean);
    function GetStrictRect: boolean;
    procedure SetStrictRect(const Value: boolean);
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   ImportScript: string read FImportScript write SetImportScript;
  property   ExportScript: string read FExportScript write SetExportScript;
  property   EditorScript: string read FEditorScript write SetEditorScript;
  property   EditorDataScript: string read FEditorDataScript write SetEditorDataScript;
  property   ExportControlDirectory: string read FExportControlDirectory write SetExportControlDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
  property   ProjectFile: string read FProjectFile write SetProjectFile;
  property   DontViewProjectIntroDialog: boolean read FDontViewProjectIntroDialog write SetDontViewProjectIntroDialog;
  property   AutoOpenLastProject: boolean read FAutoOpenLastProject write SetAutoOpenLastProject;
  property   EditorOn: boolean read FEditorOn write SetEditorOn;
  property   NewEditor: boolean read FNewEditor write FNewEditor;
  property   NewVersion: boolean read FNewVersion write SetNewVersion;
  property   AutoSave: boolean read FAutoSave write SetAutoSave;
  property   AutoSaveInterval: integer read FAutoSaveInterval write SetAutoSaveInterval;
  property   RASTER: boolean read GetRaster write SetRaster;
  property   LOG: boolean read FLOG write SetLOG;
  property   CodePage: TCodePage read FCodePage write SetCodePage;
  property   Run30Script: string read FRun30Script write SetRun30Script;
  property   PrintToFile30Script: string read FPrintToFile30Script write SetPrintToFile30Script;
  property   Compatibility30: boolean read FCompatibility30 write SetCompatibility30;
  property   Directory30: string read FDirectory30 write SetDirectory30;
  property   PrintToFileEnabled: boolean read FPrintToFileEnabled write SetPrintToFileEnabled;
  property   PrintDirectory: string read FPrintDirectory write SetPrintDirectory;
  property   BDETransLiterate: boolean read GetBDETransLiterate write SetBDETransLiterate;
  property   StrictRect: boolean read GetStrictRect write SetStrictRect;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  FEditor: TControlGroup;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FActualAction: integer;
    FActualActionVisible: boolean;
    FButtonCount: integer;
    FActualActionImageIndex: integer;
    FActualActionCaption: string;
    FActualActionScript: string;
    FProject: TORBISMapperProject;
    FCaptionString: string;
    FNoAutoSave: boolean;
    FAutoSaveNeeded: boolean;
    FScriptSender: TElement;
  FTemplateLibrary: TStringList;
  FGuideTool: TGuideFormTool;
  FMapSheetFiller: TMapSheetFiller;
  FTemplateForm: TF_Template;
  FMapSheets: TMapSheets;
    FExternalTemplate: string;
    FUseExternalTemplate: boolean;
  function  GetNOptions: TOptions; virtual;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
    procedure SetActualAction(const Value: integer);
    procedure SetActualActionCaption(const Value: string);
    procedure SetActualActionImageIndex(const Value: integer);
    procedure SetActualActionScript(const Value: string);
    procedure SetActualActionVisible(const Value: boolean);
    procedure SetButtonCount(const Value: integer);
    procedure SetNewImage(const Value: string);
    function GetActualActionCaption: string;
    function GetActualActionImageIndex: integer;
    function GetActualActionScript: string;
    function GetActualActionVisible: boolean;
    function GetActualActionHint: string;
    procedure setActualActionHint(const Value: string);
    procedure SetShowActionsCaptions(const Value: boolean);
    function GetImageHeight: integer;
    function GetImageWidth: integer;
    procedure SetImageHeight(const Value: integer);
    procedure SetImageWidth(const Value: integer);
    procedure SetProject(const Value: TORBISMapperProject);
    procedure SetCaptionString(const Value: string);
    function GetEditor: TControlGroup;
    procedure SetEditor(const Value: TControlGroup);
    function GetEditorModel: TToolModel;
    function GetScriptDirectory: string;
    function GetProjectChanged: boolean;
    procedure SetProjectChanged(const Value: boolean);
    procedure SetTimeToAutoSave(const Value: boolean);
    procedure SetNoAutoSave(const Value: boolean);
    procedure SetAutoSaveNeeded(const Value: boolean);
    procedure SetProjectFromFile(const Value: string);
    procedure SetScriptSender(const Value: TElement);
    function GetMapSheetFiller: TMapSheetFiller;
    function GetMapSheets: TMapSheets;
    function GetSelectedTemplates: TStringListElement;
    function GetTemplateLibrary: TStringList;
    procedure SetMapSheets(const Value: TMapSheets);
    procedure SetTemplateLibrary(const Value: TStringList);
    function GetSelectedMapSpace: TMapSpace;
    function GetSelectedMapSpaces: TEntity;
    function GetSelectedTemplate: string;
    procedure SetPrintToFile(const Value: boolean);
    function GetBinRasAsBitmap: boolean;
    procedure SetBinRasAsBitmap(const Value: boolean);
    procedure SetExternalTemplate(const Value: string);
    procedure SetUseExternalTemplate(const Value: boolean);
protected
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   SaveTemplateLibrary;
   procedure   SetUpAutoSave;
   procedure   CheckModelVersion;
   procedure   SetModelVersion;
   procedure   CreateNewModel;
   procedure   OpenLastProject;
   procedure   LoadProjectFromFile(aFile: string);
   procedure   SaveProject;
   procedure   CheckProjectForSave;
   procedure   LoadData30;
   procedure   SaveData30;
   procedure   LoadProjectData;
   procedure   SaveProjectData;
   procedure   LoadProjectionInfo;
   procedure   SaveProjectionInfo;
   procedure   LoadMaps;
   procedure   SaveMaps;
   procedure   CreateStat;
   procedure   CreateStatUpdate;
   procedure   LoadZnDBF;
   procedure   ImportData;
   procedure   LoadEditorModelFile;
   procedure   SaveEditorModelFile;
   procedure   SetEditorData;
   procedure   ViewProjectIntroDialog;
   procedure   RunStartScripts; override;
   function    GetOptions: TBaseOptions; override;
   procedure   SetOptions(aValue: TBaseOptions); override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_SetUpProject(var Handled: boolean); virtual;
   procedure  on_tm_ProjectManager(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProjectAs(var Handled: boolean); virtual;
   procedure  On_tm_ArchiveProjectAs(var Handled: boolean); virtual;
   procedure  On_tm_Import(var Handled: boolean); virtual;
   procedure  On_tm_Export(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  On_tm_Editor(var Handled: boolean); virtual;
   procedure  On_tm_ModelChanged(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_NewMapSheet(var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_Pruvodce(var Handled: boolean); virtual;
   procedure  on_tm_Template(var Handled: boolean); virtual;
   procedure  on_tm_TemplateSelected(var Handled: boolean); virtual;
   procedure  on_tm_TemplateTouched(var Handled: boolean); virtual;
   procedure  on_tm_MapSpaceTouched(var Handled: boolean); virtual;
   procedure  On_tm_AddTemplate(var Handled: boolean);
   procedure  On_tm_DeleteTemplate(var Handled: boolean);
   procedure  On_tm_NotePadTemplate(var Handled: boolean);
   procedure  On_tm_NotePadMSC(var Handled: boolean);
   procedure  On_tm_NotePadOIL(var Handled: boolean);
   procedure  On_tm_EditTemplate(var Handled: boolean);
   procedure  on_tm_CreateGuideAuto(var Handled: boolean); virtual;
   procedure  on_tm_CreateGuideMan(var Handled: boolean); virtual;
   procedure  on_tm_GuideSelect(var Handled: boolean); virtual;
   procedure  on_tm_CloseGuide(var Handled: boolean); virtual;
   procedure  on_tm_Automat(var Handled: boolean); virtual;
   procedure  on_tm_EndOfPrint(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_Intro; virtual;
   procedure  on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;
   function   LogFileOpen: TStringList;
   procedure  LogFileSave(const SL: TStringList);
   procedure  LogProject;
   procedure  LogLogProject(const SL: TStringList);
   procedure  LogStart;
   procedure  LogEnd;
   function   GetIniFile30: string;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   GuideTool: TGuideFormTool read FGuideTool write FGuideTool;
   property   MapSheetFiller: TMapSheetFiller read GetMapSheetFiller;
   property   TemplateForm: TF_Template read FTemplateForm write FTemplateForm;
   property   TemplateLibrary: TStringList read GetTemplateLibrary write SetTemplateLibrary;
   property   SelectedTemplates: TStringListElement read GetSelectedTemplates;
   property   MapSheets: TMapSheets read GetMapSheets write SetMapSheets;
   property   ExePath: string read GetExePath;
   property   ButtonCount: integer read FButtonCount write SetButtonCount;
   property   CaptionString: string read FCaptionString write SetCaptionString;
   property   EditorModel: TToolModel read GetEditorModel;
   property   ScriptDirectory: string read GetScriptDirectory;
   property   AutoSaveNeeded: boolean read FAutoSaveNeeded write SetAutoSaveNeeded;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   ScriptSender: TElement read FScriptSender write SetScriptSender;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   NewImage: string write SetNewImage;
   property   ActualAction: integer read FActualAction write SetActualAction;
   property   ActualActionVisible: boolean read GetActualActionVisible write SetActualActionVisible;
   property   ActualActionScript: string read GetActualActionScript write SetActualActionScript;
   property   ActualActionImageIndex: integer read GetActualActionImageIndex write SetActualActionImageIndex;
   property   ActualActionCaption: string read GetActualActionCaption write SetActualActionCaption;
   property   ActualActionHint: string read GetActualActionHint write setActualActionHint;
   property   ImageHeight: integer read GetImageHeight write SetImageHeight;
   property   ImageWidth: integer read GetImageWidth write SetImageWidth;
   property   ShowActionCaptions: boolean write SetShowActionsCaptions;
   property   Project: TORBISMapperProject read FProject write SetProject;
   property   Editor: TControlGroup read GetEditor write SetEditor;
   property   ProjectChanged: boolean read GetProjectChanged write SetProjectChanged;
   property   TimeToAutoSave: boolean write SetTimeToAutoSave;
   property   NoAutoSave: boolean read FNoAutoSave write SetNoAutoSave;
   property   ProjectFromFile: string write SetProjectFromFile;
   property   SelectedTemplate: string read GetSelectedTemplate stored false;
   property   SelectedMapSpaces: TEntity read GetSelectedMapSpaces stored false;
   property   SelectedMapSpace: TMapSpace read GetSelectedMapSpace stored false;
   property   PrintToFile: boolean write SetPrintToFile;
   property   IniFile30: string read GetIniFile30 stored false;
   property   BinRasAsBitmap: boolean read GetBinRasAsBitmap write SetBinRasAsBitmap;
   Property   UseExternalTemplate: boolean read FUseExternalTemplate write SetUseExternalTemplate;
   property   ExternalTemplate: string read FExternalTemplate write SetExternalTemplate;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  ActnList,
  _IniFile,
  //PrintToFile,
// KERNEL
  E_Files,
  M_Orbis,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  f_CmdLn,
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Stat,
  e_Reg,
  e_VersionInfo,
// INTERPRET
//Device
  e_ProjectionInfo,
  e_IScrpt,
  e_ThematicMap,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
  t_Saver,
  t_Loader,
// TOPOL
  //e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  f_Option,
  //F_Start,
  M_Proj,
// APP
  t_ProjectIntroDialog,
  t_ConfirmDialog,
  t_GraphicForm,
  f_GraphicForm,
// LHC
  t_MapperProjectDialog,
 //t_LHCImportDialog,
  t_LHCProjectManager,
  //!!! t_exportLHCDialog,
  //!!! t_ExpLHC,
  //!!! t_HelLHC,
// FILES
  u_File,
  u_Global,
// REG
// RASTER
  e_Raster,
  FileVersion,
  u_cktm,
// MAPPER
  t_MSEdit,
  t_VieMap;

{TOptions}


function TOptions.GetBDETransLiterate: boolean;
begin
   result := DBTransLiterate;
end;

function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;

function TOptions.GetRaster: boolean;
begin
   result := UseRasters;
end;

function TOptions.GetStrictRect: boolean;
begin
   result := u_Symbol.StrictRects;
end;

procedure TOptions.SetAutoOpenLastProject(const Value: boolean);
begin
   FAutoOpenLastProject := Value;
end;

procedure TOptions.SetAutoSave(const Value: boolean);
begin
  FAutoSave := Value;
end;

procedure TOptions.SetAutoSaveInterval(const Value: integer);
begin
  FAutoSaveInterval := Value;
end;

procedure TOptions.SetBDETransLiterate(const Value: boolean);
begin
   DBTransLiterate := Value;
end;

procedure TOptions.SetCodePage(const Value: TCodePage);
begin
  FCodePage := Value;
  DefaultCodePage := Value;
end;

procedure TOptions.SetCompatibility30(const Value: boolean);
begin
  FCompatibility30 := Value;
end;

procedure TOptions.SetDirectory30(const Value: string);
begin
  FDirectory30 := Value;
end;

procedure TOptions.SetDontViewProjectIntroDialog(const Value: boolean);
begin
  FDontViewProjectIntroDialog := Value;
end;

procedure TOptions.SetEditorDataScript(const Value: string);
begin
  FEditorDataScript := Value;
end;

procedure TOptions.SetEditorOn(const Value: boolean);
begin
  FEditorOn := Value;
end;

procedure TOptions.SetEditorScript(const Value: string);
begin
  FEditorScript := Value;
end;

procedure TOptions.SetExportControlDirectory(const Value: string);
begin
  FExportControlDirectory := Value;
end;


procedure TOptions.SetExportScript(const Value: string);
begin
  FExportScript := Value;
end;

procedure TOptions.SetImportScript(const Value: string);
begin
  FImportScript := Value;
end;


procedure TOptions.SetLOG(const Value: boolean);
begin
  FLOG := Value;
end;

procedure TOptions.SetNewVersion(const Value: boolean);
begin
  FNewVersion := Value;
end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   PaletFile := GetAbsolutePath(Value);
   NactiBarvickuZeSouboru(Value);
end;

procedure TOptions.SetPrintDirectory(const Value: string);
begin
  FPrintDirectory := Value;
end;

procedure TOptions.SetPrintToFile30Script(const Value: string);
begin
   FPrintToFile30Script := Value;
end;

procedure TOptions.SetPrintToFileEnabled(const Value: boolean);
begin
  FPrintToFileEnabled := Value;
end;

procedure TOptions.SetProjectDirectory(const Value: string);
begin
   FProjectDirectory := GetAbsolutePath(Value);
end;

procedure TOptions.SetProjectFile(const Value: string);
begin
  FProjectFile := Value;
end;

procedure TOptions.SetRaster(const Value: boolean);
begin
   UseRasters := value;
end;

procedure TOptions.SetRun30Script(const Value: string);
begin
  FRun30Script := Value;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
   RemoveBackSlash(PathOfLibraries);
end;


procedure TOptions.SetStrictRect(const Value: boolean);
begin
   StrictRects := Value;
end;

{TMainTool}


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   //result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   //result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   //result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   //result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   //MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  //Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
var
   CmdLn: TCommandLine;
   S: string;
begin
   if aFileName = '' then exit;
   S := aFileName;
   S := StringReplace(S,'$SCRIPT',Options.ScriptDirectory,[rfReplaceAll, rfIgnoreCase]);
   S := GetAbsolutePath(S);
   CmdLn := TCommandLine.Create;
   CmdLn.FileName := S;
   CmdLn.DoIt;
   CmdLn.Free;
   Application.ProcessMessages;
   //CommandLine.FileName:= aFileName;
   //CommandLine.DoIt
end;





procedure TMainTool.DoIt;
var
   S: string;
begin
   SHPasTopol := true;   // nouzovka....
   getDir(0, S);
   //Options.WorkingDirectory := S;
   Options.DataDirectory := S;
   inherited;
   Application.ProcessMessages;
   CaptionString := MainForm.Caption + '- ';
   PostMsg(tm_Intro,Self,nil,false);
   Text := 'Inicializace O.K.';
   //SetupAutoSave;
   MainForm.OpenOIL.InitialDir := Options.ScriptDirectory;
   MainForm.Panel1.ManualFloat(Rect(50,50,350,150));
   MainForm.Panel1.Visible := false;
   MainForm.StatusBar.ManualFloat(Rect(Screen.WorkAreaWidth-400,Screen.WorkAreaHeight-80,Screen.WorkAreaWidth,Screen.WorkAreaHeight-60));
   //LogStart;
   {
   Options.PrintToFileEnabled := Patch_TPrinter_BeginDoc;
   S := '1';
   if not Options.PrintToFileEnabled then
   begin
      //S := '2';
      //Options.PrintToFileEnabled := Patch_StartDoc_ImportTable;
      if not Options.PrintToFileEnabled then
      begin
         S := '3';
         Options.PrintToFileEnabled := Patch_StartDoc_DLL_Entry;
      end;
   end;
   if not Options.PrintToFileEnabled then
      Text := 'PrintToFile failed'
   else
      Text := 'PrintToFile Enabled '+S;
   }   
end;





procedure TMainTool.ReadParamsFromIni;
var
   IniFile: TIniFile;
begin
   inherited ReadParamsFromIni;
   IniFile:= TIniFile.Create(IniFileName);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
(*
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;
*)
begin
   //IniFile:= TRealIniFile.Create(IniFileName);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   //IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   //SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
   B: boolean;
begin
   Handled := true;
   B := MainForm.Timer.Enabled;
   MainForm.Timer.Enabled := false;
   Application.CreateForm(TF_Options, D);

   D.ed_Script.Text := Options.ScriptDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Project.Text := Options.ProjectDirectory;
   D.c_DontViewDialog.Checked := Options.DontViewProjectIntroDialog;
   D.c_OpenLastProject.Checked := Options.AutoOpenLastProject;
   D.cb_AutoSave.Checked := Options.AutoSave;
   if Options.AutoSaveInterval in [1..180] then
      D.ed_AutoSaveInterval.Value := Options.AutoSaveInterval;
   D.ed_AutoSaveInterval.Enabled := Options.AutoSave;
   if D.ShowModal = mrOk then
   begin
      Options.ScriptDirectory := D.ed_Script.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.ProjectDirectory := D.ed_Project.Text;
      Options.DontViewProjectIntroDialog := D.c_DontViewDialog.Checked;
      Options.AutoOpenLastProject := D.c_OpenLastProject.Checked;
      Options.AutoSave := D.cb_AutoSave.Checked;
      Options.AutoSaveInterval := D.ed_AutoSaveInterval.Value;
      SetUpAutoSave;
   end
   else
      MainForm.Timer.Enabled := B;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   //MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   If not IsPossibleToQuit then exit;
   WriteParamsToIni;
   CheckProjectForSave;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         LogEnd;
         Application.ProcessMessages;
         Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
var
   D: TMapperProjectDialog;
   CD: TOrbisConfirmDialog;
   P: TORBISMapperproject;
   Save: TSave;
   S,S1,S2 : string;

begin
   D := TMapperProjectDialog.Create;
   D.Caption := 'Nov projekt';
   D.ProjectDirectory := GetAbsolutePath(Options.ProjectDirectory);
   D.DoIt;
   if D.result = 1 then
   begin
      LogProject;
      P := TORBISMapperproject(D.Output);
      // projektovy soubor za tepla ulozime
      S := D.ProjectDirectory;
      CheckBackSlash(S);
      S := S+P.Name+'.MPR';
      Save := TSave.Create;
      Save.FileName := S;
      Save.Input := P;
      Save.DoIt;
      Save.Free;
      StartProgress('Tvorba novho projektu: '+P.Name,0,0);
      // Vycistime Model
      CheckProjectForSave;
      CreateNewModel;
      Project := P;
      Options.ProjectFile := S;
      Options.Compatibility30 := P.Compatibility30;
      Options.Directory30 := P.Directory30;
      S1 := P.DataDirectory;
      S2 := P.SymbolsDirectory;
      if P.Compatibility30 then
         LoadData30;
      if (S1 <> '') and not SameText(S1,Options.DataDirectory) then
         Options.DataDirectory := S1;
      if (S2 <> '') and not SameText(S2,Options.ServiceDirectory) then
         Options.ServiceDirectory := S2;
      {
      World.SystemRegister.FreeElement(World.SystemRegister.FindElementName('Projection'));
      ExecuteScript := 'LED\ProjectionInfoModel.OIL';
      // co takhle nejakej import
      CD := TOrbisConfirmDialog.Create;
      CD.Text := 'Byl vytvoen nov projekt s nzvem '+P.Name+
             '. Dosud neobsahuje dn data - pejete si je importovat z TopoLu?';
      CD.Caption := 'Nov projekt';
      CD.DoIt;
      Case CD.Result of
         1:
         begin
            //ImportData;
            SetEditorData;
            PostMsg(tm_Import,nil,nil,false);
         end;
      end;
      CD.Free;
      CreateStat;
      }
      EndProgress;
   end;
   D.Free;
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
var
   Load: TLoad;
   P: TORBISMapperProject;
begin
   MainForm.OpenDialog.InitialDir := Options.ProjectDirectory;
   if MainForm.OpenDialog.Execute then
   begin
      LoadProjectFromFile(MainForm.OpenDialog.FileName);
   end;
   if Options.EditorOn and (Editor = nil) then
      PostMsg(tm_Editor,Self,nil,false);
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin

  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.SimpleText := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   //MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   //F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_SaveProject: on_tm_SaveProject(Handled);
      tm_SaveProjectAs: on_tm_SaveProjectAs(Handled);
      tm_ArchiveProjectAs: on_tm_ArchiveProjectAs(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_Import:     on_tm_Import(Handled);
      tm_Export:     on_tm_Export(aMessage, Handled);
      tm_Editor:     on_tm_Editor(Handled);
      tm_ModelChanged:  on_tm_ModelChanged(aMessage, Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      tm_SetUpProject:  on_tm_SetUpProject(Handled);
      tm_ProjectManager:  on_tm_ProjectManager(Handled);
      tm_ZeroActivity:    TimeToAutoSave := true;
      tm_DropFile: if Editor <> nil then Editor.HandleMessage(aMessage,Handled);
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_NewMapSheet: on_tm_NewMapSheet(Handled);
      tm_MapSheetList: PostMsg(tm_Explore, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

      tm_Pruvodce         : on_tm_Pruvodce(Handled);
      tm_CreateGuideAuto  : on_tm_CreateGuideAuto(Handled);
      tm_CreateGuideMan   : on_tm_CreateGuideMan(Handled);
      tm_GuideSelect      : on_tm_GuideSelect(Handled);

      tm_ReviewGuide      : if GuideTool <> nil then GuideTool.on_tm_Review(aMessage, Handled);

      tm_Template         : on_tm_Template(Handled);
      tm_TemplateSelected : on_tm_TemplateSelected(Handled);
      tm_TemplateTouched  : on_tm_TemplateTouched(Handled);
      tm_MapSpaceTouched  : on_tm_MapSpaceTouched(Handled);
      tm_AddTemplate      : on_tm_AddTemplate(Handled);
      tm_DeleteTemplate   : on_tm_DeleteTemplate(Handled);
      tm_NotePadTemplate  : on_tm_NotePadTemplate(Handled);
      tm_NotePadMSC       : on_tm_NotePadMSC(Handled);
      tm_NotePadOIL       : on_tm_NotePadOIL(Handled);
      tm_EditTemplate     : on_tm_EditTemplate(Handled);


      tm_EndOfPrint       : on_tm_EndOfPrint(Handled);


     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);
      tm_OIL              : on_tm_OIL(aMessage,Handled);

      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
      tm_Run              : on_tm_Run(aMessage,Handled);
      tm_Intro            : on_tm_Intro;
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)
end;


function  TMainTool.GetText: string;
begin
   result := '';
   result := MainForm.StatusBar.SimpleText;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.SimpleText := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;








procedure TMainTool.SetActualAction(const Value: integer);
begin
   FActualAction := Value;
   if FActualAction > 4 then FActualAction := 4;
end;

procedure TMainTool.SetActualActionCaption(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Caption := Value;
end;

procedure TMainTool.SetActualActionImageIndex(const Value: integer);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex := Value;
end;

procedure TMainTool.SetActualActionScript(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Category := Value;
end;

procedure TMainTool.SetActualActionVisible(const Value: boolean);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Visible := Value;
end;

procedure TMainTool.SetButtonCount(const Value: integer);
begin
end;

procedure TMainTool.SetNewImage(const Value: string);
var
   BM: Graphics.TBitmap;
   S: string;
begin
   {
   BM := Graphics.TBitmap.Create;
   S := '';
   if pos(':',Value) = 0 then
   begin
      S := ExePath;
      CheckBackSlash(S);
   end;
   S := S + Value;
   try
      BM.LoadFromFile(S);
   except
   end;
   MainForm.ImageList.AddMasked(BM,clGray);
   }
end;

procedure TMainTool.on_tm_Run(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   S,SS: string;
begin
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   ScriptSender := aMessage.Sender;
   ExecuteScript := S;
   ScriptSender := nil;
end;

function TMainTool.GetActualActionCaption: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Caption;
end;

function TMainTool.GetActualActionImageIndex: integer;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex;
end;

function TMainTool.GetActualActionScript: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Category;
end;

function TMainTool.GetActualActionVisible: boolean;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Visible;
end;

function TMainTool.GetActualActionHint: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Hint;
end;

procedure TMainTool.setActualActionHint(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Hint := Value;
end;

procedure TMainTool.SetShowActionsCaptions(const Value: boolean);
begin
{
   MainForm.ToolBar.ShowCaptions := Value;
   MainForm.ToolBar.ButtonHeight := 50;
   MainForm.ToolBar.ButtonWidth := 50;
}
end;

function TMainTool.GetImageHeight: integer;
begin
   //result := MainForm.ImageList.Height;
end;

function TMainTool.GetImageWidth: integer;
begin
   //result := MainForm.ImageList.Width;
end;

procedure TMainTool.SetImageHeight(const Value: integer);
begin
   //MainForm.ImageList.Height := Value;
end;

procedure TMainTool.SetImageWidth(const Value: integer);
begin
   //MainForm.ImageList.Width := Value;
end;

procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   CMD: TCommandLineDlg;
   El: TElement;
begin
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
   //CMD.FormStyle := fsStayOnTop;
end;

procedure TMainTool.RunStartScripts;
var
  OIL: string;
  S,SS: string;
begin
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ScriptDirectory;
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
end;

procedure TMainTool.On_tm_SaveProject(var Handled: boolean);
begin
   ExecuteScript := 'LED\Project_Before_Save.oil';
   SaveProjectData;
end;

procedure TMainTool.On_tm_SaveProjectAs(var Handled: boolean);
var
   S: string;
begin
   if Project = nil then exit;
   MainForm.SaveDialog.InitialDir := Options.ProjectDirectory;
   if not MainForm.SaveDialog.Execute then exit;
   SaveMaps;
   SaveProjectionInfo;
   S := ExtractFileName(MainForm.SaveDialog.FileName);
   S := ChangeFileExt(S,'');
   Project.Name := S;
   //Project.DataDirectory := ExtractFilePath(MainForm.SaveDialog.FileName);
   Options.ProjectFile := MainForm.SaveDialog.FileName;
   MainForm.Caption := CaptionString + Project.Name;
   ExecuteScript := 'LED\Project_Before_Save.oil';
   //SaveProjectData;
   //ShowMessage(S);

end;

procedure TMainTool.On_tm_ArchiveProjectAs(var Handled: boolean);
var
   S,SN,SD,SF,SProjectName,SProjectFile,SCaption,SDataDirectory: string;
   modif: boolean;
begin
   if Project = nil then exit;
   modif := Project.Modified;
   SN := Options.ProjectDirectory;
   CheckBackSlash(SN);
   SF := 'yymmddhhnn';
   DateTimeToString(SD, SF, Now);
   SN := SN+Project.Name+SD+'.MPR';
   //SN := SN+DateTimeToStr(Now);
   MainForm.SaveDialog.InitialDir := Options.ProjectDirectory;
   MainForm.SaveDialog.FileName := SN;
   if not MainForm.SaveDialog.Execute then exit;
   S := ExtractFileName(MainForm.SaveDialog.FileName);
   S := ChangeFileExt(S,'');
   SProjectName := Project.Name;
   SProjectFile := Options.ProjectFile;
   SDataDirectory := Project.DataDirectory;
   SCaption := MainForm.Caption;
   Project.Name := S;
   Project.DataDirectory := ExtractFilePath(MainForm.SaveDialog.FileName);
   Options.ProjectFile := MainForm.SaveDialog.FileName;
   MainForm.Caption := CaptionString + Project.Name +' Archivace';
   SaveMaps;
   SaveProjectionInfo;
   SaveProjectData;
   Project.Name := SProjectName;
   Project.DataDirectory := SDataDirectory;
   Project.Modified := modif;
   Options.ProjectFile := SProjectFile;
   MainForm.Caption := SCaption;
   //ShowMessage(S);

end;

procedure TMainTool.ViewProjectIntroDialog;
var
   D: TProjectIntroDialog;
begin
   D := TProjectIntroDialog.Create;
   D.LastProjectName := Options.ProjectFile;
   D.DoIt;
   case D.Result of
      4:  PostMsg(tm_NewProject,Self,nil,false);
      5:  PostMsg(tm_OpenProject,Self,nil,false);
      6:  OpenLastProject;
   end;
   if D.DontViewDialog then Options.DontViewProjectIntroDialog := true
                       else Options.DontViewProjectIntroDialog := false;
   if D.OpenLastProject then Options.AutoOpenLastProject := true
                        else Options.AutoOpenLastProject := false;
   D.Free;
end;

procedure TMainTool.OpenLastProject;
begin
   LoadProjectFromFile(Options.ProjectFile);
end;

procedure TMainTool.SetProject(const Value: TORBISMapperProject);
var
   S: string;
begin
   ExChangeFieldElement(TElement(FProject),Value);
   if Value <> nil then
   begin
      S := '';
      if Value.Compatibility30 then
      begin
         S := ' / Map 3.0 ['+Value.Directory30+']';
      end;
      MainForm.Caption := CaptionString + Value.Name+S;
      MainForm.a_SaveProject.Enabled := true;
      MainForm.a_SaveProjectAs.Enabled := true;
      MainForm.a_ArchiveProjectAs.Enabled := true;
   end;
end;

procedure TMainTool.on_tm_Intro;
begin
   if ParamCount > 0 then
   begin
      // kontrola projektovho souboru
      LoadProjectFromFile(ParamStr(1));
   end
   else
   if not Options.DontViewProjectIntroDialog then
      ViewProjectIntroDialog
   else if Options.AutoOpenLastProject then OpenLastProject;
   if Options.EditorOn then
   begin
      PostMsg(tm_Editor,Self,nil, false);
   end;
end;

procedure TMainTool.CreateNewModel;
var
   S,SS: string;
   E: TEntity;
begin
   ProgressText := 'Ruen stvajcho modelu...';
   Application.ProcessMessages;
   E := World.ObjectModel;
   NextElement := E;
   World.ObjectModel := nil;
   E.Free();
   ProgressText := 'Vytven struktury novho  modelu...';
   Application.ProcessMessages;
   S := ScriptDirectory;
   CheckBackSlash(S);
   SS := S + 'Model.Oil';
   ExecuteScript := SS;
   //LoadMaps;
   ProgressText := 'Struktura novho modelu zdrn vytvoena';
   //LoadZnDBF;
   Application.ProcessMessages;
end;

procedure TMainTool.ImportData;
begin
   ProgressText := 'Probh import externch dat ...';
   Application.ProcessMessages;
   ExecuteScript := Options.ImportScript;
   Project.Modified := true;
   //Project.LastChangesExported := true;
end;

procedure TMainTool.on_tm_SetUpProject(var Handled: boolean);
var
   D: TMapperProjectDialog;
   S,S1: string;
begin
   if Project = nil then exit;
   D := TMapperProjectDialog.Create;
   D.ProjectDirectory := Options.ProjectDirectory;
   D.Input := Project;
   //S := Project.ExternalDataDirectory;
   //S1 := Project.ExternalDataDirectory;
   D.DoIt;
   if Project.Compatibility30 then
   begin
      Options.ServiceDirectory := Project.SymbolsDirectory;
      Options.DataDirectory := Project.DataDirectory
   end;
   SaveProject;
end;

procedure TMainTool.On_tm_Export(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   NoAutoSave := true;
   Handled:= true;
   //if not (aMessage is TOrbisTextMessage) then exit;
   {
   S := TOrbisTextMessage(aMessage).Text;
   if StringAsTwoParams(S,'&',S1,S2) then
      S := S1+S2;
   ExecuteScript := Options.GetPropertyStringByName(S+'Script');
   }
   ExecuteScript := Options.ExportScript;
   NoAutoSave := false;
end;

procedure TMainTool.On_tm_Import(var Handled: boolean);
begin
   ExecuteScript := Options.ImportScript;
   Application.ProcessMessages;
end;
(*
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
*)



procedure TMainTool.LoadProjectFromFile(aFile: string);
var
   Load: TLoad;
   NewProject: TORBISMapperProject;
   Imp: boolean;
begin
   if not FileExists(aFile) then
   begin
      ShowMessage('Projektov soubor '+aFile+' asi umel!!!');
      exit;
   end;
   if (aFile <> Options.ProjectFile) or (Project = nil) then
   begin
      StartProgress('Otevrn projektu: '+ aFile,0,0);
      ProgressText := 'ten projektovho souboru ...';
      PostMsg(tm_ToolSelected,Editor,nil,false);
      //PostMsg(tm_TaskSelected,Editor,nil,false);
      Application.ProcessMessages;
      Load := TLoad.Create;
      Load.FileName := aFile;
      Load.DoIt;
      NewProject := TORBISMapperProject(Load.Output);
      ProgressText := 'Kontrola uloen pvodnho projektu ...';
      Application.ProcessMessages;
      CheckProjectForSave;
      //LogProject;
      Project := NewProject;
      Options.ProjectFile := aFile;
      Options.Compatibility30 := Project.Compatibility30;
      Options.Directory30 := Project.Directory30;
      CreateNewModel;
      if Project.Compatibility30 then
         LoadData30;
      //NewProject.DataDirectory := ExtractFilePath(aFile);
      {
      Imp := false;
      if Project.DataFileExists then
      begin
         LoadProjectData;
      end
      else
      begin
         if Confirm('Projekt: '+Project.Name,
          'Projekt neobsahuje dosud dn data, pejete si je nyn naimportovat ?') = 1 then
         begin
            imp := true;
         end;
      end;
      CheckModelVersion;
      LoadProjectionInfo;
      LoadMaps;
      SetEditorData;
      CreateStat;
      if Imp then
         PostMsg(tm_Import,nil,nil,false);
      PostTextMsg(tm_Run,'LED\Project_After_Load.oil',nil);
      }
      EndProgress;
   end;
end;

procedure TMainTool.CheckProjectForSave;
begin
   if Editor <> nil then
      Editor.UpdateModel;
   //SaveEditorModelFile;
   //SaveMaps;
   if Project = nil then exit;
   if Project.Compatibility30 then
   begin
      SaveData30;
      if GuideTool <> nil then
      begin
         PostMsg(tm_QuitTask, GuideTool, nil, DontKill);
         Application.ProcessMessages;
         FGuideTool := nil;
      end;
      if TemplateForm <> nil then
      begin
         TemplateForm.Free;
         TemplateForm := nil;
      end;
      MainForm.Panel1.Visible := false;
   end;
   //SaveProjectionInfo;
   {
   if Project.Modified then
   begin
      if Confirm('Projekt '+ Project.Name + ' zmnn - pejete si ho uloit ?') then
      begin
         ExecuteScript := 'LED\Project_Before_Save.oil';
         SaveProjectData;
      end;
   end;
   ExecuteScript := 'LED\Project_CheckForSave.oil';
   }
end;

procedure TMainTool.LoadProjectData;
var
   Load: TLoad;
   E: TElement;
   Restore: boolean;
   S,S1,S2: string;
begin
   exit;
   {
   Restore := false;
   ProgressText := 'ten datovho souboru ...';
   Application.ProcessMessages;
   E := World.ObjectModel.FindElementName('DATA');
   Load := TLoad.Create;
   Load.FileName := Project.DataFileName;
   try
      Load.DoIt;
      E.Free;
      World.ObjectModel.NextElement := TObjectModel(Load.output);
   except
      if Confirm('Pi natn dat Projektu dolo k Chyb, pejete si obnovu ze zlon souboru?(ANO) Osobn bych doporuoval ukonit aplikaci a zkusit naten znovu (NE,STORNO)') then
         Restore := true;
      if not Restore then
      begin
         if Confirm('Odloit Container do ObjectModel? (nevte-li oem je e, volte NE!)') then
         begin
            World.ObjectModel.NextElement:=Load.Container;
            Load.Container := nil;
         end;
      end;
   end;
   Load.Free;
   if not Restore then exit;
   S := Project.DataFileName;
   S1 := ChangeFileExt(S,'.OR_');
   if not FileExists(S1) then
   begin
      ShowMessage('Je to smutn, ale zlon soubor neexistuje! Bh ehnej GISu.');
      exit;
   end;
   S2 := ChangeFileExt(S,'.OR1');
   if FileExists(S2) then DeleteFile(PChar(S2));
   RenameFile(S,S2);
   RenameFile(S1,S);
   RenameFile(S2,S1);
   ProgressText := 'ten zlonho datovho souboru ...';
   Application.ProcessMessages;
   E := World.ObjectModel.FindElementName('DATA');
   Load := TLoad.Create;
   Load.FileName := Project.DataFileName;
   try
      Load.DoIt;
      if E <> nil then
         E.Free;
      World.ObjectModel.NextElement := TObjectModel(Load.output);
   except
      if Confirm('I pi natn dat Projektu ze zlohy dolo k Chyb, soubory budou vrceny do pvodnho stavu bez ohledu na Vai odpov. Obrate se s dvrou na autory programu, nadje umr posledn.') then;
      RenameFile(S,S2);
      RenameFile(S1,S);
      RenameFile(S2,S1);
   end;
   Load.Free;
   }
end;

procedure TMainTool.SaveProjectData;
var
   Save: TSave;
   BackFileName,BackFileName1,NewFileName,FileName: string;
   E: TElement;
begin
   exit;
   {
   FileName := Project.DataFileName;
   BackFileName := ChangeFileExt(FileName,'.OR_');
   BackFileName1 := ChangeFileExt(FileName,'.OR ');
   NewFileName := ChangeFileExt(FileName,'.ORN');
   E := World.ObjectModel.FindElementName('DATA');
   if E = nil then exit;
   Save := TSave.Create;
   Save.Input := E;
   Save.FileName := NewFileName;
   Save.DoIt;
   Save.Free;
   Project.Modified := false;
   Saveproject;
   if FileExists(BackFileName1) then
      DeleteFile(PChar(BackFileName1));
   if FileExists(BackFileName)then
      RenameFile(BackFileName,BackFileName1);
   if FileExists(FileName)then
      RenameFile(FileName,BackFileName);
   RenameFile(NewFileName,FileName);
   }
end;

procedure TMainTool.SaveProject;
var
   Save: TSave;
begin
   Save := TSave.Create;
   Save.Input := Project;
   Save.FileName := Options.ProjectFile;
   Save.DoIt;
   Save.Free;
   if Project.Compatibility30 then
      SaveData30;
end;

procedure TMainTool.SetCaptionString(const Value: string);
begin
   FCaptionString := Value;
end;

procedure TMainTool.On_tm_Editor(var Handled: boolean);
var
   GF: TGraphic_Form;
   G: TGraphicForm;
begin
   if Editor <> nil then
   begin
      Editor.UpdateModel;
      PostMsg(tm_QuitTask,Editor,nil,false);
      FEditor := nil;
      MainForm.a_GraphicEditor.Checked := false;
      Options.EditorOn := false;
   end
   else
   begin
      if not Options.NewEditor and (EditorModel = nil) then
         LoadEditorModelFile;
      Options.NewEditor := false;
      if EditorModel = nil then
         ExecuteScript := Options.EditorScript;
      if EditorModel = nil then
      begin
         ShowMessage('Chyba skriptu pro vytvoen Editoru!');
         exit;
      end;
      NewToolByModel := EditorModel;
      Application.ProcessMessages;
      //achry Machry...
      G := TGraphicForm(Editor.GetToolByName('GW'));
      GF := G.Form;
      //MainForm.MenuBar.ManualDock(GF.TopBar);
      G.Tasks.ToolBar.ManualFloat(Rect(100,200,132,132));
      G.TaskTools.ToolBar.ManualFloat(Rect(200,200,232,132));
      GF.LeftBar.Visible := false;
      GF.RightBar.Visible := false;
      GF.MenuBar1.Menu := MainForm.MainMenu1;
      //MainForm.ControlBar1.Visible := false;
      MainForm.OnKeyDown := GF.FormKeyDown;
      MainForm.AcceptDropFiles := true;

      GF.ManualDock(MainForm,nil,alClient);
      //Application.ProcessMessages;
      GF.Align := alClient;
      Application.ProcessMessages;
      Editor.Visible := true;
      Application.ProcessMessages;
      if Project = nil then
      begin
         World.SystemRegister.FreeElement(World.SystemRegister.FindElementName('Projection'));
         ExecuteScript := 'LED\ProjectionInfoModel.OIL';
      end;
      if Project <> nil then
         ExecuteScript := Options.EditorDataScript;
      MainForm.a_GraphicEditor.Checked := true;
      Options.EditorOn := true;
      ExecuteScript := 'LED\EditorStart.OIL';
   end;
end;

function TMainTool.GetEditor: TControlGroup;
begin
   result := nil;
   if FEditor = nil then
   begin
      FEditor := TControlGroup(GetToolByName('EDITOR'));
   end;
   result := FEditor;
end;

procedure TMainTool.SetEditor(const Value: TControlGroup);
begin
   ExchangeFieldTool(TTool(Feditor),Value);
end;

function TMainTool.GetEditorModel: TToolModel;
var
   E: Telement;
begin
   result := nil;
   E := World.SystemRegister.FindElementName('EDITOR');
   if not (E is TToolModel) then exit;
   result := TToolModel(E);
end;

procedure TMainTool.SetEditorData;
begin

   if Editor <> nil then
      ExecuteScript := Options.EditorDataScript;
end;

procedure TMainTool.On_tm_ModelChanged(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aProject: TOrbisMapperProject;
begin
   aProject := nil;
   if aMessage.Data = nil then
      aProject := Project
   else
   if (aMessage.Data is TEntity) then
      aProject := TOrbisMapperProject(TEntity(aMessage.Data).FindElementClass(TOrbisMapperProject));
   if aProject <> nil then
      aProject.Modified := true;
end;

function TMainTool.GetScriptDirectory: string;
var
   S: string;
begin
   S := Options.ScriptDirectory;
   CheckBackSlash(S);
   result := GetAbsolutePath(S);
end;

procedure TMainTool.LoadEditorModelFile;
var
   S: string;
   L: TLoad;
begin
   S := ExePath+'LEDEDITOR.ORB';
   if not FileExists(S) then
      exit;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.SystemRegister.NextElement := L.Output;
   L.Free;
end;

procedure TMainTool.SaveEditorModelFile;
var
   S: TSave;
   FN: string;
begin
   if EditorModel = nil then exit;
   FN := ExePath+'LEDEDITOR.ORB';
   S := TSave.Create;
   S.Input := EditorModel;
   S.FileName := FN;
   S.DoIt;
   S.Free;
end;

procedure TMainTool.CheckModelVersion;
var
   Ver,_Ver: TVersionInfoElement;
   V1,V2,_V1,_V2: integer;
   En: TEntity;
begin
   V1 := 0;
   V2 := 0;
   _V1 := 0;
   _V2 := 0;

   _Ver := TVersionInfoElement(World.ObjectModel.FindElementName('Version'));
   if _Ver <> nil then
   begin
      _V1 := _Ver.MajorVersion;
      _V2 := _Ver.MinorVersion;
   end
   else
      exit;

   En := TEntity(World.ObjectModel.FindElementName('DATA'));
   if En = nil then exit;
   Ver := TVersionInfoElement(En.FindElementName('Version'));
   if Ver <> nil then
   begin
      V1 := Ver.MajorVersion;
      V2 := Ver.MinorVersion;
   end;
   if (V1 < _V1) or (V2 < _V2) then
      ExecScript('LED\UpgradeVersion.oil');
end;

procedure TMainTool.SetModelVersion;
begin

end;

procedure TMainTool.LoadProjectionInfo;
var
   S: string;
   L: TLoad;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementClass(TProjectionInfoModel));
   S := ChangeFileExt(Options.ProjectFile,'.OPP');
   if not FileExists(S) then
   begin
      ExecuteScript := 'LED\ProjectionInfoModel.OIL';
      exit;
   end;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.ObjectModel.NextElement := L.Output;
   L.Free;
end;

procedure TMainTool.SaveProjectionInfo;
var
   S: string;
   Save: TSave;
   E: TElement;
begin
   S := ChangeFileExt(Options.ProjectFile,'.OPP');
   E := World.ObjectModel.FindElementClass(TProjectionInfoModel);
   if E = nil then exit;
   Save := TSave.Create;
   Save.FileName := S;
   Save.Input := E;
   Save.DoIt;
   Save.Free;
end;

procedure TMainTool.LoadMaps;
var
   S: string;
   L: TLoad;
   E: TElement;
   ByScript: boolean;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('MAPS'));
   ByScript := Project = nil;
   if not ByScript then
   begin
      S := ChangeFileExt(Options.ProjectFile,'.OMP');
      ByScript := not FileExists(S);
   end;
   if ByScript then
   begin
      ExecuteScript := 'LED\Maps.OIL';
   end
   else
   begin
      L := TLoad.Create;
      L.FileName := S;
      L.DoIt;
      World.ObjectModel.NextElement := L.Output;
      L.Free;
   end;
   E := World.ObjectModel.FindElementName('MAPS');
   if not (E is TThematicMaps) then exit;
   TThematicMaps(E).Reset := True;
end;

procedure TMainTool.SaveMaps;
var
   S: string;
   Save: TSave;
   E: TElement;
   M: TThematicMaps;
begin
   S := ChangeFileExt(Options.ProjectFile,'.OMP');
   E := World.ObjectModel.FindElementName('MAPS');
   if E = nil then exit;
   if not (E is TThematicMaps) then
   begin
      PostTextMsg(tm_AddToProtocol,'Project Error: Maps not found',nil);
      exit;
   end;
   M := TThematicMaps(E);
   M.Clear;
   Save := TSave.Create;
   Save.FileName := S;
   Save.Input := E;
   Save.DoIt;
   Save.Free;
   M.Reset := True;
end;

procedure TMainTool.on_tm_ProjectManager(var Handled: boolean);
//var
   //M: TLHCProjectManager;
begin
   //M := TLHCProjectManager.Create;
   //M.Caption := 'Stav projektu:'+Project.Name;
   //M.DoIt;
   //M.Free;
   ExecuteScript := 'LED\Project.OIL';
end;

procedure TMainTool.LoadZnDBF;
var
   S: string;
   L: TLoad;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('Znacky_DBF'));
   S := ExePath+'LED\Zn.orb';
   if not FileExists(S) then
   begin
      ShowMessage('Soubor druh '+S+' neexistuje! (co je asi chyba)');
      exit;
   end;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.ObjectModel.NextElement := L.Output;
   L.Free;
end;

function TMainTool.GetProjectChanged: boolean;
begin
   result := false;
   if Project <> nil then
      result := Project.Modified;
end;

procedure TMainTool.SetProjectChanged(const Value: boolean);
begin
   if Project <> nil then
      Project.Modified := Value;
end;

procedure TMainTool.SetTimeToAutoSave(const Value: boolean);
begin
   if not ProjectChanged then
   begin
      AutoSaveNeeded := false;
      exit;
   end;
   if NoAutoSave then
   begin
      AutoSaveNeeded := true;
      exit;
   end;
   AutoSaveNeeded := false;
   if not ReadyForZeroActivity then exit;
   MainForm.Timer.Enabled := false;
   Application.ProcessMessages;
   SaveProjectData;
   MainForm.Timer.Enabled := true;
   EndZeroActivity;
end;

procedure TMainTool.SetUpAutoSave;
begin
   MainForm.Timer.Interval := Options.AutoSaveInterval*60000;
   MainForm.Timer.Enabled := Options.AutoSave;
end;

procedure TMainTool.SetNoAutoSave(const Value: boolean);
begin
   FNoAutoSave := Value;
   if not Value and AutoSaveNeeded then
      TimeToAutoSave := true;
end;

procedure TMainTool.SetAutoSaveNeeded(const Value: boolean);
begin
   FAutoSaveNeeded := Value;
end;



procedure TMainTool.LogEnd;
var
   SL: TStringList;
begin
   exit;
   if not Options.LOG then exit;
   SL := LogFileOpen;
   if SL = nil then exit;
   LogLogProject(SL);
   SL.Add('*LED END   '+DateTimeToStr(Now));
   SL.Add('********************************');
   LogFileSave(SL);
   SL.Free;
end;

function TMainTool.LogFileOpen: TStringList;
var
   S,SF: string;
begin
   result := nil;
   exit;
   if not Options.LOG then exit;
   result := TStringList.Create;
   SF := 'yymmdd';
   DateTimeToString(S,SF,Now);
   S := 'LED'+S+'.log';
   S := GetAbsolutePath(S);
   if not FileExists(S) then exit;
   result.LoadFromFile(S);
end;

procedure TMainTool.LogStart;
var
   SL: TStringList;
begin
   exit;
   if not Options.LOG then exit;
   SL := LogFileOpen;
   if SL = nil then exit;
   SL.Add('*LED START '+DateTimeToStr(Now));
   LogFileSave(SL);
   SL.Free;
end;

procedure TMainTool.LogFileSave(const SL: TStringList);
var
   S,SF: string;
begin
   exit;
   if not Options.LOG then exit;
   if SL = nil then exit;
   SF := 'yymmdd';
   DateTimeToString(S,SF,Now);
   S := 'LED'+S+'.log';
   S := GetAbsolutePath(S);
   SL.SaveToFile(S);
end;

procedure TMainTool.LogProject;
var
   SL: TStringList;
begin
   exit;
   if not Options.LOG then exit;
   SL := LogFileOpen;
   if SL = nil then exit;
   LogLogProject(SL);
   LogFileSave(SL);
   SL.Free;
end;

procedure TMainTool.LogLogProject(const SL: TStringList);
var
   SI: TStatLayerInfos;
   i: integer;
   SS: TStatLayerInfo;
   e: TElement;
   S: string;
   int: integer;
   d: double;
   Ul: boolean;
begin
   exit;
   if not Options.LOG then exit;
   if Project = nil then exit;
   if SL = nil then exit;
   SL.Add(' Project: '+Project.Name);
   CreateStatUpdate;
   SI := TStatLayerInfos(World.ObjectModel.FindElementClass(TStatLayerInfos));
   if SI = nil then exit;
   Ul := false;
   for i := 0 to SI.LastIndex do
   begin
      e := SI.Elements[i];
      if not (e is TStatLayerInfo) then continue;
      SS := TStatLayerInfo(e);
      if SS.IsNew then
      begin
         S := '  '+SS.Name+'  NEW ';
         S := S + ' count:'+IntToStr(SS.Count);
         if SS.IsArea then
            S := S + ' area:'+ FloatToStr(SS.Area);
         SL.Add(S);
         Ul := true;
      end
      else
      begin
         if (SS.Count <> SS.NewCount) or (SS.IsArea and(SS.NewArea <> SS.Area)) then
         begin
            S := '  '+SS.Name+'  change ';
            int := SS.NewCount - SS.count;
            if int <> 0 then
               S := S + ' count+:'+IntToStr(int);
            if SS.IsArea then
            begin
               d := SS.NewArea - SS.Area;
               if d <> 0 then
                  S := S + ' area+:'+ FloatToStr(d);
            end;
            SL.Add(S);
            Ul := true;
         end;
      end;
   end;
   if Ul then
   begin
      S := '  Ulozeno: ';
      if Project.Modified then
         S := S + 'NE (teda ne vsechno)'
      else
         S := S + 'ANO';
      SL.Add(S);
   end;
end;

procedure TMainTool.CreateStat;
var
   e: TElement;
   En: TEntity;
   SI: TStatLayerInfos;
begin
   exit;
   if not Options.LOG then exit;
   SI := TStatLayerInfos(World.ObjectModel.CreateElement('TStatLayerInfos','STAT'));
   e := TEntity(World.ObjectModel.FindElementName('DATA')).FindElementName('Layers');
   en := TEntity(e);
   SI.CreateFor(en);
end;

procedure TMainTool.CreateStatUpdate;
var
   e: TElement;
   En: TEntity;
   SI: TStatLayerInfos;
begin
   exit;
   if not Options.LOG then exit;
   SI := TStatLayerInfos(World.ObjectModel.FindElementClass(TStatLayerInfos));
   if SI = nil then exit;
   e := TEntity(World.ObjectModel.FindElementName('DATA')).FindElementName('Layers');
   en := TEntity(e);
   SI.UpdateFor(en);
end;

procedure TMainTool.SetProjectFromFile(const Value: string);
begin
   LoadProjectFromFile(Value);
end;

procedure TMainTool.SetScriptSender(const Value: TElement);
begin
  FScriptSender := Value;
end;

procedure TMainTool.On_tm_AddTemplate(var Handled: boolean);
var
  Name: string;
  ShortName, ShortName1: string;
  IniF: TIniFile;
  Index: longInt;
  S: string;
begin
  Handled := true;
  if TemplateForm = nil then exit;
  TemplateForm.odNovaSablona.InitialDir:= Options.TemplateDirectory;
  if TemplateForm.odNovaSablona.Execute then
  begin
     Name:= TemplateForm.odNovaSablona.FileName;
     ShortName:= ExtractFileName(ChangeFileExt(Name, '')); { prvn nastaven }
     if (Name = '') or (ShortName = '') then exit;
     { ten jmna mapovho listu v MSD souboru }
     IniF:= TIniFile.Create(Name);
     if IniF <> nil then
     begin
        S := ShortName;
        ShortName:= IniF.ReadString('TDESKTOP','NAME', ShortName);
        ShortName1:= IniF.ReadString('TMAPA','NAME', ShortName);
        IniF.Free;
        if (UpperCase(ShortName) = 'TDESKTOP') or (ShortName = S) then
        begin
           ShortName := ShortName1;
           if UpperCase(ShortName) = 'TMAPA' then
              ShortName := S;
        end;
     end;
     Index:= TemplateForm.ListBox.Items.Add(ShortName);
     TemplateForm.ListBox.ItemIndex:= Index;

     TemplateLibrary.Add(ShortName + '=' + Name);

     SaveTemplateLibrary;
     PostMsg(tm_TemplateTouched, Self, nil, DontKill);
  end;
end;

procedure TMainTool.on_tm_Automat(var Handled: boolean);
begin
   Handled := true;
end;

procedure TMainTool.on_tm_CloseGuide(var Handled: boolean);
begin

end;

procedure TMainTool.on_tm_CreateGuideAuto(var Handled: boolean);
begin
   Handled := true;
   try
      GuideTool.PostMsg(tm_CreateGuideAuto, GuideTool, nil, DontKill);
   except
   end;
end;

procedure TMainTool.on_tm_CreateGuideMan(var Handled: boolean);
begin
   Handled := true;
   try
      GuideTool.PostMsg(tm_CreateGuideMan, GuideTool, nil, DontKill);
   except
   end;
end;

procedure TMainTool.On_tm_DeleteTemplate(var Handled: boolean);
var
  OldIndex, Index: longInt;
  Item, Name: string;
begin
  Handled := true;
  if (TemplateForm <> nil) and (TemplateLibrary <> nil) then
  begin
   { smazn dku v listboxu }
    OldIndex:= TemplateForm.ListBox.ItemIndex;
    if OldIndex >= 0 then
    begin
      Item := TemplateForm.ListBox.Items.Strings[OldIndex];
      TemplateForm.ListBox.Items.Delete(OldIndex);
     { smazn dku v StringListu }
      Name := TemplateLibrary.Values[Item];
      Index:= TemplateLibrary.IndexOf(Item + '=' + Name);
      if Index >= 0 then
         TemplateLibrary.Delete(Index);

      if OldIndex > 0 then  {nastaven }
         TemplateForm.ListBox.ItemIndex:= OldIndex-1
      else
      if TemplateForm.ListBox.Items.Count > 1 then
         TemplateForm.ListBox.ItemIndex:= 0;
      SaveTemplateLibrary;
    end
  end;
  PostMsg(tm_TemplateTouched, Self, nil, DontKill);
end;

procedure TMainTool.On_tm_EditTemplate(var Handled: boolean);
var
  Map: TMapSheet;
  MSEditor: TMSEditorFormTool;
begin
   MapSheetFiller.Input:= SelectedMapSpace;
   MapSheetFiller.Input:= TStringElement.CreateAll('TEMPLATE', SelectedTemplate);
   MapSheetFiller.Input:= TStringElement.CreateAll('DATADIR', Options.DataDirectory);
   MapSheetFiller.FillGraphics:= false;
   MapSheetFiller.DoIt;
   Map:= TMapSheet(MapSheetFiller.Output);

   MSEditor:= TMSEditorFormTool.Create;
   AddTool(MSEditor);
   MSEditor.Input:= Map;
   MSEditor.FileName := SelectedTemplate;
   MSEditor.DoIt;
{
   if Map <> nil then
      World.PostMsg(tm_AddView, World.MainTool, Map, DontKill);
}
end;

procedure TMainTool.on_tm_EndOfPrint(var Handled: boolean);
begin
   {
   if CancelProcess then
   begin
      MainForm.Dioda.Color := clBtnFace;
      MainForm.Dioda.Enabled := false;
   end;
   if Automat.Busy then Automat.ProcessMap := false;
   }
end;

procedure TMainTool.on_tm_GuideSelect(var Handled: boolean);
begin
   Handled := true;
   if GuideTool = nil then
   begin
      On_tm_Pruvodce(Handled);
   end;
   if GuideTool = nil then exit;
   PostMsg(tm_GuideSelect, GuideTool, nil, DontKill);
end;

procedure TMainTool.on_tm_MapSpaceTouched(var Handled: boolean);
begin
   if GuideTool = nil then MainForm.l_MSpace.Caption := 'Nen oteven prvodce !'
   else
   begin
      try
         if SelectedMapSpace = nil then
            MainForm.l_MSpace.Caption := 'Nic vybrno !'
         else
            MainForm.l_MSpace.Caption := SelectedMapSpace.Name;
      except
         MainForm.l_MSpace.Caption := 'Nic vybrno !'
      end;
   end;
end;

procedure TMainTool.On_tm_NotePadMSC(var Handled: boolean);
begin
  Handled:= true;
  UseNotePadFor(ChangeFileExt(SelectedTemplate, '.MSC'))
end;

procedure TMainTool.On_tm_NotePadOIL(var Handled: boolean);
var
   CMD: TCommandLineDlg;
   S: string;
begin
   CMD := TCommandLineDlg.Create(Application);
   CMD.E := World;
   CMD.Show;
   S := ChangeFileExt(SelectedTemplate, '.OIL');
   CMD.DoLoad(S);
   //CMD.FormStyle := fsStayOnTop;
  //!!!!!!!!!
  Handled:= true;
  //UseNotePadFor(ChangeFileExt(SelectedTemplate, '.OIL'))
end;

procedure TMainTool.On_tm_NotePadTemplate(var Handled: boolean);
begin
  Handled:= true;
  UseNotePadFor(SelectedTemplate)
end;

procedure TMainTool.on_tm_Pruvodce(var Handled: boolean);
begin
   Handled := true;
   if GuideTool = nil then
   begin
      //StartProgress('Test Guide',0,30);
      //ProgressText := 'Guide Creating';
      GuideTool := TGuideFormTool.Create;
      GuideTool.WorkingDirectory := Options.Directory30;
      GuideTool.iniFileName := IniFile30;
      GuideTool.LoadAll;
      //ProgressText := 'Guide Displaying';
      GuideTool.DoIt;
      World.MainTool.AddTool(GuideTool);
      //EndProgress;
      //MainForm.Pruvodce.Checked := true;
   end
   else
   begin
      PostMsg(tm_QuitTask, GuideTool, nil, DontKill);
      FGuideTool := nil;
      //MainForm.Pruvodce.Checked := false;
   end;
   PostMsg(tm_MapSpaceTouched, Self, nil, DontKill);
end;

procedure TMainTool.on_tm_Template(var Handled: boolean);
var
  IniFile: TIniFile;
begin
   Handled := true;
   if TemplateForm = nil then
   begin
      Application.CreateForm(TF_Template, FTemplateForm);
      //MainForm.Sablony.Checked := true;

      IniFile:= TIniFile.Create(IniFile30);
      IniFile.ReadSection('TemplateLibrary', TemplateForm.ListBox.Items);
      IniFile.Free;
      TemplateForm.ListBox.ItemIndex := 0;
   end
   else
   begin
     try
       TemplateForm.Free;
       TemplateForm := nil;
       //MainForm.Sablony.Checked := false;
     except
        Application.CreateForm(TF_Template, FTemplateForm);
        //MainForm.Sablony.Checked := true;

        IniFile:= TIniFile.Create(IniFile30);
        IniFile.ReadSection('TemplateLibrary', TemplateForm.ListBox.Items);
        IniFile.Free;
     end;
   end;
   on_tm_TemplateTouched(Handled);
end;

procedure TMainTool.on_tm_TemplateSelected(var Handled: boolean);
//var
//   S: string;
//  Map: TMapSheet;
//  MapViewer: TMapViewer;
//  OILFile: string;
begin
   ExecuteScript := Options.Run30Script;
{ ml bych mt k dispozici
  1. Vybranou ablonu: SelectedTemplate: string;
  2. Vybran prostor:  SelectedMapSpace: TMapSpace;
  3. Pracovn adres: WorkingDirectory: string}
(*
  StartProgress('Vytven mapov kompozice',0,0);
  ProgressText := SelectedTemplate;
  Application.ProcessMessages;
  OILFile := ChangeFileExt(SelectedTemplate, '.OIL');
  if FileExists(OILFile) then
  begin
    ProgressText := 'Byl nalezen OIL soubor, nyn pebr zen tvorby mapy...';
    Application.ProcessMessages;
    CommandLine.FileName := OILFile;
    CommandLine.DoIt;
    CommandLine.FileName := '';
  end
  else
  begin
    if SelectedMapSpace = nil then
    begin
      if MessageDlg('Nen vybrn dn mapov prostor. Pokraovat ?',
                    mtConfirmation, [mbYes, mbNo], 0) = mrNo then
        exit;
    end;
    ProgressText := 'Automatick tvorba mapy ...';
    Application.ProcessMessages;

    MapSheetFiller.Input:= SelectedMapSpace;
    MapSheetFiller.Input:= TStringElement.CreateAll('TEMPLATE', SelectedTemplate);
    MapSheetFiller.Input:= TStringElement.CreateAll('DATADIR', Options.DataDirectory);
    ProgressText := 'Analza vrstev ...';
    Application.ProcessMessages;
    MapSheetFiller.FillGraphics:= true;
    ProgressText := 'Import vrstev ...';
    Application.ProcessMessages;
    MapSheetFiller.DoIt;
    Map:= TMapSheet(MapSheetFiller.Output);
    ProgressText := 'Zobrazen ...';
    Application.ProcessMessages;
    PostMsg(tm_AddView, Self, Map, DontKill);
    {
    MapViewer:= TMapViewer.Create;
    AddTool(MapViewer);
    MapViewer.Input:= Map;
    MapViewer.DoIt;
    }
  end;
  EndProgress;
  Application.ProcessMessages;
{
 if Map <> nil then
    World.PostMsg(tm_AddView, World.MainTool, Map, DontKill);
}
*)
end;

procedure TMainTool.on_tm_TemplateTouched(var Handled: boolean);
var
   S: string;
begin
   if TemplateForm = nil then MainForm.l_Template.Caption := 'Nen otevena knihovna ablon !'
   else
   begin
      S := SelectedTemplate;
      MainForm.l_Template.Caption := S;
      TemplateForm.b_MSD.Down := FileExists(ChangeFileExt(S,'.MSD'));
      TemplateForm.b_MSC.Down := FileExists(ChangeFileExt(S,'.MSC'));
      TemplateForm.b_OIL.Down := FileExists(ChangeFileExt(S,'.OIL'));
   end;
end;

function TMainTool.GetMapSheetFiller: TMapSheetFiller;
begin
   if FMapSheetFiller = nil then
   begin
      FMapSheetFiller := TMapSheetFiller.Create;
      AddTool(FMapSheetFiller);
   end;
   result := FMapSheetFiller;
end;

function TMainTool.GetMapSheets: TMapSheets;
begin
   if FMapSheets = nil then
   begin
      FMapsheets := TMapSheets.Create;
      World.ObjectModel.AddElement(FMapSheets);
   end;
   result := FMapSheets;
end;

function TMainTool.GetSelectedTemplates: TStringListElement;
var
   i: longInt;
begin
   result := TStringListElement.Create;
   if (TemplateForm = nil) or (TemplateLibrary = nil) then exit;
   for i := 0 to TemplateForm.ListBox.Items.Count - 1 do
   begin
      if TemplateForm.ListBox.Selected[i] then
         result.AddNameString('TEMPLATE',
                TemplateLibrary.Values[TemplateForm.ListBox.Items.Strings[i]])
   end;
end;

function TMainTool.GetTemplateLibrary: TStringList;
begin
   if not Assigned(FTemplateLibrary) then FTemplateLibrary := TStringList.Create;
   result := FTemplateLibrary;
end;

procedure TMainTool.SetMapSheets(const Value: TMapSheets);
begin
   if FMapSheets <> nil then
   begin
      World.ObjectModel.FreeElement(FMapSheets);
      FMapSheets := nil;
   end;
   FMapSheets := Value;
   World.ObjectModel.AddElement(FMapSheets);
end;

procedure TMainTool.SetTemplateLibrary(const Value: TStringList);
begin
   if assigned(FTemplateLibrary) then
   begin
      FTemplateLibrary.Free;
      FTemplateLibrary := nil;
   end;
   FTemplateLibrary := Value;
end;

procedure TMainTool.SaveTemplateLibrary;
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFile30);
   IniFile.WriteSection('TemplateLibrary', TemplateLibrary);
   IniFile.Free;
end;

function TMainTool.GetSelectedMapSpace: TMapSpace;
var
   E: TEntity;
begin
   result := nil;
   if GuideTool = nil then exit;
   E := GuideTool.Selected;
   if E = nil then exit;
   if E.Count < 1 then
   begin
      E.Free;
      exit;
   end;
   result := TMapSpace(E.Elements[0]);
   E.Free;
end;

function TMainTool.GetSelectedMapSpaces: TEntity;
begin
   result := nil;
   if GuideTool = nil then exit;
   result := GuideTool.Selected;
end;

function TMainTool.GetSelectedTemplate: string;
begin
   result := '';
   try
   if (TemplateForm <> nil) and (TemplateLibrary <> nil) and
      (TemplateForm.ListBox.ItemIndex >-1) then
         result := TemplateLibrary.Values
                   [TemplateForm.ListBox.Items.Strings
                          [TemplateForm.ListBox.ItemIndex]
                   ]
   else
     if (ParamCount > 0) and fileExists(ParamStr(1)) then
        result:= ParamStr(1);
    except
       MainForm.l_Template.Caption := 'Nen vybrna dn ablona';
    end;
end;

procedure TMainTool.LoadData30;
var
   S: string;
   IniFile: TIniFile;

begin
   MainForm.Panel1.Visible := true;
   IniFile:= TIniFile.Create(IniFile30);
   if Project <> nil then
   begin
      Project.DataDirectory := IniFile.ReadString('OPTIONS','DataDirectory','');
      Options.DataDirectory := Project.DataDirectory;
      Project.SymbolsDirectory := IniFile.ReadString('OPTIONS','ServiceDirectory','');
      Options.ServiceDirectory := Project.SymbolsDirectory;
      Options.PaletteFile := IniFile.ReadString('OPTIONS','PaletteFile','');
      Options.TemplateDirectory := IniFile.ReadString('OPTIONS','TemplateDirectory','');
      MainForm.l_Data.Caption := Options.DataDirectory;
   end;
   IniFile.ReadSectionValues('TemplateLibrary', TemplateLibrary);
   if IniFile.ReadBool('GUIDE', 'Visible', false) then postMsg(tm_Pruvodce, Self, nil, DontKill)
                                                  else postMsg(tm_MapSpaceTouched, Self, nil, DontKill);
   Application.ProcessMessages;
   if IniFile.ReadBool('TEMPLATE', 'Visible', false) then postMsg(tm_Template, Self, nil, DontKill)
                                                     else postMsg(tm_TemplateTouched, Self, nil, DontKill);
   Application.ProcessMessages;
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;

procedure TMainTool.SaveData30;
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;

begin
   IniFile:= TRealIniFile.Create(IniFile30);
   try
   if Project <> nil then
   begin
      IniFile.WriteString('OPTIONS','DataDirectory',Options.DataDirectory);
      IniFile.WriteString('OPTIONS','ServiceDirectory',Options.ServiceDirectory);
      IniFile.WriteString('OPTIONS','PaletteFile',Options.PaletteFile);
      IniFile.WriteString('OPTIONS','TemplateDirectory',Options.TemplateDirectory);
   end;
   B := GuideTool <> nil;
   IniFile.WriteBool('GUIDE', 'Visible', B);

   B := TemplateForm <> nil;
   IniFile.WriteBool('TEMPLATE', 'Visible', B);

   IniFile.WriteSection('TemplateLibrary', TemplateLibrary);
   IniFile.Free;

   SaveTemplateLibrary
   except
      ShowMessage('Problm se zpisem do souboru '+IniFile30);
   end
end;

function TMainTool.GetIniFile30: string;
var
   S: string;
begin
   S := Options.Directory30;
   CHeckBackSlash(S);
   result := S + 'Mapper32.ini'
end;

procedure TMainTool.SetPrintToFile(const Value: boolean);
begin
   ExecuteScript := Options.PrintToFile30Script;
end;

procedure TMainTool.on_tm_NewMapSheet(var Handled: boolean);
var
   Tool: TMSEditorFormTool;
begin
   Tool := TMSEditorFormTool.Create;
   Tool.Device.Page.Color := clSilver;
   AddTool(Tool);
   Tool.DoIt;
   {
   PostMsg(tm_ReView, Tool, nil, DontKill);
   }
end;

function TMainTool.GetBinRasAsBitmap: boolean;
begin
   result := BinRas_Bitmap;
end;

procedure TMainTool.SetBinRasAsBitmap(const Value: boolean);
begin
   BinRas_Bitmap := Value;
end;

procedure TMainTool.SetExternalTemplate(const Value: string);
begin
  FExternalTemplate := Value;
end;

procedure TMainTool.SetUseExternalTemplate(const Value: boolean);
begin
  FUseExternalTemplate := Value;
end;

END.
