unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// MAPPER
  e_Map,
  e_MSpace,
  f_MSEdit,
  f_Templ,
  t_Guide,
  t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  FDelRAS: TStringListElement;
  FDeleteRAS: boolean;
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FWorkingDirectory: String;
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
  function  GetDelRAS: TStringListElement;
  procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
public
  property   DelRAS: TStringListElement read GetDelRAS;
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   WorkingDirectory: string read FWorkingDirectory write FWorkingDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  ViewerIndex: integer;
  FGuideTool: TGuideFormTool;
  FMapSheetFiller: TMapSheetFiller;
  FTemplateForm: TF_Template;
  FMapSheets: TMapSheets;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  FTemplateLibrary: TStringList;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  function  GetOptions: TBaseOptions; override;
  function  GetNOptions: TOptions; virtual;
  procedure SetOptions(aValue: TBaseOptions); override;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
  function  GetGuideTool: TGuideFormTool;
  procedure SetGuideTool(aValue: TGuideFormTool);
  function  GetTemplateLibrary: TStringList;
  procedure SetTemplateLibrary(aValue: TStringList);
  function  GetSelectedTemplate: string;
  function  GetSelectedMapSpace: TMapSpace;
  function  GetSelectedTemplates: TStringListElement;
  function  GetSelectedMapSpaces: TEntity;
  function  GetMapSheets: TMapSheets;
  procedure SetMapSheets(aValue: TMapSheets);
  function  GetMapSheetFiller: TMapSheetFiller;
protected
  function  GetWorkingDirectory: string; override;
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure  SaveTemplateLibrary;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  on_tm_NewMapSheet(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_Pruvodce(var Handled: boolean); virtual;
   procedure  on_tm_Template(var Handled: boolean); virtual;
   procedure  on_tm_TemplateSelected(var Handled: boolean); virtual;
   procedure  on_tm_TemplateTouched(var Handled: boolean); virtual;
   procedure  on_tm_MapSpaceTouched(var Handled: boolean); virtual;
   procedure  On_tm_AddTemplate(var Handled: boolean);
   procedure  On_tm_DeleteTemplate(var Handled: boolean);
   procedure  On_tm_NotePadTemplate(var Handled: boolean);
   procedure  On_tm_NotePadMSC(var Handled: boolean);
   procedure  On_tm_NotePadOIL(var Handled: boolean);
   procedure  On_tm_EditTemplate(var Handled: boolean);
   procedure  on_tm_CreateGuideAuto(var Handled: boolean); virtual;
   procedure  on_tm_CreateGuideMan(var Handled: boolean); virtual;
   procedure  on_tm_GuideSelect(var Handled: boolean); virtual;
   procedure  on_tm_CloseGuide(var Handled: boolean); virtual;
   procedure  on_tm_Automat(var Handled: boolean); virtual;
   procedure  on_tm_EndOfPrint(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;
   procedure  LoadPlugIns;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   GuideTool: TGuideFormTool read FGuideTool write FGuideTool;
   property   MapSheetFiller: TMapSheetFiller read GetMapSheetFiller;
   property   TemplateForm: TF_Template read FTemplateForm write FTemplateForm;
   property   TemplateLibrary: TStringList read GetTemplateLibrary write SetTemplateLibrary;
   property   SelectedTemplates: TStringListElement read GetSelectedTemplates;
   property   MapSheets: TMapSheets read GetMapSheets write SetMapSheets;
   //property   Automat: TAutomap read GetAutomat;
   property   ExePath: string read GetExePath;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   SelectedTemplate: string read GetSelectedTemplate stored false;
   property   SelectedMapSpaces: TEntity read GetSelectedMapSpaces stored false;
   property   SelectedMapSpace: TMapSpace read GetSelectedMapSpace stored false;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  t_Loader,
  t_Saver,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  f_CmdLn,
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// SYMBOL
  u_Symbol,
// INTERPRET
  e_IScrpt,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
// TOPOL
  e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  f_Option,
  F_Start,
  M_Proj,
  u_Cursor,
// FILES
  u_File,
// REG
  FileVersion,
  u_cktm,
// MAPPER
  t_MSEdit,
  t_VieMap;

{TOptions}

function  TOptions.GetDelRAS: TStringListElement;
begin
   if FDelRas = nil then
   begin
      FdelRas := TStringListElement.Create;
      AddElement(FDelRas);
   end;
   result := FDelRas;
end;

function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   PaletFile := Value;
   NactiBarvickuZeSouboru(Value);
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
   RemoveBackSlash(PathOfLibraries);
end;


{TMainTool}

procedure TMainTool.SetMapSheets(aValue: TMapSheets);
begin
   if FMapSheets <> nil then
   begin
      World.ObjectModel.FreeElement(FMapSheets);
      FMapSheets := nil;
   end;
   FMapSheets := aValue;
   World.ObjectModel.AddElement(FMapSheets);
end;



procedure TMainTool.SetTemplateLibrary(aValue: TStringList);
begin
   if assigned(FTemplateLibrary) then
   begin
      FTemplateLibrary.Free;
      FTemplateLibrary := nil;
   end;
   FTemplateLibrary := aValue;
end;



function  TMainTool.GetGuideTool: TGuideFormTool;
begin
   result := FGuideTool;
end;

function  TMainTool.GetMapSheetFiller: TMapSheetFiller;
begin
   if FMapSheetFiller = nil then
   begin
      FMapSheetFiller := TMapSheetFiller.Create;
      AddTool(FMapSheetFiller);
   end;
   result := FMapSheetFiller;
end;

function  TMainTool.GetMapSheets: TMapSheets;
begin
   if FMapSheets = nil then
   begin
      FMapsheets := TMapSheets.Create;
      World.ObjectModel.AddElement(FMapSheets);
   end;
   result := FMapSheets;
end;

function  TMainTool.GetSelectedMapSpace: TMapSpace;
var
   E: TEntity;
begin
   result := nil;
   if GuideTool = nil then exit;
   E := GuideTool.Selected;
   if E = nil then exit;
   if E.Count < 1 then
   begin
      E.Free;
      exit;
   end;
   result := TMapSpace(E.Elements[0]);
   E.Free;
end;

function  TMainTool.GetSelectedMapSpaces: TEntity;
begin
   result := nil;
   if GuideTool = nil then exit;
   result := GuideTool.Selected;
end;

function  TMainTool.GetSelectedTemplate: string;
begin
   result := '';
   try
   if (TemplateForm <> nil) and (TemplateLibrary <> nil) and
      (TemplateForm.ListBox.ItemIndex >-1) then
         result := TemplateLibrary.Values
                   [TemplateForm.ListBox.Items.Strings
                          [TemplateForm.ListBox.ItemIndex]
                   ]
   else
     if (ParamCount > 0) and fileExists(ParamStr(1)) then
        result:= ParamStr(1);
    except
       MainForm.l_Template.Caption := 'Nen vybrna dn ablona';
    end;    
end;

function  TMainTool.GetSelectedTemplates: TStringListElement;
var
   i: longInt;
begin
   result := TStringListElement.Create;
   if (TemplateForm = nil) or (TemplateLibrary = nil) then exit;
   for i := 0 to TemplateForm.ListBox.Items.Count - 1 do
   begin
      if TemplateForm.ListBox.Selected[i] then
         result.AddNameString('TEMPLATE',
                TemplateLibrary.Values[TemplateForm.ListBox.Items.Strings[i]])
   end;
end;

function  TMainTool.GetTemplateLibrary: TStringList;
begin
   if not Assigned(FTemplateLibrary) then FTemplateLibrary := TStringList.Create;
   result := FTemplateLibrary;
end;

procedure TMainTool.SetGuideTool(aValue: TGuideFormTool);
begin
   if assigned(FGuideTool) then
   begin
      FreeElement(FGuideTool);
      FGuideTool := nil;
   end;
   FGuideTool := aValue;
end;

procedure  TMainTool.on_tm_Automat(var Handled: boolean);
begin
   Handled := true;
//   if not Automat.Busy then Automat.DoIt;
end;

procedure TMainTool.On_tm_AddTemplate(var Handled: boolean);
var
  Name: string;
  ShortName: string;
  IniF: TIniFile;
  Index: longInt;
  S: string;
begin
  Handled := true;
  if TemplateForm = nil then exit;
  TemplateForm.odNovaSablona.InitialDir:= Options.TemplateDirectory;
  if TemplateForm.odNovaSablona.Execute then
  begin
     Name:= TemplateForm.odNovaSablona.FileName;
     ShortName:= ExtractFileName(ChangeFileExt(Name, '')); { prvn nastaven }
     if (Name = '') or (ShortName = '') then exit;
     { ten jmna mapovho listu v MSD souboru }
     IniF:= TIniFile.Create(Name);
     if IniF <> nil then
     begin
        S := ShortName;
        ShortName:= IniF.ReadString('TDESKTOP','NAME', ShortName);
        IniF.Free;
        if UpperCase(ShortName) = 'TDesktop' then ShortName := S;
     end;
     Index:= TemplateForm.ListBox.Items.Add(ShortName);
     TemplateForm.ListBox.ItemIndex:= Index;

     TemplateLibrary.Add(ShortName + '=' + Name);

     SaveTemplateLibrary;
     PostMsg(tm_TemplateTouched, Self, nil, DontKill);
  end;
end;


procedure TMainTool.On_tm_DeleteTemplate(var Handled: boolean);
var
  OldIndex, Index: longInt;
  Item, Name: string;
begin
  Handled := true;
  if (TemplateForm <> nil) and (TemplateLibrary <> nil) then
  begin
   { smazn dku v listboxu }
    OldIndex:= TemplateForm.ListBox.ItemIndex;
    if OldIndex >= 0 then
    begin
      Item := TemplateForm.ListBox.Items.Strings[OldIndex];
      TemplateForm.ListBox.Items.Delete(OldIndex);
     { smazn dku v StringListu }
      Name := TemplateLibrary.Values[Item];
      Index:= TemplateLibrary.IndexOf(Item + '=' + Name);
      if Index >= 0 then
         TemplateLibrary.Delete(Index);

      if OldIndex > 0 then  {nastaven }
         TemplateForm.ListBox.ItemIndex:= OldIndex-1
      else
      if TemplateForm.ListBox.Items.Count > 1 then
         TemplateForm.ListBox.ItemIndex:= 0;
      SaveTemplateLibrary;
    end
  end;
  PostMsg(tm_TemplateTouched, Self, nil, DontKill);
end;


procedure  TMainTool.on_tm_CloseGuide(var Handled: boolean);
begin
   {
   on_tm_Pruvodce(Handled);
   }
end;

procedure  TMainTool.on_tm_CreateGuideAuto(var Handled: boolean);
begin
   Handled := true;
   try
      GuideTool.PostMsg(tm_CreateGuideAuto, GuideTool, nil, DontKill);
   except
   end;
end;

procedure  TMainTool.on_tm_CreateGuideMan(var Handled: boolean);
begin
   Handled := true;
   try
      GuideTool.PostMsg(tm_CreateGuideMan, GuideTool, nil, DontKill);
   except
   end;
end;

procedure TMainTool.On_tm_EditTemplate(var Handled: boolean);
var
  Map: TMapSheet;
  MSEditor: TMSEditorFormTool;
begin
   MapSheetFiller.Input:= SelectedMapSpace;
   MapSheetFiller.Input:= TStringElement.CreateAll('TEMPLATE', SelectedTemplate);
   MapSheetFiller.Input:= TStringElement.CreateAll('DATADIR', Options.DataDirectory);
   MapSheetFiller.FillGraphics:= false;
   MapSheetFiller.DoIt;
   Map:= TMapSheet(MapSheetFiller.Output);

   MSEditor:= TMSEditorFormTool.Create;
   AddTool(MSEditor);
   MSEditor.Input:= Map;
   MSEditor.FileName := SelectedTemplate;
   MSEditor.DoIt;
{
   if Map <> nil then
      World.PostMsg(tm_AddView, World.MainTool, Map, DontKill);
}
end;

procedure  TMainTool.on_tm_GuideSelect(var Handled: boolean);
begin
   Handled := true;
   if GuideTool = nil then
   begin
      On_tm_Pruvodce(Handled);
   end;
   if GuideTool = nil then exit;
   PostMsg(tm_GuideSelect, GuideTool, nil, DontKill);
end;

procedure  TMainTool.On_tm_MapSpaceTouched(var Handled: boolean);
begin
   if GuideTool = nil then MainForm.l_MSpace.Caption := 'Nen oteven prvodce !'
   else
   begin
      try
         if SelectedMapSpace = nil then
            MainForm.l_MSpace.Caption := 'Nic vybrno !'
         else
            MainForm.l_MSpace.Caption := SelectedMapSpace.Name;
      except
         MainForm.l_MSpace.Caption := 'Nic vybrno !'
      end;
   end;
end;

procedure  TMainTool.on_tm_NewMapSheet(var Handled: boolean);
var
   Tool: TMSEditorFormTool;
begin
   Tool := TMSEditorFormTool.Create;
   Tool.Device.Page.Color := clSilver;
   AddTool(Tool);
   Tool.DoIt;
   {
   PostMsg(tm_ReView, Tool, nil, DontKill);
   }
end;

procedure TMainTool.On_tm_NotePadMSC(var Handled: boolean);
begin
  Handled:= true;
  UseNotePadFor(ChangeFileExt(SelectedTemplate, '.MSC'))
end;

procedure TMainTool.On_tm_NotePadOIL(var Handled: boolean);
begin
  Handled:= true;
  UseNotePadFor(ChangeFileExt(SelectedTemplate, '.OIL'))
end;

procedure TMainTool.On_tm_NotePadTemplate(var Handled: boolean);
begin
  Handled:= true;
  UseNotePadFor(SelectedTemplate)
end;

procedure  TMainTool.On_tm_Pruvodce(var Handled: boolean);
begin
   Handled := true;
   if GuideTool = nil then
   begin
      //StartProgress('Test Guide',0,30);
      //ProgressText := 'Guide Creating';
      GuideTool := TGuideFormTool.Create;
      //ProgressText := 'Guide Displaying';
      GuideTool.DoIt;
      World.MainTool.AddTool(GuideTool);
      //EndProgress;
      //MainForm.Pruvodce.Checked := true;
   end
   else
   begin
      PostMsg(tm_QuitTask, GuideTool, nil, DontKill);
      FGuideTool := nil;
      //MainForm.Pruvodce.Checked := false;
   end;
   PostMsg(tm_MapSpaceTouched, Self, nil, DontKill);
end;

procedure  TMainTool.On_tm_Template(var Handled: boolean);
var
  IniFile: TIniFile;
begin
   Handled := true;
   if TemplateForm = nil then
   begin
      Application.CreateForm(TF_Template, FTemplateForm);
      //MainForm.Sablony.Checked := true;

      IniFile:= TIniFile.Create(IniFileName);
      IniFile.ReadSection('TemplateLibrary', TemplateForm.ListBox.Items);
      IniFile.Free;
      TemplateForm.ListBox.ItemIndex := 0;
   end
   else
   begin
     try
       TemplateForm.Free;
       TemplateForm := nil;
       //MainForm.Sablony.Checked := false;
     except
        Application.CreateForm(TF_Template, FTemplateForm);
        //MainForm.Sablony.Checked := true;

        IniFile:= TIniFile.Create(IniFileName);
        IniFile.ReadSection('TemplateLibrary', TemplateForm.ListBox.Items);
        IniFile.Free;
     end;
   end;
   on_tm_TemplateTouched(Handled);
end;

procedure  TMainTool.On_tm_TemplateSelected(var Handled: boolean);
var
  Map: TMapSheet;
  MapViewer: TMapViewer;
  OILFile: string;
begin
{ ml bych mt k dispozici
  1. Vybranou ablonu: SelectedTemplate: string;
  2. Vybran prostor:  SelectedMapSpace: TMapSpace;
  3. Pracovn adres: WorkingDirectory: string}
  StartProgress('Vytven mapov kompozice',0,0);
  ProgressText := SelectedTemplate;
  Application.ProcessMessages;
  OILFile := ChangeFileExt(SelectedTemplate, '.OIL');
  if FileExists(OILFile) then
  begin
    ProgressText := 'Byl nalezen OIL soubor, nyn pebr zen tvorby mapy...';
    Application.ProcessMessages;
    CommandLine.FileName := OILFile;
    CommandLine.DoIt;
    CommandLine.FileName := '';
  end
  else
  begin
    if SelectedMapSpace = nil then
    begin
      if MessageDlg('Nen vybrn dn mapov prostor. Pokraovat ?',
                    mtConfirmation, [mbYes, mbNo], 0) = mrNo then
        exit;
    end;
    ProgressText := 'Automatick tvorba mapy ...';
    Application.ProcessMessages;

    MapSheetFiller.Input:= SelectedMapSpace;
    MapSheetFiller.Input:= TStringElement.CreateAll('TEMPLATE', SelectedTemplate);
    MapSheetFiller.Input:= TStringElement.CreateAll('DATADIR', Options.DataDirectory);
    ProgressText := 'Analza vrstev ...';
    Application.ProcessMessages;
    MapSheetFiller.FillGraphics:= true;
    ProgressText := 'Import vrstev ...';
    Application.ProcessMessages;
    MapSheetFiller.DoIt;
    Map:= TMapSheet(MapSheetFiller.Output);
    ProgressText := 'Zobrazen ...';
    Application.ProcessMessages;
    PostMsg(tm_AddView, Self, Map, DontKill);
    {
    MapViewer:= TMapViewer.Create;
    AddTool(MapViewer);
    MapViewer.Input:= Map;
    MapViewer.DoIt;
    }
  end;
  EndProgress;
  Application.ProcessMessages;
{
 if Map <> nil then
    World.PostMsg(tm_AddView, World.MainTool, Map, DontKill);
}
end;


procedure  TMainTool.On_tm_TemplateTouched(var Handled: boolean);
var
   S: string;
begin
   if TemplateForm = nil then MainForm.l_Template.Caption := 'Nen otevena knihovna ablon !'
   else
   begin
      S := SelectedTemplate;
      MainForm.l_Template.Caption := S;
      TemplateForm.b_MSD.Down := FileExists(ChangeFileExt(S,'.MSD'));
      TemplateForm.b_MSC.Down := FileExists(ChangeFileExt(S,'.MSC'));
      TemplateForm.b_OIL.Down := FileExists(ChangeFileExt(S,'.OIL'));
   end;
end;

procedure TMainTool.SaveTemplateLibrary;
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteSection('TemplateLibrary', TemplateLibrary);
   IniFile.Free;
end;







function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
  CommandLine.FileName:= aFileName;
  CommandLine.DoIt
end;


function  TMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   S := Options.WorkingDirectory;
   result := CheckBackSlash(S);
end;



procedure TMainTool.DoIt;
var
  OIL: string;
  S,SS: string;
  Load: TLoad;
begin
   getDir(0, S);
   Options.WorkingDirectory := S;
   Options.DataDirectory := S;
  inherited DoIt;
  LoadUserCursors;

  //Application.CreateForm(Tf_StartForm, f_StartForm);
  //Application.HelpFile := ChangeFileExt(ParamStr(0),'.HLP');
  {
  if not Application.HelpJump('Obsah') then
     ShowMessage('Soubor npovdy neexistuje');
  }
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ExtractFilePath(ParamStr(0));
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
//     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  Text := 'Inicializace Plug - Ins';
  SS := S + 'Plugin.ORB';
  if FileExists(SS) then
  begin
     Load := TLoad.CreateAll(SS);
     try
        Load.DoIt;
        if Load.Output <> nil then
        begin
           Load.Output.Name := 'PLUGIN';
           World.AddElement(Load.Output);
        end;
     except
        ShowMessage('Nelze nalzt soubor '+SS);
     end;
     Load.Free;
     LoadPlugIns;
  end;
  MainForm.l_Data.Caption := Options.DataDirectory;
end;





procedure TMainTool.ReadParamsFromIni;
var
   Load: TLoad;
   S: string;
   IniFile: TIniFile;

begin
   inherited ReadParamsFromIni;
   //PostMsg(tm_OpenProject,Self,nil,DontKill);
   {
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      SourceModel := TOwnerEntity(Load.Output);
      Load.Free;
   end;
   }
   IniFile:= TIniFile.Create(IniFileName);
   IniFile.ReadSectionValues('TemplateLibrary', TemplateLibrary);
   if IniFile.ReadBool('GUIDE', 'Visible', false) then postMsg(tm_Pruvodce, Self, nil, DontKill)
                                                  else postMsg(tm_MapSpaceTouched, Self, nil, DontKill);
   if IniFile.ReadBool('TEMPLATE', 'Visible', false) then postMsg(tm_Template, Self, nil, DontKill)
                                                     else postMsg(tm_TemplateTouched, Self, nil, DontKill);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;

begin
   IniFile:= TRealIniFile.Create(IniFileName);
   B := GuideTool <> nil;
   IniFile.WriteBool('GUIDE', 'Visible', B);

   B := TemplateForm <> nil;
   IniFile.WriteBool('TEMPLATE', 'Visible', B);

   IniFile.WriteSection('TemplateLibrary', TemplateLibrary);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
begin
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Work.Text := Options.WorkingDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Data.Text := Options.DataDirectory;
   D.ed_Template.Text := Options.TemplateDirectory;
   if D.ShowModal = mrOk then
   begin
      Options.WorkingDirectory := D.ed_Work.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.DataDirectory := D.ed_Data.Text;
      Options.TemplateDirectory := D.ed_Template.Text;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         try
            if GuideTool <> nil then GuideTool.Free;
            GuideTool := nil;
         except
         end;
         Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
begin
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
{
var
   Load: TLoad;
   S: string;
   i: integer;
   ?: TOwnerEntity;
}
begin
   (*
   S := ExePath + 'SOURCE.ORB';
   if FileExists(S) then
   begin
      Load := TLoad.Create;
      Load.FileName := S;
      Load.DoIt;
      ? := TOwnerEntity(Load.Output);
      ??? := SM;
      Load.Free;
      for i := 0 to ?.LastIndex do
      begin
         MainForm.ed_LHC.Items.Add(?.Elements[i].Name);
      end;
   end;
   *)
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.Panels.Items[0].Text := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfPrint(var Handled: boolean);
begin
   {
   if CancelProcess then
   begin
      MainForm.Dioda.Color := clBtnFace;
      MainForm.Dioda.Enabled := false;
   end;
   if Automat.Busy then Automat.ProcessMap := false;
   }
end;


procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_NewMapSheet: on_tm_NewMapSheet(Handled);
      tm_MapSheetList: PostMsg(tm_Explore, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);
      tm_CloseGuide    : on_tm_CloseGuide(Handled);



     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
      tm_OIL              : on_tm_OIL(aMessage,Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);

      tm_Pruvodce         : on_tm_Pruvodce(Handled);
      tm_CreateGuideAuto  : on_tm_CreateGuideAuto(Handled);
      tm_CreateGuideMan   : on_tm_CreateGuideMan(Handled);
      tm_GuideSelect      : on_tm_GuideSelect(Handled);

      tm_ReviewGuide      : if GuideTool <> nil then GuideTool.on_tm_Review(aMessage, Handled);

      tm_Template         : on_tm_Template(Handled);
      tm_TemplateSelected : on_tm_TemplateSelected(Handled);
      tm_TemplateTouched  : on_tm_TemplateTouched(Handled);
      tm_MapSpaceTouched  : on_tm_MapSpaceTouched(Handled);
      tm_AddTemplate      : on_tm_AddTemplate(Handled);
      tm_DeleteTemplate   : on_tm_DeleteTemplate(Handled);
      tm_NotePadTemplate  : on_tm_NotePadTemplate(Handled);
      tm_NotePadMSC       : on_tm_NotePadMSC(Handled);
      tm_NotePadOIL       : on_tm_NotePadOIL(Handled);
      tm_EditTemplate     : on_tm_EditTemplate(Handled);


      tm_EndOfPrint       : on_tm_EndOfPrint(Handled);
      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)   
end;


function  TMainTool.GetText: string;
begin
   result := MainForm.StatusBar.Panels.Items[0].Text;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.Panels.Items[0].Text := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;












procedure TMainTool.LoadPlugIns;
var
   FV: TFileVersion;
   E: TElement;
   SLE: TStringListElement;
   i: integer;
   S: string;
begin
   E := World.FindElementName('PLUGIN');
   if not (E is TStringListElement) then exit;
   SLE := TStringListElement(E);
   FV := TFileVersion.Create;
   for i := 0 to SLE.LastIndex do
   begin
      S := SLE.Strings[i];
      if not FileExists(S) then Continue;
      FV.FileName := S;
      if FV.InfoString('InternalName') = 'RBO' then
      begin
         if not CheckModulRegistration(S) then Continue;
      end;
     LoadPackage(S);
     {!!!!!!!!!!!!!!!!!!!!!!}
   end;
   FV.Free;
end;




procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   CMD: TCommandLineDlg;
   El: TElement;
begin
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
end;

END.
