unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_ToolModel,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// APP
  t_ControlGroup,
// LHC
// MAPPER
  e_Map,
  e_MSpace;
  //f_MSEdit,
  //f_Templ,
  //t_Guide,
  //t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
    FExport_25: boolean;
    FExport_10: boolean;
    FExport_2: boolean;
    FExport_50: boolean;
    FExport_User: boolean;
    FExport_5: boolean;
    FExportControlDirectory: string;
    FBLK_5: boolean;
    FBLK_2: boolean;
    FBLK_User: boolean;
    FBLK_50: boolean;
    FBLK_25: boolean;
    FBLK_10: boolean;
  procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
    procedure SetExportScript(const Value: string);
    procedure SetImportScript(const Value: string);
    procedure SetExportControlDirectory(const Value: string);
    procedure SetExport_10(const Value: boolean);
    procedure SetExport_2(const Value: boolean);
    procedure SetExport_25(const Value: boolean);
    procedure SetExport_5(const Value: boolean);
    procedure SetExport_50(const Value: boolean);
    procedure SetExport_User(const Value: boolean);
    procedure SetBLK_10(const Value: boolean);
    procedure SetBLK_2(const Value: boolean);
    procedure SetBLK_25(const Value: boolean);
    procedure SetBLK_5(const Value: boolean);
    procedure SetBLK_50(const Value: boolean);
    procedure SetBLK_User(const Value: boolean);
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   ExportControlDirectory: string read FExportControlDirectory write SetExportControlDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
  property   Export_50: boolean read FExport_50 write SetExport_50;
  property   Export_25: boolean read FExport_25 write SetExport_25;
  property   Export_10: boolean read FExport_10 write SetExport_10;
  property   Export_5: boolean read FExport_5 write SetExport_5;
  property   Export_2: boolean read FExport_2 write SetExport_2;
  property   Export_User: boolean read FExport_User write SetExport_User;
  property   BLK_50: boolean read FBLK_50 write SetBLK_50;
  property   BLK_25: boolean read FBLK_25 write SetBLK_25;
  property   BLK_10: boolean read FBLK_10 write SetBLK_10;
  property   BLK_5: boolean read FBLK_5 write SetBLK_5;
  property   BLK_2: boolean read FBLK_2 write SetBLK_2;
  property   BLK_User: boolean read FBLK_User write SetBLK_User;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FActualAction: integer;
    FActualActionVisible: boolean;
    FButtonCount: integer;
    FActualActionImageIndex: integer;
    FActualActionCaption: string;
    FActualActionScript: string;
    FCaptionString: string;
  function  GetNOptions: TOptions; virtual;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
    procedure SetActualAction(const Value: integer);
    procedure SetActualActionCaption(const Value: string);
    procedure SetActualActionImageIndex(const Value: integer);
    procedure SetActualActionScript(const Value: string);
    procedure SetActualActionVisible(const Value: boolean);
    procedure SetButtonCount(const Value: integer);
    procedure SetNewImage(const Value: string);
    function GetActualActionCaption: string;
    function GetActualActionImageIndex: integer;
    function GetActualActionScript: string;
    function GetActualActionVisible: boolean;
    function GetActualActionHint: string;
    procedure setActualActionHint(const Value: string);
    procedure SetShowActionsCaptions(const Value: boolean);
    function GetImageHeight: integer;
    function GetImageWidth: integer;
    procedure SetImageHeight(const Value: integer);
    procedure SetImageWidth(const Value: integer);
    procedure SetCaptionString(const Value: string);
    function GetScriptDirectory: string;
protected
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   RunStartScripts; override;
   function    GetOptions: TBaseOptions; override;
   procedure   SetOptions(aValue: TBaseOptions); override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  On_tm_Export(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_OpenProject(var Handled: boolean);
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   ExePath: string read GetExePath;
   property   ButtonCount: integer read FButtonCount write SetButtonCount;
   property   CaptionString: string read FCaptionString write SetCaptionString;
   property   ScriptDirectory: string read GetScriptDirectory;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   NewImage: string write SetNewImage;
   property   ActualAction: integer read FActualAction write SetActualAction;
   property   ActualActionVisible: boolean read GetActualActionVisible write SetActualActionVisible;
   property   ActualActionScript: string read GetActualActionScript write SetActualActionScript;
   property   ActualActionImageIndex: integer read GetActualActionImageIndex write SetActualActionImageIndex;
   property   ActualActionCaption: string read GetActualActionCaption write SetActualActionCaption;
   property   ActualActionHint: string read GetActualActionHint write setActualActionHint;
   property   ImageHeight: integer read GetImageHeight write SetImageHeight;
   property   ImageWidth: integer read GetImageWidth write SetImageWidth;
   property   ShowActionCaptions: boolean write SetShowActionsCaptions;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  ActnList,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  f_CmdLn,
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// SYMBOL
  u_Symbol,
// INTERPRET
//Device
  e_ProjectionInfo,
  e_IScrpt,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
  t_Saver,
  t_Loader,
// TOPOL
  e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  M_Proj,
// APP
  t_ConfirmDialog,
// LHC
  t_ExpLHC,
// FILES
  u_File,
  t_ORBLKDialog,
  t_SelectGuideLines,
  e_Guide,
  t_ExLnTl,
// REG
  FileVersion,
  u_cktm;
// MAPPER
  //t_MSEdit,
  //t_VieMap;

{TOptions}


function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;



procedure TOptions.SetExportControlDirectory(const Value: string);
begin
  FExportControlDirectory := Value;
end;


procedure TOptions.SetExport_10(const Value: boolean);
begin
  FExport_10 := Value;
end;

procedure TOptions.SetExport_2(const Value: boolean);
begin
  FExport_2 := Value;
end;

procedure TOptions.SetExport_25(const Value: boolean);
begin
  FExport_25 := Value;
end;

procedure TOptions.SetExport_5(const Value: boolean);
begin
  FExport_5 := Value;
end;

procedure TOptions.SetExport_50(const Value: boolean);
begin
  FExport_50 := Value;
end;

procedure TOptions.SetExport_User(const Value: boolean);
begin
  FExport_User := Value;
end;

procedure TOptions.SetExportScript(const Value: string);
begin

end;

procedure TOptions.SetImportScript(const Value: string);
begin

end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   PaletFile := Value;
   NactiBarvickuZeSouboru(Value);
end;


procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
   RemoveBackSlash(PathOfLibraries);
end;


procedure TOptions.SetBLK_10(const Value: boolean);
begin
  FBLK_10 := Value;
end;

procedure TOptions.SetBLK_2(const Value: boolean);
begin
  FBLK_2 := Value;
end;

procedure TOptions.SetBLK_25(const Value: boolean);
begin
  FBLK_25 := Value;
end;

procedure TOptions.SetBLK_5(const Value: boolean);
begin
  FBLK_5 := Value;
end;

procedure TOptions.SetBLK_50(const Value: boolean);
begin
  FBLK_50 := Value;
end;

procedure TOptions.SetBLK_User(const Value: boolean);
begin
  FBLK_User := Value;
end;

{TMainTool}


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   //result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   //result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   //result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   //result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   //MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  //Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   //if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
   if aFileName = '' then exit;
   if pos(':',aFileName) = 0 then
   begin
      aFileName := ExePath + aFileName;
   end;
   CommandLine.FileName:= aFileName;
   CommandLine.DoIt
end;





procedure TMainTool.DoIt;
var
   S: string;
begin
   getDir(0, S);
   //Options.WorkingDirectory := S;
   Options.DataDirectory := S;
   inherited;
   Application.ProcessMessages;
   CaptionString := MainForm.Caption + '- ';
   PostMsg(tm_Intro,Self,nil,false);
   Text := 'Inicializace O.K.';
end;





procedure TMainTool.ReadParamsFromIni;
var
   IniFile: TIniFile;
begin
   inherited ReadParamsFromIni;
   IniFile:= TIniFile.Create(IniFileName);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
(*
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;
*)
begin
   //IniFile:= TRealIniFile.Create(IniFileName);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   //IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   //SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
//var
//   D: TF_Options;
begin
   (*
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Script.Text := Options.ScriptDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Project.Text := Options.ProjectDirectory;
   D.c_DontViewDialog.Checked := Options.DontViewProjectIntroDialog;
   D.c_OpenLastProject.Checked := Options.AutoOpenLastProject;
   if D.ShowModal = mrOk then
   begin
      Options.ScriptDirectory := D.ed_Script.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.ProjectDirectory := D.ed_Project.Text;
      Options.DontViewProjectIntroDialog := D.c_DontViewDialog.Checked;
      Options.AutoOpenLastProject := D.c_OpenLastProject.Checked;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   //MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
   *)
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   //CheckProjectForSave;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         Application.Terminate;
      end;
   end;
end;




procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin

  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.SimpleText := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;







procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_Export:     on_tm_Export(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_OpenProject: on_tm_OpenProject(Handled);


     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_OIL              : on_tm_OIL(aMessage,Handled);

      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
      tm_Run              : on_tm_Run(aMessage,Handled);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)
end;


function  TMainTool.GetText: string;
begin
   result := '';
   result := MainForm.StatusBar.SimpleText;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   MainForm.StatusBar.SimpleText := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;








procedure TMainTool.SetActualAction(const Value: integer);
begin
   FActualAction := Value;
   if FActualAction > 4 then FActualAction := 4;
end;

procedure TMainTool.SetActualActionCaption(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Caption := Value;
end;

procedure TMainTool.SetActualActionImageIndex(const Value: integer);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex := Value;
end;

procedure TMainTool.SetActualActionScript(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Category := Value;
end;

procedure TMainTool.SetActualActionVisible(const Value: boolean);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Visible := Value;
end;

procedure TMainTool.SetButtonCount(const Value: integer);
begin
end;

procedure TMainTool.SetNewImage(const Value: string);
var
   BM: Graphics.TBitmap;
   S: string;
begin
   {
   BM := Graphics.TBitmap.Create;
   S := '';
   if pos(':',Value) = 0 then
   begin
      S := ExePath;
      CheckBackSlash(S);
   end;
   S := S + Value;
   try
      BM.LoadFromFile(S);
   except
   end;
   MainForm.ImageList.AddMasked(BM,clGray);
   }
end;

procedure TMainTool.on_tm_Run(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   S,SS: string;
begin
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   if pos(':',S) = 0 then
   begin
      SS := ExePath;
      CheckBackSlash(SS);
      S := SS + S;
   end;
   ExecuteScript := S;
end;

function TMainTool.GetActualActionCaption: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Caption;
end;

function TMainTool.GetActualActionImageIndex: integer;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex;
end;

function TMainTool.GetActualActionScript: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Category;
end;

function TMainTool.GetActualActionVisible: boolean;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Visible;
end;

function TMainTool.GetActualActionHint: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Hint;
end;

procedure TMainTool.setActualActionHint(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Hint := Value;
end;

procedure TMainTool.SetShowActionsCaptions(const Value: boolean);
begin
{
   MainForm.ToolBar.ShowCaptions := Value;
   MainForm.ToolBar.ButtonHeight := 50;
   MainForm.ToolBar.ButtonWidth := 50;
}
end;

function TMainTool.GetImageHeight: integer;
begin
   //result := MainForm.ImageList.Height;
end;

function TMainTool.GetImageWidth: integer;
begin
   //result := MainForm.ImageList.Width;
end;

procedure TMainTool.SetImageHeight(const Value: integer);
begin
   //MainForm.ImageList.Height := Value;
end;

procedure TMainTool.SetImageWidth(const Value: integer);
begin
   //MainForm.ImageList.Width := Value;
end;

procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   CMD: TCommandLineDlg;
   El: TElement;
begin
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
end;

procedure TMainTool.RunStartScripts;
var
  OIL: string;
  S,SS: string;
begin
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ScriptDirectory;
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     //ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
     //ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
end;


procedure TMainTool.On_tm_Export(var Handled: boolean);
var
   D: TORBLKDialog;
   TT: TExportLHC;
   TS: TExportSimpleLHC;
   //T2: TExtractLHC;
   //TRH: TRemoveHoles;
   S: string;
   // nsledujc procedure pijde do scriptu !!!!
   LIN: TEntity;
   E : TEntity;
   Guide: TGuide;
   SL: TSelectGuideLines;

   procedure DoExport(Lines: TElement; Path: string);
   var
      Ex: TExportLinesToTopol;
   begin
      Ex := TExportLinesToTopol.Create;
      Ex.BlockName := Path;
      Ex.ExportDBF := false;
      Ex.RegisterObject := false;
      Ex.Input := Lines;
      Ex.DoIt;
      Ex.Free;
   end;
begin
   D := TORBLKDialog.Create;
   D.Caption := 'Export Prvodce do TopoLu';
   D.DoIt;
   if D.Result <> 1 then
   begin
      D.Free;
      exit;
   end;
   D.Free;
   // Vytahn lini do seznam
   PostTextMsg(tm_AddToProtocol, '*******************',Self);
   PostTextMsg(tm_AddToProtocol, 'Zatek exportu souboru prvodce '+MainForm.OpenDialog.FileName,Self);
   PostTextMsg(tm_AddToProtocol, 'Do nsledujc sloky: ',Self);
   PostTextMsg(tm_AddToProtocol, Options.DataDirectory,Self);
   PostTextMsg(tm_AddToProtocol, '  ... ',Self);
   LIN := TEntity(World.ObjectModel.FindElementName('LIN'));
   if LIN <> nil then LIN.Free;
   LIN := TEntity(World.ObjectModel.CreateElement('TOwnerEntity','LIN'));
   Guide := TGuide(World.ObjectModel.FindElementClass(TGuide));
   if Guide = nil then
   begin
      ShowMessage('Nemohu nalzt naten soubor prvodce, zkuste to znovu !');
      exit;
   end;
   StartProgress('Export Prvodce do TopoLu',0,0);
   ProgressText := 'Vyourvn lini z mapovch prostor';
   Application.ProcessMessages;
   SL := TSelectGuideLines.Create;
   SL._50 := Options.Export_50;
   SL._25 := Options.Export_25;
   SL._10 := Options.Export_10;
   SL._5 := Options.Export_5;
   SL._2 := Options.Export_2;
   SL._User := Options.Export_User;
   SL.Input := Guide;
   SL.Output := LIN;
   SL.DoIt;
   SL.Free;
   S := Options.DataDirectory;
   CheckBackSlash(S);
   Options.DataDirectory := S;
   if Options.Export_50 then
   begin
      S := Options.DataDirectory + '50.BLK';
      ProgressText := 'Export SMO_50 do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('50'),S);
      PostTextMsg(tm_AddToProtocol, 'SMO 50 uloeno do bloku '+S,Self);
   end;
   if Options.Export_25 then
   begin
      S := Options.DataDirectory + '25.BLK';
      ProgressText := 'Export SMO_25 do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('25'),S);
      PostTextMsg(tm_AddToProtocol, 'SMO 25 uloeno do bloku '+S,Self);
   end;
   if Options.Export_10 then
   begin
      S := Options.DataDirectory + '10.BLK';
      ProgressText := 'Export SMO_10 do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('10'),S);
      PostTextMsg(tm_AddToProtocol, 'SMO 10 uloeno do bloku '+S,Self);
   end;
   if Options.Export_5 then
   begin
      S := Options.DataDirectory + '5.BLK';
      ProgressText := 'Export SMO_5 do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('5'),S);
      PostTextMsg(tm_AddToProtocol, 'SMO 5 uloeno do bloku '+S,Self);
   end;
   if Options.Export_2 then
   begin
      S := Options.DataDirectory + '2.BLK';
      ProgressText := 'Export SMO_2 do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('2'),S);
      PostTextMsg(tm_AddToProtocol, 'SMO 2 uloeno do bloku '+S,Self);
   end;
   if Options.Export_User then
   begin
      S := Options.DataDirectory + 'User.BLK';
      ProgressText := 'Export USER do '+S;
      Application.ProcessMessages;
      DoExport(LIN.FindElementName('User'),S);
      PostTextMsg(tm_AddToProtocol, 'Uivatelsk vezy uloeny do bloku '+S,Self);
   end;

   ShowMessage('Export je patrn u konce, Ahoj');
   EndProgress;
   PostTextMsg(tm_AddToProtocol, 'Pokud to nespadlo, tak se soubor '+MainForm.OpenDialog.FileName,Self);
   PostTextMsg(tm_AddToProtocol, 'spn uloil do blok pod slokou ',Self);
   PostTextMsg(tm_AddToProtocol, Options.DataDirectory,Self);
   PostTextMsg(tm_AddToProtocol, '*******************',Self);
   (*
   Options.ExportControlDirectory := D.ControlDirectory;
   StartProgress('Export dat projektu '+ Project.Name+' do TopoLu',0,0);
   if D.ExportTEZ then
   begin
      S := 'Tba do bloku ' + D.TEZName;
      ProgressText := S +'- Neplochy';
      Application.ProcessMessages;
      PrepareData('TEZ','TTezPProps',135);

      ProgressText := S +'- Export ploch a lini...';
      Application.ProcessMessages;

      TT := TExportLHC.Create;
      TT.BlockName := D.TEZName;
      TT.ControlDIR := Options.ExportControlDirectory;
      TT.LayerName := 'TEZ';
      TT.Group := 135;
      TT.HolesGroup := 134;
      TT.LinesGroup := 74;
      TT.LinesColor := 15;
      TT.LinesSymbol := 1;
      TT.PropertyClassName := 'TTezPProps';
      TT.DoIt;
      TT.Free;

      ProgressText := S +'- Export bod...';
      Application.ProcessMessages;
      TS := TExportSimpleLHC.Create;
      TS.BlockName := D.TEZName;
      TS.ControlDIR := Options.ExportControlDirectory;
      TS.LayerName := 'TEZ_PNT';
      TS.DoIt;
      TS.Free;

      ProgressText := S +'- finalizace...';
      Application.ProcessMessages;
      TRH := TRemoveHoles.Create;
      TRH.LayerName := 'TEZ';
      TRH.HolesGroup := 134;
      TRH.DoIt;
      TRH.Free;
   end;
   if D.ExportSRF then
   begin
      S := 'rafy do bloku ' + D.SRFName;
      ProgressText := S +'- Neplochy';
      Application.ProcessMessages;
      PrepareData('SRF','TTopolAreaProps',144);

      ProgressText := S +'- Export ploch a lini...';
      Application.ProcessMessages;

      TT := TExportLHC.Create;
      TT.BlockName := D.SRFName;
      TT.ControlDIR := Options.ExportControlDirectory;
      TT.LayerName := 'SRF';
      TT.Group := 144;
      TT.HolesGroup := 134;
      TT.LinesGroup := 144;
      TT.LinesColor := 0;
      TT.LinesSymbol := 20;
      TT.PropertyClassName := 'TTopolAreaProps';
      TT.DoIt;
      TT.Free;

      ProgressText := S +'- Export bod...';
      Application.ProcessMessages;
      TS := TExportSimpleLHC.Create;
      TS.BlockName := D.SRFName;
      TS.ControlDIR := Options.ExportControlDirectory;
      TS.LayerName := 'SRF_PNT';
      TS.DoIt;
      TS.Free;

      ProgressText := S +'- finalizace...';
      Application.ProcessMessages;
      TRH := TRemoveHoles.Create;
      TRH.LayerName := 'TEZ';
      TRH.HolesGroup := 134;
      TRH.DoIt;
      TRH.Free;
   end;
   {
   *
   T2=Create(TExtractLHC,ET)
   T2.LayerName='SLU_PNT'
   T2.DoIt()
   T2.Free()


   TT=Create(TExportSimpleLHC,HPT)
   TT.BlockName='K:\ORBIS32\SLU_PNT.BLK'
   TT.ControlDIR='K:\ORBIS32\EXE\LED'
   TT.LayerName='SLU_PNT'
   TT.PropertyClassName='TTezPProps'
   TT.DoIt()
   TT.Free()
   *
   }
   ShowMessage('Konec exportu do TopoLu ');
   EndProgress;
   D.Free;
   *)
end;


procedure TMainTool.SetCaptionString(const Value: string);
begin
   FCaptionString := Value;
end;


function TMainTool.GetScriptDirectory: string;
var
   S: string;
begin
   S := Options.ScriptDirectory;
   CheckBackSlash(S);
   result := S;
end;



procedure TMainTool.on_tm_OpenProject(var Handled: boolean);
var
   S: string;
   L: TLoad;
begin
   if not MainForm.OpenDialog.Execute then exit;
   S := MainForm.OpenDialog.FileName;
   MainForm.OpenDialog.InitialDir := ExtractFilePath(S);
   Text := 'Uvolovn modelu ........';
   World.ObjectModel.FreeAll;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.ObjectModel.NextElement := L.Output;
   L.Free;
   MainForm.Caption := S;
   MainForm.a_DataExport.Enabled := true;
   PostMsg(tm_Export,Self,nil,false);
end;

END.
