unit f_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, Menus, ToolWin, ComCtrls, MenuBar, ExtCtrls, StdCtrls,
  ActnList, r_OrbisFrame, ImgList;

type
  TMainForm = class(TORBISForm)
    ControlBar1: TControlBar;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    huhu1: TMenuItem;
    AnimatePanel: TPanel;
    Animate: TAnimate;
    ActionList: TActionList;
    a_OpenProject: TAction;
    StatusBar: TStatusBar;
    a_Exit: TAction;
    a_StatusBar: TAction;
    a_WorldModel: TAction;
    a_ToolModel: TAction;
    a_ObjectModel: TAction;
    a_OIL: TAction;
    OtevtProjekt1: TMenuItem;
    N1: TMenuItem;
    Konecaplikace1: TMenuItem;
    EditorjazykaOIL1: TMenuItem;
    N2: TMenuItem;
    Strukturasvta1: TMenuItem;
    Strukturanstroj1: TMenuItem;
    Strukturaobjektovhomodelu1: TMenuItem;
    N3: TMenuItem;
    a_DataExport: TAction;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MenuBar: TMenuBar;
    ExportovatdoBLK1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure a_ExitExecute(Sender: TObject);
    procedure a_OpenProjectExecute(Sender: TObject);
    procedure a_OILExecute(Sender: TObject);
    procedure a_WorldModelExecute(Sender: TObject);
    procedure a_ToolModelExecute(Sender: TObject);
    procedure a_ObjectModelExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure a_DataExportExecute(Sender: TObject);
  private
  public
    procedure DisplayHint(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation
uses
   {!!!!}
   t_XML,
   {!!!!}
   IniFiles,
   FileVersion,
   m_Orbis,
   m_Proj,
   t_Main,
   u_String,
   Worlds;
{$R *.DFM}

procedure TMainForm.DisplayHint(Sender: TObject);
begin
   StatusBar.SimpleText := Application.Hint;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
   S: string;
   FV: TFileVersion;
begin
   inherited;
   try
      FV := TFileVersion.Create;
      FV.FileName := ParamStr(0);
      Caption := FV.ProductName + ' verze ' + FV.FileVersion;
      //if TimeWall <> 0 then Caption := Caption + ' neregistrovan demo';
      //TimeWall := T + EncodeTime(0, twTimeWall, 0, 0);
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);
      Left        := Ini.ReadInteger('MainForm','Left', Left);
      Top         := Ini.ReadInteger('MainForm','Top', Top);
      Width       := Ini.ReadInteger('MainForm','Width', Width);
      Height      := Ini.ReadInteger('MainForm','Height', Height);
      MenuBar.Left:= Ini.ReadInteger('MainForm','MenuBar_Left', 0);
      MenuBar.Top:= Ini.ReadInteger('MainForm','MenuBar_Top', 0);
      AnimatePanel.Left:= Ini.ReadInteger('MainForm','AnimatePanel_Left', 0);
      AnimatePanel.Top:= Ini.ReadInteger('MainForm','AnimatePanel_Top', 0);

      Ini.Free;
      //b_Directory.Hint := 'Data: ' + TMainTool(World.MainTool).Options.DataDirectory;
      S := ParamStr(0);
      S := ExtractFilePath(S);
      Animate.FileName := CheckBackSlash(S)+'ORBIS00M.AVI';
      Animate.Active := true;
      //DragAcceptFiles(Handle, true);
   except
   end;
  inherited;
  Application.HintColor := clLime;
  Application.OnHint := DisplayHint;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
   Ini: TIniFile;
begin
   inherited;
   try
      Ini := TIniFile.Create(TMainTool(World.MainTool).IniFileName);

      Ini.WriteInteger('MainForm','Left', Left);
      Ini.WriteInteger('MainForm','Top', Top);
      Ini.WriteInteger('MainForm','Width', Width);
      Ini.WriteInteger('MainForm','Height', Height);
      Ini.WriteInteger('MainForm','MenuBar_Left', MenuBar.Left);
      Ini.WriteInteger('MainForm','MenuBar_Top', MenuBar.Top);
      Ini.WriteInteger('MainForm','AnimatePanel_Left', AnimatePanel.Left);
      Ini.WriteInteger('MainForm','AnimatePanel_Top', AnimatePanel.Top);
      Ini.Free;
   except
   end;
end;

procedure TMainForm.a_ExitExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_QuitTask,Tool,nil,false);
end;

procedure TMainForm.a_OpenProjectExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_OpenProject,Tool,nil,false);
end;




procedure TMainForm.a_OILExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_OIL,Tool,nil,false);
end;

procedure TMainForm.a_WorldModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World,false);
end;

procedure TMainForm.a_ToolModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World.MainTool,false);
end;

procedure TMainForm.a_ObjectModelExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Explore,Tool,World.ObjectModel,false);
end;


procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   inherited;
   if IsPossibleToClose then
   begin
      CanClose:= true
   end
   else
   begin
      CanClose:= false;
      Tool.PostMsg(tm_QuitTask,  Tool, nil, false)
   end
end;


procedure TMainForm.a_DataExportExecute(Sender: TObject);
begin
   inherited;
   Tool.PostMsg(tm_Export,Tool,nil,false);
end;



INITIALIZATION
END.
