unit t_ORBLKDialog;

interface
uses
   f_ORBLKDialog,
   t_OrbisDialog;

type

TORBLKDialog = class(TOrbisDialog)
private
   function GetForm: TORBLKDialog_Form;
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property Form: TORBLKDialog_Form read GetForm;
published
end;

implementation
uses
   Forms,
   t_Main,
   Worlds;

{ TORBLKDialog }

procedure TORBLKDialog.CreateForm;
begin
   aForm := TORBLKDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TORBLKDialog.DoIt;
begin
   Form.cb_50.Checked := TMainTool(World.MainTool).Options.Export_50;
   Form.cb_25.Checked := TMainTool(World.MainTool).Options.Export_25;
   Form.cb_10.Checked := TMainTool(World.MainTool).Options.Export_10;
   Form.cb_5.Checked := TMainTool(World.MainTool).Options.Export_5;
   Form.cb_2.Checked := TMainTool(World.MainTool).Options.Export_2;
   Form.cb_u.Checked := TMainTool(World.MainTool).Options.Export_User;
   Form.ed_Path.Text := TMainTool(World.MainTool).Options.DataDirectory;
   inherited;
   case Result of
      1:
      begin
         TMainTool(World.MainTool).Options.Export_50     := Form.cb_50.Checked;
         TMainTool(World.MainTool).Options.Export_25     := Form.cb_25.Checked;
         TMainTool(World.MainTool).Options.Export_10     := Form.cb_10.Checked;
         TMainTool(World.MainTool).Options.Export_5      := Form.cb_5.Checked ;
         TMainTool(World.MainTool).Options.Export_2      := Form.cb_2.Checked ;
         TMainTool(World.MainTool).Options.Export_User   := Form.cb_u.Checked ;
         TMainTool(World.MainTool).Options.DataDirectory := Form.ed_Path.Text  ;
      end;
   end;
end;

function TORBLKDialog.GetForm: TORBLKDialog_Form;
begin
   result := TORBLKDialog_Form(aForm);
end;

end.
