unit t_SelectGuideLines;

interface
uses
   Elements,
   e_MSpace,
   t_recurs;

type
TSelectGuideLines = class(Trecursor)
  private
    F_2: boolean;
    F_25: boolean;
    F_5: boolean;
    F_User: boolean;
    F_50: boolean;
    F_10: boolean;
    procedure Set_10(const Value: boolean);
    procedure Set_2(const Value: boolean);
    procedure Set_25(const Value: boolean);
    procedure Set_5(const Value: boolean);
    procedure Set_50(const Value: boolean);
    procedure Set_User(const Value: boolean);
protected
   function  QProcessBefore(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
public
   procedure AddAsLine(Where: string; mapSpace: TMapSpace);
   property _50: boolean read F_50 write Set_50;
   property _25: boolean read F_25 write Set_25;
   property _10: boolean read F_10 write Set_10;
   property _5: boolean read F_5 write Set_5;
   property _2: boolean read F_2 write Set_2;
   property _User: boolean read F_User write Set_User;
end;

implementation
uses
   e_Guide,
   e_Space,
   e_TplPrp,
   G_Elems;
{ TSelectGuideLines }

procedure TSelectGuideLines.AddAsLine(Where: string; mapSpace: TMapSpace);
var
   E: TPolyLineString;
   EE: TEntity;
   C: T2DCoordinate;
   Ln: TPolyLineElement;
   aLinProp: TTopolLineProps;
begin
   if Input = nil then exit;
   if not (Output is TEntity) then Exit;
   if MapSpace = nil then exit;
   EE := TEntity(Output);
   E := TPolyLineString(EE.FindOrCreateElementName(TPolyLineString,Where));
   Ln := TPolyLineElement.Create;
   Ln.AddXY(MapSpace.MinX,MapSpace.MinY);
   Ln.AddXY(MapSpace.MaxX,MapSpace.MinY);
   Ln.AddXY(MapSpace.MaxX,MapSpace.MaxY);
   Ln.AddXY(MapSpace.MinX,MapSpace.MaxY);
   Ln.AddXY(MapSpace.MinX,MapSpace.MinY);
   aLinProp:= TTopolLineProps.Create;
   Ln.Properties:= aLinProp;
   aLinProp.Barva:= 13;
   aLinProp.Znacka:= 0;
   aLinProp.Druh:= 1;
   Ln.RecalculateRect;
   E.AddAndUpdateRect(Ln);
end;

procedure TSelectGuideLines.Process(Element: TElement);
begin
   if (Element.ClassType = TGuidePage_50) and _50 then
      AddAsLine('50',TMapSpace(Element));
   if (Element.ClassType = TGuidePage_25) and _25 then
      AddAsLine('25',TMapSpace(Element));
   if (Element.ClassType = TGuidePage_10) and _10 then
      AddAsLine('10',TMapSpace(Element));
   if (Element.ClassType = TGuidePage_5) and _5 then
      AddAsLine('5',TMapSpace(Element));
   if (Element.ClassType = TGuidePage_2) and _2 then
      AddAsLine('2',TMapSpace(Element));
   if (Element.ClassType = TUserMapSpace) and _50 then
      AddAsLine('User',TMapSpace(Element));
end;

function TSelectGuideLines.QProcessBefore(Element: TElement): boolean;
begin
   result := Element is TMapSpace;
end;

procedure TSelectGuideLines.Set_10(const Value: boolean);
begin
  F_10 := Value;
end;

procedure TSelectGuideLines.Set_2(const Value: boolean);
begin
  F_2 := Value;
end;

procedure TSelectGuideLines.Set_25(const Value: boolean);
begin
  F_25 := Value;
end;

procedure TSelectGuideLines.Set_5(const Value: boolean);
begin
  F_5 := Value;
end;

procedure TSelectGuideLines.Set_50(const Value: boolean);
begin
  F_50 := Value;
end;

procedure TSelectGuideLines.Set_User(const Value: boolean);
begin
  F_User := Value;
end;

end.
 