unit f_PrintBlaster;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, ExtCtrls, FileCtrl, Gauges, Spin, Menus,
  Buttons;

type
  TForm1 = class(TForm)
    CLB: TCheckListBox;
    OpenDialog: TOpenDialog;
    Timer: TTimer;
    Button3: TButton;
    FLB: TFileListBox;
    Memo: TMemo;
    Button4: TButton;
    Gauge: TGauge;
    Button5: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    l_prn: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    ed_Interval: TSpinEdit;
    Label5: TLabel;
    ed_FileCount: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    PopupMenu: TPopupMenu;
    Vybratve1: TMenuItem;
    Zatrhnoutvybran1: TMenuItem;
    Nezatrhnoutvybran1: TMenuItem;
    Vybranmnastavitpoetkopina1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    Label8: TLabel;
    cb_Now: TCheckBox;
    b_Start: TBitBtn;
    b_Stop: TBitBtn;
    l_Progress: TLabel;
    l_copy: TLabel;
    Timer1: TTimer;
    ed_Printer: TComboBox;
    Button6: TButton;
    cb_copy: TCheckBox;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Vybratve1Click(Sender: TObject);
    procedure Zatrhnoutvybran1Click(Sender: TObject);
    procedure Nezatrhnoutvybran1Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure b_StartClick(Sender: TObject);
    procedure b_StopClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ed_PrinterChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    FprnDir: string;
    FPrinter: string;
    FBusy: boolean;
    FActualCopies: integer;
    FActualIndex: integer;
    FActualFile: string;
    FStop: boolean;
    FPrinting: boolean;
    FLastTick: cardinal;
    FEndTick: cardinal;
    FPrinterError: boolean;
    procedure SetPrinter(const Value: string);
    procedure SetprnDir(const Value: string);
    procedure SetActualCopies(const Value: integer);
    procedure SetActualFile(const Value: string);
    procedure SetActualIndex(const Value: integer);
    procedure SetBusy(const Value: boolean);
    procedure SetStop(const Value: boolean);
    procedure SetPrinting(const Value: boolean);
    procedure SetEndTick(const Value: cardinal);
    procedure SetLastTick(const Value: cardinal);
    procedure SetPrinterError(Value: boolean);
    { Private declarations }
  public
     procedure ChangeCaption(const S: string);
     procedure PrintFiles;
     procedure CopyActualFile;
     procedure Finish;
     property Printer: string read FPrinter write SetPrinter;
     property prnDir: string read FprnDir write SetprnDir;
     property ActualIndex: integer read FActualIndex write SetActualIndex;
     property ActualFile: string read FActualFile write SetActualFile;
     property ActualCopies: integer read FActualCopies write SetActualCopies;
     property Busy: boolean read FBusy write SetBusy;
     property Stop: boolean read FStop write SetStop;
     property Printing: boolean read FPrinting write SetPrinting;
     property LastTick: Cardinal read FLastTick write SetLastTick;
     property EndTick: Cardinal read FEndTick write SetEndTick;
     property PrinterError: boolean read FPrinterError write SetPrinterError;
  end;

TPrnFileObject= class(TObject)
  private
    FDone: boolean;
    FCopy: integer;
    FFileName: string;
    FTime: TDateTime;
    FShortName: string;
    procedure SetCopy(const Value: integer);
    procedure SetDone(const Value: boolean);
    procedure SetFileName(const Value: string);
    procedure SetTime(const Value: TDateTime);
    procedure SetShortName(const Value: string);
public
   function GetListName: string;
   property ShortName: string read FShortName write SetShortName;
   property FileName: string read FFileName write SetFileName;
   property Done: boolean read FDone write SetDone;
   property Copy: integer read FCopy write SetCopy default 1;
   property Time: TDateTime read FTime write SetTime;
end;

var
  Form1: TForm1;

implementation
uses
   ShellApi,
   u_Shell,
   IniFiles,
   Winspool,
   printers;
{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
var
   S: string;
begin
   if SelectDirectory('Sloka tiskovch soubor','',S) then
   begin
      l_Prn.Caption := S;
      if CompareText(S,prnDir)<> 0 then
      begin
         Button3.SetFocus;
         prnDir := S;
      end;
   end;
end;

procedure TForm1.SetPrinter(const Value: string);
begin
  FPrinter := Value;
end;

procedure TForm1.SetprnDir(const Value: string);
begin
  FprnDir := Value;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   i: integer;
   PF: TPrnFileObject;
   S: string;
begin
   for i := 0 to CLB.Count - 1 do
   begin
      CLB.Items.Objects[i].Free;
   end;
   CLB.Clear;
   if prnDir = '' then
   begin
      ShowMessage('Nen vybrna sloka tiskovch soubor!!!');
      exit;
   end;
   FLB.Directory := prnDir;
   if not(prnDir[Length(prnDir)] = '\') then
      prnDir := prnDir + '\';
   for i := 0 to FLB.Count - 1 do
   begin
      PF := TPrnFileObject.Create;
      S := FLB.Items.Strings[i];
      PF.ShortName := S;
      PF.FileName := PrnDir +  S;
      PF.Copy := 1;
      CLB.AddItem(PF.GetListName,PF);
   end;
   CLB.MultiSelect := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   P: TPrinter;
   H: THandle;
begin
   {
   H := ConnectToPrinterDlg(Application.DialogHandle,0);
   Application.ProcessMessages;
   Caption := IntToStr(H);
   }
   P := TPrinter.Create;
   Memo.Lines.Assign(P.Printers);
   P.Free;
   {
   if OpenDialog.Execute then
   begin
      Printer := OpenDialog.FileName;
      l_Printer.Caption := Printer;
   end;
   }
end;

{ TPrnFileObject }

function TPrnFileObject.GetListName: string;
begin
   result := ShortName +' ['+ IntToStr(Copy)+']';
end;

procedure TPrnFileObject.SetCopy(const Value: integer);
begin
  FCopy := Value;
end;

procedure TPrnFileObject.SetDone(const Value: boolean);
begin
  FDone := Value;
end;

procedure TPrnFileObject.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   H1,H2: integer;
   Buffer: Pointer;
   ri:integer;
   i: integer;
begin
   H1 := FileOpen('C:\Dokumenty\PrnTest\tst01.prn',fmOpenRead);
   H2 := FileOpen('\\KANCL\HP',fmOpenWrite);
   i := FileSeek(H1,0,2);
   Gauge.MaxValue := i;
   Gauge.Progress := 0;
   FileSeek(H1,0,0);
   GetMem(Buffer,1028);
   repeat
      ri := FileRead(H1,Buffer^,1024);
      Gauge.Progress := Gauge.Progress + ri;
      FileWrite(H2,Buffer^,ri);
      Application.ProcessMessages;
   until ri < 1024;
   FileClose(H1);
   FileClose(H2);
   FreeMem(Buffer,1028)
end;

procedure TPrnFileObject.SetShortName(const Value: string);
begin
  FShortName := Value;
end;

procedure TPrnFileObject.SetTime(const Value: TDateTime);
begin
  FTime := Value;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
   Ini: TIniFile;
   S: string;
begin
   CanClose := not Busy;
   S := ParamStr(0);
   S := CHangeFileExt(S,'.ini');
   Ini := TIniFile.Create(S);
   Ini.WriteString('Options','Printers',ed_Printer.Items.CommaText);
   Ini.WriteString('Options','Printer',Printer);
   Ini.WriteString('Options','PrnDir',prnDir);
   Ini.WriteInteger('Options','Interval',ed_Interval.Value);
   Ini.WriteInteger('Options','fileCount',ed_FileCount.Value);
   Ini.WriteBool('Options','copy',cb_copy.Checked);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   Ini: TIniFile;
   S: string;
begin
   S := ParamStr(0);
   S := CHangeFileExt(S,'.ini');
   Ini := TIniFile.Create(S);
   ed_Printer.Items.CommaText := Ini.ReadString('Options','Printers','');
   Printer := Ini.ReadString('Options','Printer','');
   ed_Printer.Text := Printer;
   PrnDir := Ini.ReadString('Options','PrnDir','');
   l_prn.Caption := PrnDir;
   ed_Interval.Value := Ini.ReadInteger('Options','Interval',0);
   ed_FileCount.Value := Ini.ReadInteger('Options','fileCount',0);
   cb_copy.Checked := Ini.ReadBool('Options','copy',false);
   ChangeCaption('OK');
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to 5 do
   begin
      CLB.State[i] := cbGrayed;
   end;
   //Panel1.Enabled := false;
end;

procedure TForm1.Vybratve1Click(Sender: TObject);
begin
   CLB.SelectAll;
end;

procedure TForm1.Zatrhnoutvybran1Click(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to CLB.Count - 1 do
   begin
      if CLB.Selected[i] then
         CLB.Checked[i] := true;
   end;
end;

procedure TForm1.Nezatrhnoutvybran1Click(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to CLB.Count - 1 do
   begin
      if CLB.Selected[i] then
         CLB.Checked[i] := false;
   end;
end;

procedure TForm1.N11Click(Sender: TObject);
var
   i: integer;
   NCopy: integer;
   PFO: TPrnFileObject;
   S,_S: string;
begin
   if not (Sender is TMenuItem) then exit;
   _S := TMenuItem(Sender).Caption;
   S := '';
   for i := 1 to Length(_S) do
      if _S[i] in ['0'..'9'] then S := S + _S[i];
   NCopy := StrToIntDef(S,0);
   for i := 0 to CLB.Count - 1 do
   begin
      if CLB.Selected[i] then
      begin
         PFO := TPrnFileObject(CLB.Items.Objects[i]);
         if PFO = nil then continue;
         PFO.Copy := NCopy;
         CLB.Items.Strings[i] := PFO.GetListName;
      end;
   end;
end;

procedure TForm1.b_StartClick(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to CLB.Count - 1 do
   begin
      CLB.Selected[i] := false;
   end;
   Panel1.Enabled := false;
   Button3.Enabled := false;
   CLB.Enabled := false;
   b_Start.Enabled := false;
   b_Stop.Enabled := true;
   Busy := true;
   Stop := false;
   Memo.Lines.Clear;
   Memo.Lines.Add(DateTimetoStr(Now)+' Start...');
   ActualIndex := 0;
   PrinterError := false;
   if cb_Now.Checked then
      PrintFiles;
   if PrinterError then
   begin
      Memo.Lines.Add(' X Nelze otevt tiskrnu ...'+Printer);
      Finish;
      exit;
   end;
   if Stop then exit;
   Timer.Interval := ed_Interval.Value*60000;
   Timer.Enabled := true;
   l_Progress.Caption := 'ekme na interval...';
   ChangeCaption('waiting');
   LastTick := GetTickCount;
   Gauge.MaxValue := Timer.Interval;
   Timer1.Enabled := true;
end;

procedure TForm1.SetActualCopies(const Value: integer);
begin
  FActualCopies := Value;
end;

procedure TForm1.SetActualFile(const Value: string);
begin
  FActualFile := Value;
end;

procedure TForm1.SetActualIndex(const Value: integer);
begin
  FActualIndex := Value;
end;

procedure TForm1.SetBusy(const Value: boolean);
begin
  FBusy := Value;
end;

procedure TForm1.SetStop(const Value: boolean);
begin
  FStop := Value;
end;

procedure TForm1.b_StopClick(Sender: TObject);
begin
   if not Busy then exit;
   if MessageDlg('Opravdu peruit innost?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
   begin
      Stop := true;
      Timer.Enabled := false;
      Timer1.Enabled := false;
      Panel1.Enabled := true;
      Button3.Enabled := true;
      CLB.Enabled := true;
      b_Start.Enabled := true;
      b_Stop.Enabled := false;
      l_Progress.Caption := 'Canceled...';
      ChangeCaption('OK');
      l_COpy.Caption := '';
      Busy := false;
      Gauge.Progress := 0;
      Memo.Lines.Add(DateTimetoStr(Now)+' Nsiln perueno uivatelem..');
   end;
end;

procedure TForm1.CopyActualFile;
var
   H1,H2: integer;
   Buffer: Pointer;
   ri:integer;
   i: integer;
   S,S1: string;
begin
   if Stop then exit;
   if cb_copy.Checked then
   begin
      S := 'copy '+ ActualFile + ' ' + Printer + ' /b';
      S1 := 'cmd';
      //_CreateProcess('cmd.exe',S);
      //ShellExecute(0, Nil, PChar(S1), Nil, Nil, SW_NORMAL);
      copyfile(PCHar(ActualFile),PChar(Printer),false);
      exit;
   end;
   H1 := FileOpen(ActualFile,fmOpenRead);
   H2 := FileOpen(Printer,fmOpenWrite);
   Application.ProcessMessages;
   if H2 > -1 then
   begin
      i := FileSeek(H1,0,2);
      Gauge.MaxValue := i;
      Gauge.Progress := 0;
      FileSeek(H1,0,0);
      GetMem(Buffer,1028);
      Application.ProcessMessages;
      repeat
         ri := FileRead(H1,Buffer^,1024);
         Application.ProcessMessages;
         Gauge.Progress := Gauge.Progress + ri;
         FileWrite(H2,Buffer^,ri);
         Application.ProcessMessages;
      until Stop or (ri < 1024);
   end
   else
      PrinterError := true;
   FileClose(H1);
   FileClose(H2);
   if not PrinterError then
      FreeMem(Buffer,1028)
end;

procedure TForm1.PrintFiles;
var
   i: integer;
   DoneIndex: integer;
   PF: TPrnFileObject;
begin
   if Stop then exit;
   ChangeCaption('progress');
   DoneIndex := ed_FileCount.Value;
   if DoneIndex <= 0 then DoneIndex  := CLB.Count;
   while (DoneIndex > 0) and (ActualIndex < CLB.Count) do
   begin
      if ActualIndex > 0 then
         CLB.Selected[ActualIndex-1] := false;
      CLB.Selected[ActualIndex] := true;
      Application.ProcessMessages;
      if CLB.Checked[ActualIndex] then
      begin
         PF := TPrnFileObject(CLB.Items.Objects[ActualIndex]);
         ActualFile := PF.FileName;
         ActualCopies := PF.Copy;
         l_Progress.Caption := 'Poslme '+PF.ShortName + ' na '+Printer;
         for i := 1 to ActualCopies do
         begin
            l_copy.Caption := IntToStr(i)+'.kopie z '+IntToStr(ActualCopies);
            Memo.Lines.Add(DateTimeToStr(Now)+' '+PF.ShortName+' ...'+IntToStr(i)+'.kopie');
            CopyActualFile;
            if PrinterError then exit;
            if Stop then exit;
            Application.ProcessMessages;
         end;
         Dec(DoneIndex);
      end;
      ActualIndex := ActualIndex + 1;
   end;
   Gauge.Progress := 0;
   l_Progress.Caption := 'ekme na interval...';
   ChangeCaption('waiting');
   Gauge.MaxValue := Timer.Interval;
   Timer1.Enabled := true;
   l_Copy.Caption := '';
   if ActualIndex >= CLB.Count then Finish;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
   Timer1.Enabled := false;
   LastTick := GetTickCount;
   if Printing then exit;
   Printing := true;
   PrintFiles;
   Printing := false;
end;

procedure TForm1.SetPrinting(const Value: boolean);
begin
  FPrinting := Value;
end;

procedure TForm1.Finish;
begin
   Memo.Lines.Add(DateTimeToStr(Now)+' Finto');
   Timer.Enabled := false;
   Timer1.Enabled := false;
   Panel1.Enabled := true;
   CLB.Enabled := true;
   Busy := false;
   Button3.Enabled := true;
   b_Stop.Enabled := false;
   b_Start.Enabled := true;
   Gauge.Progress := 0;
   l_Progress.Caption := '';
   Changecaption('OK');
   l_copy.Caption := '';
end;

procedure TForm1.SetEndTick(const Value: Cardinal);
begin
  FEndTick := Value;
end;

procedure TForm1.SetLastTick(const Value: Cardinal);
begin
  FLastTick := Value;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Gauge.Progress := GetTickCount - LastTick;
   Application.ProcessMessages;
end;

procedure TForm1.ed_PrinterChange(Sender: TObject);
begin
   Printer := ed_Printer.Text;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   ed_Printer.Items.Add(Printer);
end;

procedure TForm1.ChangeCaption(const S: string);
begin
   Caption := 'PrintBlaster '+ S;
end;

procedure TForm1.SetPrinterError(Value: boolean);
begin
  FPrinterError := Value;
end;

end.

