unit f_Wall2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons,
  u_CkTm, ExtCtrls, ComCtrls, Psock, NMsmtp;

type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    b_Open: TBitBtn;
    SaveDialog: TSaveDialog;
    b_Save: TBitBtn;
    b_Quit: TBitBtn;
    Timer1: TTimer;
    g_Modul: TGroupBox;
    ed_Modul: TEdit;
    ed_MajVersion: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    cb_TimeWall: TCheckBox;
    cb_Licence: TCheckBox;
    cb_HDControl: TCheckBox;
    Image1: TImage;
    ed_MinVersion: TEdit;
    Label13: TLabel;
    Pages: TPageControl;
    Trial: TTabSheet;
    g_Trial: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ed_TimeWall: TEdit;
    ed_LastTime: TEdit;
    ed_Now: TEdit;
    Licence: TTabSheet;
    g_Licence: TGroupBox;
    Label4: TLabel;
    ed_Licence: TEdit;
    HD: TTabSheet;
    g_HDControl: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ed_HD: TEdit;
    ed_HDC: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    ed_Company: TEdit;
    ed_User: TEdit;
    Label14: TLabel;
    ed_Licence1: TEdit;
    Soubory: TTabSheet;
    AppList: TListBox;
    Reg: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn5: TBitBtn;
    b_Sent: TBitBtn;
    NMSMTP1: TNMSMTP;
    Button1: TButton;
    ed_cc: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure b_SaveClick(Sender: TObject);
    procedure b_OpenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure b_QuitClick(Sender: TObject);
    procedure cb_TimeWallClick(Sender: TObject);
    procedure cb_LicenceClick(Sender: TObject);
    procedure cb_HDControlClick(Sender: TObject);
    procedure ed_HDChange(Sender: TObject);
    procedure ed_HDDblClick(Sender: TObject);
    procedure ed_ModulChange(Sender: TObject);
    procedure ed_MajVersionChange(Sender: TObject);
    procedure ed_MinVersionChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ed_MajVersionKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ed_MinVersionKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure b_SentClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  protected
     procedure FillAppList;
     procedure FillApps;
  public
     R: TRegistrationInfo;
     OpenFileName: string;
     ReadParamFile: boolean;
     CloseAfter: boolean;
     Install: boolean;
     OldTWV: boolean;
     procedure ReadParams;
     procedure OpenTWV(const aName: string);
     procedure SaveTWV(const aName: string);
  end;

var
  Form1: TForm1;

implementation

uses
   IniFiles,
   FileVersion,
   f_TWVs,
   u_Crypt,
   u_HDTest,
   u_String;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   ed_Now.Text := DateTimeToStr(Now);
   if ParamCount > 0 then
   begin
      if ParamStr(1)='R' then
         //ReadParamFile := true
      else
         OpenTWV(ParamStr(1));
   end;
   cb_TimeWallClick(nil);
   cb_LicenceClick(nil);
   cb_HDControlClick(nil);
end;

procedure TForm1.b_SaveClick(Sender: TObject);
begin
   if SaveDialog.Execute then
   begin
      SaveTWV(SaveDialog.FileName);
   end;
end;

procedure TForm1.SaveTWV(const aName: string);
var
   N: string;
   E: string;
begin
   FillChar(R.Reg, SizeOf(R.Reg),#0);
   OpenFileName := SaveDialog.FileName;
   E := UpperCase(ExtractFileExt(OpenFileName));
   Install := E = '.RBO2';
   R.Reg.IsTrial      := cb_TimeWall.Checked;
   R.Reg.IsLicence    := cb_Licence.Checked;
   R.Reg.IsHDControl  := cb_HDControl.Checked;
   R.Reg.ModuleName   := ed_Modul.Text;
   R.Reg.User   := ed_User.Text;
   R.Reg.Company   := ed_Company.Text;
   try
      R.Reg.MajorVersion := StrToInt(ed_MajVersion.Text);
   except
   end;
   try
      R.Reg.MinorVersion := StrToInt(ed_MinVersion.Text);
   except
   end;
   if R.Reg.IsTrial then
   begin
      if ed_TimeWall.Text <> '' then R.Reg.TimeWall := StrToDateTime(ed_TimeWall.Text)
                                else R.Reg.TimeWall := 0;
      if ed_LastTime.Text <> '' then R.Reg.LastTime := StrToDateTime(ed_LastTime.Text)
                                else R.Reg.LastTime := 0;
   end;
   if R.Reg.IsLicence then
   begin
      if ed_Licence.Text <> ''  then R.Reg.Licence := StrToInt(ed_Licence.Text)
                                else R.Reg.Licence := 0;
      if ed_Licence1.Text <> ''  then R.Reg.Licence1 := StrToInt(ed_Licence1.Text)
                                 else R.Reg.Licence1 := 0;
   end;
   N := ChangeFileExt(SaveDialog.FileName,'.RBO2');
   Caption := N;
   SaveDialog.InitialDir := ExtractFilePath(N);
   SaveRBOToFile(R, N);
end;


procedure TForm1.b_OpenClick(Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      OpenTWV(OpenDialog.FileName);
   end;
end;



procedure TForm1.OpenTWV(const aName: string);
var
   Ext: string;
   HDSerialNumber: longInt;
   S,S1: string;
begin
   FillChar(R.Reg, SizeOf(R.Reg),#0);
   OpenFileName := aName;
   Caption := OpenFileName;
   SaveDialog.FileName := OpenFileName;
   Ext := ExtractFileExt(OpenFileName);
   if Ext <> '.RBO2' then exit;
   R := LoadRBOFromFile(OpenFileName);
   FillAppList;
   if R.Reg.TimeWall <> 0 then ed_TimeWall.Text := DateTimeToStr(R.Reg.TimeWall)
                          else ed_TimeWall.Text := '';
   if R.Reg.LastTime <> 0 then ed_LastTime.Text := DateTimeToStr(R.Reg.LastTime)
                          else ed_LastTime.Text := '';
   if R.Reg.Licence  = 0  then ed_Licence.Text := ''
                          else ed_Licence.Text := IntToStr(R.Reg.Licence);
   if R.Reg.Licence1 = 0  then ed_Licence1.Text := ''
                          else ed_Licence1.Text := IntToStr(R.Reg.Licence1);
   S := IntToStr(R.Reg.MajorVersion);
   S1 := IntToStr(R.Reg.MinorVersion);
   ed_Modul.Text := R.Reg.ModuleName;
   ed_MajVersion.Text := S;
   ed_MinVersion.Text := S1;
   ed_User.Text := R.Reg.User;
   ed_Company.Text := R.Reg.Company;
   HDSerialNumber := GetSystemHDSerialNumer;
   ed_HD.Text := IntToStr(HDSerialNumber);
   cb_TimeWall.Checked := R.Reg.IsTrial;
   cb_TimeWallClick(nil);
   cb_Licence.Checked := R.Reg.IsLicence;
   cb_LicenceClick(nil);
   cb_HDControl.Checked := R.Reg.IsHDControl;
   cb_HDControlClick(nil);
   ed_HDC.Text := R.Reg.ControlCode;

   SaveDialog.FileName := aName;
   SaveDialog.InitialDir := ExtractFilePath(aName);
   OpenDialog.InitialDir := SaveDialog.InitialDir;
   Caption := aName;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   ed_Now.Text := DateTimeToStr(Now);
end;

procedure TForm1.b_QuitClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.cb_TimeWallClick(Sender: TObject);
begin
   g_Trial.Visible := cb_TimeWall.Checked;
end;

procedure TForm1.cb_LicenceClick(Sender: TObject);
begin
   g_Licence.Visible := cb_Licence.Checked;
end;

procedure TForm1.cb_HDControlClick(Sender: TObject);
begin
  g_HDControl.Visible := cb_HDControl.Checked;
end;

procedure TForm1.ed_HDChange(Sender: TObject);
var
   SI: integer;
   SCI: double;
begin
   exit;
   R.Reg.ModuleName   := ed_Modul.Text;
   try
      if ed_MajVersion.Text = '' then ed_MajVersion.Text := '0';
      R.Reg.Majorversion := StrToInt(ed_MajVersion.Text);
   except
      R.Reg.Majorversion := 0;
      ed_MajVersion.Text := '0';
   end;
   try
      if ed_MinVersion.Text = '' then ed_MinVersion.Text := '0';
      R.Reg.Minorversion := StrToInt(ed_MinVersion.Text);
   except
      R.Reg.Minorversion := 0;
      ed_MinVersion.Text := '0';
   end;
   SI := StrToInt(ed_HD.Text);
   SCI := CodeHDC(SI,R);
   ed_HDC.Text := floatToStr(SCI);
   //ed_CryptHD.Text := CryptLongInt(SI);
   //ed_CryptHDC.Text := CryptDouble(SCI);
end;

procedure TForm1.ed_HDDblClick(Sender: TObject);
begin
   ed_HD.Text := '0';
   ed_HD.Text := IntToStr(GetSystemHDSerialNumer);
end;

procedure TForm1.ed_ModulChange(Sender: TObject);
begin
   //ed_HDChange(nil);
end;

procedure TForm1.ed_MajVersionChange(Sender: TObject);
begin
   //ed_HDChange(nil);
end;

procedure TForm1.ed_MinVersionChange(Sender: TObject);
begin
   //ed_HDChange(nil);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
   FV: TFileVersion;
   N: string;

begin
   if OpenDialog1.execute then
   begin
      FV := TFileVersion.Create;
      N := OpenDialog1.FileName;
      FV.FileName := N;
      N := ExtractFileName(N);
      AppList.Items.Add(N+' : '+IntToStr(FV.MajorVersion)+'.'+IntToStr(FV.MinorVersion));
      FillApps;
      FV.Free;
   end;
end;

procedure TForm1.FillAppList;
var
   i: integer;
begin
   AppList.Clear;
   for i := 0 to High(R.Apps) do
   begin
      AppList.Items.Add(R.Apps[i].AppName+' : '+AppVersionString(R.Apps[i]));
   end;
end;

procedure TForm1.FillApps;
var
   i: integer;
   An,Av: string;
begin
   SetLength(R.Apps,AppList.Items.Count);
   for i := 0 to AppList.Items.Count - 1 do
   begin
      StringAsTwoParams(AppList.Items.Strings[i],':',An,Av);
      R.Apps[i].AppName := An;
      SetAppVersionString(Av, R.Apps[i]);
   end;
end;


procedure TForm1.ed_MajVersionKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   i: integer;
begin
    if ed_MajVersion.Text = '' then ed_MajVersion.Text := '0';
    i := StrToInt(ed_MajVersion.Text);
    if Key = VK_UP then
    begin
       ed_MajVersion.Text := IntToStr(i+1);
    end
    else
    if Key = VK_Down then
    begin
       if i = 0 then exit;
       ed_MajVersion.Text := IntToStr(i-1);
    end
end;

procedure TForm1.ed_MinVersionKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   i: integer;
begin
    if ed_MinVersion.Text = '' then ed_MinVersion.Text := '0';
    i := StrToInt(ed_MinVersion.Text);
    if Key = VK_UP then
    begin
       ed_MinVersion.Text := IntToStr(i+1);
    end
    else
    if Key = VK_Down then
    begin
       if i = 0 then exit;
       ed_MinVersion.Text := IntToStr(i-1);
    end
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   AppList.Items.Delete(AppList.ItemIndex);
   FillApps;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
   AppList.Clear;
   FillApps;
end;

procedure TForm1.b_SentClick(Sender: TObject);
begin
  if NMSMTP1.Connected then
    NMSMTP1.Disconnect
  else
  begin
    NMSMTP1.Host := 'TPRONT';
    NMSMTP1.UserID := 'petr';
    NMSMTP1.Connect;
  end;
  NMSMTP1.PostMessage.Body.Text := ed_Modul.Text+' '+ed_MajVersion.Text+'.'+ed_MinVersion.Text;
  NMSMTP1.PostMessage.Body.Add(ed_Company.Text);
  NMSMTP1.PostMessage.Body.Add(ed_HD.Text+'   '+ed_User.Text);
  NMSMTP1.PostMessage.Body.Add('Vyzeno !');
  NMSMTP1.PostMessage.Body.Add(' ');
  NMSMTP1.PostMessage.Body.Add('* Odeslno programem Register master *');
  NMSMTP1.SendMail;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   if not ReadParamFile then exit;
   ReadParams;
end;

procedure TForm1.ReadParams;
var
   Ini: TIniFile;
   S: string;
begin
   cb_HDControl.Checked := true;
   S := ParamStr(0);
   S := ChangeFileExt(S,'.TXT');
   if not FileExists(S) then exit;
   Ini := TIniFile.Create(S);
   ed_Modul.Text := Ini.ReadString('REG','Modul','');
   ed_MajVersion.Text := Ini.ReadString('REG','MajVersion','0');
   ed_MinVersion.Text := Ini.ReadString('REG','MinVersion','0');
   ed_Company.Text := Ini.ReadString('REG','Company','');
   ed_User.Text := Ini.ReadString('REG','User','');
   //ed_CryptHD.Text := Ini.ReadString('REG','CryptHD','');
   CloseAfter :=Ini.ReadBool('REG','Close',false);
   //BitBtn3Click(nil);
   Application.ProcessMessages;
   Ini.WriteString('REG','HD',ed_HD.Text);
   Ini.WriteString('REG','HDC',ed_HDC.Text);
   //Ini.WriteString('REG','CryptHDC',ed_CryptHDC.Text);
   Ini.Free;
   if CloseAfter then
      Application.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   ed_cc.Text :=  GetControlCode(R,true);
   if not CheckControlCode(R) then
   begin
      ShowMessage('Chybn kd');
   end;
end;

END.
