unit e_InterpretNameBypropertyModel;

interface
uses
   e_IModel;

type

TInterpretNameByPropertyModel = class(TInterpretModel)
  private
    FBasicName: string;
    FPropertyForName: string;
    procedure SetBasicName(const Value: string);
    procedure SetPropertyForName(const Value: string);
protected
   function     GetName: string; override;
   procedure    SetName(aName: string); override;
published
   property BasicName: string read FBasicName write SetBasicName;
   property PropertyForName: string read FPropertyForName write SetPropertyForName;
end;

implementation
uses
   Elements,
   e_ElementModel,
   e_Class;

{ TInterpretNameByPropertyModel }

function TInterpretNameByPropertyModel.GetName: string;
var
   E: TElement;
begin
   result := BasicName;
   if NoPropertyModels then exit;
   E := PropertyModels.FindElementName(PropertyForName);
   if E = nil then exit;
   result := result + ' '+ TPropertyModel(E).Value;
end;

procedure TInterpretNameByPropertyModel.SetBasicName(const Value: string);
begin
  FBasicName := Value;
end;

procedure TInterpretNameByPropertyModel.SetName(aName: string);
begin
end;

procedure TInterpretNameByPropertyModel.SetPropertyForName( const Value: string);
begin
  FPropertyForName := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TInterpretNameByPropertyModel);
END.
