unit f_SelectMultiDir;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TDialogSelectMultidir = class(TForm)
    LB: TListBox;
    ed_Dir: TEdit;
    b_SelDir: TSpeedButton;
    b_Add: TBitBtn;
    b_Delete: TBitBtn;
    b_OK: TBitBtn;
    b_Cancel: TBitBtn;
    BitBtn1: TBitBtn;
    procedure LBClick(Sender: TObject);
    procedure b_AddClick(Sender: TObject);
    procedure b_DeleteClick(Sender: TObject);
    procedure b_SelDirClick(Sender: TObject);
  private
    FDir: string;
    procedure SetDir(const Value: string);
    { Private declarations }
  public
    property Dir: string read FDir write SetDir;
  end;


implementation
uses
   FileCtrl;

{$R *.dfm}

{ TDialogSelectMultidir }

procedure TDialogSelectMultidir.SetDir(const Value: string);
begin
  FDir := Value;
  LB.Items.Delimiter := ';';
  LB.Items.DelimitedText := Value;
end;

procedure TDialogSelectMultidir.LBClick(Sender: TObject);
begin
   ed_Dir.Text := LB.Items.Strings[LB.ItemIndex];
end;

procedure TDialogSelectMultidir.b_AddClick(Sender: TObject);
var
   S: String;
begin
   S := ed_Dir.Text;
   if S = '' then exit;
   if LB.Items.IndexOf(S)>-1 then exit;
   LB.Items.Add(S);
   LB.Items.Delimiter := ';';
   Dir := LB.Items.DelimitedText;
end;

procedure TDialogSelectMultidir.b_DeleteClick(Sender: TObject);
begin
   ed_Dir.Text := '';
   if LB.ItemIndex > -1 then
      LB.Items.Delete(LB.ItemIndex);
   LB.Items.Delimiter := ';';
   Dir := LB.Items.DelimitedText;
end;

procedure TDialogSelectMultidir.b_SelDirClick(Sender: TObject);
var
   S: string;
begin
   S := ed_Dir.Text;
   if SelectDirectory('Vbr jedn datov sloky','',S) then
      ed_Dir.Text := S;
end;

end.

