unit T_Main;

interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  // GISLAYAER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_ToolModel,
  e_Type,
  HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// APP
  t_ControlGroup,
// LHC
  e_LHCProject,
// MAPPER
  e_Map,
  e_MSpace;
  //f_MSEdit,
  //f_Templ,
  //t_Guide,
  //t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
    FProjectDirectory: string;
    FProjectFile: string;
    FDontViewProjectIntroDialog: boolean;
    FAutoOpenLastProject: boolean;
    FExportScript: string;
    FImportScript: string;
    FEditorScript: string;
    FEditorDataScript: string;
    FExportControlDirectory: string;
    FEditorOn: boolean;
  procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
    procedure SetProjectDirectory(const Value: string);
    procedure SetProjectFile(const Value: string);
    procedure SetDontViewProjectIntroDialog(const Value: boolean);
    procedure SetAutoOpenLastProject(const Value: boolean);
    procedure SetExportScript(const Value: string);
    procedure SetImportScript(const Value: string);
    procedure SetEditorScript(const Value: string);
    procedure SetEditorDataScript(const Value: string);
    procedure SetExportControlDirectory(const Value: string);
    procedure SetEditorOn(const Value: boolean);
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   ImportScript: string read FImportScript write SetImportScript;
  property   ExportScript: string read FExportScript write SetExportScript;
  property   EditorScript: string read FEditorScript write SetEditorScript;
  property   EditorDataScript: string read FEditorDataScript write SetEditorDataScript;
  property   ExportControlDirectory: string read FExportControlDirectory write SetExportControlDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
  property   ProjectFile: string read FProjectFile write SetProjectFile;
  property   DontViewProjectIntroDialog: boolean read FDontViewProjectIntroDialog write SetDontViewProjectIntroDialog;
  property   AutoOpenLastProject: boolean read FAutoOpenLastProject write SetAutoOpenLastProject;
  property   EditorOn: boolean read FEditorOn write SetEditorOn;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;


TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  FEditor: TControlGroup;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FActualAction: integer;
    FActualActionVisible: boolean;
    FButtonCount: integer;
    FActualActionImageIndex: integer;
    FActualActionCaption: string;
    FActualActionScript: string;
    FProject: TORBISLHCProject;
    FCaptionString: string;
  function  GetNOptions: TOptions; virtual;
  procedure SetNOptions(aValue: TOptions); virtual;
  function  GetCommandLine: TCommandLine;
  procedure SetCommandLine(aValue: TCommandLine);
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
    procedure SetActualAction(const Value: integer);
    procedure SetActualActionCaption(const Value: string);
    procedure SetActualActionImageIndex(const Value: integer);
    procedure SetActualActionScript(const Value: string);
    procedure SetActualActionVisible(const Value: boolean);
    procedure SetButtonCount(const Value: integer);
    procedure SetNewImage(const Value: string);
    function GetActualActionCaption: string;
    function GetActualActionImageIndex: integer;
    function GetActualActionScript: string;
    function GetActualActionVisible: boolean;
    function GetActualActionHint: string;
    procedure setActualActionHint(const Value: string);
    procedure SetShowActionsCaptions(const Value: boolean);
    function GetImageHeight: integer;
    function GetImageWidth: integer;
    procedure SetImageHeight(const Value: integer);
    procedure SetImageWidth(const Value: integer);
    procedure SetProject(const Value: TORBISLHCProject);
    procedure SetCaptionString(const Value: string);
    function GetEditor: TControlGroup;
    procedure SetEditor(const Value: TControlGroup);
    function GetEditorModel: TToolModel;
    function GetScriptDirectory: string;
protected
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   CreateNewModel;
   procedure   OpenLastProject;
   procedure   LoadProjectFromFile(aFile: string);
   procedure   SaveProject;
   procedure   CheckProjectForSave;
   procedure   LoadProjectData;
   procedure   SaveProjectData;
   procedure   ImportData;
   procedure   LoadEditorModelFile;
   procedure   SaveEditorModelFile;
   procedure   SetEditorData;
   procedure   ViewProjectIntroDialog;
   procedure   RunStartScripts; override;
   function    GetOptions: TBaseOptions; override;
   procedure   SetOptions(aValue: TBaseOptions); override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_SetUpProject(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProjectAs(var Handled: boolean); virtual;
   procedure  On_tm_Import(var Handled: boolean); virtual;
   procedure  On_tm_Export(var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  On_tm_Editor(var Handled: boolean); virtual;
   procedure  On_tm_ModelChanged(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_Intro; virtual;
   procedure  on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   ExePath: string read GetExePath;
   property   ButtonCount: integer read FButtonCount write SetButtonCount;
   property   CaptionString: string read FCaptionString write SetCaptionString;
   property   EditorModel: TToolModel read GetEditorModel;
   property   ScriptDirectory: string read GetScriptDirectory;
published
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   CommandLine: TCommandLine read GetCommandLine write SetCommandLine;
   property   ExecuteScript: string write ExecScript stored false;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   NewImage: string write SetNewImage;
   property   ActualAction: integer read FActualAction write SetActualAction;
   property   ActualActionVisible: boolean read GetActualActionVisible write SetActualActionVisible;
   property   ActualActionScript: string read GetActualActionScript write SetActualActionScript;
   property   ActualActionImageIndex: integer read GetActualActionImageIndex write SetActualActionImageIndex;
   property   ActualActionCaption: string read GetActualActionCaption write SetActualActionCaption;
   property   ActualActionHint: string read GetActualActionHint write setActualActionHint;
   property   ImageHeight: integer read GetImageHeight write SetImageHeight;
   property   ImageWidth: integer read GetImageWidth write SetImageWidth;
   property   ShowActionCaptions: boolean write SetShowActionsCaptions;
   property   Project: TORBISLHCProject read FProject write SetProject;
   property   Editor: TControlGroup read GetEditor write SetEditor;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  ActnList,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
// EXPLORER
  f_CmdLn,
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// SYMBOL
  u_Symbol,
// INTERPRET
  e_IScrpt,
// 0TEMP
  e_DClass,
  f_SelDir,
  T_EdiPro,
  t_Saver,
  t_Loader,
// TOPOL
  e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  t_Intera,
// MAIN
  F_Main,
  f_Option,
  F_Start,
  M_Proj,
// APP
  t_ProjectIntroDialog,
  t_ConfirmDialog,
// LHC
  t_LHCProjectDialog,
  t_exportLHCDialog,
  t_ExpLHC,
  t_HelLHC,
// FILES
  u_File,
// REG
  FileVersion,
  u_cktm;
// MAPPER
  //t_MSEdit,
  //t_VieMap;

{TOptions}


function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;

procedure TOptions.SetAutoOpenLastProject(const Value: boolean);
begin
   FAutoOpenLastProject := Value;
end;

procedure TOptions.SetDontViewProjectIntroDialog(const Value: boolean);
begin
  FDontViewProjectIntroDialog := Value;
end;

procedure TOptions.SetEditorDataScript(const Value: string);
begin
  FEditorDataScript := Value;
end;

procedure TOptions.SetEditorOn(const Value: boolean);
begin
  FEditorOn := Value;
end;

procedure TOptions.SetEditorScript(const Value: string);
begin
  FEditorScript := Value;
end;

procedure TOptions.SetExportControlDirectory(const Value: string);
begin
  FExportControlDirectory := Value;
end;

procedure TOptions.SetExportScript(const Value: string);
begin
  FExportScript := Value;
end;

procedure TOptions.SetImportScript(const Value: string);
begin
  FImportScript := Value;
end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   PaletFile := Value;
   NactiBarvickuZeSouboru(Value);
end;

procedure TOptions.SetProjectDirectory(const Value: string);
begin
   FProjectDirectory := Value;
end;

procedure TOptions.SetProjectFile(const Value: string);
begin
  FProjectFile := Value;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := aValue;
   RemoveBackSlash(PathOfLibraries);
end;


{TMainTool}


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   //result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   //result := MainForm.ProgressBar.Max;
end;

function  TMainTool.GetProgress: integer;
begin
   //result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   //result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   //MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  //Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   //if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

function  TMainTool.GetCommandLine: TCommandLine;
begin
   if FCommandLine = nil then
   begin
      FCommandLine := TCommandLine.Create;
      FCommandLine.Name := 'Hlavn interpret jazyka OIL';
      AddTool(FCommandLine);
   end;
   result := FCommandLine;
end;


procedure TMainTool.SetCommandLine(aValue: TCommandLine);
begin
   if FCommandLine <> nil then
   begin
      FreeTool(FCommandLine);
      FCommandLine := nil;
   end;
   FCommandLine := aValue;
   AddTool(FCommandLine);
end;


procedure TMainTool.ExecScript(aFileName: string);
begin
   if aFileName = '' then exit;
   if pos(':',aFileName) = 0 then
   begin
      aFileName := ExePath + aFileName;
   end;
   CommandLine.FileName:= aFileName;
   CommandLine.DoIt
end;





procedure TMainTool.DoIt;
var
   S: string;
begin
   getDir(0, S);
   //Options.WorkingDirectory := S;
   Options.DataDirectory := S;
   inherited;
   Application.ProcessMessages;
   CaptionString := MainForm.Caption + '- ';
   PostMsg(tm_Intro,Self,nil,false);
   Text := 'Inicializace O.K.';
end;





procedure TMainTool.ReadParamsFromIni;
var
   IniFile: TIniFile;
begin
   inherited ReadParamsFromIni;
   IniFile:= TIniFile.Create(IniFileName);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
   IniFile.Free;

end;



procedure TMainTool.ReadParams;
begin
   ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
(*
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;
*)
begin
   //IniFile:= TRealIniFile.Create(IniFileName);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   //IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   //SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   D: TF_Options;
begin
   Handled := true;
   Application.CreateForm(TF_Options, D);

   D.ed_Script.Text := Options.ScriptDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Project.Text := Options.ProjectDirectory;
   D.c_DontViewDialog.Checked := Options.DontViewProjectIntroDialog;
   D.c_OpenLastProject.Checked := Options.AutoOpenLastProject;
   if D.ShowModal = mrOk then
   begin
      Options.ScriptDirectory := D.ed_Script.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.ProjectDirectory := D.ed_Project.Text;
      Options.DontViewProjectIntroDialog := D.c_DontViewDialog.Checked;
      Options.AutoOpenLastProject := D.c_OpenLastProject.Checked;
   end;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   //MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   WriteParamsToIni;
   CheckProjectForSave;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var Handled: boolean);
var
   D: TLHCProjectDialog;
   CD: TOrbisConfirmDialog;
   P: TORBISLHCproject;
   Save: TSave;
   S : string;
begin
   D := TLHCProjectDialog.Create;
   D.Caption := 'Nov projekt';
   D.ProjectDirectory := Options.ProjectDirectory;
   D.DoIt;
   if D.result = 1 then
   begin
      P := TORBISLHCproject(D.Output);
      // projektovy soubor za tepla ulozime
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      S := S+P.Name+'.OPR';
      Save := TSave.Create;
      Save.FileName := S;
      Save.Input := P;
      Save.DoIt;
      StartProgress('Tvorba novho projektu: '+P.Name,0,0);
      // Vycistime Model
      CheckProjectForSave;
      CreateNewModel;
      Project := P;
      Options.ProjectFile := S;
      // co takhle nejakej import
      CD := TOrbisConfirmDialog.Create;
      CD.Text := 'Byl vytvoen nov projekt s nzvem '+P.Name+
             '. Dosud neobsahuje dn data - pejete si je importovat z TopoLu?';
      CD.Caption := 'Nov projekt';
      CD.DoIt;
      Case CD.Result of
         1:
         begin
            ImportData;
            SetEditorData;
         end;
      end;
      CD.Free;
      EndProgress;
   end;
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
var
   Load: TLoad;
   P: TORBISLHCProject;
begin
   MainForm.OpenDialog.InitialDir := Options.ProjectDirectory;
   if MainForm.OpenDialog.Execute then
   begin
      LoadProjectFromFile(MainForm.OpenDialog.FileName);
   end;
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;



procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin

  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.SimpleText := TOrbisTextMessage(aMessage).Text;
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   CommandLine := nil;
   //MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_SaveProject: on_tm_SaveProject(Handled);
      tm_SaveProjectAs: on_tm_SaveProjectAs(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_Import:     on_tm_Import(Handled);
      tm_Export:     on_tm_Export(Handled);
      tm_Editor:     on_tm_Editor(Handled);
      tm_ModelChanged:  on_tm_ModelChanged(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      tm_SetUpProject:  on_tm_SetUpProject(Handled);
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_MapSheetList: PostMsg(tm_Explore, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);



     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);
      tm_OIL              : on_tm_OIL(aMessage,Handled);

      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
      tm_Run              : on_tm_Run(aMessage,Handled);
      tm_Intro            : on_tm_Intro;
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)   
end;


function  TMainTool.GetText: string;
begin
   result := '';
   //result := MainForm.StatusBar.Panels.Items[0].Text;
end;

procedure TMainTool.SetText(const aValue: string);
begin
   //MainForm.StatusBar.Panels.Items[0].Text := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;








procedure TMainTool.SetActualAction(const Value: integer);
begin
   FActualAction := Value;
   if FActualAction > 4 then FActualAction := 4;
end;

procedure TMainTool.SetActualActionCaption(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Caption := Value;
end;

procedure TMainTool.SetActualActionImageIndex(const Value: integer);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex := Value;
end;

procedure TMainTool.SetActualActionScript(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Category := Value;
end;

procedure TMainTool.SetActualActionVisible(const Value: boolean);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Visible := Value;
end;

procedure TMainTool.SetButtonCount(const Value: integer);
begin
end;

procedure TMainTool.SetNewImage(const Value: string);
var
   BM: Graphics.TBitmap;
   S: string;
begin
   {
   BM := Graphics.TBitmap.Create;
   S := '';
   if pos(':',Value) = 0 then
   begin
      S := ExePath;
      CheckBackSlash(S);
   end;
   S := S + Value;
   try
      BM.LoadFromFile(S);
   except
   end;
   MainForm.ImageList.AddMasked(BM,clGray);
   }
end;

procedure TMainTool.on_tm_Run(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   S,SS: string;
begin
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   if pos(':',S) = 0 then
   begin
      SS := ExePath;
      CheckBackSlash(SS);
      S := SS + S;
   end;
   ExecuteScript := S;
end;

function TMainTool.GetActualActionCaption: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Caption;
end;

function TMainTool.GetActualActionImageIndex: integer;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex;
end;

function TMainTool.GetActualActionScript: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Category;
end;

function TMainTool.GetActualActionVisible: boolean;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Visible;
end;

function TMainTool.GetActualActionHint: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Hint;
end;

procedure TMainTool.setActualActionHint(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Hint := Value;
end;

procedure TMainTool.SetShowActionsCaptions(const Value: boolean);
begin
{
   MainForm.ToolBar.ShowCaptions := Value;
   MainForm.ToolBar.ButtonHeight := 50;
   MainForm.ToolBar.ButtonWidth := 50;
}
end;

function TMainTool.GetImageHeight: integer;
begin
   //result := MainForm.ImageList.Height;
end;

function TMainTool.GetImageWidth: integer;
begin
   //result := MainForm.ImageList.Width;
end;

procedure TMainTool.SetImageHeight(const Value: integer);
begin
   //MainForm.ImageList.Height := Value;
end;

procedure TMainTool.SetImageWidth(const Value: integer);
begin
   //MainForm.ImageList.Width := Value;
end;

procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   CMD: TCommandLineDlg;
   El: TElement;
begin
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
end;

procedure TMainTool.RunStartScripts;
var
  OIL: string;
  S,SS: string;
begin
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else ExecuteScript := Options.StartScript;
  S := ScriptDirectory;
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := S + 'Model.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
end;

procedure TMainTool.On_tm_SaveProject(var Handled: boolean);
begin
   SaveProjectData;
end;

procedure TMainTool.On_tm_SaveProjectAs(var Handled: boolean);
begin

end;

procedure TMainTool.ViewProjectIntroDialog;
var
   D: TProjectIntroDialog;
begin
   D := TProjectIntroDialog.Create;
   D.LastProjectName := Options.ProjectFile;
   D.DoIt;
   case D.Result of
      1:  PostMsg(tm_NewProject,Self,nil,false);
      2:  PostMsg(tm_OpenProject,Self,nil,false);
      3:  OpenLastProject;
   end;
   if D.DontViewDialog then Options.DontViewProjectIntroDialog := true
                       else Options.DontViewProjectIntroDialog := false;
   if D.OpenLastProject then Options.AutoOpenLastProject := true
                        else Options.AutoOpenLastProject := false;
   D.Free;
end;

procedure TMainTool.OpenLastProject;
begin
   LoadProjectFromFile(Options.ProjectFile);
end;

procedure TMainTool.SetProject(const Value: TORBISLHCProject);
begin
   ExChangeFieldElement(TElement(FProject),Value);
   if Value <> nil then
   begin
      MainForm.Caption := CaptionString + Value.Name;
   end;
end;

procedure TMainTool.on_tm_Intro;
begin
   if not Options.DontViewProjectIntroDialog then
      ViewProjectIntroDialog
   else if Options.AutoOpenLastProject then OpenLastProject;
   if Options.EditorOn then
      PostMsg(tm_Editor,Self,nil, false);
end;

procedure TMainTool.CreateNewModel;
var
   S,SS: string;
   E: TEntity;
begin
   ProgressText := 'Ruen stvajcho modelu...';
   Application.ProcessMessages;
   E := World.ObjectModel;
   NextElement := E;
   World.ObjectModel := nil;
   E.Free();
   ProgressText := 'Vytven struktury novho  modelu...';
   Application.ProcessMessages;
   S := ScriptDirectory;
   CheckBackSlash(S);
   SS := S + 'Model.Oil';
   ExecuteScript := SS;
   ProgressText := 'Struktura novho modelu zdrn vytvoena';
   Application.ProcessMessages;
end;

procedure TMainTool.ImportData;
begin
   ProgressText := 'Probh import externch dat ...';
   Application.ProcessMessages;
   ExecuteScript := Options.ImportScript;
   Project.Modified := true;
   Project.LastChangesExported := true;
end;

procedure TMainTool.on_tm_SetUpProject(var Handled: boolean);
var
   D: TLHCProjectDialog;
   S,S1: string;
begin
   if Project = nil then exit;
   D := TLHCProjectDialog.Create;
   D.ProjectDirectory := Options.ProjectDirectory;
   D.Input := Project;
   S := Project.ExternalDataDirectory;
   S1 := Project.ExternalDataDirectory;
   D.DoIt;
end;

procedure TMainTool.On_tm_Export(var Handled: boolean);
var
   D: TExportLHCDialog;
   TT: TExportLHC;
   T2: TExtractLHC;
   S: string;
begin
   if Project = nil then exit;
   D := TExportLHCDialog.Create;
   D.ExternalDataDirectory := Project.ExternalDataDirectory;
   D.ExportTEZ := true;
   D.ExportSRF := true;
   D.ControlDirectory := Options.ExportControlDirectory;
   D.Backup := false;
   D.BackupName := 'BL_';
   D.Caption := 'Export dat do TopoLu';
   D.DoIt;
   if D.Result <> 1 then
   begin
      D.Free;
      exit;
   end;
   Options.ExportControlDirectory := D.ControlDirectory;
   StartProgress('Export dat projektu '+ Project.Name+' do TopoLu',0,0);
   if D.ExportTEZ then
   begin
      S := 'Tba do bloku ' + D.TEZName;
      ProgressText := S +'- Hledn objekt...';
      Application.ProcessMessages;
      T2:=TExtractLHC.Create;
      T2.LayerName := 'TEZ';
      T2.DoIt;
      T2.Free;

      ProgressText := S +'- Export...';
      Application.ProcessMessages;

      TT := TExportLHC.Create;
      TT.BlockName := D.TEZName;
      TT.ControlDIR := Options.ExportControlDirectory;
      TT.LayerName := 'TEZ';
      TT.Group := 135;
      TT.PropertyClassName := 'TTezPProps';
      TT.DoIt;

      TT.Free;
   end;
   if D.ExportSRF then
   begin
      S := 'rafy do bloku ' + D.TEZName;
      ProgressText := S +'- Hledn objekt...';
      Application.ProcessMessages;
      T2:=TExtractLHC.Create;
      T2.LayerName := 'SRF';
      T2.DoIt;
      T2.Free;

      ProgressText := S +'- Export...';
      Application.ProcessMessages;

      TT := TExportLHC.Create;
      TT.BlockName := D.SRFName;
      TT.ControlDIR := Options.ExportControlDirectory;
      TT.LayerName := 'SRF';
      TT.Group := 144;
      TT.PropertyClassName := 'TTopolAreaProps';
      TT.DoIt;

      TT.Free;
   end;
   {
   *
   T2=Create(TExtractLHC,ET)
   T2.LayerName='SLU_PNT'
   T2.DoIt()
   T2.Free()


   TT=Create(TExportSimpleLHC,HPT)
   TT.BlockName='K:\ORBIS32\SLU_PNT.BLK'
   TT.ControlDIR='K:\ORBIS32\EXE\LED'
   TT.LayerName='SLU_PNT'
   TT.PropertyClassName='TTezPProps'
   TT.DoIt()
   TT.Free()
   *
   }
   EndProgress;
   D.Free;
end;

procedure TMainTool.On_tm_Import(var Handled: boolean);
begin
   if not Confirm('Vechna dosavadn data projektu pjdou asi do hje ... pokraovat ?') then
      exit;
   StartProgress('Import',0,0);
   CreateNewModel;
   ImportData;
   SetEditorData;
   EndProgress;
end;

procedure TMainTool.LoadProjectFromFile(aFile: string);
var
   Load: TLoad;
   NewProject: TORBISLHCProject;
begin
   if (aFile <> Options.ProjectFile) or (Project = nil) then
   begin
      StartProgress('Otevrn projektu: '+ aFile,0,0);
      ProgressText := 'ten projektovho souboru ...';
      Application.ProcessMessages;
      Load := TLoad.Create;
      Load.FileName := aFile;
      Load.DoIt;
      NewProject := TORBISLHCProject(Load.Output);
      ProgressText := 'Kontrola uloen pvodnho projektu ...';
      Application.ProcessMessages;
      CheckProjectForSave;
      Project := NewProject;
      Options.ProjectFile := aFile;
      CreateNewModel;
      if Project.DataFileExists
      then
      begin
         LoadProjectData;
      end
      else
      begin
         if Confirm('Projekt: '+Project.Name,
          'Projekt neobsahuje dosud dn data, pejete si je nyn naimportovat ?') = 1 then
         begin
            ImportData;
         end;
      end;
      SetEditorData;
      EndProgress;
   end;
end;

procedure TMainTool.CheckProjectForSave;
begin
   if Editor <> nil then
      Editor.UpdateModel;
   SaveEditorModelFile;
   if Project = nil then exit;
   if Project.Modified then
   begin
      if Confirm('Projekt '+ Project.Name + ' zmnn - pejete si ho uloit ?') then
      begin
         SaveProjectData;
      end;
   end;
end;

procedure TMainTool.LoadProjectData;
var
   Load: TLoad;
begin
   ProgressText := 'ten datovho souboru ...';
   Application.ProcessMessages;
   Load := TLoad.Create;
   Load.FileName := Project.DataFileName;
   try
      Load.DoIt;
      World.ObjectModel := TObjectModel(Load.output);
   except
      if Confirm('Pi natn dat Projektu dolo k Chyb') then ;
   end;
   Load.Free;
end;

procedure TMainTool.SaveProjectData;
var
   Save: TSave;
   BackFileName,FileName: string;
begin
   FileName := Project.DataFileName;
   BackFileName := ChangeFileExt(FileName,'.OR_');
   if FileExists(BackFileName) then
      DeleteFile(PChar(BackFileName));
   RenameFile(FileName,BackFileName);
   Save := TSave.Create;
   Save.Input := World.ObjectModel;
   Save.FileName := FileName;
   Save.DoIt;
   Save.Free;
   Project.Modified := false;
   Saveproject;
end;

procedure TMainTool.SaveProject;
var
   Save: TSave;
begin
   Save := TSave.Create;
   Save.Input := Project;
   Save.FileName := Options.ProjectFile;
   Save.DoIt;
   Save.Free;
end;

procedure TMainTool.SetCaptionString(const Value: string);
begin
   FCaptionString := Value;
end;

procedure TMainTool.On_tm_Editor(var Handled: boolean);
begin
   if Editor <> nil then
   begin
      Editor.UpdateModel;
      PostMsg(tm_QuitTask,Editor,nil,false);
      FEditor := nil;
      MainForm.a_GraphicEditor.Checked := false;
      Options.EditorOn := false;
   end
   else
   begin
      if EditorModel = nil then
         LoadEditorModelFile;
      if EditorModel = nil then
         ExecuteScript := Options.EditorScript;
      if EditorModel = nil then
      begin
         ShowMessage('Chyba skriptu pro vytvoen Editoru!');
         exit;
      end;
      NewToolByModel := EditorModel;
      Editor.Visible := true;
      ExecuteScript := Options.EditorDataScript;
      MainForm.a_GraphicEditor.Checked := true;
      Options.EditorOn := true;
   end;
end;

function TMainTool.GetEditor: TControlGroup;
begin
   result := nil;
   if FEditor = nil then
   begin
      FEditor := TControlGroup(GetToolByName('EDITOR'));
   end;
   result := FEditor;
end;

procedure TMainTool.SetEditor(const Value: TControlGroup);
begin
   ExchangeFieldTool(TTool(Feditor),Value);
end;

function TMainTool.GetEditorModel: TToolModel;
var
   E: Telement;
begin
   result := nil;
   E := World.SystemRegister.FindElementName('EDITOR');
   if not (E is TToolModel) then exit;
   result := TToolModel(E);
end;

procedure TMainTool.SetEditorData;
begin

   if Editor <> nil then
      ExecuteScript := Options.EditorDataScript;
end;

procedure TMainTool.On_tm_ModelChanged(var Handled: boolean);
begin
   if Project <> nil then
      Project.Modified := true;
end;

function TMainTool.GetScriptDirectory: string;
var
   S: string;
begin
   S := Options.ScriptDirectory;
   CheckBackSlash(S);
   result := S;
end;

procedure TMainTool.LoadEditorModelFile;
var
   S: string;
   L: TLoad;
begin
   S := ExePath+'LEDEDITOR.ORB';
   if not FileExists(S) then
      exit;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.SystemRegister.NextElement := L.Output;
   L.Free;
end;

procedure TMainTool.SaveEditorModelFile;
var
   S: TSave;
   FN: string;
begin
   if EditorModel = nil then exit;
   FN := ExePath+'LEDEDITOR.ORB';
   S := TSave.Create;
   S.Input := EditorModel;
   S.FileName := FN;
   S.DoIt;
   S.Free;
end;

END.
