unit f_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin;

type
  TForm1 = class(TForm)
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    RichEdit: TRichEdit;
    OpenDialog: TOpenDialog;
    ToolButton2: TToolButton;
    StatusBar: TStatusBar;
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure RichEditSelectionChange(Sender: TObject);
  private
    procedure Process(aValue: string; aColor: TColor);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
const
   s_SELECT = 'Select';
   s_From   = 'From';
   s_Where  = 'Where';
   s_And    = 'And';
   s_Or     = 'OR';
   s_Update = 'Update';
   s_Set    = 'Set';

{$R *.DFM}

procedure TForm1.Process(aValue: string; aColor: TColor);
var
   Pos: integer;
begin
   Pos := 0;
   StatusBar.SimpleText := 'Syntaxe '+aValue;
   While Pos > -1 do
   begin
      Pos := RichEdit.FindText(aValue,Pos,Length(RichEdit.Text),[stWholeWord]);
      if Pos > -1 then
      begin
         RichEdit.SelStart := Pos;
         RichEdit.SelLength := Length(aValue);
         RichEdit.SelAttributes.Color := aColor;
         RichEdit.SelAttributes.Style := [fsBold];
         Pos := Pos + 1;
      end;
   end;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
      RichEdit.Lines.LoadFromFile(OpenDialog.FileName);
   end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
   RichEdit.Enabled := false;
   Process(s_Select, clRed);
   Process(s_From, clRed);
   Process(s_Where, clRed);
   Process(s_And, clBlack);
   Process(s_Or, clBlack);
   Process(s_Update, clRed);
   Process(s_Set, clGreen);
   RichEdit.Enabled := true;
end;

procedure TForm1.RichEditSelectionChange(Sender: TObject);
var
   ln,li: integer;
begin
   Ln :=   RichEdit.Perform(EM_LINEFROMCHAR, -1, 0);
   Li :=   RichEdit.Perform(EM_LINEINDEX, -1, 0);
   Li :=   RichEdit.SelStart - Li;
   StatusBar.SimpleText := IntToStr(Ln)+'/'+IntToStr(Li);
end;

end.
