unit F_dirdlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Grids, ExtCtrls;

type
  TDirDlg = class(TForm)
    Panel1: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Panel: TPanel;
    E0: TEdit;
    S0: TSpeedButton;
    L0: TLabel;
    procedure E0Change(Sender: TObject);
    procedure S0Click(Sender: TObject);
  private
     FDirs: TStringList;
     procedure SetDirs(aValue: TStringList);
     function  FindC(const aName, Me: string): TComponent;
  public
     property Dirs: TStringList read FDirs write SetDirs;
  end;


implementation

{$R *.DFM}

uses
   SysUtils,
   FileCtrl,
   //f_SelDir,
   u_String;

procedure TDirDlg.SetDirs(aValue: TStringList);
var
   i: longInt;
   E: TEdit;
   L: TLabel;
   S: TSpeedButton;
   V: integer;
   Param, Val: string;
begin
   FDirs := aValue;
   V := E0.Top + E0.Height + 5;
   for i := 0 to aValue.Count - 1 do
   begin
      StringAsParameter(aValue.Strings[i], Param, Val);
      if i = 0 then
      begin
         L0.Caption := Param;
         E0.Text := Val;
      end
      else
      begin
         E := TEdit.Create(nil);
         Panel.InsertControl(E);
         E.Name := 'E'+IntToStr(i);
         E.Text := Val;
         E.Left  := E0.Left;
         E.Width := E0.Width;
         E.Top := V;
         E.OnChange := E0Change;

         L := TLabel.Create(nil);
         Panel.InsertControl(L);
         L.Name := 'L'+IntToStr(i);
         L.Caption := Param;
         L.Left  := L0.Left;
         L.Top := V;

         S := TSpeedButton.Create(nil);
         Panel.InsertControl(S);
         S.Name := 'S'+IntToStr(i);
         S.Caption := '...';
         S.Left  := S0.Left;
         S.Top := V;
         S.Height := E.Height;
         S.OnClick := S0Click;

         V := E.Top + E.Height + 5;
      end;
   end;
   V := V + 10;
   if Panel.Height < V then Height := Height + (V - Panel.Height);
end;

function  TDirDlg.FindC(const aName, Me: string): TComponent;
var
   S: string;
   i: longInt;
begin
   S := UpperCase(aName + Me[2]);
   result := nil;
   for i := 0 to Panel.ControlCount -1 do
   begin
      if UpperCase(Panel.Controls[i].Name) = S then
      begin
         result := Panel.Controls[i];
         exit;
      end;
   end;
end;

procedure TDirDlg.E0Change(Sender: TObject);
var
   S: string;
   E: TEdit;
   i: longInt;
begin
   if Sender is TEdit then
   begin
      E := TEdit(Sender);
      S := E.Name;
      i := StrToInt(S[2]);
      S := TLabel(FindC('L',E.Name)).Caption;
      Dirs.Values[S] := E.Text;
   end;
end;

procedure TDirDlg.S0Click(Sender: TObject);
var
   //D: TF_SelectDir;
   E: TEdit;
   S,D: string;
begin
   (*
   if not (Sender is TSpeedButton) then exit;
   E := TEdit(FindC('E', TSpeedButton(Sender).Name));
   Application.CreateForm(TF_SelectDir,D);
   if DirectoryExists(E.Text) then D.Directory.Directory := E.Text;
   if D.ShowModal = mrOK then
   begin
      E.Text := D.Directory.Directory;
   end;
   D.Free;
   *)
   if not (Sender is TSpeedButton) then exit;
   E := TEdit(FindC('E', TSpeedButton(Sender).Name));
   {
   if DirectoryExists(E.Text) then S := E.Text
                              else S := 'c:\';
   }
   S := '';
   if SelectDirectory('Vbr sloky',S,D) then
   begin
      E.Text := D;
   end;
end;

end.
