unit F_MTextReplace;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CheckLst;

type
  TForm1 = class(TForm)
    l_rasIn: TLabel;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    ed_Dirout: TEdit;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    l_Info: TLabel;
    l_tx: TLabel;
    Label1: TLabel;
    FileList: TCheckListBox;
    ErrList: TListBox;
    Label2: TLabel;
    Button3: TButton;
    ed_Search: TEdit;
    ed_Replace: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FStart: boolean;
    procedure SetStart(const Value: boolean);
  private
    FRasName: string;
    FDirOut: string;
    procedure SetRasName(const Value: string);
    procedure SetDirOut(const Value: string);
    function  Repl: boolean;
    property  Start: boolean read FStart write SetStart;
  public
     property RasName: string read FRasName write SetRasName;
     property DirOut: string read FDirOut write SetDirOut;
  end;

var
  Form1: TForm1;

implementation
uses
   FileCtrl;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   if not OpenDialog.Execute then exit;
   RasName := OpenDialog.FileName;
   FileList.Clear;
   ErrList.Clear;
   FileList.Items.Assign(OpenDialog.Files);
   l_Info.Caption := 'Poet soubor : '+IntToStr(FileList.Count);
   Button2.SetFocus;
end;

procedure TForm1.SetDirOut(const Value: string);
begin
   FDirOut := Value;
   ed_DirOut.Text := DirOut;
end;

procedure TForm1.SetRasName(const Value: string);
begin
  FRasName := Value;
  l_rasIn.Caption := Value;
  if DirOut = '' then
     DirOut := ExtractFilePath(Value);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
   Dir: string;
begin
   if DirOut <> '' then
      Dir := DirOut
   else
      Dir := '';
   if SelectDirectory('Adres pro vstup','',Dir) then
      DirOut := Dir;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   i: integer;
begin
   //NoRasLib := true;
   ErrList.Clear;
   for i := 0 to FileList.Count - 1 do
   begin
      FileList.Selected[i] := true;
      RasName := FileList.Items.Strings[i];
      if Repl then
      begin
         ErrList.Items.Add(FileList.Items.Strings[i]);
         FileList.Checked[i] := true;
      end
      else
      begin
         FileList.Checked[i] := false;
      end;
      l_Info.Caption := 'Projeto '+ IntToStr(i+1)+' soubor z '+IntToStr(FileList.Count)+' - '+IntToStr(ErrList.Count)+' repl.';
      Application.ProcessMessages;
   end;
   Caption := 'Hotovo !';
   //Button3.SetFocus;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
   Start := true;
end;

procedure TForm1.SetStart(const Value: boolean);
begin
  FStart := Value;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   if Start then
      Button1.SetFocus;
end;

function TForm1.Repl: boolean;
var
   SL: TStringList;
   i: integer;
   S,S1,S2: string;
   P: integer;
   l: integer;
begin
   result := false;
   SL := TStringList.Create;
   l := Length(ed_Search.Text);
   SL.LoadFromFile(RasName);
   for i := 0 to SL.Count - 1 do
   begin
      S := SL.Strings[i];
      P := Pos(ed_Search.Text,S);
      if P > 0 then
      begin
         S1 := copy(S,1,P-1);
         S2 := copy(S,P+l,Length(S));
         SL.Strings[i] := S1 + ed_Replace.Text + S2;
         SL.SaveToFile(RasName);
         result := true;
         break;
      end;
   end;
   SL.Free;
end;

end.

