unit f_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    Image: TImage;
    Panel1: TPanel;
    ed_Text: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    FontDialog: TFontDialog;
    Button2: TButton;
    ed_Angle: TSpinEdit;
    Memo1: TMemo;
    ed_Size: TEdit;
    ed_Height: TEdit;
    b_Size: TButton;
    b_Height: TButton;
    l_H: TLabel;
    l_S: TLabel;
    ed_pom: TEdit;
    b_pom: TButton;
    ed_Extra: TEdit;
    b_Extra: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ed_TextChange(Sender: TObject);
    procedure ed_AngleChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure b_SizeClick(Sender: TObject);
    procedure b_HeightClick(Sender: TObject);
    procedure b_pomClick(Sender: TObject);
    procedure b_ExtraClick(Sender: TObject);
  private
    FY: integer;
    FX: integer;
    procedure SetX(const Value: integer);
    procedure SetY(const Value: integer);
    { Private declarations }
  public
    procedure Review;
    property  _X: integer read FX write SetX;
    property  _Y: integer read FY write SetY;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
   FontDialog.Font.Assign(Image.Canvas.Font);
   if FontDialog.execute then
   begin
      Image.Canvas.Font.Assign(FontDialog.Font);
      ReView;
   end;
end;

procedure TForm1.Review;
var
   _Angle: integer;
   LogFont: TLogFont;
   aSize: TSize;
   TM: tagTEXTMETRICa;
   oS: integer;
   nS: integer;
   YY,ASc,aa: integer;
   S: string;
begin
   //SetGraphicsMode(Image.Canvas.Handle,GM_ADVANCED);
   Image.Canvas.Brush.Color := clWhite;
   Image.Canvas.Brush.Style := bsSolid;
   Image.Canvas.Pen.Style := psClear;
   Image.Canvas.Rectangle(Image.Canvas.ClipRect);
   Image.Canvas.Brush.Style := bsClear;
   Image.Canvas.Pen.Style := psSolid;
   Image.Canvas.Pen.Color := clRed;
   Image.Canvas.MoveTo(_X-10,_Y);
   Image.Canvas.LineTo(_X+10,_Y);
   Image.Canvas.MoveTo(_X,_Y-10);
   Image.Canvas.LineTo(_X,_Y+10);
   _Angle := ed_Angle.Value;
   GetObject(Image.Canvas.Font.Handle, sizeof(TLogFont), @LogFont);
   //GetTextMetrics
   //if _Angle <> 0 then
   begin
      with LogFont do
      begin
      (*
        lfHeight := Image.Canvas.Font.Height;
    {    lfHeight := Font.Size; }

        lfWidth := 0; { have font mapper choose }
        lfEscapement := round(_Angle*10);
        //lfOrientation := 0{round(aOrientation*10)};
        lfOrientation := lfEscapement;
        if fsBold in Image.Canvas.Font.Style then
          lfWeight := FW_BOLD
        else
          lfWeight := FW_NORMAL;
        lfItalic := Byte(fsItalic in Image.Canvas.Font.Style);
        lfUnderline := Byte(fsUnderline in Image.Canvas.Font.Style);
        lfStrikeOut := Byte(fsStrikeOut in Image.Canvas.Font.Style);
        lfCharSet := Image.Canvas.Font.CharSet;
        StrPCopy(lfFaceName, Image.Canvas.Font.Name);
        //lfQuality := DEFAULT_QUALITY;
        lfQuality := PROOF_QUALITY;
        { Everything else as default }
        lfOutPrecision := OUT_DEFAULT_PRECIS;
        lfClipPrecision := CLIP_DEFAULT_PRECIS;
        lfPitchAndFamily := byte(Image.Canvas.Font.Pitch);
       *)
         if ed_Pom.Text <> '' then
            lfWidth := StrToIntDef(ed_Pom.Text,0);
         lfEscapement := _Angle *10;
         //lfPitchAndFamily := FIXED_PITCH or FF_DONTCARE;
      end;
    {  DeleteObject(Canvas.Font.Handle); }
      Image.Canvas.Font.Handle := CreateFontIndirect(LogFont);
   end;
   GetTextMetrics(Image.Canvas.Handle,TM);
   YY := TM.tmDescent;
   //YY := Round((YY / Image.Canvas.Font.PixelsPerInch)* 72);

   Image.Canvas.MoveTo(_X,_Y+YY);
   Image.Canvas.LineTo(_X+500,_Y+YY);
   YY := TM.tmAscent;
   //YY := Round((YY / Image.Canvas.Font.PixelsPerInch)* 72);
   Asc := YY;
   Image.Canvas.MoveTo(_X,_Y-YY);
   Image.Canvas.LineTo(_X+500,_Y-YY);
   YY := TM.tmInternalLeading;
   //YY := Round((YY / Image.Canvas.Font.PixelsPerInch)* 72);
   Image.Canvas.MoveTo(_X,_Y-Asc+YY);
   Image.Canvas.LineTo(_X+500,_Y-Asc+YY);
   YY := TM.tmExternalLeading;
   //YY := Round((YY / Image.Canvas.Font.PixelsPerInch)* 72);
   Image.Canvas.MoveTo(_X,_Y-Asc-YY);
   Image.Canvas.LineTo(_X+500,_Y-Asc-YY);
   Image.Canvas.Pen.Color := clBlack;
   Memo1.Lines.Clear;
   Memo1.Lines.Add('Height         : '+IntToStr(TM.tmHeight));
   Memo1.Lines.Add('AWidth         : '+IntToStr(TM.tmAveCharWidth));
   Memo1.Lines.Add('MWidth         : '+IntToStr(TM.tmMaxCharWidth));
   Memo1.Lines.Add('Weight         : '+IntToStr(TM.tmWeight));
   Memo1.Lines.Add('Overhang       : '+IntToStr(TM.tmOverhang));
   Memo1.Lines.Add('Ascent         : '+IntToStr(TM.tmAscent));
   Memo1.Lines.Add('Descent        : '+IntToStr(TM.tmDescent));
   Memo1.Lines.Add('InternalLeading: '+IntToStr(TM.tmInternalLeading));
   Memo1.Lines.Add('ExternalLeading: '+IntToStr(TM.tmExternalLeading));
   Memo1.Lines.Add('TextHeight     : '+IntToStr(Image.Canvas.TextHeight(ed_Text.Text)));
   SetTextAlign(Image.Canvas.Handle,TA_BASELINE);
   SetTextCharacterExtra(Image.Canvas.Handle,StrToIntDef(ed_Extra.Text,0));
   S := ed_Text.Text;
   GetTextExtentPoint32(Image.Canvas.Handle,PChar(S),Length(S),aSize);
   Image.Canvas.Pen.Color := clLime;
   YY := TM.tmDescent;
   Image.Canvas.MoveTo(_X,_Y+YY);
   Image.Canvas.LineTo(_X+aSize.cx,_Y+YY);
   Image.Canvas.LineTo(_X+aSize.cx,_Y+YY-aSize.cy);
   Image.Canvas.LineTo(_X,_Y+YY-aSize.cy);
   Image.Canvas.LineTo(_X,_Y+YY);
   Image.Canvas.Pen.Color := clBlack;
   Image.Canvas.TextOut(_X,_Y,ed_Text.Text);
   ed_Size.Text := IntToStr(Image.Canvas.Font.Size);
   ed_Height.Text := IntToStr(Image.Canvas.Font.Height);
   ed_Pom.Text := IntToStr(TM.tmAveCharWidth);
   ed_Extra.Text := IntToStr(GetTextCharacterExtra(Image.Canvas.Handle));
   aa := Round(Image.Canvas.Font.Size/ 72 * Image.Canvas.Font.PixelsPerInch);
   if aa > 0 then
      aa := aa + TM.tmInternalLeading;
   l_H.Caption := IntToStr(aa);
   aa := -Round(aa/ Image.Canvas.Font.PixelsPerInch *72);
   l_S.Caption := IntToStr(aa);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   ReView;
end;

procedure TForm1.SetX(const Value: integer);
begin
  FX := Value;
end;

procedure TForm1.SetY(const Value: integer);
begin
  FY := Value;
end;

procedure TForm1.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   _X := X;
   _Y := Y;
   ReView;
end;

procedure TForm1.ed_TextChange(Sender: TObject);
begin
   ReView;
end;

procedure TForm1.ed_AngleChange(Sender: TObject);
begin
   Review;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Image.Canvas.Font.Name := 'Arial';
   Image.Canvas.Font.Size := 16;
   _X := 50;
   _Y := 50;
end;

procedure TForm1.b_SizeClick(Sender: TObject);
begin
   Image.Canvas.Font.Size := StrToInt(ed_Size.Text);
   ReView;
end;

procedure TForm1.b_HeightClick(Sender: TObject);
begin
   Image.Canvas.Font.Height := StrToInt(ed_Height.Text);
   ReView;
end;

procedure TForm1.b_pomClick(Sender: TObject);
begin
   ReView;
end;

procedure TForm1.b_ExtraClick(Sender: TObject);
var
   i: integer;
begin
{
   i := StrToIntDef(ed_Extra.Text,0);
   i := SetTextCharacterExtra(Image.Canvas.Handle,i);
   if i = $8000000 then
      b_Extra.Font.Color := clRed
   else
      b_Extra.Font.Color := 0;
}
   ReView;
end;

end.
