unit t_Tiletm;

interface
uses
// GLIB
   G_Elems,
// KERNEL
   Tools;

type

TTileTemplate = class(TTool)
private
   FTileY: double;
   FTileX: double;
   Fdy: double;
   FdX: double;
   FMargin: double;
   FFrame: boolean;
   FFrameWidth: double;
   FFrameColor: integer;
    FReferSpace: TRectEntity;
   procedure SetTileX(const Value: double);
   procedure SetTileY(const Value: double);
   procedure SetdX(const Value: double);
   procedure Setdy(const Value: double);
   procedure SetMargin(const Value: double);     
   procedure SetFrame(const Value: boolean);
   procedure SetFrameColor(const Value: integer);
   procedure SetFrameWidth(const Value: double);
    procedure SetReferSpace(const Value: TRectEntity);
public
   procedure DoIt; override;
published
   property TileX: double read FTileX write SetTileX;
   property TileY: double read FTileY write SetTileY;
   property dX: double read FdX write SetdX;
   property dy: double read Fdy write Setdy;
   property Margin: double read FMargin write SetMargin;
   property Frame: boolean read FFrame write SetFrame;
   property FrameColor: integer read FFrameColor write SetFrameColor;
   property FrameWidth: double read FFrameWidth write SetFrameWidth;
   property ReferSpace: TRectEntity read FReferSpace write SetReferSpace;
end;

implementation
uses
   Graphics,
   SysUtils,
// KERNEL
   e_Class,
// MAPPER
   e_Desktp,
   e_View;

{ TTileTemplate }

procedure TTileTemplate.DoIt;
var
   D: TDesktop;
   V,TV: TView;
   xTiles,yTiles: integer;
   DD: Double;
   R,Rt: TDoubleRect;
   TileD: TDoubleCoord;
   i,j: integer;
   //DR: TDrawRectangle;
begin
   if input = nil then exit;
   if not (Input is TDesktop) then exit;
   Output := Input;
   D := TDesktop(Input);
   V := TView(D.FindElementClass(TView));
   if V = nil then exit;
// Poty Tiles **********************************
   DD := V.Width/TileX;
   xTiles := round(int(DD));
   if Frac(DD)<> 0 then Inc(xTiles);
   DD := V.Height/TileY;
   yTiles := round(int(DD));
   if Frac(DD)<> 0 then Inc(yTiles);
// Nastaven a naten Viewu *********************
   V.Width  := TileX * xTiles;
   V.Height := TileY * yTiles;
   if ReferSpace <> nil then
   begin
      V.ModelScript.Free;
      V.ReadModel := true;
      ReferSpace.SetByDoubleRect(V.Projection.ModelView);
      exit;
   end;
   //*********BEGIN*****************
   (*
   DR := TDrawRectangle.Create;
   DR.MinX := V.ModelMinX;
   DR.MinY := V.ModelMinY;
   DR.MaxX := V.ModelMaxX;
   DR.MaxY := V.ModelMaxY;
   DR.PenColor := $0000FF;
   DR.PenStyle := psSolid;
   DR.BrushStyle := bsClear;
   *)
   //**********END****************
   V.ReadModel := true;
   //*********BEGIN*****************
   //V.AddToModel(DR);
   //**********END****************
   R := V.Projection.ModelView;
// Nastaven Rozmr Desktopu ********************
   D.Width  := (xTiles*Tilex)+((xTiles-1)*Dx)+(2*Margin);
   D.Height := (yTiles*Tiley)+((yTiles-1)*Dy)+(2*Margin);
   for i := 0 to XTiles-1 do
   begin
      for j := 0 to YTiles-1 do
      begin
         TV := TView.Create;
         TV.Name := 'V-'+IntToStr(i)+'-'+IntToStr(j);
         TV.Minx := 0;
         TV.Miny := 0;
         TV.Maxx := 1;
         TV.Maxy := 1;
         TV.Width := TileX;
         TV.Height:= TileY;
         TV.Scale := V.Scale;
         TV.Model := V.Model;
         if (i = 0) and (j = 0) then
         begin
            Rt := TV.Projection.ModelView;
            TileD.x := Rt.MaxX - Rt.MinX;
            TileD.Y := Rt.MaxY - Rt.MinY;
         end;
         TV.x := Margin+(i*(TileX+dx));
         TV.y := Margin+(j*(TileY+dy));
         TV.ModelCenterx := R.MinX+TileD.x/2+i*TileD.x;
         TV.ModelCentery := R.MinY+TileD.y/2+j*TileD.y;
         TV.PenColor := FrameColor;
         TV.PenWidth := FrameWidth;
         if Frame then TV.PenStyle := psSolid
                  else TV.PenStyle := psClear;
         TV.PenStyle := psSolid;
         D.AddElement(TV);
      end;
   end;
   D.FreeElement(V);
end;

procedure TTileTemplate.SetdX(const Value: double);
begin
  FdX := Value;
end;

procedure TTileTemplate.Setdy(const Value: double);
begin
  Fdy := Value;
end;

procedure TTileTemplate.SetFrame(const Value: boolean);
begin
  FFrame := Value;
end;

procedure TTileTemplate.SetFrameColor(const Value: integer);
begin
  FFrameColor := Value;
end;

procedure TTileTemplate.SetFrameWidth(const Value: double);
begin
  FFrameWidth := Value;
end;

procedure TTileTemplate.SetMargin(const Value: double);
begin
  FMargin := Value;
end;

procedure TTileTemplate.SetReferSpace(const Value: TRectEntity);
begin
  FReferSpace := Value;
end;

procedure TTileTemplate.SetTileX(const Value: double);
begin
  FTileX := Value;
end;

procedure TTileTemplate.SetTileY(const Value: double);
begin
  FTileY := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTileTemplate);
END.
