unit F_CheckRas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CheckLst;

type
  TForm1 = class(TForm)
    l_rasIn: TLabel;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    ed_Dirout: TEdit;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    l_Info: TLabel;
    l_tx: TLabel;
    Label1: TLabel;
    FileList: TCheckListBox;
    ErrList: TListBox;
    Label2: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FStart: boolean;
    procedure SetStart(const Value: boolean);
  private
    FRasName: string;
    FDirOut: string;
    FNoRasLib: boolean;
    procedure SetRasName(const Value: string);
    procedure SetDirOut(const Value: string);
    procedure SetNoRasLib(const Value: boolean);
    property  Start: boolean read FStart write SetStart;
  public
     function Trans: boolean;
     property RasName: string read FRasName write SetRasName;
     property DirOut: string read FDirOut write SetDirOut;
     property NoRasLib: boolean read FNoRasLib write SetNoRasLib;
  end;

var
  Form1: TForm1;

implementation
uses
   FileCtrl,
   Rasdata_TLB,
   UseLic;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   if not OpenDialog.Execute then exit;
   RasName := OpenDialog.FileName;
   FileList.Clear;
   ErrList.Clear;
   FileList.Items.Assign(OpenDialog.Files);
   l_Info.Caption := 'Poet soubor pro test: '+IntToStr(FileList.Count);
   Button2.SetFocus;
end;

procedure TForm1.SetDirOut(const Value: string);
begin
   FDirOut := Value;
   ed_DirOut.Text := DirOut;
end;

procedure TForm1.SetRasName(const Value: string);
begin
  FRasName := Value;
  l_rasIn.Caption := Value;
  if DirOut = '' then
     DirOut := ExtractFilePath(Value);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
   Dir: string;
begin
   if DirOut <> '' then
      Dir := DirOut
   else
      Dir := '';
   if SelectDirectory('Adres pro vstup','',Dir) then
      DirOut := Dir;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   i: integer;
begin
   //NoRasLib := true;
   ErrList.Clear;
   for i := 0 to FileList.Count - 1 do
   begin
      FileList.Selected[i] := true;
      RasName := FileList.Items.Strings[i];
      if NoRasLib then
      begin
         Caption := 'Chyb rastrov knihovny...!!!';
         continue;
      end;
      if not Trans then
      begin
         ErrList.Items.Add(FileList.Items.Strings[i]);
         FileList.Checked[i] := false;
      end
      else
      begin
         FileList.Checked[i] := true;
      end;
      l_Info.Caption := 'Projeto '+ IntToStr(i+1)+' soubor z '+IntToStr(FileList.Count)+' - '+IntToStr(ErrList.Count)+' chyb.';
      Application.ProcessMessages;
   end;
   Caption := 'Hotovo !';
   Button3.SetFocus;
end;

function TForm1.Trans: boolean;
var
   SrvRas: IRaster;
   hr: hresult;
const
   TLRasterLicKey: widestring = '=0FJA=0C4kVIB4AE0URF=T[:';
begin
   Caption := 'Kontrola '+RasName+' ...';
   result := true;
   // ras 1
   try
   hr:= CreateInprocObjLic('TopoL.Raster', TLRasterLicKey,
                           IRaster, IUnknown(SrvRas));
   except
      ShowMessage('S nejvt pravdpodobnost nemte nainstalovan rastrov knihovny, tak je probh nainstalujte!');
      NoRasLib := true;
      exit;
   end;
   try
   SrvRas.FileName := RasName;
   SrvRas.OpenRas(RasName, 1,2);
   Caption := 'Kontrola '+RasName+' OK';
   except
      result := false;
      Caption := 'Kontrola '+RasName+' Chyba !!!';
   end;
   {
   RasName1 := ExtractFileName(RasName);
   RasName1 := CHangeFileExt(RasName1,Combo_EXT.Text);
   Caption := 'pevod '+RasName+' na '+RasName1;
   if DirOut[Length(DirOut)]<>'\' then
      DirOut := DirOut + '\';
   RasName1 := DirOut+RasName1;
   //ras 2
   hr:= CreateInprocObjLic('TopoL.Raster', TLRasterLicKey,
                           IRaster, IUnknown(SrvRas1));
   SrvRas1.FileName := RasName1;
   //SrvRas1.Compres := 3;
   SrvRas1.CopyFrom(SrvRas,0,0,SrvRas.Width,SrvRas.Height);
   }
   Application.ProcessMessages;
   if longBool(SrvRas.IsOpen) then
      SrvRas.CloseRas(0);
   SrvRas := nil;
end;

procedure TForm1.SetNoRasLib(const Value: boolean);
begin
  FNoRasLib := Value;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   i: integer;
   RasName1 : string;
   Dir1: string;
begin
   for i := 0 to ErrList.Count-1 do
   begin
      RasName := ErrList.Items.Strings[i];
      Dir1 := ExtractFilePath(RasName);
      RasName1 := ExtractFileName(RasName);
      if DirOut[Length(DirOut)]<>'\' then
         DirOut := DirOut + '\';
      if Dir1[Length(Dir1)]<>'\' then
         Dir1 := Dir1 + '\';
      if SameText(DirOut,Dir1) then
      begin
         ShowMessage('Zadejte jin vstupn adres !!!');
         exit;
      end;
      RasName1 := DirOut+RasName1;
      Caption := 'penos '+RasName+' do '+RasName1;
      if not FileExists(RasName) then continue;
      RenameFile(RasName,RasName1);
   end;
   ErrList.Clear;
   Caption := 'Hotovo !';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Start := true;
end;

procedure TForm1.SetStart(const Value: boolean);
begin
  FStart := Value;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   if Start then
      Button1.SetFocus;
end;

end.

