unit F_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CheckLst;

type
  TForm1 = class(TForm)
    l_rasIn: TLabel;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    ed_Dirout: TEdit;
    Button2: TButton;
    combo_ext: TComboBox;
    SpeedButton1: TSpeedButton;
    l_Info: TLabel;
    Label2: TLabel;
    FileList: TListBox;
    Label1: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FRasName: string;
    FDirOut: string;
    FNoRasLib: boolean;
    procedure SetRasName(const Value: string);
    procedure SetDirOut(const Value: string);
    procedure SetNoRasLib(const Value: boolean);
  public
     procedure Trans;
     property RasName: string read FRasName write SetRasName;
     property DirOut: string read FDirOut write SetDirOut;
     property NoRasLib: boolean read FNoRasLib write SetNoRasLib;
  end;

var
  Form1: TForm1;

implementation
uses
   FileCtrl,
   Rasdata_TLB,
   UseLic;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   if not OpenDialog.Execute then exit;
   RasName := OpenDialog.FileName;
   FileList.Clear;
   FileList.Items.Assign(OpenDialog.Files);
   l_Info.Caption := 'Poet soubor pro pevod: '+IntToStr(FileList.Count);
end;

procedure TForm1.SetDirOut(const Value: string);
begin
   FDirOut := Value;
   ed_DirOut.Text := DirOut;
end;

procedure TForm1.SetRasName(const Value: string);
begin
  FRasName := Value;
  l_rasIn.Caption := Value;
  if DirOut = '' then
     DirOut := ExtractFilePath(Value);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
   Dir: string;
begin
   if DirOut <> '' then
      Dir := DirOut
   else
      Dir := '';
   if SelectDirectory('Adres pro vstup','',Dir) then
      DirOut := Dir;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   i: integer;
begin
   //NoRasLib := true;
   for i := 0 to FileList.Count - 1 do
   begin
      FileList.Selected[i] := true;
      RasName := FileList.Items.Strings[i];
      if NoRasLib then
      begin
         Caption := 'Chyb rastrov knihovny...!!!';
         continue;
      end;
      Trans;
      l_Info.Caption := 'Pevedeno '+ IntToStr(i+1)+' soubor z '+IntToStr(FileList.Count);
   end;
end;

procedure TForm1.Trans;
var
   SrvRas,SrvRas1: IRaster;
   hr: hresult;
   RasName1: string;
const
   TLRasterLicKey: widestring = '=0FJA=0C4kVIB4AE0URF=T[:';
begin
   Caption := 'pevod......';
   // ras 1
   try
   hr:= CreateInprocObjLic('TopoL.Raster', TLRasterLicKey,
                           IRaster, IUnknown(SrvRas));
   SrvRas.FileName := RasName;
   SrvRas.OpenRas(RasName, 1,2);
   except
      ShowMessage('S nejvt pravdpodobnost nemte nainstalovan rastrov knihovny, tak je probh nainstalujte!');
      NoRasLib := true;
      exit;
   end;
   RasName1 := ExtractFileName(RasName);
   RasName1 := CHangeFileExt(RasName1,Combo_EXT.Text);
   Caption := 'pevod '+RasName+' na '+RasName1;
   if DirOut[Length(DirOut)]<>'\' then
      DirOut := DirOut + '\';
   RasName1 := DirOut+RasName1;
   //ras 2
   hr:= CreateInprocObjLic('TopoL.Raster', TLRasterLicKey,
                           IRaster, IUnknown(SrvRas1));
   SrvRas1.FileName := RasName1;
   //SrvRas1.Compres := 3;
   SrvRas1.CopyFrom(SrvRas,0,0,SrvRas.Width,SrvRas.Height);
   Application.ProcessMessages;
   //SrvRas1.CloseRas(0);
   SrvRas.CloseRas(0);
   SrvRas := nil;
   SrvRas1 := nil;
   Caption := 'Hotovo !';
end;

procedure TForm1.SetNoRasLib(const Value: boolean);
begin
  FNoRasLib := Value;
end;

end.

