unit F_vyrdet;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, ExtCtrls;

type



  TVyrdetForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SQLDilec: TQuery;
    DSDilec: TDataSource;
    SQLSkupina: TQuery;
    DSSkupina: TDataSource;
    DBGrid2: TDBGrid;
    Panel3: TPanel;
    lbZAK: TLabel;
    lbDET: TLabel;
    lbVymera: TLabel;
    lbCount: TLabel;
    lbPlochaSkup: TLabel;
    cbPause: TCheckBox;
    btDalsi: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbPlocha: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    tlVyrovnejJesteJednou: TButton;
    Label6: TLabel;
    lbVymeraSkup: TLabel;
    lbCislo: TLabel;
    Label7: TLabel;
    lbKvalita: TLabel;
    Label8: TLabel;
    EdMaxOdch: TEdit;
    TopPanel: TPanel;
    TopLeftPanel: TPanel;
    Panel7: TPanel;
    DBGrid1: TDBGrid;
    Panel4: TPanel;
    Memo: TMemo;
    Ulozit: TButton;
    SaveDialog: TSaveDialog;
    SplHorizont: TSplitter;
    SplitVert: TSplitter;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btDalsiClick(Sender: TObject);
    procedure tlVyrovnejJesteJednouClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EdMaxOdchExit(Sender: TObject);
    procedure UlozitClick(Sender: TObject);
  private
    { Private declarations }
    JmDatabazeZAK: string;
    JmDatabazeDET: string;
    FKonec: boolean;
    FDalsiKrok: boolean;
    ListPloch: TList;
//    TopolTable: TTopolDBFTable;
    FMaxOdchylkaZAKDET: double;
    FLesniPolozky: string;
    FVarianta: string;
    FObsahLesnichPolozek: string;

    procedure SetJmDBFZAK(aJmeno: string);
    procedure SetJmDBFDET(aJmeno: string);
    procedure NactiPorost;
    procedure NactiSkupiny;
    procedure VypoctiPlochuAVymeruPorostu;
    procedure VypoctiPlochuAVymeruSkupin;
    function  GetPause: boolean;
    procedure SetPause(abool: boolean);
    function  GetDalsiKrok: boolean;
    procedure SetDalsiKrok(abool: boolean);
    procedure ZrusListPloch;
    procedure VytvorListPloch;
    procedure VyrovnejSkupiny;
    procedure ProvedVyrovnaniSkupin;
    procedure SaveSizes;
    procedure LoadSizes;
    function GetIni(Item, Default: string): string;
    function WhereContent: string;

  public
    { Public declarations }

    KatastrJm: string;
    VymeraDilce, PlochaDilce, VymeraSkupin, PlochaSkupin: double;
    KvalitaDilce: integer;

    procedure ProvedPorost;

    property JmZAKDBF: string read JmDatabazeZAK write SetJmDBFZAK;
    property JmDETDBF: string  read JmDatabazeDET write SetJmDBFDET;
    property Pause: boolean read GetPause write SetPause;
    property Konec: boolean read FKonec write FKonec;
    property DalsiKrok: boolean read GetDalsiKrok write SetDalsiKrok;

    property LesniPolozky: string read FLesniPolozky write FLesniPolozky;
    property ObsahLesnichPolozek: string read FObsahLesnichPolozek write FObsahLesnichPolozek;
    property Varianta: string read FVarianta write FVarianta;
  end;


implementation
{$R *.DFM}
uses
  IniFiles,
  Equaliz,
//  M_Teren,
  M_Vyrzak;



                     { TFVyrdetForm }

function TVyrDetForm.GetIni(Item, Default: string): string;
begin
  result:= ReadIniStringG(Varianta, Item, Default);
  WriteIniStringG(Varianta, Item, result);
end;


function  TVyrdetForm.GetDalsiKrok: boolean;
var
  aColor: TColor;
begin
  result:= FDalsiKrok;
  if not FDalsiKrok then
     aColor:= clRed
  else
     aColor:= clBlack;

  if aColor <>  btDalsi.Font.Color then
  begin
    btDalsi.Font.Color:= aColor;
    Application.ProcessMessages
  end
end;

procedure TVyrdetForm.SetDalsiKrok(abool: boolean);
begin
  FDalsiKrok:= abool;
end;


function  TVyrdetForm.GetPause: boolean;
begin
  result:= cbPause.Checked
end;

procedure TVyrdetForm.SetPause(abool: boolean);
begin
  cbPause.Checked:= abool;
end;


procedure TVyrdetForm.SetJmDBFZAK(aJmeno: string);
begin
  JmDatabazeZAK:= aJmeno;
  lbZAK.Caption:= aJmeno
end;


procedure TVyrdetForm.SetJmDBFDET(aJmeno: string);
begin
  JmDatabazeDET:= aJmeno;
  Caption:= 'Vyrovnvn databze DET ' + aJmeno;
  lbDET.Caption:= aJmeno;
end;


function TVyrDetForm.WhereContent: string;
var
  aItems, aContents: TStringList;
  I: integer;

  function Podminka(aI: integer): string;
  var
    aPol: string;
    aCont: string;
  begin
    aPol:= aItems.Strings[aI];
    aCont:= aContents.Strings[aI];
    result:= '';
    if aPol[1] = '$' then
    begin
      aPol:= copy(aPol, 2, 255);
      aCont:= '"'+aCont+'"';
    end;
    result:= aPol + '=' + aCont
  end;


begin
  result:= '';
  aItems:= TStringList.Create;
  aContents:= TStringList.Create;

  aItems.CommaText:= LesniPolozky;
  aContents.CommaText:= ObsahLesnichPolozek;
  result:= Podminka(0);

  if aItems.Count > 1 then
  for I:= 1 to aItems.Count-1 do
  begin
    result:= result + ' and ' + Podminka(I)
  end;
  result:= result + ';';

  aContents.Free;
  aItems.Free;
end;




procedure TVyrdetForm.NactiPorost;
begin
  with SQLDilec do
  begin
    SQL.Clear;
    SQL.Add(GetIni('VyrDet_NactiPorost', 'SELECT KU_KOD,Sk_PARC,ODDELENI,DILEC,POROST,PLOCHA,VYMERA,KVALITA FROM'));

    SQL.Add('"' + JmZAKDBF + '"');
    SQL.Add('WHERE ');
    SQL.Add(WhereContent);

    SQL.SaveToFile('NACTIPOROST.SQL');

    Open
  end;
end;



procedure TVyrdetForm.NactiSkupiny;
begin
  with SQLSkupina do
  begin
    RequestLive:= true;
    SQL.Clear;
    SQL.Add(GetIni('VyrDet_NactiSkupiny',
            'SELECT KU_KOD,Sk_PARC,ODDELENI,DILEC,POROST,VYMERA,PLOCHA,KVALITA,CISLO FROM'));

    SQL.Add('"' + JmDETDBF + '"');
    SQL.Add('WHERE ');
    SQL.Add(WhereContent);

    Open;
    lbCount.Caption:= intToStr(RecordCount)
  end;
end;




procedure TVyrDETForm.VypoctiPlochuAVymeruPorostu;
begin
  PlochaDilce:= 0;
  VymeraDilce:= 0;
  with SQLDilec do
  begin
    First;
    while not EOF do
    begin
      PlochaDilce:= PlochaDilce + FieldByName('PLOCHA').AsFloat;
      VymeraDilce:= VymeraDilce + FieldByName('VYMERA').AsFloat;
      Next
    end
  end;

  KvalitaDilce:= SQLDilec.FieldByName('KVALITA').AsInteger;
  lbKvalita.Caption:= IntToStr(KvalitaDilce);
  lbPlocha.Caption:= FloatToStr(PlochaDilce);
  lbVymera.Caption:= FloatToStr(VymeraDilce);
end;



procedure TVyrDETForm.VypoctiPlochuAVymeruSkupin;

begin
  VymeraSkupin:= 0;
  PlochaSkupin:= 0;
  with SQLSkupina do
  begin
    First;
    while not EOF do
    begin
      PlochaSkupin:= PlochaSkupin + FieldByName('PLOCHA').AsFloat;
      VymeraSkupin:= VymeraSkupin + FieldByName('VYMERA').AsFloat;
      Next
    end
  end;
  lbPlochaSkup.Caption:= FloatToStr(PlochaSkupin);
  lbVymeraSkup.Caption:= FloatToStr(VymeraSkupin);
end;




procedure TVyrdetForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  begin
    Konec:= true;
    CanClose:= true
  end
end;


procedure TVyrdetForm.btDalsiClick(Sender: TObject);
begin
  DalsiKrok:= true
end;



procedure TVyrDETForm.ZrusListPloch;
var
  I: longInt;
begin
  if ListPloch = nil then exit;

  for I:= 0 to ListPloch.Count-1 do
  begin
    if PPlocha(ListPloch.Items[I]) <> nil then
       PPlocha(ListPloch.Items[I]).Free;
  end;

  ListPloch.Free;
  ListPloch:= nil;
end;


procedure TVyrDETForm.VytvorListPloch;
{vpoty probhaj v ha, pouze pro vpoet odchylky je poteba pejt na m2}
var
  aPPlocha: PPlocha;
  Suma, Koef, Max: double;
  I, MaxI: integer;
  PCurs: TCursor;

begin
  PCurs:= Screen.Cursor;
  Screen.Cursor:= crSQLWait;
  ZrusListPloch;

  try
    with SQLSkupina do
    try
      DisableControls;
      First;
      ListPloch:= TList.Create;

     { nacitani view do listu }
      Suma:= 0;
      Max:= 0;
      MaxI:= 0;
      I:= 0;

      while not EOF do
      begin
        aPPlocha:= PPlocha.Create;
        aPPlocha.Cislo   := FieldByName('CISLO').AsInteger;
        aPPlocha.Plocha  := FieldByName('PLOCHA').AsFloat;
        Suma:= Suma + aPPlocha.Plocha;
        if aPPlocha.Plocha > Max then
        begin
          Max:= aPPlocha.Plocha;
          MaxI:= I
        end;
        ListPloch.Add(aPPlocha);
        inc(I);
        Next
      end

    finally
      EnableControls;
    end;

    if I= 0 then
       exit;
    if Suma = 0 then
       exit;
    if ListPloch.Count = 0 then
       exit;


    PlochaSkupin:= Suma;
    lbPlochaSkup.Caption:= FloatToStr(PlochaSkupin);


    Koef:= VymeraDilce/Suma;

    { Vypocet Vymer }
    Suma:= 0;
    for I:= 0 to ListPloch.Count-1 do
    begin
      aPPlocha:= PPlocha(ListPloch.Items[I]);
      aPPlocha.Vymera:= round(aPPlocha.Plocha*Koef*100)/100;

      if aPPlocha.Vymera = 0 then
      begin
        Memo.Lines.Add(ObsahLesnichPolozek);
        Memo.Lines.Add('Normln by tady vyla nulov vmra, msto n dosazuju 0.01 ha');
        aPPlocha.Vymera:= 0.01;
      end;

      Suma:= Suma + aPPlocha.Vymera
    end;

    aPPlocha:= PPlocha(ListPloch.Items[MaxI]);
    aPPlocha.Vymera:= aPPlocha.Vymera + (VymeraDilce-Suma);

    if abs(VymeraDilce-Suma) > 0.02 then
    begin
      Memo.Lines.Add(ObsahLesnichPolozek);
      Memo.Lines.Add('Pi vyrovnvn se nejvt plocha upravuje o ' +
                      FloatToStr(VymeraDilce-Suma) + ' ha!');
    end;

    Application.ProcessMessages;


    { Jeste jednou prepocet vymer }

    Suma:= 0;
    for I:= 0 to ListPloch.Count-1 do
    begin
      aPPlocha:= PPlocha(ListPloch.Items[I]);
      Suma:= Suma + aPPlocha.Vymera
    end;

    VymeraSkupin:= Suma;
    lbVymeraSkup.Caption:= FloatToStr(VymeraSkupin);

  finally
    Screen.Cursor:= PCurs;
  end
end;







procedure TVyrDETForm.VyrovnejSkupiny;
{vpoty probhaj v ha, pouze pro vpoet odchylky je poteba pejt na m2}
var
  aPPlocha: PPlocha;
  I: integer;
  PCurs: TCursor;

begin
  PCurs:= Screen.Cursor;
  Screen.Cursor:= crSQLWait;
  try
  with SQLSkupina do
  begin
    Open;
    First;
    for I:= 0 to ListPloch.Count-1 do
    begin
      aPPlocha:= PPlocha(ListPloch.Items[I]);
{
      STR(PPlocha(ListPloch.Items[I]).Vymera:6:2, VymeraStr);

      VymeraStr:= FloatToStrF(ListPloch.Items[I]).Vymera
}
      lbCislo.Caption:= IntToStr(aPPlocha.Cislo);
      lbCislo.Font.Color:= clRed;
      Application.ProcessMessages;
      Edit;
      FieldByName('VYMERA').AsFloat:= aPPlocha.Vymera;
      FieldByName('KVALITA').AsInteger:= KvalitaDilce;
      Post;
      lbCislo.Font.Color:= clBlack;
      Application.ProcessMessages;

      Next
    end;
//    Close;
  end;

  finally
    Screen.Cursor:= PCurs;
  end
end;




procedure TVyrdetForm.ProvedVyrovnaniSkupin;
begin
  VyrovnejSkupiny;
{  NactiSkupiny; }
{  VypoctiPlochuAVymeruSkupin }
end;




procedure TVyrdetForm.ProvedPorost;
begin
  try
  NactiPorost;
  VypoctiPlochuAVymeruPorostu;
  NactiSkupiny;
  VytvorListPloch;
{  VypoctiPlochuAVymeruSkupin; }

  if PlochaSkupin > 0 then
  begin
    if (abs(PlochaSkupin - PlochaDilce) > FMaxOdchylkaZAKDET) then
    begin
      Memo.Lines.Add(ObsahLesnichPolozek);
      Memo.Lines.Add('Prekroc. max. odch.ZAK-DET: '+
                 FloatToStr(PlochaDilce - PlochaSkupin));
    end;

    ProvedVyrovnaniSkupin
  end
  else
  begin
    ShowMessage('Prazdne skupiny !')
  end;

  Application.ProcessMessages
  except
  on E:EDatabaseError do
  begin
     MessageDlg(E.Message , mtError, [mbOK], 0);
  end;
  end
end;



procedure TVyrdetForm.tlVyrovnejJesteJednouClick(Sender: TObject);
begin
  VytvorListPloch;
  ProvedVyrovnaniSkupin;
  NactiSkupiny;
  VypoctiPlochuAVymeruSkupin
end;



procedure TVyrdetForm.FormCreate(Sender: TObject);
begin
  LoadSizes;
  FMaxOdchylkaZAKDET:= ReadIniDouble('MaxOdchZAKDET', 0.0001);
  EdMaxOdch.Text:= FloatToStr(FMaxOdchylkaZAKDET);
end;


procedure TVyrdetForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveSizes;
  WriteIniDouble('MaxOdchZAKDET', FMaxOdchylkaZAKDET);
  ZrusListPloch;
end;


procedure TVyrdetForm.EdMaxOdchExit(Sender: TObject);
begin
  FMaxOdchylkaZAKDET:= StrToFloat(EdMaxOdch.Text)
end;



procedure  TVyrdetForm.SaveSizes;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  IniFile.WriteInteger('VYRDETForm', 'Left', Left);
  IniFile.WriteInteger('VYRDETForm', 'Top', Top);
  IniFile.WriteInteger('VYRDETForm', 'Height', Height);
  IniFile.WriteInteger('VYRDETForm', 'Width', Width);
  IniFile.WriteInteger('VYRDETFORM', 'TopPanelHeight', TopPanel.Height);
  IniFile.WriteInteger('VYRDETFORM', 'TopLeftPanelWidth', TopLeftPanel.Width);
  IniFile.Free;
end;


procedure  TVyrDetForm.LoadSizes;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  Left:= IniFile.ReadInteger('VYRDETForm', 'Left', Left);
  Top:= IniFile.ReadInteger('VYRDETForm', 'Top', Top);
  Height:= IniFile.ReadInteger('VYRDETForm', 'Height', Height);
  Width:= IniFile.ReadInteger('VYRDETForm', 'Width', Width);
  TopPanel.Height:= IniFile.ReadInteger('VYRDETFORM', 'TopPanelHeight', TopPanel.Height);
  TopLeftPanel.Width:= IniFile.ReadInteger('VYRDETFORM', 'TopLeftPanelWidth', TopLeftPanel.Width);
  IniFile.Free;
end;




procedure TVyrdetForm.UlozitClick(Sender: TObject);
begin
  if SaveDialog.Execute then
     Memo.Lines.SaveToFile(SaveDialog.FileName)
end;

end.
