unit F_vyrzak;
{ Vyrovnn vmr v DBF ZAK
  Naten DBF ZAK
  Naten DBF skupin parcel
  }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, DB, DBTables, Grids, DBGrids,
  ExtCtrls, DBCtrls;

type
  TFVyrZak = class(TForm)
    ZAKDBF: TOpenDialog;
    SkParcDBF: TOpenDialog;
    DSZAK: TDataSource;
    SQLZAK: TQuery;
    SQLSkParc: TQuery;
    TabSkParc: TTable;
    DSSkParc: TDataSource;
    DETDBF: TOpenDialog;
    Header: THeader;
    Panel2: TPanel;
    Panel1: TPanel;
    GrZAK: TDBGrid;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    lbZAKDBF: TLabel;
    lbSkParcDBF: TLabel;
    TlVyberDBZak: TButton;
    tlVyberSkParcel: TButton;
    GroupBox2: TGroupBox;
    tlSecti: TButton;
    btZnovuNacteni: TButton;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    TlVyrSkParc: TButton;
    tlVyrVse: TBitBtn;
    Panel4: TPanel;
    Panel5: TPanel;
    btVyrovDET: TButton;
    btSumParc: TButton;
    b_PSkFromPAR: TButton;
    SQLPAR: TQuery;
    procedure TlVyberDBZakClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tlVyberSkParcelClick(Sender: TObject);
    procedure TlVyrSkParcClick(Sender: TObject);
    procedure tlSectiClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure tlVyrVseClick(Sender: TObject);
    procedure btVyrovDETClick(Sender: TObject);
    procedure btZnovuNacteniClick(Sender: TObject);
    procedure HeaderSizing(Sender: TObject; ASection, AWidth: Integer);
    procedure HeaderSized(Sender: TObject; ASection, AWidth: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure btSumParcClick(Sender: TObject);
    procedure b_PSkFromPARClick(Sender: TObject);
  private
    { Private declarations }
    KatastrJm: string;
    FVarianta: string;
    procedure UkazCelyZAK;
    procedure ZalozSkParcDBF(aName: string);
    procedure VyberDleSkPar;
    procedure NastavAZobrazSkParc;
    procedure VyrovnejSkParc;
    procedure NaplnSkParc;
    procedure VlastniNastaveniSkParc;
    procedure ResizeHeader;
    procedure SaveSizes;
    procedure LoadSizes;
    function  GetSplit: integer;
    procedure SetSplit(aValue: integer);

    function TestSQLSkParc: boolean;
    procedure UkazPorosty;
    function GetIni(Item, Default: string): string;
    function GetContent(aDataSet: TDataSet; aItems: string): string;
  public
    { Public declarations }
  published
    property Split: integer read GetSplit write SetSplit;
    property Varianta: string read FVarianta write FVarianta;
  end;

var
  FVyrZak: TFVyrZak;

implementation
uses
  IniFiles, FileCtrl,
  M_Teren, M_Vyrzak,
  Equaliz,
  F_Varianta,
  F_CompareDBF,
  F_VyrDET;
{$R *.DFM}


function MaxOdchylka(InVymera: double): double;
begin
{ result:= 1.2 * sqrt(InVymera + 10) }
  result:= 0.005*InVymera + 2.5*sqrt(InVymera)
end;



function TFVyrZak.GetIni(Item, Default: string): string;
begin
  result:= ReadIniStringG(Varianta, Item, Default);
  WriteIniStringG(Varianta, Item, result);
end;



procedure TFVyrZak.UkazCelyZAK;
begin
  with SQLZAK do
  begin
    SQL.Clear;
    SQL.Add(GetIni('UkazCelyZAK_Select', 'SELECT ' + KATASTRJm + ', SK_PARC, PLOCHA, VYMERA, ODDELENI,DILEC,KVALITA FROM'));
    SQL.Add('"' + ZAKDBF.FileName + '";');
{    SQL.Add('WHERE CISLO='+CisloPlochyStr+';'); }
{      SQL.SaveToFile('SELZAK.SQL'); }
    Open;
  end
end;




procedure TFVyrZak.VyberDleSkPar;
begin
  with SQLZAK do
  begin
    RequestLive:= true;

    SQL.Clear;
    SQL.Add(GetIni('VyberDleSkPar_Select', 'SELECT ' + KatastrJm + ',Sk_PARC, PLOCHA, VYMERA, CISLO, ODDELENI,DILEC,KVALITA FROM'));

    SQL.Add('"' + ZAKDBF.FileName + '"');
    SQL.Add('WHERE');

    if KatastrJm = 'KU_KOD' then
      SQL.Add('KU_KOD=' + TabSkParc.FieldByName('KU_KOD').AsString)
    else
      SQL.Add('KATASTR="' + TabSkParc.FieldByName('KATASTR').AsString+'"');

    SQL.Add('and SK_PARC="' +TabSkParc.FieldByName('SK_PARC').AsString  + '";');

    Open
  end
end;








procedure TFVyrZAK.VyrovnejSkParc;
{vpoty probhaj v ha, pouze pro vpoet odchylky je poteba pejt na m2}
var
  Plocha: PPlocha;
  List: TListPloch;
  InVymera, Suma, Koef, Max: double;
  I, MaxI: integer;
  PCurs: TCursor;
  Znak: char;

begin
  if SQLZAK.RecordCount = 0 then
  begin
    ShowMessage('V ZAKu pro tuto skupinu parcel neexistuje dn zznam');
    exit
  end;

  PCurs:= Screen.Cursor;
  Screen.Cursor:= crSQLWait;

  try
    InVymera:= TabSkParc.FieldByName('VYMERA').AsFloat;
  except
    on E:EDatabaseError do
    begin
      MessageDlg(E.Message , mtError, [mbOK], 0);
      exit;
    end;
  end;
  Znak:= ' ';

  with SQLZAK do
  begin
    First;
    List:= TListPloch.Create;

   { nacitani view do listu }
    Suma:= 0;
    Max:= 0;
    MaxI:= 0;
    I:= 0;

    while not EOF do
    begin
      Plocha:= PPlocha.Create;
      Plocha.Cislo   := FieldByName('CISLO').AsInteger;
      Plocha.Plocha  := FieldByName('PLOCHA').AsFloat;
      Suma:= Suma + Plocha.Plocha;
      if Plocha.Plocha > Max then
      begin
        Max:= Plocha.Plocha;
        MaxI:= I
      end;
//      List.InsertPlochu(Plocha); { zajiuje setdn }
      List.Add(Plocha);
      inc(I);
      Next
    end;

    try
      TabSkParc.Edit;
      TabSkParc.FieldByName('SUMA').AsFloat:= Suma;
      if MaxOdchylka(InVymera*10000) > abs(InVymera*10000 - Suma*10000) then
         Znak:= '1'
      else
         Znak:= '3';
      TabSkParc.FieldByName('KVALITA').AsString:= Znak;
      TabSkParc.Post;
    except
    on E:EDatabaseError do
    begin
       MessageDlg(E.Message , mtError, [mbOK], 0);
    end;
    end;

    if Suma > 0 then
       Koef:= InVymera/Suma
    else
      Koef:= 0;

    { Vypocet Vymer }
    Suma:= 0;
    for I:= 0 to List.Count-1 do
    begin
      Plocha:= PPlocha(List.Items[I]);
      Plocha.Vymera:= round(Plocha.Plocha*Koef*100)/100;
      Suma:= Suma + Plocha.Vymera
    end;

    with PPlocha(List.Items[MaxI]) do
    begin
      PPlocha(List.Items[MaxI]).Vymera:=
      PPlocha(List.Items[MaxI]).Vymera + (InVymera-Suma)
    end;

    First;
    for I:= 0 to List.Count - 1 do
    begin
      Edit;
      FieldByName('VYMERA').AsFloat:= PPlocha(List.Items[I]).Vymera;
      PPlocha(List.Items[I]).Free;
      FieldByName('KVALITA').AsString:= Znak;
      Post;
      Next;
    end;


(*
    { zapis (UPDATE) vyrovnanych hodnot do DBF }
    for I:= 0 to List.Count-1 do
    begin
      SQL.Clear;
      SQL.Add('UPDATE "' + ZAKDBF.FileName + '"');
      STR(PPlocha(List.Items[I]).Vymera:6:2, VymeraStr);

      SQL.Add('SET VYMERA='+VymeraStr + ',KVALITA='+Znak);
      SQL.Add('WHERE CISLO='+
              IntToStr(PPlocha(List.Items[I]).Cislo));

      PPlocha(List.Items[I]).Free;

     { SQL.SaveToFile('UlozVyr.SQL'); }
      ExecSQL
    end;
*)

    List.Free;
  end;
  Screen.Cursor:= PCurs;
end;




procedure TFVyrZak.ZalozSkParcDBF(aName: string);
var
  CreateStr: string;

begin
  with SQLSkParc do
  begin
   CreateStr:= KatastrJm +
               ' CHAR(9),SK_PARC CHAR(8),VYMERA DECIMAL(6,2),KVALITA DECIMAL(1,0),SUMA DECIMAL(8,4))';

   CreateStr:= GetIni('SkParcItems', CreateStr);

   sql.clear;
   sql.add ('create table "' + aName + '" (');
   sql.add (CreateStr);

   try
      execSQL;
   except
      on E:EDatabaseError do
      begin
         MessageDlg('Nemohu vytvoit tabulku '+
                     aName + #13#10 + 'Chybov hlen: ' +  #13#10 +
         E.Message , mtError, [mbOK], 0);
      end;
   end;

  end;
end;




function TFVyrZak.TestSQLSkParc: boolean;
begin
  result:= true;
  if TabSkParc.Active and (TabSkParc.RecordCount > 0) then exit;
  ShowMessage('Przdn tabulka skupin parcel !');
  result:= false
end;


procedure TFVyrZak.VlastniNastaveniSkParc;
begin
  if (SQLZAK.FieldByName(KatastrJm).AsString <> '')
     and
     (SQLZAK.FieldByName('SK_PARC').AsString <> '') then
  with TabSkParc do
  begin
    Active:= true;
    Edit;
    Append;
    FieldByName(KATASTRJm).AsString:= SQLZAK.FieldByName(KATASTRJm).AsString;
    FieldByName('SK_PARC').AsString:= SQLZAK.FieldByName('SK_PARC').AsString;
    Post;
    Close
  end;
end;



procedure TFVyrZak.NaplnSkParc;
begin
  TabSkParc.Active:= false;
  with SQLZak do
  begin
    SQL.Clear;

    SQL.Add('SELECT DISTINCT ' + KatastrJm + ',SK_PARC FROM');

    SQL.Add('"' + ZAKDBF.FileName + '";');

    Open;

    first;
    while not eof do
    begin
      VlastniNastaveniSkParc;
      next
    end
  end
end;


procedure TFVyrZak.TlVyberDBZakClick(Sender: TObject);
var
  aDir: string;
begin
  aDir:= ReadIniString('ADRESAR', '');
  if not DirectoryExists(aDir) then
     aDir:= '';

  ZAKDBF.Title:= GetIni('ZAKTitle', 'Vyber tabulku zkladnho rozdlen');
  ZAKDBF.InitialDir:= aDir;
  if ZAKDBF.Execute then
  begin
    WriteIniString('ADRESAR', extractFilePath(ZAKDBF.FileName));
    lbZAKDBF.Caption:= ZAKDBF.FileName;
    UkazCelyZAK
  end
end;


procedure TFVyrZak.NastavAZobrazSkParc;
var
  aName: string;
begin
  aName:= changeFileExt(SkParcDBF.FileName, '.DBF');
  if not fileExists(aName) then
  begin
    ZalozSkParcDBF(aName);
    TabSkParc.Active:= false;
    TabSkParc.TableName:= aName;
    NaplnSkParc;
    UkazCelyZAK
  end;

  if fileExists(aName) then
  begin
    lbSkParcDBF.Caption:= aName;
    TabSkParc.Active:= false;
    TabSkParc.TableName:= aName;
    TabSkParc.Active:= true;
  end
end;



procedure TFVyrZak.tlVyberSkParcelClick(Sender: TObject);
begin
  SkParcDBF.Title:= GetIni('SkParcTitle', 'Vyber tabulku skupin parcel');

  if SkParcDBF.Execute then
     NastavAZobrazSkParc
end;


procedure TFVyrZak.FormCreate(Sender: TObject);
var
  aForm: TVariantaForm;

begin
{  LoadSizes; }
  aForm:= TVariantaForm.Create(nil);
  aForm.ShowModal;
  Varianta:= aForm.Varianta;
  aForm.Free;

  if not (Varianta = 'LCR') then
     btSumParc.Enabled:= false;

  ResizeHeader;
  KatastrJm:= GetIni('JmenoPolozkyKatastr', 'KU_KOD');

  if ParamCount > 0 then
  begin
    if fileExists(ParamStr(1)) then
    begin
      ZAKDBF.FileName:= expandFileName(ParamStr(1));
      lbZAKDBF.Caption:= ZAKDBF.FileName;
      UkazCelyZAK
    end;

    if ParamCount > 1 then
    begin
      if fileExists(ParamStr(2)) then
      begin
        SkParcDBF.FileName:= expandFileName(ParamStr(2));
        NastavAZobrazSkParc
      end
    end
  end;
end;



procedure TFVyrZak.TlVyrSkParcClick(Sender: TObject);
begin
  if not TestSQLSkParc then exit;
  VyberDleSkPar;
  SQLZak.DisableControls;
  VyrovnejSkParc;
  SQLZak.EnableControls;
  VyberDleSkPar;
end;




procedure TFVyrZak.tlSectiClick(Sender: TObject);
var
  InVymera, OutVymera, Suma: double;
  Veta: string;

begin
  if not TestSQLSkParc then exit;
  VyberDleSkPar;

  InVymera:= TabSkParc.FieldByName('VYMERA').AsFloat;

  with SQLZAK do
  begin
    DisableControls;
    First;
   { nacitani view do listu }
    Suma:= 0;
    OutVymera:= 0;

    while not EOF do
    begin
      Suma:= Suma + FieldByName('PLOCHA').AsFloat;
      OutVymera:= OutVymera + FieldByName('VYMERA').AsFloat;
      Next
    end;

    EnableControls;
  end;

  if MaxOdchylka(InVymera*10000) > abs(InVymera*10000 - Suma*10000) then
     Veta:= 'Odchylka vyhovuje'
  else
     Veta:= 'Odchylka pekrauje max.povolenou hodnotu - nevyhovuje';


  ShowMessage
  ('Poadov. vmra:     ' + FloatToStrF(InVymera,  ffFixed, 15, 4) + #13#10 +
   'Souet ploch      :     ' + FloatToStrF(Suma,      ffFixed, 15, 4) + #13#10 +
   'Max.odchylka     :     ' + FloatToStrF(MaxOdchylka(InVymera*10000)/10000, ffFixed, 15, 4) + #13#10 +
    Veta + #13#10 +
   'Dosaen vmra:     ' + FloatToStrF(OutVymera, ffFixed, 15, 4))
end;


procedure TFVyrZak.SpeedButton1Click(Sender: TObject);
begin
  UkazCelyZAK
end;


procedure TFVyrZak.tlVyrVseClick(Sender: TObject);
begin
  if not TestSQLSkParc then exit;

  with TabSkParc do
  begin
    SQLZak.DisableControls;
    first;

    while not EOF do
    begin
      VyberDleSkPar;
      VyrovnejSkParc;
      next
    end;
    SQLZak.EnableControls;

    VyberDleSkPar;
  end;
  UkazCelyZak
end;


procedure TFVyrZak.UkazPorosty;
begin
  TabSkParc.Active:= false;
  with SQLZak do
  begin
    SQL.Clear;

    SQL.Add(GetIni('UkazPorosty_Select', 'SELECT DISTINCT ' + KatastrJm + ',SK_PARC,ODDELENI,DILEC,VYMERA FROM'));

    SQL.Add('"' + ZAKDBF.FileName + '";');

    Open;

    first;

  end
end;




function TFVyrZak.GetContent(aDataSet: TDataSet; aItems: string): string;
var
  aList: TStringList;
  I: integer;
  aItem: string;
begin
  aList:= TStringList.Create;
  aList.CommaText:= aItems;
  result:= '';
  for I:= 0 to aList.Count-1 do
  begin
    aItem:= aList.Strings[I];
    if aItem[1] = '$' then
       aItem:= copy(aItem, 2, 255);
    if I > 0 then
       result:= result + ',';
    result:= result + '"' + aDataSet.FieldByName(aItem).AsString + '"';
  end;
  aList.Free;
end;



procedure TFVyrZak.btVyrovDETClick(Sender: TObject);
var
  VyrdetForm: TVyrdetForm;
  ZAKPath, PomStr, DETJm: string;
  aLesniPolozky: string;
  aObsahLesnichPolozek: string;

begin
  ZAKPath:= ExtractFilePath(ZAKDBF.FileName);
  if ZAKPath[length(ZAKPath)] = '\' then
     PomStr:= copy(ZAKPath, 1, length(ZAKPath)-1);
  DETJm:= ExtractFileName(PomStr);
  DETJm:= 'DET' + copy(DETJm, 4, 255);

  PomStr:= ExtractFilePath(PomStr);
  DETJm:= PomStr + DETJm + '\P0110.DBF';
  if not FileExists(DETJm) then
  begin
    DETDBF.Title:= GetIni('DETTitle', 'Vyber tabulku detailnho rozdlen');
    DETDBF.InitialDir:= ZAKPath;
    if not DETDBF.Execute then exit;
    DETJm:= DETDBF.FileName;
  end
  else
    DETDBF.FileName:= DETJm;

  UkazPorosty;

  Application.CreateForm(TVyrdetForm, VyrdetForm);
  VyrdetForm.JmZAKDBF:= ZAKDBF.FileName;
  VyrdetForm.JmDETDBF:= DETJm;
  VyrdetForm.KatastrJm:= KatastrJm;
  VyrdetForm.Pause:= true;
  aLesniPolozky:= GetIni('LesniPolozky', 'ODDELENI,$DILEC,$POROST');
  VyrdetForm.LesniPolozky:= aLesniPolozky;
  VyrdetForm.Varianta:= Varianta;
  VyrdetForm.Show;



  with SQLZAK do
  begin
    First;

    while not EOF do
    begin
      aObsahLesnichPolozek:= GetContent(SQLZAK, aLesniPolozky);
      VyrdetForm.ObsahLesnichPolozek:= aObsahLesnichPolozek;
      VyrdetForm.ProvedPorost;

      if VyrdetForm.Pause then
         repeat
           VyrdetForm.DalsiKrok:= false;
           Application.ProcessMessages;
         until not VyrdetForm.Pause or VyrdetForm.DalsiKrok or VyrdetForm.Konec;

      Next;
      if VyrdetForm.Konec then
         break;
    end
  end;

  if VyrdetForm.Memo.Lines.Count > 0 then
  begin
    repeat
      Application.ProcessMessages;
    until VyrdetForm.Konec
  end;

  VyrdetForm.Free;

  UkazCelyZAK
end;

procedure TFVyrZak.btZnovuNacteniClick(Sender: TObject);
begin
  UkazCelyZak
end;


procedure TFVyrZak.ResizeHeader;
begin
{  caption:= IntToStr(Header.Width) + ', ' + IntToStr(Width); }
{  Header.Width:= Width - 6; }
  Header.Width:= Width-6;
  Header.Top:= 193;
  Header.Height:= Height - 220;
  Panel1.Left:= 3;
  Panel1.Top:= Header.Top + 3;
  Panel1.Width := Header.SectionWidth[0] - 3;
  Panel1.Height:= Header.Height - 6;

  Panel2.Left:= Header.SectionWidth[0] + 3;
  Panel2.Top:= Header.Top + 3;
  Panel2.Width := Header.SectionWidth[1] - 5;
  Panel2.Height:= Header.Height - 6;
end;



procedure TFVyrZak.HeaderSizing(Sender: TObject; ASection,
  AWidth: Integer);
begin
  ResizeHeader
end;

procedure TFVyrZak.HeaderSized(Sender: TObject; ASection, AWidth: Integer);
begin
  ResizeHeader;
end;

procedure TFVyrZak.FormResize(Sender: TObject);
begin
  ResizeHeader;
end;



procedure  TFVyrZak.SaveSizes;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  IniFile.WriteInteger('VYRZAKForm', 'Left', Left);
  IniFile.WriteInteger('VYRZAKForm', 'Top', Top);
  IniFile.WriteInteger('VYRZAKForm', 'Height', Height);
  IniFile.WriteInteger('VYRZAKForm', 'Width', Width);
  IniFile.WriteInteger('VYRZAKForm', 'Split', SPlit);
  IniFile.Free;
end;


procedure  TFVyrZak.LoadSizes;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  Left:= IniFile.ReadInteger('VYRZAKForm', 'Left', Left);
  Top:= IniFile.ReadInteger('VYRZAKForm', 'Top', Top);
  Height:= IniFile.ReadInteger('VYRZAKForm', 'Height', Height);
  Width:= IniFile.ReadInteger('VYRZAKForm', 'Width', Width);
  Split:= IniFile.ReadInteger('VYRZAKForm', 'Split', Split);
  IniFile.Free;
end;




function   TFVyrZak.GetSplit: integer;
begin
  result:= Header.SectionWidth[0]
end;


procedure   TFVyrZak.SetSplit(aValue: integer);
begin
  Header.SectionWidth[0]:= aValue
end;



procedure TFVyrZak.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SaveSizes;
  CanClose:= true
end;

procedure TFVyrZak.FormActivate(Sender: TObject);
begin
  LoadSizes
end;

procedure TFVyrZak.btSumParcClick(Sender: TObject);
var
  aForm: TCompareDBFForm;
  aDir, SourceTableName, TargetTableName: string;
begin
  aDir:= ReadIniString('ADRESAR', '');
  if not DirectoryExists(aDir) then
     aDir:= '';

  ZAKDBF.Title:= GetIni('SourceTitle', 'Vyber zdrojovou tabulku');
  ZAKDBF.InitialDir:= aDir;
  if not ZAKDBF.Execute
     then exit;

  WriteIniString('ADRESAR', extractFilePath(ZAKDBF.FileName));
  SourceTableName:= ZAKDBF.FileName;

  ZAKDBF.Title:= GetIni('TargetTitle', 'Vyber clovou tabulku');
  ZAKDBF.InitialDir:= aDir;
  if not ZAKDBF.Execute
     then exit;

  TargetTableName:= ZAKDBF.FileName;

  aForm:= TCompareDBFForm.Create(nil);
  aForm.SourceTableName:= SourceTableName;
  aForm.TargetTableName:= TargetTableName;
  aForm.ShowModal;
  aForm.Free;
end;

procedure TFVyrZak.b_PSkFromPARClick(Sender: TObject);
var
  aVym: double;
  aDir, SourceTableName,DestTableName,aName: string;
begin
  aDir:= ReadIniString('ADRESAR', '');
  if not DirectoryExists(aDir) then
     aDir:= '';

  ZAKDBF.Title:= ('Vyber tabulku parcel (nejlpe njakou _82PAR.DBF)');
  ZAKDBF.InitialDir:= aDir;
  if not ZAKDBF.Execute
     then exit;

  WriteIniString('ADRESAR', extractFilePath(ZAKDBF.FileName));
  SourceTableName:= ZAKDBF.FileName;

  SkParcDBF.Title:= 'Vyber(zalo) tabulku skupin parcel';

  if not SkParcDBF.Execute then
     exit;

  aName:= changeFileExt(SkParcDBF.FileName, '.DBF');
  TabSkParc.Active:= false;
  if FileExists(aName) then
     DeleteFile(PChar(aName));

  ZalozSkParcDBF(aName);

  if fileExists(aName) then
  begin
    lbSkParcDBF.Caption:= aName;
    TabSkParc.Active:= false;
    TabSkParc.TableName:= aName;
    TabSkParc.Active:= true;
  end
  else
     exit;

  with SQLPAR do
  begin
    SQL.Clear;
    SQL.Add('SELECT KU_KOD,SKUPAR_CIS,SUM(PARVYM) AS SUMEC FROM');
    SQL.Add('"' + SourceTableName + '"');
    SQL.ADD('GROUP BY KU_KOD,SKUPAR_CIS;');
    Open
  end;

  SQLPAR.First;

  while not SQLPAR.EOF do
  begin

    TabSkParc.Insert;
    TabSkParc.FieldByName('KU_KOD').AsString:= SQLPAR.FieldByName('KU_KOD').AsString;
    TabSkParc.FieldByName('SK_PARC').AsString:= SQLPAR.FieldByName('SKUPAR_CIS').AsString;
    TabSkParc.FieldByName('VYMERA').AsFloat:= SQLPAR.FieldByName('SUMEC').AsFloat;
    TabSkParc.Post;
    SQLPAR.Next;
  end;

  SQLPAR.Close;

end;

end.
