unit Equaliz;
{ vyrovnn s lepm algoritmem pro zbytky po zaokrouhlen
  - setdit plochy dle velikosti
  - A: podlit nejvt plochu zbytkem po zaokrouklen = kritrium pdlu
  - od nejvt plochy postupovat a pidvat vem plochm, kter pekroily
    velikost kritria pdlu
  - co se nevyerp, postupuje do dalho kola }

interface
uses
  Classes;

type
  PPlocha = class
    Cislo   : longInt;
    Plocha, Vymera: double;
  end;

TListPloch = class(TList)
private
  FSuma: double;

public
  EqualArea: double;
  RoundKoef: longInt;

  function  Plocha(aInd: longInt): double;
  function  Vymera(aInd: longInt): double;
  function  Cislo(aInd: longInt): longInt;
  procedure InsertPlochu(aPlocha: PPlocha);

  procedure Equalize;
end;



implementation



function  TListPloch.Plocha(aInd: longInt): double;
begin
  result:= PPlocha(Items[aInd]).Plocha
end;

function  TListPloch.Vymera(aInd: longInt): double;
begin
  result:= PPlocha(Items[aInd]).Vymera
end;

function  TListPloch.Cislo(aInd: longInt): longInt;
begin
  result:= PPlocha(Items[aInd]).Cislo
end;



procedure TListPloch.InsertPlochu(aPlocha: PPlocha);
var
  I: longInt;
begin
  if Count = 0 then
  begin
    Add(aPlocha);
    exit;
  end;

  for I:= 0 to Count-1 do
  begin
    if aPlocha.Plocha > Plocha(I) then
    begin
      Insert(I, aPlocha);
      exit;
    end;
  end;
  Add(aPlocha)
end;





procedure TListPloch.Equalize;
var
  I: longInt;
  aKrit: double;
  aKoef: double;
  aPomVymera: double;
  aDelta: longInt;
begin
  { Vypocet Vymer }
  FSuma:= 0;

  for I:= 0 to Count-1 do
  begin
    FSuma:= FSuma + Plocha(I)
  end;

  aKoef:= EqualArea/FSuma;
{ rozpotn }
  aPomVymera:= 0;
  for I:= 0 to Count-1 do
  with PPlocha(Items[I]) do
  begin
    Vymera:= round(Plocha*aKoef*RoundKoef)/RoundKoef;
    aPomVymera:= aPomVymera + Vymera
  end;

  aDelta:= round((EqualArea-aPomVymera) * RoundKoef);

  while aDelta <> 0 do
  begin
    aKrit:= Plocha(0) / abs(aDelta);
    for I:= 0 to Count-1 do
    begin
      if (Plocha(I) >= aKrit) and (aDelta <> 0) then
      begin
        if aDelta > 0 then
        begin
          PPlocha(Items[I]).Vymera:= Vymera(I) + 1 / RoundKoef;
          dec(aDelta)
        end
        else
        begin
          PPlocha(Items[I]).Vymera:= Vymera(I) - 1 / RoundKoef;
          inc(aDelta)
        end
      end
      else
        break
    end;
  end;
end;


end.
