unit m_vyrzak;

interface

function IniName: string;

function ReadIniStringG(aGroup, aItem, aDefault: string): string;
procedure WriteIniStringG(aGroup, aItem: string; aValue: string);

function ReadIniString(aItem, aDefault: string): string;
procedure WriteIniString(aItem: string; aValue: string);
function ReadIniInteger(aItem: string; aDefault: integer): integer;
procedure WriteIniInteger(aItem: string; aValue: integer);
function ReadIniDouble(aItem: string; aDefault: double): double;
procedure WriteIniDouble(aItem: string; aValue: double);

function JmPolKatastr: string;

implementation

uses
  Dialogs, SysUtils, WinProcs, IniFiles, FileCtrl, Forms,
  _IniFile,
  CtiRadek;






procedure GiveCRTItemsProps(aCrtName, aItem: string; var aType: char; var aLength, aDecimal: integer);
var
  F: text;
  RO: TCtiRadekClass;
  Radek, Jmeno: string;
  CR: longInt;
begin
  aType:= ' ';
  aLength:= 0;
  aDecimal:= 0;
  aItem:= UpperCase(aItem);

  assign(F, aCrtName);

  {$I-} reset(F) {$I+};
  if IOResult <> 0 then exit;

  CR:= 0;

  while not eof(F) do
  begin
    readln(F, Radek);
    inc(CR);

    if (Radek = '') or ((Radek[1] in [';','{','('])) then continue;

    RO:= TCtiRadekClass.Create(Radek);
    if not RO.DosloKChybe then
    with RO do
    begin
      PreskocMezery;
      Jmeno:= DejStringPoZnak(' ');
      Jmeno:= UpperCase(Jmeno);

      if not DosloKChybe and (Jmeno <> '') then

      begin
        if Jmeno = aItem then
        begin
          PreskocMezery;
          aType:= upCase(DejChar);

          if not DosloKChybe and (aType in ['C', 'N', 'L', 'D']) then
          begin
            aLength:= DejInteger;
            aDecimal:= DejInteger;
          end
          else
          begin
            ShowMessage
            (ExtractFileName(aCRTName) + ': Spatny typ polozky, radek c.' + IntToStr(CR));
            aType:= ' '
          end;
          break
        end
      end
    end;
    
    RO.Free;
  end;


{I-}close(F);{$I+}
  if IOresult <> 0 then;

end;




function WinDirStr: string;
type
  TDirStr          = array[0..100] of Char;
var
  PomDirStr: TDirStr;
begin
  getWindowsDirectory(PomDirStr, sizeOf(TDirStr));
  result:= StrPas(PomDirStr);
end;


function IniName: string;
begin
  result:= changeFileExt(Application.ExeName, '.INI');
end;


function ReadIniStringG(aGroup, aItem, aDefault: string): string;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  result:= IniFile.ReadString(aGroup, aItem, aDefault);
  IniFile.Free;
end;


procedure WriteIniStringG(aGroup, aItem: string; aValue: string);
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  IniFile.WriteString(aGroup, aItem, aValue);
  IniFile.Free;
end;





function ReadIniString(aItem, aDefault: string): string;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  result:= IniFile.ReadString('GLOBAL', aItem, aDefault);
  IniFile.Free;
end;


procedure WriteIniString(aItem: string; aValue: string);
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  IniFile.WriteString('GLOBAL', aItem, aValue);
  IniFile.Free;
end;



function ReadIniInteger(aItem: string; aDefault: integer): integer;
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  result:= IniFile.ReadInteger('GLOBAL', aItem, aDefault);
  IniFile.Free;
end;



procedure WriteIniInteger(aItem: string; aValue: integer);
var
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(IniName);
  IniFile.WriteInteger('GLOBAL', aItem, aValue);
  IniFile.Free;
end;



function ReadIniDouble(aItem: string; aDefault: double): double;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniName);
  result:= IniFile.ReadDouble('GLOBAL', aItem, aDefault);
  IniFile.Free;
end;

procedure WriteIniDouble(aItem: string; aValue: double);
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniName);
  IniFile.WriteDouble('GLOBAL', aItem, aValue);
  IniFile.Free;
end;






function CrtFileNameForDBF(aDBFName: string): string;
var
  aPom: string;
begin
  aPom:= ChangeFileExt(ExtractFileName(aDBFName), '.CRT');
  result:= WinDirStr + '\' + aPom;
end;





function JmPolKatastr: string;
var
  aType: char;
  aLength, aDecimal: integer;
begin
  result:= 'KU_KOD';
  GiveCRTItemsProps(CrtFileNameForDBF('P0109.CRT'), 'KU_KOD', aType, aLength, aDecimal);

  if aType = ' ' then
  begin
    GiveCRTItemsProps(CrtFileNameForDBF('P0109.CRT'), 'KATASTR', aType, aLength, aDecimal);
    if aType = ' ' then
       ShowMessage('Chybn nebo neexistujc P0109.CRT ' + #13 +
                   'Nelze nalzt definici poloky KOD_KU nebo KATASTR')
    else
      result:= 'KATASTR'
  end
end;




end.
