unit Orbis01Impl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls,
  ComServ, StdVCL, AXCtrls, ORBISx_TLB, Orbis01, ExtCtrls;

type
  TOrbis01X = class(TActiveXControl, IOrbis01X)
  private
    { Private declarations }
    FDelphiControl: TOrbis01;
    FEvents: IOrbis01XEvents;
    function _SelectDirectoryEvent(const Caption: string; const Root: WideString;
      var Directory: string): Boolean;
    function _SelectFileEvent(const Caption, Directory, Filter: string;
      var FileName: string): Boolean;
    procedure _FileAfterSaveEvent(const aFile: string);
    procedure _FileBeforeLoadEvent(const aFile: string);
    procedure _FileExistsEvent(const aFile: string);
    procedure _ProgressEndEvent(_ID, Value: Integer);
    procedure _ProgressEvent(_ID, Value: Integer);
    procedure _ProgressMaxEvent(_ID, Value: Integer);
    procedure _ProgressStartEvent(_ID: Integer; ProgressName: string; MinProgress,
      MaxProgress, Progress: Integer);
    procedure _ProgressTextEvent(_ID: Integer; Value: string);
    procedure AreaChangedEvent(Value, Value1: Double);
    procedure CanResizeEvent(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure ClickEvent(Sender: TObject);
    procedure ConstrainedResizeEvent(Sender: TObject; var MinWidth, MinHeight,
      MaxWidth, MaxHeight: Integer);
    procedure ContinualChangedEvent(aContinual: Boolean);
    procedure ContinualLoadEndEvent;
    procedure ContinualLoadStartEvent;
    procedure DblClickEvent(Sender: TObject);
    procedure InterpretDoneEvent;
    procedure LengthChangedEvent(Value, Value1: Double);
    procedure MapsChangeEvent;
    procedure MonitorCoordsChangeEvent(X, Y: Double);
    procedure MonitorLHCCHangeEvent(LHC, Oddeleni: Integer; Dilec, Porost,
      Skupina: string);
    procedure MonitorParcelyCHangeEvent(Katastr, Parcis, Parpod: Integer);
    procedure MouseEnterEvent(Sender: TObject);
    procedure MouseLeaveEvent(Sender: TObject);
    procedure NewDATAEvent;
    procedure NewModelEvent;
    procedure ProjectionCHangedEvent(aX, aY, aScale, aVirtualScale: Double);
    procedure RastersChangeEvent;
    procedure ResizeEvent(Sender: TObject);
    procedure SaveUserDataEvent(var ToSave: Boolean);
    procedure SelectEvent;
    procedure TypChangeEvent;
    procedure UserLHCAreaDialogEvent(NewObject: Boolean; Area: Double; var UserID,
      Color, Symbol, aresult: Integer);
    procedure VrsChangeEvent;
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function ClassNameIs(const Name: WideString): WordBool; safecall;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function FillLHCsString: WideString; safecall;
    function FillMapsString: WideString; safecall;
    function Get_ActiveToolName: WideString; safecall;
    function Get_ActualEditLayer: WideString; safecall;
    function Get_ActualMap: WideString; safecall;
    function Get_ActualSelectName: WideString; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_Alignment: TxAlignment; safecall;
    function Get_AlignWithMargins: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_BevelInner: TxBevelCut; safecall;
    function Get_BevelKind: TxBevelKind; safecall;
    function Get_BevelOuter: TxBevelCut; safecall;
    function Get_BorderStyle: TxBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_CenterX: Double; safecall;
    function Get_CenterY: Double; safecall;
    function Get_ClearIfLHCNotFound: WordBool; safecall;
    function Get_Client: WordBool; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_Continual: WordBool; safecall;
    function Get_Ctl3D: WordBool; safecall;
    function Get_DILEC: WideString; safecall;
    function Get_Directory_Project: WideString; safecall;
    function Get_Directory_Root: WideString; safecall;
    function Get_Directory_Script: WideString; safecall;
    function Get_Directory_Service: WideString; safecall;
    function Get_Directory_Store: WideString; safecall;
    function Get_DockSite: WordBool; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DragCursor: Smallint; safecall;
    function Get_DragMode: TxDragMode; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_ExplicitHeight: Integer; safecall;
    function Get_ExplicitLeft: Integer; safecall;
    function Get_ExplicitTop: Integer; safecall;
    function Get_ExplicitWidth: Integer; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_FullRepaint: WordBool; safecall;
    function Get_JPGCompressionQuality: Integer; safecall;
    function Get_JPGGrayscale: WordBool; safecall;
    function Get_JPGPixelFormat: Integer; safecall;
    function Get_LHC: Integer; safecall;
    function Get_Locked: WordBool; safecall;
    function Get_ManualProjectionChange: WordBool; safecall;
    function Get_MonitorActive: WordBool; safecall;
    function Get_MonitorCoords: WordBool; safecall;
    function Get_MonitorLHC: WordBool; safecall;
    function Get_MonitorParcely: WordBool; safecall;
    function Get_MouseInClient: WordBool; safecall;
    function Get_No_BDE: WordBool; safecall;
    function Get_NoProtocol: WordBool; safecall;
    function Get_ODDELENI: Integer; safecall;
    function Get_par_CISLO: Integer; safecall;
    function Get_par_KATASTR: Integer; safecall;
    function Get_par_PODLOMENI: Integer; safecall;
    function Get_ParcelaSelected: WordBool; safecall;
    function Get_ParentBackground: WordBool; safecall;
    function Get_ParentColor: WordBool; safecall;
    function Get_ParentCtl3D: WordBool; safecall;
    function Get_POROST: WideString; safecall;
    function Get_Scale: Double; safecall;
    function Get_SelX: Double; safecall;
    function Get_SelY: Double; safecall;
    function Get_SKUPINA: WideString; safecall;
    function Get_SkupinaSelected: WordBool; safecall;
    function Get_UseDockManager: WordBool; safecall;
    function Get_VerticalAlignment: TxVerticalAlignment; safecall;
    function Get_VirtualScale: Double; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    function IsRightToLeft: WordBool; safecall;
    function JoinProjects(const aSourcePath: WideString): Integer; safecall;
    function OrbisIndexToColor(aIndex: Integer): Integer; safecall;
    function Projection_Move(aNext: WordBool): WordBool; safecall;
    function Projection_Status(var NoNext, NoPrevious: WordBool): WordBool;
      safecall;
    function RenumberLHC(LHC_OLD, LHC_NEW: Integer): WordBool; safecall;
    function UseRightToLeftReading: WordBool; safecall;
    function UseRightToLeftScrollBar: WordBool; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure Activate; safecall;
    procedure ActualEditLayerToActualMap; safecall;
    procedure ClearData; safecall;
    procedure ClearTheSelect; safecall;
    procedure EndSizeMove; safecall;
    procedure ExecuteScript(const aScript: WideString); safecall;
    procedure ExploreWorld; safecall;
    procedure ExportToBMPFile(const aVal: WideString); safecall;
    procedure ExportToJPGFile(const aVal: WideString); safecall;
    procedure HighlightTheForest; safecall;
    procedure HighlightTheKatastr; safecall;
    procedure HighlightTheSelect; safecall;
    procedure CheckRasters; safecall;
    procedure CheckTyp; safecall;
    procedure CheckUserDataForSave; safecall;
    procedure CheckVrs; safecall;
    procedure Import; safecall;
    procedure InitiateAction; safecall;
    procedure LoadKatastr(const aFileName: WideString); safecall;
    procedure LoadKatastrID(aID: Integer); safecall;
    procedure LoadProject(const aProjectName: WideString); safecall;
    procedure LoadUserDataFrom(const aFileName: WideString); safecall;
    procedure MapDialog; safecall;
    procedure NewEditLayer; safecall;
    procedure NewKatastr(const aPath: WideString; aID: Integer); safecall;
    procedure NewKatastrDialog; safecall;
    procedure NewMap; safecall;
    procedure NewProject(const aPath: WideString); safecall;
    procedure NewProjectDialog; safecall;
    procedure OILEditor; safecall;
    procedure Print; safecall;
    procedure PrintMap; safecall;
    procedure ReView; safecall;
    procedure SaveProjectAsContinual; safecall;
    procedure SaveUserDataTo(const aFileName: WideString); safecall;
    procedure Set_ActiveToolName(const Value: WideString); safecall;
    procedure Set_ActualEditLayer(const Value: WideString); safecall;
    procedure Set_ActualMap(const Value: WideString); safecall;
    procedure Set_ActualSelectName(const Value: WideString); safecall;
    procedure Set_Alignment(Value: TxAlignment); safecall;
    procedure Set_AlignWithMargins(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_BevelInner(Value: TxBevelCut); safecall;
    procedure Set_BevelKind(Value: TxBevelKind); safecall;
    procedure Set_BevelOuter(Value: TxBevelCut); safecall;
    procedure Set_BorderStyle(Value: TxBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_CenterX(Value: Double); safecall;
    procedure Set_CenterY(Value: Double); safecall;
    procedure Set_ClearIfLHCNotFound(Value: WordBool); safecall;
    procedure Set_Client(Value: WordBool); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_Continual(Value: WordBool); safecall;
    procedure Set_Ctl3D(Value: WordBool); safecall;
    procedure Set_DILEC(const Value: WideString); safecall;
    procedure Set_Directory_Project(const Value: WideString); safecall;
    procedure Set_Directory_Root(const Value: WideString); safecall;
    procedure Set_Directory_Script(const Value: WideString); safecall;
    procedure Set_Directory_Service(const Value: WideString); safecall;
    procedure Set_Directory_Store(const Value: WideString); safecall;
    procedure Set_DockSite(Value: WordBool); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DragCursor(Value: Smallint); safecall;
    procedure Set_DragMode(Value: TxDragMode); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_FullRepaint(Value: WordBool); safecall;
    procedure Set_JPGCompressionQuality(Value: Integer); safecall;
    procedure Set_JPGGrayscale(Value: WordBool); safecall;
    procedure Set_JPGPixelFormat(Value: Integer); safecall;
    procedure Set_LHC(Value: Integer); safecall;
    procedure Set_Locked(Value: WordBool); safecall;
    procedure Set_ManualProjectionChange(Value: WordBool); safecall;
    procedure Set_MonitorActive(Value: WordBool); safecall;
    procedure Set_MonitorCoords(Value: WordBool); safecall;
    procedure Set_MonitorLHC(Value: WordBool); safecall;
    procedure Set_MonitorParcely(Value: WordBool); safecall;
    procedure Set_No_BDE(Value: WordBool); safecall;
    procedure Set_NoProtocol(Value: WordBool); safecall;
    procedure Set_ODDELENI(Value: Integer); safecall;
    procedure Set_par_CISLO(Value: Integer); safecall;
    procedure Set_par_KATASTR(Value: Integer); safecall;
    procedure Set_par_PODLOMENI(Value: Integer); safecall;
    procedure Set_ParcelaSelected(Value: WordBool); safecall;
    procedure Set_ParentBackground(Value: WordBool); safecall;
    procedure Set_ParentColor(Value: WordBool); safecall;
    procedure Set_ParentCtl3D(Value: WordBool); safecall;
    procedure Set_POROST(const Value: WideString); safecall;
    procedure Set_Scale(Value: Double); safecall;
    procedure Set_SelX(Value: Double); safecall;
    procedure Set_SelY(Value: Double); safecall;
    procedure Set_ShiftView(const Value: WideString); safecall;
    procedure Set_SKUPINA(const Value: WideString); safecall;
    procedure Set_SkupinaSelected(Value: WordBool); safecall;
    procedure Set_UseDockManager(Value: WordBool); safecall;
    procedure Set_VerticalAlignment(Value: TxVerticalAlignment); safecall;
    procedure Set_VirtualScale(Value: Double); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure SetDesignVisible(Value: WordBool); safecall;
    procedure SetSubComponent(IsSubComponent: WordBool); safecall;
    procedure SetupMaps; safecall;
    procedure SetupRasters; safecall;
    procedure SetupTyp; safecall;
    procedure SetupVrs; safecall;
    procedure ShowMap(const aMap: WideString); safecall;
    procedure ShowTheForest(Pattern: WordBool); safecall;
    procedure ShowTheKatastr(Pattern: WordBool); safecall;
    procedure ShowTheSelect(Pattern: WordBool); safecall;
    procedure StartSizeMove; safecall;
    procedure ViewAll; safecall;
    procedure ZoomIn; safecall;
    procedure ZoomOut; safecall;
  end;

implementation

uses ComObj;

{ TOrbis01X }

procedure TOrbis01X.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  {TODO: Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_Orbis01XPage); }
end;

procedure TOrbis01X.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IOrbis01XEvents;
end;

procedure TOrbis01X.InitializeControl;
begin
  FDelphiControl := Control as TOrbis01;
  FDelphiControl.On_FileAfterSave := _FileAfterSaveEvent;
  FDelphiControl.On_FileBeforeLoad := _FileBeforeLoadEvent;
  FDelphiControl.On_FileExists := _FileExistsEvent;
  FDelphiControl.On_Progress := _ProgressEvent;
  FDelphiControl.On_ProgressEnd := _ProgressEndEvent;
  FDelphiControl.On_ProgressMax := _ProgressMaxEvent;
  FDelphiControl.On_ProgressStart := _ProgressStartEvent;
  FDelphiControl.On_ProgressText := _ProgressTextEvent;
  FDelphiControl.On_SelectDirectory := _SelectDirectoryEvent;
  FDelphiControl.On_SelectFile := _SelectFileEvent;
  FDelphiControl.OnAreaChanged := AreaChangedEvent;
  FDelphiControl.OnCanResize := CanResizeEvent;
  FDelphiControl.OnClick := ClickEvent;
  FDelphiControl.OnConstrainedResize := ConstrainedResizeEvent;
  FDelphiControl.OnContinualChanged := ContinualChangedEvent;
  FDelphiControl.OnContinualLoadEnd := ContinualLoadEndEvent;
  FDelphiControl.OnContinualLoadStart := ContinualLoadStartEvent;
  FDelphiControl.OnDblClick := DblClickEvent;
  FDelphiControl.OnInterpretDone := InterpretDoneEvent;
  FDelphiControl.OnLengthChanged := LengthChangedEvent;
  FDelphiControl.OnMapsChange := MapsChangeEvent;
  FDelphiControl.OnMonitorCoordsChange := MonitorCoordsChangeEvent;
  FDelphiControl.OnMonitorLHCCHange := MonitorLHCCHangeEvent;
  FDelphiControl.OnMonitorParcelyCHange := MonitorParcelyCHangeEvent;
  FDelphiControl.OnMouseEnter := MouseEnterEvent;
  FDelphiControl.OnMouseLeave := MouseLeaveEvent;
  FDelphiControl.OnNewDATA := NewDATAEvent;
  FDelphiControl.OnNewModel := NewModelEvent;
  FDelphiControl.OnProjectionCHanged := ProjectionCHangedEvent;
  FDelphiControl.OnRastersChange := RastersChangeEvent;
  FDelphiControl.OnResize := ResizeEvent;
  FDelphiControl.OnSaveUserData := SaveUserDataEvent;
  FDelphiControl.OnSelect := SelectEvent;
  FDelphiControl.OnTypChange := TypChangeEvent;
  FDelphiControl.OnUserLHCAreaDialog := UserLHCAreaDialogEvent;
  FDelphiControl.OnVrsChange := VrsChangeEvent;
end;

function TOrbis01X._SelectDirectoryEvent(const Caption: string;
  const Root: WideString; var Directory: string): Boolean;
var
  TempDirectory: WideString;
begin
  TempDirectory := WideString(Directory);
  if FEvents <> nil then FEvents.On_SelectDirectory(WideString(Caption), Root, TempDirectory);
  Directory := string(TempDirectory);
end;

function TOrbis01X._SelectFileEvent(const Caption, Directory, Filter: string;
  var FileName: string): Boolean;
var
  TempFileName: WideString;
begin
  TempFileName := WideString(FileName);
  if FEvents <> nil then FEvents.On_SelectFile(WideString(Caption), WideString(Directory), WideString(Filter), TempFileName);
  FileName := string(TempFileName);
end;

function TOrbis01X.ClassNameIs(const Name: WideString): WordBool;
begin
  Result := FDelphiControl.ClassNameIs(Name);
end;

function TOrbis01X.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := FDelphiControl.DrawTextBiDiModeFlagsReadingOnly;
end;

function TOrbis01X.FillLHCsString: WideString;
begin
  Result := FDelphiControl.FillLHCsString;
end;

function TOrbis01X.FillMapsString: WideString;
begin
  Result := FDelphiControl.FillMapsString;
end;

function TOrbis01X.Get_ActiveToolName: WideString;
begin
  Result := WideString(FDelphiControl.ActiveToolName);
end;

function TOrbis01X.Get_ActualEditLayer: WideString;
begin
  Result := WideString(FDelphiControl.ActualEditLayer);
end;

function TOrbis01X.Get_ActualMap: WideString;
begin
  Result := WideString(FDelphiControl.ActualMap);
end;

function TOrbis01X.Get_ActualSelectName: WideString;
begin
  Result := WideString(FDelphiControl.ActualSelectName);
end;

function TOrbis01X.Get_AlignDisabled: WordBool;
begin
  Result := FDelphiControl.AlignDisabled;
end;

function TOrbis01X.Get_Alignment: TxAlignment;
begin
  Result := Ord(FDelphiControl.Alignment);
end;

function TOrbis01X.Get_AlignWithMargins: WordBool;
begin
  Result := FDelphiControl.AlignWithMargins;
end;

function TOrbis01X.Get_AutoSize: WordBool;
begin
  Result := FDelphiControl.AutoSize;
end;

function TOrbis01X.Get_BevelInner: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelInner);
end;

function TOrbis01X.Get_BevelKind: TxBevelKind;
begin
  Result := Ord(FDelphiControl.BevelKind);
end;

function TOrbis01X.Get_BevelOuter: TxBevelCut;
begin
  Result := Ord(FDelphiControl.BevelOuter);
end;

function TOrbis01X.Get_BorderStyle: TxBorderStyle;
begin
  Result := Ord(FDelphiControl.BorderStyle);
end;

function TOrbis01X.Get_Caption: WideString;
begin
  Result := WideString(FDelphiControl.Caption);
end;

function TOrbis01X.Get_CenterX: Double;
begin
  Result := FDelphiControl.CenterX;
end;

function TOrbis01X.Get_CenterY: Double;
begin
  Result := FDelphiControl.CenterY;
end;

function TOrbis01X.Get_ClearIfLHCNotFound: WordBool;
begin
  Result := FDelphiControl.ClearIfLHCNotFound;
end;

function TOrbis01X.Get_Client: WordBool;
begin
  Result := FDelphiControl.Client;
end;

function TOrbis01X.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(FDelphiControl.Color);
end;

function TOrbis01X.Get_Continual: WordBool;
begin
  Result := FDelphiControl.Continual;
end;

function TOrbis01X.Get_Ctl3D: WordBool;
begin
  Result := FDelphiControl.Ctl3D;
end;

function TOrbis01X.Get_DILEC: WideString;
begin
  Result := WideString(FDelphiControl.DILEC);
end;

function TOrbis01X.Get_Directory_Project: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Project);
end;

function TOrbis01X.Get_Directory_Root: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Root);
end;

function TOrbis01X.Get_Directory_Script: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Script);
end;

function TOrbis01X.Get_Directory_Service: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Service);
end;

function TOrbis01X.Get_Directory_Store: WideString;
begin
  Result := WideString(FDelphiControl.Directory_Store);
end;

function TOrbis01X.Get_DockSite: WordBool;
begin
  Result := FDelphiControl.DockSite;
end;

function TOrbis01X.Get_DoubleBuffered: WordBool;
begin
  Result := FDelphiControl.DoubleBuffered;
end;

function TOrbis01X.Get_DragCursor: Smallint;
begin
  Result := Smallint(FDelphiControl.DragCursor);
end;

function TOrbis01X.Get_DragMode: TxDragMode;
begin
  Result := Ord(FDelphiControl.DragMode);
end;

function TOrbis01X.Get_Enabled: WordBool;
begin
  Result := FDelphiControl.Enabled;
end;

function TOrbis01X.Get_ExplicitHeight: Integer;
begin
  Result := FDelphiControl.ExplicitHeight;
end;

function TOrbis01X.Get_ExplicitLeft: Integer;
begin
  Result := FDelphiControl.ExplicitLeft;
end;

function TOrbis01X.Get_ExplicitTop: Integer;
begin
  Result := FDelphiControl.ExplicitTop;
end;

function TOrbis01X.Get_ExplicitWidth: Integer;
begin
  Result := FDelphiControl.ExplicitWidth;
end;

function TOrbis01X.Get_Font: IFontDisp;
begin
  GetOleFont(FDelphiControl.Font, Result);
end;

function TOrbis01X.Get_FullRepaint: WordBool;
begin
  Result := FDelphiControl.FullRepaint;
end;

function TOrbis01X.Get_JPGCompressionQuality: Integer;
begin
  Result := FDelphiControl.JPGCompressionQuality;
end;

function TOrbis01X.Get_JPGGrayscale: WordBool;
begin
  Result := FDelphiControl.JPGGrayscale;
end;

function TOrbis01X.Get_JPGPixelFormat: Integer;
begin
  Result := FDelphiControl.JPGPixelFormat;
end;

function TOrbis01X.Get_LHC: Integer;
begin
  Result := FDelphiControl.LHC;
end;

function TOrbis01X.Get_Locked: WordBool;
begin
  Result := FDelphiControl.Locked;
end;

function TOrbis01X.Get_ManualProjectionChange: WordBool;
begin
  Result := FDelphiControl.ManualProjectionChange;
end;

function TOrbis01X.Get_MonitorActive: WordBool;
begin
  Result := FDelphiControl.MonitorActive;
end;

function TOrbis01X.Get_MonitorCoords: WordBool;
begin
  Result := FDelphiControl.MonitorCoords;
end;

function TOrbis01X.Get_MonitorLHC: WordBool;
begin
  Result := FDelphiControl.MonitorLHC;
end;

function TOrbis01X.Get_MonitorParcely: WordBool;
begin
  Result := FDelphiControl.MonitorParcely;
end;

function TOrbis01X.Get_MouseInClient: WordBool;
begin
  Result := FDelphiControl.MouseInClient;
end;

function TOrbis01X.Get_No_BDE: WordBool;
begin
  Result := FDelphiControl.No_BDE;
end;

function TOrbis01X.Get_NoProtocol: WordBool;
begin
  Result := FDelphiControl.NoProtocol;
end;

function TOrbis01X.Get_ODDELENI: Integer;
begin
  Result := FDelphiControl.ODDELENI;
end;

function TOrbis01X.Get_par_CISLO: Integer;
begin
  Result := FDelphiControl.par_CISLO;
end;

function TOrbis01X.Get_par_KATASTR: Integer;
begin
  Result := FDelphiControl.par_KATASTR;
end;

function TOrbis01X.Get_par_PODLOMENI: Integer;
begin
  Result := FDelphiControl.par_PODLOMENI;
end;

function TOrbis01X.Get_ParcelaSelected: WordBool;
begin
  Result := FDelphiControl.ParcelaSelected;
end;

function TOrbis01X.Get_ParentBackground: WordBool;
begin
  Result := FDelphiControl.ParentBackground;
end;

function TOrbis01X.Get_ParentColor: WordBool;
begin
  Result := FDelphiControl.ParentColor;
end;

function TOrbis01X.Get_ParentCtl3D: WordBool;
begin
  Result := FDelphiControl.ParentCtl3D;
end;

function TOrbis01X.Get_POROST: WideString;
begin
  Result := WideString(FDelphiControl.POROST);
end;

function TOrbis01X.Get_Scale: Double;
begin
  Result := FDelphiControl.Scale;
end;

function TOrbis01X.Get_SelX: Double;
begin
  Result := FDelphiControl.SelX;
end;

function TOrbis01X.Get_SelY: Double;
begin
  Result := FDelphiControl.SelY;
end;

function TOrbis01X.Get_SKUPINA: WideString;
begin
  Result := WideString(FDelphiControl.SKUPINA);
end;

function TOrbis01X.Get_SkupinaSelected: WordBool;
begin
  Result := FDelphiControl.SkupinaSelected;
end;

function TOrbis01X.Get_UseDockManager: WordBool;
begin
  Result := FDelphiControl.UseDockManager;
end;

function TOrbis01X.Get_VerticalAlignment: TxVerticalAlignment;
begin
  Result := Ord(FDelphiControl.VerticalAlignment);
end;

function TOrbis01X.Get_VirtualScale: Double;
begin
  Result := FDelphiControl.VirtualScale;
end;

function TOrbis01X.Get_Visible: WordBool;
begin
  Result := FDelphiControl.Visible;
end;

function TOrbis01X.Get_VisibleDockClientCount: Integer;
begin
  Result := FDelphiControl.VisibleDockClientCount;
end;

function TOrbis01X.IsRightToLeft: WordBool;
begin
  Result := FDelphiControl.IsRightToLeft;
end;

function TOrbis01X.JoinProjects(const aSourcePath: WideString): Integer;
begin
  Result := FDelphiControl.JoinProjects(aSourcePath);
end;

function TOrbis01X.OrbisIndexToColor(aIndex: Integer): Integer;
begin
  Result := FDelphiControl.OrbisIndexToColor(aIndex);
end;

function TOrbis01X.Projection_Move(aNext: WordBool): WordBool;
begin
  Result := FDelphiControl.Projection_Move(aNext);
end;

function TOrbis01X.Projection_Status(var NoNext,
  NoPrevious: WordBool): WordBool;
begin

end;

function TOrbis01X.RenumberLHC(LHC_OLD, LHC_NEW: Integer): WordBool;
begin
  Result := FDelphiControl.RenumberLHC(LHC_OLD, LHC_NEW);
end;

function TOrbis01X.UseRightToLeftReading: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftReading;
end;

function TOrbis01X.UseRightToLeftScrollBar: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftScrollBar;
end;

procedure TOrbis01X._FileAfterSaveEvent(const aFile: string);
begin
  if FEvents <> nil then FEvents.On_FileAfterSave(WideString(aFile));
end;

procedure TOrbis01X._FileBeforeLoadEvent(const aFile: string);
begin
  if FEvents <> nil then FEvents.On_FileBeforeLoad(WideString(aFile));
end;

procedure TOrbis01X._FileExistsEvent(const aFile: string);
begin
  if FEvents <> nil then FEvents.On_FileExists(WideString(aFile));
end;

procedure TOrbis01X._ProgressEndEvent(_ID, Value: Integer);
begin
  if FEvents <> nil then FEvents.On_ProgressEnd(_ID, Value);
end;

procedure TOrbis01X._ProgressEvent(_ID, Value: Integer);
begin
  if FEvents <> nil then FEvents.On_Progress(_ID, Value);
end;

procedure TOrbis01X._ProgressMaxEvent(_ID, Value: Integer);
begin
  if FEvents <> nil then FEvents.On_ProgressMax(_ID, Value);
end;

procedure TOrbis01X._ProgressStartEvent(_ID: Integer; ProgressName: string;
  MinProgress, MaxProgress, Progress: Integer);
begin
  if FEvents <> nil then FEvents.On_ProgressStart(_ID, WideString(ProgressName), MinProgress, MaxProgress, Progress);
end;

procedure TOrbis01X._ProgressTextEvent(_ID: Integer; Value: string);
begin
  if FEvents <> nil then FEvents.On_ProgressText(_ID, WideString(Value));
end;

procedure TOrbis01X._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TOrbis01X.Activate;
begin
  FDelphiControl.Activate;
end;

procedure TOrbis01X.ActualEditLayerToActualMap;
begin
  FDelphiControl.ActualEditLayerToActualMap;
end;

procedure TOrbis01X.AreaChangedEvent(Value, Value1: Double);
begin
  if FEvents <> nil then FEvents.OnAreaChanged(Value, Value1);
end;

procedure TOrbis01X.CanResizeEvent(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
var
  TempNewWidth: Integer;
  TempNewHeight: Integer;
  TempResize: WordBool;
begin
  TempNewWidth := Integer(NewWidth);
  TempNewHeight := Integer(NewHeight);
  TempResize := WordBool(Resize);
  if FEvents <> nil then FEvents.OnCanResize(TempNewWidth, TempNewHeight, TempResize);
  NewWidth := Integer(TempNewWidth);
  NewHeight := Integer(TempNewHeight);
  Resize := Boolean(TempResize);
end;

procedure TOrbis01X.ClearData;
begin
  FDelphiControl.ClearData;
end;

procedure TOrbis01X.ClearTheSelect;
begin
  FDelphiControl.ClearTheSelect;
end;

procedure TOrbis01X.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TOrbis01X.ConstrainedResizeEvent(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
var
  TempMinWidth: Integer;
  TempMinHeight: Integer;
  TempMaxWidth: Integer;
  TempMaxHeight: Integer;
begin
  TempMinWidth := Integer(MinWidth);
  TempMinHeight := Integer(MinHeight);
  TempMaxWidth := Integer(MaxWidth);
  TempMaxHeight := Integer(MaxHeight);
  if FEvents <> nil then FEvents.OnConstrainedResize(TempMinWidth, TempMinHeight, TempMaxWidth, TempMaxHeight);
  MinWidth := Integer(TempMinWidth);
  MinHeight := Integer(TempMinHeight);
  MaxWidth := Integer(TempMaxWidth);
  MaxHeight := Integer(TempMaxHeight);
end;

procedure TOrbis01X.ContinualChangedEvent(aContinual: Boolean);
begin
  if FEvents <> nil then FEvents.OnContinualChanged(WordBool(aContinual));
end;

procedure TOrbis01X.ContinualLoadEndEvent;
begin
  if FEvents <> nil then FEvents.OnContinualLoadEnd;
end;

procedure TOrbis01X.ContinualLoadStartEvent;
begin
  if FEvents <> nil then FEvents.OnContinualLoadStart;
end;

procedure TOrbis01X.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TOrbis01X.EndSizeMove;
begin
  FDelphiControl.EndSizeMove;
end;

procedure TOrbis01X.ExecuteScript(const aScript: WideString);
begin
  FDelphiControl.ExecuteScript(aScript);
end;

procedure TOrbis01X.ExploreWorld;
begin
  FDelphiControl.ExploreWorld;
end;

procedure TOrbis01X.ExportToBMPFile(const aVal: WideString);
begin
  FDelphiControl.ExportToBMPFile(aVal);
end;

procedure TOrbis01X.ExportToJPGFile(const aVal: WideString);
begin
  FDelphiControl.ExportToJPGFile(aVal);
end;

procedure TOrbis01X.HighlightTheForest;
begin
  FDelphiControl.HighlightTheForest;
end;

procedure TOrbis01X.HighlightTheKatastr;
begin
  FDelphiControl.HighlightTheKatastr;
end;

procedure TOrbis01X.HighlightTheSelect;
begin
  FDelphiControl.HighlightTheSelect;
end;

procedure TOrbis01X.CheckRasters;
begin
  FDelphiControl.CheckRasters;
end;

procedure TOrbis01X.CheckTyp;
begin
  FDelphiControl.CheckTyp;
end;

procedure TOrbis01X.CheckUserDataForSave;
begin
  FDelphiControl.CheckUserDataForSave;
end;

procedure TOrbis01X.CheckVrs;
begin
  FDelphiControl.CheckVrs;
end;

procedure TOrbis01X.Import;
begin
  FDelphiControl.Import;
end;

procedure TOrbis01X.InitiateAction;
begin
  FDelphiControl.InitiateAction;
end;

procedure TOrbis01X.InterpretDoneEvent;
begin
  if FEvents <> nil then FEvents.OnInterpretDone;
end;

procedure TOrbis01X.LengthChangedEvent(Value, Value1: Double);
begin
  if FEvents <> nil then FEvents.OnLengthChanged(Value, Value1);
end;

procedure TOrbis01X.LoadKatastr(const aFileName: WideString);
begin
  FDelphiControl.LoadKatastr(aFileName);
end;

procedure TOrbis01X.LoadKatastrID(aID: Integer);
begin
  FDelphiControl.LoadKatastrID(aID);
end;

procedure TOrbis01X.LoadProject(const aProjectName: WideString);
begin
  FDelphiControl.LoadProject(aProjectName);
end;

procedure TOrbis01X.LoadUserDataFrom(const aFileName: WideString);
begin
  FDelphiControl.LoadUserDataFrom(aFileName);
end;

procedure TOrbis01X.MapDialog;
begin
  FDelphiControl.MapDialog;
end;

procedure TOrbis01X.MapsChangeEvent;
begin
  if FEvents <> nil then FEvents.OnMapsChange;
end;

procedure TOrbis01X.MonitorCoordsChangeEvent(X, Y: Double);
begin
  if FEvents <> nil then FEvents.OnMonitorCoordsChange(X, Y);
end;

procedure TOrbis01X.MonitorLHCCHangeEvent(LHC, Oddeleni: Integer; Dilec, Porost,
  Skupina: string);
begin
  if FEvents <> nil then FEvents.OnMonitorLHCCHange(LHC, Oddeleni, WideString(Dilec), WideString(Porost), WideString(Skupina));
end;

procedure TOrbis01X.MonitorParcelyCHangeEvent(Katastr, Parcis, Parpod: Integer);
begin
  if FEvents <> nil then FEvents.OnMonitorParcelyCHange(Katastr, Parcis, Parpod);
end;

procedure TOrbis01X.MouseEnterEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnMouseEnter;
end;

procedure TOrbis01X.MouseLeaveEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnMouseLeave;
end;

procedure TOrbis01X.NewDATAEvent;
begin
  if FEvents <> nil then FEvents.OnNewDATA;
end;

procedure TOrbis01X.NewEditLayer;
begin
  FDelphiControl.NewEditLayer;
end;

procedure TOrbis01X.NewKatastr(const aPath: WideString; aID: Integer);
begin
  FDelphiControl.NewKatastr(aPath, aID);
end;

procedure TOrbis01X.NewKatastrDialog;
begin
  FDelphiControl.NewKatastrDialog;
end;

procedure TOrbis01X.NewMap;
begin
  FDelphiControl.NewMap;
end;

procedure TOrbis01X.NewModelEvent;
begin
  if FEvents <> nil then FEvents.OnNewModel;
end;

procedure TOrbis01X.NewProject(const aPath: WideString);
begin
  FDelphiControl.NewProject(aPath);
end;

procedure TOrbis01X.NewProjectDialog;
begin
  FDelphiControl.NewProjectDialog;
end;

procedure TOrbis01X.OILEditor;
begin
  FDelphiControl.OILEditor;
end;

procedure TOrbis01X.Print;
begin
  FDelphiControl.Print;
end;

procedure TOrbis01X.PrintMap;
begin
  FDelphiControl.PrintMap;
end;

procedure TOrbis01X.ProjectionCHangedEvent(aX, aY, aScale,
  aVirtualScale: Double);
begin
  if FEvents <> nil then FEvents.OnProjectionCHanged(aX, aY, aScale, aVirtualScale);
end;

procedure TOrbis01X.RastersChangeEvent;
begin
  if FEvents <> nil then FEvents.OnRastersChange;
end;

procedure TOrbis01X.ResizeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnResize;
end;

procedure TOrbis01X.ReView;
begin
  FDelphiControl.ReView;
end;

procedure TOrbis01X.SaveProjectAsContinual;
begin
  FDelphiControl.SaveProjectAsContinual;
end;

procedure TOrbis01X.SaveUserDataEvent(var ToSave: Boolean);
var
  TempToSave: WordBool;
begin
  TempToSave := WordBool(ToSave);
  if FEvents <> nil then FEvents.OnSaveUserData(TempToSave);
  ToSave := Boolean(TempToSave);
end;

procedure TOrbis01X.SaveUserDataTo(const aFileName: WideString);
begin
  FDelphiControl.SaveUserDataTo(aFileName);
end;

procedure TOrbis01X.SelectEvent;
begin
  if FEvents <> nil then FEvents.OnSelect;
end;

procedure TOrbis01X.Set_ActiveToolName(const Value: WideString);
begin
  FDelphiControl.ActiveToolName := string(Value);
end;

procedure TOrbis01X.Set_ActualEditLayer(const Value: WideString);
begin
  FDelphiControl.ActualEditLayer := string(Value);
end;

procedure TOrbis01X.Set_ActualMap(const Value: WideString);
begin
  FDelphiControl.ActualMap := string(Value);
end;

procedure TOrbis01X.Set_ActualSelectName(const Value: WideString);
begin
  FDelphiControl.ActualSelectName := string(Value);
end;

procedure TOrbis01X.Set_Alignment(Value: TxAlignment);
begin
  FDelphiControl.Alignment := TAlignment(Value);
end;

procedure TOrbis01X.Set_AlignWithMargins(Value: WordBool);
begin
  FDelphiControl.AlignWithMargins := Value;
end;

procedure TOrbis01X.Set_AutoSize(Value: WordBool);
begin
  FDelphiControl.AutoSize := Value;
end;

procedure TOrbis01X.Set_BevelInner(Value: TxBevelCut);
begin
  FDelphiControl.BevelInner := TBevelCut(Value);
end;

procedure TOrbis01X.Set_BevelKind(Value: TxBevelKind);
begin
  FDelphiControl.BevelKind := TBevelKind(Value);
end;

procedure TOrbis01X.Set_BevelOuter(Value: TxBevelCut);
begin
  FDelphiControl.BevelOuter := TBevelCut(Value);
end;

procedure TOrbis01X.Set_BorderStyle(Value: TxBorderStyle);
begin
  FDelphiControl.BorderStyle := TBorderStyle(Value);
end;

procedure TOrbis01X.Set_Caption(const Value: WideString);
begin
  FDelphiControl.Caption := TCaption(Value);
end;

procedure TOrbis01X.Set_CenterX(Value: Double);
begin
  FDelphiControl.CenterX := Value;
end;

procedure TOrbis01X.Set_CenterY(Value: Double);
begin
  FDelphiControl.CenterY := Value;
end;

procedure TOrbis01X.Set_ClearIfLHCNotFound(Value: WordBool);
begin
  FDelphiControl.ClearIfLHCNotFound := Value;
end;

procedure TOrbis01X.Set_Client(Value: WordBool);
begin
  FDelphiControl.Client := Value;
end;

procedure TOrbis01X.Set_Color(Value: OLE_COLOR);
begin
  FDelphiControl.Color := TColor(Value);
end;

procedure TOrbis01X.Set_Continual(Value: WordBool);
begin
  FDelphiControl.Continual := Value;
end;

procedure TOrbis01X.Set_Ctl3D(Value: WordBool);
begin
  FDelphiControl.Ctl3D := Value;
end;

procedure TOrbis01X.Set_DILEC(const Value: WideString);
begin
  FDelphiControl.DILEC := string(Value);
end;

procedure TOrbis01X.Set_Directory_Project(const Value: WideString);
begin
  FDelphiControl.Directory_Project := string(Value);
end;

procedure TOrbis01X.Set_Directory_Root(const Value: WideString);
begin
  FDelphiControl.Directory_Root := string(Value);
end;

procedure TOrbis01X.Set_Directory_Script(const Value: WideString);
begin
  FDelphiControl.Directory_Script := string(Value);
end;

procedure TOrbis01X.Set_Directory_Service(const Value: WideString);
begin
  FDelphiControl.Directory_Service := string(Value);
end;

procedure TOrbis01X.Set_Directory_Store(const Value: WideString);
begin
  FDelphiControl.Directory_Store := string(Value);
end;

procedure TOrbis01X.Set_DockSite(Value: WordBool);
begin
  FDelphiControl.DockSite := Value;
end;

procedure TOrbis01X.Set_DoubleBuffered(Value: WordBool);
begin
  FDelphiControl.DoubleBuffered := Value;
end;

procedure TOrbis01X.Set_DragCursor(Value: Smallint);
begin
  FDelphiControl.DragCursor := TCursor(Value);
end;

procedure TOrbis01X.Set_DragMode(Value: TxDragMode);
begin
  FDelphiControl.DragMode := TDragMode(Value);
end;

procedure TOrbis01X.Set_Enabled(Value: WordBool);
begin
  FDelphiControl.Enabled := Value;
end;

procedure TOrbis01X.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(FDelphiControl.Font, Value);
end;

procedure TOrbis01X.Set_FullRepaint(Value: WordBool);
begin
  FDelphiControl.FullRepaint := Value;
end;

procedure TOrbis01X.Set_JPGCompressionQuality(Value: Integer);
begin
  FDelphiControl.JPGCompressionQuality := Value;
end;

procedure TOrbis01X.Set_JPGGrayscale(Value: WordBool);
begin
  FDelphiControl.JPGGrayscale := Value;
end;

procedure TOrbis01X.Set_JPGPixelFormat(Value: Integer);
begin
  FDelphiControl.JPGPixelFormat := Value;
end;

procedure TOrbis01X.Set_LHC(Value: Integer);
begin
  FDelphiControl.LHC := Value;
end;

procedure TOrbis01X.Set_Locked(Value: WordBool);
begin
  FDelphiControl.Locked := Value;
end;

procedure TOrbis01X.Set_ManualProjectionChange(Value: WordBool);
begin
  FDelphiControl.ManualProjectionChange := Value;
end;

procedure TOrbis01X.Set_MonitorActive(Value: WordBool);
begin
  FDelphiControl.MonitorActive := Value;
end;

procedure TOrbis01X.Set_MonitorCoords(Value: WordBool);
begin
  FDelphiControl.MonitorCoords := Value;
end;

procedure TOrbis01X.Set_MonitorLHC(Value: WordBool);
begin
  FDelphiControl.MonitorLHC := Value;
end;

procedure TOrbis01X.Set_MonitorParcely(Value: WordBool);
begin
  FDelphiControl.MonitorParcely := Value;
end;

procedure TOrbis01X.Set_No_BDE(Value: WordBool);
begin
  FDelphiControl.No_BDE := Value;
end;

procedure TOrbis01X.Set_NoProtocol(Value: WordBool);
begin
  FDelphiControl.NoProtocol := Value;
end;

procedure TOrbis01X.Set_ODDELENI(Value: Integer);
begin
  FDelphiControl.ODDELENI := Value;
end;

procedure TOrbis01X.Set_par_CISLO(Value: Integer);
begin
  FDelphiControl.par_CISLO := Value;
end;

procedure TOrbis01X.Set_par_KATASTR(Value: Integer);
begin
  FDelphiControl.par_KATASTR := Value;
end;

procedure TOrbis01X.Set_par_PODLOMENI(Value: Integer);
begin
  FDelphiControl.par_PODLOMENI := Value;
end;

procedure TOrbis01X.Set_ParcelaSelected(Value: WordBool);
begin
  FDelphiControl.ParcelaSelected := Value;
end;

procedure TOrbis01X.Set_ParentBackground(Value: WordBool);
begin
  FDelphiControl.ParentBackground := Value;
end;

procedure TOrbis01X.Set_ParentColor(Value: WordBool);
begin
  FDelphiControl.ParentColor := Value;
end;

procedure TOrbis01X.Set_ParentCtl3D(Value: WordBool);
begin
  FDelphiControl.ParentCtl3D := Value;
end;

procedure TOrbis01X.Set_POROST(const Value: WideString);
begin
  FDelphiControl.POROST := string(Value);
end;

procedure TOrbis01X.Set_Scale(Value: Double);
begin
  FDelphiControl.Scale := Value;
end;

procedure TOrbis01X.Set_SelX(Value: Double);
begin
  FDelphiControl.SelX := Value;
end;

procedure TOrbis01X.Set_SelY(Value: Double);
begin
  FDelphiControl.SelY := Value;
end;

procedure TOrbis01X.Set_ShiftView(const Value: WideString);
begin
  FDelphiControl.ShiftView := string(Value);
end;

procedure TOrbis01X.Set_SKUPINA(const Value: WideString);
begin
  FDelphiControl.SKUPINA := string(Value);
end;

procedure TOrbis01X.Set_SkupinaSelected(Value: WordBool);
begin
  FDelphiControl.SkupinaSelected := Value;
end;

procedure TOrbis01X.Set_UseDockManager(Value: WordBool);
begin
  FDelphiControl.UseDockManager := Value;
end;

procedure TOrbis01X.Set_VerticalAlignment(Value: TxVerticalAlignment);
begin
  FDelphiControl.VerticalAlignment := TVerticalAlignment(Value);
end;

procedure TOrbis01X.Set_VirtualScale(Value: Double);
begin
  FDelphiControl.VirtualScale := Value;
end;

procedure TOrbis01X.Set_Visible(Value: WordBool);
begin
  FDelphiControl.Visible := Value;
end;

procedure TOrbis01X.SetDesignVisible(Value: WordBool);
begin
  FDelphiControl.SetDesignVisible(Value);
end;

procedure TOrbis01X.SetSubComponent(IsSubComponent: WordBool);
begin
  FDelphiControl.SetSubComponent(IsSubComponent);
end;

procedure TOrbis01X.SetupMaps;
begin
  FDelphiControl.SetupMaps;
end;

procedure TOrbis01X.SetupRasters;
begin
  FDelphiControl.SetupRasters;
end;

procedure TOrbis01X.SetupTyp;
begin
  FDelphiControl.SetupTyp;
end;

procedure TOrbis01X.SetupVrs;
begin
  FDelphiControl.SetupVrs;
end;

procedure TOrbis01X.ShowMap(const aMap: WideString);
begin
  FDelphiControl.ShowMap(aMap);
end;

procedure TOrbis01X.ShowTheForest(Pattern: WordBool);
begin
  FDelphiControl.ShowTheForest(Pattern);
end;

procedure TOrbis01X.ShowTheKatastr(Pattern: WordBool);
begin
  FDelphiControl.ShowTheKatastr(Pattern);
end;

procedure TOrbis01X.ShowTheSelect(Pattern: WordBool);
begin
  FDelphiControl.ShowTheSelect(Pattern);
end;

procedure TOrbis01X.StartSizeMove;
begin
  FDelphiControl.StartSizeMove;
end;

procedure TOrbis01X.TypChangeEvent;
begin
  if FEvents <> nil then FEvents.OnTypChange;
end;

procedure TOrbis01X.UserLHCAreaDialogEvent(NewObject: Boolean; Area: Double;
  var UserID, Color, Symbol, aresult: Integer);
var
  TempUserID: Integer;
  TempColor: Integer;
  TempSymbol: Integer;
  Temparesult: Integer;
begin
  TempUserID := Integer(UserID);
  TempColor := Integer(Color);
  TempSymbol := Integer(Symbol);
  Temparesult := Integer(aresult);
  if FEvents <> nil then FEvents.OnUserLHCAreaDialog(WordBool(NewObject), Area, TempUserID, TempColor, TempSymbol, Temparesult);
  UserID := Integer(TempUserID);
  Color := Integer(TempColor);
  Symbol := Integer(TempSymbol);
  aresult := Integer(Temparesult);
end;

procedure TOrbis01X.ViewAll;
begin
  FDelphiControl.ViewAll;
end;

procedure TOrbis01X.VrsChangeEvent;
begin
  if FEvents <> nil then FEvents.OnVrsChange;
end;

procedure TOrbis01X.ZoomIn;
begin
  FDelphiControl.ZoomIn;
end;

procedure TOrbis01X.ZoomOut;
begin
  FDelphiControl.ZoomOut;
end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TOrbis01X,
    TOrbis01,
    Class_Orbis01X,
    6,
    '',
    0,
    tmApartment);
end.
