unit HelelesPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  OrbisPanel,
// KERNEL
  Elements,
  e_Type,
  Tools,
  T_Recurs,
// GLIB
  g_Elems,
// DEVICE
  e_Device,
// Heleles
  T_HelHie;



type

  TDrawAreasRecursor = class(TRecursor)
  private
    FDevice: TCanvasDevice;
  public
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
  published
    property Device: TCanvasDevice read FDevice write FDevice;
  end;

  THelelesPanel = class(TOrbisPanel)
  private
    { Private declarations }
    FLHCDir: string;
    FLHC: string;
    FODDELENI: string;
    FDILEC: string;
    FPOROST: string;
    FSKUPINA: string;
    FTypPUPFL: integer;
    FHele     : THeleSkupina;
    function    GetSourceModel: TOwnerEntity;
    procedure   SetSourceModel(aValue: TOwnerEntity);
    function    GetSelectedObject: TRectEntity;
  protected
    procedure SetLHCDir(aDir: string);
    procedure SetLHC(aValue: string);
    procedure SetODDELENI(aValue: string);
    procedure SetDILEC(aValue: string);
    procedure SetPOROST(aValue: string);
    procedure SetSKUPINA(aValue: string);
  public
     FHierarchy: TEntity;
     procedure ClearHele;
     property  SourceModel: TOwnerEntity read GetSourceModel write SetSourceModel;
     property   SelectedObject: TRectEntity read GetSelectedObject;
     procedure Init; override;
     procedure Done; override;
  published
     procedure DrawSelected(aBrushColor, aBrushStyle, aPenMode: integer);
     procedure ReadForest;
     procedure ShowTheForest;
     procedure ReShowTheForest;
     procedure ShowAll;

     property   LHCDir: string read FLHCDir write SetLHCDir;
     property   LHC: string read FLHC write SetLHC;
     property   ODDELENI: string read FODDELENI write SetODDELENI;
     property   DILEC: string read FDILEC write SetDILEC;
     property   POROST: string read FPOROST write SetPOROST;
     property   SKUPINA: string read FSKUPINA write SetSKUPINA;
     property   TypPUPFL: integer read FTypPUPFL write FTypPUPFL;
 { prce s pohledy }
     procedure  SetAllByCoords;
 end;

procedure Register;

implementation

uses

// KERNEL
  E_Files,
  M_Orbis,
  u_String,
  Worlds,
  e_Reg,
// OIL
  T_SelectByName,
// GUI
  t_Intera,
// GLIB
  t_Grp,
// SPACE
  e_Space,
// 0TEMP
  e_DClass,

// Heleles
  T_HelSel;


procedure THelelesPanel.Init;
var
  S,SS: string;
begin
  inherited;
  S := ExtractFilePath(ParamStr(0));
  CheckBackSlash(S);
  SS := S + 'SysReg.Oil';
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else
    ScriptName := SS;
  SS := S + 'Model.Oil';

  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else
    ScriptName := SS;

  if FHele = nil then
     FHele:= THeleSkupina.Create;
end;



function  THelelesPanel.GetSourceModel: TOwnerEntity;
var
   S: string;
begin
  result:= nil;
  if World = nil then exit;
   S := 'SOURCE';
   result := TOwnerEntity(World.ObjectModel.FindElementName(S));
   if result = nil then
   begin
      result := TOwnerEntity.Create;
      result.Name := S;
      World.ObjectModel.AddElement(result);
   end;
end;


procedure THelelesPanel.ClearHele;
begin
  if FHele <> nil then
  begin
    FHele.Free;
    FHele:= THeleSkupina.Create;
  end;
end;



procedure THelelesPanel.SetSourceModel(aValue: TOwnerEntity);
var
   S: string;
   E: TElement;
begin
  if World = nil then exit;
  S := 'SOURCE';
  if aValue = nil then exit;
  if not(TElement(aValue) is TOwnerEntity) then exit;
  aValue.Name := S;
  E := World.ObjectModel.FindElementName(S);
  if E <> nil then World.FreeElement(E);
  World.ObjectModel.AddElement(aValue);
end;




procedure THelelesPanel.SetLHC(aValue: string);
var
   FM: TFileModel;
begin
  if World = nil then exit;
  if aValue = '' then
  begin
    FLHC:= '';
    exit;
  end;

  if aValue = FLHC then exit;

(*
  FM := TFileModel(SourceModel.FindElementName(aValue));

  if FM= nil then
  begin
    // pidn novho LHC
    ShowMessage('Nebyl zadn adres s grafickmi daty');
{
    NewLHC;
    if LHC <> aValue then
    begin
      FLHC:= '';
      Text := 'Nebyl naten poadovan LHC';
      ShowMessage('Nebyl naten poadovan LHC');
      MainForm.ed_LHC.Text:= '';
    end;
    exit;
}
  end;
*)
  FLHC := aValue;
{
  if MainForm.ed_LHC.Items.IndexOf(FLHC) < 0 then
    MainForm.ed_LHC.Items.Add(FLHC);
  MainForm.ed_LHC.Text := FLHC;
  MainForm.ed_Oddeleni.Items.Clear;
  for i := 0 to FM.LastIndex do
  begin
    MainForm.ed_Oddeleni.Items.Add(FM.Elements[i].Name);
  end;
  FODDELENI := '';
  ODDELENI := FM.Elements[0].Name;
}

end;




procedure THelelesPanel.SetODDELENI(aValue: string);
//var
//   E: TEntity;
//   i: integer;
begin
  if World = nil then exit;
   if aValue = FODDELENI then exit;
{
   MainForm.ed_Dilec.Items.Clear;
   MainForm.ed_Porost.Items.Clear;
   MainForm.ed_Skupina.Items.Clear;
   if (aValue <> '') and (MainForm.ed_ODDELENI.Items.IndexOf(aValue) < 0)then
   begin
      // Oddlen neexistuje
      FODDELENI := '';
      MainForm.ed_ODDELENI.Text := '';
      DILEC := '';
      POROST := '';
      SKUPINA := '';
      exit;
   end;
}
   FODDELENI := aValue;
{
   MainForm.ed_ODDELENI.Text := aValue;

   if aValue <> '' then
   begin
      E := TEntity(SourceModel.FindElementName(LHC));
      if E = nil then exit;
      E := TEntity(E.FindElementName(FODDELENI));
      if E = nil then exit;
      for i := 0 to E.LastIndex do
      begin
         MainForm.ed_Dilec.Items.Add(E.Elements[i].Name);
      end;
   end;
}
   DILEC := '';
   POROST := '';
   SKUPINA := '';
end;

procedure THelelesPanel.SetDILEC(aValue: string);
//var
//   E: TEntity;
//   i: integer;
begin
  if World = nil then exit;
   if aValue = FDILEC then exit;
{
   MainForm.ed_Porost.Items.Clear;
   MainForm.ed_Skupina.Items.Clear;
   if MainForm.ed_Dilec.Items.IndexOf(aValue) < 0 then
   begin
      FDILEC := '';
      MainForm.ed_Dilec.Text := '';
      // Oddlen neexistuje
      POROST := '';
      SKUPINA := '';
      exit;
   end;
}
   FDILEC := aValue;
{
   MainForm.ed_DILEC.Text := aValue;
   E := TEntity(SourceModel.FindElementName(LHC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(ODDELENI));
   if E = nil then exit;
   E := TEntity(E.FindElementName(FDILEC));
   if E = nil then exit;
   for i := 0 to E.LastIndex do
   begin
      MainForm.ed_Porost.Items.Add(E.Elements[i].Name);
   end;
}
   POROST := '';
   SKUPINA := '';
end;

procedure THelelesPanel.SetPOROST(aValue: string);
//var
//   E: TEntity;
//   i: integer;
begin
  if World = nil then exit;
   if aValue = FPOROST then exit;
{
   MainForm.ed_Skupina.Items.Clear;
   if MainForm.ed_Porost.Items.IndexOf(aValue) < 0 then
   begin
      FPOROST := '';
      MainForm.ed_Porost.Text := '';
      // Oddlen neexistuje
      SKUPINA := '';
      exit;
   end;
}
   FPOROST := aValue;
{
   MainForm.ed_Porost.Text := aValue;
   E := TEntity(SourceModel.FindElementName(LHC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(ODDELENI));
   if E = nil then exit;
   E := TEntity(E.FindElementName(DILEC));
   if E = nil then exit;
   E := TEntity(E.FindElementName(FPOROST));
   if E = nil then exit;
   for i := 0 to E.LastIndex do
   begin
      MainForm.ed_Skupina.Items.Add(BezMezer(E.Elements[i].Name));
   end;
}
   SKUPINA := '';
end;




procedure THelelesPanel.SetSKUPINA(aValue: string);
begin
  if World = nil then exit;
{
  TypPUPFL:= GetTypPUPFL(aValue);
   if aValue = FSKUPINA then exit;
   if MainForm.ed_Skupina.Items.IndexOf(aValue) < 0 then
   begin
      FSKUPINA := '';
      MainForm.ed_Skupina.Text := '';
      // Oddlen neexistuje
      exit;
   end;
}
   FSKUPINA := aValue;
//   MainForm.ed_Skupina.Text := aValue;
end;




procedure  THelelesPanel.SetLHCDir(aDir: string);
var
   DE,DDE: TDirectoryElement;
   S: TSelectByName;
   LHCS,SS,SSS: string;
   i,j,k, deltaK: integer;
   TMP: TOwnerEntity;
   EE: TEntity;
   Dety,DBH: TOwnerEntity;
   DC: TDatabaseClass;
   FM,FM1,FMLHC: TFileModel;
   GR: TGroupper;
   Krit: TPropsAndClass;
   Source: TOwnerEntity;
   SL: TStringList;
   aPomCr: TCursor;


 procedure BeforeExit;
 begin
   Screen.Cursor:= aPomCR;
{
   MinProgress := 0;
   MaxProgress := 0;
   Progress := 0;
   ProgressVisible := false;
   MainForm.ed_LHC.Enabled:= true;
}
 end;

begin
  if World = nil then exit;
  ClearHele;
  FLHCDir:= aDir;

(*
try
//   MainForm.ed_LHC.Enabled:= false;
   aPomCr:= Screen.Cursor;
   Screen.Cursor:= crHourGlass;
   FMLHC := nil;
   LHC := '';
{
   ProgressVisible := true;
   MinProgress := 0;
   MaxProgress := 10;
   Progress := 2;
}
   Text := 'Probh natn vybran sloky ... ';

   TMP := TOwnerEntity(World.ObjectModel.FindElementName('TMP'));
   if TMP = nil then
   begin
      TMP := TOwnerEntity.Create;
      TMP.Name := 'TMP';
      World.ObjectModel.AddElement(TMP);
   end;

//   Progress := 4;
   DE := TDirectoryElement.Create;
   LHCS := aDir;
   DE.FileName := aDir;

   Text := 'Probh vbr blok DET';
//   Progress := 5;

   S := TSelectByName.Create;
   MainTool.AddTool(S);
   S.CaseSensitive:= false;
   S.SelectedName:='DET.BLK';
   S.Input := DE;
   S.DoIt;
   S.Output.Name := 'Dety';

   if not (S.Output is TEntity) then
   begin
     S.Free;
     DE.Free;
     Text:= 'Chyba pi hledn adres DET.BLK';
//     MainForm.ed_LHC.Text:= '';
     BeforeExit;
     exit;
   end;

   if  TEntity(S.Output).Count < 1 then
   begin
     S.Free;
     DE.Free;
     Text:= 'Adres neobsahuje dn DET.BLK';
 //    MainForm.ed_LHC.Text:= '';
     BeforeExit;
     exit;
   end;

   TMP.AddElement(DE);
   TMP.NextElement := S.Output;
   Dety := TOwnerEntity(S.Output);
   S.Free;
   Text := 'Probh vbr DBF tabulek ...';
   DBH := TOwnerEntity.Create;
   DBH.Name := 'DBH';
   TMP.AddElement(DBH);
{
   Progress := 0;

   MinProgress := 0;
   MaxProgress := Dety.LastIndex;
}
   for i := 0 to Dety.LastIndex do
   begin
//      Progress := i;
      if not (Dety.Elements[i] is TDirectoryElement) then Continue;
      DDE := TDirectoryElement(Dety.Elements[i]);
      DC := TDatabaseClass.Create;
      DC.Name := 'P0110_DBF';
      DC.DataSourceType := dstTable;
      DC.DataSourcePath := DDE.FileName;
      DC.DataSource := 'p0110.dbf';
      DC.AdressField := 'CISLO';
      DC.NameField := 'CISLO';
      EE := TOwnerEntity.Create;
      EE.Name := DDE.FilePath;
      DBH.NextElement := EE;
      FM := TFileModel.Create;
      FM.Name := DDE.FilePath;
      FM.FileName := DDE.FileName;
      EE.NextElement := FM;
      EE.NextElement := DC;
      Text := 'Vybrm tabulku ' + DDE.FileName;
   end;
   TMP.FreeElement(DE);
   TMP.FreeElement(Dety);
   Text := 'Vbr tabulek ukonen';
   // sestavovn vbru do ENT


   EE := TEntity.Create;
   //vytvoen kritria pro tvorbu skupin dle katastru
   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'LHC';
   KRIT.OwnerClassName := 'TFileModel';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'ODDELENI';
   KRIT.OwnerClassName := 'TFileModel';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'DILEC';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'POROST';
   EE.NextElement := Krit;

   KRIT := TPropsAndClass.Create;
   KRIT.NextName := 'SKUPINA';
   EE.NextElement := Krit;

   //Vytvoen grupovacho nstroje
   GR := TGroupper.Create;
   GR.Criterion := EE;
   GR.OwnerClass := 'TOwnerEntity';
   //GR.NextAssigment='BlockDir=BlockDir'
   GR.DoItEmpty := true;
   SS := '/' + IntToStr(DBH.Count)+')';
   Source := SourceModel;
   SL := TStringList.Create;
//   Progress := 0;
   SSS := '';
   for i := 0 to DBH.LastIndex do
   begin
      EE := TEntity(DBH.Elements[i]);
      DC := TDatabaseClass(EE.FindElementClass(TDatabaseClass));
      if DC = nil then continue;
      if DC.Count = 0 then Continue;
      FM := TFileModel(EE.FindElementClass(TFileModel));
      Text := 'Analza ' +  FM.Path + ' (' + IntToStr(i+1) + SS;
      GR.Output := FM;
      k := DC.Count - 1;
{
      MinProgress := 0;
      MaxProgress := k;
      Progress := 0;
}
      DeltaK := 0;
      for j := 0 to k do
      begin
         GR.Input := DC.Elements[j];
         GR.DoIt;
         Inc(DeltaK);
         if DeltaK >= (k div 20) then
         begin
//            MainForm.ProgressBar.Position := j;
            DeltaK := 0;
         end;
      end;
      // zaazen do SOURCE
      FM1 := TFileModel(FM.FindElementClass(TFileModel));
      FMLHC := TFileModel(Source.FindElementName(FM1.Name));
      if FMLHC = nil then
      begin
         FMLHC := FM1;
         Source.AddElement(FMLHC);
         FMLHC.FileName := LHCS;
         j := SL.Add(FMLHC.Name);
         SL.Objects[j] := FMLHC;
         SSS := SSS + FMLHC.Name + ';';
//         MainForm.ed_LHC.Items.Add(FMLHC.Name);
      end
      else
      begin
         j := SL.IndexOf(FMLHC.Name);
         if j < 0 then
         begin
           ShowMessage('LHC slo '+ FMLHC.Name + ' je ji zmapovno');
{
            if YesNoDialog('LHC slo '+ FMLHC.Name + ' je ji zmapovno. Pejete si jej skuten nast znovu ?') then
            begin
               Source.FreeElement(FMLHC);
               FMLHC := FM1;
               Source.AddElement(FMLHC);
               FMLHC.FileName := LHCS;
               J := SL.Add(FMLHC.Name);
               SL.Objects[j] := FMLHC;
               SSS := SSS + FMLHC.Name + ';';
            end
            else SL.Add(FMLHC.Name); // Objects je nil ... bude peskakovno
}
         end
         else
         begin
            if SL.Objects[j]= nil then continue;
         end;
      end;
      for j := 0 to FM1.LastIndex do
      begin
         TFileModel(FM1.Elements[j]).FileName := FM.FileName;
         if i > 0 then FMLHC.AddElement(FM1.Elements[j]);
      end;
   end;
   SL.Free;
   if SSS = '' then Text := 'Analza LHC skonena, nepidno dn nov LHC'
               else Text := 'Analza LHC skonena, pidno LHC '+ SSS;
   if FMLHC <> nil then
      LHC := FMLHC.Name;
   TMP.FreeElement(DBH);

finally
  BeforeExit
end;
*)
end;



procedure THeleLesPanel.ReadForest;
var
   FM: TFileModel;
   E: TEntity;
   TH: THeleNacti;
begin
  if FLHCDir = '' then
     exit;
  TH := THeleNacti.Create;
  TH.Directory := FLHCDir;
  TH.DoIt;
  TH.Free;
end;


procedure THelelesPanel.ShowTheForest;
var
   E: TEntity;
   RE: TRectEntity;
   R: TDoubleRect;
   ALhc,AOddeleni,ADilec,APorost,ASkupina:string;

 begin
  if World = nil then exit;
  Busy:= true;
  try
      ClearHele;
      { posouzen, zda oekvan data jsou ji naten }
      ALhc:=lHC;
      AOddeleni:=Oddeleni;
      ADilec:=Dilec;
      APorost:=Porost;
      ASkupina:=Skupina;
      try
      if (FHierarchy = nil) or  (FHierarchy.Count = 0) then
         ReadForest;
      except
         FHierarchy:= nil;
         ReadForest;
      end;
      Lhc      :=AlHC;
      Oddeleni :=AOddeleni;
      Dilec    :=ADilec;
      Porost   :=APorost;
      Skupina  :=ASkupina;
      E        :=TEntity(World.ObjectModel.FindElementName('DATA'));
      if E = nil then
      begin
        ShowMessage('Nen nalezen objekt DATA');
        exit; {!!!!!!!!!!!!}

      end;
      FHierarchy := TEntity(E.FindElementName('HIERARCHY'));
      if FHierarchy = nil then
      begin
        ShowMessage('Nen nalezen objekt HIERARCHY');
        exit; {!!!!!!!!!!!!}
      end;

      RE:= GetSelectedObject;

      if RE = nil then
      begin
        ShowMessage('Lesnick objekt ' +
                    LHC + ' ' + ODDELENI + ' ' + DILEC + ' ' + POROST + ' ' + SKUPINA + #13 + #10 +
                    'nen v map nalezen');
        exit; {!!!!!!!!!!!!}
      end;

      R.Minx := RE.Minx;
      R.Maxx := RE.Maxx;
      R.Miny := RE.Miny;
      R.Maxy := RE.Maxy;
      PrepareMap(ActualMap);
      MainTool.Projection.ModelView:= R;
      // ReView doplnil Malik;
  finally
    Busy:= False
  end
end;



procedure THelelesPanel.ReShowTheForest;
var
   E: TEntity;
   RE: TRectEntity;
   R: TDoubleRect;
begin
  if World = nil then exit;
  Busy:= true;
  try
      E := TEntity(World.ObjectModel.FindElementName('DATA'));
      if E = nil then
      begin
        ShowMessage('Nen nalezen objekt DATA');
        exit; {!!!!!!!!!!!!}
      end;

      FHierarchy := TEntity(E.FindElementName('HIERARCHY'));
      if FHierarchy = nil then
      begin
        ShowMessage('Nen nalezen objekt HIERARCHY');
        exit; {!!!!!!!!!!!!}
      end;

      if FHierarchy.Count = 0 then
      begin
        ShowMessage('Objekt HIERARCHY je przdn');
        exit; {!!!!!!!!!!!!}
      end;

      RE:= GetSelectedObject;

      if RE = nil then
      begin
        ShowMessage('Lesnick objekt ' +
                    LHC + ' ' + ODDELENI + ' ' + DILEC + ' ' + POROST + ' ' + SKUPINA + #13 + #10 +
                    'nen v map nalezen');
        exit; {!!!!!!!!!!!!}
      end;

      R.Minx := RE.Minx;
      R.Maxx := RE.Maxx;
      R.Miny := RE.Miny;
      R.Maxy := RE.Maxy;

      PrepareMap(ActualMap);
      MainTool.Projection.ModelView:= R;
     // ReView   odtranil malik
  finally
    Busy:= False
  end
end;



procedure THelelesPanel.ShowAll;
var
   E: TEntity;
   RE: TRectEntity;
   R: TDoubleRect;
begin
  if World = nil then exit;
  ClearHele;

  E := TEntity(World.ObjectModel.FindElementName('DATA'));
  if E = nil then exit; {!!!!!!!!!!!!}
  RE := TRectEntity(E.FindElementName('HIERARCHY'));
  if not (TElement(RE) is TRectEntity) then
         exit;

  R.Minx := RE.Minx;
  R.Maxx := RE.Maxx;
  R.Miny := RE.Miny;
  R.Maxy := RE.Maxy;

  PrepareMap(ActualMap);
  MainTool.Projection.ModelView:= R;
  ReView;
end;




procedure  THelelesPanel.SetAllByCoords;
begin
  if World = nil then exit;
  if Busy then Exit;
  if FHele = nil then exit;
  if FHele.Busy then exit;

  FHele.Input:= FHierarchy;
  FHele.X:= WorldX;
  FHele.Y:= WorldY;
  FHele.Found:= false;
  FHele.DoIt;

  if FHele.Found then
  begin
    LHC:= FHele.LHC;
    Oddeleni:= FHele.ODD;
    Dilec:= FHele.DIL;
    Porost:= FHele.POR;
    Skupina:= FHele.PSK;
  end
  else
  begin
    LHC:= '';
    Oddeleni:= '';
    Dilec:= '';
    Porost:= '';
    Skupina:= '';
  end

end;



function THeleLesPanel.GetSelectedObject: TRectEntity;
var
   THH: THeleHier;
begin
  Result:= nil;

  if FHierarchy = nil then
     Exit;
  THH := THeleHier.Create;
  THH.Input := FHierarchy;
  THH.LHC := LHC;
  THH.ODD := ODDELENI;
  THH.DIL := DILEC;
  THH.POR := POROST;
  THH.PSK := SKUPINA;
  THH.DoIt;
  result  := TRectEntity(THH.Output);
  THH.Free;
end;

{
TBrushStyle = (bsSolid, bsClear, bsHorizontal, bsVertical, bsFDiagonal, bsBDiagonal, bsCross, bsDiagCross);
TPenMode = (pmBlack, pmWhite, pmNop, pmNot, pmCopy, pmNotCopy, pmMergePenNot, pmMaskPenNot, pmMergeNotPen, pmMaskNotPen, pmMerge, pmNotMerge, pmMask, pmNotMask, pmXor, pmNotXor);

}
procedure THelelesPanel.DrawSelected(aBrushColor, aBrushStyle, aPenMode: integer);
var
  aDevice: TCanvasDevice;
  aDT: TDrawAreasRecursor;
begin
// vykresli plochy v hierarchii
  aDevice:= TCanvasDevice(TInteractiveTool(ImageTool).Device);
  aDevice.Brush.Color:= aBrushColor;
  aDevice.Brush.Style:= TBrushStyle(aBrushStyle);
  aDevice.Pen.Mode:= TPenMode(aPenMode);
  aDT:= TDrawAreasRecursor.Create;
  aDT.Input:= SelectedObject;
  aDT.Device:= aDevice;
  aDT.DoIt;
  aDT.Free;
  ImageTool.PostMsg(tm_repaint, ImageTool, nil, False);
end;


procedure THelelesPanel.Done;
begin
  if FHele <> nil then
  begin
    FHele.Free;
    FHele:= nil;
  end;
  FHierarchy:= nil;
  inherited;
end;



{ TDrawAreasRecursor }

procedure TDrawAreasRecursor.Process(Element: TElement);
var
  NPlocha: TAreaElement;
  Simple: Boolean;
begin
  NPlocha:= nil;
  Simple:= False;
  if not (Element is TAreaElement) then
     Exit;

  if Element is TPolyLineAreaElement then
    NPlocha:= TPolyLineAreaElement(Element).CreateAreaElement
  else
  begin
    NPlocha:= TAreaElement(Element);
    Simple:= True;
  end;

  Device.PolyPolygon(NPlocha);

  if not Simple then
     NPlocha.Free;
end;


function TDrawAreasRecursor.QGoInside(Element: TElement): boolean;
begin
  result:= not(Element is TAreaElement)
end;


function TDrawAreasRecursor.QProcessBefore(Element: TElement): boolean;
begin
  result:= (Element is TAreaElement)
end;


procedure Register;
begin
  RegisterComponents('Orbis', [THelelesPanel]);
end;

end.
