unit F_seldir;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, FileCtrl,
  Elements, Tools;


type
  Tf_SelectDir = class(TForm)
    b_OK: TBitBtn;
    b_Cancel: TBitBtn;
    Directory: TDirectoryListBox;
    Drive: TDriveComboBox;
    Bevel1: TBevel;
    NewDir: TBitBtn;
    procedure NewDirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


TSelectDirDialog = class(TTool)
private
  FDirectory: string;
  FCaption: string;
  function GetDirectory: string;
public
  procedure DoIt; override;
published
  property Directory: string read GetDirectory write FDirectory;
  property Caption: string read FCaption write FCaption;
end;


implementation
{$R *.DFM}

uses
  Dialogs,
  SysUtils,
  e_Class,
  F_names,
  U_String;




function TSelectDirDialog.GetDirectory: string;
begin
  result:= FDirectory
end;



procedure Tf_SelectDir.NewDirClick(Sender: TObject);
var
  aDir: string;
  NameDlg: TF_Name;
begin
  Application.CreateForm(TF_Name, NameDlg);
  try
    aDir:= Directory.Directory;
    NameDlg.Caption := aDir;
    NameDlg.Left := Left;
    NameDlg.Top := Top;
    NameDlg.ShowModal;
    if NameDlg.ModalResult = mrOK then
    begin
       MkDir(AddBackSlash(aDir) + NameDlg.ed_Name.Text);
       Directory.UpDate
    end;
  except
    on E:Exception do
    begin
      ShowMessage(E.Message + ': ' + AddBackSlash(aDir) + NameDlg.ed_Name.Text);
      Screen.Cursor:= crDefault;
    end;
  end;
  NameDlg.Free;
end;



procedure  TSelectDirDialog.DoIt;
var
   DD: TF_SelectDir;
begin
   Application.CreateForm(TF_SelectDir, DD);
   try
     if FCaption <> '' then
        DD.Caption:= FCaption;

     DD.Directory.Directory:= FDirectory;
     if DD.ShowModal = mrOK then
     begin
        FDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + FDirectory);
       Screen.Cursor:= crDefault;
       FDirectory:= ''
     end;
   end;
   DD.Free;
end;


INITIALIZATION
  RegisterOrbisClass(TSelectDirDialog);
END.
