unit T_maintl;
{
[Unit_Description]
Description=Pedek hlavnho nstroje
Admin=Petr
TechTopic=Tools
Topic=Aplikace
Version=1.0
}

interface
uses
  { test }


  WinTypes,
  Elements,
  //T_Recurs,
  Tools;




type

TBaseOptions = class(TOwnerEntity);

TOldMainTool = class(TTechnology)
private
  FCancel: boolean;
protected
  function  GetParamWithExt(aExt: string): string;
{ nalezne v pkazovm dku parametr se zadanou pponou }

  procedure ReadParamsFromIni; virtual;
  procedure WriteParamsToIni; virtual;

  procedure ReadParams; virtual;
  function  GetIniFileName: string; virtual;
  function  GetWorkingDirectory: string; virtual;
  procedure LoadCursors; virtual;

  function  GetOptions: TBaseOptions; virtual; abstract;
  procedure SetOptions(aValue: TBaseOptions); virtual; abstract;

  procedure SetIniString(aGroup, aParam: string; aValue: string);
  procedure SetIniBoolean(aGroup, aParam: string; aValue: Boolean);
  procedure SetIniInteger(aGroup, aParam: string; aValue: integer);
  function  GetIniString(aGroup, aParam: string; aDef: string): string;
  function  GetIniBoolean(aGroup, aParam: string; aDef: boolean): boolean;
  function  GetIniInteger(aGroup, aParam: string; aDef: integer): integer;

public
  procedure  DoIt; override;
  procedure  on_tm_QuitTask; override;
  procedure  On_tm_About(var Handled: boolean); virtual;
  procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
  procedure  AddWorkTools; virtual;
  function   OptionPropString(aPropName: string): string;
  function   OptionBooleanProp(aPropName: string): boolean;
  property   CancelProcess: boolean read FCancel write FCancel;
  property   WorkingDirectory: string read GetWorkingDirectory;
  property   IniFileName: string read GetIniFileName;
  property   Options: TBaseOptions read GetOptions write SetOptions;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs,  SysUtils, Graphics,
  WinProcs,

  _IniFile,
  Props,
  M_Orbis,
  M_Proj,
//@  F_Main,
  F_Start,
  //g_Elems,
  u_Cursor,
  U_Props,
  u_String,
  Worlds;


function  TOldMainTool.GetParamWithExt(aExt: string): string;
{ nalezne v pkazovm dku parametr se zadanou pponou }
var
  I: integer;
begin
  aExt:= upperCase(aExt);
  result:= '';
  if ParamCount < 1 then exit;
  for I:= 1 to ParamCount do
  begin
    if upperCase(ExtractFileExt(ParamStr(I))) = aExt then
    begin
      result:= ParamStr(I);
      break
    end
  end
end;



function  TOldMainTool.GetIniFileName: string;
begin
  result:= GetParamWithExt('.INI');
  if (result <> '') and FileExists(result) then exit;
  result := WorkingDirectory + ChangeFileExt(ExtractFileName(ParamStr(0)), '.INI');
end;


function  TOldMainTool.GetWorkingDirectory: string;
var
   S: string;
begin
   S := ExtractFilePath(ParamStr(0));
   result := CheckBackSlash(S);
end;


procedure TOldMainTool.SetIniString(aGroup, aParam: string; aValue: string);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteString(aGroup, aParam, aValue);
   IniFile.Free;
end;

procedure TOldMainTool.SetIniBoolean(aGroup, aParam: string; aValue: Boolean);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteBool(aGroup, aParam, aValue);
   IniFile.Free;
end;

procedure TOldMainTool.SetIniInteger(aGroup, aParam: string; aValue: integer);
var
  IniFile: TRealIniFile;
begin
   IniFile:= TRealIniFile.Create(IniFileName);
   IniFile.WriteInteger(aGroup, aParam, aValue);
   IniFile.Free;
end;


function  TOldMainTool.GetIniString(aGroup, aParam: string; aDef: string): string;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadString(aGroup, aParam, aDef);
  IniFile.Free
end;

function  TOldMainTool.GetIniBoolean(aGroup, aParam: string; aDef: boolean): boolean;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadBool(aGroup, aParam, aDef);
  IniFile.Free
end;

function  TOldMainTool.GetIniInteger(aGroup, aParam: string; aDef: integer): integer;
var
  IniFile: TRealIniFile;
begin
  IniFile:= TRealIniFile.Create(IniFileName);
  result:= IniFile.ReadInteger(aGroup, aParam, aDef);
  IniFile.Free
end;



procedure TOldMainTool.LoadCursors;
begin
   LoadUserCursors;
end;



procedure TOldMainTool.AddWorkTools;
begin
end;


procedure TOldMainTool.ReadParamsFromIni;
var
  IniFile: TRealIniFile;
  I: longInt;
begin
  if Options <> nil then
  begin
    IniFile:= TRealIniFile.Create(IniFileName);
    for I:= GetPropIndex(Options,'LastIndex')+1 to GetPropCount(Options)-1 do
    begin
      SetPropString(Options, I,
                    IniFile.ReadString
                    ('Options', GetPropName(Options, I), GetPropString(Options, I)));
    end;
    IniFile.Free;
  end
end;


procedure TOldMainTool.WriteParamsToIni;
var
  IniFile: TRealIniFile;
  I: longInt;
begin
  if Options <> nil then
  begin
    IniFile:= TRealIniFile.Create(IniFileName);
    for I:= GetPropIndex(Options,'LastIndex')+1 to GetPropCount(Options)-1 do
    begin
      IniFile.WriteString
      ('Options', GetPropName(Options, I), GetPropString(Options, I));
    end;
    IniFile.Free;
  end
end;




procedure TOldMainTool.ReadParams;
begin
  {
  Parameters:
   1.ProjectFile
   2.ApplicationHandle
   3.Other
  }
  (*
  if ParamCount > 0 then
  begin
     Project := TRuntimeProject.Create(ParamStr(1));
  end;
  if ParamCount > 1 then
  begin
     Project.MainHandle := StrToInt(ParamStr(2));
  end;
  if ParamCount > 2 then
  begin
     { Other..... }
  end;
  *)
end;





procedure TOldMainTool.DoIt;
begin
   LoadCursors;
   ReadParams;
   AddWorkTools;
end;


procedure  TOldMainTool.on_tm_QuitTask;
begin
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
        try
           {
           PostAppMessage(Project.MainHandle, TProjectWorld(World).WM_MODUL_END, 0, 0)
           }
        except
        end;
        Application.Terminate;
      end;
   end;
end;



procedure  TOldMainTool.On_tm_About(var Handled: boolean);
begin
  F_StartForm.Visible := true;
  F_StartForm.Timer1.Enabled := true
end;


function   TOldMainTool.OptionPropString(aPropName: string): string;
begin
  result:= '';
  if Options = nil then exit;
  result:= GetPropStringByName(Options, aPropName)
end;

function   TOldMainTool.OptionBooleanProp(aPropName: string): boolean;
var
   S: string;
begin
   result:= false;
   S := OptionPropString(aPropName);
   if S = '' then exit;
   try
      result := UpperCase(S[1])='T';
   except
      result := false;
   end;
end;


procedure   TOldMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_About: On_tm_About(Handled);
   end;
end;



end.
