unit F_Test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  OrbisPanel,
  StdCtrls, Menus, ImagePanel;

type
  TForm1 = class(TForm)
    odOIL: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    btMapa: TButton;
    btUkazMapu: TButton;
    edScale: TEdit;
    btLoadTools: TButton;
    btDoTool: TButton;
    cbTools: TComboBox;
    lbLayers: TListBox;
    lbMaps: TListBox;
    Panel2: TPanel;
    Panel3: TPanel;
    lbX: TLabel;
    lbY: TLabel;
    Button3: TButton;
    Button4: TButton;
    btLayPan: TButton;
    lbLength: TLabel;
    lbArea: TLabel;
    btOPRL: TButton;
    OrbisPanel1: TOrbisPanel;
    procedure FormShow(Sender: TObject);
    procedure btMapaClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btUkazMapuClick(Sender: TObject);
    procedure OrbisPanel1Resize(Sender: TObject);
    procedure edScaleDblClick(Sender: TObject);
    procedure btLoadToolsClick(Sender: TObject);
    procedure btDoToolClick(Sender: TObject);
    procedure OrbisPanel1ToolDone(aToolName: String);
    procedure cbToolsChange(Sender: TObject);
    procedure OrbisPanel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OrbisPanel1Select;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ImageStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure btLayPanClick(Sender: TObject);
    procedure OrbisPanel1ToolChange(aToolName: String);
    procedure btOPRLClick(Sender: TObject);
  private
    { Private declarations }
    DifX, DifY: integer;
    StartDrag: Boolean;
  public
    { Public declarations }
    Spusten: boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
// KERNEL
  U_String;
(*
  Elements,

  T_ImgTol,
  E_IScrpt,
// MAPPER
  I_GText,
  E_Text;

//  F_LayPan
*)


procedure TForm1.FormShow(Sender: TObject);
begin
//  cbTools.Items.CommaText:= OrbisPanel1.Tools;
//cbTools.ItemIndex:= cbTools.Items.Count-1
end;

procedure TForm1.btMapaClick(Sender: TObject);
begin
  OrbisPanel1.ClearMap('Zakl');
  OrbisPanel1.AddToMap('Zakl', 'Rastry');
  OrbisPanel1.AddToMap('Zakl', 'Plochy');
  OrbisPanel1.AddToMap('Zakl', 'Cary');
  lbMaps.Items.CommaText:= OrbisPanel1.Maps
end;


procedure TForm1.FormHide(Sender: TObject);
begin
  OrbisPanel1.Done;
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
  OrbisPanel1.ExploreWorld
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  OrbisPanel1.AddToLayer('Rastry', 'RAS', 'G:\DataTax\TOPOLHK\Ukazka\R1.RAS');
  OrbisPanel1.AddToLayer('Plochy', 'ARE', 'G:\DataTax\TOPOLHK\Ukazka\DET.BLK');
  OrbisPanel1.AddToLayer('Cary', 'LIN', 'G:\DataTax\TOPOLHK\Ukazka\DET.BLK');
//  OrbisPanel1.AddToLayer('Cary', 'ARE', 'F:\SHP\EUROPE\Eu_cntry.shp');
//  OrbisPanel1.AddToLayer('Cary', 'RAS', 'F:\LETECTVO\ujezd.bmp');
//  OrbisPanel1.AddToLayer('Cary', 'RAS', 'F:\LETECTVO\smo_Cast.bmp');
  lbLayers.Items.CommaText:= OrbisPanel1.Layers;
  OrbisPanel1.VirtualScale:= 100;
end;

procedure TForm1.btUkazMapuClick(Sender: TObject);
begin
  OrbisPanel1.ActualMap:= 'Zakl';
  OrbisPanel1.ShowMap('');
  edScale.Text:= DoubleToStr(OrbisPanel1.ViewScale, 10, 0);

//  Image.Transparent:= false;
//  Image.Canvas.Draw(2, 2, OrbisPanel1.Image.Picture.Bitmap);
end;

procedure TForm1.OrbisPanel1Resize(Sender: TObject);
begin
  inherited;
  edScale.Text:= DoubleToStr(OrbisPanel1.ViewScale, 10, 0)
end;

procedure TForm1.edScaleDblClick(Sender: TObject);
begin
  OrbisPanel1.ViewScale:= StrToInt(EdScale.Text);
  OrbisPanel1.Review;
end;

procedure TForm1.btLoadToolsClick(Sender: TObject);
begin
  OrbisPanel1.LoadTools('e:\orbis32\exe\TestPKG');
end;

procedure TForm1.btDoToolClick(Sender: TObject);
begin
  OrbisPanel1.CreateTool('TTool', 'N1');
  OrbisPanel1.ExecuteTool('N1');
end;

procedure TForm1.OrbisPanel1ToolDone(aToolName: String);
begin
  ShowMessage('Skonil nstroj ' + aToolName);
end;


procedure TForm1.cbToolsChange(Sender: TObject);
begin
  if Length(cbTools.Text) > 4 then
     OrbisPanel1.ActiveTool:= cbTools.Text;
end;

procedure TForm1.OrbisPanel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  lbX.Caption:= FloatToStr(OrbisPanel1.WorldX);
  lbY.Caption:= FloatToStr(OrbisPanel1.WorldY);
//  OrbisPanel1.PostMouseEvent(tm_MouseMove, Tool, mbLeft, Shift, X, Y, IsActive);
end;


procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  'b': Beep;
  't': OrbisPanel1.ActiveTool:= 'TDrawLineTool';
  'e': OrbisPanel1.ActiveTool:= 'TEditor';
  'l': OrbisPanel1.ActiveTool:= 'TMeasureLengthTool';
  'p': OrbisPanel1.ActiveTool:= 'TMeasureAreaTool';
  's': OrbisPanel1.ActiveTool:= 'TShiftImage'
  end;

  cbTools.Items.CommaText:= OrbisPanel1.Tools;
  cbTools.Text:= OrbisPanel1.ActiveTool
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  vk_F5: begin
           if Shift = [] then
           begin
             OrbisPanel1.ViewScale:= OrbisPanel1.ViewScale/2;
             OrbisPanel1.Review;
             edScale.Text:= DoubleToStr(OrbisPanel1.ViewScale, 10, 0)
           end
           else if Shift = [ssCtrl] then
           begin
             OrbisPanel1.ViewScale:= 2*OrbisPanel1.ViewScale/3;
             OrbisPanel1.Review;
             edScale.Text:= DoubleToStr(OrbisPanel1.ViewScale, 10, 0)
           end;
         end;
  vk_F6: begin
           OrbisPanel1.ViewScale:= OrbisPanel1.ViewScale*2;
           OrbisPanel1.Review;
           edScale.Text:= DoubleToStr(OrbisPanel1.ViewScale, 10, 0)
         end;
  vk_Left: begin
             OrbisPanel1.CenterX:= OrbisPanel1.ViewMinX;
             OrbisPanel1.Review;
           end;
  vk_Right: begin
             OrbisPanel1.CenterX:= OrbisPanel1.ViewMaxX;
             OrbisPanel1.Review;
           end;
  vk_Up: begin
             OrbisPanel1.CenterY:= OrbisPanel1.ViewMaxY;
             OrbisPanel1.Review;
           end;
  vk_Down: begin
             OrbisPanel1.CenterY:= OrbisPanel1.ViewMinY;
             OrbisPanel1.Review;
           end;
  else
    OrbisPanel1.SetUserKey(Key, Shift)
  end
end;

procedure TForm1.OrbisPanel1Select;
var
  Pom: string;
begin
  if OrbisPanel1.IsSelObj then
  begin
    Pom:= OrbisPanel1.GetObjectProperty('cntry_name');
    ShowMessage(Pom)
  end;
end;



procedure TForm1.Button3Click(Sender: TObject);
{
var
  IScr: TInterpretScript;
  IGTI: TGeneralTextInterpret;
}
begin
(*
  IScr:= TImageToolManager(OrbisPanel1.ImageTool).InterpretScript;
  IScr.PassesCount:= 2;
  IScr.Pass:= 1;

  ISCr.FindClassName:= 'TAreaElement';
  if IScr.ActualClassName <> '' then;
  if ISCR.IsError then
     IScr.NewClassName:= 'TAreaElement';

  IScr.ActualInterpretName:= 'TGeneralTextInterpret';
{
  IGTI:= TGeneralTextInterpret(IScr.ActualInterpret);

  IGTI.ValColor:= 0;
  IGTI.ValFont:= 'Arial';
  IGTI.ValHeight:= 0.005;
  IGTI.PropText:= 'CNTRY_NAME';
  IGTI.PropX:= 'X';
  IGTI.PropY:= 'Y';
  IGTI.ProcessClassName:= 'TAreaElement';
}

  IGTI:= TGeneralTextInterpret(IScr.ActualInterpret);

  IGTI.Color:= 0;
  IGTI.ValFont:= 'Arial';
  IGTI.ValHeight:= 0.005;
  IGTI.AbsSize:= true;
  IGTI.PropText:= 'CNTRY_NAME';
  IGTI.PropX:= 'CenterX';
  IGTI.PropY:= 'CenterY';
  IGTI.ProcessClassName:= 'TAreaElement';
*)
end;


procedure TForm1.Button4Click(Sender: TObject);
(*
var

  IScr: TInterpretScript;
  IGTI: TGeneralFormatedTextBlockInterpret;
  TextBlock: TFormatedTextBlock;
  ParagraphStyle: TParagraphStyle;
  Parag: TParagraph;
  FT: TVariableText;
*)
begin
(*
  IScr:= TImageToolManager(OrbisPanel1.ImageTool).InterpretScript;
  IScr.PassesCount:= 2;
  IScr.Pass:= 1;

  ISCr.FindClassName:= 'TAreaElement';
  if IScr.ActualClassName <> '' then;
  if ISCR.IsError then
    IScr.NewClassName:= 'TAreaElement';

  IScr.ActualInterpretName:= 'TGeneralFormatedTextBlockInterpret';
  IGTI:= TGeneralFormatedTextBlockInterpret(IScr.ActualInterpret);
  TextBlock:= IGTI.TextBlock;
  TextBlock.NewStyle:= TRUE;
  ParagraphStyle:= TextBlock.ParagraphStyle;
  ParagraphStyle.FontName:= 'Arial';
  ParagraphStyle.TextHeight:= 0.001;
  ParagraphStyle.LineHeight:= 0.0015;
  ParagraphStyle.TextColor:= 0;
//  ;IGTI.ValX='0'
//  ;IGTI.ValY='0'
  IGTI.PropX:= 'CenterX';
  IGTI.PropY:= 'CenterY';

  IGTI.ProcessClassName:= 'TAreaElement';
  TextBlock.NextParagraphName:= '0';

  FT:= TVariableText.Create;
  FT.Name:= 'CNTRY_NAME';
  TextBlock.ActualParagraph.Text:= 'STATE: ';
  TextBlock.ActualParagraph.NextText:= FT;

  TextBlock.NextParagraphName:= '0';

  FT:= TVariableText.Create;
  FT.Name:= 'AREA';
  TextBlock.ActualParagraph.Text:= 'AREA: ';
  TextBlock.ActualParagraph.NextText:= FT;
*)
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  aWidth, aHeight: integer;
begin
{
  Image.Left:= 0;
  Image.Top:= 0;
  Image.Width:= OrbisPanel1.Width + 4;
  Image.Height:= OrbisPanel1.Height + 4;

  aWidth:= Image.Canvas.ClipRect.Right;
  aHeight:= Image.Canvas.ClipRect.Bottom;
  Image.Canvas.MoveTo(1, 1);
  Image.Canvas.LineTo(aWidth-1, 1);
  Image.Canvas.LineTo(aWidth-1, aHeight-1);
  Image.Canvas.LineTo(1, aHeight-1);
  Image.Canvas.LineTo(1, 1);
  Image.Canvas.LineTo(aWidth-1, aHeight-1);
  Image.Canvas.LineTo(1, aHeight-1);
  Image.Canvas.LineTo(aWidth-1, 1);
}
  OrbisPanel1.Init;
  cbTools.Items.CommaText:= OrbisPanel1.Tools;
  cbTools.Text:= OrbisPanel1.ActiveTool
end;

procedure TForm1.ImageDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if StartDrag then
  begin
    DifX:= X;
    DifY:= Y;
    StartDrag:= False;
    exit
  end;
{
  Image.Left:= Image.Left + X-DifX;
  Image.Top:=  Image.Top + Y-DifY;
}  
end;

procedure TForm1.ImageStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  StartDrag:= True;
end;

procedure TForm1.btLayPanClick(Sender: TObject);
{
var
  aTool: TLayersPanel;
  aMaps: TEntity;
}
begin
{
  aTool:= TLayersPanel.Create;
  aMaps:= OrbisPanel1.MapsObject;
  aTool.Input:= aMaps.FindElementName('Zakl');
  aTool.DoIt;
}
end;

procedure TForm1.OrbisPanel1ToolChange(aToolName: String);
begin
  if aToolName = 'TMeasureLengthTool' then
     lbLength.Caption:= Copy(OrbisPanel1.GetToolProperty('TMeasureLengthTool', 'Length'), 1, 8);

  if aToolName = 'TMeasureAreaTool' then
  begin
    lbLength.Caption:= Copy(OrbisPanel1.GetToolProperty('TMeasureAreaTool', 'Length'), 1, 8);
    lbArea.Caption:= Copy(OrbisPanel1.GetToolProperty('TMeasureAreaTool', 'Area'),1,8)
  end
end;

procedure TForm1.btOPRLClick(Sender: TObject);
begin
//  OrbisPanel1.AddToLayer('LIN_HLOB', 'LIN', 'K:\OPRL\Lo23\Lo23_2\HLOB*.BLK');
  OrbisPanel1.AddToLayer('LIN_TYP', 'LIN', 'K:\OPRL\Lo23\Lo23_2\TYP23_2.BLK');
  OrbisPanel1.AddToLayer('PLO_TYP', 'ARE', 'K:\OPRL\Lo23\Lo23_2\TYP23_2.BLK');
  OrbisPanel1.AddToLayer('LIN_HLOB', 'LIN', 'K:\OPRL\Lo23\Lo23_2\HLOB23_2.BLK');

  OrbisPanel1.ClearMap('Pehledov');
  OrbisPanel1.AddToMap('Pehledov', 'PLO_TYP');
  OrbisPanel1.AddToMap('Pehledov', 'LIN_TYP');
  OrbisPanel1.AddToMap('Pehledov', 'LIN_HLOB');
end;

end.

