unit F_Test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, XPanelControl_TLB, StdCtrls, ExtCtrls;

type
  TTestForm = class(TForm)
    Panel1: TPanel;
    btExplore: TButton;
    btLayer: TButton;
    btMap: TButton;
    btView: TButton;
    edScale: TEdit;
    Label1: TLabel;
    edX: TEdit;
    edY: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edSelObj: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure btExploreClick(Sender: TObject);
    procedure btMapClick(Sender: TObject);
    procedure btLayerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btViewClick(Sender: TObject);
    procedure edScaleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure XPanelResize(Sender: TObject);
    procedure XPanelSelect(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}
uses
  U_String;




procedure TTestForm.FormShow(Sender: TObject);
begin
  XPanel.Init;
end;

procedure TTestForm.FormHide(Sender: TObject);
begin
//  XPanel.Done;
end;

procedure TTestForm.btExploreClick(Sender: TObject);
begin
  XPanel.ExploreWorld
end;

procedure TTestForm.btMapClick(Sender: TObject);
begin
  XPanel.ClearMap('Zakl');
  XPanel.AddToMap('Zakl', 'Plochy');
  XPanel.AddToMap('Zakl', 'Cary');
end;

procedure TTestForm.btLayerClick(Sender: TObject);
begin
  XPanel.AddToLayer('Cary', 'LIN', 'G:\DataTax\IDC_LCR\01\Det.blk');
  XPanel.AddToLayer('Plochy', 'ARE', 'G:\DataTax\IDC_LCR\01\Det.blk');
//  XPanel.AddToLayer('Cary', 'LIN', '');
end;

procedure TTestForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  XPanel.Done;
  MessageBeep(0);
//  Application.ProcessMessages
end;

procedure TTestForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:= MessageDlg('Opravdu konec ?',
                         mtConfirmation, [mbYes, mbNo], 0) = mrYes
end;

procedure TTestForm.btViewClick(Sender: TObject);
begin
  XPanel.ActualMap:= 'Zakl';
  edScale.Text:= DoubleToStr(XPanel.ViewScale, 10, 0)
end;

procedure TTestForm.edScaleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key <> vk_Return then exit;
  XPanel.ViewScale:= StrToInt(EdScale.Text);
  XPanel.Review;
end;

procedure TTestForm.XPanelResize(Sender: TObject);
begin
  inherited;
  edScale.Text:= DoubleToStr(XPanel.ViewScale, 10, 0);
  edX.Text:= DoubleToStr(XPanel.CenterX, 12, 0);
  edY.Text:= DoubleToStr(XPanel.CenterY, 12, 0);
end;

procedure TTestForm.XPanelSelect(Sender: TObject);
var
  aStr1, aStr2: wideString;

begin
  if XPanel.IsSelObj then
  begin
    aStr1:= XPanel.SelObjProperty('CISLO');
    aStr2:= XPanel.SelObjProperty('Oddeleni');
    edSelObj.Text:=  aStr1 + ': ' + aStr2;
  end
end;

procedure TTestForm.FormDestroy(Sender: TObject);
begin
  ShowMessage('Destroy')
end;


end.
