unit readwrite;

interface

implementation



procedure Tf_edLayForm.SetInterpret;
var
  aEC: TElementClass;

begin
  aEC:= nil;

  if FLayer = nil then
     Exit;

  if FLayer.LayerType = 'PNT' then
  begin
    aEC:= TGeneralPointInterpret;
    FLayer.InterpretedClass:= TPointElement;
    rgLayType.ItemIndex:= 0;
  end;
  if FLayer.LayerType = 'ARE' then
  begin
    aEC:= TGeneralAreaInterpret;
    FLayer.InterpretedClass:= TAreaElement;
    rgLayType.ItemIndex:= 2;
  end;

  if FLayer.LayerType = 'LIN' then
  begin
    aEC:= TGeneralLineInterpret;
    FLayer.InterpretedClass:= TPolyLineElement;
    rgLayType.ItemIndex:= 1;
  end;

  if FLayer.LayerType = 'TXT' then
  begin
    aEC:= TGeneralTextInterpret;
    FLayer.InterpretedClass:= TTextElement;
    rgLayType.ItemIndex:= 3;
  end;

{$IFDEF RAS}
  if FLayer.LayerType = 'RAS' then
  begin
    aEC:= TRasterInterpret;
    FLayer.InterpretedClass:= TRaster;
  end;
{$ENDIF}

  if FLayer.AsText then
  begin
    aEC:= TGeneralTextInterpret;
  end;


  if FLayer.Interpret <> nil then
  begin
    if FLayer.Interpret is  aEC then
       Exit;
    FLayer.Interpret.Free;
  end;


  if aEC = nil then
     Exit;

  FLayer.Interpret:= TInterpret(aEC.Create);

  if FLayer.Interpret is TGeneralColorInterpret then
     TGeneralColorInterpret(FLayer.Interpret).ColorByTopol:= True;
  if FLayer.Interpret is TGeneralColorInterpret then
     TGeneralColorInterpret(FLayer.Interpret).PropColor:= 'BARVA';
  if FLayer.Interpret is TGeneralBrushInterpret then
     TGeneralBrushInterpret(FLayer.Interpret).PropBrush:= 'ZNACKA';

  if FLayer.Interpret is TGeneralTextInterpret then
  begin
    TGeneralTextInterpret(FLayer.Interpret).PropText:= edTextItem.Text;
    TGeneralTextInterpret(FLayer.Interpret).ValFont:= 'ARIAL';
    TGeneralTextInterpret(FLayer.Interpret).ValHeight:= 10;
  end;
end;



procedure Tf_edLayForm.SetInterpretProps(FLayer: TLayerContainer);
var
  aGCI: TGeneralColorInterpret;
  aGBI: TGeneralBrushInterpret;
  aGTI: TGeneralTextInterpret;
  aScale: Double;
  aCode: integer;
begin

  FLayer.MinScaleNumber:= aScale;

  FLayer.MaxScaleNumber:= aScale;

  FLayer.AsText:= ASTEXT;
  FLayer.LayerType:= ARE,LIN,PNT,TXT
  FLayer.SetLayerInterpretForType;

  if FLayer.Interpret is TGeneralColorInterpret then
  begin
    aGCI:= TGeneralColorInterpret(FLayer.Interpret);

    aGCI.ColorByTopol:= True;
    aGCI.UseColor:= True;
    aGCI.Color:= 0; {cerna}
    aGCI.PropColor:= 'BARVA';
    aGCI.ColorByPalette:= false;
  end;

  if FLayer.Interpret is TGeneralBrushInterpret then
  begin
    aGBI:= TGeneralBrushInterpret(FLayer.Interpret);
    aGBI.PropBrush:= 'ZNACKA';
  end;

  if FLayer.Interpret is TGeneralTextInterpret then
  begin
    aGTI:= TGeneralTextInterpret(FLayer.Interpret);
    aGTI.PropText:= 'PARCIS';
    aGTI.ValFont:= 'ARIAL';
    aGTI.PropX:= 'X';
    aGTI.PropY:= 'Y';
    aGTI.ProcessClass:= FLayer.InterpretedClass;
    aGTI.ValHeight:= 0.003;
    aGTI.AbsSize:= true;
  end;
end;



procedure Tf_edLayForm.SetEditor(const Value: TLayerContainer);
var
  GCI: TGeneralColorInterpret;
  aVal: Boolean;
begin
  FLayer := Value;
  if FLayer = nil then
     exit;

//  if FLayer.Interpret = nil then
  SetInterpret;

  aVal:= not FLayer.SwitchedOff;
  cbShowLayer.Checked:= aVal;

  panColor.Color:= clBtnFace;
  if (FLayer.Interpret is TGeneralColorInterpret) then
  begin
    GCI:= TGeneralColorInterpret(FLayer.Interpret);
    panColor.Color:= GCI.Color;
    if GCI.UseColor then
    begin
      rgColorSource.ItemIndex:= 0;
    end
{
    else
    if GCI.ToolColor <> nil then
    begin
      rgColorSource.ItemIndex:= 1;
    end
}
    else
    if GCI.PropColor <> '' then
    begin
      rgColorSource.ItemIndex:= 1;
      edColorItem.Text:= GCI.PropColor;
    end;

    if GCI.ColorByTopol then
       rgColorHow.ItemIndex:= 1
    else
    if GCI.ColorByPalette then
       rgColorHow.ItemIndex:= 2
    else
       rgColorHow.ItemIndex:= 0;
  end;

  if (FLayer.Interpret is TGeneralBrushInterpret) then
  begin
    if TGeneralBrushInterpret(FLayer.Interpret).ToolBrush <> nil then
    begin
      rgSymbol.ItemIndex:= 1;
    end
    else
    if TGeneralBrushInterpret(FLayer.Interpret).PropBrush <> '' then
    begin
      rgSymbol.ItemIndex:= 2;
//      edColorItem.Text:= TGeneralColorInterpret(FLayer.Interpret).PropColor;
    end;
  end;

  if FLayer.Interpret is TGeneralTextInterpret then
  begin
    cbAsText.Checked:= True;
    edTextItem.Text:= TGeneralTextInterpret(FLayer.Interpret).PropText;
    TGeneralTextInterpret(FLayer.Interpret).ValFont:= 'ARIAL';
    edTextHeight.Text:= IntToStr(round(TGeneralTextInterpret(FLayer.Interpret).ValHeight * 1000));
    cbTextAbsSize.Checked:= TGeneralTextInterpret(FLayer.Interpret).AbsSize;
  end;
end;


end.
