unit T_Compil;
interface
uses Elements,
     Classes,
     Tools,
     E_Type,
     language,
     T_Debug;

type KeyType=(kw_PROGRAM, kw_FUNCTION,kw_PROCEDURE ,kw_BEGIN, kw_IF, kw_CASE, kw_WHILE, kw_REPEAT, kw_FOR,
              kw_TRY, kw_END, kw_THEN, kw_ELSE, kw_OF, kw_DO, kw_TO, kw_DOWNTO, kw_UNTIL, kw_OR,kw_VAR,
              kw_AND,kw_NOT, kw_MOD, kw_DIV, kw_NIL, kw_INTEGER, kw_FLOAT, kw_CHAR, kw_BOOLEAN,kw_TRUE,kw_FALSE,kw_STRING,
              kw_tecka,kw_carka,kw_strednik,kw_rovno,kw_plus,kw_minus,kw_krat,kw_deleno,kw_bracket,kw_bracket2,kw_zavorka,kw_zavorka2,
              kw_dvojtecka,kw_mensi,kw_vetsi,kw_uvozovka,kw_apostrof,kw_mensirovno,kw_vetsirovno,kw_ruzne,kw_assign,
              kw_ElementDivider,kw_OwnerDivider,kw_ElementByNumber,kw_OwnerByNumber,kw_mezera,kw_slovo,kw_cislo,kw_celecislo,kw_retezec,kw_eof);


const _ElementDivider='\';_OwnerDivider='\\';_ElementByNumber='[';_OwnerByNumber='[';
      KeyWords:array[KeyType] of string[10]=
              ('PROGRAM', 'FUNCTION','PROCEDURE', 'BEGIN', 'IF', 'CASE', 'WHILE', 'REPEAT', 'FOR',
              'TRY', 'END', 'THEN', 'ELSE', 'OF', 'DO', 'TO', 'DOWNTO', 'UNTIL', 'OR','VAR',
              'AND','NOT', 'MOD', 'DIV', 'NIL', 'INTEGER', 'FLOAT', 'CHAR', 'BOOLEAN','TRUE','FALSE', 'STRING',
              '.',',',';','=','+','-','*','/','[',']','(',')',':','<','>','"','''','<=','>=','<>',':=',
              _ElementDivider,_OwnerDivider,_ElementByNumber,_OwnerByNumber,' ','','','','','');
      id_ElementDivider='ELEMENTDIVIDER';id_OwnerDivider='OWNERDIVIDER';

      kw_World='WORLD';
      kw_MTool='MAINTOOL';
      kw_ActivEl='ACTIVEELEMENT';

type
TStarts=set of char;

TPreCompiler=class(TTool)
private
  FHold:boolean;
  FStr,oldres:string;
  oldkey:KeyType;
  RLine,RPos,FLine,FPos,FLen,FLines:longint;
  FStarts:TStarts;
  FElementDivider:string;
  FOwnerDivider:string;
  FSource:TStringList;
  procedure SetSource(aText:TStrings);virtual;
  function GetSource:TStrings;virtual;
  procedure SetODivider(aDv:String);virtual;
  procedure SetEDivider(aDv:String);virtual;
  procedure SetLine(aLine:longint);virtual;
  procedure NewLine;virtual;
public
  constructor Create;override;
  destructor Destroy;override;
  procedure Hold;virtual;
  procedure CancelHold;virtual;
  function GiveNextWord(var res:string):KeyType;
  function StopLetter:char;
  property Source:TStrings read GetSource write SetSource;
  property OwnerDivider:string read FOwnerDivider write SetODivider;
  property ElementDivider:string read FElementDivider write SetEDivider;
  published
  property Line:longint read FLine write SetLine;
  property Pos:longint read FPos write FPos;
 {pozice, kde zacalo opravdove cteni}
  property RealLine:longint read RLine;
  property RealPos:longint read RPos;
end;

TBlockType=(_BeginBlock,_Function,_Procedure,_Program);
{pro potrebu kompilatoru}


TBlockInfo=class(TOwnerEntity) {asi bude nutne vzmenit}
private
  {asi zbytecne -odtranit pokud treba}
  FBlockType:TBlockType; {pro rychlesi zjisteni}
  FBlock:TOilBlock;
  function GetBlock:TOilBlock;
  procedure SetBlock(aBlock:TOilBlock);
public
  VarName:array[0..MaxVariables-1] of string[MaxVarLength];
  property BlockType:TBlockType read FBlockType write FBlockType;
  property Block:TOilBlock read GetBlock write SetBlock;
end;


TProcInfo=class(TBlockInfo)
private
  FCalls:longint;{kolik prvnich promennych v stacku je odkazovych}
protected
  property Calls:longint read FCalls write FCalls;
end;

TVarStatus=(primary,called);
TVarCompileInfo=class(TElement) {clen seznamu volanych promennych}
public
  VarName:string;
  Status:TVarStatus;
  VarIndex:longint;
  Typ:TType;
  TypeName:string;
end;

TProcHeaderInfo=class(TEntity)
{TVarCompileInfo jsou ulozeny primo uvnitr}
private
  FOilProc:TOilProc;
  function GetOilProc:TOilProc;
  procedure SetOilProc(aProc:TOilProc);
public
  ProcName:string;
  property OilProc:TOilProc read GetOilProc write SetOilProc;
end;

TFuncHeaderInfo=class(TProcHeaderInfo)
public
  FuncTyp:TType;
  FuncTypeName:string;
end;

TCompiler=class(TTechnology)
private
  FFuncInfoList:TOwnerEntity;
  FBlockInfoList:TOwnerEntity;
  FPreCompiler:TPreCompiler;
  procedure SetFuncInfoList(aList:TOwnerEntity);virtual;
  function GetFuncInfoList:TOwnerEntity; virtual;
  procedure SetBlockInfoList(aList:TOwnerEntity);virtual;
  function GetBlockInfoList:TOwnerEntity; virtual;
  function GetCBlockInfo:TBlockInfo;virtual;
  procedure SetCBlockInfo(aInfo:TBlockInfo);virtual;
  function GetInfoBlock(index:longint):TBlockInfo;virtual;
  procedure SetInfoBlock(index:longint;aInfo:TBlockInfo);virtual;
  function GetPreComp:TPreCompiler;virtual;
  procedure SetPreComp(aComp:TPreCompiler);virtual;
  function NextWord(var res:string):KeyType;virtual;
  function StopLetter:char;virtual;
  {exists function vraci i existenci procedur}
  function ExistsFunction(VName:string):boolean;virtual;
  function ExistsProcedure(VName:string):boolean;virtual;
  function ExistsVariable(VName:string;var aVar:TNormalVariable):boolean;virtual;
protected
   procedure FreeCurentBlockInfo;virtual;
   property FuncInfoList:TOwnerEntity read GetFuncInfoList write SetFuncInfoList;
   property BlockInfoList:TOwnerEntity read GetBlockInfoList write SetBlockInfoList;
   property CurentBlockInfo:TBlockInfo read GetCBlockInfo write SetCBlockInfo;
   property BlockInfo[index:longint]:TBlockInfo read GetInfoBlock write  SetInfoBlock;
   property PreCompiler:TPreCompiler read GetPreComp write SetPreComp;
end;


TFuncCallerCompiler=class;
TToolCompiler=class;
TTermCompiler=class;

TPathCompiler=class(TCompiler)
 private
    FToolCompiler:TToolCompiler;
    FFuncCallerCompiler:TFuncCallerCompiler;
    FTermCompiler:TTermCompiler;
    function GetToolCompiler:TToolCompiler;virtual;
    procedure SetToolCompiler(aComp:TToolCompiler);virtual;
    function GetFuncCompiler:TFuncCallerCompiler;virtual;
    procedure SetFuncCompiler(aComp:TFuncCallerCompiler);virtual;
    function GetTermCompiler:TTermCompiler;virtual;
    procedure SetTermCompiler(aComp:TTermCompiler);virtual;
 protected
    property  ToolCompiler:TToolCompiler read GetToolCompiler write SetToolCompiler;
    property  FuncCallerCompiler:TFuncCallerCompiler read GetFuncCompiler write SetFuncCompiler;
    property  TermCompiler:TTermCompiler read GetTermCompiler write SetTermCompiler;
 public
    procedure DoIt;override;
 end;

TExpressionCompiler=class;


TFactorCompiler=class(TCompiler)
 private
   FExpressionCompiler:TExpressionCompiler;
   FPathCompiler:TPathCompiler;
   function GetExpressionCompiler:TExpressionCompiler;virtual;
   procedure SetExpressionCompiler(aComp:TExpressionCompiler);virtual;
   function GetPathCompiler:TPathCompiler;virtual;
   procedure SetPathCompiler(aComp:TPathCompiler);virtual;
 protected
   property  ExpressionCompiler:TExpressionCompiler read GetExpressionCompiler write SetExpressionCompiler;
   property  PathCompiler:TPathCompiler read GetPathCompiler write SetPathCompiler;
 public
   procedure DoIt;override;
 end;

TTermCompiler=class(TCompiler)
 private
   FFactorCompiler:TFactorCompiler;
   function GetFactorCompiler:TFactorCompiler;virtual;
   procedure SetFactorCompiler(aComp:TFactorCompiler);virtual;
 protected
   property  FactorCompiler:TFactorCompiler read GetFactorCompiler write SetFactorCompiler;
 public
   procedure DoIt;override;
 end;


TSimpleExpCompiler=class(TCompiler)
 private
   FTermCompiler:TTermCompiler;
   function GetTermCompiler:TTermCompiler;virtual;
   procedure SetTermCompiler(aComp:TTermCompiler);virtual;
 protected
   property  TermCompiler:TTermCompiler read GetTermCompiler write SetTermCompiler;
 public
   procedure DoIt;override;
 end;

TExpressionCompiler=class(TCompiler)
 private
   FSimpleExpCompiler:TSimpleExpCompiler;
   function GetSimpleExpCompiler:TSimpleExpCompiler;virtual;
   procedure SetSimpleExpCompiler(aComp:TSimpleExpCompiler);virtual;
 protected
   property  SimpleExpCompiler:TSimpleExpCompiler read GetSimpleExpCompiler write SetSimpleExpCompiler;
 public
   procedure DoIt;override;
 end;

TCommandCompiler=class;

TWithExprCompiler=class(TCompiler)
 private
   FDebuged:boolean;
   FExpressionCompiler:TExpressionCompiler;
   function GetExpressionCompiler:TExpressionCompiler;virtual;
   procedure SetExpressionCompiler(aComp:TExpressionCompiler);virtual;
 protected
   property  ExpressionCompiler:TExpressionCompiler read GetExpressionCompiler write SetExpressionCompiler;
 public
   property  Debuged:boolean read FDebuged write FDebuged;
   constructor Create;override;
 end;

TFuncCallerCompiler=class(TWithExprCompiler)
 public
   procedure DoIt;override;
  end;

TToolCompiler=class(TWithExprCompiler)
 public
   procedure DoIt;override;
 end;


TLineCompiler=class(TWithExprCompiler)
 private
   FCommandCompiler:TCommandCompiler;
   function GetCommandCompiler:TCommandCompiler;virtual;
   procedure SetCommandCompiler(aComp:TCommandCompiler);virtual;
 protected
    property  CommandCompiler:TCommandCompiler read GetCommandCompiler write SetCommandCompiler;
    property  ExpressionCompiler:TExpressionCompiler read GetExpressionCompiler write SetExpressionCompiler;
 end;

TForCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
  end;

TIfCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TWhileCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TRepeatCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TCaseCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TTryCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TBeginCompiler=class(TLineCompiler)
 public
   procedure DoIt;override;
 end;

TOtherCompiler=class(TWithExprCompiler)
 private
    FTermCompiler:TTermCompiler;
    FFuncCallerCompiler:TFuncCallerCompiler;
    function GetTermCompiler:TTermCompiler;virtual;
    procedure SetTermCompiler(aComp:TTermCompiler);virtual;
    function GetFuncCallerCompiler:TFuncCallerCompiler;virtual;
    procedure SetFuncCallerCompiler(aComp:TFuncCallerCompiler);virtual;
 protected
    property  TermCompiler:TTermCompiler read GetTermCompiler write SetTermCompiler;
    property  FuncCallerCompiler:TFuncCallerCompiler read GetFuncCallerCompiler write SetFuncCallerCompiler;
 public
    procedure DoIt;override;
 end;


TCommandCompiler=class(TCompiler)
 private
   Fdebuged:boolean;
   FForCompiler:TForCompiler;
   FIfCompiler:TIfCompiler;
   FWhileCompiler:TWhileCompiler;
   FRepeatCompiler:TRepeatCompiler;
   FCaseCompiler:TCaseCompiler;
   FTryCompiler:TTryCompiler;
   FBeginCompiler:TBeginCompiler;
   FOtherCompiler:TOtherCompiler;
   function GetForCompiler:TForCompiler;virtual;
   procedure SetForCompiler(aComp:TForCompiler);virtual;
   function GetIfCompiler:TIfCompiler;virtual;
    procedure SetIfCompiler(aComp:TIfCompiler);virtual;
   function GetWhileCompiler:TWhileCompiler;virtual;
   procedure SetWhileCompiler(aComp:TWhileCompiler);virtual;
   function GetRepeatCompiler:TRepeatCompiler;virtual;
   procedure SetRepeatCompiler(aComp:TRepeatCompiler);virtual;
   function GetCaseCompiler:TCaseCompiler;virtual;
   procedure SetCaseCompiler(aComp:TCaseCompiler);virtual;
   function GetTryCompiler:TTryCompiler;virtual;
   procedure SetTryCompiler(aComp:TTryCompiler);virtual;
   function GetBeginCompiler:TBeginCompiler;virtual;
   procedure SetBeginCompiler(aComp:TBeginCompiler);virtual;
   function GetOtherCompiler:TOtherCompiler;virtual;
   procedure SetOtherCompiler(aComp:TOtherCompiler);virtual;
 protected
    property  ForCompiler:TForCompiler read GetForCompiler write SetForCompiler;
   property  IfCompiler:TIfCompiler read GetIfCompiler write SetIfCompiler;
   property  WhileCompiler:TWhileCompiler read GetWhileCompiler write SetWhileCompiler;
   property  RepeatCompiler:TRepeatCompiler read GetRepeatCompiler write SetRepeatCompiler;
   property  CaseCompiler:TCaseCompiler read GetCaseCompiler write SetCaseCompiler;
   property  TryCompiler:TTryCompiler read GetTryCompiler write SetTryCompiler;
   property  BeginCompiler:TBeginCompiler read GetBeginCompiler write SetBeginCompiler;
   property  OtherCompiler:TOtherCompiler read GetOtherCompiler write SetOtherCompiler;
 public
   property  Debuged:boolean read FDebuged write FDebuged;
   procedure DoIt;override;
 end;

TFuncDeclarationCompiler=class(TWithExprCompiler)
 private
   FCommandCompiler:TCommandCompiler;
   FFuncDeclCompiler:TFuncDeclarationCompiler;
   function GetFuncDeclCompiler:TFuncDeclarationCompiler;virtual;
   procedure SetFuncDeclCompiler(aComp:TFuncDeclarationCompiler);virtual;
   function GetCommandCompiler:TCommandCompiler;virtual;
   procedure SetCommandCompiler(aComp:TCommandCompiler);virtual;
 public
   property CommandCompiler:TCommandCompiler read GetCommandCompiler write SetCommandCompiler;
   property FuncDeclCompiler:TFuncDeclarationCompiler read GetFuncDeclCompiler write SetFuncDeclCompiler;
   procedure DoIt;override;
 end;


TProgramCompiler=class(TFuncDeclarationCompiler)
 private
   procedure SetSource(aText:TStrings);virtual;
   function GetSource:TStrings;virtual;
 public
   property Source:TStrings read GetSource write SetSource;
   {procedure SetInput(aInput:TElement);override;}
   procedure DoIt;override;
 end;

implementation
uses
     Forms,
     SysUtils,
     U_String,
     E_Class,
     T_OilOper,
     T_Errors;

const
PossibleDiv:TStarts=['!','#'..'&','?','@','\','^','|','~'];
NormalLetters:TStarts=['a'..'z','A'..'Z','_','0'..'9'];

function IsRegisteredTool(s:string;var aClass:TClass):boolean;
begin
  result:=false;
  aClass := TElementClass(GetOrbisClass(CheckClassName(S)));
  if (aClass <> nil) and aClass.InheritsFrom(TTool) then
    result:=true;
end;

{PreCompiler}
constructor TPreCompiler.Create;
var
    i:KeyType;
begin
  inherited Create;
  FSource:=TStringList.Create;
  for i:=kw_tecka to kw_apostrof do
  begin
    FStarts:=FStarts+[KeyWords[i][1]];
  end;
  FElementDivider:=_ElementDivider;
  FStarts:=FStarts+[KeyWords[kw_ElementDivider][1]];
  FOwnerDivider:=_OwnerDivider;
  FStarts:=FStarts+[KeyWords[kw_OwnerDivider][1]];
  FLine:=0;
  FPos:=1;
  FHold:=false;
end;


destructor TPreCompiler.Destroy;
begin
  if assigned(FSource) then
    FSource.Free;
  inherited Destroy;
end;


procedure TPreCompiler.SetSource(aText:TStrings);
begin
  if assigned(aText) then
  begin
    FSource.Assign(aText);
    Fline:=0;Fpos:=1;
    if FSource.Count>0 then
    begin
      FLines:=Fsource.Count;
      Fstr:=Fsource.Strings[0];
      Flen:=length(FStr);
    end;
  end
  else
    FSource:=nil;
end;

function TPreCompiler.GetSource:TStrings;
begin
  result:=FSource;
end;

procedure TPreCompiler.SetODivider(aDv:String);
var
    i:integer;
begin
  if aDv=FElementDivider then
    raise TCompilerError.CreatePos(19,FLine,Fpos-length(aDv),'');
  for i:=1 to length(aDv) do
    if not(aDv[i] in PossibleDiv) then
      raise TCompilerError.CreatePos(20,FLine,Fpos-length(aDv)-1,aDv[i]);
  FStarts:=FStarts-[OwnerDivider[1]];
  FOwnerDivider:=aDv;
  FStarts:=FStarts+[aDv[1]];
  FStarts:=FStarts+[ElementDivider[1]];
end;

procedure TPreCompiler.SetEDivider(aDv:String);
var
    i:integer;
begin
  if aDv=FOwnerDivider then
    raise TCompilerError.CreatePos(19,FLine,Fpos,'');
  for i:=1 to length(aDv) do
    if not(aDv[i] in PossibleDiv) then
      raise TCompilerError.CreatePos(20,FLine,Fpos-length(aDv)-1,aDv[i]);
  FStarts:=FStarts-[ElementDivider[1]];
  FElementDivider:=aDv;
  FStarts:=FStarts+[aDv[1]];
  FStarts:=FStarts+[OwnerDivider[1]];
end;



procedure TPreCompiler.Hold;
begin
  FHold:=true;
end;

procedure TPreCompiler.CancelHold;
begin
  FHold:=false;
end;

procedure TPreCompiler.SetLine(aLine:longint);
begin
  FLine:=aLine;
  if FLine<FLines then
  begin
    FStr:=FSource.Strings[FLine];
    FLen:=length(FStr);
  end;
end;

procedure TPreCompiler.NewLine;
begin
   FPos:=1;
   inc(FLine);
   if FLine<FLines then
   begin
     FStr:=FSource.Strings[FLine];
     FLen:=length(FStr);
   end;
end;

function TPreCompiler.GiveNextWord(var res:string):KeyType;
procedure ReadComent;
var
    ven,O,E:boolean;
    P:integer;
    s:string;
begin      {zde je nacteni Divideru}
  if FPos<FLen then
  begin
    P:=FPos;
    inc(P);
    if FStr[P]='$' then
    begin {uz to musi byt dobre nebo spatne}
      O:=false;
      E:=false;
      if (P+length(id_ElementDivider))<=FLen then
      begin
        S:=Copy(FStr,p+1,length(id_ElementDivider));
        if AnsiUpperCase(S)=id_ElementDivider then
          E:=true;
      end;
      if (P+length(id_OwnerDivider))<=FLen then
      begin
        S:=Copy(FStr,p+1,length(id_OwnerDivider));
        if AnsiUpperCase(S)=id_OwnerDivider then
          O:=true;
      end;
      if not(O or E) then
        raise TCompilerError.CreatePos(1,FLine,P+1,'identifiktor');
      if O then
        P:=P+length(id_OwnerDivider)+1 else P:=P+length(id_ElementDivider)+1;
      if (P>FLen)then
        raise TCompilerError.CreatePos(1,FLine,P,'identifiktor');
      if FStr[P]=' ' then
        repeat
          inc(P)
        until (P>FLen)or(FStr[P]<>' ');
      if (P>FLen) then
        raise TCompilerError.CreatePos(1,FLine,P,'identifiktor');
      if not (FStr[P] in PossibleDiv)
        then raise TCompilerError.CreatePos(20,FLine,P,FStr[P]);
      FPos:=P;
      P:=0;
      repeat
        inc(P)
      until (P>FLen)or (FStr[FPos+P] in [' ','}']);
      if O then
        OwnerDivider:=Copy(FStr,FPos,P)
      else
        ElementDivider:=Copy(FStr,FPos,P);
      FPos:=FPos+P;
    end;
  end;
  ven:=false;
  while not ven do
  begin
    if FStr[FPos]='}' then
      ven:=true;
    inc(FPos);
    if Fpos>FLen then
    begin
      NewLine;
      if FLine>=FLines then
        ven:=true;
    end;
  end;
end;

function Skip:boolean;{je-li konec souboru}
var
    out:boolean;
begin
  result:=false;
  if FLine>=Flines then
    result:=true
  else
  begin
    out:=false;
    repeat
      if Fpos>Flen then
      begin
        NewLine;
        if FLine>=Flines then
        begin
          result:=true;
          out:=true;
        end;
      end
      else
        case FStr[Fpos] of
          '{':
          begin
            ReadComent;
            if FLine>=Flines then
            begin
              result:=true;
              out:=true;
            end;
          end;
          ' ':
          begin
            inc(FPos);
          end;
          else out:=true;
        end;
    until out;
  end;
  Rpos:=FPos;RLine:=FLine;
  ProgressText := 'Line no.'+ IntToStr(RLine);
  Progress := RLine;
  Application.ProcessMessages;
end;

procedure SkipInteger;
begin
  while (FPos<=FLen) and  (FStr[FPos] in ['0'..'9']) do
    inc(FPos);
end;
var
    Tmppos:longint;
    inside,ED,OD,ODN,must:boolean;
    i:KeyType;
    tmpres:string;
    chr:char;
begin
  result:=kw_eof;{jen inicializace}
  if FHold then
  begin
    res:=oldres;
    result:=oldkey;
    FHold:=false;
  end
  else
  begin     {opravdove cteni}
    FHold:=false;
    if Skip then
      result:=kw_eof
    else
    begin
      TmpPos:=FPos;
      case FStr[FPos] of
      'a'..'z','A'..'Z','_':{obyc slovo}
      begin
        result:=kw_slovo;
        inside:=true;
        while inside do
        begin
          if (Fpos>FLen)or (not (FStr[FPos]in NormalLetters))then
            inside:=false
          else inc(FPos);
        end;
        res:=Copy(FStr,TmpPos,FPos-TmpPos);  {mam v res slovo}   {bylo by lepsi stromem!!!!!}
        tmpres:=AnsiUpperCase(res);
        i:=kw_PROGRAM;
        repeat
          if KeyWords[i]=tmpres then
          begin
            result:=i;
            i:=kw_STRING;
          end;
          inc(i);
        until i>kw_STRING;
      end;
      '0'..'9':{cislo}
      begin
        result:=kw_CeleCislo;
        SkipInteger;
        if FPos<=FLen then
        begin
          if FStr[FPos]='.' then
          begin {cteni za teckou}
            result:=kw_Cislo;
            inc(FPos);
            if (FPos>FLen)or(not(FStr[FPos] in ['0'..'9']))then
              raise TCompilerError.CreatePos(1,FLine,Fpos,'cel slo');
            SkipInteger;
          end;
          if FPos<=FLen then
          begin
            if (FStr[FPos]='e')or(FStr[FPos]='E') then
            begin
              result:=kw_Cislo;
              inc(FPos);
              if (FPos>FLen)then
                raise TCompilerError.CreatePos(1,FLine,Fpos,'cel slo');  {+-}
              if FStr[FPos] in ['+','-'] then
              begin
                inc(FPos);
                if (FPos>FLen)then
                  raise TCompilerError.CreatePos(1,FLine,Fpos,'cel slo');
              end;
              if not(FStr[FPos] in ['0'..'9'])then
                raise TCompilerError.CreatePos(1,FLine,Fpos,'cel slo');
              SkipInteger;
            end;
          end;
        end;
        res:=Copy(FStr,TmpPos,FPos-TmpPos);
      end;
      '"','''':{jde o retezec}
      begin
        chr:=FStr[FPos];
        result:=kw_retezec;
        inside:=true;
        inc(FPos);
        while inside do
        begin
          if (Fpos>FLen) then
            raise TCompilerError.CreatePos(16,FLine,Fpos,'');
          if FStr[FPos]=chr then
            inside:=false;
          inc(FPos);
        end;
        res:=Copy(FStr,TmpPos,FPos-TmpPos);
      end;
      else    //CASE
      begin{specialni znaky nebo chyba}
        res:=FStr[Fpos];
        chr:=FStr[Fpos];
        if FStr[Fpos] in FStarts then
        begin  {bude klicovy znak}   {tady je to trochu natvrdo}
          ED:=false;OD:=false;ODN:=false;must:=false;
          if FOwnerDivider[1]=chr then
       {1}begin
            must:=true;
            if FPos+length(FOwnerDivider)-1<=FLen then
            begin
              if FPos+length(FOwnerDivider)<=FLen then
                tmpres:=copy(FStr,FPos,length(FOwnerDivider)+1) else tmpres:='';
              if tmpres=FOwnerDivider+Keywords[kw_bracket] then
              begin
                ODN:=true;
                result:=kw_OwnerByNumber;
              end
              else
              begin
                tmpres:=copy(FStr,FPos,length(FOwnerDivider));
                if tmpres=FOwnerDivider then
                begin
                  OD:=true;
                  result:=kw_OwnerDivider;
                end
              end;
            end;
       {1}end;
          if not ODN then if FElementDivider[1]=chr then
       {2}begin
            must:=true;
            if FPos+length(FElementDivider)-1<=FLen then
            begin
              tmpres:=copy(FStr,FPos,length(FElementDivider));
              if tmpres=FElementDivider then
              begin
                ED:=true;
                result:=kw_ElementDivider;
              end
            end;
       {2}end;
          if must then
       {3}begin
            if OD and ED then
              if length(FOwnerDivider)>length(FElementDivider) then
              begin
                result:=kw_OwnerDivider;
                ED:=false;
              end
              else
                OD:=false;
              if OD then
                 FPos:=FPos+length(FOwnerDivider)-1;
              if ED then
                 FPos:=FPos+length(FElementDivider)-1;
              if ODN then
                 FPos:=FPos+length(FOwnerDivider);
              if not(OD or ED or ODN) then
                 raise TCompilerError.CreatePos(3,FLine,Fpos,'');
              end
            else
              if ':'=chr then
          {3a}begin
                result:=kw_dvojtecka;
                if FPos<FLen then
                  if FStr[Fpos+1]='=' then
                  begin
                    inc(FPos);
                    res:=':=';
                    result:=kw_assign;
                  end;
                end
                else
                  if '>'=chr then
                  begin
                    result:=kw_vetsi;
                    if FPos<FLen then
                      if FStr[Fpos+1]='=' then
                        begin
                          inc(FPos);
                          res:='>=';
                          result:=kw_vetsirovno;
                        end;
                  end
                  else
                    if '<'=chr then
                    begin
                      result:=kw_mensi;
                      if FPos<FLen then
                      begin
                        if FStr[Fpos+1]='=' then
                        begin
                          inc(FPos);
                          res:='<=';
                          result:=kw_mensirovno;
                        end
                        else
                          if FStr[Fpos+1]='>' then
                            begin
                              inc(FPos);
                              res:='<>';
                              result:=kw_ruzne;
                            end;
                        end;
                      end
                      else
                      begin
                        i:=kw_tecka;
                        repeat
                          if KeyWords[i]=chr then
                          begin
                            result:=i;
                            i:=kw_zavorka2;
                          end;
                          inc(i);
                        until i>kw_zavorka2;
                      end;
                      inc(FPos);
                    end
                    else
                      raise TCompilerError.CreatePos(3,FLine,Fpos,'');
          {3a}end;
       end;{case}
     end;
     oldres:=res;
     oldkey:=result;
  end;
end;

function TPreCompiler.StopLetter:char;
begin
 if FPos>FLen then
   result:=#0
 else
   result:=FStr[FPos];
end;

{TBlockInfo}
{function TBlockInfo.GetProcInfo:TProcInfo;
begin
  if not assigned(FProcInfo) then
  begin
    FProcInfo:=TProcInfo.Create;
    AddElement(FProcInfo);
  end;
  result:=FProcInfo;
end;

procedure TBlockInfo.SetProcInfo(aVar:TProcInfo);
begin
  if assigned(FProcInfo) then FreeElement(FProcInfo);
  FProcInfo:=aVar;
  AddElement(FProcInfo);
end;
}

function TBlockInfo.GetBlock:TOilBlock;
begin
  result:=FBlock;
end;

procedure TBlockInfo.SetBlock(aBlock:TOilBlock);
begin {kdyz je budu registrovat,tak pri freeElement ten bloku taky omylem smazu}
 {if assigned(FBlock) then FreeElement(FBlock);
 AddElement(aBlock);}
 FBlock:=aBlock;
end;

{TProcHeaderInfo}
function TProcHeaderInfo.GetOilProc:TOilProc;
begin
  result:=FOilProc;
end;

procedure TProcHeaderInfo.SetOilProc(aProc:TOilProc);
begin
  if assigned(FOilProc) then
    FreeElement(FOilProc);
  FOilProc:=aProc;
  AddElement(FOilProc);
end;

{TCompiler}
procedure TCompiler.SetBlockInfoList(aList:TOwnerEntity);
begin
  if assigned(FBlockInfoList) then
    FreeElement(FBlockInfoList);
  AddElement(aList);
  FBlockInfoList:=aList;
end;

function TCompiler.GetBlockInfoList:TOwnerEntity;
begin
  if not assigned(FBlockInfoList) then
  begin
    FBlockInfoList:=TOwnerEntity.Create;
    AddElement(FBlockInfoList);
  end;
  result:=FBlockInfoList;
end;

procedure TCompiler.SetFuncInfoList(aList:TOwnerEntity);
begin
  if assigned(FFuncInfoList) then
    FreeElement(FFuncInfoList);
  AddElement(aList);
  FFuncInfoList:=aList;
end;

function TCompiler.GetFuncInfoList:TOwnerEntity;
begin
  if not assigned(FFuncInfoList) then
  begin
    FFuncInfoList:=TOwnerEntity.Create;
    AddElement(FFuncInfoList);
  end;
  result:=FFuncInfoList;
end;

function TCompiler.GetCBlockInfo:TBlockInfo;
begin
  if BlockInfoList.Count=0 then
    result:=nil
  else
    result:=TBlockInfo(BlockInfoList.Elements[BlockInfoList.Count-1]);
end;

procedure TCompiler.SetCBlockInfo(aInfo:TBlockInfo);
begin
  BlockInfoList.AddElement(aInfo);
end;

function TCompiler.GetInfoBlock(index:longint):TBlockInfo;
begin
  result:=TBlockInfo(BlockInfoList.Elements[index]);
end;

procedure TCompiler.SetInfoBlock(index:longint;aInfo:TBlockInfo);
var
    aBlk:TOwnerEntity;
begin
  aBlk:=BlockInfoList;
  if aBlk.Count>index then
  begin
    aBlk.Elements[index].Free;
    aBlk.Elements[index]:=aInfo;
  end
  else
    aBlk.AddElement(aInfo);
end;

procedure TCompiler.FreeCurenTBlockInfo;
var
    aList:TOwnerEntity;
begin
   if Output<>nil then
     AddElement(output);
   aList:=BlockInfoList;
   if aList.Count>0 then
     aList.FreeElement(aList.Elements[aList.count-1]);
   RemoveElement(Output);
end;

function TCompiler.GetPreComp:TPreCompiler;
begin
  if not assigned(FPreCompiler) then
  begin
    FPreCompiler:=TPreCompiler.Create;
    AddElement(FPreCompiler);
  end;
  result:=FPreCompiler;
end;

procedure TCompiler.SetPreComp(aComp:TPreCompiler);
begin
   if assigned(FPreCompiler) then
     FreeElement(FPreCompiler);
   AddElement(aComp);
   FPreCompiler:=aComp;
end;

function TCompiler.NextWord(var res:string):KeyType;
begin
  result:=PreCompiler.GiveNextWord(res);
end;

function TCompiler.StopLetter:char;
begin
  result:=PreCompiler.StopLetter;
end;

function TCompiler.ExistsFunction(VName:string):boolean;
var
    i:longint;
begin
  result:=false;
  VName:=AnsiUppercase(VName);
  i:=FuncInfolist.Count-1;
  while (i>=0) and not result do
  begin
    result:=TProcheaderInfo(FuncInfolist.Elements[i]).Procname=VName;
    dec(i);
  end
end;

function TCompiler.ExistsProcedure(VName:string):boolean;
var
    i:longint;
    E:TElement;
begin
  result:=false;
  VName:=AnsiUppercase(VName);
  i:=FuncInfolist.Count-1;
  while (i>=0) and not result do
  begin
       E:=FuncInfolist.Elements[i];
       if not ( E is TFuncHeaderInfo) then
          result:=TProcheaderInfo(E).Procname=VName;
       dec(i);
  end
end;


function TCompiler.ExistsVariable(VName:string;var aVar:TNormalVariable):boolean;
var 
    j,i,v:longint;
    Inf:TBlockinfo;
begin
  avar:=nil;
  result:=false;
  j:=BlockInfoList.Count;
  i:=j-1;
  VName:=AnsiUpperCase(VName);
  while (not result)and (i>=0) do
  begin{cyklus pres bloky}
    Inf:=BlockInfo[i];
    v:=Inf.Block.VarInfoList.Count-1;
    while (not result) and (v>=0) do
    begin  {cyllus pres promenne}
      if Inf.varname[v]=VName then
      begin {existuje}
        result:=true;
        if (Inf is TprocInfo) and (v<TprocInfo(Inf).Calls) then
          aVar:=TCalledVariable.create
        else
          aVar:=TNormalVariable.create;
        aVar.VarIndex:=v;
        aVar.Block:=Inf.Block;
      end;
      dec(v)
    end;
    dec(i)
  end;
end;

{TFuncCallerCompiler}
procedure TFuncCallerCompiler.DoIt;
var 
    w:KeyType;
    St:string;
    Inf:TProcHeaderInfo;
    i,c:integer;
    Cal:TProcCaller;
    VCInfo:TVarCompileInfo;
    P:TParametr;
    canassign:boolean;
    E:TOilOperator;
    aV:TNormalVariable;
    VClass,InfClass:TElementClass;
begin
  Output:=nil;
  try
  w:=NextWord(St);St:=AnsiUppercase(st);
  if (w<>kw_slovo)then
    raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'identifiktor procedury');
  Inf:=nil;
  i:=FuncInfolist.Count-1;
  while (i>=0) and (Inf=nil) do
  begin
    if TProcheaderInfo(FuncInfolist.Elements[i]).Procname=St then
      Inf:=TProcheaderInfo(FuncInfolist.Elements[i]);
    dec(i);
  end;
  if inf=nil then
    raise TCompilerError.CreatePos(15,PreCompiler.RealLine,PreCompiler.RealPos,'');
  if StopLetter<>'(' then
    raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,'(');
  w:=NextWord(St);
  Cal:=TProcCaller.Create;
  Output:=Cal;
  Cal.OilProc:=Inf.OilProc;
  (*
 TProcCaller=class(TCaller)
 property Parameters:TEntity read GetParams write SetParams;
 property OilProc:TOilProc read GetProc write SetProc;

 TVarCompileInfo=class(TElement) {clen seznamu volanych promennych}
  VarName:string;
  Status:TVarStatus;
  VarIndex:longint;
  Typ:TType;
  TypeName:string;

TParametr=class(TEntity)
 VarIndex:longint;
 property Expression:TOilOperator read GetExp write SetExp;
  *)
  c:=Inf.Count;
  if c>0 then
  begin {nacitamparametry}
    i:=1;
    while i<c do
    begin
       VCInfo:=TVarCompileInfo(Inf.Elements[i]);
       P:=TParametr.Create;
       Cal.Parameters.AddElement(P);
       P.VarIndex:=VCInfo.VarIndex;
       case VCInfo.Status of
       primary:   {P}
       begin
         ExpressionCompiler.doit;
         E:=TOilOperator(ExpressionCompiler.Output);
         P.Expression:=E;
         E.GetTypeInfo;
         case VCInfo.Typ of
           _Integer:canassign:=E.TypeItem[_integer]or E.TypeItem[_byte] or E.TypeItem[_Other];
           _Float:canassign:=E.TypeItem[_float]or E.TypeItem[_integer]or E.TypeItem[_byte] or E.TypeItem[_Other];
           _Char:canassign:=E.TypeItem[_char]or E.TypeItem[_Other];
           _Boolean:canassign:=E.TypeItem[_boolean]or E.TypeItem[_Other];
           _String:canassign:=E.TypeItem[_string]or E.TypeItem[_Char]or E.TypeItem[_Other];
           _pointer:canassign:=E.TypeItem[_pointer]or E.TypeItem[_Other];
         end;
         E.ClearTypeInfo;
         if not canassign then
           raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
       end;      {P}
       called:   {C}
       begin
         w:=NextWord(St);
         if (w<>kw_slovo)or(not ExistsVariable(St,aV)) then
           raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'promnnou');
           if not (aV is TNormalVariable) then
           begin
             aV.free;
             raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'obyejnou promnnou');
           end;
           E:=TOilConst.Create;
           TOilConst(E).Constant:=TPointerElement.CreateValue(aV);
           P.Expression:=E;
           case VCInfo.Typ of  {vlozeny}
             _Integer:canassign:=aV.typ=_integer;
             _Float:canassign:=aV.typ in[_integer,_float];
             _Char:canassign:=aV.typ=_char;
             _Boolean:canassign:=aV.typ=_boolean;
             _String:canassign:=aV.typ in[_string,_char];
             _pointer:
             begin
               canassign:=E.TypeItem[_pointer]or E.TypeItem[_Other];
               if canassign then
               begin
                 VClass:=GetOrbisClass(aV.TypeName);
                 InfClass:=GetOrbisClass(VCInfo.TypeName);
                 canassign:=VClass.Inheritsfrom(InfClass);
               end;
             end;
           end;{vlozeny case}
        if not canassign then
          raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
        end;{C}
      end;{case}
       {kontrola carky}
      w:=NextWord(St);
      inc(i);
      if c=i then
        PreCompiler.Hold
      else
        if not (w=kw_carka) then
          raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,',');
      end;
    end;
    w:=NextWord(St);
    if not(w=kw_zavorka2) then
      raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,')');
    except if Output<>nil
      then Output.free;Output:=nil;
    raise;
  end;
end;

{TToolCompiler}
procedure TToolCompiler.DoIt;
var 
    w:Keytype;
    St:string;
    aclass:TClass;
    PN,PI,ind:integer;
    P,L:longint;
    PropName:string;
    byname:boolean;
    aTool:TTool;

    function IsProperty(Name:string;var ResPNumber:integer):boolean;
    var 
        OrbClass:TOrbisclass;
        PCount,i:integer;
    begin
      result:=false;
      OrbClass:=TOrbisClass.Create;
      OrbClass.ElementClass:=TToolOperator(Output).ToolClass;
      PCount:=OrbClass.PropCount;
      i:=1;
      while (not result) and (i<=PCount) do
      begin
         result:=result or (AnsiUpperCase(Name)=AnsiUpperCase(OrbClass.PropertyName[i-1]));
         inc(i);
      end;
      ResPNumber:=i-1;
      OrbClass.Free;
    end;
begin
  Output:=nil;
  try
  w:=NextWord(St);
  if w=kw_retezec then
  begin
    St:=Copy(St,2,length(st)-2);
    if St='' then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'nzev nstoje');
    w:=kw_slovo;
  end;
  if w<>kw_slovo then
    raise TCompilerError.CreatePos(3,PreCompiler.RealLine,PreCompiler.RealPos,'');
  if not IsRegisteredTool(St,aClass) then
    raise TCompilerError.CreatePos(13,PreCompiler.RealLine,PreCompiler.RealPos,'');
  Output:=TToolOperator.Create;
  ToolOperator(Output).ToolClass:=TToolClass(aClass);
  if StopLetter<>'('then
    raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,'(');
  NextWord(St);
  {cteni parametru}
  PI:=-1;
  w:=NextWord(St);
  if w<>kw_zavorka2 then
    PreCompiler.Hold;
  while w<>kw_zavorka2 do
  begin
    byname:=false;
    w:=NextWord(PropName);
    P:=PreCompiler.RealPos;L:=PreCompiler.RealLine;
    if w=kw_dvojtecka then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'nzev property');
    if w=kw_slovo then
    begin
      w:=NextWord(St);
      if w=kw_dvojtecka then
        byname:=true
      else
      begin
        PreCompiler.Pos:=P;PreCompiler.Line:=L;
      end;
    end
    else PreCompiler.Hold;
      if not byName then
        begin
          inc(PI);
          aTool:=TToolClass(aClass).Create;
          PropName:=aTool.NumberToPropertyName(PI);
          aTool.Free;
        end;
      if not IsProperty(PropName,PN) then
        raise TCompilerError.CreatePos(14,L,P,'');
      if TToolOperator(Output).PropInputList.Count>0 then
        for ind:=0 to TToolOperator(Output).PropInputList.Count-1 do
          if TToolOperator(Output).PropInputItem[ind].PropIndex=PN then
            raise TCompilerError.CreatePos(12,L,P,'');
      ExpressionCompiler.DoIt;
      TToolOperator(Output).PropInputList.AddElement(TToolInputInfo.Create);
      TToolOperator(Output).PropInputItem[TToolOperator(Output).PropInputList.Count-1].InputExpr:=
      TOilOperator(ExpressionCompiler.Output);
      TToolOperator(Output).PropInputItem[TToolOperator(Output).PropInputList.Count-1].PropIndex:=PN;
      w:=NextWord(St);
      if not (w in[kw_zavorka2,kw_carka]) then raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,',');
  end; {while}
  except if Output<>nil then
    Output.free;
    Output:=nil;
    raise;
  end;
end;

{TPathCompiler}
function TPathCompiler.GetToolCompiler:TToolCompiler;
begin
  if not assigned(FToolCompiler) then
  begin
    FToolCompiler:=TToolCompiler.Create;
    AddTool(FToolCompiler);
    FToolCompiler.BlockInfoList:=BlockInfoList;
    FToolCompiler.FuncInfoList:=FuncInfoList;
    FToolCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FToolCompiler;
end;

procedure TPathCompiler.SetToolCompiler(aComp:TToolCompiler);
begin
  if assigned(FToolCompiler) then
    FreeTool(FToolCompiler);
  AddTool(aComp);
  FToolCompiler:=aComp;
  FToolCompiler.BlockInfoList:=BlockInfoList;
  FToolCompiler.FuncInfoList:=FuncInfoList;
  FToolCompiler.PreCompiler:=PreCompiler;
end;

function TPathCompiler.GetFuncCompiler:TFuncCallerCompiler;
begin
  if not assigned(FFuncCallerCompiler) then
  begin
    FFuncCallerCompiler:=TFuncCallerCompiler.Create;
    AddTool(FFuncCallerCompiler);
    FFuncCallerCompiler.BlockInfoList:=BlockInfoList;
    FFuncCallerCompiler.FuncInfoList:=FuncInfoList;
    FFuncCallerCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FFuncCallerCompiler;
end;

procedure TPathCompiler.SetFuncCompiler(aComp:TFuncCallerCompiler);
begin
  if assigned(FFuncCallerCompiler) then
    FreeTool(FFuncCallerCompiler);
  AddTool(aComp);
  FFuncCallerCompiler:=aComp;
  FFuncCallerCompiler.BlockInfoList:=BlockInfoList;
  FFuncCallerCompiler.FuncInfoList:=FuncInfoList;
  FFuncCallerCompiler.PreCompiler:=PreCompiler;
end;

function TPathCompiler.GetTermCompiler:TTermCompiler;
begin
  if not assigned(FTermCompiler) then
  begin
    FTermCompiler:=TTermCompiler.Create;
    AddTool(FTermCompiler);
    FTermCompiler.BlockInfoList:=BlockInfoList;
    FTermCompiler.FuncInfoList:=FuncInfoList;
    FTermCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FTermCompiler;
end;

procedure TPathCompiler.SetTermCompiler(aComp:TTermCompiler);
begin
   if assigned(FTermCompiler) then
     FreeTool(FTermCompiler);
   AddTool(aComp);
   FTermCompiler:=aComp;
   FTermCompiler.BlockInfoList:=BlockInfoList;
   FTermCompiler.FuncInfoList:=FuncInfoList;
   FTermCompiler.PreCompiler:=PreCompiler;
end;

procedure TPathCompiler.DoIt;
var 
    St:string;
    W,typ:KeyType;
    P,L:longint;
    aV:TNormalVariable;
    dot:boolean;
    tmpO:TOilOperator;
    d1,d2:char;
    E:TOilOperator;
begin
  Output:=nil;
  try
  d1:=PreCompiler.ElementDivider[1];
  d2:=PreCompiler.OwnerDivider[1];
  w:=NextWord(St);
  P:=PreCompiler.RealPos;L:=PreCompiler.RealLine;
  dot:=false;
  case w of
    kw_tecka,kw_ElementDivider,kw_OwnerDivider,kw_bracket,kw_OwnerByNumber:
    begin {od ActiveElementu}
      Output:=TNormalVariable.Create;
      TNormalVariable(Output).Block:=BlockInfo[0].Block;
      TNormalVariable(Output).VarIndex:=ActiveElIndex{poradi Activeelemetu ve stacku};
      PreCompiler.Pos:=P;PreCompiler.Line:=L;
    end;
    kw_nil:
    begin
      Output:=TOilConst.Create;
      TOilConst(Output).Constant:=TPointerElement.CreateValue(nil);
    end;
    kw_slovo:
    begin
      if StopLetter='(' then
      begin {muze byt fce}
        if ExistsFunction(St) then
        begin
          PreCompiler.Hold;
          FuncCallerCompiler.DoIt;
          Output:=FuncCallerCompiler.OutPut;
        end
        else
        begin{tool od Activ Elementu}
          dot:=true;
          Output:=TNormalVariable.Create;
          TNormalVariable(Output).Block:=BlockInfo[0].Block;
          TNormalVariable(Output).VarIndex:=ActiveElIndex;
        end;
      end
      else
      begin
        if ExistsVariable(St,aV) then
          OutPut:=aV
        else
        begin{jde se od Activ Elementu}
          dot:=true;
          Output:=TNormalVariable.Create;
          TNormalVariable(Output).Block:=BlockInfo[0].Block;
          TNormalVariable(Output).VarIndex:=ActiveElIndex;
        end;
      end;
    end;
    else
      raise TCompilerError.CreatePos(3,PreCompiler.RealLine,PreCompiler.RealPos,'');
    end;
    {mam prectene prvni slovo}
    if dot then
    begin
      w:=kw_Tecka;
      PreCompiler.Line:=PreCompiler.RealLine;
      PreCompiler.Pos:=PreCompiler.RealPos;
    end
    else
    begin
      w:=kw_slovo;{jakesi vynulovani}
      if StopLetter in ['.',d1,d2,'['] then
      begin
        w:=NextWord(St);
        if w in [kw_tecka,kw_ElementDivider,kw_OwnerDivider,kw_bracket,kw_OwnerByNumber] then
        begin{typova kontrola}
          TOilOperator(Output).getTypeInfo;
          if not (TOilOperator(Output).TypeItem[_Other] or TOilOperator(Output).TypeItem[_Pointer])then
            raise TCompilerError.CreatePos(9,PreCompiler.RealLine,PreCompiler.RealPos,'');
          TOilOperator(Output).ClearTypeInfo;
        end
        else PreCompiler.Hold;
      end;
    end;
    {mam i zkontolovane prvni slovo}
    while w in [kw_tecka,kw_ElementDivider,kw_OwnerDivider,kw_bracket,kw_OwnerByNumber] do
    begin
      typ:=w;
      L:=PreCompiler.Line;
      P:=PreCompiler.Pos;
      w:=nextWord(St);
      if w=kw_retezec then
      begin
        w:=kw_slovo;
        St:=Copy(St,2,length(St)-2);
      end;
      case typ of
      kw_tecka:
      begin
        if (P<>PreCompiler.RealPos) or (L<>PreCompiler.RealLine) or (w<>kw_slovo) or(St='') then
          raise TCompilerError.CreatePos(1,L,P,'nzev property');
        if StopLetter='(' then
        begin {musi byt tool}
          PreCompiler.Hold;
          ToolCompiler.DoIt;
          tmpO:=TOilOperator(ToolCompiler.OutPut);
          TOilPtrOperator(tmpO).FirstOperator:=TOilOperator(Output);
          Output:=tmpO;
        end
        else
        begin {properta}
          tmpO:=TPropVariable.Create;
          TPropVariable(tmpO).InitialExp:=TOilOperator(Output);
          TPropVariable(tmpO).PropertyName:=St;
          Output:=tmpO;
        end;
      end;
      kw_OwnerDivider:
      begin
        if (P<>PreCompiler.RealPos) or (L<>PreCompiler.RealLine) or (w<>kw_slovo) or(St='') then
          raise TCompilerError.CreatePos(1,L,P,'jmno prvku');
        tmpO:=TOwnerOperator.Create;
        TOwnerOperator(tmpO).FirstOperator:=TOilOperator(Output);
        TOwnerOperator(tmpO).ElementName:=St;
        Output:=TmpO;
      end;
      kw_ElementDivider:
      begin
        if (P<>PreCompiler.RealPos) or (L<>PreCompiler.RealLine) or (w<>kw_slovo) or(St='') then
          raise TCompilerError.CreatePos(1,L,P,'jmno prvku');
        tmpO:=TElementOperator.Create;
        TElementOperator(tmpO).FirstOperator:=TOilOperator(Output);
        TElementOperator(tmpO).ElementName:=St;
        Output:=tmpO;
      end;
      kw_bracket,kw_OwnerByNumber:
      begin
        if typ=kw_bracket then
          tmpO:=TElementByNumberOperator.Create
        else
          tmpO:=TOwnerByNumberOperator.Create;
        TElementByNumberOperator(tmpO).FirstOperator:=TOilOperator(Output);
        Output:=tmpO;
        PreCompiler.Hold;
        TermCompiler.Doit;{ctu prvni vyraz}
        E:=TOilOperator(TermCompiler.output);
        TElementByNumberOperator(Output).PositionIndex:=E;
        E.GetTypeInfo;
        if not (E.TypeItem[_integer] or E.TypeItem[_byte]) then
        begin
          E.ClearTypeInfo;
	  raise TCompilerError.CreatePos(8,PreCompiler.RealLine,PreCompiler.RealPos,'');
        end;
        E.ClearTypeInfo;
        w:=nextWord(St);
        if w<>kw_bracket2 then
          raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,']');
      end;
      end;{case}
      {dalsi cteni}
      w:=kw_slovo;{jakesi vynulovani}
      if StopLetter in ['.',d1,d2,'['] then
      begin
        w:=NextWord(St);
        if not (w in [kw_tecka,kw_ElementDivider,kw_OwnerDivider,kw_bracket,kw_OwnerByNumber]) then
          PreCompiler.Hold;
      end;
    end; {while}
    except
      if Output<>nil then
        Output.free; Output:=nil;
      raise;
      end;
end;

{TFactorCompiler}
function TFactorCompiler.GetExpressionCompiler:TExpressionCompiler;
begin
  if not assigned(FExpressionCompiler) then
  begin
    FExpressionCompiler:=TExpressionCompiler.Create;
    AddTool(FExpressionCompiler);
    FExpressionCompiler.BlockInfoList:=BlockInfoList;
    FExpressionCompiler.FuncInfoList:=FuncInfoList;
    FExpressionCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FExpressionCompiler;
end;

procedure TFactorCompiler.SetExpressionCompiler(aComp:TExpressionCompiler);
begin
  if assigned(FExpressionCompiler) then
    FreeTool(FExpressionCompiler);
  AddTool(aComp);
  FExpressionCompiler:=aComp;
  FExpressionCompiler.BlockInfoList:=BlockInfoList;
  FExpressionCompiler.FuncInfoList:=FuncInfoList;
  FExpressionCompiler.PreCompiler:=PreCompiler;
end;

function TFactorCompiler.GetPathCompiler:TPathCompiler;
begin
  if not assigned(FPathCompiler) then
  begin
    FPathCompiler:=TPathCompiler.Create;
    AddTool(FPathCompiler);
    FPathCompiler.BlockInfoList:=BlockInfoList;
    FPathCompiler.FuncInfoList:=FuncInfoList;
    FPathCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FPathCompiler;
end;

procedure TFactorCompiler.SetPathCompiler(aComp:TPathCompiler);
begin
  if assigned(FPathCompiler) then
    FreeTool(FPathCompiler);
  AddTool(aComp);
  FPathCompiler:=aComp;
  FPathCompiler.BlockInfoList:=BlockInfoList;
  FPathCompiler.FuncInfoList:=FuncInfoList;
  FPathCompiler.PreCompiler:=PreCompiler;
end;


procedure TFactorCompiler.doit;

        function GiveFactor:TOilOperator;
        var
            w:KeyType;
            St:string;
            L,P:longint;
            C:TCharElement;
        begin
          result:=nil;
          try
          w:=Nextword(St);
          case w of
            kw_zavorka:
            begin
              ExpressionCompiler.Doit;
              result:=TOilOperator(ExpressionCompiler.Output);
              w:=NextWord(St);
              L:=PreCompiler.Line;P:=PreCompiler.Pos;
              if w<>kw_zavorka2 then raise TCompilerError.CreatePos(1,L,P,')');
            end;
            kw_celecislo:
            begin
              result:=TOilConst.create;
              TOilConst(result).Constant:=TIntegerElement.CreateValue(trunc(StrToExtended(St)));
            end;
            kw_cislo:
            begin
              result:=TOilConst.create;
              TOilConst(result).Constant:=TFloatElement.CreateValue(StrToExtended(St));
            end;
            kw_retezec:
            begin
              result:=TOilConst.create;
              if (St[1]='''') and (length(St)<=3) then
              begin
                C:=TCharElement.Create;
                C.AsString:=Copy(St,2,length(St)-2);
                TOilConst(result).Constant:=C;
              end
              else
                TOilConst(result).Constant:=TStringElement.CreateValue(Copy(St,2,length(St)-2));
            end;
            kw_true:
            begin
              result:=TOilConst.create;
              TOilConst(result).Constant:=TBooleanElement.CreateValue(true);
            end;
            kw_false:
            begin
              result:=TOilConst.create;
              TOilConst(result).Constant:=TBooleanElement.CreateValue(false);
            end;
            kw_slovo,kw_bracket,kw_nil,kw_tecka,kw_ElementDivider,kw_OwnerDivider:
            begin
              PreCompiler.Hold;
              PathCompiler.DoIt;
              result:=TOilOperator(PathCompiler.Output);
            end;
            kw_not:
            begin
              result:=TOilNot.create;
              TOilNot(result).FirstOperator:=GiveFactor;
              if not result.typecheck then
                raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
            end;
            else
              raise TCompilerError.CreatePos(3,PreCompiler.RealLine,PreCompiler.RealPos,'');
          end;{case}
          except
            if result<>nil then
              result.free;
              result:=nil;
              raise;
            end;
          end;

begin
  Output:=nil;
  Output:=GiveFactor;
end;

{TTermCompiler}
function TTermCompiler.GetFactorCompiler:TFactorCompiler;
begin
  if not assigned(FFactorCompiler) then
  begin
    FFactorCompiler:=TFactorCompiler.Create;
    AddTool(FFactorCompiler);
    FFactorCompiler.BlockInfoList:=BlockInfoList;
    FFactorCompiler.FuncInfoList:=FuncInfoList;
    FFactorCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FFactorCompiler;
end;

procedure TTermCompiler.SetFactorCompiler(aComp:TFactorCompiler);
begin
  if assigned(FFactorCompiler) then
    FreeTool(FFactorCompiler);
  AddTool(aComp);
  FFactorCompiler:=aComp;
  FFactorCompiler.BlockInfoList:=BlockInfoList;
  FFactorCompiler.FuncInfoList:=FuncInfoList;
  FFactorCompiler.PreCompiler:=PreCompiler;
end;

procedure TTermCompiler.Doit;
var
    w:KeyType;
    konec:boolean;
    St:string;
    O:TOilTwoPtrOperator;
begin
  Output:=nil;
  try
  FactorCompiler.DoIt;
  Output:=FactorCompiler.Output;
  konec:=false;
  repeat
    w:=NextWord(St);
    if w in [kw_krat,kw_deleno,kw_MOD,kw_DIV,kw_AND] then
    begin
      case w of
       	kw_krat:O:=TOilKrat.create;
        kw_deleno:O:=TOilDeleno.create;
        kw_MOD:O:=TOilMod.create;
        kw_DIV:O:=TOilDiv.create;
        kw_AND:O:=TOilAnd.create;
      end;{case}
      O.FirstOperator:=TOilOperator(Output);
      Output:=O;
      FactorCompiler.DoIt;
      TOilTwoPtrOperator(Output).SecondOperator:=TOilOperator(FactorCompiler.Output);
      if not TOilOperator(Output).TypeCheck then
        raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
    end
    else
    begin
      PreCompiler.Hold;
      konec:=true;
    end;
  until konec;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

{TSimpleExprCompiler}
function TSimpleExpCompiler.GetTermCompiler:TTermCompiler;
begin
  if not assigned(FTermCompiler) then
  begin
    FTermCompiler:=TTermCompiler.Create;
    AddTool(FTermCompiler);
    FTermCompiler.BlockInfoList:=BlockInfoList;
    FTermCompiler.FuncInfoList:=FuncInfoList;
    FTermCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FTermCompiler;
end;

procedure TSimpleExpCompiler.SetTermCompiler(aComp:TTermCompiler);
begin
  if assigned(FTermCompiler) then
    FreeTool(FTermCompiler);
  AddTool(aComp);
  FTermCompiler:=aComp;
  FTermCompiler.BlockInfoList:=BlockInfoList;
  FTermCompiler.FuncInfoList:=FuncInfoList;
  FTermCompiler.PreCompiler:=PreCompiler;
end;

procedure TSimpleExpCompiler.DoIt;
var
    w:KeyType;
    St:string;
    UnM:TOilUnMinus;
    konec:boolean;
    O:TOilTwoPtrOperator;
begin
  Output:=nil;
  UnM:=nil;
  try
    w:=nextWord(St);
  case w of
    kw_plus:;
    kw_minus:UnM:=TOilUnMinus.Create;
  else
    PreCompiler.Hold;
  end;
  TermCompiler.DoIt;
  Output:=TermCompiler.Output;
  konec:=false;
  repeat
    w:=NextWord(St);
    if w in [kw_plus,kw_minus,kw_OR] then
    begin
      case w of
        kw_plus:O:=TOilPlus.create;
        kw_minus:O:=TOilMinus.create;
        kw_OR:O:=TOilOr.create;
      end;{case}
      O.FirstOperator:=TOilOperator(Output);
      Output:=O;
      TermCompiler.DoIt;
      TOilTwoPtrOperator(Output).SecondOperator:=TOilOperator(TermCompiler.Output);
      if not TOilOperator(Output).TypeCheck then
         raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
    end
    else
    begin
      PreCompiler.Hold;
      konec:=true;
    end;
  until
    konec;
  if UnM<>nil then
  begin
    UnM.FirstOperator:=TOilOperator(Output);
    Output:=UnM;
    UnM:=nil;
  end;
  if not TOilOperator(Output).TypeCheck then
    raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
    except
      if Output<>nil then
        Output.free;Output:=nil;
      if UnM<>nil then
        UnM.free;
      raise;
    end;
end;

{TExpressionCompiler}
function TExpressionCompiler.GetSimpleExpCompiler:TSimpleExpCompiler;
begin
  if not assigned(FSimpleExpCompiler) then
  begin
    FSimpleExpCompiler:=TSimpleExpCompiler.Create;
    AddTool(FSimpleExpCompiler);
    FSimpleExpCompiler.BlockInfoList:=BlockInfoList;
    FSimpleExpCompiler.FuncInfoList:=FuncInfoList;
    FSimpleExpCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FSimpleExpCompiler;
end;

procedure TExpressionCompiler.SetSimpleExpCompiler(aComp:TSimpleExpCompiler);
begin
  if assigned(FSimpleExpCompiler) then
    FreeTool(FSimpleExpCompiler);
  AddTool(aComp);
  FSimpleExpCompiler:=aComp;
  FSimpleExpCompiler.BlockInfoList:=BlockInfoList;
  FSimpleExpCompiler.FuncInfoList:=FuncInfoList;
  FSimpleExpCompiler.PreCompiler:=PreCompiler;
end;

procedure TExpressionCompiler.DoIt;
var
    w:KeyType;
    St:string;
    O:TOilTwoPtrOperator;
begin
  Output:=nil;
  try
  SimpleExpCompiler.DoIt;
  Output:=TOilOperator(SimpleExpCompiler.Output);
  w:=nextWord(St);
  if w in[kw_vetsi,kw_mensi,kw_rovno,kw_mensirovno,kw_vetsirovno,kw_ruzne] then
  begin
    case w of
      kw_vetsi:O:=TOilVetsi.Create;
      kw_mensi:O:=TOilMensi.Create;
      kw_rovno:O:=TOilRovno.Create;
      kw_mensirovno:O:=TOilMensiRovno.Create;
      kw_vetsirovno:O:=TOilVetsiRovno.Create;
      kw_ruzne:O:=TOilRuzne.Create;
    end;{case}
    O.FirstOperator:=TOilOperator(Output);
    Output:=O;
    SimpleExpCompiler.DoIt;
    TOilTwoPtrOperator(Output).SecondOperator:=TOilOperator(SimpleExpCompiler.Output);
    if not TOilOperator(Output).TypeCheck then
      raise TCompilerError.CreatePos(8,PreCompiler.Line,PreCompiler.Pos,'');
  end
  else
    PreCompiler.Hold;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

{TCommandCompiler}
function TCommandCompiler.GetForCompiler:TForCompiler;
begin
  if not assigned(FForCompiler) then
  begin
    FForCompiler:=TForCompiler.Create;
    AddTool(FForCompiler);
    FForCompiler.BlockInfoList:=BlockInfoList;
    FForCompiler.FuncInfoList:=FuncInfoList;
    FForCompiler.PreCompiler:=PreCompiler;
    FForCompiler.debuged:=debuged;
  end;
  result:=FForCompiler;
end;


procedure TCommandCompiler.SetForCompiler(aComp:TForCompiler);
begin
  if assigned(FForCompiler) then
    FreeTool(FForCompiler);
  AddTool(aComp);
  FForCompiler:=aComp;
  FForCompiler.BlockInfoList:=BlockInfoList;
  FForCompiler.FuncInfoList:=FuncInfoList;
  FForCompiler.PreCompiler:=PreCompiler;
  FForCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetWhileCompiler:TWhileCompiler;
begin
  if not assigned(FWhileCompiler) then
  begin
    FWhileCompiler:=TWhileCompiler.Create;
    AddTool(FWhileCompiler);
    FWhileCompiler.BlockInfoList:=BlockInfoList;
    FWhileCompiler.FuncInfoList:=FuncInfoList;
    FWhileCompiler.PreCompiler:=PreCompiler;
    FWhileCompiler.debuged:=debuged;
  end;
  result:=FWhileCompiler;
end;


procedure TCommandCompiler.SetWhileCompiler(aComp:TWhileCompiler);
begin
  if assigned(FWhileCompiler) then
    FreeTool(FWhileCompiler);
  AddTool(aComp);
  FWhileCompiler:=aComp;
  FWhileCompiler.BlockInfoList:=BlockInfoList;
  FWhileCompiler.FuncInfoList:=FuncInfoList;
  FWhileCompiler.PreCompiler:=PreCompiler;
  FWhileCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetIfCompiler:TIfCompiler;
begin
  if not assigned(FIfCompiler) then
  begin
    FIfCompiler:=TIfCompiler.Create;
    AddTool(FIfCompiler);
    FIfCompiler.BlockInfoList:=BlockInfoList;
    FIfCompiler.FuncInfoList:=FuncInfoList;
    FIfCompiler.PreCompiler:=PreCompiler;
    FIfCompiler.debuged:=debuged;
  end;
  result:=FIfCompiler;
end;


procedure TCommandCompiler.SetIfCompiler(aComp:TIfCompiler);
begin
  if assigned(FIfCompiler) then
    FreeTool(FIfCompiler);
  AddTool(aComp);
  FIfCompiler:=aComp;
  FIfCompiler.BlockInfoList:=BlockInfoList;
  FIfCompiler.FuncInfoList:=FuncInfoList;
  FIfCompiler.PreCompiler:=PreCompiler;
  FIfCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetRepeatCompiler:TRepeatCompiler;
begin
  if not assigned(FRepeatCompiler) then
  begin
    FRepeatCompiler:=TRepeatCompiler.Create;
    AddTool(FRepeatCompiler);
    FRepeatCompiler.BlockInfoList:=BlockInfoList;
    FRepeatCompiler.FuncInfoList:=FuncInfoList;
    FRepeatCompiler.PreCompiler:=PreCompiler;
    FRepeatCompiler.debuged:=debuged;
  end;
  result:=FRepeatCompiler;
end;


procedure TCommandCompiler.SetRepeatCompiler(aComp:TRepeatCompiler);
begin
  if assigned(FRepeatCompiler) then
    FreeTool(FRepeatCompiler);
  AddTool(aComp);
  FRepeatCompiler:=aComp;
  FRepeatCompiler.BlockInfoList:=BlockInfoList;
  FRepeatCompiler.FuncInfoList:=FuncInfoList;
  FRepeatCompiler.PreCompiler:=PreCompiler;
  FRepeatCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetCaseCompiler:TCaseCompiler;
begin
  if not assigned(FCaseCompiler) then
  begin
    FCaseCompiler:=TCaseCompiler.Create;
    AddTool(FCaseCompiler);
    FCaseCompiler.BlockInfoList:=BlockInfoList;
    FCaseCompiler.FuncInfoList:=FuncInfoList;
    FCaseCompiler.PreCompiler:=PreCompiler;
    FCaseCompiler.debuged:=debuged;
  end;
  result:=FCaseCompiler;
end;


procedure TCommandCompiler.SetCaseCompiler(aComp:TCaseCompiler);
begin
  if assigned(FCaseCompiler) then
    FreeTool(FCaseCompiler);
  AddTool(aComp);
  FCaseCompiler:=aComp;
  FCaseCompiler.BlockInfoList:=BlockInfoList;
  FCaseCompiler.FuncInfoList:=FuncInfoList;
  FCaseCompiler.PreCompiler:=PreCompiler;
  FCaseCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetBeginCompiler:TBeginCompiler;
begin
  if not assigned(FBeginCompiler) then
  begin
    FBeginCompiler:=TBeginCompiler.Create;
    AddTool(FBeginCompiler);
    FBeginCompiler.BlockInfoList:=BlockInfoList;
    FBeginCompiler.FuncInfoList:=FuncInfoList;
    FBeginCompiler.PreCompiler:=PreCompiler;
    FBeginCompiler.debuged:=debuged;
  end;
  result:=FBeginCompiler;
end;


procedure TCommandCompiler.SetBeginCompiler(aComp:TBeginCompiler);
begin
  if assigned(FBeginCompiler) then
    FreeTool(FBeginCompiler);
  AddTool(aComp);
  FBeginCompiler:=aComp;
  FBeginCompiler.BlockInfoList:=BlockInfoList;
  FBeginCompiler.FuncInfoList:=FuncInfoList;
  FBeginCompiler.PreCompiler:=PreCompiler;
  FBeginCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetTryCompiler:TTryCompiler;
begin
  if not assigned(FTryCompiler) then
  begin
    FTryCompiler:=TTryCompiler.Create;
    AddTool(FTryCompiler);
    FTryCompiler.BlockInfoList:=BlockInfoList;
    FTryCompiler.FuncInfoList:=FuncInfoList;
    FTryCompiler.PreCompiler:=PreCompiler;
    FTryCompiler.debuged:=debuged;
  end;
  result:=FTryCompiler;
end;


procedure TCommandCompiler.SetTryCompiler(aComp:TTryCompiler);
begin
  if assigned(FTryCompiler) then
    FreeTool(FTryCompiler);
  AddTool(aComp);
  FTryCompiler:=aComp;
  FTryCompiler.BlockInfoList:=BlockInfoList;
  FTryCompiler.FuncInfoList:=FuncInfoList;
  FTryCompiler.PreCompiler:=PreCompiler;
  FTryCompiler.debuged:=debuged;
end;

function TCommandCompiler.GetOtherCompiler:TOtherCompiler;
begin
  if not assigned(FOtherCompiler) then
  begin
    FOtherCompiler:=TOtherCompiler.Create;
    AddTool(FOtherCompiler);
    FOtherCompiler.BlockInfoList:=BlockInfoList;
    FOtherCompiler.FuncInfoList:=FuncInfoList;
    FOtherCompiler.PreCompiler:=PreCompiler;
    FOtherCompiler.debuged:=debuged;
  end;
  result:=FOtherCompiler;
end;


procedure TCommandCompiler.SetOtherCompiler(aComp:TOtherCompiler);
begin
  if assigned(FOtherCompiler) then
    FreeTool(FOtherCompiler);
  AddTool(aComp);
  FOtherCompiler:=aComp;
  FOtherCompiler.BlockInfoList:=BlockInfoList;
  FOtherCompiler.FuncInfoList:=FuncInfoList;
  FOtherCompiler.PreCompiler:=PreCompiler;
end;

procedure TCommandCompiler.DoIt;
var
    w:keytype;
    St:string;
    PL:TOilLine;
begin
  Output:=nil;
  try
  w:=NextWord(St);
  if w in [kw_BEGIN,kw_IF,kw_CASE,kw_WHILE, kw_REPEAT,kw_FOR,kw_TRY,kw_strednik,kw_eof] then
  begin
    PreCompiler.Hold;
    case w of
        kw_BEGIN:
        begin
          BeginCompiler.DoIt;
          PL:=TOilLine(BeginCompiler.Output);
        end;
        kw_IF:
        begin
          IfCompiler.DoIt;
          PL:=TOilLine(IfCompiler.Output);
        end;
        kw_CASE:
        begin
          CaseCompiler.DoIt;
          PL:=TOilLine(CaseCompiler.Output);
        end;
        kw_WHILE:
        begin
          WhileCompiler.DoIt;
          PL:=TOilLine(WhileCompiler.Output);
        end;
        kw_REPEAT:
        begin
          RepeatCompiler.DoIt;
          PL:=TOilLine(RepeatCompiler.Output);
        end;
        kw_FOR:
        begin
          ForCompiler.DoIt;
          PL:=TOilLine(ForCompiler.Output);
        end;
        kw_TRY:
        begin
          TryCompiler.DoIt;
          PL:=TOilLine(TryCompiler.Output);
        end;
        kw_strednik:
        begin
          PL:=nil;
        end;
        kw_eof:raise TCompilerError.CreatePos(17,PreCompiler.RealLine,PreCompiler.RealPos,'');
      end;{case}
    Output:=PL;
  end
  else
  begin {OtherCompiler}
    PreCompiler.Hold;
    OtherCompiler.DoIt;
    Output:=OtherCompiler.Output;
  end;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end
end;

{TLineCompiler}
function TLineCompiler.GetCommandCompiler:TCommandCompiler;
begin
  if not assigned(FCommandCompiler) then
  begin
    FCommandCompiler:=TCommandCompiler.Create;
    AddTool(FCommandCompiler);
    FCommandCompiler.BlockInfoList:=BlockInfoList;
    FCommandCompiler.FuncInfoList:=FuncInfoList;
    FCommandCompiler.PreCompiler:=PreCompiler;
    FCommandCompiler.Debuged:=Debuged;
  end;
  result:=FCommandCompiler;
end;

procedure TLineCompiler.SetCommandCompiler(aComp:TCommandCompiler);
begin
  if assigned(FCommandCompiler) then
    FreeTool(FCommandCompiler);
  AddTool(aComp);
  FCommandCompiler:=aComp;
  FCommandCompiler.BlockInfoList:=BlockInfoList;
  FCommandCompiler.FuncInfoList:=FuncInfoList;
  FCommandCompiler.PreCompiler:=PreCompiler;
  FCommandCompiler.Debuged:=Debuged;
end;

{TWithExprCompiler}
constructor TWithExprCompiler.Create;
begin
  inherited Create;
  Debuged:=false;
end;

function TWithExprCompiler.GetExpressionCompiler:TExpressionCompiler;
begin
  if not assigned(FExpressionCompiler) then
  begin
    FExpressionCompiler:=TExpressionCompiler.Create;
    AddTool(FExpressionCompiler);
    FExpressionCompiler.BlockInfoList:=BlockInfoList;
    FExpressionCompiler.FuncInfoList:=FuncInfoList;
    FExpressionCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FExpressionCompiler;
end;

procedure TWithExprCompiler.SetExpressionCompiler(aComp:TExpressionCompiler);
begin
  if assigned(FExpressionCompiler) then
    FreeTool(FExpressionCompiler);
  AddTool(aComp);
  FExpressionCompiler:=aComp;
  FExpressionCompiler.BlockInfoList:=BlockInfoList;
  FExpressionCompiler.FuncInfoList:=FuncInfoList;
  FExpressionCompiler.PreCompiler:=PreCompiler;
end;

{TForCompiler}
procedure TForCompiler.DoIt;
var
    w:keytype;
    St:string;
    aV:TNormalVariable;
    Vtype:TType;
    E:TOilOperator;
begin
  Output:=nil;
  av:=nil;
  try
    w:=nextWord(St);
    if w<>kw_FOR then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'FOR');
    if debuged then
    begin
      Output:=TDBForLine.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TForLine.Create;
    w:=nextWord(St);{ctu promennou}
    if (w<>kw_slovo)or(not ExistsVariable(St,aV)) then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'promnnou');
    if not (aV is TNormalVariable) then
    begin
      aV.free;
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'obyejnou promnnou');
    end;
    TForLine(Output).Variable:=TNormalvariable(aV);
    VType:=aV.typ;
    if not(VType in [_integer,_char]) then
      raise TCompilerError.CreatePos(6,PreCompiler.RealLine,PreCompiler.RealPos,'');
    w:=nextWord(St);{ctu :=}
    if (w<>kw_assign)then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':=');
    ExpressionCompiler.Doit;{ctu prvni vyraz}
    E:=TOilOperator(ExpressionCompiler.output);
    TForLine(Output).Startvalue:=E;
    E.GetTypeInfo;
    if not E.TypeItem[VType] then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(8,PreCompiler.RealLine,PreCompiler.RealPos,'');
    end;
    E.ClearTypeInfo;
    w:=nextWord(St);{ctu to nebo downto}
    if not(w in [kw_TO,kw_DOWNTO])then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'TO(DOWNTO)');
    TForLine(Output).Increase:=w=kw_To;
    ExpressionCompiler.Doit;{ctu druhy vyraz}
    E:=TOilOperator(ExpressionCompiler.output);
    TForLine(Output).Endvalue:=E;
    E.GetTypeInfo;
    if not E.TypeItem[VType] then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(8,PreCompiler.RealLine,PreCompiler.RealPos,'');
    end;
    E.ClearTypeInfo;
    w:=nextWord(St);{ctu do}
    if w<>kw_DO then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'DO');
    CommandCompiler.DoIt;{ctu blok}
    TForLine(Output).Block:=TOilLine(CommandCompiler.Output);
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

procedure TIfCompiler.DoIt;
var
    w:Keytype;
    St:string;
    E:TOilOperator;
begin
  Output:=nil;
  try
    w:=nextWord(St);
    if w<>kw_IF then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'IF');
    if debuged then
    begin
      Output:=TDBIfLine.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TIfLine.Create;
    ExpressionCompiler.Doit;{ctu vyraz}
    E:=TOilOperator(ExpressionCompiler.output);
    TIfLine(Output).Expression:=E;
    E.GetTypeInfo;
    if not E.TypeItem[_boolean] then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'logick vraz');
    end;
    E.ClearTypeInfo;
    w:=nextWord(St);{ctu then}
    if w<>kw_THEN then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'THEN');
    CommandCompiler.DoIt;{ctu thenblok}
    TIfLine(Output).ThenBlock:=TOilLine(CommandCompiler.Output);
    w:=nextWord(St);{ctu do}
    if not(w in[kw_strednik,kw_else]) then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'ELSE');
    TIfLine(Output).ElseBlock:=nil;
    if w=kw_else then
    begin
      CommandCompiler.DoIt;{ctu thenblok}
      TIfLine(Output).ElseBlock:=TOilLine(CommandCompiler.Output);
    end
    else
      PreCompiler.Hold;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

procedure TWhileCompiler.DoIt;
var
    w:Keytype;
    St:string;
    E:TOilOperator;
begin
  Output:=nil;
  try
    w:=nextWord(St);
    if w<>kw_WHILE then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'WHILE');
    if debuged then
    begin
      Output:=TDBWhileLine.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TWhileLine.Create;
    ExpressionCompiler.Doit;{ctu vyraz}
    E:=TOilOperator(ExpressionCompiler.output);
    TWhileLine(Output).Expression:=E;
    E.GetTypeInfo;
    if not E.TypeItem[_boolean] then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'logick vraz');
    end;
    E.ClearTypeInfo;
    w:=nextWord(St);{ctu do}
    if w<>kw_DO then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'DO');
    CommandCompiler.DoIt;{ctu blok}
    TWhileLine(Output).Block:=TOilLine(CommandCompiler.Output);
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

procedure TRepeatCompiler.Doit;
var
    w:Keytype;
    St:string;
    E:TOilOperator;
begin
  Output:=nil;
  try
    w:=nextWord(St);
    if w<>kw_REPEAT then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'REPEAT');
    if debuged then
    begin
      Output:=TDBRepeatLine.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TRepeatLine.Create;
    w:=NextWord(St);
    while w<>kw_UNTIL do
    begin
      PreCompiler.Hold;
      CommandCompiler.DoIt;{ctu radku}
      TRepeatLine(Output).AddPrgLine(TOilLine(CommandCompiler.Output));
      w:=nextWord(St);
      if w<>kw_strednik then raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
      w:=nextWord(St);
    end;
    ExpressionCompiler.Doit;{ctu vyraz}
    E:=TOilOperator(ExpressionCompiler.output);
    TRepeatLine(Output).Expression:=E;
    E.GetTypeInfo;
    if not E.TypeItem[_boolean] then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'logick vraz');
    end;
    E.ClearTypeInfo;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

procedure TTryCompiler.DoIt;
var
    w:Keytype;
    St:string;
begin
  Output:=nil;
  try
    w:=nextWord(St);
    if w<>kw_TRY then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'TRY');
    if debuged then
    begin
      Output:=TDBProtectBlock.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TProtectBlock.Create;
    {pridat infolist}
    w:=NextWord(St);
    while w<>kw_END do
    begin
      PreCompiler.Hold;
      CommandCompiler.DoIt;{ctu radku}
      TProtectBlock(Output).Addprgline(TOilLine(CommandCompiler.Output));
      w:=nextWord(St);
      if w<>kw_strednik then
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
      w:=NextWord(St);
    end;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;


procedure TBeginCompiler.DoIt;
var
    w:Keytype;
    St:string;
    I:TBlockInfo;
begin
  Output:=nil;
  try
  w:=nextWord(St);
  if w<>kw_BEGIN then
    raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'BEGIN');
  if debuged then
  begin
    Output:=TDBOilBlock.Create;
    TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
  end
  else
    Output:=TOilBlock.Create;
  I:=TBlockInfo.Create;
  I.BlockType:=_BeginBlock;
  I.Block:=TOilBlock(Output);
  TOilBlock(Output).Stack:=CurentBlockInfo.block.Stack;
  if debuged  then
    TDBOilBlock(Output).NameStack:=TDBOilBlock(CurentBlockInfo.block).NameStack;
  CurentBlockInfo:=I;
  w:=NextWord(St);
  while w<>kw_END do
  begin
    PreCompiler.Hold;
    CommandCompiler.DoIt;{ctu radku}
    TOilBlock(Output).Addprgline(TOilLine(CommandCompiler.Output));
    w:=nextWord(St);
    if w<>kw_strednik then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
    w:=NextWord(St);
  end;
  FreeCurentBlockInfo;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

procedure TCaseCompiler.DoIt;
var
    w:Keytype;
    St:string;
    E:TOilOperator;
    Cons:TTypeElement;
begin
  Output:=nil;
  try
    w:=nextWord(St);
    if w<>kw_CASE then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'CASE');
    if debuged then
    begin
      Output:=TDBCaseLine.Create;
      TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
    end
    else
      Output:=TCaseLine.Create;
    ExpressionCompiler.DoIt;
    E:=TOilOperator(ExpressionCompiler.Output);
    TCaseLine(Output).Expression:=E;
    E.GetTypeInfo;
    if not(E.TypeItem[_char] or E.TypeItem[_integer]or E.TypeItem[_boolean]or E.TypeItem[_string]or E.TypeItem[_float]) then
    begin
      E.ClearTypeInfo;
      raise TCompilerError.CreatePos(7,PreCompiler.RealLine,PreCompiler.RealPos,'');
    end;
    E.ClearTypeInfo;
    w:=nextWord(St);
    if w<>kw_OF then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'OF');
    w:=nextWord(St);
    repeat {jednotlive itemy}
      case w of
          kw_cislo:TIntegerElement.CreateValue(trunc(StrToExtended(St)));
          kw_celecislo:TFloatElement.CreateValue(StrToExtended(St));
          kw_retezec:TStringElement.CreateValue(Copy(St,2,length(St)-2));
          kw_true,kw_false:TBooleanElement.CreateValue(w=kw_true);
      else
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'konstantu');
      end;{case}
      TCaseLine(Output).CaseItem[TCaseLine(Output).CaseList.Count]:=Cons;
      w:=nextWord(St);
      if w<>kw_dvojtecka then
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':');
      CommandCompiler.Doit;
      TCaseLine(Output).BlockItem[TCaseLine(Output).BlockList.Count]:=TOilLine(CommandCompiler.OutPut);
      w:=nextWord(St);
    until w in[kw_END,kw_ELSE];
    if w=kw_ELSE then
    begin
      CommandCompiler.Doit;
      TCaseLine(Output).ElseBlock:=TOilLine(CommandCompiler.OutPut);
    end;
  except
    if Output<>nil then
      Output.free;Output:=nil;
    raise;
  end;
end;

{TOtherCompiler}
function TOtherCompiler.GetTermCompiler:TTermCompiler;
begin
  if not assigned(FTermCompiler) then
  begin
    FTermCompiler:=TTermCompiler.Create;
    AddTool(FTermCompiler);
    FTermCompiler.BlockInfoList:=BlockInfoList;
    FTermCompiler.FuncInfoList:=FuncInfoList;
    FTermCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FTermCompiler;
end;

procedure TOtherCompiler.SetTermCompiler(aComp:TTermCompiler);
begin
  if assigned(FTermCompiler) then
    FreeTool(FTermCompiler);
  AddTool(aComp);
  FTermCompiler:=aComp;
  FTermCompiler.BlockInfoList:=BlockInfoList;
  FTermCompiler.FuncInfoList:=FuncInfoList;
  FTermCompiler.PreCompiler:=PreCompiler;
end;

function TOtherCompiler.GetFuncCallerCompiler:TFuncCallerCompiler;
begin
  if not assigned(FFuncCallerCompiler) then
  begin
    FFuncCallerCompiler:=TFuncCallerCompiler.Create;
    AddTool(FFuncCallerCompiler);
    FFuncCallerCompiler.BlockInfoList:=BlockInfoList;
    FFuncCallerCompiler.FuncInfoList:=FuncInfoList;
    FFuncCallerCompiler.PreCompiler:=PreCompiler;
  end;
  result:=FFuncCallerCompiler;
end;

procedure TOtherCompiler.SetFuncCallerCompiler(aComp:TFuncCallerCompiler);
begin
  if assigned(FFuncCallerCompiler) then
    FreeTool(FFuncCallerCompiler);
  AddTool(aComp);
  FFuncCallerCompiler:=aComp;
  FFuncCallerCompiler.BlockInfoList:=BlockInfoList;
  FFuncCallerCompiler.FuncInfoList:=FuncInfoList;
  FFuncCallerCompiler.PreCompiler:=PreCompiler;
end;

procedure TOtherCompiler.DoIt;
var
    w:Keytype;
    St,St2:string;
    Done,ven:boolean;
    L,P,L1,P1,C,i:longint;
    vars:integer;
    B:TOilBlock;
    aV:TNormalVariable;
    tmp:TExprLine;
    av1:TVariable;
    VType:TType;
    VI:TVarInfo;

      function TypeCheck(Op1,Op2:TOilOperator):boolean;
      var
          i:TType;
      begin
        Op1.GetTypeInfo;
        Op2.GetTypeInfo;
        result:=false;
        for i:=_Boolean to _Other do
          result:=(result or (Op1.TypeItem[i] and Op2.TypeItem[i]));
        result:=result or (Op1.TypeItem[_float] and Op2.TypeItem[_integer]);
        result:=result or (Op1.TypeItem[_float] and Op2.TypeItem[_byte]);
        result:=result or (Op1.TypeItem[_integer] and Op2.TypeItem[_byte]);
        result:=result or (Op1.TypeItem[_string] and Op2.TypeItem[_char]);
        Op1.CleartypeInfo;
        Op2.ClearTypeInfo;
      end;

      function CanCreateVariable(VName:string):boolean;
      var
          Inf:TBlockInfo;
          i,j:longint;
      begin
        result:=false;
        Inf:=CurentBlockInfo;
        VName:=AnsiUpperCase(VName);
        j:=Inf.block.varinfoList.Count;
        i:=0;
        while (i<j)and (Inf.VarName[i]<>VName) do
          inc(i);
        if (i>=j) then
          result:=true;
      end;


begin
  Output:=nil;
  try
    w:=NextWord(St);
    Done:=false;
    L:=PreCompiler.RealLine;P:=PreCompiler.RealPos;
    if w=kw_slovo then
    begin
      if (StopLetter='(')and ExistsProcedure(St) then
      begin {volani procedury}
        PreCompiler.Hold;
        FuncCallerCompiler.DoIt;
        if debuged then
        begin
          Output:=TDBExprLine.Create;
          TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
        end
        else
          Output:=TExprLine.Create;
        TExprLine(Output).Operator:=TOilOperator(FuncCallerCompiler.Output);
        Done:=true;
      end
      else
      begin{deklarace nove promenne}
        w:=NextWord(St2);
        if (w in [kw_dvojtecka,kw_carka]) then
        begin
          vars:=0;
          B:=CurentBlockInfo.Block;
          C:=B.VarInfoList.Count-1;
          ven:=false;
          repeat {cyklus po jednotlivych promenych}
            inc(vars);
            inc(c);
            {zaradim promenou do seznamu}
            if (not CanCreateVariable(St)) then
              raise TCompilerError.CreatePos(11,L,P,'');
            if (C=Maxvariables) then
              raise TCompilerError.CreatePos(12,PreCompiler.RealLine,PreCompiler.RealPos,'');
            if debuged then
            begin
              VI:=TDBVarInfo.Create;
              TDBVarInfo(VI).varname:=AnsiUpperCase(St);
            end
            else
              VI:=TVarInfo.Create;
            B.VarInfoList.AddElement(VI);
            CurentBlockInfo.VarName[C]:=AnsiUpperCase(St);
            ven:=w=kw_dvojtecka;
            if (not ven) then
            begin
              w:=NextWord(St);
              L:=PreCompiler.RealLine;P:=PreCompiler.RealPos;
              if w<>kw_slovo then
                raise TCompilerError.CreatePos(1,L,P,'nzev promnn');
              w:=NextWord(St2);
              if not (w in [kw_dvojtecka,kw_carka]) then
                raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':');
            end;
          until ven;
          {zjisteni typu}
          w:=NextWord(St2);
          if not (w in[kw_slovo,kw_INTEGER,kw_FLOAT, kw_CHAR, kw_BOOLEAN,kw_STRING])
             then raise TCompilerError.CreatePos(3,PreCompiler.RealLine,PreCompiler.RealPos,'');
          St2:=AnsiUpperCase(St2);
          case w of
              kw_INTEGER:VType:=_Integer;
              kw_FLOAT:VType:=_Float;
              kw_CHAR:VType:=_Char;
              kw_BOOLEAN:VType:=_Boolean;
              kw_STRING:VType:=_String;
              kw_slovo:
              begin
                St2:=CheckClassName(St2);
                if GetOrbisClass(St2)=nil then
                   raise TCompilerError.CreatePos(10,PreCompiler.RealLine,PreCompiler.RealPos,'');
                VType:=_Pointer;
              end;
          end;{case}
          for i:=c-vars+1 to C do
          begin
            B.VarTypeName[i]:=St2;
            B.VarType[i]:=VType;
          end;
          if vars=1 then
          begin {muze byt prirazeni}
            w:=NextWord(St);
            if w=kw_assign then
            begin
              if debuged then
              begin
                Output:=TDBAssignLine.Create;
                TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
              end
              else
                Output:=TassignLine.Create;
              av:=TNormalVariable.create;
              aV.VarIndex:=C;
              aV.Block:=B;
              TAssignline(Output).LeftVar:=aV;
              L1:=PreCompiler.Line;P1:=PreCompiler.Pos;
              ExpressionCompiler.DoIt;
              TAssignline(Output).Expression:=TOilOperator(ExpressionCompiler.Output);
              if not TypeCheck(TAssignLine(Output).LeftVar,TAssignLine(Output).Expression) then
                 raise TCompilerError.CreatePos(8,L1,P1,'');
            end
            else
              PreCompiler.Hold;
          end;
          Done:=true;
        end; {muze byt prirazeni}
      end;{deklarace nove promenne}
    end;{kw=kw_slovo}
  if not Done then
  begin
    PreCompiler.Line:=L;PreCompiler.Pos:=P;
    PreCompiler.CancelHold;
    TermCompiler.Doit;
    Output:=TermCompiler.Output;
    if Output is TVariable then
    begin
      w:=nextWord(St);
      if w<>kw_assign then
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':=');
      aV1:=TVariable(Output);
      if debuged then
      begin
        Output:=TDBAssignLine.Create;
        TOilLine(Output).SourceLineNum:=PreCompiler.RealLine;
      end
      else Output:=TAssignLine.Create;
      TAssignLine(Output).leftvar:=av1;
      L1:=PreCompiler.Line;P1:=PreCompiler.Pos;
      ExpressionCompiler.DoIt;
      TAssignline(Output).Expression:=TOilOperator(ExpressionCompiler.Output);
      if not TypeCheck(TAssignLine(Output).LeftVar,TAssignLine(Output).Expression) then
        raise TCompilerError.CreatePos(8,L1,P1,'');
      end
     else
       if (Output is TToolOperator)or (Output is TCaller) then
       begin
         if debuged then
         begin
           tmp:=TDBExprLine.Create;
           tmp.SourceLineNum:=PreCompiler.RealLine;
         end
         else
           tmp:=TExprLine.Create;
         tmp.Operator:=TOilOperator(Output);
         Output:=tmp;
       end
       else
         raise TCompilerError.CreatePos(3,L,P,'');
  end;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

{ProgramCompiler}
procedure TProgramCompiler.SetSource(aText:TStrings);
begin
  PreCompiler.Source:=aText;
end;

function TProgramCompiler.GetSource:TStrings;
begin
  result:=PreCompiler.Source;
end;

{ zatim nevim jaky typ by se mel v Orbisu zadavat
procedure TProgramCompiler.SetInput(aInput:TElement);
	begin
  if (aInput is TStringList) then Source:=TStrings(aInput)
  		else Source:=nil;
  end;
}

procedure TprogramCompiler.DoIt;
var
    P:TOilProgram;
    w:keytype;
    St:string;
    I:TProcInfo;
    l1,p1:longint;
    VI:TVarInfo;

        procedure DeklaraceVAR(w:string);                  {deklarace promennych}
        var vars:integer; {pocet promennych}
            St: string;
            VInf: TVarCompileInfo;
                { if w = 'var' then DeklaraceVAR(w);
                   :tohle je potreba zaradit do hledani mezi 'Program' a 'Begin'
                   a taky nevim, jak to udelat, kdyz deklaruju vice typu najednou,
                   aby kazdy radek dekl. nemusel zacit 'VAR'}
        begin
          PreCompiler.Hold;
          vars:=0;
          repeat
            repeat                                          {ctu jmena promennych}
               inc(vars);
               w := NextWord(St);
               VInf := TVarCompileInfo.Create;
               VInf.VarName:=St;                      {zalozim informaci o jmenu}
               Inf.AddElement(VInf);
               w := NextWord(St);
               if not (w in[kw_carka,kw_dvojtecka]) then
                 raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':');
            until w = kw_dvojtecka;

            w := NextWord(St);                                             {ctu typ}
            if not (w in[kw_slovo,kw_INTEGER,kw_FLOAT, kw_CHAR, kw_BOOLEAN,kw_STRING]) then
               raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'identifiktor typu');
            case w of
                 kw_INTEGER:    Vtyp := _Integer;
                 kw_FLOAT:      Vtyp := _Float;
                 kw_CHAR:       Vtyp := _Char;
                 kw_BOOLEAN:    Vtyp := _Boolean;
                 kw_STRING:     Vtyp := _String;
                 kw_slovo:
                       begin
                         Vtyp := _pointer;
                         St := CheckClassName(St);
                         if GetOrbisClass(St) = nil then
                           raise TCompilerError.CreatePos(10,PreCompiler.RealLine,PreCompiler.RealPos,'');
                       end
            end;{case}                        
            for i := 1 to vars do                                     {priradim promenym typy}
            begin
              Vinf:=TVarCompileInfo(Inf.Elements[Inf.Count-i]);
              VInf.Typ:=Vtyp;
              VInf.TypeName:=St;
            end;
          until w=kw_strednik;
        end;

begin
  BlockInfoList:=nil;
  FuncInfoList:=nil;
  Output:=nil;
  try
  w:=NextWord(St);
  if w<>kw_PROGRAM then
    raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,KeyWords[kw_PROGRAM]);
  l1:=PreCompiler.Line;
  p1:=PreCompiler.Pos;
  if debuged then
    P:=TDBOilProgram.Create
  else
    P:=TOilProgram.Create;
  Output:=P;
  w:=NextWord(St);
  P.Name:=St;
  if w<>kw_slovo then
    raise TCompilerError.CreatePos(1,l1,p1,'jmno programu');
  w:=NextWord(St);
  Precompiler.StartProgress('Compiling: '+ St,0,Precompiler.Source.Count);
  l1:=PreCompiler.RealLine;
  p1:=PreCompiler.RealPos;
  if w<>kw_strednik then
    raise TCompilerError.CreatePos(1,l1,p1,';');
  I:=TProcInfo.Create;
  I.BlockType:=_Program;
  I.Block:=P;
  I.Calls:=0;
  CurentBlockInfo:=I;
                                                {zapsani hlavnich promennych}
  if debuged then
  begin
    VI:=TDBVarInfo.Create;
    TDBVarInfo(VI).Varname:=kw_world;
  end
  else
    VI:=TVarInfo.Create;
  P.varInfolist.AddElement(VI);
  P.VarType[WorldIndex]:=_pointer;
  P.VarTypeName[WorldIndex]:='TELEMENT';
  if debuged then
  begin
    VI:=TDBVarInfo.Create;
    TDBVarInfo(VI).Varname:=kw_mtool;
  end
  else
    VI:=TVarInfo.Create;
  P.VarInfolist.AddElement(VI);
  P.VarType[MToolIndex]:=_pointer;
  P.VarTypeName[MToolIndex]:='TTOOL';
  if debuged then
  begin
    VI:=TDBVarInfo.Create;
    TDBVarInfo(VI).Varname:=kw_ActivEl;
  end
  else
    VI:=TVarInfo.Create;
  P.VarInfolist.AddElement(VI);
  P.VarType[ActiveElIndex]:=_pointer;
  P.VarTypeName[ActiveElIndex]:='TELEMENT';
  {zapis do kompilatoru}
  I.VarName[WorldIndex]:=kw_World;
  I.VarName[MToolIndex]:=kw_MTool;
  I.VarName[ActiveElIndex]:=kw_ActivEl;

  w:=NextWord(St);                                           {deklarace funkci}
  while w in [kw_FUNCTION,kw_PROCEDURE] do
  begin
    PreCompiler.Hold;
    FuncDeclCompiler.DoIt;
    P.SubProcs.AddElement(FuncDeclCompiler.Output);
    w:=NextWord(St);
    if w<>kw_strednik then
      raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,';');
    w:=NextWord(St);
  end;
  PreCompiler.Hold;
                                                                    {ctu telo}
  w:=nextWord(St);
  if w<>kw_BEGIN then
    raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'BEGIN');
  if debuged then
    TDBOilProgram(P).SourceLineNum:=PreCompiler.RealLine;
  w:=NextWord(St);
  while w<>kw_END do
  begin
    PreCompiler.Hold;
    CommandCompiler.DoIt;                                           {ctu radku}
    TOilProgram(Output).Addprgline(TOilLine(CommandCompiler.Output));
    w:=nextWord(St);
    if w<>kw_strednik then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
    w:=NextWord(St);
  end;
  if StopLetter<>'.' then
    raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,'.');
  w:=NextWord(St);
  w:=NextWord(St);
  if w<>kw_eof then
    raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'konec souboru');
  FreeCurentBlockInfo;
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;

{TFuncDeclarationCompiler}
function TFuncDeclarationCompiler.GetCommandCompiler:TCommandCompiler;
begin
  if not assigned(FCommandCompiler) then
  begin
    FCommandCompiler:=TCommandCompiler.Create;
    AddTool(FCommandCompiler);
    FCommandCompiler.BlockInfoList:=BlockInfoList;
    FCommandCompiler.FuncInfoList:=FuncInfoList;
    FCommandCompiler.PreCompiler:=PreCompiler;
    FCommandCompiler.Debuged:=Debuged;
  end;
  result:=FCommandCompiler;
end;


procedure TFuncDeclarationCompiler.SetCommandCompiler(aComp:TCommandCompiler);
begin
  if assigned(FCommandCompiler) then
    FreeTool(FCommandCompiler);
  AddTool(aComp);
  FCommandCompiler:=aComp;
  FCommandCompiler.BlockInfoList:=BlockInfoList;
  FCommandCompiler.FuncInfoList:=FuncInfoList;
  FCommandCompiler.PreCompiler:=PreCompiler;
  FCommandCompiler.Debuged:=Debuged;
end;

function TFuncDeclarationCompiler.GetFuncDeclCompiler:TFuncDeclarationCompiler;
begin
  if not assigned(FFuncDeclCompiler) then
  begin
    FFuncDeclCompiler:=TFuncDeclarationCompiler.Create;
    AddTool(FFuncDeclCompiler);
    FFuncDeclCompiler.BlockInfoList:=BlockInfoList;
    FFuncDeclCompiler.FuncInfoList:=FuncInfoList;
    FFuncDeclCompiler.PreCompiler:=PreCompiler;
    FFuncDeclCompiler.debuged:=debuged;
  end;
  result:=FFuncDeclCompiler;
end;


procedure TFuncDeclarationCompiler.SetFuncDeclCompiler(aComp:TFuncDeclarationCompiler);
begin
  if assigned(FFuncDeclCompiler) then
    FreeTool(FFuncDeclCompiler);
  AddTool(aComp);
  FFuncDeclCompiler:=aComp;
  FFuncDeclCompiler.BlockInfoList:=BlockInfoList;
  FFuncDeclCompiler.FuncInfoList:=FuncInfoList;
  FFuncDeclCompiler.PreCompiler:=PreCompiler;
  FFuncDeclCompiler.debuged:=debuged;
end;

procedure TFuncDeclarationCompiler.DoIt;
var
    w:keyType;
    St,PName:string;
    func:boolean;
    Inf:TProcHeaderInfo;
    BlInf:TProcInfo;
    call,params:boolean;
    VInf:TVarCompileInfo;
    vars,i,ind,FuncCount:integer;
    vtyp:TType;
    P:TOilProc;
    V:TVarInfo;

    function CanBeVariable(VName:string):boolean;
    var
        o:integer;
    begin {Vname uz musi byt ansiuppercase}
      result:=true;
      o:=Inf.Count-1;
      while (o>=0) and result do
      begin
        result:=TVarCompileInfo(Inf.Elements[o]).VarName<>VName;
        dec(o);
      end;
    end;

begin
  Output:=nil;
  try
    w:=NextWord(St);
    if not (w in[kw_PROCEDURE,kw_FUNCTION]) then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'PROCEDURE nebo FUNCTION');
    func:=w=kw_FUNCTION;
    w:=NextWord(PName);
    if w<>kw_slovo then
    begin
      if func then
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'jmeno funkce')
      else
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'jmeno procedury')
    end;
    if ExistsFunction(PName) then
      raise TCompilerError.CreatePos(21,PreCompiler.Line,PreCompiler.Pos,'');
      {zalozim header info}
    if func then
      Inf:=TFuncHeaderInfo.create
    else
      Inf:=TProcHeaderInfo.create;
    Inf.ProcName:=AnsiUpperCase(PName);
    FuncInfoList.AddElement(inf);
    FuncCount:=FuncInfoList.Count;
            if func then
            begin
              if debuged then
                P:=TDBOilFunc.Create
              else
                P:=TOilfunc.create;
            end
            else
            begin
              if debuged then
                P:=TDBOilProc.Create
              else
                P:=TOilProc.create;
            end;
    Output:=P;
    if debuged then
      TDBOilBlock(Output).NameStack:=TDBOilBlock(CurentBlockInfo.block).NameStack;
    Inf.OilProc:=P;
    if func then
    begin
      VInf:=TVarCompileInfo.Create;
      VInf.VarName:='RESULT';
      VInf.Status:=primary;
      Inf.AddElement(VInf);
    end;
    {zakladam blockinfo}
    P.Stack:=CurentBlockInfo.block.Stack;
    BlInf:=TProcInfo.Create;
    BlInf.Block:=P;
    CurentBlockInfo:=BLInf;
    {jsou nejake parametry?}
    w:=NextWord(St);
    params:=w=kw_zavorka;
    if params then
    begin
      w:=NextWord(St);
      if w<>kw_zavorka2 then
        PreCompiler.Hold
      else
        params:=false;
    end
    else
      PreCompiler.Hold;
    if params then
      repeat{jsou parametry}
        w:=NextWord(St);
        call:=w=kw_VAR;
        if not call then
          PreCompiler.Hold;
        vars:=0;
        repeat{ctu jednotliva jmena promennych}
           inc(vars);
           w:=NextWord(St);
           St:=AnsiUppercase(St);
           if w<>kw_slovo then
              raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'identifiktor promnn');
           if not CanBeVariable(St) then
              raise TCompilerError.CreatePos(21,PreCompiler.RealLine,PreCompiler.RealPos,'');
           {zalozim informaci o jmenu}
           VInf:=TVarCompileInfo.Create;
           VInf.VarName:=St;
           if call then
              VInf.Status:=called
           else
              VInf.Status:=primary;
           Inf.AddElement(VInf);
           w:=NextWord(St);
           if not (w in[kw_carka,kw_dvojtecka]) then
             raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':');
          until w=kw_dvojtecka;
        {ctu typ}
        w:=NextWord(St);St:=AnsiUppercase(St);
        if  not (w in[kw_slovo,kw_INTEGER,kw_FLOAT, kw_CHAR, kw_BOOLEAN,kw_STRING]) then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'identifiktor typu');
        case w of
                   kw_INTEGER:Vtyp:=_Integer;
                   kw_FLOAT:  Vtyp:=_Float;
                   kw_CHAR:   Vtyp:=_Char;
                   kw_BOOLEAN:Vtyp:=_Boolean;
                   kw_STRING: Vtyp:=_String;
                   kw_slovo:
                   begin
                     Vtyp:=_pointer;
                     St:=CheckClassName(St);
                     if GetOrbisClass(St)=nil then
                       raise TCompilerError.CreatePos(10,PreCompiler.RealLine,PreCompiler.RealPos,'');
                   end
        end;{case}
        {priradim promenym typy}
        for i:=1 to vars do
        begin
          Vinf:=TVarCompileInfo(Inf.Elements[Inf.Count-i]);
          VInf.Typ:=Vtyp;
          VInf.TypeName:=St;
        end;
        w:=NextWord(St);
        if  not (w in[kw_strednik,kw_zavorka2]) then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,')');
      until w=kw_zavorka2;
      {mam nactene deklarace parametru}
      {ctu typ funkce}
      if func then
      begin{typ fce}
        w:=NextWord(St);
        if  w <>kw_dvojtecka then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,':');
        w:=NextWord(St);St:=AnsiUppercase(St);
        if not (w in[kw_slovo,kw_INTEGER,kw_FLOAT, kw_CHAR, kw_BOOLEAN,kw_STRING]) then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'identifiktor typu');
        case w of
                   kw_INTEGER:Vtyp:=_Integer;
                   kw_FLOAT:Vtyp:=_Float;
                   kw_CHAR:Vtyp:=_Char;
                   kw_BOOLEAN:Vtyp:=_Boolean;
                   kw_STRING:Vtyp:=_String;
                   kw_slovo:
                   begin
                     Vtyp:=_pointer;
                     St:=CheckClassName(St);
                     if  GetOrbisClass(St)=nil then
                       raise TCompilerError.CreatePos(10,PreCompiler.RealLine,PreCompiler.RealPos,'');
                   end
        end;{case}
      Vinf:=TVarCompileInfo(Inf.Elements[1]);
      VInf.Typ:=Vtyp;VInf.TypeName:=St;
      TFuncHeaderInfo(Inf).FuncTyp:=Vtyp;
      TFuncHeaderInfo(Inf).FuncTypeName:=St;
    end;
    w:=NextWord(St);
    if w<>kw_strednik then
      raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
       {naskladat deklarovane do blockinfa a
       vypocitat jejich index ve stacku}
    if Inf.Count>1 then
    begin
      ind:=0;
      for i:=1 to Inf.Count-1 do
      begin
        Vinf:=TVarCompileInfo(Inf.Elements[i]);
        if VInf.Status=called then
        begin
          VInf.VarIndex:=ind;
          if debuged then
          begin
            V:=TDBVarInfo.create;
            TDBVarInfo(V).VarName:=VInf.Varname+'+';
            {+ u jmena znaci volanou promennou}
          end
          else
            V:=TVarInfo.create;
          V.VarType:=VInf.typ;
          V.typename:=VInf.TypeName;
          P.VarInfoList.AddElement(V);
          BlInf.VarName[ind]:=VInf.Varname;
          inc(ind);
        end;
      end;
      BlInf.Calls:=ind;
      P.Calls:=ind;
      for i:=1 to Inf.Count-1 do
      begin
        Vinf:=TVarCompileInfo(Inf.Elements[i]);
        if VInf.Status=primary then
        begin
          VInf.VarIndex:=ind;
          if debuged then
          begin
            V:=TDBVarInfo.create;
            TDBVarInfo(V).VarName:=VInf.Varname;
           end
          else
            V:=TVarInfo.create;
          V.VarType:=VInf.typ;
          V.typename:=VInf.Typename;
          P.VarInfoList.AddElement(V);
          BlInf.VarName[ind]:=VInf.Varname;
          inc(ind);
          end;
        end;
      end;
      if func then
        Inf.FreeElement(Inf.Elements[1]); {pryc s resultem}
      {**********************}
      {hotova hlava}
      w:=NextWord(St);{deklarace subfunkci}
      while w in [kw_FUNCTION,kw_PROCEDURE] do
      begin
        PreCompiler.Hold;
        FuncdeclCompiler.DoIt;
        {tady by bylo mozne nekam povesit vyvorene fce}
        P.addelement(FuncdeclCompiler.Output);
        {vymazat^^^^^^}
        w:=NextWord(St);
        if w<>kw_strednik then
          raise TCompilerError.CreatePos(1,PreCompiler.Line,PreCompiler.Pos,';');
        w:=NextWord(St);
      end;
      PreCompiler.Hold;
      {ctutelo}
      w:=nextWord(St);
      if w<>kw_BEGIN then
        raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,'BEGIN');
      if debuged then
        TOilProc(Output).SourceLineNum:=PreCompiler.RealLIne;
      w:=NextWord(St);
      while w<>kw_END do
      begin
        PreCompiler.Hold;
        CommandCompiler.DoIt;{ctu radku}
        TOilProc(Output).Addprgline(TOilLine(CommandCompiler.Output));
        w:=nextWord(St);
        if w<>kw_strednik then
          raise TCompilerError.CreatePos(1,PreCompiler.RealLine,PreCompiler.RealPos,';');
        w:=NextWord(St);
      end;

  freeCurentBlockInfo;
  while FuncInfoList.Count>FuncCount do
    FuncInfoList.FreeElement(FuncInfoList.Elements[FuncInfoList.Count-1]);
  except
    if Output<>nil then
      Output.free;
    Output:=nil;
    raise;
  end;
end;


end.
