unit f_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, ImgList, ComCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    imgBDE32: TImage;
    imgBDE16: TImage;
    imgtax: TImage;
    imgmapper: TImage;
    imgteren: TImage;
    imgall: TImage;
    imgexplore: TImage;
    bde32: TShape;
    bde16: TShape;
    tax: TShape;
    mapper: TShape;
    teren: TShape;
    all: TShape;
    explore: TShape;
    background: TShape;
    informace: TImage;
    konec: TImage;
    konec1: TImage;
    procedure bde32MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure backgroundMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bde16MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure taxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mapperMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure terenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure exploreMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bde32MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure bde16MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure taxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mapperMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure terenMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure exploreMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure informaceClick(Sender: TObject);
    procedure konecMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure konecMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure konecClick(Sender: TObject);
  private
     Last: TImage;
     Path: string;
     function CursIn(x,y: integer; Sender: TObject): boolean;
     procedure onMove(aImg: TImage);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
   u_String;

{$R *.DFM}

function TForm1.CursIn(x,y: integer; Sender: TObject): boolean;
var
   S: TShape;
begin
   result := false;
   if not (Sender is TShape) then exit;
   S := TShape(Sender);
   if (x > 0) and (x < S.Width)
      and (y > 0) and (y < S.Height)
      then result := true;
end;


procedure TForm1.onMove(aImg: TImage);
begin
   Canvas.Lock;
   if Last <> nil then
   if Last <> aImg then
   begin
      Last.Visible := false;
   end;
   if not aimg.Visible then
   begin
      aimg.visible := true;
      Last := aimg;
   end;
   Canvas.UnLock;
end;

procedure TForm1.bde32MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgBDE32);
end;

procedure TForm1.backgroundMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
   Canvas.Lock;
   if Last = nil then exit;
   if Last.visible then Last.visible := false;
   Last := nil;
   //Application.ProcessMessages;
   Canvas.UnLock;
end;

procedure TForm1.bde16MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgBDE16);
end;

procedure TForm1.taxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgtax);
end;

procedure TForm1.mapperMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgMapper);
end;

procedure TForm1.terenMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgteren);
end;

procedure TForm1.exploreMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   OnMove(imgexplore);
end;

procedure TForm1.bde32MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := Path + 'Tax98 CD\BDE 32\Disk1\Setup.exe';
      w := WinExec(PChar(S),SW_SHOW);
      if  w < 32 then ShowMessage('Chyba pi sputn programu '+S);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   i: integer;
   pxf: TPixelFormat;
begin
   {$IFDEF LCR}
   Caption := Caption + ' pro LR';
   Teren.enabled := false;
   Mapper.Enabled := false;
   {$ENDIF}
   Path := ExtractFilePath(ParamStr(0));
   CheckBackSlash(Path);
   i := GetDeviceCaps(Canvas.Handle,NUMCOLORS);
   //Caption := IntToStr(i);
   if i > -1 then
   begin
      if i < 20 then
      begin
         Image1.Picture.LoadFromFile(Path+'CDStart16.bmp');
         pxf := pf4bit;
      end
      else
      begin
         Image1.Picture.LoadFromFile(Path+'CDStart256.bmp');
         pxf := pf8bit;
      end;
      ImgBde32.Picture.Bitmap.PixelFormat := pxf;
      ImgBde16.Picture.Bitmap.PixelFormat := pxf;
      ImgTAX.Picture.Bitmap.PixelFormat := pxf;
      ImgMapper.Picture.Bitmap.PixelFormat := pxf;
      Imgteren.Picture.Bitmap.PixelFormat := pxf;
      ImgAll.Picture.Bitmap.PixelFormat := pxf;
      Imgexplore.Picture.Bitmap.PixelFormat := pxf;
      Konec.Picture.Bitmap.PixelFormat := pxf;
      Konec1.Picture.Bitmap.PixelFormat := pxf;
      Informace.Picture.Bitmap.PixelFormat := pxf;
   end;
end;

procedure TForm1.bde16MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := Path + 'Tax98 CD\BDE 16\Disk1\Setup.exe';
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.taxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := Path + 'Tax98 CD\TAX 98\Disk1\Install.exe';
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.mapperMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := Path + 'Tax98 CD\MAPPER 206\Disk1\Install.exe';
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.terenMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := Path + 'Tax98 CD\Teren97\Disk1\Install.exe';
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.exploreMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   S: string;
   W: integer;
begin
   if not cursIn(x,y,Sender) then exit;
   if Button = mbLeft then
   begin
      S := 'Explorer.exe '+Path;
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.informaceClick(Sender: TObject);
var
   S: string;
   W: integer;
begin
   //if not cursIn(x,y,Sender) then exit;
   //if Button = mbLeft then
   begin
      S := 'Notepad.exe '+Path+'Cti mne.txt';
      w := WinExec(PChar(S),SW_SHOW);
   end;
end;

procedure TForm1.konecMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Konec1.Visible := true;
end;

procedure TForm1.konecMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Konec1.Visible := false;
end;

procedure TForm1.konecClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
