program LEDasInitServer;

{$APPTYPE CONSOLE}

uses
   sysutils, winsock, inifiles,classes, u_Shell, u_String;

const
   WinSockVersion = (1 SHL 8) OR 1; //verze winsock.dll

   //Port = 666;
   //Port = 13225;
   DefaultBuffLen = 512; //velikost bufferu pro prijeti zpravy v bytech

var
  WSDATA : WSADATA; //promenna pro WSAStartup
  initSocket, newSocket : tSocket; //na initSocketu server nasloucha, newSocket slouzi pro samotnou komunikaci a pote zanika
  initSockAddr : SockAddr_in; //adresa iniSocketu
  newSockAddr    : pSockAddr; //adresa socketu pro komunikaci
  newSockAddrLen : PInteger;
  result, error, BuffLen : Integer;
  msg : String[100]; //posilana zprava
  recvBuff : array[0..DefaultBuffLen - 1] of Char; //buffer pro prijeti zpravy
  Ports: string;
  Port: integer;

  img, imgSize, bytesRead : Integer;
  imgBuff : Pointer;
  imgName : String;
  PortMin: integer;
  PortMax: integer;
  ini: Tinifile;
  S: string;
  inifile: string;
  Section: string;
  Sl :TStringList;
  i: integer;
  ClientID: string;
  Test: integer;
begin
  try
    S := Paramstr(0);
    S := ChangeFileExt(S,'.ini');
    inifile := S;
    ini := TIniFile.Create(S);
    Section := 'Setup';
    PortMin := ini.ReadInteger(Section,'PortMin',0);
    PortMax := ini.ReadInteger(Section,'PortMax',0);
    Port    := ini.ReadInteger(Section,'Port',0);
    ini.Free;

    result := 0;
    Writeln('Server');
    Writeln('Port: '+IntToStr(Port)+' Client ports: '+IntToStr(PortMin)+'-'+IntToStr(PortMax));
    if (Port = 0) or (PortMin = 0) or (PortMax = 0) then
    begin
       Writeln('Chybne nastaveni portu .... konec');
       Writeln('-------------------------------------------');
       Readln;
       exit;
    end;
    BuffLen := DefaultBuffLen;


    {Inicializace winsock.dll}
    WSAStartup (WinSockVersion, WSDATA);

    {Vytvoreni socketu}
    initSocket := Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if initSocket = -1 then
      begin
        writeln('Nepodarilo se vytvorit socket.');
        error := WSAGetLastError();
        Writeln('Error code: ', error);
        WSACleanUp;
        halt(1);
      end;
    writeln('Vytvoren socket: ', initSocket);

    {Naplneni adresy}
    begin
      with initSockAddr do
        begin
          sin_family := af_inet;
          sin_addr.s_addr := INADDR_ANY;
          sin_port   := htons(Port);
        end;

      {Pripojeni adresy na socket}
      result := Bind (initSocket, initSockAddr, SizeOf(initSockAddr));
      if result = -1 then
        begin
          writeln('Nepodarilo se bindnout socket: ', initSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      writeln('Bindnut socket: ', initSocket);

      {Spusteni naslouchani na danem socketu}
      result := Listen (initSocket, 1);
      if result = -1 then
        begin
          writeln('Nepodarilo se spustit naslouchani na socketu: ', initSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      writeln('Socket: ', initSocket,' nasloucha.');
    end;

    {Hlavni smycka serveru, ve ktere ceka na prichozi pripojeni}
    repeat
      writeln('Cekam na pripojeni... ');

      {Vytvoreni socketu pro komunikaci}
      GetMem(newSockAddr, SizeOf(newSockAddr^));
      GetMem(newSockAddrLen, SizeOf(newSockAddrLen^));
      newSockAddrLen^ := SizeOf(newSockAddr^);

      {Prijeti spojeni na socketu}
      newSocket := Accept (initSocket, newSockAddr, newSockAddrLen);
      if newSocket = -1 then
        begin
          writeln('Nepodarilo se vytvorit socket pro prichozi spojeni.');
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      writeln('Prichozi spojeni na socketu: ', newSocket);

      {Smycka pro prijeti zpravy}
      repeat
      writeln('Prijimam zpravu...');

      {Prijeti zpravy}
      result := recv(newSocket, recvBuff, BuffLen, 0);
      if result > 0 then
        begin
          writeln('Prijata zprava na socketu: ', newSocket, ': ',recvBuff);
          break;
        end
      else
        begin
          writeln('Error pri prijeti zpravy na socketu: ', newSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      until result > 0;

      {
      V pripade serveroveho scriptu tady bude spusteni heletaxu s parametrem,
      ktery bude cislem portu, na kterym ma s klientem komunikovat. Nasledne
      se cislo portu posle klientovi, aby vedel, jak ma s tim "svym" heletaxem
      komunikovat.
      Spusteni viz http://wiki.freepascal.org/Executing_External_Programs

      V pripade serveroveho heletaxu tady bude case, ktery bude podle toho,
      co bude v recvBuff, provadet operace a nasledne je posilat klientovi.
      }

      {Odpoved klientovi}
      //msg := 'Ahoj kliente, to vis ze muzu.';
      S := String(recvBuff);
      trim(S);
      SL := TStringList.Create;
      SL.CommaText := S;
      ini := TIniFile.Create(inifile);
      if (SL.Count = 3) and (SL[0] = 'LEDAS') and (SL[2] = 'END') then
      begin
         ClientID := SL[1];
         // overeni klienta
         Section := 'CLIENTS';
         Test := Ini.ReadInteger(Section,ClientID,0);
         if Test = 0 then
         begin
            Writeln('Client '+CLientID + ' ma smulu...');
            Msg := '0'
         end
         else
         begin
         // nalezeni volneho portu
            Section := 'PORTS';
            for i := PortMin to PortMax do
            begin
               Port := i;
               Test := Ini.ReadInteger(Section,IntToStr(Port),0);
               if Test = 0 then
                  break
               else
                  Port := -1;
            end;
            if Port > 0 then
            begin
               Writeln('Byl nalezen volny port '+IntToStr(port));
               Ini.WriteString(Section,IntToStr(Port),ClientID);
               S := ExtractFilePath(ParamStr(0));
               CheckBackSlash(S);
               S := S + 'LEDAS.exe';
               _CreateProcess(S,IntToStr(port)+'='+ClientID);
            end
            else
            begin
               Writeln('Neby nalezen zadny volny port ');
            end;
            Msg := IntToStr(Port);
         end;
      end
      else
      begin
         Writeln('Chybne prarametry');
         Msg := '0';
      end;
      ini.Free();

      {Poslani odpovedi}
      result := Send(newSocket, PByteArray(@msg[1])^, sizeof(msg), 0);
      if result = -1 then
        begin
          writeln('Nepodarilo se poslat zpravu: ',msg,', na socketu: ', newSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;

      writeln('Poslana zprava: ',msg,', na socketu: ', newSocket);

      {Cleanup}
      FreeMem(newSockAddr, SizeOf(newSockAddr^));
      FreeMem(newSockAddrLen, SizeOf(newSockAddrLen^));
      closeSocket(newSocket);

      writeln('Komunikacni socket ',newSocket,' ukoncen.');
      Writeln('-------------------------------------------');
    until false;

  {Cleanup}
  closeSocket(initSocket);
  WSACleanUp;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
