program LEDasTestClient;

{$APPTYPE CONSOLE}

uses
  sysutils,
  winsock;

const
   WinSockVersion = (1 SHL 8) OR 1; //verze winsock.dll
   ServerIP = '62.77.84.130';
   //ServerIP = '192.168.0.14';
   //Port = 13225;
   //Port = 666;
   //Port = 1234;
   DefaultBuffLen = 512; //velikost bufferu pro prijeti zpravy v bytech

var
  WSDATA : WSADATA; //promenna pro WSAStartup
  initSocket : tSocket; //socket pro spojeni se serverem
  initSockAddr : SockAddr_in; //struktura popisujici adresu socketu
  result, error, BuffLen : Integer;
  msg : String[100]; //posilana zprava
  recvBuff : array[0..DefaultBuffLen - 1] of Char; //buffer pro prijeti zpravy
  Ports: string;
  Port: integer;


  img, imgSize, bytesRead : Integer;
  imgBuff : array[0..2000000] of Char;
  imgName : String;



begin
  try
    Ports := ParamStr(1);
    Port := StrToIntDef(Ports, 13225);
    result := 0;
    Writeln('Client');
    Writeln('Port '+IntToStr(Port)+' ['+Ports+']');
    BuffLen := DefaultBuffLen;

    {Inicializace winsock.dll}
    WSAStartup (WinSockVersion, WSDATA);

    {Vytvoreni socketu}
    initSocket := Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if initSocket = -1 then
      begin
        writeln('Nepodarilo se vytvorit socket.');
        error := WSAGetLastError();
        Writeln('Error code: ', error);
        WSACleanUp;
        halt(1);
      end;
    writeln('Vytvoren socket: ', initSocket);

    {Naplneni adresy}
    begin
      with initSockAddr do
      begin
        sin_family := af_inet;
        sin_addr.s_addr := inet_addr(ServerIP);
        sin_port   := htons(Port);
      end;

      {Pripojeni k serveru}
      result := Connect (initSocket, initSockAddr, SizeOf(initSockAddr));
      if result = -1 then
        begin
          writeln('Nepodarilo se pripojit socket: ', initSocket,' na IP: ', ServerIP);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      writeln('Pripojen socket: ', initSocket,' na IP: ', ServerIP);

      {Zprava k poslani}
      msg := 'Servere, kamarade, muzes mluvit?';

      {Poslani zpravy}
      result := Send(initSocket, PByteArray(@msg[1])^, sizeof(msg), 0);
      if result = -1 then
        begin
          writeln('Nepodarilo se poslat zpravu: ',msg,', na socketu: ', initSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
      writeln('Poslana zprava: ',msg,', na socketu: ', initSocket);

      {Ukonceni odesilani ze socketu}
      result := shutdown(initSocket, SD_SEND);
      if result = -1 then
        begin
          writeln('Nepodaril se shutdown na socketu: ', initSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
    end;

    {Cekani na odpoved serveru}
    repeat
      writeln('Cekam na odpoved serveru...');

      
       imgName := 'D:\vojta\ledas\img2.jpg';

      img := FileCreate(imgName);
      if img = -1 then writeln('Nepodarilo se vytvorit soubor.');

      result := recv(initSocket, imgBuff, sizeOf(imgBuff), 0);
      Writeln('Prijato: ',result);
      FileWrite(img,imgBuff,result);
      FileClose(img);

      {Prijeti zpravy}
      //result := recv(initSocket, recvBuff, BuffLen, 0);

      if result > 0 then
        begin
          writeln('Prijata zprava na socketu: ', initSocket, ': ',recvBuff);
        end
      else if result = 0 then
        begin
          writeln('Server ukoncil spojeni se socketem: ', initSocket);
        end
      else 
        begin          
          writeln('Error pri prijeti zpravy na socketu: ', initSocket);
          error := WSAGetLastError();
          Writeln('Error code: ', error);
          WSACleanUp;
          halt(1);
        end;
    until result > 0;

  {
  V realnem klientovi tady program neskonci, ale pobezi smycka, ve ktere bude
  program reagovat na vstupy uzivatele a podle toho posilat zpravy serveru a nasledne
  vyhodnocovat odpovedi.
  }

  {Cleanup}
  closeSocket(initSocket);
  WSACleanUp;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
