unit pfgHSAPI;
{**************************************************************************}
{* pfgHSAPI Unit                                                          *}
{*                                                                        *}
{* This unit contains method declarations from the HSAPI.dll file.        *}
{* Currently, this only includes the HsRefreshConduitInfo file, which     *}
{* Palm recommends not to use. The code referencing it in pfgPalmComp.pas *}
{* is wrapped in an IFNDEF SAFE_CODE block. Any future potentially        *}
{* dangerous code will also be so wrapped, so you can define a global     *}
{* define if you don't want the code included.                            *}
{*                                                                        *}
{* Copyright  2000-2002 by Paul Gilbert, All Rights Reserved             *}
{**************************************************************************}

interface

uses SysUtils, Windows;

var
  HsRefreshConduitInfo: function: Integer; cdecl;

implementation

uses Dialogs, pfgUserData;

var
  DllHandle : THandle;
  DllLoaded : Boolean;

procedure LoadDLL;
begin
  if DLLLoaded then Exit;

  DLLHandle := LoadLibrary(PChar(PalmPath + 'hsapi.dll'));
  DLLLoaded := DLLHandle >= 32;
  if DLLLoaded then
  begin
    @HsRefreshConduitInfo := GetProcAddress(DLLHandle,'HsRefreshConduitInfo');
    Assert(@HsRefreshConduitInfo <> nil);
  end;
end;

initialization
  DLLLoaded := False;
  LoadDLL;

  if (not DllLoaded) then
  begin
    MessageDlg('pfgHSAPI: Unable to load hsapi.dll',mtError,[mbOk],0);
    Abort;
  end;

finalization
  if DLLLoaded then FreeLibrary(DLLHandle);
end.
