unit pfgPalmSyncComponent;
{
PEL 2001-05-18
moved
    DefaultCompareRecord(
to public so that it can be called from users OnComparerecord !

PEL 2001-05-28
Changes in Syncfast and SyncSlow
In first readtrough of Palm-records they cannot be modified
because the recordindex is reset for some reason
and as a result only half the records are read out to the PC :-)
temporary ? solution is to NOT modify the palm records until
stage two , when copying data back from PC-to palm !

PEL 2001-07-17
Changes in Syncfast and SyncSlow
records deleted on palm are not copied to PC in the first readthru
are later deleted , all at once by calling PurgeTable

Changes in DoDeletePalm
It now only sets the deleted attribute
- the record will be deleted later by calling PurgeTable

PEL 2001-08-30
Misplaced ".next" - on the wrong side of an "end;"
ment that the syncing could end up in endless loop :-)
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Db,
  pfgPalmDb,
  pfgSyncMgr,
  pfgPalmComp;

type
  TRecordAction = (CopyToPalm, CopyToPC, DeletePalmPC, DoNothing);
type
  TOnCompareRecord = function(Sender: TObject;
    const Props: TpfgSyncProperties; const PalmFlags, PCFlags: byte): TRecordAction
  of object;
type
  TOnBeforeSync = function(Sender: TObject;
    const Props: TpfgSyncProperties): integer of object;
type
  TOnBeforeLocalList = procedure(Sender: TObject;
    const Props: TpfgSyncProperties) of object;
type
  TOnFindLocalRecordID = function(Sender: TObject;
    RecordID: DWORD): Boolean of object;
type
  TGetLocalAttribs = function(Sender: TObject): Byte of object;
  TSetLocalAttribs = procedure(Sender: TObject; const value: Byte) of object;
type
  TGetLocalRecId = function(Sender: TObject): DWORD of object;
  TSetLocalRecId = procedure(Sender: TObject; const value: DWORD) of object;
type
  TGetLocalCatId = function(Sender: TObject): shortint of object;
  TSetLocalCatId = procedure(Sender: TObject; const value: shortint) of object;
type
  TOnErrorMessage = procedure(Sender: TObject; const ErrorMessage: string) of
    object;
type
  TOnEmptyLocalTable = procedure(DataSet: TDataSet) of object;

type
  TpfgPalmSyncComponent = class(TComponent)
  private
    FLocalDataSet: TDataSet;
    FpfgPalmRemoteTable: TpfgPalmRemoteTable;
    FSyncProperties: TpfgSyncProperties;
    FOnCompareRecord: TOnCompareRecord;
    FOnBeforeSync: TOnBeforeSync;
    FOnFindLocalRecordID: TOnFindLocalRecordID;
    FOnErrorMessage: TOnErrorMessage;
    FOnBeforeLocalList: TOnBeforeLocalList;

    FGetLocalCatId: TGetLocalCatId;
    FSetLocalCatId: TSetLocalCatId;

    FSetLocalRecId: TSetLocalRecId;
    FGetLocalRecId: TGetLocalRecId;

    FLocalCategoryField: TNumericField;
    FLocalRecIdField: TNumericField;
    FLocalDeletedField: TBooleanField;
    FLocalDirtyField: TBooleanField;
    FLocalAttribsField: TNumericField;

    FGetLocalAttribs: TGetLocalAttribs;
    FSetLocalAttribs: TSetLocalAttribs;
    FAllowCreatePalmTable: boolean;
    FOnEmptyLocalTable: TOnEmptyLocalTable;

    procedure SetLocalDataSet(const Value: TDataSet);
    procedure SetSyncProperties(const Value: TpfgSyncProperties);
    procedure SetOnCompareRecord(const Value: TOnCompareRecord);
    procedure SetpfgPalmRemoteTable(const Value: TpfgPalmRemoteTable);
    procedure SetOnBeforeSync(const Value: TOnBeforeSync);
    procedure SetOnFindLocalRecordID(const Value: TOnFindLocalRecordID);
    function compare_and_act(const maskattr: byte): TRecordAction;
    procedure SetGetLocalAttribs(const Value: TGetLocalAttribs);
    procedure SetSetLocalAttribs(const Value: TSetLocalAttribs);
    procedure SetGetLocalCatId(const Value: TGetLocalCatId);
    procedure SetGetLocalRecId(const Value: TGetLocalRecId);
    procedure SetSetLocalCatId(const Value: TSetLocalCatId);
    procedure SetSetLocalRecId(const Value: TSetLocalRecId);
    procedure SendErrorMsg(const s: string);
    procedure SetOnErrorMessage(const Value: TOnErrorMessage);
    procedure SetOnBeforeLocalList(const Value: TOnBeforeLocalList);
    procedure SetLocalCategoryField(const Value: TNumericField);
    procedure SetLocalRecIdField(const Value: TNumericField);
    procedure SetLocalDeletedField(const Value: TBooleanField);
    procedure SetLocalDirtyField(const Value: TBooleanField);
    procedure SetLocalAttribsField(const Value: TNumericField);
    procedure SetAllowCreatePalmTable(const Value: boolean);
    procedure SetOnEmptyLocalTable(const Value: TOnEmptyLocalTable);
    { Private declarations }
  protected
    { Protected declarations }
    function CompareRecord(const PalmFlags, PCFlags: byte): TRecordAction;
    procedure DoBeforeLocalList;
    function SyncFast: integer;
    function SyncSlow: integer;
    function SyncHHtoPC: integer;
    function SyncPCtoHH: integer;
    function SyncBackup: integer;
    procedure Notification(AComponent: TComponent; Operation: TOperation);
      override;
    function DoCopyToPC: integer;

    function DoCopyToPalm: integer;
    function DoDeletePalm: integer;
    function DoDeletePC: integer;
    function DoGetLocalAttribs: byte;
    procedure DoSetLocalAttribs(const value: byte);
    function DoGetLocalCatId: shortint;
    procedure DoSetLocalCatId(const value: shortint);
    function DoGetLocalRecId: dword;
    procedure DoSetLocalRecId(const value: dword);
    procedure DoEmptyLocalTable;
  public
    { Public declarations }
    property SyncProperties: TpfgSyncProperties read FSyncProperties write
    SetSyncProperties;
    function Sync: integer;
      overload;
    function Sync(SyncProps: TpfgSyncProperties): integer; overload;
    procedure CheckObligatoryAssignments;
    function DefaultCompareRecord(const PalmFlags, PCFlags: byte):
    TRecordAction;
  published
    { Published declarations }
    property pfgPalmRemoteTable: TpfgPalmRemoteTable read FpfgPalmRemoteTable
    write SetpfgPalmRemoteTable;
{ the table on the Palm you want to sync}
    property LocalDataSet: TDataSet read FLocalDataSet write SetLocalDataSet;
{ the dataset on the PC you want to sync}
    property AllowCreatePalmTable: boolean read FAllowCreatePalmTable write SetAllowCreatePalmTable;

    property OnCompareRecord: TOnCompareRecord read FOnCompareRecord write
    SetOnCompareRecord;
{ If you want to do your own comparing of records ( overrides the default compare method )}
    property OnBeforeSync: TOnBeforeSync read FOnBeforeSync write
    SetOnBeforeSync;
{ called before syncing - set up of tables etc}
    property OnBeforeLocalList: TOnBeforeLocalList read FOnBeforeLocalList write
    SetOnBeforeLocalList;
{ called before a listing of all PC- records is done
  use it to set SQL to something like "Select * from table" if you have s}
    property OnFindLocalRecordID: TOnFindLocalRecordID read FOnFindLocalRecordID
    write SetOnFindLocalRecordID;
{}
    property GetLocalAttribs: TGetLocalAttribs read FGetLocalAttribs write
    SetGetLocalAttribs;
{}
    property SetLocalAttribs: TSetLocalAttribs read FSetLocalAttribs write
    SetSetLocalAttribs;
{}
    property LocalDirtyField: TBooleanField read FLocalDirtyField write
    SetLocalDirtyField;
    property LocalDeletedField: TBooleanField read FLocalDeletedField write
    SetLocalDeletedField;
    property LocalAttribsField: TNumericField read FLocalAttribsField write
    SetLocalAttribsField;

    property LocalRecIdField: TNumericField read FLocalRecIdField write
    SetLocalRecIdField;
{}
    property GetLocalRecId: TGetLocalRecId read FGetLocalRecId write
    SetGetLocalRecId;
{}
    property SetLocalRecId: TSetLocalRecId read FSetLocalRecId write
    SetSetLocalRecId;
{}
    property LocalCategoryField: TNumericField read FLocalCategoryField write
    SetLocalCategoryField;
{}
    property GetLocalCatId: TGetLocalCatId read FGetLocalCatId write
    SetGetLocalCatId;
{}
    property SetLocalCatId: TSetLocalCatId read FSetLocalCatId write
    SetSetLocalCatId;
{}
    property OnErrorMessage: TOnErrorMessage read FOnErrorMessage write
    SetOnErrorMessage;
{Called on errors - can be used if you want to send messages to log file}

    property OnEmptyLocalTable: TOnEmptyLocalTable read FOnEmptyLocalTable write SetOnEmptyLocalTable;

  end;

procedure Register;
{.$R *.res}

//const
//  eRecAttrUpdateCheck = $01;

function IsDirty(const Flags: integer): boolean;
function IsDeleted(const Flags: integer): boolean;
function MakeAttribute(const Dirty, Deleted: boolean): integer;



implementation
uses
{.$define debugmsg}
{$IFDEF debugmsg}
  debugit,
  typinfo,
{$ENDIF}
  pfgPalmSyncError,
  pfgPalmMisc;

procedure Register;
begin
  RegisterComponents('Palm Pilot', [TpfgPalmSyncComponent]);
end;

resourcestring
  // Internal resource strings
  SMustAssignMethod = 'You must assign a method to "%s.%s"';
  SMustAssignProperty = 'You must assign the property "%s.%s"';
  SMustAssignRecIDMethod =
    'You must assign either ;'#13 +
    'LocalRecIdField or '#13 +
    'GetLocalRecId and SetLocalRecId';
  SMustAssignAttribMethod =
    'You must assign either;'#13 +
    'LocalAttribsField or'#13 +
    'LocalDirtyField and LocalDeletedField or'#13 +
    'GetLocalAttribs and SetLocalAttribs';

function IsDirty(const Flags: integer): boolean;
begin
  result := (Flags and eRecAttrDirty) <> 0;
end;

function IsDeleted(const Flags: integer): boolean;
begin
  result := (Flags and eRecAttrDeleted) <> 0;
end;

function MakeAttribute(const Dirty, Deleted: boolean): integer;
begin
  result := 0;
  if Dirty then result := result or eRecAttrDirty;
  if Deleted then result := result or eRecAttrDeleted;
end;

{ TpfgPalmSyncComponent }

procedure TpfgPalmSyncComponent.SetLocalDataSet(const Value: TDataSet);
begin
  FLocalDataSet := Value;
end;

procedure TpfgPalmSyncComponent.SetpfgPalmRemoteTable(
  const Value: TpfgPalmRemoteTable);
begin
  FpfgPalmRemoteTable := Value;
end;

procedure TpfgPalmSyncComponent.SetSyncProperties(
  const Value: TpfgSyncProperties);
begin
  FSyncProperties := Value;
end;

function TpfgPalmSyncComponent.Sync(SyncProps: TpfgSyncProperties): integer;
begin
  SyncProperties := SyncProps;
  Result := Sync;
end;

procedure TpfgPalmSyncComponent.CheckObligatoryAssignments;
begin
  if not assigned(LocalDataSet) then
  begin
    raise exception.CreateFmt(SMustAssignProperty, [self.name, 'LocalDataSet']);
  end;
  if not assigned(pfgPalmRemoteTable) then
  begin
    raise exception.CreateFmt(SMustAssignProperty, [self.name,
      'pfgPalmRemoteTable']);
  end;

  if not assigned(LocalRecIdField) then
  begin
    if (not assigned(GetLocalRecId)) or (not assigned(SetLocalRecId)) then
    begin
      raise exception.Create(SMustAssignRecIDMethod);
    end;
  end;

  if not assigned(LocalAttribsField) then
  begin
    if (not assigned(LocalDirtyField)) or (not assigned(LocalDeletedField))
      then
    begin
      if (not assigned(GetLocalAttribs)) or (not assigned(SetLocalAttribs))
        then
      begin
        raise exception.Create(SMustAssignAttribMethod);
      end;
    end;
  end;
  if (@OnFindLocalRecordID = nil) then
  begin
    raise exception.CreateFmt(SMustAssignMethod, [self.name,
      'OnFindLocalRecordID']);
  end;
end;

function TpfgPalmSyncComponent.Sync: integer;
begin
  try
    CheckObligatoryAssignments;
    pfgPalmRemoteTable.CardNum := SyncProperties.m_CardNo;
    pfgPalmRemoteTable.CreatorID := CreatorIDToStr(SyncProperties.m_Creator);
    if assigned(FOnBeforeSync) then
    begin
      FOnBeforeSync(self, SyncProperties);
    end;

    case
      SyncProperties.m_SyncType of
      eFast: result := SyncFast;
      eSlow: result := SyncSlow;
      eHHtoPC: result := SyncHHtoPC;
      ePCtoHH: result := SyncPCtoHH;
//      eBackup: result := SyncBackup;
    else
      begin
        result := SyncFast;
      end;
    end;
  except
    on e: exception do
    begin
      SendErrorMsg(e.message + ' in ' + pfgPalmRemoteTable.TableName);
      result := -1;
    end;
  end;
end;

function TpfgPalmSyncComponent.SyncBackup: integer;
(*
eBackup Perform a backup of the databases
on the handheld to the desktop computer.
*)
begin
  result := 0;
end;

function TpfgPalmSyncComponent.SyncHHtoPC: integer;
(*
eHHtoPC Perform a restore from the handheld:
overwrite the desktop database
with the database from the handheld.
*)
begin
  DoEmptyLocalTable;
  result := syncslow;
end;

function TpfgPalmSyncComponent.SyncPCtoHH: integer;
(*
ePCtoHH Perform a restore from the desktop computer:
overwrite the database on the handheld
with the database on the desktop computer
*)
begin
  pfgPalmRemoteTable.EmptyTable;
  result := syncslow;
end;

function TpfgPalmSyncComponent.SyncSlow: integer;
(*
eSlow Perform a slow synchronization:
every record is read from the handheld and compared
to the corresponding record on the desktop computer
(the data in the .dat file and
the data in the .bak file).
Used when the handheld has been synchronized with multiple computers
*)
begin
{$IFDEF debugmsg}
  DebugStrF('%s , SyncSlow', [pfgPalmRemoteTable.TableName]);
{$ENDIF}

  Result := 0; // Suppresses warning on return value

  try
    try
      pfgPalmRemoteTable.Options := pfgPalmRemoteTable.Options - [opModified];
      if not pfgPalmRemoteTable.Exists then
      begin
        if AllowCreatePalmTable then
        begin
          pfgPalmRemoteTable.CreateTable;
        end
        else
        begin
          raise exception.CreateFmt('Palm table: "%s" does not exist', [pfgPalmRemoteTable.TableName]);
        end;
      end
      else
      begin
        pfgPalmRemoteTable.Open;
      end;
      LocalDataSet.Open;

      pfgPalmRemoteTable.First;
      while not pfgPalmRemoteTable.eof do
      begin
{$IFDEF debugmsg}
        DebugStrF('Record number %d', [pfgPalmRemoteTable.RecNum]);
{$ENDIF}
        SyncYieldCycles(1);
        if FOnFindLocalRecordID(self, pfgPalmRemoteTable.Fields.RecordID) then
        begin
          if compare_and_act(0) <> DeletePalmPC then
          begin
            pfgPalmRemoteTable.next;
          end;
        end
        else
        begin
          if not isdeleted(pfgPalmRemoteTable.fields.Flags) then
          begin
            LocalDataSet.Insert;
            DoCopyToPC;
            try
              LocalDataSet.Post;
            except
              on e: exception do
              begin
                SendErrorMsg(e.message + ' in ' + pfgPalmRemoteTable.TableName);
                LocalDataSet.cancel;
              end;
            end;
          end;
          pfgPalmRemoteTable.next;
        end;
      end;
//
      DoBeforeLocalList;
      LocalDataSet.Open;
      LocalDataSet.first;
      while not LocalDataSet.Eof do
      begin
        SyncYieldCycles(1);
        if (DoGetLocalRecId <> 0) and pfgPalmRemoteTable.locateByID(DoGetLocalRecId) then
        begin
          if compare_and_act(0) <> DeletePalmPC then
          begin
            LocalDataSet.Next;
          end;
        end
        else
        begin
          LocalDataSet.Edit;
          DoSetLocalAttribs(DoGetLocalAttribs and (not eRecAttrDirty));
          pfgPalmRemoteTable.Insert;
          DoCopyToPalm;
          pfgPalmRemoteTable.Post;
          DoSetLocalRecId(pfgPalmRemoteTable.Fields.RecordID);
          LocalDataSet.Post;
          LocalDataSet.Next;
        end;
      end;
      pfgPalmRemoteTable.PurgeTable;
      result := 0;
    except
      on e: exception do
      begin
        SendErrorMsg(e.message + ' in ' + pfgPalmRemoteTable.TableName);
        result := -1;
      end;
    end;
  finally
    LocalDataSet.close;
    pfgPalmRemoteTable.close;
  end;
end;

function TpfgPalmSyncComponent.SyncFast: integer;
(*
eFast Perform a fast synchronization:
only records that have been added, archived,
deleted, or modified are
exchanged between the handheld and the desktop computer.
*)
begin
  Result := 0; // Suppresses warning on return value
  try
    try
      pfgPalmRemoteTable.Options := pfgPalmRemoteTable.Options + [opModified];
      if not pfgPalmRemoteTable.Exists then
      begin
        if AllowCreatePalmTable then
        begin
          pfgPalmRemoteTable.CreateTable;
        end
        else
        begin
          raise exception.CreateFmt('Palm table: "%s" does not exist', [pfgPalmRemoteTable.TableName]);
        end;
      end
      else
      begin
        pfgPalmRemoteTable.Open;
      end;
      LocalDataSet.Open;
//
      pfgPalmRemoteTable.First;
      while not pfgPalmRemoteTable.eof do
      begin
        SyncYieldCycles(1);
        if FOnFindLocalRecordID(self, pfgPalmRemoteTable.Fields.RecordID) then
        begin
          compare_and_act(0);
          pfgPalmRemoteTable.next;
        end
        else
        begin
          if not isdeleted(pfgPalmRemoteTable.fields.Flags) then
          begin
            LocalDataSet.Append;
            DoCopyToPC;
            try
              LocalDataSet.Post;
            except
              on e: exception do
              begin
                SendErrorMsg(e.message + ' in ' + pfgPalmRemoteTable.TableName);
                LocalDataSet.cancel;
              end;
            end;
          end;
          pfgPalmRemoteTable.next;
        end;
      end;
//
      DoBeforeLocalList;
      LocalDataSet.Open;
      LocalDataSet.first;
      while not LocalDataSet.Eof do
      begin
        SyncYieldCycles(1);
        if isdirty(DoGetLocalAttribs) then
        begin
          if (DoGetLocalRecId <> 0) and pfgPalmRemoteTable.locateByID(DoGetLocalRecId) then
          begin
            if compare_and_act(0) <> DeletePalmPC then
            begin
              LocalDataSet.Next;
            end;
          end
          else
          begin
            LocalDataSet.Edit;
            DoSetLocalAttribs(DoGetLocalAttribs and (not
              eRecAttrDirty));
            pfgPalmRemoteTable.Insert;
            DoCopyToPalm;
            pfgPalmRemoteTable.Post;
            DoSetLocalRecId(pfgPalmRemoteTable.Fields.RecordID);
            LocalDataSet.Post;
            LocalDataSet.Next;
          end;
        end
        else
        begin
          LocalDataSet.Next;
        end;
      end;
      pfgPalmRemoteTable.PurgeTable;
      result := 0;
    except
      on e: exception do
      begin
        SendErrorMsg(e.message + ' in ' + pfgPalmRemoteTable.TableName);
        result := -1;
      end;
    end;
  finally
    LocalDataSet.close;
    pfgPalmRemoteTable.close;
  end;
end;

procedure TpfgPalmSyncComponent.SetOnCompareRecord(
  const Value: TOnCompareRecord);
begin
  FOnCompareRecord := Value;
end;

function TpfgPalmSyncComponent.CompareRecord(const PalmFlags,
  PCFlags: byte): TRecordAction;
begin
  if assigned(FOnCompareRecord) then
  begin
    result := FOnCompareRecord(self, SyncProperties, PalmFlags, PCFlags);
  end
  else
  begin
    result := DefaultCompareRecord(PalmFlags, PCFlags);
  end;
end;

function TpfgPalmSyncComponent.DefaultCompareRecord(const PalmFlags,
  PCFlags: byte): TRecordAction;
begin
  result := DoNothing;
  if IsDirty(PalmFlags) then
  begin
// palm modified - Palm wins !
    result := CopyToPC;
  end
  else
  begin
// palm NOT modified !
    if IsDirty(PCFlags) and (not IsDeleted(PCFlags)) then
    begin
// PC modified - PC wins !
      result := CopyToPalm;
    end
    else
    begin
      if IsDeleted(PalmFlags) or
        IsDeleted(PCFlags) then
      begin
// Deleted on Palm or on PC !
        result := DeletePalmPC;
      end;
    end;
  end;
end;

function TpfgPalmSyncComponent.compare_and_act(const maskattr: byte): TRecordAction;
begin
  result := CompareRecord(pfgPalmRemoteTable.Fields.Flags, DoGetLocalAttribs);
{$IFDEF debugmsg}
  DebugStr(GetEnumName(Typeinfo(TRecordAction), Ord(result)));
{$ENDIF}

  case result of
    CopyToPalm:
      begin
        LocalDataSet.Edit;
        DoSetLocalAttribs((DoGetLocalAttribs and (not eRecAttrDirty) and
          (not maskattr)));
        pfgPalmRemoteTable.Edit;
        DoCopyToPalm;
        pfgPalmRemoteTable.Post;
        LocalDataSet.Post;
      end;
    CopyToPC:
      begin
        pfgPalmRemoteTable.Edit;
        pfgPalmRemoteTable.Fields.Flags := (pfgPalmRemoteTable.Fields.Flags and
          (not eRecAttrDirty) and (not maskattr));
        LocalDataSet.Edit;
        DoCopyToPC;
        LocalDataSet.Post;
        pfgPalmRemoteTable.Post;
      end;
    DeletePalmPC:
      begin
        DoDeletePalm;
        DoDeletePC;
      end;
    DoNothing:
      begin
      end;
  end;
end;


procedure TpfgPalmSyncComponent.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent = FpfgPalmRemoteTable) then
  begin
    FpfgPalmRemoteTable := nil;
  end;
  if (Operation = opRemove) and (AComponent = FLocalDataSet) then
  begin
    FLocalDataSet := nil;

// pel 2001-05-13
// needed to remove other things that will disapear if table is
// deleted !!!
    FLocalCategoryField := nil;
    FLocalRecIdField := nil;
    FLocalDeletedField := nil;
    FLocalDirtyField := nil;
    FLocalAttribsField := nil;
// pel 2001-07-17
    FOnEmptyLocalTable := nil;
  end;
end;

procedure TpfgPalmSyncComponent.SetOnBeforeSync(
  const Value: TOnBeforeSync);
begin
  FOnBeforeSync := Value;
end;

procedure TpfgPalmSyncComponent.SetOnFindLocalRecordID(
  const Value: TOnFindLocalRecordID);
begin
  FOnFindLocalRecordID := Value;
end;

function TpfgPalmSyncComponent.DoCopyToPalm: integer;
var
  i: integer;
  s: string;
begin
  result := 0;
  try
    pfgPalmRemoteTable.Fields.Flags := DoGetLocalAttribs;
    pfgPalmRemoteTable.Fields.RecordID := DoGetLocalRecId;
    pfgPalmRemoteTable.Fields.Category := DoGetLocalCatId;
    for i := 0 to pfgPalmRemoteTable.FieldCount - 1 do
    begin
      s := pfgPalmRemoteTable.Fielddefs[i].FieldName;
      pfgPalmRemoteTable.fieldbyname(s).AsString :=
        LocalDataSet.FieldByName(s).AsString;
    end;
  except
    result := -1;
  end;
end;

function TpfgPalmSyncComponent.DoCopyToPC: integer;
var
  i: integer;
  s: string;
begin
  result := 0;
  try
    DoSetLocalAttribs(pfgPalmRemoteTable.Fields.Flags);
    DoSetLocalRecId(pfgPalmRemoteTable.Fields.RecordID);
    DoSetLocalCatId(pfgPalmRemoteTable.Fields.Category);
    for i := 0 to pfgPalmRemoteTable.FieldCount - 1 do
    begin
      s := pfgPalmRemoteTable.Fielddefs[i].FieldName;
      LocalDataSet.FieldByName(s).AsString :=
        pfgPalmRemoteTable.fieldbyname(s).AsString;
    end;
  except
    result := -1;
  end;
end;

function TpfgPalmSyncComponent.DoDeletePalm: integer;
//PEL 2001-07-17
//It now only sets the deleted attribute
//- the record will be deleted later by calling PurgeTable
begin
  result := 0;
  try
    pfgPalmRemoteTable.Edit;
    pfgPalmRemoteTable.Fields.Flags :=
      pfgPalmRemoteTable.Fields.Flags or eRecAttrDeleted;
    pfgPalmRemoteTable.Post;
  except
    result := -1;
  end;
end;

function TpfgPalmSyncComponent.DoDeletePC: integer;
begin
  result := 0;
  try
    LocalDataSet.Delete;
  except
    result := -1;
  end;
end;


procedure TpfgPalmSyncComponent.SendErrorMsg(const s: string);
begin
  if assigned(FOnErrorMessage) then
  begin
    FOnErrorMessage(self, s);
  end;
end;

procedure TpfgPalmSyncComponent.SetOnErrorMessage(
  const Value: TOnErrorMessage);
begin
  FOnErrorMessage := Value;
end;

procedure TpfgPalmSyncComponent.DoBeforeLocalList;
begin
  if assigned(FOnBeforeLocalList) then
  begin
    FOnBeforeLocalList(self, FSyncProperties);
  end;
end;

procedure TpfgPalmSyncComponent.SetOnBeforeLocalList(
  const Value: TOnBeforeLocalList);
begin
  FOnBeforeLocalList := Value;
end;

{Local Attributes Field processing}

procedure TpfgPalmSyncComponent.SetLocalAttribsField(
  const Value: TNumericField);
begin
  FLocalAttribsField := Value;
  if assigned(FLocalAttribsField) then
  begin
//    if assigned(FLocalAttribsField) then
//    begin
//      FLocalAttribsField := nil;
//    end;
    if assigned(FLocalDeletedField) then
    begin
      FLocalDeletedField := nil;
    end;
    if assigned(FLocalDirtyField) then
    begin
      FLocalDirtyField := nil;
    end;
    if assigned(FSetLocalAttribs) then
    begin
      FSetLocalAttribs := nil;
    end;
    if assigned(FGetLocalAttribs) then
    begin
      FGetLocalAttribs := nil;
    end;
  end;
end;


procedure TpfgPalmSyncComponent.SetLocalDeletedField(
  const Value: TBooleanField);
begin
  FLocalDeletedField := Value;
  if assigned(FLocalDeletedField) then
  begin
    if assigned(FLocalAttribsField) then
    begin
      FLocalAttribsField := nil;
    end;
//    if assigned(FLocalDeletedField) then
//    begin
//      FLocalDeletedField := nil;
//    end;
//    if assigned(FLocalDirtyField) then
//    begin
//      FLocalDirtyField := nil;
//    end;
    if assigned(FSetLocalAttribs) then
    begin
      FSetLocalAttribs := nil;
    end;
    if assigned(FGetLocalAttribs) then
    begin
      FGetLocalAttribs := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetLocalDirtyField(
  const Value: TBooleanField);
begin
  FLocalDirtyField := Value;
  if assigned(FLocalDirtyField) then
  begin
    if assigned(FLocalAttribsField) then
    begin
      FLocalAttribsField := nil;
    end;
//    if assigned(FLocalDeletedField) then
//    begin
//      FLocalDeletedField := nil;
//    end;
//    if assigned(FLocalDirtyField) then
//    begin
//      FLocalDirtyField := nil;
//    end;
    if assigned(FSetLocalAttribs) then
    begin
      FSetLocalAttribs := nil;
    end;
    if assigned(FGetLocalAttribs) then
    begin
      FGetLocalAttribs := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetGetLocalAttribs(
  const Value: TGetLocalAttribs);
begin
  FGetLocalAttribs := Value;
  if assigned(FGetLocalAttribs) then
  begin
    if assigned(FLocalAttribsField) then
    begin
      FLocalAttribsField := nil;
    end;
    if assigned(FLocalDeletedField) then
    begin
      FLocalDeletedField := nil;
    end;
    if assigned(FLocalDirtyField) then
    begin
      FLocalDirtyField := nil;
    end;
    if assigned(FSetLocalAttribs) then
    begin
      FSetLocalAttribs := nil;
    end;
//    if assigned(FGetLocalAttribs) then
//    begin
//      FGetLocalAttribs := nil;
//    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetSetLocalAttribs(
  const Value: TSetLocalAttribs);
begin
  FSetLocalAttribs := Value;
  if assigned(FSetLocalAttribs) then
  begin
    if assigned(FLocalAttribsField) then
    begin
      FLocalAttribsField := nil;
    end;
    if assigned(FLocalDeletedField) then
    begin
      FLocalDeletedField := nil;
    end;
    if assigned(FLocalDirtyField) then
    begin
      FLocalDirtyField := nil;
    end;
//    if assigned(FSetLocalAttribs) then
//    begin
//      FSetLocalAttribs := nil;
//    end;
    if assigned(FGetLocalAttribs) then
    begin
      FGetLocalAttribs := nil;
    end;
  end;
end;

function TpfgPalmSyncComponent.DoGetLocalAttribs: byte;
begin
  result := 255;
  if assigned(FLocalAttribsField) then
  begin
    result := LocalAttribsField.AsInteger;
  end
  else
  begin
    if assigned(FLocalDeletedField) and assigned(FLocalDirtyField) then
    begin
      result := MakeAttribute(LocalDirtyField.AsBoolean,
        LocalDeletedField.AsBoolean);
    end
    else
    begin
      if assigned(FGetLocalAttribs) then
      begin
        result := GetLocalAttribs(self)
      end;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.DoSetLocalAttribs(const value: byte);
begin
  if assigned(FLocalAttribsField) then
  begin
    LocalAttribsField.AsInteger := value;
  end
  else
  begin
    if assigned(FLocalDeletedField) and assigned(FLocalDirtyField) then
    begin
      LocalDirtyField.AsBoolean := isdirty(value);
      LocalDeletedField.AsBoolean := isdeleted(value);
    end
    else
    begin
      if assigned(FSetLocalAttribs) then
      begin
        SetLocalAttribs(self, value);
      end;
    end;
  end;

end;

{ Local Category field processing }

procedure TpfgPalmSyncComponent.SetGetLocalCatId(
  const Value: TGetLocalCatId);
begin
  FGetLocalCatId := Value;
  if assigned(FGetLocalCatId) then
  begin
    if assigned(FLocalCategoryField) then
    begin
      FLocalCategoryField := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetSetLocalCatId(
  const Value: TSetLocalCatId);
begin
  FSetLocalCatId := Value;
  if assigned(FSetLocalCatId) then
  begin
    if assigned(FLocalCategoryField) then
    begin
      FLocalCategoryField := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetLocalCategoryField(
  const Value: TNumericField);
begin
  FLocalCategoryField := Value;
  if assigned(FLocalCategoryField) then
  begin
    if assigned(FGetLocalCatId) then
    begin
      FGetLocalCatId := nil;
    end;
    if assigned(FSetLocalCatId) then
    begin
      FSetLocalCatId := nil;
    end;
  end;
end;

function TpfgPalmSyncComponent.DoGetLocalCatId: shortint;
begin
  if assigned(FLocalCategoryField) then
  begin
    result := FLocalCategoryField.AsInteger;
  end
  else
  begin
    if assigned(FGetLocalCatId) then
    begin
      result := FGetLocalCatId(self);
    end
    else
    begin
      result := 0;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.DoSetLocalCatId(const value: shortint);
begin
  if assigned(FLocalCategoryField) then
  begin
    FLocalCategoryField.AsInteger := value;
  end
  else
  begin
    if assigned(FSetLocalCatId) then
    begin
      FSetLocalCatId(self, value);
    end;
  end;
end;

{ Local Record ID field processing }

procedure TpfgPalmSyncComponent.SetGetLocalRecId(
  const Value: TGetLocalRecId);
begin
  FGetLocalRecId := Value;
  if assigned(value) then
  begin
    if assigned(FLocalRecIdField) then
    begin
      LocalRecIdField := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetSetLocalRecId(
  const Value: TSetLocalRecId);
begin
  FSetLocalRecId := Value;
  if assigned(Value) then
  begin
    if assigned(FLocalRecIdField) then
    begin
      LocalRecIdField := nil;
    end;
  end;
end;

procedure TpfgPalmSyncComponent.SetLocalRecIdField(
  const Value: TNumericField);
begin
  FLocalRecIdField := Value;
  if assigned(FLocalRecIdField) then
  begin
    if assigned(FSetLocalRecId) then
    begin
      SetLocalRecId := nil;
    end;
    if assigned(FGetLocalRecId) then
    begin
      GetLocalRecId := nil;
    end;
  end;
end;

function TpfgPalmSyncComponent.DoGetLocalRecId: dword;
begin
  result := 0;
  if assigned(FLocalRecIdField) then
  begin
    result := FLocalRecIdField.Asinteger;
  end
  else
  begin
    if assigned(FGetLocalRecId) then
    begin
      result := FGetLocalRecId(self);
    end;
  end;
end;

procedure TpfgPalmSyncComponent.DoSetLocalRecId(const value: dword);
begin
  if assigned(FLocalRecIdField) then
  begin
    FLocalRecIdField.AsInteger := value;
  end
  else
  begin
    if assigned(FSetLocalRecId) then
    begin
      FSetLocalRecId(self, value);
    end;
  end;
end;



procedure TpfgPalmSyncComponent.SetAllowCreatePalmTable(
  const Value: boolean);
begin
  FAllowCreatePalmTable := Value;
end;

procedure TpfgPalmSyncComponent.DoEmptyLocalTable;
begin
  if assigned(OnEmptyLocalTable) then
  begin
    OnEmptyLocalTable(FLocalDataSet);
  end;
end;

procedure TpfgPalmSyncComponent.SetOnEmptyLocalTable(
  const Value: TOnEmptyLocalTable);
begin
  FOnEmptyLocalTable := Value;
end;

end.

