unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Gauges, StdCtrls, CheckLst;

type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Gauge: TGauge;
    b_AddFiles: TButton;
    CheckListBox: TCheckListBox;
    Memo: TRichEdit;
    b_chkall: TButton;
    b_chknone: TButton;
    b_CHkDel: TButton;
    b_Export: TButton;
    Button1: TButton;
    cb_Lcase: TCheckBox;
    ed_Pretext: TEdit;
    cb_Pretext: TCheckBox;
    cb_mysql: TCheckBox;
    cb_ps: TCheckBox;
    cb_Zakm: TCheckBox;
    b_Export_SQLite: TButton;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure b_AddFilesClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure b_chkallClick(Sender: TObject);
    procedure b_chknoneClick(Sender: TObject);
    procedure b_CHkDelClick(Sender: TObject);
    procedure b_ExportClick(Sender: TObject);
    procedure b_Export_SQLiteClick(Sender: TObject);
  private
    FError: integer;
    FDirectory: string;
    FProgressText: string;
    FAQLName: string;
    procedure SetError(const Value: integer);
    procedure SetDirectory(const Value: string);
    procedure SetProgressText(const Value: string);
    procedure SetAQLName(const Value: string);
    { Private declarations }
  protected
    procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
  public
     procedure DoIt;
     procedure DoItSQLite;
     procedure StartProgress(aText: string; aMin,aMax: integer);
     function  RemoveAllSpaces(Value: string): string;
     procedure CheckCount;
     property ProgressText: string read FProgressText write SetProgressText;
     property Error: integer read FError write SetError;
     property Directory: string read FDirectory write SetDirectory;
     property AQLName: string read FAQLName write SetAQLName;
  end;

var
  Form1: TForm1;

implementation
uses
   //StringUtils,
   SQLiteWrap,
   DB,
   ShellApi,
   DBTables;


{$R *.dfm}

{ TForm1 }

procedure TForm1.DoIt;
var
   i,ii:integer;
   SR: TSearchRec;
   //TAP: TGetAbsoluteFilePath;
   Table: TTable;
   TableName,FieldNames,FN,FS: string;
   FileCount: integer;
   S,sql,Str: string;
   T: System.Text;
   ps: integer;
   rows: integer;
   isfloat: boolean;

   procedure wl(aValue: string);
   begin
      System.Write(T,aValue);
   end;
   procedure wln(aValue: string);
   begin
      System.Writeln(T,aValue);
   end;
   function siz : string;
   begin
      result := '';
      if Table.FieldDefs[ii].Size > 0 then
         result := '(' + IntToStr(Table.FieldDefs[ii].Size) + ')';
   end;

begin
   if not SaveDialog.Execute then exit;
   sql := SaveDialog.FileName;
   Memo.Clear;
   Memo.Lines.Add('  EXPORT:');
   Memo.Lines.Add('----------');
   Memo.Lines.Add('- sql file:');
   Memo.Lines.Add(sql);
   FileCount := CheckListBox.Count;
   Gauge.MinValue := 0;
   Gauge.MaxValue := FileCount -1 ;
   Gauge.Progress := 0;
   try
   // vytvoreni souboru
   System.Assign(T,sql);
   System.Rewrite(T);
   //tabulka
   Table := TTable.Create(Application);
   // zruseni zaskrtnuti
   b_chknoneClick(nil);
   for i := 0 to FileCount - 1 do
   begin
      Gauge.Progress := i;
      S := CheckListBox.Items.Strings[i];
      Table.Active:=false;
      Table.TableName:=S;

      Application.ProcessMessages;
      Table.Active:=true;
      Table. First;
      TableName := CHangeFileExt(ExtractFileName(S),'');
      if cb_Pretext.Checked then
         TableName := ed_Pretext.Text+TableName;
      if cb_Lcase.Checked then
         TableName := LowerCase(TableName);
      wln('CREATE TABLE IF NOT EXISTS `'+TableName+'` (' );
      FieldNames := '';
      for ii := 0 to Table.Fields.Count-1 do
      begin
         Str := '';
         FN := '`' + Table.Fields[ii].DisplayName + '`';
         if cb_Zakm.Checked and (UpperCase(Table.Fields[ii].DisplayName)='ZAKM_ET') then
            FN := '`ZAKM`';
         Str := Str + FN + ' ';
         if ii > 0 then FieldNames := FieldNames +',';
         FieldNames := FieldNames + FN;
         if Table.FieldDefs[ii].FieldClass = TStringField then
            Str := Str + ' VARCHAR(' + IntToStr(Table.FieldDefs[ii].Size) + ')'
         else
         if Table.FieldDefs[ii].FieldClass = TIntegerField then
            Str := Str + ' INT' + Siz
         else
         if Table.FieldDefs[ii].FieldClass = TSmallIntField then
            Str := Str + ' SMALLINT' + Siz
         else
         if Table.FieldDefs[ii].FieldClass = TFloatField then
            Str := Str + ' FLOAT'
         else
         if Table.FieldDefs[ii].FieldClass = TDateTimeField then
            Str := Str + ' DATETIME'
         else
         if Table.FieldDefs[ii].FieldClass = TDateField then
         begin
            if cb_mysql.Checked then
               Str := Str + ' DATE'
            else
               Str := Str + ' VARCHAR(15)'
         end
         else
         if Table.FieldDefs[ii].FieldClass = TTimeField then
            Str := Str + ' TIME'
         ;
         {Str := Str + ' default';
         if Table.FieldDefs[ii].Required then} Str := Str + ' NOT';
         Str := Str + ' NULL';
         if (ii < Table.Fields.Count-1) then Str := Str + ', ';
         wln(Str);
      end;
      if cb_mysql.Checked then
         wln(') ENGINE=InnoDB DEFAULT CHARSET=utf8;')
      else
         wln(');');
      wln('');
      wln('');
      if Table.RecordCount > 0 then
      begin
         if cb_mysql.Checked then
         begin
            wln('INSERT INTO `'+TableName+'` ('+FieldNames+') VALUES');
            Table.First;
            rows := 0;
            while not Table.Eof do
            begin
               Inc(rows);
               if rows = 20 then
               begin
                  wln('INSERT INTO `'+TableName+'` ('+FieldNames+') VALUES');
                  rows := 0;
               end;
               Str := '(';
               Table.edit;
               for ii := 0 to Table.Fields.Count-1 do
               begin
                  if ii > 0 then Str := Str +',';
                  FS := Table.Fields.Fields[ii].AsString;
                  if Table.FieldDefs[ii].FieldClass = TFloatField then
                     FS := StringReplace(FS,',','.',[]);
                  Str := Str + '''' +AnsiToUTF8(FS) + '''';
               end;
               Table.Next;
               if (rows = 19) or (Table.Eof) then
                  Str := Str + ');'
               else
                  Str := Str + '),';
               wln(Str);
            end;
         end
         else
         begin
            Table.First;
            while not Table.Eof do
            begin
               Table.edit;
               Str := 'INSERT INTO `'+TableName+'` VALUES(';
               for ii := 0 to Table.Fields.Count-1 do
               begin
                  if ii > 0 then Str := Str +',';
                  FS := Table.Fields.Fields[ii].AsString;
                  if Table.FieldDefs[ii].FieldClass = TFloatField then
                     FS := StringReplace(FS,',','.',[]);
                  if cb_ps.Checked then
                  begin
                     if ((TableName = 'ps') and (Table.FieldDefs[ii].Name = 'PSK')) or
                        ((TableName = 'etaz') and (Table.FieldDefs[ii].Name = 'ETAZ'))then
                           FS := RemoveAllSpaces(FS);
                  end;
                  FS := StringReplace(FS,'"','''',[rfReplaceAll]);
                  Str := Str + '"' +AnsiToUTF8(FS) + '"';
               end;
               Table.Next;
               Str := Str + ');';
               wln(Str);
            end;
         end;
      end;
      wln('');
      wln('');
      //System.Writeln(T,S);
      CHecklistBox.Checked[i] := true;
   end;

   Table.Active := false;
   Table.Free;
   System.Close(T);
   Memo.Lines.Add(' --- HOTOVO ---')
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + '::: ');
       Memo.Lines.Add(' --- AJAJ ---')
     end;
   end;
end;
procedure TForm1.SetAQLName(const Value: string);
begin
  FAQLName := Value;
end;

procedure TForm1.SetDirectory(const Value: string);
begin
  FDirectory := Value;
end;

procedure TForm1.SetError(const Value: integer);
begin
  FError := Value;
end;

procedure TForm1.SetProgressText(const Value: string);
begin
   FProgressText := Value;
end;

procedure TForm1.StartProgress(aText: string; aMin, aMax: integer);
begin

end;

procedure TForm1.WMDropFiles(var Message: TMessage);

var
   i,ii: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S,SE,SS: string;
   Size: word;
begin
   Memo.Clear;
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      SE := UpperCase(ExtractFileExt(S));
      StrDispose(P);
      if (SE = '.DB') then
      begin
         ii := CheckListBox.Items.IndexOf(S);
         if ii > -1 then
            Memo.Lines.Add(S+' u existuje!')
         else
            CHeckListBox.AddItem(S,nil);
      end
      else
         Memo.Lines.Add(SE+' neumim !');
   end;
   CheckCount;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   DragAcceptFiles(Handle, true);
end;

procedure TForm1.b_AddFilesClick(Sender: TObject);
var
   i,ii: integer;
   S: string;
begin
   Memo.Clear;
   Memo.Lines.Add('Pidvm soubory:');
   Memo.Lines.Add('-----------------');
   if OpenDialog.Execute then
   begin
      for i := 0 to OpenDialog.Files.Count - 1 do
      begin
         S := OpenDialog.Files[i];
         ii := CheckListBox.Items.IndexOf(S);
         if ii > -1 then
            Memo.Lines.Add(S+' u existuje!')
         else
            CHeckListBox.AddItem(S,nil);
      end;
      CheckCount;
   end;
end;

procedure TForm1.CheckCount;
var
   vis: boolean;
begin
   vis := CheckListBox.Count > 0;
   b_chkall.Enabled := vis;
   b_chknone.Enabled := vis;
   b_CHkDel.Enabled := vis;
   b_Export.Enabled := vis;
   if not Vis then
   begin
      Memo.Lines.Add('dn soubory - ');
      Memo.Lines.Add('Mete je pidat tlatkem nahoe  ');
      Memo.Lines.Add('Nebo petaenm my  ');
   end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TForm1.b_chkallClick(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to CheckListBox.Count - 1 do
   begin
      CheckListBox.Checked[i] := true;
   end;
end;

procedure TForm1.b_chknoneClick(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to CheckListBox.Count - 1 do
   begin
      CheckListBox.Checked[i] := false;
   end;
end;

procedure TForm1.b_CHkDelClick(Sender: TObject);
var
   i: integer;
begin
   CheckListBox.MultiSelect := true;
   for i := CheckListBox.Count - 1 downto 0 do
   begin
      CHecklistBox.Selected[i] := CheckListBox.Checked[i];
   end;
   CHeckListBox.DeleteSelected;
   CheckCount;
end;

procedure TForm1.b_ExportClick(Sender: TObject);
begin
   DoIt;
end;

function TForm1.RemoveAllSpaces(Value: string): string;
var
  I: integer;
  //aPom: integer;
begin
  result:= '';
  if Value = '' then exit;
  for i := 1 to Length(Value) do
     if not (Value[I] in [' ',#0]) then result := result + Value[I];
end;

procedure TForm1.b_Export_SQLiteClick(Sender: TObject);
var
  database: TSqliteDatabase;
  tab: TSqliteTable;
  s: string;
begin
   DoItSQLite;
   exit;
  database := TSqliteDatabase.Create('c:\Orbis32\Project\paradox2sql\Test.s3db');
  try
     S := 'CREATE TABLE IF NOT EXISTS `lhc` (`LHC_NAZ`  VARCHAR(80) NOT NULL,`ID` ';
     S := S +' FLOAT NOT NULL,`LHC_KOD`  FLOAT NOT NULL,`LHP_OD`  VARCHAR(15) NOT NULL,`LHP_DO` ';
     S := S +'  VARCHAR(15) NOT NULL,`LHP_TAX`  VARCHAR(80) NOT NULL,`LHP_Z_OD`  VARCHAR(15) NOT NULL,';
     S := S +'`LHP_Z_DO`  VARCHAR(15) NOT NULL,`LHP_Z_TAX`  VARCHAR(80) NOT NULL,`LHP_NEZDAR`  FLOAT NOT NULL,';
     S := S +'`TEZ_PROC`  FLOAT NOT NULL,`NOR_PAS`  FLOAT NOT NULL,`ETAT_TO`  FLOAT NOT NULL,';
     S := S +'`LHC_PN_PRO`  FLOAT NOT NULL,`ETAT_TV`  FLOAT NOT NULL,`LHC_IND`  FLOAT NOT NULL,';
     S := S +'`LHC_MAX`  FLOAT NOT NULL,`ETAT_TVYB`  FLOAT NOT NULL,`ETAT`  FLOAT NOT NULL,';
     S := S +'`PUV_DAT`  VARCHAR(1) NOT NULL,`LHP_LIC`  VARCHAR(30) NOT NULL,`LHP_Z_LIC`  VARCHAR(30) NOT NULL,';
     S := S +'`MVYCH_DO40`  FLOAT NOT NULL,`LHC_KOD_ID`  INT NOT NULL,`KU_DATUM`  VARCHAR(15) NOT NULL,';
     S := S +'`LHC_IND_TV`  INT NOT NULL,`LHC_IND_TO`  INT NOT NULL,`LHO`  VARCHAR(1) NOT NULL);';
     S := AnsiToUtf8(S);
     database.ExecSQL(S);
     S := 'INSERT INTO `lhc` VALUES("Msto Tepl","0","325408","1.1.2014","31.12.2023","Plzesk lesprojekt, a.s.","","","","0","58195","39382","53369","0","9131","1087","62500","0","62500","T","P/2983/05","","404.1","0","30.6.2013","94","993","N");';
     S := AnsiToUtf8(S);
     database.ExecSQL(S);


    //database.AddParamInt(':key', 123456);

    //tab := database.GetTable('SELECT * FROM some_table WHERE ROWID=:key');
    //try
    //  while not tab.EOF do
    //  begin
    //    s := tab.FieldAsString(tab.FieldIndex['ROWID']);
    //    //do something with 'S' variable...
    //    //...
    //    //...then go to next row.
    //    tab.next;
    //  end;
    //finally
    //  tab.free;
    //end;
  finally
    database.free;
  end;
end;

procedure TForm1.DoItSQLite;
var
   i,ti,tii,ii:integer;
   SR: TSearchRec;
   //TAP: TGetAbsoluteFilePath;
   Table: TTable;
   TableName,FieldNames,FN,FS: string;
   FileCount: integer;
   S,sqlStr,sqldb,Str: string;
   T: System.Text;
   ps: integer;
   rows: integer;
   isfloat: boolean;
    database: TSqliteDatabase;
    tab: TSqliteTable;

   procedure wl(aValue: string);
   begin
      System.Write(T,aValue);
   end;
   procedure wln(aValue: string);
   begin
      System.Writeln(T,aValue);
   end;
   function siz : string;
   begin
      result := '';
      if Table.FieldDefs[ii].Size > 0 then
         result := '(' + IntToStr(Table.FieldDefs[ii].Size) + ')';
   end;

begin
   if not SaveDialog1.Execute then exit;
   sqldb := SaveDialog1.FileName;
   Memo.Clear;
   Memo.Lines.Add('  EXPORT:');
   Memo.Lines.Add('----------');
   Memo.Lines.Add('- s3db file:');
   Memo.Lines.Add(sqldb);
   FileCount := CheckListBox.Count;
   Gauge.MinValue := 0;
   Gauge.MaxValue := FileCount -1 ;
   Gauge.Progress := 0;
   try
   // otevreni databaze
   database := TSqliteDatabase.Create(sqldb);
   //tabulka
   Table := TTable.Create(Application);
   // zruseni zaskrtnuti
   b_chknoneClick(nil);
   for i := 0 to FileCount - 1 do
   begin
      Gauge.Progress := i;
      S := CheckListBox.Items.Strings[i];
      Table.Active:=false;
      Table.TableName:=S;

      Application.ProcessMessages;
      Table.Active:=true;
      Table. First;
      TableName := CHangeFileExt(ExtractFileName(S),'');
      if cb_Pretext.Checked then
         TableName := ed_Pretext.Text+TableName;
      if cb_Lcase.Checked then
         TableName := LowerCase(TableName);

      database.ExecSQL('BEGIN TRANSACTION');

      SqlStr := 'CREATE TABLE IF NOT EXISTS `'+TableName+'` (' ;
      FieldNames := '';
      for ii := 0 to Table.Fields.Count-1 do
      begin
         Str := '';
         FN := '`' + Table.Fields[ii].DisplayName + '`';
         if cb_Zakm.Checked and (UpperCase(Table.Fields[ii].DisplayName)='ZAKM_ET') then
            FN := '`ZAKM`';
         Str := Str + FN + ' ';
         if ii > 0 then FieldNames := FieldNames +',';
         FieldNames := FieldNames + FN;
         if Table.FieldDefs[ii].FieldClass = TStringField then
            Str := Str + ' VARCHAR(' + IntToStr(Table.FieldDefs[ii].Size) + ')'
         else
         if Table.FieldDefs[ii].FieldClass = TIntegerField then
            Str := Str + ' INT' + Siz
         else
         if Table.FieldDefs[ii].FieldClass = TSmallIntField then
            Str := Str + ' SMALLINT' + Siz
         else
         if Table.FieldDefs[ii].FieldClass = TFloatField then
            Str := Str + ' FLOAT'
         else
         if Table.FieldDefs[ii].FieldClass = TDateTimeField then
            Str := Str + ' VARCHAR(15)'
         else
         if Table.FieldDefs[ii].FieldClass = TDateField then
            Str := Str + ' VARCHAR(15)'
         else
         if Table.FieldDefs[ii].FieldClass = TTimeField then
            Str := Str + ' VARCHAR(30)'
         ;
         {Str := Str + ' default';
         if Table.FieldDefs[ii].Required then} Str := Str + ' NOT';
         Str := Str + ' NULL';
         if (ii < Table.Fields.Count-1) then Str := Str + ', ';
         SqlStr := SqlStr + Str;
      end;
      SqlStr := SqlStr + ');';
      database.ExecSQL(SqlStr);
      ti := Table.RecordCount;
      tii := 0;
      if Table.RecordCount > 0 then
      begin
         Table.First;
         while not Table.Eof do
         begin
            tii := tii +1;
            Caption := TableName+' '+IntToStr(tii)+'/'+IntToStr(ti);
            Application.ProcessMessages;
            Table.edit;
            SqlStr := 'INSERT INTO `'+TableName+'` VALUES(';
            for ii := 0 to Table.Fields.Count-1 do
            begin
               if ii > 0 then SQLStr := SQLStr +',';
               FS := Table.Fields.Fields[ii].AsString;
               if Table.FieldDefs[ii].FieldClass = TFloatField then
                  FS := StringReplace(FS,',','.',[]);
               if cb_ps.Checked then
               begin
                  if ((TableName = 'ps') and (Table.FieldDefs[ii].Name = 'PSK')) or
                     ((TableName = 'etaz') and (Table.FieldDefs[ii].Name = 'ETAZ'))then
                        FS := RemoveAllSpaces(FS);
               end;
               FS := StringReplace(FS,'"','''',[rfReplaceAll]);
               SQLStr := SQLStr + '"' +AnsiToUTF8(FS) + '"';
            end;
            Table.Next;
            SQLStr := SQLStr + ');';
           database.ExecSQL(SQLStr);
           Application.ProcessMessages;
         end;
      end;
      database.ExecSQL('COMMIT TRANSACTION');
      //System.Writeln(T,S);
      CHecklistBox.Checked[i] := true;
   end;

   Table.Active := false;
   Table.Free;
   Memo.Lines.Add(' --- HOTOVO ---');
   database.Free;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + '::: ');
       Memo.Lines.Add(' --- AJAJ ---')
     end;
   end;
end;

end.
