unit f_resize;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure FormConstrainedResize(Sender: TObject; var MinWidth,
      MinHeight, MaxWidth, MaxHeight: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Panel1Resize(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormEndDock(Sender, Target: TObject; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
     procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
     procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;
     procedure WMMove(var Message: TMessage) ; message WM_MOVE;
  public
     ii: integer;
    { Public declarations }
  end;

(* example from NET

~~~~~~~~~~~~~~~~~~~~~~~~~
type
   TForm1 = class(TForm)
   private
     procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
     procedure WMMove(var Message: TMessage) ; message WM_MOVE;
     procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;

...

procedure TForm1.WMEnterSizeMove(var Message: TMessage) ;
begin
   Caption := 'Move / resize started';
end;

procedure TForm1.WMMove(var Message: TMessage) ;
begin
   Caption := Format('Form is being moved.
*)


var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
   //Memo1.Lines.Add('CanResize');
//   Resize := true;
   inherited
end;

procedure TForm1.FormConstrainedResize(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
begin
   //Memo1.Lines.Add('ConstrainedResize');

end;

procedure TForm1.FormResize(Sender: TObject);
begin
   Memo1.Lines.Add('Resize'+'x:'+IntToStr(Width)+' y:'+IntToStr(Height));
   Caption := 'resize x:'+IntToStr(Width)+' y:'+IntToStr(Height);
end;

procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
   Memo1.Lines.Add('Drop');
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
   //Memo1.Lines.Add('Panel Resize''x:'+IntToStr(Width)+' y:'+IntToStr(Height));
end;

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
   Memo1.Lines.Add('Drag');
end;

procedure TForm1.FormEndDock(Sender, Target: TObject; X, Y: Integer);
begin
   Memo1.Lines.Add('End Dock');
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Memo1.Lines.Add('Mouse UP');
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Memo1.Lines.Add('Mouse DOWN');
end;

procedure TForm1.WMExitSizeMove(var Message: TMessage);
begin
   Memo1.Lines.Add('RESIZE END');
end;

procedure TForm1.WMEnterSizeMove(var Message: TMessage);
begin
   Memo1.Lines.Add('RESIZE START');
end;

procedure TForm1.WMMove(var Message: TMessage);
begin
   Memo1.Lines.Add('*** MOVE');
   Caption := 'Move '+IntToStr(Left)+'/'+IntToStr(Top);
end;

end.
