unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, {XPStyleActnCtrls,} ActnList, ActnMan, ToolWin,
  ActnCtrls, ActnMenus, ComCtrls, ImgList, Grids, ValEdit, StdCtrls,
  CheckLst, ShellApi, DB, DBTables, AppEvnts, tab, pomocny, DatB, QGraphics, Sql;

type
  TStrings=array [0..99] of string;
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    Soubor_m: TMenuItem;
    Help_m: TMenuItem;
    ToolBar: TToolBar;
    novy_tb: TToolButton;
    otevrit_tb: TToolButton;
    Uloz_jako: TToolButton;
    Uloz_tb: TToolButton;
    TBu1: TToolButton;
    Zavrit_tb: TToolButton;
    TBu2: TToolButton;
    Nastaveni_tb: TToolButton;
    TBu3: TToolButton;
    Vyber_tabulek_tb: TToolButton;
    Tv_up_kalk_tab_tb: TToolButton;
    Def_param_tb: TToolButton;
    TBu4: TToolButton;
    Vygenerovany_sql_tb: TToolButton;
    Proved_sql_tb: TToolButton;
    Prohl_upr_sql_soub_tb: TToolButton;
    TBu5: TToolButton;
    Zobr_graf_tb: TToolButton;
    TBu6: TToolButton;
    Tvorba_sestavy_tb: TToolButton;
    Prohl_sestavy_tb: TToolButton;
    Upravy_m: TMenuItem;
    Operace_m: TMenuItem;
    Novy_m: TMenuItem;
    Otevrit_m: TMenuItem;
    Zavrit_m: TMenuItem;
    N1: TMenuItem;
    Ulozit_m: TMenuItem;
    Ulozit_jako_m: TMenuItem;
    N2: TMenuItem;
    Nastaveni_m: TMenuItem;
    Konec_m: TMenuItem;
    Pridat_tabulku_m: TMenuItem;
    Kalkulacni_pole_m: TMenuItem;
    Smazat_sloupec_m: TMenuItem;
    Ukaz_dotaz_m: TMenuItem;
    Proved_dotaz_m: TMenuItem;
    Edituj_m: TMenuItem;
    N3: TMenuItem;
    tvorba_sestavy_m: TMenuItem;
    Prohlizeni_sestavy_m: TMenuItem;
    N4: TMenuItem;
    Tvorba_grafu_m: TMenuItem;
    Zakladni_stranka_m: TMenuItem;
    Hledani_stranky_m: TMenuItem;
    N5: TMenuItem;
    O_aplikaci_m: TMenuItem;
    StrGrid: TStringGrid;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    Pozadi: TImage;
    procedure FormResize(Sender: TObject);
    procedure Vyber_tabulek_tbClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Vygenerovany_sql_tbClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  ti:integer;
  bv:Boolean;
  nazev_pom,text_pom,fname,fpath:string;
  tabulky,cesty:TStrings;

implementation

{$R *.dfm}

procedure TMainForm.FormResize(Sender: TObject);
begin
  Pozadi.SetBounds(0,0,MainForm.ClientWidth,MainForm.ClientHeight);
  Pozadi.Repaint;
  Pozadi.Refresh;
  StrGrid.SetBounds(1,37+round(MainForm.Height/2),MainForm.Width-10,MainForm.Height-round(MainForm.Height/2)-30);
end;

procedure TMainForm.Vyber_tabulek_tbClick(Sender: TObject);
var i,j:integer;
    b:Boolean;
begin
  if OpenDlg.Execute then
    begin
      if fileExists(OpenDlg.FileName) then
        begin
          i:=Length(Opendlg.FileName);
          repeat
            dec(i);
          until OpenDlg.FileName[i]='\';
          fname:='';
          for j:=i+1 to Length(OpenDlg.FileName) do
            fname:=fname+OpenDlg.FileName[j];
          fpath:='';
          for j:=1 to i do
            fpath:=fpath+OpenDlg.FileName[j];
          b:=true;
          i:=0;
          repeat
            if tabulky[i]=fname then
              begin
                b:=false;
                ShowMessage('Tato tabulka je ji otevena!');
                exit;
              end;
            inc(i);
          until tabulky[i]='';
          if b=true then
            begin
              with TTabForm.Create(MainForm) do
                begin
                  popis:='';
                  Table_TF.TableName:=fname;
                  cesty[ti]:=OpenDlg.FileName;
                  tabulky[ti]:=fname;
                  inc(ti);
                  Caption:=Table_TF.TableName;
                  Table_TF.DatabaseName:=fpath;
                  Table_TF.Open();
                  autosize:=true;
                  for i:=0 to Table_TF.FieldCount-1 do
                    begin
                      ListBox_TF.AddItem(Table_TF.Fields.Fields[i].FieldName,Table_TF);
                    end;
                  Table_TF.Close;
                end;
            end;
        end;
    end;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var h:integer;
begin
  if bv=true then
    begin
      B.X:=X;
      B.Y:=Y;
      if (B.X-140)<A.X then
        begin
          A.X:=A.X-140;
          C:=A;
          A:=B;
          B:=C;
          C.X:=0;
          C.Y:=0;
        end
      else B.X:=B.X-140;
     { h:=(MainForm.ClientHeight-mainForm.Height);
          Pozadi.Canvas.Brush.Color:=ClWhite;
          Pozadi.Canvas.MoveTo(A.X,A.Y-h);
          Pozadi.Canvas.LineTo(A.X+10,A.Y-h);
          Pozadi.Canvas.LineTo(B.X-10,B.Y-h);
          Pozadi.Canvas.LineTo(B.X,B.Y-h);
          Pozadi.Repaint;   }
      A.X:=-1;
      B.X:=-1;
      bv:=false;
    end
  else
    begin
      A.X:=X;
      A.Y:=Y;
    end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  StrGrid.Cells[0,0]:='Nzev pole:  ';      //osetrit mazani sloupcu z databaze po dvoukliku na nazev sloupce v strGridu
  StrGrid.Cells[0,1]:='Popis pole:  ';
  StrGrid.Cells[0,2]:='Tabulka:  ';
  StrGrid.Cells[0,3]:='Alias tabulky:  ';
  gi:=1;
  ti:=0;
  A.X:=-1;
  B.X:=-1;
end;

procedure TMainForm.Vygenerovany_sql_tbClick(Sender: TObject);
  var i,j:integer;
      str:string;
begin
  with TSqlForm.Create(self) do
    begin
      Memo_sql.Clear;
      if gi<>1 then
        begin
          Memo_sql.Lines.Append('SELECT');
          str:='  ';
          for i:=1 to gi-1 do
            begin
              if i<> gi-1 then
                str:=str+StrGrid.Cells[i,3]+'.'+'"'+StrGrid.Cells[i,0]+'"'+' AS '+StrGrid.Cells[i,1]+', '
              else
                str:=str+StrGrid.Cells[i,3]+'.'+'"'+StrGrid.Cells[i,0]+'"'+' AS '+StrGrid.Cells[i,1];
            end;
          Memo_sql.Lines.Append(str);
          str:='';
          Memo_sql.Lines.Append('WHERE');
          i:=0;
          repeat
            if i<>0 then
              begin
                j:=1;
                str:='';
                repeat
                  str:=str+tabulky[i][j];
                  inc(j);
                until tabulky[i][j]='.';
                Memo_sql.Lines.Append(', '+'"'+cesty[i]+'"'+' '+str);
              end
            else
              begin
                j:=1;
                str:='';
                repeat
                  str:=str+tabulky[i][j];
                  inc(j);
                until tabulky[i][j]='.';
                Memo_sql.Lines.Append('  '+'"'+cesty[i]+'"'+' '+str);
              end;
            inc(i);
          until cesty[i]='';
          Memo_sql.Lines.Append('WHERE');
          i:=0;
          repeat
            if i<>0 then
              Memo_sql.Lines.Append('  AND '+vazby[i].t1+'.'+'"'+vazby[i].V1+'"'+' = '+vazby[i].t2+'.'+'"'+vazby[i].V2+'"')
            else
              Memo_sql.Lines.Append('      '+vazby[i].t1+'.'+'"'+vazby[i].V1+'"'+' = '+vazby[i].t2+'.'+'"'+vazby[i].V2+'"');
            inc(i);
          until vazby[i].V2='';
        end;
    end;
end;

end.
