unit zipTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ZipMstr, ComCtrls;

type
  TForm1 = class(TForm)
    ZipMaster: TZipMaster;
    OpenDialog: TOpenDialog;
    Button1: TButton;
    Memo: TMemo;
    Button2: TButton;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ProgressBar2: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ZipMasterProgress(Sender: TObject; ProgrType: ProgressType;
      Filename: String; FileSize: Cardinal);
  private
    { Private declarations }
    TotUncomp, TotComp: Cardinal;
    TotalSize1, TotalProgress1, TotalSize2, TotalProgress2: Int64;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$R c:\Orbis32\lib\zip\ZipMsgUS.res}

procedure TForm1.Button1Click(Sender: TObject);
var
   i: integer;
begin
   if OpenDialog.Execute then
   begin
      Memo.Lines.Clear;
      ZipMaster.ZipFileName := OpenDialog.FileName;
      for i := 0 to ZipMaster.ZipContents.Count - 1 do
      begin
         Memo.Lines.Add(PZipDirEntry(ZipMaster.ZipContents.Items[i])^.FileName);
      end;
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   ZipMaster.ZipFileName := 'c:\kos\0\test.zip';
   with ZipMaster do
        AddOptions := AddOptions + [AddRecurseDirs, AddDirNames, AddDiskSpan];
   {
   ZipMaster.KeepFreeOnDisk1 := 500;
   Zipmaster.MaxVolumeSize := 1440000;
   }
   ZipMaster.FSpecArgs.Add( '*.*' );
   SetCurrentDir( 'c:\orbis32\lib');
   ZipMaster.Add;
end;

procedure TForm1.ZipMasterProgress(Sender: TObject; ProgrType: ProgressType;
      Filename: String; FileSize: Cardinal);
var
   Step : Integer;
begin
   case ProgrType of
      TotalSize2Process:
         begin
            // ZipMaster1Message( self, 0, 'in OnProgress type TotalBytes, size= ' + IntToStr( FileSize ) );
            Label1.Caption := 'Total size: ' + IntToStr( FileSize div 1024 ) + ' Kb';
            ProgressBar2.Max := FileSize;
            ProgressBar2.Position := 1;
            TotalSize2                    := FileSize;
            TotalProgress2                := 0;
         end;
      TotalFiles2Process:
         begin
            // ZipMaster1Message( self, 0, 'in OnProgress type TotalFiles, files= ' + IntToStr( FileSize ) );
            Label2.Caption := IntToStr( FileSize ) + ' files';
         end;
      NewFile:
         begin
            // ZipMaster1Message( self, 0, 'in OnProgress type NewFile, size= ' + IntToStr( FileSize ) );
            Label3.Caption := Filename;
            ProgressBar1.Max   := FileSize;         // Current position of bar.
            ProgressBar1.Position   := 1;         // Current position of bar.
            TotalSize1                      := FileSize;
            TotalProgress1                  := 0;
         end;
      ProgressUpdate:
         begin
            TotalProgress1 := TotalProgress1 + FileSize;
            TotalProgress2 := TotalProgress2 + FileSize;
            ProgressBar1.Position := TotalProgress1;
            ProgressBar2.Position := TotalProgress2;
            // ZipMaster1Message( self, 0, 'in OnProgress type Update, size= ' + IntToStr( FileSize ) );
            // FileSize gives now the bytes processed since the last call.
            (*
            TotalProgress1 := TotalProgress1 + FileSize;
            TotalProgress2 := TotalProgress2 + FileSize;
            if TotalSize1 <> 0 then
            begin
               {$IfDef VERD4+}  // D4
               Step := Integer( Int64(TotalProgress1) * Int64(10000) div Int64(TotalSize1) );
               {$Else}          // D2 and D3
               try
                  Step := Round( TotalProgress1 * 10000 / TotalSize1 );
               except
                  Step := 2147483647;
               end;
               {$EndIf}
               // ZipMaster1Message( self, 0, 'Step = ' + IntToStr( Step ) );
               ProgressBar1.Position := 1 + Step;
            end else
               ProgressBar1.Position := 10001;
            if TotalSize2 <> 0 then
            begin
               //{$IfDef VERD4+}
               Step := Integer( Int64(TotalProgress2) * Int64(10000) div Int64(TotalSize2) );
               //{$Else}
               {
               try
                  Step := Round( TotalProgress2 * 10000 / TotalSize2 );
               except
                  Step := 2147483647;
               end;
               }
               //{$EndIf}
               ProgressBar2.Position := 1 + Step;
            end;
          *)
         end;
      EndOfBatch:    // Reset the progress bar and filename.
         begin
            // ZipMaster1Message( self, 0, 'in OnProgress type EndOfBatch' );
            Label3.Caption   := '';
            ProgressBar1.Position     := 0;
            Label1.Caption := '';
            Label2.Caption := '';
            ProgressBar2.Position     := 0;
         end;
   end;   // EOF Case
end;


end.
