unit f_Transparent;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs,
  JPEG, ComCtrls;

type
  TForm1 = class(TForm)
    Dialog: TOpenPictureDialog;
    Panel1: TPanel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Track: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TrackChange(Sender: TObject);
  private
    FF1: string;
    FF2: string;
    Busy: boolean;
    procedure SetF1(const Value: string);
    procedure SetF2(const Value: string);
    { Private declarations }
  public
     property F1: string read FF1 write SetF1;
     property F2: string read FF2 write SetF2;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   if not Dialog.Execute then
      exit;
   F1 := Dialog.FileName;
   Image1.Picture.LoadFromFile(Dialog.FileName);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   if not Dialog.Execute then
      exit;
   F2 := Dialog.FileName;
   Image2.Picture.LoadFromFile(Dialog.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   B: TBitmap;
   W,H: integer;
   aJPG: TJPEGImage;
begin
   //B := TBitmap.Create;
   //B.PixelFormat := pf24bit;
   B := Image3.Picture.Bitmap;
   W := Image3.Width;
   H := Image3.Height;
   Application.ProcessMessages;
   B.Width := W;
   B.Height := H;
   //Image3.Picture.Bitmap := B;
   Application.ProcessMessages;
   if UpperCase(ExtractFileExt(F1)) = '.JPG' then
   begin
      aJPG:= TJPEGImage.Create;
      aJPG.LoadFromFile(F1);
      B.Assign(aJPG);
      aJPG.Free;
   end
   else
   begin
      Image3.Picture.LoadFromFile(F1);
   end;
   //B.Canvas.StretchDraw(Rect(0,0,Image1.Width-1,Image1.Height-1),Image1.Picture.Bitmap);
   Image3.Refresh;
end;

procedure TForm1.SetF1(const Value: string);
begin
  FF1 := Value;
end;

procedure TForm1.SetF2(const Value: string);
begin
  FF2 := Value;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   B1,B2: Graphics.TBitmap;
   W,H: integer;
   PB1,PB2: PByteArray;
   i,j: integer;
   aJPG: TJPEGImage;
begin
   if Busy then exit;
   Busy := true;
   B1 := Graphics.TBitmap.Create;
   B1.PixelFormat := pf24bit;
   B2 := Graphics.TBitmap.Create;
   B2.PixelFormat := pf24bit;
   W := Image3.Width;
   H := Image3.Height;
   //B2.Width := W;
   //B2.Height := H;
   Application.ProcessMessages;
   if UpperCase(ExtractFileExt(F2)) = '.JPG' then
   begin
      aJPG:= TJPEGImage.Create;
      aJPG.LoadFromFile(F2);
      B1.Assign(aJPG);
      aJPG.Free;
   end
   else
   begin
      B1.LoadFromFile(F2);
   end;

   if UpperCase(ExtractFileExt(F1)) = '.JPG' then
   begin
      aJPG:= TJPEGImage.Create;
      aJPG.LoadFromFile(F1);
      B2.Assign(aJPG);
      aJPG.Free;
   end
   else
   begin
      B2.LoadFromFile(F1);
   end;
   W := B1.Width;
   H := B1.Height;
   if B2.Width < W then
      W := B2.Width;
   if B2.Height < H then
      H := B2.Height;
   //B1.Width := W;
   //B1.Height := H;
   Application.ProcessMessages;
   //B2.Canvas.Draw(0,0,Image3.Picture.Bitmap);
   try
   H := H - 1;
   W := W * 3 - 1;
   for i := 0 to H do
   begin
      PB1 := B1.ScanLine[i];
      PB2 := B2.ScanLine[i];
      for j := 0 to W do
      begin
         PB1[j] := (PB1[j]*Track.Position div 100) + (PB2[j]*(100 - Track.Position) div 100)
      end;
   end;
   except
      ShowMessage('i:'+IntToStr(i)+' j:'+IntToStr(j));
   end;
   Application.ProcessMessages;
   Image3.Picture.Bitmap.Canvas.Draw(0,0,B1);
   Image3.Refresh;
   B1.Free;
   B2.Free;
   Busy := false;
end;

procedure TForm1.TrackChange(Sender: TObject);
begin
   if Busy then exit;
   Button4Click(nil);
end;

end.
