unit T_SelectByClass;

interface
uses
// KERNEL
  e_Class,
  Elements,
  Tools,
  T_Recurs;

type

TSelectByClass = class(TRecursor)
private
  FSelectedClass: TElementClass;
  FContainerClass: TElementClass;
  function GetSelectedElements: TOwnerEntity;
  function GetSelectedClassName: string;
  procedure SetSelectedClassName(const Value: string);
    function GetContainerClassName: string;
    procedure SetContainerClassName(const Value: string);
protected
  function  QProcessBefore(Element: TElement): boolean; override;
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessAfter(Element: TElement): boolean; override;
  procedure PrepareOutput; override;
  procedure Process(Element: TElement); override;
public
  property SelectedElements: TOwnerEntity read GetSelectedElements;
published
  property SelectedClassName: string read GetSelectedClassName write SetSelectedClassName;
  property ContainerClassName: string read GetContainerClassName write SetContainerClassName;
end;


implementation
uses
  SysUtils;

function  TSelectByClass.QProcessBefore(Element: TElement): boolean;
begin
   result := true;
end;


function  TSelectByClass.QGoInside(Element: TElement): boolean;
begin
    result:= ((Element is TEntity));
end;


function  TSelectByClass.QProcessAfter(Element: TElement): boolean;
begin
   result := false;
end;


procedure TSelectByClass.PrepareOutPut;
begin
  if Output = nil then
  begin
    if FContainerClass <> nil then
      Output := FContainerClass.Create
    else
      Output := TOwnerEntity.Create;
//    AddElement(Output);
    Output.Name := 'Selected elements';
  end;
end;


function TSelectByClass.GetSelectedElements: TOwnerEntity;
begin
   if Output = nil then
   begin
     PrepareOutput;
   end;
   result := TOwnerEntity(Output);
end;

procedure TSelectByClass.Process(Element: TElement);
var
  Selected: boolean;
  aPom: string;
begin
  Selected:= Element is FSelectedClass;

  if Selected then
     SelectedElements.AddElement(Element);
end;

function TSelectByClass.GetSelectedClassName: string;
begin
  result:= '';
  if FSelectedClass = nil then
     exit;
  result:= FSelectedClass.ClassName;
end;

procedure TSelectByClass.SetSelectedClassName(const Value: string);
begin
  FSelectedClass := GetOrbisClass(Value);
end;

function TSelectByClass.GetContainerClassName: string;
begin
  result:= '';
  if FContainerClass = nil then
     exit;
  result:= FContainerClass.ClassName;
end;

procedure TSelectByClass.SetContainerClassName(const Value: string);
begin
  FContainerClass := GetOrbisClass(Value);
end;

end.

