unit T_advrcz;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Pokroil recursor zkaznicky programovateln          *
*                                                                   *
*                       Topol Pro 1997                             *
*********************************************************************
}

interface


uses Elements,
 { E_type,}
  TypInfo,
  SysUtils,
  Tools,{t_edit,}
  t_recurs,dialogs,classes,
  creacond,t_oper;

type




TCustomRecursor = class(TRecursorWithTools)
private
  FBeforeCondTree: tCondition;
  FAfterCondTree: tCondition;
  FGoInsideCondTree: tCondition;
  FBeforeCondition: string;
  FAfterCondition: string;
  FGoInsideCondition: string;

  function  GetSelectedElements: TOwnerEntity;
protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  function  QProcessAfter(Element: TElement): boolean; override;
  procedure PrepareOutput; override;
public
  property SelectedElements: TOwnerEntity read GetSelectedElements;
published
  property BeforeCondition: string  read FBeforeCondition write FBeforeCondition;
  property AfterCondition: string  read FAfterCondition write FAfterCondition;
  property GoInsideCondition: string  read FGoInsideCondition write FGoInsideCondition;
end;



implementation
uses

   e_Class,
//   g_Elems,
   syntax;



const processed=11;
const doquit=12;


     { TCustomRecursor }



function  TCustomRecursor.GetSelectedElements: TOwnerEntity;
begin
   if Output = nil then
   begin
      Output := TOwnerEntity.Create;
      Output.Name := 'Selected elements';
   end;
   result := TOwnerEntity(Output);
end;


function  TCustomRecursor.QProcessBefore(Element: TElement): boolean;
begin
  result := false;
  if FBeforeCondTree = nil then exit;
  FBeforeCondTree.ParamItem[0]:=Element;
  result:=  FBeforeCondTree.IsTrue;
  if result then
     result:= inherited QProcessBefore(Element)
end;


function  TCustomRecursor.QProcessAfter(Element: TElement): boolean;
begin
  result := false;
  if FAfterCondTree = nil then exit;
  FAfterCondTree.ParamItem[0]:=Element;
  result:=  FAfterCondTree.IsTrue;
  if result then
     result:= inherited QProcessAfter(Element)
end;


function  TCustomRecursor.QGoInside(Element: TElement): boolean;
begin
  result := true;
  if FGoInsideCondTree = nil then exit;
  FGoInsideCondTree.ParamItem[0]:=Element;
  result:=  FGoInsideCondTree.IsTrue;
  if result then
     result:= inherited QGoInside(Element)
end;


procedure TCustomRecursor.PrepareOutPut;
var
  aCondCreator:TCondCreator;

begin
  aCondCreator:= TCondCreator.Create;
  try
    if BeforeCondition <> '' then
    begin
      aCondCreator.Command:=BeforeCondition;
      aCondCreator.DoIt;
      FBeforeCondTree:=TCondition(aCondCreator.Output);
    end;

    if AfterCondition <> '' then
    begin
      aCondCreator.Command:=AfterCondition;
      aCondCreator.DoIt;
      FAfterCondTree:=TCondition(aCondCreator.Output);
    end;

    if GoInsideCondition <> '' then
    begin
      aCondCreator.Command:=GoInsideCondition;
      aCondCreator.DoIt;
      FGoInsideCondTree:=TCondition(aCondCreator.Output);
    end;
  finally
    aCondCreator.Free
  end;
end;



BEGIN
   RegisterOrbisClass(TCustomRecursor);
END.

